#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3527
#define LARGE_STATE_COUNT 1006
#define SYMBOL_COUNT 337
#define ALIAS_COUNT 5
#define TOKEN_COUNT 151
#define EXTERNAL_TOKEN_COUNT 7
#define FIELD_COUNT 31
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 274

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_macro_rules_BANG = 3,
  anon_sym_LPAREN = 4,
  anon_sym_RPAREN = 5,
  anon_sym_LBRACK = 6,
  anon_sym_RBRACK = 7,
  anon_sym_LBRACE = 8,
  anon_sym_RBRACE = 9,
  anon_sym_EQ_GT = 10,
  anon_sym_COLON = 11,
  anon_sym_DOLLAR = 12,
  aux_sym_token_repetition_pattern_token1 = 13,
  anon_sym_PLUS = 14,
  anon_sym_STAR = 15,
  anon_sym_QMARK = 16,
  anon_sym_block = 17,
  anon_sym_expr = 18,
  anon_sym_ident = 19,
  anon_sym_item = 20,
  anon_sym_lifetime = 21,
  anon_sym_literal = 22,
  anon_sym_meta = 23,
  anon_sym_pat = 24,
  anon_sym_path = 25,
  anon_sym_stmt = 26,
  anon_sym_tt = 27,
  anon_sym_ty = 28,
  anon_sym_vis = 29,
  anon_sym_u8 = 30,
  anon_sym_i8 = 31,
  anon_sym_u16 = 32,
  anon_sym_i16 = 33,
  anon_sym_u32 = 34,
  anon_sym_i32 = 35,
  anon_sym_u64 = 36,
  anon_sym_i64 = 37,
  anon_sym_u128 = 38,
  anon_sym_i128 = 39,
  anon_sym_isize = 40,
  anon_sym_usize = 41,
  anon_sym_f32 = 42,
  anon_sym_f64 = 43,
  anon_sym_bool = 44,
  anon_sym_str = 45,
  anon_sym_char = 46,
  anon_sym_SLASH = 47,
  anon_sym__ = 48,
  anon_sym_BSLASH = 49,
  anon_sym_DASH = 50,
  anon_sym_EQ = 51,
  anon_sym_DASH_GT = 52,
  anon_sym_COMMA = 53,
  anon_sym_COLON_COLON = 54,
  anon_sym_BANG = 55,
  anon_sym_DOT = 56,
  anon_sym_AT = 57,
  anon_sym_AMP = 58,
  anon_sym_POUND = 59,
  anon_sym_PERCENT = 60,
  anon_sym_CARET = 61,
  anon_sym_LT = 62,
  anon_sym_GT = 63,
  anon_sym_PIPE = 64,
  anon_sym_TILDE = 65,
  anon_sym_SQUOTE = 66,
  anon_sym_as = 67,
  anon_sym_async = 68,
  anon_sym_await = 69,
  anon_sym_break = 70,
  anon_sym_const = 71,
  anon_sym_continue = 72,
  anon_sym_default = 73,
  anon_sym_enum = 74,
  anon_sym_fn = 75,
  anon_sym_for = 76,
  anon_sym_if = 77,
  anon_sym_impl = 78,
  anon_sym_let = 79,
  anon_sym_loop = 80,
  anon_sym_match = 81,
  anon_sym_mod = 82,
  anon_sym_pub = 83,
  anon_sym_return = 84,
  anon_sym_static = 85,
  anon_sym_struct = 86,
  anon_sym_trait = 87,
  anon_sym_type = 88,
  anon_sym_union = 89,
  anon_sym_unsafe = 90,
  anon_sym_use = 91,
  anon_sym_where = 92,
  anon_sym_while = 93,
  anon_sym_extern = 94,
  anon_sym_ref = 95,
  anon_sym_else = 96,
  anon_sym_DOT_DOT_DOT = 97,
  anon_sym_in = 98,
  anon_sym_LT2 = 99,
  anon_sym_dyn = 100,
  sym_mutable_specifier = 101,
  anon_sym_DOT_DOT = 102,
  anon_sym_DOT_DOT_EQ = 103,
  anon_sym_AMP_AMP = 104,
  anon_sym_PIPE_PIPE = 105,
  anon_sym_EQ_EQ = 106,
  anon_sym_BANG_EQ = 107,
  anon_sym_LT_EQ = 108,
  anon_sym_GT_EQ = 109,
  anon_sym_LT_LT = 110,
  anon_sym_GT_GT = 111,
  anon_sym_PLUS_EQ = 112,
  anon_sym_DASH_EQ = 113,
  anon_sym_STAR_EQ = 114,
  anon_sym_SLASH_EQ = 115,
  anon_sym_PERCENT_EQ = 116,
  anon_sym_AMP_EQ = 117,
  anon_sym_PIPE_EQ = 118,
  anon_sym_CARET_EQ = 119,
  anon_sym_LT_LT_EQ = 120,
  anon_sym_GT_GT_EQ = 121,
  anon_sym_yield = 122,
  anon_sym_move = 123,
  anon_sym_try = 124,
  sym_integer_literal = 125,
  aux_sym_string_literal_token1 = 126,
  anon_sym_DQUOTE = 127,
  sym_char_literal = 128,
  sym_escape_sequence = 129,
  anon_sym_true = 130,
  anon_sym_false = 131,
  anon_sym_SLASH_SLASH = 132,
  aux_sym_line_comment_token1 = 133,
  aux_sym_line_comment_token2 = 134,
  aux_sym_line_comment_token3 = 135,
  sym__inner_line_doc_comment = 136,
  sym__outer_line_doc_comment = 137,
  anon_sym_SLASH_STAR = 138,
  anon_sym_STAR_SLASH = 139,
  sym_shebang = 140,
  sym_self = 141,
  sym_super = 142,
  sym_crate = 143,
  sym_metavariable = 144,
  sym__string_content = 145,
  sym_raw_string_literal = 146,
  sym_float_literal = 147,
  sym__outer_block_doc_comment = 148,
  sym__inner_block_doc_comment = 149,
  sym__error_sentinel = 150,
  sym_source_file = 151,
  sym__statement = 152,
  sym_empty_statement = 153,
  sym_expression_statement = 154,
  sym_macro_definition = 155,
  sym_macro_rule = 156,
  sym__token_pattern = 157,
  sym_token_tree_pattern = 158,
  sym_token_binding_pattern = 159,
  sym_token_repetition_pattern = 160,
  sym_fragment_specifier = 161,
  sym_token_tree = 162,
  sym_token_repetition = 163,
  sym_attribute_item = 164,
  sym_inner_attribute_item = 165,
  sym_attribute = 166,
  sym_mod_item = 167,
  sym_foreign_mod_item = 168,
  sym_declaration_list = 169,
  sym_struct_item = 170,
  sym_union_item = 171,
  sym_enum_item = 172,
  sym_enum_variant_list = 173,
  sym_enum_variant = 174,
  sym_field_declaration_list = 175,
  sym_field_declaration = 176,
  sym_ordered_field_declaration_list = 177,
  sym_extern_crate_declaration = 178,
  sym_const_item = 179,
  sym_static_item = 180,
  sym_type_item = 181,
  sym_function_item = 182,
  sym_function_signature_item = 183,
  sym_function_modifiers = 184,
  sym_where_clause = 185,
  sym_where_predicate = 186,
  sym_impl_item = 187,
  sym_trait_item = 188,
  sym_associated_type = 189,
  sym_trait_bounds = 190,
  sym_higher_ranked_trait_bound = 191,
  sym_removed_trait_bound = 192,
  sym_type_parameters = 193,
  sym_const_parameter = 194,
  sym_constrained_type_parameter = 195,
  sym_optional_type_parameter = 196,
  sym_let_declaration = 197,
  sym_use_declaration = 198,
  sym__use_clause = 199,
  sym_scoped_use_list = 200,
  sym_use_list = 201,
  sym_use_as_clause = 202,
  sym_use_wildcard = 203,
  sym_parameters = 204,
  sym_self_parameter = 205,
  sym_variadic_parameter = 206,
  sym_parameter = 207,
  sym_extern_modifier = 208,
  sym_visibility_modifier = 209,
  sym__type = 210,
  sym_bracketed_type = 211,
  sym_qualified_type = 212,
  sym_lifetime = 213,
  sym_array_type = 214,
  sym_for_lifetimes = 215,
  sym_function_type = 216,
  sym_tuple_type = 217,
  sym_unit_type = 218,
  sym_generic_function = 219,
  sym_generic_type = 220,
  sym_generic_type_with_turbofish = 221,
  sym_bounded_type = 222,
  sym_type_arguments = 223,
  sym_type_binding = 224,
  sym_reference_type = 225,
  sym_pointer_type = 226,
  sym_empty_type = 227,
  sym_abstract_type = 228,
  sym_dynamic_type = 229,
  sym__expression_except_range = 230,
  sym__expression = 231,
  sym_macro_invocation = 232,
  sym_delim_token_tree = 233,
  sym__delim_tokens = 234,
  sym__non_delim_token = 235,
  sym_scoped_identifier = 236,
  sym_scoped_type_identifier_in_expression_position = 237,
  sym_scoped_type_identifier = 238,
  sym_range_expression = 239,
  sym_unary_expression = 240,
  sym_try_expression = 241,
  sym_reference_expression = 242,
  sym_binary_expression = 243,
  sym_assignment_expression = 244,
  sym_compound_assignment_expr = 245,
  sym_type_cast_expression = 246,
  sym_return_expression = 247,
  sym_yield_expression = 248,
  sym_call_expression = 249,
  sym_arguments = 250,
  sym_array_expression = 251,
  sym_parenthesized_expression = 252,
  sym_tuple_expression = 253,
  sym_unit_expression = 254,
  sym_struct_expression = 255,
  sym_field_initializer_list = 256,
  sym_shorthand_field_initializer = 257,
  sym_field_initializer = 258,
  sym_base_field_initializer = 259,
  sym_if_expression = 260,
  sym_let_condition = 261,
  sym__let_chain = 262,
  sym__condition = 263,
  sym_else_clause = 264,
  sym_match_expression = 265,
  sym_match_block = 266,
  sym_match_arm = 267,
  sym_last_match_arm = 268,
  sym_match_pattern = 269,
  sym_while_expression = 270,
  sym_loop_expression = 271,
  sym_for_expression = 272,
  sym_const_block = 273,
  sym_closure_expression = 274,
  sym_closure_parameters = 275,
  sym_label = 276,
  sym_break_expression = 277,
  sym_continue_expression = 278,
  sym_index_expression = 279,
  sym_await_expression = 280,
  sym_field_expression = 281,
  sym_unsafe_block = 282,
  sym_async_block = 283,
  sym_try_block = 284,
  sym_block = 285,
  sym__pattern = 286,
  sym_tuple_pattern = 287,
  sym_slice_pattern = 288,
  sym_tuple_struct_pattern = 289,
  sym_struct_pattern = 290,
  sym_field_pattern = 291,
  sym_remaining_field_pattern = 292,
  sym_mut_pattern = 293,
  sym_range_pattern = 294,
  sym_ref_pattern = 295,
  sym_captured_pattern = 296,
  sym_reference_pattern = 297,
  sym_or_pattern = 298,
  sym__literal = 299,
  sym__literal_pattern = 300,
  sym_negative_literal = 301,
  sym_string_literal = 302,
  sym_boolean_literal = 303,
  sym_line_comment = 304,
  sym__line_doc_comment = 305,
  sym_block_comment = 306,
  sym__block_doc_comment = 307,
  aux_sym_source_file_repeat1 = 308,
  aux_sym_macro_definition_repeat1 = 309,
  aux_sym_token_tree_pattern_repeat1 = 310,
  aux_sym_token_tree_repeat1 = 311,
  aux_sym__non_special_token_repeat1 = 312,
  aux_sym_declaration_list_repeat1 = 313,
  aux_sym_enum_variant_list_repeat1 = 314,
  aux_sym_enum_variant_list_repeat2 = 315,
  aux_sym_field_declaration_list_repeat1 = 316,
  aux_sym_ordered_field_declaration_list_repeat1 = 317,
  aux_sym_function_modifiers_repeat1 = 318,
  aux_sym_where_clause_repeat1 = 319,
  aux_sym_trait_bounds_repeat1 = 320,
  aux_sym_type_parameters_repeat1 = 321,
  aux_sym_use_list_repeat1 = 322,
  aux_sym_parameters_repeat1 = 323,
  aux_sym_for_lifetimes_repeat1 = 324,
  aux_sym_tuple_type_repeat1 = 325,
  aux_sym_type_arguments_repeat1 = 326,
  aux_sym_delim_token_tree_repeat1 = 327,
  aux_sym_arguments_repeat1 = 328,
  aux_sym_tuple_expression_repeat1 = 329,
  aux_sym_field_initializer_list_repeat1 = 330,
  aux_sym_match_block_repeat1 = 331,
  aux_sym_closure_parameters_repeat1 = 332,
  aux_sym_tuple_pattern_repeat1 = 333,
  aux_sym_slice_pattern_repeat1 = 334,
  aux_sym_struct_pattern_repeat1 = 335,
  aux_sym_string_literal_repeat1 = 336,
  alias_sym_closure_pattern = 337,
  alias_sym_field_identifier = 338,
  alias_sym_let_chain = 339,
  alias_sym_shorthand_field_identifier = 340,
  alias_sym_type_identifier = 341,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_macro_rules_BANG] = "macro_rules!",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_token_repetition_pattern_token1] = "token_repetition_pattern_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_block] = "block",
  [anon_sym_expr] = "expr",
  [anon_sym_ident] = "ident",
  [anon_sym_item] = "item",
  [anon_sym_lifetime] = "lifetime",
  [anon_sym_literal] = "literal",
  [anon_sym_meta] = "meta",
  [anon_sym_pat] = "pat",
  [anon_sym_path] = "path",
  [anon_sym_stmt] = "stmt",
  [anon_sym_tt] = "tt",
  [anon_sym_ty] = "ty",
  [anon_sym_vis] = "vis",
  [anon_sym_u8] = "primitive_type",
  [anon_sym_i8] = "primitive_type",
  [anon_sym_u16] = "primitive_type",
  [anon_sym_i16] = "primitive_type",
  [anon_sym_u32] = "primitive_type",
  [anon_sym_i32] = "primitive_type",
  [anon_sym_u64] = "primitive_type",
  [anon_sym_i64] = "primitive_type",
  [anon_sym_u128] = "primitive_type",
  [anon_sym_i128] = "primitive_type",
  [anon_sym_isize] = "primitive_type",
  [anon_sym_usize] = "primitive_type",
  [anon_sym_f32] = "primitive_type",
  [anon_sym_f64] = "primitive_type",
  [anon_sym_bool] = "primitive_type",
  [anon_sym_str] = "primitive_type",
  [anon_sym_char] = "primitive_type",
  [anon_sym_SLASH] = "/",
  [anon_sym__] = "_",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_DASH] = "-",
  [anon_sym_EQ] = "=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_BANG] = "!",
  [anon_sym_DOT] = ".",
  [anon_sym_AT] = "@",
  [anon_sym_AMP] = "&",
  [anon_sym_POUND] = "#",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_PIPE] = "|",
  [anon_sym_TILDE] = "~",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_as] = "as",
  [anon_sym_async] = "async",
  [anon_sym_await] = "await",
  [anon_sym_break] = "break",
  [anon_sym_const] = "const",
  [anon_sym_continue] = "continue",
  [anon_sym_default] = "default",
  [anon_sym_enum] = "enum",
  [anon_sym_fn] = "fn",
  [anon_sym_for] = "for",
  [anon_sym_if] = "if",
  [anon_sym_impl] = "impl",
  [anon_sym_let] = "let",
  [anon_sym_loop] = "loop",
  [anon_sym_match] = "match",
  [anon_sym_mod] = "mod",
  [anon_sym_pub] = "pub",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_struct] = "struct",
  [anon_sym_trait] = "trait",
  [anon_sym_type] = "type",
  [anon_sym_union] = "union",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_use] = "use",
  [anon_sym_where] = "where",
  [anon_sym_while] = "while",
  [anon_sym_extern] = "extern",
  [anon_sym_ref] = "ref",
  [anon_sym_else] = "else",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_in] = "in",
  [anon_sym_LT2] = "<",
  [anon_sym_dyn] = "dyn",
  [sym_mutable_specifier] = "mutable_specifier",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_yield] = "yield",
  [anon_sym_move] = "move",
  [anon_sym_try] = "try",
  [sym_integer_literal] = "integer_literal",
  [aux_sym_string_literal_token1] = "\"",
  [anon_sym_DQUOTE] = "\"",
  [sym_char_literal] = "char_literal",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_SLASH_SLASH] = "//",
  [aux_sym_line_comment_token1] = "line_comment_token1",
  [aux_sym_line_comment_token2] = "line_comment_token2",
  [aux_sym_line_comment_token3] = "line_comment_token3",
  [sym__inner_line_doc_comment] = "inner_doc_comment",
  [sym__outer_line_doc_comment] = "outer_doc_comment",
  [anon_sym_SLASH_STAR] = "/*",
  [anon_sym_STAR_SLASH] = "*/",
  [sym_shebang] = "shebang",
  [sym_self] = "self",
  [sym_super] = "super",
  [sym_crate] = "crate",
  [sym_metavariable] = "metavariable",
  [sym__string_content] = "_string_content",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_float_literal] = "float_literal",
  [sym__outer_block_doc_comment] = "outer_doc_comment",
  [sym__inner_block_doc_comment] = "inner_doc_comment",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_source_file] = "source_file",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_macro_definition] = "macro_definition",
  [sym_macro_rule] = "macro_rule",
  [sym__token_pattern] = "_token_pattern",
  [sym_token_tree_pattern] = "token_tree_pattern",
  [sym_token_binding_pattern] = "token_binding_pattern",
  [sym_token_repetition_pattern] = "token_repetition_pattern",
  [sym_fragment_specifier] = "fragment_specifier",
  [sym_token_tree] = "token_tree",
  [sym_token_repetition] = "token_repetition",
  [sym_attribute_item] = "attribute_item",
  [sym_inner_attribute_item] = "inner_attribute_item",
  [sym_attribute] = "attribute",
  [sym_mod_item] = "mod_item",
  [sym_foreign_mod_item] = "foreign_mod_item",
  [sym_declaration_list] = "declaration_list",
  [sym_struct_item] = "struct_item",
  [sym_union_item] = "union_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_ordered_field_declaration_list] = "ordered_field_declaration_list",
  [sym_extern_crate_declaration] = "extern_crate_declaration",
  [sym_const_item] = "const_item",
  [sym_static_item] = "static_item",
  [sym_type_item] = "type_item",
  [sym_function_item] = "function_item",
  [sym_function_signature_item] = "function_signature_item",
  [sym_function_modifiers] = "function_modifiers",
  [sym_where_clause] = "where_clause",
  [sym_where_predicate] = "where_predicate",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_associated_type] = "associated_type",
  [sym_trait_bounds] = "trait_bounds",
  [sym_higher_ranked_trait_bound] = "higher_ranked_trait_bound",
  [sym_removed_trait_bound] = "removed_trait_bound",
  [sym_type_parameters] = "type_parameters",
  [sym_const_parameter] = "const_parameter",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_let_declaration] = "let_declaration",
  [sym_use_declaration] = "use_declaration",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_use_wildcard] = "use_wildcard",
  [sym_parameters] = "parameters",
  [sym_self_parameter] = "self_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter] = "parameter",
  [sym_extern_modifier] = "extern_modifier",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym__type] = "_type",
  [sym_bracketed_type] = "bracketed_type",
  [sym_qualified_type] = "qualified_type",
  [sym_lifetime] = "lifetime",
  [sym_array_type] = "array_type",
  [sym_for_lifetimes] = "for_lifetimes",
  [sym_function_type] = "function_type",
  [sym_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type_with_turbofish",
  [sym_bounded_type] = "bounded_type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_binding] = "type_binding",
  [sym_reference_type] = "reference_type",
  [sym_pointer_type] = "pointer_type",
  [sym_empty_type] = "empty_type",
  [sym_abstract_type] = "abstract_type",
  [sym_dynamic_type] = "dynamic_type",
  [sym__expression_except_range] = "_expression_except_range",
  [sym__expression] = "_expression",
  [sym_macro_invocation] = "macro_invocation",
  [sym_delim_token_tree] = "token_tree",
  [sym__delim_tokens] = "_delim_tokens",
  [sym__non_delim_token] = "_non_delim_token",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier_in_expression_position] = "scoped_type_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_range_expression] = "range_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_try_expression] = "try_expression",
  [sym_reference_expression] = "reference_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_compound_assignment_expr] = "compound_assignment_expr",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_return_expression] = "return_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_array_expression] = "array_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_unit_expression] = "unit_expression",
  [sym_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_shorthand_field_initializer] = "shorthand_field_initializer",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_if_expression] = "if_expression",
  [sym_let_condition] = "let_condition",
  [sym__let_chain] = "_let_chain",
  [sym__condition] = "_condition",
  [sym_else_clause] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym_while_expression] = "while_expression",
  [sym_loop_expression] = "loop_expression",
  [sym_for_expression] = "for_expression",
  [sym_const_block] = "const_block",
  [sym_closure_expression] = "closure_expression",
  [sym_closure_parameters] = "closure_parameters",
  [sym_label] = "label",
  [sym_break_expression] = "break_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_index_expression] = "index_expression",
  [sym_await_expression] = "await_expression",
  [sym_field_expression] = "field_expression",
  [sym_unsafe_block] = "unsafe_block",
  [sym_async_block] = "async_block",
  [sym_try_block] = "try_block",
  [sym_block] = "block",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_slice_pattern] = "slice_pattern",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym_remaining_field_pattern] = "remaining_field_pattern",
  [sym_mut_pattern] = "mut_pattern",
  [sym_range_pattern] = "range_pattern",
  [sym_ref_pattern] = "ref_pattern",
  [sym_captured_pattern] = "captured_pattern",
  [sym_reference_pattern] = "reference_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym__literal] = "_literal",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_negative_literal] = "negative_literal",
  [sym_string_literal] = "string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_line_comment] = "line_comment",
  [sym__line_doc_comment] = "doc_comment",
  [sym_block_comment] = "block_comment",
  [sym__block_doc_comment] = "doc_comment",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_macro_definition_repeat1] = "macro_definition_repeat1",
  [aux_sym_token_tree_pattern_repeat1] = "token_tree_pattern_repeat1",
  [aux_sym_token_tree_repeat1] = "token_tree_repeat1",
  [aux_sym__non_special_token_repeat1] = "_non_special_token_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_ordered_field_declaration_list_repeat1] = "ordered_field_declaration_list_repeat1",
  [aux_sym_function_modifiers_repeat1] = "function_modifiers_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_trait_bounds_repeat1] = "trait_bounds_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_for_lifetimes_repeat1] = "for_lifetimes_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_delim_token_tree_repeat1] = "delim_token_tree_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_closure_parameters_repeat1] = "closure_parameters_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_slice_pattern_repeat1] = "slice_pattern_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_closure_pattern] = "closure_pattern",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_let_chain] = "let_chain",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_macro_rules_BANG] = anon_sym_macro_rules_BANG,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_token_repetition_pattern_token1] = aux_sym_token_repetition_pattern_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_expr] = anon_sym_expr,
  [anon_sym_ident] = anon_sym_ident,
  [anon_sym_item] = anon_sym_item,
  [anon_sym_lifetime] = anon_sym_lifetime,
  [anon_sym_literal] = anon_sym_literal,
  [anon_sym_meta] = anon_sym_meta,
  [anon_sym_pat] = anon_sym_pat,
  [anon_sym_path] = anon_sym_path,
  [anon_sym_stmt] = anon_sym_stmt,
  [anon_sym_tt] = anon_sym_tt,
  [anon_sym_ty] = anon_sym_ty,
  [anon_sym_vis] = anon_sym_vis,
  [anon_sym_u8] = anon_sym_u8,
  [anon_sym_i8] = anon_sym_u8,
  [anon_sym_u16] = anon_sym_u8,
  [anon_sym_i16] = anon_sym_u8,
  [anon_sym_u32] = anon_sym_u8,
  [anon_sym_i32] = anon_sym_u8,
  [anon_sym_u64] = anon_sym_u8,
  [anon_sym_i64] = anon_sym_u8,
  [anon_sym_u128] = anon_sym_u8,
  [anon_sym_i128] = anon_sym_u8,
  [anon_sym_isize] = anon_sym_u8,
  [anon_sym_usize] = anon_sym_u8,
  [anon_sym_f32] = anon_sym_u8,
  [anon_sym_f64] = anon_sym_u8,
  [anon_sym_bool] = anon_sym_u8,
  [anon_sym_str] = anon_sym_u8,
  [anon_sym_char] = anon_sym_u8,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym__] = anon_sym__,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_dyn] = anon_sym_dyn,
  [sym_mutable_specifier] = sym_mutable_specifier,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_move] = anon_sym_move,
  [anon_sym_try] = anon_sym_try,
  [sym_integer_literal] = sym_integer_literal,
  [aux_sym_string_literal_token1] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_char_literal] = sym_char_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [aux_sym_line_comment_token1] = aux_sym_line_comment_token1,
  [aux_sym_line_comment_token2] = aux_sym_line_comment_token2,
  [aux_sym_line_comment_token3] = aux_sym_line_comment_token3,
  [sym__inner_line_doc_comment] = sym__inner_block_doc_comment,
  [sym__outer_line_doc_comment] = sym__outer_block_doc_comment,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [anon_sym_STAR_SLASH] = anon_sym_STAR_SLASH,
  [sym_shebang] = sym_shebang,
  [sym_self] = sym_self,
  [sym_super] = sym_super,
  [sym_crate] = sym_crate,
  [sym_metavariable] = sym_metavariable,
  [sym__string_content] = sym__string_content,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_float_literal] = sym_float_literal,
  [sym__outer_block_doc_comment] = sym__outer_block_doc_comment,
  [sym__inner_block_doc_comment] = sym__inner_block_doc_comment,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_source_file] = sym_source_file,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_macro_definition] = sym_macro_definition,
  [sym_macro_rule] = sym_macro_rule,
  [sym__token_pattern] = sym__token_pattern,
  [sym_token_tree_pattern] = sym_token_tree_pattern,
  [sym_token_binding_pattern] = sym_token_binding_pattern,
  [sym_token_repetition_pattern] = sym_token_repetition_pattern,
  [sym_fragment_specifier] = sym_fragment_specifier,
  [sym_token_tree] = sym_token_tree,
  [sym_token_repetition] = sym_token_repetition,
  [sym_attribute_item] = sym_attribute_item,
  [sym_inner_attribute_item] = sym_inner_attribute_item,
  [sym_attribute] = sym_attribute,
  [sym_mod_item] = sym_mod_item,
  [sym_foreign_mod_item] = sym_foreign_mod_item,
  [sym_declaration_list] = sym_declaration_list,
  [sym_struct_item] = sym_struct_item,
  [sym_union_item] = sym_union_item,
  [sym_enum_item] = sym_enum_item,
  [sym_enum_variant_list] = sym_enum_variant_list,
  [sym_enum_variant] = sym_enum_variant,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_ordered_field_declaration_list] = sym_ordered_field_declaration_list,
  [sym_extern_crate_declaration] = sym_extern_crate_declaration,
  [sym_const_item] = sym_const_item,
  [sym_static_item] = sym_static_item,
  [sym_type_item] = sym_type_item,
  [sym_function_item] = sym_function_item,
  [sym_function_signature_item] = sym_function_signature_item,
  [sym_function_modifiers] = sym_function_modifiers,
  [sym_where_clause] = sym_where_clause,
  [sym_where_predicate] = sym_where_predicate,
  [sym_impl_item] = sym_impl_item,
  [sym_trait_item] = sym_trait_item,
  [sym_associated_type] = sym_associated_type,
  [sym_trait_bounds] = sym_trait_bounds,
  [sym_higher_ranked_trait_bound] = sym_higher_ranked_trait_bound,
  [sym_removed_trait_bound] = sym_removed_trait_bound,
  [sym_type_parameters] = sym_type_parameters,
  [sym_const_parameter] = sym_const_parameter,
  [sym_constrained_type_parameter] = sym_constrained_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_let_declaration] = sym_let_declaration,
  [sym_use_declaration] = sym_use_declaration,
  [sym__use_clause] = sym__use_clause,
  [sym_scoped_use_list] = sym_scoped_use_list,
  [sym_use_list] = sym_use_list,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_use_wildcard] = sym_use_wildcard,
  [sym_parameters] = sym_parameters,
  [sym_self_parameter] = sym_self_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter] = sym_parameter,
  [sym_extern_modifier] = sym_extern_modifier,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym__type] = sym__type,
  [sym_bracketed_type] = sym_bracketed_type,
  [sym_qualified_type] = sym_qualified_type,
  [sym_lifetime] = sym_lifetime,
  [sym_array_type] = sym_array_type,
  [sym_for_lifetimes] = sym_for_lifetimes,
  [sym_function_type] = sym_function_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_unit_type] = sym_unit_type,
  [sym_generic_function] = sym_generic_function,
  [sym_generic_type] = sym_generic_type,
  [sym_generic_type_with_turbofish] = sym_generic_type_with_turbofish,
  [sym_bounded_type] = sym_bounded_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_binding] = sym_type_binding,
  [sym_reference_type] = sym_reference_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_empty_type] = sym_empty_type,
  [sym_abstract_type] = sym_abstract_type,
  [sym_dynamic_type] = sym_dynamic_type,
  [sym__expression_except_range] = sym__expression_except_range,
  [sym__expression] = sym__expression,
  [sym_macro_invocation] = sym_macro_invocation,
  [sym_delim_token_tree] = sym_token_tree,
  [sym__delim_tokens] = sym__delim_tokens,
  [sym__non_delim_token] = sym__non_delim_token,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_scoped_type_identifier_in_expression_position] = sym_scoped_type_identifier,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_range_expression] = sym_range_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_reference_expression] = sym_reference_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_compound_assignment_expr] = sym_compound_assignment_expr,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_arguments] = sym_arguments,
  [sym_array_expression] = sym_array_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_unit_expression] = sym_unit_expression,
  [sym_struct_expression] = sym_struct_expression,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_shorthand_field_initializer] = sym_shorthand_field_initializer,
  [sym_field_initializer] = sym_field_initializer,
  [sym_base_field_initializer] = sym_base_field_initializer,
  [sym_if_expression] = sym_if_expression,
  [sym_let_condition] = sym_let_condition,
  [sym__let_chain] = sym__let_chain,
  [sym__condition] = sym__condition,
  [sym_else_clause] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym_match_pattern] = sym_match_pattern,
  [sym_while_expression] = sym_while_expression,
  [sym_loop_expression] = sym_loop_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_const_block] = sym_const_block,
  [sym_closure_expression] = sym_closure_expression,
  [sym_closure_parameters] = sym_closure_parameters,
  [sym_label] = sym_label,
  [sym_break_expression] = sym_break_expression,
  [sym_continue_expression] = sym_continue_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_unsafe_block] = sym_unsafe_block,
  [sym_async_block] = sym_async_block,
  [sym_try_block] = sym_try_block,
  [sym_block] = sym_block,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_slice_pattern] = sym_slice_pattern,
  [sym_tuple_struct_pattern] = sym_tuple_struct_pattern,
  [sym_struct_pattern] = sym_struct_pattern,
  [sym_field_pattern] = sym_field_pattern,
  [sym_remaining_field_pattern] = sym_remaining_field_pattern,
  [sym_mut_pattern] = sym_mut_pattern,
  [sym_range_pattern] = sym_range_pattern,
  [sym_ref_pattern] = sym_ref_pattern,
  [sym_captured_pattern] = sym_captured_pattern,
  [sym_reference_pattern] = sym_reference_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym__literal] = sym__literal,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_negative_literal] = sym_negative_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_line_comment] = sym_line_comment,
  [sym__line_doc_comment] = sym__line_doc_comment,
  [sym_block_comment] = sym_block_comment,
  [sym__block_doc_comment] = sym__line_doc_comment,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_macro_definition_repeat1] = aux_sym_macro_definition_repeat1,
  [aux_sym_token_tree_pattern_repeat1] = aux_sym_token_tree_pattern_repeat1,
  [aux_sym_token_tree_repeat1] = aux_sym_token_tree_repeat1,
  [aux_sym__non_special_token_repeat1] = aux_sym__non_special_token_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_enum_variant_list_repeat1] = aux_sym_enum_variant_list_repeat1,
  [aux_sym_enum_variant_list_repeat2] = aux_sym_enum_variant_list_repeat2,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_ordered_field_declaration_list_repeat1] = aux_sym_ordered_field_declaration_list_repeat1,
  [aux_sym_function_modifiers_repeat1] = aux_sym_function_modifiers_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_trait_bounds_repeat1] = aux_sym_trait_bounds_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_for_lifetimes_repeat1] = aux_sym_for_lifetimes_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_delim_token_tree_repeat1] = aux_sym_delim_token_tree_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_closure_parameters_repeat1] = aux_sym_closure_parameters_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_slice_pattern_repeat1] = aux_sym_slice_pattern_repeat1,
  [aux_sym_struct_pattern_repeat1] = aux_sym_struct_pattern_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_closure_pattern] = alias_sym_closure_pattern,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_let_chain] = alias_sym_let_chain,
  [alias_sym_shorthand_field_identifier] = alias_sym_shorthand_field_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro_rules_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_token_repetition_pattern_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_expr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ident] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lifetime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_literal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_path] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stmt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dyn] = {
    .visible = true,
    .named = false,
  },
  [sym_mutable_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_move] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_line_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token3] = {
    .visible = false,
    .named = false,
  },
  [sym__inner_line_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_line_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_crate] = {
    .visible = true,
    .named = true,
  },
  [sym_metavariable] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_block_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__inner_block_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_rule] = {
    .visible = true,
    .named = true,
  },
  [sym__token_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_token_tree_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_binding_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_fragment_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_union_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_crate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_static_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_associated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_higher_ranked_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_removed_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_const_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_self_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracketed_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lifetime] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_for_lifetimes] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_type] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_except_range] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_macro_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_delim_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym__delim_tokens] = {
    .visible = false,
    .named = true,
  },
  [sym__non_delim_token] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier_in_expression_position] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_shorthand_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_let_condition] = {
    .visible = true,
    .named = true,
  },
  [sym__let_chain] = {
    .visible = false,
    .named = true,
  },
  [sym__condition] = {
    .visible = false,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_const_block] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_async_block] = {
    .visible = true,
    .named = true,
  },
  [sym_try_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_remaining_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_mut_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_captured_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_negative_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__line_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__block_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__non_special_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_bounds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_lifetimes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_delim_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_closure_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_closure_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_let_chain] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_bounds = 6,
  field_condition = 7,
  field_consequence = 8,
  field_default_type = 9,
  field_doc = 10,
  field_element = 11,
  field_field = 12,
  field_function = 13,
  field_inner = 14,
  field_left = 15,
  field_length = 16,
  field_list = 17,
  field_macro = 18,
  field_name = 19,
  field_operator = 20,
  field_outer = 21,
  field_parameters = 22,
  field_path = 23,
  field_pattern = 24,
  field_return_type = 25,
  field_right = 26,
  field_trait = 27,
  field_type = 28,
  field_type_arguments = 29,
  field_type_parameters = 30,
  field_value = 31,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_bounds] = "bounds",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_default_type] = "default_type",
  [field_doc] = "doc",
  [field_element] = "element",
  [field_field] = "field",
  [field_function] = "function",
  [field_inner] = "inner",
  [field_left] = "left",
  [field_length] = "length",
  [field_list] = "list",
  [field_macro] = "macro",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_outer] = "outer",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_trait] = "trait",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [10] = {.index = 5, .length = 2},
  [11] = {.index = 5, .length = 2},
  [12] = {.index = 7, .length = 2},
  [13] = {.index = 9, .length = 2},
  [14] = {.index = 11, .length = 3},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 14, .length = 2},
  [17] = {.index = 16, .length = 1},
  [18] = {.index = 17, .length = 1},
  [19] = {.index = 18, .length = 2},
  [20] = {.index = 20, .length = 1},
  [21] = {.index = 21, .length = 1},
  [22] = {.index = 21, .length = 1},
  [23] = {.index = 22, .length = 2},
  [24] = {.index = 18, .length = 2},
  [25] = {.index = 22, .length = 2},
  [26] = {.index = 18, .length = 2},
  [27] = {.index = 24, .length = 1},
  [28] = {.index = 25, .length = 2},
  [29] = {.index = 27, .length = 2},
  [30] = {.index = 29, .length = 2},
  [31] = {.index = 31, .length = 1},
  [32] = {.index = 32, .length = 2},
  [33] = {.index = 25, .length = 2},
  [34] = {.index = 34, .length = 2},
  [35] = {.index = 36, .length = 1},
  [36] = {.index = 37, .length = 1},
  [37] = {.index = 38, .length = 2},
  [38] = {.index = 14, .length = 2},
  [39] = {.index = 14, .length = 2},
  [40] = {.index = 40, .length = 2},
  [41] = {.index = 42, .length = 2},
  [42] = {.index = 24, .length = 1},
  [43] = {.index = 44, .length = 1},
  [44] = {.index = 14, .length = 2},
  [45] = {.index = 14, .length = 2},
  [46] = {.index = 45, .length = 3},
  [47] = {.index = 48, .length = 2},
  [48] = {.index = 50, .length = 2},
  [49] = {.index = 50, .length = 2},
  [50] = {.index = 52, .length = 2},
  [51] = {.index = 42, .length = 2},
  [52] = {.index = 2, .length = 1},
  [53] = {.index = 54, .length = 1},
  [54] = {.index = 54, .length = 1},
  [55] = {.index = 55, .length = 1},
  [56] = {.index = 56, .length = 1},
  [57] = {.index = 57, .length = 1},
  [58] = {.index = 58, .length = 2},
  [59] = {.index = 60, .length = 2},
  [60] = {.index = 60, .length = 2},
  [62] = {.index = 62, .length = 1},
  [63] = {.index = 62, .length = 1},
  [64] = {.index = 63, .length = 1},
  [66] = {.index = 64, .length = 2},
  [67] = {.index = 63, .length = 1},
  [68] = {.index = 66, .length = 2},
  [69] = {.index = 68, .length = 3},
  [70] = {.index = 71, .length = 2},
  [71] = {.index = 73, .length = 3},
  [72] = {.index = 76, .length = 3},
  [74] = {.index = 79, .length = 2},
  [75] = {.index = 79, .length = 2},
  [76] = {.index = 81, .length = 2},
  [77] = {.index = 83, .length = 3},
  [78] = {.index = 86, .length = 2},
  [79] = {.index = 88, .length = 1},
  [81] = {.index = 89, .length = 2},
  [82] = {.index = 91, .length = 2},
  [83] = {.index = 93, .length = 3},
  [84] = {.index = 96, .length = 2},
  [85] = {.index = 98, .length = 2},
  [86] = {.index = 100, .length = 2},
  [87] = {.index = 102, .length = 2},
  [88] = {.index = 104, .length = 2},
  [89] = {.index = 102, .length = 2},
  [90] = {.index = 104, .length = 2},
  [91] = {.index = 106, .length = 1},
  [92] = {.index = 100, .length = 2},
  [93] = {.index = 106, .length = 1},
  [94] = {.index = 107, .length = 1},
  [95] = {.index = 108, .length = 3},
  [96] = {.index = 111, .length = 1},
  [97] = {.index = 112, .length = 1},
  [98] = {.index = 16, .length = 1},
  [99] = {.index = 113, .length = 1},
  [100] = {.index = 114, .length = 2},
  [101] = {.index = 116, .length = 1},
  [102] = {.index = 116, .length = 1},
  [103] = {.index = 117, .length = 3},
  [104] = {.index = 120, .length = 1},
  [105] = {.index = 117, .length = 3},
  [106] = {.index = 121, .length = 2},
  [107] = {.index = 2, .length = 1},
  [108] = {.index = 123, .length = 2},
  [109] = {.index = 125, .length = 3},
  [110] = {.index = 128, .length = 3},
  [111] = {.index = 131, .length = 4},
  [112] = {.index = 135, .length = 3},
  [113] = {.index = 138, .length = 3},
  [114] = {.index = 141, .length = 2},
  [115] = {.index = 143, .length = 2},
  [116] = {.index = 143, .length = 2},
  [117] = {.index = 145, .length = 2},
  [118] = {.index = 147, .length = 3},
  [119] = {.index = 150, .length = 3},
  [120] = {.index = 145, .length = 2},
  [121] = {.index = 147, .length = 3},
  [122] = {.index = 153, .length = 2},
  [124] = {.index = 155, .length = 3},
  [125] = {.index = 158, .length = 3},
  [126] = {.index = 161, .length = 4},
  [127] = {.index = 123, .length = 2},
  [128] = {.index = 165, .length = 3},
  [129] = {.index = 168, .length = 2},
  [130] = {.index = 170, .length = 3},
  [131] = {.index = 173, .length = 2},
  [132] = {.index = 175, .length = 2},
  [133] = {.index = 177, .length = 3},
  [134] = {.index = 180, .length = 3},
  [135] = {.index = 183, .length = 2},
  [136] = {.index = 185, .length = 2},
  [137] = {.index = 187, .length = 3},
  [138] = {.index = 190, .length = 2},
  [139] = {.index = 192, .length = 2},
  [140] = {.index = 194, .length = 1},
  [141] = {.index = 195, .length = 2},
  [142] = {.index = 197, .length = 1},
  [143] = {.index = 198, .length = 2},
  [144] = {.index = 200, .length = 2},
  [145] = {.index = 202, .length = 2},
  [146] = {.index = 204, .length = 3},
  [147] = {.index = 204, .length = 3},
  [148] = {.index = 106, .length = 1},
  [149] = {.index = 207, .length = 2},
  [150] = {.index = 183, .length = 2},
  [151] = {.index = 209, .length = 4},
  [152] = {.index = 213, .length = 3},
  [153] = {.index = 216, .length = 4},
  [154] = {.index = 220, .length = 2},
  [155] = {.index = 222, .length = 3},
  [156] = {.index = 220, .length = 2},
  [157] = {.index = 222, .length = 3},
  [158] = {.index = 225, .length = 3},
  [159] = {.index = 228, .length = 3},
  [160] = {.index = 231, .length = 4},
  [161] = {.index = 228, .length = 3},
  [162] = {.index = 231, .length = 4},
  [163] = {.index = 225, .length = 3},
  [164] = {.index = 235, .length = 2},
  [165] = {.index = 237, .length = 2},
  [166] = {.index = 239, .length = 2},
  [167] = {.index = 241, .length = 2},
  [168] = {.index = 243, .length = 1},
  [169] = {.index = 243, .length = 1},
  [170] = {.index = 244, .length = 2},
  [171] = {.index = 246, .length = 3},
  [172] = {.index = 249, .length = 2},
  [173] = {.index = 251, .length = 2},
  [174] = {.index = 200, .length = 2},
  [175] = {.index = 253, .length = 4},
  [176] = {.index = 257, .length = 3},
  [177] = {.index = 260, .length = 3},
  [178] = {.index = 263, .length = 3},
  [179] = {.index = 266, .length = 3},
  [180] = {.index = 269, .length = 4},
  [181] = {.index = 273, .length = 2},
  [182] = {.index = 275, .length = 2},
  [183] = {.index = 277, .length = 3},
  [184] = {.index = 280, .length = 4},
  [185] = {.index = 284, .length = 3},
  [186] = {.index = 244, .length = 2},
  [187] = {.index = 287, .length = 2},
  [188] = {.index = 289, .length = 3},
  [189] = {.index = 292, .length = 3},
  [190] = {.index = 295, .length = 2},
  [191] = {.index = 297, .length = 3},
  [192] = {.index = 200, .length = 2},
  [193] = {.index = 300, .length = 3},
  [194] = {.index = 303, .length = 2},
  [195] = {.index = 305, .length = 2},
  [196] = {.index = 307, .length = 3},
  [197] = {.index = 310, .length = 3},
  [198] = {.index = 275, .length = 2},
  [199] = {.index = 313, .length = 4},
  [200] = {.index = 317, .length = 5},
  [201] = {.index = 322, .length = 4},
  [202] = {.index = 326, .length = 3},
  [203] = {.index = 326, .length = 3},
  [204] = {.index = 329, .length = 3},
  [205] = {.index = 332, .length = 4},
  [206] = {.index = 329, .length = 3},
  [207] = {.index = 332, .length = 4},
  [208] = {.index = 336, .length = 4},
  [209] = {.index = 336, .length = 4},
  [210] = {.index = 340, .length = 3},
  [211] = {.index = 343, .length = 3},
  [212] = {.index = 346, .length = 3},
  [213] = {.index = 349, .length = 2},
  [214] = {.index = 351, .length = 2},
  [215] = {.index = 123, .length = 2},
  [216] = {.index = 353, .length = 2},
  [217] = {.index = 355, .length = 3},
  [218] = {.index = 353, .length = 2},
  [219] = {.index = 355, .length = 3},
  [220] = {.index = 358, .length = 3},
  [221] = {.index = 361, .length = 4},
  [222] = {.index = 358, .length = 3},
  [223] = {.index = 361, .length = 4},
  [224] = {.index = 365, .length = 4},
  [225] = {.index = 369, .length = 4},
  [226] = {.index = 373, .length = 3},
  [227] = {.index = 376, .length = 4},
  [228] = {.index = 380, .length = 3},
  [229] = {.index = 383, .length = 3},
  [230] = {.index = 386, .length = 3},
  [231] = {.index = 389, .length = 4},
  [232] = {.index = 393, .length = 2},
  [233] = {.index = 395, .length = 3},
  [234] = {.index = 398, .length = 4},
  [235] = {.index = 402, .length = 3},
  [236] = {.index = 405, .length = 3},
  [237] = {.index = 408, .length = 2},
  [238] = {.index = 410, .length = 3},
  [239] = {.index = 413, .length = 5},
  [240] = {.index = 418, .length = 4},
  [241] = {.index = 418, .length = 4},
  [242] = {.index = 422, .length = 3},
  [243] = {.index = 425, .length = 3},
  [244] = {.index = 428, .length = 3},
  [245] = {.index = 431, .length = 3},
  [246] = {.index = 434, .length = 2},
  [247] = {.index = 436, .length = 3},
  [248] = {.index = 436, .length = 3},
  [249] = {.index = 439, .length = 3},
  [250] = {.index = 442, .length = 4},
  [251] = {.index = 439, .length = 3},
  [252] = {.index = 442, .length = 4},
  [253] = {.index = 446, .length = 4},
  [254] = {.index = 446, .length = 4},
  [255] = {.index = 450, .length = 4},
  [256] = {.index = 454, .length = 5},
  [257] = {.index = 459, .length = 4},
  [258] = {.index = 463, .length = 2},
  [259] = {.index = 465, .length = 4},
  [260] = {.index = 469, .length = 4},
  [261] = {.index = 473, .length = 3},
  [262] = {.index = 476, .length = 4},
  [263] = {.index = 480, .length = 4},
  [264] = {.index = 484, .length = 3},
  [265] = {.index = 487, .length = 4},
  [266] = {.index = 487, .length = 4},
  [267] = {.index = 491, .length = 5},
  [268] = {.index = 496, .length = 4},
  [269] = {.index = 500, .length = 5},
  [270] = {.index = 505, .length = 4},
  [271] = {.index = 509, .length = 4},
  [272] = {.index = 513, .length = 3},
  [273] = {.index = 516, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_inner, 0},
  [1] =
    {field_outer, 0},
  [2] =
    {field_name, 1},
  [3] =
    {field_value, 1},
  [4] =
    {field_body, 1},
  [5] =
    {field_body, 1},
    {field_name, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_body, 1},
    {field_parameters, 0},
  [11] =
    {field_doc, 1},
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [14] =
    {field_name, 2},
    {field_path, 0},
  [16] =
    {field_value, 2},
  [17] =
    {field_type, 1},
  [18] =
    {field_type, 0},
    {field_type_arguments, 1},
  [20] =
    {field_parameters, 1},
  [21] =
    {field_trait, 1},
  [22] =
    {field_parameters, 1},
    {field_trait, 0},
  [24] =
    {field_macro, 0},
  [25] =
    {field_body, 2},
    {field_name, 1},
  [27] =
    {field_condition, 1},
    {field_consequence, 2},
  [29] =
    {field_body, 2},
    {field_type, 1},
  [31] =
    {field_pattern, 1},
  [32] =
    {field_body, 2},
    {field_value, 1},
  [34] =
    {field_body, 2},
    {field_parameters, 1},
  [36] =
    {field_list, 1},
  [37] =
    {field_argument, 1},
  [38] =
    {field_body, 2},
    {field_condition, 1},
  [40] =
    {field_function, 0},
    {field_type_arguments, 2},
  [42] =
    {field_type, 0},
    {field_type_arguments, 2},
  [44] =
    {field_body, 2},
  [45] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [48] =
    {field_left, 0},
    {field_right, 2},
  [50] =
    {field_field, 2},
    {field_value, 0},
  [52] =
    {field_type, 2},
    {field_value, 0},
  [54] =
    {field_arguments, 1},
  [55] =
    {field_element, 1},
  [56] =
    {field_type, 2},
  [57] =
    {field_parameters, 2},
  [58] =
    {field_alias, 2},
    {field_type, 0},
  [60] =
    {field_parameters, 2},
    {field_trait, 1},
  [62] =
    {field_type, 0},
  [63] =
    {field_name, 0},
  [64] =
    {field_pattern, 0},
    {field_type, 2},
  [66] =
    {field_body, 3},
    {field_name, 1},
  [68] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [71] =
    {field_name, 1},
    {field_parameters, 2},
  [73] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [76] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [79] =
    {field_bounds, 1},
    {field_left, 0},
  [81] =
    {field_type, 2},
    {field_type_parameters, 1},
  [83] =
    {field_body, 3},
    {field_type, 2},
    {field_type_parameters, 1},
  [86] =
    {field_body, 3},
    {field_type, 1},
  [88] =
    {field_pattern, 2},
  [89] =
    {field_body, 3},
    {field_parameters, 2},
  [91] =
    {field_name, 1},
    {field_type_parameters, 2},
  [93] =
    {field_body, 3},
    {field_bounds, 2},
    {field_name, 1},
  [96] =
    {field_bounds, 2},
    {field_name, 1},
  [98] =
    {field_body, 3},
    {field_type, 2},
  [100] =
    {field_body, 3},
    {field_name, 2},
  [102] =
    {field_list, 2},
    {field_path, 0},
  [104] =
    {field_alias, 2},
    {field_path, 0},
  [106] =
    {field_name, 2},
  [107] =
    {field_argument, 2},
  [108] =
    {field_body, 3},
    {field_parameters, 0},
    {field_return_type, 2},
  [111] =
    {field_body, 3},
  [112] =
    {field_length, 3},
  [113] =
    {field_type, 3},
  [114] =
    {field_parameters, 1},
    {field_return_type, 3},
  [116] =
    {field_trait, 3},
  [117] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_trait, 0},
  [120] =
    {field_parameters, 3},
  [121] =
    {field_pattern, 1},
    {field_type, 3},
  [123] =
    {field_name, 1},
    {field_type, 3},
  [125] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [128] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [131] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [135] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [138] =
    {field_body, 4},
    {field_pattern, 1},
    {field_value, 3},
  [141] =
    {field_pattern, 1},
    {field_value, 3},
  [143] =
    {field_default_type, 2},
    {field_name, 0},
  [145] =
    {field_trait, 1},
    {field_type, 3},
  [147] =
    {field_body, 4},
    {field_trait, 1},
    {field_type, 3},
  [150] =
    {field_body, 4},
    {field_type, 2},
    {field_type_parameters, 1},
  [153] =
    {field_alternative, 3},
    {field_pattern, 1},
  [155] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3},
  [158] =
    {field_body, 4},
    {field_bounds, 2},
    {field_name, 1},
  [161] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [165] =
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [168] =
    {field_type, 3},
    {field_type_parameters, 2},
  [170] =
    {field_body, 4},
    {field_type, 3},
    {field_type_parameters, 2},
  [173] =
    {field_body, 4},
    {field_type, 2},
  [175] =
    {field_body, 4},
    {field_name, 2},
  [177] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 2},
  [180] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [183] =
    {field_name, 0},
    {field_value, 2},
  [185] =
    {field_name, 2},
    {field_parameters, 3},
  [187] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [190] =
    {field_name, 2},
    {field_type_parameters, 3},
  [192] =
    {field_body, 4},
    {field_name, 3},
  [194] =
    {field_name, 3},
  [195] =
    {field_body, 4},
    {field_condition, 3},
  [197] =
    {field_length, 4},
  [198] =
    {field_element, 1},
    {field_length, 3},
  [200] =
    {field_name, 0},
    {field_type, 2},
  [202] =
    {field_parameters, 2},
    {field_return_type, 4},
  [204] =
    {field_parameters, 2},
    {field_return_type, 4},
    {field_trait, 1},
  [207] =
    {field_name, 0},
    {field_pattern, 2},
  [209] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [213] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [216] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [220] =
    {field_trait, 2},
    {field_type, 4},
  [222] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
  [225] =
    {field_body, 5},
    {field_trait, 1},
    {field_type, 3},
  [228] =
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [231] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [235] =
    {field_pattern, 2},
    {field_type, 4},
  [237] =
    {field_pattern, 2},
    {field_value, 4},
  [239] =
    {field_alternative, 4},
    {field_pattern, 2},
  [241] =
    {field_pattern, 0},
    {field_value, 2},
  [243] =
    {field_condition, 2},
  [244] =
    {field_name, 2},
    {field_type, 4},
  [246] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4},
  [249] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [251] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [253] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [257] =
    {field_name, 1},
    {field_type, 4},
    {field_type_parameters, 2},
  [260] =
    {field_body, 5},
    {field_type, 3},
    {field_type_parameters, 2},
  [263] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 2},
  [266] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [269] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [273] =
    {field_alias, 4},
    {field_name, 2},
  [275] =
    {field_name, 1},
    {field_value, 3},
  [277] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [280] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [284] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [287] =
    {field_body, 5},
    {field_name, 3},
  [289] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 3},
  [292] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [295] =
    {field_name, 3},
    {field_parameters, 4},
  [297] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [300] =
    {field_name, 0},
    {field_type, 3},
    {field_type_arguments, 1},
  [303] =
    {field_parameters, 3},
    {field_return_type, 5},
  [305] =
    {field_name, 1},
    {field_pattern, 3},
  [307] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 5},
  [310] =
    {field_body, 1},
    {field_name, 0},
    {field_value, 3},
  [313] =
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [317] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [322] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [326] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
  [329] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [332] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [336] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [340] =
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [343] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_type, 3},
  [346] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_value, 3},
  [349] =
    {field_name, 3},
    {field_type, 5},
  [351] =
    {field_type, 2},
    {field_type, 3, .inherited = true},
  [353] =
    {field_trait, 3},
    {field_type, 5},
  [355] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
  [358] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [361] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [365] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [369] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [373] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [376] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [380] =
    {field_name, 2},
    {field_type, 5},
    {field_type_parameters, 3},
  [383] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 3},
  [386] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [389] =
    {field_body, 6},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [393] =
    {field_alias, 5},
    {field_name, 3},
  [395] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [398] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [402] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [405] =
    {field_body, 6},
    {field_pattern, 3},
    {field_value, 5},
  [408] =
    {field_name, 2},
    {field_pattern, 4},
  [410] =
    {field_body, 2},
    {field_name, 1},
    {field_value, 4},
  [413] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [418] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [422] =
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [425] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_type, 4},
  [428] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_value, 4},
  [431] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 6},
  [434] =
    {field_type, 3},
    {field_type, 4, .inherited = true},
  [436] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
  [439] =
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [442] =
    {field_body, 7},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [446] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [450] =
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [454] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [459] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [463] =
    {field_name, 4},
    {field_type, 6},
  [465] =
    {field_body, 7},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [469] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [473] =
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [476] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [480] =
    {field_alternative, 7},
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [484] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 7},
  [487] =
    {field_body, 8},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [491] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [496] =
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [500] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [505] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [509] =
    {field_alternative, 8},
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [513] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 8},
  [516] =
    {field_body, 9},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [5] = {
    [1] = alias_sym_type_identifier,
  },
  [7] = {
    [0] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = alias_sym_let_chain,
  },
  [10] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = sym_identifier,
  },
  [16] = {
    [0] = sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = sym_identifier,
  },
  [21] = {
    [1] = alias_sym_type_identifier,
  },
  [23] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [0] = alias_sym_type_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_type_identifier,
  },
  [39] = {
    [2] = alias_sym_type_identifier,
  },
  [41] = {
    [0] = alias_sym_type_identifier,
  },
  [44] = {
    [0] = sym_generic_type,
  },
  [45] = {
    [0] = sym_generic_type,
    [2] = alias_sym_type_identifier,
  },
  [49] = {
    [2] = alias_sym_field_identifier,
  },
  [52] = {
    [1] = sym_identifier,
  },
  [53] = {
    [0] = sym_identifier,
  },
  [59] = {
    [1] = alias_sym_type_identifier,
  },
  [61] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [63] = {
    [0] = alias_sym_type_identifier,
  },
  [64] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [65] = {
    [2] = sym_identifier,
  },
  [68] = {
    [1] = alias_sym_type_identifier,
  },
  [69] = {
    [1] = alias_sym_type_identifier,
  },
  [73] = {
    [1] = alias_sym_type_identifier,
  },
  [74] = {
    [0] = alias_sym_type_identifier,
  },
  [80] = {
    [0] = alias_sym_closure_pattern,
  },
  [82] = {
    [1] = alias_sym_type_identifier,
  },
  [83] = {
    [1] = alias_sym_type_identifier,
  },
  [84] = {
    [1] = alias_sym_type_identifier,
  },
  [86] = {
    [2] = alias_sym_type_identifier,
  },
  [87] = {
    [0] = sym_identifier,
  },
  [88] = {
    [0] = sym_identifier,
  },
  [93] = {
    [2] = alias_sym_type_identifier,
  },
  [98] = {
    [0] = sym_identifier,
  },
  [101] = {
    [3] = alias_sym_type_identifier,
  },
  [103] = {
    [0] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [109] = {
    [1] = alias_sym_type_identifier,
  },
  [115] = {
    [0] = alias_sym_type_identifier,
  },
  [117] = {
    [1] = alias_sym_type_identifier,
  },
  [118] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [3] = sym_identifier,
  },
  [125] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [1] = alias_sym_type_identifier,
  },
  [127] = {
    [1] = alias_sym_type_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [132] = {
    [2] = alias_sym_type_identifier,
  },
  [133] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [2] = alias_sym_type_identifier,
  },
  [135] = {
    [0] = alias_sym_field_identifier,
  },
  [138] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [3] = alias_sym_type_identifier,
  },
  [144] = {
    [0] = alias_sym_type_identifier,
  },
  [146] = {
    [1] = alias_sym_type_identifier,
  },
  [148] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [149] = {
    [0] = alias_sym_field_identifier,
  },
  [154] = {
    [2] = alias_sym_type_identifier,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [158] = {
    [1] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [168] = {
    [0] = alias_sym_closure_pattern,
  },
  [174] = {
    [0] = alias_sym_field_identifier,
  },
  [175] = {
    [1] = alias_sym_type_identifier,
  },
  [176] = {
    [1] = alias_sym_type_identifier,
  },
  [178] = {
    [2] = alias_sym_type_identifier,
  },
  [179] = {
    [2] = alias_sym_type_identifier,
  },
  [180] = {
    [2] = alias_sym_type_identifier,
  },
  [182] = {
    [1] = alias_sym_field_identifier,
  },
  [186] = {
    [2] = alias_sym_type_identifier,
  },
  [187] = {
    [3] = alias_sym_type_identifier,
  },
  [188] = {
    [3] = alias_sym_type_identifier,
  },
  [189] = {
    [3] = alias_sym_type_identifier,
  },
  [193] = {
    [0] = alias_sym_type_identifier,
  },
  [195] = {
    [1] = alias_sym_field_identifier,
  },
  [202] = {
    [2] = alias_sym_type_identifier,
  },
  [204] = {
    [3] = alias_sym_type_identifier,
  },
  [205] = {
    [3] = alias_sym_type_identifier,
  },
  [208] = {
    [2] = alias_sym_type_identifier,
  },
  [215] = {
    [1] = alias_sym_field_identifier,
  },
  [216] = {
    [3] = alias_sym_type_identifier,
  },
  [217] = {
    [3] = alias_sym_type_identifier,
  },
  [220] = {
    [3] = alias_sym_type_identifier,
  },
  [221] = {
    [3] = alias_sym_type_identifier,
  },
  [224] = {
    [2] = alias_sym_type_identifier,
  },
  [228] = {
    [2] = alias_sym_type_identifier,
  },
  [229] = {
    [3] = alias_sym_type_identifier,
  },
  [230] = {
    [3] = alias_sym_type_identifier,
  },
  [231] = {
    [3] = alias_sym_type_identifier,
  },
  [237] = {
    [2] = alias_sym_field_identifier,
  },
  [240] = {
    [3] = alias_sym_type_identifier,
  },
  [247] = {
    [3] = alias_sym_type_identifier,
  },
  [249] = {
    [4] = alias_sym_type_identifier,
  },
  [250] = {
    [4] = alias_sym_type_identifier,
  },
  [253] = {
    [3] = alias_sym_type_identifier,
  },
  [259] = {
    [3] = alias_sym_type_identifier,
  },
  [265] = {
    [4] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_generic_type_with_turbofish, 2,
    sym_generic_type_with_turbofish,
    sym_generic_type,
  sym__let_chain, 2,
    sym__let_chain,
    alias_sym_let_chain,
  sym_closure_expression, 2,
    sym_closure_expression,
    alias_sym_closure_pattern,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 5,
  [9] = 2,
  [10] = 2,
  [11] = 7,
  [12] = 12,
  [13] = 6,
  [14] = 7,
  [15] = 5,
  [16] = 2,
  [17] = 6,
  [18] = 7,
  [19] = 6,
  [20] = 5,
  [21] = 5,
  [22] = 6,
  [23] = 23,
  [24] = 24,
  [25] = 7,
  [26] = 5,
  [27] = 5,
  [28] = 7,
  [29] = 23,
  [30] = 2,
  [31] = 31,
  [32] = 6,
  [33] = 7,
  [34] = 6,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 38,
  [41] = 37,
  [42] = 42,
  [43] = 35,
  [44] = 35,
  [45] = 37,
  [46] = 38,
  [47] = 36,
  [48] = 42,
  [49] = 37,
  [50] = 35,
  [51] = 37,
  [52] = 38,
  [53] = 37,
  [54] = 38,
  [55] = 39,
  [56] = 38,
  [57] = 39,
  [58] = 35,
  [59] = 36,
  [60] = 42,
  [61] = 36,
  [62] = 38,
  [63] = 36,
  [64] = 37,
  [65] = 42,
  [66] = 39,
  [67] = 42,
  [68] = 38,
  [69] = 38,
  [70] = 37,
  [71] = 38,
  [72] = 37,
  [73] = 39,
  [74] = 37,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 75,
  [79] = 76,
  [80] = 77,
  [81] = 81,
  [82] = 81,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 86,
  [90] = 86,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 88,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 84,
  [99] = 88,
  [100] = 86,
  [101] = 95,
  [102] = 97,
  [103] = 85,
  [104] = 104,
  [105] = 88,
  [106] = 83,
  [107] = 104,
  [108] = 96,
  [109] = 93,
  [110] = 93,
  [111] = 87,
  [112] = 93,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 114,
  [117] = 113,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 120,
  [123] = 123,
  [124] = 121,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 121,
  [131] = 120,
  [132] = 119,
  [133] = 128,
  [134] = 134,
  [135] = 126,
  [136] = 121,
  [137] = 119,
  [138] = 121,
  [139] = 120,
  [140] = 127,
  [141] = 125,
  [142] = 120,
  [143] = 123,
  [144] = 134,
  [145] = 145,
  [146] = 120,
  [147] = 119,
  [148] = 121,
  [149] = 119,
  [150] = 120,
  [151] = 119,
  [152] = 119,
  [153] = 121,
  [154] = 154,
  [155] = 155,
  [156] = 155,
  [157] = 155,
  [158] = 155,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 155,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 165,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 184,
  [190] = 187,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 180,
  [195] = 195,
  [196] = 196,
  [197] = 174,
  [198] = 185,
  [199] = 199,
  [200] = 200,
  [201] = 196,
  [202] = 183,
  [203] = 182,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 180,
  [209] = 179,
  [210] = 180,
  [211] = 211,
  [212] = 205,
  [213] = 196,
  [214] = 200,
  [215] = 199,
  [216] = 171,
  [217] = 170,
  [218] = 174,
  [219] = 219,
  [220] = 220,
  [221] = 180,
  [222] = 222,
  [223] = 223,
  [224] = 184,
  [225] = 225,
  [226] = 187,
  [227] = 211,
  [228] = 167,
  [229] = 185,
  [230] = 230,
  [231] = 231,
  [232] = 204,
  [233] = 183,
  [234] = 182,
  [235] = 178,
  [236] = 180,
  [237] = 237,
  [238] = 238,
  [239] = 180,
  [240] = 240,
  [241] = 196,
  [242] = 242,
  [243] = 181,
  [244] = 180,
  [245] = 245,
  [246] = 246,
  [247] = 205,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 176,
  [252] = 252,
  [253] = 164,
  [254] = 254,
  [255] = 170,
  [256] = 171,
  [257] = 171,
  [258] = 182,
  [259] = 259,
  [260] = 183,
  [261] = 185,
  [262] = 187,
  [263] = 184,
  [264] = 249,
  [265] = 180,
  [266] = 170,
  [267] = 174,
  [268] = 199,
  [269] = 200,
  [270] = 196,
  [271] = 271,
  [272] = 220,
  [273] = 273,
  [274] = 274,
  [275] = 242,
  [276] = 167,
  [277] = 199,
  [278] = 191,
  [279] = 205,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 220,
  [284] = 205,
  [285] = 187,
  [286] = 286,
  [287] = 287,
  [288] = 167,
  [289] = 289,
  [290] = 254,
  [291] = 291,
  [292] = 220,
  [293] = 165,
  [294] = 294,
  [295] = 295,
  [296] = 291,
  [297] = 294,
  [298] = 167,
  [299] = 200,
  [300] = 165,
  [301] = 231,
  [302] = 164,
  [303] = 303,
  [304] = 199,
  [305] = 225,
  [306] = 184,
  [307] = 286,
  [308] = 180,
  [309] = 174,
  [310] = 200,
  [311] = 286,
  [312] = 164,
  [313] = 170,
  [314] = 171,
  [315] = 182,
  [316] = 183,
  [317] = 185,
  [318] = 206,
  [319] = 319,
  [320] = 320,
  [321] = 319,
  [322] = 320,
  [323] = 319,
  [324] = 320,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 326,
  [329] = 329,
  [330] = 330,
  [331] = 329,
  [332] = 327,
  [333] = 326,
  [334] = 329,
  [335] = 330,
  [336] = 327,
  [337] = 330,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 340,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 342,
  [346] = 343,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 339,
  [352] = 348,
  [353] = 353,
  [354] = 350,
  [355] = 355,
  [356] = 356,
  [357] = 356,
  [358] = 356,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 362,
  [370] = 359,
  [371] = 360,
  [372] = 361,
  [373] = 373,
  [374] = 366,
  [375] = 359,
  [376] = 360,
  [377] = 377,
  [378] = 361,
  [379] = 379,
  [380] = 359,
  [381] = 373,
  [382] = 368,
  [383] = 367,
  [384] = 373,
  [385] = 364,
  [386] = 386,
  [387] = 363,
  [388] = 361,
  [389] = 360,
  [390] = 359,
  [391] = 366,
  [392] = 362,
  [393] = 366,
  [394] = 373,
  [395] = 362,
  [396] = 396,
  [397] = 362,
  [398] = 366,
  [399] = 366,
  [400] = 362,
  [401] = 373,
  [402] = 373,
  [403] = 386,
  [404] = 361,
  [405] = 365,
  [406] = 359,
  [407] = 361,
  [408] = 360,
  [409] = 360,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 412,
  [414] = 411,
  [415] = 415,
  [416] = 415,
  [417] = 417,
  [418] = 411,
  [419] = 417,
  [420] = 417,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 423,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 379,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 443,
  [449] = 438,
  [450] = 303,
  [451] = 439,
  [452] = 426,
  [453] = 453,
  [454] = 454,
  [455] = 432,
  [456] = 173,
  [457] = 457,
  [458] = 458,
  [459] = 129,
  [460] = 159,
  [461] = 154,
  [462] = 161,
  [463] = 160,
  [464] = 162,
  [465] = 207,
  [466] = 168,
  [467] = 467,
  [468] = 223,
  [469] = 259,
  [470] = 240,
  [471] = 467,
  [472] = 166,
  [473] = 248,
  [474] = 172,
  [475] = 219,
  [476] = 246,
  [477] = 287,
  [478] = 289,
  [479] = 295,
  [480] = 192,
  [481] = 222,
  [482] = 467,
  [483] = 237,
  [484] = 195,
  [485] = 467,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 489,
  [491] = 489,
  [492] = 489,
  [493] = 493,
  [494] = 488,
  [495] = 493,
  [496] = 493,
  [497] = 488,
  [498] = 498,
  [499] = 498,
  [500] = 500,
  [501] = 498,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 161,
  [514] = 514,
  [515] = 159,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 154,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 160,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 162,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 512,
  [684] = 684,
  [685] = 685,
  [686] = 604,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 775,
  [777] = 777,
  [778] = 778,
  [779] = 778,
  [780] = 777,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 791,
  [793] = 793,
  [794] = 794,
  [795] = 793,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 797,
  [802] = 802,
  [803] = 803,
  [804] = 798,
  [805] = 805,
  [806] = 802,
  [807] = 805,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 813,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 819,
  [826] = 811,
  [827] = 813,
  [828] = 828,
  [829] = 812,
  [830] = 809,
  [831] = 831,
  [832] = 810,
  [833] = 816,
  [834] = 834,
  [835] = 810,
  [836] = 824,
  [837] = 837,
  [838] = 813,
  [839] = 834,
  [840] = 840,
  [841] = 808,
  [842] = 810,
  [843] = 818,
  [844] = 844,
  [845] = 592,
  [846] = 846,
  [847] = 844,
  [848] = 844,
  [849] = 844,
  [850] = 850,
  [851] = 851,
  [852] = 851,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 854,
  [859] = 854,
  [860] = 851,
  [861] = 856,
  [862] = 857,
  [863] = 856,
  [864] = 864,
  [865] = 853,
  [866] = 853,
  [867] = 855,
  [868] = 853,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 871,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 872,
  [889] = 889,
  [890] = 890,
  [891] = 876,
  [892] = 892,
  [893] = 893,
  [894] = 893,
  [895] = 895,
  [896] = 878,
  [897] = 897,
  [898] = 881,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 895,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 901,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 880,
  [914] = 879,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 869,
  [919] = 874,
  [920] = 882,
  [921] = 921,
  [922] = 887,
  [923] = 923,
  [924] = 924,
  [925] = 869,
  [926] = 926,
  [927] = 889,
  [928] = 890,
  [929] = 916,
  [930] = 930,
  [931] = 931,
  [932] = 892,
  [933] = 904,
  [934] = 934,
  [935] = 875,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 943,
  [950] = 921,
  [951] = 924,
  [952] = 944,
  [953] = 939,
  [954] = 954,
  [955] = 955,
  [956] = 941,
  [957] = 936,
  [958] = 945,
  [959] = 946,
  [960] = 960,
  [961] = 961,
  [962] = 947,
  [963] = 963,
  [964] = 964,
  [965] = 915,
  [966] = 966,
  [967] = 912,
  [968] = 902,
  [969] = 960,
  [970] = 961,
  [971] = 897,
  [972] = 915,
  [973] = 973,
  [974] = 974,
  [975] = 877,
  [976] = 973,
  [977] = 963,
  [978] = 978,
  [979] = 902,
  [980] = 926,
  [981] = 897,
  [982] = 872,
  [983] = 911,
  [984] = 877,
  [985] = 883,
  [986] = 986,
  [987] = 897,
  [988] = 902,
  [989] = 940,
  [990] = 923,
  [991] = 931,
  [992] = 915,
  [993] = 963,
  [994] = 917,
  [995] = 961,
  [996] = 908,
  [997] = 960,
  [998] = 931,
  [999] = 899,
  [1000] = 966,
  [1001] = 907,
  [1002] = 906,
  [1003] = 905,
  [1004] = 923,
  [1005] = 917,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 592,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 177,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 161,
  [1022] = 159,
  [1023] = 303,
  [1024] = 154,
  [1025] = 160,
  [1026] = 173,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 282,
  [1030] = 1030,
  [1031] = 162,
  [1032] = 1032,
  [1033] = 578,
  [1034] = 1034,
  [1035] = 738,
  [1036] = 1036,
  [1037] = 709,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 546,
  [1042] = 639,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 129,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1011,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 379,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 729,
  [1089] = 1089,
  [1090] = 159,
  [1091] = 694,
  [1092] = 295,
  [1093] = 1093,
  [1094] = 667,
  [1095] = 735,
  [1096] = 1096,
  [1097] = 685,
  [1098] = 219,
  [1099] = 563,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 566,
  [1103] = 507,
  [1104] = 525,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 526,
  [1108] = 1108,
  [1109] = 773,
  [1110] = 504,
  [1111] = 754,
  [1112] = 439,
  [1113] = 550,
  [1114] = 1114,
  [1115] = 556,
  [1116] = 557,
  [1117] = 560,
  [1118] = 248,
  [1119] = 166,
  [1120] = 610,
  [1121] = 612,
  [1122] = 620,
  [1123] = 1123,
  [1124] = 624,
  [1125] = 630,
  [1126] = 642,
  [1127] = 753,
  [1128] = 173,
  [1129] = 748,
  [1130] = 744,
  [1131] = 742,
  [1132] = 740,
  [1133] = 655,
  [1134] = 736,
  [1135] = 734,
  [1136] = 1136,
  [1137] = 730,
  [1138] = 726,
  [1139] = 719,
  [1140] = 718,
  [1141] = 716,
  [1142] = 715,
  [1143] = 712,
  [1144] = 1144,
  [1145] = 701,
  [1146] = 619,
  [1147] = 583,
  [1148] = 237,
  [1149] = 519,
  [1150] = 1150,
  [1151] = 661,
  [1152] = 533,
  [1153] = 1153,
  [1154] = 548,
  [1155] = 1155,
  [1156] = 555,
  [1157] = 596,
  [1158] = 600,
  [1159] = 602,
  [1160] = 606,
  [1161] = 607,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 609,
  [1165] = 611,
  [1166] = 623,
  [1167] = 634,
  [1168] = 1168,
  [1169] = 772,
  [1170] = 731,
  [1171] = 698,
  [1172] = 637,
  [1173] = 638,
  [1174] = 1174,
  [1175] = 240,
  [1176] = 658,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 644,
  [1180] = 511,
  [1181] = 645,
  [1182] = 559,
  [1183] = 579,
  [1184] = 684,
  [1185] = 581,
  [1186] = 582,
  [1187] = 586,
  [1188] = 591,
  [1189] = 646,
  [1190] = 617,
  [1191] = 1191,
  [1192] = 647,
  [1193] = 652,
  [1194] = 1194,
  [1195] = 653,
  [1196] = 687,
  [1197] = 1197,
  [1198] = 690,
  [1199] = 696,
  [1200] = 649,
  [1201] = 697,
  [1202] = 699,
  [1203] = 710,
  [1204] = 711,
  [1205] = 722,
  [1206] = 503,
  [1207] = 725,
  [1208] = 727,
  [1209] = 681,
  [1210] = 675,
  [1211] = 259,
  [1212] = 1212,
  [1213] = 752,
  [1214] = 750,
  [1215] = 672,
  [1216] = 749,
  [1217] = 746,
  [1218] = 679,
  [1219] = 745,
  [1220] = 680,
  [1221] = 289,
  [1222] = 682,
  [1223] = 1223,
  [1224] = 691,
  [1225] = 720,
  [1226] = 717,
  [1227] = 714,
  [1228] = 713,
  [1229] = 695,
  [1230] = 303,
  [1231] = 161,
  [1232] = 1232,
  [1233] = 598,
  [1234] = 721,
  [1235] = 724,
  [1236] = 705,
  [1237] = 704,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 702,
  [1241] = 728,
  [1242] = 568,
  [1243] = 592,
  [1244] = 1244,
  [1245] = 570,
  [1246] = 573,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 759,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 438,
  [1254] = 774,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 771,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 770,
  [1262] = 1262,
  [1263] = 769,
  [1264] = 768,
  [1265] = 154,
  [1266] = 569,
  [1267] = 767,
  [1268] = 764,
  [1269] = 561,
  [1270] = 763,
  [1271] = 762,
  [1272] = 1272,
  [1273] = 761,
  [1274] = 760,
  [1275] = 758,
  [1276] = 1276,
  [1277] = 674,
  [1278] = 676,
  [1279] = 1279,
  [1280] = 518,
  [1281] = 673,
  [1282] = 521,
  [1283] = 520,
  [1284] = 509,
  [1285] = 757,
  [1286] = 177,
  [1287] = 1287,
  [1288] = 755,
  [1289] = 751,
  [1290] = 432,
  [1291] = 747,
  [1292] = 195,
  [1293] = 1293,
  [1294] = 743,
  [1295] = 603,
  [1296] = 516,
  [1297] = 547,
  [1298] = 1298,
  [1299] = 552,
  [1300] = 554,
  [1301] = 1301,
  [1302] = 558,
  [1303] = 741,
  [1304] = 514,
  [1305] = 739,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 575,
  [1309] = 1309,
  [1310] = 576,
  [1311] = 223,
  [1312] = 580,
  [1313] = 584,
  [1314] = 737,
  [1315] = 585,
  [1316] = 660,
  [1317] = 443,
  [1318] = 587,
  [1319] = 723,
  [1320] = 708,
  [1321] = 593,
  [1322] = 282,
  [1323] = 707,
  [1324] = 706,
  [1325] = 703,
  [1326] = 287,
  [1327] = 162,
  [1328] = 692,
  [1329] = 689,
  [1330] = 688,
  [1331] = 678,
  [1332] = 677,
  [1333] = 589,
  [1334] = 656,
  [1335] = 671,
  [1336] = 1336,
  [1337] = 669,
  [1338] = 670,
  [1339] = 523,
  [1340] = 635,
  [1341] = 668,
  [1342] = 1342,
  [1343] = 605,
  [1344] = 616,
  [1345] = 1345,
  [1346] = 666,
  [1347] = 665,
  [1348] = 664,
  [1349] = 1349,
  [1350] = 663,
  [1351] = 662,
  [1352] = 659,
  [1353] = 643,
  [1354] = 657,
  [1355] = 654,
  [1356] = 651,
  [1357] = 650,
  [1358] = 1358,
  [1359] = 648,
  [1360] = 246,
  [1361] = 622,
  [1362] = 633,
  [1363] = 629,
  [1364] = 628,
  [1365] = 627,
  [1366] = 631,
  [1367] = 626,
  [1368] = 1368,
  [1369] = 625,
  [1370] = 632,
  [1371] = 636,
  [1372] = 621,
  [1373] = 618,
  [1374] = 640,
  [1375] = 615,
  [1376] = 1376,
  [1377] = 614,
  [1378] = 1378,
  [1379] = 700,
  [1380] = 597,
  [1381] = 577,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 574,
  [1386] = 572,
  [1387] = 571,
  [1388] = 567,
  [1389] = 1389,
  [1390] = 564,
  [1391] = 551,
  [1392] = 549,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 544,
  [1398] = 1398,
  [1399] = 160,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 543,
  [1403] = 542,
  [1404] = 541,
  [1405] = 540,
  [1406] = 538,
  [1407] = 537,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 536,
  [1411] = 641,
  [1412] = 535,
  [1413] = 534,
  [1414] = 1414,
  [1415] = 532,
  [1416] = 613,
  [1417] = 1417,
  [1418] = 608,
  [1419] = 588,
  [1420] = 599,
  [1421] = 693,
  [1422] = 222,
  [1423] = 1423,
  [1424] = 207,
  [1425] = 530,
  [1426] = 531,
  [1427] = 1427,
  [1428] = 529,
  [1429] = 528,
  [1430] = 527,
  [1431] = 522,
  [1432] = 508,
  [1433] = 505,
  [1434] = 595,
  [1435] = 594,
  [1436] = 168,
  [1437] = 192,
  [1438] = 1438,
  [1439] = 562,
  [1440] = 545,
  [1441] = 539,
  [1442] = 524,
  [1443] = 517,
  [1444] = 510,
  [1445] = 172,
  [1446] = 506,
  [1447] = 1012,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 799,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1045,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1014,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1015,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1045,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1013,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1019,
  [1484] = 1017,
  [1485] = 1018,
  [1486] = 1486,
  [1487] = 1030,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1488,
  [1491] = 1055,
  [1492] = 1489,
  [1493] = 846,
  [1494] = 1028,
  [1495] = 1489,
  [1496] = 1072,
  [1497] = 1027,
  [1498] = 1045,
  [1499] = 1486,
  [1500] = 1020,
  [1501] = 1486,
  [1502] = 592,
  [1503] = 1503,
  [1504] = 1050,
  [1505] = 1032,
  [1506] = 1048,
  [1507] = 1488,
  [1508] = 1389,
  [1509] = 1438,
  [1510] = 1438,
  [1511] = 1054,
  [1512] = 1043,
  [1513] = 129,
  [1514] = 1055,
  [1515] = 1039,
  [1516] = 1034,
  [1517] = 1093,
  [1518] = 1518,
  [1519] = 1389,
  [1520] = 1050,
  [1521] = 1072,
  [1522] = 1522,
  [1523] = 1048,
  [1524] = 1232,
  [1525] = 1438,
  [1526] = 1518,
  [1527] = 1077,
  [1528] = 1522,
  [1529] = 1084,
  [1530] = 1086,
  [1531] = 1044,
  [1532] = 1051,
  [1533] = 1076,
  [1534] = 1068,
  [1535] = 1087,
  [1536] = 1065,
  [1537] = 1081,
  [1538] = 1457,
  [1539] = 1083,
  [1540] = 1047,
  [1541] = 1541,
  [1542] = 1075,
  [1543] = 1066,
  [1544] = 1064,
  [1545] = 1063,
  [1546] = 1052,
  [1547] = 1060,
  [1548] = 1548,
  [1549] = 1069,
  [1550] = 1079,
  [1551] = 1232,
  [1552] = 1067,
  [1553] = 1553,
  [1554] = 1078,
  [1555] = 1061,
  [1556] = 1556,
  [1557] = 1058,
  [1558] = 1057,
  [1559] = 1556,
  [1560] = 1553,
  [1561] = 1080,
  [1562] = 1451,
  [1563] = 1073,
  [1564] = 1457,
  [1565] = 1056,
  [1566] = 1566,
  [1567] = 1548,
  [1568] = 1553,
  [1569] = 1541,
  [1570] = 1093,
  [1571] = 1571,
  [1572] = 1553,
  [1573] = 1556,
  [1574] = 1054,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 161,
  [1578] = 159,
  [1579] = 1556,
  [1580] = 1071,
  [1581] = 1451,
  [1582] = 154,
  [1583] = 160,
  [1584] = 1584,
  [1585] = 162,
  [1586] = 1586,
  [1587] = 1070,
  [1588] = 1588,
  [1589] = 1459,
  [1590] = 1163,
  [1591] = 1591,
  [1592] = 172,
  [1593] = 1461,
  [1594] = 1423,
  [1595] = 1595,
  [1596] = 1478,
  [1597] = 1480,
  [1598] = 222,
  [1599] = 438,
  [1600] = 207,
  [1601] = 192,
  [1602] = 168,
  [1603] = 1378,
  [1604] = 1417,
  [1605] = 1475,
  [1606] = 1336,
  [1607] = 379,
  [1608] = 1476,
  [1609] = 1609,
  [1610] = 1345,
  [1611] = 1309,
  [1612] = 1301,
  [1613] = 1272,
  [1614] = 1262,
  [1615] = 1298,
  [1616] = 1396,
  [1617] = 1247,
  [1618] = 1011,
  [1619] = 1619,
  [1620] = 1368,
  [1621] = 246,
  [1622] = 432,
  [1623] = 1591,
  [1624] = 1474,
  [1625] = 1358,
  [1626] = 1287,
  [1627] = 287,
  [1628] = 1427,
  [1629] = 1472,
  [1630] = 1471,
  [1631] = 177,
  [1632] = 1414,
  [1633] = 1470,
  [1634] = 439,
  [1635] = 1401,
  [1636] = 443,
  [1637] = 1469,
  [1638] = 1383,
  [1639] = 1382,
  [1640] = 223,
  [1641] = 1223,
  [1642] = 1212,
  [1643] = 195,
  [1644] = 1644,
  [1645] = 1306,
  [1646] = 1467,
  [1647] = 1644,
  [1648] = 1466,
  [1649] = 1464,
  [1650] = 1463,
  [1651] = 1256,
  [1652] = 1652,
  [1653] = 1394,
  [1654] = 282,
  [1655] = 1197,
  [1656] = 1393,
  [1657] = 1162,
  [1658] = 1482,
  [1659] = 1376,
  [1660] = 1194,
  [1661] = 1619,
  [1662] = 1481,
  [1663] = 1191,
  [1664] = 1250,
  [1665] = 1248,
  [1666] = 1244,
  [1667] = 1461,
  [1668] = 237,
  [1669] = 1384,
  [1670] = 1114,
  [1671] = 1279,
  [1672] = 1479,
  [1673] = 1252,
  [1674] = 1478,
  [1675] = 1260,
  [1676] = 1108,
  [1677] = 1475,
  [1678] = 1476,
  [1679] = 1342,
  [1680] = 1480,
  [1681] = 1276,
  [1682] = 1459,
  [1683] = 1460,
  [1684] = 1307,
  [1685] = 1168,
  [1686] = 1089,
  [1687] = 1106,
  [1688] = 1395,
  [1689] = 1105,
  [1690] = 303,
  [1691] = 1259,
  [1692] = 1609,
  [1693] = 1258,
  [1694] = 1609,
  [1695] = 1100,
  [1696] = 1239,
  [1697] = 1238,
  [1698] = 1479,
  [1699] = 1178,
  [1700] = 1409,
  [1701] = 1460,
  [1702] = 1408,
  [1703] = 1400,
  [1704] = 1177,
  [1705] = 1398,
  [1706] = 1174,
  [1707] = 289,
  [1708] = 259,
  [1709] = 1293,
  [1710] = 1251,
  [1711] = 1096,
  [1712] = 1155,
  [1713] = 295,
  [1714] = 240,
  [1715] = 1255,
  [1716] = 219,
  [1717] = 1481,
  [1718] = 248,
  [1719] = 1482,
  [1720] = 1153,
  [1721] = 1123,
  [1722] = 1150,
  [1723] = 1474,
  [1724] = 1463,
  [1725] = 1144,
  [1726] = 1472,
  [1727] = 1471,
  [1728] = 173,
  [1729] = 1470,
  [1730] = 1464,
  [1731] = 1466,
  [1732] = 1136,
  [1733] = 166,
  [1734] = 1349,
  [1735] = 1469,
  [1736] = 1467,
  [1737] = 1480,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1480,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1461,
  [1749] = 1472,
  [1750] = 1478,
  [1751] = 1751,
  [1752] = 1475,
  [1753] = 1476,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1474,
  [1758] = 1758,
  [1759] = 1472,
  [1760] = 1460,
  [1761] = 1471,
  [1762] = 1743,
  [1763] = 1740,
  [1764] = 1461,
  [1765] = 1765,
  [1766] = 1478,
  [1767] = 1459,
  [1768] = 1480,
  [1769] = 1470,
  [1770] = 1475,
  [1771] = 1476,
  [1772] = 1739,
  [1773] = 1474,
  [1774] = 1741,
  [1775] = 1469,
  [1776] = 1467,
  [1777] = 1755,
  [1778] = 1778,
  [1779] = 1466,
  [1780] = 1780,
  [1781] = 1480,
  [1782] = 1464,
  [1783] = 1463,
  [1784] = 1482,
  [1785] = 1481,
  [1786] = 1479,
  [1787] = 1747,
  [1788] = 1459,
  [1789] = 1789,
  [1790] = 1789,
  [1791] = 1742,
  [1792] = 1742,
  [1793] = 1459,
  [1794] = 1794,
  [1795] = 1479,
  [1796] = 1796,
  [1797] = 1481,
  [1798] = 1482,
  [1799] = 1799,
  [1800] = 1744,
  [1801] = 1751,
  [1802] = 1802,
  [1803] = 1463,
  [1804] = 1743,
  [1805] = 1794,
  [1806] = 1460,
  [1807] = 1741,
  [1808] = 1742,
  [1809] = 1755,
  [1810] = 1460,
  [1811] = 1811,
  [1812] = 1743,
  [1813] = 1765,
  [1814] = 1741,
  [1815] = 1459,
  [1816] = 1464,
  [1817] = 1742,
  [1818] = 1799,
  [1819] = 1466,
  [1820] = 1467,
  [1821] = 1469,
  [1822] = 1765,
  [1823] = 1823,
  [1824] = 1470,
  [1825] = 1755,
  [1826] = 1755,
  [1827] = 1471,
  [1828] = 1743,
  [1829] = 1741,
  [1830] = 1742,
  [1831] = 1741,
  [1832] = 1832,
  [1833] = 1741,
  [1834] = 1743,
  [1835] = 1835,
  [1836] = 1755,
  [1837] = 1742,
  [1838] = 1460,
  [1839] = 1743,
  [1840] = 1765,
  [1841] = 1755,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1746,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1846,
  [1853] = 1853,
  [1854] = 1843,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1811,
  [1860] = 1860,
  [1861] = 1860,
  [1862] = 1845,
  [1863] = 1863,
  [1864] = 1863,
  [1865] = 1835,
  [1866] = 1853,
  [1867] = 1850,
  [1868] = 1868,
  [1869] = 1847,
  [1870] = 1845,
  [1871] = 1871,
  [1872] = 1844,
  [1873] = 1855,
  [1874] = 1874,
  [1875] = 1851,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1878,
  [1880] = 1876,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1882,
  [1884] = 1881,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1885,
  [1888] = 1886,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1892,
  [1894] = 1894,
  [1895] = 1892,
  [1896] = 1894,
  [1897] = 1892,
  [1898] = 1892,
  [1899] = 1899,
  [1900] = 1899,
  [1901] = 443,
  [1902] = 1012,
  [1903] = 438,
  [1904] = 1013,
  [1905] = 1018,
  [1906] = 1015,
  [1907] = 1032,
  [1908] = 1014,
  [1909] = 1909,
  [1910] = 1030,
  [1911] = 1027,
  [1912] = 1019,
  [1913] = 1020,
  [1914] = 1028,
  [1915] = 1017,
  [1916] = 1043,
  [1917] = 1018,
  [1918] = 1032,
  [1919] = 1080,
  [1920] = 1027,
  [1921] = 1030,
  [1922] = 1044,
  [1923] = 1039,
  [1924] = 1034,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1086,
  [1928] = 1063,
  [1929] = 1069,
  [1930] = 1071,
  [1931] = 1931,
  [1932] = 1084,
  [1933] = 1926,
  [1934] = 1077,
  [1935] = 1078,
  [1936] = 1058,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1081,
  [1940] = 1083,
  [1941] = 1079,
  [1942] = 282,
  [1943] = 1938,
  [1944] = 1056,
  [1945] = 1075,
  [1946] = 1066,
  [1947] = 1070,
  [1948] = 1065,
  [1949] = 173,
  [1950] = 1073,
  [1951] = 1064,
  [1952] = 1938,
  [1953] = 1076,
  [1954] = 1087,
  [1955] = 1925,
  [1956] = 303,
  [1957] = 1047,
  [1958] = 1067,
  [1959] = 177,
  [1960] = 1057,
  [1961] = 1068,
  [1962] = 1576,
  [1963] = 1238,
  [1964] = 1368,
  [1965] = 1571,
  [1966] = 1105,
  [1967] = 1153,
  [1968] = 1244,
  [1969] = 1255,
  [1970] = 1150,
  [1971] = 1251,
  [1972] = 1378,
  [1973] = 1144,
  [1974] = 1239,
  [1975] = 1975,
  [1976] = 1136,
  [1977] = 1396,
  [1978] = 1106,
  [1979] = 1108,
  [1980] = 1259,
  [1981] = 1981,
  [1982] = 1096,
  [1983] = 1588,
  [1984] = 1586,
  [1985] = 1100,
  [1986] = 1384,
  [1987] = 1925,
  [1988] = 1336,
  [1989] = 1162,
  [1990] = 1258,
  [1991] = 1163,
  [1992] = 1358,
  [1993] = 1993,
  [1994] = 432,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1018,
  [1998] = 1027,
  [1999] = 1030,
  [2000] = 1030,
  [2001] = 1027,
  [2002] = 1032,
  [2003] = 1027,
  [2004] = 2004,
  [2005] = 1018,
  [2006] = 2006,
  [2007] = 1032,
  [2008] = 1030,
  [2009] = 1032,
  [2010] = 1018,
  [2011] = 2011,
  [2012] = 1909,
  [2013] = 2013,
  [2014] = 1030,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 160,
  [2021] = 2018,
  [2022] = 2022,
  [2023] = 162,
  [2024] = 1027,
  [2025] = 161,
  [2026] = 2026,
  [2027] = 1032,
  [2028] = 2028,
  [2029] = 2028,
  [2030] = 154,
  [2031] = 2031,
  [2032] = 2016,
  [2033] = 2026,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 159,
  [2037] = 2034,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 1931,
  [2041] = 2041,
  [2042] = 2042,
  [2043] = 2043,
  [2044] = 1018,
  [2045] = 2022,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 1937,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2060,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 1931,
  [2067] = 2067,
  [2068] = 2049,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 1931,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 172,
  [2076] = 2067,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2052,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2052,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2084,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 1937,
  [2104] = 1937,
  [2105] = 2105,
  [2106] = 2106,
  [2107] = 2100,
  [2108] = 2098,
  [2109] = 2109,
  [2110] = 2095,
  [2111] = 2111,
  [2112] = 2094,
  [2113] = 2113,
  [2114] = 1034,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 1931,
  [2118] = 2095,
  [2119] = 2119,
  [2120] = 2099,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2121,
  [2124] = 2105,
  [2125] = 2119,
  [2126] = 1044,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2111,
  [2131] = 2102,
  [2132] = 2122,
  [2133] = 2101,
  [2134] = 2096,
  [2135] = 1039,
  [2136] = 2115,
  [2137] = 2116,
  [2138] = 2138,
  [2139] = 2096,
  [2140] = 2140,
  [2141] = 2138,
  [2142] = 2129,
  [2143] = 2128,
  [2144] = 2144,
  [2145] = 2127,
  [2146] = 1043,
  [2147] = 2113,
  [2148] = 2109,
  [2149] = 2140,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2158,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2171,
  [2177] = 2177,
  [2178] = 2177,
  [2179] = 2179,
  [2180] = 2165,
  [2181] = 2157,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 1937,
  [2188] = 2169,
  [2189] = 2189,
  [2190] = 2174,
  [2191] = 2160,
  [2192] = 2192,
  [2193] = 2156,
  [2194] = 2183,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2173,
  [2198] = 2189,
  [2199] = 2199,
  [2200] = 2186,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2172,
  [2204] = 2204,
  [2205] = 2202,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2206,
  [2210] = 2210,
  [2211] = 2204,
  [2212] = 2170,
  [2213] = 2161,
  [2214] = 2185,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2215,
  [2222] = 2218,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2228,
  [2230] = 2230,
  [2231] = 2216,
  [2232] = 2224,
  [2233] = 2233,
  [2234] = 2225,
  [2235] = 2226,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2230,
  [2244] = 2239,
  [2245] = 2242,
  [2246] = 2240,
  [2247] = 2220,
  [2248] = 2248,
  [2249] = 1995,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2251,
  [2253] = 2253,
  [2254] = 2238,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2237,
  [2259] = 2259,
  [2260] = 2241,
  [2261] = 2233,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2227,
  [2266] = 2217,
  [2267] = 2236,
  [2268] = 2237,
  [2269] = 2259,
  [2270] = 2255,
  [2271] = 2271,
  [2272] = 2011,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2275,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2006,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2286,
  [2295] = 2295,
  [2296] = 2004,
  [2297] = 2278,
  [2298] = 2287,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2274,
  [2308] = 2308,
  [2309] = 2308,
  [2310] = 2305,
  [2311] = 2304,
  [2312] = 2299,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2276,
  [2316] = 2281,
  [2317] = 2306,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2321,
  [2323] = 2301,
  [2324] = 2300,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2319,
  [2328] = 2291,
  [2329] = 2325,
  [2330] = 2326,
  [2331] = 2331,
  [2332] = 2273,
  [2333] = 2289,
  [2334] = 2334,
  [2335] = 2290,
  [2336] = 2292,
  [2337] = 2303,
  [2338] = 2338,
  [2339] = 2318,
  [2340] = 2334,
  [2341] = 2285,
  [2342] = 2281,
  [2343] = 2343,
  [2344] = 2292,
  [2345] = 2345,
  [2346] = 443,
  [2347] = 2280,
  [2348] = 2303,
  [2349] = 2292,
  [2350] = 2338,
  [2351] = 2351,
  [2352] = 438,
  [2353] = 2331,
  [2354] = 2320,
  [2355] = 2345,
  [2356] = 2351,
  [2357] = 432,
  [2358] = 2343,
  [2359] = 2295,
  [2360] = 2293,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 1453,
  [2366] = 1449,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2368,
  [2372] = 2372,
  [2373] = 1450,
  [2374] = 2374,
  [2375] = 1456,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2368,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 1011,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2378,
  [2397] = 2364,
  [2398] = 2369,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2383,
  [2407] = 2378,
  [2408] = 1455,
  [2409] = 1454,
  [2410] = 2401,
  [2411] = 2367,
  [2412] = 2393,
  [2413] = 2413,
  [2414] = 2374,
  [2415] = 2415,
  [2416] = 2364,
  [2417] = 2372,
  [2418] = 2418,
  [2419] = 2404,
  [2420] = 2374,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2422,
  [2425] = 2425,
  [2426] = 2385,
  [2427] = 2427,
  [2428] = 2368,
  [2429] = 2376,
  [2430] = 2430,
  [2431] = 2421,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2372,
  [2436] = 2436,
  [2437] = 2425,
  [2438] = 2403,
  [2439] = 2390,
  [2440] = 2376,
  [2441] = 2388,
  [2442] = 2442,
  [2443] = 2427,
  [2444] = 2444,
  [2445] = 2370,
  [2446] = 2377,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2361,
  [2451] = 2387,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 447,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2466,
  [2467] = 2467,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2468,
  [2472] = 2469,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2459,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2470,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2453,
  [2487] = 2487,
  [2488] = 430,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2476,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2468,
  [2502] = 2502,
  [2503] = 2479,
  [2504] = 2480,
  [2505] = 2505,
  [2506] = 2490,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2502,
  [2511] = 2469,
  [2512] = 2469,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 2519,
  [2522] = 2520,
  [2523] = 2519,
  [2524] = 2498,
  [2525] = 2520,
  [2526] = 2519,
  [2527] = 2520,
  [2528] = 2509,
  [2529] = 2519,
  [2530] = 2520,
  [2531] = 2017,
  [2532] = 2015,
  [2533] = 2043,
  [2534] = 2042,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2519,
  [2539] = 2520,
  [2540] = 2031,
  [2541] = 2541,
  [2542] = 2035,
  [2543] = 2038,
  [2544] = 2473,
  [2545] = 2465,
  [2546] = 2041,
  [2547] = 2466,
  [2548] = 2505,
  [2549] = 2497,
  [2550] = 2473,
  [2551] = 2519,
  [2552] = 2520,
  [2553] = 2553,
  [2554] = 2541,
  [2555] = 2485,
  [2556] = 2518,
  [2557] = 2485,
  [2558] = 2473,
  [2559] = 2559,
  [2560] = 2560,
  [2561] = 2461,
  [2562] = 2562,
  [2563] = 2519,
  [2564] = 2520,
  [2565] = 2553,
  [2566] = 2541,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2535,
  [2570] = 2518,
  [2571] = 2517,
  [2572] = 2567,
  [2573] = 2495,
  [2574] = 2485,
  [2575] = 2473,
  [2576] = 2497,
  [2577] = 2466,
  [2578] = 2578,
  [2579] = 2469,
  [2580] = 2517,
  [2581] = 2541,
  [2582] = 2518,
  [2583] = 2583,
  [2584] = 2584,
  [2585] = 2553,
  [2586] = 2535,
  [2587] = 2559,
  [2588] = 2513,
  [2589] = 2508,
  [2590] = 2507,
  [2591] = 2591,
  [2592] = 2461,
  [2593] = 2519,
  [2594] = 2594,
  [2595] = 2595,
  [2596] = 2520,
  [2597] = 2597,
  [2598] = 2567,
  [2599] = 2599,
  [2600] = 2600,
  [2601] = 2541,
  [2602] = 2602,
  [2603] = 2584,
  [2604] = 2553,
  [2605] = 2553,
  [2606] = 2584,
  [2607] = 2607,
  [2608] = 2541,
  [2609] = 2567,
  [2610] = 2535,
  [2611] = 2518,
  [2612] = 2517,
  [2613] = 2602,
  [2614] = 2495,
  [2615] = 2602,
  [2616] = 2468,
  [2617] = 2453,
  [2618] = 2618,
  [2619] = 2485,
  [2620] = 2473,
  [2621] = 2497,
  [2622] = 2462,
  [2623] = 2466,
  [2624] = 2624,
  [2625] = 2458,
  [2626] = 2597,
  [2627] = 2627,
  [2628] = 2628,
  [2629] = 2483,
  [2630] = 2630,
  [2631] = 2491,
  [2632] = 2632,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2492,
  [2636] = 2520,
  [2637] = 2494,
  [2638] = 2638,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 2594,
  [2642] = 2642,
  [2643] = 2643,
  [2644] = 2519,
  [2645] = 2645,
  [2646] = 2484,
  [2647] = 2647,
  [2648] = 2597,
  [2649] = 2632,
  [2650] = 2595,
  [2651] = 2599,
  [2652] = 2624,
  [2653] = 2647,
  [2654] = 2627,
  [2655] = 2583,
  [2656] = 2630,
  [2657] = 2657,
  [2658] = 2568,
  [2659] = 2583,
  [2660] = 2559,
  [2661] = 2487,
  [2662] = 2537,
  [2663] = 2559,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2665,
  [2667] = 2667,
  [2668] = 2668,
  [2669] = 2454,
  [2670] = 2634,
  [2671] = 2664,
  [2672] = 2667,
  [2673] = 2514,
  [2674] = 2536,
  [2675] = 2520,
  [2676] = 2467,
  [2677] = 2513,
  [2678] = 2499,
  [2679] = 2679,
  [2680] = 2508,
  [2681] = 2507,
  [2682] = 2502,
  [2683] = 2490,
  [2684] = 2460,
  [2685] = 2668,
  [2686] = 2461,
  [2687] = 2519,
  [2688] = 2594,
  [2689] = 2689,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 2692,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2695,
  [2696] = 2696,
  [2697] = 2697,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2700,
  [2701] = 2701,
  [2702] = 2702,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2705,
  [2706] = 2706,
  [2707] = 2707,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2712,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2693,
  [2717] = 2692,
  [2718] = 2718,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 2053,
  [2722] = 2722,
  [2723] = 2088,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2727,
  [2728] = 2701,
  [2729] = 2729,
  [2730] = 2730,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2714,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 2739,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2759,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2762,
  [2763] = 2763,
  [2764] = 2703,
  [2765] = 172,
  [2766] = 2766,
  [2767] = 2057,
  [2768] = 2712,
  [2769] = 2065,
  [2770] = 2074,
  [2771] = 2691,
  [2772] = 2080,
  [2773] = 2697,
  [2774] = 2085,
  [2775] = 2077,
  [2776] = 2718,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2092,
  [2780] = 2780,
  [2781] = 2781,
  [2782] = 2730,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2759,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2737,
  [2791] = 2788,
  [2792] = 2792,
  [2793] = 2793,
  [2794] = 2722,
  [2795] = 2795,
  [2796] = 2726,
  [2797] = 2797,
  [2798] = 2798,
  [2799] = 2799,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2744,
  [2803] = 2803,
  [2804] = 2742,
  [2805] = 2741,
  [2806] = 2799,
  [2807] = 2807,
  [2808] = 2795,
  [2809] = 2809,
  [2810] = 2810,
  [2811] = 2778,
  [2812] = 2812,
  [2813] = 2813,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2803,
  [2817] = 2817,
  [2818] = 2051,
  [2819] = 2819,
  [2820] = 2711,
  [2821] = 2078,
  [2822] = 2822,
  [2823] = 2755,
  [2824] = 2731,
  [2825] = 2825,
  [2826] = 2733,
  [2827] = 2827,
  [2828] = 2828,
  [2829] = 2813,
  [2830] = 2830,
  [2831] = 2048,
  [2832] = 2832,
  [2833] = 2070,
  [2834] = 2834,
  [2835] = 2072,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2838,
  [2839] = 2055,
  [2840] = 2058,
  [2841] = 2061,
  [2842] = 2815,
  [2843] = 2843,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2086,
  [2847] = 2819,
  [2848] = 2848,
  [2849] = 2090,
  [2850] = 2822,
  [2851] = 2706,
  [2852] = 2755,
  [2853] = 2853,
  [2854] = 2825,
  [2855] = 2855,
  [2856] = 2856,
  [2857] = 2857,
  [2858] = 2091,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2046,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2741,
  [2867] = 2755,
  [2868] = 2868,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2755,
  [2872] = 2081,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2875,
  [2876] = 2876,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2874,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2865,
  [2886] = 2702,
  [2887] = 2887,
  [2888] = 2755,
  [2889] = 2739,
  [2890] = 2890,
  [2891] = 2830,
  [2892] = 2892,
  [2893] = 2878,
  [2894] = 2894,
  [2895] = 2878,
  [2896] = 2896,
  [2897] = 2832,
  [2898] = 2834,
  [2899] = 2899,
  [2900] = 2836,
  [2901] = 2809,
  [2902] = 2082,
  [2903] = 2079,
  [2904] = 2798,
  [2905] = 2797,
  [2906] = 2073,
  [2907] = 2069,
  [2908] = 2793,
  [2909] = 2860,
  [2910] = 2060,
  [2911] = 2911,
  [2912] = 2825,
  [2913] = 2789,
  [2914] = 2837,
  [2915] = 2915,
  [2916] = 2780,
  [2917] = 2822,
  [2918] = 2819,
  [2919] = 2919,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 2922,
  [2923] = 2696,
  [2924] = 2924,
  [2925] = 2745,
  [2926] = 2726,
  [2927] = 2722,
  [2928] = 2859,
  [2929] = 2718,
  [2930] = 2930,
  [2931] = 2812,
  [2932] = 2812,
  [2933] = 2933,
  [2934] = 2845,
  [2935] = 2838,
  [2936] = 2936,
  [2937] = 2848,
  [2938] = 2938,
  [2939] = 2873,
  [2940] = 2054,
  [2941] = 2758,
  [2942] = 2725,
  [2943] = 2724,
  [2944] = 2944,
  [2945] = 2890,
  [2946] = 2740,
  [2947] = 2947,
  [2948] = 2853,
  [2949] = 2713,
  [2950] = 2710,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2709,
  [2954] = 2708,
  [2955] = 2856,
  [2956] = 2754,
  [2957] = 2857,
  [2958] = 2707,
  [2959] = 2047,
  [2960] = 2756,
  [2961] = 2050,
  [2962] = 2962,
  [2963] = 2755,
  [2964] = 2936,
  [2965] = 2729,
  [2966] = 2694,
  [2967] = 2059,
  [2968] = 2838,
  [2969] = 2064,
  [2970] = 2870,
  [2971] = 2699,
  [2972] = 2862,
  [2973] = 2973,
  [2974] = 2974,
  [2975] = 2975,
  [2976] = 2976,
  [2977] = 2977,
  [2978] = 2978,
  [2979] = 2979,
  [2980] = 2980,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2985,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 2988,
  [2989] = 2984,
  [2990] = 2990,
  [2991] = 2991,
  [2992] = 2992,
  [2993] = 2993,
  [2994] = 2994,
  [2995] = 2995,
  [2996] = 2996,
  [2997] = 2997,
  [2998] = 2996,
  [2999] = 2999,
  [3000] = 2997,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 2977,
  [3005] = 2979,
  [3006] = 3006,
  [3007] = 2990,
  [3008] = 3008,
  [3009] = 3009,
  [3010] = 2980,
  [3011] = 3011,
  [3012] = 2996,
  [3013] = 3001,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 3016,
  [3017] = 2994,
  [3018] = 3018,
  [3019] = 3019,
  [3020] = 3018,
  [3021] = 439,
  [3022] = 3022,
  [3023] = 3011,
  [3024] = 3024,
  [3025] = 3025,
  [3026] = 3026,
  [3027] = 3024,
  [3028] = 3011,
  [3029] = 3026,
  [3030] = 2979,
  [3031] = 2981,
  [3032] = 3032,
  [3033] = 3003,
  [3034] = 2980,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3016,
  [3046] = 3040,
  [3047] = 3024,
  [3048] = 2997,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 2985,
  [3054] = 3019,
  [3055] = 3055,
  [3056] = 2979,
  [3057] = 3057,
  [3058] = 3041,
  [3059] = 3052,
  [3060] = 2987,
  [3061] = 3061,
  [3062] = 3041,
  [3063] = 3063,
  [3064] = 3051,
  [3065] = 3065,
  [3066] = 3040,
  [3067] = 3067,
  [3068] = 3015,
  [3069] = 2993,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 3065,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3039,
  [3076] = 3076,
  [3077] = 3026,
  [3078] = 3073,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 2828,
  [3082] = 3082,
  [3083] = 3083,
  [3084] = 2827,
  [3085] = 2992,
  [3086] = 3086,
  [3087] = 3063,
  [3088] = 3051,
  [3089] = 3050,
  [3090] = 2992,
  [3091] = 3025,
  [3092] = 2980,
  [3093] = 2976,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 2993,
  [3097] = 3016,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 3102,
  [3103] = 2979,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3008,
  [3107] = 3002,
  [3108] = 3108,
  [3109] = 3019,
  [3110] = 2977,
  [3111] = 2979,
  [3112] = 2977,
  [3113] = 3024,
  [3114] = 3114,
  [3115] = 3038,
  [3116] = 2980,
  [3117] = 3117,
  [3118] = 3040,
  [3119] = 3016,
  [3120] = 3002,
  [3121] = 3121,
  [3122] = 2979,
  [3123] = 3123,
  [3124] = 3055,
  [3125] = 3057,
  [3126] = 3126,
  [3127] = 3127,
  [3128] = 2980,
  [3129] = 3129,
  [3130] = 3037,
  [3131] = 3131,
  [3132] = 3008,
  [3133] = 3035,
  [3134] = 3134,
  [3135] = 3135,
  [3136] = 3136,
  [3137] = 3022,
  [3138] = 3094,
  [3139] = 3049,
  [3140] = 2993,
  [3141] = 3104,
  [3142] = 1384,
  [3143] = 2986,
  [3144] = 3144,
  [3145] = 3095,
  [3146] = 2979,
  [3147] = 3108,
  [3148] = 3019,
  [3149] = 3149,
  [3150] = 3065,
  [3151] = 3151,
  [3152] = 2988,
  [3153] = 2980,
  [3154] = 3083,
  [3155] = 3040,
  [3156] = 3016,
  [3157] = 2995,
  [3158] = 2978,
  [3159] = 2983,
  [3160] = 3009,
  [3161] = 3019,
  [3162] = 3014,
  [3163] = 2991,
  [3164] = 3032,
  [3165] = 3165,
  [3166] = 2999,
  [3167] = 3044,
  [3168] = 2993,
  [3169] = 2993,
  [3170] = 3170,
  [3171] = 3117,
  [3172] = 2984,
  [3173] = 3036,
  [3174] = 2979,
  [3175] = 3019,
  [3176] = 3176,
  [3177] = 3074,
  [3178] = 2980,
  [3179] = 3179,
  [3180] = 3040,
  [3181] = 3016,
  [3182] = 3070,
  [3183] = 3105,
  [3184] = 3121,
  [3185] = 3185,
  [3186] = 3098,
  [3187] = 3099,
  [3188] = 2980,
  [3189] = 3082,
  [3190] = 3079,
  [3191] = 3191,
  [3192] = 3135,
  [3193] = 3100,
  [3194] = 2993,
  [3195] = 3102,
  [3196] = 3170,
  [3197] = 2997,
  [3198] = 2979,
  [3199] = 3019,
  [3200] = 3200,
  [3201] = 2980,
  [3202] = 1255,
  [3203] = 3040,
  [3204] = 3016,
  [3205] = 1251,
  [3206] = 3206,
  [3207] = 3207,
  [3208] = 3208,
  [3209] = 3200,
  [3210] = 2979,
  [3211] = 2980,
  [3212] = 3212,
  [3213] = 3040,
  [3214] = 3016,
  [3215] = 3049,
  [3216] = 3216,
  [3217] = 3040,
  [3218] = 3016,
  [3219] = 1162,
  [3220] = 3070,
  [3221] = 3040,
  [3222] = 3016,
  [3223] = 3136,
  [3224] = 3224,
  [3225] = 3040,
  [3226] = 3016,
  [3227] = 3149,
  [3228] = 3228,
  [3229] = 3074,
  [3230] = 3230,
  [3231] = 3127,
  [3232] = 2996,
  [3233] = 3185,
  [3234] = 3234,
  [3235] = 3216,
  [3236] = 3230,
  [3237] = 3165,
  [3238] = 3191,
  [3239] = 2192,
  [3240] = 3240,
  [3241] = 3241,
  [3242] = 3242,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 3246,
  [3247] = 3247,
  [3248] = 3248,
  [3249] = 3249,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 3252,
  [3253] = 3253,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 3256,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 3259,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 431,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3267,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 3271,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 3275,
  [3276] = 3276,
  [3277] = 3277,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 3281,
  [3282] = 3243,
  [3283] = 3283,
  [3284] = 3263,
  [3285] = 3285,
  [3286] = 3286,
  [3287] = 3287,
  [3288] = 3245,
  [3289] = 3248,
  [3290] = 3290,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 3256,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 3298,
  [3299] = 3299,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 3303,
  [3304] = 3254,
  [3305] = 3305,
  [3306] = 3306,
  [3307] = 3307,
  [3308] = 3308,
  [3309] = 3253,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3268,
  [3323] = 3323,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 3296,
  [3327] = 3327,
  [3328] = 3328,
  [3329] = 3275,
  [3330] = 3330,
  [3331] = 3331,
  [3332] = 3269,
  [3333] = 3327,
  [3334] = 3315,
  [3335] = 3335,
  [3336] = 3327,
  [3337] = 3327,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 3310,
  [3341] = 3341,
  [3342] = 3320,
  [3343] = 3343,
  [3344] = 3275,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3299,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3291,
  [3351] = 3297,
  [3352] = 3352,
  [3353] = 3270,
  [3354] = 3354,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 3315,
  [3358] = 3358,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3366,
  [3367] = 3330,
  [3368] = 3368,
  [3369] = 3330,
  [3370] = 3370,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3318,
  [3374] = 3374,
  [3375] = 3296,
  [3376] = 3315,
  [3377] = 3277,
  [3378] = 3349,
  [3379] = 3244,
  [3380] = 3292,
  [3381] = 3266,
  [3382] = 3287,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 3242,
  [3387] = 3244,
  [3388] = 3242,
  [3389] = 3389,
  [3390] = 3301,
  [3391] = 3253,
  [3392] = 3254,
  [3393] = 3250,
  [3394] = 3256,
  [3395] = 3341,
  [3396] = 3396,
  [3397] = 3316,
  [3398] = 3346,
  [3399] = 3269,
  [3400] = 3400,
  [3401] = 3262,
  [3402] = 3313,
  [3403] = 3248,
  [3404] = 3290,
  [3405] = 3291,
  [3406] = 3406,
  [3407] = 3271,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3272,
  [3411] = 3240,
  [3412] = 3383,
  [3413] = 3249,
  [3414] = 3251,
  [3415] = 3415,
  [3416] = 3273,
  [3417] = 3244,
  [3418] = 3418,
  [3419] = 3253,
  [3420] = 3256,
  [3421] = 3323,
  [3422] = 3422,
  [3423] = 3325,
  [3424] = 3424,
  [3425] = 3291,
  [3426] = 3252,
  [3427] = 3262,
  [3428] = 3345,
  [3429] = 3258,
  [3430] = 3274,
  [3431] = 3253,
  [3432] = 3256,
  [3433] = 3291,
  [3434] = 3253,
  [3435] = 3256,
  [3436] = 3291,
  [3437] = 3253,
  [3438] = 3256,
  [3439] = 3291,
  [3440] = 3253,
  [3441] = 3256,
  [3442] = 3253,
  [3443] = 3256,
  [3444] = 3253,
  [3445] = 3256,
  [3446] = 3253,
  [3447] = 3256,
  [3448] = 3278,
  [3449] = 3449,
  [3450] = 3450,
  [3451] = 3370,
  [3452] = 3374,
  [3453] = 3356,
  [3454] = 424,
  [3455] = 3335,
  [3456] = 3255,
  [3457] = 3257,
  [3458] = 3458,
  [3459] = 3364,
  [3460] = 3298,
  [3461] = 3290,
  [3462] = 3312,
  [3463] = 3385,
  [3464] = 3331,
  [3465] = 3465,
  [3466] = 3307,
  [3467] = 3267,
  [3468] = 3400,
  [3469] = 3276,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 3260,
  [3473] = 3308,
  [3474] = 3276,
  [3475] = 3315,
  [3476] = 3422,
  [3477] = 3385,
  [3478] = 3294,
  [3479] = 3479,
  [3480] = 3321,
  [3481] = 3481,
  [3482] = 3285,
  [3483] = 3483,
  [3484] = 3408,
  [3485] = 3485,
  [3486] = 3485,
  [3487] = 3409,
  [3488] = 3488,
  [3489] = 3259,
  [3490] = 3296,
  [3491] = 3299,
  [3492] = 3492,
  [3493] = 3465,
  [3494] = 3481,
  [3495] = 3374,
  [3496] = 3356,
  [3497] = 3255,
  [3498] = 3275,
  [3499] = 3303,
  [3500] = 3374,
  [3501] = 3255,
  [3502] = 3488,
  [3503] = 3305,
  [3504] = 3255,
  [3505] = 3255,
  [3506] = 3255,
  [3507] = 3507,
  [3508] = 3241,
  [3509] = 3339,
  [3510] = 3470,
  [3511] = 3311,
  [3512] = 3371,
  [3513] = 3483,
  [3514] = 3418,
  [3515] = 3458,
  [3516] = 3297,
  [3517] = 3261,
  [3518] = 3471,
  [3519] = 3283,
  [3520] = 3297,
  [3521] = 3314,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43642
    ? (c < 3784
      ? (c < 2759
        ? (c < 2048
          ? (c < 1155
            ? (c < 736
              ? (c < 183
                ? (c < 'a'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 183 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)))))
              : (c <= 740 || (c < 895
                ? (c < 768
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)))
                : (c <= 895 || (c < 910
                  ? (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)))))))
            : (c <= 1159 || (c < 1552
              ? (c < 1471
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)))
                : (c <= 1471 || (c < 1479
                  ? (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)
                  : (c <= 1479 || (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)))))
              : (c <= 1562 || (c < 1791
                ? (c < 1749
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)
                  : (c <= 1756 || (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)))
                : (c <= 1791 || (c < 1984
                  ? (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)
                  : (c <= 2037 || (c < 2045
                    ? c == 2042
                    : c <= 2045)))))))))
          : (c <= 2093 || (c < 2561
            ? (c < 2474
              ? (c < 2275
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)
                  : (c <= 2183 || (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)))
                : (c <= 2403 || (c < 2437
                  ? (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)
                  : (c <= 2444 || (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)))))
              : (c <= 2480 || (c < 2519
                ? (c < 2492
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2500 || (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)))
                : (c <= 2519 || (c < 2534
                  ? (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)
                  : (c <= 2545 || (c < 2558
                    ? c == 2556
                    : c <= 2558)))))))
            : (c <= 2563 || (c < 2641
              ? (c < 2613
                ? (c < 2579
                  ? (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)
                  : (c <= 2600 || (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)))
                : (c <= 2614 || (c < 2622
                  ? (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)
                  : (c <= 2626 || (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)))))
              : (c <= 2641 || (c < 2703
                ? (c < 2662
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2677 || (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)))
                : (c <= 2705 || (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)))))))))))
        : (c <= 2761 || (c < 3174
          ? (c < 2962
            ? (c < 2869
              ? (c < 2817
                ? (c < 2784
                  ? (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)
                  : (c <= 2787 || (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)))
                : (c <= 2819 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)))))
              : (c <= 2873 || (c < 2911
                ? (c < 2891
                  ? (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)
                  : (c <= 2893 || (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)))
                : (c <= 2915 || (c < 2946
                  ? (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)
                  : (c <= 2947 || (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)))))))
            : (c <= 2965 || (c < 3046
              ? (c < 2990
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)))
                : (c <= 3001 || (c < 3018
                  ? (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)
                  : (c <= 3021 || (c < 3031
                    ? c == 3024
                    : c <= 3031)))))
              : (c <= 3055 || (c < 3142
                ? (c < 3090
                  ? (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)))
                : (c <= 3144 || (c < 3160
                  ? (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)
                  : (c <= 3162 || (c < 3168
                    ? c == 3165
                    : c <= 3171)))))))))
          : (c <= 3183 || (c < 3457
            ? (c < 3296
              ? (c < 3253
                ? (c < 3214
                  ? (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)
                  : (c <= 3216 || (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)))
                : (c <= 3257 || (c < 3274
                  ? (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)
                  : (c <= 3277 || (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)))))
              : (c <= 3299 || (c < 3398
                ? (c < 3328
                  ? (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)
                  : (c <= 3340 || (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)))
                : (c <= 3400 || (c < 3423
                  ? (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)
                  : (c <= 3427 || (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)))))))
            : (c <= 3459 || (c < 3585
              ? (c < 3530
                ? (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || (c < 3520
                    ? c == 3517
                    : c <= 3526)))
                : (c <= 3530 || (c < 3544
                  ? (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)
                  : (c <= 3551 || (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)))))
              : (c <= 3642 || (c < 3724
                ? (c < 3713
                  ? (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)
                  : (c <= 3714 || (c < 3718
                    ? c == 3716
                    : c <= 3722)))
                : (c <= 3747 || (c < 3776
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))))))))))
      : (c <= 3789 || (c < 8027
        ? (c < 5919
          ? (c < 4696
            ? (c < 3974
              ? (c < 3893
                ? (c < 3840
                  ? (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)
                  : (c <= 3840 || (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)))
                : (c <= 3893 || (c < 3902
                  ? (c < 3897
                    ? c == 3895
                    : c <= 3897)
                  : (c <= 3911 || (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)))))
              : (c <= 3991 || (c < 4295
                ? (c < 4096
                  ? (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)
                  : (c <= 4169 || (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)))))))
            : (c <= 4696 || (c < 4888
              ? (c < 4792
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)))
                : (c <= 4798 || (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)))))
              : (c <= 4954 || (c < 5121
                ? (c < 4992
                  ? (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)
                  : (c <= 5007 || (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)))
                : (c <= 5740 || (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)))))))))
          : (c <= 5940 || (c < 6752
            ? (c < 6272
              ? (c < 6103
                ? (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)
                  : (c <= 6000 || (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)))
                : (c <= 6103 || (c < 6155
                  ? (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)
                  : (c <= 6157 || (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)))))
              : (c <= 6314 || (c < 6512
                ? (c < 6432
                  ? (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)
                  : (c <= 6443 || (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6608
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6618 || (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)))))))
            : (c <= 6780 || (c < 7245
              ? (c < 6912
                ? (c < 6823
                  ? (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)
                  : (c <= 6823 || (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)))
                : (c <= 6988 || (c < 7040
                  ? (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)
                  : (c <= 7155 || (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)))))
              : (c <= 7293 || (c < 7424
                ? (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)))
                : (c <= 7957 || (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)))))))))))
        : (c <= 8027 || (c < 11728
          ? (c < 8469
            ? (c < 8182
              ? (c < 8130
                ? (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))))
              : (c <= 8188 || (c < 8400
                ? (c < 8305
                  ? (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)
                  : (c <= 8305 || (c < 8336
                    ? c == 8319
                    : c <= 8348)))
                : (c <= 8412 || (c < 8450
                  ? (c < 8421
                    ? c == 8417
                    : c <= 8432)
                  : (c <= 8450 || (c < 8458
                    ? c == 8455
                    : c <= 8467)))))))
            : (c <= 8469 || (c < 11520
              ? (c < 8508
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || (c < 8490
                    ? c == 8488
                    : c <= 8505)))
                : (c <= 8511 || (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)))))
              : (c <= 11557 || (c < 11680
                ? (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || (c < 11647
                    ? c == 11631
                    : c <= 11670)))
                : (c <= 11686 || (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)))))))))
          : (c <= 11734 || (c < 42775
            ? (c < 12549
              ? (c < 12344
                ? (c < 12293
                  ? (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)
                  : (c <= 12295 || (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))))
              : (c <= 12591 || (c < 42192
                ? (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)))
                : (c <= 42237 || (c < 42560
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)
                  : (c <= 42607 || (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)))))))
            : (c <= 42783 || (c < 43259
              ? (c < 42994
                ? (c < 42960
                  ? (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)
                  : (c <= 42961 || (c < 42965
                    ? c == 42963
                    : c <= 42969)))
                : (c <= 43047 || (c < 43136
                  ? (c < 43072
                    ? c == 43052
                    : c <= 43123)
                  : (c <= 43205 || (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)))))
              : (c <= 43259 || (c < 43488
                ? (c < 43360
                  ? (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)
                  : (c <= 43388 || (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)))
                : (c <= 43518 || (c < 43600
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)
                  : (c <= 43609 || (c >= 43616 && c <= 43638)))))))))))))))
    : (c <= 43714 || (c < 71472
      ? (c < 67644
        ? (c < 65382
          ? (c < 64318
            ? (c < 44012
              ? (c < 43793
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43759)
                  : (c <= 43766 || (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44010)))))
              : (c <= 44013 || (c < 64112
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 44016 && c <= 44025)
                    : c <= 55203)
                  : (c <= 55238 || (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64296 || (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)))))))
            : (c <= 64318 || (c < 65101
              ? (c < 64848
                ? (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)))
                : (c <= 64911 || (c < 65024
                  ? (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)
                  : (c <= 65039 || (c < 65075
                    ? (c >= 65056 && c <= 65071)
                    : c <= 65076)))))
              : (c <= 65103 || (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65313
                  ? (c < 65296
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65305)
                  : (c <= 65338 || (c < 65345
                    ? c == 65343
                    : c <= 65370)))))))))
          : (c <= 65470 || (c < 66560
            ? (c < 65856
              ? (c < 65549
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)))
                : (c <= 65574 || (c < 65599
                  ? (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)
                  : (c <= 65613 || (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)))))
              : (c <= 65908 || (c < 66349
                ? (c < 66208
                  ? (c < 66176
                    ? c == 66045
                    : c <= 66204)
                  : (c <= 66256 || (c < 66304
                    ? c == 66272
                    : c <= 66335)))
                : (c <= 66378 || (c < 66464
                  ? (c < 66432
                    ? (c >= 66384 && c <= 66426)
                    : c <= 66461)
                  : (c <= 66499 || (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)))))))
            : (c <= 66717 || (c < 66995
              ? (c < 66928
                ? (c < 66776
                  ? (c < 66736
                    ? (c >= 66720 && c <= 66729)
                    : c <= 66771)
                  : (c <= 66811 || (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)))
                : (c <= 66938 || (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))))
              : (c <= 67001 || (c < 67463
                ? (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)))
                : (c <= 67504 || (c < 67592
                  ? (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)
                  : (c <= 67592 || (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)))))))))))
        : (c <= 67644 || (c < 69968
          ? (c < 68480
            ? (c < 68108
              ? (c < 67840
                ? (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)))
                : (c <= 67861 || (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)))))
              : (c <= 68115 || (c < 68224
                ? (c < 68152
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68154 || (c < 68192
                    ? c == 68159
                    : c <= 68220)))
                : (c <= 68252 || (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)
                  : (c <= 68405 || (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)))))))
            : (c <= 68497 || (c < 69488
              ? (c < 69248
                ? (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)))
                : (c <= 69289 || (c < 69376
                  ? (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69456)))))
              : (c <= 69509 || (c < 69826
                ? (c < 69632
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69702 || (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)))
                : (c <= 69826 || (c < 69888
                  ? (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)
                  : (c <= 69940 || (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)))))))))
          : (c <= 70003 || (c < 70471
            ? (c < 70287
              ? (c < 70144
                ? (c < 70089
                  ? (c < 70016
                    ? c == 70006
                    : c <= 70084)
                  : (c <= 70092 || (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)))
                : (c <= 70161 || (c < 70272
                  ? (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)
                  : (c <= 70278 || (c < 70282
                    ? c == 70280
                    : c <= 70285)))))
              : (c <= 70301 || (c < 70415
                ? (c < 70384
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)
                  : (c <= 70393 || (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)))
                : (c <= 70416 || (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)))))))
            : (c <= 70472 || (c < 70864
              ? (c < 70512
                ? (c < 70487
                  ? (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)
                  : (c <= 70487 || (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)))
                : (c <= 70516 || (c < 70750
                  ? (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)
                  : (c <= 70753 || (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)))))
              : (c <= 70873 || (c < 71248
                ? (c < 71128
                  ? (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)
                  : (c <= 71133 || (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)))
                : (c <= 71257 || (c < 71424
                  ? (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)
                  : (c <= 71450 || (c >= 71453 && c <= 71467)))))))))))))
      : (c <= 71481 || (c < 119973
        ? (c < 82944
          ? (c < 72784
            ? (c < 72096
              ? (c < 71948
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71738)
                  : (c <= 71913 || (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)))
                : (c <= 71955 || (c < 71991
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71989)
                  : (c <= 71992 || (c < 72016
                    ? (c >= 71995 && c <= 72003)
                    : c <= 72025)))))
              : (c <= 72103 || (c < 72272
                ? (c < 72163
                  ? (c < 72154
                    ? (c >= 72106 && c <= 72151)
                    : c <= 72161)
                  : (c <= 72164 || (c < 72263
                    ? (c >= 72192 && c <= 72254)
                    : c <= 72263)))
                : (c <= 72345 || (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c < 72760
                    ? (c >= 72714 && c <= 72758)
                    : c <= 72768)))))))
            : (c <= 72793 || (c < 73063
              ? (c < 72971
                ? (c < 72873
                  ? (c < 72850
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72871)
                  : (c <= 72886 || (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)))
                : (c <= 73014 || (c < 73023
                  ? (c < 73020
                    ? c == 73018
                    : c <= 73021)
                  : (c <= 73031 || (c < 73056
                    ? (c >= 73040 && c <= 73049)
                    : c <= 73061)))))
              : (c <= 73064 || (c < 73648
                ? (c < 73107
                  ? (c < 73104
                    ? (c >= 73066 && c <= 73102)
                    : c <= 73105)
                  : (c <= 73112 || (c < 73440
                    ? (c >= 73120 && c <= 73129)
                    : c <= 73462)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c < 77824
                    ? (c >= 77712 && c <= 77808)
                    : c <= 78894)))))))))
          : (c <= 83526 || (c < 110581
            ? (c < 93053
              ? (c < 92880
                ? (c < 92768
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92777 || (c < 92864
                    ? (c >= 92784 && c <= 92862)
                    : c <= 92873)))
                : (c <= 92909 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92912 && c <= 92916)
                    : c <= 92982)
                  : (c <= 92995 || (c < 93027
                    ? (c >= 93008 && c <= 93017)
                    : c <= 93047)))))
              : (c <= 93071 || (c < 94179
                ? (c < 94031
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94087 || (c < 94176
                    ? (c >= 94095 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94180 || (c < 100352
                  ? (c < 94208
                    ? (c >= 94192 && c <= 94193)
                    : c <= 100343)
                  : (c <= 101589 || (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)))))))
            : (c <= 110587 || (c < 118576
              ? (c < 113664
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c < 110960
                    ? (c >= 110948 && c <= 110951)
                    : c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c < 118528
                    ? (c >= 113821 && c <= 113822)
                    : c <= 118573)))))
              : (c <= 118598 || (c < 119362
                ? (c < 119163
                  ? (c < 119149
                    ? (c >= 119141 && c <= 119145)
                    : c <= 119154)
                  : (c <= 119170 || (c < 119210
                    ? (c >= 119173 && c <= 119179)
                    : c <= 119213)))
                : (c <= 119364 || (c < 119966
                  ? (c < 119894
                    ? (c >= 119808 && c <= 119892)
                    : c <= 119964)
                  : (c <= 119967 || c == 119970))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'b' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(175);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(109);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(196);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '|') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(46);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '%') ADVANCE(114);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(98);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(109);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(116);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(196);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(82);
      if (lookahead == '%') ADVANCE(114);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(98);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(109);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(116);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(196);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(98);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '@') ADVANCE(109);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '@') ADVANCE(109);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '|') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == 'b' ||
          lookahead == 'c') ADVANCE(184);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 23:
      if (lookahead == '&') ADVANCE(133);
      END_STATE();
    case 24:
      if (lookahead == '\'') ADVANCE(162);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(162);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 26:
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(179);
      if (lookahead == '/') ADVANCE(164);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '?') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(85);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(131);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(129);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(130);
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(181);
      END_STATE();
    case 33:
      if (lookahead == '1') ADVANCE(35);
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(37);
      if (lookahead == '8') ADVANCE(151);
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 34:
      if (lookahead == '2') ADVANCE(151);
      END_STATE();
    case 35:
      if (lookahead == '2') ADVANCE(38);
      if (lookahead == '6') ADVANCE(151);
      END_STATE();
    case 36:
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == '4') ADVANCE(151);
      END_STATE();
    case 38:
      if (lookahead == '8') ADVANCE(151);
      END_STATE();
    case 39:
      if (lookahead == ':') ADVANCE(104);
      END_STATE();
    case 40:
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 41:
      if (lookahead == '>') ADVANCE(102);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 45:
      if (lookahead == 'u') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(60);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(49);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 47:
      if (lookahead == 'z') ADVANCE(43);
      END_STATE();
    case 48:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 49:
      if (lookahead == '{') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 50:
      if (lookahead == '}') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 51:
      if (lookahead == '}') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 52:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(156);
      END_STATE();
    case 53:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '[') ADVANCE(197);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(157);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(159);
      END_STATE();
    case 64:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(198);
      END_STATE();
    case 65:
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 66:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(109);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(196);
      END_STATE();
    case 67:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(96);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(119);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 68:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(103);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 69:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(126);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(155);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == 'b') ADVANCE(183);
      if (lookahead == 'c') ADVANCE(184);
      if (lookahead == 'm') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(185);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(158);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(196);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_macro_rules_BANG);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(104);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(198);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '*') ADVANCE(179);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '/') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(179);
      if (lookahead == '/') ADVANCE(164);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(179);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(102);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(102);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(131);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(53);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(139);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(140);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(147);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(162);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(127);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(127);
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '2') ADVANCE(159);
      if (lookahead == 'f') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(159);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '3') ADVANCE(152);
      if (lookahead == '6') ADVANCE(154);
      if (lookahead == 'f') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(159);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '4') ADVANCE(159);
      if (lookahead == 'f') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(159);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'b') ADVANCE(52);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(158);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(159);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '*') ADVANCE(180);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '!') ADVANCE(175);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym__inner_line_doc_comment);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym__outer_line_doc_comment);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym__outer_line_doc_comment);
      if (lookahead == '*') ADVANCE(176);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(176);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym__outer_line_doc_comment);
      if (lookahead == '*') ADVANCE(176);
      if (lookahead == '=') ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '/') ADVANCE(176);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_STAR_SLASH);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(72);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(25);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(160);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(65);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(193);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(196);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(188);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(196);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(192);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(194);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(189);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(186);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(191);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(195);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(182);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(190);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_shebang);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '[') ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_metavariable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(198);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'b') ADVANCE(3);
      if (lookahead == 'c') ADVANCE(4);
      if (lookahead == 'd') ADVANCE(5);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'f') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(27);
      if (lookahead == 'y') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == '3') ADVANCE(32);
      if (lookahead == '6') ADVANCE(33);
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 8:
      if (lookahead == '1') ADVANCE(37);
      if (lookahead == '3') ADVANCE(38);
      if (lookahead == '6') ADVANCE(39);
      if (lookahead == '8') ADVANCE(40);
      if (lookahead == 'd') ADVANCE(41);
      if (lookahead == 'f') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      if (lookahead == 'y') ADVANCE(62);
      END_STATE();
    case 15:
      if (lookahead == '1') ADVANCE(63);
      if (lookahead == '3') ADVANCE(64);
      if (lookahead == '6') ADVANCE(65);
      if (lookahead == '8') ADVANCE(66);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'f') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 32:
      if (lookahead == '2') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == '4') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 37:
      if (lookahead == '2') ADVANCE(90);
      if (lookahead == '6') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == '2') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == '4') ADVANCE(93);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(95);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'v') ADVANCE(105);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 56:
      if (lookahead == 'f') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(113);
      if (lookahead == 'r') ADVANCE(114);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(117);
      if (lookahead == 'y') ADVANCE(118);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_tt);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_ty);
      if (lookahead == 'p') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(120);
      if (lookahead == '6') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == '4') ADVANCE(123);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(124);
      if (lookahead == 's') ADVANCE(125);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(126);
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_dyn);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 83:
      if (lookahead == 'm') ADVANCE(143);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 90:
      if (lookahead == '8') ADVANCE(147);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'z') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(154);
      END_STATE();
    case 102:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(156);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_mutable_specifier);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_pat);
      if (lookahead == 'h') ADVANCE(158);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 111:
      if (lookahead == 'f') ADVANCE(160);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 120:
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 124:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 127:
      if (lookahead == 'z') ADVANCE(171);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_vis);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(173);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(175);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 134:
      if (lookahead == 'k') ADVANCE(177);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 136:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 138:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(180);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_expr);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_move);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_path);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_stmt);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(192);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 170:
      if (lookahead == 'f') ADVANCE(196);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(200);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_crate);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_ident);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 191:
      if (lookahead == 'c') ADVANCE(207);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 201:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 204:
      if (lookahead == 'm') ADVANCE(212);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_literal);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_lifetime);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 68, .external_lex_state = 2},
  [2] = {.lex_state = 69, .external_lex_state = 2},
  [3] = {.lex_state = 69, .external_lex_state = 2},
  [4] = {.lex_state = 69, .external_lex_state = 2},
  [5] = {.lex_state = 69, .external_lex_state = 2},
  [6] = {.lex_state = 69, .external_lex_state = 2},
  [7] = {.lex_state = 69, .external_lex_state = 2},
  [8] = {.lex_state = 69, .external_lex_state = 2},
  [9] = {.lex_state = 69, .external_lex_state = 2},
  [10] = {.lex_state = 69, .external_lex_state = 2},
  [11] = {.lex_state = 69, .external_lex_state = 2},
  [12] = {.lex_state = 69, .external_lex_state = 2},
  [13] = {.lex_state = 69, .external_lex_state = 2},
  [14] = {.lex_state = 69, .external_lex_state = 2},
  [15] = {.lex_state = 69, .external_lex_state = 2},
  [16] = {.lex_state = 69, .external_lex_state = 2},
  [17] = {.lex_state = 69, .external_lex_state = 2},
  [18] = {.lex_state = 69, .external_lex_state = 2},
  [19] = {.lex_state = 69, .external_lex_state = 2},
  [20] = {.lex_state = 69, .external_lex_state = 2},
  [21] = {.lex_state = 69, .external_lex_state = 2},
  [22] = {.lex_state = 69, .external_lex_state = 2},
  [23] = {.lex_state = 69, .external_lex_state = 2},
  [24] = {.lex_state = 69, .external_lex_state = 2},
  [25] = {.lex_state = 69, .external_lex_state = 2},
  [26] = {.lex_state = 69, .external_lex_state = 2},
  [27] = {.lex_state = 69, .external_lex_state = 2},
  [28] = {.lex_state = 69, .external_lex_state = 2},
  [29] = {.lex_state = 69, .external_lex_state = 2},
  [30] = {.lex_state = 69, .external_lex_state = 2},
  [31] = {.lex_state = 69, .external_lex_state = 2},
  [32] = {.lex_state = 69, .external_lex_state = 2},
  [33] = {.lex_state = 69, .external_lex_state = 2},
  [34] = {.lex_state = 69, .external_lex_state = 2},
  [35] = {.lex_state = 1, .external_lex_state = 2},
  [36] = {.lex_state = 1, .external_lex_state = 2},
  [37] = {.lex_state = 1, .external_lex_state = 2},
  [38] = {.lex_state = 1, .external_lex_state = 2},
  [39] = {.lex_state = 1, .external_lex_state = 2},
  [40] = {.lex_state = 1, .external_lex_state = 2},
  [41] = {.lex_state = 1, .external_lex_state = 2},
  [42] = {.lex_state = 1, .external_lex_state = 2},
  [43] = {.lex_state = 2, .external_lex_state = 2},
  [44] = {.lex_state = 2, .external_lex_state = 2},
  [45] = {.lex_state = 2, .external_lex_state = 2},
  [46] = {.lex_state = 2, .external_lex_state = 2},
  [47] = {.lex_state = 2, .external_lex_state = 2},
  [48] = {.lex_state = 2, .external_lex_state = 2},
  [49] = {.lex_state = 2, .external_lex_state = 2},
  [50] = {.lex_state = 1, .external_lex_state = 2},
  [51] = {.lex_state = 2, .external_lex_state = 2},
  [52] = {.lex_state = 2, .external_lex_state = 2},
  [53] = {.lex_state = 2, .external_lex_state = 2},
  [54] = {.lex_state = 2, .external_lex_state = 2},
  [55] = {.lex_state = 2, .external_lex_state = 2},
  [56] = {.lex_state = 2, .external_lex_state = 2},
  [57] = {.lex_state = 2, .external_lex_state = 2},
  [58] = {.lex_state = 1, .external_lex_state = 2},
  [59] = {.lex_state = 2, .external_lex_state = 2},
  [60] = {.lex_state = 2, .external_lex_state = 2},
  [61] = {.lex_state = 1, .external_lex_state = 2},
  [62] = {.lex_state = 1, .external_lex_state = 2},
  [63] = {.lex_state = 1, .external_lex_state = 2},
  [64] = {.lex_state = 1, .external_lex_state = 2},
  [65] = {.lex_state = 1, .external_lex_state = 2},
  [66] = {.lex_state = 1, .external_lex_state = 2},
  [67] = {.lex_state = 1, .external_lex_state = 2},
  [68] = {.lex_state = 1, .external_lex_state = 2},
  [69] = {.lex_state = 1, .external_lex_state = 2},
  [70] = {.lex_state = 1, .external_lex_state = 2},
  [71] = {.lex_state = 1, .external_lex_state = 2},
  [72] = {.lex_state = 1, .external_lex_state = 2},
  [73] = {.lex_state = 1, .external_lex_state = 2},
  [74] = {.lex_state = 1, .external_lex_state = 2},
  [75] = {.lex_state = 9, .external_lex_state = 2},
  [76] = {.lex_state = 9, .external_lex_state = 2},
  [77] = {.lex_state = 9, .external_lex_state = 2},
  [78] = {.lex_state = 9, .external_lex_state = 2},
  [79] = {.lex_state = 9, .external_lex_state = 2},
  [80] = {.lex_state = 9, .external_lex_state = 2},
  [81] = {.lex_state = 9, .external_lex_state = 2},
  [82] = {.lex_state = 9, .external_lex_state = 2},
  [83] = {.lex_state = 9, .external_lex_state = 2},
  [84] = {.lex_state = 9, .external_lex_state = 2},
  [85] = {.lex_state = 9, .external_lex_state = 2},
  [86] = {.lex_state = 9, .external_lex_state = 2},
  [87] = {.lex_state = 9, .external_lex_state = 2},
  [88] = {.lex_state = 9, .external_lex_state = 2},
  [89] = {.lex_state = 9, .external_lex_state = 2},
  [90] = {.lex_state = 9, .external_lex_state = 2},
  [91] = {.lex_state = 9, .external_lex_state = 2},
  [92] = {.lex_state = 9, .external_lex_state = 2},
  [93] = {.lex_state = 9, .external_lex_state = 2},
  [94] = {.lex_state = 9, .external_lex_state = 2},
  [95] = {.lex_state = 9, .external_lex_state = 2},
  [96] = {.lex_state = 9, .external_lex_state = 2},
  [97] = {.lex_state = 9, .external_lex_state = 2},
  [98] = {.lex_state = 9, .external_lex_state = 2},
  [99] = {.lex_state = 9, .external_lex_state = 2},
  [100] = {.lex_state = 9, .external_lex_state = 2},
  [101] = {.lex_state = 9, .external_lex_state = 2},
  [102] = {.lex_state = 9, .external_lex_state = 2},
  [103] = {.lex_state = 9, .external_lex_state = 2},
  [104] = {.lex_state = 9, .external_lex_state = 2},
  [105] = {.lex_state = 9, .external_lex_state = 2},
  [106] = {.lex_state = 9, .external_lex_state = 2},
  [107] = {.lex_state = 9, .external_lex_state = 2},
  [108] = {.lex_state = 9, .external_lex_state = 2},
  [109] = {.lex_state = 9, .external_lex_state = 2},
  [110] = {.lex_state = 9, .external_lex_state = 2},
  [111] = {.lex_state = 9, .external_lex_state = 2},
  [112] = {.lex_state = 9, .external_lex_state = 2},
  [113] = {.lex_state = 9, .external_lex_state = 2},
  [114] = {.lex_state = 9, .external_lex_state = 2},
  [115] = {.lex_state = 9, .external_lex_state = 2},
  [116] = {.lex_state = 9, .external_lex_state = 2},
  [117] = {.lex_state = 9, .external_lex_state = 2},
  [118] = {.lex_state = 9, .external_lex_state = 2},
  [119] = {.lex_state = 12, .external_lex_state = 2},
  [120] = {.lex_state = 12, .external_lex_state = 2},
  [121] = {.lex_state = 12, .external_lex_state = 2},
  [122] = {.lex_state = 12, .external_lex_state = 2},
  [123] = {.lex_state = 9, .external_lex_state = 2},
  [124] = {.lex_state = 12, .external_lex_state = 2},
  [125] = {.lex_state = 9, .external_lex_state = 2},
  [126] = {.lex_state = 9, .external_lex_state = 2},
  [127] = {.lex_state = 9, .external_lex_state = 2},
  [128] = {.lex_state = 9, .external_lex_state = 2},
  [129] = {.lex_state = 67, .external_lex_state = 2},
  [130] = {.lex_state = 12, .external_lex_state = 2},
  [131] = {.lex_state = 12, .external_lex_state = 2},
  [132] = {.lex_state = 12, .external_lex_state = 2},
  [133] = {.lex_state = 9, .external_lex_state = 2},
  [134] = {.lex_state = 9, .external_lex_state = 2},
  [135] = {.lex_state = 9, .external_lex_state = 2},
  [136] = {.lex_state = 12, .external_lex_state = 2},
  [137] = {.lex_state = 12, .external_lex_state = 2},
  [138] = {.lex_state = 12, .external_lex_state = 2},
  [139] = {.lex_state = 12, .external_lex_state = 2},
  [140] = {.lex_state = 9, .external_lex_state = 2},
  [141] = {.lex_state = 9, .external_lex_state = 2},
  [142] = {.lex_state = 12, .external_lex_state = 2},
  [143] = {.lex_state = 9, .external_lex_state = 2},
  [144] = {.lex_state = 9, .external_lex_state = 2},
  [145] = {.lex_state = 9, .external_lex_state = 2},
  [146] = {.lex_state = 12, .external_lex_state = 2},
  [147] = {.lex_state = 12, .external_lex_state = 2},
  [148] = {.lex_state = 12, .external_lex_state = 2},
  [149] = {.lex_state = 12, .external_lex_state = 2},
  [150] = {.lex_state = 12, .external_lex_state = 2},
  [151] = {.lex_state = 12, .external_lex_state = 2},
  [152] = {.lex_state = 12, .external_lex_state = 2},
  [153] = {.lex_state = 12, .external_lex_state = 2},
  [154] = {.lex_state = 67, .external_lex_state = 2},
  [155] = {.lex_state = 9, .external_lex_state = 2},
  [156] = {.lex_state = 9, .external_lex_state = 2},
  [157] = {.lex_state = 9, .external_lex_state = 2},
  [158] = {.lex_state = 9, .external_lex_state = 2},
  [159] = {.lex_state = 67, .external_lex_state = 2},
  [160] = {.lex_state = 67, .external_lex_state = 2},
  [161] = {.lex_state = 67, .external_lex_state = 2},
  [162] = {.lex_state = 67, .external_lex_state = 2},
  [163] = {.lex_state = 9, .external_lex_state = 2},
  [164] = {.lex_state = 9, .external_lex_state = 2},
  [165] = {.lex_state = 9, .external_lex_state = 2},
  [166] = {.lex_state = 67, .external_lex_state = 2},
  [167] = {.lex_state = 9, .external_lex_state = 2},
  [168] = {.lex_state = 67, .external_lex_state = 2},
  [169] = {.lex_state = 9, .external_lex_state = 2},
  [170] = {.lex_state = 9, .external_lex_state = 2},
  [171] = {.lex_state = 9, .external_lex_state = 2},
  [172] = {.lex_state = 67, .external_lex_state = 2},
  [173] = {.lex_state = 67, .external_lex_state = 2},
  [174] = {.lex_state = 9, .external_lex_state = 2},
  [175] = {.lex_state = 9, .external_lex_state = 2},
  [176] = {.lex_state = 9, .external_lex_state = 2},
  [177] = {.lex_state = 67, .external_lex_state = 2},
  [178] = {.lex_state = 9, .external_lex_state = 2},
  [179] = {.lex_state = 9, .external_lex_state = 2},
  [180] = {.lex_state = 9, .external_lex_state = 2},
  [181] = {.lex_state = 9, .external_lex_state = 2},
  [182] = {.lex_state = 9, .external_lex_state = 2},
  [183] = {.lex_state = 9, .external_lex_state = 2},
  [184] = {.lex_state = 9, .external_lex_state = 2},
  [185] = {.lex_state = 9, .external_lex_state = 2},
  [186] = {.lex_state = 9, .external_lex_state = 2},
  [187] = {.lex_state = 9, .external_lex_state = 2},
  [188] = {.lex_state = 9, .external_lex_state = 2},
  [189] = {.lex_state = 9, .external_lex_state = 2},
  [190] = {.lex_state = 9, .external_lex_state = 2},
  [191] = {.lex_state = 9, .external_lex_state = 2},
  [192] = {.lex_state = 67, .external_lex_state = 2},
  [193] = {.lex_state = 67, .external_lex_state = 2},
  [194] = {.lex_state = 9, .external_lex_state = 2},
  [195] = {.lex_state = 67, .external_lex_state = 2},
  [196] = {.lex_state = 9, .external_lex_state = 2},
  [197] = {.lex_state = 9, .external_lex_state = 2},
  [198] = {.lex_state = 9, .external_lex_state = 2},
  [199] = {.lex_state = 9, .external_lex_state = 2},
  [200] = {.lex_state = 9, .external_lex_state = 2},
  [201] = {.lex_state = 9, .external_lex_state = 2},
  [202] = {.lex_state = 9, .external_lex_state = 2},
  [203] = {.lex_state = 9, .external_lex_state = 2},
  [204] = {.lex_state = 9, .external_lex_state = 2},
  [205] = {.lex_state = 9, .external_lex_state = 2},
  [206] = {.lex_state = 67, .external_lex_state = 2},
  [207] = {.lex_state = 67, .external_lex_state = 2},
  [208] = {.lex_state = 9, .external_lex_state = 2},
  [209] = {.lex_state = 9, .external_lex_state = 2},
  [210] = {.lex_state = 9, .external_lex_state = 2},
  [211] = {.lex_state = 9, .external_lex_state = 2},
  [212] = {.lex_state = 9, .external_lex_state = 2},
  [213] = {.lex_state = 9, .external_lex_state = 2},
  [214] = {.lex_state = 9, .external_lex_state = 2},
  [215] = {.lex_state = 9, .external_lex_state = 2},
  [216] = {.lex_state = 9, .external_lex_state = 2},
  [217] = {.lex_state = 9, .external_lex_state = 2},
  [218] = {.lex_state = 9, .external_lex_state = 2},
  [219] = {.lex_state = 67, .external_lex_state = 2},
  [220] = {.lex_state = 9, .external_lex_state = 2},
  [221] = {.lex_state = 9, .external_lex_state = 2},
  [222] = {.lex_state = 67, .external_lex_state = 2},
  [223] = {.lex_state = 67, .external_lex_state = 2},
  [224] = {.lex_state = 9, .external_lex_state = 2},
  [225] = {.lex_state = 9, .external_lex_state = 2},
  [226] = {.lex_state = 9, .external_lex_state = 2},
  [227] = {.lex_state = 9, .external_lex_state = 2},
  [228] = {.lex_state = 9, .external_lex_state = 2},
  [229] = {.lex_state = 9, .external_lex_state = 2},
  [230] = {.lex_state = 9, .external_lex_state = 2},
  [231] = {.lex_state = 9, .external_lex_state = 2},
  [232] = {.lex_state = 9, .external_lex_state = 2},
  [233] = {.lex_state = 9, .external_lex_state = 2},
  [234] = {.lex_state = 9, .external_lex_state = 2},
  [235] = {.lex_state = 9, .external_lex_state = 2},
  [236] = {.lex_state = 9, .external_lex_state = 2},
  [237] = {.lex_state = 67, .external_lex_state = 2},
  [238] = {.lex_state = 9, .external_lex_state = 2},
  [239] = {.lex_state = 9, .external_lex_state = 2},
  [240] = {.lex_state = 67, .external_lex_state = 2},
  [241] = {.lex_state = 9, .external_lex_state = 2},
  [242] = {.lex_state = 9, .external_lex_state = 2},
  [243] = {.lex_state = 9, .external_lex_state = 2},
  [244] = {.lex_state = 9, .external_lex_state = 2},
  [245] = {.lex_state = 9, .external_lex_state = 2},
  [246] = {.lex_state = 67, .external_lex_state = 2},
  [247] = {.lex_state = 9, .external_lex_state = 2},
  [248] = {.lex_state = 67, .external_lex_state = 2},
  [249] = {.lex_state = 9, .external_lex_state = 2},
  [250] = {.lex_state = 9, .external_lex_state = 2},
  [251] = {.lex_state = 9, .external_lex_state = 2},
  [252] = {.lex_state = 9, .external_lex_state = 2},
  [253] = {.lex_state = 9, .external_lex_state = 2},
  [254] = {.lex_state = 9, .external_lex_state = 2},
  [255] = {.lex_state = 9, .external_lex_state = 2},
  [256] = {.lex_state = 9, .external_lex_state = 2},
  [257] = {.lex_state = 9, .external_lex_state = 2},
  [258] = {.lex_state = 9, .external_lex_state = 2},
  [259] = {.lex_state = 67, .external_lex_state = 2},
  [260] = {.lex_state = 9, .external_lex_state = 2},
  [261] = {.lex_state = 9, .external_lex_state = 2},
  [262] = {.lex_state = 9, .external_lex_state = 2},
  [263] = {.lex_state = 9, .external_lex_state = 2},
  [264] = {.lex_state = 9, .external_lex_state = 2},
  [265] = {.lex_state = 9, .external_lex_state = 2},
  [266] = {.lex_state = 9, .external_lex_state = 2},
  [267] = {.lex_state = 9, .external_lex_state = 2},
  [268] = {.lex_state = 9, .external_lex_state = 2},
  [269] = {.lex_state = 9, .external_lex_state = 2},
  [270] = {.lex_state = 9, .external_lex_state = 2},
  [271] = {.lex_state = 9, .external_lex_state = 2},
  [272] = {.lex_state = 9, .external_lex_state = 2},
  [273] = {.lex_state = 9, .external_lex_state = 2},
  [274] = {.lex_state = 9, .external_lex_state = 2},
  [275] = {.lex_state = 9, .external_lex_state = 2},
  [276] = {.lex_state = 9, .external_lex_state = 2},
  [277] = {.lex_state = 9, .external_lex_state = 2},
  [278] = {.lex_state = 9, .external_lex_state = 2},
  [279] = {.lex_state = 9, .external_lex_state = 2},
  [280] = {.lex_state = 9, .external_lex_state = 2},
  [281] = {.lex_state = 9, .external_lex_state = 2},
  [282] = {.lex_state = 67, .external_lex_state = 2},
  [283] = {.lex_state = 9, .external_lex_state = 2},
  [284] = {.lex_state = 9, .external_lex_state = 2},
  [285] = {.lex_state = 9, .external_lex_state = 2},
  [286] = {.lex_state = 9, .external_lex_state = 2},
  [287] = {.lex_state = 67, .external_lex_state = 2},
  [288] = {.lex_state = 9, .external_lex_state = 2},
  [289] = {.lex_state = 67, .external_lex_state = 2},
  [290] = {.lex_state = 9, .external_lex_state = 2},
  [291] = {.lex_state = 9, .external_lex_state = 2},
  [292] = {.lex_state = 9, .external_lex_state = 2},
  [293] = {.lex_state = 9, .external_lex_state = 2},
  [294] = {.lex_state = 9, .external_lex_state = 2},
  [295] = {.lex_state = 67, .external_lex_state = 2},
  [296] = {.lex_state = 9, .external_lex_state = 2},
  [297] = {.lex_state = 9, .external_lex_state = 2},
  [298] = {.lex_state = 9, .external_lex_state = 2},
  [299] = {.lex_state = 9, .external_lex_state = 2},
  [300] = {.lex_state = 9, .external_lex_state = 2},
  [301] = {.lex_state = 9, .external_lex_state = 2},
  [302] = {.lex_state = 9, .external_lex_state = 2},
  [303] = {.lex_state = 67, .external_lex_state = 2},
  [304] = {.lex_state = 9, .external_lex_state = 2},
  [305] = {.lex_state = 9, .external_lex_state = 2},
  [306] = {.lex_state = 9, .external_lex_state = 2},
  [307] = {.lex_state = 9, .external_lex_state = 2},
  [308] = {.lex_state = 9, .external_lex_state = 2},
  [309] = {.lex_state = 9, .external_lex_state = 2},
  [310] = {.lex_state = 9, .external_lex_state = 2},
  [311] = {.lex_state = 9, .external_lex_state = 2},
  [312] = {.lex_state = 9, .external_lex_state = 2},
  [313] = {.lex_state = 9, .external_lex_state = 2},
  [314] = {.lex_state = 9, .external_lex_state = 2},
  [315] = {.lex_state = 9, .external_lex_state = 2},
  [316] = {.lex_state = 9, .external_lex_state = 2},
  [317] = {.lex_state = 9, .external_lex_state = 2},
  [318] = {.lex_state = 67, .external_lex_state = 2},
  [319] = {.lex_state = 10, .external_lex_state = 2},
  [320] = {.lex_state = 10, .external_lex_state = 2},
  [321] = {.lex_state = 10, .external_lex_state = 2},
  [322] = {.lex_state = 10, .external_lex_state = 2},
  [323] = {.lex_state = 10, .external_lex_state = 2},
  [324] = {.lex_state = 10, .external_lex_state = 2},
  [325] = {.lex_state = 8, .external_lex_state = 2},
  [326] = {.lex_state = 10, .external_lex_state = 2},
  [327] = {.lex_state = 10, .external_lex_state = 2},
  [328] = {.lex_state = 10, .external_lex_state = 2},
  [329] = {.lex_state = 9, .external_lex_state = 2},
  [330] = {.lex_state = 10, .external_lex_state = 2},
  [331] = {.lex_state = 9, .external_lex_state = 2},
  [332] = {.lex_state = 10, .external_lex_state = 2},
  [333] = {.lex_state = 10, .external_lex_state = 2},
  [334] = {.lex_state = 9, .external_lex_state = 2},
  [335] = {.lex_state = 10, .external_lex_state = 2},
  [336] = {.lex_state = 10, .external_lex_state = 2},
  [337] = {.lex_state = 10, .external_lex_state = 2},
  [338] = {.lex_state = 10, .external_lex_state = 2},
  [339] = {.lex_state = 8, .external_lex_state = 2},
  [340] = {.lex_state = 8, .external_lex_state = 2},
  [341] = {.lex_state = 8, .external_lex_state = 2},
  [342] = {.lex_state = 8, .external_lex_state = 2},
  [343] = {.lex_state = 8, .external_lex_state = 2},
  [344] = {.lex_state = 11, .external_lex_state = 2},
  [345] = {.lex_state = 8, .external_lex_state = 2},
  [346] = {.lex_state = 8, .external_lex_state = 2},
  [347] = {.lex_state = 8, .external_lex_state = 2},
  [348] = {.lex_state = 8, .external_lex_state = 2},
  [349] = {.lex_state = 8, .external_lex_state = 2},
  [350] = {.lex_state = 8, .external_lex_state = 2},
  [351] = {.lex_state = 8, .external_lex_state = 2},
  [352] = {.lex_state = 8, .external_lex_state = 2},
  [353] = {.lex_state = 8, .external_lex_state = 2},
  [354] = {.lex_state = 8, .external_lex_state = 2},
  [355] = {.lex_state = 10, .external_lex_state = 2},
  [356] = {.lex_state = 10, .external_lex_state = 2},
  [357] = {.lex_state = 10, .external_lex_state = 2},
  [358] = {.lex_state = 10, .external_lex_state = 2},
  [359] = {.lex_state = 11, .external_lex_state = 2},
  [360] = {.lex_state = 11, .external_lex_state = 2},
  [361] = {.lex_state = 11, .external_lex_state = 2},
  [362] = {.lex_state = 11, .external_lex_state = 2},
  [363] = {.lex_state = 8, .external_lex_state = 2},
  [364] = {.lex_state = 8, .external_lex_state = 2},
  [365] = {.lex_state = 8, .external_lex_state = 2},
  [366] = {.lex_state = 11, .external_lex_state = 2},
  [367] = {.lex_state = 8, .external_lex_state = 2},
  [368] = {.lex_state = 8, .external_lex_state = 2},
  [369] = {.lex_state = 11, .external_lex_state = 2},
  [370] = {.lex_state = 11, .external_lex_state = 2},
  [371] = {.lex_state = 11, .external_lex_state = 2},
  [372] = {.lex_state = 11, .external_lex_state = 2},
  [373] = {.lex_state = 11, .external_lex_state = 2},
  [374] = {.lex_state = 11, .external_lex_state = 2},
  [375] = {.lex_state = 11, .external_lex_state = 2},
  [376] = {.lex_state = 11, .external_lex_state = 2},
  [377] = {.lex_state = 8, .external_lex_state = 2},
  [378] = {.lex_state = 11, .external_lex_state = 2},
  [379] = {.lex_state = 1, .external_lex_state = 2},
  [380] = {.lex_state = 11, .external_lex_state = 2},
  [381] = {.lex_state = 11, .external_lex_state = 2},
  [382] = {.lex_state = 8, .external_lex_state = 2},
  [383] = {.lex_state = 8, .external_lex_state = 2},
  [384] = {.lex_state = 11, .external_lex_state = 2},
  [385] = {.lex_state = 8, .external_lex_state = 2},
  [386] = {.lex_state = 8, .external_lex_state = 2},
  [387] = {.lex_state = 8, .external_lex_state = 2},
  [388] = {.lex_state = 11, .external_lex_state = 2},
  [389] = {.lex_state = 11, .external_lex_state = 2},
  [390] = {.lex_state = 11, .external_lex_state = 2},
  [391] = {.lex_state = 11, .external_lex_state = 2},
  [392] = {.lex_state = 11, .external_lex_state = 2},
  [393] = {.lex_state = 11, .external_lex_state = 2},
  [394] = {.lex_state = 11, .external_lex_state = 2},
  [395] = {.lex_state = 11, .external_lex_state = 2},
  [396] = {.lex_state = 8, .external_lex_state = 2},
  [397] = {.lex_state = 11, .external_lex_state = 2},
  [398] = {.lex_state = 11, .external_lex_state = 2},
  [399] = {.lex_state = 11, .external_lex_state = 2},
  [400] = {.lex_state = 11, .external_lex_state = 2},
  [401] = {.lex_state = 11, .external_lex_state = 2},
  [402] = {.lex_state = 11, .external_lex_state = 2},
  [403] = {.lex_state = 8, .external_lex_state = 2},
  [404] = {.lex_state = 11, .external_lex_state = 2},
  [405] = {.lex_state = 8, .external_lex_state = 2},
  [406] = {.lex_state = 11, .external_lex_state = 2},
  [407] = {.lex_state = 11, .external_lex_state = 2},
  [408] = {.lex_state = 11, .external_lex_state = 2},
  [409] = {.lex_state = 11, .external_lex_state = 2},
  [410] = {.lex_state = 9, .external_lex_state = 2},
  [411] = {.lex_state = 9, .external_lex_state = 2},
  [412] = {.lex_state = 9, .external_lex_state = 2},
  [413] = {.lex_state = 9, .external_lex_state = 2},
  [414] = {.lex_state = 9, .external_lex_state = 2},
  [415] = {.lex_state = 9, .external_lex_state = 2},
  [416] = {.lex_state = 9, .external_lex_state = 2},
  [417] = {.lex_state = 9, .external_lex_state = 2},
  [418] = {.lex_state = 9, .external_lex_state = 2},
  [419] = {.lex_state = 9, .external_lex_state = 2},
  [420] = {.lex_state = 9, .external_lex_state = 2},
  [421] = {.lex_state = 8, .external_lex_state = 2},
  [422] = {.lex_state = 8, .external_lex_state = 2},
  [423] = {.lex_state = 8, .external_lex_state = 2},
  [424] = {.lex_state = 8, .external_lex_state = 2},
  [425] = {.lex_state = 8, .external_lex_state = 2},
  [426] = {.lex_state = 8, .external_lex_state = 2},
  [427] = {.lex_state = 11, .external_lex_state = 2},
  [428] = {.lex_state = 11, .external_lex_state = 2},
  [429] = {.lex_state = 8, .external_lex_state = 2},
  [430] = {.lex_state = 8, .external_lex_state = 2},
  [431] = {.lex_state = 8, .external_lex_state = 2},
  [432] = {.lex_state = 8, .external_lex_state = 2},
  [433] = {.lex_state = 8, .external_lex_state = 2},
  [434] = {.lex_state = 2, .external_lex_state = 2},
  [435] = {.lex_state = 8, .external_lex_state = 2},
  [436] = {.lex_state = 8, .external_lex_state = 2},
  [437] = {.lex_state = 8, .external_lex_state = 2},
  [438] = {.lex_state = 8, .external_lex_state = 2},
  [439] = {.lex_state = 8, .external_lex_state = 2},
  [440] = {.lex_state = 8, .external_lex_state = 2},
  [441] = {.lex_state = 8, .external_lex_state = 2},
  [442] = {.lex_state = 8, .external_lex_state = 2},
  [443] = {.lex_state = 8, .external_lex_state = 2},
  [444] = {.lex_state = 8, .external_lex_state = 2},
  [445] = {.lex_state = 8, .external_lex_state = 2},
  [446] = {.lex_state = 8, .external_lex_state = 2},
  [447] = {.lex_state = 8, .external_lex_state = 2},
  [448] = {.lex_state = 11, .external_lex_state = 2},
  [449] = {.lex_state = 11, .external_lex_state = 2},
  [450] = {.lex_state = 11, .external_lex_state = 2},
  [451] = {.lex_state = 11, .external_lex_state = 2},
  [452] = {.lex_state = 11, .external_lex_state = 2},
  [453] = {.lex_state = 11, .external_lex_state = 2},
  [454] = {.lex_state = 11, .external_lex_state = 2},
  [455] = {.lex_state = 11, .external_lex_state = 2},
  [456] = {.lex_state = 11, .external_lex_state = 2},
  [457] = {.lex_state = 11, .external_lex_state = 2},
  [458] = {.lex_state = 12, .external_lex_state = 2},
  [459] = {.lex_state = 1, .external_lex_state = 2},
  [460] = {.lex_state = 1, .external_lex_state = 2},
  [461] = {.lex_state = 1, .external_lex_state = 2},
  [462] = {.lex_state = 1, .external_lex_state = 2},
  [463] = {.lex_state = 1, .external_lex_state = 2},
  [464] = {.lex_state = 1, .external_lex_state = 2},
  [465] = {.lex_state = 1, .external_lex_state = 2},
  [466] = {.lex_state = 1, .external_lex_state = 2},
  [467] = {.lex_state = 9, .external_lex_state = 2},
  [468] = {.lex_state = 1, .external_lex_state = 2},
  [469] = {.lex_state = 1, .external_lex_state = 2},
  [470] = {.lex_state = 1, .external_lex_state = 2},
  [471] = {.lex_state = 9, .external_lex_state = 2},
  [472] = {.lex_state = 1, .external_lex_state = 2},
  [473] = {.lex_state = 1, .external_lex_state = 2},
  [474] = {.lex_state = 1, .external_lex_state = 2},
  [475] = {.lex_state = 1, .external_lex_state = 2},
  [476] = {.lex_state = 1, .external_lex_state = 2},
  [477] = {.lex_state = 1, .external_lex_state = 2},
  [478] = {.lex_state = 1, .external_lex_state = 2},
  [479] = {.lex_state = 1, .external_lex_state = 2},
  [480] = {.lex_state = 1, .external_lex_state = 2},
  [481] = {.lex_state = 1, .external_lex_state = 2},
  [482] = {.lex_state = 9, .external_lex_state = 2},
  [483] = {.lex_state = 1, .external_lex_state = 2},
  [484] = {.lex_state = 1, .external_lex_state = 2},
  [485] = {.lex_state = 9, .external_lex_state = 2},
  [486] = {.lex_state = 1, .external_lex_state = 2},
  [487] = {.lex_state = 1, .external_lex_state = 2},
  [488] = {.lex_state = 9, .external_lex_state = 2},
  [489] = {.lex_state = 9, .external_lex_state = 2},
  [490] = {.lex_state = 9, .external_lex_state = 2},
  [491] = {.lex_state = 9, .external_lex_state = 2},
  [492] = {.lex_state = 9, .external_lex_state = 2},
  [493] = {.lex_state = 9, .external_lex_state = 2},
  [494] = {.lex_state = 9, .external_lex_state = 2},
  [495] = {.lex_state = 9, .external_lex_state = 2},
  [496] = {.lex_state = 9, .external_lex_state = 2},
  [497] = {.lex_state = 9, .external_lex_state = 2},
  [498] = {.lex_state = 9, .external_lex_state = 2},
  [499] = {.lex_state = 9, .external_lex_state = 2},
  [500] = {.lex_state = 9, .external_lex_state = 2},
  [501] = {.lex_state = 9, .external_lex_state = 2},
  [502] = {.lex_state = 9, .external_lex_state = 2},
  [503] = {.lex_state = 69, .external_lex_state = 2},
  [504] = {.lex_state = 69, .external_lex_state = 2},
  [505] = {.lex_state = 69, .external_lex_state = 2},
  [506] = {.lex_state = 69, .external_lex_state = 2},
  [507] = {.lex_state = 69, .external_lex_state = 2},
  [508] = {.lex_state = 69, .external_lex_state = 2},
  [509] = {.lex_state = 69, .external_lex_state = 2},
  [510] = {.lex_state = 69, .external_lex_state = 2},
  [511] = {.lex_state = 69, .external_lex_state = 2},
  [512] = {.lex_state = 7},
  [513] = {.lex_state = 69, .external_lex_state = 2},
  [514] = {.lex_state = 69, .external_lex_state = 2},
  [515] = {.lex_state = 69, .external_lex_state = 2},
  [516] = {.lex_state = 69, .external_lex_state = 2},
  [517] = {.lex_state = 69, .external_lex_state = 2},
  [518] = {.lex_state = 69, .external_lex_state = 2},
  [519] = {.lex_state = 69, .external_lex_state = 2},
  [520] = {.lex_state = 69, .external_lex_state = 2},
  [521] = {.lex_state = 69, .external_lex_state = 2},
  [522] = {.lex_state = 69, .external_lex_state = 2},
  [523] = {.lex_state = 69, .external_lex_state = 2},
  [524] = {.lex_state = 69, .external_lex_state = 2},
  [525] = {.lex_state = 69, .external_lex_state = 2},
  [526] = {.lex_state = 69, .external_lex_state = 2},
  [527] = {.lex_state = 69, .external_lex_state = 2},
  [528] = {.lex_state = 69, .external_lex_state = 2},
  [529] = {.lex_state = 69, .external_lex_state = 2},
  [530] = {.lex_state = 69, .external_lex_state = 2},
  [531] = {.lex_state = 69, .external_lex_state = 2},
  [532] = {.lex_state = 69, .external_lex_state = 2},
  [533] = {.lex_state = 69, .external_lex_state = 2},
  [534] = {.lex_state = 69, .external_lex_state = 2},
  [535] = {.lex_state = 69, .external_lex_state = 2},
  [536] = {.lex_state = 69, .external_lex_state = 2},
  [537] = {.lex_state = 69, .external_lex_state = 2},
  [538] = {.lex_state = 69, .external_lex_state = 2},
  [539] = {.lex_state = 69, .external_lex_state = 2},
  [540] = {.lex_state = 69, .external_lex_state = 2},
  [541] = {.lex_state = 69, .external_lex_state = 2},
  [542] = {.lex_state = 69, .external_lex_state = 2},
  [543] = {.lex_state = 69, .external_lex_state = 2},
  [544] = {.lex_state = 69, .external_lex_state = 2},
  [545] = {.lex_state = 69, .external_lex_state = 2},
  [546] = {.lex_state = 69, .external_lex_state = 2},
  [547] = {.lex_state = 69, .external_lex_state = 2},
  [548] = {.lex_state = 69, .external_lex_state = 2},
  [549] = {.lex_state = 69, .external_lex_state = 2},
  [550] = {.lex_state = 69, .external_lex_state = 2},
  [551] = {.lex_state = 69, .external_lex_state = 2},
  [552] = {.lex_state = 69, .external_lex_state = 2},
  [553] = {.lex_state = 69, .external_lex_state = 2},
  [554] = {.lex_state = 69, .external_lex_state = 2},
  [555] = {.lex_state = 69, .external_lex_state = 2},
  [556] = {.lex_state = 69, .external_lex_state = 2},
  [557] = {.lex_state = 69, .external_lex_state = 2},
  [558] = {.lex_state = 69, .external_lex_state = 2},
  [559] = {.lex_state = 69, .external_lex_state = 2},
  [560] = {.lex_state = 69, .external_lex_state = 2},
  [561] = {.lex_state = 69, .external_lex_state = 2},
  [562] = {.lex_state = 69, .external_lex_state = 2},
  [563] = {.lex_state = 69, .external_lex_state = 2},
  [564] = {.lex_state = 69, .external_lex_state = 2},
  [565] = {.lex_state = 69, .external_lex_state = 2},
  [566] = {.lex_state = 69, .external_lex_state = 2},
  [567] = {.lex_state = 69, .external_lex_state = 2},
  [568] = {.lex_state = 69, .external_lex_state = 2},
  [569] = {.lex_state = 69, .external_lex_state = 2},
  [570] = {.lex_state = 69, .external_lex_state = 2},
  [571] = {.lex_state = 69, .external_lex_state = 2},
  [572] = {.lex_state = 69, .external_lex_state = 2},
  [573] = {.lex_state = 69, .external_lex_state = 2},
  [574] = {.lex_state = 69, .external_lex_state = 2},
  [575] = {.lex_state = 69, .external_lex_state = 2},
  [576] = {.lex_state = 69, .external_lex_state = 2},
  [577] = {.lex_state = 69, .external_lex_state = 2},
  [578] = {.lex_state = 69, .external_lex_state = 2},
  [579] = {.lex_state = 69, .external_lex_state = 2},
  [580] = {.lex_state = 69, .external_lex_state = 2},
  [581] = {.lex_state = 69, .external_lex_state = 2},
  [582] = {.lex_state = 69, .external_lex_state = 2},
  [583] = {.lex_state = 69, .external_lex_state = 2},
  [584] = {.lex_state = 69, .external_lex_state = 2},
  [585] = {.lex_state = 69, .external_lex_state = 2},
  [586] = {.lex_state = 69, .external_lex_state = 2},
  [587] = {.lex_state = 69, .external_lex_state = 2},
  [588] = {.lex_state = 69, .external_lex_state = 2},
  [589] = {.lex_state = 69, .external_lex_state = 2},
  [590] = {.lex_state = 7},
  [591] = {.lex_state = 69, .external_lex_state = 2},
  [592] = {.lex_state = 69, .external_lex_state = 2},
  [593] = {.lex_state = 69, .external_lex_state = 2},
  [594] = {.lex_state = 69, .external_lex_state = 2},
  [595] = {.lex_state = 69, .external_lex_state = 2},
  [596] = {.lex_state = 69, .external_lex_state = 2},
  [597] = {.lex_state = 69, .external_lex_state = 2},
  [598] = {.lex_state = 69, .external_lex_state = 2},
  [599] = {.lex_state = 69, .external_lex_state = 2},
  [600] = {.lex_state = 69, .external_lex_state = 2},
  [601] = {.lex_state = 69, .external_lex_state = 2},
  [602] = {.lex_state = 69, .external_lex_state = 2},
  [603] = {.lex_state = 69, .external_lex_state = 2},
  [604] = {.lex_state = 7},
  [605] = {.lex_state = 69, .external_lex_state = 2},
  [606] = {.lex_state = 69, .external_lex_state = 2},
  [607] = {.lex_state = 69, .external_lex_state = 2},
  [608] = {.lex_state = 69, .external_lex_state = 2},
  [609] = {.lex_state = 69, .external_lex_state = 2},
  [610] = {.lex_state = 69, .external_lex_state = 2},
  [611] = {.lex_state = 69, .external_lex_state = 2},
  [612] = {.lex_state = 69, .external_lex_state = 2},
  [613] = {.lex_state = 69, .external_lex_state = 2},
  [614] = {.lex_state = 69, .external_lex_state = 2},
  [615] = {.lex_state = 69, .external_lex_state = 2},
  [616] = {.lex_state = 69, .external_lex_state = 2},
  [617] = {.lex_state = 69, .external_lex_state = 2},
  [618] = {.lex_state = 69, .external_lex_state = 2},
  [619] = {.lex_state = 69, .external_lex_state = 2},
  [620] = {.lex_state = 69, .external_lex_state = 2},
  [621] = {.lex_state = 69, .external_lex_state = 2},
  [622] = {.lex_state = 69, .external_lex_state = 2},
  [623] = {.lex_state = 69, .external_lex_state = 2},
  [624] = {.lex_state = 69, .external_lex_state = 2},
  [625] = {.lex_state = 69, .external_lex_state = 2},
  [626] = {.lex_state = 69, .external_lex_state = 2},
  [627] = {.lex_state = 69, .external_lex_state = 2},
  [628] = {.lex_state = 69, .external_lex_state = 2},
  [629] = {.lex_state = 69, .external_lex_state = 2},
  [630] = {.lex_state = 69, .external_lex_state = 2},
  [631] = {.lex_state = 69, .external_lex_state = 2},
  [632] = {.lex_state = 69, .external_lex_state = 2},
  [633] = {.lex_state = 69, .external_lex_state = 2},
  [634] = {.lex_state = 69, .external_lex_state = 2},
  [635] = {.lex_state = 69, .external_lex_state = 2},
  [636] = {.lex_state = 69, .external_lex_state = 2},
  [637] = {.lex_state = 69, .external_lex_state = 2},
  [638] = {.lex_state = 69, .external_lex_state = 2},
  [639] = {.lex_state = 69, .external_lex_state = 2},
  [640] = {.lex_state = 69, .external_lex_state = 2},
  [641] = {.lex_state = 69, .external_lex_state = 2},
  [642] = {.lex_state = 69, .external_lex_state = 2},
  [643] = {.lex_state = 69, .external_lex_state = 2},
  [644] = {.lex_state = 69, .external_lex_state = 2},
  [645] = {.lex_state = 69, .external_lex_state = 2},
  [646] = {.lex_state = 69, .external_lex_state = 2},
  [647] = {.lex_state = 69, .external_lex_state = 2},
  [648] = {.lex_state = 69, .external_lex_state = 2},
  [649] = {.lex_state = 69, .external_lex_state = 2},
  [650] = {.lex_state = 69, .external_lex_state = 2},
  [651] = {.lex_state = 69, .external_lex_state = 2},
  [652] = {.lex_state = 69, .external_lex_state = 2},
  [653] = {.lex_state = 69, .external_lex_state = 2},
  [654] = {.lex_state = 69, .external_lex_state = 2},
  [655] = {.lex_state = 69, .external_lex_state = 2},
  [656] = {.lex_state = 69, .external_lex_state = 2},
  [657] = {.lex_state = 69, .external_lex_state = 2},
  [658] = {.lex_state = 69, .external_lex_state = 2},
  [659] = {.lex_state = 69, .external_lex_state = 2},
  [660] = {.lex_state = 69, .external_lex_state = 2},
  [661] = {.lex_state = 69, .external_lex_state = 2},
  [662] = {.lex_state = 69, .external_lex_state = 2},
  [663] = {.lex_state = 69, .external_lex_state = 2},
  [664] = {.lex_state = 69, .external_lex_state = 2},
  [665] = {.lex_state = 69, .external_lex_state = 2},
  [666] = {.lex_state = 69, .external_lex_state = 2},
  [667] = {.lex_state = 69, .external_lex_state = 2},
  [668] = {.lex_state = 69, .external_lex_state = 2},
  [669] = {.lex_state = 69, .external_lex_state = 2},
  [670] = {.lex_state = 69, .external_lex_state = 2},
  [671] = {.lex_state = 69, .external_lex_state = 2},
  [672] = {.lex_state = 69, .external_lex_state = 2},
  [673] = {.lex_state = 69, .external_lex_state = 2},
  [674] = {.lex_state = 69, .external_lex_state = 2},
  [675] = {.lex_state = 69, .external_lex_state = 2},
  [676] = {.lex_state = 69, .external_lex_state = 2},
  [677] = {.lex_state = 69, .external_lex_state = 2},
  [678] = {.lex_state = 69, .external_lex_state = 2},
  [679] = {.lex_state = 69, .external_lex_state = 2},
  [680] = {.lex_state = 69, .external_lex_state = 2},
  [681] = {.lex_state = 69, .external_lex_state = 2},
  [682] = {.lex_state = 69, .external_lex_state = 2},
  [683] = {.lex_state = 7},
  [684] = {.lex_state = 69, .external_lex_state = 2},
  [685] = {.lex_state = 69, .external_lex_state = 2},
  [686] = {.lex_state = 7},
  [687] = {.lex_state = 69, .external_lex_state = 2},
  [688] = {.lex_state = 69, .external_lex_state = 2},
  [689] = {.lex_state = 69, .external_lex_state = 2},
  [690] = {.lex_state = 69, .external_lex_state = 2},
  [691] = {.lex_state = 69, .external_lex_state = 2},
  [692] = {.lex_state = 69, .external_lex_state = 2},
  [693] = {.lex_state = 69, .external_lex_state = 2},
  [694] = {.lex_state = 69, .external_lex_state = 2},
  [695] = {.lex_state = 69, .external_lex_state = 2},
  [696] = {.lex_state = 69, .external_lex_state = 2},
  [697] = {.lex_state = 69, .external_lex_state = 2},
  [698] = {.lex_state = 69, .external_lex_state = 2},
  [699] = {.lex_state = 69, .external_lex_state = 2},
  [700] = {.lex_state = 69, .external_lex_state = 2},
  [701] = {.lex_state = 69, .external_lex_state = 2},
  [702] = {.lex_state = 69, .external_lex_state = 2},
  [703] = {.lex_state = 69, .external_lex_state = 2},
  [704] = {.lex_state = 69, .external_lex_state = 2},
  [705] = {.lex_state = 69, .external_lex_state = 2},
  [706] = {.lex_state = 69, .external_lex_state = 2},
  [707] = {.lex_state = 69, .external_lex_state = 2},
  [708] = {.lex_state = 69, .external_lex_state = 2},
  [709] = {.lex_state = 69, .external_lex_state = 2},
  [710] = {.lex_state = 69, .external_lex_state = 2},
  [711] = {.lex_state = 69, .external_lex_state = 2},
  [712] = {.lex_state = 69, .external_lex_state = 2},
  [713] = {.lex_state = 69, .external_lex_state = 2},
  [714] = {.lex_state = 69, .external_lex_state = 2},
  [715] = {.lex_state = 69, .external_lex_state = 2},
  [716] = {.lex_state = 69, .external_lex_state = 2},
  [717] = {.lex_state = 69, .external_lex_state = 2},
  [718] = {.lex_state = 69, .external_lex_state = 2},
  [719] = {.lex_state = 69, .external_lex_state = 2},
  [720] = {.lex_state = 69, .external_lex_state = 2},
  [721] = {.lex_state = 69, .external_lex_state = 2},
  [722] = {.lex_state = 69, .external_lex_state = 2},
  [723] = {.lex_state = 69, .external_lex_state = 2},
  [724] = {.lex_state = 69, .external_lex_state = 2},
  [725] = {.lex_state = 69, .external_lex_state = 2},
  [726] = {.lex_state = 69, .external_lex_state = 2},
  [727] = {.lex_state = 69, .external_lex_state = 2},
  [728] = {.lex_state = 69, .external_lex_state = 2},
  [729] = {.lex_state = 69, .external_lex_state = 2},
  [730] = {.lex_state = 69, .external_lex_state = 2},
  [731] = {.lex_state = 69, .external_lex_state = 2},
  [732] = {.lex_state = 69, .external_lex_state = 2},
  [733] = {.lex_state = 69, .external_lex_state = 2},
  [734] = {.lex_state = 69, .external_lex_state = 2},
  [735] = {.lex_state = 69, .external_lex_state = 2},
  [736] = {.lex_state = 69, .external_lex_state = 2},
  [737] = {.lex_state = 69, .external_lex_state = 2},
  [738] = {.lex_state = 69, .external_lex_state = 2},
  [739] = {.lex_state = 69, .external_lex_state = 2},
  [740] = {.lex_state = 69, .external_lex_state = 2},
  [741] = {.lex_state = 69, .external_lex_state = 2},
  [742] = {.lex_state = 69, .external_lex_state = 2},
  [743] = {.lex_state = 69, .external_lex_state = 2},
  [744] = {.lex_state = 69, .external_lex_state = 2},
  [745] = {.lex_state = 69, .external_lex_state = 2},
  [746] = {.lex_state = 69, .external_lex_state = 2},
  [747] = {.lex_state = 69, .external_lex_state = 2},
  [748] = {.lex_state = 69, .external_lex_state = 2},
  [749] = {.lex_state = 69, .external_lex_state = 2},
  [750] = {.lex_state = 69, .external_lex_state = 2},
  [751] = {.lex_state = 69, .external_lex_state = 2},
  [752] = {.lex_state = 69, .external_lex_state = 2},
  [753] = {.lex_state = 69, .external_lex_state = 2},
  [754] = {.lex_state = 69, .external_lex_state = 2},
  [755] = {.lex_state = 69, .external_lex_state = 2},
  [756] = {.lex_state = 9, .external_lex_state = 2},
  [757] = {.lex_state = 69, .external_lex_state = 2},
  [758] = {.lex_state = 69, .external_lex_state = 2},
  [759] = {.lex_state = 69, .external_lex_state = 2},
  [760] = {.lex_state = 69, .external_lex_state = 2},
  [761] = {.lex_state = 69, .external_lex_state = 2},
  [762] = {.lex_state = 69, .external_lex_state = 2},
  [763] = {.lex_state = 69, .external_lex_state = 2},
  [764] = {.lex_state = 69, .external_lex_state = 2},
  [765] = {.lex_state = 9, .external_lex_state = 2},
  [766] = {.lex_state = 69, .external_lex_state = 2},
  [767] = {.lex_state = 69, .external_lex_state = 2},
  [768] = {.lex_state = 69, .external_lex_state = 2},
  [769] = {.lex_state = 69, .external_lex_state = 2},
  [770] = {.lex_state = 69, .external_lex_state = 2},
  [771] = {.lex_state = 69, .external_lex_state = 2},
  [772] = {.lex_state = 69, .external_lex_state = 2},
  [773] = {.lex_state = 69, .external_lex_state = 2},
  [774] = {.lex_state = 69, .external_lex_state = 2},
  [775] = {.lex_state = 9, .external_lex_state = 2},
  [776] = {.lex_state = 9, .external_lex_state = 2},
  [777] = {.lex_state = 9, .external_lex_state = 2},
  [778] = {.lex_state = 9, .external_lex_state = 2},
  [779] = {.lex_state = 9, .external_lex_state = 2},
  [780] = {.lex_state = 9, .external_lex_state = 2},
  [781] = {.lex_state = 9, .external_lex_state = 2},
  [782] = {.lex_state = 13},
  [783] = {.lex_state = 13},
  [784] = {.lex_state = 13},
  [785] = {.lex_state = 13},
  [786] = {.lex_state = 13},
  [787] = {.lex_state = 13},
  [788] = {.lex_state = 13},
  [789] = {.lex_state = 13},
  [790] = {.lex_state = 9, .external_lex_state = 2},
  [791] = {.lex_state = 9, .external_lex_state = 2},
  [792] = {.lex_state = 9, .external_lex_state = 2},
  [793] = {.lex_state = 9, .external_lex_state = 2},
  [794] = {.lex_state = 13},
  [795] = {.lex_state = 9, .external_lex_state = 2},
  [796] = {.lex_state = 13},
  [797] = {.lex_state = 9, .external_lex_state = 2},
  [798] = {.lex_state = 9, .external_lex_state = 2},
  [799] = {.lex_state = 9, .external_lex_state = 2},
  [800] = {.lex_state = 13},
  [801] = {.lex_state = 9, .external_lex_state = 2},
  [802] = {.lex_state = 9, .external_lex_state = 2},
  [803] = {.lex_state = 9, .external_lex_state = 2},
  [804] = {.lex_state = 9, .external_lex_state = 2},
  [805] = {.lex_state = 9, .external_lex_state = 2},
  [806] = {.lex_state = 9, .external_lex_state = 2},
  [807] = {.lex_state = 9, .external_lex_state = 2},
  [808] = {.lex_state = 9, .external_lex_state = 2},
  [809] = {.lex_state = 9, .external_lex_state = 2},
  [810] = {.lex_state = 9, .external_lex_state = 2},
  [811] = {.lex_state = 9, .external_lex_state = 2},
  [812] = {.lex_state = 9, .external_lex_state = 2},
  [813] = {.lex_state = 9, .external_lex_state = 2},
  [814] = {.lex_state = 9, .external_lex_state = 2},
  [815] = {.lex_state = 13},
  [816] = {.lex_state = 9, .external_lex_state = 2},
  [817] = {.lex_state = 13},
  [818] = {.lex_state = 9, .external_lex_state = 2},
  [819] = {.lex_state = 9, .external_lex_state = 2},
  [820] = {.lex_state = 13},
  [821] = {.lex_state = 9, .external_lex_state = 2},
  [822] = {.lex_state = 13},
  [823] = {.lex_state = 9, .external_lex_state = 2},
  [824] = {.lex_state = 9, .external_lex_state = 2},
  [825] = {.lex_state = 9, .external_lex_state = 2},
  [826] = {.lex_state = 9, .external_lex_state = 2},
  [827] = {.lex_state = 9, .external_lex_state = 2},
  [828] = {.lex_state = 9, .external_lex_state = 2},
  [829] = {.lex_state = 9, .external_lex_state = 2},
  [830] = {.lex_state = 9, .external_lex_state = 2},
  [831] = {.lex_state = 9, .external_lex_state = 2},
  [832] = {.lex_state = 9, .external_lex_state = 2},
  [833] = {.lex_state = 9, .external_lex_state = 2},
  [834] = {.lex_state = 9, .external_lex_state = 2},
  [835] = {.lex_state = 9, .external_lex_state = 2},
  [836] = {.lex_state = 9, .external_lex_state = 2},
  [837] = {.lex_state = 9, .external_lex_state = 2},
  [838] = {.lex_state = 9, .external_lex_state = 2},
  [839] = {.lex_state = 9, .external_lex_state = 2},
  [840] = {.lex_state = 9, .external_lex_state = 2},
  [841] = {.lex_state = 9, .external_lex_state = 2},
  [842] = {.lex_state = 9, .external_lex_state = 2},
  [843] = {.lex_state = 9, .external_lex_state = 2},
  [844] = {.lex_state = 13},
  [845] = {.lex_state = 9, .external_lex_state = 2},
  [846] = {.lex_state = 9, .external_lex_state = 2},
  [847] = {.lex_state = 13},
  [848] = {.lex_state = 13},
  [849] = {.lex_state = 13},
  [850] = {.lex_state = 13},
  [851] = {.lex_state = 13},
  [852] = {.lex_state = 13},
  [853] = {.lex_state = 13},
  [854] = {.lex_state = 13},
  [855] = {.lex_state = 13},
  [856] = {.lex_state = 13},
  [857] = {.lex_state = 13},
  [858] = {.lex_state = 13},
  [859] = {.lex_state = 13},
  [860] = {.lex_state = 13},
  [861] = {.lex_state = 13},
  [862] = {.lex_state = 13},
  [863] = {.lex_state = 13},
  [864] = {.lex_state = 13},
  [865] = {.lex_state = 13},
  [866] = {.lex_state = 13},
  [867] = {.lex_state = 13},
  [868] = {.lex_state = 13},
  [869] = {.lex_state = 13},
  [870] = {.lex_state = 13},
  [871] = {.lex_state = 13},
  [872] = {.lex_state = 13},
  [873] = {.lex_state = 13},
  [874] = {.lex_state = 13},
  [875] = {.lex_state = 13},
  [876] = {.lex_state = 13},
  [877] = {.lex_state = 13},
  [878] = {.lex_state = 13},
  [879] = {.lex_state = 13},
  [880] = {.lex_state = 13},
  [881] = {.lex_state = 13},
  [882] = {.lex_state = 13},
  [883] = {.lex_state = 13},
  [884] = {.lex_state = 13},
  [885] = {.lex_state = 13},
  [886] = {.lex_state = 13},
  [887] = {.lex_state = 13},
  [888] = {.lex_state = 13},
  [889] = {.lex_state = 13},
  [890] = {.lex_state = 13},
  [891] = {.lex_state = 13},
  [892] = {.lex_state = 13},
  [893] = {.lex_state = 13},
  [894] = {.lex_state = 13},
  [895] = {.lex_state = 13},
  [896] = {.lex_state = 13},
  [897] = {.lex_state = 13},
  [898] = {.lex_state = 13},
  [899] = {.lex_state = 13},
  [900] = {.lex_state = 13},
  [901] = {.lex_state = 13},
  [902] = {.lex_state = 13},
  [903] = {.lex_state = 13},
  [904] = {.lex_state = 13},
  [905] = {.lex_state = 13},
  [906] = {.lex_state = 13},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 13},
  [911] = {.lex_state = 13},
  [912] = {.lex_state = 13},
  [913] = {.lex_state = 13},
  [914] = {.lex_state = 13},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 13},
  [917] = {.lex_state = 13},
  [918] = {.lex_state = 13},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 13},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 13},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 13},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 13},
  [927] = {.lex_state = 13},
  [928] = {.lex_state = 13},
  [929] = {.lex_state = 13},
  [930] = {.lex_state = 13},
  [931] = {.lex_state = 13},
  [932] = {.lex_state = 13},
  [933] = {.lex_state = 13},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 13},
  [937] = {.lex_state = 13},
  [938] = {.lex_state = 13},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 13},
  [942] = {.lex_state = 13},
  [943] = {.lex_state = 13},
  [944] = {.lex_state = 13},
  [945] = {.lex_state = 13},
  [946] = {.lex_state = 13},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 13},
  [949] = {.lex_state = 13},
  [950] = {.lex_state = 13},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 13},
  [954] = {.lex_state = 13},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 13},
  [957] = {.lex_state = 13},
  [958] = {.lex_state = 13},
  [959] = {.lex_state = 13},
  [960] = {.lex_state = 13},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 13},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 13},
  [965] = {.lex_state = 13},
  [966] = {.lex_state = 13},
  [967] = {.lex_state = 13},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 13},
  [970] = {.lex_state = 13},
  [971] = {.lex_state = 13},
  [972] = {.lex_state = 13},
  [973] = {.lex_state = 13},
  [974] = {.lex_state = 13},
  [975] = {.lex_state = 13},
  [976] = {.lex_state = 13},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 13},
  [979] = {.lex_state = 13},
  [980] = {.lex_state = 13},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 13},
  [983] = {.lex_state = 13},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 13},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 13},
  [990] = {.lex_state = 13},
  [991] = {.lex_state = 13},
  [992] = {.lex_state = 13},
  [993] = {.lex_state = 13},
  [994] = {.lex_state = 13},
  [995] = {.lex_state = 13},
  [996] = {.lex_state = 13},
  [997] = {.lex_state = 13},
  [998] = {.lex_state = 13},
  [999] = {.lex_state = 13},
  [1000] = {.lex_state = 13},
  [1001] = {.lex_state = 13},
  [1002] = {.lex_state = 13},
  [1003] = {.lex_state = 13},
  [1004] = {.lex_state = 13},
  [1005] = {.lex_state = 13},
  [1006] = {.lex_state = 12, .external_lex_state = 2},
  [1007] = {.lex_state = 12, .external_lex_state = 2},
  [1008] = {.lex_state = 12, .external_lex_state = 2},
  [1009] = {.lex_state = 9, .external_lex_state = 2},
  [1010] = {.lex_state = 10, .external_lex_state = 2},
  [1011] = {.lex_state = 13},
  [1012] = {.lex_state = 3},
  [1013] = {.lex_state = 3},
  [1014] = {.lex_state = 3},
  [1015] = {.lex_state = 3},
  [1016] = {.lex_state = 7},
  [1017] = {.lex_state = 3},
  [1018] = {.lex_state = 3},
  [1019] = {.lex_state = 3},
  [1020] = {.lex_state = 3},
  [1021] = {.lex_state = 7},
  [1022] = {.lex_state = 7},
  [1023] = {.lex_state = 7},
  [1024] = {.lex_state = 7},
  [1025] = {.lex_state = 7},
  [1026] = {.lex_state = 7},
  [1027] = {.lex_state = 3},
  [1028] = {.lex_state = 3},
  [1029] = {.lex_state = 7},
  [1030] = {.lex_state = 3},
  [1031] = {.lex_state = 7},
  [1032] = {.lex_state = 3},
  [1033] = {.lex_state = 21},
  [1034] = {.lex_state = 4},
  [1035] = {.lex_state = 21},
  [1036] = {.lex_state = 9, .external_lex_state = 2},
  [1037] = {.lex_state = 21},
  [1038] = {.lex_state = 9, .external_lex_state = 2},
  [1039] = {.lex_state = 4},
  [1040] = {.lex_state = 4},
  [1041] = {.lex_state = 21},
  [1042] = {.lex_state = 21},
  [1043] = {.lex_state = 4},
  [1044] = {.lex_state = 4},
  [1045] = {.lex_state = 4},
  [1046] = {.lex_state = 4},
  [1047] = {.lex_state = 17},
  [1048] = {.lex_state = 4},
  [1049] = {.lex_state = 9, .external_lex_state = 2},
  [1050] = {.lex_state = 4},
  [1051] = {.lex_state = 4},
  [1052] = {.lex_state = 4},
  [1053] = {.lex_state = 9, .external_lex_state = 2},
  [1054] = {.lex_state = 4},
  [1055] = {.lex_state = 4},
  [1056] = {.lex_state = 4},
  [1057] = {.lex_state = 4},
  [1058] = {.lex_state = 4},
  [1059] = {.lex_state = 9, .external_lex_state = 2},
  [1060] = {.lex_state = 4},
  [1061] = {.lex_state = 4},
  [1062] = {.lex_state = 18},
  [1063] = {.lex_state = 4},
  [1064] = {.lex_state = 17},
  [1065] = {.lex_state = 4},
  [1066] = {.lex_state = 17},
  [1067] = {.lex_state = 4},
  [1068] = {.lex_state = 17},
  [1069] = {.lex_state = 4},
  [1070] = {.lex_state = 17},
  [1071] = {.lex_state = 4},
  [1072] = {.lex_state = 4},
  [1073] = {.lex_state = 17},
  [1074] = {.lex_state = 13},
  [1075] = {.lex_state = 17},
  [1076] = {.lex_state = 17},
  [1077] = {.lex_state = 4},
  [1078] = {.lex_state = 17},
  [1079] = {.lex_state = 17},
  [1080] = {.lex_state = 3},
  [1081] = {.lex_state = 4},
  [1082] = {.lex_state = 18},
  [1083] = {.lex_state = 17},
  [1084] = {.lex_state = 4},
  [1085] = {.lex_state = 13},
  [1086] = {.lex_state = 4},
  [1087] = {.lex_state = 17},
  [1088] = {.lex_state = 7},
  [1089] = {.lex_state = 4},
  [1090] = {.lex_state = 4},
  [1091] = {.lex_state = 7},
  [1092] = {.lex_state = 4},
  [1093] = {.lex_state = 4},
  [1094] = {.lex_state = 7},
  [1095] = {.lex_state = 7},
  [1096] = {.lex_state = 4},
  [1097] = {.lex_state = 7},
  [1098] = {.lex_state = 4},
  [1099] = {.lex_state = 7},
  [1100] = {.lex_state = 4},
  [1101] = {.lex_state = 7},
  [1102] = {.lex_state = 7},
  [1103] = {.lex_state = 7},
  [1104] = {.lex_state = 7},
  [1105] = {.lex_state = 4},
  [1106] = {.lex_state = 4},
  [1107] = {.lex_state = 7},
  [1108] = {.lex_state = 4},
  [1109] = {.lex_state = 7},
  [1110] = {.lex_state = 7},
  [1111] = {.lex_state = 7},
  [1112] = {.lex_state = 4},
  [1113] = {.lex_state = 7},
  [1114] = {.lex_state = 4},
  [1115] = {.lex_state = 7},
  [1116] = {.lex_state = 7},
  [1117] = {.lex_state = 7},
  [1118] = {.lex_state = 4},
  [1119] = {.lex_state = 4},
  [1120] = {.lex_state = 7},
  [1121] = {.lex_state = 7},
  [1122] = {.lex_state = 7},
  [1123] = {.lex_state = 4},
  [1124] = {.lex_state = 7},
  [1125] = {.lex_state = 7},
  [1126] = {.lex_state = 7},
  [1127] = {.lex_state = 7},
  [1128] = {.lex_state = 4},
  [1129] = {.lex_state = 7},
  [1130] = {.lex_state = 7},
  [1131] = {.lex_state = 7},
  [1132] = {.lex_state = 7},
  [1133] = {.lex_state = 7},
  [1134] = {.lex_state = 7},
  [1135] = {.lex_state = 7},
  [1136] = {.lex_state = 4},
  [1137] = {.lex_state = 7},
  [1138] = {.lex_state = 7},
  [1139] = {.lex_state = 7},
  [1140] = {.lex_state = 7},
  [1141] = {.lex_state = 7},
  [1142] = {.lex_state = 7},
  [1143] = {.lex_state = 7},
  [1144] = {.lex_state = 4},
  [1145] = {.lex_state = 7},
  [1146] = {.lex_state = 7},
  [1147] = {.lex_state = 7},
  [1148] = {.lex_state = 4},
  [1149] = {.lex_state = 7},
  [1150] = {.lex_state = 4},
  [1151] = {.lex_state = 7},
  [1152] = {.lex_state = 7},
  [1153] = {.lex_state = 4},
  [1154] = {.lex_state = 7},
  [1155] = {.lex_state = 4},
  [1156] = {.lex_state = 7},
  [1157] = {.lex_state = 7},
  [1158] = {.lex_state = 7},
  [1159] = {.lex_state = 7},
  [1160] = {.lex_state = 7},
  [1161] = {.lex_state = 7},
  [1162] = {.lex_state = 4},
  [1163] = {.lex_state = 4},
  [1164] = {.lex_state = 7},
  [1165] = {.lex_state = 7},
  [1166] = {.lex_state = 7},
  [1167] = {.lex_state = 7},
  [1168] = {.lex_state = 4},
  [1169] = {.lex_state = 7},
  [1170] = {.lex_state = 7},
  [1171] = {.lex_state = 7},
  [1172] = {.lex_state = 7},
  [1173] = {.lex_state = 7},
  [1174] = {.lex_state = 4},
  [1175] = {.lex_state = 4},
  [1176] = {.lex_state = 7},
  [1177] = {.lex_state = 4},
  [1178] = {.lex_state = 4},
  [1179] = {.lex_state = 7},
  [1180] = {.lex_state = 7},
  [1181] = {.lex_state = 7},
  [1182] = {.lex_state = 7},
  [1183] = {.lex_state = 7},
  [1184] = {.lex_state = 7},
  [1185] = {.lex_state = 7},
  [1186] = {.lex_state = 7},
  [1187] = {.lex_state = 7},
  [1188] = {.lex_state = 7},
  [1189] = {.lex_state = 7},
  [1190] = {.lex_state = 7},
  [1191] = {.lex_state = 4},
  [1192] = {.lex_state = 7},
  [1193] = {.lex_state = 7},
  [1194] = {.lex_state = 4},
  [1195] = {.lex_state = 7},
  [1196] = {.lex_state = 7},
  [1197] = {.lex_state = 4},
  [1198] = {.lex_state = 7},
  [1199] = {.lex_state = 7},
  [1200] = {.lex_state = 7},
  [1201] = {.lex_state = 7},
  [1202] = {.lex_state = 7},
  [1203] = {.lex_state = 7},
  [1204] = {.lex_state = 7},
  [1205] = {.lex_state = 7},
  [1206] = {.lex_state = 7},
  [1207] = {.lex_state = 7},
  [1208] = {.lex_state = 7},
  [1209] = {.lex_state = 7},
  [1210] = {.lex_state = 7},
  [1211] = {.lex_state = 4},
  [1212] = {.lex_state = 4},
  [1213] = {.lex_state = 7},
  [1214] = {.lex_state = 7},
  [1215] = {.lex_state = 7},
  [1216] = {.lex_state = 7},
  [1217] = {.lex_state = 7},
  [1218] = {.lex_state = 7},
  [1219] = {.lex_state = 7},
  [1220] = {.lex_state = 7},
  [1221] = {.lex_state = 4},
  [1222] = {.lex_state = 7},
  [1223] = {.lex_state = 4},
  [1224] = {.lex_state = 7},
  [1225] = {.lex_state = 7},
  [1226] = {.lex_state = 7},
  [1227] = {.lex_state = 7},
  [1228] = {.lex_state = 7},
  [1229] = {.lex_state = 7},
  [1230] = {.lex_state = 4},
  [1231] = {.lex_state = 4},
  [1232] = {.lex_state = 4},
  [1233] = {.lex_state = 7},
  [1234] = {.lex_state = 7},
  [1235] = {.lex_state = 7},
  [1236] = {.lex_state = 7},
  [1237] = {.lex_state = 7},
  [1238] = {.lex_state = 4},
  [1239] = {.lex_state = 4},
  [1240] = {.lex_state = 7},
  [1241] = {.lex_state = 7},
  [1242] = {.lex_state = 7},
  [1243] = {.lex_state = 7},
  [1244] = {.lex_state = 4},
  [1245] = {.lex_state = 7},
  [1246] = {.lex_state = 7},
  [1247] = {.lex_state = 4},
  [1248] = {.lex_state = 4},
  [1249] = {.lex_state = 7},
  [1250] = {.lex_state = 4},
  [1251] = {.lex_state = 4},
  [1252] = {.lex_state = 4},
  [1253] = {.lex_state = 4},
  [1254] = {.lex_state = 7},
  [1255] = {.lex_state = 4},
  [1256] = {.lex_state = 4},
  [1257] = {.lex_state = 7},
  [1258] = {.lex_state = 4},
  [1259] = {.lex_state = 4},
  [1260] = {.lex_state = 4},
  [1261] = {.lex_state = 7},
  [1262] = {.lex_state = 4},
  [1263] = {.lex_state = 7},
  [1264] = {.lex_state = 7},
  [1265] = {.lex_state = 4},
  [1266] = {.lex_state = 7},
  [1267] = {.lex_state = 7},
  [1268] = {.lex_state = 7},
  [1269] = {.lex_state = 7},
  [1270] = {.lex_state = 7},
  [1271] = {.lex_state = 7},
  [1272] = {.lex_state = 4},
  [1273] = {.lex_state = 7},
  [1274] = {.lex_state = 7},
  [1275] = {.lex_state = 7},
  [1276] = {.lex_state = 4},
  [1277] = {.lex_state = 7},
  [1278] = {.lex_state = 7},
  [1279] = {.lex_state = 4},
  [1280] = {.lex_state = 7},
  [1281] = {.lex_state = 7},
  [1282] = {.lex_state = 7},
  [1283] = {.lex_state = 7},
  [1284] = {.lex_state = 7},
  [1285] = {.lex_state = 7},
  [1286] = {.lex_state = 4},
  [1287] = {.lex_state = 4},
  [1288] = {.lex_state = 7},
  [1289] = {.lex_state = 7},
  [1290] = {.lex_state = 4},
  [1291] = {.lex_state = 7},
  [1292] = {.lex_state = 4},
  [1293] = {.lex_state = 4},
  [1294] = {.lex_state = 7},
  [1295] = {.lex_state = 7},
  [1296] = {.lex_state = 7},
  [1297] = {.lex_state = 7},
  [1298] = {.lex_state = 4},
  [1299] = {.lex_state = 7},
  [1300] = {.lex_state = 7},
  [1301] = {.lex_state = 4},
  [1302] = {.lex_state = 7},
  [1303] = {.lex_state = 7},
  [1304] = {.lex_state = 7},
  [1305] = {.lex_state = 7},
  [1306] = {.lex_state = 4},
  [1307] = {.lex_state = 4},
  [1308] = {.lex_state = 7},
  [1309] = {.lex_state = 4},
  [1310] = {.lex_state = 7},
  [1311] = {.lex_state = 4},
  [1312] = {.lex_state = 7},
  [1313] = {.lex_state = 7},
  [1314] = {.lex_state = 7},
  [1315] = {.lex_state = 7},
  [1316] = {.lex_state = 7},
  [1317] = {.lex_state = 4},
  [1318] = {.lex_state = 7},
  [1319] = {.lex_state = 7},
  [1320] = {.lex_state = 7},
  [1321] = {.lex_state = 7},
  [1322] = {.lex_state = 4},
  [1323] = {.lex_state = 7},
  [1324] = {.lex_state = 7},
  [1325] = {.lex_state = 7},
  [1326] = {.lex_state = 4},
  [1327] = {.lex_state = 4},
  [1328] = {.lex_state = 7},
  [1329] = {.lex_state = 7},
  [1330] = {.lex_state = 7},
  [1331] = {.lex_state = 7},
  [1332] = {.lex_state = 7},
  [1333] = {.lex_state = 7},
  [1334] = {.lex_state = 7},
  [1335] = {.lex_state = 7},
  [1336] = {.lex_state = 4},
  [1337] = {.lex_state = 7},
  [1338] = {.lex_state = 7},
  [1339] = {.lex_state = 7},
  [1340] = {.lex_state = 7},
  [1341] = {.lex_state = 7},
  [1342] = {.lex_state = 4},
  [1343] = {.lex_state = 7},
  [1344] = {.lex_state = 7},
  [1345] = {.lex_state = 4},
  [1346] = {.lex_state = 7},
  [1347] = {.lex_state = 7},
  [1348] = {.lex_state = 7},
  [1349] = {.lex_state = 4},
  [1350] = {.lex_state = 7},
  [1351] = {.lex_state = 7},
  [1352] = {.lex_state = 7},
  [1353] = {.lex_state = 7},
  [1354] = {.lex_state = 7},
  [1355] = {.lex_state = 7},
  [1356] = {.lex_state = 7},
  [1357] = {.lex_state = 7},
  [1358] = {.lex_state = 4},
  [1359] = {.lex_state = 7},
  [1360] = {.lex_state = 4},
  [1361] = {.lex_state = 7},
  [1362] = {.lex_state = 7},
  [1363] = {.lex_state = 7},
  [1364] = {.lex_state = 7},
  [1365] = {.lex_state = 7},
  [1366] = {.lex_state = 7},
  [1367] = {.lex_state = 7},
  [1368] = {.lex_state = 4},
  [1369] = {.lex_state = 7},
  [1370] = {.lex_state = 7},
  [1371] = {.lex_state = 7},
  [1372] = {.lex_state = 7},
  [1373] = {.lex_state = 7},
  [1374] = {.lex_state = 7},
  [1375] = {.lex_state = 7},
  [1376] = {.lex_state = 4},
  [1377] = {.lex_state = 7},
  [1378] = {.lex_state = 4},
  [1379] = {.lex_state = 7},
  [1380] = {.lex_state = 7},
  [1381] = {.lex_state = 7},
  [1382] = {.lex_state = 4},
  [1383] = {.lex_state = 4},
  [1384] = {.lex_state = 4},
  [1385] = {.lex_state = 7},
  [1386] = {.lex_state = 7},
  [1387] = {.lex_state = 7},
  [1388] = {.lex_state = 7},
  [1389] = {.lex_state = 4},
  [1390] = {.lex_state = 7},
  [1391] = {.lex_state = 7},
  [1392] = {.lex_state = 7},
  [1393] = {.lex_state = 4},
  [1394] = {.lex_state = 4},
  [1395] = {.lex_state = 4},
  [1396] = {.lex_state = 4},
  [1397] = {.lex_state = 7},
  [1398] = {.lex_state = 4},
  [1399] = {.lex_state = 4},
  [1400] = {.lex_state = 4},
  [1401] = {.lex_state = 4},
  [1402] = {.lex_state = 7},
  [1403] = {.lex_state = 7},
  [1404] = {.lex_state = 7},
  [1405] = {.lex_state = 7},
  [1406] = {.lex_state = 7},
  [1407] = {.lex_state = 7},
  [1408] = {.lex_state = 4},
  [1409] = {.lex_state = 4},
  [1410] = {.lex_state = 7},
  [1411] = {.lex_state = 7},
  [1412] = {.lex_state = 7},
  [1413] = {.lex_state = 7},
  [1414] = {.lex_state = 4},
  [1415] = {.lex_state = 7},
  [1416] = {.lex_state = 7},
  [1417] = {.lex_state = 4},
  [1418] = {.lex_state = 7},
  [1419] = {.lex_state = 7},
  [1420] = {.lex_state = 7},
  [1421] = {.lex_state = 7},
  [1422] = {.lex_state = 4},
  [1423] = {.lex_state = 4},
  [1424] = {.lex_state = 4},
  [1425] = {.lex_state = 7},
  [1426] = {.lex_state = 7},
  [1427] = {.lex_state = 4},
  [1428] = {.lex_state = 7},
  [1429] = {.lex_state = 7},
  [1430] = {.lex_state = 7},
  [1431] = {.lex_state = 7},
  [1432] = {.lex_state = 7},
  [1433] = {.lex_state = 7},
  [1434] = {.lex_state = 7},
  [1435] = {.lex_state = 7},
  [1436] = {.lex_state = 4},
  [1437] = {.lex_state = 4},
  [1438] = {.lex_state = 4},
  [1439] = {.lex_state = 7},
  [1440] = {.lex_state = 7},
  [1441] = {.lex_state = 7},
  [1442] = {.lex_state = 7},
  [1443] = {.lex_state = 7},
  [1444] = {.lex_state = 7},
  [1445] = {.lex_state = 4},
  [1446] = {.lex_state = 7},
  [1447] = {.lex_state = 6},
  [1448] = {.lex_state = 13},
  [1449] = {.lex_state = 13},
  [1450] = {.lex_state = 13},
  [1451] = {.lex_state = 4},
  [1452] = {.lex_state = 13},
  [1453] = {.lex_state = 13},
  [1454] = {.lex_state = 13},
  [1455] = {.lex_state = 13},
  [1456] = {.lex_state = 13},
  [1457] = {.lex_state = 4},
  [1458] = {.lex_state = 13},
  [1459] = {.lex_state = 4},
  [1460] = {.lex_state = 4},
  [1461] = {.lex_state = 4},
  [1462] = {.lex_state = 5},
  [1463] = {.lex_state = 4},
  [1464] = {.lex_state = 4},
  [1465] = {.lex_state = 6},
  [1466] = {.lex_state = 4},
  [1467] = {.lex_state = 4},
  [1468] = {.lex_state = 6},
  [1469] = {.lex_state = 4},
  [1470] = {.lex_state = 4},
  [1471] = {.lex_state = 4},
  [1472] = {.lex_state = 4},
  [1473] = {.lex_state = 4},
  [1474] = {.lex_state = 4},
  [1475] = {.lex_state = 4},
  [1476] = {.lex_state = 4},
  [1477] = {.lex_state = 6},
  [1478] = {.lex_state = 4},
  [1479] = {.lex_state = 4},
  [1480] = {.lex_state = 4},
  [1481] = {.lex_state = 4},
  [1482] = {.lex_state = 4},
  [1483] = {.lex_state = 6},
  [1484] = {.lex_state = 6},
  [1485] = {.lex_state = 6},
  [1486] = {.lex_state = 13},
  [1487] = {.lex_state = 6},
  [1488] = {.lex_state = 13},
  [1489] = {.lex_state = 13},
  [1490] = {.lex_state = 13},
  [1491] = {.lex_state = 5},
  [1492] = {.lex_state = 13},
  [1493] = {.lex_state = 13},
  [1494] = {.lex_state = 6},
  [1495] = {.lex_state = 13},
  [1496] = {.lex_state = 5},
  [1497] = {.lex_state = 6},
  [1498] = {.lex_state = 4},
  [1499] = {.lex_state = 13},
  [1500] = {.lex_state = 6},
  [1501] = {.lex_state = 13},
  [1502] = {.lex_state = 13},
  [1503] = {.lex_state = 4},
  [1504] = {.lex_state = 5},
  [1505] = {.lex_state = 6},
  [1506] = {.lex_state = 5},
  [1507] = {.lex_state = 13},
  [1508] = {.lex_state = 5},
  [1509] = {.lex_state = 4},
  [1510] = {.lex_state = 4},
  [1511] = {.lex_state = 5},
  [1512] = {.lex_state = 5},
  [1513] = {.lex_state = 5},
  [1514] = {.lex_state = 4},
  [1515] = {.lex_state = 5},
  [1516] = {.lex_state = 5},
  [1517] = {.lex_state = 5},
  [1518] = {.lex_state = 9, .external_lex_state = 2},
  [1519] = {.lex_state = 4},
  [1520] = {.lex_state = 4},
  [1521] = {.lex_state = 4},
  [1522] = {.lex_state = 9, .external_lex_state = 2},
  [1523] = {.lex_state = 4},
  [1524] = {.lex_state = 5},
  [1525] = {.lex_state = 5},
  [1526] = {.lex_state = 9, .external_lex_state = 2},
  [1527] = {.lex_state = 5},
  [1528] = {.lex_state = 9, .external_lex_state = 2},
  [1529] = {.lex_state = 5},
  [1530] = {.lex_state = 5},
  [1531] = {.lex_state = 5},
  [1532] = {.lex_state = 5},
  [1533] = {.lex_state = 19},
  [1534] = {.lex_state = 19},
  [1535] = {.lex_state = 19},
  [1536] = {.lex_state = 5},
  [1537] = {.lex_state = 5},
  [1538] = {.lex_state = 5},
  [1539] = {.lex_state = 19},
  [1540] = {.lex_state = 19},
  [1541] = {.lex_state = 4},
  [1542] = {.lex_state = 19},
  [1543] = {.lex_state = 19},
  [1544] = {.lex_state = 19},
  [1545] = {.lex_state = 5},
  [1546] = {.lex_state = 5},
  [1547] = {.lex_state = 5},
  [1548] = {.lex_state = 4},
  [1549] = {.lex_state = 5},
  [1550] = {.lex_state = 19},
  [1551] = {.lex_state = 4},
  [1552] = {.lex_state = 5},
  [1553] = {.lex_state = 4},
  [1554] = {.lex_state = 19},
  [1555] = {.lex_state = 5},
  [1556] = {.lex_state = 4},
  [1557] = {.lex_state = 5},
  [1558] = {.lex_state = 5},
  [1559] = {.lex_state = 4},
  [1560] = {.lex_state = 4},
  [1561] = {.lex_state = 6},
  [1562] = {.lex_state = 5},
  [1563] = {.lex_state = 19},
  [1564] = {.lex_state = 4},
  [1565] = {.lex_state = 5},
  [1566] = {.lex_state = 13},
  [1567] = {.lex_state = 4},
  [1568] = {.lex_state = 4},
  [1569] = {.lex_state = 4},
  [1570] = {.lex_state = 4},
  [1571] = {.lex_state = 13},
  [1572] = {.lex_state = 4},
  [1573] = {.lex_state = 4},
  [1574] = {.lex_state = 4},
  [1575] = {.lex_state = 13},
  [1576] = {.lex_state = 13},
  [1577] = {.lex_state = 5},
  [1578] = {.lex_state = 5},
  [1579] = {.lex_state = 4},
  [1580] = {.lex_state = 5},
  [1581] = {.lex_state = 4},
  [1582] = {.lex_state = 5},
  [1583] = {.lex_state = 5},
  [1584] = {.lex_state = 13},
  [1585] = {.lex_state = 5},
  [1586] = {.lex_state = 13},
  [1587] = {.lex_state = 19},
  [1588] = {.lex_state = 13},
  [1589] = {.lex_state = 4},
  [1590] = {.lex_state = 5},
  [1591] = {.lex_state = 4},
  [1592] = {.lex_state = 5},
  [1593] = {.lex_state = 4},
  [1594] = {.lex_state = 5},
  [1595] = {.lex_state = 4},
  [1596] = {.lex_state = 4},
  [1597] = {.lex_state = 4},
  [1598] = {.lex_state = 5},
  [1599] = {.lex_state = 5},
  [1600] = {.lex_state = 5},
  [1601] = {.lex_state = 5},
  [1602] = {.lex_state = 5},
  [1603] = {.lex_state = 5},
  [1604] = {.lex_state = 5},
  [1605] = {.lex_state = 4},
  [1606] = {.lex_state = 5},
  [1607] = {.lex_state = 5},
  [1608] = {.lex_state = 4},
  [1609] = {.lex_state = 13},
  [1610] = {.lex_state = 5},
  [1611] = {.lex_state = 5},
  [1612] = {.lex_state = 5},
  [1613] = {.lex_state = 5},
  [1614] = {.lex_state = 5},
  [1615] = {.lex_state = 5},
  [1616] = {.lex_state = 5},
  [1617] = {.lex_state = 5},
  [1618] = {.lex_state = 5},
  [1619] = {.lex_state = 4},
  [1620] = {.lex_state = 5},
  [1621] = {.lex_state = 5},
  [1622] = {.lex_state = 5},
  [1623] = {.lex_state = 4},
  [1624] = {.lex_state = 4},
  [1625] = {.lex_state = 5},
  [1626] = {.lex_state = 5},
  [1627] = {.lex_state = 5},
  [1628] = {.lex_state = 5},
  [1629] = {.lex_state = 4},
  [1630] = {.lex_state = 4},
  [1631] = {.lex_state = 5},
  [1632] = {.lex_state = 5},
  [1633] = {.lex_state = 4},
  [1634] = {.lex_state = 5},
  [1635] = {.lex_state = 5},
  [1636] = {.lex_state = 5},
  [1637] = {.lex_state = 4},
  [1638] = {.lex_state = 5},
  [1639] = {.lex_state = 5},
  [1640] = {.lex_state = 5},
  [1641] = {.lex_state = 5},
  [1642] = {.lex_state = 5},
  [1643] = {.lex_state = 5},
  [1644] = {.lex_state = 4},
  [1645] = {.lex_state = 5},
  [1646] = {.lex_state = 4},
  [1647] = {.lex_state = 4},
  [1648] = {.lex_state = 4},
  [1649] = {.lex_state = 4},
  [1650] = {.lex_state = 4},
  [1651] = {.lex_state = 5},
  [1652] = {.lex_state = 4},
  [1653] = {.lex_state = 5},
  [1654] = {.lex_state = 5},
  [1655] = {.lex_state = 5},
  [1656] = {.lex_state = 5},
  [1657] = {.lex_state = 5},
  [1658] = {.lex_state = 4},
  [1659] = {.lex_state = 5},
  [1660] = {.lex_state = 5},
  [1661] = {.lex_state = 4},
  [1662] = {.lex_state = 4},
  [1663] = {.lex_state = 5},
  [1664] = {.lex_state = 5},
  [1665] = {.lex_state = 5},
  [1666] = {.lex_state = 5},
  [1667] = {.lex_state = 5},
  [1668] = {.lex_state = 5},
  [1669] = {.lex_state = 5},
  [1670] = {.lex_state = 5},
  [1671] = {.lex_state = 5},
  [1672] = {.lex_state = 5},
  [1673] = {.lex_state = 5},
  [1674] = {.lex_state = 5},
  [1675] = {.lex_state = 5},
  [1676] = {.lex_state = 5},
  [1677] = {.lex_state = 5},
  [1678] = {.lex_state = 5},
  [1679] = {.lex_state = 5},
  [1680] = {.lex_state = 5},
  [1681] = {.lex_state = 5},
  [1682] = {.lex_state = 5},
  [1683] = {.lex_state = 5},
  [1684] = {.lex_state = 5},
  [1685] = {.lex_state = 5},
  [1686] = {.lex_state = 5},
  [1687] = {.lex_state = 5},
  [1688] = {.lex_state = 5},
  [1689] = {.lex_state = 5},
  [1690] = {.lex_state = 5},
  [1691] = {.lex_state = 5},
  [1692] = {.lex_state = 13},
  [1693] = {.lex_state = 5},
  [1694] = {.lex_state = 13},
  [1695] = {.lex_state = 5},
  [1696] = {.lex_state = 5},
  [1697] = {.lex_state = 5},
  [1698] = {.lex_state = 4},
  [1699] = {.lex_state = 5},
  [1700] = {.lex_state = 5},
  [1701] = {.lex_state = 4},
  [1702] = {.lex_state = 5},
  [1703] = {.lex_state = 5},
  [1704] = {.lex_state = 5},
  [1705] = {.lex_state = 5},
  [1706] = {.lex_state = 5},
  [1707] = {.lex_state = 5},
  [1708] = {.lex_state = 5},
  [1709] = {.lex_state = 5},
  [1710] = {.lex_state = 5},
  [1711] = {.lex_state = 5},
  [1712] = {.lex_state = 5},
  [1713] = {.lex_state = 5},
  [1714] = {.lex_state = 5},
  [1715] = {.lex_state = 5},
  [1716] = {.lex_state = 5},
  [1717] = {.lex_state = 5},
  [1718] = {.lex_state = 5},
  [1719] = {.lex_state = 5},
  [1720] = {.lex_state = 5},
  [1721] = {.lex_state = 5},
  [1722] = {.lex_state = 5},
  [1723] = {.lex_state = 5},
  [1724] = {.lex_state = 5},
  [1725] = {.lex_state = 5},
  [1726] = {.lex_state = 5},
  [1727] = {.lex_state = 5},
  [1728] = {.lex_state = 5},
  [1729] = {.lex_state = 5},
  [1730] = {.lex_state = 5},
  [1731] = {.lex_state = 5},
  [1732] = {.lex_state = 5},
  [1733] = {.lex_state = 5},
  [1734] = {.lex_state = 5},
  [1735] = {.lex_state = 5},
  [1736] = {.lex_state = 5},
  [1737] = {.lex_state = 5},
  [1738] = {.lex_state = 4},
  [1739] = {.lex_state = 4},
  [1740] = {.lex_state = 4},
  [1741] = {.lex_state = 4},
  [1742] = {.lex_state = 4},
  [1743] = {.lex_state = 4},
  [1744] = {.lex_state = 4},
  [1745] = {.lex_state = 4},
  [1746] = {.lex_state = 4},
  [1747] = {.lex_state = 4},
  [1748] = {.lex_state = 5},
  [1749] = {.lex_state = 5},
  [1750] = {.lex_state = 5},
  [1751] = {.lex_state = 4},
  [1752] = {.lex_state = 5},
  [1753] = {.lex_state = 5},
  [1754] = {.lex_state = 4},
  [1755] = {.lex_state = 4},
  [1756] = {.lex_state = 4},
  [1757] = {.lex_state = 4},
  [1758] = {.lex_state = 4},
  [1759] = {.lex_state = 4},
  [1760] = {.lex_state = 5},
  [1761] = {.lex_state = 4},
  [1762] = {.lex_state = 4},
  [1763] = {.lex_state = 4},
  [1764] = {.lex_state = 4},
  [1765] = {.lex_state = 4},
  [1766] = {.lex_state = 4},
  [1767] = {.lex_state = 4},
  [1768] = {.lex_state = 5},
  [1769] = {.lex_state = 4},
  [1770] = {.lex_state = 4},
  [1771] = {.lex_state = 4},
  [1772] = {.lex_state = 4},
  [1773] = {.lex_state = 5},
  [1774] = {.lex_state = 4},
  [1775] = {.lex_state = 4},
  [1776] = {.lex_state = 4},
  [1777] = {.lex_state = 4},
  [1778] = {.lex_state = 4},
  [1779] = {.lex_state = 4},
  [1780] = {.lex_state = 4},
  [1781] = {.lex_state = 4},
  [1782] = {.lex_state = 4},
  [1783] = {.lex_state = 4},
  [1784] = {.lex_state = 4},
  [1785] = {.lex_state = 4},
  [1786] = {.lex_state = 5},
  [1787] = {.lex_state = 4},
  [1788] = {.lex_state = 5},
  [1789] = {.lex_state = 4},
  [1790] = {.lex_state = 4},
  [1791] = {.lex_state = 4},
  [1792] = {.lex_state = 4},
  [1793] = {.lex_state = 4},
  [1794] = {.lex_state = 4},
  [1795] = {.lex_state = 4},
  [1796] = {.lex_state = 4},
  [1797] = {.lex_state = 5},
  [1798] = {.lex_state = 5},
  [1799] = {.lex_state = 4},
  [1800] = {.lex_state = 4},
  [1801] = {.lex_state = 4},
  [1802] = {.lex_state = 4},
  [1803] = {.lex_state = 5},
  [1804] = {.lex_state = 4},
  [1805] = {.lex_state = 4},
  [1806] = {.lex_state = 4},
  [1807] = {.lex_state = 4},
  [1808] = {.lex_state = 4},
  [1809] = {.lex_state = 4},
  [1810] = {.lex_state = 4},
  [1811] = {.lex_state = 4},
  [1812] = {.lex_state = 4},
  [1813] = {.lex_state = 4},
  [1814] = {.lex_state = 4},
  [1815] = {.lex_state = 5},
  [1816] = {.lex_state = 5},
  [1817] = {.lex_state = 4},
  [1818] = {.lex_state = 4},
  [1819] = {.lex_state = 5},
  [1820] = {.lex_state = 5},
  [1821] = {.lex_state = 5},
  [1822] = {.lex_state = 4},
  [1823] = {.lex_state = 13},
  [1824] = {.lex_state = 5},
  [1825] = {.lex_state = 4},
  [1826] = {.lex_state = 4},
  [1827] = {.lex_state = 5},
  [1828] = {.lex_state = 4},
  [1829] = {.lex_state = 4},
  [1830] = {.lex_state = 4},
  [1831] = {.lex_state = 4},
  [1832] = {.lex_state = 4},
  [1833] = {.lex_state = 4},
  [1834] = {.lex_state = 4},
  [1835] = {.lex_state = 4},
  [1836] = {.lex_state = 4},
  [1837] = {.lex_state = 4},
  [1838] = {.lex_state = 5},
  [1839] = {.lex_state = 4},
  [1840] = {.lex_state = 4},
  [1841] = {.lex_state = 4},
  [1842] = {.lex_state = 4},
  [1843] = {.lex_state = 4},
  [1844] = {.lex_state = 4},
  [1845] = {.lex_state = 4},
  [1846] = {.lex_state = 4},
  [1847] = {.lex_state = 4},
  [1848] = {.lex_state = 13},
  [1849] = {.lex_state = 5},
  [1850] = {.lex_state = 4},
  [1851] = {.lex_state = 4},
  [1852] = {.lex_state = 4},
  [1853] = {.lex_state = 4},
  [1854] = {.lex_state = 4},
  [1855] = {.lex_state = 4},
  [1856] = {.lex_state = 4},
  [1857] = {.lex_state = 4},
  [1858] = {.lex_state = 4},
  [1859] = {.lex_state = 5},
  [1860] = {.lex_state = 4},
  [1861] = {.lex_state = 4},
  [1862] = {.lex_state = 4},
  [1863] = {.lex_state = 4},
  [1864] = {.lex_state = 4},
  [1865] = {.lex_state = 5},
  [1866] = {.lex_state = 4},
  [1867] = {.lex_state = 4},
  [1868] = {.lex_state = 4},
  [1869] = {.lex_state = 4},
  [1870] = {.lex_state = 4},
  [1871] = {.lex_state = 13},
  [1872] = {.lex_state = 4},
  [1873] = {.lex_state = 4},
  [1874] = {.lex_state = 4},
  [1875] = {.lex_state = 4},
  [1876] = {.lex_state = 13},
  [1877] = {.lex_state = 13},
  [1878] = {.lex_state = 13},
  [1879] = {.lex_state = 13},
  [1880] = {.lex_state = 13},
  [1881] = {.lex_state = 13},
  [1882] = {.lex_state = 13},
  [1883] = {.lex_state = 13},
  [1884] = {.lex_state = 13},
  [1885] = {.lex_state = 13},
  [1886] = {.lex_state = 13},
  [1887] = {.lex_state = 13},
  [1888] = {.lex_state = 13},
  [1889] = {.lex_state = 13},
  [1890] = {.lex_state = 13},
  [1891] = {.lex_state = 13},
  [1892] = {.lex_state = 13},
  [1893] = {.lex_state = 13},
  [1894] = {.lex_state = 13},
  [1895] = {.lex_state = 13},
  [1896] = {.lex_state = 13},
  [1897] = {.lex_state = 13},
  [1898] = {.lex_state = 13},
  [1899] = {.lex_state = 13},
  [1900] = {.lex_state = 13},
  [1901] = {.lex_state = 26},
  [1902] = {.lex_state = 15},
  [1903] = {.lex_state = 26},
  [1904] = {.lex_state = 15},
  [1905] = {.lex_state = 15},
  [1906] = {.lex_state = 15},
  [1907] = {.lex_state = 15},
  [1908] = {.lex_state = 15},
  [1909] = {.lex_state = 15},
  [1910] = {.lex_state = 15},
  [1911] = {.lex_state = 15},
  [1912] = {.lex_state = 26},
  [1913] = {.lex_state = 26},
  [1914] = {.lex_state = 26},
  [1915] = {.lex_state = 26},
  [1916] = {.lex_state = 13},
  [1917] = {.lex_state = 15},
  [1918] = {.lex_state = 15},
  [1919] = {.lex_state = 26},
  [1920] = {.lex_state = 15},
  [1921] = {.lex_state = 15},
  [1922] = {.lex_state = 13},
  [1923] = {.lex_state = 13},
  [1924] = {.lex_state = 13},
  [1925] = {.lex_state = 15},
  [1926] = {.lex_state = 13},
  [1927] = {.lex_state = 13},
  [1928] = {.lex_state = 13},
  [1929] = {.lex_state = 13},
  [1930] = {.lex_state = 13},
  [1931] = {.lex_state = 15},
  [1932] = {.lex_state = 13},
  [1933] = {.lex_state = 13},
  [1934] = {.lex_state = 13},
  [1935] = {.lex_state = 26},
  [1936] = {.lex_state = 13},
  [1937] = {.lex_state = 13},
  [1938] = {.lex_state = 15},
  [1939] = {.lex_state = 13},
  [1940] = {.lex_state = 26},
  [1941] = {.lex_state = 26},
  [1942] = {.lex_state = 26},
  [1943] = {.lex_state = 15},
  [1944] = {.lex_state = 13},
  [1945] = {.lex_state = 26},
  [1946] = {.lex_state = 26},
  [1947] = {.lex_state = 26},
  [1948] = {.lex_state = 13},
  [1949] = {.lex_state = 26},
  [1950] = {.lex_state = 26},
  [1951] = {.lex_state = 26},
  [1952] = {.lex_state = 15},
  [1953] = {.lex_state = 26},
  [1954] = {.lex_state = 26},
  [1955] = {.lex_state = 15},
  [1956] = {.lex_state = 26},
  [1957] = {.lex_state = 26},
  [1958] = {.lex_state = 13},
  [1959] = {.lex_state = 26},
  [1960] = {.lex_state = 13},
  [1961] = {.lex_state = 26},
  [1962] = {.lex_state = 13},
  [1963] = {.lex_state = 26},
  [1964] = {.lex_state = 26},
  [1965] = {.lex_state = 13},
  [1966] = {.lex_state = 26},
  [1967] = {.lex_state = 26},
  [1968] = {.lex_state = 26},
  [1969] = {.lex_state = 26},
  [1970] = {.lex_state = 26},
  [1971] = {.lex_state = 26},
  [1972] = {.lex_state = 26},
  [1973] = {.lex_state = 26},
  [1974] = {.lex_state = 26},
  [1975] = {.lex_state = 13},
  [1976] = {.lex_state = 26},
  [1977] = {.lex_state = 26},
  [1978] = {.lex_state = 26},
  [1979] = {.lex_state = 26},
  [1980] = {.lex_state = 26},
  [1981] = {.lex_state = 13},
  [1982] = {.lex_state = 26},
  [1983] = {.lex_state = 13},
  [1984] = {.lex_state = 13},
  [1985] = {.lex_state = 26},
  [1986] = {.lex_state = 26},
  [1987] = {.lex_state = 15},
  [1988] = {.lex_state = 26},
  [1989] = {.lex_state = 26},
  [1990] = {.lex_state = 26},
  [1991] = {.lex_state = 26},
  [1992] = {.lex_state = 26},
  [1993] = {.lex_state = 15},
  [1994] = {.lex_state = 26},
  [1995] = {.lex_state = 13},
  [1996] = {.lex_state = 13},
  [1997] = {.lex_state = 15},
  [1998] = {.lex_state = 15},
  [1999] = {.lex_state = 15},
  [2000] = {.lex_state = 15},
  [2001] = {.lex_state = 15},
  [2002] = {.lex_state = 15},
  [2003] = {.lex_state = 15},
  [2004] = {.lex_state = 26},
  [2005] = {.lex_state = 15},
  [2006] = {.lex_state = 26},
  [2007] = {.lex_state = 15},
  [2008] = {.lex_state = 15},
  [2009] = {.lex_state = 15},
  [2010] = {.lex_state = 15},
  [2011] = {.lex_state = 26},
  [2012] = {.lex_state = 16},
  [2013] = {.lex_state = 13},
  [2014] = {.lex_state = 16},
  [2015] = {.lex_state = 13},
  [2016] = {.lex_state = 15},
  [2017] = {.lex_state = 13},
  [2018] = {.lex_state = 15},
  [2019] = {.lex_state = 13},
  [2020] = {.lex_state = 26},
  [2021] = {.lex_state = 15},
  [2022] = {.lex_state = 15},
  [2023] = {.lex_state = 26},
  [2024] = {.lex_state = 16},
  [2025] = {.lex_state = 26},
  [2026] = {.lex_state = 20},
  [2027] = {.lex_state = 16},
  [2028] = {.lex_state = 20},
  [2029] = {.lex_state = 20},
  [2030] = {.lex_state = 26},
  [2031] = {.lex_state = 13},
  [2032] = {.lex_state = 15},
  [2033] = {.lex_state = 20},
  [2034] = {.lex_state = 15},
  [2035] = {.lex_state = 13},
  [2036] = {.lex_state = 26},
  [2037] = {.lex_state = 15},
  [2038] = {.lex_state = 13},
  [2039] = {.lex_state = 13},
  [2040] = {.lex_state = 15},
  [2041] = {.lex_state = 13},
  [2042] = {.lex_state = 13},
  [2043] = {.lex_state = 13},
  [2044] = {.lex_state = 16},
  [2045] = {.lex_state = 15},
  [2046] = {.lex_state = 26},
  [2047] = {.lex_state = 26},
  [2048] = {.lex_state = 26},
  [2049] = {.lex_state = 22},
  [2050] = {.lex_state = 26},
  [2051] = {.lex_state = 26},
  [2052] = {.lex_state = 15},
  [2053] = {.lex_state = 26},
  [2054] = {.lex_state = 26},
  [2055] = {.lex_state = 26},
  [2056] = {.lex_state = 7},
  [2057] = {.lex_state = 26},
  [2058] = {.lex_state = 26},
  [2059] = {.lex_state = 26},
  [2060] = {.lex_state = 26},
  [2061] = {.lex_state = 26},
  [2062] = {.lex_state = 13},
  [2063] = {.lex_state = 15},
  [2064] = {.lex_state = 26},
  [2065] = {.lex_state = 26},
  [2066] = {.lex_state = 15},
  [2067] = {.lex_state = 13},
  [2068] = {.lex_state = 22},
  [2069] = {.lex_state = 26},
  [2070] = {.lex_state = 26},
  [2071] = {.lex_state = 16},
  [2072] = {.lex_state = 26},
  [2073] = {.lex_state = 26},
  [2074] = {.lex_state = 26},
  [2075] = {.lex_state = 26},
  [2076] = {.lex_state = 13},
  [2077] = {.lex_state = 26},
  [2078] = {.lex_state = 26},
  [2079] = {.lex_state = 26},
  [2080] = {.lex_state = 26},
  [2081] = {.lex_state = 26},
  [2082] = {.lex_state = 26},
  [2083] = {.lex_state = 15},
  [2084] = {.lex_state = 13},
  [2085] = {.lex_state = 26},
  [2086] = {.lex_state = 26},
  [2087] = {.lex_state = 26},
  [2088] = {.lex_state = 26},
  [2089] = {.lex_state = 15},
  [2090] = {.lex_state = 26},
  [2091] = {.lex_state = 26},
  [2092] = {.lex_state = 26},
  [2093] = {.lex_state = 13},
  [2094] = {.lex_state = 22},
  [2095] = {.lex_state = 7},
  [2096] = {.lex_state = 3},
  [2097] = {.lex_state = 68},
  [2098] = {.lex_state = 13},
  [2099] = {.lex_state = 13},
  [2100] = {.lex_state = 13},
  [2101] = {.lex_state = 13},
  [2102] = {.lex_state = 13},
  [2103] = {.lex_state = 16},
  [2104] = {.lex_state = 7},
  [2105] = {.lex_state = 13},
  [2106] = {.lex_state = 13},
  [2107] = {.lex_state = 13},
  [2108] = {.lex_state = 13},
  [2109] = {.lex_state = 13},
  [2110] = {.lex_state = 7},
  [2111] = {.lex_state = 22},
  [2112] = {.lex_state = 22},
  [2113] = {.lex_state = 13},
  [2114] = {.lex_state = 16},
  [2115] = {.lex_state = 26},
  [2116] = {.lex_state = 26},
  [2117] = {.lex_state = 15},
  [2118] = {.lex_state = 7},
  [2119] = {.lex_state = 13},
  [2120] = {.lex_state = 13},
  [2121] = {.lex_state = 13},
  [2122] = {.lex_state = 13},
  [2123] = {.lex_state = 13},
  [2124] = {.lex_state = 13},
  [2125] = {.lex_state = 13},
  [2126] = {.lex_state = 16},
  [2127] = {.lex_state = 26},
  [2128] = {.lex_state = 13},
  [2129] = {.lex_state = 13},
  [2130] = {.lex_state = 22},
  [2131] = {.lex_state = 13},
  [2132] = {.lex_state = 13},
  [2133] = {.lex_state = 13},
  [2134] = {.lex_state = 3},
  [2135] = {.lex_state = 16},
  [2136] = {.lex_state = 26},
  [2137] = {.lex_state = 26},
  [2138] = {.lex_state = 26},
  [2139] = {.lex_state = 3},
  [2140] = {.lex_state = 13},
  [2141] = {.lex_state = 26},
  [2142] = {.lex_state = 13},
  [2143] = {.lex_state = 13},
  [2144] = {.lex_state = 13},
  [2145] = {.lex_state = 26},
  [2146] = {.lex_state = 16},
  [2147] = {.lex_state = 13},
  [2148] = {.lex_state = 13},
  [2149] = {.lex_state = 13},
  [2150] = {.lex_state = 13},
  [2151] = {.lex_state = 13},
  [2152] = {.lex_state = 13},
  [2153] = {.lex_state = 13},
  [2154] = {.lex_state = 13},
  [2155] = {.lex_state = 20},
  [2156] = {.lex_state = 13},
  [2157] = {.lex_state = 13},
  [2158] = {.lex_state = 13},
  [2159] = {.lex_state = 13},
  [2160] = {.lex_state = 22},
  [2161] = {.lex_state = 13},
  [2162] = {.lex_state = 13},
  [2163] = {.lex_state = 13},
  [2164] = {.lex_state = 22},
  [2165] = {.lex_state = 13},
  [2166] = {.lex_state = 13},
  [2167] = {.lex_state = 13},
  [2168] = {.lex_state = 13},
  [2169] = {.lex_state = 13},
  [2170] = {.lex_state = 13},
  [2171] = {.lex_state = 13},
  [2172] = {.lex_state = 13},
  [2173] = {.lex_state = 22},
  [2174] = {.lex_state = 22},
  [2175] = {.lex_state = 13},
  [2176] = {.lex_state = 13},
  [2177] = {.lex_state = 13},
  [2178] = {.lex_state = 13},
  [2179] = {.lex_state = 13},
  [2180] = {.lex_state = 13},
  [2181] = {.lex_state = 13},
  [2182] = {.lex_state = 13},
  [2183] = {.lex_state = 13},
  [2184] = {.lex_state = 13},
  [2185] = {.lex_state = 13},
  [2186] = {.lex_state = 13},
  [2187] = {.lex_state = 7},
  [2188] = {.lex_state = 13},
  [2189] = {.lex_state = 13},
  [2190] = {.lex_state = 22},
  [2191] = {.lex_state = 22},
  [2192] = {.lex_state = 13},
  [2193] = {.lex_state = 13},
  [2194] = {.lex_state = 13},
  [2195] = {.lex_state = 13},
  [2196] = {.lex_state = 13},
  [2197] = {.lex_state = 22},
  [2198] = {.lex_state = 13},
  [2199] = {.lex_state = 13},
  [2200] = {.lex_state = 13},
  [2201] = {.lex_state = 13},
  [2202] = {.lex_state = 13},
  [2203] = {.lex_state = 13},
  [2204] = {.lex_state = 22},
  [2205] = {.lex_state = 13},
  [2206] = {.lex_state = 22},
  [2207] = {.lex_state = 13},
  [2208] = {.lex_state = 13},
  [2209] = {.lex_state = 22},
  [2210] = {.lex_state = 13},
  [2211] = {.lex_state = 22},
  [2212] = {.lex_state = 13},
  [2213] = {.lex_state = 13},
  [2214] = {.lex_state = 13},
  [2215] = {.lex_state = 22},
  [2216] = {.lex_state = 68},
  [2217] = {.lex_state = 68},
  [2218] = {.lex_state = 13},
  [2219] = {.lex_state = 13},
  [2220] = {.lex_state = 68},
  [2221] = {.lex_state = 22},
  [2222] = {.lex_state = 13},
  [2223] = {.lex_state = 68},
  [2224] = {.lex_state = 13},
  [2225] = {.lex_state = 68},
  [2226] = {.lex_state = 68},
  [2227] = {.lex_state = 13},
  [2228] = {.lex_state = 68},
  [2229] = {.lex_state = 68},
  [2230] = {.lex_state = 68},
  [2231] = {.lex_state = 68},
  [2232] = {.lex_state = 13},
  [2233] = {.lex_state = 68},
  [2234] = {.lex_state = 68},
  [2235] = {.lex_state = 68},
  [2236] = {.lex_state = 1},
  [2237] = {.lex_state = 7},
  [2238] = {.lex_state = 22},
  [2239] = {.lex_state = 13},
  [2240] = {.lex_state = 68},
  [2241] = {.lex_state = 68},
  [2242] = {.lex_state = 68},
  [2243] = {.lex_state = 68},
  [2244] = {.lex_state = 13},
  [2245] = {.lex_state = 68},
  [2246] = {.lex_state = 68},
  [2247] = {.lex_state = 68},
  [2248] = {.lex_state = 13},
  [2249] = {.lex_state = 16},
  [2250] = {.lex_state = 26},
  [2251] = {.lex_state = 68},
  [2252] = {.lex_state = 68},
  [2253] = {.lex_state = 68},
  [2254] = {.lex_state = 22},
  [2255] = {.lex_state = 22},
  [2256] = {.lex_state = 68},
  [2257] = {.lex_state = 26},
  [2258] = {.lex_state = 7},
  [2259] = {.lex_state = 22},
  [2260] = {.lex_state = 68},
  [2261] = {.lex_state = 68},
  [2262] = {.lex_state = 68},
  [2263] = {.lex_state = 68},
  [2264] = {.lex_state = 68},
  [2265] = {.lex_state = 13},
  [2266] = {.lex_state = 68},
  [2267] = {.lex_state = 1},
  [2268] = {.lex_state = 7},
  [2269] = {.lex_state = 22},
  [2270] = {.lex_state = 22},
  [2271] = {.lex_state = 1},
  [2272] = {.lex_state = 16},
  [2273] = {.lex_state = 13},
  [2274] = {.lex_state = 13},
  [2275] = {.lex_state = 1},
  [2276] = {.lex_state = 13},
  [2277] = {.lex_state = 13},
  [2278] = {.lex_state = 13},
  [2279] = {.lex_state = 1},
  [2280] = {.lex_state = 1},
  [2281] = {.lex_state = 26},
  [2282] = {.lex_state = 68},
  [2283] = {.lex_state = 22},
  [2284] = {.lex_state = 26},
  [2285] = {.lex_state = 17},
  [2286] = {.lex_state = 17},
  [2287] = {.lex_state = 13},
  [2288] = {.lex_state = 16},
  [2289] = {.lex_state = 13},
  [2290] = {.lex_state = 13},
  [2291] = {.lex_state = 13},
  [2292] = {.lex_state = 13},
  [2293] = {.lex_state = 26},
  [2294] = {.lex_state = 17},
  [2295] = {.lex_state = 13},
  [2296] = {.lex_state = 16},
  [2297] = {.lex_state = 13},
  [2298] = {.lex_state = 13},
  [2299] = {.lex_state = 13},
  [2300] = {.lex_state = 13},
  [2301] = {.lex_state = 13},
  [2302] = {.lex_state = 26},
  [2303] = {.lex_state = 26},
  [2304] = {.lex_state = 13},
  [2305] = {.lex_state = 13},
  [2306] = {.lex_state = 13},
  [2307] = {.lex_state = 13},
  [2308] = {.lex_state = 13},
  [2309] = {.lex_state = 13},
  [2310] = {.lex_state = 13},
  [2311] = {.lex_state = 13},
  [2312] = {.lex_state = 13},
  [2313] = {.lex_state = 13},
  [2314] = {.lex_state = 13},
  [2315] = {.lex_state = 13},
  [2316] = {.lex_state = 26},
  [2317] = {.lex_state = 13},
  [2318] = {.lex_state = 13},
  [2319] = {.lex_state = 13},
  [2320] = {.lex_state = 13},
  [2321] = {.lex_state = 17},
  [2322] = {.lex_state = 17},
  [2323] = {.lex_state = 13},
  [2324] = {.lex_state = 13},
  [2325] = {.lex_state = 13},
  [2326] = {.lex_state = 13},
  [2327] = {.lex_state = 13},
  [2328] = {.lex_state = 13},
  [2329] = {.lex_state = 13},
  [2330] = {.lex_state = 13},
  [2331] = {.lex_state = 13},
  [2332] = {.lex_state = 13},
  [2333] = {.lex_state = 13},
  [2334] = {.lex_state = 20},
  [2335] = {.lex_state = 13},
  [2336] = {.lex_state = 13},
  [2337] = {.lex_state = 12},
  [2338] = {.lex_state = 13},
  [2339] = {.lex_state = 13},
  [2340] = {.lex_state = 20},
  [2341] = {.lex_state = 17},
  [2342] = {.lex_state = 12},
  [2343] = {.lex_state = 13},
  [2344] = {.lex_state = 13},
  [2345] = {.lex_state = 13},
  [2346] = {.lex_state = 16},
  [2347] = {.lex_state = 1},
  [2348] = {.lex_state = 26},
  [2349] = {.lex_state = 13},
  [2350] = {.lex_state = 13},
  [2351] = {.lex_state = 13},
  [2352] = {.lex_state = 16},
  [2353] = {.lex_state = 13},
  [2354] = {.lex_state = 13},
  [2355] = {.lex_state = 13},
  [2356] = {.lex_state = 13},
  [2357] = {.lex_state = 16},
  [2358] = {.lex_state = 13},
  [2359] = {.lex_state = 13},
  [2360] = {.lex_state = 26},
  [2361] = {.lex_state = 7},
  [2362] = {.lex_state = 13},
  [2363] = {.lex_state = 13},
  [2364] = {.lex_state = 26},
  [2365] = {.lex_state = 26},
  [2366] = {.lex_state = 26},
  [2367] = {.lex_state = 7},
  [2368] = {.lex_state = 26},
  [2369] = {.lex_state = 7},
  [2370] = {.lex_state = 26},
  [2371] = {.lex_state = 26},
  [2372] = {.lex_state = 13},
  [2373] = {.lex_state = 26},
  [2374] = {.lex_state = 26},
  [2375] = {.lex_state = 26},
  [2376] = {.lex_state = 3},
  [2377] = {.lex_state = 7},
  [2378] = {.lex_state = 26},
  [2379] = {.lex_state = 7},
  [2380] = {.lex_state = 13},
  [2381] = {.lex_state = 26},
  [2382] = {.lex_state = 26},
  [2383] = {.lex_state = 7},
  [2384] = {.lex_state = 13},
  [2385] = {.lex_state = 7},
  [2386] = {.lex_state = 1},
  [2387] = {.lex_state = 7},
  [2388] = {.lex_state = 7},
  [2389] = {.lex_state = 26},
  [2390] = {.lex_state = 7},
  [2391] = {.lex_state = 13},
  [2392] = {.lex_state = 13},
  [2393] = {.lex_state = 7},
  [2394] = {.lex_state = 13},
  [2395] = {.lex_state = 13},
  [2396] = {.lex_state = 26},
  [2397] = {.lex_state = 68},
  [2398] = {.lex_state = 7},
  [2399] = {.lex_state = 13},
  [2400] = {.lex_state = 13},
  [2401] = {.lex_state = 7},
  [2402] = {.lex_state = 26},
  [2403] = {.lex_state = 26},
  [2404] = {.lex_state = 7},
  [2405] = {.lex_state = 7},
  [2406] = {.lex_state = 7},
  [2407] = {.lex_state = 68},
  [2408] = {.lex_state = 26},
  [2409] = {.lex_state = 26},
  [2410] = {.lex_state = 7},
  [2411] = {.lex_state = 7},
  [2412] = {.lex_state = 7},
  [2413] = {.lex_state = 13},
  [2414] = {.lex_state = 26},
  [2415] = {.lex_state = 13},
  [2416] = {.lex_state = 26},
  [2417] = {.lex_state = 13},
  [2418] = {.lex_state = 68},
  [2419] = {.lex_state = 7},
  [2420] = {.lex_state = 26},
  [2421] = {.lex_state = 7},
  [2422] = {.lex_state = 7},
  [2423] = {.lex_state = 171},
  [2424] = {.lex_state = 7},
  [2425] = {.lex_state = 7},
  [2426] = {.lex_state = 7},
  [2427] = {.lex_state = 26},
  [2428] = {.lex_state = 26},
  [2429] = {.lex_state = 3},
  [2430] = {.lex_state = 13},
  [2431] = {.lex_state = 7},
  [2432] = {.lex_state = 13},
  [2433] = {.lex_state = 13},
  [2434] = {.lex_state = 13},
  [2435] = {.lex_state = 13},
  [2436] = {.lex_state = 13},
  [2437] = {.lex_state = 7},
  [2438] = {.lex_state = 26},
  [2439] = {.lex_state = 7},
  [2440] = {.lex_state = 3},
  [2441] = {.lex_state = 7},
  [2442] = {.lex_state = 1},
  [2443] = {.lex_state = 26},
  [2444] = {.lex_state = 13},
  [2445] = {.lex_state = 26},
  [2446] = {.lex_state = 7},
  [2447] = {.lex_state = 13},
  [2448] = {.lex_state = 3},
  [2449] = {.lex_state = 7},
  [2450] = {.lex_state = 7},
  [2451] = {.lex_state = 7},
  [2452] = {.lex_state = 13},
  [2453] = {.lex_state = 7},
  [2454] = {.lex_state = 13},
  [2455] = {.lex_state = 7, .external_lex_state = 3},
  [2456] = {.lex_state = 28},
  [2457] = {.lex_state = 28},
  [2458] = {.lex_state = 3},
  [2459] = {.lex_state = 7},
  [2460] = {.lex_state = 3},
  [2461] = {.lex_state = 7},
  [2462] = {.lex_state = 3},
  [2463] = {.lex_state = 68},
  [2464] = {.lex_state = 28},
  [2465] = {.lex_state = 3},
  [2466] = {.lex_state = 7},
  [2467] = {.lex_state = 26},
  [2468] = {.lex_state = 13},
  [2469] = {.lex_state = 1},
  [2470] = {.lex_state = 7},
  [2471] = {.lex_state = 13},
  [2472] = {.lex_state = 1},
  [2473] = {.lex_state = 7, .external_lex_state = 4},
  [2474] = {.lex_state = 26},
  [2475] = {.lex_state = 7},
  [2476] = {.lex_state = 68},
  [2477] = {.lex_state = 13},
  [2478] = {.lex_state = 7},
  [2479] = {.lex_state = 7},
  [2480] = {.lex_state = 7},
  [2481] = {.lex_state = 7, .external_lex_state = 4},
  [2482] = {.lex_state = 26},
  [2483] = {.lex_state = 7},
  [2484] = {.lex_state = 7},
  [2485] = {.lex_state = 7},
  [2486] = {.lex_state = 7},
  [2487] = {.lex_state = 68},
  [2488] = {.lex_state = 68},
  [2489] = {.lex_state = 28},
  [2490] = {.lex_state = 3},
  [2491] = {.lex_state = 7},
  [2492] = {.lex_state = 13},
  [2493] = {.lex_state = 68},
  [2494] = {.lex_state = 13},
  [2495] = {.lex_state = 15},
  [2496] = {.lex_state = 68},
  [2497] = {.lex_state = 7},
  [2498] = {.lex_state = 7},
  [2499] = {.lex_state = 13},
  [2500] = {.lex_state = 68},
  [2501] = {.lex_state = 13},
  [2502] = {.lex_state = 3},
  [2503] = {.lex_state = 7},
  [2504] = {.lex_state = 7},
  [2505] = {.lex_state = 13},
  [2506] = {.lex_state = 3},
  [2507] = {.lex_state = 68},
  [2508] = {.lex_state = 68},
  [2509] = {.lex_state = 68},
  [2510] = {.lex_state = 3},
  [2511] = {.lex_state = 1},
  [2512] = {.lex_state = 1},
  [2513] = {.lex_state = 68},
  [2514] = {.lex_state = 13},
  [2515] = {.lex_state = 7},
  [2516] = {.lex_state = 26},
  [2517] = {.lex_state = 7},
  [2518] = {.lex_state = 68},
  [2519] = {.lex_state = 3},
  [2520] = {.lex_state = 3},
  [2521] = {.lex_state = 3},
  [2522] = {.lex_state = 3},
  [2523] = {.lex_state = 3},
  [2524] = {.lex_state = 7},
  [2525] = {.lex_state = 3},
  [2526] = {.lex_state = 3},
  [2527] = {.lex_state = 3},
  [2528] = {.lex_state = 68},
  [2529] = {.lex_state = 3},
  [2530] = {.lex_state = 3},
  [2531] = {.lex_state = 16},
  [2532] = {.lex_state = 16},
  [2533] = {.lex_state = 16},
  [2534] = {.lex_state = 16},
  [2535] = {.lex_state = 7},
  [2536] = {.lex_state = 68},
  [2537] = {.lex_state = 68},
  [2538] = {.lex_state = 3},
  [2539] = {.lex_state = 3},
  [2540] = {.lex_state = 16},
  [2541] = {.lex_state = 7, .external_lex_state = 4},
  [2542] = {.lex_state = 16},
  [2543] = {.lex_state = 16},
  [2544] = {.lex_state = 7, .external_lex_state = 4},
  [2545] = {.lex_state = 3},
  [2546] = {.lex_state = 16},
  [2547] = {.lex_state = 7},
  [2548] = {.lex_state = 13},
  [2549] = {.lex_state = 7},
  [2550] = {.lex_state = 7, .external_lex_state = 4},
  [2551] = {.lex_state = 3},
  [2552] = {.lex_state = 3},
  [2553] = {.lex_state = 68},
  [2554] = {.lex_state = 7, .external_lex_state = 4},
  [2555] = {.lex_state = 7},
  [2556] = {.lex_state = 68},
  [2557] = {.lex_state = 7},
  [2558] = {.lex_state = 7, .external_lex_state = 4},
  [2559] = {.lex_state = 7},
  [2560] = {.lex_state = 13},
  [2561] = {.lex_state = 7},
  [2562] = {.lex_state = 68},
  [2563] = {.lex_state = 3},
  [2564] = {.lex_state = 3},
  [2565] = {.lex_state = 68},
  [2566] = {.lex_state = 7, .external_lex_state = 4},
  [2567] = {.lex_state = 7},
  [2568] = {.lex_state = 13},
  [2569] = {.lex_state = 7},
  [2570] = {.lex_state = 68},
  [2571] = {.lex_state = 7},
  [2572] = {.lex_state = 7},
  [2573] = {.lex_state = 15},
  [2574] = {.lex_state = 7},
  [2575] = {.lex_state = 7, .external_lex_state = 4},
  [2576] = {.lex_state = 7},
  [2577] = {.lex_state = 7},
  [2578] = {.lex_state = 26},
  [2579] = {.lex_state = 1},
  [2580] = {.lex_state = 7},
  [2581] = {.lex_state = 7, .external_lex_state = 4},
  [2582] = {.lex_state = 68},
  [2583] = {.lex_state = 68},
  [2584] = {.lex_state = 3},
  [2585] = {.lex_state = 68},
  [2586] = {.lex_state = 7},
  [2587] = {.lex_state = 7},
  [2588] = {.lex_state = 68},
  [2589] = {.lex_state = 68},
  [2590] = {.lex_state = 68},
  [2591] = {.lex_state = 68},
  [2592] = {.lex_state = 7},
  [2593] = {.lex_state = 3},
  [2594] = {.lex_state = 3},
  [2595] = {.lex_state = 13},
  [2596] = {.lex_state = 3},
  [2597] = {.lex_state = 68},
  [2598] = {.lex_state = 7},
  [2599] = {.lex_state = 13},
  [2600] = {.lex_state = 26},
  [2601] = {.lex_state = 7, .external_lex_state = 4},
  [2602] = {.lex_state = 3},
  [2603] = {.lex_state = 3},
  [2604] = {.lex_state = 68},
  [2605] = {.lex_state = 68},
  [2606] = {.lex_state = 3},
  [2607] = {.lex_state = 7},
  [2608] = {.lex_state = 7, .external_lex_state = 4},
  [2609] = {.lex_state = 7},
  [2610] = {.lex_state = 7},
  [2611] = {.lex_state = 68},
  [2612] = {.lex_state = 7},
  [2613] = {.lex_state = 3},
  [2614] = {.lex_state = 15},
  [2615] = {.lex_state = 3},
  [2616] = {.lex_state = 13},
  [2617] = {.lex_state = 7},
  [2618] = {.lex_state = 26},
  [2619] = {.lex_state = 7},
  [2620] = {.lex_state = 7, .external_lex_state = 4},
  [2621] = {.lex_state = 7},
  [2622] = {.lex_state = 3},
  [2623] = {.lex_state = 7},
  [2624] = {.lex_state = 13},
  [2625] = {.lex_state = 3},
  [2626] = {.lex_state = 68},
  [2627] = {.lex_state = 13},
  [2628] = {.lex_state = 68},
  [2629] = {.lex_state = 7},
  [2630] = {.lex_state = 13},
  [2631] = {.lex_state = 7},
  [2632] = {.lex_state = 68},
  [2633] = {.lex_state = 26},
  [2634] = {.lex_state = 13},
  [2635] = {.lex_state = 13},
  [2636] = {.lex_state = 3},
  [2637] = {.lex_state = 13},
  [2638] = {.lex_state = 68},
  [2639] = {.lex_state = 7},
  [2640] = {.lex_state = 7},
  [2641] = {.lex_state = 3},
  [2642] = {.lex_state = 68},
  [2643] = {.lex_state = 68},
  [2644] = {.lex_state = 3},
  [2645] = {.lex_state = 68},
  [2646] = {.lex_state = 7},
  [2647] = {.lex_state = 68},
  [2648] = {.lex_state = 68},
  [2649] = {.lex_state = 68},
  [2650] = {.lex_state = 13},
  [2651] = {.lex_state = 13},
  [2652] = {.lex_state = 13},
  [2653] = {.lex_state = 68},
  [2654] = {.lex_state = 13},
  [2655] = {.lex_state = 68},
  [2656] = {.lex_state = 13},
  [2657] = {.lex_state = 26},
  [2658] = {.lex_state = 13},
  [2659] = {.lex_state = 68},
  [2660] = {.lex_state = 7},
  [2661] = {.lex_state = 68},
  [2662] = {.lex_state = 68},
  [2663] = {.lex_state = 7},
  [2664] = {.lex_state = 13},
  [2665] = {.lex_state = 13},
  [2666] = {.lex_state = 13},
  [2667] = {.lex_state = 13},
  [2668] = {.lex_state = 13},
  [2669] = {.lex_state = 13},
  [2670] = {.lex_state = 13},
  [2671] = {.lex_state = 13},
  [2672] = {.lex_state = 13},
  [2673] = {.lex_state = 13},
  [2674] = {.lex_state = 68},
  [2675] = {.lex_state = 3},
  [2676] = {.lex_state = 26},
  [2677] = {.lex_state = 68},
  [2678] = {.lex_state = 13},
  [2679] = {.lex_state = 68},
  [2680] = {.lex_state = 68},
  [2681] = {.lex_state = 68},
  [2682] = {.lex_state = 3},
  [2683] = {.lex_state = 3},
  [2684] = {.lex_state = 3},
  [2685] = {.lex_state = 13},
  [2686] = {.lex_state = 7},
  [2687] = {.lex_state = 3},
  [2688] = {.lex_state = 3},
  [2689] = {.lex_state = 68},
  [2690] = {.lex_state = 68},
  [2691] = {.lex_state = 68},
  [2692] = {.lex_state = 68},
  [2693] = {.lex_state = 13},
  [2694] = {.lex_state = 68},
  [2695] = {.lex_state = 68},
  [2696] = {.lex_state = 13},
  [2697] = {.lex_state = 13},
  [2698] = {.lex_state = 68},
  [2699] = {.lex_state = 3},
  [2700] = {.lex_state = 68},
  [2701] = {.lex_state = 3},
  [2702] = {.lex_state = 3},
  [2703] = {.lex_state = 68},
  [2704] = {.lex_state = 68},
  [2705] = {.lex_state = 68},
  [2706] = {.lex_state = 3},
  [2707] = {.lex_state = 68},
  [2708] = {.lex_state = 68},
  [2709] = {.lex_state = 68},
  [2710] = {.lex_state = 68},
  [2711] = {.lex_state = 68},
  [2712] = {.lex_state = 68},
  [2713] = {.lex_state = 68},
  [2714] = {.lex_state = 68},
  [2715] = {.lex_state = 68},
  [2716] = {.lex_state = 13},
  [2717] = {.lex_state = 68},
  [2718] = {.lex_state = 68},
  [2719] = {.lex_state = 68},
  [2720] = {.lex_state = 68},
  [2721] = {.lex_state = 16},
  [2722] = {.lex_state = 68},
  [2723] = {.lex_state = 16},
  [2724] = {.lex_state = 68},
  [2725] = {.lex_state = 68},
  [2726] = {.lex_state = 68},
  [2727] = {.lex_state = 13},
  [2728] = {.lex_state = 3},
  [2729] = {.lex_state = 68},
  [2730] = {.lex_state = 68},
  [2731] = {.lex_state = 68},
  [2732] = {.lex_state = 13},
  [2733] = {.lex_state = 68},
  [2734] = {.lex_state = 68},
  [2735] = {.lex_state = 68},
  [2736] = {.lex_state = 68},
  [2737] = {.lex_state = 68},
  [2738] = {.lex_state = 17},
  [2739] = {.lex_state = 68},
  [2740] = {.lex_state = 68},
  [2741] = {.lex_state = 68},
  [2742] = {.lex_state = 68},
  [2743] = {.lex_state = 68},
  [2744] = {.lex_state = 68},
  [2745] = {.lex_state = 68},
  [2746] = {.lex_state = 68},
  [2747] = {.lex_state = 68},
  [2748] = {.lex_state = 68},
  [2749] = {.lex_state = 68},
  [2750] = {.lex_state = 68},
  [2751] = {.lex_state = 68},
  [2752] = {.lex_state = 68},
  [2753] = {.lex_state = 68},
  [2754] = {.lex_state = 68},
  [2755] = {.lex_state = 13},
  [2756] = {.lex_state = 68},
  [2757] = {.lex_state = 68},
  [2758] = {.lex_state = 68},
  [2759] = {.lex_state = 68},
  [2760] = {.lex_state = 68},
  [2761] = {.lex_state = 17},
  [2762] = {.lex_state = 68},
  [2763] = {.lex_state = 68},
  [2764] = {.lex_state = 68},
  [2765] = {.lex_state = 16},
  [2766] = {.lex_state = 68},
  [2767] = {.lex_state = 16},
  [2768] = {.lex_state = 68},
  [2769] = {.lex_state = 16},
  [2770] = {.lex_state = 16},
  [2771] = {.lex_state = 68},
  [2772] = {.lex_state = 16},
  [2773] = {.lex_state = 13},
  [2774] = {.lex_state = 16},
  [2775] = {.lex_state = 16},
  [2776] = {.lex_state = 68},
  [2777] = {.lex_state = 13},
  [2778] = {.lex_state = 13},
  [2779] = {.lex_state = 16},
  [2780] = {.lex_state = 68},
  [2781] = {.lex_state = 68},
  [2782] = {.lex_state = 68},
  [2783] = {.lex_state = 68},
  [2784] = {.lex_state = 68},
  [2785] = {.lex_state = 68},
  [2786] = {.lex_state = 68},
  [2787] = {.lex_state = 68},
  [2788] = {.lex_state = 13},
  [2789] = {.lex_state = 68},
  [2790] = {.lex_state = 68},
  [2791] = {.lex_state = 13},
  [2792] = {.lex_state = 26},
  [2793] = {.lex_state = 68},
  [2794] = {.lex_state = 68},
  [2795] = {.lex_state = 3},
  [2796] = {.lex_state = 68},
  [2797] = {.lex_state = 68},
  [2798] = {.lex_state = 68},
  [2799] = {.lex_state = 68},
  [2800] = {.lex_state = 68},
  [2801] = {.lex_state = 68},
  [2802] = {.lex_state = 68},
  [2803] = {.lex_state = 68},
  [2804] = {.lex_state = 68},
  [2805] = {.lex_state = 68},
  [2806] = {.lex_state = 68},
  [2807] = {.lex_state = 13},
  [2808] = {.lex_state = 3},
  [2809] = {.lex_state = 68},
  [2810] = {.lex_state = 68},
  [2811] = {.lex_state = 13},
  [2812] = {.lex_state = 3},
  [2813] = {.lex_state = 68},
  [2814] = {.lex_state = 68},
  [2815] = {.lex_state = 68},
  [2816] = {.lex_state = 68},
  [2817] = {.lex_state = 68},
  [2818] = {.lex_state = 16},
  [2819] = {.lex_state = 68},
  [2820] = {.lex_state = 68},
  [2821] = {.lex_state = 16},
  [2822] = {.lex_state = 68},
  [2823] = {.lex_state = 13},
  [2824] = {.lex_state = 68},
  [2825] = {.lex_state = 68},
  [2826] = {.lex_state = 68},
  [2827] = {.lex_state = 7},
  [2828] = {.lex_state = 7},
  [2829] = {.lex_state = 68},
  [2830] = {.lex_state = 68},
  [2831] = {.lex_state = 16},
  [2832] = {.lex_state = 68},
  [2833] = {.lex_state = 16},
  [2834] = {.lex_state = 68},
  [2835] = {.lex_state = 16},
  [2836] = {.lex_state = 68},
  [2837] = {.lex_state = 68},
  [2838] = {.lex_state = 68},
  [2839] = {.lex_state = 16},
  [2840] = {.lex_state = 16},
  [2841] = {.lex_state = 16},
  [2842] = {.lex_state = 68},
  [2843] = {.lex_state = 68},
  [2844] = {.lex_state = 68},
  [2845] = {.lex_state = 68},
  [2846] = {.lex_state = 16},
  [2847] = {.lex_state = 68},
  [2848] = {.lex_state = 68},
  [2849] = {.lex_state = 16},
  [2850] = {.lex_state = 68},
  [2851] = {.lex_state = 3},
  [2852] = {.lex_state = 13},
  [2853] = {.lex_state = 68},
  [2854] = {.lex_state = 68},
  [2855] = {.lex_state = 16},
  [2856] = {.lex_state = 68},
  [2857] = {.lex_state = 68},
  [2858] = {.lex_state = 16},
  [2859] = {.lex_state = 68},
  [2860] = {.lex_state = 68},
  [2861] = {.lex_state = 17},
  [2862] = {.lex_state = 68},
  [2863] = {.lex_state = 16},
  [2864] = {.lex_state = 68},
  [2865] = {.lex_state = 68},
  [2866] = {.lex_state = 68},
  [2867] = {.lex_state = 13},
  [2868] = {.lex_state = 68},
  [2869] = {.lex_state = 7},
  [2870] = {.lex_state = 68},
  [2871] = {.lex_state = 13},
  [2872] = {.lex_state = 16},
  [2873] = {.lex_state = 13},
  [2874] = {.lex_state = 68},
  [2875] = {.lex_state = 68},
  [2876] = {.lex_state = 7},
  [2877] = {.lex_state = 68},
  [2878] = {.lex_state = 68},
  [2879] = {.lex_state = 68},
  [2880] = {.lex_state = 68},
  [2881] = {.lex_state = 68},
  [2882] = {.lex_state = 68},
  [2883] = {.lex_state = 68},
  [2884] = {.lex_state = 68},
  [2885] = {.lex_state = 68},
  [2886] = {.lex_state = 3},
  [2887] = {.lex_state = 68},
  [2888] = {.lex_state = 13},
  [2889] = {.lex_state = 68},
  [2890] = {.lex_state = 13},
  [2891] = {.lex_state = 68},
  [2892] = {.lex_state = 7, .external_lex_state = 4},
  [2893] = {.lex_state = 68},
  [2894] = {.lex_state = 68},
  [2895] = {.lex_state = 68},
  [2896] = {.lex_state = 17},
  [2897] = {.lex_state = 68},
  [2898] = {.lex_state = 68},
  [2899] = {.lex_state = 68},
  [2900] = {.lex_state = 68},
  [2901] = {.lex_state = 68},
  [2902] = {.lex_state = 16},
  [2903] = {.lex_state = 16},
  [2904] = {.lex_state = 68},
  [2905] = {.lex_state = 68},
  [2906] = {.lex_state = 16},
  [2907] = {.lex_state = 16},
  [2908] = {.lex_state = 68},
  [2909] = {.lex_state = 68},
  [2910] = {.lex_state = 16},
  [2911] = {.lex_state = 68},
  [2912] = {.lex_state = 68},
  [2913] = {.lex_state = 68},
  [2914] = {.lex_state = 68},
  [2915] = {.lex_state = 68},
  [2916] = {.lex_state = 68},
  [2917] = {.lex_state = 68},
  [2918] = {.lex_state = 68},
  [2919] = {.lex_state = 68},
  [2920] = {.lex_state = 68},
  [2921] = {.lex_state = 68},
  [2922] = {.lex_state = 68},
  [2923] = {.lex_state = 13},
  [2924] = {.lex_state = 68},
  [2925] = {.lex_state = 68},
  [2926] = {.lex_state = 68},
  [2927] = {.lex_state = 68},
  [2928] = {.lex_state = 68},
  [2929] = {.lex_state = 68},
  [2930] = {.lex_state = 68},
  [2931] = {.lex_state = 3},
  [2932] = {.lex_state = 3},
  [2933] = {.lex_state = 68},
  [2934] = {.lex_state = 68},
  [2935] = {.lex_state = 68},
  [2936] = {.lex_state = 68},
  [2937] = {.lex_state = 68},
  [2938] = {.lex_state = 68},
  [2939] = {.lex_state = 13},
  [2940] = {.lex_state = 16},
  [2941] = {.lex_state = 68},
  [2942] = {.lex_state = 68},
  [2943] = {.lex_state = 68},
  [2944] = {.lex_state = 68},
  [2945] = {.lex_state = 13},
  [2946] = {.lex_state = 68},
  [2947] = {.lex_state = 17},
  [2948] = {.lex_state = 68},
  [2949] = {.lex_state = 68},
  [2950] = {.lex_state = 68},
  [2951] = {.lex_state = 68},
  [2952] = {.lex_state = 68},
  [2953] = {.lex_state = 68},
  [2954] = {.lex_state = 68},
  [2955] = {.lex_state = 68},
  [2956] = {.lex_state = 68},
  [2957] = {.lex_state = 68},
  [2958] = {.lex_state = 68},
  [2959] = {.lex_state = 16},
  [2960] = {.lex_state = 68},
  [2961] = {.lex_state = 16},
  [2962] = {.lex_state = 68},
  [2963] = {.lex_state = 13},
  [2964] = {.lex_state = 68},
  [2965] = {.lex_state = 68},
  [2966] = {.lex_state = 68},
  [2967] = {.lex_state = 16},
  [2968] = {.lex_state = 68},
  [2969] = {.lex_state = 16},
  [2970] = {.lex_state = 68},
  [2971] = {.lex_state = 3},
  [2972] = {.lex_state = 68},
  [2973] = {.lex_state = 68},
  [2974] = {.lex_state = 68},
  [2975] = {.lex_state = 68},
  [2976] = {.lex_state = 68},
  [2977] = {.lex_state = 13},
  [2978] = {.lex_state = 68},
  [2979] = {.lex_state = 13},
  [2980] = {.lex_state = 13},
  [2981] = {.lex_state = 68},
  [2982] = {.lex_state = 68},
  [2983] = {.lex_state = 68},
  [2984] = {.lex_state = 13},
  [2985] = {.lex_state = 68},
  [2986] = {.lex_state = 68},
  [2987] = {.lex_state = 13},
  [2988] = {.lex_state = 68},
  [2989] = {.lex_state = 13},
  [2990] = {.lex_state = 13},
  [2991] = {.lex_state = 13},
  [2992] = {.lex_state = 13},
  [2993] = {.lex_state = 68},
  [2994] = {.lex_state = 13},
  [2995] = {.lex_state = 68},
  [2996] = {.lex_state = 13},
  [2997] = {.lex_state = 13},
  [2998] = {.lex_state = 13},
  [2999] = {.lex_state = 68},
  [3000] = {.lex_state = 13},
  [3001] = {.lex_state = 3},
  [3002] = {.lex_state = 13},
  [3003] = {.lex_state = 68},
  [3004] = {.lex_state = 13},
  [3005] = {.lex_state = 13},
  [3006] = {.lex_state = 68},
  [3007] = {.lex_state = 13},
  [3008] = {.lex_state = 68},
  [3009] = {.lex_state = 68},
  [3010] = {.lex_state = 13},
  [3011] = {.lex_state = 13},
  [3012] = {.lex_state = 13},
  [3013] = {.lex_state = 3},
  [3014] = {.lex_state = 68},
  [3015] = {.lex_state = 13},
  [3016] = {.lex_state = 13},
  [3017] = {.lex_state = 13},
  [3018] = {.lex_state = 13},
  [3019] = {.lex_state = 68},
  [3020] = {.lex_state = 13},
  [3021] = {.lex_state = 68},
  [3022] = {.lex_state = 68},
  [3023] = {.lex_state = 13},
  [3024] = {.lex_state = 13},
  [3025] = {.lex_state = 68},
  [3026] = {.lex_state = 13},
  [3027] = {.lex_state = 13},
  [3028] = {.lex_state = 13},
  [3029] = {.lex_state = 13},
  [3030] = {.lex_state = 13},
  [3031] = {.lex_state = 68},
  [3032] = {.lex_state = 68},
  [3033] = {.lex_state = 68},
  [3034] = {.lex_state = 13},
  [3035] = {.lex_state = 68},
  [3036] = {.lex_state = 13},
  [3037] = {.lex_state = 68},
  [3038] = {.lex_state = 68},
  [3039] = {.lex_state = 13},
  [3040] = {.lex_state = 13},
  [3041] = {.lex_state = 68},
  [3042] = {.lex_state = 17},
  [3043] = {.lex_state = 68},
  [3044] = {.lex_state = 68},
  [3045] = {.lex_state = 13},
  [3046] = {.lex_state = 13},
  [3047] = {.lex_state = 13},
  [3048] = {.lex_state = 13},
  [3049] = {.lex_state = 13},
  [3050] = {.lex_state = 68},
  [3051] = {.lex_state = 13},
  [3052] = {.lex_state = 13},
  [3053] = {.lex_state = 68},
  [3054] = {.lex_state = 68},
  [3055] = {.lex_state = 68},
  [3056] = {.lex_state = 13},
  [3057] = {.lex_state = 68},
  [3058] = {.lex_state = 68},
  [3059] = {.lex_state = 13},
  [3060] = {.lex_state = 13},
  [3061] = {.lex_state = 68},
  [3062] = {.lex_state = 68},
  [3063] = {.lex_state = 13},
  [3064] = {.lex_state = 13},
  [3065] = {.lex_state = 68},
  [3066] = {.lex_state = 13},
  [3067] = {.lex_state = 68},
  [3068] = {.lex_state = 13},
  [3069] = {.lex_state = 68},
  [3070] = {.lex_state = 68},
  [3071] = {.lex_state = 68},
  [3072] = {.lex_state = 68},
  [3073] = {.lex_state = 68},
  [3074] = {.lex_state = 68},
  [3075] = {.lex_state = 13},
  [3076] = {.lex_state = 68},
  [3077] = {.lex_state = 13},
  [3078] = {.lex_state = 68},
  [3079] = {.lex_state = 68},
  [3080] = {.lex_state = 7},
  [3081] = {.lex_state = 2},
  [3082] = {.lex_state = 68},
  [3083] = {.lex_state = 68},
  [3084] = {.lex_state = 2},
  [3085] = {.lex_state = 13},
  [3086] = {.lex_state = 68},
  [3087] = {.lex_state = 13},
  [3088] = {.lex_state = 13},
  [3089] = {.lex_state = 68},
  [3090] = {.lex_state = 13},
  [3091] = {.lex_state = 68},
  [3092] = {.lex_state = 13},
  [3093] = {.lex_state = 68},
  [3094] = {.lex_state = 68},
  [3095] = {.lex_state = 68, .external_lex_state = 5},
  [3096] = {.lex_state = 68},
  [3097] = {.lex_state = 13},
  [3098] = {.lex_state = 68},
  [3099] = {.lex_state = 68},
  [3100] = {.lex_state = 68},
  [3101] = {.lex_state = 68},
  [3102] = {.lex_state = 68},
  [3103] = {.lex_state = 13},
  [3104] = {.lex_state = 68},
  [3105] = {.lex_state = 68},
  [3106] = {.lex_state = 68},
  [3107] = {.lex_state = 13},
  [3108] = {.lex_state = 68},
  [3109] = {.lex_state = 68},
  [3110] = {.lex_state = 13},
  [3111] = {.lex_state = 13},
  [3112] = {.lex_state = 13},
  [3113] = {.lex_state = 13},
  [3114] = {.lex_state = 68},
  [3115] = {.lex_state = 68},
  [3116] = {.lex_state = 13},
  [3117] = {.lex_state = 68},
  [3118] = {.lex_state = 13},
  [3119] = {.lex_state = 13},
  [3120] = {.lex_state = 13},
  [3121] = {.lex_state = 68},
  [3122] = {.lex_state = 13},
  [3123] = {.lex_state = 68},
  [3124] = {.lex_state = 68},
  [3125] = {.lex_state = 68},
  [3126] = {.lex_state = 68},
  [3127] = {.lex_state = 68},
  [3128] = {.lex_state = 13},
  [3129] = {.lex_state = 68},
  [3130] = {.lex_state = 68},
  [3131] = {.lex_state = 68},
  [3132] = {.lex_state = 68},
  [3133] = {.lex_state = 68},
  [3134] = {.lex_state = 6},
  [3135] = {.lex_state = 68},
  [3136] = {.lex_state = 68},
  [3137] = {.lex_state = 68},
  [3138] = {.lex_state = 68},
  [3139] = {.lex_state = 13},
  [3140] = {.lex_state = 68},
  [3141] = {.lex_state = 68},
  [3142] = {.lex_state = 26},
  [3143] = {.lex_state = 68},
  [3144] = {.lex_state = 68},
  [3145] = {.lex_state = 68, .external_lex_state = 5},
  [3146] = {.lex_state = 13},
  [3147] = {.lex_state = 68},
  [3148] = {.lex_state = 68},
  [3149] = {.lex_state = 68},
  [3150] = {.lex_state = 68},
  [3151] = {.lex_state = 68},
  [3152] = {.lex_state = 68},
  [3153] = {.lex_state = 13},
  [3154] = {.lex_state = 68},
  [3155] = {.lex_state = 13},
  [3156] = {.lex_state = 13},
  [3157] = {.lex_state = 68},
  [3158] = {.lex_state = 68},
  [3159] = {.lex_state = 68},
  [3160] = {.lex_state = 68},
  [3161] = {.lex_state = 68},
  [3162] = {.lex_state = 68},
  [3163] = {.lex_state = 13},
  [3164] = {.lex_state = 68},
  [3165] = {.lex_state = 68},
  [3166] = {.lex_state = 68},
  [3167] = {.lex_state = 68},
  [3168] = {.lex_state = 68},
  [3169] = {.lex_state = 68},
  [3170] = {.lex_state = 68},
  [3171] = {.lex_state = 68},
  [3172] = {.lex_state = 13},
  [3173] = {.lex_state = 13},
  [3174] = {.lex_state = 13},
  [3175] = {.lex_state = 68},
  [3176] = {.lex_state = 68},
  [3177] = {.lex_state = 68},
  [3178] = {.lex_state = 13},
  [3179] = {.lex_state = 13},
  [3180] = {.lex_state = 13},
  [3181] = {.lex_state = 13},
  [3182] = {.lex_state = 68},
  [3183] = {.lex_state = 68},
  [3184] = {.lex_state = 68},
  [3185] = {.lex_state = 68},
  [3186] = {.lex_state = 68},
  [3187] = {.lex_state = 68},
  [3188] = {.lex_state = 13},
  [3189] = {.lex_state = 68},
  [3190] = {.lex_state = 68},
  [3191] = {.lex_state = 68},
  [3192] = {.lex_state = 68},
  [3193] = {.lex_state = 68},
  [3194] = {.lex_state = 68},
  [3195] = {.lex_state = 68},
  [3196] = {.lex_state = 68},
  [3197] = {.lex_state = 13},
  [3198] = {.lex_state = 13},
  [3199] = {.lex_state = 68},
  [3200] = {.lex_state = 68},
  [3201] = {.lex_state = 13},
  [3202] = {.lex_state = 26},
  [3203] = {.lex_state = 13},
  [3204] = {.lex_state = 13},
  [3205] = {.lex_state = 26},
  [3206] = {.lex_state = 7},
  [3207] = {.lex_state = 68},
  [3208] = {.lex_state = 68},
  [3209] = {.lex_state = 68},
  [3210] = {.lex_state = 13},
  [3211] = {.lex_state = 13},
  [3212] = {.lex_state = 68},
  [3213] = {.lex_state = 13},
  [3214] = {.lex_state = 13},
  [3215] = {.lex_state = 13},
  [3216] = {.lex_state = 68},
  [3217] = {.lex_state = 13},
  [3218] = {.lex_state = 13},
  [3219] = {.lex_state = 26},
  [3220] = {.lex_state = 68},
  [3221] = {.lex_state = 13},
  [3222] = {.lex_state = 13},
  [3223] = {.lex_state = 68},
  [3224] = {.lex_state = 68},
  [3225] = {.lex_state = 13},
  [3226] = {.lex_state = 13},
  [3227] = {.lex_state = 68},
  [3228] = {.lex_state = 26},
  [3229] = {.lex_state = 68},
  [3230] = {.lex_state = 13},
  [3231] = {.lex_state = 68},
  [3232] = {.lex_state = 13},
  [3233] = {.lex_state = 68},
  [3234] = {.lex_state = 68},
  [3235] = {.lex_state = 68},
  [3236] = {.lex_state = 13},
  [3237] = {.lex_state = 68},
  [3238] = {.lex_state = 68},
  [3239] = {.lex_state = 26},
  [3240] = {.lex_state = 68},
  [3241] = {.lex_state = 13},
  [3242] = {.lex_state = 68},
  [3243] = {.lex_state = 68},
  [3244] = {.lex_state = 68},
  [3245] = {.lex_state = 68},
  [3246] = {.lex_state = 68},
  [3247] = {.lex_state = 68},
  [3248] = {.lex_state = 68},
  [3249] = {.lex_state = 13},
  [3250] = {.lex_state = 68},
  [3251] = {.lex_state = 13},
  [3252] = {.lex_state = 13},
  [3253] = {.lex_state = 68},
  [3254] = {.lex_state = 13},
  [3255] = {.lex_state = 17},
  [3256] = {.lex_state = 68},
  [3257] = {.lex_state = 17},
  [3258] = {.lex_state = 13},
  [3259] = {.lex_state = 68},
  [3260] = {.lex_state = 17},
  [3261] = {.lex_state = 13},
  [3262] = {.lex_state = 68},
  [3263] = {.lex_state = 68},
  [3264] = {.lex_state = 69},
  [3265] = {.lex_state = 68},
  [3266] = {.lex_state = 68},
  [3267] = {.lex_state = 68},
  [3268] = {.lex_state = 13},
  [3269] = {.lex_state = 68},
  [3270] = {.lex_state = 13},
  [3271] = {.lex_state = 13},
  [3272] = {.lex_state = 13},
  [3273] = {.lex_state = 13},
  [3274] = {.lex_state = 13},
  [3275] = {.lex_state = 13},
  [3276] = {.lex_state = 68},
  [3277] = {.lex_state = 68},
  [3278] = {.lex_state = 68},
  [3279] = {.lex_state = 69},
  [3280] = {.lex_state = 69},
  [3281] = {.lex_state = 69},
  [3282] = {.lex_state = 68},
  [3283] = {.lex_state = 13},
  [3284] = {.lex_state = 68},
  [3285] = {.lex_state = 17},
  [3286] = {.lex_state = 68},
  [3287] = {.lex_state = 68},
  [3288] = {.lex_state = 68},
  [3289] = {.lex_state = 68},
  [3290] = {.lex_state = 13},
  [3291] = {.lex_state = 68},
  [3292] = {.lex_state = 68},
  [3293] = {.lex_state = 13},
  [3294] = {.lex_state = 68},
  [3295] = {.lex_state = 68},
  [3296] = {.lex_state = 68},
  [3297] = {.lex_state = 13},
  [3298] = {.lex_state = 68},
  [3299] = {.lex_state = 68},
  [3300] = {.lex_state = 68},
  [3301] = {.lex_state = 68},
  [3302] = {.lex_state = 68},
  [3303] = {.lex_state = 68},
  [3304] = {.lex_state = 13},
  [3305] = {.lex_state = 68},
  [3306] = {.lex_state = 68},
  [3307] = {.lex_state = 13},
  [3308] = {.lex_state = 13},
  [3309] = {.lex_state = 68},
  [3310] = {.lex_state = 68},
  [3311] = {.lex_state = 13},
  [3312] = {.lex_state = 17},
  [3313] = {.lex_state = 68},
  [3314] = {.lex_state = 68},
  [3315] = {.lex_state = 68},
  [3316] = {.lex_state = 68},
  [3317] = {.lex_state = 13},
  [3318] = {.lex_state = 68},
  [3319] = {.lex_state = 13},
  [3320] = {.lex_state = 68},
  [3321] = {.lex_state = 68},
  [3322] = {.lex_state = 13},
  [3323] = {.lex_state = 68},
  [3324] = {.lex_state = 68},
  [3325] = {.lex_state = 68},
  [3326] = {.lex_state = 68},
  [3327] = {.lex_state = 68},
  [3328] = {.lex_state = 69},
  [3329] = {.lex_state = 13},
  [3330] = {.lex_state = 68},
  [3331] = {.lex_state = 68},
  [3332] = {.lex_state = 68},
  [3333] = {.lex_state = 68},
  [3334] = {.lex_state = 68},
  [3335] = {.lex_state = 68},
  [3336] = {.lex_state = 68},
  [3337] = {.lex_state = 68},
  [3338] = {.lex_state = 17},
  [3339] = {.lex_state = 13},
  [3340] = {.lex_state = 68},
  [3341] = {.lex_state = 68},
  [3342] = {.lex_state = 68},
  [3343] = {.lex_state = 68},
  [3344] = {.lex_state = 13},
  [3345] = {.lex_state = 68},
  [3346] = {.lex_state = 68},
  [3347] = {.lex_state = 68},
  [3348] = {.lex_state = 68},
  [3349] = {.lex_state = 68},
  [3350] = {.lex_state = 68},
  [3351] = {.lex_state = 13},
  [3352] = {.lex_state = 13},
  [3353] = {.lex_state = 13},
  [3354] = {.lex_state = 17},
  [3355] = {.lex_state = 13},
  [3356] = {.lex_state = 68},
  [3357] = {.lex_state = 68},
  [3358] = {.lex_state = 68},
  [3359] = {.lex_state = 7, .external_lex_state = 6},
  [3360] = {.lex_state = 13},
  [3361] = {.lex_state = 7, .external_lex_state = 6},
  [3362] = {.lex_state = 7, .external_lex_state = 6},
  [3363] = {.lex_state = 169},
  [3364] = {.lex_state = 13},
  [3365] = {.lex_state = 13},
  [3366] = {.lex_state = 169},
  [3367] = {.lex_state = 68},
  [3368] = {.lex_state = 169},
  [3369] = {.lex_state = 68},
  [3370] = {.lex_state = 68},
  [3371] = {.lex_state = 68},
  [3372] = {.lex_state = 169},
  [3373] = {.lex_state = 68},
  [3374] = {.lex_state = 17},
  [3375] = {.lex_state = 68},
  [3376] = {.lex_state = 68},
  [3377] = {.lex_state = 68},
  [3378] = {.lex_state = 68},
  [3379] = {.lex_state = 68},
  [3380] = {.lex_state = 68},
  [3381] = {.lex_state = 68},
  [3382] = {.lex_state = 68},
  [3383] = {.lex_state = 13},
  [3384] = {.lex_state = 68},
  [3385] = {.lex_state = 13},
  [3386] = {.lex_state = 68},
  [3387] = {.lex_state = 68},
  [3388] = {.lex_state = 68},
  [3389] = {.lex_state = 68},
  [3390] = {.lex_state = 68},
  [3391] = {.lex_state = 68},
  [3392] = {.lex_state = 13},
  [3393] = {.lex_state = 68},
  [3394] = {.lex_state = 68},
  [3395] = {.lex_state = 68},
  [3396] = {.lex_state = 13},
  [3397] = {.lex_state = 68},
  [3398] = {.lex_state = 68},
  [3399] = {.lex_state = 68},
  [3400] = {.lex_state = 68},
  [3401] = {.lex_state = 68},
  [3402] = {.lex_state = 68},
  [3403] = {.lex_state = 68},
  [3404] = {.lex_state = 13},
  [3405] = {.lex_state = 68},
  [3406] = {.lex_state = 68},
  [3407] = {.lex_state = 13},
  [3408] = {.lex_state = 68},
  [3409] = {.lex_state = 68},
  [3410] = {.lex_state = 13},
  [3411] = {.lex_state = 68},
  [3412] = {.lex_state = 13},
  [3413] = {.lex_state = 13},
  [3414] = {.lex_state = 13},
  [3415] = {.lex_state = 69},
  [3416] = {.lex_state = 13},
  [3417] = {.lex_state = 68},
  [3418] = {.lex_state = 13},
  [3419] = {.lex_state = 68},
  [3420] = {.lex_state = 68},
  [3421] = {.lex_state = 68},
  [3422] = {.lex_state = 17},
  [3423] = {.lex_state = 68},
  [3424] = {.lex_state = 68},
  [3425] = {.lex_state = 68},
  [3426] = {.lex_state = 13},
  [3427] = {.lex_state = 68},
  [3428] = {.lex_state = 68},
  [3429] = {.lex_state = 13},
  [3430] = {.lex_state = 13},
  [3431] = {.lex_state = 68},
  [3432] = {.lex_state = 68},
  [3433] = {.lex_state = 68},
  [3434] = {.lex_state = 68},
  [3435] = {.lex_state = 68},
  [3436] = {.lex_state = 68},
  [3437] = {.lex_state = 68},
  [3438] = {.lex_state = 68},
  [3439] = {.lex_state = 68},
  [3440] = {.lex_state = 68},
  [3441] = {.lex_state = 68},
  [3442] = {.lex_state = 68},
  [3443] = {.lex_state = 68},
  [3444] = {.lex_state = 68},
  [3445] = {.lex_state = 68},
  [3446] = {.lex_state = 68},
  [3447] = {.lex_state = 68},
  [3448] = {.lex_state = 68},
  [3449] = {.lex_state = 13},
  [3450] = {.lex_state = 13},
  [3451] = {.lex_state = 68},
  [3452] = {.lex_state = 17},
  [3453] = {.lex_state = 68},
  [3454] = {.lex_state = 69},
  [3455] = {.lex_state = 68},
  [3456] = {.lex_state = 17},
  [3457] = {.lex_state = 17},
  [3458] = {.lex_state = 13},
  [3459] = {.lex_state = 13},
  [3460] = {.lex_state = 68},
  [3461] = {.lex_state = 13},
  [3462] = {.lex_state = 17},
  [3463] = {.lex_state = 13},
  [3464] = {.lex_state = 68},
  [3465] = {.lex_state = 68},
  [3466] = {.lex_state = 13},
  [3467] = {.lex_state = 68},
  [3468] = {.lex_state = 68},
  [3469] = {.lex_state = 68},
  [3470] = {.lex_state = 68},
  [3471] = {.lex_state = 68},
  [3472] = {.lex_state = 17},
  [3473] = {.lex_state = 13},
  [3474] = {.lex_state = 68},
  [3475] = {.lex_state = 68},
  [3476] = {.lex_state = 17},
  [3477] = {.lex_state = 13},
  [3478] = {.lex_state = 68},
  [3479] = {.lex_state = 69},
  [3480] = {.lex_state = 68},
  [3481] = {.lex_state = 17},
  [3482] = {.lex_state = 17},
  [3483] = {.lex_state = 68},
  [3484] = {.lex_state = 68},
  [3485] = {.lex_state = 68},
  [3486] = {.lex_state = 68},
  [3487] = {.lex_state = 68},
  [3488] = {.lex_state = 68},
  [3489] = {.lex_state = 68},
  [3490] = {.lex_state = 68},
  [3491] = {.lex_state = 68},
  [3492] = {.lex_state = 17},
  [3493] = {.lex_state = 68},
  [3494] = {.lex_state = 17},
  [3495] = {.lex_state = 17},
  [3496] = {.lex_state = 68},
  [3497] = {.lex_state = 17},
  [3498] = {.lex_state = 13},
  [3499] = {.lex_state = 68},
  [3500] = {.lex_state = 17},
  [3501] = {.lex_state = 17},
  [3502] = {.lex_state = 68},
  [3503] = {.lex_state = 68},
  [3504] = {.lex_state = 17},
  [3505] = {.lex_state = 17},
  [3506] = {.lex_state = 17},
  [3507] = {.lex_state = 69},
  [3508] = {.lex_state = 13},
  [3509] = {.lex_state = 13},
  [3510] = {.lex_state = 68},
  [3511] = {.lex_state = 13},
  [3512] = {.lex_state = 68},
  [3513] = {.lex_state = 68},
  [3514] = {.lex_state = 13},
  [3515] = {.lex_state = 13},
  [3516] = {.lex_state = 13},
  [3517] = {.lex_state = 13},
  [3518] = {.lex_state = 68},
  [3519] = {.lex_state = 13},
  [3520] = {.lex_state = 13},
  [3521] = {.lex_state = 68},
  [3522] = {(TSStateId)(-1)},
  [3523] = {(TSStateId)(-1)},
  [3524] = {(TSStateId)(-1)},
  [3525] = {(TSStateId)(-1)},
  [3526] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_line_comment] = STATE(0),
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_macro_rules_BANG] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_expr] = ACTIONS(1),
    [anon_sym_ident] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_lifetime] = ACTIONS(1),
    [anon_sym_literal] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_pat] = ACTIONS(1),
    [anon_sym_path] = ACTIONS(1),
    [anon_sym_stmt] = ACTIONS(1),
    [anon_sym_tt] = ACTIONS(1),
    [anon_sym_ty] = ACTIONS(1),
    [anon_sym_vis] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_dyn] = ACTIONS(1),
    [sym_mutable_specifier] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_move] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [aux_sym_string_literal_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [sym__inner_line_doc_comment] = ACTIONS(1),
    [sym__outer_line_doc_comment] = ACTIONS(1),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [sym_shebang] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_crate] = ACTIONS(1),
    [sym_metavariable] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym__outer_block_doc_comment] = ACTIONS(1),
    [sym__inner_block_doc_comment] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(3384),
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(1),
    [sym_block_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_shebang] = ACTIONS(105),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [2] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1828),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(2),
    [sym_block_comment] = STATE(2),
    [aux_sym_source_file_repeat1] = STATE(21),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [3] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1804),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(3),
    [sym_block_comment] = STATE(3),
    [aux_sym_source_file_repeat1] = STATE(26),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [4] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(4),
    [sym_block_comment] = STATE(4),
    [aux_sym_source_file_repeat1] = STATE(5),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [5] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1774),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(5),
    [sym_block_comment] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [6] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1826),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(6),
    [sym_block_comment] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(125),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [7] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1830),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(7),
    [sym_block_comment] = STATE(7),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(127),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [8] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1833),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(8),
    [sym_block_comment] = STATE(8),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [9] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1743),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(9),
    [sym_block_comment] = STATE(9),
    [aux_sym_source_file_repeat1] = STATE(20),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [10] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1834),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(10),
    [sym_block_comment] = STATE(10),
    [aux_sym_source_file_repeat1] = STATE(8),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [11] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1791),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(11),
    [sym_block_comment] = STATE(11),
    [aux_sym_source_file_repeat1] = STATE(34),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [12] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(12),
    [sym_block_comment] = STATE(12),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [13] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1836),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(13),
    [sym_block_comment] = STATE(13),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [14] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1837),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(14),
    [sym_block_comment] = STATE(14),
    [aux_sym_source_file_repeat1] = STATE(13),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [15] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1831),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(15),
    [sym_block_comment] = STATE(15),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [16] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1839),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(16),
    [sym_block_comment] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(15),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [17] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(17),
    [sym_block_comment] = STATE(17),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [18] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1742),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(18),
    [sym_block_comment] = STATE(18),
    [aux_sym_source_file_repeat1] = STATE(17),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [19] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1825),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(19),
    [sym_block_comment] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [20] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1741),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(20),
    [sym_block_comment] = STATE(20),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [21] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1829),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(21),
    [sym_block_comment] = STATE(21),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [22] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1755),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(22),
    [sym_block_comment] = STATE(22),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [23] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(23),
    [sym_block_comment] = STATE(23),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [ts_builtin_sym_end] = ACTIONS(159),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(164),
    [anon_sym_macro_rules_BANG] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(170),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(176),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_u8] = ACTIONS(182),
    [anon_sym_i8] = ACTIONS(182),
    [anon_sym_u16] = ACTIONS(182),
    [anon_sym_i16] = ACTIONS(182),
    [anon_sym_u32] = ACTIONS(182),
    [anon_sym_i32] = ACTIONS(182),
    [anon_sym_u64] = ACTIONS(182),
    [anon_sym_i64] = ACTIONS(182),
    [anon_sym_u128] = ACTIONS(182),
    [anon_sym_i128] = ACTIONS(182),
    [anon_sym_isize] = ACTIONS(182),
    [anon_sym_usize] = ACTIONS(182),
    [anon_sym_f32] = ACTIONS(182),
    [anon_sym_f64] = ACTIONS(182),
    [anon_sym_bool] = ACTIONS(182),
    [anon_sym_str] = ACTIONS(182),
    [anon_sym_char] = ACTIONS(182),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(188),
    [anon_sym_POUND] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(194),
    [anon_sym_PIPE] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(200),
    [anon_sym_async] = ACTIONS(203),
    [anon_sym_break] = ACTIONS(206),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_continue] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_enum] = ACTIONS(218),
    [anon_sym_fn] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_impl] = ACTIONS(230),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_loop] = ACTIONS(236),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_mod] = ACTIONS(242),
    [anon_sym_pub] = ACTIONS(245),
    [anon_sym_return] = ACTIONS(248),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(254),
    [anon_sym_trait] = ACTIONS(257),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_union] = ACTIONS(263),
    [anon_sym_unsafe] = ACTIONS(266),
    [anon_sym_use] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(272),
    [anon_sym_extern] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(278),
    [anon_sym_yield] = ACTIONS(281),
    [anon_sym_move] = ACTIONS(284),
    [anon_sym_try] = ACTIONS(287),
    [sym_integer_literal] = ACTIONS(290),
    [aux_sym_string_literal_token1] = ACTIONS(293),
    [sym_char_literal] = ACTIONS(290),
    [anon_sym_true] = ACTIONS(296),
    [anon_sym_false] = ACTIONS(296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(299),
    [sym_super] = ACTIONS(302),
    [sym_crate] = ACTIONS(305),
    [sym_metavariable] = ACTIONS(308),
    [sym_raw_string_literal] = ACTIONS(290),
    [sym_float_literal] = ACTIONS(290),
  },
  [24] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(24),
    [sym_block_comment] = STATE(24),
    [aux_sym_source_file_repeat1] = STATE(31),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [25] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1817),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(25),
    [sym_block_comment] = STATE(25),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(311),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [26] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1807),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(26),
    [sym_block_comment] = STATE(26),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(313),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [27] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1814),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(27),
    [sym_block_comment] = STATE(27),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(315),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [28] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1792),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(28),
    [sym_block_comment] = STATE(28),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(317),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [29] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(318),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(29),
    [sym_block_comment] = STATE(29),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(164),
    [anon_sym_macro_rules_BANG] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(170),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(176),
    [anon_sym_RBRACE] = ACTIONS(159),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_u8] = ACTIONS(182),
    [anon_sym_i8] = ACTIONS(182),
    [anon_sym_u16] = ACTIONS(182),
    [anon_sym_i16] = ACTIONS(182),
    [anon_sym_u32] = ACTIONS(182),
    [anon_sym_i32] = ACTIONS(182),
    [anon_sym_u64] = ACTIONS(182),
    [anon_sym_i64] = ACTIONS(182),
    [anon_sym_u128] = ACTIONS(182),
    [anon_sym_i128] = ACTIONS(182),
    [anon_sym_isize] = ACTIONS(182),
    [anon_sym_usize] = ACTIONS(182),
    [anon_sym_f32] = ACTIONS(182),
    [anon_sym_f64] = ACTIONS(182),
    [anon_sym_bool] = ACTIONS(182),
    [anon_sym_str] = ACTIONS(182),
    [anon_sym_char] = ACTIONS(182),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(188),
    [anon_sym_POUND] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(194),
    [anon_sym_PIPE] = ACTIONS(197),
    [anon_sym_SQUOTE] = ACTIONS(200),
    [anon_sym_async] = ACTIONS(203),
    [anon_sym_break] = ACTIONS(206),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_continue] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_enum] = ACTIONS(218),
    [anon_sym_fn] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_impl] = ACTIONS(230),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_loop] = ACTIONS(236),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_mod] = ACTIONS(242),
    [anon_sym_pub] = ACTIONS(245),
    [anon_sym_return] = ACTIONS(248),
    [anon_sym_static] = ACTIONS(251),
    [anon_sym_struct] = ACTIONS(254),
    [anon_sym_trait] = ACTIONS(257),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_union] = ACTIONS(263),
    [anon_sym_unsafe] = ACTIONS(266),
    [anon_sym_use] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(272),
    [anon_sym_extern] = ACTIONS(275),
    [anon_sym_DOT_DOT] = ACTIONS(278),
    [anon_sym_yield] = ACTIONS(281),
    [anon_sym_move] = ACTIONS(284),
    [anon_sym_try] = ACTIONS(287),
    [sym_integer_literal] = ACTIONS(290),
    [aux_sym_string_literal_token1] = ACTIONS(293),
    [sym_char_literal] = ACTIONS(290),
    [anon_sym_true] = ACTIONS(296),
    [anon_sym_false] = ACTIONS(296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(299),
    [sym_super] = ACTIONS(302),
    [sym_crate] = ACTIONS(305),
    [sym_metavariable] = ACTIONS(308),
    [sym_raw_string_literal] = ACTIONS(290),
    [sym_float_literal] = ACTIONS(290),
  },
  [30] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1812),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(30),
    [sym_block_comment] = STATE(30),
    [aux_sym_source_file_repeat1] = STATE(27),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(319),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [31] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1868),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(31),
    [sym_block_comment] = STATE(31),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [ts_builtin_sym_end] = ACTIONS(321),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [32] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1809),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(32),
    [sym_block_comment] = STATE(32),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [33] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1808),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(33),
    [sym_block_comment] = STATE(33),
    [aux_sym_source_file_repeat1] = STATE(32),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [34] = {
    [sym__statement] = STATE(732),
    [sym_empty_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_macro_definition] = STATE(733),
    [sym_attribute_item] = STATE(733),
    [sym_inner_attribute_item] = STATE(733),
    [sym_mod_item] = STATE(733),
    [sym_foreign_mod_item] = STATE(733),
    [sym_struct_item] = STATE(733),
    [sym_union_item] = STATE(733),
    [sym_enum_item] = STATE(733),
    [sym_extern_crate_declaration] = STATE(733),
    [sym_const_item] = STATE(733),
    [sym_static_item] = STATE(733),
    [sym_type_item] = STATE(733),
    [sym_function_item] = STATE(733),
    [sym_function_signature_item] = STATE(733),
    [sym_function_modifiers] = STATE(3241),
    [sym_impl_item] = STATE(733),
    [sym_trait_item] = STATE(733),
    [sym_associated_type] = STATE(733),
    [sym_let_declaration] = STATE(733),
    [sym_use_declaration] = STATE(733),
    [sym_extern_modifier] = STATE(2128),
    [sym_visibility_modifier] = STATE(1933),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1777),
    [sym_macro_invocation] = STATE(206),
    [sym_scoped_identifier] = STATE(1510),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(193),
    [sym_match_expression] = STATE(193),
    [sym_while_expression] = STATE(193),
    [sym_loop_expression] = STATE(193),
    [sym_for_expression] = STATE(193),
    [sym_const_block] = STATE(193),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3374),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(193),
    [sym_async_block] = STATE(193),
    [sym_try_block] = STATE(193),
    [sym_block] = STATE(193),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(34),
    [sym_block_comment] = STATE(34),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(327),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(117),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [35] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1479),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_EQ] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_PERCENT] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_DOT_DOT] = ACTIONS(337),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(331),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_BANG_EQ] = ACTIONS(331),
    [anon_sym_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_EQ] = ACTIONS(331),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_PLUS_EQ] = ACTIONS(331),
    [anon_sym_DASH_EQ] = ACTIONS(331),
    [anon_sym_STAR_EQ] = ACTIONS(331),
    [anon_sym_SLASH_EQ] = ACTIONS(331),
    [anon_sym_PERCENT_EQ] = ACTIONS(331),
    [anon_sym_AMP_EQ] = ACTIONS(331),
    [anon_sym_PIPE_EQ] = ACTIONS(331),
    [anon_sym_CARET_EQ] = ACTIONS(331),
    [anon_sym_LT_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_GT_EQ] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [36] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1478),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(363),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_EQ] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(365),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(365),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_DOT_DOT] = ACTIONS(373),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [37] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1475),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(375),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [38] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1469),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_RBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [39] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1461),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(35),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_as] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(383),
    [anon_sym_DOT_DOT] = ACTIONS(385),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_PLUS_EQ] = ACTIONS(383),
    [anon_sym_DASH_EQ] = ACTIONS(383),
    [anon_sym_STAR_EQ] = ACTIONS(383),
    [anon_sym_SLASH_EQ] = ACTIONS(383),
    [anon_sym_PERCENT_EQ] = ACTIONS(383),
    [anon_sym_AMP_EQ] = ACTIONS(383),
    [anon_sym_PIPE_EQ] = ACTIONS(383),
    [anon_sym_CARET_EQ] = ACTIONS(383),
    [anon_sym_LT_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_GT_EQ] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [40] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1469),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_RBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [41] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1475),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(375),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [42] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1476),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(389),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(389),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(373),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [43] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1672),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_EQ] = ACTIONS(337),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_PERCENT] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_DOT_DOT] = ACTIONS(337),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(331),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_BANG_EQ] = ACTIONS(331),
    [anon_sym_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_EQ] = ACTIONS(331),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_PLUS_EQ] = ACTIONS(331),
    [anon_sym_DASH_EQ] = ACTIONS(331),
    [anon_sym_STAR_EQ] = ACTIONS(331),
    [anon_sym_SLASH_EQ] = ACTIONS(331),
    [anon_sym_PERCENT_EQ] = ACTIONS(331),
    [anon_sym_AMP_EQ] = ACTIONS(331),
    [anon_sym_PIPE_EQ] = ACTIONS(331),
    [anon_sym_CARET_EQ] = ACTIONS(331),
    [anon_sym_LT_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_GT_EQ] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [44] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1786),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_EQ] = ACTIONS(337),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_PERCENT] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_DOT_DOT] = ACTIONS(337),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(331),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_BANG_EQ] = ACTIONS(331),
    [anon_sym_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_EQ] = ACTIONS(331),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_PLUS_EQ] = ACTIONS(331),
    [anon_sym_DASH_EQ] = ACTIONS(331),
    [anon_sym_STAR_EQ] = ACTIONS(331),
    [anon_sym_SLASH_EQ] = ACTIONS(331),
    [anon_sym_PERCENT_EQ] = ACTIONS(331),
    [anon_sym_AMP_EQ] = ACTIONS(331),
    [anon_sym_PIPE_EQ] = ACTIONS(331),
    [anon_sym_CARET_EQ] = ACTIONS(331),
    [anon_sym_LT_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_GT_EQ] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [45] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1752),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [46] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1735),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [47] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1750),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_QMARK] = ACTIONS(363),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_EQ] = ACTIONS(365),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(365),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_DOT_DOT] = ACTIONS(467),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [48] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1753),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(447),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(467),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [49] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1677),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [50] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1795),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_EQ] = ACTIONS(337),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_PERCENT] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_DOT_DOT] = ACTIONS(337),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(331),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_BANG_EQ] = ACTIONS(331),
    [anon_sym_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_EQ] = ACTIONS(331),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_PLUS_EQ] = ACTIONS(331),
    [anon_sym_DASH_EQ] = ACTIONS(331),
    [anon_sym_STAR_EQ] = ACTIONS(331),
    [anon_sym_SLASH_EQ] = ACTIONS(331),
    [anon_sym_PERCENT_EQ] = ACTIONS(331),
    [anon_sym_AMP_EQ] = ACTIONS(331),
    [anon_sym_PIPE_EQ] = ACTIONS(331),
    [anon_sym_CARET_EQ] = ACTIONS(331),
    [anon_sym_LT_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_GT_EQ] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [51] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1752),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [52] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1821),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [53] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1677),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [54] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1735),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [55] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1748),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(44),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(383),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(385),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(383),
    [anon_sym_DOT_DOT] = ACTIONS(385),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_PLUS_EQ] = ACTIONS(383),
    [anon_sym_DASH_EQ] = ACTIONS(383),
    [anon_sym_STAR_EQ] = ACTIONS(383),
    [anon_sym_SLASH_EQ] = ACTIONS(383),
    [anon_sym_PERCENT_EQ] = ACTIONS(383),
    [anon_sym_AMP_EQ] = ACTIONS(383),
    [anon_sym_PIPE_EQ] = ACTIONS(383),
    [anon_sym_CARET_EQ] = ACTIONS(383),
    [anon_sym_LT_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_GT_EQ] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [56] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1821),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [57] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1667),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(43),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(383),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(385),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(383),
    [anon_sym_DOT_DOT] = ACTIONS(385),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_PLUS_EQ] = ACTIONS(383),
    [anon_sym_DASH_EQ] = ACTIONS(383),
    [anon_sym_STAR_EQ] = ACTIONS(383),
    [anon_sym_SLASH_EQ] = ACTIONS(383),
    [anon_sym_PERCENT_EQ] = ACTIONS(383),
    [anon_sym_AMP_EQ] = ACTIONS(383),
    [anon_sym_PIPE_EQ] = ACTIONS(383),
    [anon_sym_CARET_EQ] = ACTIONS(383),
    [anon_sym_LT_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_GT_EQ] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [58] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1698),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_EQ] = ACTIONS(337),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_PERCENT] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_as] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_DOT_DOT] = ACTIONS(337),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(331),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_BANG_EQ] = ACTIONS(331),
    [anon_sym_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_EQ] = ACTIONS(331),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_PLUS_EQ] = ACTIONS(331),
    [anon_sym_DASH_EQ] = ACTIONS(331),
    [anon_sym_STAR_EQ] = ACTIONS(331),
    [anon_sym_SLASH_EQ] = ACTIONS(331),
    [anon_sym_PERCENT_EQ] = ACTIONS(331),
    [anon_sym_AMP_EQ] = ACTIONS(331),
    [anon_sym_PIPE_EQ] = ACTIONS(331),
    [anon_sym_CARET_EQ] = ACTIONS(331),
    [anon_sym_LT_LT_EQ] = ACTIONS(331),
    [anon_sym_GT_GT_EQ] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [59] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1674),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(363),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(365),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(365),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_DOT_DOT] = ACTIONS(513),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [60] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1678),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_EQ_GT] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(513),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [61] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1766),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_QMARK] = ACTIONS(363),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(365),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(365),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [62] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1775),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [63] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1596),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(497),
    [anon_sym_QMARK] = ACTIONS(363),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_EQ] = ACTIONS(365),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(519),
    [anon_sym_PERCENT] = ACTIONS(365),
    [anon_sym_CARET] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(365),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_DOT_DOT] = ACTIONS(521),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [64] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1605),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(377),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [65] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1771),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [66] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1593),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(58),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(385),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(385),
    [anon_sym_as] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(383),
    [anon_sym_DOT_DOT] = ACTIONS(385),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_PLUS_EQ] = ACTIONS(383),
    [anon_sym_DASH_EQ] = ACTIONS(383),
    [anon_sym_STAR_EQ] = ACTIONS(383),
    [anon_sym_SLASH_EQ] = ACTIONS(383),
    [anon_sym_PERCENT_EQ] = ACTIONS(383),
    [anon_sym_AMP_EQ] = ACTIONS(383),
    [anon_sym_PIPE_EQ] = ACTIONS(383),
    [anon_sym_CARET_EQ] = ACTIONS(383),
    [anon_sym_LT_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_GT_EQ] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [67] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1608),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(67),
    [sym_block_comment] = STATE(67),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(497),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(519),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(521),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [68] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(68),
    [sym_block_comment] = STATE(68),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(381),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [69] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(69),
    [sym_block_comment] = STATE(69),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(381),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [70] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1770),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(70),
    [sym_block_comment] = STATE(70),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [71] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1775),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(71),
    [sym_block_comment] = STATE(71),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PERCENT] = ACTIONS(381),
    [anon_sym_CARET] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(379),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_LT_LT] = ACTIONS(381),
    [anon_sym_GT_GT] = ACTIONS(381),
    [anon_sym_PLUS_EQ] = ACTIONS(379),
    [anon_sym_DASH_EQ] = ACTIONS(379),
    [anon_sym_STAR_EQ] = ACTIONS(379),
    [anon_sym_SLASH_EQ] = ACTIONS(379),
    [anon_sym_PERCENT_EQ] = ACTIONS(379),
    [anon_sym_AMP_EQ] = ACTIONS(379),
    [anon_sym_PIPE_EQ] = ACTIONS(379),
    [anon_sym_CARET_EQ] = ACTIONS(379),
    [anon_sym_LT_LT_EQ] = ACTIONS(379),
    [anon_sym_GT_GT_EQ] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [72] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1770),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(72),
    [sym_block_comment] = STATE(72),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [73] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1764),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(50),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(73),
    [sym_block_comment] = STATE(73),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(385),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_as] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(383),
    [anon_sym_DOT_DOT] = ACTIONS(385),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_PLUS_EQ] = ACTIONS(383),
    [anon_sym_DASH_EQ] = ACTIONS(383),
    [anon_sym_STAR_EQ] = ACTIONS(383),
    [anon_sym_SLASH_EQ] = ACTIONS(383),
    [anon_sym_PERCENT_EQ] = ACTIONS(383),
    [anon_sym_AMP_EQ] = ACTIONS(383),
    [anon_sym_PIPE_EQ] = ACTIONS(383),
    [anon_sym_CARET_EQ] = ACTIONS(383),
    [anon_sym_LT_LT_EQ] = ACTIONS(383),
    [anon_sym_GT_GT_EQ] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [74] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1605),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(74),
    [sym_block_comment] = STATE(74),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(377),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(377),
    [anon_sym_CARET] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(377),
    [anon_sym_as] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(377),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(375),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_PLUS_EQ] = ACTIONS(375),
    [anon_sym_DASH_EQ] = ACTIONS(375),
    [anon_sym_STAR_EQ] = ACTIONS(375),
    [anon_sym_SLASH_EQ] = ACTIONS(375),
    [anon_sym_PERCENT_EQ] = ACTIONS(375),
    [anon_sym_AMP_EQ] = ACTIONS(375),
    [anon_sym_PIPE_EQ] = ACTIONS(375),
    [anon_sym_CARET_EQ] = ACTIONS(375),
    [anon_sym_LT_LT_EQ] = ACTIONS(375),
    [anon_sym_GT_GT_EQ] = ACTIONS(375),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [75] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1619),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(75),
    [sym_block_comment] = STATE(75),
    [aux_sym_enum_variant_list_repeat1] = STATE(113),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [76] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1567),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(76),
    [sym_block_comment] = STATE(76),
    [aux_sym_enum_variant_list_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [77] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1591),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(77),
    [sym_block_comment] = STATE(77),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_RBRACK] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_u8] = ACTIONS(550),
    [anon_sym_i8] = ACTIONS(550),
    [anon_sym_u16] = ACTIONS(550),
    [anon_sym_i16] = ACTIONS(550),
    [anon_sym_u32] = ACTIONS(550),
    [anon_sym_i32] = ACTIONS(550),
    [anon_sym_u64] = ACTIONS(550),
    [anon_sym_i64] = ACTIONS(550),
    [anon_sym_u128] = ACTIONS(550),
    [anon_sym_i128] = ACTIONS(550),
    [anon_sym_isize] = ACTIONS(550),
    [anon_sym_usize] = ACTIONS(550),
    [anon_sym_f32] = ACTIONS(550),
    [anon_sym_f64] = ACTIONS(550),
    [anon_sym_bool] = ACTIONS(550),
    [anon_sym_str] = ACTIONS(550),
    [anon_sym_char] = ACTIONS(550),
    [anon_sym_DASH] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_COLON_COLON] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_POUND] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(571),
    [anon_sym_break] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(577),
    [anon_sym_continue] = ACTIONS(580),
    [anon_sym_default] = ACTIONS(583),
    [anon_sym_for] = ACTIONS(586),
    [anon_sym_if] = ACTIONS(589),
    [anon_sym_loop] = ACTIONS(592),
    [anon_sym_match] = ACTIONS(595),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_static] = ACTIONS(601),
    [anon_sym_union] = ACTIONS(583),
    [anon_sym_unsafe] = ACTIONS(604),
    [anon_sym_while] = ACTIONS(607),
    [anon_sym_DOT_DOT] = ACTIONS(610),
    [anon_sym_yield] = ACTIONS(613),
    [anon_sym_move] = ACTIONS(616),
    [anon_sym_try] = ACTIONS(619),
    [sym_integer_literal] = ACTIONS(622),
    [aux_sym_string_literal_token1] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(622),
    [anon_sym_true] = ACTIONS(628),
    [anon_sym_false] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(631),
    [sym_super] = ACTIONS(634),
    [sym_crate] = ACTIONS(634),
    [sym_metavariable] = ACTIONS(637),
    [sym_raw_string_literal] = ACTIONS(622),
    [sym_float_literal] = ACTIONS(622),
  },
  [78] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1661),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(78),
    [sym_block_comment] = STATE(78),
    [aux_sym_enum_variant_list_repeat1] = STATE(117),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [79] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1548),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(79),
    [sym_block_comment] = STATE(79),
    [aux_sym_enum_variant_list_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(646),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [80] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1623),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(80),
    [sym_block_comment] = STATE(80),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_RBRACK] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(547),
    [anon_sym_u8] = ACTIONS(550),
    [anon_sym_i8] = ACTIONS(550),
    [anon_sym_u16] = ACTIONS(550),
    [anon_sym_i16] = ACTIONS(550),
    [anon_sym_u32] = ACTIONS(550),
    [anon_sym_i32] = ACTIONS(550),
    [anon_sym_u64] = ACTIONS(550),
    [anon_sym_i64] = ACTIONS(550),
    [anon_sym_u128] = ACTIONS(550),
    [anon_sym_i128] = ACTIONS(550),
    [anon_sym_isize] = ACTIONS(550),
    [anon_sym_usize] = ACTIONS(550),
    [anon_sym_f32] = ACTIONS(550),
    [anon_sym_f64] = ACTIONS(550),
    [anon_sym_bool] = ACTIONS(550),
    [anon_sym_str] = ACTIONS(550),
    [anon_sym_char] = ACTIONS(550),
    [anon_sym_DASH] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_COLON_COLON] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(547),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_POUND] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(568),
    [anon_sym_async] = ACTIONS(571),
    [anon_sym_break] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(577),
    [anon_sym_continue] = ACTIONS(580),
    [anon_sym_default] = ACTIONS(583),
    [anon_sym_for] = ACTIONS(586),
    [anon_sym_if] = ACTIONS(589),
    [anon_sym_loop] = ACTIONS(592),
    [anon_sym_match] = ACTIONS(595),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_static] = ACTIONS(601),
    [anon_sym_union] = ACTIONS(583),
    [anon_sym_unsafe] = ACTIONS(604),
    [anon_sym_while] = ACTIONS(607),
    [anon_sym_DOT_DOT] = ACTIONS(610),
    [anon_sym_yield] = ACTIONS(613),
    [anon_sym_move] = ACTIONS(616),
    [anon_sym_try] = ACTIONS(619),
    [sym_integer_literal] = ACTIONS(622),
    [aux_sym_string_literal_token1] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(622),
    [anon_sym_true] = ACTIONS(628),
    [anon_sym_false] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(631),
    [sym_super] = ACTIONS(634),
    [sym_crate] = ACTIONS(634),
    [sym_metavariable] = ACTIONS(637),
    [sym_raw_string_literal] = ACTIONS(622),
    [sym_float_literal] = ACTIONS(622),
  },
  [81] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1541),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(81),
    [sym_block_comment] = STATE(81),
    [aux_sym_enum_variant_list_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [82] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1569),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(82),
    [sym_block_comment] = STATE(82),
    [aux_sym_enum_variant_list_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [83] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(83),
    [sym_block_comment] = STATE(83),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [84] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(84),
    [sym_block_comment] = STATE(84),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [85] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(85),
    [sym_block_comment] = STATE(85),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(660),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [86] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2569),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(86),
    [sym_block_comment] = STATE(86),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [87] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1744),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(87),
    [sym_block_comment] = STATE(87),
    [aux_sym_enum_variant_list_repeat1] = STATE(116),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [88] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2598),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(88),
    [sym_block_comment] = STATE(88),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [89] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2535),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(89),
    [sym_block_comment] = STATE(89),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [90] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2610),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(90),
    [sym_block_comment] = STATE(90),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [91] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1865),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_let_condition] = STATE(3084),
    [sym__let_chain] = STATE(3081),
    [sym__condition] = STATE(3279),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(91),
    [sym_block_comment] = STATE(91),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(676),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [92] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1865),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_let_condition] = STATE(3084),
    [sym__let_chain] = STATE(3081),
    [sym__condition] = STATE(3280),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(92),
    [sym_block_comment] = STATE(92),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(676),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [93] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2660),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(93),
    [sym_block_comment] = STATE(93),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [94] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2609),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(94),
    [sym_block_comment] = STATE(94),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [95] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(95),
    [sym_block_comment] = STATE(95),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [96] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(96),
    [sym_block_comment] = STATE(96),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [97] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(97),
    [sym_block_comment] = STATE(97),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [98] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(98),
    [sym_block_comment] = STATE(98),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [99] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2567),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(99),
    [sym_block_comment] = STATE(99),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [100] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2586),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(100),
    [sym_block_comment] = STATE(100),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [101] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(101),
    [sym_block_comment] = STATE(101),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(688),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [102] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(102),
    [sym_block_comment] = STATE(102),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [103] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(103),
    [sym_block_comment] = STATE(103),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(692),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [104] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(104),
    [sym_block_comment] = STATE(104),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [105] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2572),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(105),
    [sym_block_comment] = STATE(105),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [106] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(106),
    [sym_block_comment] = STATE(106),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [107] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(107),
    [sym_block_comment] = STATE(107),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [108] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(108),
    [sym_block_comment] = STATE(108),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [109] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2587),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(109),
    [sym_block_comment] = STATE(109),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [110] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2663),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(110),
    [sym_block_comment] = STATE(110),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [111] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1800),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(111),
    [sym_block_comment] = STATE(111),
    [aux_sym_enum_variant_list_repeat1] = STATE(114),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [112] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2827),
    [sym__let_chain] = STATE(2828),
    [sym__condition] = STATE(2559),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(112),
    [sym_block_comment] = STATE(112),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [113] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1644),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(113),
    [sym_block_comment] = STATE(113),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [114] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1863),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(114),
    [sym_block_comment] = STATE(114),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [115] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1652),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(115),
    [sym_block_comment] = STATE(115),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [116] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1864),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(116),
    [sym_block_comment] = STATE(116),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [117] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1647),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(117),
    [sym_block_comment] = STATE(117),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [118] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(118),
    [sym_block_comment] = STATE(118),
    [aux_sym_enum_variant_list_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [119] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1745),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1417),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(119),
    [sym_block_comment] = STATE(119),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym__] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [120] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1460),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1408),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(120),
    [sym_block_comment] = STATE(120),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [121] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1767),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1252),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(121),
    [sym_block_comment] = STATE(121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [122] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1806),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1408),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(122),
    [sym_block_comment] = STATE(122),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [123] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1799),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(123),
    [sym_block_comment] = STATE(123),
    [aux_sym_tuple_expression_repeat1] = STATE(125),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [124] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1788),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1673),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(124),
    [sym_block_comment] = STATE(124),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(734),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [125] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1790),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(125),
    [sym_block_comment] = STATE(125),
    [aux_sym_tuple_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [126] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1633),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2607),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(126),
    [sym_block_comment] = STATE(126),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [127] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1790),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(127),
    [sym_block_comment] = STATE(127),
    [aux_sym_tuple_expression_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [128] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1811),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_let_condition] = STATE(2607),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(128),
    [sym_block_comment] = STATE(128),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [129] = {
    [sym_else_clause] = STATE(289),
    [sym_line_comment] = STATE(129),
    [sym_block_comment] = STATE(129),
    [ts_builtin_sym_end] = ACTIONS(740),
    [sym_identifier] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_macro_rules_BANG] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_u8] = ACTIONS(742),
    [anon_sym_i8] = ACTIONS(742),
    [anon_sym_u16] = ACTIONS(742),
    [anon_sym_i16] = ACTIONS(742),
    [anon_sym_u32] = ACTIONS(742),
    [anon_sym_i32] = ACTIONS(742),
    [anon_sym_u64] = ACTIONS(742),
    [anon_sym_i64] = ACTIONS(742),
    [anon_sym_u128] = ACTIONS(742),
    [anon_sym_i128] = ACTIONS(742),
    [anon_sym_isize] = ACTIONS(742),
    [anon_sym_usize] = ACTIONS(742),
    [anon_sym_f32] = ACTIONS(742),
    [anon_sym_f64] = ACTIONS(742),
    [anon_sym_bool] = ACTIONS(742),
    [anon_sym_str] = ACTIONS(742),
    [anon_sym_char] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_POUND] = ACTIONS(740),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(742),
    [anon_sym_as] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(742),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_fn] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_impl] = ACTIONS(742),
    [anon_sym_let] = ACTIONS(742),
    [anon_sym_loop] = ACTIONS(742),
    [anon_sym_match] = ACTIONS(742),
    [anon_sym_mod] = ACTIONS(742),
    [anon_sym_pub] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_trait] = ACTIONS(742),
    [anon_sym_type] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_unsafe] = ACTIONS(742),
    [anon_sym_use] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym_else] = ACTIONS(744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(740),
    [anon_sym_DOT_DOT] = ACTIONS(742),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(740),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_PIPE_PIPE] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_PLUS_EQ] = ACTIONS(740),
    [anon_sym_DASH_EQ] = ACTIONS(740),
    [anon_sym_STAR_EQ] = ACTIONS(740),
    [anon_sym_SLASH_EQ] = ACTIONS(740),
    [anon_sym_PERCENT_EQ] = ACTIONS(740),
    [anon_sym_AMP_EQ] = ACTIONS(740),
    [anon_sym_PIPE_EQ] = ACTIONS(740),
    [anon_sym_CARET_EQ] = ACTIONS(740),
    [anon_sym_LT_LT_EQ] = ACTIONS(740),
    [anon_sym_GT_GT_EQ] = ACTIONS(740),
    [anon_sym_yield] = ACTIONS(742),
    [anon_sym_move] = ACTIONS(742),
    [anon_sym_try] = ACTIONS(742),
    [sym_integer_literal] = ACTIONS(740),
    [aux_sym_string_literal_token1] = ACTIONS(740),
    [sym_char_literal] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(742),
    [anon_sym_false] = ACTIONS(742),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(742),
    [sym_super] = ACTIONS(742),
    [sym_crate] = ACTIONS(742),
    [sym_metavariable] = ACTIONS(740),
    [sym_raw_string_literal] = ACTIONS(740),
    [sym_float_literal] = ACTIONS(740),
  },
  [130] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1459),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1252),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(130),
    [sym_block_comment] = STATE(130),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [131] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1760),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1702),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(131),
    [sym_block_comment] = STATE(131),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(734),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [132] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1597),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1417),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(132),
    [sym_block_comment] = STATE(132),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym__] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [133] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1859),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_let_condition] = STATE(2607),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(133),
    [sym_block_comment] = STATE(133),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(676),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [134] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1751),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(134),
    [sym_block_comment] = STATE(134),
    [aux_sym_tuple_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(750),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [135] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1824),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_let_condition] = STATE(2607),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(135),
    [sym_block_comment] = STATE(135),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(676),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [136] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1589),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1252),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(136),
    [sym_block_comment] = STATE(136),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym__] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [137] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1768),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1604),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(137),
    [sym_block_comment] = STATE(137),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(754),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(734),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [138] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1793),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1252),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(138),
    [sym_block_comment] = STATE(138),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym__] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(722),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [139] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1838),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1702),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(139),
    [sym_block_comment] = STATE(139),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [140] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1789),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(140),
    [sym_block_comment] = STATE(140),
    [aux_sym_tuple_expression_repeat1] = STATE(144),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [141] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1789),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(141),
    [sym_block_comment] = STATE(141),
    [aux_sym_tuple_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [142] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1810),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1408),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(142),
    [sym_block_comment] = STATE(142),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym__] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [143] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1818),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(143),
    [sym_block_comment] = STATE(143),
    [aux_sym_tuple_expression_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [144] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1801),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(144),
    [sym_block_comment] = STATE(144),
    [aux_sym_tuple_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [145] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1842),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(145),
    [sym_block_comment] = STATE(145),
    [aux_sym_tuple_expression_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_u8] = ACTIONS(781),
    [anon_sym_i8] = ACTIONS(781),
    [anon_sym_u16] = ACTIONS(781),
    [anon_sym_i16] = ACTIONS(781),
    [anon_sym_u32] = ACTIONS(781),
    [anon_sym_i32] = ACTIONS(781),
    [anon_sym_u64] = ACTIONS(781),
    [anon_sym_i64] = ACTIONS(781),
    [anon_sym_u128] = ACTIONS(781),
    [anon_sym_i128] = ACTIONS(781),
    [anon_sym_isize] = ACTIONS(781),
    [anon_sym_usize] = ACTIONS(781),
    [anon_sym_f32] = ACTIONS(781),
    [anon_sym_f64] = ACTIONS(781),
    [anon_sym_bool] = ACTIONS(781),
    [anon_sym_str] = ACTIONS(781),
    [anon_sym_char] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_COLON_COLON] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(790),
    [anon_sym_PIPE] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(802),
    [anon_sym_const] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(808),
    [anon_sym_default] = ACTIONS(811),
    [anon_sym_for] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(817),
    [anon_sym_loop] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(823),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(811),
    [anon_sym_unsafe] = ACTIONS(832),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_DOT_DOT] = ACTIONS(838),
    [anon_sym_yield] = ACTIONS(841),
    [anon_sym_move] = ACTIONS(844),
    [anon_sym_try] = ACTIONS(847),
    [sym_integer_literal] = ACTIONS(850),
    [aux_sym_string_literal_token1] = ACTIONS(853),
    [sym_char_literal] = ACTIONS(850),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(856),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(859),
    [sym_super] = ACTIONS(862),
    [sym_crate] = ACTIONS(862),
    [sym_metavariable] = ACTIONS(865),
    [sym_raw_string_literal] = ACTIONS(850),
    [sym_float_literal] = ACTIONS(850),
  },
  [146] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1683),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1702),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [147] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1480),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1417),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [148] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1682),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1673),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(148),
    [sym_block_comment] = STATE(148),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [149] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1680),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1604),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(149),
    [sym_block_comment] = STATE(149),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(754),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [150] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1701),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1408),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(150),
    [sym_block_comment] = STATE(150),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym__] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [151] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1781),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1417),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [152] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1737),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1604),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(754),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [153] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1815),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1673),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym__] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_DASH_GT] = ACTIONS(730),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [154] = {
    [sym_line_comment] = STATE(154),
    [sym_block_comment] = STATE(154),
    [ts_builtin_sym_end] = ACTIONS(870),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_macro_rules_BANG] = ACTIONS(870),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_LBRACK] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(870),
    [anon_sym_RBRACE] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_STAR] = ACTIONS(872),
    [anon_sym_QMARK] = ACTIONS(870),
    [anon_sym_u8] = ACTIONS(872),
    [anon_sym_i8] = ACTIONS(872),
    [anon_sym_u16] = ACTIONS(872),
    [anon_sym_i16] = ACTIONS(872),
    [anon_sym_u32] = ACTIONS(872),
    [anon_sym_i32] = ACTIONS(872),
    [anon_sym_u64] = ACTIONS(872),
    [anon_sym_i64] = ACTIONS(872),
    [anon_sym_u128] = ACTIONS(872),
    [anon_sym_i128] = ACTIONS(872),
    [anon_sym_isize] = ACTIONS(872),
    [anon_sym_usize] = ACTIONS(872),
    [anon_sym_f32] = ACTIONS(872),
    [anon_sym_f64] = ACTIONS(872),
    [anon_sym_bool] = ACTIONS(872),
    [anon_sym_str] = ACTIONS(872),
    [anon_sym_char] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_EQ] = ACTIONS(872),
    [anon_sym_COLON_COLON] = ACTIONS(870),
    [anon_sym_BANG] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(872),
    [anon_sym_AMP] = ACTIONS(872),
    [anon_sym_POUND] = ACTIONS(870),
    [anon_sym_PERCENT] = ACTIONS(872),
    [anon_sym_CARET] = ACTIONS(872),
    [anon_sym_LT] = ACTIONS(872),
    [anon_sym_GT] = ACTIONS(872),
    [anon_sym_PIPE] = ACTIONS(872),
    [anon_sym_SQUOTE] = ACTIONS(872),
    [anon_sym_as] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_break] = ACTIONS(872),
    [anon_sym_const] = ACTIONS(872),
    [anon_sym_continue] = ACTIONS(872),
    [anon_sym_default] = ACTIONS(872),
    [anon_sym_enum] = ACTIONS(872),
    [anon_sym_fn] = ACTIONS(872),
    [anon_sym_for] = ACTIONS(872),
    [anon_sym_if] = ACTIONS(872),
    [anon_sym_impl] = ACTIONS(872),
    [anon_sym_let] = ACTIONS(872),
    [anon_sym_loop] = ACTIONS(872),
    [anon_sym_match] = ACTIONS(872),
    [anon_sym_mod] = ACTIONS(872),
    [anon_sym_pub] = ACTIONS(872),
    [anon_sym_return] = ACTIONS(872),
    [anon_sym_static] = ACTIONS(872),
    [anon_sym_struct] = ACTIONS(872),
    [anon_sym_trait] = ACTIONS(872),
    [anon_sym_type] = ACTIONS(872),
    [anon_sym_union] = ACTIONS(872),
    [anon_sym_unsafe] = ACTIONS(872),
    [anon_sym_use] = ACTIONS(872),
    [anon_sym_while] = ACTIONS(872),
    [anon_sym_extern] = ACTIONS(872),
    [anon_sym_else] = ACTIONS(872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(870),
    [anon_sym_DOT_DOT] = ACTIONS(872),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(870),
    [anon_sym_AMP_AMP] = ACTIONS(870),
    [anon_sym_PIPE_PIPE] = ACTIONS(870),
    [anon_sym_EQ_EQ] = ACTIONS(870),
    [anon_sym_BANG_EQ] = ACTIONS(870),
    [anon_sym_LT_EQ] = ACTIONS(870),
    [anon_sym_GT_EQ] = ACTIONS(870),
    [anon_sym_LT_LT] = ACTIONS(872),
    [anon_sym_GT_GT] = ACTIONS(872),
    [anon_sym_PLUS_EQ] = ACTIONS(870),
    [anon_sym_DASH_EQ] = ACTIONS(870),
    [anon_sym_STAR_EQ] = ACTIONS(870),
    [anon_sym_SLASH_EQ] = ACTIONS(870),
    [anon_sym_PERCENT_EQ] = ACTIONS(870),
    [anon_sym_AMP_EQ] = ACTIONS(870),
    [anon_sym_PIPE_EQ] = ACTIONS(870),
    [anon_sym_CARET_EQ] = ACTIONS(870),
    [anon_sym_LT_LT_EQ] = ACTIONS(870),
    [anon_sym_GT_GT_EQ] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(872),
    [anon_sym_move] = ACTIONS(872),
    [anon_sym_try] = ACTIONS(872),
    [sym_integer_literal] = ACTIONS(870),
    [aux_sym_string_literal_token1] = ACTIONS(870),
    [sym_char_literal] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(872),
    [anon_sym_false] = ACTIONS(872),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(872),
    [sym_super] = ACTIONS(872),
    [sym_crate] = ACTIONS(872),
    [sym_metavariable] = ACTIONS(870),
    [sym_raw_string_literal] = ACTIONS(870),
    [sym_float_literal] = ACTIONS(870),
  },
  [155] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1306),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(155),
    [sym_block_comment] = STATE(155),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [sym_mutable_specifier] = ACTIONS(874),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [156] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1306),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(156),
    [sym_block_comment] = STATE(156),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [sym_mutable_specifier] = ACTIONS(876),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [157] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1645),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [sym_mutable_specifier] = ACTIONS(878),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [158] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1645),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(158),
    [sym_block_comment] = STATE(158),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [sym_mutable_specifier] = ACTIONS(880),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [159] = {
    [sym_line_comment] = STATE(159),
    [sym_block_comment] = STATE(159),
    [ts_builtin_sym_end] = ACTIONS(882),
    [sym_identifier] = ACTIONS(884),
    [anon_sym_SEMI] = ACTIONS(882),
    [anon_sym_macro_rules_BANG] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_STAR] = ACTIONS(884),
    [anon_sym_QMARK] = ACTIONS(882),
    [anon_sym_u8] = ACTIONS(884),
    [anon_sym_i8] = ACTIONS(884),
    [anon_sym_u16] = ACTIONS(884),
    [anon_sym_i16] = ACTIONS(884),
    [anon_sym_u32] = ACTIONS(884),
    [anon_sym_i32] = ACTIONS(884),
    [anon_sym_u64] = ACTIONS(884),
    [anon_sym_i64] = ACTIONS(884),
    [anon_sym_u128] = ACTIONS(884),
    [anon_sym_i128] = ACTIONS(884),
    [anon_sym_isize] = ACTIONS(884),
    [anon_sym_usize] = ACTIONS(884),
    [anon_sym_f32] = ACTIONS(884),
    [anon_sym_f64] = ACTIONS(884),
    [anon_sym_bool] = ACTIONS(884),
    [anon_sym_str] = ACTIONS(884),
    [anon_sym_char] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_EQ] = ACTIONS(884),
    [anon_sym_COLON_COLON] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_DOT] = ACTIONS(884),
    [anon_sym_AMP] = ACTIONS(884),
    [anon_sym_POUND] = ACTIONS(882),
    [anon_sym_PERCENT] = ACTIONS(884),
    [anon_sym_CARET] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_PIPE] = ACTIONS(884),
    [anon_sym_SQUOTE] = ACTIONS(884),
    [anon_sym_as] = ACTIONS(884),
    [anon_sym_async] = ACTIONS(884),
    [anon_sym_break] = ACTIONS(884),
    [anon_sym_const] = ACTIONS(884),
    [anon_sym_continue] = ACTIONS(884),
    [anon_sym_default] = ACTIONS(884),
    [anon_sym_enum] = ACTIONS(884),
    [anon_sym_fn] = ACTIONS(884),
    [anon_sym_for] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(884),
    [anon_sym_impl] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(884),
    [anon_sym_loop] = ACTIONS(884),
    [anon_sym_match] = ACTIONS(884),
    [anon_sym_mod] = ACTIONS(884),
    [anon_sym_pub] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(884),
    [anon_sym_static] = ACTIONS(884),
    [anon_sym_struct] = ACTIONS(884),
    [anon_sym_trait] = ACTIONS(884),
    [anon_sym_type] = ACTIONS(884),
    [anon_sym_union] = ACTIONS(884),
    [anon_sym_unsafe] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(884),
    [anon_sym_while] = ACTIONS(884),
    [anon_sym_extern] = ACTIONS(884),
    [anon_sym_else] = ACTIONS(884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(882),
    [anon_sym_DOT_DOT] = ACTIONS(884),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(882),
    [anon_sym_AMP_AMP] = ACTIONS(882),
    [anon_sym_PIPE_PIPE] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG_EQ] = ACTIONS(882),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_LT_LT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_PLUS_EQ] = ACTIONS(882),
    [anon_sym_DASH_EQ] = ACTIONS(882),
    [anon_sym_STAR_EQ] = ACTIONS(882),
    [anon_sym_SLASH_EQ] = ACTIONS(882),
    [anon_sym_PERCENT_EQ] = ACTIONS(882),
    [anon_sym_AMP_EQ] = ACTIONS(882),
    [anon_sym_PIPE_EQ] = ACTIONS(882),
    [anon_sym_CARET_EQ] = ACTIONS(882),
    [anon_sym_LT_LT_EQ] = ACTIONS(882),
    [anon_sym_GT_GT_EQ] = ACTIONS(882),
    [anon_sym_yield] = ACTIONS(884),
    [anon_sym_move] = ACTIONS(884),
    [anon_sym_try] = ACTIONS(884),
    [sym_integer_literal] = ACTIONS(882),
    [aux_sym_string_literal_token1] = ACTIONS(882),
    [sym_char_literal] = ACTIONS(882),
    [anon_sym_true] = ACTIONS(884),
    [anon_sym_false] = ACTIONS(884),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(884),
    [sym_super] = ACTIONS(884),
    [sym_crate] = ACTIONS(884),
    [sym_metavariable] = ACTIONS(882),
    [sym_raw_string_literal] = ACTIONS(882),
    [sym_float_literal] = ACTIONS(882),
  },
  [160] = {
    [sym_line_comment] = STATE(160),
    [sym_block_comment] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(886),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(886),
    [anon_sym_macro_rules_BANG] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(886),
    [anon_sym_u8] = ACTIONS(888),
    [anon_sym_i8] = ACTIONS(888),
    [anon_sym_u16] = ACTIONS(888),
    [anon_sym_i16] = ACTIONS(888),
    [anon_sym_u32] = ACTIONS(888),
    [anon_sym_i32] = ACTIONS(888),
    [anon_sym_u64] = ACTIONS(888),
    [anon_sym_i64] = ACTIONS(888),
    [anon_sym_u128] = ACTIONS(888),
    [anon_sym_i128] = ACTIONS(888),
    [anon_sym_isize] = ACTIONS(888),
    [anon_sym_usize] = ACTIONS(888),
    [anon_sym_f32] = ACTIONS(888),
    [anon_sym_f64] = ACTIONS(888),
    [anon_sym_bool] = ACTIONS(888),
    [anon_sym_str] = ACTIONS(888),
    [anon_sym_char] = ACTIONS(888),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_COLON_COLON] = ACTIONS(886),
    [anon_sym_BANG] = ACTIONS(888),
    [anon_sym_DOT] = ACTIONS(888),
    [anon_sym_AMP] = ACTIONS(888),
    [anon_sym_POUND] = ACTIONS(886),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_CARET] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_PIPE] = ACTIONS(888),
    [anon_sym_SQUOTE] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(888),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_break] = ACTIONS(888),
    [anon_sym_const] = ACTIONS(888),
    [anon_sym_continue] = ACTIONS(888),
    [anon_sym_default] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(888),
    [anon_sym_fn] = ACTIONS(888),
    [anon_sym_for] = ACTIONS(888),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_impl] = ACTIONS(888),
    [anon_sym_let] = ACTIONS(888),
    [anon_sym_loop] = ACTIONS(888),
    [anon_sym_match] = ACTIONS(888),
    [anon_sym_mod] = ACTIONS(888),
    [anon_sym_pub] = ACTIONS(888),
    [anon_sym_return] = ACTIONS(888),
    [anon_sym_static] = ACTIONS(888),
    [anon_sym_struct] = ACTIONS(888),
    [anon_sym_trait] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(888),
    [anon_sym_union] = ACTIONS(888),
    [anon_sym_unsafe] = ACTIONS(888),
    [anon_sym_use] = ACTIONS(888),
    [anon_sym_while] = ACTIONS(888),
    [anon_sym_extern] = ACTIONS(888),
    [anon_sym_else] = ACTIONS(888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(886),
    [anon_sym_DOT_DOT] = ACTIONS(888),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(886),
    [anon_sym_AMP_AMP] = ACTIONS(886),
    [anon_sym_PIPE_PIPE] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(886),
    [anon_sym_DASH_EQ] = ACTIONS(886),
    [anon_sym_STAR_EQ] = ACTIONS(886),
    [anon_sym_SLASH_EQ] = ACTIONS(886),
    [anon_sym_PERCENT_EQ] = ACTIONS(886),
    [anon_sym_AMP_EQ] = ACTIONS(886),
    [anon_sym_PIPE_EQ] = ACTIONS(886),
    [anon_sym_CARET_EQ] = ACTIONS(886),
    [anon_sym_LT_LT_EQ] = ACTIONS(886),
    [anon_sym_GT_GT_EQ] = ACTIONS(886),
    [anon_sym_yield] = ACTIONS(888),
    [anon_sym_move] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(888),
    [sym_integer_literal] = ACTIONS(886),
    [aux_sym_string_literal_token1] = ACTIONS(886),
    [sym_char_literal] = ACTIONS(886),
    [anon_sym_true] = ACTIONS(888),
    [anon_sym_false] = ACTIONS(888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(888),
    [sym_super] = ACTIONS(888),
    [sym_crate] = ACTIONS(888),
    [sym_metavariable] = ACTIONS(886),
    [sym_raw_string_literal] = ACTIONS(886),
    [sym_float_literal] = ACTIONS(886),
  },
  [161] = {
    [sym_line_comment] = STATE(161),
    [sym_block_comment] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(890),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(890),
    [anon_sym_macro_rules_BANG] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_QMARK] = ACTIONS(890),
    [anon_sym_u8] = ACTIONS(892),
    [anon_sym_i8] = ACTIONS(892),
    [anon_sym_u16] = ACTIONS(892),
    [anon_sym_i16] = ACTIONS(892),
    [anon_sym_u32] = ACTIONS(892),
    [anon_sym_i32] = ACTIONS(892),
    [anon_sym_u64] = ACTIONS(892),
    [anon_sym_i64] = ACTIONS(892),
    [anon_sym_u128] = ACTIONS(892),
    [anon_sym_i128] = ACTIONS(892),
    [anon_sym_isize] = ACTIONS(892),
    [anon_sym_usize] = ACTIONS(892),
    [anon_sym_f32] = ACTIONS(892),
    [anon_sym_f64] = ACTIONS(892),
    [anon_sym_bool] = ACTIONS(892),
    [anon_sym_str] = ACTIONS(892),
    [anon_sym_char] = ACTIONS(892),
    [anon_sym_SLASH] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(892),
    [anon_sym_COLON_COLON] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_DOT] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(892),
    [anon_sym_POUND] = ACTIONS(890),
    [anon_sym_PERCENT] = ACTIONS(892),
    [anon_sym_CARET] = ACTIONS(892),
    [anon_sym_LT] = ACTIONS(892),
    [anon_sym_GT] = ACTIONS(892),
    [anon_sym_PIPE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(892),
    [anon_sym_async] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_const] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_default] = ACTIONS(892),
    [anon_sym_enum] = ACTIONS(892),
    [anon_sym_fn] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(892),
    [anon_sym_impl] = ACTIONS(892),
    [anon_sym_let] = ACTIONS(892),
    [anon_sym_loop] = ACTIONS(892),
    [anon_sym_match] = ACTIONS(892),
    [anon_sym_mod] = ACTIONS(892),
    [anon_sym_pub] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_struct] = ACTIONS(892),
    [anon_sym_trait] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_union] = ACTIONS(892),
    [anon_sym_unsafe] = ACTIONS(892),
    [anon_sym_use] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_extern] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(890),
    [anon_sym_DOT_DOT] = ACTIONS(892),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(890),
    [anon_sym_AMP_AMP] = ACTIONS(890),
    [anon_sym_PIPE_PIPE] = ACTIONS(890),
    [anon_sym_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG_EQ] = ACTIONS(890),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_LT_LT] = ACTIONS(892),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_EQ] = ACTIONS(890),
    [anon_sym_DASH_EQ] = ACTIONS(890),
    [anon_sym_STAR_EQ] = ACTIONS(890),
    [anon_sym_SLASH_EQ] = ACTIONS(890),
    [anon_sym_PERCENT_EQ] = ACTIONS(890),
    [anon_sym_AMP_EQ] = ACTIONS(890),
    [anon_sym_PIPE_EQ] = ACTIONS(890),
    [anon_sym_CARET_EQ] = ACTIONS(890),
    [anon_sym_LT_LT_EQ] = ACTIONS(890),
    [anon_sym_GT_GT_EQ] = ACTIONS(890),
    [anon_sym_yield] = ACTIONS(892),
    [anon_sym_move] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [sym_integer_literal] = ACTIONS(890),
    [aux_sym_string_literal_token1] = ACTIONS(890),
    [sym_char_literal] = ACTIONS(890),
    [anon_sym_true] = ACTIONS(892),
    [anon_sym_false] = ACTIONS(892),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(892),
    [sym_super] = ACTIONS(892),
    [sym_crate] = ACTIONS(892),
    [sym_metavariable] = ACTIONS(890),
    [sym_raw_string_literal] = ACTIONS(890),
    [sym_float_literal] = ACTIONS(890),
  },
  [162] = {
    [sym_line_comment] = STATE(162),
    [sym_block_comment] = STATE(162),
    [ts_builtin_sym_end] = ACTIONS(894),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(894),
    [anon_sym_macro_rules_BANG] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_RBRACE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_STAR] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_u8] = ACTIONS(896),
    [anon_sym_i8] = ACTIONS(896),
    [anon_sym_u16] = ACTIONS(896),
    [anon_sym_i16] = ACTIONS(896),
    [anon_sym_u32] = ACTIONS(896),
    [anon_sym_i32] = ACTIONS(896),
    [anon_sym_u64] = ACTIONS(896),
    [anon_sym_i64] = ACTIONS(896),
    [anon_sym_u128] = ACTIONS(896),
    [anon_sym_i128] = ACTIONS(896),
    [anon_sym_isize] = ACTIONS(896),
    [anon_sym_usize] = ACTIONS(896),
    [anon_sym_f32] = ACTIONS(896),
    [anon_sym_f64] = ACTIONS(896),
    [anon_sym_bool] = ACTIONS(896),
    [anon_sym_str] = ACTIONS(896),
    [anon_sym_char] = ACTIONS(896),
    [anon_sym_SLASH] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_EQ] = ACTIONS(896),
    [anon_sym_COLON_COLON] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_DOT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(896),
    [anon_sym_POUND] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_LT] = ACTIONS(896),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(896),
    [anon_sym_async] = ACTIONS(896),
    [anon_sym_break] = ACTIONS(896),
    [anon_sym_const] = ACTIONS(896),
    [anon_sym_continue] = ACTIONS(896),
    [anon_sym_default] = ACTIONS(896),
    [anon_sym_enum] = ACTIONS(896),
    [anon_sym_fn] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(896),
    [anon_sym_if] = ACTIONS(896),
    [anon_sym_impl] = ACTIONS(896),
    [anon_sym_let] = ACTIONS(896),
    [anon_sym_loop] = ACTIONS(896),
    [anon_sym_match] = ACTIONS(896),
    [anon_sym_mod] = ACTIONS(896),
    [anon_sym_pub] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(896),
    [anon_sym_struct] = ACTIONS(896),
    [anon_sym_trait] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_union] = ACTIONS(896),
    [anon_sym_unsafe] = ACTIONS(896),
    [anon_sym_use] = ACTIONS(896),
    [anon_sym_while] = ACTIONS(896),
    [anon_sym_extern] = ACTIONS(896),
    [anon_sym_else] = ACTIONS(896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(896),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(896),
    [anon_sym_PLUS_EQ] = ACTIONS(894),
    [anon_sym_DASH_EQ] = ACTIONS(894),
    [anon_sym_STAR_EQ] = ACTIONS(894),
    [anon_sym_SLASH_EQ] = ACTIONS(894),
    [anon_sym_PERCENT_EQ] = ACTIONS(894),
    [anon_sym_AMP_EQ] = ACTIONS(894),
    [anon_sym_PIPE_EQ] = ACTIONS(894),
    [anon_sym_CARET_EQ] = ACTIONS(894),
    [anon_sym_LT_LT_EQ] = ACTIONS(894),
    [anon_sym_GT_GT_EQ] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_move] = ACTIONS(896),
    [anon_sym_try] = ACTIONS(896),
    [sym_integer_literal] = ACTIONS(894),
    [aux_sym_string_literal_token1] = ACTIONS(894),
    [sym_char_literal] = ACTIONS(894),
    [anon_sym_true] = ACTIONS(896),
    [anon_sym_false] = ACTIONS(896),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(896),
    [sym_super] = ACTIONS(896),
    [sym_crate] = ACTIONS(896),
    [sym_metavariable] = ACTIONS(894),
    [sym_raw_string_literal] = ACTIONS(894),
    [sym_float_literal] = ACTIONS(894),
  },
  [163] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1306),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(163),
    [sym_block_comment] = STATE(163),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [sym_mutable_specifier] = ACTIONS(898),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [164] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1560),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [165] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1579),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(165),
    [sym_block_comment] = STATE(165),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [166] = {
    [sym_line_comment] = STATE(166),
    [sym_block_comment] = STATE(166),
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(902),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_macro_rules_BANG] = ACTIONS(900),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_LBRACK] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(902),
    [anon_sym_QMARK] = ACTIONS(900),
    [anon_sym_u8] = ACTIONS(902),
    [anon_sym_i8] = ACTIONS(902),
    [anon_sym_u16] = ACTIONS(902),
    [anon_sym_i16] = ACTIONS(902),
    [anon_sym_u32] = ACTIONS(902),
    [anon_sym_i32] = ACTIONS(902),
    [anon_sym_u64] = ACTIONS(902),
    [anon_sym_i64] = ACTIONS(902),
    [anon_sym_u128] = ACTIONS(902),
    [anon_sym_i128] = ACTIONS(902),
    [anon_sym_isize] = ACTIONS(902),
    [anon_sym_usize] = ACTIONS(902),
    [anon_sym_f32] = ACTIONS(902),
    [anon_sym_f64] = ACTIONS(902),
    [anon_sym_bool] = ACTIONS(902),
    [anon_sym_str] = ACTIONS(902),
    [anon_sym_char] = ACTIONS(902),
    [anon_sym_SLASH] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_EQ] = ACTIONS(902),
    [anon_sym_COLON_COLON] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_DOT] = ACTIONS(902),
    [anon_sym_AMP] = ACTIONS(902),
    [anon_sym_POUND] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(902),
    [anon_sym_CARET] = ACTIONS(902),
    [anon_sym_LT] = ACTIONS(902),
    [anon_sym_GT] = ACTIONS(902),
    [anon_sym_PIPE] = ACTIONS(902),
    [anon_sym_SQUOTE] = ACTIONS(902),
    [anon_sym_as] = ACTIONS(902),
    [anon_sym_async] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_fn] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_impl] = ACTIONS(902),
    [anon_sym_let] = ACTIONS(902),
    [anon_sym_loop] = ACTIONS(902),
    [anon_sym_match] = ACTIONS(902),
    [anon_sym_mod] = ACTIONS(902),
    [anon_sym_pub] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_struct] = ACTIONS(902),
    [anon_sym_trait] = ACTIONS(902),
    [anon_sym_type] = ACTIONS(902),
    [anon_sym_union] = ACTIONS(902),
    [anon_sym_unsafe] = ACTIONS(902),
    [anon_sym_use] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(900),
    [anon_sym_DOT_DOT] = ACTIONS(902),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(900),
    [anon_sym_PIPE_PIPE] = ACTIONS(900),
    [anon_sym_EQ_EQ] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(900),
    [anon_sym_LT_EQ] = ACTIONS(900),
    [anon_sym_GT_EQ] = ACTIONS(900),
    [anon_sym_LT_LT] = ACTIONS(902),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_PLUS_EQ] = ACTIONS(900),
    [anon_sym_DASH_EQ] = ACTIONS(900),
    [anon_sym_STAR_EQ] = ACTIONS(900),
    [anon_sym_SLASH_EQ] = ACTIONS(900),
    [anon_sym_PERCENT_EQ] = ACTIONS(900),
    [anon_sym_AMP_EQ] = ACTIONS(900),
    [anon_sym_PIPE_EQ] = ACTIONS(900),
    [anon_sym_CARET_EQ] = ACTIONS(900),
    [anon_sym_LT_LT_EQ] = ACTIONS(900),
    [anon_sym_GT_GT_EQ] = ACTIONS(900),
    [anon_sym_yield] = ACTIONS(902),
    [anon_sym_move] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [sym_integer_literal] = ACTIONS(900),
    [aux_sym_string_literal_token1] = ACTIONS(900),
    [sym_char_literal] = ACTIONS(900),
    [anon_sym_true] = ACTIONS(902),
    [anon_sym_false] = ACTIONS(902),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(902),
    [sym_super] = ACTIONS(902),
    [sym_crate] = ACTIONS(902),
    [sym_metavariable] = ACTIONS(900),
    [sym_raw_string_literal] = ACTIONS(900),
    [sym_float_literal] = ACTIONS(900),
  },
  [167] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1709),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(167),
    [sym_block_comment] = STATE(167),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [168] = {
    [sym_line_comment] = STATE(168),
    [sym_block_comment] = STATE(168),
    [ts_builtin_sym_end] = ACTIONS(904),
    [sym_identifier] = ACTIONS(906),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_macro_rules_BANG] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(906),
    [anon_sym_QMARK] = ACTIONS(904),
    [anon_sym_u8] = ACTIONS(906),
    [anon_sym_i8] = ACTIONS(906),
    [anon_sym_u16] = ACTIONS(906),
    [anon_sym_i16] = ACTIONS(906),
    [anon_sym_u32] = ACTIONS(906),
    [anon_sym_i32] = ACTIONS(906),
    [anon_sym_u64] = ACTIONS(906),
    [anon_sym_i64] = ACTIONS(906),
    [anon_sym_u128] = ACTIONS(906),
    [anon_sym_i128] = ACTIONS(906),
    [anon_sym_isize] = ACTIONS(906),
    [anon_sym_usize] = ACTIONS(906),
    [anon_sym_f32] = ACTIONS(906),
    [anon_sym_f64] = ACTIONS(906),
    [anon_sym_bool] = ACTIONS(906),
    [anon_sym_str] = ACTIONS(906),
    [anon_sym_char] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_EQ] = ACTIONS(906),
    [anon_sym_COLON_COLON] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_DOT] = ACTIONS(906),
    [anon_sym_AMP] = ACTIONS(906),
    [anon_sym_POUND] = ACTIONS(904),
    [anon_sym_PERCENT] = ACTIONS(906),
    [anon_sym_CARET] = ACTIONS(906),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_PIPE] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(906),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_fn] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_impl] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_loop] = ACTIONS(906),
    [anon_sym_match] = ACTIONS(906),
    [anon_sym_mod] = ACTIONS(906),
    [anon_sym_pub] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_struct] = ACTIONS(906),
    [anon_sym_trait] = ACTIONS(906),
    [anon_sym_type] = ACTIONS(906),
    [anon_sym_union] = ACTIONS(906),
    [anon_sym_unsafe] = ACTIONS(906),
    [anon_sym_use] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_extern] = ACTIONS(906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(904),
    [anon_sym_DOT_DOT] = ACTIONS(906),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(904),
    [anon_sym_AMP_AMP] = ACTIONS(904),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(904),
    [anon_sym_LT_LT] = ACTIONS(906),
    [anon_sym_GT_GT] = ACTIONS(906),
    [anon_sym_PLUS_EQ] = ACTIONS(904),
    [anon_sym_DASH_EQ] = ACTIONS(904),
    [anon_sym_STAR_EQ] = ACTIONS(904),
    [anon_sym_SLASH_EQ] = ACTIONS(904),
    [anon_sym_PERCENT_EQ] = ACTIONS(904),
    [anon_sym_AMP_EQ] = ACTIONS(904),
    [anon_sym_PIPE_EQ] = ACTIONS(904),
    [anon_sym_CARET_EQ] = ACTIONS(904),
    [anon_sym_LT_LT_EQ] = ACTIONS(904),
    [anon_sym_GT_GT_EQ] = ACTIONS(904),
    [anon_sym_yield] = ACTIONS(906),
    [anon_sym_move] = ACTIONS(906),
    [anon_sym_try] = ACTIONS(906),
    [sym_integer_literal] = ACTIONS(904),
    [aux_sym_string_literal_token1] = ACTIONS(904),
    [sym_char_literal] = ACTIONS(904),
    [anon_sym_true] = ACTIONS(906),
    [anon_sym_false] = ACTIONS(906),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(906),
    [sym_super] = ACTIONS(906),
    [sym_crate] = ACTIONS(906),
    [sym_metavariable] = ACTIONS(904),
    [sym_raw_string_literal] = ACTIONS(904),
    [sym_float_literal] = ACTIONS(904),
  },
  [169] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1832),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(169),
    [sym_block_comment] = STATE(169),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [170] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1797),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(170),
    [sym_block_comment] = STATE(170),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [171] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1660),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [172] = {
    [sym_line_comment] = STATE(172),
    [sym_block_comment] = STATE(172),
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(910),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_macro_rules_BANG] = ACTIONS(908),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_LBRACK] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(910),
    [anon_sym_QMARK] = ACTIONS(908),
    [anon_sym_u8] = ACTIONS(910),
    [anon_sym_i8] = ACTIONS(910),
    [anon_sym_u16] = ACTIONS(910),
    [anon_sym_i16] = ACTIONS(910),
    [anon_sym_u32] = ACTIONS(910),
    [anon_sym_i32] = ACTIONS(910),
    [anon_sym_u64] = ACTIONS(910),
    [anon_sym_i64] = ACTIONS(910),
    [anon_sym_u128] = ACTIONS(910),
    [anon_sym_i128] = ACTIONS(910),
    [anon_sym_isize] = ACTIONS(910),
    [anon_sym_usize] = ACTIONS(910),
    [anon_sym_f32] = ACTIONS(910),
    [anon_sym_f64] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_str] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_COLON_COLON] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(910),
    [anon_sym_DOT] = ACTIONS(910),
    [anon_sym_AMP] = ACTIONS(910),
    [anon_sym_POUND] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(910),
    [anon_sym_CARET] = ACTIONS(910),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_GT] = ACTIONS(910),
    [anon_sym_PIPE] = ACTIONS(910),
    [anon_sym_SQUOTE] = ACTIONS(910),
    [anon_sym_as] = ACTIONS(910),
    [anon_sym_async] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_fn] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_impl] = ACTIONS(910),
    [anon_sym_let] = ACTIONS(910),
    [anon_sym_loop] = ACTIONS(910),
    [anon_sym_match] = ACTIONS(910),
    [anon_sym_mod] = ACTIONS(910),
    [anon_sym_pub] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_trait] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_unsafe] = ACTIONS(910),
    [anon_sym_use] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(908),
    [anon_sym_DOT_DOT] = ACTIONS(910),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(908),
    [anon_sym_AMP_AMP] = ACTIONS(908),
    [anon_sym_PIPE_PIPE] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(908),
    [anon_sym_BANG_EQ] = ACTIONS(908),
    [anon_sym_LT_EQ] = ACTIONS(908),
    [anon_sym_GT_EQ] = ACTIONS(908),
    [anon_sym_LT_LT] = ACTIONS(910),
    [anon_sym_GT_GT] = ACTIONS(910),
    [anon_sym_PLUS_EQ] = ACTIONS(908),
    [anon_sym_DASH_EQ] = ACTIONS(908),
    [anon_sym_STAR_EQ] = ACTIONS(908),
    [anon_sym_SLASH_EQ] = ACTIONS(908),
    [anon_sym_PERCENT_EQ] = ACTIONS(908),
    [anon_sym_AMP_EQ] = ACTIONS(908),
    [anon_sym_PIPE_EQ] = ACTIONS(908),
    [anon_sym_CARET_EQ] = ACTIONS(908),
    [anon_sym_LT_LT_EQ] = ACTIONS(908),
    [anon_sym_GT_GT_EQ] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_move] = ACTIONS(910),
    [anon_sym_try] = ACTIONS(910),
    [sym_integer_literal] = ACTIONS(908),
    [aux_sym_string_literal_token1] = ACTIONS(908),
    [sym_char_literal] = ACTIONS(908),
    [anon_sym_true] = ACTIONS(910),
    [anon_sym_false] = ACTIONS(910),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(910),
    [sym_super] = ACTIONS(910),
    [sym_crate] = ACTIONS(910),
    [sym_metavariable] = ACTIONS(908),
    [sym_raw_string_literal] = ACTIONS(908),
    [sym_float_literal] = ACTIONS(908),
  },
  [173] = {
    [sym_line_comment] = STATE(173),
    [sym_block_comment] = STATE(173),
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(914),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_macro_rules_BANG] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(914),
    [anon_sym_QMARK] = ACTIONS(912),
    [anon_sym_u8] = ACTIONS(914),
    [anon_sym_i8] = ACTIONS(914),
    [anon_sym_u16] = ACTIONS(914),
    [anon_sym_i16] = ACTIONS(914),
    [anon_sym_u32] = ACTIONS(914),
    [anon_sym_i32] = ACTIONS(914),
    [anon_sym_u64] = ACTIONS(914),
    [anon_sym_i64] = ACTIONS(914),
    [anon_sym_u128] = ACTIONS(914),
    [anon_sym_i128] = ACTIONS(914),
    [anon_sym_isize] = ACTIONS(914),
    [anon_sym_usize] = ACTIONS(914),
    [anon_sym_f32] = ACTIONS(914),
    [anon_sym_f64] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_str] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_EQ] = ACTIONS(914),
    [anon_sym_COLON_COLON] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(914),
    [anon_sym_AMP] = ACTIONS(914),
    [anon_sym_POUND] = ACTIONS(912),
    [anon_sym_PERCENT] = ACTIONS(914),
    [anon_sym_CARET] = ACTIONS(914),
    [anon_sym_LT] = ACTIONS(914),
    [anon_sym_GT] = ACTIONS(914),
    [anon_sym_PIPE] = ACTIONS(914),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_async] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_fn] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_impl] = ACTIONS(914),
    [anon_sym_let] = ACTIONS(914),
    [anon_sym_loop] = ACTIONS(914),
    [anon_sym_match] = ACTIONS(914),
    [anon_sym_mod] = ACTIONS(914),
    [anon_sym_pub] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_trait] = ACTIONS(914),
    [anon_sym_type] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_unsafe] = ACTIONS(914),
    [anon_sym_use] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(912),
    [anon_sym_DOT_DOT] = ACTIONS(914),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(912),
    [anon_sym_AMP_AMP] = ACTIONS(912),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(912),
    [anon_sym_BANG_EQ] = ACTIONS(912),
    [anon_sym_LT_EQ] = ACTIONS(912),
    [anon_sym_GT_EQ] = ACTIONS(912),
    [anon_sym_LT_LT] = ACTIONS(914),
    [anon_sym_GT_GT] = ACTIONS(914),
    [anon_sym_PLUS_EQ] = ACTIONS(912),
    [anon_sym_DASH_EQ] = ACTIONS(912),
    [anon_sym_STAR_EQ] = ACTIONS(912),
    [anon_sym_SLASH_EQ] = ACTIONS(912),
    [anon_sym_PERCENT_EQ] = ACTIONS(912),
    [anon_sym_AMP_EQ] = ACTIONS(912),
    [anon_sym_PIPE_EQ] = ACTIONS(912),
    [anon_sym_CARET_EQ] = ACTIONS(912),
    [anon_sym_LT_LT_EQ] = ACTIONS(912),
    [anon_sym_GT_GT_EQ] = ACTIONS(912),
    [anon_sym_yield] = ACTIONS(914),
    [anon_sym_move] = ACTIONS(914),
    [anon_sym_try] = ACTIONS(914),
    [sym_integer_literal] = ACTIONS(912),
    [aux_sym_string_literal_token1] = ACTIONS(912),
    [sym_char_literal] = ACTIONS(912),
    [anon_sym_true] = ACTIONS(914),
    [anon_sym_false] = ACTIONS(914),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(914),
    [sym_super] = ACTIONS(914),
    [sym_crate] = ACTIONS(914),
    [sym_metavariable] = ACTIONS(912),
    [sym_raw_string_literal] = ACTIONS(912),
    [sym_float_literal] = ACTIONS(912),
  },
  [174] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1769),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [175] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1556),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(175),
    [sym_block_comment] = STATE(175),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [176] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1739),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(176),
    [sym_block_comment] = STATE(176),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [177] = {
    [sym_line_comment] = STATE(177),
    [sym_block_comment] = STATE(177),
    [ts_builtin_sym_end] = ACTIONS(916),
    [sym_identifier] = ACTIONS(918),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_macro_rules_BANG] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(916),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(918),
    [anon_sym_QMARK] = ACTIONS(916),
    [anon_sym_u8] = ACTIONS(918),
    [anon_sym_i8] = ACTIONS(918),
    [anon_sym_u16] = ACTIONS(918),
    [anon_sym_i16] = ACTIONS(918),
    [anon_sym_u32] = ACTIONS(918),
    [anon_sym_i32] = ACTIONS(918),
    [anon_sym_u64] = ACTIONS(918),
    [anon_sym_i64] = ACTIONS(918),
    [anon_sym_u128] = ACTIONS(918),
    [anon_sym_i128] = ACTIONS(918),
    [anon_sym_isize] = ACTIONS(918),
    [anon_sym_usize] = ACTIONS(918),
    [anon_sym_f32] = ACTIONS(918),
    [anon_sym_f64] = ACTIONS(918),
    [anon_sym_bool] = ACTIONS(918),
    [anon_sym_str] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_EQ] = ACTIONS(918),
    [anon_sym_COLON_COLON] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_DOT] = ACTIONS(918),
    [anon_sym_AMP] = ACTIONS(918),
    [anon_sym_POUND] = ACTIONS(916),
    [anon_sym_PERCENT] = ACTIONS(918),
    [anon_sym_CARET] = ACTIONS(918),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_GT] = ACTIONS(918),
    [anon_sym_PIPE] = ACTIONS(918),
    [anon_sym_SQUOTE] = ACTIONS(918),
    [anon_sym_as] = ACTIONS(918),
    [anon_sym_async] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_fn] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_impl] = ACTIONS(918),
    [anon_sym_let] = ACTIONS(918),
    [anon_sym_loop] = ACTIONS(918),
    [anon_sym_match] = ACTIONS(918),
    [anon_sym_mod] = ACTIONS(918),
    [anon_sym_pub] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_trait] = ACTIONS(918),
    [anon_sym_type] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_unsafe] = ACTIONS(918),
    [anon_sym_use] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(916),
    [anon_sym_DOT_DOT] = ACTIONS(918),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(916),
    [anon_sym_AMP_AMP] = ACTIONS(916),
    [anon_sym_PIPE_PIPE] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(916),
    [anon_sym_BANG_EQ] = ACTIONS(916),
    [anon_sym_LT_EQ] = ACTIONS(916),
    [anon_sym_GT_EQ] = ACTIONS(916),
    [anon_sym_LT_LT] = ACTIONS(918),
    [anon_sym_GT_GT] = ACTIONS(918),
    [anon_sym_PLUS_EQ] = ACTIONS(916),
    [anon_sym_DASH_EQ] = ACTIONS(916),
    [anon_sym_STAR_EQ] = ACTIONS(916),
    [anon_sym_SLASH_EQ] = ACTIONS(916),
    [anon_sym_PERCENT_EQ] = ACTIONS(916),
    [anon_sym_AMP_EQ] = ACTIONS(916),
    [anon_sym_PIPE_EQ] = ACTIONS(916),
    [anon_sym_CARET_EQ] = ACTIONS(916),
    [anon_sym_LT_LT_EQ] = ACTIONS(916),
    [anon_sym_GT_GT_EQ] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(918),
    [anon_sym_move] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(918),
    [sym_integer_literal] = ACTIONS(916),
    [aux_sym_string_literal_token1] = ACTIONS(916),
    [sym_char_literal] = ACTIONS(916),
    [anon_sym_true] = ACTIONS(918),
    [anon_sym_false] = ACTIONS(918),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(918),
    [sym_super] = ACTIONS(918),
    [sym_crate] = ACTIONS(918),
    [sym_metavariable] = ACTIONS(916),
    [sym_raw_string_literal] = ACTIONS(916),
    [sym_float_literal] = ACTIONS(916),
  },
  [178] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1861),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(178),
    [sym_block_comment] = STATE(178),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [179] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1851),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(179),
    [sym_block_comment] = STATE(179),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [180] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1469),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [181] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1869),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(181),
    [sym_block_comment] = STATE(181),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [182] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1798),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [183] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1803),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(183),
    [sym_block_comment] = STATE(183),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [184] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1646),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(184),
    [sym_block_comment] = STATE(184),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [185] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1816),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(185),
    [sym_block_comment] = STATE(185),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [186] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1796),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(186),
    [sym_block_comment] = STATE(186),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [187] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1819),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(187),
    [sym_block_comment] = STATE(187),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [188] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1856),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(487),
    [sym_match_expression] = STATE(487),
    [sym_while_expression] = STATE(487),
    [sym_loop_expression] = STATE(487),
    [sym_for_expression] = STATE(487),
    [sym_const_block] = STATE(487),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3500),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(487),
    [sym_async_block] = STATE(487),
    [sym_try_block] = STATE(487),
    [sym_block] = STATE(487),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(188),
    [sym_block_comment] = STATE(188),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_loop] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(938),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [189] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1820),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(189),
    [sym_block_comment] = STATE(189),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [190] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1648),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(190),
    [sym_block_comment] = STATE(190),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [191] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1872),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(191),
    [sym_block_comment] = STATE(191),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [192] = {
    [sym_line_comment] = STATE(192),
    [sym_block_comment] = STATE(192),
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_macro_rules_BANG] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_QMARK] = ACTIONS(940),
    [anon_sym_u8] = ACTIONS(942),
    [anon_sym_i8] = ACTIONS(942),
    [anon_sym_u16] = ACTIONS(942),
    [anon_sym_i16] = ACTIONS(942),
    [anon_sym_u32] = ACTIONS(942),
    [anon_sym_i32] = ACTIONS(942),
    [anon_sym_u64] = ACTIONS(942),
    [anon_sym_i64] = ACTIONS(942),
    [anon_sym_u128] = ACTIONS(942),
    [anon_sym_i128] = ACTIONS(942),
    [anon_sym_isize] = ACTIONS(942),
    [anon_sym_usize] = ACTIONS(942),
    [anon_sym_f32] = ACTIONS(942),
    [anon_sym_f64] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_str] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_EQ] = ACTIONS(942),
    [anon_sym_COLON_COLON] = ACTIONS(940),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_DOT] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_POUND] = ACTIONS(940),
    [anon_sym_PERCENT] = ACTIONS(942),
    [anon_sym_CARET] = ACTIONS(942),
    [anon_sym_LT] = ACTIONS(942),
    [anon_sym_GT] = ACTIONS(942),
    [anon_sym_PIPE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [anon_sym_as] = ACTIONS(942),
    [anon_sym_async] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_fn] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_impl] = ACTIONS(942),
    [anon_sym_let] = ACTIONS(942),
    [anon_sym_loop] = ACTIONS(942),
    [anon_sym_match] = ACTIONS(942),
    [anon_sym_mod] = ACTIONS(942),
    [anon_sym_pub] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_struct] = ACTIONS(942),
    [anon_sym_trait] = ACTIONS(942),
    [anon_sym_type] = ACTIONS(942),
    [anon_sym_union] = ACTIONS(942),
    [anon_sym_unsafe] = ACTIONS(942),
    [anon_sym_use] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_extern] = ACTIONS(942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(940),
    [anon_sym_DOT_DOT] = ACTIONS(942),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(940),
    [anon_sym_AMP_AMP] = ACTIONS(940),
    [anon_sym_PIPE_PIPE] = ACTIONS(940),
    [anon_sym_EQ_EQ] = ACTIONS(940),
    [anon_sym_BANG_EQ] = ACTIONS(940),
    [anon_sym_LT_EQ] = ACTIONS(940),
    [anon_sym_GT_EQ] = ACTIONS(940),
    [anon_sym_LT_LT] = ACTIONS(942),
    [anon_sym_GT_GT] = ACTIONS(942),
    [anon_sym_PLUS_EQ] = ACTIONS(940),
    [anon_sym_DASH_EQ] = ACTIONS(940),
    [anon_sym_STAR_EQ] = ACTIONS(940),
    [anon_sym_SLASH_EQ] = ACTIONS(940),
    [anon_sym_PERCENT_EQ] = ACTIONS(940),
    [anon_sym_AMP_EQ] = ACTIONS(940),
    [anon_sym_PIPE_EQ] = ACTIONS(940),
    [anon_sym_CARET_EQ] = ACTIONS(940),
    [anon_sym_LT_LT_EQ] = ACTIONS(940),
    [anon_sym_GT_GT_EQ] = ACTIONS(940),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_move] = ACTIONS(942),
    [anon_sym_try] = ACTIONS(942),
    [sym_integer_literal] = ACTIONS(940),
    [aux_sym_string_literal_token1] = ACTIONS(940),
    [sym_char_literal] = ACTIONS(940),
    [anon_sym_true] = ACTIONS(942),
    [anon_sym_false] = ACTIONS(942),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_crate] = ACTIONS(942),
    [sym_metavariable] = ACTIONS(940),
    [sym_raw_string_literal] = ACTIONS(940),
    [sym_float_literal] = ACTIONS(940),
  },
  [193] = {
    [sym_line_comment] = STATE(193),
    [sym_block_comment] = STATE(193),
    [ts_builtin_sym_end] = ACTIONS(944),
    [sym_identifier] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_macro_rules_BANG] = ACTIONS(944),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_LBRACK] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_QMARK] = ACTIONS(950),
    [anon_sym_u8] = ACTIONS(946),
    [anon_sym_i8] = ACTIONS(946),
    [anon_sym_u16] = ACTIONS(946),
    [anon_sym_i16] = ACTIONS(946),
    [anon_sym_u32] = ACTIONS(946),
    [anon_sym_i32] = ACTIONS(946),
    [anon_sym_u64] = ACTIONS(946),
    [anon_sym_i64] = ACTIONS(946),
    [anon_sym_u128] = ACTIONS(946),
    [anon_sym_i128] = ACTIONS(946),
    [anon_sym_isize] = ACTIONS(946),
    [anon_sym_usize] = ACTIONS(946),
    [anon_sym_f32] = ACTIONS(946),
    [anon_sym_f64] = ACTIONS(946),
    [anon_sym_bool] = ACTIONS(946),
    [anon_sym_str] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_EQ] = ACTIONS(948),
    [anon_sym_COLON_COLON] = ACTIONS(944),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_DOT] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_POUND] = ACTIONS(944),
    [anon_sym_PERCENT] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(946),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [anon_sym_as] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_fn] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_impl] = ACTIONS(946),
    [anon_sym_let] = ACTIONS(946),
    [anon_sym_loop] = ACTIONS(946),
    [anon_sym_match] = ACTIONS(946),
    [anon_sym_mod] = ACTIONS(946),
    [anon_sym_pub] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_trait] = ACTIONS(946),
    [anon_sym_type] = ACTIONS(946),
    [anon_sym_union] = ACTIONS(946),
    [anon_sym_unsafe] = ACTIONS(946),
    [anon_sym_use] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(950),
    [anon_sym_DOT_DOT] = ACTIONS(946),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_LT_LT] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_PLUS_EQ] = ACTIONS(950),
    [anon_sym_DASH_EQ] = ACTIONS(950),
    [anon_sym_STAR_EQ] = ACTIONS(950),
    [anon_sym_SLASH_EQ] = ACTIONS(950),
    [anon_sym_PERCENT_EQ] = ACTIONS(950),
    [anon_sym_AMP_EQ] = ACTIONS(950),
    [anon_sym_PIPE_EQ] = ACTIONS(950),
    [anon_sym_CARET_EQ] = ACTIONS(950),
    [anon_sym_LT_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_GT_EQ] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_move] = ACTIONS(946),
    [anon_sym_try] = ACTIONS(946),
    [sym_integer_literal] = ACTIONS(944),
    [aux_sym_string_literal_token1] = ACTIONS(944),
    [sym_char_literal] = ACTIONS(944),
    [anon_sym_true] = ACTIONS(946),
    [anon_sym_false] = ACTIONS(946),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(946),
    [sym_super] = ACTIONS(946),
    [sym_crate] = ACTIONS(946),
    [sym_metavariable] = ACTIONS(944),
    [sym_raw_string_literal] = ACTIONS(944),
    [sym_float_literal] = ACTIONS(944),
  },
  [194] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(194),
    [sym_block_comment] = STATE(194),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [195] = {
    [sym_line_comment] = STATE(195),
    [sym_block_comment] = STATE(195),
    [ts_builtin_sym_end] = ACTIONS(952),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_macro_rules_BANG] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_QMARK] = ACTIONS(952),
    [anon_sym_u8] = ACTIONS(954),
    [anon_sym_i8] = ACTIONS(954),
    [anon_sym_u16] = ACTIONS(954),
    [anon_sym_i16] = ACTIONS(954),
    [anon_sym_u32] = ACTIONS(954),
    [anon_sym_i32] = ACTIONS(954),
    [anon_sym_u64] = ACTIONS(954),
    [anon_sym_i64] = ACTIONS(954),
    [anon_sym_u128] = ACTIONS(954),
    [anon_sym_i128] = ACTIONS(954),
    [anon_sym_isize] = ACTIONS(954),
    [anon_sym_usize] = ACTIONS(954),
    [anon_sym_f32] = ACTIONS(954),
    [anon_sym_f64] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_str] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_SLASH] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_EQ] = ACTIONS(954),
    [anon_sym_COLON_COLON] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(954),
    [anon_sym_DOT] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_POUND] = ACTIONS(952),
    [anon_sym_PERCENT] = ACTIONS(954),
    [anon_sym_CARET] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(954),
    [anon_sym_SQUOTE] = ACTIONS(954),
    [anon_sym_as] = ACTIONS(954),
    [anon_sym_async] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_fn] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_impl] = ACTIONS(954),
    [anon_sym_let] = ACTIONS(954),
    [anon_sym_loop] = ACTIONS(954),
    [anon_sym_match] = ACTIONS(954),
    [anon_sym_mod] = ACTIONS(954),
    [anon_sym_pub] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_struct] = ACTIONS(954),
    [anon_sym_trait] = ACTIONS(954),
    [anon_sym_type] = ACTIONS(954),
    [anon_sym_union] = ACTIONS(954),
    [anon_sym_unsafe] = ACTIONS(954),
    [anon_sym_use] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_extern] = ACTIONS(954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(952),
    [anon_sym_DOT_DOT] = ACTIONS(954),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(952),
    [anon_sym_AMP_AMP] = ACTIONS(952),
    [anon_sym_PIPE_PIPE] = ACTIONS(952),
    [anon_sym_EQ_EQ] = ACTIONS(952),
    [anon_sym_BANG_EQ] = ACTIONS(952),
    [anon_sym_LT_EQ] = ACTIONS(952),
    [anon_sym_GT_EQ] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(954),
    [anon_sym_GT_GT] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(952),
    [anon_sym_DASH_EQ] = ACTIONS(952),
    [anon_sym_STAR_EQ] = ACTIONS(952),
    [anon_sym_SLASH_EQ] = ACTIONS(952),
    [anon_sym_PERCENT_EQ] = ACTIONS(952),
    [anon_sym_AMP_EQ] = ACTIONS(952),
    [anon_sym_PIPE_EQ] = ACTIONS(952),
    [anon_sym_CARET_EQ] = ACTIONS(952),
    [anon_sym_LT_LT_EQ] = ACTIONS(952),
    [anon_sym_GT_GT_EQ] = ACTIONS(952),
    [anon_sym_yield] = ACTIONS(954),
    [anon_sym_move] = ACTIONS(954),
    [anon_sym_try] = ACTIONS(954),
    [sym_integer_literal] = ACTIONS(952),
    [aux_sym_string_literal_token1] = ACTIONS(952),
    [sym_char_literal] = ACTIONS(952),
    [anon_sym_true] = ACTIONS(954),
    [anon_sym_false] = ACTIONS(954),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(954),
    [sym_super] = ACTIONS(954),
    [sym_crate] = ACTIONS(954),
    [sym_metavariable] = ACTIONS(952),
    [sym_raw_string_literal] = ACTIONS(952),
    [sym_float_literal] = ACTIONS(952),
  },
  [196] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1624),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(196),
    [sym_block_comment] = STATE(196),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [197] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1824),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(197),
    [sym_block_comment] = STATE(197),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [198] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1649),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(198),
    [sym_block_comment] = STATE(198),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [199] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1827),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [200] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1749),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [201] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1773),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [202] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1650),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(202),
    [sym_block_comment] = STATE(202),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [203] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1658),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(203),
    [sym_block_comment] = STATE(203),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [204] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1747),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(204),
    [sym_block_comment] = STATE(204),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [205] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1223),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(205),
    [sym_block_comment] = STATE(205),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [206] = {
    [sym_line_comment] = STATE(206),
    [sym_block_comment] = STATE(206),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(950),
    [anon_sym_macro_rules_BANG] = ACTIONS(956),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(950),
    [anon_sym_u8] = ACTIONS(958),
    [anon_sym_i8] = ACTIONS(958),
    [anon_sym_u16] = ACTIONS(958),
    [anon_sym_i16] = ACTIONS(958),
    [anon_sym_u32] = ACTIONS(958),
    [anon_sym_i32] = ACTIONS(958),
    [anon_sym_u64] = ACTIONS(958),
    [anon_sym_i64] = ACTIONS(958),
    [anon_sym_u128] = ACTIONS(958),
    [anon_sym_i128] = ACTIONS(958),
    [anon_sym_isize] = ACTIONS(958),
    [anon_sym_usize] = ACTIONS(958),
    [anon_sym_f32] = ACTIONS(958),
    [anon_sym_f64] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_str] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_EQ] = ACTIONS(948),
    [anon_sym_COLON_COLON] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_DOT] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_POUND] = ACTIONS(956),
    [anon_sym_PERCENT] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_fn] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_impl] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_loop] = ACTIONS(958),
    [anon_sym_match] = ACTIONS(958),
    [anon_sym_mod] = ACTIONS(958),
    [anon_sym_pub] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_trait] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_unsafe] = ACTIONS(958),
    [anon_sym_use] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(950),
    [anon_sym_DOT_DOT] = ACTIONS(948),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_LT_LT] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_PLUS_EQ] = ACTIONS(950),
    [anon_sym_DASH_EQ] = ACTIONS(950),
    [anon_sym_STAR_EQ] = ACTIONS(950),
    [anon_sym_SLASH_EQ] = ACTIONS(950),
    [anon_sym_PERCENT_EQ] = ACTIONS(950),
    [anon_sym_AMP_EQ] = ACTIONS(950),
    [anon_sym_PIPE_EQ] = ACTIONS(950),
    [anon_sym_CARET_EQ] = ACTIONS(950),
    [anon_sym_LT_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_GT_EQ] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_move] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [sym_integer_literal] = ACTIONS(956),
    [aux_sym_string_literal_token1] = ACTIONS(956),
    [sym_char_literal] = ACTIONS(956),
    [anon_sym_true] = ACTIONS(958),
    [anon_sym_false] = ACTIONS(958),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_crate] = ACTIONS(958),
    [sym_metavariable] = ACTIONS(956),
    [sym_raw_string_literal] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
  },
  [207] = {
    [sym_line_comment] = STATE(207),
    [sym_block_comment] = STATE(207),
    [ts_builtin_sym_end] = ACTIONS(960),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(960),
    [anon_sym_macro_rules_BANG] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_QMARK] = ACTIONS(960),
    [anon_sym_u8] = ACTIONS(962),
    [anon_sym_i8] = ACTIONS(962),
    [anon_sym_u16] = ACTIONS(962),
    [anon_sym_i16] = ACTIONS(962),
    [anon_sym_u32] = ACTIONS(962),
    [anon_sym_i32] = ACTIONS(962),
    [anon_sym_u64] = ACTIONS(962),
    [anon_sym_i64] = ACTIONS(962),
    [anon_sym_u128] = ACTIONS(962),
    [anon_sym_i128] = ACTIONS(962),
    [anon_sym_isize] = ACTIONS(962),
    [anon_sym_usize] = ACTIONS(962),
    [anon_sym_f32] = ACTIONS(962),
    [anon_sym_f64] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_str] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_EQ] = ACTIONS(962),
    [anon_sym_COLON_COLON] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_POUND] = ACTIONS(960),
    [anon_sym_PERCENT] = ACTIONS(962),
    [anon_sym_CARET] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(962),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [anon_sym_as] = ACTIONS(962),
    [anon_sym_async] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_fn] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_impl] = ACTIONS(962),
    [anon_sym_let] = ACTIONS(962),
    [anon_sym_loop] = ACTIONS(962),
    [anon_sym_match] = ACTIONS(962),
    [anon_sym_mod] = ACTIONS(962),
    [anon_sym_pub] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_struct] = ACTIONS(962),
    [anon_sym_trait] = ACTIONS(962),
    [anon_sym_type] = ACTIONS(962),
    [anon_sym_union] = ACTIONS(962),
    [anon_sym_unsafe] = ACTIONS(962),
    [anon_sym_use] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_extern] = ACTIONS(962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(960),
    [anon_sym_DOT_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_EQ_EQ] = ACTIONS(960),
    [anon_sym_BANG_EQ] = ACTIONS(960),
    [anon_sym_LT_EQ] = ACTIONS(960),
    [anon_sym_GT_EQ] = ACTIONS(960),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(962),
    [anon_sym_PLUS_EQ] = ACTIONS(960),
    [anon_sym_DASH_EQ] = ACTIONS(960),
    [anon_sym_STAR_EQ] = ACTIONS(960),
    [anon_sym_SLASH_EQ] = ACTIONS(960),
    [anon_sym_PERCENT_EQ] = ACTIONS(960),
    [anon_sym_AMP_EQ] = ACTIONS(960),
    [anon_sym_PIPE_EQ] = ACTIONS(960),
    [anon_sym_CARET_EQ] = ACTIONS(960),
    [anon_sym_LT_LT_EQ] = ACTIONS(960),
    [anon_sym_GT_GT_EQ] = ACTIONS(960),
    [anon_sym_yield] = ACTIONS(962),
    [anon_sym_move] = ACTIONS(962),
    [anon_sym_try] = ACTIONS(962),
    [sym_integer_literal] = ACTIONS(960),
    [aux_sym_string_literal_token1] = ACTIONS(960),
    [sym_char_literal] = ACTIONS(960),
    [anon_sym_true] = ACTIONS(962),
    [anon_sym_false] = ACTIONS(962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(962),
    [sym_super] = ACTIONS(962),
    [sym_crate] = ACTIONS(962),
    [sym_metavariable] = ACTIONS(960),
    [sym_raw_string_literal] = ACTIONS(960),
    [sym_float_literal] = ACTIONS(960),
  },
  [208] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1775),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [209] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1875),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(209),
    [sym_block_comment] = STATE(209),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [210] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1735),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(210),
    [sym_block_comment] = STATE(210),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(734),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [211] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1850),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(211),
    [sym_block_comment] = STATE(211),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [212] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1641),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(212),
    [sym_block_comment] = STATE(212),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [213] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1723),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(213),
    [sym_block_comment] = STATE(213),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [214] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1726),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(214),
    [sym_block_comment] = STATE(214),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [215] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1727),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(215),
    [sym_block_comment] = STATE(215),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [216] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1194),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [217] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1662),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(217),
    [sym_block_comment] = STATE(217),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [218] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1729),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [219] = {
    [sym_line_comment] = STATE(219),
    [sym_block_comment] = STATE(219),
    [ts_builtin_sym_end] = ACTIONS(964),
    [sym_identifier] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(964),
    [anon_sym_macro_rules_BANG] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_QMARK] = ACTIONS(964),
    [anon_sym_u8] = ACTIONS(966),
    [anon_sym_i8] = ACTIONS(966),
    [anon_sym_u16] = ACTIONS(966),
    [anon_sym_i16] = ACTIONS(966),
    [anon_sym_u32] = ACTIONS(966),
    [anon_sym_i32] = ACTIONS(966),
    [anon_sym_u64] = ACTIONS(966),
    [anon_sym_i64] = ACTIONS(966),
    [anon_sym_u128] = ACTIONS(966),
    [anon_sym_i128] = ACTIONS(966),
    [anon_sym_isize] = ACTIONS(966),
    [anon_sym_usize] = ACTIONS(966),
    [anon_sym_f32] = ACTIONS(966),
    [anon_sym_f64] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_str] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_SLASH] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_COLON_COLON] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(966),
    [anon_sym_DOT] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(966),
    [anon_sym_POUND] = ACTIONS(964),
    [anon_sym_PERCENT] = ACTIONS(966),
    [anon_sym_CARET] = ACTIONS(966),
    [anon_sym_LT] = ACTIONS(966),
    [anon_sym_GT] = ACTIONS(966),
    [anon_sym_PIPE] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(966),
    [anon_sym_async] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_fn] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_impl] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(966),
    [anon_sym_loop] = ACTIONS(966),
    [anon_sym_match] = ACTIONS(966),
    [anon_sym_mod] = ACTIONS(966),
    [anon_sym_pub] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_struct] = ACTIONS(966),
    [anon_sym_trait] = ACTIONS(966),
    [anon_sym_type] = ACTIONS(966),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_unsafe] = ACTIONS(966),
    [anon_sym_use] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_extern] = ACTIONS(966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(964),
    [anon_sym_DOT_DOT] = ACTIONS(966),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(964),
    [anon_sym_AMP_AMP] = ACTIONS(964),
    [anon_sym_PIPE_PIPE] = ACTIONS(964),
    [anon_sym_EQ_EQ] = ACTIONS(964),
    [anon_sym_BANG_EQ] = ACTIONS(964),
    [anon_sym_LT_EQ] = ACTIONS(964),
    [anon_sym_GT_EQ] = ACTIONS(964),
    [anon_sym_LT_LT] = ACTIONS(966),
    [anon_sym_GT_GT] = ACTIONS(966),
    [anon_sym_PLUS_EQ] = ACTIONS(964),
    [anon_sym_DASH_EQ] = ACTIONS(964),
    [anon_sym_STAR_EQ] = ACTIONS(964),
    [anon_sym_SLASH_EQ] = ACTIONS(964),
    [anon_sym_PERCENT_EQ] = ACTIONS(964),
    [anon_sym_AMP_EQ] = ACTIONS(964),
    [anon_sym_PIPE_EQ] = ACTIONS(964),
    [anon_sym_CARET_EQ] = ACTIONS(964),
    [anon_sym_LT_LT_EQ] = ACTIONS(964),
    [anon_sym_GT_GT_EQ] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(966),
    [anon_sym_move] = ACTIONS(966),
    [anon_sym_try] = ACTIONS(966),
    [sym_integer_literal] = ACTIONS(964),
    [aux_sym_string_literal_token1] = ACTIONS(964),
    [sym_char_literal] = ACTIONS(964),
    [anon_sym_true] = ACTIONS(966),
    [anon_sym_false] = ACTIONS(966),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(966),
    [sym_super] = ACTIONS(966),
    [sym_crate] = ACTIONS(966),
    [sym_metavariable] = ACTIONS(964),
    [sym_raw_string_literal] = ACTIONS(964),
    [sym_float_literal] = ACTIONS(964),
  },
  [220] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1822),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [221] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1775),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [222] = {
    [sym_line_comment] = STATE(222),
    [sym_block_comment] = STATE(222),
    [ts_builtin_sym_end] = ACTIONS(970),
    [sym_identifier] = ACTIONS(972),
    [anon_sym_SEMI] = ACTIONS(970),
    [anon_sym_macro_rules_BANG] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(970),
    [anon_sym_u8] = ACTIONS(972),
    [anon_sym_i8] = ACTIONS(972),
    [anon_sym_u16] = ACTIONS(972),
    [anon_sym_i16] = ACTIONS(972),
    [anon_sym_u32] = ACTIONS(972),
    [anon_sym_i32] = ACTIONS(972),
    [anon_sym_u64] = ACTIONS(972),
    [anon_sym_i64] = ACTIONS(972),
    [anon_sym_u128] = ACTIONS(972),
    [anon_sym_i128] = ACTIONS(972),
    [anon_sym_isize] = ACTIONS(972),
    [anon_sym_usize] = ACTIONS(972),
    [anon_sym_f32] = ACTIONS(972),
    [anon_sym_f64] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_str] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_SLASH] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_EQ] = ACTIONS(972),
    [anon_sym_COLON_COLON] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_DOT] = ACTIONS(972),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_POUND] = ACTIONS(970),
    [anon_sym_PERCENT] = ACTIONS(972),
    [anon_sym_CARET] = ACTIONS(972),
    [anon_sym_LT] = ACTIONS(972),
    [anon_sym_GT] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(972),
    [anon_sym_SQUOTE] = ACTIONS(972),
    [anon_sym_as] = ACTIONS(972),
    [anon_sym_async] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_fn] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_impl] = ACTIONS(972),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_loop] = ACTIONS(972),
    [anon_sym_match] = ACTIONS(972),
    [anon_sym_mod] = ACTIONS(972),
    [anon_sym_pub] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_trait] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_unsafe] = ACTIONS(972),
    [anon_sym_use] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(970),
    [anon_sym_DOT_DOT] = ACTIONS(972),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(970),
    [anon_sym_AMP_AMP] = ACTIONS(970),
    [anon_sym_PIPE_PIPE] = ACTIONS(970),
    [anon_sym_EQ_EQ] = ACTIONS(970),
    [anon_sym_BANG_EQ] = ACTIONS(970),
    [anon_sym_LT_EQ] = ACTIONS(970),
    [anon_sym_GT_EQ] = ACTIONS(970),
    [anon_sym_LT_LT] = ACTIONS(972),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_PLUS_EQ] = ACTIONS(970),
    [anon_sym_DASH_EQ] = ACTIONS(970),
    [anon_sym_STAR_EQ] = ACTIONS(970),
    [anon_sym_SLASH_EQ] = ACTIONS(970),
    [anon_sym_PERCENT_EQ] = ACTIONS(970),
    [anon_sym_AMP_EQ] = ACTIONS(970),
    [anon_sym_PIPE_EQ] = ACTIONS(970),
    [anon_sym_CARET_EQ] = ACTIONS(970),
    [anon_sym_LT_LT_EQ] = ACTIONS(970),
    [anon_sym_GT_GT_EQ] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(972),
    [anon_sym_move] = ACTIONS(972),
    [anon_sym_try] = ACTIONS(972),
    [sym_integer_literal] = ACTIONS(970),
    [aux_sym_string_literal_token1] = ACTIONS(970),
    [sym_char_literal] = ACTIONS(970),
    [anon_sym_true] = ACTIONS(972),
    [anon_sym_false] = ACTIONS(972),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(972),
    [sym_super] = ACTIONS(972),
    [sym_crate] = ACTIONS(972),
    [sym_metavariable] = ACTIONS(970),
    [sym_raw_string_literal] = ACTIONS(970),
    [sym_float_literal] = ACTIONS(970),
  },
  [223] = {
    [sym_line_comment] = STATE(223),
    [sym_block_comment] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_macro_rules_BANG] = ACTIONS(974),
    [anon_sym_LPAREN] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(976),
    [anon_sym_QMARK] = ACTIONS(974),
    [anon_sym_u8] = ACTIONS(976),
    [anon_sym_i8] = ACTIONS(976),
    [anon_sym_u16] = ACTIONS(976),
    [anon_sym_i16] = ACTIONS(976),
    [anon_sym_u32] = ACTIONS(976),
    [anon_sym_i32] = ACTIONS(976),
    [anon_sym_u64] = ACTIONS(976),
    [anon_sym_i64] = ACTIONS(976),
    [anon_sym_u128] = ACTIONS(976),
    [anon_sym_i128] = ACTIONS(976),
    [anon_sym_isize] = ACTIONS(976),
    [anon_sym_usize] = ACTIONS(976),
    [anon_sym_f32] = ACTIONS(976),
    [anon_sym_f64] = ACTIONS(976),
    [anon_sym_bool] = ACTIONS(976),
    [anon_sym_str] = ACTIONS(976),
    [anon_sym_char] = ACTIONS(976),
    [anon_sym_SLASH] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_EQ] = ACTIONS(976),
    [anon_sym_COLON_COLON] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(976),
    [anon_sym_DOT] = ACTIONS(976),
    [anon_sym_AMP] = ACTIONS(976),
    [anon_sym_POUND] = ACTIONS(974),
    [anon_sym_PERCENT] = ACTIONS(976),
    [anon_sym_CARET] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(976),
    [anon_sym_GT] = ACTIONS(976),
    [anon_sym_PIPE] = ACTIONS(976),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_as] = ACTIONS(976),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_fn] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_impl] = ACTIONS(976),
    [anon_sym_let] = ACTIONS(976),
    [anon_sym_loop] = ACTIONS(976),
    [anon_sym_match] = ACTIONS(976),
    [anon_sym_mod] = ACTIONS(976),
    [anon_sym_pub] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_trait] = ACTIONS(976),
    [anon_sym_type] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_unsafe] = ACTIONS(976),
    [anon_sym_use] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(974),
    [anon_sym_DOT_DOT] = ACTIONS(976),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_EQ_EQ] = ACTIONS(974),
    [anon_sym_BANG_EQ] = ACTIONS(974),
    [anon_sym_LT_EQ] = ACTIONS(974),
    [anon_sym_GT_EQ] = ACTIONS(974),
    [anon_sym_LT_LT] = ACTIONS(976),
    [anon_sym_GT_GT] = ACTIONS(976),
    [anon_sym_PLUS_EQ] = ACTIONS(974),
    [anon_sym_DASH_EQ] = ACTIONS(974),
    [anon_sym_STAR_EQ] = ACTIONS(974),
    [anon_sym_SLASH_EQ] = ACTIONS(974),
    [anon_sym_PERCENT_EQ] = ACTIONS(974),
    [anon_sym_AMP_EQ] = ACTIONS(974),
    [anon_sym_PIPE_EQ] = ACTIONS(974),
    [anon_sym_CARET_EQ] = ACTIONS(974),
    [anon_sym_LT_LT_EQ] = ACTIONS(974),
    [anon_sym_GT_GT_EQ] = ACTIONS(974),
    [anon_sym_yield] = ACTIONS(976),
    [anon_sym_move] = ACTIONS(976),
    [anon_sym_try] = ACTIONS(976),
    [sym_integer_literal] = ACTIONS(974),
    [aux_sym_string_literal_token1] = ACTIONS(974),
    [sym_char_literal] = ACTIONS(974),
    [anon_sym_true] = ACTIONS(976),
    [anon_sym_false] = ACTIONS(976),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(976),
    [sym_super] = ACTIONS(976),
    [sym_crate] = ACTIONS(976),
    [sym_metavariable] = ACTIONS(974),
    [sym_raw_string_literal] = ACTIONS(974),
    [sym_float_literal] = ACTIONS(974),
  },
  [224] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(224),
    [sym_block_comment] = STATE(224),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [225] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1805),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(225),
    [sym_block_comment] = STATE(225),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [226] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1731),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(226),
    [sym_block_comment] = STATE(226),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [227] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1867),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(227),
    [sym_block_comment] = STATE(227),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [228] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1293),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(228),
    [sym_block_comment] = STATE(228),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [229] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1730),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(229),
    [sym_block_comment] = STATE(229),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [230] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1802),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(230),
    [sym_block_comment] = STATE(230),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [231] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [232] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1787),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(232),
    [sym_block_comment] = STATE(232),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [233] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1724),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(233),
    [sym_block_comment] = STATE(233),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [234] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1719),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(234),
    [sym_block_comment] = STATE(234),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [235] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1860),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(235),
    [sym_block_comment] = STATE(235),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [236] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1821),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(236),
    [sym_block_comment] = STATE(236),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [237] = {
    [sym_line_comment] = STATE(237),
    [sym_block_comment] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(978),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_macro_rules_BANG] = ACTIONS(978),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_LBRACK] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_RBRACE] = ACTIONS(978),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_QMARK] = ACTIONS(978),
    [anon_sym_u8] = ACTIONS(980),
    [anon_sym_i8] = ACTIONS(980),
    [anon_sym_u16] = ACTIONS(980),
    [anon_sym_i16] = ACTIONS(980),
    [anon_sym_u32] = ACTIONS(980),
    [anon_sym_i32] = ACTIONS(980),
    [anon_sym_u64] = ACTIONS(980),
    [anon_sym_i64] = ACTIONS(980),
    [anon_sym_u128] = ACTIONS(980),
    [anon_sym_i128] = ACTIONS(980),
    [anon_sym_isize] = ACTIONS(980),
    [anon_sym_usize] = ACTIONS(980),
    [anon_sym_f32] = ACTIONS(980),
    [anon_sym_f64] = ACTIONS(980),
    [anon_sym_bool] = ACTIONS(980),
    [anon_sym_str] = ACTIONS(980),
    [anon_sym_char] = ACTIONS(980),
    [anon_sym_SLASH] = ACTIONS(980),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_EQ] = ACTIONS(980),
    [anon_sym_COLON_COLON] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(980),
    [anon_sym_DOT] = ACTIONS(980),
    [anon_sym_AMP] = ACTIONS(980),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_PERCENT] = ACTIONS(980),
    [anon_sym_CARET] = ACTIONS(980),
    [anon_sym_LT] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(980),
    [anon_sym_PIPE] = ACTIONS(980),
    [anon_sym_SQUOTE] = ACTIONS(980),
    [anon_sym_as] = ACTIONS(980),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_fn] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_impl] = ACTIONS(980),
    [anon_sym_let] = ACTIONS(980),
    [anon_sym_loop] = ACTIONS(980),
    [anon_sym_match] = ACTIONS(980),
    [anon_sym_mod] = ACTIONS(980),
    [anon_sym_pub] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_trait] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_unsafe] = ACTIONS(980),
    [anon_sym_use] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(978),
    [anon_sym_DOT_DOT] = ACTIONS(980),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(978),
    [anon_sym_AMP_AMP] = ACTIONS(978),
    [anon_sym_PIPE_PIPE] = ACTIONS(978),
    [anon_sym_EQ_EQ] = ACTIONS(978),
    [anon_sym_BANG_EQ] = ACTIONS(978),
    [anon_sym_LT_EQ] = ACTIONS(978),
    [anon_sym_GT_EQ] = ACTIONS(978),
    [anon_sym_LT_LT] = ACTIONS(980),
    [anon_sym_GT_GT] = ACTIONS(980),
    [anon_sym_PLUS_EQ] = ACTIONS(978),
    [anon_sym_DASH_EQ] = ACTIONS(978),
    [anon_sym_STAR_EQ] = ACTIONS(978),
    [anon_sym_SLASH_EQ] = ACTIONS(978),
    [anon_sym_PERCENT_EQ] = ACTIONS(978),
    [anon_sym_AMP_EQ] = ACTIONS(978),
    [anon_sym_PIPE_EQ] = ACTIONS(978),
    [anon_sym_CARET_EQ] = ACTIONS(978),
    [anon_sym_LT_LT_EQ] = ACTIONS(978),
    [anon_sym_GT_GT_EQ] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(980),
    [anon_sym_move] = ACTIONS(980),
    [anon_sym_try] = ACTIONS(980),
    [sym_integer_literal] = ACTIONS(978),
    [aux_sym_string_literal_token1] = ACTIONS(978),
    [sym_char_literal] = ACTIONS(978),
    [anon_sym_true] = ACTIONS(980),
    [anon_sym_false] = ACTIONS(980),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(980),
    [sym_super] = ACTIONS(980),
    [sym_crate] = ACTIONS(980),
    [sym_metavariable] = ACTIONS(978),
    [sym_raw_string_literal] = ACTIONS(978),
    [sym_float_literal] = ACTIONS(978),
  },
  [238] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1857),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(238),
    [sym_block_comment] = STATE(238),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [239] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1735),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(239),
    [sym_block_comment] = STATE(239),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [240] = {
    [sym_line_comment] = STATE(240),
    [sym_block_comment] = STATE(240),
    [ts_builtin_sym_end] = ACTIONS(982),
    [sym_identifier] = ACTIONS(984),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_macro_rules_BANG] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(982),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(984),
    [anon_sym_QMARK] = ACTIONS(982),
    [anon_sym_u8] = ACTIONS(984),
    [anon_sym_i8] = ACTIONS(984),
    [anon_sym_u16] = ACTIONS(984),
    [anon_sym_i16] = ACTIONS(984),
    [anon_sym_u32] = ACTIONS(984),
    [anon_sym_i32] = ACTIONS(984),
    [anon_sym_u64] = ACTIONS(984),
    [anon_sym_i64] = ACTIONS(984),
    [anon_sym_u128] = ACTIONS(984),
    [anon_sym_i128] = ACTIONS(984),
    [anon_sym_isize] = ACTIONS(984),
    [anon_sym_usize] = ACTIONS(984),
    [anon_sym_f32] = ACTIONS(984),
    [anon_sym_f64] = ACTIONS(984),
    [anon_sym_bool] = ACTIONS(984),
    [anon_sym_str] = ACTIONS(984),
    [anon_sym_char] = ACTIONS(984),
    [anon_sym_SLASH] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_EQ] = ACTIONS(984),
    [anon_sym_COLON_COLON] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(984),
    [anon_sym_DOT] = ACTIONS(984),
    [anon_sym_AMP] = ACTIONS(984),
    [anon_sym_POUND] = ACTIONS(982),
    [anon_sym_PERCENT] = ACTIONS(984),
    [anon_sym_CARET] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(984),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_PIPE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_as] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_fn] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_impl] = ACTIONS(984),
    [anon_sym_let] = ACTIONS(984),
    [anon_sym_loop] = ACTIONS(984),
    [anon_sym_match] = ACTIONS(984),
    [anon_sym_mod] = ACTIONS(984),
    [anon_sym_pub] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_trait] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_unsafe] = ACTIONS(984),
    [anon_sym_use] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(982),
    [anon_sym_DOT_DOT] = ACTIONS(984),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(982),
    [anon_sym_AMP_AMP] = ACTIONS(982),
    [anon_sym_PIPE_PIPE] = ACTIONS(982),
    [anon_sym_EQ_EQ] = ACTIONS(982),
    [anon_sym_BANG_EQ] = ACTIONS(982),
    [anon_sym_LT_EQ] = ACTIONS(982),
    [anon_sym_GT_EQ] = ACTIONS(982),
    [anon_sym_LT_LT] = ACTIONS(984),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_PLUS_EQ] = ACTIONS(982),
    [anon_sym_DASH_EQ] = ACTIONS(982),
    [anon_sym_STAR_EQ] = ACTIONS(982),
    [anon_sym_SLASH_EQ] = ACTIONS(982),
    [anon_sym_PERCENT_EQ] = ACTIONS(982),
    [anon_sym_AMP_EQ] = ACTIONS(982),
    [anon_sym_PIPE_EQ] = ACTIONS(982),
    [anon_sym_CARET_EQ] = ACTIONS(982),
    [anon_sym_LT_LT_EQ] = ACTIONS(982),
    [anon_sym_GT_GT_EQ] = ACTIONS(982),
    [anon_sym_yield] = ACTIONS(984),
    [anon_sym_move] = ACTIONS(984),
    [anon_sym_try] = ACTIONS(984),
    [sym_integer_literal] = ACTIONS(982),
    [aux_sym_string_literal_token1] = ACTIONS(982),
    [sym_char_literal] = ACTIONS(982),
    [anon_sym_true] = ACTIONS(984),
    [anon_sym_false] = ACTIONS(984),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(984),
    [sym_super] = ACTIONS(984),
    [sym_crate] = ACTIONS(984),
    [sym_metavariable] = ACTIONS(982),
    [sym_raw_string_literal] = ACTIONS(982),
    [sym_float_literal] = ACTIONS(982),
  },
  [241] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1757),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(241),
    [sym_block_comment] = STATE(241),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [242] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1854),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [243] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1847),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [244] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1821),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(244),
    [sym_block_comment] = STATE(244),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [245] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1780),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(487),
    [sym_match_expression] = STATE(487),
    [sym_while_expression] = STATE(487),
    [sym_loop_expression] = STATE(487),
    [sym_for_expression] = STATE(487),
    [sym_const_block] = STATE(487),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3500),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(487),
    [sym_async_block] = STATE(487),
    [sym_try_block] = STATE(487),
    [sym_block] = STATE(487),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(245),
    [sym_block_comment] = STATE(245),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_loop] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(938),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [246] = {
    [sym_line_comment] = STATE(246),
    [sym_block_comment] = STATE(246),
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(988),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_macro_rules_BANG] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(988),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_u8] = ACTIONS(988),
    [anon_sym_i8] = ACTIONS(988),
    [anon_sym_u16] = ACTIONS(988),
    [anon_sym_i16] = ACTIONS(988),
    [anon_sym_u32] = ACTIONS(988),
    [anon_sym_i32] = ACTIONS(988),
    [anon_sym_u64] = ACTIONS(988),
    [anon_sym_i64] = ACTIONS(988),
    [anon_sym_u128] = ACTIONS(988),
    [anon_sym_i128] = ACTIONS(988),
    [anon_sym_isize] = ACTIONS(988),
    [anon_sym_usize] = ACTIONS(988),
    [anon_sym_f32] = ACTIONS(988),
    [anon_sym_f64] = ACTIONS(988),
    [anon_sym_bool] = ACTIONS(988),
    [anon_sym_str] = ACTIONS(988),
    [anon_sym_char] = ACTIONS(988),
    [anon_sym_SLASH] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_EQ] = ACTIONS(988),
    [anon_sym_COLON_COLON] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(988),
    [anon_sym_DOT] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(988),
    [anon_sym_POUND] = ACTIONS(986),
    [anon_sym_PERCENT] = ACTIONS(988),
    [anon_sym_CARET] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(988),
    [anon_sym_as] = ACTIONS(988),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_fn] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_impl] = ACTIONS(988),
    [anon_sym_let] = ACTIONS(988),
    [anon_sym_loop] = ACTIONS(988),
    [anon_sym_match] = ACTIONS(988),
    [anon_sym_mod] = ACTIONS(988),
    [anon_sym_pub] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_trait] = ACTIONS(988),
    [anon_sym_type] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_unsafe] = ACTIONS(988),
    [anon_sym_use] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(986),
    [anon_sym_DOT_DOT] = ACTIONS(988),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_EQ] = ACTIONS(986),
    [anon_sym_BANG_EQ] = ACTIONS(986),
    [anon_sym_LT_EQ] = ACTIONS(986),
    [anon_sym_GT_EQ] = ACTIONS(986),
    [anon_sym_LT_LT] = ACTIONS(988),
    [anon_sym_GT_GT] = ACTIONS(988),
    [anon_sym_PLUS_EQ] = ACTIONS(986),
    [anon_sym_DASH_EQ] = ACTIONS(986),
    [anon_sym_STAR_EQ] = ACTIONS(986),
    [anon_sym_SLASH_EQ] = ACTIONS(986),
    [anon_sym_PERCENT_EQ] = ACTIONS(986),
    [anon_sym_AMP_EQ] = ACTIONS(986),
    [anon_sym_PIPE_EQ] = ACTIONS(986),
    [anon_sym_CARET_EQ] = ACTIONS(986),
    [anon_sym_LT_LT_EQ] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(986),
    [anon_sym_yield] = ACTIONS(988),
    [anon_sym_move] = ACTIONS(988),
    [anon_sym_try] = ACTIONS(988),
    [sym_integer_literal] = ACTIONS(986),
    [aux_sym_string_literal_token1] = ACTIONS(986),
    [sym_char_literal] = ACTIONS(986),
    [anon_sym_true] = ACTIONS(988),
    [anon_sym_false] = ACTIONS(988),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(988),
    [sym_super] = ACTIONS(988),
    [sym_crate] = ACTIONS(988),
    [sym_metavariable] = ACTIONS(986),
    [sym_raw_string_literal] = ACTIONS(986),
    [sym_float_literal] = ACTIONS(986),
  },
  [247] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1223),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [248] = {
    [sym_line_comment] = STATE(248),
    [sym_block_comment] = STATE(248),
    [ts_builtin_sym_end] = ACTIONS(990),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_macro_rules_BANG] = ACTIONS(990),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(990),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_RBRACE] = ACTIONS(990),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(992),
    [anon_sym_QMARK] = ACTIONS(990),
    [anon_sym_u8] = ACTIONS(992),
    [anon_sym_i8] = ACTIONS(992),
    [anon_sym_u16] = ACTIONS(992),
    [anon_sym_i16] = ACTIONS(992),
    [anon_sym_u32] = ACTIONS(992),
    [anon_sym_i32] = ACTIONS(992),
    [anon_sym_u64] = ACTIONS(992),
    [anon_sym_i64] = ACTIONS(992),
    [anon_sym_u128] = ACTIONS(992),
    [anon_sym_i128] = ACTIONS(992),
    [anon_sym_isize] = ACTIONS(992),
    [anon_sym_usize] = ACTIONS(992),
    [anon_sym_f32] = ACTIONS(992),
    [anon_sym_f64] = ACTIONS(992),
    [anon_sym_bool] = ACTIONS(992),
    [anon_sym_str] = ACTIONS(992),
    [anon_sym_char] = ACTIONS(992),
    [anon_sym_SLASH] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_EQ] = ACTIONS(992),
    [anon_sym_COLON_COLON] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(992),
    [anon_sym_AMP] = ACTIONS(992),
    [anon_sym_POUND] = ACTIONS(990),
    [anon_sym_PERCENT] = ACTIONS(992),
    [anon_sym_CARET] = ACTIONS(992),
    [anon_sym_LT] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(992),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_fn] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_impl] = ACTIONS(992),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_loop] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_mod] = ACTIONS(992),
    [anon_sym_pub] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_trait] = ACTIONS(992),
    [anon_sym_type] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_unsafe] = ACTIONS(992),
    [anon_sym_use] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(990),
    [anon_sym_DOT_DOT] = ACTIONS(992),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(990),
    [anon_sym_AMP_AMP] = ACTIONS(990),
    [anon_sym_PIPE_PIPE] = ACTIONS(990),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_LT_EQ] = ACTIONS(990),
    [anon_sym_GT_EQ] = ACTIONS(990),
    [anon_sym_LT_LT] = ACTIONS(992),
    [anon_sym_GT_GT] = ACTIONS(992),
    [anon_sym_PLUS_EQ] = ACTIONS(990),
    [anon_sym_DASH_EQ] = ACTIONS(990),
    [anon_sym_STAR_EQ] = ACTIONS(990),
    [anon_sym_SLASH_EQ] = ACTIONS(990),
    [anon_sym_PERCENT_EQ] = ACTIONS(990),
    [anon_sym_AMP_EQ] = ACTIONS(990),
    [anon_sym_PIPE_EQ] = ACTIONS(990),
    [anon_sym_CARET_EQ] = ACTIONS(990),
    [anon_sym_LT_LT_EQ] = ACTIONS(990),
    [anon_sym_GT_GT_EQ] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_move] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [sym_integer_literal] = ACTIONS(990),
    [aux_sym_string_literal_token1] = ACTIONS(990),
    [sym_char_literal] = ACTIONS(990),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(992),
    [sym_super] = ACTIONS(992),
    [sym_crate] = ACTIONS(992),
    [sym_metavariable] = ACTIONS(990),
    [sym_raw_string_literal] = ACTIONS(990),
    [sym_float_literal] = ACTIONS(990),
  },
  [249] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1763),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(249),
    [sym_block_comment] = STATE(249),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [250] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1754),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [251] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1772),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [252] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1758),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [253] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1568),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [254] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1866),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [255] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1481),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [256] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1194),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [257] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1660),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(257),
    [sym_block_comment] = STATE(257),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [258] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [259] = {
    [sym_line_comment] = STATE(259),
    [sym_block_comment] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(994),
    [sym_identifier] = ACTIONS(996),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_macro_rules_BANG] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(994),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_QMARK] = ACTIONS(994),
    [anon_sym_u8] = ACTIONS(996),
    [anon_sym_i8] = ACTIONS(996),
    [anon_sym_u16] = ACTIONS(996),
    [anon_sym_i16] = ACTIONS(996),
    [anon_sym_u32] = ACTIONS(996),
    [anon_sym_i32] = ACTIONS(996),
    [anon_sym_u64] = ACTIONS(996),
    [anon_sym_i64] = ACTIONS(996),
    [anon_sym_u128] = ACTIONS(996),
    [anon_sym_i128] = ACTIONS(996),
    [anon_sym_isize] = ACTIONS(996),
    [anon_sym_usize] = ACTIONS(996),
    [anon_sym_f32] = ACTIONS(996),
    [anon_sym_f64] = ACTIONS(996),
    [anon_sym_bool] = ACTIONS(996),
    [anon_sym_str] = ACTIONS(996),
    [anon_sym_char] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_EQ] = ACTIONS(996),
    [anon_sym_COLON_COLON] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_DOT] = ACTIONS(996),
    [anon_sym_AMP] = ACTIONS(996),
    [anon_sym_POUND] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(996),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_GT] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(996),
    [anon_sym_SQUOTE] = ACTIONS(996),
    [anon_sym_as] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_fn] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_impl] = ACTIONS(996),
    [anon_sym_let] = ACTIONS(996),
    [anon_sym_loop] = ACTIONS(996),
    [anon_sym_match] = ACTIONS(996),
    [anon_sym_mod] = ACTIONS(996),
    [anon_sym_pub] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_trait] = ACTIONS(996),
    [anon_sym_type] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_unsafe] = ACTIONS(996),
    [anon_sym_use] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(994),
    [anon_sym_DOT_DOT] = ACTIONS(996),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(994),
    [anon_sym_AMP_AMP] = ACTIONS(994),
    [anon_sym_PIPE_PIPE] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(996),
    [anon_sym_PLUS_EQ] = ACTIONS(994),
    [anon_sym_DASH_EQ] = ACTIONS(994),
    [anon_sym_STAR_EQ] = ACTIONS(994),
    [anon_sym_SLASH_EQ] = ACTIONS(994),
    [anon_sym_PERCENT_EQ] = ACTIONS(994),
    [anon_sym_AMP_EQ] = ACTIONS(994),
    [anon_sym_PIPE_EQ] = ACTIONS(994),
    [anon_sym_CARET_EQ] = ACTIONS(994),
    [anon_sym_LT_LT_EQ] = ACTIONS(994),
    [anon_sym_GT_GT_EQ] = ACTIONS(994),
    [anon_sym_yield] = ACTIONS(996),
    [anon_sym_move] = ACTIONS(996),
    [anon_sym_try] = ACTIONS(996),
    [sym_integer_literal] = ACTIONS(994),
    [aux_sym_string_literal_token1] = ACTIONS(994),
    [sym_char_literal] = ACTIONS(994),
    [anon_sym_true] = ACTIONS(996),
    [anon_sym_false] = ACTIONS(996),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(996),
    [sym_super] = ACTIONS(996),
    [sym_crate] = ACTIONS(996),
    [sym_metavariable] = ACTIONS(994),
    [sym_raw_string_literal] = ACTIONS(994),
    [sym_float_literal] = ACTIONS(994),
  },
  [260] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1463),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [261] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1464),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(261),
    [sym_block_comment] = STATE(261),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [262] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1466),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [263] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1467),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [264] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1740),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [265] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1469),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [266] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1717),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [267] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1470),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [268] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1471),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [269] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1472),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [270] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1474),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [271] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1756),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(271),
    [sym_block_comment] = STATE(271),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [272] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1765),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [273] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1778),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(486),
    [sym_match_expression] = STATE(486),
    [sym_while_expression] = STATE(486),
    [sym_loop_expression] = STATE(486),
    [sym_for_expression] = STATE(486),
    [sym_const_block] = STATE(486),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3500),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(486),
    [sym_async_block] = STATE(486),
    [sym_try_block] = STATE(486),
    [sym_block] = STATE(486),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_loop] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(938),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [274] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1874),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(486),
    [sym_match_expression] = STATE(486),
    [sym_while_expression] = STATE(486),
    [sym_loop_expression] = STATE(486),
    [sym_for_expression] = STATE(486),
    [sym_const_block] = STATE(486),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3500),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(486),
    [sym_async_block] = STATE(486),
    [sym_try_block] = STATE(486),
    [sym_block] = STATE(486),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_loop] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(938),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [275] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1843),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [276] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1293),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [277] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1630),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [278] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1844),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [279] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1223),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [280] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1738),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [281] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(281),
    [sym_block_comment] = STATE(281),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [282] = {
    [sym_line_comment] = STATE(282),
    [sym_block_comment] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(998),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_macro_rules_BANG] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_QMARK] = ACTIONS(998),
    [anon_sym_u8] = ACTIONS(1000),
    [anon_sym_i8] = ACTIONS(1000),
    [anon_sym_u16] = ACTIONS(1000),
    [anon_sym_i16] = ACTIONS(1000),
    [anon_sym_u32] = ACTIONS(1000),
    [anon_sym_i32] = ACTIONS(1000),
    [anon_sym_u64] = ACTIONS(1000),
    [anon_sym_i64] = ACTIONS(1000),
    [anon_sym_u128] = ACTIONS(1000),
    [anon_sym_i128] = ACTIONS(1000),
    [anon_sym_isize] = ACTIONS(1000),
    [anon_sym_usize] = ACTIONS(1000),
    [anon_sym_f32] = ACTIONS(1000),
    [anon_sym_f64] = ACTIONS(1000),
    [anon_sym_bool] = ACTIONS(1000),
    [anon_sym_str] = ACTIONS(1000),
    [anon_sym_char] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1000),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_COLON_COLON] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(1000),
    [anon_sym_AMP] = ACTIONS(1000),
    [anon_sym_POUND] = ACTIONS(998),
    [anon_sym_PERCENT] = ACTIONS(1000),
    [anon_sym_CARET] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1000),
    [anon_sym_GT] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1000),
    [anon_sym_SQUOTE] = ACTIONS(1000),
    [anon_sym_as] = ACTIONS(1000),
    [anon_sym_async] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_fn] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_impl] = ACTIONS(1000),
    [anon_sym_let] = ACTIONS(1000),
    [anon_sym_loop] = ACTIONS(1000),
    [anon_sym_match] = ACTIONS(1000),
    [anon_sym_mod] = ACTIONS(1000),
    [anon_sym_pub] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_trait] = ACTIONS(1000),
    [anon_sym_type] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_unsafe] = ACTIONS(1000),
    [anon_sym_use] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(998),
    [anon_sym_DOT_DOT] = ACTIONS(1000),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(998),
    [anon_sym_AMP_AMP] = ACTIONS(998),
    [anon_sym_PIPE_PIPE] = ACTIONS(998),
    [anon_sym_EQ_EQ] = ACTIONS(998),
    [anon_sym_BANG_EQ] = ACTIONS(998),
    [anon_sym_LT_EQ] = ACTIONS(998),
    [anon_sym_GT_EQ] = ACTIONS(998),
    [anon_sym_LT_LT] = ACTIONS(1000),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_PLUS_EQ] = ACTIONS(998),
    [anon_sym_DASH_EQ] = ACTIONS(998),
    [anon_sym_STAR_EQ] = ACTIONS(998),
    [anon_sym_SLASH_EQ] = ACTIONS(998),
    [anon_sym_PERCENT_EQ] = ACTIONS(998),
    [anon_sym_AMP_EQ] = ACTIONS(998),
    [anon_sym_PIPE_EQ] = ACTIONS(998),
    [anon_sym_CARET_EQ] = ACTIONS(998),
    [anon_sym_LT_LT_EQ] = ACTIONS(998),
    [anon_sym_GT_GT_EQ] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_move] = ACTIONS(1000),
    [anon_sym_try] = ACTIONS(1000),
    [sym_integer_literal] = ACTIONS(998),
    [aux_sym_string_literal_token1] = ACTIONS(998),
    [sym_char_literal] = ACTIONS(998),
    [anon_sym_true] = ACTIONS(1000),
    [anon_sym_false] = ACTIONS(1000),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1000),
    [sym_super] = ACTIONS(1000),
    [sym_crate] = ACTIONS(1000),
    [sym_metavariable] = ACTIONS(998),
    [sym_raw_string_literal] = ACTIONS(998),
    [sym_float_literal] = ACTIONS(998),
  },
  [283] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1840),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [284] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1641),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(752),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [285] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1779),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [286] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1862),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [287] = {
    [sym_line_comment] = STATE(287),
    [sym_block_comment] = STATE(287),
    [ts_builtin_sym_end] = ACTIONS(1002),
    [sym_identifier] = ACTIONS(1004),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_macro_rules_BANG] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_RBRACE] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_QMARK] = ACTIONS(1002),
    [anon_sym_u8] = ACTIONS(1004),
    [anon_sym_i8] = ACTIONS(1004),
    [anon_sym_u16] = ACTIONS(1004),
    [anon_sym_i16] = ACTIONS(1004),
    [anon_sym_u32] = ACTIONS(1004),
    [anon_sym_i32] = ACTIONS(1004),
    [anon_sym_u64] = ACTIONS(1004),
    [anon_sym_i64] = ACTIONS(1004),
    [anon_sym_u128] = ACTIONS(1004),
    [anon_sym_i128] = ACTIONS(1004),
    [anon_sym_isize] = ACTIONS(1004),
    [anon_sym_usize] = ACTIONS(1004),
    [anon_sym_f32] = ACTIONS(1004),
    [anon_sym_f64] = ACTIONS(1004),
    [anon_sym_bool] = ACTIONS(1004),
    [anon_sym_str] = ACTIONS(1004),
    [anon_sym_char] = ACTIONS(1004),
    [anon_sym_SLASH] = ACTIONS(1004),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_EQ] = ACTIONS(1004),
    [anon_sym_COLON_COLON] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_DOT] = ACTIONS(1004),
    [anon_sym_AMP] = ACTIONS(1004),
    [anon_sym_POUND] = ACTIONS(1002),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_CARET] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_PIPE] = ACTIONS(1004),
    [anon_sym_SQUOTE] = ACTIONS(1004),
    [anon_sym_as] = ACTIONS(1004),
    [anon_sym_async] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_fn] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_impl] = ACTIONS(1004),
    [anon_sym_let] = ACTIONS(1004),
    [anon_sym_loop] = ACTIONS(1004),
    [anon_sym_match] = ACTIONS(1004),
    [anon_sym_mod] = ACTIONS(1004),
    [anon_sym_pub] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_trait] = ACTIONS(1004),
    [anon_sym_type] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_unsafe] = ACTIONS(1004),
    [anon_sym_use] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1002),
    [anon_sym_DOT_DOT] = ACTIONS(1004),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1002),
    [anon_sym_PIPE_PIPE] = ACTIONS(1002),
    [anon_sym_EQ_EQ] = ACTIONS(1002),
    [anon_sym_BANG_EQ] = ACTIONS(1002),
    [anon_sym_LT_EQ] = ACTIONS(1002),
    [anon_sym_GT_EQ] = ACTIONS(1002),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1004),
    [anon_sym_PLUS_EQ] = ACTIONS(1002),
    [anon_sym_DASH_EQ] = ACTIONS(1002),
    [anon_sym_STAR_EQ] = ACTIONS(1002),
    [anon_sym_SLASH_EQ] = ACTIONS(1002),
    [anon_sym_PERCENT_EQ] = ACTIONS(1002),
    [anon_sym_AMP_EQ] = ACTIONS(1002),
    [anon_sym_PIPE_EQ] = ACTIONS(1002),
    [anon_sym_CARET_EQ] = ACTIONS(1002),
    [anon_sym_LT_LT_EQ] = ACTIONS(1002),
    [anon_sym_GT_GT_EQ] = ACTIONS(1002),
    [anon_sym_yield] = ACTIONS(1004),
    [anon_sym_move] = ACTIONS(1004),
    [anon_sym_try] = ACTIONS(1004),
    [sym_integer_literal] = ACTIONS(1002),
    [aux_sym_string_literal_token1] = ACTIONS(1002),
    [sym_char_literal] = ACTIONS(1002),
    [anon_sym_true] = ACTIONS(1004),
    [anon_sym_false] = ACTIONS(1004),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1004),
    [sym_super] = ACTIONS(1004),
    [sym_crate] = ACTIONS(1004),
    [sym_metavariable] = ACTIONS(1002),
    [sym_raw_string_literal] = ACTIONS(1002),
    [sym_float_literal] = ACTIONS(1002),
  },
  [288] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1709),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(146),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(288),
    [sym_block_comment] = STATE(288),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [289] = {
    [sym_line_comment] = STATE(289),
    [sym_block_comment] = STATE(289),
    [ts_builtin_sym_end] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_macro_rules_BANG] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(1006),
    [anon_sym_u8] = ACTIONS(1008),
    [anon_sym_i8] = ACTIONS(1008),
    [anon_sym_u16] = ACTIONS(1008),
    [anon_sym_i16] = ACTIONS(1008),
    [anon_sym_u32] = ACTIONS(1008),
    [anon_sym_i32] = ACTIONS(1008),
    [anon_sym_u64] = ACTIONS(1008),
    [anon_sym_i64] = ACTIONS(1008),
    [anon_sym_u128] = ACTIONS(1008),
    [anon_sym_i128] = ACTIONS(1008),
    [anon_sym_isize] = ACTIONS(1008),
    [anon_sym_usize] = ACTIONS(1008),
    [anon_sym_f32] = ACTIONS(1008),
    [anon_sym_f64] = ACTIONS(1008),
    [anon_sym_bool] = ACTIONS(1008),
    [anon_sym_str] = ACTIONS(1008),
    [anon_sym_char] = ACTIONS(1008),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_EQ] = ACTIONS(1008),
    [anon_sym_COLON_COLON] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_DOT] = ACTIONS(1008),
    [anon_sym_AMP] = ACTIONS(1008),
    [anon_sym_POUND] = ACTIONS(1006),
    [anon_sym_PERCENT] = ACTIONS(1008),
    [anon_sym_CARET] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1008),
    [anon_sym_GT] = ACTIONS(1008),
    [anon_sym_PIPE] = ACTIONS(1008),
    [anon_sym_SQUOTE] = ACTIONS(1008),
    [anon_sym_as] = ACTIONS(1008),
    [anon_sym_async] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_fn] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_impl] = ACTIONS(1008),
    [anon_sym_let] = ACTIONS(1008),
    [anon_sym_loop] = ACTIONS(1008),
    [anon_sym_match] = ACTIONS(1008),
    [anon_sym_mod] = ACTIONS(1008),
    [anon_sym_pub] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_trait] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_unsafe] = ACTIONS(1008),
    [anon_sym_use] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1006),
    [anon_sym_DOT_DOT] = ACTIONS(1008),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1006),
    [anon_sym_AMP_AMP] = ACTIONS(1006),
    [anon_sym_PIPE_PIPE] = ACTIONS(1006),
    [anon_sym_EQ_EQ] = ACTIONS(1006),
    [anon_sym_BANG_EQ] = ACTIONS(1006),
    [anon_sym_LT_EQ] = ACTIONS(1006),
    [anon_sym_GT_EQ] = ACTIONS(1006),
    [anon_sym_LT_LT] = ACTIONS(1008),
    [anon_sym_GT_GT] = ACTIONS(1008),
    [anon_sym_PLUS_EQ] = ACTIONS(1006),
    [anon_sym_DASH_EQ] = ACTIONS(1006),
    [anon_sym_STAR_EQ] = ACTIONS(1006),
    [anon_sym_SLASH_EQ] = ACTIONS(1006),
    [anon_sym_PERCENT_EQ] = ACTIONS(1006),
    [anon_sym_AMP_EQ] = ACTIONS(1006),
    [anon_sym_PIPE_EQ] = ACTIONS(1006),
    [anon_sym_CARET_EQ] = ACTIONS(1006),
    [anon_sym_LT_LT_EQ] = ACTIONS(1006),
    [anon_sym_GT_GT_EQ] = ACTIONS(1006),
    [anon_sym_yield] = ACTIONS(1008),
    [anon_sym_move] = ACTIONS(1008),
    [anon_sym_try] = ACTIONS(1008),
    [sym_integer_literal] = ACTIONS(1006),
    [aux_sym_string_literal_token1] = ACTIONS(1006),
    [sym_char_literal] = ACTIONS(1006),
    [anon_sym_true] = ACTIONS(1008),
    [anon_sym_false] = ACTIONS(1008),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1008),
    [sym_super] = ACTIONS(1008),
    [sym_crate] = ACTIONS(1008),
    [sym_metavariable] = ACTIONS(1006),
    [sym_raw_string_literal] = ACTIONS(1006),
    [sym_float_literal] = ACTIONS(1006),
  },
  [290] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1853),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(290),
    [sym_block_comment] = STATE(290),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [291] = {
    [sym_bracketed_type] = STATE(3387),
    [sym_generic_function] = STATE(1628),
    [sym_generic_type_with_turbofish] = STATE(2866),
    [sym__expression_except_range] = STATE(1547),
    [sym__expression] = STATE(1849),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(1525),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3154),
    [sym_range_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1628),
    [sym_try_expression] = STATE(1628),
    [sym_reference_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_assignment_expression] = STATE(1628),
    [sym_compound_assignment_expr] = STATE(1628),
    [sym_type_cast_expression] = STATE(1628),
    [sym_return_expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_array_expression] = STATE(1628),
    [sym_parenthesized_expression] = STATE(1628),
    [sym_tuple_expression] = STATE(1628),
    [sym_unit_expression] = STATE(1628),
    [sym_struct_expression] = STATE(1628),
    [sym_if_expression] = STATE(1628),
    [sym_match_expression] = STATE(1628),
    [sym_while_expression] = STATE(1628),
    [sym_loop_expression] = STATE(1628),
    [sym_for_expression] = STATE(1628),
    [sym_const_block] = STATE(1628),
    [sym_closure_expression] = STATE(1628),
    [sym_closure_parameters] = STATE(139),
    [sym_label] = STATE(3495),
    [sym_break_expression] = STATE(1628),
    [sym_continue_expression] = STATE(1628),
    [sym_index_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_field_expression] = STATE(1555),
    [sym_unsafe_block] = STATE(1628),
    [sym_async_block] = STATE(1628),
    [sym_try_block] = STATE(1628),
    [sym_block] = STATE(1628),
    [sym__literal] = STATE(1628),
    [sym_string_literal] = STATE(1634),
    [sym_boolean_literal] = STATE(1634),
    [sym_line_comment] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_u8] = ACTIONS(399),
    [anon_sym_i8] = ACTIONS(399),
    [anon_sym_u16] = ACTIONS(399),
    [anon_sym_i16] = ACTIONS(399),
    [anon_sym_u32] = ACTIONS(399),
    [anon_sym_i32] = ACTIONS(399),
    [anon_sym_u64] = ACTIONS(399),
    [anon_sym_i64] = ACTIONS(399),
    [anon_sym_u128] = ACTIONS(399),
    [anon_sym_i128] = ACTIONS(399),
    [anon_sym_isize] = ACTIONS(399),
    [anon_sym_usize] = ACTIONS(399),
    [anon_sym_f32] = ACTIONS(399),
    [anon_sym_f64] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_str] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_COLON_COLON] = ACTIONS(401),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(409),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_loop] = ACTIONS(417),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_union] = ACTIONS(413),
    [anon_sym_unsafe] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(678),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_move] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(437),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(439),
    [anon_sym_false] = ACTIONS(439),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(441),
    [sym_super] = ACTIONS(443),
    [sym_crate] = ACTIONS(443),
    [sym_metavariable] = ACTIONS(445),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
  },
  [292] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1813),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [293] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1573),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [294] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1873),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [295] = {
    [sym_line_comment] = STATE(295),
    [sym_block_comment] = STATE(295),
    [ts_builtin_sym_end] = ACTIONS(1010),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_macro_rules_BANG] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(1010),
    [anon_sym_u8] = ACTIONS(1012),
    [anon_sym_i8] = ACTIONS(1012),
    [anon_sym_u16] = ACTIONS(1012),
    [anon_sym_i16] = ACTIONS(1012),
    [anon_sym_u32] = ACTIONS(1012),
    [anon_sym_i32] = ACTIONS(1012),
    [anon_sym_u64] = ACTIONS(1012),
    [anon_sym_i64] = ACTIONS(1012),
    [anon_sym_u128] = ACTIONS(1012),
    [anon_sym_i128] = ACTIONS(1012),
    [anon_sym_isize] = ACTIONS(1012),
    [anon_sym_usize] = ACTIONS(1012),
    [anon_sym_f32] = ACTIONS(1012),
    [anon_sym_f64] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_str] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_EQ] = ACTIONS(1012),
    [anon_sym_COLON_COLON] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1012),
    [anon_sym_DOT] = ACTIONS(1012),
    [anon_sym_AMP] = ACTIONS(1012),
    [anon_sym_POUND] = ACTIONS(1010),
    [anon_sym_PERCENT] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1012),
    [anon_sym_PIPE] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(1012),
    [anon_sym_as] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_fn] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_impl] = ACTIONS(1012),
    [anon_sym_let] = ACTIONS(1012),
    [anon_sym_loop] = ACTIONS(1012),
    [anon_sym_match] = ACTIONS(1012),
    [anon_sym_mod] = ACTIONS(1012),
    [anon_sym_pub] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_trait] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_unsafe] = ACTIONS(1012),
    [anon_sym_use] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1010),
    [anon_sym_DOT_DOT] = ACTIONS(1012),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1010),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(1010),
    [anon_sym_BANG_EQ] = ACTIONS(1010),
    [anon_sym_LT_EQ] = ACTIONS(1010),
    [anon_sym_GT_EQ] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(1012),
    [anon_sym_PLUS_EQ] = ACTIONS(1010),
    [anon_sym_DASH_EQ] = ACTIONS(1010),
    [anon_sym_STAR_EQ] = ACTIONS(1010),
    [anon_sym_SLASH_EQ] = ACTIONS(1010),
    [anon_sym_PERCENT_EQ] = ACTIONS(1010),
    [anon_sym_AMP_EQ] = ACTIONS(1010),
    [anon_sym_PIPE_EQ] = ACTIONS(1010),
    [anon_sym_CARET_EQ] = ACTIONS(1010),
    [anon_sym_LT_LT_EQ] = ACTIONS(1010),
    [anon_sym_GT_GT_EQ] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_move] = ACTIONS(1012),
    [anon_sym_try] = ACTIONS(1012),
    [sym_integer_literal] = ACTIONS(1010),
    [aux_sym_string_literal_token1] = ACTIONS(1010),
    [sym_char_literal] = ACTIONS(1010),
    [anon_sym_true] = ACTIONS(1012),
    [anon_sym_false] = ACTIONS(1012),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1012),
    [sym_super] = ACTIONS(1012),
    [sym_crate] = ACTIONS(1012),
    [sym_metavariable] = ACTIONS(1010),
    [sym_raw_string_literal] = ACTIONS(1010),
    [sym_float_literal] = ACTIONS(1010),
  },
  [296] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1746),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [297] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1855),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(297),
    [sym_block_comment] = STATE(297),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [298] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1293),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [299] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1629),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [300] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1559),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [301] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1846),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [302] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1572),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [303] = {
    [sym_line_comment] = STATE(303),
    [sym_block_comment] = STATE(303),
    [ts_builtin_sym_end] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_macro_rules_BANG] = ACTIONS(1014),
    [anon_sym_LPAREN] = ACTIONS(1014),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1016),
    [anon_sym_QMARK] = ACTIONS(1014),
    [anon_sym_u8] = ACTIONS(1016),
    [anon_sym_i8] = ACTIONS(1016),
    [anon_sym_u16] = ACTIONS(1016),
    [anon_sym_i16] = ACTIONS(1016),
    [anon_sym_u32] = ACTIONS(1016),
    [anon_sym_i32] = ACTIONS(1016),
    [anon_sym_u64] = ACTIONS(1016),
    [anon_sym_i64] = ACTIONS(1016),
    [anon_sym_u128] = ACTIONS(1016),
    [anon_sym_i128] = ACTIONS(1016),
    [anon_sym_isize] = ACTIONS(1016),
    [anon_sym_usize] = ACTIONS(1016),
    [anon_sym_f32] = ACTIONS(1016),
    [anon_sym_f64] = ACTIONS(1016),
    [anon_sym_bool] = ACTIONS(1016),
    [anon_sym_str] = ACTIONS(1016),
    [anon_sym_char] = ACTIONS(1016),
    [anon_sym_SLASH] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_EQ] = ACTIONS(1016),
    [anon_sym_COLON_COLON] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_DOT] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_POUND] = ACTIONS(1014),
    [anon_sym_PERCENT] = ACTIONS(1016),
    [anon_sym_CARET] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_fn] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_impl] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_loop] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_mod] = ACTIONS(1016),
    [anon_sym_pub] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_trait] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_unsafe] = ACTIONS(1016),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1014),
    [anon_sym_DOT_DOT] = ACTIONS(1016),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1014),
    [anon_sym_AMP_AMP] = ACTIONS(1014),
    [anon_sym_PIPE_PIPE] = ACTIONS(1014),
    [anon_sym_EQ_EQ] = ACTIONS(1014),
    [anon_sym_BANG_EQ] = ACTIONS(1014),
    [anon_sym_LT_EQ] = ACTIONS(1014),
    [anon_sym_GT_EQ] = ACTIONS(1014),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [anon_sym_PLUS_EQ] = ACTIONS(1014),
    [anon_sym_DASH_EQ] = ACTIONS(1014),
    [anon_sym_STAR_EQ] = ACTIONS(1014),
    [anon_sym_SLASH_EQ] = ACTIONS(1014),
    [anon_sym_PERCENT_EQ] = ACTIONS(1014),
    [anon_sym_AMP_EQ] = ACTIONS(1014),
    [anon_sym_PIPE_EQ] = ACTIONS(1014),
    [anon_sym_CARET_EQ] = ACTIONS(1014),
    [anon_sym_LT_LT_EQ] = ACTIONS(1014),
    [anon_sym_GT_GT_EQ] = ACTIONS(1014),
    [anon_sym_yield] = ACTIONS(1016),
    [anon_sym_move] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [sym_integer_literal] = ACTIONS(1014),
    [aux_sym_string_literal_token1] = ACTIONS(1014),
    [sym_char_literal] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1016),
    [sym_super] = ACTIONS(1016),
    [sym_crate] = ACTIONS(1016),
    [sym_metavariable] = ACTIONS(1014),
    [sym_raw_string_literal] = ACTIONS(1014),
    [sym_float_literal] = ACTIONS(1014),
  },
  [304] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1761),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [305] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1794),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [306] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1776),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [307] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1870),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [308] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [309] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1633),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [310] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1759),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [311] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2741),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1845),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1438),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(120),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(311),
    [sym_block_comment] = STATE(311),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(345),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [312] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1553),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(150),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(312),
    [sym_block_comment] = STATE(312),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(662),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(668),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [313] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1785),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(313),
    [sym_block_comment] = STATE(313),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [314] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1194),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [315] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1784),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [316] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1783),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [317] = {
    [sym_bracketed_type] = STATE(3379),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(2805),
    [sym__expression_except_range] = STATE(1060),
    [sym__expression] = STATE(1782),
    [sym_macro_invocation] = STATE(1383),
    [sym_scoped_identifier] = STATE(1509),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3083),
    [sym_range_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(1427),
    [sym_compound_assignment_expr] = STATE(1427),
    [sym_type_cast_expression] = STATE(1427),
    [sym_return_expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_const_block] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(142),
    [sym_label] = STATE(3452),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_field_expression] = STATE(1061),
    [sym_unsafe_block] = STATE(1427),
    [sym_async_block] = STATE(1427),
    [sym_try_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [sym_line_comment] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_u8] = ACTIONS(471),
    [anon_sym_i8] = ACTIONS(471),
    [anon_sym_u16] = ACTIONS(471),
    [anon_sym_i16] = ACTIONS(471),
    [anon_sym_u32] = ACTIONS(471),
    [anon_sym_i32] = ACTIONS(471),
    [anon_sym_u64] = ACTIONS(471),
    [anon_sym_i64] = ACTIONS(471),
    [anon_sym_u128] = ACTIONS(471),
    [anon_sym_i128] = ACTIONS(471),
    [anon_sym_isize] = ACTIONS(471),
    [anon_sym_usize] = ACTIONS(471),
    [anon_sym_f32] = ACTIONS(471),
    [anon_sym_f64] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_str] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_COLON_COLON] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_loop] = ACTIONS(351),
    [anon_sym_match] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_DOT_DOT] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(361),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(489),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(95),
    [sym_float_literal] = ACTIONS(95),
  },
  [318] = {
    [sym_line_comment] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(950),
    [anon_sym_macro_rules_BANG] = ACTIONS(956),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(950),
    [anon_sym_u8] = ACTIONS(958),
    [anon_sym_i8] = ACTIONS(958),
    [anon_sym_u16] = ACTIONS(958),
    [anon_sym_i16] = ACTIONS(958),
    [anon_sym_u32] = ACTIONS(958),
    [anon_sym_i32] = ACTIONS(958),
    [anon_sym_u64] = ACTIONS(958),
    [anon_sym_i64] = ACTIONS(958),
    [anon_sym_u128] = ACTIONS(958),
    [anon_sym_i128] = ACTIONS(958),
    [anon_sym_isize] = ACTIONS(958),
    [anon_sym_usize] = ACTIONS(958),
    [anon_sym_f32] = ACTIONS(958),
    [anon_sym_f64] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_str] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_EQ] = ACTIONS(948),
    [anon_sym_COLON_COLON] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_DOT] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_POUND] = ACTIONS(956),
    [anon_sym_PERCENT] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_fn] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_impl] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_loop] = ACTIONS(958),
    [anon_sym_match] = ACTIONS(958),
    [anon_sym_mod] = ACTIONS(958),
    [anon_sym_pub] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_trait] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_unsafe] = ACTIONS(958),
    [anon_sym_use] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(950),
    [anon_sym_DOT_DOT] = ACTIONS(948),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_LT_LT] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_PLUS_EQ] = ACTIONS(950),
    [anon_sym_DASH_EQ] = ACTIONS(950),
    [anon_sym_STAR_EQ] = ACTIONS(950),
    [anon_sym_SLASH_EQ] = ACTIONS(950),
    [anon_sym_PERCENT_EQ] = ACTIONS(950),
    [anon_sym_AMP_EQ] = ACTIONS(950),
    [anon_sym_PIPE_EQ] = ACTIONS(950),
    [anon_sym_CARET_EQ] = ACTIONS(950),
    [anon_sym_LT_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_GT_EQ] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_move] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [sym_integer_literal] = ACTIONS(956),
    [aux_sym_string_literal_token1] = ACTIONS(956),
    [sym_char_literal] = ACTIONS(956),
    [anon_sym_true] = ACTIONS(958),
    [anon_sym_false] = ACTIONS(958),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_crate] = ACTIONS(958),
    [sym_metavariable] = ACTIONS(956),
    [sym_raw_string_literal] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
  },
  [319] = {
    [sym_attribute_item] = STATE(356),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2926),
    [sym_variadic_parameter] = STATE(2926),
    [sym_parameter] = STATE(2926),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2588),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(319),
    [sym_block_comment] = STATE(319),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1034),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [320] = {
    [sym_attribute_item] = STATE(358),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2796),
    [sym_variadic_parameter] = STATE(2796),
    [sym_parameter] = STATE(2796),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2513),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2382),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(320),
    [sym_block_comment] = STATE(320),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1088),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1094),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1104),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [321] = {
    [sym_attribute_item] = STATE(357),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2726),
    [sym_variadic_parameter] = STATE(2726),
    [sym_parameter] = STATE(2726),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2677),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(321),
    [sym_block_comment] = STATE(321),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [322] = {
    [sym_attribute_item] = STATE(358),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2796),
    [sym_variadic_parameter] = STATE(2796),
    [sym_parameter] = STATE(2796),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2513),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2382),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(322),
    [sym_block_comment] = STATE(322),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1118),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1104),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [323] = {
    [sym_attribute_item] = STATE(358),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2796),
    [sym_variadic_parameter] = STATE(2796),
    [sym_parameter] = STATE(2796),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2513),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(323),
    [sym_block_comment] = STATE(323),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1120),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1124),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [324] = {
    [sym_attribute_item] = STATE(358),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2796),
    [sym_variadic_parameter] = STATE(2796),
    [sym_parameter] = STATE(2796),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2513),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2382),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(324),
    [sym_block_comment] = STATE(324),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1126),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1128),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1104),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [325] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(325),
    [sym_block_comment] = STATE(325),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1139),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_RBRACK] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_COLON] = ACTIONS(1147),
    [anon_sym_DOLLAR] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_u8] = ACTIONS(1130),
    [anon_sym_i8] = ACTIONS(1130),
    [anon_sym_u16] = ACTIONS(1130),
    [anon_sym_i16] = ACTIONS(1130),
    [anon_sym_u32] = ACTIONS(1130),
    [anon_sym_i32] = ACTIONS(1130),
    [anon_sym_u64] = ACTIONS(1130),
    [anon_sym_i64] = ACTIONS(1130),
    [anon_sym_u128] = ACTIONS(1130),
    [anon_sym_i128] = ACTIONS(1130),
    [anon_sym_isize] = ACTIONS(1130),
    [anon_sym_usize] = ACTIONS(1130),
    [anon_sym_f32] = ACTIONS(1130),
    [anon_sym_f64] = ACTIONS(1130),
    [anon_sym_bool] = ACTIONS(1130),
    [anon_sym_str] = ACTIONS(1130),
    [anon_sym_char] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym__] = ACTIONS(1147),
    [anon_sym_BSLASH] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_EQ] = ACTIONS(1133),
    [anon_sym_DASH_GT] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_COLON_COLON] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_as] = ACTIONS(1130),
    [anon_sym_async] = ACTIONS(1130),
    [anon_sym_await] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_const] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_default] = ACTIONS(1130),
    [anon_sym_enum] = ACTIONS(1130),
    [anon_sym_fn] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1130),
    [anon_sym_impl] = ACTIONS(1130),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_loop] = ACTIONS(1130),
    [anon_sym_match] = ACTIONS(1130),
    [anon_sym_mod] = ACTIONS(1130),
    [anon_sym_pub] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_static] = ACTIONS(1130),
    [anon_sym_struct] = ACTIONS(1130),
    [anon_sym_trait] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(1130),
    [anon_sym_union] = ACTIONS(1130),
    [anon_sym_unsafe] = ACTIONS(1130),
    [anon_sym_use] = ACTIONS(1130),
    [anon_sym_where] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [sym_mutable_specifier] = ACTIONS(1130),
    [sym_integer_literal] = ACTIONS(1153),
    [aux_sym_string_literal_token1] = ACTIONS(1156),
    [sym_char_literal] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1159),
    [anon_sym_false] = ACTIONS(1159),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1130),
    [sym_super] = ACTIONS(1130),
    [sym_crate] = ACTIONS(1130),
    [sym_metavariable] = ACTIONS(1162),
    [sym_raw_string_literal] = ACTIONS(1153),
    [sym_float_literal] = ACTIONS(1153),
  },
  [326] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(326),
    [sym_block_comment] = STATE(326),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [327] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(327),
    [sym_block_comment] = STATE(327),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [328] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(328),
    [sym_block_comment] = STATE(328),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [329] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2648),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(2865),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2653),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(329),
    [sym_block_comment] = STATE(329),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1106),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [330] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(330),
    [sym_block_comment] = STATE(330),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [331] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2648),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(2865),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2653),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(331),
    [sym_block_comment] = STATE(331),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1106),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [332] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(332),
    [sym_block_comment] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [333] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(333),
    [sym_block_comment] = STATE(333),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [334] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2648),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(2865),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2653),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(334),
    [sym_block_comment] = STATE(334),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1106),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [335] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(335),
    [sym_block_comment] = STATE(335),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [336] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(336),
    [sym_block_comment] = STATE(336),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [337] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(337),
    [sym_block_comment] = STATE(337),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1203),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [338] = {
    [sym_attribute_item] = STATE(355),
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3101),
    [sym_variadic_parameter] = STATE(3101),
    [sym_parameter] = STATE(3101),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(338),
    [sym_block_comment] = STATE(338),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_POUND] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [339] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(339),
    [sym_block_comment] = STATE(339),
    [aux_sym_token_tree_pattern_repeat1] = STATE(345),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [340] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(340),
    [sym_block_comment] = STATE(340),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [341] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(341),
    [sym_block_comment] = STATE(341),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [342] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(342),
    [sym_block_comment] = STATE(342),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [343] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(343),
    [sym_block_comment] = STATE(343),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [344] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(344),
    [sym_block_comment] = STATE(344),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [anon_sym_COLON] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1233),
    [anon_sym_i8] = ACTIONS(1233),
    [anon_sym_u16] = ACTIONS(1233),
    [anon_sym_i16] = ACTIONS(1233),
    [anon_sym_u32] = ACTIONS(1233),
    [anon_sym_i32] = ACTIONS(1233),
    [anon_sym_u64] = ACTIONS(1233),
    [anon_sym_i64] = ACTIONS(1233),
    [anon_sym_u128] = ACTIONS(1233),
    [anon_sym_i128] = ACTIONS(1233),
    [anon_sym_isize] = ACTIONS(1233),
    [anon_sym_usize] = ACTIONS(1233),
    [anon_sym_f32] = ACTIONS(1233),
    [anon_sym_f64] = ACTIONS(1233),
    [anon_sym_bool] = ACTIONS(1233),
    [anon_sym_str] = ACTIONS(1233),
    [anon_sym_char] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym__] = ACTIONS(1250),
    [anon_sym_BSLASH] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1236),
    [anon_sym_DASH_GT] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(1236),
    [anon_sym_DOT] = ACTIONS(1236),
    [anon_sym_AT] = ACTIONS(1236),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_PERCENT] = ACTIONS(1236),
    [anon_sym_CARET] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1236),
    [anon_sym_PIPE] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [anon_sym_as] = ACTIONS(1233),
    [anon_sym_async] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_fn] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_impl] = ACTIONS(1233),
    [anon_sym_let] = ACTIONS(1233),
    [anon_sym_loop] = ACTIONS(1233),
    [anon_sym_match] = ACTIONS(1233),
    [anon_sym_mod] = ACTIONS(1233),
    [anon_sym_pub] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_trait] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_unsafe] = ACTIONS(1233),
    [anon_sym_use] = ACTIONS(1233),
    [anon_sym_where] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [sym_mutable_specifier] = ACTIONS(1233),
    [sym_integer_literal] = ACTIONS(1256),
    [aux_sym_string_literal_token1] = ACTIONS(1259),
    [sym_char_literal] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1262),
    [anon_sym_false] = ACTIONS(1262),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1233),
    [sym_super] = ACTIONS(1233),
    [sym_crate] = ACTIONS(1233),
    [sym_raw_string_literal] = ACTIONS(1256),
    [sym_float_literal] = ACTIONS(1256),
  },
  [345] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(345),
    [sym_block_comment] = STATE(345),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [346] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(346),
    [sym_block_comment] = STATE(346),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [347] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(347),
    [sym_block_comment] = STATE(347),
    [aux_sym_token_tree_pattern_repeat1] = STATE(325),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [348] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(348),
    [sym_block_comment] = STATE(348),
    [aux_sym_token_tree_pattern_repeat1] = STATE(343),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [349] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(349),
    [sym_block_comment] = STATE(349),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_RBRACK] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1278),
    [anon_sym_COLON] = ACTIONS(1286),
    [anon_sym_DOLLAR] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1272),
    [anon_sym_u8] = ACTIONS(1269),
    [anon_sym_i8] = ACTIONS(1269),
    [anon_sym_u16] = ACTIONS(1269),
    [anon_sym_i16] = ACTIONS(1269),
    [anon_sym_u32] = ACTIONS(1269),
    [anon_sym_i32] = ACTIONS(1269),
    [anon_sym_u64] = ACTIONS(1269),
    [anon_sym_i64] = ACTIONS(1269),
    [anon_sym_u128] = ACTIONS(1269),
    [anon_sym_i128] = ACTIONS(1269),
    [anon_sym_isize] = ACTIONS(1269),
    [anon_sym_usize] = ACTIONS(1269),
    [anon_sym_f32] = ACTIONS(1269),
    [anon_sym_f64] = ACTIONS(1269),
    [anon_sym_bool] = ACTIONS(1269),
    [anon_sym_str] = ACTIONS(1269),
    [anon_sym_char] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym__] = ACTIONS(1286),
    [anon_sym_BSLASH] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_DASH_GT] = ACTIONS(1272),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_COLON_COLON] = ACTIONS(1272),
    [anon_sym_BANG] = ACTIONS(1272),
    [anon_sym_DOT] = ACTIONS(1272),
    [anon_sym_AT] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_POUND] = ACTIONS(1272),
    [anon_sym_PERCENT] = ACTIONS(1272),
    [anon_sym_CARET] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1272),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [anon_sym_as] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1269),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_fn] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_impl] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1269),
    [anon_sym_loop] = ACTIONS(1269),
    [anon_sym_match] = ACTIONS(1269),
    [anon_sym_mod] = ACTIONS(1269),
    [anon_sym_pub] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_trait] = ACTIONS(1269),
    [anon_sym_type] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_unsafe] = ACTIONS(1269),
    [anon_sym_use] = ACTIONS(1269),
    [anon_sym_where] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [sym_mutable_specifier] = ACTIONS(1269),
    [sym_integer_literal] = ACTIONS(1292),
    [aux_sym_string_literal_token1] = ACTIONS(1295),
    [sym_char_literal] = ACTIONS(1292),
    [anon_sym_true] = ACTIONS(1298),
    [anon_sym_false] = ACTIONS(1298),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_crate] = ACTIONS(1269),
    [sym_metavariable] = ACTIONS(1301),
    [sym_raw_string_literal] = ACTIONS(1292),
    [sym_float_literal] = ACTIONS(1292),
  },
  [350] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(350),
    [sym_block_comment] = STATE(350),
    [aux_sym_token_tree_pattern_repeat1] = STATE(340),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [351] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(351),
    [sym_block_comment] = STATE(351),
    [aux_sym_token_tree_pattern_repeat1] = STATE(342),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_RBRACK] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [352] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(352),
    [sym_block_comment] = STATE(352),
    [aux_sym_token_tree_pattern_repeat1] = STATE(346),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [353] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(353),
    [sym_block_comment] = STATE(353),
    [aux_sym_token_tree_pattern_repeat1] = STATE(347),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [354] = {
    [sym__token_pattern] = STATE(445),
    [sym_token_tree_pattern] = STATE(436),
    [sym_token_binding_pattern] = STATE(436),
    [sym_token_repetition_pattern] = STATE(436),
    [sym__literal] = STATE(436),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(354),
    [sym_block_comment] = STATE(354),
    [aux_sym_token_tree_pattern_repeat1] = STATE(341),
    [aux_sym__non_special_token_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1219),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1205),
    [anon_sym_i8] = ACTIONS(1205),
    [anon_sym_u16] = ACTIONS(1205),
    [anon_sym_i16] = ACTIONS(1205),
    [anon_sym_u32] = ACTIONS(1205),
    [anon_sym_i32] = ACTIONS(1205),
    [anon_sym_u64] = ACTIONS(1205),
    [anon_sym_i64] = ACTIONS(1205),
    [anon_sym_u128] = ACTIONS(1205),
    [anon_sym_i128] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_str] = ACTIONS(1205),
    [anon_sym_char] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_impl] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_loop] = ACTIONS(1205),
    [anon_sym_match] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_trait] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_unsafe] = ACTIONS(1205),
    [anon_sym_use] = ACTIONS(1205),
    [anon_sym_where] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1205),
    [sym_super] = ACTIONS(1205),
    [sym_crate] = ACTIONS(1205),
    [sym_metavariable] = ACTIONS(1227),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [355] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(3234),
    [sym_variadic_parameter] = STATE(3234),
    [sym_parameter] = STATE(3234),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2736),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(355),
    [sym_block_comment] = STATE(355),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [356] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2912),
    [sym_variadic_parameter] = STATE(2912),
    [sym_parameter] = STATE(2912),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2583),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(356),
    [sym_block_comment] = STATE(356),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [357] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2825),
    [sym_variadic_parameter] = STATE(2825),
    [sym_parameter] = STATE(2825),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2659),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(357),
    [sym_block_comment] = STATE(357),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [358] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_self_parameter] = STATE(2854),
    [sym_variadic_parameter] = STATE(2854),
    [sym_parameter] = STATE(2854),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2655),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(2807),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3228),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(358),
    [sym_block_comment] = STATE(358),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1064),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1068),
    [anon_sym_DOT_DOT] = ACTIONS(1070),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1078),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [359] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(359),
    [sym_block_comment] = STATE(359),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(397),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [360] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(360),
    [sym_block_comment] = STATE(360),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(366),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [361] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(361),
    [sym_block_comment] = STATE(361),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(384),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [362] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(362),
    [sym_block_comment] = STATE(362),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [363] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(363),
    [sym_block_comment] = STATE(363),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [364] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(364),
    [sym_block_comment] = STATE(364),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [365] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(365),
    [sym_block_comment] = STATE(365),
    [aux_sym_token_tree_repeat1] = STATE(363),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [366] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(366),
    [sym_block_comment] = STATE(366),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [367] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(367),
    [sym_block_comment] = STATE(367),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [368] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(368),
    [sym_block_comment] = STATE(368),
    [aux_sym_token_tree_repeat1] = STATE(383),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [369] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(369),
    [sym_block_comment] = STATE(369),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [370] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(370),
    [sym_block_comment] = STATE(370),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(392),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [371] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(371),
    [sym_block_comment] = STATE(371),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(393),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [372] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(372),
    [sym_block_comment] = STATE(372),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(394),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [373] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(373),
    [sym_block_comment] = STATE(373),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [374] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(374),
    [sym_block_comment] = STATE(374),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [375] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(375),
    [sym_block_comment] = STATE(375),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(362),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [376] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(376),
    [sym_block_comment] = STATE(376),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [377] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(377),
    [sym_block_comment] = STATE(377),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [378] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(378),
    [sym_block_comment] = STATE(378),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(373),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [379] = {
    [sym_line_comment] = STATE(379),
    [sym_block_comment] = STATE(379),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1368),
    [anon_sym_RPAREN] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1368),
    [anon_sym_RBRACK] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_RBRACE] = ACTIONS(1368),
    [anon_sym_COLON] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1368),
    [anon_sym_u8] = ACTIONS(1366),
    [anon_sym_i8] = ACTIONS(1366),
    [anon_sym_u16] = ACTIONS(1366),
    [anon_sym_i16] = ACTIONS(1366),
    [anon_sym_u32] = ACTIONS(1366),
    [anon_sym_i32] = ACTIONS(1366),
    [anon_sym_u64] = ACTIONS(1366),
    [anon_sym_i64] = ACTIONS(1366),
    [anon_sym_u128] = ACTIONS(1366),
    [anon_sym_i128] = ACTIONS(1366),
    [anon_sym_isize] = ACTIONS(1366),
    [anon_sym_usize] = ACTIONS(1366),
    [anon_sym_f32] = ACTIONS(1366),
    [anon_sym_f64] = ACTIONS(1366),
    [anon_sym_bool] = ACTIONS(1366),
    [anon_sym_str] = ACTIONS(1366),
    [anon_sym_char] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_COMMA] = ACTIONS(1368),
    [anon_sym_COLON_COLON] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_loop] = ACTIONS(1366),
    [anon_sym_match] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_unsafe] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1368),
    [anon_sym_PIPE_PIPE] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1368),
    [anon_sym_BANG_EQ] = ACTIONS(1368),
    [anon_sym_LT_EQ] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1368),
    [anon_sym_LT_LT] = ACTIONS(1366),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_PLUS_EQ] = ACTIONS(1368),
    [anon_sym_DASH_EQ] = ACTIONS(1368),
    [anon_sym_STAR_EQ] = ACTIONS(1368),
    [anon_sym_SLASH_EQ] = ACTIONS(1368),
    [anon_sym_PERCENT_EQ] = ACTIONS(1368),
    [anon_sym_AMP_EQ] = ACTIONS(1368),
    [anon_sym_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_CARET_EQ] = ACTIONS(1368),
    [anon_sym_LT_LT_EQ] = ACTIONS(1368),
    [anon_sym_GT_GT_EQ] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1366),
    [anon_sym_move] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [sym_integer_literal] = ACTIONS(1368),
    [aux_sym_string_literal_token1] = ACTIONS(1368),
    [sym_char_literal] = ACTIONS(1368),
    [anon_sym_true] = ACTIONS(1366),
    [anon_sym_false] = ACTIONS(1366),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1366),
    [sym_super] = ACTIONS(1366),
    [sym_crate] = ACTIONS(1366),
    [sym_metavariable] = ACTIONS(1368),
    [sym_raw_string_literal] = ACTIONS(1368),
    [sym_float_literal] = ACTIONS(1368),
  },
  [380] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(380),
    [sym_block_comment] = STATE(380),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [381] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(381),
    [sym_block_comment] = STATE(381),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [382] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(382),
    [sym_block_comment] = STATE(382),
    [aux_sym_token_tree_repeat1] = STATE(367),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [383] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(383),
    [sym_block_comment] = STATE(383),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [384] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(384),
    [sym_block_comment] = STATE(384),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [385] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(385),
    [sym_block_comment] = STATE(385),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [386] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(386),
    [sym_block_comment] = STATE(386),
    [aux_sym_token_tree_repeat1] = STATE(364),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [387] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(387),
    [sym_block_comment] = STATE(387),
    [aux_sym_token_tree_repeat1] = STATE(349),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [388] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(388),
    [sym_block_comment] = STATE(388),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(381),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [389] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(389),
    [sym_block_comment] = STATE(389),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(374),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [390] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(390),
    [sym_block_comment] = STATE(390),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(369),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [391] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(391),
    [sym_block_comment] = STATE(391),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [392] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(392),
    [sym_block_comment] = STATE(392),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [393] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(393),
    [sym_block_comment] = STATE(393),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [394] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(394),
    [sym_block_comment] = STATE(394),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [395] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(395),
    [sym_block_comment] = STATE(395),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [396] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(396),
    [sym_block_comment] = STATE(396),
    [aux_sym_token_tree_repeat1] = STATE(377),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [397] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(397),
    [sym_block_comment] = STATE(397),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [398] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(398),
    [sym_block_comment] = STATE(398),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [399] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(399),
    [sym_block_comment] = STATE(399),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [400] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(400),
    [sym_block_comment] = STATE(400),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [401] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(401),
    [sym_block_comment] = STATE(401),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [402] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(402),
    [sym_block_comment] = STATE(402),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [403] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(403),
    [sym_block_comment] = STATE(403),
    [aux_sym_token_tree_repeat1] = STATE(385),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [404] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(404),
    [sym_block_comment] = STATE(404),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(401),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [405] = {
    [sym_token_tree] = STATE(441),
    [sym_token_repetition] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(439),
    [sym_boolean_literal] = STATE(439),
    [sym_line_comment] = STATE(405),
    [sym_block_comment] = STATE(405),
    [aux_sym_token_tree_repeat1] = STATE(387),
    [aux_sym__non_special_token_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [sym_mutable_specifier] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1221),
    [aux_sym_string_literal_token1] = ACTIONS(1223),
    [sym_char_literal] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(1225),
    [anon_sym_false] = ACTIONS(1225),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1354),
    [sym_raw_string_literal] = ACTIONS(1221),
    [sym_float_literal] = ACTIONS(1221),
  },
  [406] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(406),
    [sym_block_comment] = STATE(406),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [407] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(407),
    [sym_block_comment] = STATE(407),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [408] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(408),
    [sym_block_comment] = STATE(408),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(399),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [409] = {
    [sym_delim_token_tree] = STATE(454),
    [sym__delim_tokens] = STATE(457),
    [sym__non_delim_token] = STATE(454),
    [sym__literal] = STATE(453),
    [sym_string_literal] = STATE(451),
    [sym_boolean_literal] = STATE(451),
    [sym_line_comment] = STATE(409),
    [sym_block_comment] = STATE(409),
    [aux_sym__non_special_token_repeat1] = STATE(428),
    [aux_sym_delim_token_tree_repeat1] = STATE(398),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1314),
    [anon_sym_i8] = ACTIONS(1314),
    [anon_sym_u16] = ACTIONS(1314),
    [anon_sym_i16] = ACTIONS(1314),
    [anon_sym_u32] = ACTIONS(1314),
    [anon_sym_i32] = ACTIONS(1314),
    [anon_sym_u64] = ACTIONS(1314),
    [anon_sym_i64] = ACTIONS(1314),
    [anon_sym_u128] = ACTIONS(1314),
    [anon_sym_i128] = ACTIONS(1314),
    [anon_sym_isize] = ACTIONS(1314),
    [anon_sym_usize] = ACTIONS(1314),
    [anon_sym_f32] = ACTIONS(1314),
    [anon_sym_f64] = ACTIONS(1314),
    [anon_sym_bool] = ACTIONS(1314),
    [anon_sym_str] = ACTIONS(1314),
    [anon_sym_char] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_fn] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_impl] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_loop] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_mod] = ACTIONS(1314),
    [anon_sym_pub] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_trait] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_unsafe] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [sym_mutable_specifier] = ACTIONS(1314),
    [sym_integer_literal] = ACTIONS(1330),
    [aux_sym_string_literal_token1] = ACTIONS(1332),
    [sym_char_literal] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1334),
    [anon_sym_false] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_crate] = ACTIONS(1314),
    [sym_raw_string_literal] = ACTIONS(1330),
    [sym_float_literal] = ACTIONS(1330),
  },
  [410] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2838),
    [sym_bracketed_type] = STATE(3442),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3443),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2407),
    [sym_scoped_identifier] = STATE(2104),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2632),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(410),
    [sym_block_comment] = STATE(410),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1392),
    [anon_sym_i8] = ACTIONS(1392),
    [anon_sym_u16] = ACTIONS(1392),
    [anon_sym_i16] = ACTIONS(1392),
    [anon_sym_u32] = ACTIONS(1392),
    [anon_sym_i32] = ACTIONS(1392),
    [anon_sym_u64] = ACTIONS(1392),
    [anon_sym_i64] = ACTIONS(1392),
    [anon_sym_u128] = ACTIONS(1392),
    [anon_sym_i128] = ACTIONS(1392),
    [anon_sym_isize] = ACTIONS(1392),
    [anon_sym_usize] = ACTIONS(1392),
    [anon_sym_f32] = ACTIONS(1392),
    [anon_sym_f64] = ACTIONS(1392),
    [anon_sym_bool] = ACTIONS(1392),
    [anon_sym_str] = ACTIONS(1392),
    [anon_sym_char] = ACTIONS(1392),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_crate] = ACTIONS(1404),
    [sym_metavariable] = ACTIONS(1406),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [411] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2070),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(411),
    [sym_block_comment] = STATE(411),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1106),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [412] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(850),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(412),
    [sym_block_comment] = STATE(412),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1410),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1412),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [413] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(850),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(413),
    [sym_block_comment] = STATE(413),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1414),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1416),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [414] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3442),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3443),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2407),
    [sym_scoped_identifier] = STATE(2104),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2070),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(414),
    [sym_block_comment] = STATE(414),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1392),
    [anon_sym_i8] = ACTIONS(1392),
    [anon_sym_u16] = ACTIONS(1392),
    [anon_sym_i16] = ACTIONS(1392),
    [anon_sym_u32] = ACTIONS(1392),
    [anon_sym_i32] = ACTIONS(1392),
    [anon_sym_u64] = ACTIONS(1392),
    [anon_sym_i64] = ACTIONS(1392),
    [anon_sym_u128] = ACTIONS(1392),
    [anon_sym_i128] = ACTIONS(1392),
    [anon_sym_isize] = ACTIONS(1392),
    [anon_sym_usize] = ACTIONS(1392),
    [anon_sym_f32] = ACTIONS(1392),
    [anon_sym_f64] = ACTIONS(1392),
    [anon_sym_bool] = ACTIONS(1392),
    [anon_sym_str] = ACTIONS(1392),
    [anon_sym_char] = ACTIONS(1392),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_crate] = ACTIONS(1404),
    [sym_metavariable] = ACTIONS(1406),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [415] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2070),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(415),
    [sym_block_comment] = STATE(415),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1418),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [416] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2070),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(416),
    [sym_block_comment] = STATE(416),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1420),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [417] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3442),
    [sym_lifetime] = STATE(848),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3443),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2407),
    [sym_scoped_identifier] = STATE(2104),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(417),
    [sym_block_comment] = STATE(417),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1392),
    [anon_sym_i8] = ACTIONS(1392),
    [anon_sym_u16] = ACTIONS(1392),
    [anon_sym_i16] = ACTIONS(1392),
    [anon_sym_u32] = ACTIONS(1392),
    [anon_sym_i32] = ACTIONS(1392),
    [anon_sym_u64] = ACTIONS(1392),
    [anon_sym_i64] = ACTIONS(1392),
    [anon_sym_u128] = ACTIONS(1392),
    [anon_sym_i128] = ACTIONS(1392),
    [anon_sym_isize] = ACTIONS(1392),
    [anon_sym_usize] = ACTIONS(1392),
    [anon_sym_f32] = ACTIONS(1392),
    [anon_sym_f64] = ACTIONS(1392),
    [anon_sym_bool] = ACTIONS(1392),
    [anon_sym_str] = ACTIONS(1392),
    [anon_sym_char] = ACTIONS(1392),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1422),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_crate] = ACTIONS(1404),
    [sym_metavariable] = ACTIONS(1406),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [418] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2070),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(418),
    [sym_block_comment] = STATE(418),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1080),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [419] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3440),
    [sym_lifetime] = STATE(848),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3441),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2378),
    [sym_scoped_identifier] = STATE(2056),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(419),
    [sym_block_comment] = STATE(419),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1090),
    [anon_sym_i8] = ACTIONS(1090),
    [anon_sym_u16] = ACTIONS(1090),
    [anon_sym_i16] = ACTIONS(1090),
    [anon_sym_u32] = ACTIONS(1090),
    [anon_sym_i32] = ACTIONS(1090),
    [anon_sym_u64] = ACTIONS(1090),
    [anon_sym_i64] = ACTIONS(1090),
    [anon_sym_u128] = ACTIONS(1090),
    [anon_sym_i128] = ACTIONS(1090),
    [anon_sym_isize] = ACTIONS(1090),
    [anon_sym_usize] = ACTIONS(1090),
    [anon_sym_f32] = ACTIONS(1090),
    [anon_sym_f64] = ACTIONS(1090),
    [anon_sym_bool] = ACTIONS(1090),
    [anon_sym_str] = ACTIONS(1090),
    [anon_sym_char] = ACTIONS(1090),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1102),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1424),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1106),
    [sym_super] = ACTIONS(1106),
    [sym_crate] = ACTIONS(1106),
    [sym_metavariable] = ACTIONS(1108),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [420] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3431),
    [sym_lifetime] = STATE(848),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3432),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(2396),
    [sym_scoped_identifier] = STATE(2187),
    [sym_scoped_type_identifier] = STATE(2087),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(420),
    [sym_block_comment] = STATE(420),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1028),
    [anon_sym_i8] = ACTIONS(1028),
    [anon_sym_u16] = ACTIONS(1028),
    [anon_sym_i16] = ACTIONS(1028),
    [anon_sym_u32] = ACTIONS(1028),
    [anon_sym_i32] = ACTIONS(1028),
    [anon_sym_u64] = ACTIONS(1028),
    [anon_sym_i64] = ACTIONS(1028),
    [anon_sym_u128] = ACTIONS(1028),
    [anon_sym_i128] = ACTIONS(1028),
    [anon_sym_isize] = ACTIONS(1028),
    [anon_sym_usize] = ACTIONS(1028),
    [anon_sym_f32] = ACTIONS(1028),
    [anon_sym_f64] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_str] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1058),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_ref] = ACTIONS(1062),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(1426),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1080),
    [sym_super] = ACTIONS(1080),
    [sym_crate] = ACTIONS(1080),
    [sym_metavariable] = ACTIONS(1082),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [421] = {
    [sym_line_comment] = STATE(421),
    [sym_block_comment] = STATE(421),
    [aux_sym__non_special_token_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_RBRACK] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1428),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_fn] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_impl] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_loop] = ACTIONS(1428),
    [anon_sym_match] = ACTIONS(1428),
    [anon_sym_mod] = ACTIONS(1428),
    [anon_sym_pub] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_struct] = ACTIONS(1428),
    [anon_sym_trait] = ACTIONS(1428),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_unsafe] = ACTIONS(1428),
    [anon_sym_use] = ACTIONS(1428),
    [anon_sym_where] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [sym_mutable_specifier] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1430),
    [sym_raw_string_literal] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [422] = {
    [sym_line_comment] = STATE(422),
    [sym_block_comment] = STATE(422),
    [aux_sym__non_special_token_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_RBRACK] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1217),
    [anon_sym_DOLLAR] = ACTIONS(1432),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_u8] = ACTIONS(1432),
    [anon_sym_i8] = ACTIONS(1432),
    [anon_sym_u16] = ACTIONS(1432),
    [anon_sym_i16] = ACTIONS(1432),
    [anon_sym_u32] = ACTIONS(1432),
    [anon_sym_i32] = ACTIONS(1432),
    [anon_sym_u64] = ACTIONS(1432),
    [anon_sym_i64] = ACTIONS(1432),
    [anon_sym_u128] = ACTIONS(1432),
    [anon_sym_i128] = ACTIONS(1432),
    [anon_sym_isize] = ACTIONS(1432),
    [anon_sym_usize] = ACTIONS(1432),
    [anon_sym_f32] = ACTIONS(1432),
    [anon_sym_f64] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_str] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
    [anon_sym_BSLASH] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_DASH_GT] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_COLON_COLON] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_as] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_fn] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_impl] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_loop] = ACTIONS(1432),
    [anon_sym_match] = ACTIONS(1432),
    [anon_sym_mod] = ACTIONS(1432),
    [anon_sym_pub] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_struct] = ACTIONS(1432),
    [anon_sym_trait] = ACTIONS(1432),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_unsafe] = ACTIONS(1432),
    [anon_sym_use] = ACTIONS(1432),
    [anon_sym_where] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [sym_mutable_specifier] = ACTIONS(1432),
    [sym_integer_literal] = ACTIONS(1434),
    [aux_sym_string_literal_token1] = ACTIONS(1434),
    [sym_char_literal] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_crate] = ACTIONS(1432),
    [sym_metavariable] = ACTIONS(1434),
    [sym_raw_string_literal] = ACTIONS(1434),
    [sym_float_literal] = ACTIONS(1434),
  },
  [423] = {
    [sym_line_comment] = STATE(423),
    [sym_block_comment] = STATE(423),
    [aux_sym__non_special_token_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_RBRACK] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_COLON] = ACTIONS(1443),
    [anon_sym_DOLLAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_u8] = ACTIONS(1436),
    [anon_sym_i8] = ACTIONS(1436),
    [anon_sym_u16] = ACTIONS(1436),
    [anon_sym_i16] = ACTIONS(1436),
    [anon_sym_u32] = ACTIONS(1436),
    [anon_sym_i32] = ACTIONS(1436),
    [anon_sym_u64] = ACTIONS(1436),
    [anon_sym_i64] = ACTIONS(1436),
    [anon_sym_u128] = ACTIONS(1436),
    [anon_sym_i128] = ACTIONS(1436),
    [anon_sym_isize] = ACTIONS(1436),
    [anon_sym_usize] = ACTIONS(1436),
    [anon_sym_f32] = ACTIONS(1436),
    [anon_sym_f64] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_str] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym__] = ACTIONS(1443),
    [anon_sym_BSLASH] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_EQ] = ACTIONS(1438),
    [anon_sym_DASH_GT] = ACTIONS(1438),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_POUND] = ACTIONS(1438),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1438),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_await] = ACTIONS(1436),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_fn] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_impl] = ACTIONS(1436),
    [anon_sym_let] = ACTIONS(1436),
    [anon_sym_loop] = ACTIONS(1436),
    [anon_sym_match] = ACTIONS(1436),
    [anon_sym_mod] = ACTIONS(1436),
    [anon_sym_pub] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_trait] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [anon_sym_unsafe] = ACTIONS(1436),
    [anon_sym_use] = ACTIONS(1436),
    [anon_sym_where] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [sym_mutable_specifier] = ACTIONS(1436),
    [sym_integer_literal] = ACTIONS(1441),
    [aux_sym_string_literal_token1] = ACTIONS(1441),
    [sym_char_literal] = ACTIONS(1441),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1436),
    [sym_super] = ACTIONS(1436),
    [sym_crate] = ACTIONS(1436),
    [sym_metavariable] = ACTIONS(1441),
    [sym_raw_string_literal] = ACTIONS(1441),
    [sym_float_literal] = ACTIONS(1441),
  },
  [424] = {
    [sym_line_comment] = STATE(424),
    [sym_block_comment] = STATE(424),
    [sym_identifier] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1448),
    [anon_sym_RBRACK] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1448),
    [anon_sym_u8] = ACTIONS(1446),
    [anon_sym_i8] = ACTIONS(1446),
    [anon_sym_u16] = ACTIONS(1446),
    [anon_sym_i16] = ACTIONS(1446),
    [anon_sym_u32] = ACTIONS(1446),
    [anon_sym_i32] = ACTIONS(1446),
    [anon_sym_u64] = ACTIONS(1446),
    [anon_sym_i64] = ACTIONS(1446),
    [anon_sym_u128] = ACTIONS(1446),
    [anon_sym_i128] = ACTIONS(1446),
    [anon_sym_isize] = ACTIONS(1446),
    [anon_sym_usize] = ACTIONS(1446),
    [anon_sym_f32] = ACTIONS(1446),
    [anon_sym_f64] = ACTIONS(1446),
    [anon_sym_bool] = ACTIONS(1446),
    [anon_sym_str] = ACTIONS(1446),
    [anon_sym_char] = ACTIONS(1446),
    [anon_sym_SLASH] = ACTIONS(1446),
    [anon_sym__] = ACTIONS(1446),
    [anon_sym_BSLASH] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_DASH_GT] = ACTIONS(1448),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_COLON_COLON] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [anon_sym_as] = ACTIONS(1446),
    [anon_sym_async] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_fn] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_impl] = ACTIONS(1446),
    [anon_sym_let] = ACTIONS(1446),
    [anon_sym_loop] = ACTIONS(1446),
    [anon_sym_match] = ACTIONS(1446),
    [anon_sym_mod] = ACTIONS(1446),
    [anon_sym_pub] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_trait] = ACTIONS(1446),
    [anon_sym_type] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_unsafe] = ACTIONS(1446),
    [anon_sym_use] = ACTIONS(1446),
    [anon_sym_where] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [sym_mutable_specifier] = ACTIONS(1446),
    [sym_integer_literal] = ACTIONS(1448),
    [aux_sym_string_literal_token1] = ACTIONS(1448),
    [sym_char_literal] = ACTIONS(1448),
    [anon_sym_true] = ACTIONS(1446),
    [anon_sym_false] = ACTIONS(1446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1446),
    [sym_super] = ACTIONS(1446),
    [sym_crate] = ACTIONS(1446),
    [sym_metavariable] = ACTIONS(1448),
    [sym_raw_string_literal] = ACTIONS(1448),
    [sym_float_literal] = ACTIONS(1448),
  },
  [425] = {
    [sym_line_comment] = STATE(425),
    [sym_block_comment] = STATE(425),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_RBRACK] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_COLON] = ACTIONS(1450),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(1430),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1430),
    [anon_sym_DASH_GT] = ACTIONS(1430),
    [anon_sym_COMMA] = ACTIONS(1430),
    [anon_sym_COLON_COLON] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1430),
    [anon_sym_DOT] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_PERCENT] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1428),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_fn] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_impl] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_loop] = ACTIONS(1428),
    [anon_sym_match] = ACTIONS(1428),
    [anon_sym_mod] = ACTIONS(1428),
    [anon_sym_pub] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_struct] = ACTIONS(1428),
    [anon_sym_trait] = ACTIONS(1428),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_unsafe] = ACTIONS(1428),
    [anon_sym_use] = ACTIONS(1428),
    [anon_sym_where] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [sym_mutable_specifier] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1430),
    [sym_raw_string_literal] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [426] = {
    [sym_line_comment] = STATE(426),
    [sym_block_comment] = STATE(426),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_RBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1454),
    [anon_sym_COLON] = ACTIONS(1452),
    [anon_sym_DOLLAR] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1454),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_BSLASH] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(1454),
    [anon_sym_DASH_GT] = ACTIONS(1454),
    [anon_sym_COMMA] = ACTIONS(1454),
    [anon_sym_COLON_COLON] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1454),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1454),
    [anon_sym_CARET] = ACTIONS(1454),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_fn] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_impl] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_loop] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_mod] = ACTIONS(1452),
    [anon_sym_pub] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_trait] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_unsafe] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_where] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [sym_mutable_specifier] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1454),
    [aux_sym_string_literal_token1] = ACTIONS(1454),
    [sym_char_literal] = ACTIONS(1454),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1454),
    [sym_raw_string_literal] = ACTIONS(1454),
    [sym_float_literal] = ACTIONS(1454),
  },
  [427] = {
    [sym_line_comment] = STATE(427),
    [sym_block_comment] = STATE(427),
    [aux_sym__non_special_token_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_RBRACK] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_COLON] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1456),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_u8] = ACTIONS(1436),
    [anon_sym_i8] = ACTIONS(1436),
    [anon_sym_u16] = ACTIONS(1436),
    [anon_sym_i16] = ACTIONS(1436),
    [anon_sym_u32] = ACTIONS(1436),
    [anon_sym_i32] = ACTIONS(1436),
    [anon_sym_u64] = ACTIONS(1436),
    [anon_sym_i64] = ACTIONS(1436),
    [anon_sym_u128] = ACTIONS(1436),
    [anon_sym_i128] = ACTIONS(1436),
    [anon_sym_isize] = ACTIONS(1436),
    [anon_sym_usize] = ACTIONS(1436),
    [anon_sym_f32] = ACTIONS(1436),
    [anon_sym_f64] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_str] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym__] = ACTIONS(1459),
    [anon_sym_BSLASH] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1456),
    [anon_sym_DASH_GT] = ACTIONS(1456),
    [anon_sym_COMMA] = ACTIONS(1456),
    [anon_sym_COLON_COLON] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_DOT] = ACTIONS(1456),
    [anon_sym_AT] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_POUND] = ACTIONS(1456),
    [anon_sym_PERCENT] = ACTIONS(1456),
    [anon_sym_CARET] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(1456),
    [anon_sym_GT] = ACTIONS(1456),
    [anon_sym_PIPE] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_await] = ACTIONS(1436),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_fn] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_impl] = ACTIONS(1436),
    [anon_sym_let] = ACTIONS(1436),
    [anon_sym_loop] = ACTIONS(1436),
    [anon_sym_match] = ACTIONS(1436),
    [anon_sym_mod] = ACTIONS(1436),
    [anon_sym_pub] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_trait] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [anon_sym_unsafe] = ACTIONS(1436),
    [anon_sym_use] = ACTIONS(1436),
    [anon_sym_where] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [sym_mutable_specifier] = ACTIONS(1436),
    [sym_integer_literal] = ACTIONS(1441),
    [aux_sym_string_literal_token1] = ACTIONS(1441),
    [sym_char_literal] = ACTIONS(1441),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1436),
    [sym_super] = ACTIONS(1436),
    [sym_crate] = ACTIONS(1436),
    [sym_raw_string_literal] = ACTIONS(1441),
    [sym_float_literal] = ACTIONS(1441),
  },
  [428] = {
    [sym_line_comment] = STATE(428),
    [sym_block_comment] = STATE(428),
    [aux_sym__non_special_token_repeat1] = STATE(427),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_u8] = ACTIONS(1462),
    [anon_sym_i8] = ACTIONS(1462),
    [anon_sym_u16] = ACTIONS(1462),
    [anon_sym_i16] = ACTIONS(1462),
    [anon_sym_u32] = ACTIONS(1462),
    [anon_sym_i32] = ACTIONS(1462),
    [anon_sym_u64] = ACTIONS(1462),
    [anon_sym_i64] = ACTIONS(1462),
    [anon_sym_u128] = ACTIONS(1462),
    [anon_sym_i128] = ACTIONS(1462),
    [anon_sym_isize] = ACTIONS(1462),
    [anon_sym_usize] = ACTIONS(1462),
    [anon_sym_f32] = ACTIONS(1462),
    [anon_sym_f64] = ACTIONS(1462),
    [anon_sym_bool] = ACTIONS(1462),
    [anon_sym_str] = ACTIONS(1462),
    [anon_sym_char] = ACTIONS(1462),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym__] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_DASH_GT] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_as] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_fn] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_impl] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_loop] = ACTIONS(1462),
    [anon_sym_match] = ACTIONS(1462),
    [anon_sym_mod] = ACTIONS(1462),
    [anon_sym_pub] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_trait] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_unsafe] = ACTIONS(1462),
    [anon_sym_use] = ACTIONS(1462),
    [anon_sym_where] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [sym_mutable_specifier] = ACTIONS(1462),
    [sym_integer_literal] = ACTIONS(1464),
    [aux_sym_string_literal_token1] = ACTIONS(1464),
    [sym_char_literal] = ACTIONS(1464),
    [anon_sym_true] = ACTIONS(1462),
    [anon_sym_false] = ACTIONS(1462),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_crate] = ACTIONS(1462),
    [sym_raw_string_literal] = ACTIONS(1464),
    [sym_float_literal] = ACTIONS(1464),
  },
  [429] = {
    [sym_line_comment] = STATE(429),
    [sym_block_comment] = STATE(429),
    [sym_identifier] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1468),
    [anon_sym_RBRACK] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_COLON] = ACTIONS(1466),
    [anon_sym_DOLLAR] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1468),
    [anon_sym_u8] = ACTIONS(1466),
    [anon_sym_i8] = ACTIONS(1466),
    [anon_sym_u16] = ACTIONS(1466),
    [anon_sym_i16] = ACTIONS(1466),
    [anon_sym_u32] = ACTIONS(1466),
    [anon_sym_i32] = ACTIONS(1466),
    [anon_sym_u64] = ACTIONS(1466),
    [anon_sym_i64] = ACTIONS(1466),
    [anon_sym_u128] = ACTIONS(1466),
    [anon_sym_i128] = ACTIONS(1466),
    [anon_sym_isize] = ACTIONS(1466),
    [anon_sym_usize] = ACTIONS(1466),
    [anon_sym_f32] = ACTIONS(1466),
    [anon_sym_f64] = ACTIONS(1466),
    [anon_sym_bool] = ACTIONS(1466),
    [anon_sym_str] = ACTIONS(1466),
    [anon_sym_char] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1466),
    [anon_sym__] = ACTIONS(1466),
    [anon_sym_BSLASH] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_COMMA] = ACTIONS(1468),
    [anon_sym_COLON_COLON] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_DOT] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_POUND] = ACTIONS(1468),
    [anon_sym_PERCENT] = ACTIONS(1468),
    [anon_sym_CARET] = ACTIONS(1468),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_as] = ACTIONS(1466),
    [anon_sym_async] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_fn] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_impl] = ACTIONS(1466),
    [anon_sym_let] = ACTIONS(1466),
    [anon_sym_loop] = ACTIONS(1466),
    [anon_sym_match] = ACTIONS(1466),
    [anon_sym_mod] = ACTIONS(1466),
    [anon_sym_pub] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_trait] = ACTIONS(1466),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [anon_sym_unsafe] = ACTIONS(1466),
    [anon_sym_use] = ACTIONS(1466),
    [anon_sym_where] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [sym_mutable_specifier] = ACTIONS(1466),
    [sym_integer_literal] = ACTIONS(1468),
    [aux_sym_string_literal_token1] = ACTIONS(1468),
    [sym_char_literal] = ACTIONS(1468),
    [anon_sym_true] = ACTIONS(1466),
    [anon_sym_false] = ACTIONS(1466),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1466),
    [sym_super] = ACTIONS(1466),
    [sym_crate] = ACTIONS(1466),
    [sym_metavariable] = ACTIONS(1468),
    [sym_raw_string_literal] = ACTIONS(1468),
    [sym_float_literal] = ACTIONS(1468),
  },
  [430] = {
    [sym_line_comment] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym_identifier] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_COLON] = ACTIONS(1470),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1472),
    [anon_sym_u8] = ACTIONS(1470),
    [anon_sym_i8] = ACTIONS(1470),
    [anon_sym_u16] = ACTIONS(1470),
    [anon_sym_i16] = ACTIONS(1470),
    [anon_sym_u32] = ACTIONS(1470),
    [anon_sym_i32] = ACTIONS(1470),
    [anon_sym_u64] = ACTIONS(1470),
    [anon_sym_i64] = ACTIONS(1470),
    [anon_sym_u128] = ACTIONS(1470),
    [anon_sym_i128] = ACTIONS(1470),
    [anon_sym_isize] = ACTIONS(1470),
    [anon_sym_usize] = ACTIONS(1470),
    [anon_sym_f32] = ACTIONS(1470),
    [anon_sym_f64] = ACTIONS(1470),
    [anon_sym_bool] = ACTIONS(1470),
    [anon_sym_str] = ACTIONS(1470),
    [anon_sym_char] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym__] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_COLON_COLON] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_POUND] = ACTIONS(1472),
    [anon_sym_PERCENT] = ACTIONS(1472),
    [anon_sym_CARET] = ACTIONS(1472),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_as] = ACTIONS(1470),
    [anon_sym_async] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_fn] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_impl] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1470),
    [anon_sym_loop] = ACTIONS(1470),
    [anon_sym_match] = ACTIONS(1470),
    [anon_sym_mod] = ACTIONS(1470),
    [anon_sym_pub] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_struct] = ACTIONS(1470),
    [anon_sym_trait] = ACTIONS(1470),
    [anon_sym_type] = ACTIONS(1470),
    [anon_sym_union] = ACTIONS(1470),
    [anon_sym_unsafe] = ACTIONS(1470),
    [anon_sym_use] = ACTIONS(1470),
    [anon_sym_where] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [sym_mutable_specifier] = ACTIONS(1470),
    [sym_integer_literal] = ACTIONS(1472),
    [aux_sym_string_literal_token1] = ACTIONS(1472),
    [sym_char_literal] = ACTIONS(1472),
    [anon_sym_true] = ACTIONS(1470),
    [anon_sym_false] = ACTIONS(1470),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1470),
    [sym_super] = ACTIONS(1470),
    [sym_crate] = ACTIONS(1470),
    [sym_metavariable] = ACTIONS(1472),
    [sym_raw_string_literal] = ACTIONS(1472),
    [sym_float_literal] = ACTIONS(1472),
  },
  [431] = {
    [sym_line_comment] = STATE(431),
    [sym_block_comment] = STATE(431),
    [sym_identifier] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_RBRACK] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_COLON] = ACTIONS(1474),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1476),
    [anon_sym_u8] = ACTIONS(1474),
    [anon_sym_i8] = ACTIONS(1474),
    [anon_sym_u16] = ACTIONS(1474),
    [anon_sym_i16] = ACTIONS(1474),
    [anon_sym_u32] = ACTIONS(1474),
    [anon_sym_i32] = ACTIONS(1474),
    [anon_sym_u64] = ACTIONS(1474),
    [anon_sym_i64] = ACTIONS(1474),
    [anon_sym_u128] = ACTIONS(1474),
    [anon_sym_i128] = ACTIONS(1474),
    [anon_sym_isize] = ACTIONS(1474),
    [anon_sym_usize] = ACTIONS(1474),
    [anon_sym_f32] = ACTIONS(1474),
    [anon_sym_f64] = ACTIONS(1474),
    [anon_sym_bool] = ACTIONS(1474),
    [anon_sym_str] = ACTIONS(1474),
    [anon_sym_char] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym__] = ACTIONS(1474),
    [anon_sym_BSLASH] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_COMMA] = ACTIONS(1476),
    [anon_sym_COLON_COLON] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_DOT] = ACTIONS(1476),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_POUND] = ACTIONS(1476),
    [anon_sym_PERCENT] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_as] = ACTIONS(1474),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_await] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_fn] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_impl] = ACTIONS(1474),
    [anon_sym_let] = ACTIONS(1474),
    [anon_sym_loop] = ACTIONS(1474),
    [anon_sym_match] = ACTIONS(1474),
    [anon_sym_mod] = ACTIONS(1474),
    [anon_sym_pub] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_struct] = ACTIONS(1474),
    [anon_sym_trait] = ACTIONS(1474),
    [anon_sym_type] = ACTIONS(1474),
    [anon_sym_union] = ACTIONS(1474),
    [anon_sym_unsafe] = ACTIONS(1474),
    [anon_sym_use] = ACTIONS(1474),
    [anon_sym_where] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [sym_mutable_specifier] = ACTIONS(1474),
    [sym_integer_literal] = ACTIONS(1476),
    [aux_sym_string_literal_token1] = ACTIONS(1476),
    [sym_char_literal] = ACTIONS(1476),
    [anon_sym_true] = ACTIONS(1474),
    [anon_sym_false] = ACTIONS(1474),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1474),
    [sym_super] = ACTIONS(1474),
    [sym_crate] = ACTIONS(1474),
    [sym_metavariable] = ACTIONS(1476),
    [sym_raw_string_literal] = ACTIONS(1476),
    [sym_float_literal] = ACTIONS(1476),
  },
  [432] = {
    [sym_line_comment] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym_identifier] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1480),
    [anon_sym_RPAREN] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_RBRACK] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1480),
    [anon_sym_COLON] = ACTIONS(1478),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1480),
    [anon_sym_u8] = ACTIONS(1478),
    [anon_sym_i8] = ACTIONS(1478),
    [anon_sym_u16] = ACTIONS(1478),
    [anon_sym_i16] = ACTIONS(1478),
    [anon_sym_u32] = ACTIONS(1478),
    [anon_sym_i32] = ACTIONS(1478),
    [anon_sym_u64] = ACTIONS(1478),
    [anon_sym_i64] = ACTIONS(1478),
    [anon_sym_u128] = ACTIONS(1478),
    [anon_sym_i128] = ACTIONS(1478),
    [anon_sym_isize] = ACTIONS(1478),
    [anon_sym_usize] = ACTIONS(1478),
    [anon_sym_f32] = ACTIONS(1478),
    [anon_sym_f64] = ACTIONS(1478),
    [anon_sym_bool] = ACTIONS(1478),
    [anon_sym_str] = ACTIONS(1478),
    [anon_sym_char] = ACTIONS(1478),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym__] = ACTIONS(1478),
    [anon_sym_BSLASH] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_COMMA] = ACTIONS(1480),
    [anon_sym_COLON_COLON] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_DOT] = ACTIONS(1480),
    [anon_sym_AT] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_POUND] = ACTIONS(1480),
    [anon_sym_PERCENT] = ACTIONS(1480),
    [anon_sym_CARET] = ACTIONS(1480),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_as] = ACTIONS(1478),
    [anon_sym_async] = ACTIONS(1478),
    [anon_sym_await] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_fn] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_impl] = ACTIONS(1478),
    [anon_sym_let] = ACTIONS(1478),
    [anon_sym_loop] = ACTIONS(1478),
    [anon_sym_match] = ACTIONS(1478),
    [anon_sym_mod] = ACTIONS(1478),
    [anon_sym_pub] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_trait] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_unsafe] = ACTIONS(1478),
    [anon_sym_use] = ACTIONS(1478),
    [anon_sym_where] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [sym_mutable_specifier] = ACTIONS(1478),
    [sym_integer_literal] = ACTIONS(1480),
    [aux_sym_string_literal_token1] = ACTIONS(1480),
    [sym_char_literal] = ACTIONS(1480),
    [anon_sym_true] = ACTIONS(1478),
    [anon_sym_false] = ACTIONS(1478),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1478),
    [sym_super] = ACTIONS(1478),
    [sym_crate] = ACTIONS(1478),
    [sym_metavariable] = ACTIONS(1480),
    [sym_raw_string_literal] = ACTIONS(1480),
    [sym_float_literal] = ACTIONS(1480),
  },
  [433] = {
    [sym_line_comment] = STATE(433),
    [sym_block_comment] = STATE(433),
    [sym_identifier] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [anon_sym_RPAREN] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1484),
    [anon_sym_RBRACK] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [anon_sym_COLON] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1484),
    [anon_sym_u8] = ACTIONS(1482),
    [anon_sym_i8] = ACTIONS(1482),
    [anon_sym_u16] = ACTIONS(1482),
    [anon_sym_i16] = ACTIONS(1482),
    [anon_sym_u32] = ACTIONS(1482),
    [anon_sym_i32] = ACTIONS(1482),
    [anon_sym_u64] = ACTIONS(1482),
    [anon_sym_i64] = ACTIONS(1482),
    [anon_sym_u128] = ACTIONS(1482),
    [anon_sym_i128] = ACTIONS(1482),
    [anon_sym_isize] = ACTIONS(1482),
    [anon_sym_usize] = ACTIONS(1482),
    [anon_sym_f32] = ACTIONS(1482),
    [anon_sym_f64] = ACTIONS(1482),
    [anon_sym_bool] = ACTIONS(1482),
    [anon_sym_str] = ACTIONS(1482),
    [anon_sym_char] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym__] = ACTIONS(1482),
    [anon_sym_BSLASH] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_DOT] = ACTIONS(1484),
    [anon_sym_AT] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_POUND] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_CARET] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_as] = ACTIONS(1482),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_await] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_fn] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_impl] = ACTIONS(1482),
    [anon_sym_let] = ACTIONS(1482),
    [anon_sym_loop] = ACTIONS(1482),
    [anon_sym_match] = ACTIONS(1482),
    [anon_sym_mod] = ACTIONS(1482),
    [anon_sym_pub] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_struct] = ACTIONS(1482),
    [anon_sym_trait] = ACTIONS(1482),
    [anon_sym_type] = ACTIONS(1482),
    [anon_sym_union] = ACTIONS(1482),
    [anon_sym_unsafe] = ACTIONS(1482),
    [anon_sym_use] = ACTIONS(1482),
    [anon_sym_where] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [sym_mutable_specifier] = ACTIONS(1482),
    [sym_integer_literal] = ACTIONS(1484),
    [aux_sym_string_literal_token1] = ACTIONS(1484),
    [sym_char_literal] = ACTIONS(1484),
    [anon_sym_true] = ACTIONS(1482),
    [anon_sym_false] = ACTIONS(1482),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1482),
    [sym_super] = ACTIONS(1482),
    [sym_crate] = ACTIONS(1482),
    [sym_metavariable] = ACTIONS(1484),
    [sym_raw_string_literal] = ACTIONS(1484),
    [sym_float_literal] = ACTIONS(1484),
  },
  [434] = {
    [sym_line_comment] = STATE(434),
    [sym_block_comment] = STATE(434),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_EQ_GT] = ACTIONS(1368),
    [anon_sym_COLON] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1368),
    [anon_sym_u8] = ACTIONS(1366),
    [anon_sym_i8] = ACTIONS(1366),
    [anon_sym_u16] = ACTIONS(1366),
    [anon_sym_i16] = ACTIONS(1366),
    [anon_sym_u32] = ACTIONS(1366),
    [anon_sym_i32] = ACTIONS(1366),
    [anon_sym_u64] = ACTIONS(1366),
    [anon_sym_i64] = ACTIONS(1366),
    [anon_sym_u128] = ACTIONS(1366),
    [anon_sym_i128] = ACTIONS(1366),
    [anon_sym_isize] = ACTIONS(1366),
    [anon_sym_usize] = ACTIONS(1366),
    [anon_sym_f32] = ACTIONS(1366),
    [anon_sym_f64] = ACTIONS(1366),
    [anon_sym_bool] = ACTIONS(1366),
    [anon_sym_str] = ACTIONS(1366),
    [anon_sym_char] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_COLON_COLON] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_loop] = ACTIONS(1366),
    [anon_sym_match] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_unsafe] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1368),
    [anon_sym_PIPE_PIPE] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1368),
    [anon_sym_BANG_EQ] = ACTIONS(1368),
    [anon_sym_LT_EQ] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1368),
    [anon_sym_LT_LT] = ACTIONS(1366),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_PLUS_EQ] = ACTIONS(1368),
    [anon_sym_DASH_EQ] = ACTIONS(1368),
    [anon_sym_STAR_EQ] = ACTIONS(1368),
    [anon_sym_SLASH_EQ] = ACTIONS(1368),
    [anon_sym_PERCENT_EQ] = ACTIONS(1368),
    [anon_sym_AMP_EQ] = ACTIONS(1368),
    [anon_sym_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_CARET_EQ] = ACTIONS(1368),
    [anon_sym_LT_LT_EQ] = ACTIONS(1368),
    [anon_sym_GT_GT_EQ] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1366),
    [anon_sym_move] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [sym_integer_literal] = ACTIONS(1368),
    [aux_sym_string_literal_token1] = ACTIONS(1368),
    [sym_char_literal] = ACTIONS(1368),
    [anon_sym_true] = ACTIONS(1366),
    [anon_sym_false] = ACTIONS(1366),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1366),
    [sym_super] = ACTIONS(1366),
    [sym_crate] = ACTIONS(1366),
    [sym_metavariable] = ACTIONS(1368),
    [sym_raw_string_literal] = ACTIONS(1368),
    [sym_float_literal] = ACTIONS(1368),
  },
  [435] = {
    [sym_line_comment] = STATE(435),
    [sym_block_comment] = STATE(435),
    [sym_identifier] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_RBRACK] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_COLON] = ACTIONS(1486),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_QMARK] = ACTIONS(1488),
    [anon_sym_u8] = ACTIONS(1486),
    [anon_sym_i8] = ACTIONS(1486),
    [anon_sym_u16] = ACTIONS(1486),
    [anon_sym_i16] = ACTIONS(1486),
    [anon_sym_u32] = ACTIONS(1486),
    [anon_sym_i32] = ACTIONS(1486),
    [anon_sym_u64] = ACTIONS(1486),
    [anon_sym_i64] = ACTIONS(1486),
    [anon_sym_u128] = ACTIONS(1486),
    [anon_sym_i128] = ACTIONS(1486),
    [anon_sym_isize] = ACTIONS(1486),
    [anon_sym_usize] = ACTIONS(1486),
    [anon_sym_f32] = ACTIONS(1486),
    [anon_sym_f64] = ACTIONS(1486),
    [anon_sym_bool] = ACTIONS(1486),
    [anon_sym_str] = ACTIONS(1486),
    [anon_sym_char] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym__] = ACTIONS(1486),
    [anon_sym_BSLASH] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_DASH_GT] = ACTIONS(1488),
    [anon_sym_COMMA] = ACTIONS(1488),
    [anon_sym_COLON_COLON] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_DOT] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_POUND] = ACTIONS(1488),
    [anon_sym_PERCENT] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1488),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_as] = ACTIONS(1486),
    [anon_sym_async] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_fn] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_impl] = ACTIONS(1486),
    [anon_sym_let] = ACTIONS(1486),
    [anon_sym_loop] = ACTIONS(1486),
    [anon_sym_match] = ACTIONS(1486),
    [anon_sym_mod] = ACTIONS(1486),
    [anon_sym_pub] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_struct] = ACTIONS(1486),
    [anon_sym_trait] = ACTIONS(1486),
    [anon_sym_type] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1486),
    [anon_sym_unsafe] = ACTIONS(1486),
    [anon_sym_use] = ACTIONS(1486),
    [anon_sym_where] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [sym_mutable_specifier] = ACTIONS(1486),
    [sym_integer_literal] = ACTIONS(1488),
    [aux_sym_string_literal_token1] = ACTIONS(1488),
    [sym_char_literal] = ACTIONS(1488),
    [anon_sym_true] = ACTIONS(1486),
    [anon_sym_false] = ACTIONS(1486),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1486),
    [sym_super] = ACTIONS(1486),
    [sym_crate] = ACTIONS(1486),
    [sym_metavariable] = ACTIONS(1488),
    [sym_raw_string_literal] = ACTIONS(1488),
    [sym_float_literal] = ACTIONS(1488),
  },
  [436] = {
    [sym_line_comment] = STATE(436),
    [sym_block_comment] = STATE(436),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_RBRACK] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_COLON] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(1430),
    [anon_sym_u8] = ACTIONS(1428),
    [anon_sym_i8] = ACTIONS(1428),
    [anon_sym_u16] = ACTIONS(1428),
    [anon_sym_i16] = ACTIONS(1428),
    [anon_sym_u32] = ACTIONS(1428),
    [anon_sym_i32] = ACTIONS(1428),
    [anon_sym_u64] = ACTIONS(1428),
    [anon_sym_i64] = ACTIONS(1428),
    [anon_sym_u128] = ACTIONS(1428),
    [anon_sym_i128] = ACTIONS(1428),
    [anon_sym_isize] = ACTIONS(1428),
    [anon_sym_usize] = ACTIONS(1428),
    [anon_sym_f32] = ACTIONS(1428),
    [anon_sym_f64] = ACTIONS(1428),
    [anon_sym_bool] = ACTIONS(1428),
    [anon_sym_str] = ACTIONS(1428),
    [anon_sym_char] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1430),
    [anon_sym_DASH_GT] = ACTIONS(1430),
    [anon_sym_COMMA] = ACTIONS(1430),
    [anon_sym_COLON_COLON] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1430),
    [anon_sym_DOT] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_PERCENT] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1428),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_fn] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_impl] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_loop] = ACTIONS(1428),
    [anon_sym_match] = ACTIONS(1428),
    [anon_sym_mod] = ACTIONS(1428),
    [anon_sym_pub] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_struct] = ACTIONS(1428),
    [anon_sym_trait] = ACTIONS(1428),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_union] = ACTIONS(1428),
    [anon_sym_unsafe] = ACTIONS(1428),
    [anon_sym_use] = ACTIONS(1428),
    [anon_sym_where] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [sym_mutable_specifier] = ACTIONS(1428),
    [sym_integer_literal] = ACTIONS(1430),
    [aux_sym_string_literal_token1] = ACTIONS(1430),
    [sym_char_literal] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_crate] = ACTIONS(1428),
    [sym_metavariable] = ACTIONS(1430),
    [sym_raw_string_literal] = ACTIONS(1430),
    [sym_float_literal] = ACTIONS(1430),
  },
  [437] = {
    [sym_line_comment] = STATE(437),
    [sym_block_comment] = STATE(437),
    [sym_identifier] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1492),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [anon_sym_RBRACK] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_COLON] = ACTIONS(1490),
    [anon_sym_DOLLAR] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1492),
    [anon_sym_u8] = ACTIONS(1490),
    [anon_sym_i8] = ACTIONS(1490),
    [anon_sym_u16] = ACTIONS(1490),
    [anon_sym_i16] = ACTIONS(1490),
    [anon_sym_u32] = ACTIONS(1490),
    [anon_sym_i32] = ACTIONS(1490),
    [anon_sym_u64] = ACTIONS(1490),
    [anon_sym_i64] = ACTIONS(1490),
    [anon_sym_u128] = ACTIONS(1490),
    [anon_sym_i128] = ACTIONS(1490),
    [anon_sym_isize] = ACTIONS(1490),
    [anon_sym_usize] = ACTIONS(1490),
    [anon_sym_f32] = ACTIONS(1490),
    [anon_sym_f64] = ACTIONS(1490),
    [anon_sym_bool] = ACTIONS(1490),
    [anon_sym_str] = ACTIONS(1490),
    [anon_sym_char] = ACTIONS(1490),
    [anon_sym_SLASH] = ACTIONS(1490),
    [anon_sym__] = ACTIONS(1490),
    [anon_sym_BSLASH] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_COMMA] = ACTIONS(1492),
    [anon_sym_COLON_COLON] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1492),
    [anon_sym_AT] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_POUND] = ACTIONS(1492),
    [anon_sym_PERCENT] = ACTIONS(1492),
    [anon_sym_CARET] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_as] = ACTIONS(1490),
    [anon_sym_async] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_fn] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_impl] = ACTIONS(1490),
    [anon_sym_let] = ACTIONS(1490),
    [anon_sym_loop] = ACTIONS(1490),
    [anon_sym_match] = ACTIONS(1490),
    [anon_sym_mod] = ACTIONS(1490),
    [anon_sym_pub] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_trait] = ACTIONS(1490),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [anon_sym_unsafe] = ACTIONS(1490),
    [anon_sym_use] = ACTIONS(1490),
    [anon_sym_where] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [sym_mutable_specifier] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1492),
    [aux_sym_string_literal_token1] = ACTIONS(1492),
    [sym_char_literal] = ACTIONS(1492),
    [anon_sym_true] = ACTIONS(1490),
    [anon_sym_false] = ACTIONS(1490),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1490),
    [sym_super] = ACTIONS(1490),
    [sym_crate] = ACTIONS(1490),
    [sym_metavariable] = ACTIONS(1492),
    [sym_raw_string_literal] = ACTIONS(1492),
    [sym_float_literal] = ACTIONS(1492),
  },
  [438] = {
    [sym_line_comment] = STATE(438),
    [sym_block_comment] = STATE(438),
    [sym_identifier] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_RPAREN] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_RBRACE] = ACTIONS(1496),
    [anon_sym_COLON] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_QMARK] = ACTIONS(1496),
    [anon_sym_u8] = ACTIONS(1494),
    [anon_sym_i8] = ACTIONS(1494),
    [anon_sym_u16] = ACTIONS(1494),
    [anon_sym_i16] = ACTIONS(1494),
    [anon_sym_u32] = ACTIONS(1494),
    [anon_sym_i32] = ACTIONS(1494),
    [anon_sym_u64] = ACTIONS(1494),
    [anon_sym_i64] = ACTIONS(1494),
    [anon_sym_u128] = ACTIONS(1494),
    [anon_sym_i128] = ACTIONS(1494),
    [anon_sym_isize] = ACTIONS(1494),
    [anon_sym_usize] = ACTIONS(1494),
    [anon_sym_f32] = ACTIONS(1494),
    [anon_sym_f64] = ACTIONS(1494),
    [anon_sym_bool] = ACTIONS(1494),
    [anon_sym_str] = ACTIONS(1494),
    [anon_sym_char] = ACTIONS(1494),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym__] = ACTIONS(1494),
    [anon_sym_BSLASH] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_EQ] = ACTIONS(1496),
    [anon_sym_DASH_GT] = ACTIONS(1496),
    [anon_sym_COMMA] = ACTIONS(1496),
    [anon_sym_COLON_COLON] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_DOT] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_POUND] = ACTIONS(1496),
    [anon_sym_PERCENT] = ACTIONS(1496),
    [anon_sym_CARET] = ACTIONS(1496),
    [anon_sym_LT] = ACTIONS(1496),
    [anon_sym_GT] = ACTIONS(1496),
    [anon_sym_PIPE] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_as] = ACTIONS(1494),
    [anon_sym_async] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_fn] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_impl] = ACTIONS(1494),
    [anon_sym_let] = ACTIONS(1494),
    [anon_sym_loop] = ACTIONS(1494),
    [anon_sym_match] = ACTIONS(1494),
    [anon_sym_mod] = ACTIONS(1494),
    [anon_sym_pub] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_trait] = ACTIONS(1494),
    [anon_sym_type] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_unsafe] = ACTIONS(1494),
    [anon_sym_use] = ACTIONS(1494),
    [anon_sym_where] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [sym_mutable_specifier] = ACTIONS(1494),
    [sym_integer_literal] = ACTIONS(1496),
    [aux_sym_string_literal_token1] = ACTIONS(1496),
    [sym_char_literal] = ACTIONS(1496),
    [anon_sym_true] = ACTIONS(1494),
    [anon_sym_false] = ACTIONS(1494),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1494),
    [sym_super] = ACTIONS(1494),
    [sym_crate] = ACTIONS(1494),
    [sym_metavariable] = ACTIONS(1496),
    [sym_raw_string_literal] = ACTIONS(1496),
    [sym_float_literal] = ACTIONS(1496),
  },
  [439] = {
    [sym_line_comment] = STATE(439),
    [sym_block_comment] = STATE(439),
    [sym_identifier] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1500),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_RBRACE] = ACTIONS(1500),
    [anon_sym_COLON] = ACTIONS(1498),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1500),
    [anon_sym_u8] = ACTIONS(1498),
    [anon_sym_i8] = ACTIONS(1498),
    [anon_sym_u16] = ACTIONS(1498),
    [anon_sym_i16] = ACTIONS(1498),
    [anon_sym_u32] = ACTIONS(1498),
    [anon_sym_i32] = ACTIONS(1498),
    [anon_sym_u64] = ACTIONS(1498),
    [anon_sym_i64] = ACTIONS(1498),
    [anon_sym_u128] = ACTIONS(1498),
    [anon_sym_i128] = ACTIONS(1498),
    [anon_sym_isize] = ACTIONS(1498),
    [anon_sym_usize] = ACTIONS(1498),
    [anon_sym_f32] = ACTIONS(1498),
    [anon_sym_f64] = ACTIONS(1498),
    [anon_sym_bool] = ACTIONS(1498),
    [anon_sym_str] = ACTIONS(1498),
    [anon_sym_char] = ACTIONS(1498),
    [anon_sym_SLASH] = ACTIONS(1498),
    [anon_sym__] = ACTIONS(1498),
    [anon_sym_BSLASH] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_COMMA] = ACTIONS(1500),
    [anon_sym_COLON_COLON] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_DOT] = ACTIONS(1500),
    [anon_sym_AT] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_POUND] = ACTIONS(1500),
    [anon_sym_PERCENT] = ACTIONS(1500),
    [anon_sym_CARET] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_as] = ACTIONS(1498),
    [anon_sym_async] = ACTIONS(1498),
    [anon_sym_await] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_fn] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_impl] = ACTIONS(1498),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_loop] = ACTIONS(1498),
    [anon_sym_match] = ACTIONS(1498),
    [anon_sym_mod] = ACTIONS(1498),
    [anon_sym_pub] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_trait] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_unsafe] = ACTIONS(1498),
    [anon_sym_use] = ACTIONS(1498),
    [anon_sym_where] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [sym_mutable_specifier] = ACTIONS(1498),
    [sym_integer_literal] = ACTIONS(1500),
    [aux_sym_string_literal_token1] = ACTIONS(1500),
    [sym_char_literal] = ACTIONS(1500),
    [anon_sym_true] = ACTIONS(1498),
    [anon_sym_false] = ACTIONS(1498),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1498),
    [sym_super] = ACTIONS(1498),
    [sym_crate] = ACTIONS(1498),
    [sym_metavariable] = ACTIONS(1500),
    [sym_raw_string_literal] = ACTIONS(1500),
    [sym_float_literal] = ACTIONS(1500),
  },
  [440] = {
    [sym_line_comment] = STATE(440),
    [sym_block_comment] = STATE(440),
    [sym_identifier] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_RPAREN] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_COLON] = ACTIONS(1502),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1504),
    [anon_sym_u8] = ACTIONS(1502),
    [anon_sym_i8] = ACTIONS(1502),
    [anon_sym_u16] = ACTIONS(1502),
    [anon_sym_i16] = ACTIONS(1502),
    [anon_sym_u32] = ACTIONS(1502),
    [anon_sym_i32] = ACTIONS(1502),
    [anon_sym_u64] = ACTIONS(1502),
    [anon_sym_i64] = ACTIONS(1502),
    [anon_sym_u128] = ACTIONS(1502),
    [anon_sym_i128] = ACTIONS(1502),
    [anon_sym_isize] = ACTIONS(1502),
    [anon_sym_usize] = ACTIONS(1502),
    [anon_sym_f32] = ACTIONS(1502),
    [anon_sym_f64] = ACTIONS(1502),
    [anon_sym_bool] = ACTIONS(1502),
    [anon_sym_str] = ACTIONS(1502),
    [anon_sym_char] = ACTIONS(1502),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym__] = ACTIONS(1502),
    [anon_sym_BSLASH] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_COMMA] = ACTIONS(1504),
    [anon_sym_COLON_COLON] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_DOT] = ACTIONS(1504),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_POUND] = ACTIONS(1504),
    [anon_sym_PERCENT] = ACTIONS(1504),
    [anon_sym_CARET] = ACTIONS(1504),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_as] = ACTIONS(1502),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_await] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_fn] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_impl] = ACTIONS(1502),
    [anon_sym_let] = ACTIONS(1502),
    [anon_sym_loop] = ACTIONS(1502),
    [anon_sym_match] = ACTIONS(1502),
    [anon_sym_mod] = ACTIONS(1502),
    [anon_sym_pub] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_struct] = ACTIONS(1502),
    [anon_sym_trait] = ACTIONS(1502),
    [anon_sym_type] = ACTIONS(1502),
    [anon_sym_union] = ACTIONS(1502),
    [anon_sym_unsafe] = ACTIONS(1502),
    [anon_sym_use] = ACTIONS(1502),
    [anon_sym_where] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [sym_mutable_specifier] = ACTIONS(1502),
    [sym_integer_literal] = ACTIONS(1504),
    [aux_sym_string_literal_token1] = ACTIONS(1504),
    [sym_char_literal] = ACTIONS(1504),
    [anon_sym_true] = ACTIONS(1502),
    [anon_sym_false] = ACTIONS(1502),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1502),
    [sym_super] = ACTIONS(1502),
    [sym_crate] = ACTIONS(1502),
    [sym_metavariable] = ACTIONS(1504),
    [sym_raw_string_literal] = ACTIONS(1504),
    [sym_float_literal] = ACTIONS(1504),
  },
  [441] = {
    [sym_line_comment] = STATE(441),
    [sym_block_comment] = STATE(441),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_RBRACK] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1432),
    [anon_sym_DOLLAR] = ACTIONS(1432),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_u8] = ACTIONS(1432),
    [anon_sym_i8] = ACTIONS(1432),
    [anon_sym_u16] = ACTIONS(1432),
    [anon_sym_i16] = ACTIONS(1432),
    [anon_sym_u32] = ACTIONS(1432),
    [anon_sym_i32] = ACTIONS(1432),
    [anon_sym_u64] = ACTIONS(1432),
    [anon_sym_i64] = ACTIONS(1432),
    [anon_sym_u128] = ACTIONS(1432),
    [anon_sym_i128] = ACTIONS(1432),
    [anon_sym_isize] = ACTIONS(1432),
    [anon_sym_usize] = ACTIONS(1432),
    [anon_sym_f32] = ACTIONS(1432),
    [anon_sym_f64] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_str] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym__] = ACTIONS(1432),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_DASH_GT] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_COLON_COLON] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_as] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_fn] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_impl] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_loop] = ACTIONS(1432),
    [anon_sym_match] = ACTIONS(1432),
    [anon_sym_mod] = ACTIONS(1432),
    [anon_sym_pub] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_struct] = ACTIONS(1432),
    [anon_sym_trait] = ACTIONS(1432),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_unsafe] = ACTIONS(1432),
    [anon_sym_use] = ACTIONS(1432),
    [anon_sym_where] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [sym_mutable_specifier] = ACTIONS(1432),
    [sym_integer_literal] = ACTIONS(1434),
    [aux_sym_string_literal_token1] = ACTIONS(1434),
    [sym_char_literal] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_crate] = ACTIONS(1432),
    [sym_metavariable] = ACTIONS(1434),
    [sym_raw_string_literal] = ACTIONS(1434),
    [sym_float_literal] = ACTIONS(1434),
  },
  [442] = {
    [sym_line_comment] = STATE(442),
    [sym_block_comment] = STATE(442),
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_COLON] = ACTIONS(1506),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1508),
    [anon_sym_u8] = ACTIONS(1506),
    [anon_sym_i8] = ACTIONS(1506),
    [anon_sym_u16] = ACTIONS(1506),
    [anon_sym_i16] = ACTIONS(1506),
    [anon_sym_u32] = ACTIONS(1506),
    [anon_sym_i32] = ACTIONS(1506),
    [anon_sym_u64] = ACTIONS(1506),
    [anon_sym_i64] = ACTIONS(1506),
    [anon_sym_u128] = ACTIONS(1506),
    [anon_sym_i128] = ACTIONS(1506),
    [anon_sym_isize] = ACTIONS(1506),
    [anon_sym_usize] = ACTIONS(1506),
    [anon_sym_f32] = ACTIONS(1506),
    [anon_sym_f64] = ACTIONS(1506),
    [anon_sym_bool] = ACTIONS(1506),
    [anon_sym_str] = ACTIONS(1506),
    [anon_sym_char] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym__] = ACTIONS(1506),
    [anon_sym_BSLASH] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_COLON_COLON] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_DOT] = ACTIONS(1508),
    [anon_sym_AT] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_POUND] = ACTIONS(1508),
    [anon_sym_PERCENT] = ACTIONS(1508),
    [anon_sym_CARET] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_as] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_await] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_fn] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_impl] = ACTIONS(1506),
    [anon_sym_let] = ACTIONS(1506),
    [anon_sym_loop] = ACTIONS(1506),
    [anon_sym_match] = ACTIONS(1506),
    [anon_sym_mod] = ACTIONS(1506),
    [anon_sym_pub] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_trait] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_unsafe] = ACTIONS(1506),
    [anon_sym_use] = ACTIONS(1506),
    [anon_sym_where] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [sym_mutable_specifier] = ACTIONS(1506),
    [sym_integer_literal] = ACTIONS(1508),
    [aux_sym_string_literal_token1] = ACTIONS(1508),
    [sym_char_literal] = ACTIONS(1508),
    [anon_sym_true] = ACTIONS(1506),
    [anon_sym_false] = ACTIONS(1506),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1506),
    [sym_super] = ACTIONS(1506),
    [sym_crate] = ACTIONS(1506),
    [sym_metavariable] = ACTIONS(1508),
    [sym_raw_string_literal] = ACTIONS(1508),
    [sym_float_literal] = ACTIONS(1508),
  },
  [443] = {
    [sym_line_comment] = STATE(443),
    [sym_block_comment] = STATE(443),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [anon_sym_RPAREN] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_QMARK] = ACTIONS(1512),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym__] = ACTIONS(1510),
    [anon_sym_BSLASH] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_EQ] = ACTIONS(1512),
    [anon_sym_DASH_GT] = ACTIONS(1512),
    [anon_sym_COMMA] = ACTIONS(1512),
    [anon_sym_COLON_COLON] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_DOT] = ACTIONS(1512),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_POUND] = ACTIONS(1512),
    [anon_sym_PERCENT] = ACTIONS(1512),
    [anon_sym_CARET] = ACTIONS(1512),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_as] = ACTIONS(1510),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_await] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_fn] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_impl] = ACTIONS(1510),
    [anon_sym_let] = ACTIONS(1510),
    [anon_sym_loop] = ACTIONS(1510),
    [anon_sym_match] = ACTIONS(1510),
    [anon_sym_mod] = ACTIONS(1510),
    [anon_sym_pub] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_trait] = ACTIONS(1510),
    [anon_sym_type] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_unsafe] = ACTIONS(1510),
    [anon_sym_use] = ACTIONS(1510),
    [anon_sym_where] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [sym_mutable_specifier] = ACTIONS(1510),
    [sym_integer_literal] = ACTIONS(1512),
    [aux_sym_string_literal_token1] = ACTIONS(1512),
    [sym_char_literal] = ACTIONS(1512),
    [anon_sym_true] = ACTIONS(1510),
    [anon_sym_false] = ACTIONS(1510),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1510),
    [sym_super] = ACTIONS(1510),
    [sym_crate] = ACTIONS(1510),
    [sym_metavariable] = ACTIONS(1512),
    [sym_raw_string_literal] = ACTIONS(1512),
    [sym_float_literal] = ACTIONS(1512),
  },
  [444] = {
    [sym_line_comment] = STATE(444),
    [sym_block_comment] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [anon_sym_RPAREN] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [anon_sym_RBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_u8] = ACTIONS(1514),
    [anon_sym_i8] = ACTIONS(1514),
    [anon_sym_u16] = ACTIONS(1514),
    [anon_sym_i16] = ACTIONS(1514),
    [anon_sym_u32] = ACTIONS(1514),
    [anon_sym_i32] = ACTIONS(1514),
    [anon_sym_u64] = ACTIONS(1514),
    [anon_sym_i64] = ACTIONS(1514),
    [anon_sym_u128] = ACTIONS(1514),
    [anon_sym_i128] = ACTIONS(1514),
    [anon_sym_isize] = ACTIONS(1514),
    [anon_sym_usize] = ACTIONS(1514),
    [anon_sym_f32] = ACTIONS(1514),
    [anon_sym_f64] = ACTIONS(1514),
    [anon_sym_bool] = ACTIONS(1514),
    [anon_sym_str] = ACTIONS(1514),
    [anon_sym_char] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym__] = ACTIONS(1514),
    [anon_sym_BSLASH] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_DASH_GT] = ACTIONS(1516),
    [anon_sym_COMMA] = ACTIONS(1516),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_DOT] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_POUND] = ACTIONS(1516),
    [anon_sym_PERCENT] = ACTIONS(1516),
    [anon_sym_CARET] = ACTIONS(1516),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [anon_sym_as] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_await] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_fn] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_impl] = ACTIONS(1514),
    [anon_sym_let] = ACTIONS(1514),
    [anon_sym_loop] = ACTIONS(1514),
    [anon_sym_match] = ACTIONS(1514),
    [anon_sym_mod] = ACTIONS(1514),
    [anon_sym_pub] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_struct] = ACTIONS(1514),
    [anon_sym_trait] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_union] = ACTIONS(1514),
    [anon_sym_unsafe] = ACTIONS(1514),
    [anon_sym_use] = ACTIONS(1514),
    [anon_sym_where] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [sym_mutable_specifier] = ACTIONS(1514),
    [sym_integer_literal] = ACTIONS(1516),
    [aux_sym_string_literal_token1] = ACTIONS(1516),
    [sym_char_literal] = ACTIONS(1516),
    [anon_sym_true] = ACTIONS(1514),
    [anon_sym_false] = ACTIONS(1514),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1514),
    [sym_super] = ACTIONS(1514),
    [sym_crate] = ACTIONS(1514),
    [sym_metavariable] = ACTIONS(1516),
    [sym_raw_string_literal] = ACTIONS(1516),
    [sym_float_literal] = ACTIONS(1516),
  },
  [445] = {
    [sym_line_comment] = STATE(445),
    [sym_block_comment] = STATE(445),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_RPAREN] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1520),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_COLON] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1520),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_QMARK] = ACTIONS(1520),
    [anon_sym_u8] = ACTIONS(1518),
    [anon_sym_i8] = ACTIONS(1518),
    [anon_sym_u16] = ACTIONS(1518),
    [anon_sym_i16] = ACTIONS(1518),
    [anon_sym_u32] = ACTIONS(1518),
    [anon_sym_i32] = ACTIONS(1518),
    [anon_sym_u64] = ACTIONS(1518),
    [anon_sym_i64] = ACTIONS(1518),
    [anon_sym_u128] = ACTIONS(1518),
    [anon_sym_i128] = ACTIONS(1518),
    [anon_sym_isize] = ACTIONS(1518),
    [anon_sym_usize] = ACTIONS(1518),
    [anon_sym_f32] = ACTIONS(1518),
    [anon_sym_f64] = ACTIONS(1518),
    [anon_sym_bool] = ACTIONS(1518),
    [anon_sym_str] = ACTIONS(1518),
    [anon_sym_char] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1518),
    [anon_sym__] = ACTIONS(1518),
    [anon_sym_BSLASH] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_EQ] = ACTIONS(1520),
    [anon_sym_DASH_GT] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_COLON_COLON] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_DOT] = ACTIONS(1520),
    [anon_sym_AT] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_POUND] = ACTIONS(1520),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_LT] = ACTIONS(1520),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1518),
    [anon_sym_as] = ACTIONS(1518),
    [anon_sym_async] = ACTIONS(1518),
    [anon_sym_await] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_impl] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(1518),
    [anon_sym_loop] = ACTIONS(1518),
    [anon_sym_match] = ACTIONS(1518),
    [anon_sym_mod] = ACTIONS(1518),
    [anon_sym_pub] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_struct] = ACTIONS(1518),
    [anon_sym_trait] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_union] = ACTIONS(1518),
    [anon_sym_unsafe] = ACTIONS(1518),
    [anon_sym_use] = ACTIONS(1518),
    [anon_sym_where] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [sym_mutable_specifier] = ACTIONS(1518),
    [sym_integer_literal] = ACTIONS(1520),
    [aux_sym_string_literal_token1] = ACTIONS(1520),
    [sym_char_literal] = ACTIONS(1520),
    [anon_sym_true] = ACTIONS(1518),
    [anon_sym_false] = ACTIONS(1518),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1518),
    [sym_super] = ACTIONS(1518),
    [sym_crate] = ACTIONS(1518),
    [sym_metavariable] = ACTIONS(1520),
    [sym_raw_string_literal] = ACTIONS(1520),
    [sym_float_literal] = ACTIONS(1520),
  },
  [446] = {
    [sym_line_comment] = STATE(446),
    [sym_block_comment] = STATE(446),
    [sym_identifier] = ACTIONS(1522),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_RBRACE] = ACTIONS(1524),
    [anon_sym_COLON] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1524),
    [anon_sym_u8] = ACTIONS(1522),
    [anon_sym_i8] = ACTIONS(1522),
    [anon_sym_u16] = ACTIONS(1522),
    [anon_sym_i16] = ACTIONS(1522),
    [anon_sym_u32] = ACTIONS(1522),
    [anon_sym_i32] = ACTIONS(1522),
    [anon_sym_u64] = ACTIONS(1522),
    [anon_sym_i64] = ACTIONS(1522),
    [anon_sym_u128] = ACTIONS(1522),
    [anon_sym_i128] = ACTIONS(1522),
    [anon_sym_isize] = ACTIONS(1522),
    [anon_sym_usize] = ACTIONS(1522),
    [anon_sym_f32] = ACTIONS(1522),
    [anon_sym_f64] = ACTIONS(1522),
    [anon_sym_bool] = ACTIONS(1522),
    [anon_sym_str] = ACTIONS(1522),
    [anon_sym_char] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym__] = ACTIONS(1522),
    [anon_sym_BSLASH] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(1524),
    [anon_sym_DASH_GT] = ACTIONS(1524),
    [anon_sym_COMMA] = ACTIONS(1524),
    [anon_sym_COLON_COLON] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_POUND] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1524),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [anon_sym_as] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_await] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_fn] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_impl] = ACTIONS(1522),
    [anon_sym_let] = ACTIONS(1522),
    [anon_sym_loop] = ACTIONS(1522),
    [anon_sym_match] = ACTIONS(1522),
    [anon_sym_mod] = ACTIONS(1522),
    [anon_sym_pub] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_struct] = ACTIONS(1522),
    [anon_sym_trait] = ACTIONS(1522),
    [anon_sym_type] = ACTIONS(1522),
    [anon_sym_union] = ACTIONS(1522),
    [anon_sym_unsafe] = ACTIONS(1522),
    [anon_sym_use] = ACTIONS(1522),
    [anon_sym_where] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [sym_mutable_specifier] = ACTIONS(1522),
    [sym_integer_literal] = ACTIONS(1524),
    [aux_sym_string_literal_token1] = ACTIONS(1524),
    [sym_char_literal] = ACTIONS(1524),
    [anon_sym_true] = ACTIONS(1522),
    [anon_sym_false] = ACTIONS(1522),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym_raw_string_literal] = ACTIONS(1524),
    [sym_float_literal] = ACTIONS(1524),
  },
  [447] = {
    [sym_line_comment] = STATE(447),
    [sym_block_comment] = STATE(447),
    [sym_identifier] = ACTIONS(1526),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_RPAREN] = ACTIONS(1528),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_COLON] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_u8] = ACTIONS(1526),
    [anon_sym_i8] = ACTIONS(1526),
    [anon_sym_u16] = ACTIONS(1526),
    [anon_sym_i16] = ACTIONS(1526),
    [anon_sym_u32] = ACTIONS(1526),
    [anon_sym_i32] = ACTIONS(1526),
    [anon_sym_u64] = ACTIONS(1526),
    [anon_sym_i64] = ACTIONS(1526),
    [anon_sym_u128] = ACTIONS(1526),
    [anon_sym_i128] = ACTIONS(1526),
    [anon_sym_isize] = ACTIONS(1526),
    [anon_sym_usize] = ACTIONS(1526),
    [anon_sym_f32] = ACTIONS(1526),
    [anon_sym_f64] = ACTIONS(1526),
    [anon_sym_bool] = ACTIONS(1526),
    [anon_sym_str] = ACTIONS(1526),
    [anon_sym_char] = ACTIONS(1526),
    [anon_sym_SLASH] = ACTIONS(1526),
    [anon_sym__] = ACTIONS(1526),
    [anon_sym_BSLASH] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_EQ] = ACTIONS(1528),
    [anon_sym_DASH_GT] = ACTIONS(1528),
    [anon_sym_COMMA] = ACTIONS(1528),
    [anon_sym_COLON_COLON] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_DOT] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_POUND] = ACTIONS(1528),
    [anon_sym_PERCENT] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1528),
    [anon_sym_LT] = ACTIONS(1528),
    [anon_sym_GT] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [anon_sym_as] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_fn] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_impl] = ACTIONS(1526),
    [anon_sym_let] = ACTIONS(1526),
    [anon_sym_loop] = ACTIONS(1526),
    [anon_sym_match] = ACTIONS(1526),
    [anon_sym_mod] = ACTIONS(1526),
    [anon_sym_pub] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_struct] = ACTIONS(1526),
    [anon_sym_trait] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1526),
    [anon_sym_union] = ACTIONS(1526),
    [anon_sym_unsafe] = ACTIONS(1526),
    [anon_sym_use] = ACTIONS(1526),
    [anon_sym_where] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [sym_mutable_specifier] = ACTIONS(1526),
    [sym_integer_literal] = ACTIONS(1528),
    [aux_sym_string_literal_token1] = ACTIONS(1528),
    [sym_char_literal] = ACTIONS(1528),
    [anon_sym_true] = ACTIONS(1526),
    [anon_sym_false] = ACTIONS(1526),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1526),
    [sym_super] = ACTIONS(1526),
    [sym_crate] = ACTIONS(1526),
    [sym_metavariable] = ACTIONS(1528),
    [sym_raw_string_literal] = ACTIONS(1528),
    [sym_float_literal] = ACTIONS(1528),
  },
  [448] = {
    [sym_line_comment] = STATE(448),
    [sym_block_comment] = STATE(448),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [anon_sym_RPAREN] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_QMARK] = ACTIONS(1512),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym__] = ACTIONS(1510),
    [anon_sym_BSLASH] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_EQ] = ACTIONS(1512),
    [anon_sym_DASH_GT] = ACTIONS(1512),
    [anon_sym_COMMA] = ACTIONS(1512),
    [anon_sym_COLON_COLON] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_DOT] = ACTIONS(1512),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_POUND] = ACTIONS(1512),
    [anon_sym_PERCENT] = ACTIONS(1512),
    [anon_sym_CARET] = ACTIONS(1512),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_as] = ACTIONS(1510),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_await] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_fn] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_impl] = ACTIONS(1510),
    [anon_sym_let] = ACTIONS(1510),
    [anon_sym_loop] = ACTIONS(1510),
    [anon_sym_match] = ACTIONS(1510),
    [anon_sym_mod] = ACTIONS(1510),
    [anon_sym_pub] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_trait] = ACTIONS(1510),
    [anon_sym_type] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_unsafe] = ACTIONS(1510),
    [anon_sym_use] = ACTIONS(1510),
    [anon_sym_where] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [sym_mutable_specifier] = ACTIONS(1510),
    [sym_integer_literal] = ACTIONS(1512),
    [aux_sym_string_literal_token1] = ACTIONS(1512),
    [sym_char_literal] = ACTIONS(1512),
    [anon_sym_true] = ACTIONS(1510),
    [anon_sym_false] = ACTIONS(1510),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1510),
    [sym_super] = ACTIONS(1510),
    [sym_crate] = ACTIONS(1510),
    [sym_raw_string_literal] = ACTIONS(1512),
    [sym_float_literal] = ACTIONS(1512),
  },
  [449] = {
    [sym_line_comment] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym_identifier] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_RPAREN] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_RBRACE] = ACTIONS(1496),
    [anon_sym_COLON] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_QMARK] = ACTIONS(1496),
    [anon_sym_u8] = ACTIONS(1494),
    [anon_sym_i8] = ACTIONS(1494),
    [anon_sym_u16] = ACTIONS(1494),
    [anon_sym_i16] = ACTIONS(1494),
    [anon_sym_u32] = ACTIONS(1494),
    [anon_sym_i32] = ACTIONS(1494),
    [anon_sym_u64] = ACTIONS(1494),
    [anon_sym_i64] = ACTIONS(1494),
    [anon_sym_u128] = ACTIONS(1494),
    [anon_sym_i128] = ACTIONS(1494),
    [anon_sym_isize] = ACTIONS(1494),
    [anon_sym_usize] = ACTIONS(1494),
    [anon_sym_f32] = ACTIONS(1494),
    [anon_sym_f64] = ACTIONS(1494),
    [anon_sym_bool] = ACTIONS(1494),
    [anon_sym_str] = ACTIONS(1494),
    [anon_sym_char] = ACTIONS(1494),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym__] = ACTIONS(1494),
    [anon_sym_BSLASH] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_EQ] = ACTIONS(1496),
    [anon_sym_DASH_GT] = ACTIONS(1496),
    [anon_sym_COMMA] = ACTIONS(1496),
    [anon_sym_COLON_COLON] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_DOT] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_POUND] = ACTIONS(1496),
    [anon_sym_PERCENT] = ACTIONS(1496),
    [anon_sym_CARET] = ACTIONS(1496),
    [anon_sym_LT] = ACTIONS(1496),
    [anon_sym_GT] = ACTIONS(1496),
    [anon_sym_PIPE] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_as] = ACTIONS(1494),
    [anon_sym_async] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_fn] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_impl] = ACTIONS(1494),
    [anon_sym_let] = ACTIONS(1494),
    [anon_sym_loop] = ACTIONS(1494),
    [anon_sym_match] = ACTIONS(1494),
    [anon_sym_mod] = ACTIONS(1494),
    [anon_sym_pub] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_trait] = ACTIONS(1494),
    [anon_sym_type] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_unsafe] = ACTIONS(1494),
    [anon_sym_use] = ACTIONS(1494),
    [anon_sym_where] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [sym_mutable_specifier] = ACTIONS(1494),
    [sym_integer_literal] = ACTIONS(1496),
    [aux_sym_string_literal_token1] = ACTIONS(1496),
    [sym_char_literal] = ACTIONS(1496),
    [anon_sym_true] = ACTIONS(1494),
    [anon_sym_false] = ACTIONS(1494),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1494),
    [sym_super] = ACTIONS(1494),
    [sym_crate] = ACTIONS(1494),
    [sym_raw_string_literal] = ACTIONS(1496),
    [sym_float_literal] = ACTIONS(1496),
  },
  [450] = {
    [sym_line_comment] = STATE(450),
    [sym_block_comment] = STATE(450),
    [sym_identifier] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_LPAREN] = ACTIONS(1014),
    [anon_sym_RPAREN] = ACTIONS(1014),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [anon_sym_RBRACK] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [anon_sym_COLON] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(1014),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_QMARK] = ACTIONS(1014),
    [anon_sym_u8] = ACTIONS(1016),
    [anon_sym_i8] = ACTIONS(1016),
    [anon_sym_u16] = ACTIONS(1016),
    [anon_sym_i16] = ACTIONS(1016),
    [anon_sym_u32] = ACTIONS(1016),
    [anon_sym_i32] = ACTIONS(1016),
    [anon_sym_u64] = ACTIONS(1016),
    [anon_sym_i64] = ACTIONS(1016),
    [anon_sym_u128] = ACTIONS(1016),
    [anon_sym_i128] = ACTIONS(1016),
    [anon_sym_isize] = ACTIONS(1016),
    [anon_sym_usize] = ACTIONS(1016),
    [anon_sym_f32] = ACTIONS(1016),
    [anon_sym_f64] = ACTIONS(1016),
    [anon_sym_bool] = ACTIONS(1016),
    [anon_sym_str] = ACTIONS(1016),
    [anon_sym_char] = ACTIONS(1016),
    [anon_sym_SLASH] = ACTIONS(1016),
    [anon_sym__] = ACTIONS(1016),
    [anon_sym_BSLASH] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_EQ] = ACTIONS(1014),
    [anon_sym_DASH_GT] = ACTIONS(1014),
    [anon_sym_COMMA] = ACTIONS(1014),
    [anon_sym_COLON_COLON] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_DOT] = ACTIONS(1014),
    [anon_sym_AT] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_POUND] = ACTIONS(1014),
    [anon_sym_PERCENT] = ACTIONS(1014),
    [anon_sym_CARET] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1014),
    [anon_sym_PIPE] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_await] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_fn] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_impl] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_loop] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_mod] = ACTIONS(1016),
    [anon_sym_pub] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_trait] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_unsafe] = ACTIONS(1016),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_where] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [sym_mutable_specifier] = ACTIONS(1016),
    [sym_integer_literal] = ACTIONS(1014),
    [aux_sym_string_literal_token1] = ACTIONS(1014),
    [sym_char_literal] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1016),
    [sym_super] = ACTIONS(1016),
    [sym_crate] = ACTIONS(1016),
    [sym_raw_string_literal] = ACTIONS(1014),
    [sym_float_literal] = ACTIONS(1014),
  },
  [451] = {
    [sym_line_comment] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym_identifier] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1500),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_RBRACE] = ACTIONS(1500),
    [anon_sym_COLON] = ACTIONS(1498),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1500),
    [anon_sym_u8] = ACTIONS(1498),
    [anon_sym_i8] = ACTIONS(1498),
    [anon_sym_u16] = ACTIONS(1498),
    [anon_sym_i16] = ACTIONS(1498),
    [anon_sym_u32] = ACTIONS(1498),
    [anon_sym_i32] = ACTIONS(1498),
    [anon_sym_u64] = ACTIONS(1498),
    [anon_sym_i64] = ACTIONS(1498),
    [anon_sym_u128] = ACTIONS(1498),
    [anon_sym_i128] = ACTIONS(1498),
    [anon_sym_isize] = ACTIONS(1498),
    [anon_sym_usize] = ACTIONS(1498),
    [anon_sym_f32] = ACTIONS(1498),
    [anon_sym_f64] = ACTIONS(1498),
    [anon_sym_bool] = ACTIONS(1498),
    [anon_sym_str] = ACTIONS(1498),
    [anon_sym_char] = ACTIONS(1498),
    [anon_sym_SLASH] = ACTIONS(1498),
    [anon_sym__] = ACTIONS(1498),
    [anon_sym_BSLASH] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_COMMA] = ACTIONS(1500),
    [anon_sym_COLON_COLON] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_DOT] = ACTIONS(1500),
    [anon_sym_AT] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_POUND] = ACTIONS(1500),
    [anon_sym_PERCENT] = ACTIONS(1500),
    [anon_sym_CARET] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_as] = ACTIONS(1498),
    [anon_sym_async] = ACTIONS(1498),
    [anon_sym_await] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_fn] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_impl] = ACTIONS(1498),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_loop] = ACTIONS(1498),
    [anon_sym_match] = ACTIONS(1498),
    [anon_sym_mod] = ACTIONS(1498),
    [anon_sym_pub] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_trait] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_unsafe] = ACTIONS(1498),
    [anon_sym_use] = ACTIONS(1498),
    [anon_sym_where] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [sym_mutable_specifier] = ACTIONS(1498),
    [sym_integer_literal] = ACTIONS(1500),
    [aux_sym_string_literal_token1] = ACTIONS(1500),
    [sym_char_literal] = ACTIONS(1500),
    [anon_sym_true] = ACTIONS(1498),
    [anon_sym_false] = ACTIONS(1498),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1498),
    [sym_super] = ACTIONS(1498),
    [sym_crate] = ACTIONS(1498),
    [sym_raw_string_literal] = ACTIONS(1500),
    [sym_float_literal] = ACTIONS(1500),
  },
  [452] = {
    [sym_line_comment] = STATE(452),
    [sym_block_comment] = STATE(452),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_RBRACK] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1454),
    [anon_sym_COLON] = ACTIONS(1452),
    [anon_sym_DOLLAR] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1454),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_BSLASH] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(1454),
    [anon_sym_DASH_GT] = ACTIONS(1454),
    [anon_sym_COMMA] = ACTIONS(1454),
    [anon_sym_COLON_COLON] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1454),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1454),
    [anon_sym_CARET] = ACTIONS(1454),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_fn] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_impl] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_loop] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_mod] = ACTIONS(1452),
    [anon_sym_pub] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_trait] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_unsafe] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_where] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [sym_mutable_specifier] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1454),
    [aux_sym_string_literal_token1] = ACTIONS(1454),
    [sym_char_literal] = ACTIONS(1454),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_raw_string_literal] = ACTIONS(1454),
    [sym_float_literal] = ACTIONS(1454),
  },
  [453] = {
    [sym_line_comment] = STATE(453),
    [sym_block_comment] = STATE(453),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_COLON] = ACTIONS(1462),
    [anon_sym_DOLLAR] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_QMARK] = ACTIONS(1464),
    [anon_sym_u8] = ACTIONS(1462),
    [anon_sym_i8] = ACTIONS(1462),
    [anon_sym_u16] = ACTIONS(1462),
    [anon_sym_i16] = ACTIONS(1462),
    [anon_sym_u32] = ACTIONS(1462),
    [anon_sym_i32] = ACTIONS(1462),
    [anon_sym_u64] = ACTIONS(1462),
    [anon_sym_i64] = ACTIONS(1462),
    [anon_sym_u128] = ACTIONS(1462),
    [anon_sym_i128] = ACTIONS(1462),
    [anon_sym_isize] = ACTIONS(1462),
    [anon_sym_usize] = ACTIONS(1462),
    [anon_sym_f32] = ACTIONS(1462),
    [anon_sym_f64] = ACTIONS(1462),
    [anon_sym_bool] = ACTIONS(1462),
    [anon_sym_str] = ACTIONS(1462),
    [anon_sym_char] = ACTIONS(1462),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym__] = ACTIONS(1462),
    [anon_sym_BSLASH] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_EQ] = ACTIONS(1464),
    [anon_sym_DASH_GT] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_COLON_COLON] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_AT] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_POUND] = ACTIONS(1464),
    [anon_sym_PERCENT] = ACTIONS(1464),
    [anon_sym_CARET] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1464),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_as] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_fn] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_impl] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_loop] = ACTIONS(1462),
    [anon_sym_match] = ACTIONS(1462),
    [anon_sym_mod] = ACTIONS(1462),
    [anon_sym_pub] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_trait] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_unsafe] = ACTIONS(1462),
    [anon_sym_use] = ACTIONS(1462),
    [anon_sym_where] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [sym_mutable_specifier] = ACTIONS(1462),
    [sym_integer_literal] = ACTIONS(1464),
    [aux_sym_string_literal_token1] = ACTIONS(1464),
    [sym_char_literal] = ACTIONS(1464),
    [anon_sym_true] = ACTIONS(1462),
    [anon_sym_false] = ACTIONS(1462),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_crate] = ACTIONS(1462),
    [sym_raw_string_literal] = ACTIONS(1464),
    [sym_float_literal] = ACTIONS(1464),
  },
  [454] = {
    [sym_line_comment] = STATE(454),
    [sym_block_comment] = STATE(454),
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1530),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_u8] = ACTIONS(1530),
    [anon_sym_i8] = ACTIONS(1530),
    [anon_sym_u16] = ACTIONS(1530),
    [anon_sym_i16] = ACTIONS(1530),
    [anon_sym_u32] = ACTIONS(1530),
    [anon_sym_i32] = ACTIONS(1530),
    [anon_sym_u64] = ACTIONS(1530),
    [anon_sym_i64] = ACTIONS(1530),
    [anon_sym_u128] = ACTIONS(1530),
    [anon_sym_i128] = ACTIONS(1530),
    [anon_sym_isize] = ACTIONS(1530),
    [anon_sym_usize] = ACTIONS(1530),
    [anon_sym_f32] = ACTIONS(1530),
    [anon_sym_f64] = ACTIONS(1530),
    [anon_sym_bool] = ACTIONS(1530),
    [anon_sym_str] = ACTIONS(1530),
    [anon_sym_char] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1530),
    [anon_sym__] = ACTIONS(1530),
    [anon_sym_BSLASH] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_DASH_GT] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_COLON_COLON] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_POUND] = ACTIONS(1532),
    [anon_sym_PERCENT] = ACTIONS(1532),
    [anon_sym_CARET] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1530),
    [anon_sym_as] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_await] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_fn] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_impl] = ACTIONS(1530),
    [anon_sym_let] = ACTIONS(1530),
    [anon_sym_loop] = ACTIONS(1530),
    [anon_sym_match] = ACTIONS(1530),
    [anon_sym_mod] = ACTIONS(1530),
    [anon_sym_pub] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_struct] = ACTIONS(1530),
    [anon_sym_trait] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_union] = ACTIONS(1530),
    [anon_sym_unsafe] = ACTIONS(1530),
    [anon_sym_use] = ACTIONS(1530),
    [anon_sym_where] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [sym_mutable_specifier] = ACTIONS(1530),
    [sym_integer_literal] = ACTIONS(1532),
    [aux_sym_string_literal_token1] = ACTIONS(1532),
    [sym_char_literal] = ACTIONS(1532),
    [anon_sym_true] = ACTIONS(1530),
    [anon_sym_false] = ACTIONS(1530),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1530),
    [sym_super] = ACTIONS(1530),
    [sym_crate] = ACTIONS(1530),
    [sym_raw_string_literal] = ACTIONS(1532),
    [sym_float_literal] = ACTIONS(1532),
  },
  [455] = {
    [sym_line_comment] = STATE(455),
    [sym_block_comment] = STATE(455),
    [sym_identifier] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1480),
    [anon_sym_RPAREN] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_RBRACK] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1480),
    [anon_sym_COLON] = ACTIONS(1478),
    [anon_sym_DOLLAR] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1480),
    [anon_sym_u8] = ACTIONS(1478),
    [anon_sym_i8] = ACTIONS(1478),
    [anon_sym_u16] = ACTIONS(1478),
    [anon_sym_i16] = ACTIONS(1478),
    [anon_sym_u32] = ACTIONS(1478),
    [anon_sym_i32] = ACTIONS(1478),
    [anon_sym_u64] = ACTIONS(1478),
    [anon_sym_i64] = ACTIONS(1478),
    [anon_sym_u128] = ACTIONS(1478),
    [anon_sym_i128] = ACTIONS(1478),
    [anon_sym_isize] = ACTIONS(1478),
    [anon_sym_usize] = ACTIONS(1478),
    [anon_sym_f32] = ACTIONS(1478),
    [anon_sym_f64] = ACTIONS(1478),
    [anon_sym_bool] = ACTIONS(1478),
    [anon_sym_str] = ACTIONS(1478),
    [anon_sym_char] = ACTIONS(1478),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym__] = ACTIONS(1478),
    [anon_sym_BSLASH] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_COMMA] = ACTIONS(1480),
    [anon_sym_COLON_COLON] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_DOT] = ACTIONS(1480),
    [anon_sym_AT] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_POUND] = ACTIONS(1480),
    [anon_sym_PERCENT] = ACTIONS(1480),
    [anon_sym_CARET] = ACTIONS(1480),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_as] = ACTIONS(1478),
    [anon_sym_async] = ACTIONS(1478),
    [anon_sym_await] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_fn] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_impl] = ACTIONS(1478),
    [anon_sym_let] = ACTIONS(1478),
    [anon_sym_loop] = ACTIONS(1478),
    [anon_sym_match] = ACTIONS(1478),
    [anon_sym_mod] = ACTIONS(1478),
    [anon_sym_pub] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_trait] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_unsafe] = ACTIONS(1478),
    [anon_sym_use] = ACTIONS(1478),
    [anon_sym_where] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [sym_mutable_specifier] = ACTIONS(1478),
    [sym_integer_literal] = ACTIONS(1480),
    [aux_sym_string_literal_token1] = ACTIONS(1480),
    [sym_char_literal] = ACTIONS(1480),
    [anon_sym_true] = ACTIONS(1478),
    [anon_sym_false] = ACTIONS(1478),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1478),
    [sym_super] = ACTIONS(1478),
    [sym_crate] = ACTIONS(1478),
    [sym_raw_string_literal] = ACTIONS(1480),
    [sym_float_literal] = ACTIONS(1480),
  },
  [456] = {
    [sym_line_comment] = STATE(456),
    [sym_block_comment] = STATE(456),
    [sym_identifier] = ACTIONS(914),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_RPAREN] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(912),
    [anon_sym_RBRACK] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_COLON] = ACTIONS(914),
    [anon_sym_DOLLAR] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_QMARK] = ACTIONS(912),
    [anon_sym_u8] = ACTIONS(914),
    [anon_sym_i8] = ACTIONS(914),
    [anon_sym_u16] = ACTIONS(914),
    [anon_sym_i16] = ACTIONS(914),
    [anon_sym_u32] = ACTIONS(914),
    [anon_sym_i32] = ACTIONS(914),
    [anon_sym_u64] = ACTIONS(914),
    [anon_sym_i64] = ACTIONS(914),
    [anon_sym_u128] = ACTIONS(914),
    [anon_sym_i128] = ACTIONS(914),
    [anon_sym_isize] = ACTIONS(914),
    [anon_sym_usize] = ACTIONS(914),
    [anon_sym_f32] = ACTIONS(914),
    [anon_sym_f64] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_str] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym__] = ACTIONS(914),
    [anon_sym_BSLASH] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_EQ] = ACTIONS(912),
    [anon_sym_DASH_GT] = ACTIONS(912),
    [anon_sym_COMMA] = ACTIONS(912),
    [anon_sym_COLON_COLON] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_POUND] = ACTIONS(912),
    [anon_sym_PERCENT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_LT] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(912),
    [anon_sym_PIPE] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_async] = ACTIONS(914),
    [anon_sym_await] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_fn] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_impl] = ACTIONS(914),
    [anon_sym_let] = ACTIONS(914),
    [anon_sym_loop] = ACTIONS(914),
    [anon_sym_match] = ACTIONS(914),
    [anon_sym_mod] = ACTIONS(914),
    [anon_sym_pub] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_trait] = ACTIONS(914),
    [anon_sym_type] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_unsafe] = ACTIONS(914),
    [anon_sym_use] = ACTIONS(914),
    [anon_sym_where] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [sym_mutable_specifier] = ACTIONS(914),
    [sym_integer_literal] = ACTIONS(912),
    [aux_sym_string_literal_token1] = ACTIONS(912),
    [sym_char_literal] = ACTIONS(912),
    [anon_sym_true] = ACTIONS(914),
    [anon_sym_false] = ACTIONS(914),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(914),
    [sym_super] = ACTIONS(914),
    [sym_crate] = ACTIONS(914),
    [sym_raw_string_literal] = ACTIONS(912),
    [sym_float_literal] = ACTIONS(912),
  },
  [457] = {
    [sym_line_comment] = STATE(457),
    [sym_block_comment] = STATE(457),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_COLON] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1536),
    [anon_sym_STAR] = ACTIONS(1536),
    [anon_sym_QMARK] = ACTIONS(1536),
    [anon_sym_u8] = ACTIONS(1534),
    [anon_sym_i8] = ACTIONS(1534),
    [anon_sym_u16] = ACTIONS(1534),
    [anon_sym_i16] = ACTIONS(1534),
    [anon_sym_u32] = ACTIONS(1534),
    [anon_sym_i32] = ACTIONS(1534),
    [anon_sym_u64] = ACTIONS(1534),
    [anon_sym_i64] = ACTIONS(1534),
    [anon_sym_u128] = ACTIONS(1534),
    [anon_sym_i128] = ACTIONS(1534),
    [anon_sym_isize] = ACTIONS(1534),
    [anon_sym_usize] = ACTIONS(1534),
    [anon_sym_f32] = ACTIONS(1534),
    [anon_sym_f64] = ACTIONS(1534),
    [anon_sym_bool] = ACTIONS(1534),
    [anon_sym_str] = ACTIONS(1534),
    [anon_sym_char] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(1534),
    [anon_sym__] = ACTIONS(1534),
    [anon_sym_BSLASH] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_EQ] = ACTIONS(1536),
    [anon_sym_DASH_GT] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_COLON_COLON] = ACTIONS(1536),
    [anon_sym_BANG] = ACTIONS(1536),
    [anon_sym_DOT] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_POUND] = ACTIONS(1536),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1536),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(1534),
    [anon_sym_as] = ACTIONS(1534),
    [anon_sym_async] = ACTIONS(1534),
    [anon_sym_await] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1534),
    [anon_sym_const] = ACTIONS(1534),
    [anon_sym_continue] = ACTIONS(1534),
    [anon_sym_default] = ACTIONS(1534),
    [anon_sym_enum] = ACTIONS(1534),
    [anon_sym_fn] = ACTIONS(1534),
    [anon_sym_for] = ACTIONS(1534),
    [anon_sym_if] = ACTIONS(1534),
    [anon_sym_impl] = ACTIONS(1534),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_loop] = ACTIONS(1534),
    [anon_sym_match] = ACTIONS(1534),
    [anon_sym_mod] = ACTIONS(1534),
    [anon_sym_pub] = ACTIONS(1534),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_struct] = ACTIONS(1534),
    [anon_sym_trait] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_union] = ACTIONS(1534),
    [anon_sym_unsafe] = ACTIONS(1534),
    [anon_sym_use] = ACTIONS(1534),
    [anon_sym_where] = ACTIONS(1534),
    [anon_sym_while] = ACTIONS(1534),
    [sym_mutable_specifier] = ACTIONS(1534),
    [sym_integer_literal] = ACTIONS(1536),
    [aux_sym_string_literal_token1] = ACTIONS(1536),
    [sym_char_literal] = ACTIONS(1536),
    [anon_sym_true] = ACTIONS(1534),
    [anon_sym_false] = ACTIONS(1534),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1534),
    [sym_super] = ACTIONS(1534),
    [sym_crate] = ACTIONS(1534),
    [sym_raw_string_literal] = ACTIONS(1536),
    [sym_float_literal] = ACTIONS(1536),
  },
  [458] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2046),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_u8] = ACTIONS(1538),
    [anon_sym_i8] = ACTIONS(1538),
    [anon_sym_u16] = ACTIONS(1538),
    [anon_sym_i16] = ACTIONS(1538),
    [anon_sym_u32] = ACTIONS(1538),
    [anon_sym_i32] = ACTIONS(1538),
    [anon_sym_u64] = ACTIONS(1538),
    [anon_sym_i64] = ACTIONS(1538),
    [anon_sym_u128] = ACTIONS(1538),
    [anon_sym_i128] = ACTIONS(1538),
    [anon_sym_isize] = ACTIONS(1538),
    [anon_sym_usize] = ACTIONS(1538),
    [anon_sym_f32] = ACTIONS(1538),
    [anon_sym_f64] = ACTIONS(1538),
    [anon_sym_bool] = ACTIONS(1538),
    [anon_sym_str] = ACTIONS(1538),
    [anon_sym_char] = ACTIONS(1538),
    [anon_sym__] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [anon_sym_COLON_COLON] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1538),
    [anon_sym_async] = ACTIONS(1538),
    [anon_sym_break] = ACTIONS(1538),
    [anon_sym_const] = ACTIONS(1538),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_default] = ACTIONS(1538),
    [anon_sym_for] = ACTIONS(1538),
    [anon_sym_if] = ACTIONS(1538),
    [anon_sym_loop] = ACTIONS(1538),
    [anon_sym_match] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1538),
    [anon_sym_static] = ACTIONS(1538),
    [anon_sym_union] = ACTIONS(1538),
    [anon_sym_unsafe] = ACTIONS(1538),
    [anon_sym_while] = ACTIONS(1538),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1540),
    [anon_sym_yield] = ACTIONS(1538),
    [anon_sym_move] = ACTIONS(1538),
    [anon_sym_try] = ACTIONS(1538),
    [sym_integer_literal] = ACTIONS(1540),
    [aux_sym_string_literal_token1] = ACTIONS(1540),
    [sym_char_literal] = ACTIONS(1540),
    [anon_sym_true] = ACTIONS(1538),
    [anon_sym_false] = ACTIONS(1538),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1538),
    [sym_super] = ACTIONS(1538),
    [sym_crate] = ACTIONS(1538),
    [sym_metavariable] = ACTIONS(1540),
    [sym_raw_string_literal] = ACTIONS(1540),
    [sym_float_literal] = ACTIONS(1540),
  },
  [459] = {
    [sym_else_clause] = STATE(478),
    [sym_line_comment] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym_identifier] = ACTIONS(742),
    [anon_sym_LPAREN] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(740),
    [anon_sym_u8] = ACTIONS(742),
    [anon_sym_i8] = ACTIONS(742),
    [anon_sym_u16] = ACTIONS(742),
    [anon_sym_i16] = ACTIONS(742),
    [anon_sym_u32] = ACTIONS(742),
    [anon_sym_i32] = ACTIONS(742),
    [anon_sym_u64] = ACTIONS(742),
    [anon_sym_i64] = ACTIONS(742),
    [anon_sym_u128] = ACTIONS(742),
    [anon_sym_i128] = ACTIONS(742),
    [anon_sym_isize] = ACTIONS(742),
    [anon_sym_usize] = ACTIONS(742),
    [anon_sym_f32] = ACTIONS(742),
    [anon_sym_f64] = ACTIONS(742),
    [anon_sym_bool] = ACTIONS(742),
    [anon_sym_str] = ACTIONS(742),
    [anon_sym_char] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym__] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_COLON_COLON] = ACTIONS(740),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_POUND] = ACTIONS(740),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_as] = ACTIONS(742),
    [anon_sym_const] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_static] = ACTIONS(742),
    [anon_sym_union] = ACTIONS(742),
    [anon_sym_ref] = ACTIONS(742),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(740),
    [sym_mutable_specifier] = ACTIONS(742),
    [anon_sym_DOT_DOT] = ACTIONS(742),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(740),
    [anon_sym_AMP_AMP] = ACTIONS(740),
    [anon_sym_PIPE_PIPE] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(740),
    [anon_sym_BANG_EQ] = ACTIONS(740),
    [anon_sym_LT_EQ] = ACTIONS(740),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_PLUS_EQ] = ACTIONS(740),
    [anon_sym_DASH_EQ] = ACTIONS(740),
    [anon_sym_STAR_EQ] = ACTIONS(740),
    [anon_sym_SLASH_EQ] = ACTIONS(740),
    [anon_sym_PERCENT_EQ] = ACTIONS(740),
    [anon_sym_AMP_EQ] = ACTIONS(740),
    [anon_sym_PIPE_EQ] = ACTIONS(740),
    [anon_sym_CARET_EQ] = ACTIONS(740),
    [anon_sym_LT_LT_EQ] = ACTIONS(740),
    [anon_sym_GT_GT_EQ] = ACTIONS(740),
    [anon_sym_move] = ACTIONS(742),
    [sym_integer_literal] = ACTIONS(740),
    [aux_sym_string_literal_token1] = ACTIONS(740),
    [sym_char_literal] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(742),
    [anon_sym_false] = ACTIONS(742),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(742),
    [sym_super] = ACTIONS(742),
    [sym_crate] = ACTIONS(742),
    [sym_metavariable] = ACTIONS(740),
    [sym_raw_string_literal] = ACTIONS(740),
    [sym_float_literal] = ACTIONS(740),
  },
  [460] = {
    [sym_line_comment] = STATE(460),
    [sym_block_comment] = STATE(460),
    [sym_identifier] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_STAR] = ACTIONS(884),
    [anon_sym_QMARK] = ACTIONS(882),
    [anon_sym_u8] = ACTIONS(884),
    [anon_sym_i8] = ACTIONS(884),
    [anon_sym_u16] = ACTIONS(884),
    [anon_sym_i16] = ACTIONS(884),
    [anon_sym_u32] = ACTIONS(884),
    [anon_sym_i32] = ACTIONS(884),
    [anon_sym_u64] = ACTIONS(884),
    [anon_sym_i64] = ACTIONS(884),
    [anon_sym_u128] = ACTIONS(884),
    [anon_sym_i128] = ACTIONS(884),
    [anon_sym_isize] = ACTIONS(884),
    [anon_sym_usize] = ACTIONS(884),
    [anon_sym_f32] = ACTIONS(884),
    [anon_sym_f64] = ACTIONS(884),
    [anon_sym_bool] = ACTIONS(884),
    [anon_sym_str] = ACTIONS(884),
    [anon_sym_char] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(884),
    [anon_sym__] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_EQ] = ACTIONS(884),
    [anon_sym_COMMA] = ACTIONS(882),
    [anon_sym_COLON_COLON] = ACTIONS(882),
    [anon_sym_DOT] = ACTIONS(884),
    [anon_sym_AMP] = ACTIONS(884),
    [anon_sym_POUND] = ACTIONS(882),
    [anon_sym_PERCENT] = ACTIONS(884),
    [anon_sym_CARET] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_PIPE] = ACTIONS(884),
    [anon_sym_as] = ACTIONS(884),
    [anon_sym_const] = ACTIONS(884),
    [anon_sym_default] = ACTIONS(884),
    [anon_sym_static] = ACTIONS(884),
    [anon_sym_union] = ACTIONS(884),
    [anon_sym_ref] = ACTIONS(884),
    [anon_sym_else] = ACTIONS(884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(882),
    [sym_mutable_specifier] = ACTIONS(884),
    [anon_sym_DOT_DOT] = ACTIONS(884),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(882),
    [anon_sym_AMP_AMP] = ACTIONS(882),
    [anon_sym_PIPE_PIPE] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG_EQ] = ACTIONS(882),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_LT_LT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(884),
    [anon_sym_PLUS_EQ] = ACTIONS(882),
    [anon_sym_DASH_EQ] = ACTIONS(882),
    [anon_sym_STAR_EQ] = ACTIONS(882),
    [anon_sym_SLASH_EQ] = ACTIONS(882),
    [anon_sym_PERCENT_EQ] = ACTIONS(882),
    [anon_sym_AMP_EQ] = ACTIONS(882),
    [anon_sym_PIPE_EQ] = ACTIONS(882),
    [anon_sym_CARET_EQ] = ACTIONS(882),
    [anon_sym_LT_LT_EQ] = ACTIONS(882),
    [anon_sym_GT_GT_EQ] = ACTIONS(882),
    [anon_sym_move] = ACTIONS(884),
    [sym_integer_literal] = ACTIONS(882),
    [aux_sym_string_literal_token1] = ACTIONS(882),
    [sym_char_literal] = ACTIONS(882),
    [anon_sym_true] = ACTIONS(884),
    [anon_sym_false] = ACTIONS(884),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(884),
    [sym_super] = ACTIONS(884),
    [sym_crate] = ACTIONS(884),
    [sym_metavariable] = ACTIONS(882),
    [sym_raw_string_literal] = ACTIONS(882),
    [sym_float_literal] = ACTIONS(882),
  },
  [461] = {
    [sym_line_comment] = STATE(461),
    [sym_block_comment] = STATE(461),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_LBRACK] = ACTIONS(870),
    [anon_sym_RBRACE] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(872),
    [anon_sym_STAR] = ACTIONS(872),
    [anon_sym_QMARK] = ACTIONS(870),
    [anon_sym_u8] = ACTIONS(872),
    [anon_sym_i8] = ACTIONS(872),
    [anon_sym_u16] = ACTIONS(872),
    [anon_sym_i16] = ACTIONS(872),
    [anon_sym_u32] = ACTIONS(872),
    [anon_sym_i32] = ACTIONS(872),
    [anon_sym_u64] = ACTIONS(872),
    [anon_sym_i64] = ACTIONS(872),
    [anon_sym_u128] = ACTIONS(872),
    [anon_sym_i128] = ACTIONS(872),
    [anon_sym_isize] = ACTIONS(872),
    [anon_sym_usize] = ACTIONS(872),
    [anon_sym_f32] = ACTIONS(872),
    [anon_sym_f64] = ACTIONS(872),
    [anon_sym_bool] = ACTIONS(872),
    [anon_sym_str] = ACTIONS(872),
    [anon_sym_char] = ACTIONS(872),
    [anon_sym_SLASH] = ACTIONS(872),
    [anon_sym__] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(872),
    [anon_sym_EQ] = ACTIONS(872),
    [anon_sym_COMMA] = ACTIONS(870),
    [anon_sym_COLON_COLON] = ACTIONS(870),
    [anon_sym_DOT] = ACTIONS(872),
    [anon_sym_AMP] = ACTIONS(872),
    [anon_sym_POUND] = ACTIONS(870),
    [anon_sym_PERCENT] = ACTIONS(872),
    [anon_sym_CARET] = ACTIONS(872),
    [anon_sym_LT] = ACTIONS(872),
    [anon_sym_GT] = ACTIONS(872),
    [anon_sym_PIPE] = ACTIONS(872),
    [anon_sym_as] = ACTIONS(872),
    [anon_sym_const] = ACTIONS(872),
    [anon_sym_default] = ACTIONS(872),
    [anon_sym_static] = ACTIONS(872),
    [anon_sym_union] = ACTIONS(872),
    [anon_sym_ref] = ACTIONS(872),
    [anon_sym_else] = ACTIONS(872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(870),
    [sym_mutable_specifier] = ACTIONS(872),
    [anon_sym_DOT_DOT] = ACTIONS(872),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(870),
    [anon_sym_AMP_AMP] = ACTIONS(870),
    [anon_sym_PIPE_PIPE] = ACTIONS(870),
    [anon_sym_EQ_EQ] = ACTIONS(870),
    [anon_sym_BANG_EQ] = ACTIONS(870),
    [anon_sym_LT_EQ] = ACTIONS(870),
    [anon_sym_GT_EQ] = ACTIONS(870),
    [anon_sym_LT_LT] = ACTIONS(872),
    [anon_sym_GT_GT] = ACTIONS(872),
    [anon_sym_PLUS_EQ] = ACTIONS(870),
    [anon_sym_DASH_EQ] = ACTIONS(870),
    [anon_sym_STAR_EQ] = ACTIONS(870),
    [anon_sym_SLASH_EQ] = ACTIONS(870),
    [anon_sym_PERCENT_EQ] = ACTIONS(870),
    [anon_sym_AMP_EQ] = ACTIONS(870),
    [anon_sym_PIPE_EQ] = ACTIONS(870),
    [anon_sym_CARET_EQ] = ACTIONS(870),
    [anon_sym_LT_LT_EQ] = ACTIONS(870),
    [anon_sym_GT_GT_EQ] = ACTIONS(870),
    [anon_sym_move] = ACTIONS(872),
    [sym_integer_literal] = ACTIONS(870),
    [aux_sym_string_literal_token1] = ACTIONS(870),
    [sym_char_literal] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(872),
    [anon_sym_false] = ACTIONS(872),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(872),
    [sym_super] = ACTIONS(872),
    [sym_crate] = ACTIONS(872),
    [sym_metavariable] = ACTIONS(870),
    [sym_raw_string_literal] = ACTIONS(870),
    [sym_float_literal] = ACTIONS(870),
  },
  [462] = {
    [sym_line_comment] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_LPAREN] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_QMARK] = ACTIONS(890),
    [anon_sym_u8] = ACTIONS(892),
    [anon_sym_i8] = ACTIONS(892),
    [anon_sym_u16] = ACTIONS(892),
    [anon_sym_i16] = ACTIONS(892),
    [anon_sym_u32] = ACTIONS(892),
    [anon_sym_i32] = ACTIONS(892),
    [anon_sym_u64] = ACTIONS(892),
    [anon_sym_i64] = ACTIONS(892),
    [anon_sym_u128] = ACTIONS(892),
    [anon_sym_i128] = ACTIONS(892),
    [anon_sym_isize] = ACTIONS(892),
    [anon_sym_usize] = ACTIONS(892),
    [anon_sym_f32] = ACTIONS(892),
    [anon_sym_f64] = ACTIONS(892),
    [anon_sym_bool] = ACTIONS(892),
    [anon_sym_str] = ACTIONS(892),
    [anon_sym_char] = ACTIONS(892),
    [anon_sym_SLASH] = ACTIONS(892),
    [anon_sym__] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(892),
    [anon_sym_COMMA] = ACTIONS(890),
    [anon_sym_COLON_COLON] = ACTIONS(890),
    [anon_sym_DOT] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(892),
    [anon_sym_POUND] = ACTIONS(890),
    [anon_sym_PERCENT] = ACTIONS(892),
    [anon_sym_CARET] = ACTIONS(892),
    [anon_sym_LT] = ACTIONS(892),
    [anon_sym_GT] = ACTIONS(892),
    [anon_sym_PIPE] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(892),
    [anon_sym_const] = ACTIONS(892),
    [anon_sym_default] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_union] = ACTIONS(892),
    [anon_sym_ref] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(890),
    [sym_mutable_specifier] = ACTIONS(892),
    [anon_sym_DOT_DOT] = ACTIONS(892),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(890),
    [anon_sym_AMP_AMP] = ACTIONS(890),
    [anon_sym_PIPE_PIPE] = ACTIONS(890),
    [anon_sym_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG_EQ] = ACTIONS(890),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_LT_LT] = ACTIONS(892),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_EQ] = ACTIONS(890),
    [anon_sym_DASH_EQ] = ACTIONS(890),
    [anon_sym_STAR_EQ] = ACTIONS(890),
    [anon_sym_SLASH_EQ] = ACTIONS(890),
    [anon_sym_PERCENT_EQ] = ACTIONS(890),
    [anon_sym_AMP_EQ] = ACTIONS(890),
    [anon_sym_PIPE_EQ] = ACTIONS(890),
    [anon_sym_CARET_EQ] = ACTIONS(890),
    [anon_sym_LT_LT_EQ] = ACTIONS(890),
    [anon_sym_GT_GT_EQ] = ACTIONS(890),
    [anon_sym_move] = ACTIONS(892),
    [sym_integer_literal] = ACTIONS(890),
    [aux_sym_string_literal_token1] = ACTIONS(890),
    [sym_char_literal] = ACTIONS(890),
    [anon_sym_true] = ACTIONS(892),
    [anon_sym_false] = ACTIONS(892),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(892),
    [sym_super] = ACTIONS(892),
    [sym_crate] = ACTIONS(892),
    [sym_metavariable] = ACTIONS(890),
    [sym_raw_string_literal] = ACTIONS(890),
    [sym_float_literal] = ACTIONS(890),
  },
  [463] = {
    [sym_line_comment] = STATE(463),
    [sym_block_comment] = STATE(463),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(886),
    [anon_sym_u8] = ACTIONS(888),
    [anon_sym_i8] = ACTIONS(888),
    [anon_sym_u16] = ACTIONS(888),
    [anon_sym_i16] = ACTIONS(888),
    [anon_sym_u32] = ACTIONS(888),
    [anon_sym_i32] = ACTIONS(888),
    [anon_sym_u64] = ACTIONS(888),
    [anon_sym_i64] = ACTIONS(888),
    [anon_sym_u128] = ACTIONS(888),
    [anon_sym_i128] = ACTIONS(888),
    [anon_sym_isize] = ACTIONS(888),
    [anon_sym_usize] = ACTIONS(888),
    [anon_sym_f32] = ACTIONS(888),
    [anon_sym_f64] = ACTIONS(888),
    [anon_sym_bool] = ACTIONS(888),
    [anon_sym_str] = ACTIONS(888),
    [anon_sym_char] = ACTIONS(888),
    [anon_sym_SLASH] = ACTIONS(888),
    [anon_sym__] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_COLON_COLON] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(888),
    [anon_sym_AMP] = ACTIONS(888),
    [anon_sym_POUND] = ACTIONS(886),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_CARET] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_PIPE] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(888),
    [anon_sym_const] = ACTIONS(888),
    [anon_sym_default] = ACTIONS(888),
    [anon_sym_static] = ACTIONS(888),
    [anon_sym_union] = ACTIONS(888),
    [anon_sym_ref] = ACTIONS(888),
    [anon_sym_else] = ACTIONS(888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(886),
    [sym_mutable_specifier] = ACTIONS(888),
    [anon_sym_DOT_DOT] = ACTIONS(888),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(886),
    [anon_sym_AMP_AMP] = ACTIONS(886),
    [anon_sym_PIPE_PIPE] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(886),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(886),
    [anon_sym_DASH_EQ] = ACTIONS(886),
    [anon_sym_STAR_EQ] = ACTIONS(886),
    [anon_sym_SLASH_EQ] = ACTIONS(886),
    [anon_sym_PERCENT_EQ] = ACTIONS(886),
    [anon_sym_AMP_EQ] = ACTIONS(886),
    [anon_sym_PIPE_EQ] = ACTIONS(886),
    [anon_sym_CARET_EQ] = ACTIONS(886),
    [anon_sym_LT_LT_EQ] = ACTIONS(886),
    [anon_sym_GT_GT_EQ] = ACTIONS(886),
    [anon_sym_move] = ACTIONS(888),
    [sym_integer_literal] = ACTIONS(886),
    [aux_sym_string_literal_token1] = ACTIONS(886),
    [sym_char_literal] = ACTIONS(886),
    [anon_sym_true] = ACTIONS(888),
    [anon_sym_false] = ACTIONS(888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(888),
    [sym_super] = ACTIONS(888),
    [sym_crate] = ACTIONS(888),
    [sym_metavariable] = ACTIONS(886),
    [sym_raw_string_literal] = ACTIONS(886),
    [sym_float_literal] = ACTIONS(886),
  },
  [464] = {
    [sym_line_comment] = STATE(464),
    [sym_block_comment] = STATE(464),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_RBRACE] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(896),
    [anon_sym_STAR] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(894),
    [anon_sym_u8] = ACTIONS(896),
    [anon_sym_i8] = ACTIONS(896),
    [anon_sym_u16] = ACTIONS(896),
    [anon_sym_i16] = ACTIONS(896),
    [anon_sym_u32] = ACTIONS(896),
    [anon_sym_i32] = ACTIONS(896),
    [anon_sym_u64] = ACTIONS(896),
    [anon_sym_i64] = ACTIONS(896),
    [anon_sym_u128] = ACTIONS(896),
    [anon_sym_i128] = ACTIONS(896),
    [anon_sym_isize] = ACTIONS(896),
    [anon_sym_usize] = ACTIONS(896),
    [anon_sym_f32] = ACTIONS(896),
    [anon_sym_f64] = ACTIONS(896),
    [anon_sym_bool] = ACTIONS(896),
    [anon_sym_str] = ACTIONS(896),
    [anon_sym_char] = ACTIONS(896),
    [anon_sym_SLASH] = ACTIONS(896),
    [anon_sym__] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(896),
    [anon_sym_EQ] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(894),
    [anon_sym_DOT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(896),
    [anon_sym_POUND] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_CARET] = ACTIONS(896),
    [anon_sym_LT] = ACTIONS(896),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(896),
    [anon_sym_const] = ACTIONS(896),
    [anon_sym_default] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(896),
    [anon_sym_union] = ACTIONS(896),
    [anon_sym_ref] = ACTIONS(896),
    [anon_sym_else] = ACTIONS(896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(894),
    [sym_mutable_specifier] = ACTIONS(896),
    [anon_sym_DOT_DOT] = ACTIONS(896),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_GT_GT] = ACTIONS(896),
    [anon_sym_PLUS_EQ] = ACTIONS(894),
    [anon_sym_DASH_EQ] = ACTIONS(894),
    [anon_sym_STAR_EQ] = ACTIONS(894),
    [anon_sym_SLASH_EQ] = ACTIONS(894),
    [anon_sym_PERCENT_EQ] = ACTIONS(894),
    [anon_sym_AMP_EQ] = ACTIONS(894),
    [anon_sym_PIPE_EQ] = ACTIONS(894),
    [anon_sym_CARET_EQ] = ACTIONS(894),
    [anon_sym_LT_LT_EQ] = ACTIONS(894),
    [anon_sym_GT_GT_EQ] = ACTIONS(894),
    [anon_sym_move] = ACTIONS(896),
    [sym_integer_literal] = ACTIONS(894),
    [aux_sym_string_literal_token1] = ACTIONS(894),
    [sym_char_literal] = ACTIONS(894),
    [anon_sym_true] = ACTIONS(896),
    [anon_sym_false] = ACTIONS(896),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(896),
    [sym_super] = ACTIONS(896),
    [sym_crate] = ACTIONS(896),
    [sym_metavariable] = ACTIONS(894),
    [sym_raw_string_literal] = ACTIONS(894),
    [sym_float_literal] = ACTIONS(894),
  },
  [465] = {
    [sym_line_comment] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym_identifier] = ACTIONS(962),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_QMARK] = ACTIONS(960),
    [anon_sym_u8] = ACTIONS(962),
    [anon_sym_i8] = ACTIONS(962),
    [anon_sym_u16] = ACTIONS(962),
    [anon_sym_i16] = ACTIONS(962),
    [anon_sym_u32] = ACTIONS(962),
    [anon_sym_i32] = ACTIONS(962),
    [anon_sym_u64] = ACTIONS(962),
    [anon_sym_i64] = ACTIONS(962),
    [anon_sym_u128] = ACTIONS(962),
    [anon_sym_i128] = ACTIONS(962),
    [anon_sym_isize] = ACTIONS(962),
    [anon_sym_usize] = ACTIONS(962),
    [anon_sym_f32] = ACTIONS(962),
    [anon_sym_f64] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_str] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym__] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_EQ] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(960),
    [anon_sym_COLON_COLON] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_POUND] = ACTIONS(960),
    [anon_sym_PERCENT] = ACTIONS(962),
    [anon_sym_CARET] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(962),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_as] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_union] = ACTIONS(962),
    [anon_sym_ref] = ACTIONS(962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(960),
    [sym_mutable_specifier] = ACTIONS(962),
    [anon_sym_DOT_DOT] = ACTIONS(962),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_EQ_EQ] = ACTIONS(960),
    [anon_sym_BANG_EQ] = ACTIONS(960),
    [anon_sym_LT_EQ] = ACTIONS(960),
    [anon_sym_GT_EQ] = ACTIONS(960),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(962),
    [anon_sym_PLUS_EQ] = ACTIONS(960),
    [anon_sym_DASH_EQ] = ACTIONS(960),
    [anon_sym_STAR_EQ] = ACTIONS(960),
    [anon_sym_SLASH_EQ] = ACTIONS(960),
    [anon_sym_PERCENT_EQ] = ACTIONS(960),
    [anon_sym_AMP_EQ] = ACTIONS(960),
    [anon_sym_PIPE_EQ] = ACTIONS(960),
    [anon_sym_CARET_EQ] = ACTIONS(960),
    [anon_sym_LT_LT_EQ] = ACTIONS(960),
    [anon_sym_GT_GT_EQ] = ACTIONS(960),
    [anon_sym_move] = ACTIONS(962),
    [sym_integer_literal] = ACTIONS(960),
    [aux_sym_string_literal_token1] = ACTIONS(960),
    [sym_char_literal] = ACTIONS(960),
    [anon_sym_true] = ACTIONS(962),
    [anon_sym_false] = ACTIONS(962),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(962),
    [sym_super] = ACTIONS(962),
    [sym_crate] = ACTIONS(962),
    [sym_metavariable] = ACTIONS(960),
    [sym_raw_string_literal] = ACTIONS(960),
    [sym_float_literal] = ACTIONS(960),
  },
  [466] = {
    [sym_line_comment] = STATE(466),
    [sym_block_comment] = STATE(466),
    [sym_identifier] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(906),
    [anon_sym_QMARK] = ACTIONS(904),
    [anon_sym_u8] = ACTIONS(906),
    [anon_sym_i8] = ACTIONS(906),
    [anon_sym_u16] = ACTIONS(906),
    [anon_sym_i16] = ACTIONS(906),
    [anon_sym_u32] = ACTIONS(906),
    [anon_sym_i32] = ACTIONS(906),
    [anon_sym_u64] = ACTIONS(906),
    [anon_sym_i64] = ACTIONS(906),
    [anon_sym_u128] = ACTIONS(906),
    [anon_sym_i128] = ACTIONS(906),
    [anon_sym_isize] = ACTIONS(906),
    [anon_sym_usize] = ACTIONS(906),
    [anon_sym_f32] = ACTIONS(906),
    [anon_sym_f64] = ACTIONS(906),
    [anon_sym_bool] = ACTIONS(906),
    [anon_sym_str] = ACTIONS(906),
    [anon_sym_char] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(906),
    [anon_sym__] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_EQ] = ACTIONS(906),
    [anon_sym_COMMA] = ACTIONS(904),
    [anon_sym_COLON_COLON] = ACTIONS(904),
    [anon_sym_DOT] = ACTIONS(906),
    [anon_sym_AMP] = ACTIONS(906),
    [anon_sym_POUND] = ACTIONS(904),
    [anon_sym_PERCENT] = ACTIONS(906),
    [anon_sym_CARET] = ACTIONS(906),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_PIPE] = ACTIONS(906),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_union] = ACTIONS(906),
    [anon_sym_ref] = ACTIONS(906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(904),
    [sym_mutable_specifier] = ACTIONS(906),
    [anon_sym_DOT_DOT] = ACTIONS(906),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(904),
    [anon_sym_AMP_AMP] = ACTIONS(904),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(904),
    [anon_sym_LT_LT] = ACTIONS(906),
    [anon_sym_GT_GT] = ACTIONS(906),
    [anon_sym_PLUS_EQ] = ACTIONS(904),
    [anon_sym_DASH_EQ] = ACTIONS(904),
    [anon_sym_STAR_EQ] = ACTIONS(904),
    [anon_sym_SLASH_EQ] = ACTIONS(904),
    [anon_sym_PERCENT_EQ] = ACTIONS(904),
    [anon_sym_AMP_EQ] = ACTIONS(904),
    [anon_sym_PIPE_EQ] = ACTIONS(904),
    [anon_sym_CARET_EQ] = ACTIONS(904),
    [anon_sym_LT_LT_EQ] = ACTIONS(904),
    [anon_sym_GT_GT_EQ] = ACTIONS(904),
    [anon_sym_move] = ACTIONS(906),
    [sym_integer_literal] = ACTIONS(904),
    [aux_sym_string_literal_token1] = ACTIONS(904),
    [sym_char_literal] = ACTIONS(904),
    [anon_sym_true] = ACTIONS(906),
    [anon_sym_false] = ACTIONS(906),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(906),
    [sym_super] = ACTIONS(906),
    [sym_crate] = ACTIONS(906),
    [sym_metavariable] = ACTIONS(904),
    [sym_raw_string_literal] = ACTIONS(904),
    [sym_float_literal] = ACTIONS(904),
  },
  [467] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3336),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(467),
    [sym_block_comment] = STATE(467),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [468] = {
    [sym_line_comment] = STATE(468),
    [sym_block_comment] = STATE(468),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_LPAREN] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(976),
    [anon_sym_QMARK] = ACTIONS(974),
    [anon_sym_u8] = ACTIONS(976),
    [anon_sym_i8] = ACTIONS(976),
    [anon_sym_u16] = ACTIONS(976),
    [anon_sym_i16] = ACTIONS(976),
    [anon_sym_u32] = ACTIONS(976),
    [anon_sym_i32] = ACTIONS(976),
    [anon_sym_u64] = ACTIONS(976),
    [anon_sym_i64] = ACTIONS(976),
    [anon_sym_u128] = ACTIONS(976),
    [anon_sym_i128] = ACTIONS(976),
    [anon_sym_isize] = ACTIONS(976),
    [anon_sym_usize] = ACTIONS(976),
    [anon_sym_f32] = ACTIONS(976),
    [anon_sym_f64] = ACTIONS(976),
    [anon_sym_bool] = ACTIONS(976),
    [anon_sym_str] = ACTIONS(976),
    [anon_sym_char] = ACTIONS(976),
    [anon_sym_SLASH] = ACTIONS(976),
    [anon_sym__] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_EQ] = ACTIONS(976),
    [anon_sym_COMMA] = ACTIONS(974),
    [anon_sym_COLON_COLON] = ACTIONS(974),
    [anon_sym_DOT] = ACTIONS(976),
    [anon_sym_AMP] = ACTIONS(976),
    [anon_sym_POUND] = ACTIONS(974),
    [anon_sym_PERCENT] = ACTIONS(976),
    [anon_sym_CARET] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(976),
    [anon_sym_GT] = ACTIONS(976),
    [anon_sym_PIPE] = ACTIONS(976),
    [anon_sym_as] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_ref] = ACTIONS(976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(974),
    [sym_mutable_specifier] = ACTIONS(976),
    [anon_sym_DOT_DOT] = ACTIONS(976),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_EQ_EQ] = ACTIONS(974),
    [anon_sym_BANG_EQ] = ACTIONS(974),
    [anon_sym_LT_EQ] = ACTIONS(974),
    [anon_sym_GT_EQ] = ACTIONS(974),
    [anon_sym_LT_LT] = ACTIONS(976),
    [anon_sym_GT_GT] = ACTIONS(976),
    [anon_sym_PLUS_EQ] = ACTIONS(974),
    [anon_sym_DASH_EQ] = ACTIONS(974),
    [anon_sym_STAR_EQ] = ACTIONS(974),
    [anon_sym_SLASH_EQ] = ACTIONS(974),
    [anon_sym_PERCENT_EQ] = ACTIONS(974),
    [anon_sym_AMP_EQ] = ACTIONS(974),
    [anon_sym_PIPE_EQ] = ACTIONS(974),
    [anon_sym_CARET_EQ] = ACTIONS(974),
    [anon_sym_LT_LT_EQ] = ACTIONS(974),
    [anon_sym_GT_GT_EQ] = ACTIONS(974),
    [anon_sym_move] = ACTIONS(976),
    [sym_integer_literal] = ACTIONS(974),
    [aux_sym_string_literal_token1] = ACTIONS(974),
    [sym_char_literal] = ACTIONS(974),
    [anon_sym_true] = ACTIONS(976),
    [anon_sym_false] = ACTIONS(976),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(976),
    [sym_super] = ACTIONS(976),
    [sym_crate] = ACTIONS(976),
    [sym_metavariable] = ACTIONS(974),
    [sym_raw_string_literal] = ACTIONS(974),
    [sym_float_literal] = ACTIONS(974),
  },
  [469] = {
    [sym_line_comment] = STATE(469),
    [sym_block_comment] = STATE(469),
    [sym_identifier] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_QMARK] = ACTIONS(994),
    [anon_sym_u8] = ACTIONS(996),
    [anon_sym_i8] = ACTIONS(996),
    [anon_sym_u16] = ACTIONS(996),
    [anon_sym_i16] = ACTIONS(996),
    [anon_sym_u32] = ACTIONS(996),
    [anon_sym_i32] = ACTIONS(996),
    [anon_sym_u64] = ACTIONS(996),
    [anon_sym_i64] = ACTIONS(996),
    [anon_sym_u128] = ACTIONS(996),
    [anon_sym_i128] = ACTIONS(996),
    [anon_sym_isize] = ACTIONS(996),
    [anon_sym_usize] = ACTIONS(996),
    [anon_sym_f32] = ACTIONS(996),
    [anon_sym_f64] = ACTIONS(996),
    [anon_sym_bool] = ACTIONS(996),
    [anon_sym_str] = ACTIONS(996),
    [anon_sym_char] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym__] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_EQ] = ACTIONS(996),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_COLON_COLON] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(996),
    [anon_sym_AMP] = ACTIONS(996),
    [anon_sym_POUND] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(996),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_GT] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(996),
    [anon_sym_as] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_ref] = ACTIONS(996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(994),
    [sym_mutable_specifier] = ACTIONS(996),
    [anon_sym_DOT_DOT] = ACTIONS(996),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(994),
    [anon_sym_AMP_AMP] = ACTIONS(994),
    [anon_sym_PIPE_PIPE] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(996),
    [anon_sym_PLUS_EQ] = ACTIONS(994),
    [anon_sym_DASH_EQ] = ACTIONS(994),
    [anon_sym_STAR_EQ] = ACTIONS(994),
    [anon_sym_SLASH_EQ] = ACTIONS(994),
    [anon_sym_PERCENT_EQ] = ACTIONS(994),
    [anon_sym_AMP_EQ] = ACTIONS(994),
    [anon_sym_PIPE_EQ] = ACTIONS(994),
    [anon_sym_CARET_EQ] = ACTIONS(994),
    [anon_sym_LT_LT_EQ] = ACTIONS(994),
    [anon_sym_GT_GT_EQ] = ACTIONS(994),
    [anon_sym_move] = ACTIONS(996),
    [sym_integer_literal] = ACTIONS(994),
    [aux_sym_string_literal_token1] = ACTIONS(994),
    [sym_char_literal] = ACTIONS(994),
    [anon_sym_true] = ACTIONS(996),
    [anon_sym_false] = ACTIONS(996),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(996),
    [sym_super] = ACTIONS(996),
    [sym_crate] = ACTIONS(996),
    [sym_metavariable] = ACTIONS(994),
    [sym_raw_string_literal] = ACTIONS(994),
    [sym_float_literal] = ACTIONS(994),
  },
  [470] = {
    [sym_line_comment] = STATE(470),
    [sym_block_comment] = STATE(470),
    [sym_identifier] = ACTIONS(984),
    [anon_sym_LPAREN] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(982),
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(984),
    [anon_sym_QMARK] = ACTIONS(982),
    [anon_sym_u8] = ACTIONS(984),
    [anon_sym_i8] = ACTIONS(984),
    [anon_sym_u16] = ACTIONS(984),
    [anon_sym_i16] = ACTIONS(984),
    [anon_sym_u32] = ACTIONS(984),
    [anon_sym_i32] = ACTIONS(984),
    [anon_sym_u64] = ACTIONS(984),
    [anon_sym_i64] = ACTIONS(984),
    [anon_sym_u128] = ACTIONS(984),
    [anon_sym_i128] = ACTIONS(984),
    [anon_sym_isize] = ACTIONS(984),
    [anon_sym_usize] = ACTIONS(984),
    [anon_sym_f32] = ACTIONS(984),
    [anon_sym_f64] = ACTIONS(984),
    [anon_sym_bool] = ACTIONS(984),
    [anon_sym_str] = ACTIONS(984),
    [anon_sym_char] = ACTIONS(984),
    [anon_sym_SLASH] = ACTIONS(984),
    [anon_sym__] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_EQ] = ACTIONS(984),
    [anon_sym_COMMA] = ACTIONS(982),
    [anon_sym_COLON_COLON] = ACTIONS(982),
    [anon_sym_DOT] = ACTIONS(984),
    [anon_sym_AMP] = ACTIONS(984),
    [anon_sym_POUND] = ACTIONS(982),
    [anon_sym_PERCENT] = ACTIONS(984),
    [anon_sym_CARET] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(984),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_PIPE] = ACTIONS(984),
    [anon_sym_as] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_ref] = ACTIONS(984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(982),
    [sym_mutable_specifier] = ACTIONS(984),
    [anon_sym_DOT_DOT] = ACTIONS(984),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(982),
    [anon_sym_AMP_AMP] = ACTIONS(982),
    [anon_sym_PIPE_PIPE] = ACTIONS(982),
    [anon_sym_EQ_EQ] = ACTIONS(982),
    [anon_sym_BANG_EQ] = ACTIONS(982),
    [anon_sym_LT_EQ] = ACTIONS(982),
    [anon_sym_GT_EQ] = ACTIONS(982),
    [anon_sym_LT_LT] = ACTIONS(984),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_PLUS_EQ] = ACTIONS(982),
    [anon_sym_DASH_EQ] = ACTIONS(982),
    [anon_sym_STAR_EQ] = ACTIONS(982),
    [anon_sym_SLASH_EQ] = ACTIONS(982),
    [anon_sym_PERCENT_EQ] = ACTIONS(982),
    [anon_sym_AMP_EQ] = ACTIONS(982),
    [anon_sym_PIPE_EQ] = ACTIONS(982),
    [anon_sym_CARET_EQ] = ACTIONS(982),
    [anon_sym_LT_LT_EQ] = ACTIONS(982),
    [anon_sym_GT_GT_EQ] = ACTIONS(982),
    [anon_sym_move] = ACTIONS(984),
    [sym_integer_literal] = ACTIONS(982),
    [aux_sym_string_literal_token1] = ACTIONS(982),
    [sym_char_literal] = ACTIONS(982),
    [anon_sym_true] = ACTIONS(984),
    [anon_sym_false] = ACTIONS(984),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(984),
    [sym_super] = ACTIONS(984),
    [sym_crate] = ACTIONS(984),
    [sym_metavariable] = ACTIONS(982),
    [sym_raw_string_literal] = ACTIONS(982),
    [sym_float_literal] = ACTIONS(982),
  },
  [471] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3327),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(471),
    [sym_block_comment] = STATE(471),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(491),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [472] = {
    [sym_line_comment] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym_identifier] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_LBRACK] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(902),
    [anon_sym_QMARK] = ACTIONS(900),
    [anon_sym_u8] = ACTIONS(902),
    [anon_sym_i8] = ACTIONS(902),
    [anon_sym_u16] = ACTIONS(902),
    [anon_sym_i16] = ACTIONS(902),
    [anon_sym_u32] = ACTIONS(902),
    [anon_sym_i32] = ACTIONS(902),
    [anon_sym_u64] = ACTIONS(902),
    [anon_sym_i64] = ACTIONS(902),
    [anon_sym_u128] = ACTIONS(902),
    [anon_sym_i128] = ACTIONS(902),
    [anon_sym_isize] = ACTIONS(902),
    [anon_sym_usize] = ACTIONS(902),
    [anon_sym_f32] = ACTIONS(902),
    [anon_sym_f64] = ACTIONS(902),
    [anon_sym_bool] = ACTIONS(902),
    [anon_sym_str] = ACTIONS(902),
    [anon_sym_char] = ACTIONS(902),
    [anon_sym_SLASH] = ACTIONS(902),
    [anon_sym__] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_EQ] = ACTIONS(902),
    [anon_sym_COMMA] = ACTIONS(900),
    [anon_sym_COLON_COLON] = ACTIONS(900),
    [anon_sym_DOT] = ACTIONS(902),
    [anon_sym_AMP] = ACTIONS(902),
    [anon_sym_POUND] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(902),
    [anon_sym_CARET] = ACTIONS(902),
    [anon_sym_LT] = ACTIONS(902),
    [anon_sym_GT] = ACTIONS(902),
    [anon_sym_PIPE] = ACTIONS(902),
    [anon_sym_as] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_union] = ACTIONS(902),
    [anon_sym_ref] = ACTIONS(902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(900),
    [sym_mutable_specifier] = ACTIONS(902),
    [anon_sym_DOT_DOT] = ACTIONS(902),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(900),
    [anon_sym_PIPE_PIPE] = ACTIONS(900),
    [anon_sym_EQ_EQ] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(900),
    [anon_sym_LT_EQ] = ACTIONS(900),
    [anon_sym_GT_EQ] = ACTIONS(900),
    [anon_sym_LT_LT] = ACTIONS(902),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_PLUS_EQ] = ACTIONS(900),
    [anon_sym_DASH_EQ] = ACTIONS(900),
    [anon_sym_STAR_EQ] = ACTIONS(900),
    [anon_sym_SLASH_EQ] = ACTIONS(900),
    [anon_sym_PERCENT_EQ] = ACTIONS(900),
    [anon_sym_AMP_EQ] = ACTIONS(900),
    [anon_sym_PIPE_EQ] = ACTIONS(900),
    [anon_sym_CARET_EQ] = ACTIONS(900),
    [anon_sym_LT_LT_EQ] = ACTIONS(900),
    [anon_sym_GT_GT_EQ] = ACTIONS(900),
    [anon_sym_move] = ACTIONS(902),
    [sym_integer_literal] = ACTIONS(900),
    [aux_sym_string_literal_token1] = ACTIONS(900),
    [sym_char_literal] = ACTIONS(900),
    [anon_sym_true] = ACTIONS(902),
    [anon_sym_false] = ACTIONS(902),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(902),
    [sym_super] = ACTIONS(902),
    [sym_crate] = ACTIONS(902),
    [sym_metavariable] = ACTIONS(900),
    [sym_raw_string_literal] = ACTIONS(900),
    [sym_float_literal] = ACTIONS(900),
  },
  [473] = {
    [sym_line_comment] = STATE(473),
    [sym_block_comment] = STATE(473),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(990),
    [anon_sym_RBRACE] = ACTIONS(990),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(992),
    [anon_sym_QMARK] = ACTIONS(990),
    [anon_sym_u8] = ACTIONS(992),
    [anon_sym_i8] = ACTIONS(992),
    [anon_sym_u16] = ACTIONS(992),
    [anon_sym_i16] = ACTIONS(992),
    [anon_sym_u32] = ACTIONS(992),
    [anon_sym_i32] = ACTIONS(992),
    [anon_sym_u64] = ACTIONS(992),
    [anon_sym_i64] = ACTIONS(992),
    [anon_sym_u128] = ACTIONS(992),
    [anon_sym_i128] = ACTIONS(992),
    [anon_sym_isize] = ACTIONS(992),
    [anon_sym_usize] = ACTIONS(992),
    [anon_sym_f32] = ACTIONS(992),
    [anon_sym_f64] = ACTIONS(992),
    [anon_sym_bool] = ACTIONS(992),
    [anon_sym_str] = ACTIONS(992),
    [anon_sym_char] = ACTIONS(992),
    [anon_sym_SLASH] = ACTIONS(992),
    [anon_sym__] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_EQ] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(990),
    [anon_sym_COLON_COLON] = ACTIONS(990),
    [anon_sym_DOT] = ACTIONS(992),
    [anon_sym_AMP] = ACTIONS(992),
    [anon_sym_POUND] = ACTIONS(990),
    [anon_sym_PERCENT] = ACTIONS(992),
    [anon_sym_CARET] = ACTIONS(992),
    [anon_sym_LT] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(992),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_ref] = ACTIONS(992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(990),
    [sym_mutable_specifier] = ACTIONS(992),
    [anon_sym_DOT_DOT] = ACTIONS(992),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(990),
    [anon_sym_AMP_AMP] = ACTIONS(990),
    [anon_sym_PIPE_PIPE] = ACTIONS(990),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_LT_EQ] = ACTIONS(990),
    [anon_sym_GT_EQ] = ACTIONS(990),
    [anon_sym_LT_LT] = ACTIONS(992),
    [anon_sym_GT_GT] = ACTIONS(992),
    [anon_sym_PLUS_EQ] = ACTIONS(990),
    [anon_sym_DASH_EQ] = ACTIONS(990),
    [anon_sym_STAR_EQ] = ACTIONS(990),
    [anon_sym_SLASH_EQ] = ACTIONS(990),
    [anon_sym_PERCENT_EQ] = ACTIONS(990),
    [anon_sym_AMP_EQ] = ACTIONS(990),
    [anon_sym_PIPE_EQ] = ACTIONS(990),
    [anon_sym_CARET_EQ] = ACTIONS(990),
    [anon_sym_LT_LT_EQ] = ACTIONS(990),
    [anon_sym_GT_GT_EQ] = ACTIONS(990),
    [anon_sym_move] = ACTIONS(992),
    [sym_integer_literal] = ACTIONS(990),
    [aux_sym_string_literal_token1] = ACTIONS(990),
    [sym_char_literal] = ACTIONS(990),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(992),
    [sym_super] = ACTIONS(992),
    [sym_crate] = ACTIONS(992),
    [sym_metavariable] = ACTIONS(990),
    [sym_raw_string_literal] = ACTIONS(990),
    [sym_float_literal] = ACTIONS(990),
  },
  [474] = {
    [sym_line_comment] = STATE(474),
    [sym_block_comment] = STATE(474),
    [sym_identifier] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_LBRACK] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(910),
    [anon_sym_QMARK] = ACTIONS(908),
    [anon_sym_u8] = ACTIONS(910),
    [anon_sym_i8] = ACTIONS(910),
    [anon_sym_u16] = ACTIONS(910),
    [anon_sym_i16] = ACTIONS(910),
    [anon_sym_u32] = ACTIONS(910),
    [anon_sym_i32] = ACTIONS(910),
    [anon_sym_u64] = ACTIONS(910),
    [anon_sym_i64] = ACTIONS(910),
    [anon_sym_u128] = ACTIONS(910),
    [anon_sym_i128] = ACTIONS(910),
    [anon_sym_isize] = ACTIONS(910),
    [anon_sym_usize] = ACTIONS(910),
    [anon_sym_f32] = ACTIONS(910),
    [anon_sym_f64] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_str] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(910),
    [anon_sym__] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(908),
    [anon_sym_COLON_COLON] = ACTIONS(908),
    [anon_sym_DOT] = ACTIONS(910),
    [anon_sym_AMP] = ACTIONS(910),
    [anon_sym_POUND] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(910),
    [anon_sym_CARET] = ACTIONS(910),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_GT] = ACTIONS(910),
    [anon_sym_PIPE] = ACTIONS(910),
    [anon_sym_as] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_ref] = ACTIONS(910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(908),
    [sym_mutable_specifier] = ACTIONS(910),
    [anon_sym_DOT_DOT] = ACTIONS(910),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(908),
    [anon_sym_AMP_AMP] = ACTIONS(908),
    [anon_sym_PIPE_PIPE] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(908),
    [anon_sym_BANG_EQ] = ACTIONS(908),
    [anon_sym_LT_EQ] = ACTIONS(908),
    [anon_sym_GT_EQ] = ACTIONS(908),
    [anon_sym_LT_LT] = ACTIONS(910),
    [anon_sym_GT_GT] = ACTIONS(910),
    [anon_sym_PLUS_EQ] = ACTIONS(908),
    [anon_sym_DASH_EQ] = ACTIONS(908),
    [anon_sym_STAR_EQ] = ACTIONS(908),
    [anon_sym_SLASH_EQ] = ACTIONS(908),
    [anon_sym_PERCENT_EQ] = ACTIONS(908),
    [anon_sym_AMP_EQ] = ACTIONS(908),
    [anon_sym_PIPE_EQ] = ACTIONS(908),
    [anon_sym_CARET_EQ] = ACTIONS(908),
    [anon_sym_LT_LT_EQ] = ACTIONS(908),
    [anon_sym_GT_GT_EQ] = ACTIONS(908),
    [anon_sym_move] = ACTIONS(910),
    [sym_integer_literal] = ACTIONS(908),
    [aux_sym_string_literal_token1] = ACTIONS(908),
    [sym_char_literal] = ACTIONS(908),
    [anon_sym_true] = ACTIONS(910),
    [anon_sym_false] = ACTIONS(910),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(910),
    [sym_super] = ACTIONS(910),
    [sym_crate] = ACTIONS(910),
    [sym_metavariable] = ACTIONS(908),
    [sym_raw_string_literal] = ACTIONS(908),
    [sym_float_literal] = ACTIONS(908),
  },
  [475] = {
    [sym_line_comment] = STATE(475),
    [sym_block_comment] = STATE(475),
    [sym_identifier] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_QMARK] = ACTIONS(964),
    [anon_sym_u8] = ACTIONS(966),
    [anon_sym_i8] = ACTIONS(966),
    [anon_sym_u16] = ACTIONS(966),
    [anon_sym_i16] = ACTIONS(966),
    [anon_sym_u32] = ACTIONS(966),
    [anon_sym_i32] = ACTIONS(966),
    [anon_sym_u64] = ACTIONS(966),
    [anon_sym_i64] = ACTIONS(966),
    [anon_sym_u128] = ACTIONS(966),
    [anon_sym_i128] = ACTIONS(966),
    [anon_sym_isize] = ACTIONS(966),
    [anon_sym_usize] = ACTIONS(966),
    [anon_sym_f32] = ACTIONS(966),
    [anon_sym_f64] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_str] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_SLASH] = ACTIONS(966),
    [anon_sym__] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_COMMA] = ACTIONS(964),
    [anon_sym_COLON_COLON] = ACTIONS(964),
    [anon_sym_DOT] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(966),
    [anon_sym_POUND] = ACTIONS(964),
    [anon_sym_PERCENT] = ACTIONS(966),
    [anon_sym_CARET] = ACTIONS(966),
    [anon_sym_LT] = ACTIONS(966),
    [anon_sym_GT] = ACTIONS(966),
    [anon_sym_PIPE] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_ref] = ACTIONS(966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(964),
    [sym_mutable_specifier] = ACTIONS(966),
    [anon_sym_DOT_DOT] = ACTIONS(966),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(964),
    [anon_sym_AMP_AMP] = ACTIONS(964),
    [anon_sym_PIPE_PIPE] = ACTIONS(964),
    [anon_sym_EQ_EQ] = ACTIONS(964),
    [anon_sym_BANG_EQ] = ACTIONS(964),
    [anon_sym_LT_EQ] = ACTIONS(964),
    [anon_sym_GT_EQ] = ACTIONS(964),
    [anon_sym_LT_LT] = ACTIONS(966),
    [anon_sym_GT_GT] = ACTIONS(966),
    [anon_sym_PLUS_EQ] = ACTIONS(964),
    [anon_sym_DASH_EQ] = ACTIONS(964),
    [anon_sym_STAR_EQ] = ACTIONS(964),
    [anon_sym_SLASH_EQ] = ACTIONS(964),
    [anon_sym_PERCENT_EQ] = ACTIONS(964),
    [anon_sym_AMP_EQ] = ACTIONS(964),
    [anon_sym_PIPE_EQ] = ACTIONS(964),
    [anon_sym_CARET_EQ] = ACTIONS(964),
    [anon_sym_LT_LT_EQ] = ACTIONS(964),
    [anon_sym_GT_GT_EQ] = ACTIONS(964),
    [anon_sym_move] = ACTIONS(966),
    [sym_integer_literal] = ACTIONS(964),
    [aux_sym_string_literal_token1] = ACTIONS(964),
    [sym_char_literal] = ACTIONS(964),
    [anon_sym_true] = ACTIONS(966),
    [anon_sym_false] = ACTIONS(966),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(966),
    [sym_super] = ACTIONS(966),
    [sym_crate] = ACTIONS(966),
    [sym_metavariable] = ACTIONS(964),
    [sym_raw_string_literal] = ACTIONS(964),
    [sym_float_literal] = ACTIONS(964),
  },
  [476] = {
    [sym_line_comment] = STATE(476),
    [sym_block_comment] = STATE(476),
    [sym_identifier] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(988),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_u8] = ACTIONS(988),
    [anon_sym_i8] = ACTIONS(988),
    [anon_sym_u16] = ACTIONS(988),
    [anon_sym_i16] = ACTIONS(988),
    [anon_sym_u32] = ACTIONS(988),
    [anon_sym_i32] = ACTIONS(988),
    [anon_sym_u64] = ACTIONS(988),
    [anon_sym_i64] = ACTIONS(988),
    [anon_sym_u128] = ACTIONS(988),
    [anon_sym_i128] = ACTIONS(988),
    [anon_sym_isize] = ACTIONS(988),
    [anon_sym_usize] = ACTIONS(988),
    [anon_sym_f32] = ACTIONS(988),
    [anon_sym_f64] = ACTIONS(988),
    [anon_sym_bool] = ACTIONS(988),
    [anon_sym_str] = ACTIONS(988),
    [anon_sym_char] = ACTIONS(988),
    [anon_sym_SLASH] = ACTIONS(988),
    [anon_sym__] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_EQ] = ACTIONS(988),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_COLON_COLON] = ACTIONS(986),
    [anon_sym_DOT] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(988),
    [anon_sym_POUND] = ACTIONS(986),
    [anon_sym_PERCENT] = ACTIONS(988),
    [anon_sym_CARET] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(988),
    [anon_sym_as] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(986),
    [sym_mutable_specifier] = ACTIONS(988),
    [anon_sym_DOT_DOT] = ACTIONS(988),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_EQ] = ACTIONS(986),
    [anon_sym_BANG_EQ] = ACTIONS(986),
    [anon_sym_LT_EQ] = ACTIONS(986),
    [anon_sym_GT_EQ] = ACTIONS(986),
    [anon_sym_LT_LT] = ACTIONS(988),
    [anon_sym_GT_GT] = ACTIONS(988),
    [anon_sym_PLUS_EQ] = ACTIONS(986),
    [anon_sym_DASH_EQ] = ACTIONS(986),
    [anon_sym_STAR_EQ] = ACTIONS(986),
    [anon_sym_SLASH_EQ] = ACTIONS(986),
    [anon_sym_PERCENT_EQ] = ACTIONS(986),
    [anon_sym_AMP_EQ] = ACTIONS(986),
    [anon_sym_PIPE_EQ] = ACTIONS(986),
    [anon_sym_CARET_EQ] = ACTIONS(986),
    [anon_sym_LT_LT_EQ] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(986),
    [anon_sym_move] = ACTIONS(988),
    [sym_integer_literal] = ACTIONS(986),
    [aux_sym_string_literal_token1] = ACTIONS(986),
    [sym_char_literal] = ACTIONS(986),
    [anon_sym_true] = ACTIONS(988),
    [anon_sym_false] = ACTIONS(988),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(988),
    [sym_super] = ACTIONS(988),
    [sym_crate] = ACTIONS(988),
    [sym_metavariable] = ACTIONS(986),
    [sym_raw_string_literal] = ACTIONS(986),
    [sym_float_literal] = ACTIONS(986),
  },
  [477] = {
    [sym_line_comment] = STATE(477),
    [sym_block_comment] = STATE(477),
    [sym_identifier] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1002),
    [anon_sym_RBRACE] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_QMARK] = ACTIONS(1002),
    [anon_sym_u8] = ACTIONS(1004),
    [anon_sym_i8] = ACTIONS(1004),
    [anon_sym_u16] = ACTIONS(1004),
    [anon_sym_i16] = ACTIONS(1004),
    [anon_sym_u32] = ACTIONS(1004),
    [anon_sym_i32] = ACTIONS(1004),
    [anon_sym_u64] = ACTIONS(1004),
    [anon_sym_i64] = ACTIONS(1004),
    [anon_sym_u128] = ACTIONS(1004),
    [anon_sym_i128] = ACTIONS(1004),
    [anon_sym_isize] = ACTIONS(1004),
    [anon_sym_usize] = ACTIONS(1004),
    [anon_sym_f32] = ACTIONS(1004),
    [anon_sym_f64] = ACTIONS(1004),
    [anon_sym_bool] = ACTIONS(1004),
    [anon_sym_str] = ACTIONS(1004),
    [anon_sym_char] = ACTIONS(1004),
    [anon_sym_SLASH] = ACTIONS(1004),
    [anon_sym__] = ACTIONS(1004),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_EQ] = ACTIONS(1004),
    [anon_sym_COMMA] = ACTIONS(1002),
    [anon_sym_COLON_COLON] = ACTIONS(1002),
    [anon_sym_DOT] = ACTIONS(1004),
    [anon_sym_AMP] = ACTIONS(1004),
    [anon_sym_POUND] = ACTIONS(1002),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_CARET] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_PIPE] = ACTIONS(1004),
    [anon_sym_as] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_ref] = ACTIONS(1004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1002),
    [sym_mutable_specifier] = ACTIONS(1004),
    [anon_sym_DOT_DOT] = ACTIONS(1004),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1002),
    [anon_sym_PIPE_PIPE] = ACTIONS(1002),
    [anon_sym_EQ_EQ] = ACTIONS(1002),
    [anon_sym_BANG_EQ] = ACTIONS(1002),
    [anon_sym_LT_EQ] = ACTIONS(1002),
    [anon_sym_GT_EQ] = ACTIONS(1002),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1004),
    [anon_sym_PLUS_EQ] = ACTIONS(1002),
    [anon_sym_DASH_EQ] = ACTIONS(1002),
    [anon_sym_STAR_EQ] = ACTIONS(1002),
    [anon_sym_SLASH_EQ] = ACTIONS(1002),
    [anon_sym_PERCENT_EQ] = ACTIONS(1002),
    [anon_sym_AMP_EQ] = ACTIONS(1002),
    [anon_sym_PIPE_EQ] = ACTIONS(1002),
    [anon_sym_CARET_EQ] = ACTIONS(1002),
    [anon_sym_LT_LT_EQ] = ACTIONS(1002),
    [anon_sym_GT_GT_EQ] = ACTIONS(1002),
    [anon_sym_move] = ACTIONS(1004),
    [sym_integer_literal] = ACTIONS(1002),
    [aux_sym_string_literal_token1] = ACTIONS(1002),
    [sym_char_literal] = ACTIONS(1002),
    [anon_sym_true] = ACTIONS(1004),
    [anon_sym_false] = ACTIONS(1004),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1004),
    [sym_super] = ACTIONS(1004),
    [sym_crate] = ACTIONS(1004),
    [sym_metavariable] = ACTIONS(1002),
    [sym_raw_string_literal] = ACTIONS(1002),
    [sym_float_literal] = ACTIONS(1002),
  },
  [478] = {
    [sym_line_comment] = STATE(478),
    [sym_block_comment] = STATE(478),
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(1006),
    [anon_sym_u8] = ACTIONS(1008),
    [anon_sym_i8] = ACTIONS(1008),
    [anon_sym_u16] = ACTIONS(1008),
    [anon_sym_i16] = ACTIONS(1008),
    [anon_sym_u32] = ACTIONS(1008),
    [anon_sym_i32] = ACTIONS(1008),
    [anon_sym_u64] = ACTIONS(1008),
    [anon_sym_i64] = ACTIONS(1008),
    [anon_sym_u128] = ACTIONS(1008),
    [anon_sym_i128] = ACTIONS(1008),
    [anon_sym_isize] = ACTIONS(1008),
    [anon_sym_usize] = ACTIONS(1008),
    [anon_sym_f32] = ACTIONS(1008),
    [anon_sym_f64] = ACTIONS(1008),
    [anon_sym_bool] = ACTIONS(1008),
    [anon_sym_str] = ACTIONS(1008),
    [anon_sym_char] = ACTIONS(1008),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym__] = ACTIONS(1008),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_EQ] = ACTIONS(1008),
    [anon_sym_COMMA] = ACTIONS(1006),
    [anon_sym_COLON_COLON] = ACTIONS(1006),
    [anon_sym_DOT] = ACTIONS(1008),
    [anon_sym_AMP] = ACTIONS(1008),
    [anon_sym_POUND] = ACTIONS(1006),
    [anon_sym_PERCENT] = ACTIONS(1008),
    [anon_sym_CARET] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1008),
    [anon_sym_GT] = ACTIONS(1008),
    [anon_sym_PIPE] = ACTIONS(1008),
    [anon_sym_as] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_ref] = ACTIONS(1008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1006),
    [sym_mutable_specifier] = ACTIONS(1008),
    [anon_sym_DOT_DOT] = ACTIONS(1008),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1006),
    [anon_sym_AMP_AMP] = ACTIONS(1006),
    [anon_sym_PIPE_PIPE] = ACTIONS(1006),
    [anon_sym_EQ_EQ] = ACTIONS(1006),
    [anon_sym_BANG_EQ] = ACTIONS(1006),
    [anon_sym_LT_EQ] = ACTIONS(1006),
    [anon_sym_GT_EQ] = ACTIONS(1006),
    [anon_sym_LT_LT] = ACTIONS(1008),
    [anon_sym_GT_GT] = ACTIONS(1008),
    [anon_sym_PLUS_EQ] = ACTIONS(1006),
    [anon_sym_DASH_EQ] = ACTIONS(1006),
    [anon_sym_STAR_EQ] = ACTIONS(1006),
    [anon_sym_SLASH_EQ] = ACTIONS(1006),
    [anon_sym_PERCENT_EQ] = ACTIONS(1006),
    [anon_sym_AMP_EQ] = ACTIONS(1006),
    [anon_sym_PIPE_EQ] = ACTIONS(1006),
    [anon_sym_CARET_EQ] = ACTIONS(1006),
    [anon_sym_LT_LT_EQ] = ACTIONS(1006),
    [anon_sym_GT_GT_EQ] = ACTIONS(1006),
    [anon_sym_move] = ACTIONS(1008),
    [sym_integer_literal] = ACTIONS(1006),
    [aux_sym_string_literal_token1] = ACTIONS(1006),
    [sym_char_literal] = ACTIONS(1006),
    [anon_sym_true] = ACTIONS(1008),
    [anon_sym_false] = ACTIONS(1008),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1008),
    [sym_super] = ACTIONS(1008),
    [sym_crate] = ACTIONS(1008),
    [sym_metavariable] = ACTIONS(1006),
    [sym_raw_string_literal] = ACTIONS(1006),
    [sym_float_literal] = ACTIONS(1006),
  },
  [479] = {
    [sym_line_comment] = STATE(479),
    [sym_block_comment] = STATE(479),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(1010),
    [anon_sym_u8] = ACTIONS(1012),
    [anon_sym_i8] = ACTIONS(1012),
    [anon_sym_u16] = ACTIONS(1012),
    [anon_sym_i16] = ACTIONS(1012),
    [anon_sym_u32] = ACTIONS(1012),
    [anon_sym_i32] = ACTIONS(1012),
    [anon_sym_u64] = ACTIONS(1012),
    [anon_sym_i64] = ACTIONS(1012),
    [anon_sym_u128] = ACTIONS(1012),
    [anon_sym_i128] = ACTIONS(1012),
    [anon_sym_isize] = ACTIONS(1012),
    [anon_sym_usize] = ACTIONS(1012),
    [anon_sym_f32] = ACTIONS(1012),
    [anon_sym_f64] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_str] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym__] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_EQ] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(1010),
    [anon_sym_COLON_COLON] = ACTIONS(1010),
    [anon_sym_DOT] = ACTIONS(1012),
    [anon_sym_AMP] = ACTIONS(1012),
    [anon_sym_POUND] = ACTIONS(1010),
    [anon_sym_PERCENT] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1012),
    [anon_sym_PIPE] = ACTIONS(1012),
    [anon_sym_as] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_ref] = ACTIONS(1012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1010),
    [sym_mutable_specifier] = ACTIONS(1012),
    [anon_sym_DOT_DOT] = ACTIONS(1012),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1010),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(1010),
    [anon_sym_BANG_EQ] = ACTIONS(1010),
    [anon_sym_LT_EQ] = ACTIONS(1010),
    [anon_sym_GT_EQ] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(1012),
    [anon_sym_PLUS_EQ] = ACTIONS(1010),
    [anon_sym_DASH_EQ] = ACTIONS(1010),
    [anon_sym_STAR_EQ] = ACTIONS(1010),
    [anon_sym_SLASH_EQ] = ACTIONS(1010),
    [anon_sym_PERCENT_EQ] = ACTIONS(1010),
    [anon_sym_AMP_EQ] = ACTIONS(1010),
    [anon_sym_PIPE_EQ] = ACTIONS(1010),
    [anon_sym_CARET_EQ] = ACTIONS(1010),
    [anon_sym_LT_LT_EQ] = ACTIONS(1010),
    [anon_sym_GT_GT_EQ] = ACTIONS(1010),
    [anon_sym_move] = ACTIONS(1012),
    [sym_integer_literal] = ACTIONS(1010),
    [aux_sym_string_literal_token1] = ACTIONS(1010),
    [sym_char_literal] = ACTIONS(1010),
    [anon_sym_true] = ACTIONS(1012),
    [anon_sym_false] = ACTIONS(1012),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1012),
    [sym_super] = ACTIONS(1012),
    [sym_crate] = ACTIONS(1012),
    [sym_metavariable] = ACTIONS(1010),
    [sym_raw_string_literal] = ACTIONS(1010),
    [sym_float_literal] = ACTIONS(1010),
  },
  [480] = {
    [sym_line_comment] = STATE(480),
    [sym_block_comment] = STATE(480),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_QMARK] = ACTIONS(940),
    [anon_sym_u8] = ACTIONS(942),
    [anon_sym_i8] = ACTIONS(942),
    [anon_sym_u16] = ACTIONS(942),
    [anon_sym_i16] = ACTIONS(942),
    [anon_sym_u32] = ACTIONS(942),
    [anon_sym_i32] = ACTIONS(942),
    [anon_sym_u64] = ACTIONS(942),
    [anon_sym_i64] = ACTIONS(942),
    [anon_sym_u128] = ACTIONS(942),
    [anon_sym_i128] = ACTIONS(942),
    [anon_sym_isize] = ACTIONS(942),
    [anon_sym_usize] = ACTIONS(942),
    [anon_sym_f32] = ACTIONS(942),
    [anon_sym_f64] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_str] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(942),
    [anon_sym__] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_EQ] = ACTIONS(942),
    [anon_sym_COMMA] = ACTIONS(940),
    [anon_sym_COLON_COLON] = ACTIONS(940),
    [anon_sym_DOT] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_POUND] = ACTIONS(940),
    [anon_sym_PERCENT] = ACTIONS(942),
    [anon_sym_CARET] = ACTIONS(942),
    [anon_sym_LT] = ACTIONS(942),
    [anon_sym_GT] = ACTIONS(942),
    [anon_sym_PIPE] = ACTIONS(942),
    [anon_sym_as] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_union] = ACTIONS(942),
    [anon_sym_ref] = ACTIONS(942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(940),
    [sym_mutable_specifier] = ACTIONS(942),
    [anon_sym_DOT_DOT] = ACTIONS(942),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(940),
    [anon_sym_AMP_AMP] = ACTIONS(940),
    [anon_sym_PIPE_PIPE] = ACTIONS(940),
    [anon_sym_EQ_EQ] = ACTIONS(940),
    [anon_sym_BANG_EQ] = ACTIONS(940),
    [anon_sym_LT_EQ] = ACTIONS(940),
    [anon_sym_GT_EQ] = ACTIONS(940),
    [anon_sym_LT_LT] = ACTIONS(942),
    [anon_sym_GT_GT] = ACTIONS(942),
    [anon_sym_PLUS_EQ] = ACTIONS(940),
    [anon_sym_DASH_EQ] = ACTIONS(940),
    [anon_sym_STAR_EQ] = ACTIONS(940),
    [anon_sym_SLASH_EQ] = ACTIONS(940),
    [anon_sym_PERCENT_EQ] = ACTIONS(940),
    [anon_sym_AMP_EQ] = ACTIONS(940),
    [anon_sym_PIPE_EQ] = ACTIONS(940),
    [anon_sym_CARET_EQ] = ACTIONS(940),
    [anon_sym_LT_LT_EQ] = ACTIONS(940),
    [anon_sym_GT_GT_EQ] = ACTIONS(940),
    [anon_sym_move] = ACTIONS(942),
    [sym_integer_literal] = ACTIONS(940),
    [aux_sym_string_literal_token1] = ACTIONS(940),
    [sym_char_literal] = ACTIONS(940),
    [anon_sym_true] = ACTIONS(942),
    [anon_sym_false] = ACTIONS(942),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_crate] = ACTIONS(942),
    [sym_metavariable] = ACTIONS(940),
    [sym_raw_string_literal] = ACTIONS(940),
    [sym_float_literal] = ACTIONS(940),
  },
  [481] = {
    [sym_line_comment] = STATE(481),
    [sym_block_comment] = STATE(481),
    [sym_identifier] = ACTIONS(972),
    [anon_sym_LPAREN] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(970),
    [anon_sym_u8] = ACTIONS(972),
    [anon_sym_i8] = ACTIONS(972),
    [anon_sym_u16] = ACTIONS(972),
    [anon_sym_i16] = ACTIONS(972),
    [anon_sym_u32] = ACTIONS(972),
    [anon_sym_i32] = ACTIONS(972),
    [anon_sym_u64] = ACTIONS(972),
    [anon_sym_i64] = ACTIONS(972),
    [anon_sym_u128] = ACTIONS(972),
    [anon_sym_i128] = ACTIONS(972),
    [anon_sym_isize] = ACTIONS(972),
    [anon_sym_usize] = ACTIONS(972),
    [anon_sym_f32] = ACTIONS(972),
    [anon_sym_f64] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_str] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_SLASH] = ACTIONS(972),
    [anon_sym__] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_EQ] = ACTIONS(972),
    [anon_sym_COMMA] = ACTIONS(970),
    [anon_sym_COLON_COLON] = ACTIONS(970),
    [anon_sym_DOT] = ACTIONS(972),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_POUND] = ACTIONS(970),
    [anon_sym_PERCENT] = ACTIONS(972),
    [anon_sym_CARET] = ACTIONS(972),
    [anon_sym_LT] = ACTIONS(972),
    [anon_sym_GT] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(972),
    [anon_sym_as] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_ref] = ACTIONS(972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(970),
    [sym_mutable_specifier] = ACTIONS(972),
    [anon_sym_DOT_DOT] = ACTIONS(972),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(970),
    [anon_sym_AMP_AMP] = ACTIONS(970),
    [anon_sym_PIPE_PIPE] = ACTIONS(970),
    [anon_sym_EQ_EQ] = ACTIONS(970),
    [anon_sym_BANG_EQ] = ACTIONS(970),
    [anon_sym_LT_EQ] = ACTIONS(970),
    [anon_sym_GT_EQ] = ACTIONS(970),
    [anon_sym_LT_LT] = ACTIONS(972),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_PLUS_EQ] = ACTIONS(970),
    [anon_sym_DASH_EQ] = ACTIONS(970),
    [anon_sym_STAR_EQ] = ACTIONS(970),
    [anon_sym_SLASH_EQ] = ACTIONS(970),
    [anon_sym_PERCENT_EQ] = ACTIONS(970),
    [anon_sym_AMP_EQ] = ACTIONS(970),
    [anon_sym_PIPE_EQ] = ACTIONS(970),
    [anon_sym_CARET_EQ] = ACTIONS(970),
    [anon_sym_LT_LT_EQ] = ACTIONS(970),
    [anon_sym_GT_GT_EQ] = ACTIONS(970),
    [anon_sym_move] = ACTIONS(972),
    [sym_integer_literal] = ACTIONS(970),
    [aux_sym_string_literal_token1] = ACTIONS(970),
    [sym_char_literal] = ACTIONS(970),
    [anon_sym_true] = ACTIONS(972),
    [anon_sym_false] = ACTIONS(972),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(972),
    [sym_super] = ACTIONS(972),
    [sym_crate] = ACTIONS(972),
    [sym_metavariable] = ACTIONS(970),
    [sym_raw_string_literal] = ACTIONS(970),
    [sym_float_literal] = ACTIONS(970),
  },
  [482] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3333),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(482),
    [sym_block_comment] = STATE(482),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(492),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [483] = {
    [sym_line_comment] = STATE(483),
    [sym_block_comment] = STATE(483),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_LBRACK] = ACTIONS(978),
    [anon_sym_RBRACE] = ACTIONS(978),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_QMARK] = ACTIONS(978),
    [anon_sym_u8] = ACTIONS(980),
    [anon_sym_i8] = ACTIONS(980),
    [anon_sym_u16] = ACTIONS(980),
    [anon_sym_i16] = ACTIONS(980),
    [anon_sym_u32] = ACTIONS(980),
    [anon_sym_i32] = ACTIONS(980),
    [anon_sym_u64] = ACTIONS(980),
    [anon_sym_i64] = ACTIONS(980),
    [anon_sym_u128] = ACTIONS(980),
    [anon_sym_i128] = ACTIONS(980),
    [anon_sym_isize] = ACTIONS(980),
    [anon_sym_usize] = ACTIONS(980),
    [anon_sym_f32] = ACTIONS(980),
    [anon_sym_f64] = ACTIONS(980),
    [anon_sym_bool] = ACTIONS(980),
    [anon_sym_str] = ACTIONS(980),
    [anon_sym_char] = ACTIONS(980),
    [anon_sym_SLASH] = ACTIONS(980),
    [anon_sym__] = ACTIONS(980),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_EQ] = ACTIONS(980),
    [anon_sym_COMMA] = ACTIONS(978),
    [anon_sym_COLON_COLON] = ACTIONS(978),
    [anon_sym_DOT] = ACTIONS(980),
    [anon_sym_AMP] = ACTIONS(980),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_PERCENT] = ACTIONS(980),
    [anon_sym_CARET] = ACTIONS(980),
    [anon_sym_LT] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(980),
    [anon_sym_PIPE] = ACTIONS(980),
    [anon_sym_as] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_ref] = ACTIONS(980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(978),
    [sym_mutable_specifier] = ACTIONS(980),
    [anon_sym_DOT_DOT] = ACTIONS(980),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(978),
    [anon_sym_AMP_AMP] = ACTIONS(978),
    [anon_sym_PIPE_PIPE] = ACTIONS(978),
    [anon_sym_EQ_EQ] = ACTIONS(978),
    [anon_sym_BANG_EQ] = ACTIONS(978),
    [anon_sym_LT_EQ] = ACTIONS(978),
    [anon_sym_GT_EQ] = ACTIONS(978),
    [anon_sym_LT_LT] = ACTIONS(980),
    [anon_sym_GT_GT] = ACTIONS(980),
    [anon_sym_PLUS_EQ] = ACTIONS(978),
    [anon_sym_DASH_EQ] = ACTIONS(978),
    [anon_sym_STAR_EQ] = ACTIONS(978),
    [anon_sym_SLASH_EQ] = ACTIONS(978),
    [anon_sym_PERCENT_EQ] = ACTIONS(978),
    [anon_sym_AMP_EQ] = ACTIONS(978),
    [anon_sym_PIPE_EQ] = ACTIONS(978),
    [anon_sym_CARET_EQ] = ACTIONS(978),
    [anon_sym_LT_LT_EQ] = ACTIONS(978),
    [anon_sym_GT_GT_EQ] = ACTIONS(978),
    [anon_sym_move] = ACTIONS(980),
    [sym_integer_literal] = ACTIONS(978),
    [aux_sym_string_literal_token1] = ACTIONS(978),
    [sym_char_literal] = ACTIONS(978),
    [anon_sym_true] = ACTIONS(980),
    [anon_sym_false] = ACTIONS(980),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(980),
    [sym_super] = ACTIONS(980),
    [sym_crate] = ACTIONS(980),
    [sym_metavariable] = ACTIONS(978),
    [sym_raw_string_literal] = ACTIONS(978),
    [sym_float_literal] = ACTIONS(978),
  },
  [484] = {
    [sym_line_comment] = STATE(484),
    [sym_block_comment] = STATE(484),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_QMARK] = ACTIONS(952),
    [anon_sym_u8] = ACTIONS(954),
    [anon_sym_i8] = ACTIONS(954),
    [anon_sym_u16] = ACTIONS(954),
    [anon_sym_i16] = ACTIONS(954),
    [anon_sym_u32] = ACTIONS(954),
    [anon_sym_i32] = ACTIONS(954),
    [anon_sym_u64] = ACTIONS(954),
    [anon_sym_i64] = ACTIONS(954),
    [anon_sym_u128] = ACTIONS(954),
    [anon_sym_i128] = ACTIONS(954),
    [anon_sym_isize] = ACTIONS(954),
    [anon_sym_usize] = ACTIONS(954),
    [anon_sym_f32] = ACTIONS(954),
    [anon_sym_f64] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_str] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_SLASH] = ACTIONS(954),
    [anon_sym__] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_EQ] = ACTIONS(954),
    [anon_sym_COMMA] = ACTIONS(952),
    [anon_sym_COLON_COLON] = ACTIONS(952),
    [anon_sym_DOT] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_POUND] = ACTIONS(952),
    [anon_sym_PERCENT] = ACTIONS(954),
    [anon_sym_CARET] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(954),
    [anon_sym_as] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_union] = ACTIONS(954),
    [anon_sym_ref] = ACTIONS(954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(952),
    [sym_mutable_specifier] = ACTIONS(954),
    [anon_sym_DOT_DOT] = ACTIONS(954),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(952),
    [anon_sym_AMP_AMP] = ACTIONS(952),
    [anon_sym_PIPE_PIPE] = ACTIONS(952),
    [anon_sym_EQ_EQ] = ACTIONS(952),
    [anon_sym_BANG_EQ] = ACTIONS(952),
    [anon_sym_LT_EQ] = ACTIONS(952),
    [anon_sym_GT_EQ] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(954),
    [anon_sym_GT_GT] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(952),
    [anon_sym_DASH_EQ] = ACTIONS(952),
    [anon_sym_STAR_EQ] = ACTIONS(952),
    [anon_sym_SLASH_EQ] = ACTIONS(952),
    [anon_sym_PERCENT_EQ] = ACTIONS(952),
    [anon_sym_AMP_EQ] = ACTIONS(952),
    [anon_sym_PIPE_EQ] = ACTIONS(952),
    [anon_sym_CARET_EQ] = ACTIONS(952),
    [anon_sym_LT_LT_EQ] = ACTIONS(952),
    [anon_sym_GT_GT_EQ] = ACTIONS(952),
    [anon_sym_move] = ACTIONS(954),
    [sym_integer_literal] = ACTIONS(952),
    [aux_sym_string_literal_token1] = ACTIONS(952),
    [sym_char_literal] = ACTIONS(952),
    [anon_sym_true] = ACTIONS(954),
    [anon_sym_false] = ACTIONS(954),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(954),
    [sym_super] = ACTIONS(954),
    [sym_crate] = ACTIONS(954),
    [sym_metavariable] = ACTIONS(952),
    [sym_raw_string_literal] = ACTIONS(952),
    [sym_float_literal] = ACTIONS(952),
  },
  [485] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3337),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(485),
    [sym_block_comment] = STATE(485),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(489),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [486] = {
    [sym_line_comment] = STATE(486),
    [sym_block_comment] = STATE(486),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1594),
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(950),
    [anon_sym_u8] = ACTIONS(1592),
    [anon_sym_i8] = ACTIONS(1592),
    [anon_sym_u16] = ACTIONS(1592),
    [anon_sym_i16] = ACTIONS(1592),
    [anon_sym_u32] = ACTIONS(1592),
    [anon_sym_i32] = ACTIONS(1592),
    [anon_sym_u64] = ACTIONS(1592),
    [anon_sym_i64] = ACTIONS(1592),
    [anon_sym_u128] = ACTIONS(1592),
    [anon_sym_i128] = ACTIONS(1592),
    [anon_sym_isize] = ACTIONS(1592),
    [anon_sym_usize] = ACTIONS(1592),
    [anon_sym_f32] = ACTIONS(1592),
    [anon_sym_f64] = ACTIONS(1592),
    [anon_sym_bool] = ACTIONS(1592),
    [anon_sym_str] = ACTIONS(1592),
    [anon_sym_char] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym__] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(948),
    [anon_sym_COMMA] = ACTIONS(950),
    [anon_sym_COLON_COLON] = ACTIONS(1594),
    [anon_sym_DOT] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(1592),
    [anon_sym_POUND] = ACTIONS(1594),
    [anon_sym_PERCENT] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(1592),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(1592),
    [anon_sym_as] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_union] = ACTIONS(1592),
    [anon_sym_ref] = ACTIONS(1592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(950),
    [sym_mutable_specifier] = ACTIONS(1592),
    [anon_sym_DOT_DOT] = ACTIONS(1592),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_LT_LT] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_PLUS_EQ] = ACTIONS(950),
    [anon_sym_DASH_EQ] = ACTIONS(950),
    [anon_sym_STAR_EQ] = ACTIONS(950),
    [anon_sym_SLASH_EQ] = ACTIONS(950),
    [anon_sym_PERCENT_EQ] = ACTIONS(950),
    [anon_sym_AMP_EQ] = ACTIONS(950),
    [anon_sym_PIPE_EQ] = ACTIONS(950),
    [anon_sym_CARET_EQ] = ACTIONS(950),
    [anon_sym_LT_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_GT_EQ] = ACTIONS(950),
    [anon_sym_move] = ACTIONS(1592),
    [sym_integer_literal] = ACTIONS(1594),
    [aux_sym_string_literal_token1] = ACTIONS(1594),
    [sym_char_literal] = ACTIONS(1594),
    [anon_sym_true] = ACTIONS(1592),
    [anon_sym_false] = ACTIONS(1592),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_crate] = ACTIONS(1592),
    [sym_metavariable] = ACTIONS(1594),
    [sym_raw_string_literal] = ACTIONS(1594),
    [sym_float_literal] = ACTIONS(1594),
  },
  [487] = {
    [sym_line_comment] = STATE(487),
    [sym_block_comment] = STATE(487),
    [sym_identifier] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_LBRACK] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(950),
    [anon_sym_u8] = ACTIONS(1596),
    [anon_sym_i8] = ACTIONS(1596),
    [anon_sym_u16] = ACTIONS(1596),
    [anon_sym_i16] = ACTIONS(1596),
    [anon_sym_u32] = ACTIONS(1596),
    [anon_sym_i32] = ACTIONS(1596),
    [anon_sym_u64] = ACTIONS(1596),
    [anon_sym_i64] = ACTIONS(1596),
    [anon_sym_u128] = ACTIONS(1596),
    [anon_sym_i128] = ACTIONS(1596),
    [anon_sym_isize] = ACTIONS(1596),
    [anon_sym_usize] = ACTIONS(1596),
    [anon_sym_f32] = ACTIONS(1596),
    [anon_sym_f64] = ACTIONS(1596),
    [anon_sym_bool] = ACTIONS(1596),
    [anon_sym_str] = ACTIONS(1596),
    [anon_sym_char] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym__] = ACTIONS(1596),
    [anon_sym_DASH] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(948),
    [anon_sym_COMMA] = ACTIONS(950),
    [anon_sym_COLON_COLON] = ACTIONS(1598),
    [anon_sym_DOT] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(1596),
    [anon_sym_POUND] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_as] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(1596),
    [anon_sym_default] = ACTIONS(1596),
    [anon_sym_static] = ACTIONS(1596),
    [anon_sym_union] = ACTIONS(1596),
    [anon_sym_ref] = ACTIONS(1596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(950),
    [sym_mutable_specifier] = ACTIONS(1596),
    [anon_sym_DOT_DOT] = ACTIONS(1596),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_LT_LT] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_PLUS_EQ] = ACTIONS(950),
    [anon_sym_DASH_EQ] = ACTIONS(950),
    [anon_sym_STAR_EQ] = ACTIONS(950),
    [anon_sym_SLASH_EQ] = ACTIONS(950),
    [anon_sym_PERCENT_EQ] = ACTIONS(950),
    [anon_sym_AMP_EQ] = ACTIONS(950),
    [anon_sym_PIPE_EQ] = ACTIONS(950),
    [anon_sym_CARET_EQ] = ACTIONS(950),
    [anon_sym_LT_LT_EQ] = ACTIONS(950),
    [anon_sym_GT_GT_EQ] = ACTIONS(950),
    [anon_sym_move] = ACTIONS(1596),
    [sym_integer_literal] = ACTIONS(1598),
    [aux_sym_string_literal_token1] = ACTIONS(1598),
    [sym_char_literal] = ACTIONS(1598),
    [anon_sym_true] = ACTIONS(1596),
    [anon_sym_false] = ACTIONS(1596),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1596),
    [sym_super] = ACTIONS(1596),
    [sym_crate] = ACTIONS(1596),
    [sym_metavariable] = ACTIONS(1598),
    [sym_raw_string_literal] = ACTIONS(1598),
    [sym_float_literal] = ACTIONS(1598),
  },
  [488] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(488),
    [sym_block_comment] = STATE(488),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(1614),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [489] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3375),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(489),
    [sym_block_comment] = STATE(489),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [490] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3296),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(490),
    [sym_block_comment] = STATE(490),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [491] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3326),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(491),
    [sym_block_comment] = STATE(491),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [492] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_last_match_arm] = STATE(3490),
    [sym_match_pattern] = STATE(3328),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(492),
    [sym_block_comment] = STATE(492),
    [aux_sym_enum_variant_list_repeat1] = STATE(765),
    [aux_sym_match_block_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [493] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(493),
    [sym_block_comment] = STATE(493),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(1628),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [494] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(494),
    [sym_block_comment] = STATE(494),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(1630),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [495] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(495),
    [sym_block_comment] = STATE(495),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [496] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(496),
    [sym_block_comment] = STATE(496),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(1634),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [497] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(497),
    [sym_block_comment] = STATE(497),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [498] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2681),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2680),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(2722),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(2722),
    [sym__literal] = STATE(2722),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(498),
    [sym_block_comment] = STATE(498),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [499] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2507),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2508),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(2794),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(2794),
    [sym__literal] = STATE(2794),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(499),
    [sym_block_comment] = STATE(499),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [500] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_arm] = STATE(1059),
    [sym_match_pattern] = STATE(3281),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(500),
    [sym_block_comment] = STATE(500),
    [aux_sym_enum_variant_list_repeat1] = STATE(756),
    [aux_sym_match_block_repeat1] = STATE(500),
    [sym_identifier] = ACTIONS(1638),
    [anon_sym_LPAREN] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1644),
    [anon_sym_u8] = ACTIONS(1647),
    [anon_sym_i8] = ACTIONS(1647),
    [anon_sym_u16] = ACTIONS(1647),
    [anon_sym_i16] = ACTIONS(1647),
    [anon_sym_u32] = ACTIONS(1647),
    [anon_sym_i32] = ACTIONS(1647),
    [anon_sym_u64] = ACTIONS(1647),
    [anon_sym_i64] = ACTIONS(1647),
    [anon_sym_u128] = ACTIONS(1647),
    [anon_sym_i128] = ACTIONS(1647),
    [anon_sym_isize] = ACTIONS(1647),
    [anon_sym_usize] = ACTIONS(1647),
    [anon_sym_f32] = ACTIONS(1647),
    [anon_sym_f64] = ACTIONS(1647),
    [anon_sym_bool] = ACTIONS(1647),
    [anon_sym_str] = ACTIONS(1647),
    [anon_sym_char] = ACTIONS(1647),
    [anon_sym__] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1653),
    [anon_sym_COLON_COLON] = ACTIONS(1656),
    [anon_sym_AMP] = ACTIONS(1659),
    [anon_sym_POUND] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1671),
    [anon_sym_default] = ACTIONS(1674),
    [anon_sym_static] = ACTIONS(1677),
    [anon_sym_union] = ACTIONS(1674),
    [anon_sym_ref] = ACTIONS(1680),
    [sym_mutable_specifier] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1686),
    [anon_sym_move] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1692),
    [aux_sym_string_literal_token1] = ACTIONS(1695),
    [sym_char_literal] = ACTIONS(1692),
    [anon_sym_true] = ACTIONS(1698),
    [anon_sym_false] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1701),
    [sym_super] = ACTIONS(1701),
    [sym_crate] = ACTIONS(1701),
    [sym_metavariable] = ACTIONS(1704),
    [sym_raw_string_literal] = ACTIONS(1692),
    [sym_float_literal] = ACTIONS(1692),
  },
  [501] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2590),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2589),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(2927),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(2927),
    [sym__literal] = STATE(2927),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(501),
    [sym_block_comment] = STATE(501),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [502] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2920),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2915),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_type_binding] = STATE(3086),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_label] = STATE(3497),
    [sym_block] = STATE(3086),
    [sym__literal] = STATE(3086),
    [sym_string_literal] = STATE(3021),
    [sym_boolean_literal] = STATE(3021),
    [sym_line_comment] = STATE(502),
    [sym_block_comment] = STATE(502),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_integer_literal] = ACTIONS(1622),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1622),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
    [sym_raw_string_literal] = ACTIONS(1622),
    [sym_float_literal] = ACTIONS(1622),
  },
  [503] = {
    [sym_line_comment] = STATE(503),
    [sym_block_comment] = STATE(503),
    [ts_builtin_sym_end] = ACTIONS(1707),
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_macro_rules_BANG] = ACTIONS(1707),
    [anon_sym_LPAREN] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u8] = ACTIONS(1709),
    [anon_sym_i8] = ACTIONS(1709),
    [anon_sym_u16] = ACTIONS(1709),
    [anon_sym_i16] = ACTIONS(1709),
    [anon_sym_u32] = ACTIONS(1709),
    [anon_sym_i32] = ACTIONS(1709),
    [anon_sym_u64] = ACTIONS(1709),
    [anon_sym_i64] = ACTIONS(1709),
    [anon_sym_u128] = ACTIONS(1709),
    [anon_sym_i128] = ACTIONS(1709),
    [anon_sym_isize] = ACTIONS(1709),
    [anon_sym_usize] = ACTIONS(1709),
    [anon_sym_f32] = ACTIONS(1709),
    [anon_sym_f64] = ACTIONS(1709),
    [anon_sym_bool] = ACTIONS(1709),
    [anon_sym_str] = ACTIONS(1709),
    [anon_sym_char] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1707),
    [anon_sym_COLON_COLON] = ACTIONS(1707),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_POUND] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SQUOTE] = ACTIONS(1709),
    [anon_sym_async] = ACTIONS(1709),
    [anon_sym_break] = ACTIONS(1709),
    [anon_sym_const] = ACTIONS(1709),
    [anon_sym_continue] = ACTIONS(1709),
    [anon_sym_default] = ACTIONS(1709),
    [anon_sym_enum] = ACTIONS(1709),
    [anon_sym_fn] = ACTIONS(1709),
    [anon_sym_for] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1709),
    [anon_sym_impl] = ACTIONS(1709),
    [anon_sym_let] = ACTIONS(1709),
    [anon_sym_loop] = ACTIONS(1709),
    [anon_sym_match] = ACTIONS(1709),
    [anon_sym_mod] = ACTIONS(1709),
    [anon_sym_pub] = ACTIONS(1709),
    [anon_sym_return] = ACTIONS(1709),
    [anon_sym_static] = ACTIONS(1709),
    [anon_sym_struct] = ACTIONS(1709),
    [anon_sym_trait] = ACTIONS(1709),
    [anon_sym_type] = ACTIONS(1709),
    [anon_sym_union] = ACTIONS(1709),
    [anon_sym_unsafe] = ACTIONS(1709),
    [anon_sym_use] = ACTIONS(1709),
    [anon_sym_while] = ACTIONS(1709),
    [anon_sym_extern] = ACTIONS(1709),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_yield] = ACTIONS(1709),
    [anon_sym_move] = ACTIONS(1709),
    [anon_sym_try] = ACTIONS(1709),
    [sym_integer_literal] = ACTIONS(1707),
    [aux_sym_string_literal_token1] = ACTIONS(1707),
    [sym_char_literal] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1709),
    [sym_super] = ACTIONS(1709),
    [sym_crate] = ACTIONS(1709),
    [sym_metavariable] = ACTIONS(1707),
    [sym_raw_string_literal] = ACTIONS(1707),
    [sym_float_literal] = ACTIONS(1707),
  },
  [504] = {
    [sym_line_comment] = STATE(504),
    [sym_block_comment] = STATE(504),
    [ts_builtin_sym_end] = ACTIONS(1711),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_macro_rules_BANG] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_u8] = ACTIONS(1713),
    [anon_sym_i8] = ACTIONS(1713),
    [anon_sym_u16] = ACTIONS(1713),
    [anon_sym_i16] = ACTIONS(1713),
    [anon_sym_u32] = ACTIONS(1713),
    [anon_sym_i32] = ACTIONS(1713),
    [anon_sym_u64] = ACTIONS(1713),
    [anon_sym_i64] = ACTIONS(1713),
    [anon_sym_u128] = ACTIONS(1713),
    [anon_sym_i128] = ACTIONS(1713),
    [anon_sym_isize] = ACTIONS(1713),
    [anon_sym_usize] = ACTIONS(1713),
    [anon_sym_f32] = ACTIONS(1713),
    [anon_sym_f64] = ACTIONS(1713),
    [anon_sym_bool] = ACTIONS(1713),
    [anon_sym_str] = ACTIONS(1713),
    [anon_sym_char] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_COLON_COLON] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_POUND] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_async] = ACTIONS(1713),
    [anon_sym_break] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(1713),
    [anon_sym_continue] = ACTIONS(1713),
    [anon_sym_default] = ACTIONS(1713),
    [anon_sym_enum] = ACTIONS(1713),
    [anon_sym_fn] = ACTIONS(1713),
    [anon_sym_for] = ACTIONS(1713),
    [anon_sym_if] = ACTIONS(1713),
    [anon_sym_impl] = ACTIONS(1713),
    [anon_sym_let] = ACTIONS(1713),
    [anon_sym_loop] = ACTIONS(1713),
    [anon_sym_match] = ACTIONS(1713),
    [anon_sym_mod] = ACTIONS(1713),
    [anon_sym_pub] = ACTIONS(1713),
    [anon_sym_return] = ACTIONS(1713),
    [anon_sym_static] = ACTIONS(1713),
    [anon_sym_struct] = ACTIONS(1713),
    [anon_sym_trait] = ACTIONS(1713),
    [anon_sym_type] = ACTIONS(1713),
    [anon_sym_union] = ACTIONS(1713),
    [anon_sym_unsafe] = ACTIONS(1713),
    [anon_sym_use] = ACTIONS(1713),
    [anon_sym_while] = ACTIONS(1713),
    [anon_sym_extern] = ACTIONS(1713),
    [anon_sym_DOT_DOT] = ACTIONS(1711),
    [anon_sym_yield] = ACTIONS(1713),
    [anon_sym_move] = ACTIONS(1713),
    [anon_sym_try] = ACTIONS(1713),
    [sym_integer_literal] = ACTIONS(1711),
    [aux_sym_string_literal_token1] = ACTIONS(1711),
    [sym_char_literal] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1713),
    [anon_sym_false] = ACTIONS(1713),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1713),
    [sym_super] = ACTIONS(1713),
    [sym_crate] = ACTIONS(1713),
    [sym_metavariable] = ACTIONS(1711),
    [sym_raw_string_literal] = ACTIONS(1711),
    [sym_float_literal] = ACTIONS(1711),
  },
  [505] = {
    [sym_line_comment] = STATE(505),
    [sym_block_comment] = STATE(505),
    [ts_builtin_sym_end] = ACTIONS(1715),
    [sym_identifier] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(1715),
    [anon_sym_macro_rules_BANG] = ACTIONS(1715),
    [anon_sym_LPAREN] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(1715),
    [anon_sym_RBRACE] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1715),
    [anon_sym_u8] = ACTIONS(1717),
    [anon_sym_i8] = ACTIONS(1717),
    [anon_sym_u16] = ACTIONS(1717),
    [anon_sym_i16] = ACTIONS(1717),
    [anon_sym_u32] = ACTIONS(1717),
    [anon_sym_i32] = ACTIONS(1717),
    [anon_sym_u64] = ACTIONS(1717),
    [anon_sym_i64] = ACTIONS(1717),
    [anon_sym_u128] = ACTIONS(1717),
    [anon_sym_i128] = ACTIONS(1717),
    [anon_sym_isize] = ACTIONS(1717),
    [anon_sym_usize] = ACTIONS(1717),
    [anon_sym_f32] = ACTIONS(1717),
    [anon_sym_f64] = ACTIONS(1717),
    [anon_sym_bool] = ACTIONS(1717),
    [anon_sym_str] = ACTIONS(1717),
    [anon_sym_char] = ACTIONS(1717),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_COLON_COLON] = ACTIONS(1715),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(1715),
    [anon_sym_POUND] = ACTIONS(1715),
    [anon_sym_LT] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1715),
    [anon_sym_SQUOTE] = ACTIONS(1717),
    [anon_sym_async] = ACTIONS(1717),
    [anon_sym_break] = ACTIONS(1717),
    [anon_sym_const] = ACTIONS(1717),
    [anon_sym_continue] = ACTIONS(1717),
    [anon_sym_default] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1717),
    [anon_sym_fn] = ACTIONS(1717),
    [anon_sym_for] = ACTIONS(1717),
    [anon_sym_if] = ACTIONS(1717),
    [anon_sym_impl] = ACTIONS(1717),
    [anon_sym_let] = ACTIONS(1717),
    [anon_sym_loop] = ACTIONS(1717),
    [anon_sym_match] = ACTIONS(1717),
    [anon_sym_mod] = ACTIONS(1717),
    [anon_sym_pub] = ACTIONS(1717),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_static] = ACTIONS(1717),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_trait] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(1717),
    [anon_sym_union] = ACTIONS(1717),
    [anon_sym_unsafe] = ACTIONS(1717),
    [anon_sym_use] = ACTIONS(1717),
    [anon_sym_while] = ACTIONS(1717),
    [anon_sym_extern] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1715),
    [anon_sym_yield] = ACTIONS(1717),
    [anon_sym_move] = ACTIONS(1717),
    [anon_sym_try] = ACTIONS(1717),
    [sym_integer_literal] = ACTIONS(1715),
    [aux_sym_string_literal_token1] = ACTIONS(1715),
    [sym_char_literal] = ACTIONS(1715),
    [anon_sym_true] = ACTIONS(1717),
    [anon_sym_false] = ACTIONS(1717),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1717),
    [sym_super] = ACTIONS(1717),
    [sym_crate] = ACTIONS(1717),
    [sym_metavariable] = ACTIONS(1715),
    [sym_raw_string_literal] = ACTIONS(1715),
    [sym_float_literal] = ACTIONS(1715),
  },
  [506] = {
    [sym_line_comment] = STATE(506),
    [sym_block_comment] = STATE(506),
    [ts_builtin_sym_end] = ACTIONS(1719),
    [sym_identifier] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_macro_rules_BANG] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_u8] = ACTIONS(1721),
    [anon_sym_i8] = ACTIONS(1721),
    [anon_sym_u16] = ACTIONS(1721),
    [anon_sym_i16] = ACTIONS(1721),
    [anon_sym_u32] = ACTIONS(1721),
    [anon_sym_i32] = ACTIONS(1721),
    [anon_sym_u64] = ACTIONS(1721),
    [anon_sym_i64] = ACTIONS(1721),
    [anon_sym_u128] = ACTIONS(1721),
    [anon_sym_i128] = ACTIONS(1721),
    [anon_sym_isize] = ACTIONS(1721),
    [anon_sym_usize] = ACTIONS(1721),
    [anon_sym_f32] = ACTIONS(1721),
    [anon_sym_f64] = ACTIONS(1721),
    [anon_sym_bool] = ACTIONS(1721),
    [anon_sym_str] = ACTIONS(1721),
    [anon_sym_char] = ACTIONS(1721),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_COLON_COLON] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_POUND] = ACTIONS(1719),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_SQUOTE] = ACTIONS(1721),
    [anon_sym_async] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_const] = ACTIONS(1721),
    [anon_sym_continue] = ACTIONS(1721),
    [anon_sym_default] = ACTIONS(1721),
    [anon_sym_enum] = ACTIONS(1721),
    [anon_sym_fn] = ACTIONS(1721),
    [anon_sym_for] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1721),
    [anon_sym_impl] = ACTIONS(1721),
    [anon_sym_let] = ACTIONS(1721),
    [anon_sym_loop] = ACTIONS(1721),
    [anon_sym_match] = ACTIONS(1721),
    [anon_sym_mod] = ACTIONS(1721),
    [anon_sym_pub] = ACTIONS(1721),
    [anon_sym_return] = ACTIONS(1721),
    [anon_sym_static] = ACTIONS(1721),
    [anon_sym_struct] = ACTIONS(1721),
    [anon_sym_trait] = ACTIONS(1721),
    [anon_sym_type] = ACTIONS(1721),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_unsafe] = ACTIONS(1721),
    [anon_sym_use] = ACTIONS(1721),
    [anon_sym_while] = ACTIONS(1721),
    [anon_sym_extern] = ACTIONS(1721),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_move] = ACTIONS(1721),
    [anon_sym_try] = ACTIONS(1721),
    [sym_integer_literal] = ACTIONS(1719),
    [aux_sym_string_literal_token1] = ACTIONS(1719),
    [sym_char_literal] = ACTIONS(1719),
    [anon_sym_true] = ACTIONS(1721),
    [anon_sym_false] = ACTIONS(1721),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1721),
    [sym_super] = ACTIONS(1721),
    [sym_crate] = ACTIONS(1721),
    [sym_metavariable] = ACTIONS(1719),
    [sym_raw_string_literal] = ACTIONS(1719),
    [sym_float_literal] = ACTIONS(1719),
  },
  [507] = {
    [sym_line_comment] = STATE(507),
    [sym_block_comment] = STATE(507),
    [ts_builtin_sym_end] = ACTIONS(1723),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_macro_rules_BANG] = ACTIONS(1723),
    [anon_sym_LPAREN] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_STAR] = ACTIONS(1723),
    [anon_sym_u8] = ACTIONS(1725),
    [anon_sym_i8] = ACTIONS(1725),
    [anon_sym_u16] = ACTIONS(1725),
    [anon_sym_i16] = ACTIONS(1725),
    [anon_sym_u32] = ACTIONS(1725),
    [anon_sym_i32] = ACTIONS(1725),
    [anon_sym_u64] = ACTIONS(1725),
    [anon_sym_i64] = ACTIONS(1725),
    [anon_sym_u128] = ACTIONS(1725),
    [anon_sym_i128] = ACTIONS(1725),
    [anon_sym_isize] = ACTIONS(1725),
    [anon_sym_usize] = ACTIONS(1725),
    [anon_sym_f32] = ACTIONS(1725),
    [anon_sym_f64] = ACTIONS(1725),
    [anon_sym_bool] = ACTIONS(1725),
    [anon_sym_str] = ACTIONS(1725),
    [anon_sym_char] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1723),
    [anon_sym_COLON_COLON] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1723),
    [anon_sym_POUND] = ACTIONS(1723),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1723),
    [anon_sym_SQUOTE] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_break] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_continue] = ACTIONS(1725),
    [anon_sym_default] = ACTIONS(1725),
    [anon_sym_enum] = ACTIONS(1725),
    [anon_sym_fn] = ACTIONS(1725),
    [anon_sym_for] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(1725),
    [anon_sym_impl] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_loop] = ACTIONS(1725),
    [anon_sym_match] = ACTIONS(1725),
    [anon_sym_mod] = ACTIONS(1725),
    [anon_sym_pub] = ACTIONS(1725),
    [anon_sym_return] = ACTIONS(1725),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_struct] = ACTIONS(1725),
    [anon_sym_trait] = ACTIONS(1725),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_union] = ACTIONS(1725),
    [anon_sym_unsafe] = ACTIONS(1725),
    [anon_sym_use] = ACTIONS(1725),
    [anon_sym_while] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym_DOT_DOT] = ACTIONS(1723),
    [anon_sym_yield] = ACTIONS(1725),
    [anon_sym_move] = ACTIONS(1725),
    [anon_sym_try] = ACTIONS(1725),
    [sym_integer_literal] = ACTIONS(1723),
    [aux_sym_string_literal_token1] = ACTIONS(1723),
    [sym_char_literal] = ACTIONS(1723),
    [anon_sym_true] = ACTIONS(1725),
    [anon_sym_false] = ACTIONS(1725),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1725),
    [sym_super] = ACTIONS(1725),
    [sym_crate] = ACTIONS(1725),
    [sym_metavariable] = ACTIONS(1723),
    [sym_raw_string_literal] = ACTIONS(1723),
    [sym_float_literal] = ACTIONS(1723),
  },
  [508] = {
    [sym_line_comment] = STATE(508),
    [sym_block_comment] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(1727),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_macro_rules_BANG] = ACTIONS(1727),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_STAR] = ACTIONS(1727),
    [anon_sym_u8] = ACTIONS(1729),
    [anon_sym_i8] = ACTIONS(1729),
    [anon_sym_u16] = ACTIONS(1729),
    [anon_sym_i16] = ACTIONS(1729),
    [anon_sym_u32] = ACTIONS(1729),
    [anon_sym_i32] = ACTIONS(1729),
    [anon_sym_u64] = ACTIONS(1729),
    [anon_sym_i64] = ACTIONS(1729),
    [anon_sym_u128] = ACTIONS(1729),
    [anon_sym_i128] = ACTIONS(1729),
    [anon_sym_isize] = ACTIONS(1729),
    [anon_sym_usize] = ACTIONS(1729),
    [anon_sym_f32] = ACTIONS(1729),
    [anon_sym_f64] = ACTIONS(1729),
    [anon_sym_bool] = ACTIONS(1729),
    [anon_sym_str] = ACTIONS(1729),
    [anon_sym_char] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1727),
    [anon_sym_COLON_COLON] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_POUND] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_break] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(1729),
    [anon_sym_continue] = ACTIONS(1729),
    [anon_sym_default] = ACTIONS(1729),
    [anon_sym_enum] = ACTIONS(1729),
    [anon_sym_fn] = ACTIONS(1729),
    [anon_sym_for] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1729),
    [anon_sym_impl] = ACTIONS(1729),
    [anon_sym_let] = ACTIONS(1729),
    [anon_sym_loop] = ACTIONS(1729),
    [anon_sym_match] = ACTIONS(1729),
    [anon_sym_mod] = ACTIONS(1729),
    [anon_sym_pub] = ACTIONS(1729),
    [anon_sym_return] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_struct] = ACTIONS(1729),
    [anon_sym_trait] = ACTIONS(1729),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_union] = ACTIONS(1729),
    [anon_sym_unsafe] = ACTIONS(1729),
    [anon_sym_use] = ACTIONS(1729),
    [anon_sym_while] = ACTIONS(1729),
    [anon_sym_extern] = ACTIONS(1729),
    [anon_sym_DOT_DOT] = ACTIONS(1727),
    [anon_sym_yield] = ACTIONS(1729),
    [anon_sym_move] = ACTIONS(1729),
    [anon_sym_try] = ACTIONS(1729),
    [sym_integer_literal] = ACTIONS(1727),
    [aux_sym_string_literal_token1] = ACTIONS(1727),
    [sym_char_literal] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1729),
    [anon_sym_false] = ACTIONS(1729),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1729),
    [sym_super] = ACTIONS(1729),
    [sym_crate] = ACTIONS(1729),
    [sym_metavariable] = ACTIONS(1727),
    [sym_raw_string_literal] = ACTIONS(1727),
    [sym_float_literal] = ACTIONS(1727),
  },
  [509] = {
    [sym_line_comment] = STATE(509),
    [sym_block_comment] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(1731),
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1731),
    [anon_sym_macro_rules_BANG] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_RBRACE] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_u8] = ACTIONS(1733),
    [anon_sym_i8] = ACTIONS(1733),
    [anon_sym_u16] = ACTIONS(1733),
    [anon_sym_i16] = ACTIONS(1733),
    [anon_sym_u32] = ACTIONS(1733),
    [anon_sym_i32] = ACTIONS(1733),
    [anon_sym_u64] = ACTIONS(1733),
    [anon_sym_i64] = ACTIONS(1733),
    [anon_sym_u128] = ACTIONS(1733),
    [anon_sym_i128] = ACTIONS(1733),
    [anon_sym_isize] = ACTIONS(1733),
    [anon_sym_usize] = ACTIONS(1733),
    [anon_sym_f32] = ACTIONS(1733),
    [anon_sym_f64] = ACTIONS(1733),
    [anon_sym_bool] = ACTIONS(1733),
    [anon_sym_str] = ACTIONS(1733),
    [anon_sym_char] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_COLON_COLON] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_POUND] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_SQUOTE] = ACTIONS(1733),
    [anon_sym_async] = ACTIONS(1733),
    [anon_sym_break] = ACTIONS(1733),
    [anon_sym_const] = ACTIONS(1733),
    [anon_sym_continue] = ACTIONS(1733),
    [anon_sym_default] = ACTIONS(1733),
    [anon_sym_enum] = ACTIONS(1733),
    [anon_sym_fn] = ACTIONS(1733),
    [anon_sym_for] = ACTIONS(1733),
    [anon_sym_if] = ACTIONS(1733),
    [anon_sym_impl] = ACTIONS(1733),
    [anon_sym_let] = ACTIONS(1733),
    [anon_sym_loop] = ACTIONS(1733),
    [anon_sym_match] = ACTIONS(1733),
    [anon_sym_mod] = ACTIONS(1733),
    [anon_sym_pub] = ACTIONS(1733),
    [anon_sym_return] = ACTIONS(1733),
    [anon_sym_static] = ACTIONS(1733),
    [anon_sym_struct] = ACTIONS(1733),
    [anon_sym_trait] = ACTIONS(1733),
    [anon_sym_type] = ACTIONS(1733),
    [anon_sym_union] = ACTIONS(1733),
    [anon_sym_unsafe] = ACTIONS(1733),
    [anon_sym_use] = ACTIONS(1733),
    [anon_sym_while] = ACTIONS(1733),
    [anon_sym_extern] = ACTIONS(1733),
    [anon_sym_DOT_DOT] = ACTIONS(1731),
    [anon_sym_yield] = ACTIONS(1733),
    [anon_sym_move] = ACTIONS(1733),
    [anon_sym_try] = ACTIONS(1733),
    [sym_integer_literal] = ACTIONS(1731),
    [aux_sym_string_literal_token1] = ACTIONS(1731),
    [sym_char_literal] = ACTIONS(1731),
    [anon_sym_true] = ACTIONS(1733),
    [anon_sym_false] = ACTIONS(1733),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1733),
    [sym_super] = ACTIONS(1733),
    [sym_crate] = ACTIONS(1733),
    [sym_metavariable] = ACTIONS(1731),
    [sym_raw_string_literal] = ACTIONS(1731),
    [sym_float_literal] = ACTIONS(1731),
  },
  [510] = {
    [sym_line_comment] = STATE(510),
    [sym_block_comment] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_macro_rules_BANG] = ACTIONS(1735),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_u8] = ACTIONS(1737),
    [anon_sym_i8] = ACTIONS(1737),
    [anon_sym_u16] = ACTIONS(1737),
    [anon_sym_i16] = ACTIONS(1737),
    [anon_sym_u32] = ACTIONS(1737),
    [anon_sym_i32] = ACTIONS(1737),
    [anon_sym_u64] = ACTIONS(1737),
    [anon_sym_i64] = ACTIONS(1737),
    [anon_sym_u128] = ACTIONS(1737),
    [anon_sym_i128] = ACTIONS(1737),
    [anon_sym_isize] = ACTIONS(1737),
    [anon_sym_usize] = ACTIONS(1737),
    [anon_sym_f32] = ACTIONS(1737),
    [anon_sym_f64] = ACTIONS(1737),
    [anon_sym_bool] = ACTIONS(1737),
    [anon_sym_str] = ACTIONS(1737),
    [anon_sym_char] = ACTIONS(1737),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_COLON_COLON] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_AMP] = ACTIONS(1735),
    [anon_sym_POUND] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_SQUOTE] = ACTIONS(1737),
    [anon_sym_async] = ACTIONS(1737),
    [anon_sym_break] = ACTIONS(1737),
    [anon_sym_const] = ACTIONS(1737),
    [anon_sym_continue] = ACTIONS(1737),
    [anon_sym_default] = ACTIONS(1737),
    [anon_sym_enum] = ACTIONS(1737),
    [anon_sym_fn] = ACTIONS(1737),
    [anon_sym_for] = ACTIONS(1737),
    [anon_sym_if] = ACTIONS(1737),
    [anon_sym_impl] = ACTIONS(1737),
    [anon_sym_let] = ACTIONS(1737),
    [anon_sym_loop] = ACTIONS(1737),
    [anon_sym_match] = ACTIONS(1737),
    [anon_sym_mod] = ACTIONS(1737),
    [anon_sym_pub] = ACTIONS(1737),
    [anon_sym_return] = ACTIONS(1737),
    [anon_sym_static] = ACTIONS(1737),
    [anon_sym_struct] = ACTIONS(1737),
    [anon_sym_trait] = ACTIONS(1737),
    [anon_sym_type] = ACTIONS(1737),
    [anon_sym_union] = ACTIONS(1737),
    [anon_sym_unsafe] = ACTIONS(1737),
    [anon_sym_use] = ACTIONS(1737),
    [anon_sym_while] = ACTIONS(1737),
    [anon_sym_extern] = ACTIONS(1737),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_yield] = ACTIONS(1737),
    [anon_sym_move] = ACTIONS(1737),
    [anon_sym_try] = ACTIONS(1737),
    [sym_integer_literal] = ACTIONS(1735),
    [aux_sym_string_literal_token1] = ACTIONS(1735),
    [sym_char_literal] = ACTIONS(1735),
    [anon_sym_true] = ACTIONS(1737),
    [anon_sym_false] = ACTIONS(1737),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1737),
    [sym_super] = ACTIONS(1737),
    [sym_crate] = ACTIONS(1737),
    [sym_metavariable] = ACTIONS(1735),
    [sym_raw_string_literal] = ACTIONS(1735),
    [sym_float_literal] = ACTIONS(1735),
  },
  [511] = {
    [sym_line_comment] = STATE(511),
    [sym_block_comment] = STATE(511),
    [ts_builtin_sym_end] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_macro_rules_BANG] = ACTIONS(1739),
    [anon_sym_LPAREN] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1739),
    [anon_sym_u8] = ACTIONS(1741),
    [anon_sym_i8] = ACTIONS(1741),
    [anon_sym_u16] = ACTIONS(1741),
    [anon_sym_i16] = ACTIONS(1741),
    [anon_sym_u32] = ACTIONS(1741),
    [anon_sym_i32] = ACTIONS(1741),
    [anon_sym_u64] = ACTIONS(1741),
    [anon_sym_i64] = ACTIONS(1741),
    [anon_sym_u128] = ACTIONS(1741),
    [anon_sym_i128] = ACTIONS(1741),
    [anon_sym_isize] = ACTIONS(1741),
    [anon_sym_usize] = ACTIONS(1741),
    [anon_sym_f32] = ACTIONS(1741),
    [anon_sym_f64] = ACTIONS(1741),
    [anon_sym_bool] = ACTIONS(1741),
    [anon_sym_str] = ACTIONS(1741),
    [anon_sym_char] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_COLON_COLON] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_POUND] = ACTIONS(1739),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_PIPE] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1741),
    [anon_sym_const] = ACTIONS(1741),
    [anon_sym_continue] = ACTIONS(1741),
    [anon_sym_default] = ACTIONS(1741),
    [anon_sym_enum] = ACTIONS(1741),
    [anon_sym_fn] = ACTIONS(1741),
    [anon_sym_for] = ACTIONS(1741),
    [anon_sym_if] = ACTIONS(1741),
    [anon_sym_impl] = ACTIONS(1741),
    [anon_sym_let] = ACTIONS(1741),
    [anon_sym_loop] = ACTIONS(1741),
    [anon_sym_match] = ACTIONS(1741),
    [anon_sym_mod] = ACTIONS(1741),
    [anon_sym_pub] = ACTIONS(1741),
    [anon_sym_return] = ACTIONS(1741),
    [anon_sym_static] = ACTIONS(1741),
    [anon_sym_struct] = ACTIONS(1741),
    [anon_sym_trait] = ACTIONS(1741),
    [anon_sym_type] = ACTIONS(1741),
    [anon_sym_union] = ACTIONS(1741),
    [anon_sym_unsafe] = ACTIONS(1741),
    [anon_sym_use] = ACTIONS(1741),
    [anon_sym_while] = ACTIONS(1741),
    [anon_sym_extern] = ACTIONS(1741),
    [anon_sym_DOT_DOT] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_move] = ACTIONS(1741),
    [anon_sym_try] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [aux_sym_string_literal_token1] = ACTIONS(1739),
    [sym_char_literal] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(1741),
    [anon_sym_false] = ACTIONS(1741),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1741),
    [sym_super] = ACTIONS(1741),
    [sym_crate] = ACTIONS(1741),
    [sym_metavariable] = ACTIONS(1739),
    [sym_raw_string_literal] = ACTIONS(1739),
    [sym_float_literal] = ACTIONS(1739),
  },
  [512] = {
    [sym_empty_statement] = STATE(1101),
    [sym_macro_definition] = STATE(1101),
    [sym_attribute_item] = STATE(1101),
    [sym_inner_attribute_item] = STATE(1101),
    [sym_mod_item] = STATE(1101),
    [sym_foreign_mod_item] = STATE(1101),
    [sym_struct_item] = STATE(1101),
    [sym_union_item] = STATE(1101),
    [sym_enum_item] = STATE(1101),
    [sym_extern_crate_declaration] = STATE(1101),
    [sym_const_item] = STATE(1101),
    [sym_static_item] = STATE(1101),
    [sym_type_item] = STATE(1101),
    [sym_function_item] = STATE(1101),
    [sym_function_signature_item] = STATE(1101),
    [sym_function_modifiers] = STATE(3508),
    [sym_impl_item] = STATE(1101),
    [sym_trait_item] = STATE(1101),
    [sym_associated_type] = STATE(1101),
    [sym_let_declaration] = STATE(1101),
    [sym_use_declaration] = STATE(1101),
    [sym_extern_modifier] = STATE(2143),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type_with_turbofish] = STATE(3269),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(3067),
    [sym_line_comment] = STATE(512),
    [sym_block_comment] = STATE(512),
    [aux_sym_declaration_list_repeat1] = STATE(590),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_macro_rules_BANG] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(1749),
    [anon_sym_u8] = ACTIONS(1751),
    [anon_sym_i8] = ACTIONS(1751),
    [anon_sym_u16] = ACTIONS(1751),
    [anon_sym_i16] = ACTIONS(1751),
    [anon_sym_u32] = ACTIONS(1751),
    [anon_sym_i32] = ACTIONS(1751),
    [anon_sym_u64] = ACTIONS(1751),
    [anon_sym_i64] = ACTIONS(1751),
    [anon_sym_u128] = ACTIONS(1751),
    [anon_sym_i128] = ACTIONS(1751),
    [anon_sym_isize] = ACTIONS(1751),
    [anon_sym_usize] = ACTIONS(1751),
    [anon_sym_f32] = ACTIONS(1751),
    [anon_sym_f64] = ACTIONS(1751),
    [anon_sym_bool] = ACTIONS(1751),
    [anon_sym_str] = ACTIONS(1751),
    [anon_sym_char] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_POUND] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1757),
    [anon_sym_default] = ACTIONS(1759),
    [anon_sym_enum] = ACTIONS(1761),
    [anon_sym_fn] = ACTIONS(1763),
    [anon_sym_impl] = ACTIONS(1765),
    [anon_sym_let] = ACTIONS(1767),
    [anon_sym_mod] = ACTIONS(1769),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_struct] = ACTIONS(1773),
    [anon_sym_trait] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_union] = ACTIONS(1779),
    [anon_sym_unsafe] = ACTIONS(1781),
    [anon_sym_use] = ACTIONS(1783),
    [anon_sym_extern] = ACTIONS(1785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1787),
    [sym_super] = ACTIONS(1787),
    [sym_crate] = ACTIONS(1789),
    [sym_metavariable] = ACTIONS(1791),
  },
  [513] = {
    [sym_line_comment] = STATE(513),
    [sym_block_comment] = STATE(513),
    [ts_builtin_sym_end] = ACTIONS(890),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(890),
    [anon_sym_macro_rules_BANG] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(890),
    [anon_sym_u8] = ACTIONS(892),
    [anon_sym_i8] = ACTIONS(892),
    [anon_sym_u16] = ACTIONS(892),
    [anon_sym_i16] = ACTIONS(892),
    [anon_sym_u32] = ACTIONS(892),
    [anon_sym_i32] = ACTIONS(892),
    [anon_sym_u64] = ACTIONS(892),
    [anon_sym_i64] = ACTIONS(892),
    [anon_sym_u128] = ACTIONS(892),
    [anon_sym_i128] = ACTIONS(892),
    [anon_sym_isize] = ACTIONS(892),
    [anon_sym_usize] = ACTIONS(892),
    [anon_sym_f32] = ACTIONS(892),
    [anon_sym_f64] = ACTIONS(892),
    [anon_sym_bool] = ACTIONS(892),
    [anon_sym_str] = ACTIONS(892),
    [anon_sym_char] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_COLON_COLON] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(890),
    [anon_sym_AMP] = ACTIONS(890),
    [anon_sym_POUND] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(890),
    [anon_sym_PIPE] = ACTIONS(890),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_async] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_const] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_default] = ACTIONS(892),
    [anon_sym_enum] = ACTIONS(892),
    [anon_sym_fn] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(892),
    [anon_sym_impl] = ACTIONS(892),
    [anon_sym_let] = ACTIONS(892),
    [anon_sym_loop] = ACTIONS(892),
    [anon_sym_match] = ACTIONS(892),
    [anon_sym_mod] = ACTIONS(892),
    [anon_sym_pub] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_struct] = ACTIONS(892),
    [anon_sym_trait] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_union] = ACTIONS(892),
    [anon_sym_unsafe] = ACTIONS(892),
    [anon_sym_use] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_extern] = ACTIONS(892),
    [anon_sym_DOT_DOT] = ACTIONS(890),
    [anon_sym_yield] = ACTIONS(892),
    [anon_sym_move] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [sym_integer_literal] = ACTIONS(890),
    [aux_sym_string_literal_token1] = ACTIONS(890),
    [sym_char_literal] = ACTIONS(890),
    [anon_sym_true] = ACTIONS(892),
    [anon_sym_false] = ACTIONS(892),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(892),
    [sym_super] = ACTIONS(892),
    [sym_crate] = ACTIONS(892),
    [sym_metavariable] = ACTIONS(890),
    [sym_raw_string_literal] = ACTIONS(890),
    [sym_float_literal] = ACTIONS(890),
  },
  [514] = {
    [sym_line_comment] = STATE(514),
    [sym_block_comment] = STATE(514),
    [ts_builtin_sym_end] = ACTIONS(1793),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_macro_rules_BANG] = ACTIONS(1793),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_LBRACK] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(1793),
    [anon_sym_RBRACE] = ACTIONS(1793),
    [anon_sym_STAR] = ACTIONS(1793),
    [anon_sym_u8] = ACTIONS(1795),
    [anon_sym_i8] = ACTIONS(1795),
    [anon_sym_u16] = ACTIONS(1795),
    [anon_sym_i16] = ACTIONS(1795),
    [anon_sym_u32] = ACTIONS(1795),
    [anon_sym_i32] = ACTIONS(1795),
    [anon_sym_u64] = ACTIONS(1795),
    [anon_sym_i64] = ACTIONS(1795),
    [anon_sym_u128] = ACTIONS(1795),
    [anon_sym_i128] = ACTIONS(1795),
    [anon_sym_isize] = ACTIONS(1795),
    [anon_sym_usize] = ACTIONS(1795),
    [anon_sym_f32] = ACTIONS(1795),
    [anon_sym_f64] = ACTIONS(1795),
    [anon_sym_bool] = ACTIONS(1795),
    [anon_sym_str] = ACTIONS(1795),
    [anon_sym_char] = ACTIONS(1795),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_COLON_COLON] = ACTIONS(1793),
    [anon_sym_BANG] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_POUND] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(1795),
    [anon_sym_break] = ACTIONS(1795),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_continue] = ACTIONS(1795),
    [anon_sym_default] = ACTIONS(1795),
    [anon_sym_enum] = ACTIONS(1795),
    [anon_sym_fn] = ACTIONS(1795),
    [anon_sym_for] = ACTIONS(1795),
    [anon_sym_if] = ACTIONS(1795),
    [anon_sym_impl] = ACTIONS(1795),
    [anon_sym_let] = ACTIONS(1795),
    [anon_sym_loop] = ACTIONS(1795),
    [anon_sym_match] = ACTIONS(1795),
    [anon_sym_mod] = ACTIONS(1795),
    [anon_sym_pub] = ACTIONS(1795),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_static] = ACTIONS(1795),
    [anon_sym_struct] = ACTIONS(1795),
    [anon_sym_trait] = ACTIONS(1795),
    [anon_sym_type] = ACTIONS(1795),
    [anon_sym_union] = ACTIONS(1795),
    [anon_sym_unsafe] = ACTIONS(1795),
    [anon_sym_use] = ACTIONS(1795),
    [anon_sym_while] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_yield] = ACTIONS(1795),
    [anon_sym_move] = ACTIONS(1795),
    [anon_sym_try] = ACTIONS(1795),
    [sym_integer_literal] = ACTIONS(1793),
    [aux_sym_string_literal_token1] = ACTIONS(1793),
    [sym_char_literal] = ACTIONS(1793),
    [anon_sym_true] = ACTIONS(1795),
    [anon_sym_false] = ACTIONS(1795),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1795),
    [sym_super] = ACTIONS(1795),
    [sym_crate] = ACTIONS(1795),
    [sym_metavariable] = ACTIONS(1793),
    [sym_raw_string_literal] = ACTIONS(1793),
    [sym_float_literal] = ACTIONS(1793),
  },
  [515] = {
    [sym_line_comment] = STATE(515),
    [sym_block_comment] = STATE(515),
    [ts_builtin_sym_end] = ACTIONS(882),
    [sym_identifier] = ACTIONS(884),
    [anon_sym_SEMI] = ACTIONS(882),
    [anon_sym_macro_rules_BANG] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(882),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_u8] = ACTIONS(884),
    [anon_sym_i8] = ACTIONS(884),
    [anon_sym_u16] = ACTIONS(884),
    [anon_sym_i16] = ACTIONS(884),
    [anon_sym_u32] = ACTIONS(884),
    [anon_sym_i32] = ACTIONS(884),
    [anon_sym_u64] = ACTIONS(884),
    [anon_sym_i64] = ACTIONS(884),
    [anon_sym_u128] = ACTIONS(884),
    [anon_sym_i128] = ACTIONS(884),
    [anon_sym_isize] = ACTIONS(884),
    [anon_sym_usize] = ACTIONS(884),
    [anon_sym_f32] = ACTIONS(884),
    [anon_sym_f64] = ACTIONS(884),
    [anon_sym_bool] = ACTIONS(884),
    [anon_sym_str] = ACTIONS(884),
    [anon_sym_char] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(882),
    [anon_sym_COLON_COLON] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_POUND] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(882),
    [anon_sym_PIPE] = ACTIONS(882),
    [anon_sym_SQUOTE] = ACTIONS(884),
    [anon_sym_async] = ACTIONS(884),
    [anon_sym_break] = ACTIONS(884),
    [anon_sym_const] = ACTIONS(884),
    [anon_sym_continue] = ACTIONS(884),
    [anon_sym_default] = ACTIONS(884),
    [anon_sym_enum] = ACTIONS(884),
    [anon_sym_fn] = ACTIONS(884),
    [anon_sym_for] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(884),
    [anon_sym_impl] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(884),
    [anon_sym_loop] = ACTIONS(884),
    [anon_sym_match] = ACTIONS(884),
    [anon_sym_mod] = ACTIONS(884),
    [anon_sym_pub] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(884),
    [anon_sym_static] = ACTIONS(884),
    [anon_sym_struct] = ACTIONS(884),
    [anon_sym_trait] = ACTIONS(884),
    [anon_sym_type] = ACTIONS(884),
    [anon_sym_union] = ACTIONS(884),
    [anon_sym_unsafe] = ACTIONS(884),
    [anon_sym_use] = ACTIONS(884),
    [anon_sym_while] = ACTIONS(884),
    [anon_sym_extern] = ACTIONS(884),
    [anon_sym_DOT_DOT] = ACTIONS(882),
    [anon_sym_yield] = ACTIONS(884),
    [anon_sym_move] = ACTIONS(884),
    [anon_sym_try] = ACTIONS(884),
    [sym_integer_literal] = ACTIONS(882),
    [aux_sym_string_literal_token1] = ACTIONS(882),
    [sym_char_literal] = ACTIONS(882),
    [anon_sym_true] = ACTIONS(884),
    [anon_sym_false] = ACTIONS(884),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(884),
    [sym_super] = ACTIONS(884),
    [sym_crate] = ACTIONS(884),
    [sym_metavariable] = ACTIONS(882),
    [sym_raw_string_literal] = ACTIONS(882),
    [sym_float_literal] = ACTIONS(882),
  },
  [516] = {
    [sym_line_comment] = STATE(516),
    [sym_block_comment] = STATE(516),
    [ts_builtin_sym_end] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym_macro_rules_BANG] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1797),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1797),
    [anon_sym_u8] = ACTIONS(1799),
    [anon_sym_i8] = ACTIONS(1799),
    [anon_sym_u16] = ACTIONS(1799),
    [anon_sym_i16] = ACTIONS(1799),
    [anon_sym_u32] = ACTIONS(1799),
    [anon_sym_i32] = ACTIONS(1799),
    [anon_sym_u64] = ACTIONS(1799),
    [anon_sym_i64] = ACTIONS(1799),
    [anon_sym_u128] = ACTIONS(1799),
    [anon_sym_i128] = ACTIONS(1799),
    [anon_sym_isize] = ACTIONS(1799),
    [anon_sym_usize] = ACTIONS(1799),
    [anon_sym_f32] = ACTIONS(1799),
    [anon_sym_f64] = ACTIONS(1799),
    [anon_sym_bool] = ACTIONS(1799),
    [anon_sym_str] = ACTIONS(1799),
    [anon_sym_char] = ACTIONS(1799),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_COLON_COLON] = ACTIONS(1797),
    [anon_sym_BANG] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_POUND] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(1797),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1799),
    [anon_sym_async] = ACTIONS(1799),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_const] = ACTIONS(1799),
    [anon_sym_continue] = ACTIONS(1799),
    [anon_sym_default] = ACTIONS(1799),
    [anon_sym_enum] = ACTIONS(1799),
    [anon_sym_fn] = ACTIONS(1799),
    [anon_sym_for] = ACTIONS(1799),
    [anon_sym_if] = ACTIONS(1799),
    [anon_sym_impl] = ACTIONS(1799),
    [anon_sym_let] = ACTIONS(1799),
    [anon_sym_loop] = ACTIONS(1799),
    [anon_sym_match] = ACTIONS(1799),
    [anon_sym_mod] = ACTIONS(1799),
    [anon_sym_pub] = ACTIONS(1799),
    [anon_sym_return] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1799),
    [anon_sym_struct] = ACTIONS(1799),
    [anon_sym_trait] = ACTIONS(1799),
    [anon_sym_type] = ACTIONS(1799),
    [anon_sym_union] = ACTIONS(1799),
    [anon_sym_unsafe] = ACTIONS(1799),
    [anon_sym_use] = ACTIONS(1799),
    [anon_sym_while] = ACTIONS(1799),
    [anon_sym_extern] = ACTIONS(1799),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_yield] = ACTIONS(1799),
    [anon_sym_move] = ACTIONS(1799),
    [anon_sym_try] = ACTIONS(1799),
    [sym_integer_literal] = ACTIONS(1797),
    [aux_sym_string_literal_token1] = ACTIONS(1797),
    [sym_char_literal] = ACTIONS(1797),
    [anon_sym_true] = ACTIONS(1799),
    [anon_sym_false] = ACTIONS(1799),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1799),
    [sym_super] = ACTIONS(1799),
    [sym_crate] = ACTIONS(1799),
    [sym_metavariable] = ACTIONS(1797),
    [sym_raw_string_literal] = ACTIONS(1797),
    [sym_float_literal] = ACTIONS(1797),
  },
  [517] = {
    [sym_line_comment] = STATE(517),
    [sym_block_comment] = STATE(517),
    [ts_builtin_sym_end] = ACTIONS(1801),
    [sym_identifier] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_macro_rules_BANG] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_RBRACE] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_u8] = ACTIONS(1803),
    [anon_sym_i8] = ACTIONS(1803),
    [anon_sym_u16] = ACTIONS(1803),
    [anon_sym_i16] = ACTIONS(1803),
    [anon_sym_u32] = ACTIONS(1803),
    [anon_sym_i32] = ACTIONS(1803),
    [anon_sym_u64] = ACTIONS(1803),
    [anon_sym_i64] = ACTIONS(1803),
    [anon_sym_u128] = ACTIONS(1803),
    [anon_sym_i128] = ACTIONS(1803),
    [anon_sym_isize] = ACTIONS(1803),
    [anon_sym_usize] = ACTIONS(1803),
    [anon_sym_f32] = ACTIONS(1803),
    [anon_sym_f64] = ACTIONS(1803),
    [anon_sym_bool] = ACTIONS(1803),
    [anon_sym_str] = ACTIONS(1803),
    [anon_sym_char] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_COLON_COLON] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_POUND] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_SQUOTE] = ACTIONS(1803),
    [anon_sym_async] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_fn] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_impl] = ACTIONS(1803),
    [anon_sym_let] = ACTIONS(1803),
    [anon_sym_loop] = ACTIONS(1803),
    [anon_sym_match] = ACTIONS(1803),
    [anon_sym_mod] = ACTIONS(1803),
    [anon_sym_pub] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_trait] = ACTIONS(1803),
    [anon_sym_type] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_unsafe] = ACTIONS(1803),
    [anon_sym_use] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1801),
    [anon_sym_yield] = ACTIONS(1803),
    [anon_sym_move] = ACTIONS(1803),
    [anon_sym_try] = ACTIONS(1803),
    [sym_integer_literal] = ACTIONS(1801),
    [aux_sym_string_literal_token1] = ACTIONS(1801),
    [sym_char_literal] = ACTIONS(1801),
    [anon_sym_true] = ACTIONS(1803),
    [anon_sym_false] = ACTIONS(1803),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1803),
    [sym_super] = ACTIONS(1803),
    [sym_crate] = ACTIONS(1803),
    [sym_metavariable] = ACTIONS(1801),
    [sym_raw_string_literal] = ACTIONS(1801),
    [sym_float_literal] = ACTIONS(1801),
  },
  [518] = {
    [sym_line_comment] = STATE(518),
    [sym_block_comment] = STATE(518),
    [ts_builtin_sym_end] = ACTIONS(1805),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_macro_rules_BANG] = ACTIONS(1805),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_u8] = ACTIONS(1807),
    [anon_sym_i8] = ACTIONS(1807),
    [anon_sym_u16] = ACTIONS(1807),
    [anon_sym_i16] = ACTIONS(1807),
    [anon_sym_u32] = ACTIONS(1807),
    [anon_sym_i32] = ACTIONS(1807),
    [anon_sym_u64] = ACTIONS(1807),
    [anon_sym_i64] = ACTIONS(1807),
    [anon_sym_u128] = ACTIONS(1807),
    [anon_sym_i128] = ACTIONS(1807),
    [anon_sym_isize] = ACTIONS(1807),
    [anon_sym_usize] = ACTIONS(1807),
    [anon_sym_f32] = ACTIONS(1807),
    [anon_sym_f64] = ACTIONS(1807),
    [anon_sym_bool] = ACTIONS(1807),
    [anon_sym_str] = ACTIONS(1807),
    [anon_sym_char] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_COLON_COLON] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_POUND] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1805),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_SQUOTE] = ACTIONS(1807),
    [anon_sym_async] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_fn] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_impl] = ACTIONS(1807),
    [anon_sym_let] = ACTIONS(1807),
    [anon_sym_loop] = ACTIONS(1807),
    [anon_sym_match] = ACTIONS(1807),
    [anon_sym_mod] = ACTIONS(1807),
    [anon_sym_pub] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_trait] = ACTIONS(1807),
    [anon_sym_type] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_unsafe] = ACTIONS(1807),
    [anon_sym_use] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_DOT_DOT] = ACTIONS(1805),
    [anon_sym_yield] = ACTIONS(1807),
    [anon_sym_move] = ACTIONS(1807),
    [anon_sym_try] = ACTIONS(1807),
    [sym_integer_literal] = ACTIONS(1805),
    [aux_sym_string_literal_token1] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [anon_sym_true] = ACTIONS(1807),
    [anon_sym_false] = ACTIONS(1807),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1807),
    [sym_super] = ACTIONS(1807),
    [sym_crate] = ACTIONS(1807),
    [sym_metavariable] = ACTIONS(1805),
    [sym_raw_string_literal] = ACTIONS(1805),
    [sym_float_literal] = ACTIONS(1805),
  },
  [519] = {
    [sym_line_comment] = STATE(519),
    [sym_block_comment] = STATE(519),
    [ts_builtin_sym_end] = ACTIONS(1809),
    [sym_identifier] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_macro_rules_BANG] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_LBRACK] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_RBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_u8] = ACTIONS(1811),
    [anon_sym_i8] = ACTIONS(1811),
    [anon_sym_u16] = ACTIONS(1811),
    [anon_sym_i16] = ACTIONS(1811),
    [anon_sym_u32] = ACTIONS(1811),
    [anon_sym_i32] = ACTIONS(1811),
    [anon_sym_u64] = ACTIONS(1811),
    [anon_sym_i64] = ACTIONS(1811),
    [anon_sym_u128] = ACTIONS(1811),
    [anon_sym_i128] = ACTIONS(1811),
    [anon_sym_isize] = ACTIONS(1811),
    [anon_sym_usize] = ACTIONS(1811),
    [anon_sym_f32] = ACTIONS(1811),
    [anon_sym_f64] = ACTIONS(1811),
    [anon_sym_bool] = ACTIONS(1811),
    [anon_sym_str] = ACTIONS(1811),
    [anon_sym_char] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_COLON_COLON] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_POUND] = ACTIONS(1809),
    [anon_sym_LT] = ACTIONS(1809),
    [anon_sym_PIPE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1811),
    [anon_sym_async] = ACTIONS(1811),
    [anon_sym_break] = ACTIONS(1811),
    [anon_sym_const] = ACTIONS(1811),
    [anon_sym_continue] = ACTIONS(1811),
    [anon_sym_default] = ACTIONS(1811),
    [anon_sym_enum] = ACTIONS(1811),
    [anon_sym_fn] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1811),
    [anon_sym_if] = ACTIONS(1811),
    [anon_sym_impl] = ACTIONS(1811),
    [anon_sym_let] = ACTIONS(1811),
    [anon_sym_loop] = ACTIONS(1811),
    [anon_sym_match] = ACTIONS(1811),
    [anon_sym_mod] = ACTIONS(1811),
    [anon_sym_pub] = ACTIONS(1811),
    [anon_sym_return] = ACTIONS(1811),
    [anon_sym_static] = ACTIONS(1811),
    [anon_sym_struct] = ACTIONS(1811),
    [anon_sym_trait] = ACTIONS(1811),
    [anon_sym_type] = ACTIONS(1811),
    [anon_sym_union] = ACTIONS(1811),
    [anon_sym_unsafe] = ACTIONS(1811),
    [anon_sym_use] = ACTIONS(1811),
    [anon_sym_while] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(1811),
    [anon_sym_DOT_DOT] = ACTIONS(1809),
    [anon_sym_yield] = ACTIONS(1811),
    [anon_sym_move] = ACTIONS(1811),
    [anon_sym_try] = ACTIONS(1811),
    [sym_integer_literal] = ACTIONS(1809),
    [aux_sym_string_literal_token1] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [anon_sym_true] = ACTIONS(1811),
    [anon_sym_false] = ACTIONS(1811),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1811),
    [sym_super] = ACTIONS(1811),
    [sym_crate] = ACTIONS(1811),
    [sym_metavariable] = ACTIONS(1809),
    [sym_raw_string_literal] = ACTIONS(1809),
    [sym_float_literal] = ACTIONS(1809),
  },
  [520] = {
    [sym_line_comment] = STATE(520),
    [sym_block_comment] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(1813),
    [sym_identifier] = ACTIONS(1815),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_macro_rules_BANG] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [anon_sym_LBRACE] = ACTIONS(1813),
    [anon_sym_RBRACE] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1813),
    [anon_sym_u8] = ACTIONS(1815),
    [anon_sym_i8] = ACTIONS(1815),
    [anon_sym_u16] = ACTIONS(1815),
    [anon_sym_i16] = ACTIONS(1815),
    [anon_sym_u32] = ACTIONS(1815),
    [anon_sym_i32] = ACTIONS(1815),
    [anon_sym_u64] = ACTIONS(1815),
    [anon_sym_i64] = ACTIONS(1815),
    [anon_sym_u128] = ACTIONS(1815),
    [anon_sym_i128] = ACTIONS(1815),
    [anon_sym_isize] = ACTIONS(1815),
    [anon_sym_usize] = ACTIONS(1815),
    [anon_sym_f32] = ACTIONS(1815),
    [anon_sym_f64] = ACTIONS(1815),
    [anon_sym_bool] = ACTIONS(1815),
    [anon_sym_str] = ACTIONS(1815),
    [anon_sym_char] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1813),
    [anon_sym_COLON_COLON] = ACTIONS(1813),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_POUND] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1813),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_SQUOTE] = ACTIONS(1815),
    [anon_sym_async] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1815),
    [anon_sym_const] = ACTIONS(1815),
    [anon_sym_continue] = ACTIONS(1815),
    [anon_sym_default] = ACTIONS(1815),
    [anon_sym_enum] = ACTIONS(1815),
    [anon_sym_fn] = ACTIONS(1815),
    [anon_sym_for] = ACTIONS(1815),
    [anon_sym_if] = ACTIONS(1815),
    [anon_sym_impl] = ACTIONS(1815),
    [anon_sym_let] = ACTIONS(1815),
    [anon_sym_loop] = ACTIONS(1815),
    [anon_sym_match] = ACTIONS(1815),
    [anon_sym_mod] = ACTIONS(1815),
    [anon_sym_pub] = ACTIONS(1815),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_static] = ACTIONS(1815),
    [anon_sym_struct] = ACTIONS(1815),
    [anon_sym_trait] = ACTIONS(1815),
    [anon_sym_type] = ACTIONS(1815),
    [anon_sym_union] = ACTIONS(1815),
    [anon_sym_unsafe] = ACTIONS(1815),
    [anon_sym_use] = ACTIONS(1815),
    [anon_sym_while] = ACTIONS(1815),
    [anon_sym_extern] = ACTIONS(1815),
    [anon_sym_DOT_DOT] = ACTIONS(1813),
    [anon_sym_yield] = ACTIONS(1815),
    [anon_sym_move] = ACTIONS(1815),
    [anon_sym_try] = ACTIONS(1815),
    [sym_integer_literal] = ACTIONS(1813),
    [aux_sym_string_literal_token1] = ACTIONS(1813),
    [sym_char_literal] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(1815),
    [anon_sym_false] = ACTIONS(1815),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1815),
    [sym_super] = ACTIONS(1815),
    [sym_crate] = ACTIONS(1815),
    [sym_metavariable] = ACTIONS(1813),
    [sym_raw_string_literal] = ACTIONS(1813),
    [sym_float_literal] = ACTIONS(1813),
  },
  [521] = {
    [sym_line_comment] = STATE(521),
    [sym_block_comment] = STATE(521),
    [ts_builtin_sym_end] = ACTIONS(1817),
    [sym_identifier] = ACTIONS(1819),
    [anon_sym_SEMI] = ACTIONS(1817),
    [anon_sym_macro_rules_BANG] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(1817),
    [anon_sym_RBRACE] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1817),
    [anon_sym_u8] = ACTIONS(1819),
    [anon_sym_i8] = ACTIONS(1819),
    [anon_sym_u16] = ACTIONS(1819),
    [anon_sym_i16] = ACTIONS(1819),
    [anon_sym_u32] = ACTIONS(1819),
    [anon_sym_i32] = ACTIONS(1819),
    [anon_sym_u64] = ACTIONS(1819),
    [anon_sym_i64] = ACTIONS(1819),
    [anon_sym_u128] = ACTIONS(1819),
    [anon_sym_i128] = ACTIONS(1819),
    [anon_sym_isize] = ACTIONS(1819),
    [anon_sym_usize] = ACTIONS(1819),
    [anon_sym_f32] = ACTIONS(1819),
    [anon_sym_f64] = ACTIONS(1819),
    [anon_sym_bool] = ACTIONS(1819),
    [anon_sym_str] = ACTIONS(1819),
    [anon_sym_char] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_COLON_COLON] = ACTIONS(1817),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1817),
    [anon_sym_POUND] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1817),
    [anon_sym_PIPE] = ACTIONS(1817),
    [anon_sym_SQUOTE] = ACTIONS(1819),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_break] = ACTIONS(1819),
    [anon_sym_const] = ACTIONS(1819),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_default] = ACTIONS(1819),
    [anon_sym_enum] = ACTIONS(1819),
    [anon_sym_fn] = ACTIONS(1819),
    [anon_sym_for] = ACTIONS(1819),
    [anon_sym_if] = ACTIONS(1819),
    [anon_sym_impl] = ACTIONS(1819),
    [anon_sym_let] = ACTIONS(1819),
    [anon_sym_loop] = ACTIONS(1819),
    [anon_sym_match] = ACTIONS(1819),
    [anon_sym_mod] = ACTIONS(1819),
    [anon_sym_pub] = ACTIONS(1819),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_static] = ACTIONS(1819),
    [anon_sym_struct] = ACTIONS(1819),
    [anon_sym_trait] = ACTIONS(1819),
    [anon_sym_type] = ACTIONS(1819),
    [anon_sym_union] = ACTIONS(1819),
    [anon_sym_unsafe] = ACTIONS(1819),
    [anon_sym_use] = ACTIONS(1819),
    [anon_sym_while] = ACTIONS(1819),
    [anon_sym_extern] = ACTIONS(1819),
    [anon_sym_DOT_DOT] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1819),
    [anon_sym_move] = ACTIONS(1819),
    [anon_sym_try] = ACTIONS(1819),
    [sym_integer_literal] = ACTIONS(1817),
    [aux_sym_string_literal_token1] = ACTIONS(1817),
    [sym_char_literal] = ACTIONS(1817),
    [anon_sym_true] = ACTIONS(1819),
    [anon_sym_false] = ACTIONS(1819),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1819),
    [sym_super] = ACTIONS(1819),
    [sym_crate] = ACTIONS(1819),
    [sym_metavariable] = ACTIONS(1817),
    [sym_raw_string_literal] = ACTIONS(1817),
    [sym_float_literal] = ACTIONS(1817),
  },
  [522] = {
    [sym_line_comment] = STATE(522),
    [sym_block_comment] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(1821),
    [sym_identifier] = ACTIONS(1823),
    [anon_sym_SEMI] = ACTIONS(1821),
    [anon_sym_macro_rules_BANG] = ACTIONS(1821),
    [anon_sym_LPAREN] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1821),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_STAR] = ACTIONS(1821),
    [anon_sym_u8] = ACTIONS(1823),
    [anon_sym_i8] = ACTIONS(1823),
    [anon_sym_u16] = ACTIONS(1823),
    [anon_sym_i16] = ACTIONS(1823),
    [anon_sym_u32] = ACTIONS(1823),
    [anon_sym_i32] = ACTIONS(1823),
    [anon_sym_u64] = ACTIONS(1823),
    [anon_sym_i64] = ACTIONS(1823),
    [anon_sym_u128] = ACTIONS(1823),
    [anon_sym_i128] = ACTIONS(1823),
    [anon_sym_isize] = ACTIONS(1823),
    [anon_sym_usize] = ACTIONS(1823),
    [anon_sym_f32] = ACTIONS(1823),
    [anon_sym_f64] = ACTIONS(1823),
    [anon_sym_bool] = ACTIONS(1823),
    [anon_sym_str] = ACTIONS(1823),
    [anon_sym_char] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1821),
    [anon_sym_COLON_COLON] = ACTIONS(1821),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_POUND] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1821),
    [anon_sym_PIPE] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1823),
    [anon_sym_async] = ACTIONS(1823),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_const] = ACTIONS(1823),
    [anon_sym_continue] = ACTIONS(1823),
    [anon_sym_default] = ACTIONS(1823),
    [anon_sym_enum] = ACTIONS(1823),
    [anon_sym_fn] = ACTIONS(1823),
    [anon_sym_for] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1823),
    [anon_sym_impl] = ACTIONS(1823),
    [anon_sym_let] = ACTIONS(1823),
    [anon_sym_loop] = ACTIONS(1823),
    [anon_sym_match] = ACTIONS(1823),
    [anon_sym_mod] = ACTIONS(1823),
    [anon_sym_pub] = ACTIONS(1823),
    [anon_sym_return] = ACTIONS(1823),
    [anon_sym_static] = ACTIONS(1823),
    [anon_sym_struct] = ACTIONS(1823),
    [anon_sym_trait] = ACTIONS(1823),
    [anon_sym_type] = ACTIONS(1823),
    [anon_sym_union] = ACTIONS(1823),
    [anon_sym_unsafe] = ACTIONS(1823),
    [anon_sym_use] = ACTIONS(1823),
    [anon_sym_while] = ACTIONS(1823),
    [anon_sym_extern] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1821),
    [anon_sym_yield] = ACTIONS(1823),
    [anon_sym_move] = ACTIONS(1823),
    [anon_sym_try] = ACTIONS(1823),
    [sym_integer_literal] = ACTIONS(1821),
    [aux_sym_string_literal_token1] = ACTIONS(1821),
    [sym_char_literal] = ACTIONS(1821),
    [anon_sym_true] = ACTIONS(1823),
    [anon_sym_false] = ACTIONS(1823),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1823),
    [sym_super] = ACTIONS(1823),
    [sym_crate] = ACTIONS(1823),
    [sym_metavariable] = ACTIONS(1821),
    [sym_raw_string_literal] = ACTIONS(1821),
    [sym_float_literal] = ACTIONS(1821),
  },
  [523] = {
    [sym_line_comment] = STATE(523),
    [sym_block_comment] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(1825),
    [sym_identifier] = ACTIONS(1827),
    [anon_sym_SEMI] = ACTIONS(1825),
    [anon_sym_macro_rules_BANG] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1825),
    [anon_sym_LBRACK] = ACTIONS(1825),
    [anon_sym_LBRACE] = ACTIONS(1825),
    [anon_sym_RBRACE] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1825),
    [anon_sym_u8] = ACTIONS(1827),
    [anon_sym_i8] = ACTIONS(1827),
    [anon_sym_u16] = ACTIONS(1827),
    [anon_sym_i16] = ACTIONS(1827),
    [anon_sym_u32] = ACTIONS(1827),
    [anon_sym_i32] = ACTIONS(1827),
    [anon_sym_u64] = ACTIONS(1827),
    [anon_sym_i64] = ACTIONS(1827),
    [anon_sym_u128] = ACTIONS(1827),
    [anon_sym_i128] = ACTIONS(1827),
    [anon_sym_isize] = ACTIONS(1827),
    [anon_sym_usize] = ACTIONS(1827),
    [anon_sym_f32] = ACTIONS(1827),
    [anon_sym_f64] = ACTIONS(1827),
    [anon_sym_bool] = ACTIONS(1827),
    [anon_sym_str] = ACTIONS(1827),
    [anon_sym_char] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1825),
    [anon_sym_COLON_COLON] = ACTIONS(1825),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_POUND] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1825),
    [anon_sym_SQUOTE] = ACTIONS(1827),
    [anon_sym_async] = ACTIONS(1827),
    [anon_sym_break] = ACTIONS(1827),
    [anon_sym_const] = ACTIONS(1827),
    [anon_sym_continue] = ACTIONS(1827),
    [anon_sym_default] = ACTIONS(1827),
    [anon_sym_enum] = ACTIONS(1827),
    [anon_sym_fn] = ACTIONS(1827),
    [anon_sym_for] = ACTIONS(1827),
    [anon_sym_if] = ACTIONS(1827),
    [anon_sym_impl] = ACTIONS(1827),
    [anon_sym_let] = ACTIONS(1827),
    [anon_sym_loop] = ACTIONS(1827),
    [anon_sym_match] = ACTIONS(1827),
    [anon_sym_mod] = ACTIONS(1827),
    [anon_sym_pub] = ACTIONS(1827),
    [anon_sym_return] = ACTIONS(1827),
    [anon_sym_static] = ACTIONS(1827),
    [anon_sym_struct] = ACTIONS(1827),
    [anon_sym_trait] = ACTIONS(1827),
    [anon_sym_type] = ACTIONS(1827),
    [anon_sym_union] = ACTIONS(1827),
    [anon_sym_unsafe] = ACTIONS(1827),
    [anon_sym_use] = ACTIONS(1827),
    [anon_sym_while] = ACTIONS(1827),
    [anon_sym_extern] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1825),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_move] = ACTIONS(1827),
    [anon_sym_try] = ACTIONS(1827),
    [sym_integer_literal] = ACTIONS(1825),
    [aux_sym_string_literal_token1] = ACTIONS(1825),
    [sym_char_literal] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1827),
    [anon_sym_false] = ACTIONS(1827),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1827),
    [sym_super] = ACTIONS(1827),
    [sym_crate] = ACTIONS(1827),
    [sym_metavariable] = ACTIONS(1825),
    [sym_raw_string_literal] = ACTIONS(1825),
    [sym_float_literal] = ACTIONS(1825),
  },
  [524] = {
    [sym_line_comment] = STATE(524),
    [sym_block_comment] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(1829),
    [sym_identifier] = ACTIONS(1831),
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_macro_rules_BANG] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1829),
    [anon_sym_u8] = ACTIONS(1831),
    [anon_sym_i8] = ACTIONS(1831),
    [anon_sym_u16] = ACTIONS(1831),
    [anon_sym_i16] = ACTIONS(1831),
    [anon_sym_u32] = ACTIONS(1831),
    [anon_sym_i32] = ACTIONS(1831),
    [anon_sym_u64] = ACTIONS(1831),
    [anon_sym_i64] = ACTIONS(1831),
    [anon_sym_u128] = ACTIONS(1831),
    [anon_sym_i128] = ACTIONS(1831),
    [anon_sym_isize] = ACTIONS(1831),
    [anon_sym_usize] = ACTIONS(1831),
    [anon_sym_f32] = ACTIONS(1831),
    [anon_sym_f64] = ACTIONS(1831),
    [anon_sym_bool] = ACTIONS(1831),
    [anon_sym_str] = ACTIONS(1831),
    [anon_sym_char] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1829),
    [anon_sym_COLON_COLON] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1829),
    [anon_sym_POUND] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1829),
    [anon_sym_SQUOTE] = ACTIONS(1831),
    [anon_sym_async] = ACTIONS(1831),
    [anon_sym_break] = ACTIONS(1831),
    [anon_sym_const] = ACTIONS(1831),
    [anon_sym_continue] = ACTIONS(1831),
    [anon_sym_default] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1831),
    [anon_sym_fn] = ACTIONS(1831),
    [anon_sym_for] = ACTIONS(1831),
    [anon_sym_if] = ACTIONS(1831),
    [anon_sym_impl] = ACTIONS(1831),
    [anon_sym_let] = ACTIONS(1831),
    [anon_sym_loop] = ACTIONS(1831),
    [anon_sym_match] = ACTIONS(1831),
    [anon_sym_mod] = ACTIONS(1831),
    [anon_sym_pub] = ACTIONS(1831),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_static] = ACTIONS(1831),
    [anon_sym_struct] = ACTIONS(1831),
    [anon_sym_trait] = ACTIONS(1831),
    [anon_sym_type] = ACTIONS(1831),
    [anon_sym_union] = ACTIONS(1831),
    [anon_sym_unsafe] = ACTIONS(1831),
    [anon_sym_use] = ACTIONS(1831),
    [anon_sym_while] = ACTIONS(1831),
    [anon_sym_extern] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1829),
    [anon_sym_yield] = ACTIONS(1831),
    [anon_sym_move] = ACTIONS(1831),
    [anon_sym_try] = ACTIONS(1831),
    [sym_integer_literal] = ACTIONS(1829),
    [aux_sym_string_literal_token1] = ACTIONS(1829),
    [sym_char_literal] = ACTIONS(1829),
    [anon_sym_true] = ACTIONS(1831),
    [anon_sym_false] = ACTIONS(1831),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1831),
    [sym_super] = ACTIONS(1831),
    [sym_crate] = ACTIONS(1831),
    [sym_metavariable] = ACTIONS(1829),
    [sym_raw_string_literal] = ACTIONS(1829),
    [sym_float_literal] = ACTIONS(1829),
  },
  [525] = {
    [sym_line_comment] = STATE(525),
    [sym_block_comment] = STATE(525),
    [ts_builtin_sym_end] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_macro_rules_BANG] = ACTIONS(1833),
    [anon_sym_LPAREN] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1833),
    [anon_sym_RBRACE] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1833),
    [anon_sym_u8] = ACTIONS(1835),
    [anon_sym_i8] = ACTIONS(1835),
    [anon_sym_u16] = ACTIONS(1835),
    [anon_sym_i16] = ACTIONS(1835),
    [anon_sym_u32] = ACTIONS(1835),
    [anon_sym_i32] = ACTIONS(1835),
    [anon_sym_u64] = ACTIONS(1835),
    [anon_sym_i64] = ACTIONS(1835),
    [anon_sym_u128] = ACTIONS(1835),
    [anon_sym_i128] = ACTIONS(1835),
    [anon_sym_isize] = ACTIONS(1835),
    [anon_sym_usize] = ACTIONS(1835),
    [anon_sym_f32] = ACTIONS(1835),
    [anon_sym_f64] = ACTIONS(1835),
    [anon_sym_bool] = ACTIONS(1835),
    [anon_sym_str] = ACTIONS(1835),
    [anon_sym_char] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_COLON_COLON] = ACTIONS(1833),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_AMP] = ACTIONS(1833),
    [anon_sym_POUND] = ACTIONS(1833),
    [anon_sym_LT] = ACTIONS(1833),
    [anon_sym_PIPE] = ACTIONS(1833),
    [anon_sym_SQUOTE] = ACTIONS(1835),
    [anon_sym_async] = ACTIONS(1835),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_const] = ACTIONS(1835),
    [anon_sym_continue] = ACTIONS(1835),
    [anon_sym_default] = ACTIONS(1835),
    [anon_sym_enum] = ACTIONS(1835),
    [anon_sym_fn] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(1835),
    [anon_sym_if] = ACTIONS(1835),
    [anon_sym_impl] = ACTIONS(1835),
    [anon_sym_let] = ACTIONS(1835),
    [anon_sym_loop] = ACTIONS(1835),
    [anon_sym_match] = ACTIONS(1835),
    [anon_sym_mod] = ACTIONS(1835),
    [anon_sym_pub] = ACTIONS(1835),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_static] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1835),
    [anon_sym_trait] = ACTIONS(1835),
    [anon_sym_type] = ACTIONS(1835),
    [anon_sym_union] = ACTIONS(1835),
    [anon_sym_unsafe] = ACTIONS(1835),
    [anon_sym_use] = ACTIONS(1835),
    [anon_sym_while] = ACTIONS(1835),
    [anon_sym_extern] = ACTIONS(1835),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_yield] = ACTIONS(1835),
    [anon_sym_move] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(1835),
    [sym_integer_literal] = ACTIONS(1833),
    [aux_sym_string_literal_token1] = ACTIONS(1833),
    [sym_char_literal] = ACTIONS(1833),
    [anon_sym_true] = ACTIONS(1835),
    [anon_sym_false] = ACTIONS(1835),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1835),
    [sym_super] = ACTIONS(1835),
    [sym_crate] = ACTIONS(1835),
    [sym_metavariable] = ACTIONS(1833),
    [sym_raw_string_literal] = ACTIONS(1833),
    [sym_float_literal] = ACTIONS(1833),
  },
  [526] = {
    [sym_line_comment] = STATE(526),
    [sym_block_comment] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(1837),
    [sym_identifier] = ACTIONS(1839),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_macro_rules_BANG] = ACTIONS(1837),
    [anon_sym_LPAREN] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1837),
    [anon_sym_RBRACE] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_u8] = ACTIONS(1839),
    [anon_sym_i8] = ACTIONS(1839),
    [anon_sym_u16] = ACTIONS(1839),
    [anon_sym_i16] = ACTIONS(1839),
    [anon_sym_u32] = ACTIONS(1839),
    [anon_sym_i32] = ACTIONS(1839),
    [anon_sym_u64] = ACTIONS(1839),
    [anon_sym_i64] = ACTIONS(1839),
    [anon_sym_u128] = ACTIONS(1839),
    [anon_sym_i128] = ACTIONS(1839),
    [anon_sym_isize] = ACTIONS(1839),
    [anon_sym_usize] = ACTIONS(1839),
    [anon_sym_f32] = ACTIONS(1839),
    [anon_sym_f64] = ACTIONS(1839),
    [anon_sym_bool] = ACTIONS(1839),
    [anon_sym_str] = ACTIONS(1839),
    [anon_sym_char] = ACTIONS(1839),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_POUND] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_SQUOTE] = ACTIONS(1839),
    [anon_sym_async] = ACTIONS(1839),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_const] = ACTIONS(1839),
    [anon_sym_continue] = ACTIONS(1839),
    [anon_sym_default] = ACTIONS(1839),
    [anon_sym_enum] = ACTIONS(1839),
    [anon_sym_fn] = ACTIONS(1839),
    [anon_sym_for] = ACTIONS(1839),
    [anon_sym_if] = ACTIONS(1839),
    [anon_sym_impl] = ACTIONS(1839),
    [anon_sym_let] = ACTIONS(1839),
    [anon_sym_loop] = ACTIONS(1839),
    [anon_sym_match] = ACTIONS(1839),
    [anon_sym_mod] = ACTIONS(1839),
    [anon_sym_pub] = ACTIONS(1839),
    [anon_sym_return] = ACTIONS(1839),
    [anon_sym_static] = ACTIONS(1839),
    [anon_sym_struct] = ACTIONS(1839),
    [anon_sym_trait] = ACTIONS(1839),
    [anon_sym_type] = ACTIONS(1839),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_unsafe] = ACTIONS(1839),
    [anon_sym_use] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1839),
    [anon_sym_extern] = ACTIONS(1839),
    [anon_sym_DOT_DOT] = ACTIONS(1837),
    [anon_sym_yield] = ACTIONS(1839),
    [anon_sym_move] = ACTIONS(1839),
    [anon_sym_try] = ACTIONS(1839),
    [sym_integer_literal] = ACTIONS(1837),
    [aux_sym_string_literal_token1] = ACTIONS(1837),
    [sym_char_literal] = ACTIONS(1837),
    [anon_sym_true] = ACTIONS(1839),
    [anon_sym_false] = ACTIONS(1839),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1839),
    [sym_super] = ACTIONS(1839),
    [sym_crate] = ACTIONS(1839),
    [sym_metavariable] = ACTIONS(1837),
    [sym_raw_string_literal] = ACTIONS(1837),
    [sym_float_literal] = ACTIONS(1837),
  },
  [527] = {
    [sym_line_comment] = STATE(527),
    [sym_block_comment] = STATE(527),
    [ts_builtin_sym_end] = ACTIONS(1841),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_macro_rules_BANG] = ACTIONS(1841),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_u8] = ACTIONS(1843),
    [anon_sym_i8] = ACTIONS(1843),
    [anon_sym_u16] = ACTIONS(1843),
    [anon_sym_i16] = ACTIONS(1843),
    [anon_sym_u32] = ACTIONS(1843),
    [anon_sym_i32] = ACTIONS(1843),
    [anon_sym_u64] = ACTIONS(1843),
    [anon_sym_i64] = ACTIONS(1843),
    [anon_sym_u128] = ACTIONS(1843),
    [anon_sym_i128] = ACTIONS(1843),
    [anon_sym_isize] = ACTIONS(1843),
    [anon_sym_usize] = ACTIONS(1843),
    [anon_sym_f32] = ACTIONS(1843),
    [anon_sym_f64] = ACTIONS(1843),
    [anon_sym_bool] = ACTIONS(1843),
    [anon_sym_str] = ACTIONS(1843),
    [anon_sym_char] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_COLON_COLON] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_AMP] = ACTIONS(1841),
    [anon_sym_POUND] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1841),
    [anon_sym_PIPE] = ACTIONS(1841),
    [anon_sym_SQUOTE] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [anon_sym_fn] = ACTIONS(1843),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_if] = ACTIONS(1843),
    [anon_sym_impl] = ACTIONS(1843),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_loop] = ACTIONS(1843),
    [anon_sym_match] = ACTIONS(1843),
    [anon_sym_mod] = ACTIONS(1843),
    [anon_sym_pub] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_struct] = ACTIONS(1843),
    [anon_sym_trait] = ACTIONS(1843),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_union] = ACTIONS(1843),
    [anon_sym_unsafe] = ACTIONS(1843),
    [anon_sym_use] = ACTIONS(1843),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_extern] = ACTIONS(1843),
    [anon_sym_DOT_DOT] = ACTIONS(1841),
    [anon_sym_yield] = ACTIONS(1843),
    [anon_sym_move] = ACTIONS(1843),
    [anon_sym_try] = ACTIONS(1843),
    [sym_integer_literal] = ACTIONS(1841),
    [aux_sym_string_literal_token1] = ACTIONS(1841),
    [sym_char_literal] = ACTIONS(1841),
    [anon_sym_true] = ACTIONS(1843),
    [anon_sym_false] = ACTIONS(1843),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [sym_crate] = ACTIONS(1843),
    [sym_metavariable] = ACTIONS(1841),
    [sym_raw_string_literal] = ACTIONS(1841),
    [sym_float_literal] = ACTIONS(1841),
  },
  [528] = {
    [sym_line_comment] = STATE(528),
    [sym_block_comment] = STATE(528),
    [ts_builtin_sym_end] = ACTIONS(1845),
    [sym_identifier] = ACTIONS(1847),
    [anon_sym_SEMI] = ACTIONS(1845),
    [anon_sym_macro_rules_BANG] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [anon_sym_LBRACE] = ACTIONS(1845),
    [anon_sym_RBRACE] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_u8] = ACTIONS(1847),
    [anon_sym_i8] = ACTIONS(1847),
    [anon_sym_u16] = ACTIONS(1847),
    [anon_sym_i16] = ACTIONS(1847),
    [anon_sym_u32] = ACTIONS(1847),
    [anon_sym_i32] = ACTIONS(1847),
    [anon_sym_u64] = ACTIONS(1847),
    [anon_sym_i64] = ACTIONS(1847),
    [anon_sym_u128] = ACTIONS(1847),
    [anon_sym_i128] = ACTIONS(1847),
    [anon_sym_isize] = ACTIONS(1847),
    [anon_sym_usize] = ACTIONS(1847),
    [anon_sym_f32] = ACTIONS(1847),
    [anon_sym_f64] = ACTIONS(1847),
    [anon_sym_bool] = ACTIONS(1847),
    [anon_sym_str] = ACTIONS(1847),
    [anon_sym_char] = ACTIONS(1847),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_COLON_COLON] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_AMP] = ACTIONS(1845),
    [anon_sym_POUND] = ACTIONS(1845),
    [anon_sym_LT] = ACTIONS(1845),
    [anon_sym_PIPE] = ACTIONS(1845),
    [anon_sym_SQUOTE] = ACTIONS(1847),
    [anon_sym_async] = ACTIONS(1847),
    [anon_sym_break] = ACTIONS(1847),
    [anon_sym_const] = ACTIONS(1847),
    [anon_sym_continue] = ACTIONS(1847),
    [anon_sym_default] = ACTIONS(1847),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_fn] = ACTIONS(1847),
    [anon_sym_for] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1847),
    [anon_sym_impl] = ACTIONS(1847),
    [anon_sym_let] = ACTIONS(1847),
    [anon_sym_loop] = ACTIONS(1847),
    [anon_sym_match] = ACTIONS(1847),
    [anon_sym_mod] = ACTIONS(1847),
    [anon_sym_pub] = ACTIONS(1847),
    [anon_sym_return] = ACTIONS(1847),
    [anon_sym_static] = ACTIONS(1847),
    [anon_sym_struct] = ACTIONS(1847),
    [anon_sym_trait] = ACTIONS(1847),
    [anon_sym_type] = ACTIONS(1847),
    [anon_sym_union] = ACTIONS(1847),
    [anon_sym_unsafe] = ACTIONS(1847),
    [anon_sym_use] = ACTIONS(1847),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_extern] = ACTIONS(1847),
    [anon_sym_DOT_DOT] = ACTIONS(1845),
    [anon_sym_yield] = ACTIONS(1847),
    [anon_sym_move] = ACTIONS(1847),
    [anon_sym_try] = ACTIONS(1847),
    [sym_integer_literal] = ACTIONS(1845),
    [aux_sym_string_literal_token1] = ACTIONS(1845),
    [sym_char_literal] = ACTIONS(1845),
    [anon_sym_true] = ACTIONS(1847),
    [anon_sym_false] = ACTIONS(1847),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1847),
    [sym_super] = ACTIONS(1847),
    [sym_crate] = ACTIONS(1847),
    [sym_metavariable] = ACTIONS(1845),
    [sym_raw_string_literal] = ACTIONS(1845),
    [sym_float_literal] = ACTIONS(1845),
  },
  [529] = {
    [sym_line_comment] = STATE(529),
    [sym_block_comment] = STATE(529),
    [ts_builtin_sym_end] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1849),
    [anon_sym_macro_rules_BANG] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_LBRACK] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1849),
    [anon_sym_RBRACE] = ACTIONS(1849),
    [anon_sym_STAR] = ACTIONS(1849),
    [anon_sym_u8] = ACTIONS(1851),
    [anon_sym_i8] = ACTIONS(1851),
    [anon_sym_u16] = ACTIONS(1851),
    [anon_sym_i16] = ACTIONS(1851),
    [anon_sym_u32] = ACTIONS(1851),
    [anon_sym_i32] = ACTIONS(1851),
    [anon_sym_u64] = ACTIONS(1851),
    [anon_sym_i64] = ACTIONS(1851),
    [anon_sym_u128] = ACTIONS(1851),
    [anon_sym_i128] = ACTIONS(1851),
    [anon_sym_isize] = ACTIONS(1851),
    [anon_sym_usize] = ACTIONS(1851),
    [anon_sym_f32] = ACTIONS(1851),
    [anon_sym_f64] = ACTIONS(1851),
    [anon_sym_bool] = ACTIONS(1851),
    [anon_sym_str] = ACTIONS(1851),
    [anon_sym_char] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_COLON_COLON] = ACTIONS(1849),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1849),
    [anon_sym_POUND] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(1849),
    [anon_sym_PIPE] = ACTIONS(1849),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [anon_sym_async] = ACTIONS(1851),
    [anon_sym_break] = ACTIONS(1851),
    [anon_sym_const] = ACTIONS(1851),
    [anon_sym_continue] = ACTIONS(1851),
    [anon_sym_default] = ACTIONS(1851),
    [anon_sym_enum] = ACTIONS(1851),
    [anon_sym_fn] = ACTIONS(1851),
    [anon_sym_for] = ACTIONS(1851),
    [anon_sym_if] = ACTIONS(1851),
    [anon_sym_impl] = ACTIONS(1851),
    [anon_sym_let] = ACTIONS(1851),
    [anon_sym_loop] = ACTIONS(1851),
    [anon_sym_match] = ACTIONS(1851),
    [anon_sym_mod] = ACTIONS(1851),
    [anon_sym_pub] = ACTIONS(1851),
    [anon_sym_return] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1851),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_trait] = ACTIONS(1851),
    [anon_sym_type] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1851),
    [anon_sym_unsafe] = ACTIONS(1851),
    [anon_sym_use] = ACTIONS(1851),
    [anon_sym_while] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1849),
    [anon_sym_yield] = ACTIONS(1851),
    [anon_sym_move] = ACTIONS(1851),
    [anon_sym_try] = ACTIONS(1851),
    [sym_integer_literal] = ACTIONS(1849),
    [aux_sym_string_literal_token1] = ACTIONS(1849),
    [sym_char_literal] = ACTIONS(1849),
    [anon_sym_true] = ACTIONS(1851),
    [anon_sym_false] = ACTIONS(1851),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1851),
    [sym_super] = ACTIONS(1851),
    [sym_crate] = ACTIONS(1851),
    [sym_metavariable] = ACTIONS(1849),
    [sym_raw_string_literal] = ACTIONS(1849),
    [sym_float_literal] = ACTIONS(1849),
  },
  [530] = {
    [sym_line_comment] = STATE(530),
    [sym_block_comment] = STATE(530),
    [ts_builtin_sym_end] = ACTIONS(1853),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_macro_rules_BANG] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_STAR] = ACTIONS(1853),
    [anon_sym_u8] = ACTIONS(1855),
    [anon_sym_i8] = ACTIONS(1855),
    [anon_sym_u16] = ACTIONS(1855),
    [anon_sym_i16] = ACTIONS(1855),
    [anon_sym_u32] = ACTIONS(1855),
    [anon_sym_i32] = ACTIONS(1855),
    [anon_sym_u64] = ACTIONS(1855),
    [anon_sym_i64] = ACTIONS(1855),
    [anon_sym_u128] = ACTIONS(1855),
    [anon_sym_i128] = ACTIONS(1855),
    [anon_sym_isize] = ACTIONS(1855),
    [anon_sym_usize] = ACTIONS(1855),
    [anon_sym_f32] = ACTIONS(1855),
    [anon_sym_f64] = ACTIONS(1855),
    [anon_sym_bool] = ACTIONS(1855),
    [anon_sym_str] = ACTIONS(1855),
    [anon_sym_char] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1853),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1853),
    [anon_sym_POUND] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1853),
    [anon_sym_SQUOTE] = ACTIONS(1855),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_break] = ACTIONS(1855),
    [anon_sym_const] = ACTIONS(1855),
    [anon_sym_continue] = ACTIONS(1855),
    [anon_sym_default] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1855),
    [anon_sym_fn] = ACTIONS(1855),
    [anon_sym_for] = ACTIONS(1855),
    [anon_sym_if] = ACTIONS(1855),
    [anon_sym_impl] = ACTIONS(1855),
    [anon_sym_let] = ACTIONS(1855),
    [anon_sym_loop] = ACTIONS(1855),
    [anon_sym_match] = ACTIONS(1855),
    [anon_sym_mod] = ACTIONS(1855),
    [anon_sym_pub] = ACTIONS(1855),
    [anon_sym_return] = ACTIONS(1855),
    [anon_sym_static] = ACTIONS(1855),
    [anon_sym_struct] = ACTIONS(1855),
    [anon_sym_trait] = ACTIONS(1855),
    [anon_sym_type] = ACTIONS(1855),
    [anon_sym_union] = ACTIONS(1855),
    [anon_sym_unsafe] = ACTIONS(1855),
    [anon_sym_use] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(1855),
    [anon_sym_extern] = ACTIONS(1855),
    [anon_sym_DOT_DOT] = ACTIONS(1853),
    [anon_sym_yield] = ACTIONS(1855),
    [anon_sym_move] = ACTIONS(1855),
    [anon_sym_try] = ACTIONS(1855),
    [sym_integer_literal] = ACTIONS(1853),
    [aux_sym_string_literal_token1] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [anon_sym_true] = ACTIONS(1855),
    [anon_sym_false] = ACTIONS(1855),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1855),
    [sym_super] = ACTIONS(1855),
    [sym_crate] = ACTIONS(1855),
    [sym_metavariable] = ACTIONS(1853),
    [sym_raw_string_literal] = ACTIONS(1853),
    [sym_float_literal] = ACTIONS(1853),
  },
  [531] = {
    [sym_line_comment] = STATE(531),
    [sym_block_comment] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [sym_identifier] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_macro_rules_BANG] = ACTIONS(1857),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(1857),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_STAR] = ACTIONS(1857),
    [anon_sym_u8] = ACTIONS(1859),
    [anon_sym_i8] = ACTIONS(1859),
    [anon_sym_u16] = ACTIONS(1859),
    [anon_sym_i16] = ACTIONS(1859),
    [anon_sym_u32] = ACTIONS(1859),
    [anon_sym_i32] = ACTIONS(1859),
    [anon_sym_u64] = ACTIONS(1859),
    [anon_sym_i64] = ACTIONS(1859),
    [anon_sym_u128] = ACTIONS(1859),
    [anon_sym_i128] = ACTIONS(1859),
    [anon_sym_isize] = ACTIONS(1859),
    [anon_sym_usize] = ACTIONS(1859),
    [anon_sym_f32] = ACTIONS(1859),
    [anon_sym_f64] = ACTIONS(1859),
    [anon_sym_bool] = ACTIONS(1859),
    [anon_sym_str] = ACTIONS(1859),
    [anon_sym_char] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1857),
    [anon_sym_COLON_COLON] = ACTIONS(1857),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_AMP] = ACTIONS(1857),
    [anon_sym_POUND] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1859),
    [anon_sym_continue] = ACTIONS(1859),
    [anon_sym_default] = ACTIONS(1859),
    [anon_sym_enum] = ACTIONS(1859),
    [anon_sym_fn] = ACTIONS(1859),
    [anon_sym_for] = ACTIONS(1859),
    [anon_sym_if] = ACTIONS(1859),
    [anon_sym_impl] = ACTIONS(1859),
    [anon_sym_let] = ACTIONS(1859),
    [anon_sym_loop] = ACTIONS(1859),
    [anon_sym_match] = ACTIONS(1859),
    [anon_sym_mod] = ACTIONS(1859),
    [anon_sym_pub] = ACTIONS(1859),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1859),
    [anon_sym_trait] = ACTIONS(1859),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_union] = ACTIONS(1859),
    [anon_sym_unsafe] = ACTIONS(1859),
    [anon_sym_use] = ACTIONS(1859),
    [anon_sym_while] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1857),
    [anon_sym_yield] = ACTIONS(1859),
    [anon_sym_move] = ACTIONS(1859),
    [anon_sym_try] = ACTIONS(1859),
    [sym_integer_literal] = ACTIONS(1857),
    [aux_sym_string_literal_token1] = ACTIONS(1857),
    [sym_char_literal] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1859),
    [anon_sym_false] = ACTIONS(1859),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1859),
    [sym_super] = ACTIONS(1859),
    [sym_crate] = ACTIONS(1859),
    [sym_metavariable] = ACTIONS(1857),
    [sym_raw_string_literal] = ACTIONS(1857),
    [sym_float_literal] = ACTIONS(1857),
  },
  [532] = {
    [sym_line_comment] = STATE(532),
    [sym_block_comment] = STATE(532),
    [ts_builtin_sym_end] = ACTIONS(1861),
    [sym_identifier] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1861),
    [anon_sym_macro_rules_BANG] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1861),
    [anon_sym_u8] = ACTIONS(1863),
    [anon_sym_i8] = ACTIONS(1863),
    [anon_sym_u16] = ACTIONS(1863),
    [anon_sym_i16] = ACTIONS(1863),
    [anon_sym_u32] = ACTIONS(1863),
    [anon_sym_i32] = ACTIONS(1863),
    [anon_sym_u64] = ACTIONS(1863),
    [anon_sym_i64] = ACTIONS(1863),
    [anon_sym_u128] = ACTIONS(1863),
    [anon_sym_i128] = ACTIONS(1863),
    [anon_sym_isize] = ACTIONS(1863),
    [anon_sym_usize] = ACTIONS(1863),
    [anon_sym_f32] = ACTIONS(1863),
    [anon_sym_f64] = ACTIONS(1863),
    [anon_sym_bool] = ACTIONS(1863),
    [anon_sym_str] = ACTIONS(1863),
    [anon_sym_char] = ACTIONS(1863),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_COLON_COLON] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_POUND] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_SQUOTE] = ACTIONS(1863),
    [anon_sym_async] = ACTIONS(1863),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_const] = ACTIONS(1863),
    [anon_sym_continue] = ACTIONS(1863),
    [anon_sym_default] = ACTIONS(1863),
    [anon_sym_enum] = ACTIONS(1863),
    [anon_sym_fn] = ACTIONS(1863),
    [anon_sym_for] = ACTIONS(1863),
    [anon_sym_if] = ACTIONS(1863),
    [anon_sym_impl] = ACTIONS(1863),
    [anon_sym_let] = ACTIONS(1863),
    [anon_sym_loop] = ACTIONS(1863),
    [anon_sym_match] = ACTIONS(1863),
    [anon_sym_mod] = ACTIONS(1863),
    [anon_sym_pub] = ACTIONS(1863),
    [anon_sym_return] = ACTIONS(1863),
    [anon_sym_static] = ACTIONS(1863),
    [anon_sym_struct] = ACTIONS(1863),
    [anon_sym_trait] = ACTIONS(1863),
    [anon_sym_type] = ACTIONS(1863),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_unsafe] = ACTIONS(1863),
    [anon_sym_use] = ACTIONS(1863),
    [anon_sym_while] = ACTIONS(1863),
    [anon_sym_extern] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1863),
    [anon_sym_move] = ACTIONS(1863),
    [anon_sym_try] = ACTIONS(1863),
    [sym_integer_literal] = ACTIONS(1861),
    [aux_sym_string_literal_token1] = ACTIONS(1861),
    [sym_char_literal] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1863),
    [anon_sym_false] = ACTIONS(1863),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1863),
    [sym_super] = ACTIONS(1863),
    [sym_crate] = ACTIONS(1863),
    [sym_metavariable] = ACTIONS(1861),
    [sym_raw_string_literal] = ACTIONS(1861),
    [sym_float_literal] = ACTIONS(1861),
  },
  [533] = {
    [sym_line_comment] = STATE(533),
    [sym_block_comment] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(1865),
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_macro_rules_BANG] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_STAR] = ACTIONS(1865),
    [anon_sym_u8] = ACTIONS(1867),
    [anon_sym_i8] = ACTIONS(1867),
    [anon_sym_u16] = ACTIONS(1867),
    [anon_sym_i16] = ACTIONS(1867),
    [anon_sym_u32] = ACTIONS(1867),
    [anon_sym_i32] = ACTIONS(1867),
    [anon_sym_u64] = ACTIONS(1867),
    [anon_sym_i64] = ACTIONS(1867),
    [anon_sym_u128] = ACTIONS(1867),
    [anon_sym_i128] = ACTIONS(1867),
    [anon_sym_isize] = ACTIONS(1867),
    [anon_sym_usize] = ACTIONS(1867),
    [anon_sym_f32] = ACTIONS(1867),
    [anon_sym_f64] = ACTIONS(1867),
    [anon_sym_bool] = ACTIONS(1867),
    [anon_sym_str] = ACTIONS(1867),
    [anon_sym_char] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1865),
    [anon_sym_COLON_COLON] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_POUND] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1865),
    [anon_sym_SQUOTE] = ACTIONS(1867),
    [anon_sym_async] = ACTIONS(1867),
    [anon_sym_break] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(1867),
    [anon_sym_continue] = ACTIONS(1867),
    [anon_sym_default] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1867),
    [anon_sym_fn] = ACTIONS(1867),
    [anon_sym_for] = ACTIONS(1867),
    [anon_sym_if] = ACTIONS(1867),
    [anon_sym_impl] = ACTIONS(1867),
    [anon_sym_let] = ACTIONS(1867),
    [anon_sym_loop] = ACTIONS(1867),
    [anon_sym_match] = ACTIONS(1867),
    [anon_sym_mod] = ACTIONS(1867),
    [anon_sym_pub] = ACTIONS(1867),
    [anon_sym_return] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1867),
    [anon_sym_struct] = ACTIONS(1867),
    [anon_sym_trait] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1867),
    [anon_sym_union] = ACTIONS(1867),
    [anon_sym_unsafe] = ACTIONS(1867),
    [anon_sym_use] = ACTIONS(1867),
    [anon_sym_while] = ACTIONS(1867),
    [anon_sym_extern] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1865),
    [anon_sym_yield] = ACTIONS(1867),
    [anon_sym_move] = ACTIONS(1867),
    [anon_sym_try] = ACTIONS(1867),
    [sym_integer_literal] = ACTIONS(1865),
    [aux_sym_string_literal_token1] = ACTIONS(1865),
    [sym_char_literal] = ACTIONS(1865),
    [anon_sym_true] = ACTIONS(1867),
    [anon_sym_false] = ACTIONS(1867),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1867),
    [sym_super] = ACTIONS(1867),
    [sym_crate] = ACTIONS(1867),
    [sym_metavariable] = ACTIONS(1865),
    [sym_raw_string_literal] = ACTIONS(1865),
    [sym_float_literal] = ACTIONS(1865),
  },
  [534] = {
    [sym_line_comment] = STATE(534),
    [sym_block_comment] = STATE(534),
    [ts_builtin_sym_end] = ACTIONS(1869),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_macro_rules_BANG] = ACTIONS(1869),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1869),
    [anon_sym_RBRACE] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_u8] = ACTIONS(1871),
    [anon_sym_i8] = ACTIONS(1871),
    [anon_sym_u16] = ACTIONS(1871),
    [anon_sym_i16] = ACTIONS(1871),
    [anon_sym_u32] = ACTIONS(1871),
    [anon_sym_i32] = ACTIONS(1871),
    [anon_sym_u64] = ACTIONS(1871),
    [anon_sym_i64] = ACTIONS(1871),
    [anon_sym_u128] = ACTIONS(1871),
    [anon_sym_i128] = ACTIONS(1871),
    [anon_sym_isize] = ACTIONS(1871),
    [anon_sym_usize] = ACTIONS(1871),
    [anon_sym_f32] = ACTIONS(1871),
    [anon_sym_f64] = ACTIONS(1871),
    [anon_sym_bool] = ACTIONS(1871),
    [anon_sym_str] = ACTIONS(1871),
    [anon_sym_char] = ACTIONS(1871),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_COLON_COLON] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_POUND] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_break] = ACTIONS(1871),
    [anon_sym_const] = ACTIONS(1871),
    [anon_sym_continue] = ACTIONS(1871),
    [anon_sym_default] = ACTIONS(1871),
    [anon_sym_enum] = ACTIONS(1871),
    [anon_sym_fn] = ACTIONS(1871),
    [anon_sym_for] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1871),
    [anon_sym_impl] = ACTIONS(1871),
    [anon_sym_let] = ACTIONS(1871),
    [anon_sym_loop] = ACTIONS(1871),
    [anon_sym_match] = ACTIONS(1871),
    [anon_sym_mod] = ACTIONS(1871),
    [anon_sym_pub] = ACTIONS(1871),
    [anon_sym_return] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1871),
    [anon_sym_struct] = ACTIONS(1871),
    [anon_sym_trait] = ACTIONS(1871),
    [anon_sym_type] = ACTIONS(1871),
    [anon_sym_union] = ACTIONS(1871),
    [anon_sym_unsafe] = ACTIONS(1871),
    [anon_sym_use] = ACTIONS(1871),
    [anon_sym_while] = ACTIONS(1871),
    [anon_sym_extern] = ACTIONS(1871),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_yield] = ACTIONS(1871),
    [anon_sym_move] = ACTIONS(1871),
    [anon_sym_try] = ACTIONS(1871),
    [sym_integer_literal] = ACTIONS(1869),
    [aux_sym_string_literal_token1] = ACTIONS(1869),
    [sym_char_literal] = ACTIONS(1869),
    [anon_sym_true] = ACTIONS(1871),
    [anon_sym_false] = ACTIONS(1871),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1871),
    [sym_super] = ACTIONS(1871),
    [sym_crate] = ACTIONS(1871),
    [sym_metavariable] = ACTIONS(1869),
    [sym_raw_string_literal] = ACTIONS(1869),
    [sym_float_literal] = ACTIONS(1869),
  },
  [535] = {
    [sym_line_comment] = STATE(535),
    [sym_block_comment] = STATE(535),
    [ts_builtin_sym_end] = ACTIONS(1873),
    [sym_identifier] = ACTIONS(1875),
    [anon_sym_SEMI] = ACTIONS(1873),
    [anon_sym_macro_rules_BANG] = ACTIONS(1873),
    [anon_sym_LPAREN] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1873),
    [anon_sym_RBRACE] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_u8] = ACTIONS(1875),
    [anon_sym_i8] = ACTIONS(1875),
    [anon_sym_u16] = ACTIONS(1875),
    [anon_sym_i16] = ACTIONS(1875),
    [anon_sym_u32] = ACTIONS(1875),
    [anon_sym_i32] = ACTIONS(1875),
    [anon_sym_u64] = ACTIONS(1875),
    [anon_sym_i64] = ACTIONS(1875),
    [anon_sym_u128] = ACTIONS(1875),
    [anon_sym_i128] = ACTIONS(1875),
    [anon_sym_isize] = ACTIONS(1875),
    [anon_sym_usize] = ACTIONS(1875),
    [anon_sym_f32] = ACTIONS(1875),
    [anon_sym_f64] = ACTIONS(1875),
    [anon_sym_bool] = ACTIONS(1875),
    [anon_sym_str] = ACTIONS(1875),
    [anon_sym_char] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_COLON_COLON] = ACTIONS(1873),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_AMP] = ACTIONS(1873),
    [anon_sym_POUND] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(1873),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_SQUOTE] = ACTIONS(1875),
    [anon_sym_async] = ACTIONS(1875),
    [anon_sym_break] = ACTIONS(1875),
    [anon_sym_const] = ACTIONS(1875),
    [anon_sym_continue] = ACTIONS(1875),
    [anon_sym_default] = ACTIONS(1875),
    [anon_sym_enum] = ACTIONS(1875),
    [anon_sym_fn] = ACTIONS(1875),
    [anon_sym_for] = ACTIONS(1875),
    [anon_sym_if] = ACTIONS(1875),
    [anon_sym_impl] = ACTIONS(1875),
    [anon_sym_let] = ACTIONS(1875),
    [anon_sym_loop] = ACTIONS(1875),
    [anon_sym_match] = ACTIONS(1875),
    [anon_sym_mod] = ACTIONS(1875),
    [anon_sym_pub] = ACTIONS(1875),
    [anon_sym_return] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1875),
    [anon_sym_struct] = ACTIONS(1875),
    [anon_sym_trait] = ACTIONS(1875),
    [anon_sym_type] = ACTIONS(1875),
    [anon_sym_union] = ACTIONS(1875),
    [anon_sym_unsafe] = ACTIONS(1875),
    [anon_sym_use] = ACTIONS(1875),
    [anon_sym_while] = ACTIONS(1875),
    [anon_sym_extern] = ACTIONS(1875),
    [anon_sym_DOT_DOT] = ACTIONS(1873),
    [anon_sym_yield] = ACTIONS(1875),
    [anon_sym_move] = ACTIONS(1875),
    [anon_sym_try] = ACTIONS(1875),
    [sym_integer_literal] = ACTIONS(1873),
    [aux_sym_string_literal_token1] = ACTIONS(1873),
    [sym_char_literal] = ACTIONS(1873),
    [anon_sym_true] = ACTIONS(1875),
    [anon_sym_false] = ACTIONS(1875),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1875),
    [sym_super] = ACTIONS(1875),
    [sym_crate] = ACTIONS(1875),
    [sym_metavariable] = ACTIONS(1873),
    [sym_raw_string_literal] = ACTIONS(1873),
    [sym_float_literal] = ACTIONS(1873),
  },
  [536] = {
    [sym_line_comment] = STATE(536),
    [sym_block_comment] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [anon_sym_SEMI] = ACTIONS(1877),
    [anon_sym_macro_rules_BANG] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_u8] = ACTIONS(1879),
    [anon_sym_i8] = ACTIONS(1879),
    [anon_sym_u16] = ACTIONS(1879),
    [anon_sym_i16] = ACTIONS(1879),
    [anon_sym_u32] = ACTIONS(1879),
    [anon_sym_i32] = ACTIONS(1879),
    [anon_sym_u64] = ACTIONS(1879),
    [anon_sym_i64] = ACTIONS(1879),
    [anon_sym_u128] = ACTIONS(1879),
    [anon_sym_i128] = ACTIONS(1879),
    [anon_sym_isize] = ACTIONS(1879),
    [anon_sym_usize] = ACTIONS(1879),
    [anon_sym_f32] = ACTIONS(1879),
    [anon_sym_f64] = ACTIONS(1879),
    [anon_sym_bool] = ACTIONS(1879),
    [anon_sym_str] = ACTIONS(1879),
    [anon_sym_char] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_COLON_COLON] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1877),
    [anon_sym_AMP] = ACTIONS(1877),
    [anon_sym_POUND] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1877),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_async] = ACTIONS(1879),
    [anon_sym_break] = ACTIONS(1879),
    [anon_sym_const] = ACTIONS(1879),
    [anon_sym_continue] = ACTIONS(1879),
    [anon_sym_default] = ACTIONS(1879),
    [anon_sym_enum] = ACTIONS(1879),
    [anon_sym_fn] = ACTIONS(1879),
    [anon_sym_for] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1879),
    [anon_sym_impl] = ACTIONS(1879),
    [anon_sym_let] = ACTIONS(1879),
    [anon_sym_loop] = ACTIONS(1879),
    [anon_sym_match] = ACTIONS(1879),
    [anon_sym_mod] = ACTIONS(1879),
    [anon_sym_pub] = ACTIONS(1879),
    [anon_sym_return] = ACTIONS(1879),
    [anon_sym_static] = ACTIONS(1879),
    [anon_sym_struct] = ACTIONS(1879),
    [anon_sym_trait] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1879),
    [anon_sym_union] = ACTIONS(1879),
    [anon_sym_unsafe] = ACTIONS(1879),
    [anon_sym_use] = ACTIONS(1879),
    [anon_sym_while] = ACTIONS(1879),
    [anon_sym_extern] = ACTIONS(1879),
    [anon_sym_DOT_DOT] = ACTIONS(1877),
    [anon_sym_yield] = ACTIONS(1879),
    [anon_sym_move] = ACTIONS(1879),
    [anon_sym_try] = ACTIONS(1879),
    [sym_integer_literal] = ACTIONS(1877),
    [aux_sym_string_literal_token1] = ACTIONS(1877),
    [sym_char_literal] = ACTIONS(1877),
    [anon_sym_true] = ACTIONS(1879),
    [anon_sym_false] = ACTIONS(1879),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1879),
    [sym_super] = ACTIONS(1879),
    [sym_crate] = ACTIONS(1879),
    [sym_metavariable] = ACTIONS(1877),
    [sym_raw_string_literal] = ACTIONS(1877),
    [sym_float_literal] = ACTIONS(1877),
  },
  [537] = {
    [sym_line_comment] = STATE(537),
    [sym_block_comment] = STATE(537),
    [ts_builtin_sym_end] = ACTIONS(1881),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1881),
    [anon_sym_macro_rules_BANG] = ACTIONS(1881),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1881),
    [anon_sym_LBRACE] = ACTIONS(1881),
    [anon_sym_RBRACE] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_u8] = ACTIONS(1883),
    [anon_sym_i8] = ACTIONS(1883),
    [anon_sym_u16] = ACTIONS(1883),
    [anon_sym_i16] = ACTIONS(1883),
    [anon_sym_u32] = ACTIONS(1883),
    [anon_sym_i32] = ACTIONS(1883),
    [anon_sym_u64] = ACTIONS(1883),
    [anon_sym_i64] = ACTIONS(1883),
    [anon_sym_u128] = ACTIONS(1883),
    [anon_sym_i128] = ACTIONS(1883),
    [anon_sym_isize] = ACTIONS(1883),
    [anon_sym_usize] = ACTIONS(1883),
    [anon_sym_f32] = ACTIONS(1883),
    [anon_sym_f64] = ACTIONS(1883),
    [anon_sym_bool] = ACTIONS(1883),
    [anon_sym_str] = ACTIONS(1883),
    [anon_sym_char] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_COLON_COLON] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1881),
    [anon_sym_AMP] = ACTIONS(1881),
    [anon_sym_POUND] = ACTIONS(1881),
    [anon_sym_LT] = ACTIONS(1881),
    [anon_sym_PIPE] = ACTIONS(1881),
    [anon_sym_SQUOTE] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1883),
    [anon_sym_break] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(1883),
    [anon_sym_continue] = ACTIONS(1883),
    [anon_sym_default] = ACTIONS(1883),
    [anon_sym_enum] = ACTIONS(1883),
    [anon_sym_fn] = ACTIONS(1883),
    [anon_sym_for] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1883),
    [anon_sym_impl] = ACTIONS(1883),
    [anon_sym_let] = ACTIONS(1883),
    [anon_sym_loop] = ACTIONS(1883),
    [anon_sym_match] = ACTIONS(1883),
    [anon_sym_mod] = ACTIONS(1883),
    [anon_sym_pub] = ACTIONS(1883),
    [anon_sym_return] = ACTIONS(1883),
    [anon_sym_static] = ACTIONS(1883),
    [anon_sym_struct] = ACTIONS(1883),
    [anon_sym_trait] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_union] = ACTIONS(1883),
    [anon_sym_unsafe] = ACTIONS(1883),
    [anon_sym_use] = ACTIONS(1883),
    [anon_sym_while] = ACTIONS(1883),
    [anon_sym_extern] = ACTIONS(1883),
    [anon_sym_DOT_DOT] = ACTIONS(1881),
    [anon_sym_yield] = ACTIONS(1883),
    [anon_sym_move] = ACTIONS(1883),
    [anon_sym_try] = ACTIONS(1883),
    [sym_integer_literal] = ACTIONS(1881),
    [aux_sym_string_literal_token1] = ACTIONS(1881),
    [sym_char_literal] = ACTIONS(1881),
    [anon_sym_true] = ACTIONS(1883),
    [anon_sym_false] = ACTIONS(1883),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1883),
    [sym_super] = ACTIONS(1883),
    [sym_crate] = ACTIONS(1883),
    [sym_metavariable] = ACTIONS(1881),
    [sym_raw_string_literal] = ACTIONS(1881),
    [sym_float_literal] = ACTIONS(1881),
  },
  [538] = {
    [sym_line_comment] = STATE(538),
    [sym_block_comment] = STATE(538),
    [ts_builtin_sym_end] = ACTIONS(1885),
    [sym_identifier] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_macro_rules_BANG] = ACTIONS(1885),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_u8] = ACTIONS(1887),
    [anon_sym_i8] = ACTIONS(1887),
    [anon_sym_u16] = ACTIONS(1887),
    [anon_sym_i16] = ACTIONS(1887),
    [anon_sym_u32] = ACTIONS(1887),
    [anon_sym_i32] = ACTIONS(1887),
    [anon_sym_u64] = ACTIONS(1887),
    [anon_sym_i64] = ACTIONS(1887),
    [anon_sym_u128] = ACTIONS(1887),
    [anon_sym_i128] = ACTIONS(1887),
    [anon_sym_isize] = ACTIONS(1887),
    [anon_sym_usize] = ACTIONS(1887),
    [anon_sym_f32] = ACTIONS(1887),
    [anon_sym_f64] = ACTIONS(1887),
    [anon_sym_bool] = ACTIONS(1887),
    [anon_sym_str] = ACTIONS(1887),
    [anon_sym_char] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
    [anon_sym_POUND] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(1887),
    [anon_sym_async] = ACTIONS(1887),
    [anon_sym_break] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1887),
    [anon_sym_continue] = ACTIONS(1887),
    [anon_sym_default] = ACTIONS(1887),
    [anon_sym_enum] = ACTIONS(1887),
    [anon_sym_fn] = ACTIONS(1887),
    [anon_sym_for] = ACTIONS(1887),
    [anon_sym_if] = ACTIONS(1887),
    [anon_sym_impl] = ACTIONS(1887),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_loop] = ACTIONS(1887),
    [anon_sym_match] = ACTIONS(1887),
    [anon_sym_mod] = ACTIONS(1887),
    [anon_sym_pub] = ACTIONS(1887),
    [anon_sym_return] = ACTIONS(1887),
    [anon_sym_static] = ACTIONS(1887),
    [anon_sym_struct] = ACTIONS(1887),
    [anon_sym_trait] = ACTIONS(1887),
    [anon_sym_type] = ACTIONS(1887),
    [anon_sym_union] = ACTIONS(1887),
    [anon_sym_unsafe] = ACTIONS(1887),
    [anon_sym_use] = ACTIONS(1887),
    [anon_sym_while] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(1887),
    [anon_sym_DOT_DOT] = ACTIONS(1885),
    [anon_sym_yield] = ACTIONS(1887),
    [anon_sym_move] = ACTIONS(1887),
    [anon_sym_try] = ACTIONS(1887),
    [sym_integer_literal] = ACTIONS(1885),
    [aux_sym_string_literal_token1] = ACTIONS(1885),
    [sym_char_literal] = ACTIONS(1885),
    [anon_sym_true] = ACTIONS(1887),
    [anon_sym_false] = ACTIONS(1887),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1887),
    [sym_super] = ACTIONS(1887),
    [sym_crate] = ACTIONS(1887),
    [sym_metavariable] = ACTIONS(1885),
    [sym_raw_string_literal] = ACTIONS(1885),
    [sym_float_literal] = ACTIONS(1885),
  },
  [539] = {
    [sym_line_comment] = STATE(539),
    [sym_block_comment] = STATE(539),
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_macro_rules_BANG] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_STAR] = ACTIONS(1889),
    [anon_sym_u8] = ACTIONS(1891),
    [anon_sym_i8] = ACTIONS(1891),
    [anon_sym_u16] = ACTIONS(1891),
    [anon_sym_i16] = ACTIONS(1891),
    [anon_sym_u32] = ACTIONS(1891),
    [anon_sym_i32] = ACTIONS(1891),
    [anon_sym_u64] = ACTIONS(1891),
    [anon_sym_i64] = ACTIONS(1891),
    [anon_sym_u128] = ACTIONS(1891),
    [anon_sym_i128] = ACTIONS(1891),
    [anon_sym_isize] = ACTIONS(1891),
    [anon_sym_usize] = ACTIONS(1891),
    [anon_sym_f32] = ACTIONS(1891),
    [anon_sym_f64] = ACTIONS(1891),
    [anon_sym_bool] = ACTIONS(1891),
    [anon_sym_str] = ACTIONS(1891),
    [anon_sym_char] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_POUND] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_break] = ACTIONS(1891),
    [anon_sym_const] = ACTIONS(1891),
    [anon_sym_continue] = ACTIONS(1891),
    [anon_sym_default] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_fn] = ACTIONS(1891),
    [anon_sym_for] = ACTIONS(1891),
    [anon_sym_if] = ACTIONS(1891),
    [anon_sym_impl] = ACTIONS(1891),
    [anon_sym_let] = ACTIONS(1891),
    [anon_sym_loop] = ACTIONS(1891),
    [anon_sym_match] = ACTIONS(1891),
    [anon_sym_mod] = ACTIONS(1891),
    [anon_sym_pub] = ACTIONS(1891),
    [anon_sym_return] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1891),
    [anon_sym_trait] = ACTIONS(1891),
    [anon_sym_type] = ACTIONS(1891),
    [anon_sym_union] = ACTIONS(1891),
    [anon_sym_unsafe] = ACTIONS(1891),
    [anon_sym_use] = ACTIONS(1891),
    [anon_sym_while] = ACTIONS(1891),
    [anon_sym_extern] = ACTIONS(1891),
    [anon_sym_DOT_DOT] = ACTIONS(1889),
    [anon_sym_yield] = ACTIONS(1891),
    [anon_sym_move] = ACTIONS(1891),
    [anon_sym_try] = ACTIONS(1891),
    [sym_integer_literal] = ACTIONS(1889),
    [aux_sym_string_literal_token1] = ACTIONS(1889),
    [sym_char_literal] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1891),
    [anon_sym_false] = ACTIONS(1891),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1891),
    [sym_super] = ACTIONS(1891),
    [sym_crate] = ACTIONS(1891),
    [sym_metavariable] = ACTIONS(1889),
    [sym_raw_string_literal] = ACTIONS(1889),
    [sym_float_literal] = ACTIONS(1889),
  },
  [540] = {
    [sym_line_comment] = STATE(540),
    [sym_block_comment] = STATE(540),
    [ts_builtin_sym_end] = ACTIONS(1893),
    [sym_identifier] = ACTIONS(1895),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_macro_rules_BANG] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(1893),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_u8] = ACTIONS(1895),
    [anon_sym_i8] = ACTIONS(1895),
    [anon_sym_u16] = ACTIONS(1895),
    [anon_sym_i16] = ACTIONS(1895),
    [anon_sym_u32] = ACTIONS(1895),
    [anon_sym_i32] = ACTIONS(1895),
    [anon_sym_u64] = ACTIONS(1895),
    [anon_sym_i64] = ACTIONS(1895),
    [anon_sym_u128] = ACTIONS(1895),
    [anon_sym_i128] = ACTIONS(1895),
    [anon_sym_isize] = ACTIONS(1895),
    [anon_sym_usize] = ACTIONS(1895),
    [anon_sym_f32] = ACTIONS(1895),
    [anon_sym_f64] = ACTIONS(1895),
    [anon_sym_bool] = ACTIONS(1895),
    [anon_sym_str] = ACTIONS(1895),
    [anon_sym_char] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_POUND] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1893),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_async] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1895),
    [anon_sym_const] = ACTIONS(1895),
    [anon_sym_continue] = ACTIONS(1895),
    [anon_sym_default] = ACTIONS(1895),
    [anon_sym_enum] = ACTIONS(1895),
    [anon_sym_fn] = ACTIONS(1895),
    [anon_sym_for] = ACTIONS(1895),
    [anon_sym_if] = ACTIONS(1895),
    [anon_sym_impl] = ACTIONS(1895),
    [anon_sym_let] = ACTIONS(1895),
    [anon_sym_loop] = ACTIONS(1895),
    [anon_sym_match] = ACTIONS(1895),
    [anon_sym_mod] = ACTIONS(1895),
    [anon_sym_pub] = ACTIONS(1895),
    [anon_sym_return] = ACTIONS(1895),
    [anon_sym_static] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1895),
    [anon_sym_trait] = ACTIONS(1895),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_union] = ACTIONS(1895),
    [anon_sym_unsafe] = ACTIONS(1895),
    [anon_sym_use] = ACTIONS(1895),
    [anon_sym_while] = ACTIONS(1895),
    [anon_sym_extern] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_move] = ACTIONS(1895),
    [anon_sym_try] = ACTIONS(1895),
    [sym_integer_literal] = ACTIONS(1893),
    [aux_sym_string_literal_token1] = ACTIONS(1893),
    [sym_char_literal] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(1895),
    [anon_sym_false] = ACTIONS(1895),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1895),
    [sym_super] = ACTIONS(1895),
    [sym_crate] = ACTIONS(1895),
    [sym_metavariable] = ACTIONS(1893),
    [sym_raw_string_literal] = ACTIONS(1893),
    [sym_float_literal] = ACTIONS(1893),
  },
  [541] = {
    [sym_line_comment] = STATE(541),
    [sym_block_comment] = STATE(541),
    [ts_builtin_sym_end] = ACTIONS(1897),
    [sym_identifier] = ACTIONS(1899),
    [anon_sym_SEMI] = ACTIONS(1897),
    [anon_sym_macro_rules_BANG] = ACTIONS(1897),
    [anon_sym_LPAREN] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1897),
    [anon_sym_RBRACE] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1897),
    [anon_sym_u8] = ACTIONS(1899),
    [anon_sym_i8] = ACTIONS(1899),
    [anon_sym_u16] = ACTIONS(1899),
    [anon_sym_i16] = ACTIONS(1899),
    [anon_sym_u32] = ACTIONS(1899),
    [anon_sym_i32] = ACTIONS(1899),
    [anon_sym_u64] = ACTIONS(1899),
    [anon_sym_i64] = ACTIONS(1899),
    [anon_sym_u128] = ACTIONS(1899),
    [anon_sym_i128] = ACTIONS(1899),
    [anon_sym_isize] = ACTIONS(1899),
    [anon_sym_usize] = ACTIONS(1899),
    [anon_sym_f32] = ACTIONS(1899),
    [anon_sym_f64] = ACTIONS(1899),
    [anon_sym_bool] = ACTIONS(1899),
    [anon_sym_str] = ACTIONS(1899),
    [anon_sym_char] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1897),
    [anon_sym_BANG] = ACTIONS(1897),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_POUND] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1897),
    [anon_sym_PIPE] = ACTIONS(1897),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_async] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1899),
    [anon_sym_const] = ACTIONS(1899),
    [anon_sym_continue] = ACTIONS(1899),
    [anon_sym_default] = ACTIONS(1899),
    [anon_sym_enum] = ACTIONS(1899),
    [anon_sym_fn] = ACTIONS(1899),
    [anon_sym_for] = ACTIONS(1899),
    [anon_sym_if] = ACTIONS(1899),
    [anon_sym_impl] = ACTIONS(1899),
    [anon_sym_let] = ACTIONS(1899),
    [anon_sym_loop] = ACTIONS(1899),
    [anon_sym_match] = ACTIONS(1899),
    [anon_sym_mod] = ACTIONS(1899),
    [anon_sym_pub] = ACTIONS(1899),
    [anon_sym_return] = ACTIONS(1899),
    [anon_sym_static] = ACTIONS(1899),
    [anon_sym_struct] = ACTIONS(1899),
    [anon_sym_trait] = ACTIONS(1899),
    [anon_sym_type] = ACTIONS(1899),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_unsafe] = ACTIONS(1899),
    [anon_sym_use] = ACTIONS(1899),
    [anon_sym_while] = ACTIONS(1899),
    [anon_sym_extern] = ACTIONS(1899),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_move] = ACTIONS(1899),
    [anon_sym_try] = ACTIONS(1899),
    [sym_integer_literal] = ACTIONS(1897),
    [aux_sym_string_literal_token1] = ACTIONS(1897),
    [sym_char_literal] = ACTIONS(1897),
    [anon_sym_true] = ACTIONS(1899),
    [anon_sym_false] = ACTIONS(1899),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1899),
    [sym_super] = ACTIONS(1899),
    [sym_crate] = ACTIONS(1899),
    [sym_metavariable] = ACTIONS(1897),
    [sym_raw_string_literal] = ACTIONS(1897),
    [sym_float_literal] = ACTIONS(1897),
  },
  [542] = {
    [sym_line_comment] = STATE(542),
    [sym_block_comment] = STATE(542),
    [ts_builtin_sym_end] = ACTIONS(1901),
    [sym_identifier] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1901),
    [anon_sym_macro_rules_BANG] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_u8] = ACTIONS(1903),
    [anon_sym_i8] = ACTIONS(1903),
    [anon_sym_u16] = ACTIONS(1903),
    [anon_sym_i16] = ACTIONS(1903),
    [anon_sym_u32] = ACTIONS(1903),
    [anon_sym_i32] = ACTIONS(1903),
    [anon_sym_u64] = ACTIONS(1903),
    [anon_sym_i64] = ACTIONS(1903),
    [anon_sym_u128] = ACTIONS(1903),
    [anon_sym_i128] = ACTIONS(1903),
    [anon_sym_isize] = ACTIONS(1903),
    [anon_sym_usize] = ACTIONS(1903),
    [anon_sym_f32] = ACTIONS(1903),
    [anon_sym_f64] = ACTIONS(1903),
    [anon_sym_bool] = ACTIONS(1903),
    [anon_sym_str] = ACTIONS(1903),
    [anon_sym_char] = ACTIONS(1903),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1901),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_POUND] = ACTIONS(1901),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_PIPE] = ACTIONS(1901),
    [anon_sym_SQUOTE] = ACTIONS(1903),
    [anon_sym_async] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_fn] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_impl] = ACTIONS(1903),
    [anon_sym_let] = ACTIONS(1903),
    [anon_sym_loop] = ACTIONS(1903),
    [anon_sym_match] = ACTIONS(1903),
    [anon_sym_mod] = ACTIONS(1903),
    [anon_sym_pub] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_trait] = ACTIONS(1903),
    [anon_sym_type] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_unsafe] = ACTIONS(1903),
    [anon_sym_use] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_yield] = ACTIONS(1903),
    [anon_sym_move] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [sym_integer_literal] = ACTIONS(1901),
    [aux_sym_string_literal_token1] = ACTIONS(1901),
    [sym_char_literal] = ACTIONS(1901),
    [anon_sym_true] = ACTIONS(1903),
    [anon_sym_false] = ACTIONS(1903),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1903),
    [sym_super] = ACTIONS(1903),
    [sym_crate] = ACTIONS(1903),
    [sym_metavariable] = ACTIONS(1901),
    [sym_raw_string_literal] = ACTIONS(1901),
    [sym_float_literal] = ACTIONS(1901),
  },
  [543] = {
    [sym_line_comment] = STATE(543),
    [sym_block_comment] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1905),
    [sym_identifier] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym_macro_rules_BANG] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(1905),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_u8] = ACTIONS(1907),
    [anon_sym_i8] = ACTIONS(1907),
    [anon_sym_u16] = ACTIONS(1907),
    [anon_sym_i16] = ACTIONS(1907),
    [anon_sym_u32] = ACTIONS(1907),
    [anon_sym_i32] = ACTIONS(1907),
    [anon_sym_u64] = ACTIONS(1907),
    [anon_sym_i64] = ACTIONS(1907),
    [anon_sym_u128] = ACTIONS(1907),
    [anon_sym_i128] = ACTIONS(1907),
    [anon_sym_isize] = ACTIONS(1907),
    [anon_sym_usize] = ACTIONS(1907),
    [anon_sym_f32] = ACTIONS(1907),
    [anon_sym_f64] = ACTIONS(1907),
    [anon_sym_bool] = ACTIONS(1907),
    [anon_sym_str] = ACTIONS(1907),
    [anon_sym_char] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1905),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1905),
    [anon_sym_POUND] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_break] = ACTIONS(1907),
    [anon_sym_const] = ACTIONS(1907),
    [anon_sym_continue] = ACTIONS(1907),
    [anon_sym_default] = ACTIONS(1907),
    [anon_sym_enum] = ACTIONS(1907),
    [anon_sym_fn] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1907),
    [anon_sym_if] = ACTIONS(1907),
    [anon_sym_impl] = ACTIONS(1907),
    [anon_sym_let] = ACTIONS(1907),
    [anon_sym_loop] = ACTIONS(1907),
    [anon_sym_match] = ACTIONS(1907),
    [anon_sym_mod] = ACTIONS(1907),
    [anon_sym_pub] = ACTIONS(1907),
    [anon_sym_return] = ACTIONS(1907),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_struct] = ACTIONS(1907),
    [anon_sym_trait] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_union] = ACTIONS(1907),
    [anon_sym_unsafe] = ACTIONS(1907),
    [anon_sym_use] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1907),
    [anon_sym_extern] = ACTIONS(1907),
    [anon_sym_DOT_DOT] = ACTIONS(1905),
    [anon_sym_yield] = ACTIONS(1907),
    [anon_sym_move] = ACTIONS(1907),
    [anon_sym_try] = ACTIONS(1907),
    [sym_integer_literal] = ACTIONS(1905),
    [aux_sym_string_literal_token1] = ACTIONS(1905),
    [sym_char_literal] = ACTIONS(1905),
    [anon_sym_true] = ACTIONS(1907),
    [anon_sym_false] = ACTIONS(1907),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1907),
    [sym_super] = ACTIONS(1907),
    [sym_crate] = ACTIONS(1907),
    [sym_metavariable] = ACTIONS(1905),
    [sym_raw_string_literal] = ACTIONS(1905),
    [sym_float_literal] = ACTIONS(1905),
  },
  [544] = {
    [sym_line_comment] = STATE(544),
    [sym_block_comment] = STATE(544),
    [ts_builtin_sym_end] = ACTIONS(1909),
    [sym_identifier] = ACTIONS(1911),
    [anon_sym_SEMI] = ACTIONS(1909),
    [anon_sym_macro_rules_BANG] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_RBRACE] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_u8] = ACTIONS(1911),
    [anon_sym_i8] = ACTIONS(1911),
    [anon_sym_u16] = ACTIONS(1911),
    [anon_sym_i16] = ACTIONS(1911),
    [anon_sym_u32] = ACTIONS(1911),
    [anon_sym_i32] = ACTIONS(1911),
    [anon_sym_u64] = ACTIONS(1911),
    [anon_sym_i64] = ACTIONS(1911),
    [anon_sym_u128] = ACTIONS(1911),
    [anon_sym_i128] = ACTIONS(1911),
    [anon_sym_isize] = ACTIONS(1911),
    [anon_sym_usize] = ACTIONS(1911),
    [anon_sym_f32] = ACTIONS(1911),
    [anon_sym_f64] = ACTIONS(1911),
    [anon_sym_bool] = ACTIONS(1911),
    [anon_sym_str] = ACTIONS(1911),
    [anon_sym_char] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_POUND] = ACTIONS(1909),
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_async] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1911),
    [anon_sym_continue] = ACTIONS(1911),
    [anon_sym_default] = ACTIONS(1911),
    [anon_sym_enum] = ACTIONS(1911),
    [anon_sym_fn] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(1911),
    [anon_sym_if] = ACTIONS(1911),
    [anon_sym_impl] = ACTIONS(1911),
    [anon_sym_let] = ACTIONS(1911),
    [anon_sym_loop] = ACTIONS(1911),
    [anon_sym_match] = ACTIONS(1911),
    [anon_sym_mod] = ACTIONS(1911),
    [anon_sym_pub] = ACTIONS(1911),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1911),
    [anon_sym_struct] = ACTIONS(1911),
    [anon_sym_trait] = ACTIONS(1911),
    [anon_sym_type] = ACTIONS(1911),
    [anon_sym_union] = ACTIONS(1911),
    [anon_sym_unsafe] = ACTIONS(1911),
    [anon_sym_use] = ACTIONS(1911),
    [anon_sym_while] = ACTIONS(1911),
    [anon_sym_extern] = ACTIONS(1911),
    [anon_sym_DOT_DOT] = ACTIONS(1909),
    [anon_sym_yield] = ACTIONS(1911),
    [anon_sym_move] = ACTIONS(1911),
    [anon_sym_try] = ACTIONS(1911),
    [sym_integer_literal] = ACTIONS(1909),
    [aux_sym_string_literal_token1] = ACTIONS(1909),
    [sym_char_literal] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(1911),
    [anon_sym_false] = ACTIONS(1911),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1911),
    [sym_super] = ACTIONS(1911),
    [sym_crate] = ACTIONS(1911),
    [sym_metavariable] = ACTIONS(1909),
    [sym_raw_string_literal] = ACTIONS(1909),
    [sym_float_literal] = ACTIONS(1909),
  },
  [545] = {
    [sym_line_comment] = STATE(545),
    [sym_block_comment] = STATE(545),
    [ts_builtin_sym_end] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1913),
    [anon_sym_macro_rules_BANG] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_u8] = ACTIONS(1915),
    [anon_sym_i8] = ACTIONS(1915),
    [anon_sym_u16] = ACTIONS(1915),
    [anon_sym_i16] = ACTIONS(1915),
    [anon_sym_u32] = ACTIONS(1915),
    [anon_sym_i32] = ACTIONS(1915),
    [anon_sym_u64] = ACTIONS(1915),
    [anon_sym_i64] = ACTIONS(1915),
    [anon_sym_u128] = ACTIONS(1915),
    [anon_sym_i128] = ACTIONS(1915),
    [anon_sym_isize] = ACTIONS(1915),
    [anon_sym_usize] = ACTIONS(1915),
    [anon_sym_f32] = ACTIONS(1915),
    [anon_sym_f64] = ACTIONS(1915),
    [anon_sym_bool] = ACTIONS(1915),
    [anon_sym_str] = ACTIONS(1915),
    [anon_sym_char] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_POUND] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1913),
    [anon_sym_PIPE] = ACTIONS(1913),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_async] = ACTIONS(1915),
    [anon_sym_break] = ACTIONS(1915),
    [anon_sym_const] = ACTIONS(1915),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_default] = ACTIONS(1915),
    [anon_sym_enum] = ACTIONS(1915),
    [anon_sym_fn] = ACTIONS(1915),
    [anon_sym_for] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(1915),
    [anon_sym_impl] = ACTIONS(1915),
    [anon_sym_let] = ACTIONS(1915),
    [anon_sym_loop] = ACTIONS(1915),
    [anon_sym_match] = ACTIONS(1915),
    [anon_sym_mod] = ACTIONS(1915),
    [anon_sym_pub] = ACTIONS(1915),
    [anon_sym_return] = ACTIONS(1915),
    [anon_sym_static] = ACTIONS(1915),
    [anon_sym_struct] = ACTIONS(1915),
    [anon_sym_trait] = ACTIONS(1915),
    [anon_sym_type] = ACTIONS(1915),
    [anon_sym_union] = ACTIONS(1915),
    [anon_sym_unsafe] = ACTIONS(1915),
    [anon_sym_use] = ACTIONS(1915),
    [anon_sym_while] = ACTIONS(1915),
    [anon_sym_extern] = ACTIONS(1915),
    [anon_sym_DOT_DOT] = ACTIONS(1913),
    [anon_sym_yield] = ACTIONS(1915),
    [anon_sym_move] = ACTIONS(1915),
    [anon_sym_try] = ACTIONS(1915),
    [sym_integer_literal] = ACTIONS(1913),
    [aux_sym_string_literal_token1] = ACTIONS(1913),
    [sym_char_literal] = ACTIONS(1913),
    [anon_sym_true] = ACTIONS(1915),
    [anon_sym_false] = ACTIONS(1915),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1915),
    [sym_super] = ACTIONS(1915),
    [sym_crate] = ACTIONS(1915),
    [sym_metavariable] = ACTIONS(1913),
    [sym_raw_string_literal] = ACTIONS(1913),
    [sym_float_literal] = ACTIONS(1913),
  },
  [546] = {
    [sym_line_comment] = STATE(546),
    [sym_block_comment] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym_macro_rules_BANG] = ACTIONS(1917),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_LBRACE] = ACTIONS(1917),
    [anon_sym_RBRACE] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_u8] = ACTIONS(1919),
    [anon_sym_i8] = ACTIONS(1919),
    [anon_sym_u16] = ACTIONS(1919),
    [anon_sym_i16] = ACTIONS(1919),
    [anon_sym_u32] = ACTIONS(1919),
    [anon_sym_i32] = ACTIONS(1919),
    [anon_sym_u64] = ACTIONS(1919),
    [anon_sym_i64] = ACTIONS(1919),
    [anon_sym_u128] = ACTIONS(1919),
    [anon_sym_i128] = ACTIONS(1919),
    [anon_sym_isize] = ACTIONS(1919),
    [anon_sym_usize] = ACTIONS(1919),
    [anon_sym_f32] = ACTIONS(1919),
    [anon_sym_f64] = ACTIONS(1919),
    [anon_sym_bool] = ACTIONS(1919),
    [anon_sym_str] = ACTIONS(1919),
    [anon_sym_char] = ACTIONS(1919),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_COLON_COLON] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_POUND] = ACTIONS(1917),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1917),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [anon_sym_async] = ACTIONS(1919),
    [anon_sym_break] = ACTIONS(1919),
    [anon_sym_const] = ACTIONS(1919),
    [anon_sym_continue] = ACTIONS(1919),
    [anon_sym_default] = ACTIONS(1919),
    [anon_sym_enum] = ACTIONS(1919),
    [anon_sym_fn] = ACTIONS(1919),
    [anon_sym_for] = ACTIONS(1919),
    [anon_sym_if] = ACTIONS(1919),
    [anon_sym_impl] = ACTIONS(1919),
    [anon_sym_let] = ACTIONS(1919),
    [anon_sym_loop] = ACTIONS(1919),
    [anon_sym_match] = ACTIONS(1919),
    [anon_sym_mod] = ACTIONS(1919),
    [anon_sym_pub] = ACTIONS(1919),
    [anon_sym_return] = ACTIONS(1919),
    [anon_sym_static] = ACTIONS(1919),
    [anon_sym_struct] = ACTIONS(1919),
    [anon_sym_trait] = ACTIONS(1919),
    [anon_sym_type] = ACTIONS(1919),
    [anon_sym_union] = ACTIONS(1919),
    [anon_sym_unsafe] = ACTIONS(1919),
    [anon_sym_use] = ACTIONS(1919),
    [anon_sym_while] = ACTIONS(1919),
    [anon_sym_extern] = ACTIONS(1919),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_yield] = ACTIONS(1919),
    [anon_sym_move] = ACTIONS(1919),
    [anon_sym_try] = ACTIONS(1919),
    [sym_integer_literal] = ACTIONS(1917),
    [aux_sym_string_literal_token1] = ACTIONS(1917),
    [sym_char_literal] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1919),
    [anon_sym_false] = ACTIONS(1919),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1919),
    [sym_super] = ACTIONS(1919),
    [sym_crate] = ACTIONS(1919),
    [sym_metavariable] = ACTIONS(1917),
    [sym_raw_string_literal] = ACTIONS(1917),
    [sym_float_literal] = ACTIONS(1917),
  },
  [547] = {
    [sym_line_comment] = STATE(547),
    [sym_block_comment] = STATE(547),
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_macro_rules_BANG] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_STAR] = ACTIONS(1921),
    [anon_sym_u8] = ACTIONS(1923),
    [anon_sym_i8] = ACTIONS(1923),
    [anon_sym_u16] = ACTIONS(1923),
    [anon_sym_i16] = ACTIONS(1923),
    [anon_sym_u32] = ACTIONS(1923),
    [anon_sym_i32] = ACTIONS(1923),
    [anon_sym_u64] = ACTIONS(1923),
    [anon_sym_i64] = ACTIONS(1923),
    [anon_sym_u128] = ACTIONS(1923),
    [anon_sym_i128] = ACTIONS(1923),
    [anon_sym_isize] = ACTIONS(1923),
    [anon_sym_usize] = ACTIONS(1923),
    [anon_sym_f32] = ACTIONS(1923),
    [anon_sym_f64] = ACTIONS(1923),
    [anon_sym_bool] = ACTIONS(1923),
    [anon_sym_str] = ACTIONS(1923),
    [anon_sym_char] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1921),
    [anon_sym_COLON_COLON] = ACTIONS(1921),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_AMP] = ACTIONS(1921),
    [anon_sym_POUND] = ACTIONS(1921),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_impl] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_loop] = ACTIONS(1923),
    [anon_sym_match] = ACTIONS(1923),
    [anon_sym_mod] = ACTIONS(1923),
    [anon_sym_pub] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_trait] = ACTIONS(1923),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_union] = ACTIONS(1923),
    [anon_sym_unsafe] = ACTIONS(1923),
    [anon_sym_use] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_extern] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1921),
    [anon_sym_yield] = ACTIONS(1923),
    [anon_sym_move] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1923),
    [sym_integer_literal] = ACTIONS(1921),
    [aux_sym_string_literal_token1] = ACTIONS(1921),
    [sym_char_literal] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(1923),
    [anon_sym_false] = ACTIONS(1923),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_crate] = ACTIONS(1923),
    [sym_metavariable] = ACTIONS(1921),
    [sym_raw_string_literal] = ACTIONS(1921),
    [sym_float_literal] = ACTIONS(1921),
  },
  [548] = {
    [sym_line_comment] = STATE(548),
    [sym_block_comment] = STATE(548),
    [ts_builtin_sym_end] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1925),
    [anon_sym_macro_rules_BANG] = ACTIONS(1925),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1925),
    [anon_sym_RBRACE] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_u8] = ACTIONS(1927),
    [anon_sym_i8] = ACTIONS(1927),
    [anon_sym_u16] = ACTIONS(1927),
    [anon_sym_i16] = ACTIONS(1927),
    [anon_sym_u32] = ACTIONS(1927),
    [anon_sym_i32] = ACTIONS(1927),
    [anon_sym_u64] = ACTIONS(1927),
    [anon_sym_i64] = ACTIONS(1927),
    [anon_sym_u128] = ACTIONS(1927),
    [anon_sym_i128] = ACTIONS(1927),
    [anon_sym_isize] = ACTIONS(1927),
    [anon_sym_usize] = ACTIONS(1927),
    [anon_sym_f32] = ACTIONS(1927),
    [anon_sym_f64] = ACTIONS(1927),
    [anon_sym_bool] = ACTIONS(1927),
    [anon_sym_str] = ACTIONS(1927),
    [anon_sym_char] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_AMP] = ACTIONS(1925),
    [anon_sym_POUND] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(1925),
    [anon_sym_PIPE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [anon_sym_async] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1927),
    [anon_sym_const] = ACTIONS(1927),
    [anon_sym_continue] = ACTIONS(1927),
    [anon_sym_default] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1927),
    [anon_sym_fn] = ACTIONS(1927),
    [anon_sym_for] = ACTIONS(1927),
    [anon_sym_if] = ACTIONS(1927),
    [anon_sym_impl] = ACTIONS(1927),
    [anon_sym_let] = ACTIONS(1927),
    [anon_sym_loop] = ACTIONS(1927),
    [anon_sym_match] = ACTIONS(1927),
    [anon_sym_mod] = ACTIONS(1927),
    [anon_sym_pub] = ACTIONS(1927),
    [anon_sym_return] = ACTIONS(1927),
    [anon_sym_static] = ACTIONS(1927),
    [anon_sym_struct] = ACTIONS(1927),
    [anon_sym_trait] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1927),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_unsafe] = ACTIONS(1927),
    [anon_sym_use] = ACTIONS(1927),
    [anon_sym_while] = ACTIONS(1927),
    [anon_sym_extern] = ACTIONS(1927),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_move] = ACTIONS(1927),
    [anon_sym_try] = ACTIONS(1927),
    [sym_integer_literal] = ACTIONS(1925),
    [aux_sym_string_literal_token1] = ACTIONS(1925),
    [sym_char_literal] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(1927),
    [anon_sym_false] = ACTIONS(1927),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1927),
    [sym_super] = ACTIONS(1927),
    [sym_crate] = ACTIONS(1927),
    [sym_metavariable] = ACTIONS(1925),
    [sym_raw_string_literal] = ACTIONS(1925),
    [sym_float_literal] = ACTIONS(1925),
  },
  [549] = {
    [sym_line_comment] = STATE(549),
    [sym_block_comment] = STATE(549),
    [ts_builtin_sym_end] = ACTIONS(1929),
    [sym_identifier] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym_macro_rules_BANG] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1929),
    [anon_sym_RBRACE] = ACTIONS(1929),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_u8] = ACTIONS(1931),
    [anon_sym_i8] = ACTIONS(1931),
    [anon_sym_u16] = ACTIONS(1931),
    [anon_sym_i16] = ACTIONS(1931),
    [anon_sym_u32] = ACTIONS(1931),
    [anon_sym_i32] = ACTIONS(1931),
    [anon_sym_u64] = ACTIONS(1931),
    [anon_sym_i64] = ACTIONS(1931),
    [anon_sym_u128] = ACTIONS(1931),
    [anon_sym_i128] = ACTIONS(1931),
    [anon_sym_isize] = ACTIONS(1931),
    [anon_sym_usize] = ACTIONS(1931),
    [anon_sym_f32] = ACTIONS(1931),
    [anon_sym_f64] = ACTIONS(1931),
    [anon_sym_bool] = ACTIONS(1931),
    [anon_sym_str] = ACTIONS(1931),
    [anon_sym_char] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1929),
    [anon_sym_COLON_COLON] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1929),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_POUND] = ACTIONS(1929),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(1931),
    [anon_sym_async] = ACTIONS(1931),
    [anon_sym_break] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(1931),
    [anon_sym_continue] = ACTIONS(1931),
    [anon_sym_default] = ACTIONS(1931),
    [anon_sym_enum] = ACTIONS(1931),
    [anon_sym_fn] = ACTIONS(1931),
    [anon_sym_for] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1931),
    [anon_sym_impl] = ACTIONS(1931),
    [anon_sym_let] = ACTIONS(1931),
    [anon_sym_loop] = ACTIONS(1931),
    [anon_sym_match] = ACTIONS(1931),
    [anon_sym_mod] = ACTIONS(1931),
    [anon_sym_pub] = ACTIONS(1931),
    [anon_sym_return] = ACTIONS(1931),
    [anon_sym_static] = ACTIONS(1931),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_trait] = ACTIONS(1931),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_union] = ACTIONS(1931),
    [anon_sym_unsafe] = ACTIONS(1931),
    [anon_sym_use] = ACTIONS(1931),
    [anon_sym_while] = ACTIONS(1931),
    [anon_sym_extern] = ACTIONS(1931),
    [anon_sym_DOT_DOT] = ACTIONS(1929),
    [anon_sym_yield] = ACTIONS(1931),
    [anon_sym_move] = ACTIONS(1931),
    [anon_sym_try] = ACTIONS(1931),
    [sym_integer_literal] = ACTIONS(1929),
    [aux_sym_string_literal_token1] = ACTIONS(1929),
    [sym_char_literal] = ACTIONS(1929),
    [anon_sym_true] = ACTIONS(1931),
    [anon_sym_false] = ACTIONS(1931),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1931),
    [sym_super] = ACTIONS(1931),
    [sym_crate] = ACTIONS(1931),
    [sym_metavariable] = ACTIONS(1929),
    [sym_raw_string_literal] = ACTIONS(1929),
    [sym_float_literal] = ACTIONS(1929),
  },
  [550] = {
    [sym_line_comment] = STATE(550),
    [sym_block_comment] = STATE(550),
    [ts_builtin_sym_end] = ACTIONS(1933),
    [sym_identifier] = ACTIONS(1935),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_macro_rules_BANG] = ACTIONS(1933),
    [anon_sym_LPAREN] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_u8] = ACTIONS(1935),
    [anon_sym_i8] = ACTIONS(1935),
    [anon_sym_u16] = ACTIONS(1935),
    [anon_sym_i16] = ACTIONS(1935),
    [anon_sym_u32] = ACTIONS(1935),
    [anon_sym_i32] = ACTIONS(1935),
    [anon_sym_u64] = ACTIONS(1935),
    [anon_sym_i64] = ACTIONS(1935),
    [anon_sym_u128] = ACTIONS(1935),
    [anon_sym_i128] = ACTIONS(1935),
    [anon_sym_isize] = ACTIONS(1935),
    [anon_sym_usize] = ACTIONS(1935),
    [anon_sym_f32] = ACTIONS(1935),
    [anon_sym_f64] = ACTIONS(1935),
    [anon_sym_bool] = ACTIONS(1935),
    [anon_sym_str] = ACTIONS(1935),
    [anon_sym_char] = ACTIONS(1935),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_COLON_COLON] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_AMP] = ACTIONS(1933),
    [anon_sym_POUND] = ACTIONS(1933),
    [anon_sym_LT] = ACTIONS(1933),
    [anon_sym_PIPE] = ACTIONS(1933),
    [anon_sym_SQUOTE] = ACTIONS(1935),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_break] = ACTIONS(1935),
    [anon_sym_const] = ACTIONS(1935),
    [anon_sym_continue] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1935),
    [anon_sym_enum] = ACTIONS(1935),
    [anon_sym_fn] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1935),
    [anon_sym_impl] = ACTIONS(1935),
    [anon_sym_let] = ACTIONS(1935),
    [anon_sym_loop] = ACTIONS(1935),
    [anon_sym_match] = ACTIONS(1935),
    [anon_sym_mod] = ACTIONS(1935),
    [anon_sym_pub] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(1935),
    [anon_sym_static] = ACTIONS(1935),
    [anon_sym_struct] = ACTIONS(1935),
    [anon_sym_trait] = ACTIONS(1935),
    [anon_sym_type] = ACTIONS(1935),
    [anon_sym_union] = ACTIONS(1935),
    [anon_sym_unsafe] = ACTIONS(1935),
    [anon_sym_use] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1935),
    [anon_sym_extern] = ACTIONS(1935),
    [anon_sym_DOT_DOT] = ACTIONS(1933),
    [anon_sym_yield] = ACTIONS(1935),
    [anon_sym_move] = ACTIONS(1935),
    [anon_sym_try] = ACTIONS(1935),
    [sym_integer_literal] = ACTIONS(1933),
    [aux_sym_string_literal_token1] = ACTIONS(1933),
    [sym_char_literal] = ACTIONS(1933),
    [anon_sym_true] = ACTIONS(1935),
    [anon_sym_false] = ACTIONS(1935),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1935),
    [sym_super] = ACTIONS(1935),
    [sym_crate] = ACTIONS(1935),
    [sym_metavariable] = ACTIONS(1933),
    [sym_raw_string_literal] = ACTIONS(1933),
    [sym_float_literal] = ACTIONS(1933),
  },
  [551] = {
    [sym_line_comment] = STATE(551),
    [sym_block_comment] = STATE(551),
    [ts_builtin_sym_end] = ACTIONS(1937),
    [sym_identifier] = ACTIONS(1939),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym_macro_rules_BANG] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_LBRACK] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_RBRACE] = ACTIONS(1937),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_u8] = ACTIONS(1939),
    [anon_sym_i8] = ACTIONS(1939),
    [anon_sym_u16] = ACTIONS(1939),
    [anon_sym_i16] = ACTIONS(1939),
    [anon_sym_u32] = ACTIONS(1939),
    [anon_sym_i32] = ACTIONS(1939),
    [anon_sym_u64] = ACTIONS(1939),
    [anon_sym_i64] = ACTIONS(1939),
    [anon_sym_u128] = ACTIONS(1939),
    [anon_sym_i128] = ACTIONS(1939),
    [anon_sym_isize] = ACTIONS(1939),
    [anon_sym_usize] = ACTIONS(1939),
    [anon_sym_f32] = ACTIONS(1939),
    [anon_sym_f64] = ACTIONS(1939),
    [anon_sym_bool] = ACTIONS(1939),
    [anon_sym_str] = ACTIONS(1939),
    [anon_sym_char] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1937),
    [anon_sym_COLON_COLON] = ACTIONS(1937),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(1937),
    [anon_sym_POUND] = ACTIONS(1937),
    [anon_sym_LT] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1937),
    [anon_sym_SQUOTE] = ACTIONS(1939),
    [anon_sym_async] = ACTIONS(1939),
    [anon_sym_break] = ACTIONS(1939),
    [anon_sym_const] = ACTIONS(1939),
    [anon_sym_continue] = ACTIONS(1939),
    [anon_sym_default] = ACTIONS(1939),
    [anon_sym_enum] = ACTIONS(1939),
    [anon_sym_fn] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(1939),
    [anon_sym_if] = ACTIONS(1939),
    [anon_sym_impl] = ACTIONS(1939),
    [anon_sym_let] = ACTIONS(1939),
    [anon_sym_loop] = ACTIONS(1939),
    [anon_sym_match] = ACTIONS(1939),
    [anon_sym_mod] = ACTIONS(1939),
    [anon_sym_pub] = ACTIONS(1939),
    [anon_sym_return] = ACTIONS(1939),
    [anon_sym_static] = ACTIONS(1939),
    [anon_sym_struct] = ACTIONS(1939),
    [anon_sym_trait] = ACTIONS(1939),
    [anon_sym_type] = ACTIONS(1939),
    [anon_sym_union] = ACTIONS(1939),
    [anon_sym_unsafe] = ACTIONS(1939),
    [anon_sym_use] = ACTIONS(1939),
    [anon_sym_while] = ACTIONS(1939),
    [anon_sym_extern] = ACTIONS(1939),
    [anon_sym_DOT_DOT] = ACTIONS(1937),
    [anon_sym_yield] = ACTIONS(1939),
    [anon_sym_move] = ACTIONS(1939),
    [anon_sym_try] = ACTIONS(1939),
    [sym_integer_literal] = ACTIONS(1937),
    [aux_sym_string_literal_token1] = ACTIONS(1937),
    [sym_char_literal] = ACTIONS(1937),
    [anon_sym_true] = ACTIONS(1939),
    [anon_sym_false] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1939),
    [sym_super] = ACTIONS(1939),
    [sym_crate] = ACTIONS(1939),
    [sym_metavariable] = ACTIONS(1937),
    [sym_raw_string_literal] = ACTIONS(1937),
    [sym_float_literal] = ACTIONS(1937),
  },
  [552] = {
    [sym_line_comment] = STATE(552),
    [sym_block_comment] = STATE(552),
    [ts_builtin_sym_end] = ACTIONS(1941),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_macro_rules_BANG] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_RBRACE] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1941),
    [anon_sym_u8] = ACTIONS(1943),
    [anon_sym_i8] = ACTIONS(1943),
    [anon_sym_u16] = ACTIONS(1943),
    [anon_sym_i16] = ACTIONS(1943),
    [anon_sym_u32] = ACTIONS(1943),
    [anon_sym_i32] = ACTIONS(1943),
    [anon_sym_u64] = ACTIONS(1943),
    [anon_sym_i64] = ACTIONS(1943),
    [anon_sym_u128] = ACTIONS(1943),
    [anon_sym_i128] = ACTIONS(1943),
    [anon_sym_isize] = ACTIONS(1943),
    [anon_sym_usize] = ACTIONS(1943),
    [anon_sym_f32] = ACTIONS(1943),
    [anon_sym_f64] = ACTIONS(1943),
    [anon_sym_bool] = ACTIONS(1943),
    [anon_sym_str] = ACTIONS(1943),
    [anon_sym_char] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_COLON_COLON] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_POUND] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_async] = ACTIONS(1943),
    [anon_sym_break] = ACTIONS(1943),
    [anon_sym_const] = ACTIONS(1943),
    [anon_sym_continue] = ACTIONS(1943),
    [anon_sym_default] = ACTIONS(1943),
    [anon_sym_enum] = ACTIONS(1943),
    [anon_sym_fn] = ACTIONS(1943),
    [anon_sym_for] = ACTIONS(1943),
    [anon_sym_if] = ACTIONS(1943),
    [anon_sym_impl] = ACTIONS(1943),
    [anon_sym_let] = ACTIONS(1943),
    [anon_sym_loop] = ACTIONS(1943),
    [anon_sym_match] = ACTIONS(1943),
    [anon_sym_mod] = ACTIONS(1943),
    [anon_sym_pub] = ACTIONS(1943),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_static] = ACTIONS(1943),
    [anon_sym_struct] = ACTIONS(1943),
    [anon_sym_trait] = ACTIONS(1943),
    [anon_sym_type] = ACTIONS(1943),
    [anon_sym_union] = ACTIONS(1943),
    [anon_sym_unsafe] = ACTIONS(1943),
    [anon_sym_use] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1943),
    [anon_sym_extern] = ACTIONS(1943),
    [anon_sym_DOT_DOT] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1943),
    [anon_sym_move] = ACTIONS(1943),
    [anon_sym_try] = ACTIONS(1943),
    [sym_integer_literal] = ACTIONS(1941),
    [aux_sym_string_literal_token1] = ACTIONS(1941),
    [sym_char_literal] = ACTIONS(1941),
    [anon_sym_true] = ACTIONS(1943),
    [anon_sym_false] = ACTIONS(1943),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1943),
    [sym_super] = ACTIONS(1943),
    [sym_crate] = ACTIONS(1943),
    [sym_metavariable] = ACTIONS(1941),
    [sym_raw_string_literal] = ACTIONS(1941),
    [sym_float_literal] = ACTIONS(1941),
  },
  [553] = {
    [sym_line_comment] = STATE(553),
    [sym_block_comment] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(870),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_macro_rules_BANG] = ACTIONS(870),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_LBRACK] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(870),
    [anon_sym_RBRACE] = ACTIONS(870),
    [anon_sym_STAR] = ACTIONS(870),
    [anon_sym_u8] = ACTIONS(872),
    [anon_sym_i8] = ACTIONS(872),
    [anon_sym_u16] = ACTIONS(872),
    [anon_sym_i16] = ACTIONS(872),
    [anon_sym_u32] = ACTIONS(872),
    [anon_sym_i32] = ACTIONS(872),
    [anon_sym_u64] = ACTIONS(872),
    [anon_sym_i64] = ACTIONS(872),
    [anon_sym_u128] = ACTIONS(872),
    [anon_sym_i128] = ACTIONS(872),
    [anon_sym_isize] = ACTIONS(872),
    [anon_sym_usize] = ACTIONS(872),
    [anon_sym_f32] = ACTIONS(872),
    [anon_sym_f64] = ACTIONS(872),
    [anon_sym_bool] = ACTIONS(872),
    [anon_sym_str] = ACTIONS(872),
    [anon_sym_char] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_COLON_COLON] = ACTIONS(870),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_AMP] = ACTIONS(870),
    [anon_sym_POUND] = ACTIONS(870),
    [anon_sym_LT] = ACTIONS(870),
    [anon_sym_PIPE] = ACTIONS(870),
    [anon_sym_SQUOTE] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_break] = ACTIONS(872),
    [anon_sym_const] = ACTIONS(872),
    [anon_sym_continue] = ACTIONS(872),
    [anon_sym_default] = ACTIONS(872),
    [anon_sym_enum] = ACTIONS(872),
    [anon_sym_fn] = ACTIONS(872),
    [anon_sym_for] = ACTIONS(872),
    [anon_sym_if] = ACTIONS(872),
    [anon_sym_impl] = ACTIONS(872),
    [anon_sym_let] = ACTIONS(872),
    [anon_sym_loop] = ACTIONS(872),
    [anon_sym_match] = ACTIONS(872),
    [anon_sym_mod] = ACTIONS(872),
    [anon_sym_pub] = ACTIONS(872),
    [anon_sym_return] = ACTIONS(872),
    [anon_sym_static] = ACTIONS(872),
    [anon_sym_struct] = ACTIONS(872),
    [anon_sym_trait] = ACTIONS(872),
    [anon_sym_type] = ACTIONS(872),
    [anon_sym_union] = ACTIONS(872),
    [anon_sym_unsafe] = ACTIONS(872),
    [anon_sym_use] = ACTIONS(872),
    [anon_sym_while] = ACTIONS(872),
    [anon_sym_extern] = ACTIONS(872),
    [anon_sym_DOT_DOT] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(872),
    [anon_sym_move] = ACTIONS(872),
    [anon_sym_try] = ACTIONS(872),
    [sym_integer_literal] = ACTIONS(870),
    [aux_sym_string_literal_token1] = ACTIONS(870),
    [sym_char_literal] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(872),
    [anon_sym_false] = ACTIONS(872),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(872),
    [sym_super] = ACTIONS(872),
    [sym_crate] = ACTIONS(872),
    [sym_metavariable] = ACTIONS(870),
    [sym_raw_string_literal] = ACTIONS(870),
    [sym_float_literal] = ACTIONS(870),
  },
  [554] = {
    [sym_line_comment] = STATE(554),
    [sym_block_comment] = STATE(554),
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_macro_rules_BANG] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_u8] = ACTIONS(1947),
    [anon_sym_i8] = ACTIONS(1947),
    [anon_sym_u16] = ACTIONS(1947),
    [anon_sym_i16] = ACTIONS(1947),
    [anon_sym_u32] = ACTIONS(1947),
    [anon_sym_i32] = ACTIONS(1947),
    [anon_sym_u64] = ACTIONS(1947),
    [anon_sym_i64] = ACTIONS(1947),
    [anon_sym_u128] = ACTIONS(1947),
    [anon_sym_i128] = ACTIONS(1947),
    [anon_sym_isize] = ACTIONS(1947),
    [anon_sym_usize] = ACTIONS(1947),
    [anon_sym_f32] = ACTIONS(1947),
    [anon_sym_f64] = ACTIONS(1947),
    [anon_sym_bool] = ACTIONS(1947),
    [anon_sym_str] = ACTIONS(1947),
    [anon_sym_char] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_POUND] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_fn] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_impl] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_loop] = ACTIONS(1947),
    [anon_sym_match] = ACTIONS(1947),
    [anon_sym_mod] = ACTIONS(1947),
    [anon_sym_pub] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_trait] = ACTIONS(1947),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_unsafe] = ACTIONS(1947),
    [anon_sym_use] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym_DOT_DOT] = ACTIONS(1945),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_move] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [sym_integer_literal] = ACTIONS(1945),
    [aux_sym_string_literal_token1] = ACTIONS(1945),
    [sym_char_literal] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1947),
    [anon_sym_false] = ACTIONS(1947),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_crate] = ACTIONS(1947),
    [sym_metavariable] = ACTIONS(1945),
    [sym_raw_string_literal] = ACTIONS(1945),
    [sym_float_literal] = ACTIONS(1945),
  },
  [555] = {
    [sym_line_comment] = STATE(555),
    [sym_block_comment] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym_macro_rules_BANG] = ACTIONS(1949),
    [anon_sym_LPAREN] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(1949),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_u8] = ACTIONS(1951),
    [anon_sym_i8] = ACTIONS(1951),
    [anon_sym_u16] = ACTIONS(1951),
    [anon_sym_i16] = ACTIONS(1951),
    [anon_sym_u32] = ACTIONS(1951),
    [anon_sym_i32] = ACTIONS(1951),
    [anon_sym_u64] = ACTIONS(1951),
    [anon_sym_i64] = ACTIONS(1951),
    [anon_sym_u128] = ACTIONS(1951),
    [anon_sym_i128] = ACTIONS(1951),
    [anon_sym_isize] = ACTIONS(1951),
    [anon_sym_usize] = ACTIONS(1951),
    [anon_sym_f32] = ACTIONS(1951),
    [anon_sym_f64] = ACTIONS(1951),
    [anon_sym_bool] = ACTIONS(1951),
    [anon_sym_str] = ACTIONS(1951),
    [anon_sym_char] = ACTIONS(1951),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_POUND] = ACTIONS(1949),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_PIPE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1951),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_fn] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_impl] = ACTIONS(1951),
    [anon_sym_let] = ACTIONS(1951),
    [anon_sym_loop] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1951),
    [anon_sym_mod] = ACTIONS(1951),
    [anon_sym_pub] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_trait] = ACTIONS(1951),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_unsafe] = ACTIONS(1951),
    [anon_sym_use] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym_DOT_DOT] = ACTIONS(1949),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_move] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [sym_integer_literal] = ACTIONS(1949),
    [aux_sym_string_literal_token1] = ACTIONS(1949),
    [sym_char_literal] = ACTIONS(1949),
    [anon_sym_true] = ACTIONS(1951),
    [anon_sym_false] = ACTIONS(1951),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1951),
    [sym_super] = ACTIONS(1951),
    [sym_crate] = ACTIONS(1951),
    [sym_metavariable] = ACTIONS(1949),
    [sym_raw_string_literal] = ACTIONS(1949),
    [sym_float_literal] = ACTIONS(1949),
  },
  [556] = {
    [sym_line_comment] = STATE(556),
    [sym_block_comment] = STATE(556),
    [ts_builtin_sym_end] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_macro_rules_BANG] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_u8] = ACTIONS(1955),
    [anon_sym_i8] = ACTIONS(1955),
    [anon_sym_u16] = ACTIONS(1955),
    [anon_sym_i16] = ACTIONS(1955),
    [anon_sym_u32] = ACTIONS(1955),
    [anon_sym_i32] = ACTIONS(1955),
    [anon_sym_u64] = ACTIONS(1955),
    [anon_sym_i64] = ACTIONS(1955),
    [anon_sym_u128] = ACTIONS(1955),
    [anon_sym_i128] = ACTIONS(1955),
    [anon_sym_isize] = ACTIONS(1955),
    [anon_sym_usize] = ACTIONS(1955),
    [anon_sym_f32] = ACTIONS(1955),
    [anon_sym_f64] = ACTIONS(1955),
    [anon_sym_bool] = ACTIONS(1955),
    [anon_sym_str] = ACTIONS(1955),
    [anon_sym_char] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1953),
    [anon_sym_BANG] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_POUND] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_async] = ACTIONS(1955),
    [anon_sym_break] = ACTIONS(1955),
    [anon_sym_const] = ACTIONS(1955),
    [anon_sym_continue] = ACTIONS(1955),
    [anon_sym_default] = ACTIONS(1955),
    [anon_sym_enum] = ACTIONS(1955),
    [anon_sym_fn] = ACTIONS(1955),
    [anon_sym_for] = ACTIONS(1955),
    [anon_sym_if] = ACTIONS(1955),
    [anon_sym_impl] = ACTIONS(1955),
    [anon_sym_let] = ACTIONS(1955),
    [anon_sym_loop] = ACTIONS(1955),
    [anon_sym_match] = ACTIONS(1955),
    [anon_sym_mod] = ACTIONS(1955),
    [anon_sym_pub] = ACTIONS(1955),
    [anon_sym_return] = ACTIONS(1955),
    [anon_sym_static] = ACTIONS(1955),
    [anon_sym_struct] = ACTIONS(1955),
    [anon_sym_trait] = ACTIONS(1955),
    [anon_sym_type] = ACTIONS(1955),
    [anon_sym_union] = ACTIONS(1955),
    [anon_sym_unsafe] = ACTIONS(1955),
    [anon_sym_use] = ACTIONS(1955),
    [anon_sym_while] = ACTIONS(1955),
    [anon_sym_extern] = ACTIONS(1955),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_yield] = ACTIONS(1955),
    [anon_sym_move] = ACTIONS(1955),
    [anon_sym_try] = ACTIONS(1955),
    [sym_integer_literal] = ACTIONS(1953),
    [aux_sym_string_literal_token1] = ACTIONS(1953),
    [sym_char_literal] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(1955),
    [anon_sym_false] = ACTIONS(1955),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1955),
    [sym_super] = ACTIONS(1955),
    [sym_crate] = ACTIONS(1955),
    [sym_metavariable] = ACTIONS(1953),
    [sym_raw_string_literal] = ACTIONS(1953),
    [sym_float_literal] = ACTIONS(1953),
  },
  [557] = {
    [sym_line_comment] = STATE(557),
    [sym_block_comment] = STATE(557),
    [ts_builtin_sym_end] = ACTIONS(1957),
    [sym_identifier] = ACTIONS(1959),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_macro_rules_BANG] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1957),
    [anon_sym_u8] = ACTIONS(1959),
    [anon_sym_i8] = ACTIONS(1959),
    [anon_sym_u16] = ACTIONS(1959),
    [anon_sym_i16] = ACTIONS(1959),
    [anon_sym_u32] = ACTIONS(1959),
    [anon_sym_i32] = ACTIONS(1959),
    [anon_sym_u64] = ACTIONS(1959),
    [anon_sym_i64] = ACTIONS(1959),
    [anon_sym_u128] = ACTIONS(1959),
    [anon_sym_i128] = ACTIONS(1959),
    [anon_sym_isize] = ACTIONS(1959),
    [anon_sym_usize] = ACTIONS(1959),
    [anon_sym_f32] = ACTIONS(1959),
    [anon_sym_f64] = ACTIONS(1959),
    [anon_sym_bool] = ACTIONS(1959),
    [anon_sym_str] = ACTIONS(1959),
    [anon_sym_char] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1957),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_POUND] = ACTIONS(1957),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_PIPE] = ACTIONS(1957),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_async] = ACTIONS(1959),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(1959),
    [anon_sym_continue] = ACTIONS(1959),
    [anon_sym_default] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1959),
    [anon_sym_fn] = ACTIONS(1959),
    [anon_sym_for] = ACTIONS(1959),
    [anon_sym_if] = ACTIONS(1959),
    [anon_sym_impl] = ACTIONS(1959),
    [anon_sym_let] = ACTIONS(1959),
    [anon_sym_loop] = ACTIONS(1959),
    [anon_sym_match] = ACTIONS(1959),
    [anon_sym_mod] = ACTIONS(1959),
    [anon_sym_pub] = ACTIONS(1959),
    [anon_sym_return] = ACTIONS(1959),
    [anon_sym_static] = ACTIONS(1959),
    [anon_sym_struct] = ACTIONS(1959),
    [anon_sym_trait] = ACTIONS(1959),
    [anon_sym_type] = ACTIONS(1959),
    [anon_sym_union] = ACTIONS(1959),
    [anon_sym_unsafe] = ACTIONS(1959),
    [anon_sym_use] = ACTIONS(1959),
    [anon_sym_while] = ACTIONS(1959),
    [anon_sym_extern] = ACTIONS(1959),
    [anon_sym_DOT_DOT] = ACTIONS(1957),
    [anon_sym_yield] = ACTIONS(1959),
    [anon_sym_move] = ACTIONS(1959),
    [anon_sym_try] = ACTIONS(1959),
    [sym_integer_literal] = ACTIONS(1957),
    [aux_sym_string_literal_token1] = ACTIONS(1957),
    [sym_char_literal] = ACTIONS(1957),
    [anon_sym_true] = ACTIONS(1959),
    [anon_sym_false] = ACTIONS(1959),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1959),
    [sym_super] = ACTIONS(1959),
    [sym_crate] = ACTIONS(1959),
    [sym_metavariable] = ACTIONS(1957),
    [sym_raw_string_literal] = ACTIONS(1957),
    [sym_float_literal] = ACTIONS(1957),
  },
  [558] = {
    [sym_line_comment] = STATE(558),
    [sym_block_comment] = STATE(558),
    [ts_builtin_sym_end] = ACTIONS(1961),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_macro_rules_BANG] = ACTIONS(1961),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1961),
    [anon_sym_u8] = ACTIONS(1963),
    [anon_sym_i8] = ACTIONS(1963),
    [anon_sym_u16] = ACTIONS(1963),
    [anon_sym_i16] = ACTIONS(1963),
    [anon_sym_u32] = ACTIONS(1963),
    [anon_sym_i32] = ACTIONS(1963),
    [anon_sym_u64] = ACTIONS(1963),
    [anon_sym_i64] = ACTIONS(1963),
    [anon_sym_u128] = ACTIONS(1963),
    [anon_sym_i128] = ACTIONS(1963),
    [anon_sym_isize] = ACTIONS(1963),
    [anon_sym_usize] = ACTIONS(1963),
    [anon_sym_f32] = ACTIONS(1963),
    [anon_sym_f64] = ACTIONS(1963),
    [anon_sym_bool] = ACTIONS(1963),
    [anon_sym_str] = ACTIONS(1963),
    [anon_sym_char] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1961),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_POUND] = ACTIONS(1961),
    [anon_sym_LT] = ACTIONS(1961),
    [anon_sym_PIPE] = ACTIONS(1961),
    [anon_sym_SQUOTE] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(1963),
    [anon_sym_break] = ACTIONS(1963),
    [anon_sym_const] = ACTIONS(1963),
    [anon_sym_continue] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(1963),
    [anon_sym_enum] = ACTIONS(1963),
    [anon_sym_fn] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1963),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_impl] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_loop] = ACTIONS(1963),
    [anon_sym_match] = ACTIONS(1963),
    [anon_sym_mod] = ACTIONS(1963),
    [anon_sym_pub] = ACTIONS(1963),
    [anon_sym_return] = ACTIONS(1963),
    [anon_sym_static] = ACTIONS(1963),
    [anon_sym_struct] = ACTIONS(1963),
    [anon_sym_trait] = ACTIONS(1963),
    [anon_sym_type] = ACTIONS(1963),
    [anon_sym_union] = ACTIONS(1963),
    [anon_sym_unsafe] = ACTIONS(1963),
    [anon_sym_use] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(1963),
    [anon_sym_extern] = ACTIONS(1963),
    [anon_sym_DOT_DOT] = ACTIONS(1961),
    [anon_sym_yield] = ACTIONS(1963),
    [anon_sym_move] = ACTIONS(1963),
    [anon_sym_try] = ACTIONS(1963),
    [sym_integer_literal] = ACTIONS(1961),
    [aux_sym_string_literal_token1] = ACTIONS(1961),
    [sym_char_literal] = ACTIONS(1961),
    [anon_sym_true] = ACTIONS(1963),
    [anon_sym_false] = ACTIONS(1963),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1963),
    [sym_super] = ACTIONS(1963),
    [sym_crate] = ACTIONS(1963),
    [sym_metavariable] = ACTIONS(1961),
    [sym_raw_string_literal] = ACTIONS(1961),
    [sym_float_literal] = ACTIONS(1961),
  },
  [559] = {
    [sym_line_comment] = STATE(559),
    [sym_block_comment] = STATE(559),
    [ts_builtin_sym_end] = ACTIONS(1965),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_macro_rules_BANG] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1965),
    [anon_sym_u8] = ACTIONS(1967),
    [anon_sym_i8] = ACTIONS(1967),
    [anon_sym_u16] = ACTIONS(1967),
    [anon_sym_i16] = ACTIONS(1967),
    [anon_sym_u32] = ACTIONS(1967),
    [anon_sym_i32] = ACTIONS(1967),
    [anon_sym_u64] = ACTIONS(1967),
    [anon_sym_i64] = ACTIONS(1967),
    [anon_sym_u128] = ACTIONS(1967),
    [anon_sym_i128] = ACTIONS(1967),
    [anon_sym_isize] = ACTIONS(1967),
    [anon_sym_usize] = ACTIONS(1967),
    [anon_sym_f32] = ACTIONS(1967),
    [anon_sym_f64] = ACTIONS(1967),
    [anon_sym_bool] = ACTIONS(1967),
    [anon_sym_str] = ACTIONS(1967),
    [anon_sym_char] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1965),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_POUND] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_PIPE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_fn] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_impl] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_loop] = ACTIONS(1967),
    [anon_sym_match] = ACTIONS(1967),
    [anon_sym_mod] = ACTIONS(1967),
    [anon_sym_pub] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_trait] = ACTIONS(1967),
    [anon_sym_type] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_unsafe] = ACTIONS(1967),
    [anon_sym_use] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_DOT_DOT] = ACTIONS(1965),
    [anon_sym_yield] = ACTIONS(1967),
    [anon_sym_move] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [sym_integer_literal] = ACTIONS(1965),
    [aux_sym_string_literal_token1] = ACTIONS(1965),
    [sym_char_literal] = ACTIONS(1965),
    [anon_sym_true] = ACTIONS(1967),
    [anon_sym_false] = ACTIONS(1967),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1967),
    [sym_super] = ACTIONS(1967),
    [sym_crate] = ACTIONS(1967),
    [sym_metavariable] = ACTIONS(1965),
    [sym_raw_string_literal] = ACTIONS(1965),
    [sym_float_literal] = ACTIONS(1965),
  },
  [560] = {
    [sym_line_comment] = STATE(560),
    [sym_block_comment] = STATE(560),
    [ts_builtin_sym_end] = ACTIONS(1969),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym_macro_rules_BANG] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_u8] = ACTIONS(1971),
    [anon_sym_i8] = ACTIONS(1971),
    [anon_sym_u16] = ACTIONS(1971),
    [anon_sym_i16] = ACTIONS(1971),
    [anon_sym_u32] = ACTIONS(1971),
    [anon_sym_i32] = ACTIONS(1971),
    [anon_sym_u64] = ACTIONS(1971),
    [anon_sym_i64] = ACTIONS(1971),
    [anon_sym_u128] = ACTIONS(1971),
    [anon_sym_i128] = ACTIONS(1971),
    [anon_sym_isize] = ACTIONS(1971),
    [anon_sym_usize] = ACTIONS(1971),
    [anon_sym_f32] = ACTIONS(1971),
    [anon_sym_f64] = ACTIONS(1971),
    [anon_sym_bool] = ACTIONS(1971),
    [anon_sym_str] = ACTIONS(1971),
    [anon_sym_char] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_POUND] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_fn] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_impl] = ACTIONS(1971),
    [anon_sym_let] = ACTIONS(1971),
    [anon_sym_loop] = ACTIONS(1971),
    [anon_sym_match] = ACTIONS(1971),
    [anon_sym_mod] = ACTIONS(1971),
    [anon_sym_pub] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_trait] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_unsafe] = ACTIONS(1971),
    [anon_sym_use] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym_DOT_DOT] = ACTIONS(1969),
    [anon_sym_yield] = ACTIONS(1971),
    [anon_sym_move] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [sym_integer_literal] = ACTIONS(1969),
    [aux_sym_string_literal_token1] = ACTIONS(1969),
    [sym_char_literal] = ACTIONS(1969),
    [anon_sym_true] = ACTIONS(1971),
    [anon_sym_false] = ACTIONS(1971),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1971),
    [sym_super] = ACTIONS(1971),
    [sym_crate] = ACTIONS(1971),
    [sym_metavariable] = ACTIONS(1969),
    [sym_raw_string_literal] = ACTIONS(1969),
    [sym_float_literal] = ACTIONS(1969),
  },
  [561] = {
    [sym_line_comment] = STATE(561),
    [sym_block_comment] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym_macro_rules_BANG] = ACTIONS(1973),
    [anon_sym_LPAREN] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_u8] = ACTIONS(1975),
    [anon_sym_i8] = ACTIONS(1975),
    [anon_sym_u16] = ACTIONS(1975),
    [anon_sym_i16] = ACTIONS(1975),
    [anon_sym_u32] = ACTIONS(1975),
    [anon_sym_i32] = ACTIONS(1975),
    [anon_sym_u64] = ACTIONS(1975),
    [anon_sym_i64] = ACTIONS(1975),
    [anon_sym_u128] = ACTIONS(1975),
    [anon_sym_i128] = ACTIONS(1975),
    [anon_sym_isize] = ACTIONS(1975),
    [anon_sym_usize] = ACTIONS(1975),
    [anon_sym_f32] = ACTIONS(1975),
    [anon_sym_f64] = ACTIONS(1975),
    [anon_sym_bool] = ACTIONS(1975),
    [anon_sym_str] = ACTIONS(1975),
    [anon_sym_char] = ACTIONS(1975),
    [anon_sym_DASH] = ACTIONS(1973),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1973),
    [anon_sym_POUND] = ACTIONS(1973),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1975),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_fn] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_impl] = ACTIONS(1975),
    [anon_sym_let] = ACTIONS(1975),
    [anon_sym_loop] = ACTIONS(1975),
    [anon_sym_match] = ACTIONS(1975),
    [anon_sym_mod] = ACTIONS(1975),
    [anon_sym_pub] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_trait] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_unsafe] = ACTIONS(1975),
    [anon_sym_use] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_yield] = ACTIONS(1975),
    [anon_sym_move] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [sym_integer_literal] = ACTIONS(1973),
    [aux_sym_string_literal_token1] = ACTIONS(1973),
    [sym_char_literal] = ACTIONS(1973),
    [anon_sym_true] = ACTIONS(1975),
    [anon_sym_false] = ACTIONS(1975),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1975),
    [sym_super] = ACTIONS(1975),
    [sym_crate] = ACTIONS(1975),
    [sym_metavariable] = ACTIONS(1973),
    [sym_raw_string_literal] = ACTIONS(1973),
    [sym_float_literal] = ACTIONS(1973),
  },
  [562] = {
    [sym_line_comment] = STATE(562),
    [sym_block_comment] = STATE(562),
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_macro_rules_BANG] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_u8] = ACTIONS(1979),
    [anon_sym_i8] = ACTIONS(1979),
    [anon_sym_u16] = ACTIONS(1979),
    [anon_sym_i16] = ACTIONS(1979),
    [anon_sym_u32] = ACTIONS(1979),
    [anon_sym_i32] = ACTIONS(1979),
    [anon_sym_u64] = ACTIONS(1979),
    [anon_sym_i64] = ACTIONS(1979),
    [anon_sym_u128] = ACTIONS(1979),
    [anon_sym_i128] = ACTIONS(1979),
    [anon_sym_isize] = ACTIONS(1979),
    [anon_sym_usize] = ACTIONS(1979),
    [anon_sym_f32] = ACTIONS(1979),
    [anon_sym_f64] = ACTIONS(1979),
    [anon_sym_bool] = ACTIONS(1979),
    [anon_sym_str] = ACTIONS(1979),
    [anon_sym_char] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_POUND] = ACTIONS(1977),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_fn] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_impl] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_loop] = ACTIONS(1979),
    [anon_sym_match] = ACTIONS(1979),
    [anon_sym_mod] = ACTIONS(1979),
    [anon_sym_pub] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_trait] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_use] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_DOT_DOT] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_move] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [sym_integer_literal] = ACTIONS(1977),
    [aux_sym_string_literal_token1] = ACTIONS(1977),
    [sym_char_literal] = ACTIONS(1977),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_crate] = ACTIONS(1979),
    [sym_metavariable] = ACTIONS(1977),
    [sym_raw_string_literal] = ACTIONS(1977),
    [sym_float_literal] = ACTIONS(1977),
  },
  [563] = {
    [sym_line_comment] = STATE(563),
    [sym_block_comment] = STATE(563),
    [ts_builtin_sym_end] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_macro_rules_BANG] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_u8] = ACTIONS(1983),
    [anon_sym_i8] = ACTIONS(1983),
    [anon_sym_u16] = ACTIONS(1983),
    [anon_sym_i16] = ACTIONS(1983),
    [anon_sym_u32] = ACTIONS(1983),
    [anon_sym_i32] = ACTIONS(1983),
    [anon_sym_u64] = ACTIONS(1983),
    [anon_sym_i64] = ACTIONS(1983),
    [anon_sym_u128] = ACTIONS(1983),
    [anon_sym_i128] = ACTIONS(1983),
    [anon_sym_isize] = ACTIONS(1983),
    [anon_sym_usize] = ACTIONS(1983),
    [anon_sym_f32] = ACTIONS(1983),
    [anon_sym_f64] = ACTIONS(1983),
    [anon_sym_bool] = ACTIONS(1983),
    [anon_sym_str] = ACTIONS(1983),
    [anon_sym_char] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1981),
    [anon_sym_POUND] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_async] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_fn] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_impl] = ACTIONS(1983),
    [anon_sym_let] = ACTIONS(1983),
    [anon_sym_loop] = ACTIONS(1983),
    [anon_sym_match] = ACTIONS(1983),
    [anon_sym_mod] = ACTIONS(1983),
    [anon_sym_pub] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_trait] = ACTIONS(1983),
    [anon_sym_type] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_unsafe] = ACTIONS(1983),
    [anon_sym_use] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_move] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [sym_integer_literal] = ACTIONS(1981),
    [aux_sym_string_literal_token1] = ACTIONS(1981),
    [sym_char_literal] = ACTIONS(1981),
    [anon_sym_true] = ACTIONS(1983),
    [anon_sym_false] = ACTIONS(1983),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1983),
    [sym_super] = ACTIONS(1983),
    [sym_crate] = ACTIONS(1983),
    [sym_metavariable] = ACTIONS(1981),
    [sym_raw_string_literal] = ACTIONS(1981),
    [sym_float_literal] = ACTIONS(1981),
  },
  [564] = {
    [sym_line_comment] = STATE(564),
    [sym_block_comment] = STATE(564),
    [ts_builtin_sym_end] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_macro_rules_BANG] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_u8] = ACTIONS(1987),
    [anon_sym_i8] = ACTIONS(1987),
    [anon_sym_u16] = ACTIONS(1987),
    [anon_sym_i16] = ACTIONS(1987),
    [anon_sym_u32] = ACTIONS(1987),
    [anon_sym_i32] = ACTIONS(1987),
    [anon_sym_u64] = ACTIONS(1987),
    [anon_sym_i64] = ACTIONS(1987),
    [anon_sym_u128] = ACTIONS(1987),
    [anon_sym_i128] = ACTIONS(1987),
    [anon_sym_isize] = ACTIONS(1987),
    [anon_sym_usize] = ACTIONS(1987),
    [anon_sym_f32] = ACTIONS(1987),
    [anon_sym_f64] = ACTIONS(1987),
    [anon_sym_bool] = ACTIONS(1987),
    [anon_sym_str] = ACTIONS(1987),
    [anon_sym_char] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_POUND] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1987),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_fn] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_impl] = ACTIONS(1987),
    [anon_sym_let] = ACTIONS(1987),
    [anon_sym_loop] = ACTIONS(1987),
    [anon_sym_match] = ACTIONS(1987),
    [anon_sym_mod] = ACTIONS(1987),
    [anon_sym_pub] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_trait] = ACTIONS(1987),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_unsafe] = ACTIONS(1987),
    [anon_sym_use] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_DOT_DOT] = ACTIONS(1985),
    [anon_sym_yield] = ACTIONS(1987),
    [anon_sym_move] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [sym_integer_literal] = ACTIONS(1985),
    [aux_sym_string_literal_token1] = ACTIONS(1985),
    [sym_char_literal] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(1987),
    [anon_sym_false] = ACTIONS(1987),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1987),
    [sym_super] = ACTIONS(1987),
    [sym_crate] = ACTIONS(1987),
    [sym_metavariable] = ACTIONS(1985),
    [sym_raw_string_literal] = ACTIONS(1985),
    [sym_float_literal] = ACTIONS(1985),
  },
  [565] = {
    [sym_line_comment] = STATE(565),
    [sym_block_comment] = STATE(565),
    [ts_builtin_sym_end] = ACTIONS(886),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(886),
    [anon_sym_macro_rules_BANG] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(886),
    [anon_sym_u8] = ACTIONS(888),
    [anon_sym_i8] = ACTIONS(888),
    [anon_sym_u16] = ACTIONS(888),
    [anon_sym_i16] = ACTIONS(888),
    [anon_sym_u32] = ACTIONS(888),
    [anon_sym_i32] = ACTIONS(888),
    [anon_sym_u64] = ACTIONS(888),
    [anon_sym_i64] = ACTIONS(888),
    [anon_sym_u128] = ACTIONS(888),
    [anon_sym_i128] = ACTIONS(888),
    [anon_sym_isize] = ACTIONS(888),
    [anon_sym_usize] = ACTIONS(888),
    [anon_sym_f32] = ACTIONS(888),
    [anon_sym_f64] = ACTIONS(888),
    [anon_sym_bool] = ACTIONS(888),
    [anon_sym_str] = ACTIONS(888),
    [anon_sym_char] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_COLON_COLON] = ACTIONS(886),
    [anon_sym_BANG] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_POUND] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_SQUOTE] = ACTIONS(888),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_break] = ACTIONS(888),
    [anon_sym_const] = ACTIONS(888),
    [anon_sym_continue] = ACTIONS(888),
    [anon_sym_default] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(888),
    [anon_sym_fn] = ACTIONS(888),
    [anon_sym_for] = ACTIONS(888),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_impl] = ACTIONS(888),
    [anon_sym_let] = ACTIONS(888),
    [anon_sym_loop] = ACTIONS(888),
    [anon_sym_match] = ACTIONS(888),
    [anon_sym_mod] = ACTIONS(888),
    [anon_sym_pub] = ACTIONS(888),
    [anon_sym_return] = ACTIONS(888),
    [anon_sym_static] = ACTIONS(888),
    [anon_sym_struct] = ACTIONS(888),
    [anon_sym_trait] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(888),
    [anon_sym_union] = ACTIONS(888),
    [anon_sym_unsafe] = ACTIONS(888),
    [anon_sym_use] = ACTIONS(888),
    [anon_sym_while] = ACTIONS(888),
    [anon_sym_extern] = ACTIONS(888),
    [anon_sym_DOT_DOT] = ACTIONS(886),
    [anon_sym_yield] = ACTIONS(888),
    [anon_sym_move] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(888),
    [sym_integer_literal] = ACTIONS(886),
    [aux_sym_string_literal_token1] = ACTIONS(886),
    [sym_char_literal] = ACTIONS(886),
    [anon_sym_true] = ACTIONS(888),
    [anon_sym_false] = ACTIONS(888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(888),
    [sym_super] = ACTIONS(888),
    [sym_crate] = ACTIONS(888),
    [sym_metavariable] = ACTIONS(886),
    [sym_raw_string_literal] = ACTIONS(886),
    [sym_float_literal] = ACTIONS(886),
  },
  [566] = {
    [sym_line_comment] = STATE(566),
    [sym_block_comment] = STATE(566),
    [ts_builtin_sym_end] = ACTIONS(1989),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_macro_rules_BANG] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_u8] = ACTIONS(1991),
    [anon_sym_i8] = ACTIONS(1991),
    [anon_sym_u16] = ACTIONS(1991),
    [anon_sym_i16] = ACTIONS(1991),
    [anon_sym_u32] = ACTIONS(1991),
    [anon_sym_i32] = ACTIONS(1991),
    [anon_sym_u64] = ACTIONS(1991),
    [anon_sym_i64] = ACTIONS(1991),
    [anon_sym_u128] = ACTIONS(1991),
    [anon_sym_i128] = ACTIONS(1991),
    [anon_sym_isize] = ACTIONS(1991),
    [anon_sym_usize] = ACTIONS(1991),
    [anon_sym_f32] = ACTIONS(1991),
    [anon_sym_f64] = ACTIONS(1991),
    [anon_sym_bool] = ACTIONS(1991),
    [anon_sym_str] = ACTIONS(1991),
    [anon_sym_char] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_POUND] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1991),
    [anon_sym_async] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_fn] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_impl] = ACTIONS(1991),
    [anon_sym_let] = ACTIONS(1991),
    [anon_sym_loop] = ACTIONS(1991),
    [anon_sym_match] = ACTIONS(1991),
    [anon_sym_mod] = ACTIONS(1991),
    [anon_sym_pub] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_trait] = ACTIONS(1991),
    [anon_sym_type] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_unsafe] = ACTIONS(1991),
    [anon_sym_use] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1989),
    [anon_sym_yield] = ACTIONS(1991),
    [anon_sym_move] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [sym_integer_literal] = ACTIONS(1989),
    [aux_sym_string_literal_token1] = ACTIONS(1989),
    [sym_char_literal] = ACTIONS(1989),
    [anon_sym_true] = ACTIONS(1991),
    [anon_sym_false] = ACTIONS(1991),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1991),
    [sym_super] = ACTIONS(1991),
    [sym_crate] = ACTIONS(1991),
    [sym_metavariable] = ACTIONS(1989),
    [sym_raw_string_literal] = ACTIONS(1989),
    [sym_float_literal] = ACTIONS(1989),
  },
  [567] = {
    [sym_line_comment] = STATE(567),
    [sym_block_comment] = STATE(567),
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym_macro_rules_BANG] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_u8] = ACTIONS(1995),
    [anon_sym_i8] = ACTIONS(1995),
    [anon_sym_u16] = ACTIONS(1995),
    [anon_sym_i16] = ACTIONS(1995),
    [anon_sym_u32] = ACTIONS(1995),
    [anon_sym_i32] = ACTIONS(1995),
    [anon_sym_u64] = ACTIONS(1995),
    [anon_sym_i64] = ACTIONS(1995),
    [anon_sym_u128] = ACTIONS(1995),
    [anon_sym_i128] = ACTIONS(1995),
    [anon_sym_isize] = ACTIONS(1995),
    [anon_sym_usize] = ACTIONS(1995),
    [anon_sym_f32] = ACTIONS(1995),
    [anon_sym_f64] = ACTIONS(1995),
    [anon_sym_bool] = ACTIONS(1995),
    [anon_sym_str] = ACTIONS(1995),
    [anon_sym_char] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1993),
    [anon_sym_POUND] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [anon_sym_fn] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_impl] = ACTIONS(1995),
    [anon_sym_let] = ACTIONS(1995),
    [anon_sym_loop] = ACTIONS(1995),
    [anon_sym_match] = ACTIONS(1995),
    [anon_sym_mod] = ACTIONS(1995),
    [anon_sym_pub] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_struct] = ACTIONS(1995),
    [anon_sym_trait] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_union] = ACTIONS(1995),
    [anon_sym_unsafe] = ACTIONS(1995),
    [anon_sym_use] = ACTIONS(1995),
    [anon_sym_while] = ACTIONS(1995),
    [anon_sym_extern] = ACTIONS(1995),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_yield] = ACTIONS(1995),
    [anon_sym_move] = ACTIONS(1995),
    [anon_sym_try] = ACTIONS(1995),
    [sym_integer_literal] = ACTIONS(1993),
    [aux_sym_string_literal_token1] = ACTIONS(1993),
    [sym_char_literal] = ACTIONS(1993),
    [anon_sym_true] = ACTIONS(1995),
    [anon_sym_false] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1995),
    [sym_super] = ACTIONS(1995),
    [sym_crate] = ACTIONS(1995),
    [sym_metavariable] = ACTIONS(1993),
    [sym_raw_string_literal] = ACTIONS(1993),
    [sym_float_literal] = ACTIONS(1993),
  },
  [568] = {
    [sym_line_comment] = STATE(568),
    [sym_block_comment] = STATE(568),
    [ts_builtin_sym_end] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_macro_rules_BANG] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u8] = ACTIONS(1999),
    [anon_sym_i8] = ACTIONS(1999),
    [anon_sym_u16] = ACTIONS(1999),
    [anon_sym_i16] = ACTIONS(1999),
    [anon_sym_u32] = ACTIONS(1999),
    [anon_sym_i32] = ACTIONS(1999),
    [anon_sym_u64] = ACTIONS(1999),
    [anon_sym_i64] = ACTIONS(1999),
    [anon_sym_u128] = ACTIONS(1999),
    [anon_sym_i128] = ACTIONS(1999),
    [anon_sym_isize] = ACTIONS(1999),
    [anon_sym_usize] = ACTIONS(1999),
    [anon_sym_f32] = ACTIONS(1999),
    [anon_sym_f64] = ACTIONS(1999),
    [anon_sym_bool] = ACTIONS(1999),
    [anon_sym_str] = ACTIONS(1999),
    [anon_sym_char] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_POUND] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_break] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_continue] = ACTIONS(1999),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
    [anon_sym_fn] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_impl] = ACTIONS(1999),
    [anon_sym_let] = ACTIONS(1999),
    [anon_sym_loop] = ACTIONS(1999),
    [anon_sym_match] = ACTIONS(1999),
    [anon_sym_mod] = ACTIONS(1999),
    [anon_sym_pub] = ACTIONS(1999),
    [anon_sym_return] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_struct] = ACTIONS(1999),
    [anon_sym_trait] = ACTIONS(1999),
    [anon_sym_type] = ACTIONS(1999),
    [anon_sym_union] = ACTIONS(1999),
    [anon_sym_unsafe] = ACTIONS(1999),
    [anon_sym_use] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_extern] = ACTIONS(1999),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_yield] = ACTIONS(1999),
    [anon_sym_move] = ACTIONS(1999),
    [anon_sym_try] = ACTIONS(1999),
    [sym_integer_literal] = ACTIONS(1997),
    [aux_sym_string_literal_token1] = ACTIONS(1997),
    [sym_char_literal] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(1999),
    [anon_sym_false] = ACTIONS(1999),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1999),
    [sym_super] = ACTIONS(1999),
    [sym_crate] = ACTIONS(1999),
    [sym_metavariable] = ACTIONS(1997),
    [sym_raw_string_literal] = ACTIONS(1997),
    [sym_float_literal] = ACTIONS(1997),
  },
  [569] = {
    [sym_line_comment] = STATE(569),
    [sym_block_comment] = STATE(569),
    [ts_builtin_sym_end] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_macro_rules_BANG] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_u8] = ACTIONS(2003),
    [anon_sym_i8] = ACTIONS(2003),
    [anon_sym_u16] = ACTIONS(2003),
    [anon_sym_i16] = ACTIONS(2003),
    [anon_sym_u32] = ACTIONS(2003),
    [anon_sym_i32] = ACTIONS(2003),
    [anon_sym_u64] = ACTIONS(2003),
    [anon_sym_i64] = ACTIONS(2003),
    [anon_sym_u128] = ACTIONS(2003),
    [anon_sym_i128] = ACTIONS(2003),
    [anon_sym_isize] = ACTIONS(2003),
    [anon_sym_usize] = ACTIONS(2003),
    [anon_sym_f32] = ACTIONS(2003),
    [anon_sym_f64] = ACTIONS(2003),
    [anon_sym_bool] = ACTIONS(2003),
    [anon_sym_str] = ACTIONS(2003),
    [anon_sym_char] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_COLON_COLON] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [anon_sym_fn] = ACTIONS(2003),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_if] = ACTIONS(2003),
    [anon_sym_impl] = ACTIONS(2003),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_loop] = ACTIONS(2003),
    [anon_sym_match] = ACTIONS(2003),
    [anon_sym_mod] = ACTIONS(2003),
    [anon_sym_pub] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_struct] = ACTIONS(2003),
    [anon_sym_trait] = ACTIONS(2003),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_union] = ACTIONS(2003),
    [anon_sym_unsafe] = ACTIONS(2003),
    [anon_sym_use] = ACTIONS(2003),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_extern] = ACTIONS(2003),
    [anon_sym_DOT_DOT] = ACTIONS(2001),
    [anon_sym_yield] = ACTIONS(2003),
    [anon_sym_move] = ACTIONS(2003),
    [anon_sym_try] = ACTIONS(2003),
    [sym_integer_literal] = ACTIONS(2001),
    [aux_sym_string_literal_token1] = ACTIONS(2001),
    [sym_char_literal] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(2003),
    [anon_sym_false] = ACTIONS(2003),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [sym_crate] = ACTIONS(2003),
    [sym_metavariable] = ACTIONS(2001),
    [sym_raw_string_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
  },
  [570] = {
    [sym_line_comment] = STATE(570),
    [sym_block_comment] = STATE(570),
    [ts_builtin_sym_end] = ACTIONS(2005),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_macro_rules_BANG] = ACTIONS(2005),
    [anon_sym_LPAREN] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2005),
    [anon_sym_u8] = ACTIONS(2007),
    [anon_sym_i8] = ACTIONS(2007),
    [anon_sym_u16] = ACTIONS(2007),
    [anon_sym_i16] = ACTIONS(2007),
    [anon_sym_u32] = ACTIONS(2007),
    [anon_sym_i32] = ACTIONS(2007),
    [anon_sym_u64] = ACTIONS(2007),
    [anon_sym_i64] = ACTIONS(2007),
    [anon_sym_u128] = ACTIONS(2007),
    [anon_sym_i128] = ACTIONS(2007),
    [anon_sym_isize] = ACTIONS(2007),
    [anon_sym_usize] = ACTIONS(2007),
    [anon_sym_f32] = ACTIONS(2007),
    [anon_sym_f64] = ACTIONS(2007),
    [anon_sym_bool] = ACTIONS(2007),
    [anon_sym_str] = ACTIONS(2007),
    [anon_sym_char] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2005),
    [anon_sym_BANG] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_POUND] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_async] = ACTIONS(2007),
    [anon_sym_break] = ACTIONS(2007),
    [anon_sym_const] = ACTIONS(2007),
    [anon_sym_continue] = ACTIONS(2007),
    [anon_sym_default] = ACTIONS(2007),
    [anon_sym_enum] = ACTIONS(2007),
    [anon_sym_fn] = ACTIONS(2007),
    [anon_sym_for] = ACTIONS(2007),
    [anon_sym_if] = ACTIONS(2007),
    [anon_sym_impl] = ACTIONS(2007),
    [anon_sym_let] = ACTIONS(2007),
    [anon_sym_loop] = ACTIONS(2007),
    [anon_sym_match] = ACTIONS(2007),
    [anon_sym_mod] = ACTIONS(2007),
    [anon_sym_pub] = ACTIONS(2007),
    [anon_sym_return] = ACTIONS(2007),
    [anon_sym_static] = ACTIONS(2007),
    [anon_sym_struct] = ACTIONS(2007),
    [anon_sym_trait] = ACTIONS(2007),
    [anon_sym_type] = ACTIONS(2007),
    [anon_sym_union] = ACTIONS(2007),
    [anon_sym_unsafe] = ACTIONS(2007),
    [anon_sym_use] = ACTIONS(2007),
    [anon_sym_while] = ACTIONS(2007),
    [anon_sym_extern] = ACTIONS(2007),
    [anon_sym_DOT_DOT] = ACTIONS(2005),
    [anon_sym_yield] = ACTIONS(2007),
    [anon_sym_move] = ACTIONS(2007),
    [anon_sym_try] = ACTIONS(2007),
    [sym_integer_literal] = ACTIONS(2005),
    [aux_sym_string_literal_token1] = ACTIONS(2005),
    [sym_char_literal] = ACTIONS(2005),
    [anon_sym_true] = ACTIONS(2007),
    [anon_sym_false] = ACTIONS(2007),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2007),
    [sym_super] = ACTIONS(2007),
    [sym_crate] = ACTIONS(2007),
    [sym_metavariable] = ACTIONS(2005),
    [sym_raw_string_literal] = ACTIONS(2005),
    [sym_float_literal] = ACTIONS(2005),
  },
  [571] = {
    [sym_line_comment] = STATE(571),
    [sym_block_comment] = STATE(571),
    [ts_builtin_sym_end] = ACTIONS(2009),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2009),
    [anon_sym_macro_rules_BANG] = ACTIONS(2009),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2009),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_RBRACE] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2009),
    [anon_sym_u8] = ACTIONS(2011),
    [anon_sym_i8] = ACTIONS(2011),
    [anon_sym_u16] = ACTIONS(2011),
    [anon_sym_i16] = ACTIONS(2011),
    [anon_sym_u32] = ACTIONS(2011),
    [anon_sym_i32] = ACTIONS(2011),
    [anon_sym_u64] = ACTIONS(2011),
    [anon_sym_i64] = ACTIONS(2011),
    [anon_sym_u128] = ACTIONS(2011),
    [anon_sym_i128] = ACTIONS(2011),
    [anon_sym_isize] = ACTIONS(2011),
    [anon_sym_usize] = ACTIONS(2011),
    [anon_sym_f32] = ACTIONS(2011),
    [anon_sym_f64] = ACTIONS(2011),
    [anon_sym_bool] = ACTIONS(2011),
    [anon_sym_str] = ACTIONS(2011),
    [anon_sym_char] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2009),
    [anon_sym_COLON_COLON] = ACTIONS(2009),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_POUND] = ACTIONS(2009),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SQUOTE] = ACTIONS(2011),
    [anon_sym_async] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_fn] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_impl] = ACTIONS(2011),
    [anon_sym_let] = ACTIONS(2011),
    [anon_sym_loop] = ACTIONS(2011),
    [anon_sym_match] = ACTIONS(2011),
    [anon_sym_mod] = ACTIONS(2011),
    [anon_sym_pub] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_trait] = ACTIONS(2011),
    [anon_sym_type] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_unsafe] = ACTIONS(2011),
    [anon_sym_use] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym_DOT_DOT] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_move] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [sym_integer_literal] = ACTIONS(2009),
    [aux_sym_string_literal_token1] = ACTIONS(2009),
    [sym_char_literal] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(2011),
    [anon_sym_false] = ACTIONS(2011),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2011),
    [sym_super] = ACTIONS(2011),
    [sym_crate] = ACTIONS(2011),
    [sym_metavariable] = ACTIONS(2009),
    [sym_raw_string_literal] = ACTIONS(2009),
    [sym_float_literal] = ACTIONS(2009),
  },
  [572] = {
    [sym_line_comment] = STATE(572),
    [sym_block_comment] = STATE(572),
    [ts_builtin_sym_end] = ACTIONS(2013),
    [sym_identifier] = ACTIONS(2015),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym_macro_rules_BANG] = ACTIONS(2013),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_u8] = ACTIONS(2015),
    [anon_sym_i8] = ACTIONS(2015),
    [anon_sym_u16] = ACTIONS(2015),
    [anon_sym_i16] = ACTIONS(2015),
    [anon_sym_u32] = ACTIONS(2015),
    [anon_sym_i32] = ACTIONS(2015),
    [anon_sym_u64] = ACTIONS(2015),
    [anon_sym_i64] = ACTIONS(2015),
    [anon_sym_u128] = ACTIONS(2015),
    [anon_sym_i128] = ACTIONS(2015),
    [anon_sym_isize] = ACTIONS(2015),
    [anon_sym_usize] = ACTIONS(2015),
    [anon_sym_f32] = ACTIONS(2015),
    [anon_sym_f64] = ACTIONS(2015),
    [anon_sym_bool] = ACTIONS(2015),
    [anon_sym_str] = ACTIONS(2015),
    [anon_sym_char] = ACTIONS(2015),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_COLON_COLON] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_POUND] = ACTIONS(2013),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2015),
    [anon_sym_async] = ACTIONS(2015),
    [anon_sym_break] = ACTIONS(2015),
    [anon_sym_const] = ACTIONS(2015),
    [anon_sym_continue] = ACTIONS(2015),
    [anon_sym_default] = ACTIONS(2015),
    [anon_sym_enum] = ACTIONS(2015),
    [anon_sym_fn] = ACTIONS(2015),
    [anon_sym_for] = ACTIONS(2015),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_impl] = ACTIONS(2015),
    [anon_sym_let] = ACTIONS(2015),
    [anon_sym_loop] = ACTIONS(2015),
    [anon_sym_match] = ACTIONS(2015),
    [anon_sym_mod] = ACTIONS(2015),
    [anon_sym_pub] = ACTIONS(2015),
    [anon_sym_return] = ACTIONS(2015),
    [anon_sym_static] = ACTIONS(2015),
    [anon_sym_struct] = ACTIONS(2015),
    [anon_sym_trait] = ACTIONS(2015),
    [anon_sym_type] = ACTIONS(2015),
    [anon_sym_union] = ACTIONS(2015),
    [anon_sym_unsafe] = ACTIONS(2015),
    [anon_sym_use] = ACTIONS(2015),
    [anon_sym_while] = ACTIONS(2015),
    [anon_sym_extern] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2013),
    [anon_sym_yield] = ACTIONS(2015),
    [anon_sym_move] = ACTIONS(2015),
    [anon_sym_try] = ACTIONS(2015),
    [sym_integer_literal] = ACTIONS(2013),
    [aux_sym_string_literal_token1] = ACTIONS(2013),
    [sym_char_literal] = ACTIONS(2013),
    [anon_sym_true] = ACTIONS(2015),
    [anon_sym_false] = ACTIONS(2015),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2015),
    [sym_super] = ACTIONS(2015),
    [sym_crate] = ACTIONS(2015),
    [sym_metavariable] = ACTIONS(2013),
    [sym_raw_string_literal] = ACTIONS(2013),
    [sym_float_literal] = ACTIONS(2013),
  },
  [573] = {
    [sym_line_comment] = STATE(573),
    [sym_block_comment] = STATE(573),
    [ts_builtin_sym_end] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2017),
    [anon_sym_macro_rules_BANG] = ACTIONS(2017),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2017),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_u8] = ACTIONS(2019),
    [anon_sym_i8] = ACTIONS(2019),
    [anon_sym_u16] = ACTIONS(2019),
    [anon_sym_i16] = ACTIONS(2019),
    [anon_sym_u32] = ACTIONS(2019),
    [anon_sym_i32] = ACTIONS(2019),
    [anon_sym_u64] = ACTIONS(2019),
    [anon_sym_i64] = ACTIONS(2019),
    [anon_sym_u128] = ACTIONS(2019),
    [anon_sym_i128] = ACTIONS(2019),
    [anon_sym_isize] = ACTIONS(2019),
    [anon_sym_usize] = ACTIONS(2019),
    [anon_sym_f32] = ACTIONS(2019),
    [anon_sym_f64] = ACTIONS(2019),
    [anon_sym_bool] = ACTIONS(2019),
    [anon_sym_str] = ACTIONS(2019),
    [anon_sym_char] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_POUND] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_break] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2019),
    [anon_sym_continue] = ACTIONS(2019),
    [anon_sym_default] = ACTIONS(2019),
    [anon_sym_enum] = ACTIONS(2019),
    [anon_sym_fn] = ACTIONS(2019),
    [anon_sym_for] = ACTIONS(2019),
    [anon_sym_if] = ACTIONS(2019),
    [anon_sym_impl] = ACTIONS(2019),
    [anon_sym_let] = ACTIONS(2019),
    [anon_sym_loop] = ACTIONS(2019),
    [anon_sym_match] = ACTIONS(2019),
    [anon_sym_mod] = ACTIONS(2019),
    [anon_sym_pub] = ACTIONS(2019),
    [anon_sym_return] = ACTIONS(2019),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_struct] = ACTIONS(2019),
    [anon_sym_trait] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_union] = ACTIONS(2019),
    [anon_sym_unsafe] = ACTIONS(2019),
    [anon_sym_use] = ACTIONS(2019),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_extern] = ACTIONS(2019),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_yield] = ACTIONS(2019),
    [anon_sym_move] = ACTIONS(2019),
    [anon_sym_try] = ACTIONS(2019),
    [sym_integer_literal] = ACTIONS(2017),
    [aux_sym_string_literal_token1] = ACTIONS(2017),
    [sym_char_literal] = ACTIONS(2017),
    [anon_sym_true] = ACTIONS(2019),
    [anon_sym_false] = ACTIONS(2019),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2019),
    [sym_super] = ACTIONS(2019),
    [sym_crate] = ACTIONS(2019),
    [sym_metavariable] = ACTIONS(2017),
    [sym_raw_string_literal] = ACTIONS(2017),
    [sym_float_literal] = ACTIONS(2017),
  },
  [574] = {
    [sym_line_comment] = STATE(574),
    [sym_block_comment] = STATE(574),
    [ts_builtin_sym_end] = ACTIONS(2021),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_macro_rules_BANG] = ACTIONS(2021),
    [anon_sym_LPAREN] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_u8] = ACTIONS(2023),
    [anon_sym_i8] = ACTIONS(2023),
    [anon_sym_u16] = ACTIONS(2023),
    [anon_sym_i16] = ACTIONS(2023),
    [anon_sym_u32] = ACTIONS(2023),
    [anon_sym_i32] = ACTIONS(2023),
    [anon_sym_u64] = ACTIONS(2023),
    [anon_sym_i64] = ACTIONS(2023),
    [anon_sym_u128] = ACTIONS(2023),
    [anon_sym_i128] = ACTIONS(2023),
    [anon_sym_isize] = ACTIONS(2023),
    [anon_sym_usize] = ACTIONS(2023),
    [anon_sym_f32] = ACTIONS(2023),
    [anon_sym_f64] = ACTIONS(2023),
    [anon_sym_bool] = ACTIONS(2023),
    [anon_sym_str] = ACTIONS(2023),
    [anon_sym_char] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2021),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_POUND] = ACTIONS(2021),
    [anon_sym_LT] = ACTIONS(2021),
    [anon_sym_PIPE] = ACTIONS(2021),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_break] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2023),
    [anon_sym_continue] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(2023),
    [anon_sym_enum] = ACTIONS(2023),
    [anon_sym_fn] = ACTIONS(2023),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(2023),
    [anon_sym_impl] = ACTIONS(2023),
    [anon_sym_let] = ACTIONS(2023),
    [anon_sym_loop] = ACTIONS(2023),
    [anon_sym_match] = ACTIONS(2023),
    [anon_sym_mod] = ACTIONS(2023),
    [anon_sym_pub] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2023),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2023),
    [anon_sym_trait] = ACTIONS(2023),
    [anon_sym_type] = ACTIONS(2023),
    [anon_sym_union] = ACTIONS(2023),
    [anon_sym_unsafe] = ACTIONS(2023),
    [anon_sym_use] = ACTIONS(2023),
    [anon_sym_while] = ACTIONS(2023),
    [anon_sym_extern] = ACTIONS(2023),
    [anon_sym_DOT_DOT] = ACTIONS(2021),
    [anon_sym_yield] = ACTIONS(2023),
    [anon_sym_move] = ACTIONS(2023),
    [anon_sym_try] = ACTIONS(2023),
    [sym_integer_literal] = ACTIONS(2021),
    [aux_sym_string_literal_token1] = ACTIONS(2021),
    [sym_char_literal] = ACTIONS(2021),
    [anon_sym_true] = ACTIONS(2023),
    [anon_sym_false] = ACTIONS(2023),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2023),
    [sym_super] = ACTIONS(2023),
    [sym_crate] = ACTIONS(2023),
    [sym_metavariable] = ACTIONS(2021),
    [sym_raw_string_literal] = ACTIONS(2021),
    [sym_float_literal] = ACTIONS(2021),
  },
  [575] = {
    [sym_line_comment] = STATE(575),
    [sym_block_comment] = STATE(575),
    [ts_builtin_sym_end] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_macro_rules_BANG] = ACTIONS(2025),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_LBRACK] = ACTIONS(2025),
    [anon_sym_LBRACE] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_u8] = ACTIONS(2027),
    [anon_sym_i8] = ACTIONS(2027),
    [anon_sym_u16] = ACTIONS(2027),
    [anon_sym_i16] = ACTIONS(2027),
    [anon_sym_u32] = ACTIONS(2027),
    [anon_sym_i32] = ACTIONS(2027),
    [anon_sym_u64] = ACTIONS(2027),
    [anon_sym_i64] = ACTIONS(2027),
    [anon_sym_u128] = ACTIONS(2027),
    [anon_sym_i128] = ACTIONS(2027),
    [anon_sym_isize] = ACTIONS(2027),
    [anon_sym_usize] = ACTIONS(2027),
    [anon_sym_f32] = ACTIONS(2027),
    [anon_sym_f64] = ACTIONS(2027),
    [anon_sym_bool] = ACTIONS(2027),
    [anon_sym_str] = ACTIONS(2027),
    [anon_sym_char] = ACTIONS(2027),
    [anon_sym_DASH] = ACTIONS(2025),
    [anon_sym_COLON_COLON] = ACTIONS(2025),
    [anon_sym_BANG] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(2025),
    [anon_sym_POUND] = ACTIONS(2025),
    [anon_sym_LT] = ACTIONS(2025),
    [anon_sym_PIPE] = ACTIONS(2025),
    [anon_sym_SQUOTE] = ACTIONS(2027),
    [anon_sym_async] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_fn] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_impl] = ACTIONS(2027),
    [anon_sym_let] = ACTIONS(2027),
    [anon_sym_loop] = ACTIONS(2027),
    [anon_sym_match] = ACTIONS(2027),
    [anon_sym_mod] = ACTIONS(2027),
    [anon_sym_pub] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_trait] = ACTIONS(2027),
    [anon_sym_type] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_unsafe] = ACTIONS(2027),
    [anon_sym_use] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym_DOT_DOT] = ACTIONS(2025),
    [anon_sym_yield] = ACTIONS(2027),
    [anon_sym_move] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [sym_integer_literal] = ACTIONS(2025),
    [aux_sym_string_literal_token1] = ACTIONS(2025),
    [sym_char_literal] = ACTIONS(2025),
    [anon_sym_true] = ACTIONS(2027),
    [anon_sym_false] = ACTIONS(2027),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2027),
    [sym_super] = ACTIONS(2027),
    [sym_crate] = ACTIONS(2027),
    [sym_metavariable] = ACTIONS(2025),
    [sym_raw_string_literal] = ACTIONS(2025),
    [sym_float_literal] = ACTIONS(2025),
  },
  [576] = {
    [sym_line_comment] = STATE(576),
    [sym_block_comment] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_macro_rules_BANG] = ACTIONS(2029),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_u8] = ACTIONS(2031),
    [anon_sym_i8] = ACTIONS(2031),
    [anon_sym_u16] = ACTIONS(2031),
    [anon_sym_i16] = ACTIONS(2031),
    [anon_sym_u32] = ACTIONS(2031),
    [anon_sym_i32] = ACTIONS(2031),
    [anon_sym_u64] = ACTIONS(2031),
    [anon_sym_i64] = ACTIONS(2031),
    [anon_sym_u128] = ACTIONS(2031),
    [anon_sym_i128] = ACTIONS(2031),
    [anon_sym_isize] = ACTIONS(2031),
    [anon_sym_usize] = ACTIONS(2031),
    [anon_sym_f32] = ACTIONS(2031),
    [anon_sym_f64] = ACTIONS(2031),
    [anon_sym_bool] = ACTIONS(2031),
    [anon_sym_str] = ACTIONS(2031),
    [anon_sym_char] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2029),
    [anon_sym_POUND] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_PIPE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_fn] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_impl] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_loop] = ACTIONS(2031),
    [anon_sym_match] = ACTIONS(2031),
    [anon_sym_mod] = ACTIONS(2031),
    [anon_sym_pub] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_trait] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [anon_sym_unsafe] = ACTIONS(2031),
    [anon_sym_use] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym_DOT_DOT] = ACTIONS(2029),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_move] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [sym_integer_literal] = ACTIONS(2029),
    [aux_sym_string_literal_token1] = ACTIONS(2029),
    [sym_char_literal] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(2031),
    [anon_sym_false] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_crate] = ACTIONS(2031),
    [sym_metavariable] = ACTIONS(2029),
    [sym_raw_string_literal] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
  },
  [577] = {
    [sym_line_comment] = STATE(577),
    [sym_block_comment] = STATE(577),
    [ts_builtin_sym_end] = ACTIONS(2033),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_macro_rules_BANG] = ACTIONS(2033),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_u8] = ACTIONS(2035),
    [anon_sym_i8] = ACTIONS(2035),
    [anon_sym_u16] = ACTIONS(2035),
    [anon_sym_i16] = ACTIONS(2035),
    [anon_sym_u32] = ACTIONS(2035),
    [anon_sym_i32] = ACTIONS(2035),
    [anon_sym_u64] = ACTIONS(2035),
    [anon_sym_i64] = ACTIONS(2035),
    [anon_sym_u128] = ACTIONS(2035),
    [anon_sym_i128] = ACTIONS(2035),
    [anon_sym_isize] = ACTIONS(2035),
    [anon_sym_usize] = ACTIONS(2035),
    [anon_sym_f32] = ACTIONS(2035),
    [anon_sym_f64] = ACTIONS(2035),
    [anon_sym_bool] = ACTIONS(2035),
    [anon_sym_str] = ACTIONS(2035),
    [anon_sym_char] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2033),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym_POUND] = ACTIONS(2033),
    [anon_sym_LT] = ACTIONS(2033),
    [anon_sym_PIPE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [anon_sym_async] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2035),
    [anon_sym_enum] = ACTIONS(2035),
    [anon_sym_fn] = ACTIONS(2035),
    [anon_sym_for] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_impl] = ACTIONS(2035),
    [anon_sym_let] = ACTIONS(2035),
    [anon_sym_loop] = ACTIONS(2035),
    [anon_sym_match] = ACTIONS(2035),
    [anon_sym_mod] = ACTIONS(2035),
    [anon_sym_pub] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_static] = ACTIONS(2035),
    [anon_sym_struct] = ACTIONS(2035),
    [anon_sym_trait] = ACTIONS(2035),
    [anon_sym_type] = ACTIONS(2035),
    [anon_sym_union] = ACTIONS(2035),
    [anon_sym_unsafe] = ACTIONS(2035),
    [anon_sym_use] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_extern] = ACTIONS(2035),
    [anon_sym_DOT_DOT] = ACTIONS(2033),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_move] = ACTIONS(2035),
    [anon_sym_try] = ACTIONS(2035),
    [sym_integer_literal] = ACTIONS(2033),
    [aux_sym_string_literal_token1] = ACTIONS(2033),
    [sym_char_literal] = ACTIONS(2033),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2035),
    [sym_super] = ACTIONS(2035),
    [sym_crate] = ACTIONS(2035),
    [sym_metavariable] = ACTIONS(2033),
    [sym_raw_string_literal] = ACTIONS(2033),
    [sym_float_literal] = ACTIONS(2033),
  },
  [578] = {
    [sym_line_comment] = STATE(578),
    [sym_block_comment] = STATE(578),
    [ts_builtin_sym_end] = ACTIONS(2037),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_macro_rules_BANG] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2037),
    [anon_sym_u8] = ACTIONS(2039),
    [anon_sym_i8] = ACTIONS(2039),
    [anon_sym_u16] = ACTIONS(2039),
    [anon_sym_i16] = ACTIONS(2039),
    [anon_sym_u32] = ACTIONS(2039),
    [anon_sym_i32] = ACTIONS(2039),
    [anon_sym_u64] = ACTIONS(2039),
    [anon_sym_i64] = ACTIONS(2039),
    [anon_sym_u128] = ACTIONS(2039),
    [anon_sym_i128] = ACTIONS(2039),
    [anon_sym_isize] = ACTIONS(2039),
    [anon_sym_usize] = ACTIONS(2039),
    [anon_sym_f32] = ACTIONS(2039),
    [anon_sym_f64] = ACTIONS(2039),
    [anon_sym_bool] = ACTIONS(2039),
    [anon_sym_str] = ACTIONS(2039),
    [anon_sym_char] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2037),
    [anon_sym_COLON_COLON] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
    [anon_sym_POUND] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2039),
    [anon_sym_async] = ACTIONS(2039),
    [anon_sym_break] = ACTIONS(2039),
    [anon_sym_const] = ACTIONS(2039),
    [anon_sym_continue] = ACTIONS(2039),
    [anon_sym_default] = ACTIONS(2039),
    [anon_sym_enum] = ACTIONS(2039),
    [anon_sym_fn] = ACTIONS(2039),
    [anon_sym_for] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(2039),
    [anon_sym_impl] = ACTIONS(2039),
    [anon_sym_let] = ACTIONS(2039),
    [anon_sym_loop] = ACTIONS(2039),
    [anon_sym_match] = ACTIONS(2039),
    [anon_sym_mod] = ACTIONS(2039),
    [anon_sym_pub] = ACTIONS(2039),
    [anon_sym_return] = ACTIONS(2039),
    [anon_sym_static] = ACTIONS(2039),
    [anon_sym_struct] = ACTIONS(2039),
    [anon_sym_trait] = ACTIONS(2039),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_union] = ACTIONS(2039),
    [anon_sym_unsafe] = ACTIONS(2039),
    [anon_sym_use] = ACTIONS(2039),
    [anon_sym_while] = ACTIONS(2039),
    [anon_sym_extern] = ACTIONS(2039),
    [anon_sym_DOT_DOT] = ACTIONS(2037),
    [anon_sym_yield] = ACTIONS(2039),
    [anon_sym_move] = ACTIONS(2039),
    [anon_sym_try] = ACTIONS(2039),
    [sym_integer_literal] = ACTIONS(2037),
    [aux_sym_string_literal_token1] = ACTIONS(2037),
    [sym_char_literal] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(2039),
    [anon_sym_false] = ACTIONS(2039),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2039),
    [sym_super] = ACTIONS(2039),
    [sym_crate] = ACTIONS(2039),
    [sym_metavariable] = ACTIONS(2037),
    [sym_raw_string_literal] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
  },
  [579] = {
    [sym_line_comment] = STATE(579),
    [sym_block_comment] = STATE(579),
    [ts_builtin_sym_end] = ACTIONS(2041),
    [sym_identifier] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_macro_rules_BANG] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_u8] = ACTIONS(2043),
    [anon_sym_i8] = ACTIONS(2043),
    [anon_sym_u16] = ACTIONS(2043),
    [anon_sym_i16] = ACTIONS(2043),
    [anon_sym_u32] = ACTIONS(2043),
    [anon_sym_i32] = ACTIONS(2043),
    [anon_sym_u64] = ACTIONS(2043),
    [anon_sym_i64] = ACTIONS(2043),
    [anon_sym_u128] = ACTIONS(2043),
    [anon_sym_i128] = ACTIONS(2043),
    [anon_sym_isize] = ACTIONS(2043),
    [anon_sym_usize] = ACTIONS(2043),
    [anon_sym_f32] = ACTIONS(2043),
    [anon_sym_f64] = ACTIONS(2043),
    [anon_sym_bool] = ACTIONS(2043),
    [anon_sym_str] = ACTIONS(2043),
    [anon_sym_char] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2041),
    [anon_sym_COLON_COLON] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_POUND] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2043),
    [anon_sym_async] = ACTIONS(2043),
    [anon_sym_break] = ACTIONS(2043),
    [anon_sym_const] = ACTIONS(2043),
    [anon_sym_continue] = ACTIONS(2043),
    [anon_sym_default] = ACTIONS(2043),
    [anon_sym_enum] = ACTIONS(2043),
    [anon_sym_fn] = ACTIONS(2043),
    [anon_sym_for] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2043),
    [anon_sym_impl] = ACTIONS(2043),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_loop] = ACTIONS(2043),
    [anon_sym_match] = ACTIONS(2043),
    [anon_sym_mod] = ACTIONS(2043),
    [anon_sym_pub] = ACTIONS(2043),
    [anon_sym_return] = ACTIONS(2043),
    [anon_sym_static] = ACTIONS(2043),
    [anon_sym_struct] = ACTIONS(2043),
    [anon_sym_trait] = ACTIONS(2043),
    [anon_sym_type] = ACTIONS(2043),
    [anon_sym_union] = ACTIONS(2043),
    [anon_sym_unsafe] = ACTIONS(2043),
    [anon_sym_use] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2043),
    [anon_sym_extern] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2041),
    [anon_sym_yield] = ACTIONS(2043),
    [anon_sym_move] = ACTIONS(2043),
    [anon_sym_try] = ACTIONS(2043),
    [sym_integer_literal] = ACTIONS(2041),
    [aux_sym_string_literal_token1] = ACTIONS(2041),
    [sym_char_literal] = ACTIONS(2041),
    [anon_sym_true] = ACTIONS(2043),
    [anon_sym_false] = ACTIONS(2043),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2043),
    [sym_super] = ACTIONS(2043),
    [sym_crate] = ACTIONS(2043),
    [sym_metavariable] = ACTIONS(2041),
    [sym_raw_string_literal] = ACTIONS(2041),
    [sym_float_literal] = ACTIONS(2041),
  },
  [580] = {
    [sym_line_comment] = STATE(580),
    [sym_block_comment] = STATE(580),
    [ts_builtin_sym_end] = ACTIONS(2045),
    [sym_identifier] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_macro_rules_BANG] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_u8] = ACTIONS(2047),
    [anon_sym_i8] = ACTIONS(2047),
    [anon_sym_u16] = ACTIONS(2047),
    [anon_sym_i16] = ACTIONS(2047),
    [anon_sym_u32] = ACTIONS(2047),
    [anon_sym_i32] = ACTIONS(2047),
    [anon_sym_u64] = ACTIONS(2047),
    [anon_sym_i64] = ACTIONS(2047),
    [anon_sym_u128] = ACTIONS(2047),
    [anon_sym_i128] = ACTIONS(2047),
    [anon_sym_isize] = ACTIONS(2047),
    [anon_sym_usize] = ACTIONS(2047),
    [anon_sym_f32] = ACTIONS(2047),
    [anon_sym_f64] = ACTIONS(2047),
    [anon_sym_bool] = ACTIONS(2047),
    [anon_sym_str] = ACTIONS(2047),
    [anon_sym_char] = ACTIONS(2047),
    [anon_sym_DASH] = ACTIONS(2045),
    [anon_sym_COLON_COLON] = ACTIONS(2045),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_POUND] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2047),
    [anon_sym_async] = ACTIONS(2047),
    [anon_sym_break] = ACTIONS(2047),
    [anon_sym_const] = ACTIONS(2047),
    [anon_sym_continue] = ACTIONS(2047),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_enum] = ACTIONS(2047),
    [anon_sym_fn] = ACTIONS(2047),
    [anon_sym_for] = ACTIONS(2047),
    [anon_sym_if] = ACTIONS(2047),
    [anon_sym_impl] = ACTIONS(2047),
    [anon_sym_let] = ACTIONS(2047),
    [anon_sym_loop] = ACTIONS(2047),
    [anon_sym_match] = ACTIONS(2047),
    [anon_sym_mod] = ACTIONS(2047),
    [anon_sym_pub] = ACTIONS(2047),
    [anon_sym_return] = ACTIONS(2047),
    [anon_sym_static] = ACTIONS(2047),
    [anon_sym_struct] = ACTIONS(2047),
    [anon_sym_trait] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2047),
    [anon_sym_union] = ACTIONS(2047),
    [anon_sym_unsafe] = ACTIONS(2047),
    [anon_sym_use] = ACTIONS(2047),
    [anon_sym_while] = ACTIONS(2047),
    [anon_sym_extern] = ACTIONS(2047),
    [anon_sym_DOT_DOT] = ACTIONS(2045),
    [anon_sym_yield] = ACTIONS(2047),
    [anon_sym_move] = ACTIONS(2047),
    [anon_sym_try] = ACTIONS(2047),
    [sym_integer_literal] = ACTIONS(2045),
    [aux_sym_string_literal_token1] = ACTIONS(2045),
    [sym_char_literal] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(2047),
    [anon_sym_false] = ACTIONS(2047),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2047),
    [sym_super] = ACTIONS(2047),
    [sym_crate] = ACTIONS(2047),
    [sym_metavariable] = ACTIONS(2045),
    [sym_raw_string_literal] = ACTIONS(2045),
    [sym_float_literal] = ACTIONS(2045),
  },
  [581] = {
    [sym_line_comment] = STATE(581),
    [sym_block_comment] = STATE(581),
    [ts_builtin_sym_end] = ACTIONS(2049),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_macro_rules_BANG] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u8] = ACTIONS(2051),
    [anon_sym_i8] = ACTIONS(2051),
    [anon_sym_u16] = ACTIONS(2051),
    [anon_sym_i16] = ACTIONS(2051),
    [anon_sym_u32] = ACTIONS(2051),
    [anon_sym_i32] = ACTIONS(2051),
    [anon_sym_u64] = ACTIONS(2051),
    [anon_sym_i64] = ACTIONS(2051),
    [anon_sym_u128] = ACTIONS(2051),
    [anon_sym_i128] = ACTIONS(2051),
    [anon_sym_isize] = ACTIONS(2051),
    [anon_sym_usize] = ACTIONS(2051),
    [anon_sym_f32] = ACTIONS(2051),
    [anon_sym_f64] = ACTIONS(2051),
    [anon_sym_bool] = ACTIONS(2051),
    [anon_sym_str] = ACTIONS(2051),
    [anon_sym_char] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2049),
    [anon_sym_COLON_COLON] = ACTIONS(2049),
    [anon_sym_BANG] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2049),
    [anon_sym_POUND] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_PIPE] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [anon_sym_async] = ACTIONS(2051),
    [anon_sym_break] = ACTIONS(2051),
    [anon_sym_const] = ACTIONS(2051),
    [anon_sym_continue] = ACTIONS(2051),
    [anon_sym_default] = ACTIONS(2051),
    [anon_sym_enum] = ACTIONS(2051),
    [anon_sym_fn] = ACTIONS(2051),
    [anon_sym_for] = ACTIONS(2051),
    [anon_sym_if] = ACTIONS(2051),
    [anon_sym_impl] = ACTIONS(2051),
    [anon_sym_let] = ACTIONS(2051),
    [anon_sym_loop] = ACTIONS(2051),
    [anon_sym_match] = ACTIONS(2051),
    [anon_sym_mod] = ACTIONS(2051),
    [anon_sym_pub] = ACTIONS(2051),
    [anon_sym_return] = ACTIONS(2051),
    [anon_sym_static] = ACTIONS(2051),
    [anon_sym_struct] = ACTIONS(2051),
    [anon_sym_trait] = ACTIONS(2051),
    [anon_sym_type] = ACTIONS(2051),
    [anon_sym_union] = ACTIONS(2051),
    [anon_sym_unsafe] = ACTIONS(2051),
    [anon_sym_use] = ACTIONS(2051),
    [anon_sym_while] = ACTIONS(2051),
    [anon_sym_extern] = ACTIONS(2051),
    [anon_sym_DOT_DOT] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2051),
    [anon_sym_move] = ACTIONS(2051),
    [anon_sym_try] = ACTIONS(2051),
    [sym_integer_literal] = ACTIONS(2049),
    [aux_sym_string_literal_token1] = ACTIONS(2049),
    [sym_char_literal] = ACTIONS(2049),
    [anon_sym_true] = ACTIONS(2051),
    [anon_sym_false] = ACTIONS(2051),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2051),
    [sym_super] = ACTIONS(2051),
    [sym_crate] = ACTIONS(2051),
    [sym_metavariable] = ACTIONS(2049),
    [sym_raw_string_literal] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
  },
  [582] = {
    [sym_line_comment] = STATE(582),
    [sym_block_comment] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_macro_rules_BANG] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_u8] = ACTIONS(2055),
    [anon_sym_i8] = ACTIONS(2055),
    [anon_sym_u16] = ACTIONS(2055),
    [anon_sym_i16] = ACTIONS(2055),
    [anon_sym_u32] = ACTIONS(2055),
    [anon_sym_i32] = ACTIONS(2055),
    [anon_sym_u64] = ACTIONS(2055),
    [anon_sym_i64] = ACTIONS(2055),
    [anon_sym_u128] = ACTIONS(2055),
    [anon_sym_i128] = ACTIONS(2055),
    [anon_sym_isize] = ACTIONS(2055),
    [anon_sym_usize] = ACTIONS(2055),
    [anon_sym_f32] = ACTIONS(2055),
    [anon_sym_f64] = ACTIONS(2055),
    [anon_sym_bool] = ACTIONS(2055),
    [anon_sym_str] = ACTIONS(2055),
    [anon_sym_char] = ACTIONS(2055),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2055),
    [anon_sym_async] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2055),
    [anon_sym_const] = ACTIONS(2055),
    [anon_sym_continue] = ACTIONS(2055),
    [anon_sym_default] = ACTIONS(2055),
    [anon_sym_enum] = ACTIONS(2055),
    [anon_sym_fn] = ACTIONS(2055),
    [anon_sym_for] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2055),
    [anon_sym_impl] = ACTIONS(2055),
    [anon_sym_let] = ACTIONS(2055),
    [anon_sym_loop] = ACTIONS(2055),
    [anon_sym_match] = ACTIONS(2055),
    [anon_sym_mod] = ACTIONS(2055),
    [anon_sym_pub] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_static] = ACTIONS(2055),
    [anon_sym_struct] = ACTIONS(2055),
    [anon_sym_trait] = ACTIONS(2055),
    [anon_sym_type] = ACTIONS(2055),
    [anon_sym_union] = ACTIONS(2055),
    [anon_sym_unsafe] = ACTIONS(2055),
    [anon_sym_use] = ACTIONS(2055),
    [anon_sym_while] = ACTIONS(2055),
    [anon_sym_extern] = ACTIONS(2055),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2055),
    [anon_sym_move] = ACTIONS(2055),
    [anon_sym_try] = ACTIONS(2055),
    [sym_integer_literal] = ACTIONS(2053),
    [aux_sym_string_literal_token1] = ACTIONS(2053),
    [sym_char_literal] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2055),
    [anon_sym_false] = ACTIONS(2055),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2055),
    [sym_super] = ACTIONS(2055),
    [sym_crate] = ACTIONS(2055),
    [sym_metavariable] = ACTIONS(2053),
    [sym_raw_string_literal] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
  },
  [583] = {
    [sym_line_comment] = STATE(583),
    [sym_block_comment] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(2057),
    [sym_identifier] = ACTIONS(2059),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_macro_rules_BANG] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_u8] = ACTIONS(2059),
    [anon_sym_i8] = ACTIONS(2059),
    [anon_sym_u16] = ACTIONS(2059),
    [anon_sym_i16] = ACTIONS(2059),
    [anon_sym_u32] = ACTIONS(2059),
    [anon_sym_i32] = ACTIONS(2059),
    [anon_sym_u64] = ACTIONS(2059),
    [anon_sym_i64] = ACTIONS(2059),
    [anon_sym_u128] = ACTIONS(2059),
    [anon_sym_i128] = ACTIONS(2059),
    [anon_sym_isize] = ACTIONS(2059),
    [anon_sym_usize] = ACTIONS(2059),
    [anon_sym_f32] = ACTIONS(2059),
    [anon_sym_f64] = ACTIONS(2059),
    [anon_sym_bool] = ACTIONS(2059),
    [anon_sym_str] = ACTIONS(2059),
    [anon_sym_char] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_POUND] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2059),
    [anon_sym_async] = ACTIONS(2059),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_const] = ACTIONS(2059),
    [anon_sym_continue] = ACTIONS(2059),
    [anon_sym_default] = ACTIONS(2059),
    [anon_sym_enum] = ACTIONS(2059),
    [anon_sym_fn] = ACTIONS(2059),
    [anon_sym_for] = ACTIONS(2059),
    [anon_sym_if] = ACTIONS(2059),
    [anon_sym_impl] = ACTIONS(2059),
    [anon_sym_let] = ACTIONS(2059),
    [anon_sym_loop] = ACTIONS(2059),
    [anon_sym_match] = ACTIONS(2059),
    [anon_sym_mod] = ACTIONS(2059),
    [anon_sym_pub] = ACTIONS(2059),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_static] = ACTIONS(2059),
    [anon_sym_struct] = ACTIONS(2059),
    [anon_sym_trait] = ACTIONS(2059),
    [anon_sym_type] = ACTIONS(2059),
    [anon_sym_union] = ACTIONS(2059),
    [anon_sym_unsafe] = ACTIONS(2059),
    [anon_sym_use] = ACTIONS(2059),
    [anon_sym_while] = ACTIONS(2059),
    [anon_sym_extern] = ACTIONS(2059),
    [anon_sym_DOT_DOT] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2059),
    [anon_sym_move] = ACTIONS(2059),
    [anon_sym_try] = ACTIONS(2059),
    [sym_integer_literal] = ACTIONS(2057),
    [aux_sym_string_literal_token1] = ACTIONS(2057),
    [sym_char_literal] = ACTIONS(2057),
    [anon_sym_true] = ACTIONS(2059),
    [anon_sym_false] = ACTIONS(2059),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2059),
    [sym_super] = ACTIONS(2059),
    [sym_crate] = ACTIONS(2059),
    [sym_metavariable] = ACTIONS(2057),
    [sym_raw_string_literal] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
  },
  [584] = {
    [sym_line_comment] = STATE(584),
    [sym_block_comment] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_macro_rules_BANG] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_u8] = ACTIONS(2063),
    [anon_sym_i8] = ACTIONS(2063),
    [anon_sym_u16] = ACTIONS(2063),
    [anon_sym_i16] = ACTIONS(2063),
    [anon_sym_u32] = ACTIONS(2063),
    [anon_sym_i32] = ACTIONS(2063),
    [anon_sym_u64] = ACTIONS(2063),
    [anon_sym_i64] = ACTIONS(2063),
    [anon_sym_u128] = ACTIONS(2063),
    [anon_sym_i128] = ACTIONS(2063),
    [anon_sym_isize] = ACTIONS(2063),
    [anon_sym_usize] = ACTIONS(2063),
    [anon_sym_f32] = ACTIONS(2063),
    [anon_sym_f64] = ACTIONS(2063),
    [anon_sym_bool] = ACTIONS(2063),
    [anon_sym_str] = ACTIONS(2063),
    [anon_sym_char] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_COLON_COLON] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_POUND] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2063),
    [anon_sym_async] = ACTIONS(2063),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2063),
    [anon_sym_continue] = ACTIONS(2063),
    [anon_sym_default] = ACTIONS(2063),
    [anon_sym_enum] = ACTIONS(2063),
    [anon_sym_fn] = ACTIONS(2063),
    [anon_sym_for] = ACTIONS(2063),
    [anon_sym_if] = ACTIONS(2063),
    [anon_sym_impl] = ACTIONS(2063),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_loop] = ACTIONS(2063),
    [anon_sym_match] = ACTIONS(2063),
    [anon_sym_mod] = ACTIONS(2063),
    [anon_sym_pub] = ACTIONS(2063),
    [anon_sym_return] = ACTIONS(2063),
    [anon_sym_static] = ACTIONS(2063),
    [anon_sym_struct] = ACTIONS(2063),
    [anon_sym_trait] = ACTIONS(2063),
    [anon_sym_type] = ACTIONS(2063),
    [anon_sym_union] = ACTIONS(2063),
    [anon_sym_unsafe] = ACTIONS(2063),
    [anon_sym_use] = ACTIONS(2063),
    [anon_sym_while] = ACTIONS(2063),
    [anon_sym_extern] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2061),
    [anon_sym_yield] = ACTIONS(2063),
    [anon_sym_move] = ACTIONS(2063),
    [anon_sym_try] = ACTIONS(2063),
    [sym_integer_literal] = ACTIONS(2061),
    [aux_sym_string_literal_token1] = ACTIONS(2061),
    [sym_char_literal] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(2063),
    [anon_sym_false] = ACTIONS(2063),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2063),
    [sym_super] = ACTIONS(2063),
    [sym_crate] = ACTIONS(2063),
    [sym_metavariable] = ACTIONS(2061),
    [sym_raw_string_literal] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
  },
  [585] = {
    [sym_line_comment] = STATE(585),
    [sym_block_comment] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_macro_rules_BANG] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_STAR] = ACTIONS(2065),
    [anon_sym_u8] = ACTIONS(2067),
    [anon_sym_i8] = ACTIONS(2067),
    [anon_sym_u16] = ACTIONS(2067),
    [anon_sym_i16] = ACTIONS(2067),
    [anon_sym_u32] = ACTIONS(2067),
    [anon_sym_i32] = ACTIONS(2067),
    [anon_sym_u64] = ACTIONS(2067),
    [anon_sym_i64] = ACTIONS(2067),
    [anon_sym_u128] = ACTIONS(2067),
    [anon_sym_i128] = ACTIONS(2067),
    [anon_sym_isize] = ACTIONS(2067),
    [anon_sym_usize] = ACTIONS(2067),
    [anon_sym_f32] = ACTIONS(2067),
    [anon_sym_f64] = ACTIONS(2067),
    [anon_sym_bool] = ACTIONS(2067),
    [anon_sym_str] = ACTIONS(2067),
    [anon_sym_char] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2065),
    [anon_sym_COLON_COLON] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
    [anon_sym_POUND] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [anon_sym_fn] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_impl] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_loop] = ACTIONS(2067),
    [anon_sym_match] = ACTIONS(2067),
    [anon_sym_mod] = ACTIONS(2067),
    [anon_sym_pub] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_struct] = ACTIONS(2067),
    [anon_sym_trait] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_union] = ACTIONS(2067),
    [anon_sym_unsafe] = ACTIONS(2067),
    [anon_sym_use] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_extern] = ACTIONS(2067),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_move] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [sym_integer_literal] = ACTIONS(2065),
    [aux_sym_string_literal_token1] = ACTIONS(2065),
    [sym_char_literal] = ACTIONS(2065),
    [anon_sym_true] = ACTIONS(2067),
    [anon_sym_false] = ACTIONS(2067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_crate] = ACTIONS(2067),
    [sym_metavariable] = ACTIONS(2065),
    [sym_raw_string_literal] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
  },
  [586] = {
    [sym_line_comment] = STATE(586),
    [sym_block_comment] = STATE(586),
    [ts_builtin_sym_end] = ACTIONS(2069),
    [sym_identifier] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_macro_rules_BANG] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_STAR] = ACTIONS(2069),
    [anon_sym_u8] = ACTIONS(2071),
    [anon_sym_i8] = ACTIONS(2071),
    [anon_sym_u16] = ACTIONS(2071),
    [anon_sym_i16] = ACTIONS(2071),
    [anon_sym_u32] = ACTIONS(2071),
    [anon_sym_i32] = ACTIONS(2071),
    [anon_sym_u64] = ACTIONS(2071),
    [anon_sym_i64] = ACTIONS(2071),
    [anon_sym_u128] = ACTIONS(2071),
    [anon_sym_i128] = ACTIONS(2071),
    [anon_sym_isize] = ACTIONS(2071),
    [anon_sym_usize] = ACTIONS(2071),
    [anon_sym_f32] = ACTIONS(2071),
    [anon_sym_f64] = ACTIONS(2071),
    [anon_sym_bool] = ACTIONS(2071),
    [anon_sym_str] = ACTIONS(2071),
    [anon_sym_char] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_COLON_COLON] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2069),
    [anon_sym_POUND] = ACTIONS(2069),
    [anon_sym_LT] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2071),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_break] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2071),
    [anon_sym_continue] = ACTIONS(2071),
    [anon_sym_default] = ACTIONS(2071),
    [anon_sym_enum] = ACTIONS(2071),
    [anon_sym_fn] = ACTIONS(2071),
    [anon_sym_for] = ACTIONS(2071),
    [anon_sym_if] = ACTIONS(2071),
    [anon_sym_impl] = ACTIONS(2071),
    [anon_sym_let] = ACTIONS(2071),
    [anon_sym_loop] = ACTIONS(2071),
    [anon_sym_match] = ACTIONS(2071),
    [anon_sym_mod] = ACTIONS(2071),
    [anon_sym_pub] = ACTIONS(2071),
    [anon_sym_return] = ACTIONS(2071),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_struct] = ACTIONS(2071),
    [anon_sym_trait] = ACTIONS(2071),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_union] = ACTIONS(2071),
    [anon_sym_unsafe] = ACTIONS(2071),
    [anon_sym_use] = ACTIONS(2071),
    [anon_sym_while] = ACTIONS(2071),
    [anon_sym_extern] = ACTIONS(2071),
    [anon_sym_DOT_DOT] = ACTIONS(2069),
    [anon_sym_yield] = ACTIONS(2071),
    [anon_sym_move] = ACTIONS(2071),
    [anon_sym_try] = ACTIONS(2071),
    [sym_integer_literal] = ACTIONS(2069),
    [aux_sym_string_literal_token1] = ACTIONS(2069),
    [sym_char_literal] = ACTIONS(2069),
    [anon_sym_true] = ACTIONS(2071),
    [anon_sym_false] = ACTIONS(2071),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2071),
    [sym_super] = ACTIONS(2071),
    [sym_crate] = ACTIONS(2071),
    [sym_metavariable] = ACTIONS(2069),
    [sym_raw_string_literal] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
  },
  [587] = {
    [sym_line_comment] = STATE(587),
    [sym_block_comment] = STATE(587),
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_SEMI] = ACTIONS(2073),
    [anon_sym_macro_rules_BANG] = ACTIONS(2073),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2073),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_u8] = ACTIONS(2075),
    [anon_sym_i8] = ACTIONS(2075),
    [anon_sym_u16] = ACTIONS(2075),
    [anon_sym_i16] = ACTIONS(2075),
    [anon_sym_u32] = ACTIONS(2075),
    [anon_sym_i32] = ACTIONS(2075),
    [anon_sym_u64] = ACTIONS(2075),
    [anon_sym_i64] = ACTIONS(2075),
    [anon_sym_u128] = ACTIONS(2075),
    [anon_sym_i128] = ACTIONS(2075),
    [anon_sym_isize] = ACTIONS(2075),
    [anon_sym_usize] = ACTIONS(2075),
    [anon_sym_f32] = ACTIONS(2075),
    [anon_sym_f64] = ACTIONS(2075),
    [anon_sym_bool] = ACTIONS(2075),
    [anon_sym_str] = ACTIONS(2075),
    [anon_sym_char] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_COLON_COLON] = ACTIONS(2073),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_POUND] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_default] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
    [anon_sym_fn] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_impl] = ACTIONS(2075),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_loop] = ACTIONS(2075),
    [anon_sym_match] = ACTIONS(2075),
    [anon_sym_mod] = ACTIONS(2075),
    [anon_sym_pub] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_static] = ACTIONS(2075),
    [anon_sym_struct] = ACTIONS(2075),
    [anon_sym_trait] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_union] = ACTIONS(2075),
    [anon_sym_unsafe] = ACTIONS(2075),
    [anon_sym_use] = ACTIONS(2075),
    [anon_sym_while] = ACTIONS(2075),
    [anon_sym_extern] = ACTIONS(2075),
    [anon_sym_DOT_DOT] = ACTIONS(2073),
    [anon_sym_yield] = ACTIONS(2075),
    [anon_sym_move] = ACTIONS(2075),
    [anon_sym_try] = ACTIONS(2075),
    [sym_integer_literal] = ACTIONS(2073),
    [aux_sym_string_literal_token1] = ACTIONS(2073),
    [sym_char_literal] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(2075),
    [anon_sym_false] = ACTIONS(2075),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2075),
    [sym_super] = ACTIONS(2075),
    [sym_crate] = ACTIONS(2075),
    [sym_metavariable] = ACTIONS(2073),
    [sym_raw_string_literal] = ACTIONS(2073),
    [sym_float_literal] = ACTIONS(2073),
  },
  [588] = {
    [sym_line_comment] = STATE(588),
    [sym_block_comment] = STATE(588),
    [ts_builtin_sym_end] = ACTIONS(2077),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_macro_rules_BANG] = ACTIONS(2077),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_LBRACE] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(2077),
    [anon_sym_u8] = ACTIONS(2079),
    [anon_sym_i8] = ACTIONS(2079),
    [anon_sym_u16] = ACTIONS(2079),
    [anon_sym_i16] = ACTIONS(2079),
    [anon_sym_u32] = ACTIONS(2079),
    [anon_sym_i32] = ACTIONS(2079),
    [anon_sym_u64] = ACTIONS(2079),
    [anon_sym_i64] = ACTIONS(2079),
    [anon_sym_u128] = ACTIONS(2079),
    [anon_sym_i128] = ACTIONS(2079),
    [anon_sym_isize] = ACTIONS(2079),
    [anon_sym_usize] = ACTIONS(2079),
    [anon_sym_f32] = ACTIONS(2079),
    [anon_sym_f64] = ACTIONS(2079),
    [anon_sym_bool] = ACTIONS(2079),
    [anon_sym_str] = ACTIONS(2079),
    [anon_sym_char] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_COLON_COLON] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2077),
    [anon_sym_AMP] = ACTIONS(2077),
    [anon_sym_POUND] = ACTIONS(2077),
    [anon_sym_LT] = ACTIONS(2077),
    [anon_sym_PIPE] = ACTIONS(2077),
    [anon_sym_SQUOTE] = ACTIONS(2079),
    [anon_sym_async] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2079),
    [anon_sym_const] = ACTIONS(2079),
    [anon_sym_continue] = ACTIONS(2079),
    [anon_sym_default] = ACTIONS(2079),
    [anon_sym_enum] = ACTIONS(2079),
    [anon_sym_fn] = ACTIONS(2079),
    [anon_sym_for] = ACTIONS(2079),
    [anon_sym_if] = ACTIONS(2079),
    [anon_sym_impl] = ACTIONS(2079),
    [anon_sym_let] = ACTIONS(2079),
    [anon_sym_loop] = ACTIONS(2079),
    [anon_sym_match] = ACTIONS(2079),
    [anon_sym_mod] = ACTIONS(2079),
    [anon_sym_pub] = ACTIONS(2079),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_static] = ACTIONS(2079),
    [anon_sym_struct] = ACTIONS(2079),
    [anon_sym_trait] = ACTIONS(2079),
    [anon_sym_type] = ACTIONS(2079),
    [anon_sym_union] = ACTIONS(2079),
    [anon_sym_unsafe] = ACTIONS(2079),
    [anon_sym_use] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(2079),
    [anon_sym_extern] = ACTIONS(2079),
    [anon_sym_DOT_DOT] = ACTIONS(2077),
    [anon_sym_yield] = ACTIONS(2079),
    [anon_sym_move] = ACTIONS(2079),
    [anon_sym_try] = ACTIONS(2079),
    [sym_integer_literal] = ACTIONS(2077),
    [aux_sym_string_literal_token1] = ACTIONS(2077),
    [sym_char_literal] = ACTIONS(2077),
    [anon_sym_true] = ACTIONS(2079),
    [anon_sym_false] = ACTIONS(2079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2079),
    [sym_super] = ACTIONS(2079),
    [sym_crate] = ACTIONS(2079),
    [sym_metavariable] = ACTIONS(2077),
    [sym_raw_string_literal] = ACTIONS(2077),
    [sym_float_literal] = ACTIONS(2077),
  },
  [589] = {
    [sym_line_comment] = STATE(589),
    [sym_block_comment] = STATE(589),
    [ts_builtin_sym_end] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_macro_rules_BANG] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(2081),
    [anon_sym_u8] = ACTIONS(2083),
    [anon_sym_i8] = ACTIONS(2083),
    [anon_sym_u16] = ACTIONS(2083),
    [anon_sym_i16] = ACTIONS(2083),
    [anon_sym_u32] = ACTIONS(2083),
    [anon_sym_i32] = ACTIONS(2083),
    [anon_sym_u64] = ACTIONS(2083),
    [anon_sym_i64] = ACTIONS(2083),
    [anon_sym_u128] = ACTIONS(2083),
    [anon_sym_i128] = ACTIONS(2083),
    [anon_sym_isize] = ACTIONS(2083),
    [anon_sym_usize] = ACTIONS(2083),
    [anon_sym_f32] = ACTIONS(2083),
    [anon_sym_f64] = ACTIONS(2083),
    [anon_sym_bool] = ACTIONS(2083),
    [anon_sym_str] = ACTIONS(2083),
    [anon_sym_char] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_COLON_COLON] = ACTIONS(2081),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_AMP] = ACTIONS(2081),
    [anon_sym_POUND] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_PIPE] = ACTIONS(2081),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [anon_sym_fn] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_impl] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_loop] = ACTIONS(2083),
    [anon_sym_match] = ACTIONS(2083),
    [anon_sym_mod] = ACTIONS(2083),
    [anon_sym_pub] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_struct] = ACTIONS(2083),
    [anon_sym_trait] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_union] = ACTIONS(2083),
    [anon_sym_unsafe] = ACTIONS(2083),
    [anon_sym_use] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_extern] = ACTIONS(2083),
    [anon_sym_DOT_DOT] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_move] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [sym_integer_literal] = ACTIONS(2081),
    [aux_sym_string_literal_token1] = ACTIONS(2081),
    [sym_char_literal] = ACTIONS(2081),
    [anon_sym_true] = ACTIONS(2083),
    [anon_sym_false] = ACTIONS(2083),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_crate] = ACTIONS(2083),
    [sym_metavariable] = ACTIONS(2081),
    [sym_raw_string_literal] = ACTIONS(2081),
    [sym_float_literal] = ACTIONS(2081),
  },
  [590] = {
    [sym_empty_statement] = STATE(1101),
    [sym_macro_definition] = STATE(1101),
    [sym_attribute_item] = STATE(1101),
    [sym_inner_attribute_item] = STATE(1101),
    [sym_mod_item] = STATE(1101),
    [sym_foreign_mod_item] = STATE(1101),
    [sym_struct_item] = STATE(1101),
    [sym_union_item] = STATE(1101),
    [sym_enum_item] = STATE(1101),
    [sym_extern_crate_declaration] = STATE(1101),
    [sym_const_item] = STATE(1101),
    [sym_static_item] = STATE(1101),
    [sym_type_item] = STATE(1101),
    [sym_function_item] = STATE(1101),
    [sym_function_signature_item] = STATE(1101),
    [sym_function_modifiers] = STATE(3508),
    [sym_impl_item] = STATE(1101),
    [sym_trait_item] = STATE(1101),
    [sym_associated_type] = STATE(1101),
    [sym_let_declaration] = STATE(1101),
    [sym_use_declaration] = STATE(1101),
    [sym_extern_modifier] = STATE(2143),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type_with_turbofish] = STATE(3269),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(3067),
    [sym_line_comment] = STATE(590),
    [sym_block_comment] = STATE(590),
    [aux_sym_declaration_list_repeat1] = STATE(590),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2085),
    [anon_sym_SEMI] = ACTIONS(2088),
    [anon_sym_macro_rules_BANG] = ACTIONS(2091),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_u8] = ACTIONS(2096),
    [anon_sym_i8] = ACTIONS(2096),
    [anon_sym_u16] = ACTIONS(2096),
    [anon_sym_i16] = ACTIONS(2096),
    [anon_sym_u32] = ACTIONS(2096),
    [anon_sym_i32] = ACTIONS(2096),
    [anon_sym_u64] = ACTIONS(2096),
    [anon_sym_i64] = ACTIONS(2096),
    [anon_sym_u128] = ACTIONS(2096),
    [anon_sym_i128] = ACTIONS(2096),
    [anon_sym_isize] = ACTIONS(2096),
    [anon_sym_usize] = ACTIONS(2096),
    [anon_sym_f32] = ACTIONS(2096),
    [anon_sym_f64] = ACTIONS(2096),
    [anon_sym_bool] = ACTIONS(2096),
    [anon_sym_str] = ACTIONS(2096),
    [anon_sym_char] = ACTIONS(2096),
    [anon_sym_COLON_COLON] = ACTIONS(2099),
    [anon_sym_POUND] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2114),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_fn] = ACTIONS(2120),
    [anon_sym_impl] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_mod] = ACTIONS(2129),
    [anon_sym_pub] = ACTIONS(2132),
    [anon_sym_static] = ACTIONS(2135),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_trait] = ACTIONS(2141),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_union] = ACTIONS(2147),
    [anon_sym_unsafe] = ACTIONS(2150),
    [anon_sym_use] = ACTIONS(2153),
    [anon_sym_extern] = ACTIONS(2156),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2159),
    [sym_super] = ACTIONS(2159),
    [sym_crate] = ACTIONS(2162),
    [sym_metavariable] = ACTIONS(2165),
  },
  [591] = {
    [sym_line_comment] = STATE(591),
    [sym_block_comment] = STATE(591),
    [ts_builtin_sym_end] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_macro_rules_BANG] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2168),
    [anon_sym_RBRACE] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2168),
    [anon_sym_u8] = ACTIONS(2170),
    [anon_sym_i8] = ACTIONS(2170),
    [anon_sym_u16] = ACTIONS(2170),
    [anon_sym_i16] = ACTIONS(2170),
    [anon_sym_u32] = ACTIONS(2170),
    [anon_sym_i32] = ACTIONS(2170),
    [anon_sym_u64] = ACTIONS(2170),
    [anon_sym_i64] = ACTIONS(2170),
    [anon_sym_u128] = ACTIONS(2170),
    [anon_sym_i128] = ACTIONS(2170),
    [anon_sym_isize] = ACTIONS(2170),
    [anon_sym_usize] = ACTIONS(2170),
    [anon_sym_f32] = ACTIONS(2170),
    [anon_sym_f64] = ACTIONS(2170),
    [anon_sym_bool] = ACTIONS(2170),
    [anon_sym_str] = ACTIONS(2170),
    [anon_sym_char] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2168),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_POUND] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_SQUOTE] = ACTIONS(2170),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_break] = ACTIONS(2170),
    [anon_sym_const] = ACTIONS(2170),
    [anon_sym_continue] = ACTIONS(2170),
    [anon_sym_default] = ACTIONS(2170),
    [anon_sym_enum] = ACTIONS(2170),
    [anon_sym_fn] = ACTIONS(2170),
    [anon_sym_for] = ACTIONS(2170),
    [anon_sym_if] = ACTIONS(2170),
    [anon_sym_impl] = ACTIONS(2170),
    [anon_sym_let] = ACTIONS(2170),
    [anon_sym_loop] = ACTIONS(2170),
    [anon_sym_match] = ACTIONS(2170),
    [anon_sym_mod] = ACTIONS(2170),
    [anon_sym_pub] = ACTIONS(2170),
    [anon_sym_return] = ACTIONS(2170),
    [anon_sym_static] = ACTIONS(2170),
    [anon_sym_struct] = ACTIONS(2170),
    [anon_sym_trait] = ACTIONS(2170),
    [anon_sym_type] = ACTIONS(2170),
    [anon_sym_union] = ACTIONS(2170),
    [anon_sym_unsafe] = ACTIONS(2170),
    [anon_sym_use] = ACTIONS(2170),
    [anon_sym_while] = ACTIONS(2170),
    [anon_sym_extern] = ACTIONS(2170),
    [anon_sym_DOT_DOT] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2170),
    [anon_sym_move] = ACTIONS(2170),
    [anon_sym_try] = ACTIONS(2170),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(2168),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(2170),
    [anon_sym_false] = ACTIONS(2170),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2170),
    [sym_super] = ACTIONS(2170),
    [sym_crate] = ACTIONS(2170),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
  },
  [592] = {
    [sym_line_comment] = STATE(592),
    [sym_block_comment] = STATE(592),
    [ts_builtin_sym_end] = ACTIONS(2172),
    [sym_identifier] = ACTIONS(2174),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_macro_rules_BANG] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_u8] = ACTIONS(2174),
    [anon_sym_i8] = ACTIONS(2174),
    [anon_sym_u16] = ACTIONS(2174),
    [anon_sym_i16] = ACTIONS(2174),
    [anon_sym_u32] = ACTIONS(2174),
    [anon_sym_i32] = ACTIONS(2174),
    [anon_sym_u64] = ACTIONS(2174),
    [anon_sym_i64] = ACTIONS(2174),
    [anon_sym_u128] = ACTIONS(2174),
    [anon_sym_i128] = ACTIONS(2174),
    [anon_sym_isize] = ACTIONS(2174),
    [anon_sym_usize] = ACTIONS(2174),
    [anon_sym_f32] = ACTIONS(2174),
    [anon_sym_f64] = ACTIONS(2174),
    [anon_sym_bool] = ACTIONS(2174),
    [anon_sym_str] = ACTIONS(2174),
    [anon_sym_char] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_POUND] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_async] = ACTIONS(2174),
    [anon_sym_break] = ACTIONS(2174),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_continue] = ACTIONS(2174),
    [anon_sym_default] = ACTIONS(2174),
    [anon_sym_enum] = ACTIONS(2174),
    [anon_sym_fn] = ACTIONS(2174),
    [anon_sym_for] = ACTIONS(2174),
    [anon_sym_if] = ACTIONS(2174),
    [anon_sym_impl] = ACTIONS(2174),
    [anon_sym_let] = ACTIONS(2174),
    [anon_sym_loop] = ACTIONS(2174),
    [anon_sym_match] = ACTIONS(2174),
    [anon_sym_mod] = ACTIONS(2174),
    [anon_sym_pub] = ACTIONS(2174),
    [anon_sym_return] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2174),
    [anon_sym_struct] = ACTIONS(2174),
    [anon_sym_trait] = ACTIONS(2174),
    [anon_sym_type] = ACTIONS(2174),
    [anon_sym_union] = ACTIONS(2174),
    [anon_sym_unsafe] = ACTIONS(2174),
    [anon_sym_use] = ACTIONS(2174),
    [anon_sym_while] = ACTIONS(2174),
    [anon_sym_extern] = ACTIONS(2174),
    [anon_sym_DOT_DOT] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2174),
    [anon_sym_move] = ACTIONS(2174),
    [anon_sym_try] = ACTIONS(2174),
    [sym_integer_literal] = ACTIONS(2172),
    [aux_sym_string_literal_token1] = ACTIONS(2172),
    [sym_char_literal] = ACTIONS(2172),
    [anon_sym_true] = ACTIONS(2174),
    [anon_sym_false] = ACTIONS(2174),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2174),
    [sym_super] = ACTIONS(2174),
    [sym_crate] = ACTIONS(2174),
    [sym_metavariable] = ACTIONS(2172),
    [sym_raw_string_literal] = ACTIONS(2172),
    [sym_float_literal] = ACTIONS(2172),
  },
  [593] = {
    [sym_line_comment] = STATE(593),
    [sym_block_comment] = STATE(593),
    [ts_builtin_sym_end] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym_macro_rules_BANG] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_u8] = ACTIONS(2178),
    [anon_sym_i8] = ACTIONS(2178),
    [anon_sym_u16] = ACTIONS(2178),
    [anon_sym_i16] = ACTIONS(2178),
    [anon_sym_u32] = ACTIONS(2178),
    [anon_sym_i32] = ACTIONS(2178),
    [anon_sym_u64] = ACTIONS(2178),
    [anon_sym_i64] = ACTIONS(2178),
    [anon_sym_u128] = ACTIONS(2178),
    [anon_sym_i128] = ACTIONS(2178),
    [anon_sym_isize] = ACTIONS(2178),
    [anon_sym_usize] = ACTIONS(2178),
    [anon_sym_f32] = ACTIONS(2178),
    [anon_sym_f64] = ACTIONS(2178),
    [anon_sym_bool] = ACTIONS(2178),
    [anon_sym_str] = ACTIONS(2178),
    [anon_sym_char] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym_POUND] = ACTIONS(2176),
    [anon_sym_LT] = ACTIONS(2176),
    [anon_sym_PIPE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [anon_sym_fn] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_impl] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_loop] = ACTIONS(2178),
    [anon_sym_match] = ACTIONS(2178),
    [anon_sym_mod] = ACTIONS(2178),
    [anon_sym_pub] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_struct] = ACTIONS(2178),
    [anon_sym_trait] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_union] = ACTIONS(2178),
    [anon_sym_unsafe] = ACTIONS(2178),
    [anon_sym_use] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_extern] = ACTIONS(2178),
    [anon_sym_DOT_DOT] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_move] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [sym_integer_literal] = ACTIONS(2176),
    [aux_sym_string_literal_token1] = ACTIONS(2176),
    [sym_char_literal] = ACTIONS(2176),
    [anon_sym_true] = ACTIONS(2178),
    [anon_sym_false] = ACTIONS(2178),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_crate] = ACTIONS(2178),
    [sym_metavariable] = ACTIONS(2176),
    [sym_raw_string_literal] = ACTIONS(2176),
    [sym_float_literal] = ACTIONS(2176),
  },
  [594] = {
    [sym_line_comment] = STATE(594),
    [sym_block_comment] = STATE(594),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2180),
    [anon_sym_macro_rules_BANG] = ACTIONS(2180),
    [anon_sym_LPAREN] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2180),
    [anon_sym_RBRACE] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2180),
    [anon_sym_u8] = ACTIONS(2182),
    [anon_sym_i8] = ACTIONS(2182),
    [anon_sym_u16] = ACTIONS(2182),
    [anon_sym_i16] = ACTIONS(2182),
    [anon_sym_u32] = ACTIONS(2182),
    [anon_sym_i32] = ACTIONS(2182),
    [anon_sym_u64] = ACTIONS(2182),
    [anon_sym_i64] = ACTIONS(2182),
    [anon_sym_u128] = ACTIONS(2182),
    [anon_sym_i128] = ACTIONS(2182),
    [anon_sym_isize] = ACTIONS(2182),
    [anon_sym_usize] = ACTIONS(2182),
    [anon_sym_f32] = ACTIONS(2182),
    [anon_sym_f64] = ACTIONS(2182),
    [anon_sym_bool] = ACTIONS(2182),
    [anon_sym_str] = ACTIONS(2182),
    [anon_sym_char] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2180),
    [anon_sym_BANG] = ACTIONS(2180),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_POUND] = ACTIONS(2180),
    [anon_sym_LT] = ACTIONS(2180),
    [anon_sym_PIPE] = ACTIONS(2180),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [anon_sym_fn] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_impl] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_loop] = ACTIONS(2182),
    [anon_sym_match] = ACTIONS(2182),
    [anon_sym_mod] = ACTIONS(2182),
    [anon_sym_pub] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_struct] = ACTIONS(2182),
    [anon_sym_trait] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_union] = ACTIONS(2182),
    [anon_sym_unsafe] = ACTIONS(2182),
    [anon_sym_use] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_extern] = ACTIONS(2182),
    [anon_sym_DOT_DOT] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_move] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [sym_integer_literal] = ACTIONS(2180),
    [aux_sym_string_literal_token1] = ACTIONS(2180),
    [sym_char_literal] = ACTIONS(2180),
    [anon_sym_true] = ACTIONS(2182),
    [anon_sym_false] = ACTIONS(2182),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_crate] = ACTIONS(2182),
    [sym_metavariable] = ACTIONS(2180),
    [sym_raw_string_literal] = ACTIONS(2180),
    [sym_float_literal] = ACTIONS(2180),
  },
  [595] = {
    [sym_line_comment] = STATE(595),
    [sym_block_comment] = STATE(595),
    [ts_builtin_sym_end] = ACTIONS(2184),
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2184),
    [anon_sym_macro_rules_BANG] = ACTIONS(2184),
    [anon_sym_LPAREN] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_LBRACE] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_u8] = ACTIONS(2186),
    [anon_sym_i8] = ACTIONS(2186),
    [anon_sym_u16] = ACTIONS(2186),
    [anon_sym_i16] = ACTIONS(2186),
    [anon_sym_u32] = ACTIONS(2186),
    [anon_sym_i32] = ACTIONS(2186),
    [anon_sym_u64] = ACTIONS(2186),
    [anon_sym_i64] = ACTIONS(2186),
    [anon_sym_u128] = ACTIONS(2186),
    [anon_sym_i128] = ACTIONS(2186),
    [anon_sym_isize] = ACTIONS(2186),
    [anon_sym_usize] = ACTIONS(2186),
    [anon_sym_f32] = ACTIONS(2186),
    [anon_sym_f64] = ACTIONS(2186),
    [anon_sym_bool] = ACTIONS(2186),
    [anon_sym_str] = ACTIONS(2186),
    [anon_sym_char] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2184),
    [anon_sym_COLON_COLON] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_POUND] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_async] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_fn] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_impl] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_loop] = ACTIONS(2186),
    [anon_sym_match] = ACTIONS(2186),
    [anon_sym_mod] = ACTIONS(2186),
    [anon_sym_pub] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_trait] = ACTIONS(2186),
    [anon_sym_type] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_unsafe] = ACTIONS(2186),
    [anon_sym_use] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2186),
    [anon_sym_move] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [sym_integer_literal] = ACTIONS(2184),
    [aux_sym_string_literal_token1] = ACTIONS(2184),
    [sym_char_literal] = ACTIONS(2184),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2186),
    [sym_super] = ACTIONS(2186),
    [sym_crate] = ACTIONS(2186),
    [sym_metavariable] = ACTIONS(2184),
    [sym_raw_string_literal] = ACTIONS(2184),
    [sym_float_literal] = ACTIONS(2184),
  },
  [596] = {
    [sym_line_comment] = STATE(596),
    [sym_block_comment] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_macro_rules_BANG] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_u8] = ACTIONS(2190),
    [anon_sym_i8] = ACTIONS(2190),
    [anon_sym_u16] = ACTIONS(2190),
    [anon_sym_i16] = ACTIONS(2190),
    [anon_sym_u32] = ACTIONS(2190),
    [anon_sym_i32] = ACTIONS(2190),
    [anon_sym_u64] = ACTIONS(2190),
    [anon_sym_i64] = ACTIONS(2190),
    [anon_sym_u128] = ACTIONS(2190),
    [anon_sym_i128] = ACTIONS(2190),
    [anon_sym_isize] = ACTIONS(2190),
    [anon_sym_usize] = ACTIONS(2190),
    [anon_sym_f32] = ACTIONS(2190),
    [anon_sym_f64] = ACTIONS(2190),
    [anon_sym_bool] = ACTIONS(2190),
    [anon_sym_str] = ACTIONS(2190),
    [anon_sym_char] = ACTIONS(2190),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2188),
    [anon_sym_POUND] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym_async] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_fn] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_impl] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_loop] = ACTIONS(2190),
    [anon_sym_match] = ACTIONS(2190),
    [anon_sym_mod] = ACTIONS(2190),
    [anon_sym_pub] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_trait] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_unsafe] = ACTIONS(2190),
    [anon_sym_use] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym_DOT_DOT] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2190),
    [anon_sym_move] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [sym_integer_literal] = ACTIONS(2188),
    [aux_sym_string_literal_token1] = ACTIONS(2188),
    [sym_char_literal] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2190),
    [anon_sym_false] = ACTIONS(2190),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2190),
    [sym_super] = ACTIONS(2190),
    [sym_crate] = ACTIONS(2190),
    [sym_metavariable] = ACTIONS(2188),
    [sym_raw_string_literal] = ACTIONS(2188),
    [sym_float_literal] = ACTIONS(2188),
  },
  [597] = {
    [sym_line_comment] = STATE(597),
    [sym_block_comment] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym_macro_rules_BANG] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_u8] = ACTIONS(2194),
    [anon_sym_i8] = ACTIONS(2194),
    [anon_sym_u16] = ACTIONS(2194),
    [anon_sym_i16] = ACTIONS(2194),
    [anon_sym_u32] = ACTIONS(2194),
    [anon_sym_i32] = ACTIONS(2194),
    [anon_sym_u64] = ACTIONS(2194),
    [anon_sym_i64] = ACTIONS(2194),
    [anon_sym_u128] = ACTIONS(2194),
    [anon_sym_i128] = ACTIONS(2194),
    [anon_sym_isize] = ACTIONS(2194),
    [anon_sym_usize] = ACTIONS(2194),
    [anon_sym_f32] = ACTIONS(2194),
    [anon_sym_f64] = ACTIONS(2194),
    [anon_sym_bool] = ACTIONS(2194),
    [anon_sym_str] = ACTIONS(2194),
    [anon_sym_char] = ACTIONS(2194),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2192),
    [anon_sym_POUND] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2194),
    [anon_sym_async] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_fn] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_impl] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_loop] = ACTIONS(2194),
    [anon_sym_match] = ACTIONS(2194),
    [anon_sym_mod] = ACTIONS(2194),
    [anon_sym_pub] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_trait] = ACTIONS(2194),
    [anon_sym_type] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_unsafe] = ACTIONS(2194),
    [anon_sym_use] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym_DOT_DOT] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2194),
    [anon_sym_move] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [sym_integer_literal] = ACTIONS(2192),
    [aux_sym_string_literal_token1] = ACTIONS(2192),
    [sym_char_literal] = ACTIONS(2192),
    [anon_sym_true] = ACTIONS(2194),
    [anon_sym_false] = ACTIONS(2194),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2194),
    [sym_super] = ACTIONS(2194),
    [sym_crate] = ACTIONS(2194),
    [sym_metavariable] = ACTIONS(2192),
    [sym_raw_string_literal] = ACTIONS(2192),
    [sym_float_literal] = ACTIONS(2192),
  },
  [598] = {
    [sym_line_comment] = STATE(598),
    [sym_block_comment] = STATE(598),
    [ts_builtin_sym_end] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_macro_rules_BANG] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_u8] = ACTIONS(2198),
    [anon_sym_i8] = ACTIONS(2198),
    [anon_sym_u16] = ACTIONS(2198),
    [anon_sym_i16] = ACTIONS(2198),
    [anon_sym_u32] = ACTIONS(2198),
    [anon_sym_i32] = ACTIONS(2198),
    [anon_sym_u64] = ACTIONS(2198),
    [anon_sym_i64] = ACTIONS(2198),
    [anon_sym_u128] = ACTIONS(2198),
    [anon_sym_i128] = ACTIONS(2198),
    [anon_sym_isize] = ACTIONS(2198),
    [anon_sym_usize] = ACTIONS(2198),
    [anon_sym_f32] = ACTIONS(2198),
    [anon_sym_f64] = ACTIONS(2198),
    [anon_sym_bool] = ACTIONS(2198),
    [anon_sym_str] = ACTIONS(2198),
    [anon_sym_char] = ACTIONS(2198),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_POUND] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [anon_sym_async] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_fn] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_impl] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_loop] = ACTIONS(2198),
    [anon_sym_match] = ACTIONS(2198),
    [anon_sym_mod] = ACTIONS(2198),
    [anon_sym_pub] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_trait] = ACTIONS(2198),
    [anon_sym_type] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_unsafe] = ACTIONS(2198),
    [anon_sym_use] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym_DOT_DOT] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2198),
    [anon_sym_move] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [sym_integer_literal] = ACTIONS(2196),
    [aux_sym_string_literal_token1] = ACTIONS(2196),
    [sym_char_literal] = ACTIONS(2196),
    [anon_sym_true] = ACTIONS(2198),
    [anon_sym_false] = ACTIONS(2198),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2198),
    [sym_super] = ACTIONS(2198),
    [sym_crate] = ACTIONS(2198),
    [sym_metavariable] = ACTIONS(2196),
    [sym_raw_string_literal] = ACTIONS(2196),
    [sym_float_literal] = ACTIONS(2196),
  },
  [599] = {
    [sym_line_comment] = STATE(599),
    [sym_block_comment] = STATE(599),
    [ts_builtin_sym_end] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_macro_rules_BANG] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_u8] = ACTIONS(2202),
    [anon_sym_i8] = ACTIONS(2202),
    [anon_sym_u16] = ACTIONS(2202),
    [anon_sym_i16] = ACTIONS(2202),
    [anon_sym_u32] = ACTIONS(2202),
    [anon_sym_i32] = ACTIONS(2202),
    [anon_sym_u64] = ACTIONS(2202),
    [anon_sym_i64] = ACTIONS(2202),
    [anon_sym_u128] = ACTIONS(2202),
    [anon_sym_i128] = ACTIONS(2202),
    [anon_sym_isize] = ACTIONS(2202),
    [anon_sym_usize] = ACTIONS(2202),
    [anon_sym_f32] = ACTIONS(2202),
    [anon_sym_f64] = ACTIONS(2202),
    [anon_sym_bool] = ACTIONS(2202),
    [anon_sym_str] = ACTIONS(2202),
    [anon_sym_char] = ACTIONS(2202),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(2200),
    [anon_sym_LT] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2202),
    [anon_sym_async] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_fn] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_impl] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_loop] = ACTIONS(2202),
    [anon_sym_match] = ACTIONS(2202),
    [anon_sym_mod] = ACTIONS(2202),
    [anon_sym_pub] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_trait] = ACTIONS(2202),
    [anon_sym_type] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_unsafe] = ACTIONS(2202),
    [anon_sym_use] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2202),
    [anon_sym_move] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [sym_integer_literal] = ACTIONS(2200),
    [aux_sym_string_literal_token1] = ACTIONS(2200),
    [sym_char_literal] = ACTIONS(2200),
    [anon_sym_true] = ACTIONS(2202),
    [anon_sym_false] = ACTIONS(2202),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2202),
    [sym_super] = ACTIONS(2202),
    [sym_crate] = ACTIONS(2202),
    [sym_metavariable] = ACTIONS(2200),
    [sym_raw_string_literal] = ACTIONS(2200),
    [sym_float_literal] = ACTIONS(2200),
  },
  [600] = {
    [sym_line_comment] = STATE(600),
    [sym_block_comment] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_macro_rules_BANG] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_u8] = ACTIONS(2206),
    [anon_sym_i8] = ACTIONS(2206),
    [anon_sym_u16] = ACTIONS(2206),
    [anon_sym_i16] = ACTIONS(2206),
    [anon_sym_u32] = ACTIONS(2206),
    [anon_sym_i32] = ACTIONS(2206),
    [anon_sym_u64] = ACTIONS(2206),
    [anon_sym_i64] = ACTIONS(2206),
    [anon_sym_u128] = ACTIONS(2206),
    [anon_sym_i128] = ACTIONS(2206),
    [anon_sym_isize] = ACTIONS(2206),
    [anon_sym_usize] = ACTIONS(2206),
    [anon_sym_f32] = ACTIONS(2206),
    [anon_sym_f64] = ACTIONS(2206),
    [anon_sym_bool] = ACTIONS(2206),
    [anon_sym_str] = ACTIONS(2206),
    [anon_sym_char] = ACTIONS(2206),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_POUND] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [anon_sym_async] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_fn] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_impl] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_loop] = ACTIONS(2206),
    [anon_sym_match] = ACTIONS(2206),
    [anon_sym_mod] = ACTIONS(2206),
    [anon_sym_pub] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_trait] = ACTIONS(2206),
    [anon_sym_type] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_unsafe] = ACTIONS(2206),
    [anon_sym_use] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym_DOT_DOT] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2206),
    [anon_sym_move] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [sym_integer_literal] = ACTIONS(2204),
    [aux_sym_string_literal_token1] = ACTIONS(2204),
    [sym_char_literal] = ACTIONS(2204),
    [anon_sym_true] = ACTIONS(2206),
    [anon_sym_false] = ACTIONS(2206),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2206),
    [sym_super] = ACTIONS(2206),
    [sym_crate] = ACTIONS(2206),
    [sym_metavariable] = ACTIONS(2204),
    [sym_raw_string_literal] = ACTIONS(2204),
    [sym_float_literal] = ACTIONS(2204),
  },
  [601] = {
    [sym_line_comment] = STATE(601),
    [sym_block_comment] = STATE(601),
    [ts_builtin_sym_end] = ACTIONS(894),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(894),
    [anon_sym_macro_rules_BANG] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(894),
    [anon_sym_RBRACE] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_u8] = ACTIONS(896),
    [anon_sym_i8] = ACTIONS(896),
    [anon_sym_u16] = ACTIONS(896),
    [anon_sym_i16] = ACTIONS(896),
    [anon_sym_u32] = ACTIONS(896),
    [anon_sym_i32] = ACTIONS(896),
    [anon_sym_u64] = ACTIONS(896),
    [anon_sym_i64] = ACTIONS(896),
    [anon_sym_u128] = ACTIONS(896),
    [anon_sym_i128] = ACTIONS(896),
    [anon_sym_isize] = ACTIONS(896),
    [anon_sym_usize] = ACTIONS(896),
    [anon_sym_f32] = ACTIONS(896),
    [anon_sym_f64] = ACTIONS(896),
    [anon_sym_bool] = ACTIONS(896),
    [anon_sym_str] = ACTIONS(896),
    [anon_sym_char] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(894),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_POUND] = ACTIONS(894),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_async] = ACTIONS(896),
    [anon_sym_break] = ACTIONS(896),
    [anon_sym_const] = ACTIONS(896),
    [anon_sym_continue] = ACTIONS(896),
    [anon_sym_default] = ACTIONS(896),
    [anon_sym_enum] = ACTIONS(896),
    [anon_sym_fn] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(896),
    [anon_sym_if] = ACTIONS(896),
    [anon_sym_impl] = ACTIONS(896),
    [anon_sym_let] = ACTIONS(896),
    [anon_sym_loop] = ACTIONS(896),
    [anon_sym_match] = ACTIONS(896),
    [anon_sym_mod] = ACTIONS(896),
    [anon_sym_pub] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(896),
    [anon_sym_struct] = ACTIONS(896),
    [anon_sym_trait] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_union] = ACTIONS(896),
    [anon_sym_unsafe] = ACTIONS(896),
    [anon_sym_use] = ACTIONS(896),
    [anon_sym_while] = ACTIONS(896),
    [anon_sym_extern] = ACTIONS(896),
    [anon_sym_DOT_DOT] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_move] = ACTIONS(896),
    [anon_sym_try] = ACTIONS(896),
    [sym_integer_literal] = ACTIONS(894),
    [aux_sym_string_literal_token1] = ACTIONS(894),
    [sym_char_literal] = ACTIONS(894),
    [anon_sym_true] = ACTIONS(896),
    [anon_sym_false] = ACTIONS(896),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(896),
    [sym_super] = ACTIONS(896),
    [sym_crate] = ACTIONS(896),
    [sym_metavariable] = ACTIONS(894),
    [sym_raw_string_literal] = ACTIONS(894),
    [sym_float_literal] = ACTIONS(894),
  },
  [602] = {
    [sym_line_comment] = STATE(602),
    [sym_block_comment] = STATE(602),
    [ts_builtin_sym_end] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym_macro_rules_BANG] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_u8] = ACTIONS(2210),
    [anon_sym_i8] = ACTIONS(2210),
    [anon_sym_u16] = ACTIONS(2210),
    [anon_sym_i16] = ACTIONS(2210),
    [anon_sym_u32] = ACTIONS(2210),
    [anon_sym_i32] = ACTIONS(2210),
    [anon_sym_u64] = ACTIONS(2210),
    [anon_sym_i64] = ACTIONS(2210),
    [anon_sym_u128] = ACTIONS(2210),
    [anon_sym_i128] = ACTIONS(2210),
    [anon_sym_isize] = ACTIONS(2210),
    [anon_sym_usize] = ACTIONS(2210),
    [anon_sym_f32] = ACTIONS(2210),
    [anon_sym_f64] = ACTIONS(2210),
    [anon_sym_bool] = ACTIONS(2210),
    [anon_sym_str] = ACTIONS(2210),
    [anon_sym_char] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2208),
    [anon_sym_POUND] = ACTIONS(2208),
    [anon_sym_LT] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [anon_sym_async] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_fn] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_impl] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_loop] = ACTIONS(2210),
    [anon_sym_match] = ACTIONS(2210),
    [anon_sym_mod] = ACTIONS(2210),
    [anon_sym_pub] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_trait] = ACTIONS(2210),
    [anon_sym_type] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_unsafe] = ACTIONS(2210),
    [anon_sym_use] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym_DOT_DOT] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2210),
    [anon_sym_move] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [sym_integer_literal] = ACTIONS(2208),
    [aux_sym_string_literal_token1] = ACTIONS(2208),
    [sym_char_literal] = ACTIONS(2208),
    [anon_sym_true] = ACTIONS(2210),
    [anon_sym_false] = ACTIONS(2210),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2210),
    [sym_super] = ACTIONS(2210),
    [sym_crate] = ACTIONS(2210),
    [sym_metavariable] = ACTIONS(2208),
    [sym_raw_string_literal] = ACTIONS(2208),
    [sym_float_literal] = ACTIONS(2208),
  },
  [603] = {
    [sym_line_comment] = STATE(603),
    [sym_block_comment] = STATE(603),
    [ts_builtin_sym_end] = ACTIONS(2212),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_macro_rules_BANG] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2212),
    [anon_sym_u8] = ACTIONS(2214),
    [anon_sym_i8] = ACTIONS(2214),
    [anon_sym_u16] = ACTIONS(2214),
    [anon_sym_i16] = ACTIONS(2214),
    [anon_sym_u32] = ACTIONS(2214),
    [anon_sym_i32] = ACTIONS(2214),
    [anon_sym_u64] = ACTIONS(2214),
    [anon_sym_i64] = ACTIONS(2214),
    [anon_sym_u128] = ACTIONS(2214),
    [anon_sym_i128] = ACTIONS(2214),
    [anon_sym_isize] = ACTIONS(2214),
    [anon_sym_usize] = ACTIONS(2214),
    [anon_sym_f32] = ACTIONS(2214),
    [anon_sym_f64] = ACTIONS(2214),
    [anon_sym_bool] = ACTIONS(2214),
    [anon_sym_str] = ACTIONS(2214),
    [anon_sym_char] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_COLON_COLON] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2212),
    [anon_sym_POUND] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym_async] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_fn] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_impl] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_loop] = ACTIONS(2214),
    [anon_sym_match] = ACTIONS(2214),
    [anon_sym_mod] = ACTIONS(2214),
    [anon_sym_pub] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_trait] = ACTIONS(2214),
    [anon_sym_type] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_unsafe] = ACTIONS(2214),
    [anon_sym_use] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2214),
    [anon_sym_move] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2212),
    [aux_sym_string_literal_token1] = ACTIONS(2212),
    [sym_char_literal] = ACTIONS(2212),
    [anon_sym_true] = ACTIONS(2214),
    [anon_sym_false] = ACTIONS(2214),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2214),
    [sym_super] = ACTIONS(2214),
    [sym_crate] = ACTIONS(2214),
    [sym_metavariable] = ACTIONS(2212),
    [sym_raw_string_literal] = ACTIONS(2212),
    [sym_float_literal] = ACTIONS(2212),
  },
  [604] = {
    [sym_empty_statement] = STATE(1101),
    [sym_macro_definition] = STATE(1101),
    [sym_attribute_item] = STATE(1101),
    [sym_inner_attribute_item] = STATE(1101),
    [sym_mod_item] = STATE(1101),
    [sym_foreign_mod_item] = STATE(1101),
    [sym_struct_item] = STATE(1101),
    [sym_union_item] = STATE(1101),
    [sym_enum_item] = STATE(1101),
    [sym_extern_crate_declaration] = STATE(1101),
    [sym_const_item] = STATE(1101),
    [sym_static_item] = STATE(1101),
    [sym_type_item] = STATE(1101),
    [sym_function_item] = STATE(1101),
    [sym_function_signature_item] = STATE(1101),
    [sym_function_modifiers] = STATE(3508),
    [sym_impl_item] = STATE(1101),
    [sym_trait_item] = STATE(1101),
    [sym_associated_type] = STATE(1101),
    [sym_let_declaration] = STATE(1101),
    [sym_use_declaration] = STATE(1101),
    [sym_extern_modifier] = STATE(2143),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type_with_turbofish] = STATE(3269),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(3067),
    [sym_line_comment] = STATE(604),
    [sym_block_comment] = STATE(604),
    [aux_sym_declaration_list_repeat1] = STATE(683),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_macro_rules_BANG] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_u8] = ACTIONS(1751),
    [anon_sym_i8] = ACTIONS(1751),
    [anon_sym_u16] = ACTIONS(1751),
    [anon_sym_i16] = ACTIONS(1751),
    [anon_sym_u32] = ACTIONS(1751),
    [anon_sym_i32] = ACTIONS(1751),
    [anon_sym_u64] = ACTIONS(1751),
    [anon_sym_i64] = ACTIONS(1751),
    [anon_sym_u128] = ACTIONS(1751),
    [anon_sym_i128] = ACTIONS(1751),
    [anon_sym_isize] = ACTIONS(1751),
    [anon_sym_usize] = ACTIONS(1751),
    [anon_sym_f32] = ACTIONS(1751),
    [anon_sym_f64] = ACTIONS(1751),
    [anon_sym_bool] = ACTIONS(1751),
    [anon_sym_str] = ACTIONS(1751),
    [anon_sym_char] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_POUND] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1757),
    [anon_sym_default] = ACTIONS(1759),
    [anon_sym_enum] = ACTIONS(1761),
    [anon_sym_fn] = ACTIONS(1763),
    [anon_sym_impl] = ACTIONS(1765),
    [anon_sym_let] = ACTIONS(1767),
    [anon_sym_mod] = ACTIONS(1769),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_struct] = ACTIONS(1773),
    [anon_sym_trait] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_union] = ACTIONS(1779),
    [anon_sym_unsafe] = ACTIONS(1781),
    [anon_sym_use] = ACTIONS(1783),
    [anon_sym_extern] = ACTIONS(1785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1787),
    [sym_super] = ACTIONS(1787),
    [sym_crate] = ACTIONS(1789),
    [sym_metavariable] = ACTIONS(1791),
  },
  [605] = {
    [sym_line_comment] = STATE(605),
    [sym_block_comment] = STATE(605),
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_macro_rules_BANG] = ACTIONS(2218),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_u8] = ACTIONS(2220),
    [anon_sym_i8] = ACTIONS(2220),
    [anon_sym_u16] = ACTIONS(2220),
    [anon_sym_i16] = ACTIONS(2220),
    [anon_sym_u32] = ACTIONS(2220),
    [anon_sym_i32] = ACTIONS(2220),
    [anon_sym_u64] = ACTIONS(2220),
    [anon_sym_i64] = ACTIONS(2220),
    [anon_sym_u128] = ACTIONS(2220),
    [anon_sym_i128] = ACTIONS(2220),
    [anon_sym_isize] = ACTIONS(2220),
    [anon_sym_usize] = ACTIONS(2220),
    [anon_sym_f32] = ACTIONS(2220),
    [anon_sym_f64] = ACTIONS(2220),
    [anon_sym_bool] = ACTIONS(2220),
    [anon_sym_str] = ACTIONS(2220),
    [anon_sym_char] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_POUND] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_PIPE] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
    [anon_sym_fn] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_impl] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_loop] = ACTIONS(2220),
    [anon_sym_match] = ACTIONS(2220),
    [anon_sym_mod] = ACTIONS(2220),
    [anon_sym_pub] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_struct] = ACTIONS(2220),
    [anon_sym_trait] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_unsafe] = ACTIONS(2220),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_move] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [sym_integer_literal] = ACTIONS(2218),
    [aux_sym_string_literal_token1] = ACTIONS(2218),
    [sym_char_literal] = ACTIONS(2218),
    [anon_sym_true] = ACTIONS(2220),
    [anon_sym_false] = ACTIONS(2220),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_crate] = ACTIONS(2220),
    [sym_metavariable] = ACTIONS(2218),
    [sym_raw_string_literal] = ACTIONS(2218),
    [sym_float_literal] = ACTIONS(2218),
  },
  [606] = {
    [sym_line_comment] = STATE(606),
    [sym_block_comment] = STATE(606),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_macro_rules_BANG] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_u8] = ACTIONS(2224),
    [anon_sym_i8] = ACTIONS(2224),
    [anon_sym_u16] = ACTIONS(2224),
    [anon_sym_i16] = ACTIONS(2224),
    [anon_sym_u32] = ACTIONS(2224),
    [anon_sym_i32] = ACTIONS(2224),
    [anon_sym_u64] = ACTIONS(2224),
    [anon_sym_i64] = ACTIONS(2224),
    [anon_sym_u128] = ACTIONS(2224),
    [anon_sym_i128] = ACTIONS(2224),
    [anon_sym_isize] = ACTIONS(2224),
    [anon_sym_usize] = ACTIONS(2224),
    [anon_sym_f32] = ACTIONS(2224),
    [anon_sym_f64] = ACTIONS(2224),
    [anon_sym_bool] = ACTIONS(2224),
    [anon_sym_str] = ACTIONS(2224),
    [anon_sym_char] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_POUND] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_fn] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_impl] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_loop] = ACTIONS(2224),
    [anon_sym_match] = ACTIONS(2224),
    [anon_sym_mod] = ACTIONS(2224),
    [anon_sym_pub] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_trait] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_use] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_DOT_DOT] = ACTIONS(2222),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_move] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [sym_integer_literal] = ACTIONS(2222),
    [aux_sym_string_literal_token1] = ACTIONS(2222),
    [sym_char_literal] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(2224),
    [anon_sym_false] = ACTIONS(2224),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_crate] = ACTIONS(2224),
    [sym_metavariable] = ACTIONS(2222),
    [sym_raw_string_literal] = ACTIONS(2222),
    [sym_float_literal] = ACTIONS(2222),
  },
  [607] = {
    [sym_line_comment] = STATE(607),
    [sym_block_comment] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_macro_rules_BANG] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_u8] = ACTIONS(2228),
    [anon_sym_i8] = ACTIONS(2228),
    [anon_sym_u16] = ACTIONS(2228),
    [anon_sym_i16] = ACTIONS(2228),
    [anon_sym_u32] = ACTIONS(2228),
    [anon_sym_i32] = ACTIONS(2228),
    [anon_sym_u64] = ACTIONS(2228),
    [anon_sym_i64] = ACTIONS(2228),
    [anon_sym_u128] = ACTIONS(2228),
    [anon_sym_i128] = ACTIONS(2228),
    [anon_sym_isize] = ACTIONS(2228),
    [anon_sym_usize] = ACTIONS(2228),
    [anon_sym_f32] = ACTIONS(2228),
    [anon_sym_f64] = ACTIONS(2228),
    [anon_sym_bool] = ACTIONS(2228),
    [anon_sym_str] = ACTIONS(2228),
    [anon_sym_char] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_POUND] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_fn] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_impl] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_loop] = ACTIONS(2228),
    [anon_sym_match] = ACTIONS(2228),
    [anon_sym_mod] = ACTIONS(2228),
    [anon_sym_pub] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_trait] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2228),
    [anon_sym_union] = ACTIONS(2228),
    [anon_sym_unsafe] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2228),
    [anon_sym_DOT_DOT] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_move] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [sym_integer_literal] = ACTIONS(2226),
    [aux_sym_string_literal_token1] = ACTIONS(2226),
    [sym_char_literal] = ACTIONS(2226),
    [anon_sym_true] = ACTIONS(2228),
    [anon_sym_false] = ACTIONS(2228),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2228),
    [sym_super] = ACTIONS(2228),
    [sym_crate] = ACTIONS(2228),
    [sym_metavariable] = ACTIONS(2226),
    [sym_raw_string_literal] = ACTIONS(2226),
    [sym_float_literal] = ACTIONS(2226),
  },
  [608] = {
    [sym_line_comment] = STATE(608),
    [sym_block_comment] = STATE(608),
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_macro_rules_BANG] = ACTIONS(2230),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2230),
    [anon_sym_u8] = ACTIONS(2232),
    [anon_sym_i8] = ACTIONS(2232),
    [anon_sym_u16] = ACTIONS(2232),
    [anon_sym_i16] = ACTIONS(2232),
    [anon_sym_u32] = ACTIONS(2232),
    [anon_sym_i32] = ACTIONS(2232),
    [anon_sym_u64] = ACTIONS(2232),
    [anon_sym_i64] = ACTIONS(2232),
    [anon_sym_u128] = ACTIONS(2232),
    [anon_sym_i128] = ACTIONS(2232),
    [anon_sym_isize] = ACTIONS(2232),
    [anon_sym_usize] = ACTIONS(2232),
    [anon_sym_f32] = ACTIONS(2232),
    [anon_sym_f64] = ACTIONS(2232),
    [anon_sym_bool] = ACTIONS(2232),
    [anon_sym_str] = ACTIONS(2232),
    [anon_sym_char] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2230),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_POUND] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(2230),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_async] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
    [anon_sym_fn] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_impl] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_loop] = ACTIONS(2232),
    [anon_sym_match] = ACTIONS(2232),
    [anon_sym_mod] = ACTIONS(2232),
    [anon_sym_pub] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_struct] = ACTIONS(2232),
    [anon_sym_trait] = ACTIONS(2232),
    [anon_sym_type] = ACTIONS(2232),
    [anon_sym_union] = ACTIONS(2232),
    [anon_sym_unsafe] = ACTIONS(2232),
    [anon_sym_use] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2232),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_yield] = ACTIONS(2232),
    [anon_sym_move] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [sym_integer_literal] = ACTIONS(2230),
    [aux_sym_string_literal_token1] = ACTIONS(2230),
    [sym_char_literal] = ACTIONS(2230),
    [anon_sym_true] = ACTIONS(2232),
    [anon_sym_false] = ACTIONS(2232),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2232),
    [sym_super] = ACTIONS(2232),
    [sym_crate] = ACTIONS(2232),
    [sym_metavariable] = ACTIONS(2230),
    [sym_raw_string_literal] = ACTIONS(2230),
    [sym_float_literal] = ACTIONS(2230),
  },
  [609] = {
    [sym_line_comment] = STATE(609),
    [sym_block_comment] = STATE(609),
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_macro_rules_BANG] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_u8] = ACTIONS(2236),
    [anon_sym_i8] = ACTIONS(2236),
    [anon_sym_u16] = ACTIONS(2236),
    [anon_sym_i16] = ACTIONS(2236),
    [anon_sym_u32] = ACTIONS(2236),
    [anon_sym_i32] = ACTIONS(2236),
    [anon_sym_u64] = ACTIONS(2236),
    [anon_sym_i64] = ACTIONS(2236),
    [anon_sym_u128] = ACTIONS(2236),
    [anon_sym_i128] = ACTIONS(2236),
    [anon_sym_isize] = ACTIONS(2236),
    [anon_sym_usize] = ACTIONS(2236),
    [anon_sym_f32] = ACTIONS(2236),
    [anon_sym_f64] = ACTIONS(2236),
    [anon_sym_bool] = ACTIONS(2236),
    [anon_sym_str] = ACTIONS(2236),
    [anon_sym_char] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_POUND] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_fn] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_impl] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_loop] = ACTIONS(2236),
    [anon_sym_match] = ACTIONS(2236),
    [anon_sym_mod] = ACTIONS(2236),
    [anon_sym_pub] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_struct] = ACTIONS(2236),
    [anon_sym_trait] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_union] = ACTIONS(2236),
    [anon_sym_unsafe] = ACTIONS(2236),
    [anon_sym_use] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2236),
    [anon_sym_DOT_DOT] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2236),
    [anon_sym_move] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [sym_integer_literal] = ACTIONS(2234),
    [aux_sym_string_literal_token1] = ACTIONS(2234),
    [sym_char_literal] = ACTIONS(2234),
    [anon_sym_true] = ACTIONS(2236),
    [anon_sym_false] = ACTIONS(2236),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [sym_crate] = ACTIONS(2236),
    [sym_metavariable] = ACTIONS(2234),
    [sym_raw_string_literal] = ACTIONS(2234),
    [sym_float_literal] = ACTIONS(2234),
  },
  [610] = {
    [sym_line_comment] = STATE(610),
    [sym_block_comment] = STATE(610),
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_macro_rules_BANG] = ACTIONS(2238),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2238),
    [anon_sym_u8] = ACTIONS(2240),
    [anon_sym_i8] = ACTIONS(2240),
    [anon_sym_u16] = ACTIONS(2240),
    [anon_sym_i16] = ACTIONS(2240),
    [anon_sym_u32] = ACTIONS(2240),
    [anon_sym_i32] = ACTIONS(2240),
    [anon_sym_u64] = ACTIONS(2240),
    [anon_sym_i64] = ACTIONS(2240),
    [anon_sym_u128] = ACTIONS(2240),
    [anon_sym_i128] = ACTIONS(2240),
    [anon_sym_isize] = ACTIONS(2240),
    [anon_sym_usize] = ACTIONS(2240),
    [anon_sym_f32] = ACTIONS(2240),
    [anon_sym_f64] = ACTIONS(2240),
    [anon_sym_bool] = ACTIONS(2240),
    [anon_sym_str] = ACTIONS(2240),
    [anon_sym_char] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2238),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_POUND] = ACTIONS(2238),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_fn] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_impl] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_loop] = ACTIONS(2240),
    [anon_sym_match] = ACTIONS(2240),
    [anon_sym_mod] = ACTIONS(2240),
    [anon_sym_pub] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_trait] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2240),
    [anon_sym_union] = ACTIONS(2240),
    [anon_sym_unsafe] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym_DOT_DOT] = ACTIONS(2238),
    [anon_sym_yield] = ACTIONS(2240),
    [anon_sym_move] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [sym_integer_literal] = ACTIONS(2238),
    [aux_sym_string_literal_token1] = ACTIONS(2238),
    [sym_char_literal] = ACTIONS(2238),
    [anon_sym_true] = ACTIONS(2240),
    [anon_sym_false] = ACTIONS(2240),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2240),
    [sym_super] = ACTIONS(2240),
    [sym_crate] = ACTIONS(2240),
    [sym_metavariable] = ACTIONS(2238),
    [sym_raw_string_literal] = ACTIONS(2238),
    [sym_float_literal] = ACTIONS(2238),
  },
  [611] = {
    [sym_line_comment] = STATE(611),
    [sym_block_comment] = STATE(611),
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_macro_rules_BANG] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2242),
    [anon_sym_u8] = ACTIONS(2244),
    [anon_sym_i8] = ACTIONS(2244),
    [anon_sym_u16] = ACTIONS(2244),
    [anon_sym_i16] = ACTIONS(2244),
    [anon_sym_u32] = ACTIONS(2244),
    [anon_sym_i32] = ACTIONS(2244),
    [anon_sym_u64] = ACTIONS(2244),
    [anon_sym_i64] = ACTIONS(2244),
    [anon_sym_u128] = ACTIONS(2244),
    [anon_sym_i128] = ACTIONS(2244),
    [anon_sym_isize] = ACTIONS(2244),
    [anon_sym_usize] = ACTIONS(2244),
    [anon_sym_f32] = ACTIONS(2244),
    [anon_sym_f64] = ACTIONS(2244),
    [anon_sym_bool] = ACTIONS(2244),
    [anon_sym_str] = ACTIONS(2244),
    [anon_sym_char] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_POUND] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_PIPE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
    [anon_sym_fn] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_impl] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_loop] = ACTIONS(2244),
    [anon_sym_match] = ACTIONS(2244),
    [anon_sym_mod] = ACTIONS(2244),
    [anon_sym_pub] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_struct] = ACTIONS(2244),
    [anon_sym_trait] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_union] = ACTIONS(2244),
    [anon_sym_unsafe] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym_DOT_DOT] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_move] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [sym_integer_literal] = ACTIONS(2242),
    [aux_sym_string_literal_token1] = ACTIONS(2242),
    [sym_char_literal] = ACTIONS(2242),
    [anon_sym_true] = ACTIONS(2244),
    [anon_sym_false] = ACTIONS(2244),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_crate] = ACTIONS(2244),
    [sym_metavariable] = ACTIONS(2242),
    [sym_raw_string_literal] = ACTIONS(2242),
    [sym_float_literal] = ACTIONS(2242),
  },
  [612] = {
    [sym_line_comment] = STATE(612),
    [sym_block_comment] = STATE(612),
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_macro_rules_BANG] = ACTIONS(2246),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_u8] = ACTIONS(2248),
    [anon_sym_i8] = ACTIONS(2248),
    [anon_sym_u16] = ACTIONS(2248),
    [anon_sym_i16] = ACTIONS(2248),
    [anon_sym_u32] = ACTIONS(2248),
    [anon_sym_i32] = ACTIONS(2248),
    [anon_sym_u64] = ACTIONS(2248),
    [anon_sym_i64] = ACTIONS(2248),
    [anon_sym_u128] = ACTIONS(2248),
    [anon_sym_i128] = ACTIONS(2248),
    [anon_sym_isize] = ACTIONS(2248),
    [anon_sym_usize] = ACTIONS(2248),
    [anon_sym_f32] = ACTIONS(2248),
    [anon_sym_f64] = ACTIONS(2248),
    [anon_sym_bool] = ACTIONS(2248),
    [anon_sym_str] = ACTIONS(2248),
    [anon_sym_char] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2246),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_POUND] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_fn] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_impl] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_loop] = ACTIONS(2248),
    [anon_sym_match] = ACTIONS(2248),
    [anon_sym_mod] = ACTIONS(2248),
    [anon_sym_pub] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_struct] = ACTIONS(2248),
    [anon_sym_trait] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_union] = ACTIONS(2248),
    [anon_sym_unsafe] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_extern] = ACTIONS(2248),
    [anon_sym_DOT_DOT] = ACTIONS(2246),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_move] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [sym_integer_literal] = ACTIONS(2246),
    [aux_sym_string_literal_token1] = ACTIONS(2246),
    [sym_char_literal] = ACTIONS(2246),
    [anon_sym_true] = ACTIONS(2248),
    [anon_sym_false] = ACTIONS(2248),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_crate] = ACTIONS(2248),
    [sym_metavariable] = ACTIONS(2246),
    [sym_raw_string_literal] = ACTIONS(2246),
    [sym_float_literal] = ACTIONS(2246),
  },
  [613] = {
    [sym_line_comment] = STATE(613),
    [sym_block_comment] = STATE(613),
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_macro_rules_BANG] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_u8] = ACTIONS(2252),
    [anon_sym_i8] = ACTIONS(2252),
    [anon_sym_u16] = ACTIONS(2252),
    [anon_sym_i16] = ACTIONS(2252),
    [anon_sym_u32] = ACTIONS(2252),
    [anon_sym_i32] = ACTIONS(2252),
    [anon_sym_u64] = ACTIONS(2252),
    [anon_sym_i64] = ACTIONS(2252),
    [anon_sym_u128] = ACTIONS(2252),
    [anon_sym_i128] = ACTIONS(2252),
    [anon_sym_isize] = ACTIONS(2252),
    [anon_sym_usize] = ACTIONS(2252),
    [anon_sym_f32] = ACTIONS(2252),
    [anon_sym_f64] = ACTIONS(2252),
    [anon_sym_bool] = ACTIONS(2252),
    [anon_sym_str] = ACTIONS(2252),
    [anon_sym_char] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_POUND] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_fn] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_impl] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_loop] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_mod] = ACTIONS(2252),
    [anon_sym_pub] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_trait] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_union] = ACTIONS(2252),
    [anon_sym_unsafe] = ACTIONS(2252),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym_DOT_DOT] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_move] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [sym_integer_literal] = ACTIONS(2250),
    [aux_sym_string_literal_token1] = ACTIONS(2250),
    [sym_char_literal] = ACTIONS(2250),
    [anon_sym_true] = ACTIONS(2252),
    [anon_sym_false] = ACTIONS(2252),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_crate] = ACTIONS(2252),
    [sym_metavariable] = ACTIONS(2250),
    [sym_raw_string_literal] = ACTIONS(2250),
    [sym_float_literal] = ACTIONS(2250),
  },
  [614] = {
    [sym_line_comment] = STATE(614),
    [sym_block_comment] = STATE(614),
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_macro_rules_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_u8] = ACTIONS(2256),
    [anon_sym_i8] = ACTIONS(2256),
    [anon_sym_u16] = ACTIONS(2256),
    [anon_sym_i16] = ACTIONS(2256),
    [anon_sym_u32] = ACTIONS(2256),
    [anon_sym_i32] = ACTIONS(2256),
    [anon_sym_u64] = ACTIONS(2256),
    [anon_sym_i64] = ACTIONS(2256),
    [anon_sym_u128] = ACTIONS(2256),
    [anon_sym_i128] = ACTIONS(2256),
    [anon_sym_isize] = ACTIONS(2256),
    [anon_sym_usize] = ACTIONS(2256),
    [anon_sym_f32] = ACTIONS(2256),
    [anon_sym_f64] = ACTIONS(2256),
    [anon_sym_bool] = ACTIONS(2256),
    [anon_sym_str] = ACTIONS(2256),
    [anon_sym_char] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_POUND] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_fn] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_impl] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_loop] = ACTIONS(2256),
    [anon_sym_match] = ACTIONS(2256),
    [anon_sym_mod] = ACTIONS(2256),
    [anon_sym_pub] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_trait] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_union] = ACTIONS(2256),
    [anon_sym_unsafe] = ACTIONS(2256),
    [anon_sym_use] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_move] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [sym_integer_literal] = ACTIONS(2254),
    [aux_sym_string_literal_token1] = ACTIONS(2254),
    [sym_char_literal] = ACTIONS(2254),
    [anon_sym_true] = ACTIONS(2256),
    [anon_sym_false] = ACTIONS(2256),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_crate] = ACTIONS(2256),
    [sym_metavariable] = ACTIONS(2254),
    [sym_raw_string_literal] = ACTIONS(2254),
    [sym_float_literal] = ACTIONS(2254),
  },
  [615] = {
    [sym_line_comment] = STATE(615),
    [sym_block_comment] = STATE(615),
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_macro_rules_BANG] = ACTIONS(2258),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_u8] = ACTIONS(2260),
    [anon_sym_i8] = ACTIONS(2260),
    [anon_sym_u16] = ACTIONS(2260),
    [anon_sym_i16] = ACTIONS(2260),
    [anon_sym_u32] = ACTIONS(2260),
    [anon_sym_i32] = ACTIONS(2260),
    [anon_sym_u64] = ACTIONS(2260),
    [anon_sym_i64] = ACTIONS(2260),
    [anon_sym_u128] = ACTIONS(2260),
    [anon_sym_i128] = ACTIONS(2260),
    [anon_sym_isize] = ACTIONS(2260),
    [anon_sym_usize] = ACTIONS(2260),
    [anon_sym_f32] = ACTIONS(2260),
    [anon_sym_f64] = ACTIONS(2260),
    [anon_sym_bool] = ACTIONS(2260),
    [anon_sym_str] = ACTIONS(2260),
    [anon_sym_char] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(2258),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_fn] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_impl] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_loop] = ACTIONS(2260),
    [anon_sym_match] = ACTIONS(2260),
    [anon_sym_mod] = ACTIONS(2260),
    [anon_sym_pub] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_trait] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_unsafe] = ACTIONS(2260),
    [anon_sym_use] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym_DOT_DOT] = ACTIONS(2258),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_move] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [sym_integer_literal] = ACTIONS(2258),
    [aux_sym_string_literal_token1] = ACTIONS(2258),
    [sym_char_literal] = ACTIONS(2258),
    [anon_sym_true] = ACTIONS(2260),
    [anon_sym_false] = ACTIONS(2260),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_crate] = ACTIONS(2260),
    [sym_metavariable] = ACTIONS(2258),
    [sym_raw_string_literal] = ACTIONS(2258),
    [sym_float_literal] = ACTIONS(2258),
  },
  [616] = {
    [sym_line_comment] = STATE(616),
    [sym_block_comment] = STATE(616),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_macro_rules_BANG] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_u8] = ACTIONS(2264),
    [anon_sym_i8] = ACTIONS(2264),
    [anon_sym_u16] = ACTIONS(2264),
    [anon_sym_i16] = ACTIONS(2264),
    [anon_sym_u32] = ACTIONS(2264),
    [anon_sym_i32] = ACTIONS(2264),
    [anon_sym_u64] = ACTIONS(2264),
    [anon_sym_i64] = ACTIONS(2264),
    [anon_sym_u128] = ACTIONS(2264),
    [anon_sym_i128] = ACTIONS(2264),
    [anon_sym_isize] = ACTIONS(2264),
    [anon_sym_usize] = ACTIONS(2264),
    [anon_sym_f32] = ACTIONS(2264),
    [anon_sym_f64] = ACTIONS(2264),
    [anon_sym_bool] = ACTIONS(2264),
    [anon_sym_str] = ACTIONS(2264),
    [anon_sym_char] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_POUND] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_fn] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_impl] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_loop] = ACTIONS(2264),
    [anon_sym_match] = ACTIONS(2264),
    [anon_sym_mod] = ACTIONS(2264),
    [anon_sym_pub] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_trait] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_unsafe] = ACTIONS(2264),
    [anon_sym_use] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym_DOT_DOT] = ACTIONS(2262),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_move] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [sym_integer_literal] = ACTIONS(2262),
    [aux_sym_string_literal_token1] = ACTIONS(2262),
    [sym_char_literal] = ACTIONS(2262),
    [anon_sym_true] = ACTIONS(2264),
    [anon_sym_false] = ACTIONS(2264),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_crate] = ACTIONS(2264),
    [sym_metavariable] = ACTIONS(2262),
    [sym_raw_string_literal] = ACTIONS(2262),
    [sym_float_literal] = ACTIONS(2262),
  },
  [617] = {
    [sym_line_comment] = STATE(617),
    [sym_block_comment] = STATE(617),
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_macro_rules_BANG] = ACTIONS(2266),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_u8] = ACTIONS(2268),
    [anon_sym_i8] = ACTIONS(2268),
    [anon_sym_u16] = ACTIONS(2268),
    [anon_sym_i16] = ACTIONS(2268),
    [anon_sym_u32] = ACTIONS(2268),
    [anon_sym_i32] = ACTIONS(2268),
    [anon_sym_u64] = ACTIONS(2268),
    [anon_sym_i64] = ACTIONS(2268),
    [anon_sym_u128] = ACTIONS(2268),
    [anon_sym_i128] = ACTIONS(2268),
    [anon_sym_isize] = ACTIONS(2268),
    [anon_sym_usize] = ACTIONS(2268),
    [anon_sym_f32] = ACTIONS(2268),
    [anon_sym_f64] = ACTIONS(2268),
    [anon_sym_bool] = ACTIONS(2268),
    [anon_sym_str] = ACTIONS(2268),
    [anon_sym_char] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_POUND] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_fn] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_impl] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_loop] = ACTIONS(2268),
    [anon_sym_match] = ACTIONS(2268),
    [anon_sym_mod] = ACTIONS(2268),
    [anon_sym_pub] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_trait] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_unsafe] = ACTIONS(2268),
    [anon_sym_use] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_move] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [sym_integer_literal] = ACTIONS(2266),
    [aux_sym_string_literal_token1] = ACTIONS(2266),
    [sym_char_literal] = ACTIONS(2266),
    [anon_sym_true] = ACTIONS(2268),
    [anon_sym_false] = ACTIONS(2268),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2268),
    [sym_super] = ACTIONS(2268),
    [sym_crate] = ACTIONS(2268),
    [sym_metavariable] = ACTIONS(2266),
    [sym_raw_string_literal] = ACTIONS(2266),
    [sym_float_literal] = ACTIONS(2266),
  },
  [618] = {
    [sym_line_comment] = STATE(618),
    [sym_block_comment] = STATE(618),
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_macro_rules_BANG] = ACTIONS(2270),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_u8] = ACTIONS(2272),
    [anon_sym_i8] = ACTIONS(2272),
    [anon_sym_u16] = ACTIONS(2272),
    [anon_sym_i16] = ACTIONS(2272),
    [anon_sym_u32] = ACTIONS(2272),
    [anon_sym_i32] = ACTIONS(2272),
    [anon_sym_u64] = ACTIONS(2272),
    [anon_sym_i64] = ACTIONS(2272),
    [anon_sym_u128] = ACTIONS(2272),
    [anon_sym_i128] = ACTIONS(2272),
    [anon_sym_isize] = ACTIONS(2272),
    [anon_sym_usize] = ACTIONS(2272),
    [anon_sym_f32] = ACTIONS(2272),
    [anon_sym_f64] = ACTIONS(2272),
    [anon_sym_bool] = ACTIONS(2272),
    [anon_sym_str] = ACTIONS(2272),
    [anon_sym_char] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_POUND] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_fn] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_impl] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_loop] = ACTIONS(2272),
    [anon_sym_match] = ACTIONS(2272),
    [anon_sym_mod] = ACTIONS(2272),
    [anon_sym_pub] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_trait] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_unsafe] = ACTIONS(2272),
    [anon_sym_use] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym_DOT_DOT] = ACTIONS(2270),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_move] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [sym_integer_literal] = ACTIONS(2270),
    [aux_sym_string_literal_token1] = ACTIONS(2270),
    [sym_char_literal] = ACTIONS(2270),
    [anon_sym_true] = ACTIONS(2272),
    [anon_sym_false] = ACTIONS(2272),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_crate] = ACTIONS(2272),
    [sym_metavariable] = ACTIONS(2270),
    [sym_raw_string_literal] = ACTIONS(2270),
    [sym_float_literal] = ACTIONS(2270),
  },
  [619] = {
    [sym_line_comment] = STATE(619),
    [sym_block_comment] = STATE(619),
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_macro_rules_BANG] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_u8] = ACTIONS(2276),
    [anon_sym_i8] = ACTIONS(2276),
    [anon_sym_u16] = ACTIONS(2276),
    [anon_sym_i16] = ACTIONS(2276),
    [anon_sym_u32] = ACTIONS(2276),
    [anon_sym_i32] = ACTIONS(2276),
    [anon_sym_u64] = ACTIONS(2276),
    [anon_sym_i64] = ACTIONS(2276),
    [anon_sym_u128] = ACTIONS(2276),
    [anon_sym_i128] = ACTIONS(2276),
    [anon_sym_isize] = ACTIONS(2276),
    [anon_sym_usize] = ACTIONS(2276),
    [anon_sym_f32] = ACTIONS(2276),
    [anon_sym_f64] = ACTIONS(2276),
    [anon_sym_bool] = ACTIONS(2276),
    [anon_sym_str] = ACTIONS(2276),
    [anon_sym_char] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_POUND] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_fn] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_impl] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_loop] = ACTIONS(2276),
    [anon_sym_match] = ACTIONS(2276),
    [anon_sym_mod] = ACTIONS(2276),
    [anon_sym_pub] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_trait] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_unsafe] = ACTIONS(2276),
    [anon_sym_use] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym_DOT_DOT] = ACTIONS(2274),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_move] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [sym_integer_literal] = ACTIONS(2274),
    [aux_sym_string_literal_token1] = ACTIONS(2274),
    [sym_char_literal] = ACTIONS(2274),
    [anon_sym_true] = ACTIONS(2276),
    [anon_sym_false] = ACTIONS(2276),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_crate] = ACTIONS(2276),
    [sym_metavariable] = ACTIONS(2274),
    [sym_raw_string_literal] = ACTIONS(2274),
    [sym_float_literal] = ACTIONS(2274),
  },
  [620] = {
    [sym_line_comment] = STATE(620),
    [sym_block_comment] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_macro_rules_BANG] = ACTIONS(2278),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_u8] = ACTIONS(2280),
    [anon_sym_i8] = ACTIONS(2280),
    [anon_sym_u16] = ACTIONS(2280),
    [anon_sym_i16] = ACTIONS(2280),
    [anon_sym_u32] = ACTIONS(2280),
    [anon_sym_i32] = ACTIONS(2280),
    [anon_sym_u64] = ACTIONS(2280),
    [anon_sym_i64] = ACTIONS(2280),
    [anon_sym_u128] = ACTIONS(2280),
    [anon_sym_i128] = ACTIONS(2280),
    [anon_sym_isize] = ACTIONS(2280),
    [anon_sym_usize] = ACTIONS(2280),
    [anon_sym_f32] = ACTIONS(2280),
    [anon_sym_f64] = ACTIONS(2280),
    [anon_sym_bool] = ACTIONS(2280),
    [anon_sym_str] = ACTIONS(2280),
    [anon_sym_char] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_POUND] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_fn] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_impl] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_loop] = ACTIONS(2280),
    [anon_sym_match] = ACTIONS(2280),
    [anon_sym_mod] = ACTIONS(2280),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_trait] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(2280),
    [anon_sym_use] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym_DOT_DOT] = ACTIONS(2278),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_move] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [sym_integer_literal] = ACTIONS(2278),
    [aux_sym_string_literal_token1] = ACTIONS(2278),
    [sym_char_literal] = ACTIONS(2278),
    [anon_sym_true] = ACTIONS(2280),
    [anon_sym_false] = ACTIONS(2280),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_crate] = ACTIONS(2280),
    [sym_metavariable] = ACTIONS(2278),
    [sym_raw_string_literal] = ACTIONS(2278),
    [sym_float_literal] = ACTIONS(2278),
  },
  [621] = {
    [sym_line_comment] = STATE(621),
    [sym_block_comment] = STATE(621),
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_macro_rules_BANG] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_u8] = ACTIONS(2284),
    [anon_sym_i8] = ACTIONS(2284),
    [anon_sym_u16] = ACTIONS(2284),
    [anon_sym_i16] = ACTIONS(2284),
    [anon_sym_u32] = ACTIONS(2284),
    [anon_sym_i32] = ACTIONS(2284),
    [anon_sym_u64] = ACTIONS(2284),
    [anon_sym_i64] = ACTIONS(2284),
    [anon_sym_u128] = ACTIONS(2284),
    [anon_sym_i128] = ACTIONS(2284),
    [anon_sym_isize] = ACTIONS(2284),
    [anon_sym_usize] = ACTIONS(2284),
    [anon_sym_f32] = ACTIONS(2284),
    [anon_sym_f64] = ACTIONS(2284),
    [anon_sym_bool] = ACTIONS(2284),
    [anon_sym_str] = ACTIONS(2284),
    [anon_sym_char] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2282),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_fn] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_impl] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_loop] = ACTIONS(2284),
    [anon_sym_match] = ACTIONS(2284),
    [anon_sym_mod] = ACTIONS(2284),
    [anon_sym_pub] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_trait] = ACTIONS(2284),
    [anon_sym_type] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_unsafe] = ACTIONS(2284),
    [anon_sym_use] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym_DOT_DOT] = ACTIONS(2282),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_move] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [sym_integer_literal] = ACTIONS(2282),
    [aux_sym_string_literal_token1] = ACTIONS(2282),
    [sym_char_literal] = ACTIONS(2282),
    [anon_sym_true] = ACTIONS(2284),
    [anon_sym_false] = ACTIONS(2284),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2284),
    [sym_super] = ACTIONS(2284),
    [sym_crate] = ACTIONS(2284),
    [sym_metavariable] = ACTIONS(2282),
    [sym_raw_string_literal] = ACTIONS(2282),
    [sym_float_literal] = ACTIONS(2282),
  },
  [622] = {
    [sym_line_comment] = STATE(622),
    [sym_block_comment] = STATE(622),
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_macro_rules_BANG] = ACTIONS(2286),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_u8] = ACTIONS(2288),
    [anon_sym_i8] = ACTIONS(2288),
    [anon_sym_u16] = ACTIONS(2288),
    [anon_sym_i16] = ACTIONS(2288),
    [anon_sym_u32] = ACTIONS(2288),
    [anon_sym_i32] = ACTIONS(2288),
    [anon_sym_u64] = ACTIONS(2288),
    [anon_sym_i64] = ACTIONS(2288),
    [anon_sym_u128] = ACTIONS(2288),
    [anon_sym_i128] = ACTIONS(2288),
    [anon_sym_isize] = ACTIONS(2288),
    [anon_sym_usize] = ACTIONS(2288),
    [anon_sym_f32] = ACTIONS(2288),
    [anon_sym_f64] = ACTIONS(2288),
    [anon_sym_bool] = ACTIONS(2288),
    [anon_sym_str] = ACTIONS(2288),
    [anon_sym_char] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2286),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_POUND] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_fn] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_impl] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_loop] = ACTIONS(2288),
    [anon_sym_match] = ACTIONS(2288),
    [anon_sym_mod] = ACTIONS(2288),
    [anon_sym_pub] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_trait] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_unsafe] = ACTIONS(2288),
    [anon_sym_use] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_move] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [sym_integer_literal] = ACTIONS(2286),
    [aux_sym_string_literal_token1] = ACTIONS(2286),
    [sym_char_literal] = ACTIONS(2286),
    [anon_sym_true] = ACTIONS(2288),
    [anon_sym_false] = ACTIONS(2288),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_crate] = ACTIONS(2288),
    [sym_metavariable] = ACTIONS(2286),
    [sym_raw_string_literal] = ACTIONS(2286),
    [sym_float_literal] = ACTIONS(2286),
  },
  [623] = {
    [sym_line_comment] = STATE(623),
    [sym_block_comment] = STATE(623),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_macro_rules_BANG] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_u8] = ACTIONS(2292),
    [anon_sym_i8] = ACTIONS(2292),
    [anon_sym_u16] = ACTIONS(2292),
    [anon_sym_i16] = ACTIONS(2292),
    [anon_sym_u32] = ACTIONS(2292),
    [anon_sym_i32] = ACTIONS(2292),
    [anon_sym_u64] = ACTIONS(2292),
    [anon_sym_i64] = ACTIONS(2292),
    [anon_sym_u128] = ACTIONS(2292),
    [anon_sym_i128] = ACTIONS(2292),
    [anon_sym_isize] = ACTIONS(2292),
    [anon_sym_usize] = ACTIONS(2292),
    [anon_sym_f32] = ACTIONS(2292),
    [anon_sym_f64] = ACTIONS(2292),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_str] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2290),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_POUND] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_fn] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_impl] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_loop] = ACTIONS(2292),
    [anon_sym_match] = ACTIONS(2292),
    [anon_sym_mod] = ACTIONS(2292),
    [anon_sym_pub] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_trait] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_unsafe] = ACTIONS(2292),
    [anon_sym_use] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_DOT_DOT] = ACTIONS(2290),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_move] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [sym_integer_literal] = ACTIONS(2290),
    [aux_sym_string_literal_token1] = ACTIONS(2290),
    [sym_char_literal] = ACTIONS(2290),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_crate] = ACTIONS(2292),
    [sym_metavariable] = ACTIONS(2290),
    [sym_raw_string_literal] = ACTIONS(2290),
    [sym_float_literal] = ACTIONS(2290),
  },
  [624] = {
    [sym_line_comment] = STATE(624),
    [sym_block_comment] = STATE(624),
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_macro_rules_BANG] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_u8] = ACTIONS(2296),
    [anon_sym_i8] = ACTIONS(2296),
    [anon_sym_u16] = ACTIONS(2296),
    [anon_sym_i16] = ACTIONS(2296),
    [anon_sym_u32] = ACTIONS(2296),
    [anon_sym_i32] = ACTIONS(2296),
    [anon_sym_u64] = ACTIONS(2296),
    [anon_sym_i64] = ACTIONS(2296),
    [anon_sym_u128] = ACTIONS(2296),
    [anon_sym_i128] = ACTIONS(2296),
    [anon_sym_isize] = ACTIONS(2296),
    [anon_sym_usize] = ACTIONS(2296),
    [anon_sym_f32] = ACTIONS(2296),
    [anon_sym_f64] = ACTIONS(2296),
    [anon_sym_bool] = ACTIONS(2296),
    [anon_sym_str] = ACTIONS(2296),
    [anon_sym_char] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2294),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_POUND] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_fn] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_impl] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_loop] = ACTIONS(2296),
    [anon_sym_match] = ACTIONS(2296),
    [anon_sym_mod] = ACTIONS(2296),
    [anon_sym_pub] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_trait] = ACTIONS(2296),
    [anon_sym_type] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_unsafe] = ACTIONS(2296),
    [anon_sym_use] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym_DOT_DOT] = ACTIONS(2294),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_move] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [sym_integer_literal] = ACTIONS(2294),
    [aux_sym_string_literal_token1] = ACTIONS(2294),
    [sym_char_literal] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2296),
    [anon_sym_false] = ACTIONS(2296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2296),
    [sym_super] = ACTIONS(2296),
    [sym_crate] = ACTIONS(2296),
    [sym_metavariable] = ACTIONS(2294),
    [sym_raw_string_literal] = ACTIONS(2294),
    [sym_float_literal] = ACTIONS(2294),
  },
  [625] = {
    [sym_line_comment] = STATE(625),
    [sym_block_comment] = STATE(625),
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_macro_rules_BANG] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_u8] = ACTIONS(2300),
    [anon_sym_i8] = ACTIONS(2300),
    [anon_sym_u16] = ACTIONS(2300),
    [anon_sym_i16] = ACTIONS(2300),
    [anon_sym_u32] = ACTIONS(2300),
    [anon_sym_i32] = ACTIONS(2300),
    [anon_sym_u64] = ACTIONS(2300),
    [anon_sym_i64] = ACTIONS(2300),
    [anon_sym_u128] = ACTIONS(2300),
    [anon_sym_i128] = ACTIONS(2300),
    [anon_sym_isize] = ACTIONS(2300),
    [anon_sym_usize] = ACTIONS(2300),
    [anon_sym_f32] = ACTIONS(2300),
    [anon_sym_f64] = ACTIONS(2300),
    [anon_sym_bool] = ACTIONS(2300),
    [anon_sym_str] = ACTIONS(2300),
    [anon_sym_char] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_POUND] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_fn] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_impl] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_loop] = ACTIONS(2300),
    [anon_sym_match] = ACTIONS(2300),
    [anon_sym_mod] = ACTIONS(2300),
    [anon_sym_pub] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_trait] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_unsafe] = ACTIONS(2300),
    [anon_sym_use] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym_DOT_DOT] = ACTIONS(2298),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_move] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [sym_integer_literal] = ACTIONS(2298),
    [aux_sym_string_literal_token1] = ACTIONS(2298),
    [sym_char_literal] = ACTIONS(2298),
    [anon_sym_true] = ACTIONS(2300),
    [anon_sym_false] = ACTIONS(2300),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_crate] = ACTIONS(2300),
    [sym_metavariable] = ACTIONS(2298),
    [sym_raw_string_literal] = ACTIONS(2298),
    [sym_float_literal] = ACTIONS(2298),
  },
  [626] = {
    [sym_line_comment] = STATE(626),
    [sym_block_comment] = STATE(626),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_macro_rules_BANG] = ACTIONS(2302),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_u8] = ACTIONS(2304),
    [anon_sym_i8] = ACTIONS(2304),
    [anon_sym_u16] = ACTIONS(2304),
    [anon_sym_i16] = ACTIONS(2304),
    [anon_sym_u32] = ACTIONS(2304),
    [anon_sym_i32] = ACTIONS(2304),
    [anon_sym_u64] = ACTIONS(2304),
    [anon_sym_i64] = ACTIONS(2304),
    [anon_sym_u128] = ACTIONS(2304),
    [anon_sym_i128] = ACTIONS(2304),
    [anon_sym_isize] = ACTIONS(2304),
    [anon_sym_usize] = ACTIONS(2304),
    [anon_sym_f32] = ACTIONS(2304),
    [anon_sym_f64] = ACTIONS(2304),
    [anon_sym_bool] = ACTIONS(2304),
    [anon_sym_str] = ACTIONS(2304),
    [anon_sym_char] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_POUND] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_fn] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_impl] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_loop] = ACTIONS(2304),
    [anon_sym_match] = ACTIONS(2304),
    [anon_sym_mod] = ACTIONS(2304),
    [anon_sym_pub] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_trait] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_unsafe] = ACTIONS(2304),
    [anon_sym_use] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(2302),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_move] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [sym_integer_literal] = ACTIONS(2302),
    [aux_sym_string_literal_token1] = ACTIONS(2302),
    [sym_char_literal] = ACTIONS(2302),
    [anon_sym_true] = ACTIONS(2304),
    [anon_sym_false] = ACTIONS(2304),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_crate] = ACTIONS(2304),
    [sym_metavariable] = ACTIONS(2302),
    [sym_raw_string_literal] = ACTIONS(2302),
    [sym_float_literal] = ACTIONS(2302),
  },
  [627] = {
    [sym_line_comment] = STATE(627),
    [sym_block_comment] = STATE(627),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_macro_rules_BANG] = ACTIONS(2306),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_u8] = ACTIONS(2308),
    [anon_sym_i8] = ACTIONS(2308),
    [anon_sym_u16] = ACTIONS(2308),
    [anon_sym_i16] = ACTIONS(2308),
    [anon_sym_u32] = ACTIONS(2308),
    [anon_sym_i32] = ACTIONS(2308),
    [anon_sym_u64] = ACTIONS(2308),
    [anon_sym_i64] = ACTIONS(2308),
    [anon_sym_u128] = ACTIONS(2308),
    [anon_sym_i128] = ACTIONS(2308),
    [anon_sym_isize] = ACTIONS(2308),
    [anon_sym_usize] = ACTIONS(2308),
    [anon_sym_f32] = ACTIONS(2308),
    [anon_sym_f64] = ACTIONS(2308),
    [anon_sym_bool] = ACTIONS(2308),
    [anon_sym_str] = ACTIONS(2308),
    [anon_sym_char] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_POUND] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_fn] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_impl] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_loop] = ACTIONS(2308),
    [anon_sym_match] = ACTIONS(2308),
    [anon_sym_mod] = ACTIONS(2308),
    [anon_sym_pub] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_trait] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_unsafe] = ACTIONS(2308),
    [anon_sym_use] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym_DOT_DOT] = ACTIONS(2306),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_move] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [sym_integer_literal] = ACTIONS(2306),
    [aux_sym_string_literal_token1] = ACTIONS(2306),
    [sym_char_literal] = ACTIONS(2306),
    [anon_sym_true] = ACTIONS(2308),
    [anon_sym_false] = ACTIONS(2308),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_crate] = ACTIONS(2308),
    [sym_metavariable] = ACTIONS(2306),
    [sym_raw_string_literal] = ACTIONS(2306),
    [sym_float_literal] = ACTIONS(2306),
  },
  [628] = {
    [sym_line_comment] = STATE(628),
    [sym_block_comment] = STATE(628),
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_macro_rules_BANG] = ACTIONS(2310),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_u8] = ACTIONS(2312),
    [anon_sym_i8] = ACTIONS(2312),
    [anon_sym_u16] = ACTIONS(2312),
    [anon_sym_i16] = ACTIONS(2312),
    [anon_sym_u32] = ACTIONS(2312),
    [anon_sym_i32] = ACTIONS(2312),
    [anon_sym_u64] = ACTIONS(2312),
    [anon_sym_i64] = ACTIONS(2312),
    [anon_sym_u128] = ACTIONS(2312),
    [anon_sym_i128] = ACTIONS(2312),
    [anon_sym_isize] = ACTIONS(2312),
    [anon_sym_usize] = ACTIONS(2312),
    [anon_sym_f32] = ACTIONS(2312),
    [anon_sym_f64] = ACTIONS(2312),
    [anon_sym_bool] = ACTIONS(2312),
    [anon_sym_str] = ACTIONS(2312),
    [anon_sym_char] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_POUND] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_fn] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_impl] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_loop] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_mod] = ACTIONS(2312),
    [anon_sym_pub] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_trait] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_unsafe] = ACTIONS(2312),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_move] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [sym_integer_literal] = ACTIONS(2310),
    [aux_sym_string_literal_token1] = ACTIONS(2310),
    [sym_char_literal] = ACTIONS(2310),
    [anon_sym_true] = ACTIONS(2312),
    [anon_sym_false] = ACTIONS(2312),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_crate] = ACTIONS(2312),
    [sym_metavariable] = ACTIONS(2310),
    [sym_raw_string_literal] = ACTIONS(2310),
    [sym_float_literal] = ACTIONS(2310),
  },
  [629] = {
    [sym_line_comment] = STATE(629),
    [sym_block_comment] = STATE(629),
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_macro_rules_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_u8] = ACTIONS(2316),
    [anon_sym_i8] = ACTIONS(2316),
    [anon_sym_u16] = ACTIONS(2316),
    [anon_sym_i16] = ACTIONS(2316),
    [anon_sym_u32] = ACTIONS(2316),
    [anon_sym_i32] = ACTIONS(2316),
    [anon_sym_u64] = ACTIONS(2316),
    [anon_sym_i64] = ACTIONS(2316),
    [anon_sym_u128] = ACTIONS(2316),
    [anon_sym_i128] = ACTIONS(2316),
    [anon_sym_isize] = ACTIONS(2316),
    [anon_sym_usize] = ACTIONS(2316),
    [anon_sym_f32] = ACTIONS(2316),
    [anon_sym_f64] = ACTIONS(2316),
    [anon_sym_bool] = ACTIONS(2316),
    [anon_sym_str] = ACTIONS(2316),
    [anon_sym_char] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_POUND] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_fn] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_impl] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_loop] = ACTIONS(2316),
    [anon_sym_match] = ACTIONS(2316),
    [anon_sym_mod] = ACTIONS(2316),
    [anon_sym_pub] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_trait] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_unsafe] = ACTIONS(2316),
    [anon_sym_use] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_move] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [sym_integer_literal] = ACTIONS(2314),
    [aux_sym_string_literal_token1] = ACTIONS(2314),
    [sym_char_literal] = ACTIONS(2314),
    [anon_sym_true] = ACTIONS(2316),
    [anon_sym_false] = ACTIONS(2316),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [sym_crate] = ACTIONS(2316),
    [sym_metavariable] = ACTIONS(2314),
    [sym_raw_string_literal] = ACTIONS(2314),
    [sym_float_literal] = ACTIONS(2314),
  },
  [630] = {
    [sym_line_comment] = STATE(630),
    [sym_block_comment] = STATE(630),
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_macro_rules_BANG] = ACTIONS(2318),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_u8] = ACTIONS(2320),
    [anon_sym_i8] = ACTIONS(2320),
    [anon_sym_u16] = ACTIONS(2320),
    [anon_sym_i16] = ACTIONS(2320),
    [anon_sym_u32] = ACTIONS(2320),
    [anon_sym_i32] = ACTIONS(2320),
    [anon_sym_u64] = ACTIONS(2320),
    [anon_sym_i64] = ACTIONS(2320),
    [anon_sym_u128] = ACTIONS(2320),
    [anon_sym_i128] = ACTIONS(2320),
    [anon_sym_isize] = ACTIONS(2320),
    [anon_sym_usize] = ACTIONS(2320),
    [anon_sym_f32] = ACTIONS(2320),
    [anon_sym_f64] = ACTIONS(2320),
    [anon_sym_bool] = ACTIONS(2320),
    [anon_sym_str] = ACTIONS(2320),
    [anon_sym_char] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_POUND] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_PIPE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
    [anon_sym_fn] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_impl] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_loop] = ACTIONS(2320),
    [anon_sym_match] = ACTIONS(2320),
    [anon_sym_mod] = ACTIONS(2320),
    [anon_sym_pub] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_struct] = ACTIONS(2320),
    [anon_sym_trait] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_union] = ACTIONS(2320),
    [anon_sym_unsafe] = ACTIONS(2320),
    [anon_sym_use] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_extern] = ACTIONS(2320),
    [anon_sym_DOT_DOT] = ACTIONS(2318),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_move] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [sym_integer_literal] = ACTIONS(2318),
    [aux_sym_string_literal_token1] = ACTIONS(2318),
    [sym_char_literal] = ACTIONS(2318),
    [anon_sym_true] = ACTIONS(2320),
    [anon_sym_false] = ACTIONS(2320),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_crate] = ACTIONS(2320),
    [sym_metavariable] = ACTIONS(2318),
    [sym_raw_string_literal] = ACTIONS(2318),
    [sym_float_literal] = ACTIONS(2318),
  },
  [631] = {
    [sym_line_comment] = STATE(631),
    [sym_block_comment] = STATE(631),
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_macro_rules_BANG] = ACTIONS(2322),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_u8] = ACTIONS(2324),
    [anon_sym_i8] = ACTIONS(2324),
    [anon_sym_u16] = ACTIONS(2324),
    [anon_sym_i16] = ACTIONS(2324),
    [anon_sym_u32] = ACTIONS(2324),
    [anon_sym_i32] = ACTIONS(2324),
    [anon_sym_u64] = ACTIONS(2324),
    [anon_sym_i64] = ACTIONS(2324),
    [anon_sym_u128] = ACTIONS(2324),
    [anon_sym_i128] = ACTIONS(2324),
    [anon_sym_isize] = ACTIONS(2324),
    [anon_sym_usize] = ACTIONS(2324),
    [anon_sym_f32] = ACTIONS(2324),
    [anon_sym_f64] = ACTIONS(2324),
    [anon_sym_bool] = ACTIONS(2324),
    [anon_sym_str] = ACTIONS(2324),
    [anon_sym_char] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2322),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_POUND] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_PIPE] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_fn] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_impl] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_loop] = ACTIONS(2324),
    [anon_sym_match] = ACTIONS(2324),
    [anon_sym_mod] = ACTIONS(2324),
    [anon_sym_pub] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_trait] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_union] = ACTIONS(2324),
    [anon_sym_unsafe] = ACTIONS(2324),
    [anon_sym_use] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_DOT_DOT] = ACTIONS(2322),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_move] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [sym_integer_literal] = ACTIONS(2322),
    [aux_sym_string_literal_token1] = ACTIONS(2322),
    [sym_char_literal] = ACTIONS(2322),
    [anon_sym_true] = ACTIONS(2324),
    [anon_sym_false] = ACTIONS(2324),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_crate] = ACTIONS(2324),
    [sym_metavariable] = ACTIONS(2322),
    [sym_raw_string_literal] = ACTIONS(2322),
    [sym_float_literal] = ACTIONS(2322),
  },
  [632] = {
    [sym_line_comment] = STATE(632),
    [sym_block_comment] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_macro_rules_BANG] = ACTIONS(2326),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_u8] = ACTIONS(2328),
    [anon_sym_i8] = ACTIONS(2328),
    [anon_sym_u16] = ACTIONS(2328),
    [anon_sym_i16] = ACTIONS(2328),
    [anon_sym_u32] = ACTIONS(2328),
    [anon_sym_i32] = ACTIONS(2328),
    [anon_sym_u64] = ACTIONS(2328),
    [anon_sym_i64] = ACTIONS(2328),
    [anon_sym_u128] = ACTIONS(2328),
    [anon_sym_i128] = ACTIONS(2328),
    [anon_sym_isize] = ACTIONS(2328),
    [anon_sym_usize] = ACTIONS(2328),
    [anon_sym_f32] = ACTIONS(2328),
    [anon_sym_f64] = ACTIONS(2328),
    [anon_sym_bool] = ACTIONS(2328),
    [anon_sym_str] = ACTIONS(2328),
    [anon_sym_char] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2326),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_POUND] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_async] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(2328),
    [anon_sym_continue] = ACTIONS(2328),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_enum] = ACTIONS(2328),
    [anon_sym_fn] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_impl] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_loop] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_mod] = ACTIONS(2328),
    [anon_sym_pub] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_struct] = ACTIONS(2328),
    [anon_sym_trait] = ACTIONS(2328),
    [anon_sym_type] = ACTIONS(2328),
    [anon_sym_union] = ACTIONS(2328),
    [anon_sym_unsafe] = ACTIONS(2328),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_extern] = ACTIONS(2328),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_move] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [sym_integer_literal] = ACTIONS(2326),
    [aux_sym_string_literal_token1] = ACTIONS(2326),
    [sym_char_literal] = ACTIONS(2326),
    [anon_sym_true] = ACTIONS(2328),
    [anon_sym_false] = ACTIONS(2328),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2328),
    [sym_super] = ACTIONS(2328),
    [sym_crate] = ACTIONS(2328),
    [sym_metavariable] = ACTIONS(2326),
    [sym_raw_string_literal] = ACTIONS(2326),
    [sym_float_literal] = ACTIONS(2326),
  },
  [633] = {
    [sym_line_comment] = STATE(633),
    [sym_block_comment] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_macro_rules_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_u8] = ACTIONS(2332),
    [anon_sym_i8] = ACTIONS(2332),
    [anon_sym_u16] = ACTIONS(2332),
    [anon_sym_i16] = ACTIONS(2332),
    [anon_sym_u32] = ACTIONS(2332),
    [anon_sym_i32] = ACTIONS(2332),
    [anon_sym_u64] = ACTIONS(2332),
    [anon_sym_i64] = ACTIONS(2332),
    [anon_sym_u128] = ACTIONS(2332),
    [anon_sym_i128] = ACTIONS(2332),
    [anon_sym_isize] = ACTIONS(2332),
    [anon_sym_usize] = ACTIONS(2332),
    [anon_sym_f32] = ACTIONS(2332),
    [anon_sym_f64] = ACTIONS(2332),
    [anon_sym_bool] = ACTIONS(2332),
    [anon_sym_str] = ACTIONS(2332),
    [anon_sym_char] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_POUND] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_PIPE] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
    [anon_sym_fn] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_impl] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_loop] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_mod] = ACTIONS(2332),
    [anon_sym_pub] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_struct] = ACTIONS(2332),
    [anon_sym_trait] = ACTIONS(2332),
    [anon_sym_type] = ACTIONS(2332),
    [anon_sym_union] = ACTIONS(2332),
    [anon_sym_unsafe] = ACTIONS(2332),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_extern] = ACTIONS(2332),
    [anon_sym_DOT_DOT] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_move] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [sym_integer_literal] = ACTIONS(2330),
    [aux_sym_string_literal_token1] = ACTIONS(2330),
    [sym_char_literal] = ACTIONS(2330),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2332),
    [sym_super] = ACTIONS(2332),
    [sym_crate] = ACTIONS(2332),
    [sym_metavariable] = ACTIONS(2330),
    [sym_raw_string_literal] = ACTIONS(2330),
    [sym_float_literal] = ACTIONS(2330),
  },
  [634] = {
    [sym_line_comment] = STATE(634),
    [sym_block_comment] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_macro_rules_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_u8] = ACTIONS(2336),
    [anon_sym_i8] = ACTIONS(2336),
    [anon_sym_u16] = ACTIONS(2336),
    [anon_sym_i16] = ACTIONS(2336),
    [anon_sym_u32] = ACTIONS(2336),
    [anon_sym_i32] = ACTIONS(2336),
    [anon_sym_u64] = ACTIONS(2336),
    [anon_sym_i64] = ACTIONS(2336),
    [anon_sym_u128] = ACTIONS(2336),
    [anon_sym_i128] = ACTIONS(2336),
    [anon_sym_isize] = ACTIONS(2336),
    [anon_sym_usize] = ACTIONS(2336),
    [anon_sym_f32] = ACTIONS(2336),
    [anon_sym_f64] = ACTIONS(2336),
    [anon_sym_bool] = ACTIONS(2336),
    [anon_sym_str] = ACTIONS(2336),
    [anon_sym_char] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_POUND] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
    [anon_sym_fn] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_impl] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_loop] = ACTIONS(2336),
    [anon_sym_match] = ACTIONS(2336),
    [anon_sym_mod] = ACTIONS(2336),
    [anon_sym_pub] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_struct] = ACTIONS(2336),
    [anon_sym_trait] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_union] = ACTIONS(2336),
    [anon_sym_unsafe] = ACTIONS(2336),
    [anon_sym_use] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_extern] = ACTIONS(2336),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_move] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [sym_integer_literal] = ACTIONS(2334),
    [aux_sym_string_literal_token1] = ACTIONS(2334),
    [sym_char_literal] = ACTIONS(2334),
    [anon_sym_true] = ACTIONS(2336),
    [anon_sym_false] = ACTIONS(2336),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_crate] = ACTIONS(2336),
    [sym_metavariable] = ACTIONS(2334),
    [sym_raw_string_literal] = ACTIONS(2334),
    [sym_float_literal] = ACTIONS(2334),
  },
  [635] = {
    [sym_line_comment] = STATE(635),
    [sym_block_comment] = STATE(635),
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_macro_rules_BANG] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2338),
    [anon_sym_u8] = ACTIONS(2340),
    [anon_sym_i8] = ACTIONS(2340),
    [anon_sym_u16] = ACTIONS(2340),
    [anon_sym_i16] = ACTIONS(2340),
    [anon_sym_u32] = ACTIONS(2340),
    [anon_sym_i32] = ACTIONS(2340),
    [anon_sym_u64] = ACTIONS(2340),
    [anon_sym_i64] = ACTIONS(2340),
    [anon_sym_u128] = ACTIONS(2340),
    [anon_sym_i128] = ACTIONS(2340),
    [anon_sym_isize] = ACTIONS(2340),
    [anon_sym_usize] = ACTIONS(2340),
    [anon_sym_f32] = ACTIONS(2340),
    [anon_sym_f64] = ACTIONS(2340),
    [anon_sym_bool] = ACTIONS(2340),
    [anon_sym_str] = ACTIONS(2340),
    [anon_sym_char] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_POUND] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_fn] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_impl] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_loop] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_mod] = ACTIONS(2340),
    [anon_sym_pub] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2340),
    [anon_sym_trait] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_union] = ACTIONS(2340),
    [anon_sym_unsafe] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_extern] = ACTIONS(2340),
    [anon_sym_DOT_DOT] = ACTIONS(2338),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_move] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [sym_integer_literal] = ACTIONS(2338),
    [aux_sym_string_literal_token1] = ACTIONS(2338),
    [sym_char_literal] = ACTIONS(2338),
    [anon_sym_true] = ACTIONS(2340),
    [anon_sym_false] = ACTIONS(2340),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_crate] = ACTIONS(2340),
    [sym_metavariable] = ACTIONS(2338),
    [sym_raw_string_literal] = ACTIONS(2338),
    [sym_float_literal] = ACTIONS(2338),
  },
  [636] = {
    [sym_line_comment] = STATE(636),
    [sym_block_comment] = STATE(636),
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_macro_rules_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_u8] = ACTIONS(2344),
    [anon_sym_i8] = ACTIONS(2344),
    [anon_sym_u16] = ACTIONS(2344),
    [anon_sym_i16] = ACTIONS(2344),
    [anon_sym_u32] = ACTIONS(2344),
    [anon_sym_i32] = ACTIONS(2344),
    [anon_sym_u64] = ACTIONS(2344),
    [anon_sym_i64] = ACTIONS(2344),
    [anon_sym_u128] = ACTIONS(2344),
    [anon_sym_i128] = ACTIONS(2344),
    [anon_sym_isize] = ACTIONS(2344),
    [anon_sym_usize] = ACTIONS(2344),
    [anon_sym_f32] = ACTIONS(2344),
    [anon_sym_f64] = ACTIONS(2344),
    [anon_sym_bool] = ACTIONS(2344),
    [anon_sym_str] = ACTIONS(2344),
    [anon_sym_char] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_POUND] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
    [anon_sym_fn] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_impl] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_loop] = ACTIONS(2344),
    [anon_sym_match] = ACTIONS(2344),
    [anon_sym_mod] = ACTIONS(2344),
    [anon_sym_pub] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_struct] = ACTIONS(2344),
    [anon_sym_trait] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_union] = ACTIONS(2344),
    [anon_sym_unsafe] = ACTIONS(2344),
    [anon_sym_use] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_extern] = ACTIONS(2344),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_move] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [sym_integer_literal] = ACTIONS(2342),
    [aux_sym_string_literal_token1] = ACTIONS(2342),
    [sym_char_literal] = ACTIONS(2342),
    [anon_sym_true] = ACTIONS(2344),
    [anon_sym_false] = ACTIONS(2344),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_crate] = ACTIONS(2344),
    [sym_metavariable] = ACTIONS(2342),
    [sym_raw_string_literal] = ACTIONS(2342),
    [sym_float_literal] = ACTIONS(2342),
  },
  [637] = {
    [sym_line_comment] = STATE(637),
    [sym_block_comment] = STATE(637),
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_macro_rules_BANG] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_u8] = ACTIONS(2348),
    [anon_sym_i8] = ACTIONS(2348),
    [anon_sym_u16] = ACTIONS(2348),
    [anon_sym_i16] = ACTIONS(2348),
    [anon_sym_u32] = ACTIONS(2348),
    [anon_sym_i32] = ACTIONS(2348),
    [anon_sym_u64] = ACTIONS(2348),
    [anon_sym_i64] = ACTIONS(2348),
    [anon_sym_u128] = ACTIONS(2348),
    [anon_sym_i128] = ACTIONS(2348),
    [anon_sym_isize] = ACTIONS(2348),
    [anon_sym_usize] = ACTIONS(2348),
    [anon_sym_f32] = ACTIONS(2348),
    [anon_sym_f64] = ACTIONS(2348),
    [anon_sym_bool] = ACTIONS(2348),
    [anon_sym_str] = ACTIONS(2348),
    [anon_sym_char] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2346),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_POUND] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_fn] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_impl] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_loop] = ACTIONS(2348),
    [anon_sym_match] = ACTIONS(2348),
    [anon_sym_mod] = ACTIONS(2348),
    [anon_sym_pub] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_trait] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_unsafe] = ACTIONS(2348),
    [anon_sym_use] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym_DOT_DOT] = ACTIONS(2346),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_move] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [sym_integer_literal] = ACTIONS(2346),
    [aux_sym_string_literal_token1] = ACTIONS(2346),
    [sym_char_literal] = ACTIONS(2346),
    [anon_sym_true] = ACTIONS(2348),
    [anon_sym_false] = ACTIONS(2348),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [sym_crate] = ACTIONS(2348),
    [sym_metavariable] = ACTIONS(2346),
    [sym_raw_string_literal] = ACTIONS(2346),
    [sym_float_literal] = ACTIONS(2346),
  },
  [638] = {
    [sym_line_comment] = STATE(638),
    [sym_block_comment] = STATE(638),
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_macro_rules_BANG] = ACTIONS(2350),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_u8] = ACTIONS(2352),
    [anon_sym_i8] = ACTIONS(2352),
    [anon_sym_u16] = ACTIONS(2352),
    [anon_sym_i16] = ACTIONS(2352),
    [anon_sym_u32] = ACTIONS(2352),
    [anon_sym_i32] = ACTIONS(2352),
    [anon_sym_u64] = ACTIONS(2352),
    [anon_sym_i64] = ACTIONS(2352),
    [anon_sym_u128] = ACTIONS(2352),
    [anon_sym_i128] = ACTIONS(2352),
    [anon_sym_isize] = ACTIONS(2352),
    [anon_sym_usize] = ACTIONS(2352),
    [anon_sym_f32] = ACTIONS(2352),
    [anon_sym_f64] = ACTIONS(2352),
    [anon_sym_bool] = ACTIONS(2352),
    [anon_sym_str] = ACTIONS(2352),
    [anon_sym_char] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_POUND] = ACTIONS(2350),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_PIPE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_fn] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_impl] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_loop] = ACTIONS(2352),
    [anon_sym_match] = ACTIONS(2352),
    [anon_sym_mod] = ACTIONS(2352),
    [anon_sym_pub] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_trait] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_unsafe] = ACTIONS(2352),
    [anon_sym_use] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym_DOT_DOT] = ACTIONS(2350),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_move] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [sym_integer_literal] = ACTIONS(2350),
    [aux_sym_string_literal_token1] = ACTIONS(2350),
    [sym_char_literal] = ACTIONS(2350),
    [anon_sym_true] = ACTIONS(2352),
    [anon_sym_false] = ACTIONS(2352),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2352),
    [sym_super] = ACTIONS(2352),
    [sym_crate] = ACTIONS(2352),
    [sym_metavariable] = ACTIONS(2350),
    [sym_raw_string_literal] = ACTIONS(2350),
    [sym_float_literal] = ACTIONS(2350),
  },
  [639] = {
    [sym_line_comment] = STATE(639),
    [sym_block_comment] = STATE(639),
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_macro_rules_BANG] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_u8] = ACTIONS(2356),
    [anon_sym_i8] = ACTIONS(2356),
    [anon_sym_u16] = ACTIONS(2356),
    [anon_sym_i16] = ACTIONS(2356),
    [anon_sym_u32] = ACTIONS(2356),
    [anon_sym_i32] = ACTIONS(2356),
    [anon_sym_u64] = ACTIONS(2356),
    [anon_sym_i64] = ACTIONS(2356),
    [anon_sym_u128] = ACTIONS(2356),
    [anon_sym_i128] = ACTIONS(2356),
    [anon_sym_isize] = ACTIONS(2356),
    [anon_sym_usize] = ACTIONS(2356),
    [anon_sym_f32] = ACTIONS(2356),
    [anon_sym_f64] = ACTIONS(2356),
    [anon_sym_bool] = ACTIONS(2356),
    [anon_sym_str] = ACTIONS(2356),
    [anon_sym_char] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_POUND] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_fn] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_impl] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_loop] = ACTIONS(2356),
    [anon_sym_match] = ACTIONS(2356),
    [anon_sym_mod] = ACTIONS(2356),
    [anon_sym_pub] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_trait] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_unsafe] = ACTIONS(2356),
    [anon_sym_use] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym_DOT_DOT] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_move] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [sym_integer_literal] = ACTIONS(2354),
    [aux_sym_string_literal_token1] = ACTIONS(2354),
    [sym_char_literal] = ACTIONS(2354),
    [anon_sym_true] = ACTIONS(2356),
    [anon_sym_false] = ACTIONS(2356),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_crate] = ACTIONS(2356),
    [sym_metavariable] = ACTIONS(2354),
    [sym_raw_string_literal] = ACTIONS(2354),
    [sym_float_literal] = ACTIONS(2354),
  },
  [640] = {
    [sym_line_comment] = STATE(640),
    [sym_block_comment] = STATE(640),
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_macro_rules_BANG] = ACTIONS(2358),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_u8] = ACTIONS(2360),
    [anon_sym_i8] = ACTIONS(2360),
    [anon_sym_u16] = ACTIONS(2360),
    [anon_sym_i16] = ACTIONS(2360),
    [anon_sym_u32] = ACTIONS(2360),
    [anon_sym_i32] = ACTIONS(2360),
    [anon_sym_u64] = ACTIONS(2360),
    [anon_sym_i64] = ACTIONS(2360),
    [anon_sym_u128] = ACTIONS(2360),
    [anon_sym_i128] = ACTIONS(2360),
    [anon_sym_isize] = ACTIONS(2360),
    [anon_sym_usize] = ACTIONS(2360),
    [anon_sym_f32] = ACTIONS(2360),
    [anon_sym_f64] = ACTIONS(2360),
    [anon_sym_bool] = ACTIONS(2360),
    [anon_sym_str] = ACTIONS(2360),
    [anon_sym_char] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_POUND] = ACTIONS(2358),
    [anon_sym_LT] = ACTIONS(2358),
    [anon_sym_PIPE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_enum] = ACTIONS(2360),
    [anon_sym_fn] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_impl] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_loop] = ACTIONS(2360),
    [anon_sym_match] = ACTIONS(2360),
    [anon_sym_mod] = ACTIONS(2360),
    [anon_sym_pub] = ACTIONS(2360),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_struct] = ACTIONS(2360),
    [anon_sym_trait] = ACTIONS(2360),
    [anon_sym_type] = ACTIONS(2360),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_unsafe] = ACTIONS(2360),
    [anon_sym_use] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [anon_sym_extern] = ACTIONS(2360),
    [anon_sym_DOT_DOT] = ACTIONS(2358),
    [anon_sym_yield] = ACTIONS(2360),
    [anon_sym_move] = ACTIONS(2360),
    [anon_sym_try] = ACTIONS(2360),
    [sym_integer_literal] = ACTIONS(2358),
    [aux_sym_string_literal_token1] = ACTIONS(2358),
    [sym_char_literal] = ACTIONS(2358),
    [anon_sym_true] = ACTIONS(2360),
    [anon_sym_false] = ACTIONS(2360),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2360),
    [sym_super] = ACTIONS(2360),
    [sym_crate] = ACTIONS(2360),
    [sym_metavariable] = ACTIONS(2358),
    [sym_raw_string_literal] = ACTIONS(2358),
    [sym_float_literal] = ACTIONS(2358),
  },
  [641] = {
    [sym_line_comment] = STATE(641),
    [sym_block_comment] = STATE(641),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_macro_rules_BANG] = ACTIONS(2362),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_u8] = ACTIONS(2364),
    [anon_sym_i8] = ACTIONS(2364),
    [anon_sym_u16] = ACTIONS(2364),
    [anon_sym_i16] = ACTIONS(2364),
    [anon_sym_u32] = ACTIONS(2364),
    [anon_sym_i32] = ACTIONS(2364),
    [anon_sym_u64] = ACTIONS(2364),
    [anon_sym_i64] = ACTIONS(2364),
    [anon_sym_u128] = ACTIONS(2364),
    [anon_sym_i128] = ACTIONS(2364),
    [anon_sym_isize] = ACTIONS(2364),
    [anon_sym_usize] = ACTIONS(2364),
    [anon_sym_f32] = ACTIONS(2364),
    [anon_sym_f64] = ACTIONS(2364),
    [anon_sym_bool] = ACTIONS(2364),
    [anon_sym_str] = ACTIONS(2364),
    [anon_sym_char] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2362),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_POUND] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2362),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_enum] = ACTIONS(2364),
    [anon_sym_fn] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_impl] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_loop] = ACTIONS(2364),
    [anon_sym_match] = ACTIONS(2364),
    [anon_sym_mod] = ACTIONS(2364),
    [anon_sym_pub] = ACTIONS(2364),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_struct] = ACTIONS(2364),
    [anon_sym_trait] = ACTIONS(2364),
    [anon_sym_type] = ACTIONS(2364),
    [anon_sym_union] = ACTIONS(2364),
    [anon_sym_unsafe] = ACTIONS(2364),
    [anon_sym_use] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_DOT_DOT] = ACTIONS(2362),
    [anon_sym_yield] = ACTIONS(2364),
    [anon_sym_move] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2364),
    [sym_integer_literal] = ACTIONS(2362),
    [aux_sym_string_literal_token1] = ACTIONS(2362),
    [sym_char_literal] = ACTIONS(2362),
    [anon_sym_true] = ACTIONS(2364),
    [anon_sym_false] = ACTIONS(2364),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2364),
    [sym_super] = ACTIONS(2364),
    [sym_crate] = ACTIONS(2364),
    [sym_metavariable] = ACTIONS(2362),
    [sym_raw_string_literal] = ACTIONS(2362),
    [sym_float_literal] = ACTIONS(2362),
  },
  [642] = {
    [sym_line_comment] = STATE(642),
    [sym_block_comment] = STATE(642),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_macro_rules_BANG] = ACTIONS(2366),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2366),
    [anon_sym_u8] = ACTIONS(2368),
    [anon_sym_i8] = ACTIONS(2368),
    [anon_sym_u16] = ACTIONS(2368),
    [anon_sym_i16] = ACTIONS(2368),
    [anon_sym_u32] = ACTIONS(2368),
    [anon_sym_i32] = ACTIONS(2368),
    [anon_sym_u64] = ACTIONS(2368),
    [anon_sym_i64] = ACTIONS(2368),
    [anon_sym_u128] = ACTIONS(2368),
    [anon_sym_i128] = ACTIONS(2368),
    [anon_sym_isize] = ACTIONS(2368),
    [anon_sym_usize] = ACTIONS(2368),
    [anon_sym_f32] = ACTIONS(2368),
    [anon_sym_f64] = ACTIONS(2368),
    [anon_sym_bool] = ACTIONS(2368),
    [anon_sym_str] = ACTIONS(2368),
    [anon_sym_char] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2366),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_POUND] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_PIPE] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
    [anon_sym_fn] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_impl] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_loop] = ACTIONS(2368),
    [anon_sym_match] = ACTIONS(2368),
    [anon_sym_mod] = ACTIONS(2368),
    [anon_sym_pub] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_struct] = ACTIONS(2368),
    [anon_sym_trait] = ACTIONS(2368),
    [anon_sym_type] = ACTIONS(2368),
    [anon_sym_union] = ACTIONS(2368),
    [anon_sym_unsafe] = ACTIONS(2368),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_extern] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(2366),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_move] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [sym_integer_literal] = ACTIONS(2366),
    [aux_sym_string_literal_token1] = ACTIONS(2366),
    [sym_char_literal] = ACTIONS(2366),
    [anon_sym_true] = ACTIONS(2368),
    [anon_sym_false] = ACTIONS(2368),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_crate] = ACTIONS(2368),
    [sym_metavariable] = ACTIONS(2366),
    [sym_raw_string_literal] = ACTIONS(2366),
    [sym_float_literal] = ACTIONS(2366),
  },
  [643] = {
    [sym_line_comment] = STATE(643),
    [sym_block_comment] = STATE(643),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_macro_rules_BANG] = ACTIONS(2370),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2370),
    [anon_sym_u8] = ACTIONS(2372),
    [anon_sym_i8] = ACTIONS(2372),
    [anon_sym_u16] = ACTIONS(2372),
    [anon_sym_i16] = ACTIONS(2372),
    [anon_sym_u32] = ACTIONS(2372),
    [anon_sym_i32] = ACTIONS(2372),
    [anon_sym_u64] = ACTIONS(2372),
    [anon_sym_i64] = ACTIONS(2372),
    [anon_sym_u128] = ACTIONS(2372),
    [anon_sym_i128] = ACTIONS(2372),
    [anon_sym_isize] = ACTIONS(2372),
    [anon_sym_usize] = ACTIONS(2372),
    [anon_sym_f32] = ACTIONS(2372),
    [anon_sym_f64] = ACTIONS(2372),
    [anon_sym_bool] = ACTIONS(2372),
    [anon_sym_str] = ACTIONS(2372),
    [anon_sym_char] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_PIPE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
    [anon_sym_fn] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_impl] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_loop] = ACTIONS(2372),
    [anon_sym_match] = ACTIONS(2372),
    [anon_sym_mod] = ACTIONS(2372),
    [anon_sym_pub] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_struct] = ACTIONS(2372),
    [anon_sym_trait] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_union] = ACTIONS(2372),
    [anon_sym_unsafe] = ACTIONS(2372),
    [anon_sym_use] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_extern] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(2370),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_move] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [sym_integer_literal] = ACTIONS(2370),
    [aux_sym_string_literal_token1] = ACTIONS(2370),
    [sym_char_literal] = ACTIONS(2370),
    [anon_sym_true] = ACTIONS(2372),
    [anon_sym_false] = ACTIONS(2372),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_crate] = ACTIONS(2372),
    [sym_metavariable] = ACTIONS(2370),
    [sym_raw_string_literal] = ACTIONS(2370),
    [sym_float_literal] = ACTIONS(2370),
  },
  [644] = {
    [sym_line_comment] = STATE(644),
    [sym_block_comment] = STATE(644),
    [ts_builtin_sym_end] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_macro_rules_BANG] = ACTIONS(2374),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2374),
    [anon_sym_u8] = ACTIONS(2376),
    [anon_sym_i8] = ACTIONS(2376),
    [anon_sym_u16] = ACTIONS(2376),
    [anon_sym_i16] = ACTIONS(2376),
    [anon_sym_u32] = ACTIONS(2376),
    [anon_sym_i32] = ACTIONS(2376),
    [anon_sym_u64] = ACTIONS(2376),
    [anon_sym_i64] = ACTIONS(2376),
    [anon_sym_u128] = ACTIONS(2376),
    [anon_sym_i128] = ACTIONS(2376),
    [anon_sym_isize] = ACTIONS(2376),
    [anon_sym_usize] = ACTIONS(2376),
    [anon_sym_f32] = ACTIONS(2376),
    [anon_sym_f64] = ACTIONS(2376),
    [anon_sym_bool] = ACTIONS(2376),
    [anon_sym_str] = ACTIONS(2376),
    [anon_sym_char] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2374),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_POUND] = ACTIONS(2374),
    [anon_sym_LT] = ACTIONS(2374),
    [anon_sym_PIPE] = ACTIONS(2374),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_fn] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_impl] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_loop] = ACTIONS(2376),
    [anon_sym_match] = ACTIONS(2376),
    [anon_sym_mod] = ACTIONS(2376),
    [anon_sym_pub] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_trait] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_unsafe] = ACTIONS(2376),
    [anon_sym_use] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2374),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_move] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [sym_integer_literal] = ACTIONS(2374),
    [aux_sym_string_literal_token1] = ACTIONS(2374),
    [sym_char_literal] = ACTIONS(2374),
    [anon_sym_true] = ACTIONS(2376),
    [anon_sym_false] = ACTIONS(2376),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2376),
    [sym_super] = ACTIONS(2376),
    [sym_crate] = ACTIONS(2376),
    [sym_metavariable] = ACTIONS(2374),
    [sym_raw_string_literal] = ACTIONS(2374),
    [sym_float_literal] = ACTIONS(2374),
  },
  [645] = {
    [sym_line_comment] = STATE(645),
    [sym_block_comment] = STATE(645),
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_macro_rules_BANG] = ACTIONS(2378),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_u8] = ACTIONS(2380),
    [anon_sym_i8] = ACTIONS(2380),
    [anon_sym_u16] = ACTIONS(2380),
    [anon_sym_i16] = ACTIONS(2380),
    [anon_sym_u32] = ACTIONS(2380),
    [anon_sym_i32] = ACTIONS(2380),
    [anon_sym_u64] = ACTIONS(2380),
    [anon_sym_i64] = ACTIONS(2380),
    [anon_sym_u128] = ACTIONS(2380),
    [anon_sym_i128] = ACTIONS(2380),
    [anon_sym_isize] = ACTIONS(2380),
    [anon_sym_usize] = ACTIONS(2380),
    [anon_sym_f32] = ACTIONS(2380),
    [anon_sym_f64] = ACTIONS(2380),
    [anon_sym_bool] = ACTIONS(2380),
    [anon_sym_str] = ACTIONS(2380),
    [anon_sym_char] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_POUND] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
    [anon_sym_fn] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_impl] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_loop] = ACTIONS(2380),
    [anon_sym_match] = ACTIONS(2380),
    [anon_sym_mod] = ACTIONS(2380),
    [anon_sym_pub] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_trait] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_union] = ACTIONS(2380),
    [anon_sym_unsafe] = ACTIONS(2380),
    [anon_sym_use] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_extern] = ACTIONS(2380),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_move] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [sym_integer_literal] = ACTIONS(2378),
    [aux_sym_string_literal_token1] = ACTIONS(2378),
    [sym_char_literal] = ACTIONS(2378),
    [anon_sym_true] = ACTIONS(2380),
    [anon_sym_false] = ACTIONS(2380),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_crate] = ACTIONS(2380),
    [sym_metavariable] = ACTIONS(2378),
    [sym_raw_string_literal] = ACTIONS(2378),
    [sym_float_literal] = ACTIONS(2378),
  },
  [646] = {
    [sym_line_comment] = STATE(646),
    [sym_block_comment] = STATE(646),
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_macro_rules_BANG] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_u8] = ACTIONS(2384),
    [anon_sym_i8] = ACTIONS(2384),
    [anon_sym_u16] = ACTIONS(2384),
    [anon_sym_i16] = ACTIONS(2384),
    [anon_sym_u32] = ACTIONS(2384),
    [anon_sym_i32] = ACTIONS(2384),
    [anon_sym_u64] = ACTIONS(2384),
    [anon_sym_i64] = ACTIONS(2384),
    [anon_sym_u128] = ACTIONS(2384),
    [anon_sym_i128] = ACTIONS(2384),
    [anon_sym_isize] = ACTIONS(2384),
    [anon_sym_usize] = ACTIONS(2384),
    [anon_sym_f32] = ACTIONS(2384),
    [anon_sym_f64] = ACTIONS(2384),
    [anon_sym_bool] = ACTIONS(2384),
    [anon_sym_str] = ACTIONS(2384),
    [anon_sym_char] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_POUND] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2382),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_fn] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_impl] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_loop] = ACTIONS(2384),
    [anon_sym_match] = ACTIONS(2384),
    [anon_sym_mod] = ACTIONS(2384),
    [anon_sym_pub] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_trait] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_unsafe] = ACTIONS(2384),
    [anon_sym_use] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym_DOT_DOT] = ACTIONS(2382),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_move] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2382),
    [aux_sym_string_literal_token1] = ACTIONS(2382),
    [sym_char_literal] = ACTIONS(2382),
    [anon_sym_true] = ACTIONS(2384),
    [anon_sym_false] = ACTIONS(2384),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_crate] = ACTIONS(2384),
    [sym_metavariable] = ACTIONS(2382),
    [sym_raw_string_literal] = ACTIONS(2382),
    [sym_float_literal] = ACTIONS(2382),
  },
  [647] = {
    [sym_line_comment] = STATE(647),
    [sym_block_comment] = STATE(647),
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_macro_rules_BANG] = ACTIONS(2386),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_u8] = ACTIONS(2388),
    [anon_sym_i8] = ACTIONS(2388),
    [anon_sym_u16] = ACTIONS(2388),
    [anon_sym_i16] = ACTIONS(2388),
    [anon_sym_u32] = ACTIONS(2388),
    [anon_sym_i32] = ACTIONS(2388),
    [anon_sym_u64] = ACTIONS(2388),
    [anon_sym_i64] = ACTIONS(2388),
    [anon_sym_u128] = ACTIONS(2388),
    [anon_sym_i128] = ACTIONS(2388),
    [anon_sym_isize] = ACTIONS(2388),
    [anon_sym_usize] = ACTIONS(2388),
    [anon_sym_f32] = ACTIONS(2388),
    [anon_sym_f64] = ACTIONS(2388),
    [anon_sym_bool] = ACTIONS(2388),
    [anon_sym_str] = ACTIONS(2388),
    [anon_sym_char] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_POUND] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_fn] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_impl] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_loop] = ACTIONS(2388),
    [anon_sym_match] = ACTIONS(2388),
    [anon_sym_mod] = ACTIONS(2388),
    [anon_sym_pub] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_trait] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_unsafe] = ACTIONS(2388),
    [anon_sym_use] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym_DOT_DOT] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_move] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [sym_integer_literal] = ACTIONS(2386),
    [aux_sym_string_literal_token1] = ACTIONS(2386),
    [sym_char_literal] = ACTIONS(2386),
    [anon_sym_true] = ACTIONS(2388),
    [anon_sym_false] = ACTIONS(2388),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_crate] = ACTIONS(2388),
    [sym_metavariable] = ACTIONS(2386),
    [sym_raw_string_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
  },
  [648] = {
    [sym_line_comment] = STATE(648),
    [sym_block_comment] = STATE(648),
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_macro_rules_BANG] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_u8] = ACTIONS(2392),
    [anon_sym_i8] = ACTIONS(2392),
    [anon_sym_u16] = ACTIONS(2392),
    [anon_sym_i16] = ACTIONS(2392),
    [anon_sym_u32] = ACTIONS(2392),
    [anon_sym_i32] = ACTIONS(2392),
    [anon_sym_u64] = ACTIONS(2392),
    [anon_sym_i64] = ACTIONS(2392),
    [anon_sym_u128] = ACTIONS(2392),
    [anon_sym_i128] = ACTIONS(2392),
    [anon_sym_isize] = ACTIONS(2392),
    [anon_sym_usize] = ACTIONS(2392),
    [anon_sym_f32] = ACTIONS(2392),
    [anon_sym_f64] = ACTIONS(2392),
    [anon_sym_bool] = ACTIONS(2392),
    [anon_sym_str] = ACTIONS(2392),
    [anon_sym_char] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_POUND] = ACTIONS(2390),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_fn] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_impl] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_loop] = ACTIONS(2392),
    [anon_sym_match] = ACTIONS(2392),
    [anon_sym_mod] = ACTIONS(2392),
    [anon_sym_pub] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_trait] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_unsafe] = ACTIONS(2392),
    [anon_sym_use] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym_DOT_DOT] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_move] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [sym_integer_literal] = ACTIONS(2390),
    [aux_sym_string_literal_token1] = ACTIONS(2390),
    [sym_char_literal] = ACTIONS(2390),
    [anon_sym_true] = ACTIONS(2392),
    [anon_sym_false] = ACTIONS(2392),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_crate] = ACTIONS(2392),
    [sym_metavariable] = ACTIONS(2390),
    [sym_raw_string_literal] = ACTIONS(2390),
    [sym_float_literal] = ACTIONS(2390),
  },
  [649] = {
    [sym_line_comment] = STATE(649),
    [sym_block_comment] = STATE(649),
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_macro_rules_BANG] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_u8] = ACTIONS(2396),
    [anon_sym_i8] = ACTIONS(2396),
    [anon_sym_u16] = ACTIONS(2396),
    [anon_sym_i16] = ACTIONS(2396),
    [anon_sym_u32] = ACTIONS(2396),
    [anon_sym_i32] = ACTIONS(2396),
    [anon_sym_u64] = ACTIONS(2396),
    [anon_sym_i64] = ACTIONS(2396),
    [anon_sym_u128] = ACTIONS(2396),
    [anon_sym_i128] = ACTIONS(2396),
    [anon_sym_isize] = ACTIONS(2396),
    [anon_sym_usize] = ACTIONS(2396),
    [anon_sym_f32] = ACTIONS(2396),
    [anon_sym_f64] = ACTIONS(2396),
    [anon_sym_bool] = ACTIONS(2396),
    [anon_sym_str] = ACTIONS(2396),
    [anon_sym_char] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_POUND] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_fn] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_impl] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_loop] = ACTIONS(2396),
    [anon_sym_match] = ACTIONS(2396),
    [anon_sym_mod] = ACTIONS(2396),
    [anon_sym_pub] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_trait] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_unsafe] = ACTIONS(2396),
    [anon_sym_use] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym_DOT_DOT] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_move] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [sym_integer_literal] = ACTIONS(2394),
    [aux_sym_string_literal_token1] = ACTIONS(2394),
    [sym_char_literal] = ACTIONS(2394),
    [anon_sym_true] = ACTIONS(2396),
    [anon_sym_false] = ACTIONS(2396),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_crate] = ACTIONS(2396),
    [sym_metavariable] = ACTIONS(2394),
    [sym_raw_string_literal] = ACTIONS(2394),
    [sym_float_literal] = ACTIONS(2394),
  },
  [650] = {
    [sym_line_comment] = STATE(650),
    [sym_block_comment] = STATE(650),
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_macro_rules_BANG] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_u8] = ACTIONS(2400),
    [anon_sym_i8] = ACTIONS(2400),
    [anon_sym_u16] = ACTIONS(2400),
    [anon_sym_i16] = ACTIONS(2400),
    [anon_sym_u32] = ACTIONS(2400),
    [anon_sym_i32] = ACTIONS(2400),
    [anon_sym_u64] = ACTIONS(2400),
    [anon_sym_i64] = ACTIONS(2400),
    [anon_sym_u128] = ACTIONS(2400),
    [anon_sym_i128] = ACTIONS(2400),
    [anon_sym_isize] = ACTIONS(2400),
    [anon_sym_usize] = ACTIONS(2400),
    [anon_sym_f32] = ACTIONS(2400),
    [anon_sym_f64] = ACTIONS(2400),
    [anon_sym_bool] = ACTIONS(2400),
    [anon_sym_str] = ACTIONS(2400),
    [anon_sym_char] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_POUND] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_fn] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_impl] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_loop] = ACTIONS(2400),
    [anon_sym_match] = ACTIONS(2400),
    [anon_sym_mod] = ACTIONS(2400),
    [anon_sym_pub] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_trait] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_unsafe] = ACTIONS(2400),
    [anon_sym_use] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(2400),
    [anon_sym_DOT_DOT] = ACTIONS(2398),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_move] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [sym_integer_literal] = ACTIONS(2398),
    [aux_sym_string_literal_token1] = ACTIONS(2398),
    [sym_char_literal] = ACTIONS(2398),
    [anon_sym_true] = ACTIONS(2400),
    [anon_sym_false] = ACTIONS(2400),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_crate] = ACTIONS(2400),
    [sym_metavariable] = ACTIONS(2398),
    [sym_raw_string_literal] = ACTIONS(2398),
    [sym_float_literal] = ACTIONS(2398),
  },
  [651] = {
    [sym_line_comment] = STATE(651),
    [sym_block_comment] = STATE(651),
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_macro_rules_BANG] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_u8] = ACTIONS(2404),
    [anon_sym_i8] = ACTIONS(2404),
    [anon_sym_u16] = ACTIONS(2404),
    [anon_sym_i16] = ACTIONS(2404),
    [anon_sym_u32] = ACTIONS(2404),
    [anon_sym_i32] = ACTIONS(2404),
    [anon_sym_u64] = ACTIONS(2404),
    [anon_sym_i64] = ACTIONS(2404),
    [anon_sym_u128] = ACTIONS(2404),
    [anon_sym_i128] = ACTIONS(2404),
    [anon_sym_isize] = ACTIONS(2404),
    [anon_sym_usize] = ACTIONS(2404),
    [anon_sym_f32] = ACTIONS(2404),
    [anon_sym_f64] = ACTIONS(2404),
    [anon_sym_bool] = ACTIONS(2404),
    [anon_sym_str] = ACTIONS(2404),
    [anon_sym_char] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_fn] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_impl] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_loop] = ACTIONS(2404),
    [anon_sym_match] = ACTIONS(2404),
    [anon_sym_mod] = ACTIONS(2404),
    [anon_sym_pub] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_trait] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_unsafe] = ACTIONS(2404),
    [anon_sym_use] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym_DOT_DOT] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_move] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [sym_integer_literal] = ACTIONS(2402),
    [aux_sym_string_literal_token1] = ACTIONS(2402),
    [sym_char_literal] = ACTIONS(2402),
    [anon_sym_true] = ACTIONS(2404),
    [anon_sym_false] = ACTIONS(2404),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_crate] = ACTIONS(2404),
    [sym_metavariable] = ACTIONS(2402),
    [sym_raw_string_literal] = ACTIONS(2402),
    [sym_float_literal] = ACTIONS(2402),
  },
  [652] = {
    [sym_line_comment] = STATE(652),
    [sym_block_comment] = STATE(652),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_macro_rules_BANG] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_u8] = ACTIONS(2408),
    [anon_sym_i8] = ACTIONS(2408),
    [anon_sym_u16] = ACTIONS(2408),
    [anon_sym_i16] = ACTIONS(2408),
    [anon_sym_u32] = ACTIONS(2408),
    [anon_sym_i32] = ACTIONS(2408),
    [anon_sym_u64] = ACTIONS(2408),
    [anon_sym_i64] = ACTIONS(2408),
    [anon_sym_u128] = ACTIONS(2408),
    [anon_sym_i128] = ACTIONS(2408),
    [anon_sym_isize] = ACTIONS(2408),
    [anon_sym_usize] = ACTIONS(2408),
    [anon_sym_f32] = ACTIONS(2408),
    [anon_sym_f64] = ACTIONS(2408),
    [anon_sym_bool] = ACTIONS(2408),
    [anon_sym_str] = ACTIONS(2408),
    [anon_sym_char] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_POUND] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
    [anon_sym_fn] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_impl] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_loop] = ACTIONS(2408),
    [anon_sym_match] = ACTIONS(2408),
    [anon_sym_mod] = ACTIONS(2408),
    [anon_sym_pub] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_struct] = ACTIONS(2408),
    [anon_sym_trait] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_union] = ACTIONS(2408),
    [anon_sym_unsafe] = ACTIONS(2408),
    [anon_sym_use] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_extern] = ACTIONS(2408),
    [anon_sym_DOT_DOT] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_move] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [sym_integer_literal] = ACTIONS(2406),
    [aux_sym_string_literal_token1] = ACTIONS(2406),
    [sym_char_literal] = ACTIONS(2406),
    [anon_sym_true] = ACTIONS(2408),
    [anon_sym_false] = ACTIONS(2408),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_crate] = ACTIONS(2408),
    [sym_metavariable] = ACTIONS(2406),
    [sym_raw_string_literal] = ACTIONS(2406),
    [sym_float_literal] = ACTIONS(2406),
  },
  [653] = {
    [sym_line_comment] = STATE(653),
    [sym_block_comment] = STATE(653),
    [ts_builtin_sym_end] = ACTIONS(2410),
    [sym_identifier] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_macro_rules_BANG] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_u8] = ACTIONS(2412),
    [anon_sym_i8] = ACTIONS(2412),
    [anon_sym_u16] = ACTIONS(2412),
    [anon_sym_i16] = ACTIONS(2412),
    [anon_sym_u32] = ACTIONS(2412),
    [anon_sym_i32] = ACTIONS(2412),
    [anon_sym_u64] = ACTIONS(2412),
    [anon_sym_i64] = ACTIONS(2412),
    [anon_sym_u128] = ACTIONS(2412),
    [anon_sym_i128] = ACTIONS(2412),
    [anon_sym_isize] = ACTIONS(2412),
    [anon_sym_usize] = ACTIONS(2412),
    [anon_sym_f32] = ACTIONS(2412),
    [anon_sym_f64] = ACTIONS(2412),
    [anon_sym_bool] = ACTIONS(2412),
    [anon_sym_str] = ACTIONS(2412),
    [anon_sym_char] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_POUND] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_async] = ACTIONS(2412),
    [anon_sym_break] = ACTIONS(2412),
    [anon_sym_const] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(2412),
    [anon_sym_default] = ACTIONS(2412),
    [anon_sym_enum] = ACTIONS(2412),
    [anon_sym_fn] = ACTIONS(2412),
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_if] = ACTIONS(2412),
    [anon_sym_impl] = ACTIONS(2412),
    [anon_sym_let] = ACTIONS(2412),
    [anon_sym_loop] = ACTIONS(2412),
    [anon_sym_match] = ACTIONS(2412),
    [anon_sym_mod] = ACTIONS(2412),
    [anon_sym_pub] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2412),
    [anon_sym_struct] = ACTIONS(2412),
    [anon_sym_trait] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2412),
    [anon_sym_union] = ACTIONS(2412),
    [anon_sym_unsafe] = ACTIONS(2412),
    [anon_sym_use] = ACTIONS(2412),
    [anon_sym_while] = ACTIONS(2412),
    [anon_sym_extern] = ACTIONS(2412),
    [anon_sym_DOT_DOT] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2412),
    [anon_sym_move] = ACTIONS(2412),
    [anon_sym_try] = ACTIONS(2412),
    [sym_integer_literal] = ACTIONS(2410),
    [aux_sym_string_literal_token1] = ACTIONS(2410),
    [sym_char_literal] = ACTIONS(2410),
    [anon_sym_true] = ACTIONS(2412),
    [anon_sym_false] = ACTIONS(2412),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2412),
    [sym_super] = ACTIONS(2412),
    [sym_crate] = ACTIONS(2412),
    [sym_metavariable] = ACTIONS(2410),
    [sym_raw_string_literal] = ACTIONS(2410),
    [sym_float_literal] = ACTIONS(2410),
  },
  [654] = {
    [sym_line_comment] = STATE(654),
    [sym_block_comment] = STATE(654),
    [ts_builtin_sym_end] = ACTIONS(2414),
    [sym_identifier] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_macro_rules_BANG] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_u8] = ACTIONS(2416),
    [anon_sym_i8] = ACTIONS(2416),
    [anon_sym_u16] = ACTIONS(2416),
    [anon_sym_i16] = ACTIONS(2416),
    [anon_sym_u32] = ACTIONS(2416),
    [anon_sym_i32] = ACTIONS(2416),
    [anon_sym_u64] = ACTIONS(2416),
    [anon_sym_i64] = ACTIONS(2416),
    [anon_sym_u128] = ACTIONS(2416),
    [anon_sym_i128] = ACTIONS(2416),
    [anon_sym_isize] = ACTIONS(2416),
    [anon_sym_usize] = ACTIONS(2416),
    [anon_sym_f32] = ACTIONS(2416),
    [anon_sym_f64] = ACTIONS(2416),
    [anon_sym_bool] = ACTIONS(2416),
    [anon_sym_str] = ACTIONS(2416),
    [anon_sym_char] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_POUND] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_fn] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_impl] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_loop] = ACTIONS(2416),
    [anon_sym_match] = ACTIONS(2416),
    [anon_sym_mod] = ACTIONS(2416),
    [anon_sym_pub] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_struct] = ACTIONS(2416),
    [anon_sym_trait] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_union] = ACTIONS(2416),
    [anon_sym_unsafe] = ACTIONS(2416),
    [anon_sym_use] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_extern] = ACTIONS(2416),
    [anon_sym_DOT_DOT] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2416),
    [anon_sym_move] = ACTIONS(2416),
    [anon_sym_try] = ACTIONS(2416),
    [sym_integer_literal] = ACTIONS(2414),
    [aux_sym_string_literal_token1] = ACTIONS(2414),
    [sym_char_literal] = ACTIONS(2414),
    [anon_sym_true] = ACTIONS(2416),
    [anon_sym_false] = ACTIONS(2416),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2416),
    [sym_super] = ACTIONS(2416),
    [sym_crate] = ACTIONS(2416),
    [sym_metavariable] = ACTIONS(2414),
    [sym_raw_string_literal] = ACTIONS(2414),
    [sym_float_literal] = ACTIONS(2414),
  },
  [655] = {
    [sym_line_comment] = STATE(655),
    [sym_block_comment] = STATE(655),
    [ts_builtin_sym_end] = ACTIONS(2418),
    [sym_identifier] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_macro_rules_BANG] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_u8] = ACTIONS(2420),
    [anon_sym_i8] = ACTIONS(2420),
    [anon_sym_u16] = ACTIONS(2420),
    [anon_sym_i16] = ACTIONS(2420),
    [anon_sym_u32] = ACTIONS(2420),
    [anon_sym_i32] = ACTIONS(2420),
    [anon_sym_u64] = ACTIONS(2420),
    [anon_sym_i64] = ACTIONS(2420),
    [anon_sym_u128] = ACTIONS(2420),
    [anon_sym_i128] = ACTIONS(2420),
    [anon_sym_isize] = ACTIONS(2420),
    [anon_sym_usize] = ACTIONS(2420),
    [anon_sym_f32] = ACTIONS(2420),
    [anon_sym_f64] = ACTIONS(2420),
    [anon_sym_bool] = ACTIONS(2420),
    [anon_sym_str] = ACTIONS(2420),
    [anon_sym_char] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_POUND] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_async] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_fn] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_impl] = ACTIONS(2420),
    [anon_sym_let] = ACTIONS(2420),
    [anon_sym_loop] = ACTIONS(2420),
    [anon_sym_match] = ACTIONS(2420),
    [anon_sym_mod] = ACTIONS(2420),
    [anon_sym_pub] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_trait] = ACTIONS(2420),
    [anon_sym_type] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_unsafe] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym_DOT_DOT] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2420),
    [anon_sym_move] = ACTIONS(2420),
    [anon_sym_try] = ACTIONS(2420),
    [sym_integer_literal] = ACTIONS(2418),
    [aux_sym_string_literal_token1] = ACTIONS(2418),
    [sym_char_literal] = ACTIONS(2418),
    [anon_sym_true] = ACTIONS(2420),
    [anon_sym_false] = ACTIONS(2420),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2420),
    [sym_super] = ACTIONS(2420),
    [sym_crate] = ACTIONS(2420),
    [sym_metavariable] = ACTIONS(2418),
    [sym_raw_string_literal] = ACTIONS(2418),
    [sym_float_literal] = ACTIONS(2418),
  },
  [656] = {
    [sym_line_comment] = STATE(656),
    [sym_block_comment] = STATE(656),
    [ts_builtin_sym_end] = ACTIONS(2422),
    [sym_identifier] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2422),
    [anon_sym_macro_rules_BANG] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_u8] = ACTIONS(2424),
    [anon_sym_i8] = ACTIONS(2424),
    [anon_sym_u16] = ACTIONS(2424),
    [anon_sym_i16] = ACTIONS(2424),
    [anon_sym_u32] = ACTIONS(2424),
    [anon_sym_i32] = ACTIONS(2424),
    [anon_sym_u64] = ACTIONS(2424),
    [anon_sym_i64] = ACTIONS(2424),
    [anon_sym_u128] = ACTIONS(2424),
    [anon_sym_i128] = ACTIONS(2424),
    [anon_sym_isize] = ACTIONS(2424),
    [anon_sym_usize] = ACTIONS(2424),
    [anon_sym_f32] = ACTIONS(2424),
    [anon_sym_f64] = ACTIONS(2424),
    [anon_sym_bool] = ACTIONS(2424),
    [anon_sym_str] = ACTIONS(2424),
    [anon_sym_char] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_POUND] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [anon_sym_async] = ACTIONS(2424),
    [anon_sym_break] = ACTIONS(2424),
    [anon_sym_const] = ACTIONS(2424),
    [anon_sym_continue] = ACTIONS(2424),
    [anon_sym_default] = ACTIONS(2424),
    [anon_sym_enum] = ACTIONS(2424),
    [anon_sym_fn] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2424),
    [anon_sym_if] = ACTIONS(2424),
    [anon_sym_impl] = ACTIONS(2424),
    [anon_sym_let] = ACTIONS(2424),
    [anon_sym_loop] = ACTIONS(2424),
    [anon_sym_match] = ACTIONS(2424),
    [anon_sym_mod] = ACTIONS(2424),
    [anon_sym_pub] = ACTIONS(2424),
    [anon_sym_return] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2424),
    [anon_sym_struct] = ACTIONS(2424),
    [anon_sym_trait] = ACTIONS(2424),
    [anon_sym_type] = ACTIONS(2424),
    [anon_sym_union] = ACTIONS(2424),
    [anon_sym_unsafe] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2424),
    [anon_sym_extern] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2424),
    [anon_sym_move] = ACTIONS(2424),
    [anon_sym_try] = ACTIONS(2424),
    [sym_integer_literal] = ACTIONS(2422),
    [aux_sym_string_literal_token1] = ACTIONS(2422),
    [sym_char_literal] = ACTIONS(2422),
    [anon_sym_true] = ACTIONS(2424),
    [anon_sym_false] = ACTIONS(2424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2424),
    [sym_super] = ACTIONS(2424),
    [sym_crate] = ACTIONS(2424),
    [sym_metavariable] = ACTIONS(2422),
    [sym_raw_string_literal] = ACTIONS(2422),
    [sym_float_literal] = ACTIONS(2422),
  },
  [657] = {
    [sym_line_comment] = STATE(657),
    [sym_block_comment] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym_macro_rules_BANG] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_u8] = ACTIONS(2428),
    [anon_sym_i8] = ACTIONS(2428),
    [anon_sym_u16] = ACTIONS(2428),
    [anon_sym_i16] = ACTIONS(2428),
    [anon_sym_u32] = ACTIONS(2428),
    [anon_sym_i32] = ACTIONS(2428),
    [anon_sym_u64] = ACTIONS(2428),
    [anon_sym_i64] = ACTIONS(2428),
    [anon_sym_u128] = ACTIONS(2428),
    [anon_sym_i128] = ACTIONS(2428),
    [anon_sym_isize] = ACTIONS(2428),
    [anon_sym_usize] = ACTIONS(2428),
    [anon_sym_f32] = ACTIONS(2428),
    [anon_sym_f64] = ACTIONS(2428),
    [anon_sym_bool] = ACTIONS(2428),
    [anon_sym_str] = ACTIONS(2428),
    [anon_sym_char] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_COLON_COLON] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_POUND] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_fn] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_impl] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_loop] = ACTIONS(2428),
    [anon_sym_match] = ACTIONS(2428),
    [anon_sym_mod] = ACTIONS(2428),
    [anon_sym_pub] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_trait] = ACTIONS(2428),
    [anon_sym_type] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_unsafe] = ACTIONS(2428),
    [anon_sym_use] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2428),
    [anon_sym_move] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [sym_integer_literal] = ACTIONS(2426),
    [aux_sym_string_literal_token1] = ACTIONS(2426),
    [sym_char_literal] = ACTIONS(2426),
    [anon_sym_true] = ACTIONS(2428),
    [anon_sym_false] = ACTIONS(2428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2428),
    [sym_super] = ACTIONS(2428),
    [sym_crate] = ACTIONS(2428),
    [sym_metavariable] = ACTIONS(2426),
    [sym_raw_string_literal] = ACTIONS(2426),
    [sym_float_literal] = ACTIONS(2426),
  },
  [658] = {
    [sym_line_comment] = STATE(658),
    [sym_block_comment] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_macro_rules_BANG] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_u8] = ACTIONS(2432),
    [anon_sym_i8] = ACTIONS(2432),
    [anon_sym_u16] = ACTIONS(2432),
    [anon_sym_i16] = ACTIONS(2432),
    [anon_sym_u32] = ACTIONS(2432),
    [anon_sym_i32] = ACTIONS(2432),
    [anon_sym_u64] = ACTIONS(2432),
    [anon_sym_i64] = ACTIONS(2432),
    [anon_sym_u128] = ACTIONS(2432),
    [anon_sym_i128] = ACTIONS(2432),
    [anon_sym_isize] = ACTIONS(2432),
    [anon_sym_usize] = ACTIONS(2432),
    [anon_sym_f32] = ACTIONS(2432),
    [anon_sym_f64] = ACTIONS(2432),
    [anon_sym_bool] = ACTIONS(2432),
    [anon_sym_str] = ACTIONS(2432),
    [anon_sym_char] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_COLON_COLON] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_POUND] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
    [anon_sym_fn] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_impl] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_loop] = ACTIONS(2432),
    [anon_sym_match] = ACTIONS(2432),
    [anon_sym_mod] = ACTIONS(2432),
    [anon_sym_pub] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_struct] = ACTIONS(2432),
    [anon_sym_trait] = ACTIONS(2432),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_union] = ACTIONS(2432),
    [anon_sym_unsafe] = ACTIONS(2432),
    [anon_sym_use] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_extern] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_move] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [sym_integer_literal] = ACTIONS(2430),
    [aux_sym_string_literal_token1] = ACTIONS(2430),
    [sym_char_literal] = ACTIONS(2430),
    [anon_sym_true] = ACTIONS(2432),
    [anon_sym_false] = ACTIONS(2432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_crate] = ACTIONS(2432),
    [sym_metavariable] = ACTIONS(2430),
    [sym_raw_string_literal] = ACTIONS(2430),
    [sym_float_literal] = ACTIONS(2430),
  },
  [659] = {
    [sym_line_comment] = STATE(659),
    [sym_block_comment] = STATE(659),
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_identifier] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_macro_rules_BANG] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_u8] = ACTIONS(2436),
    [anon_sym_i8] = ACTIONS(2436),
    [anon_sym_u16] = ACTIONS(2436),
    [anon_sym_i16] = ACTIONS(2436),
    [anon_sym_u32] = ACTIONS(2436),
    [anon_sym_i32] = ACTIONS(2436),
    [anon_sym_u64] = ACTIONS(2436),
    [anon_sym_i64] = ACTIONS(2436),
    [anon_sym_u128] = ACTIONS(2436),
    [anon_sym_i128] = ACTIONS(2436),
    [anon_sym_isize] = ACTIONS(2436),
    [anon_sym_usize] = ACTIONS(2436),
    [anon_sym_f32] = ACTIONS(2436),
    [anon_sym_f64] = ACTIONS(2436),
    [anon_sym_bool] = ACTIONS(2436),
    [anon_sym_str] = ACTIONS(2436),
    [anon_sym_char] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_COLON_COLON] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_POUND] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_fn] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_impl] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_loop] = ACTIONS(2436),
    [anon_sym_match] = ACTIONS(2436),
    [anon_sym_mod] = ACTIONS(2436),
    [anon_sym_pub] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_trait] = ACTIONS(2436),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [anon_sym_unsafe] = ACTIONS(2436),
    [anon_sym_use] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym_DOT_DOT] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_move] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [sym_integer_literal] = ACTIONS(2434),
    [aux_sym_string_literal_token1] = ACTIONS(2434),
    [sym_char_literal] = ACTIONS(2434),
    [anon_sym_true] = ACTIONS(2436),
    [anon_sym_false] = ACTIONS(2436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_crate] = ACTIONS(2436),
    [sym_metavariable] = ACTIONS(2434),
    [sym_raw_string_literal] = ACTIONS(2434),
    [sym_float_literal] = ACTIONS(2434),
  },
  [660] = {
    [sym_line_comment] = STATE(660),
    [sym_block_comment] = STATE(660),
    [ts_builtin_sym_end] = ACTIONS(2438),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_macro_rules_BANG] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_u8] = ACTIONS(2440),
    [anon_sym_i8] = ACTIONS(2440),
    [anon_sym_u16] = ACTIONS(2440),
    [anon_sym_i16] = ACTIONS(2440),
    [anon_sym_u32] = ACTIONS(2440),
    [anon_sym_i32] = ACTIONS(2440),
    [anon_sym_u64] = ACTIONS(2440),
    [anon_sym_i64] = ACTIONS(2440),
    [anon_sym_u128] = ACTIONS(2440),
    [anon_sym_i128] = ACTIONS(2440),
    [anon_sym_isize] = ACTIONS(2440),
    [anon_sym_usize] = ACTIONS(2440),
    [anon_sym_f32] = ACTIONS(2440),
    [anon_sym_f64] = ACTIONS(2440),
    [anon_sym_bool] = ACTIONS(2440),
    [anon_sym_str] = ACTIONS(2440),
    [anon_sym_char] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_POUND] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2440),
    [anon_sym_break] = ACTIONS(2440),
    [anon_sym_const] = ACTIONS(2440),
    [anon_sym_continue] = ACTIONS(2440),
    [anon_sym_default] = ACTIONS(2440),
    [anon_sym_enum] = ACTIONS(2440),
    [anon_sym_fn] = ACTIONS(2440),
    [anon_sym_for] = ACTIONS(2440),
    [anon_sym_if] = ACTIONS(2440),
    [anon_sym_impl] = ACTIONS(2440),
    [anon_sym_let] = ACTIONS(2440),
    [anon_sym_loop] = ACTIONS(2440),
    [anon_sym_match] = ACTIONS(2440),
    [anon_sym_mod] = ACTIONS(2440),
    [anon_sym_pub] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2440),
    [anon_sym_static] = ACTIONS(2440),
    [anon_sym_struct] = ACTIONS(2440),
    [anon_sym_trait] = ACTIONS(2440),
    [anon_sym_type] = ACTIONS(2440),
    [anon_sym_union] = ACTIONS(2440),
    [anon_sym_unsafe] = ACTIONS(2440),
    [anon_sym_use] = ACTIONS(2440),
    [anon_sym_while] = ACTIONS(2440),
    [anon_sym_extern] = ACTIONS(2440),
    [anon_sym_DOT_DOT] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2440),
    [anon_sym_move] = ACTIONS(2440),
    [anon_sym_try] = ACTIONS(2440),
    [sym_integer_literal] = ACTIONS(2438),
    [aux_sym_string_literal_token1] = ACTIONS(2438),
    [sym_char_literal] = ACTIONS(2438),
    [anon_sym_true] = ACTIONS(2440),
    [anon_sym_false] = ACTIONS(2440),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2440),
    [sym_super] = ACTIONS(2440),
    [sym_crate] = ACTIONS(2440),
    [sym_metavariable] = ACTIONS(2438),
    [sym_raw_string_literal] = ACTIONS(2438),
    [sym_float_literal] = ACTIONS(2438),
  },
  [661] = {
    [sym_line_comment] = STATE(661),
    [sym_block_comment] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [sym_identifier] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_macro_rules_BANG] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(2442),
    [anon_sym_u8] = ACTIONS(2444),
    [anon_sym_i8] = ACTIONS(2444),
    [anon_sym_u16] = ACTIONS(2444),
    [anon_sym_i16] = ACTIONS(2444),
    [anon_sym_u32] = ACTIONS(2444),
    [anon_sym_i32] = ACTIONS(2444),
    [anon_sym_u64] = ACTIONS(2444),
    [anon_sym_i64] = ACTIONS(2444),
    [anon_sym_u128] = ACTIONS(2444),
    [anon_sym_i128] = ACTIONS(2444),
    [anon_sym_isize] = ACTIONS(2444),
    [anon_sym_usize] = ACTIONS(2444),
    [anon_sym_f32] = ACTIONS(2444),
    [anon_sym_f64] = ACTIONS(2444),
    [anon_sym_bool] = ACTIONS(2444),
    [anon_sym_str] = ACTIONS(2444),
    [anon_sym_char] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_COLON_COLON] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_POUND] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [anon_sym_async] = ACTIONS(2444),
    [anon_sym_break] = ACTIONS(2444),
    [anon_sym_const] = ACTIONS(2444),
    [anon_sym_continue] = ACTIONS(2444),
    [anon_sym_default] = ACTIONS(2444),
    [anon_sym_enum] = ACTIONS(2444),
    [anon_sym_fn] = ACTIONS(2444),
    [anon_sym_for] = ACTIONS(2444),
    [anon_sym_if] = ACTIONS(2444),
    [anon_sym_impl] = ACTIONS(2444),
    [anon_sym_let] = ACTIONS(2444),
    [anon_sym_loop] = ACTIONS(2444),
    [anon_sym_match] = ACTIONS(2444),
    [anon_sym_mod] = ACTIONS(2444),
    [anon_sym_pub] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2444),
    [anon_sym_static] = ACTIONS(2444),
    [anon_sym_struct] = ACTIONS(2444),
    [anon_sym_trait] = ACTIONS(2444),
    [anon_sym_type] = ACTIONS(2444),
    [anon_sym_union] = ACTIONS(2444),
    [anon_sym_unsafe] = ACTIONS(2444),
    [anon_sym_use] = ACTIONS(2444),
    [anon_sym_while] = ACTIONS(2444),
    [anon_sym_extern] = ACTIONS(2444),
    [anon_sym_DOT_DOT] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2444),
    [anon_sym_move] = ACTIONS(2444),
    [anon_sym_try] = ACTIONS(2444),
    [sym_integer_literal] = ACTIONS(2442),
    [aux_sym_string_literal_token1] = ACTIONS(2442),
    [sym_char_literal] = ACTIONS(2442),
    [anon_sym_true] = ACTIONS(2444),
    [anon_sym_false] = ACTIONS(2444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2444),
    [sym_super] = ACTIONS(2444),
    [sym_crate] = ACTIONS(2444),
    [sym_metavariable] = ACTIONS(2442),
    [sym_raw_string_literal] = ACTIONS(2442),
    [sym_float_literal] = ACTIONS(2442),
  },
  [662] = {
    [sym_line_comment] = STATE(662),
    [sym_block_comment] = STATE(662),
    [ts_builtin_sym_end] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_macro_rules_BANG] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2446),
    [anon_sym_u8] = ACTIONS(2448),
    [anon_sym_i8] = ACTIONS(2448),
    [anon_sym_u16] = ACTIONS(2448),
    [anon_sym_i16] = ACTIONS(2448),
    [anon_sym_u32] = ACTIONS(2448),
    [anon_sym_i32] = ACTIONS(2448),
    [anon_sym_u64] = ACTIONS(2448),
    [anon_sym_i64] = ACTIONS(2448),
    [anon_sym_u128] = ACTIONS(2448),
    [anon_sym_i128] = ACTIONS(2448),
    [anon_sym_isize] = ACTIONS(2448),
    [anon_sym_usize] = ACTIONS(2448),
    [anon_sym_f32] = ACTIONS(2448),
    [anon_sym_f64] = ACTIONS(2448),
    [anon_sym_bool] = ACTIONS(2448),
    [anon_sym_str] = ACTIONS(2448),
    [anon_sym_char] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_COLON_COLON] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_POUND] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [anon_sym_async] = ACTIONS(2448),
    [anon_sym_break] = ACTIONS(2448),
    [anon_sym_const] = ACTIONS(2448),
    [anon_sym_continue] = ACTIONS(2448),
    [anon_sym_default] = ACTIONS(2448),
    [anon_sym_enum] = ACTIONS(2448),
    [anon_sym_fn] = ACTIONS(2448),
    [anon_sym_for] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2448),
    [anon_sym_impl] = ACTIONS(2448),
    [anon_sym_let] = ACTIONS(2448),
    [anon_sym_loop] = ACTIONS(2448),
    [anon_sym_match] = ACTIONS(2448),
    [anon_sym_mod] = ACTIONS(2448),
    [anon_sym_pub] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2448),
    [anon_sym_static] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2448),
    [anon_sym_trait] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2448),
    [anon_sym_union] = ACTIONS(2448),
    [anon_sym_unsafe] = ACTIONS(2448),
    [anon_sym_use] = ACTIONS(2448),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_extern] = ACTIONS(2448),
    [anon_sym_DOT_DOT] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2448),
    [anon_sym_move] = ACTIONS(2448),
    [anon_sym_try] = ACTIONS(2448),
    [sym_integer_literal] = ACTIONS(2446),
    [aux_sym_string_literal_token1] = ACTIONS(2446),
    [sym_char_literal] = ACTIONS(2446),
    [anon_sym_true] = ACTIONS(2448),
    [anon_sym_false] = ACTIONS(2448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2448),
    [sym_super] = ACTIONS(2448),
    [sym_crate] = ACTIONS(2448),
    [sym_metavariable] = ACTIONS(2446),
    [sym_raw_string_literal] = ACTIONS(2446),
    [sym_float_literal] = ACTIONS(2446),
  },
  [663] = {
    [sym_line_comment] = STATE(663),
    [sym_block_comment] = STATE(663),
    [ts_builtin_sym_end] = ACTIONS(2450),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_macro_rules_BANG] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_u8] = ACTIONS(2452),
    [anon_sym_i8] = ACTIONS(2452),
    [anon_sym_u16] = ACTIONS(2452),
    [anon_sym_i16] = ACTIONS(2452),
    [anon_sym_u32] = ACTIONS(2452),
    [anon_sym_i32] = ACTIONS(2452),
    [anon_sym_u64] = ACTIONS(2452),
    [anon_sym_i64] = ACTIONS(2452),
    [anon_sym_u128] = ACTIONS(2452),
    [anon_sym_i128] = ACTIONS(2452),
    [anon_sym_isize] = ACTIONS(2452),
    [anon_sym_usize] = ACTIONS(2452),
    [anon_sym_f32] = ACTIONS(2452),
    [anon_sym_f64] = ACTIONS(2452),
    [anon_sym_bool] = ACTIONS(2452),
    [anon_sym_str] = ACTIONS(2452),
    [anon_sym_char] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_COLON_COLON] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_POUND] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_break] = ACTIONS(2452),
    [anon_sym_const] = ACTIONS(2452),
    [anon_sym_continue] = ACTIONS(2452),
    [anon_sym_default] = ACTIONS(2452),
    [anon_sym_enum] = ACTIONS(2452),
    [anon_sym_fn] = ACTIONS(2452),
    [anon_sym_for] = ACTIONS(2452),
    [anon_sym_if] = ACTIONS(2452),
    [anon_sym_impl] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_loop] = ACTIONS(2452),
    [anon_sym_match] = ACTIONS(2452),
    [anon_sym_mod] = ACTIONS(2452),
    [anon_sym_pub] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_struct] = ACTIONS(2452),
    [anon_sym_trait] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_union] = ACTIONS(2452),
    [anon_sym_unsafe] = ACTIONS(2452),
    [anon_sym_use] = ACTIONS(2452),
    [anon_sym_while] = ACTIONS(2452),
    [anon_sym_extern] = ACTIONS(2452),
    [anon_sym_DOT_DOT] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_move] = ACTIONS(2452),
    [anon_sym_try] = ACTIONS(2452),
    [sym_integer_literal] = ACTIONS(2450),
    [aux_sym_string_literal_token1] = ACTIONS(2450),
    [sym_char_literal] = ACTIONS(2450),
    [anon_sym_true] = ACTIONS(2452),
    [anon_sym_false] = ACTIONS(2452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_crate] = ACTIONS(2452),
    [sym_metavariable] = ACTIONS(2450),
    [sym_raw_string_literal] = ACTIONS(2450),
    [sym_float_literal] = ACTIONS(2450),
  },
  [664] = {
    [sym_line_comment] = STATE(664),
    [sym_block_comment] = STATE(664),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [sym_identifier] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_macro_rules_BANG] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_u8] = ACTIONS(2456),
    [anon_sym_i8] = ACTIONS(2456),
    [anon_sym_u16] = ACTIONS(2456),
    [anon_sym_i16] = ACTIONS(2456),
    [anon_sym_u32] = ACTIONS(2456),
    [anon_sym_i32] = ACTIONS(2456),
    [anon_sym_u64] = ACTIONS(2456),
    [anon_sym_i64] = ACTIONS(2456),
    [anon_sym_u128] = ACTIONS(2456),
    [anon_sym_i128] = ACTIONS(2456),
    [anon_sym_isize] = ACTIONS(2456),
    [anon_sym_usize] = ACTIONS(2456),
    [anon_sym_f32] = ACTIONS(2456),
    [anon_sym_f64] = ACTIONS(2456),
    [anon_sym_bool] = ACTIONS(2456),
    [anon_sym_str] = ACTIONS(2456),
    [anon_sym_char] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_POUND] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_const] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_default] = ACTIONS(2456),
    [anon_sym_enum] = ACTIONS(2456),
    [anon_sym_fn] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_impl] = ACTIONS(2456),
    [anon_sym_let] = ACTIONS(2456),
    [anon_sym_loop] = ACTIONS(2456),
    [anon_sym_match] = ACTIONS(2456),
    [anon_sym_mod] = ACTIONS(2456),
    [anon_sym_pub] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_static] = ACTIONS(2456),
    [anon_sym_struct] = ACTIONS(2456),
    [anon_sym_trait] = ACTIONS(2456),
    [anon_sym_type] = ACTIONS(2456),
    [anon_sym_union] = ACTIONS(2456),
    [anon_sym_unsafe] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_extern] = ACTIONS(2456),
    [anon_sym_DOT_DOT] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_move] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [sym_integer_literal] = ACTIONS(2454),
    [aux_sym_string_literal_token1] = ACTIONS(2454),
    [sym_char_literal] = ACTIONS(2454),
    [anon_sym_true] = ACTIONS(2456),
    [anon_sym_false] = ACTIONS(2456),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2456),
    [sym_super] = ACTIONS(2456),
    [sym_crate] = ACTIONS(2456),
    [sym_metavariable] = ACTIONS(2454),
    [sym_raw_string_literal] = ACTIONS(2454),
    [sym_float_literal] = ACTIONS(2454),
  },
  [665] = {
    [sym_line_comment] = STATE(665),
    [sym_block_comment] = STATE(665),
    [ts_builtin_sym_end] = ACTIONS(2458),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_macro_rules_BANG] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2458),
    [anon_sym_u8] = ACTIONS(2460),
    [anon_sym_i8] = ACTIONS(2460),
    [anon_sym_u16] = ACTIONS(2460),
    [anon_sym_i16] = ACTIONS(2460),
    [anon_sym_u32] = ACTIONS(2460),
    [anon_sym_i32] = ACTIONS(2460),
    [anon_sym_u64] = ACTIONS(2460),
    [anon_sym_i64] = ACTIONS(2460),
    [anon_sym_u128] = ACTIONS(2460),
    [anon_sym_i128] = ACTIONS(2460),
    [anon_sym_isize] = ACTIONS(2460),
    [anon_sym_usize] = ACTIONS(2460),
    [anon_sym_f32] = ACTIONS(2460),
    [anon_sym_f64] = ACTIONS(2460),
    [anon_sym_bool] = ACTIONS(2460),
    [anon_sym_str] = ACTIONS(2460),
    [anon_sym_char] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_COLON_COLON] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_POUND] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2460),
    [anon_sym_break] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(2460),
    [anon_sym_default] = ACTIONS(2460),
    [anon_sym_enum] = ACTIONS(2460),
    [anon_sym_fn] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2460),
    [anon_sym_impl] = ACTIONS(2460),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_loop] = ACTIONS(2460),
    [anon_sym_match] = ACTIONS(2460),
    [anon_sym_mod] = ACTIONS(2460),
    [anon_sym_pub] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2460),
    [anon_sym_struct] = ACTIONS(2460),
    [anon_sym_trait] = ACTIONS(2460),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_union] = ACTIONS(2460),
    [anon_sym_unsafe] = ACTIONS(2460),
    [anon_sym_use] = ACTIONS(2460),
    [anon_sym_while] = ACTIONS(2460),
    [anon_sym_extern] = ACTIONS(2460),
    [anon_sym_DOT_DOT] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2460),
    [anon_sym_move] = ACTIONS(2460),
    [anon_sym_try] = ACTIONS(2460),
    [sym_integer_literal] = ACTIONS(2458),
    [aux_sym_string_literal_token1] = ACTIONS(2458),
    [sym_char_literal] = ACTIONS(2458),
    [anon_sym_true] = ACTIONS(2460),
    [anon_sym_false] = ACTIONS(2460),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2460),
    [sym_super] = ACTIONS(2460),
    [sym_crate] = ACTIONS(2460),
    [sym_metavariable] = ACTIONS(2458),
    [sym_raw_string_literal] = ACTIONS(2458),
    [sym_float_literal] = ACTIONS(2458),
  },
  [666] = {
    [sym_line_comment] = STATE(666),
    [sym_block_comment] = STATE(666),
    [ts_builtin_sym_end] = ACTIONS(2462),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_macro_rules_BANG] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_u8] = ACTIONS(2464),
    [anon_sym_i8] = ACTIONS(2464),
    [anon_sym_u16] = ACTIONS(2464),
    [anon_sym_i16] = ACTIONS(2464),
    [anon_sym_u32] = ACTIONS(2464),
    [anon_sym_i32] = ACTIONS(2464),
    [anon_sym_u64] = ACTIONS(2464),
    [anon_sym_i64] = ACTIONS(2464),
    [anon_sym_u128] = ACTIONS(2464),
    [anon_sym_i128] = ACTIONS(2464),
    [anon_sym_isize] = ACTIONS(2464),
    [anon_sym_usize] = ACTIONS(2464),
    [anon_sym_f32] = ACTIONS(2464),
    [anon_sym_f64] = ACTIONS(2464),
    [anon_sym_bool] = ACTIONS(2464),
    [anon_sym_str] = ACTIONS(2464),
    [anon_sym_char] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_POUND] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2464),
    [anon_sym_break] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_continue] = ACTIONS(2464),
    [anon_sym_default] = ACTIONS(2464),
    [anon_sym_enum] = ACTIONS(2464),
    [anon_sym_fn] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_impl] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_loop] = ACTIONS(2464),
    [anon_sym_match] = ACTIONS(2464),
    [anon_sym_mod] = ACTIONS(2464),
    [anon_sym_pub] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_trait] = ACTIONS(2464),
    [anon_sym_type] = ACTIONS(2464),
    [anon_sym_union] = ACTIONS(2464),
    [anon_sym_unsafe] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [anon_sym_extern] = ACTIONS(2464),
    [anon_sym_DOT_DOT] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2464),
    [anon_sym_move] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [sym_integer_literal] = ACTIONS(2462),
    [aux_sym_string_literal_token1] = ACTIONS(2462),
    [sym_char_literal] = ACTIONS(2462),
    [anon_sym_true] = ACTIONS(2464),
    [anon_sym_false] = ACTIONS(2464),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2464),
    [sym_super] = ACTIONS(2464),
    [sym_crate] = ACTIONS(2464),
    [sym_metavariable] = ACTIONS(2462),
    [sym_raw_string_literal] = ACTIONS(2462),
    [sym_float_literal] = ACTIONS(2462),
  },
  [667] = {
    [sym_line_comment] = STATE(667),
    [sym_block_comment] = STATE(667),
    [ts_builtin_sym_end] = ACTIONS(2466),
    [sym_identifier] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_macro_rules_BANG] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_u8] = ACTIONS(2468),
    [anon_sym_i8] = ACTIONS(2468),
    [anon_sym_u16] = ACTIONS(2468),
    [anon_sym_i16] = ACTIONS(2468),
    [anon_sym_u32] = ACTIONS(2468),
    [anon_sym_i32] = ACTIONS(2468),
    [anon_sym_u64] = ACTIONS(2468),
    [anon_sym_i64] = ACTIONS(2468),
    [anon_sym_u128] = ACTIONS(2468),
    [anon_sym_i128] = ACTIONS(2468),
    [anon_sym_isize] = ACTIONS(2468),
    [anon_sym_usize] = ACTIONS(2468),
    [anon_sym_f32] = ACTIONS(2468),
    [anon_sym_f64] = ACTIONS(2468),
    [anon_sym_bool] = ACTIONS(2468),
    [anon_sym_str] = ACTIONS(2468),
    [anon_sym_char] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_POUND] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym_async] = ACTIONS(2468),
    [anon_sym_break] = ACTIONS(2468),
    [anon_sym_const] = ACTIONS(2468),
    [anon_sym_continue] = ACTIONS(2468),
    [anon_sym_default] = ACTIONS(2468),
    [anon_sym_enum] = ACTIONS(2468),
    [anon_sym_fn] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2468),
    [anon_sym_if] = ACTIONS(2468),
    [anon_sym_impl] = ACTIONS(2468),
    [anon_sym_let] = ACTIONS(2468),
    [anon_sym_loop] = ACTIONS(2468),
    [anon_sym_match] = ACTIONS(2468),
    [anon_sym_mod] = ACTIONS(2468),
    [anon_sym_pub] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2468),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_trait] = ACTIONS(2468),
    [anon_sym_type] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2468),
    [anon_sym_unsafe] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2468),
    [anon_sym_while] = ACTIONS(2468),
    [anon_sym_extern] = ACTIONS(2468),
    [anon_sym_DOT_DOT] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2468),
    [anon_sym_move] = ACTIONS(2468),
    [anon_sym_try] = ACTIONS(2468),
    [sym_integer_literal] = ACTIONS(2466),
    [aux_sym_string_literal_token1] = ACTIONS(2466),
    [sym_char_literal] = ACTIONS(2466),
    [anon_sym_true] = ACTIONS(2468),
    [anon_sym_false] = ACTIONS(2468),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2468),
    [sym_super] = ACTIONS(2468),
    [sym_crate] = ACTIONS(2468),
    [sym_metavariable] = ACTIONS(2466),
    [sym_raw_string_literal] = ACTIONS(2466),
    [sym_float_literal] = ACTIONS(2466),
  },
  [668] = {
    [sym_line_comment] = STATE(668),
    [sym_block_comment] = STATE(668),
    [ts_builtin_sym_end] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2470),
    [anon_sym_macro_rules_BANG] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_u8] = ACTIONS(2472),
    [anon_sym_i8] = ACTIONS(2472),
    [anon_sym_u16] = ACTIONS(2472),
    [anon_sym_i16] = ACTIONS(2472),
    [anon_sym_u32] = ACTIONS(2472),
    [anon_sym_i32] = ACTIONS(2472),
    [anon_sym_u64] = ACTIONS(2472),
    [anon_sym_i64] = ACTIONS(2472),
    [anon_sym_u128] = ACTIONS(2472),
    [anon_sym_i128] = ACTIONS(2472),
    [anon_sym_isize] = ACTIONS(2472),
    [anon_sym_usize] = ACTIONS(2472),
    [anon_sym_f32] = ACTIONS(2472),
    [anon_sym_f64] = ACTIONS(2472),
    [anon_sym_bool] = ACTIONS(2472),
    [anon_sym_str] = ACTIONS(2472),
    [anon_sym_char] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_POUND] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2472),
    [anon_sym_break] = ACTIONS(2472),
    [anon_sym_const] = ACTIONS(2472),
    [anon_sym_continue] = ACTIONS(2472),
    [anon_sym_default] = ACTIONS(2472),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_fn] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2472),
    [anon_sym_if] = ACTIONS(2472),
    [anon_sym_impl] = ACTIONS(2472),
    [anon_sym_let] = ACTIONS(2472),
    [anon_sym_loop] = ACTIONS(2472),
    [anon_sym_match] = ACTIONS(2472),
    [anon_sym_mod] = ACTIONS(2472),
    [anon_sym_pub] = ACTIONS(2472),
    [anon_sym_return] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2472),
    [anon_sym_struct] = ACTIONS(2472),
    [anon_sym_trait] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2472),
    [anon_sym_union] = ACTIONS(2472),
    [anon_sym_unsafe] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2472),
    [anon_sym_while] = ACTIONS(2472),
    [anon_sym_extern] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2472),
    [anon_sym_move] = ACTIONS(2472),
    [anon_sym_try] = ACTIONS(2472),
    [sym_integer_literal] = ACTIONS(2470),
    [aux_sym_string_literal_token1] = ACTIONS(2470),
    [sym_char_literal] = ACTIONS(2470),
    [anon_sym_true] = ACTIONS(2472),
    [anon_sym_false] = ACTIONS(2472),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2472),
    [sym_super] = ACTIONS(2472),
    [sym_crate] = ACTIONS(2472),
    [sym_metavariable] = ACTIONS(2470),
    [sym_raw_string_literal] = ACTIONS(2470),
    [sym_float_literal] = ACTIONS(2470),
  },
  [669] = {
    [sym_line_comment] = STATE(669),
    [sym_block_comment] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(2474),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2474),
    [anon_sym_macro_rules_BANG] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_u8] = ACTIONS(2476),
    [anon_sym_i8] = ACTIONS(2476),
    [anon_sym_u16] = ACTIONS(2476),
    [anon_sym_i16] = ACTIONS(2476),
    [anon_sym_u32] = ACTIONS(2476),
    [anon_sym_i32] = ACTIONS(2476),
    [anon_sym_u64] = ACTIONS(2476),
    [anon_sym_i64] = ACTIONS(2476),
    [anon_sym_u128] = ACTIONS(2476),
    [anon_sym_i128] = ACTIONS(2476),
    [anon_sym_isize] = ACTIONS(2476),
    [anon_sym_usize] = ACTIONS(2476),
    [anon_sym_f32] = ACTIONS(2476),
    [anon_sym_f64] = ACTIONS(2476),
    [anon_sym_bool] = ACTIONS(2476),
    [anon_sym_str] = ACTIONS(2476),
    [anon_sym_char] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_POUND] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [anon_sym_async] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_fn] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_impl] = ACTIONS(2476),
    [anon_sym_let] = ACTIONS(2476),
    [anon_sym_loop] = ACTIONS(2476),
    [anon_sym_match] = ACTIONS(2476),
    [anon_sym_mod] = ACTIONS(2476),
    [anon_sym_pub] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_trait] = ACTIONS(2476),
    [anon_sym_type] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_unsafe] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym_DOT_DOT] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2476),
    [anon_sym_move] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [sym_integer_literal] = ACTIONS(2474),
    [aux_sym_string_literal_token1] = ACTIONS(2474),
    [sym_char_literal] = ACTIONS(2474),
    [anon_sym_true] = ACTIONS(2476),
    [anon_sym_false] = ACTIONS(2476),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2476),
    [sym_super] = ACTIONS(2476),
    [sym_crate] = ACTIONS(2476),
    [sym_metavariable] = ACTIONS(2474),
    [sym_raw_string_literal] = ACTIONS(2474),
    [sym_float_literal] = ACTIONS(2474),
  },
  [670] = {
    [sym_line_comment] = STATE(670),
    [sym_block_comment] = STATE(670),
    [ts_builtin_sym_end] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_macro_rules_BANG] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_u8] = ACTIONS(2480),
    [anon_sym_i8] = ACTIONS(2480),
    [anon_sym_u16] = ACTIONS(2480),
    [anon_sym_i16] = ACTIONS(2480),
    [anon_sym_u32] = ACTIONS(2480),
    [anon_sym_i32] = ACTIONS(2480),
    [anon_sym_u64] = ACTIONS(2480),
    [anon_sym_i64] = ACTIONS(2480),
    [anon_sym_u128] = ACTIONS(2480),
    [anon_sym_i128] = ACTIONS(2480),
    [anon_sym_isize] = ACTIONS(2480),
    [anon_sym_usize] = ACTIONS(2480),
    [anon_sym_f32] = ACTIONS(2480),
    [anon_sym_f64] = ACTIONS(2480),
    [anon_sym_bool] = ACTIONS(2480),
    [anon_sym_str] = ACTIONS(2480),
    [anon_sym_char] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_COLON_COLON] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_POUND] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [anon_sym_async] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_fn] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_impl] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_loop] = ACTIONS(2480),
    [anon_sym_match] = ACTIONS(2480),
    [anon_sym_mod] = ACTIONS(2480),
    [anon_sym_pub] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_trait] = ACTIONS(2480),
    [anon_sym_type] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_unsafe] = ACTIONS(2480),
    [anon_sym_use] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym_DOT_DOT] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2480),
    [anon_sym_move] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [sym_integer_literal] = ACTIONS(2478),
    [aux_sym_string_literal_token1] = ACTIONS(2478),
    [sym_char_literal] = ACTIONS(2478),
    [anon_sym_true] = ACTIONS(2480),
    [anon_sym_false] = ACTIONS(2480),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2480),
    [sym_super] = ACTIONS(2480),
    [sym_crate] = ACTIONS(2480),
    [sym_metavariable] = ACTIONS(2478),
    [sym_raw_string_literal] = ACTIONS(2478),
    [sym_float_literal] = ACTIONS(2478),
  },
  [671] = {
    [sym_line_comment] = STATE(671),
    [sym_block_comment] = STATE(671),
    [ts_builtin_sym_end] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_macro_rules_BANG] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_u8] = ACTIONS(2484),
    [anon_sym_i8] = ACTIONS(2484),
    [anon_sym_u16] = ACTIONS(2484),
    [anon_sym_i16] = ACTIONS(2484),
    [anon_sym_u32] = ACTIONS(2484),
    [anon_sym_i32] = ACTIONS(2484),
    [anon_sym_u64] = ACTIONS(2484),
    [anon_sym_i64] = ACTIONS(2484),
    [anon_sym_u128] = ACTIONS(2484),
    [anon_sym_i128] = ACTIONS(2484),
    [anon_sym_isize] = ACTIONS(2484),
    [anon_sym_usize] = ACTIONS(2484),
    [anon_sym_f32] = ACTIONS(2484),
    [anon_sym_f64] = ACTIONS(2484),
    [anon_sym_bool] = ACTIONS(2484),
    [anon_sym_str] = ACTIONS(2484),
    [anon_sym_char] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_POUND] = ACTIONS(2482),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [anon_sym_async] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [anon_sym_fn] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2484),
    [anon_sym_impl] = ACTIONS(2484),
    [anon_sym_let] = ACTIONS(2484),
    [anon_sym_loop] = ACTIONS(2484),
    [anon_sym_match] = ACTIONS(2484),
    [anon_sym_mod] = ACTIONS(2484),
    [anon_sym_pub] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_struct] = ACTIONS(2484),
    [anon_sym_trait] = ACTIONS(2484),
    [anon_sym_type] = ACTIONS(2484),
    [anon_sym_union] = ACTIONS(2484),
    [anon_sym_unsafe] = ACTIONS(2484),
    [anon_sym_use] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_extern] = ACTIONS(2484),
    [anon_sym_DOT_DOT] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2484),
    [anon_sym_move] = ACTIONS(2484),
    [anon_sym_try] = ACTIONS(2484),
    [sym_integer_literal] = ACTIONS(2482),
    [aux_sym_string_literal_token1] = ACTIONS(2482),
    [sym_char_literal] = ACTIONS(2482),
    [anon_sym_true] = ACTIONS(2484),
    [anon_sym_false] = ACTIONS(2484),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2484),
    [sym_super] = ACTIONS(2484),
    [sym_crate] = ACTIONS(2484),
    [sym_metavariable] = ACTIONS(2482),
    [sym_raw_string_literal] = ACTIONS(2482),
    [sym_float_literal] = ACTIONS(2482),
  },
  [672] = {
    [sym_line_comment] = STATE(672),
    [sym_block_comment] = STATE(672),
    [ts_builtin_sym_end] = ACTIONS(2486),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_macro_rules_BANG] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_u8] = ACTIONS(2488),
    [anon_sym_i8] = ACTIONS(2488),
    [anon_sym_u16] = ACTIONS(2488),
    [anon_sym_i16] = ACTIONS(2488),
    [anon_sym_u32] = ACTIONS(2488),
    [anon_sym_i32] = ACTIONS(2488),
    [anon_sym_u64] = ACTIONS(2488),
    [anon_sym_i64] = ACTIONS(2488),
    [anon_sym_u128] = ACTIONS(2488),
    [anon_sym_i128] = ACTIONS(2488),
    [anon_sym_isize] = ACTIONS(2488),
    [anon_sym_usize] = ACTIONS(2488),
    [anon_sym_f32] = ACTIONS(2488),
    [anon_sym_f64] = ACTIONS(2488),
    [anon_sym_bool] = ACTIONS(2488),
    [anon_sym_str] = ACTIONS(2488),
    [anon_sym_char] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_POUND] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_fn] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_impl] = ACTIONS(2488),
    [anon_sym_let] = ACTIONS(2488),
    [anon_sym_loop] = ACTIONS(2488),
    [anon_sym_match] = ACTIONS(2488),
    [anon_sym_mod] = ACTIONS(2488),
    [anon_sym_pub] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_trait] = ACTIONS(2488),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_unsafe] = ACTIONS(2488),
    [anon_sym_use] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2488),
    [anon_sym_move] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [sym_integer_literal] = ACTIONS(2486),
    [aux_sym_string_literal_token1] = ACTIONS(2486),
    [sym_char_literal] = ACTIONS(2486),
    [anon_sym_true] = ACTIONS(2488),
    [anon_sym_false] = ACTIONS(2488),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2488),
    [sym_super] = ACTIONS(2488),
    [sym_crate] = ACTIONS(2488),
    [sym_metavariable] = ACTIONS(2486),
    [sym_raw_string_literal] = ACTIONS(2486),
    [sym_float_literal] = ACTIONS(2486),
  },
  [673] = {
    [sym_line_comment] = STATE(673),
    [sym_block_comment] = STATE(673),
    [ts_builtin_sym_end] = ACTIONS(2490),
    [sym_identifier] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_macro_rules_BANG] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_u8] = ACTIONS(2492),
    [anon_sym_i8] = ACTIONS(2492),
    [anon_sym_u16] = ACTIONS(2492),
    [anon_sym_i16] = ACTIONS(2492),
    [anon_sym_u32] = ACTIONS(2492),
    [anon_sym_i32] = ACTIONS(2492),
    [anon_sym_u64] = ACTIONS(2492),
    [anon_sym_i64] = ACTIONS(2492),
    [anon_sym_u128] = ACTIONS(2492),
    [anon_sym_i128] = ACTIONS(2492),
    [anon_sym_isize] = ACTIONS(2492),
    [anon_sym_usize] = ACTIONS(2492),
    [anon_sym_f32] = ACTIONS(2492),
    [anon_sym_f64] = ACTIONS(2492),
    [anon_sym_bool] = ACTIONS(2492),
    [anon_sym_str] = ACTIONS(2492),
    [anon_sym_char] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_async] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_fn] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_impl] = ACTIONS(2492),
    [anon_sym_let] = ACTIONS(2492),
    [anon_sym_loop] = ACTIONS(2492),
    [anon_sym_match] = ACTIONS(2492),
    [anon_sym_mod] = ACTIONS(2492),
    [anon_sym_pub] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_trait] = ACTIONS(2492),
    [anon_sym_type] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_unsafe] = ACTIONS(2492),
    [anon_sym_use] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(2492),
    [anon_sym_move] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [sym_integer_literal] = ACTIONS(2490),
    [aux_sym_string_literal_token1] = ACTIONS(2490),
    [sym_char_literal] = ACTIONS(2490),
    [anon_sym_true] = ACTIONS(2492),
    [anon_sym_false] = ACTIONS(2492),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2492),
    [sym_super] = ACTIONS(2492),
    [sym_crate] = ACTIONS(2492),
    [sym_metavariable] = ACTIONS(2490),
    [sym_raw_string_literal] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
  },
  [674] = {
    [sym_line_comment] = STATE(674),
    [sym_block_comment] = STATE(674),
    [ts_builtin_sym_end] = ACTIONS(2494),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_macro_rules_BANG] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_u8] = ACTIONS(2496),
    [anon_sym_i8] = ACTIONS(2496),
    [anon_sym_u16] = ACTIONS(2496),
    [anon_sym_i16] = ACTIONS(2496),
    [anon_sym_u32] = ACTIONS(2496),
    [anon_sym_i32] = ACTIONS(2496),
    [anon_sym_u64] = ACTIONS(2496),
    [anon_sym_i64] = ACTIONS(2496),
    [anon_sym_u128] = ACTIONS(2496),
    [anon_sym_i128] = ACTIONS(2496),
    [anon_sym_isize] = ACTIONS(2496),
    [anon_sym_usize] = ACTIONS(2496),
    [anon_sym_f32] = ACTIONS(2496),
    [anon_sym_f64] = ACTIONS(2496),
    [anon_sym_bool] = ACTIONS(2496),
    [anon_sym_str] = ACTIONS(2496),
    [anon_sym_char] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2494),
    [anon_sym_POUND] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [anon_sym_async] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_fn] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_impl] = ACTIONS(2496),
    [anon_sym_let] = ACTIONS(2496),
    [anon_sym_loop] = ACTIONS(2496),
    [anon_sym_match] = ACTIONS(2496),
    [anon_sym_mod] = ACTIONS(2496),
    [anon_sym_pub] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_trait] = ACTIONS(2496),
    [anon_sym_type] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_unsafe] = ACTIONS(2496),
    [anon_sym_use] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym_DOT_DOT] = ACTIONS(2494),
    [anon_sym_yield] = ACTIONS(2496),
    [anon_sym_move] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [sym_integer_literal] = ACTIONS(2494),
    [aux_sym_string_literal_token1] = ACTIONS(2494),
    [sym_char_literal] = ACTIONS(2494),
    [anon_sym_true] = ACTIONS(2496),
    [anon_sym_false] = ACTIONS(2496),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2496),
    [sym_super] = ACTIONS(2496),
    [sym_crate] = ACTIONS(2496),
    [sym_metavariable] = ACTIONS(2494),
    [sym_raw_string_literal] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
  },
  [675] = {
    [sym_line_comment] = STATE(675),
    [sym_block_comment] = STATE(675),
    [ts_builtin_sym_end] = ACTIONS(2498),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_macro_rules_BANG] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_u8] = ACTIONS(2500),
    [anon_sym_i8] = ACTIONS(2500),
    [anon_sym_u16] = ACTIONS(2500),
    [anon_sym_i16] = ACTIONS(2500),
    [anon_sym_u32] = ACTIONS(2500),
    [anon_sym_i32] = ACTIONS(2500),
    [anon_sym_u64] = ACTIONS(2500),
    [anon_sym_i64] = ACTIONS(2500),
    [anon_sym_u128] = ACTIONS(2500),
    [anon_sym_i128] = ACTIONS(2500),
    [anon_sym_isize] = ACTIONS(2500),
    [anon_sym_usize] = ACTIONS(2500),
    [anon_sym_f32] = ACTIONS(2500),
    [anon_sym_f64] = ACTIONS(2500),
    [anon_sym_bool] = ACTIONS(2500),
    [anon_sym_str] = ACTIONS(2500),
    [anon_sym_char] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_POUND] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [anon_sym_async] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_fn] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_impl] = ACTIONS(2500),
    [anon_sym_let] = ACTIONS(2500),
    [anon_sym_loop] = ACTIONS(2500),
    [anon_sym_match] = ACTIONS(2500),
    [anon_sym_mod] = ACTIONS(2500),
    [anon_sym_pub] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_trait] = ACTIONS(2500),
    [anon_sym_type] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_unsafe] = ACTIONS(2500),
    [anon_sym_use] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym_DOT_DOT] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2500),
    [anon_sym_move] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [sym_integer_literal] = ACTIONS(2498),
    [aux_sym_string_literal_token1] = ACTIONS(2498),
    [sym_char_literal] = ACTIONS(2498),
    [anon_sym_true] = ACTIONS(2500),
    [anon_sym_false] = ACTIONS(2500),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2500),
    [sym_super] = ACTIONS(2500),
    [sym_crate] = ACTIONS(2500),
    [sym_metavariable] = ACTIONS(2498),
    [sym_raw_string_literal] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
  },
  [676] = {
    [sym_line_comment] = STATE(676),
    [sym_block_comment] = STATE(676),
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_macro_rules_BANG] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_u8] = ACTIONS(2504),
    [anon_sym_i8] = ACTIONS(2504),
    [anon_sym_u16] = ACTIONS(2504),
    [anon_sym_i16] = ACTIONS(2504),
    [anon_sym_u32] = ACTIONS(2504),
    [anon_sym_i32] = ACTIONS(2504),
    [anon_sym_u64] = ACTIONS(2504),
    [anon_sym_i64] = ACTIONS(2504),
    [anon_sym_u128] = ACTIONS(2504),
    [anon_sym_i128] = ACTIONS(2504),
    [anon_sym_isize] = ACTIONS(2504),
    [anon_sym_usize] = ACTIONS(2504),
    [anon_sym_f32] = ACTIONS(2504),
    [anon_sym_f64] = ACTIONS(2504),
    [anon_sym_bool] = ACTIONS(2504),
    [anon_sym_str] = ACTIONS(2504),
    [anon_sym_char] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2502),
    [anon_sym_POUND] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [anon_sym_async] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_fn] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_impl] = ACTIONS(2504),
    [anon_sym_let] = ACTIONS(2504),
    [anon_sym_loop] = ACTIONS(2504),
    [anon_sym_match] = ACTIONS(2504),
    [anon_sym_mod] = ACTIONS(2504),
    [anon_sym_pub] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_trait] = ACTIONS(2504),
    [anon_sym_type] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_unsafe] = ACTIONS(2504),
    [anon_sym_use] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym_DOT_DOT] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2504),
    [anon_sym_move] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [sym_integer_literal] = ACTIONS(2502),
    [aux_sym_string_literal_token1] = ACTIONS(2502),
    [sym_char_literal] = ACTIONS(2502),
    [anon_sym_true] = ACTIONS(2504),
    [anon_sym_false] = ACTIONS(2504),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2504),
    [sym_super] = ACTIONS(2504),
    [sym_crate] = ACTIONS(2504),
    [sym_metavariable] = ACTIONS(2502),
    [sym_raw_string_literal] = ACTIONS(2502),
    [sym_float_literal] = ACTIONS(2502),
  },
  [677] = {
    [sym_line_comment] = STATE(677),
    [sym_block_comment] = STATE(677),
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_macro_rules_BANG] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_u8] = ACTIONS(2508),
    [anon_sym_i8] = ACTIONS(2508),
    [anon_sym_u16] = ACTIONS(2508),
    [anon_sym_i16] = ACTIONS(2508),
    [anon_sym_u32] = ACTIONS(2508),
    [anon_sym_i32] = ACTIONS(2508),
    [anon_sym_u64] = ACTIONS(2508),
    [anon_sym_i64] = ACTIONS(2508),
    [anon_sym_u128] = ACTIONS(2508),
    [anon_sym_i128] = ACTIONS(2508),
    [anon_sym_isize] = ACTIONS(2508),
    [anon_sym_usize] = ACTIONS(2508),
    [anon_sym_f32] = ACTIONS(2508),
    [anon_sym_f64] = ACTIONS(2508),
    [anon_sym_bool] = ACTIONS(2508),
    [anon_sym_str] = ACTIONS(2508),
    [anon_sym_char] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_POUND] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [anon_sym_async] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_fn] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_impl] = ACTIONS(2508),
    [anon_sym_let] = ACTIONS(2508),
    [anon_sym_loop] = ACTIONS(2508),
    [anon_sym_match] = ACTIONS(2508),
    [anon_sym_mod] = ACTIONS(2508),
    [anon_sym_pub] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_trait] = ACTIONS(2508),
    [anon_sym_type] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [anon_sym_unsafe] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym_DOT_DOT] = ACTIONS(2506),
    [anon_sym_yield] = ACTIONS(2508),
    [anon_sym_move] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [sym_integer_literal] = ACTIONS(2506),
    [aux_sym_string_literal_token1] = ACTIONS(2506),
    [sym_char_literal] = ACTIONS(2506),
    [anon_sym_true] = ACTIONS(2508),
    [anon_sym_false] = ACTIONS(2508),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2508),
    [sym_super] = ACTIONS(2508),
    [sym_crate] = ACTIONS(2508),
    [sym_metavariable] = ACTIONS(2506),
    [sym_raw_string_literal] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
  },
  [678] = {
    [sym_line_comment] = STATE(678),
    [sym_block_comment] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(2510),
    [sym_identifier] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_macro_rules_BANG] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_u8] = ACTIONS(2512),
    [anon_sym_i8] = ACTIONS(2512),
    [anon_sym_u16] = ACTIONS(2512),
    [anon_sym_i16] = ACTIONS(2512),
    [anon_sym_u32] = ACTIONS(2512),
    [anon_sym_i32] = ACTIONS(2512),
    [anon_sym_u64] = ACTIONS(2512),
    [anon_sym_i64] = ACTIONS(2512),
    [anon_sym_u128] = ACTIONS(2512),
    [anon_sym_i128] = ACTIONS(2512),
    [anon_sym_isize] = ACTIONS(2512),
    [anon_sym_usize] = ACTIONS(2512),
    [anon_sym_f32] = ACTIONS(2512),
    [anon_sym_f64] = ACTIONS(2512),
    [anon_sym_bool] = ACTIONS(2512),
    [anon_sym_str] = ACTIONS(2512),
    [anon_sym_char] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_LT] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_async] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_fn] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_impl] = ACTIONS(2512),
    [anon_sym_let] = ACTIONS(2512),
    [anon_sym_loop] = ACTIONS(2512),
    [anon_sym_match] = ACTIONS(2512),
    [anon_sym_mod] = ACTIONS(2512),
    [anon_sym_pub] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_trait] = ACTIONS(2512),
    [anon_sym_type] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [anon_sym_unsafe] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym_DOT_DOT] = ACTIONS(2510),
    [anon_sym_yield] = ACTIONS(2512),
    [anon_sym_move] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [sym_integer_literal] = ACTIONS(2510),
    [aux_sym_string_literal_token1] = ACTIONS(2510),
    [sym_char_literal] = ACTIONS(2510),
    [anon_sym_true] = ACTIONS(2512),
    [anon_sym_false] = ACTIONS(2512),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2512),
    [sym_super] = ACTIONS(2512),
    [sym_crate] = ACTIONS(2512),
    [sym_metavariable] = ACTIONS(2510),
    [sym_raw_string_literal] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
  },
  [679] = {
    [sym_line_comment] = STATE(679),
    [sym_block_comment] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2514),
    [sym_identifier] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_macro_rules_BANG] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_u8] = ACTIONS(2516),
    [anon_sym_i8] = ACTIONS(2516),
    [anon_sym_u16] = ACTIONS(2516),
    [anon_sym_i16] = ACTIONS(2516),
    [anon_sym_u32] = ACTIONS(2516),
    [anon_sym_i32] = ACTIONS(2516),
    [anon_sym_u64] = ACTIONS(2516),
    [anon_sym_i64] = ACTIONS(2516),
    [anon_sym_u128] = ACTIONS(2516),
    [anon_sym_i128] = ACTIONS(2516),
    [anon_sym_isize] = ACTIONS(2516),
    [anon_sym_usize] = ACTIONS(2516),
    [anon_sym_f32] = ACTIONS(2516),
    [anon_sym_f64] = ACTIONS(2516),
    [anon_sym_bool] = ACTIONS(2516),
    [anon_sym_str] = ACTIONS(2516),
    [anon_sym_char] = ACTIONS(2516),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_POUND] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [anon_sym_async] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_fn] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_impl] = ACTIONS(2516),
    [anon_sym_let] = ACTIONS(2516),
    [anon_sym_loop] = ACTIONS(2516),
    [anon_sym_match] = ACTIONS(2516),
    [anon_sym_mod] = ACTIONS(2516),
    [anon_sym_pub] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_trait] = ACTIONS(2516),
    [anon_sym_type] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [anon_sym_unsafe] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym_DOT_DOT] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2516),
    [anon_sym_move] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [sym_integer_literal] = ACTIONS(2514),
    [aux_sym_string_literal_token1] = ACTIONS(2514),
    [sym_char_literal] = ACTIONS(2514),
    [anon_sym_true] = ACTIONS(2516),
    [anon_sym_false] = ACTIONS(2516),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2516),
    [sym_super] = ACTIONS(2516),
    [sym_crate] = ACTIONS(2516),
    [sym_metavariable] = ACTIONS(2514),
    [sym_raw_string_literal] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
  },
  [680] = {
    [sym_line_comment] = STATE(680),
    [sym_block_comment] = STATE(680),
    [ts_builtin_sym_end] = ACTIONS(2518),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_macro_rules_BANG] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_u8] = ACTIONS(2520),
    [anon_sym_i8] = ACTIONS(2520),
    [anon_sym_u16] = ACTIONS(2520),
    [anon_sym_i16] = ACTIONS(2520),
    [anon_sym_u32] = ACTIONS(2520),
    [anon_sym_i32] = ACTIONS(2520),
    [anon_sym_u64] = ACTIONS(2520),
    [anon_sym_i64] = ACTIONS(2520),
    [anon_sym_u128] = ACTIONS(2520),
    [anon_sym_i128] = ACTIONS(2520),
    [anon_sym_isize] = ACTIONS(2520),
    [anon_sym_usize] = ACTIONS(2520),
    [anon_sym_f32] = ACTIONS(2520),
    [anon_sym_f64] = ACTIONS(2520),
    [anon_sym_bool] = ACTIONS(2520),
    [anon_sym_str] = ACTIONS(2520),
    [anon_sym_char] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_POUND] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [anon_sym_async] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_fn] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_impl] = ACTIONS(2520),
    [anon_sym_let] = ACTIONS(2520),
    [anon_sym_loop] = ACTIONS(2520),
    [anon_sym_match] = ACTIONS(2520),
    [anon_sym_mod] = ACTIONS(2520),
    [anon_sym_pub] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_trait] = ACTIONS(2520),
    [anon_sym_type] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [anon_sym_unsafe] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym_DOT_DOT] = ACTIONS(2518),
    [anon_sym_yield] = ACTIONS(2520),
    [anon_sym_move] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [sym_integer_literal] = ACTIONS(2518),
    [aux_sym_string_literal_token1] = ACTIONS(2518),
    [sym_char_literal] = ACTIONS(2518),
    [anon_sym_true] = ACTIONS(2520),
    [anon_sym_false] = ACTIONS(2520),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2520),
    [sym_super] = ACTIONS(2520),
    [sym_crate] = ACTIONS(2520),
    [sym_metavariable] = ACTIONS(2518),
    [sym_raw_string_literal] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
  },
  [681] = {
    [sym_line_comment] = STATE(681),
    [sym_block_comment] = STATE(681),
    [ts_builtin_sym_end] = ACTIONS(2522),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_macro_rules_BANG] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_u8] = ACTIONS(2524),
    [anon_sym_i8] = ACTIONS(2524),
    [anon_sym_u16] = ACTIONS(2524),
    [anon_sym_i16] = ACTIONS(2524),
    [anon_sym_u32] = ACTIONS(2524),
    [anon_sym_i32] = ACTIONS(2524),
    [anon_sym_u64] = ACTIONS(2524),
    [anon_sym_i64] = ACTIONS(2524),
    [anon_sym_u128] = ACTIONS(2524),
    [anon_sym_i128] = ACTIONS(2524),
    [anon_sym_isize] = ACTIONS(2524),
    [anon_sym_usize] = ACTIONS(2524),
    [anon_sym_f32] = ACTIONS(2524),
    [anon_sym_f64] = ACTIONS(2524),
    [anon_sym_bool] = ACTIONS(2524),
    [anon_sym_str] = ACTIONS(2524),
    [anon_sym_char] = ACTIONS(2524),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2522),
    [anon_sym_POUND] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_fn] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_impl] = ACTIONS(2524),
    [anon_sym_let] = ACTIONS(2524),
    [anon_sym_loop] = ACTIONS(2524),
    [anon_sym_match] = ACTIONS(2524),
    [anon_sym_mod] = ACTIONS(2524),
    [anon_sym_pub] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_trait] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_unsafe] = ACTIONS(2524),
    [anon_sym_use] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym_DOT_DOT] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2524),
    [anon_sym_move] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [sym_integer_literal] = ACTIONS(2522),
    [aux_sym_string_literal_token1] = ACTIONS(2522),
    [sym_char_literal] = ACTIONS(2522),
    [anon_sym_true] = ACTIONS(2524),
    [anon_sym_false] = ACTIONS(2524),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2524),
    [sym_super] = ACTIONS(2524),
    [sym_crate] = ACTIONS(2524),
    [sym_metavariable] = ACTIONS(2522),
    [sym_raw_string_literal] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
  },
  [682] = {
    [sym_line_comment] = STATE(682),
    [sym_block_comment] = STATE(682),
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_macro_rules_BANG] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_u8] = ACTIONS(2528),
    [anon_sym_i8] = ACTIONS(2528),
    [anon_sym_u16] = ACTIONS(2528),
    [anon_sym_i16] = ACTIONS(2528),
    [anon_sym_u32] = ACTIONS(2528),
    [anon_sym_i32] = ACTIONS(2528),
    [anon_sym_u64] = ACTIONS(2528),
    [anon_sym_i64] = ACTIONS(2528),
    [anon_sym_u128] = ACTIONS(2528),
    [anon_sym_i128] = ACTIONS(2528),
    [anon_sym_isize] = ACTIONS(2528),
    [anon_sym_usize] = ACTIONS(2528),
    [anon_sym_f32] = ACTIONS(2528),
    [anon_sym_f64] = ACTIONS(2528),
    [anon_sym_bool] = ACTIONS(2528),
    [anon_sym_str] = ACTIONS(2528),
    [anon_sym_char] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_POUND] = ACTIONS(2526),
    [anon_sym_LT] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [anon_sym_async] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_fn] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_impl] = ACTIONS(2528),
    [anon_sym_let] = ACTIONS(2528),
    [anon_sym_loop] = ACTIONS(2528),
    [anon_sym_match] = ACTIONS(2528),
    [anon_sym_mod] = ACTIONS(2528),
    [anon_sym_pub] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2528),
    [anon_sym_trait] = ACTIONS(2528),
    [anon_sym_type] = ACTIONS(2528),
    [anon_sym_union] = ACTIONS(2528),
    [anon_sym_unsafe] = ACTIONS(2528),
    [anon_sym_use] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_extern] = ACTIONS(2528),
    [anon_sym_DOT_DOT] = ACTIONS(2526),
    [anon_sym_yield] = ACTIONS(2528),
    [anon_sym_move] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [sym_integer_literal] = ACTIONS(2526),
    [aux_sym_string_literal_token1] = ACTIONS(2526),
    [sym_char_literal] = ACTIONS(2526),
    [anon_sym_true] = ACTIONS(2528),
    [anon_sym_false] = ACTIONS(2528),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2528),
    [sym_super] = ACTIONS(2528),
    [sym_crate] = ACTIONS(2528),
    [sym_metavariable] = ACTIONS(2526),
    [sym_raw_string_literal] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
  },
  [683] = {
    [sym_empty_statement] = STATE(1101),
    [sym_macro_definition] = STATE(1101),
    [sym_attribute_item] = STATE(1101),
    [sym_inner_attribute_item] = STATE(1101),
    [sym_mod_item] = STATE(1101),
    [sym_foreign_mod_item] = STATE(1101),
    [sym_struct_item] = STATE(1101),
    [sym_union_item] = STATE(1101),
    [sym_enum_item] = STATE(1101),
    [sym_extern_crate_declaration] = STATE(1101),
    [sym_const_item] = STATE(1101),
    [sym_static_item] = STATE(1101),
    [sym_type_item] = STATE(1101),
    [sym_function_item] = STATE(1101),
    [sym_function_signature_item] = STATE(1101),
    [sym_function_modifiers] = STATE(3508),
    [sym_impl_item] = STATE(1101),
    [sym_trait_item] = STATE(1101),
    [sym_associated_type] = STATE(1101),
    [sym_let_declaration] = STATE(1101),
    [sym_use_declaration] = STATE(1101),
    [sym_extern_modifier] = STATE(2143),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type_with_turbofish] = STATE(3269),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(3067),
    [sym_line_comment] = STATE(683),
    [sym_block_comment] = STATE(683),
    [aux_sym_declaration_list_repeat1] = STATE(590),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_macro_rules_BANG] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_u8] = ACTIONS(1751),
    [anon_sym_i8] = ACTIONS(1751),
    [anon_sym_u16] = ACTIONS(1751),
    [anon_sym_i16] = ACTIONS(1751),
    [anon_sym_u32] = ACTIONS(1751),
    [anon_sym_i32] = ACTIONS(1751),
    [anon_sym_u64] = ACTIONS(1751),
    [anon_sym_i64] = ACTIONS(1751),
    [anon_sym_u128] = ACTIONS(1751),
    [anon_sym_i128] = ACTIONS(1751),
    [anon_sym_isize] = ACTIONS(1751),
    [anon_sym_usize] = ACTIONS(1751),
    [anon_sym_f32] = ACTIONS(1751),
    [anon_sym_f64] = ACTIONS(1751),
    [anon_sym_bool] = ACTIONS(1751),
    [anon_sym_str] = ACTIONS(1751),
    [anon_sym_char] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_POUND] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1757),
    [anon_sym_default] = ACTIONS(1759),
    [anon_sym_enum] = ACTIONS(1761),
    [anon_sym_fn] = ACTIONS(1763),
    [anon_sym_impl] = ACTIONS(1765),
    [anon_sym_let] = ACTIONS(1767),
    [anon_sym_mod] = ACTIONS(1769),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_struct] = ACTIONS(1773),
    [anon_sym_trait] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_union] = ACTIONS(1779),
    [anon_sym_unsafe] = ACTIONS(1781),
    [anon_sym_use] = ACTIONS(1783),
    [anon_sym_extern] = ACTIONS(1785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1787),
    [sym_super] = ACTIONS(1787),
    [sym_crate] = ACTIONS(1789),
    [sym_metavariable] = ACTIONS(1791),
  },
  [684] = {
    [sym_line_comment] = STATE(684),
    [sym_block_comment] = STATE(684),
    [ts_builtin_sym_end] = ACTIONS(2532),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_macro_rules_BANG] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2532),
    [anon_sym_u8] = ACTIONS(2534),
    [anon_sym_i8] = ACTIONS(2534),
    [anon_sym_u16] = ACTIONS(2534),
    [anon_sym_i16] = ACTIONS(2534),
    [anon_sym_u32] = ACTIONS(2534),
    [anon_sym_i32] = ACTIONS(2534),
    [anon_sym_u64] = ACTIONS(2534),
    [anon_sym_i64] = ACTIONS(2534),
    [anon_sym_u128] = ACTIONS(2534),
    [anon_sym_i128] = ACTIONS(2534),
    [anon_sym_isize] = ACTIONS(2534),
    [anon_sym_usize] = ACTIONS(2534),
    [anon_sym_f32] = ACTIONS(2534),
    [anon_sym_f64] = ACTIONS(2534),
    [anon_sym_bool] = ACTIONS(2534),
    [anon_sym_str] = ACTIONS(2534),
    [anon_sym_char] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_POUND] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_default] = ACTIONS(2534),
    [anon_sym_enum] = ACTIONS(2534),
    [anon_sym_fn] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_impl] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_loop] = ACTIONS(2534),
    [anon_sym_match] = ACTIONS(2534),
    [anon_sym_mod] = ACTIONS(2534),
    [anon_sym_pub] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_trait] = ACTIONS(2534),
    [anon_sym_type] = ACTIONS(2534),
    [anon_sym_union] = ACTIONS(2534),
    [anon_sym_unsafe] = ACTIONS(2534),
    [anon_sym_use] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_extern] = ACTIONS(2534),
    [anon_sym_DOT_DOT] = ACTIONS(2532),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_move] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [sym_integer_literal] = ACTIONS(2532),
    [aux_sym_string_literal_token1] = ACTIONS(2532),
    [sym_char_literal] = ACTIONS(2532),
    [anon_sym_true] = ACTIONS(2534),
    [anon_sym_false] = ACTIONS(2534),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2534),
    [sym_super] = ACTIONS(2534),
    [sym_crate] = ACTIONS(2534),
    [sym_metavariable] = ACTIONS(2532),
    [sym_raw_string_literal] = ACTIONS(2532),
    [sym_float_literal] = ACTIONS(2532),
  },
  [685] = {
    [sym_line_comment] = STATE(685),
    [sym_block_comment] = STATE(685),
    [ts_builtin_sym_end] = ACTIONS(2536),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_macro_rules_BANG] = ACTIONS(2536),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2536),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_u8] = ACTIONS(2538),
    [anon_sym_i8] = ACTIONS(2538),
    [anon_sym_u16] = ACTIONS(2538),
    [anon_sym_i16] = ACTIONS(2538),
    [anon_sym_u32] = ACTIONS(2538),
    [anon_sym_i32] = ACTIONS(2538),
    [anon_sym_u64] = ACTIONS(2538),
    [anon_sym_i64] = ACTIONS(2538),
    [anon_sym_u128] = ACTIONS(2538),
    [anon_sym_i128] = ACTIONS(2538),
    [anon_sym_isize] = ACTIONS(2538),
    [anon_sym_usize] = ACTIONS(2538),
    [anon_sym_f32] = ACTIONS(2538),
    [anon_sym_f64] = ACTIONS(2538),
    [anon_sym_bool] = ACTIONS(2538),
    [anon_sym_str] = ACTIONS(2538),
    [anon_sym_char] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2536),
    [anon_sym_BANG] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_POUND] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(2538),
    [anon_sym_break] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_continue] = ACTIONS(2538),
    [anon_sym_default] = ACTIONS(2538),
    [anon_sym_enum] = ACTIONS(2538),
    [anon_sym_fn] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_impl] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_loop] = ACTIONS(2538),
    [anon_sym_match] = ACTIONS(2538),
    [anon_sym_mod] = ACTIONS(2538),
    [anon_sym_pub] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_static] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_trait] = ACTIONS(2538),
    [anon_sym_type] = ACTIONS(2538),
    [anon_sym_union] = ACTIONS(2538),
    [anon_sym_unsafe] = ACTIONS(2538),
    [anon_sym_use] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_extern] = ACTIONS(2538),
    [anon_sym_DOT_DOT] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2538),
    [anon_sym_move] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [sym_integer_literal] = ACTIONS(2536),
    [aux_sym_string_literal_token1] = ACTIONS(2536),
    [sym_char_literal] = ACTIONS(2536),
    [anon_sym_true] = ACTIONS(2538),
    [anon_sym_false] = ACTIONS(2538),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2538),
    [sym_super] = ACTIONS(2538),
    [sym_crate] = ACTIONS(2538),
    [sym_metavariable] = ACTIONS(2536),
    [sym_raw_string_literal] = ACTIONS(2536),
    [sym_float_literal] = ACTIONS(2536),
  },
  [686] = {
    [sym_empty_statement] = STATE(1101),
    [sym_macro_definition] = STATE(1101),
    [sym_attribute_item] = STATE(1101),
    [sym_inner_attribute_item] = STATE(1101),
    [sym_mod_item] = STATE(1101),
    [sym_foreign_mod_item] = STATE(1101),
    [sym_struct_item] = STATE(1101),
    [sym_union_item] = STATE(1101),
    [sym_enum_item] = STATE(1101),
    [sym_extern_crate_declaration] = STATE(1101),
    [sym_const_item] = STATE(1101),
    [sym_static_item] = STATE(1101),
    [sym_type_item] = STATE(1101),
    [sym_function_item] = STATE(1101),
    [sym_function_signature_item] = STATE(1101),
    [sym_function_modifiers] = STATE(3508),
    [sym_impl_item] = STATE(1101),
    [sym_trait_item] = STATE(1101),
    [sym_associated_type] = STATE(1101),
    [sym_let_declaration] = STATE(1101),
    [sym_use_declaration] = STATE(1101),
    [sym_extern_modifier] = STATE(2143),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type_with_turbofish] = STATE(3269),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(3067),
    [sym_line_comment] = STATE(686),
    [sym_block_comment] = STATE(686),
    [aux_sym_declaration_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_macro_rules_BANG] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_u8] = ACTIONS(1751),
    [anon_sym_i8] = ACTIONS(1751),
    [anon_sym_u16] = ACTIONS(1751),
    [anon_sym_i16] = ACTIONS(1751),
    [anon_sym_u32] = ACTIONS(1751),
    [anon_sym_i32] = ACTIONS(1751),
    [anon_sym_u64] = ACTIONS(1751),
    [anon_sym_i64] = ACTIONS(1751),
    [anon_sym_u128] = ACTIONS(1751),
    [anon_sym_i128] = ACTIONS(1751),
    [anon_sym_isize] = ACTIONS(1751),
    [anon_sym_usize] = ACTIONS(1751),
    [anon_sym_f32] = ACTIONS(1751),
    [anon_sym_f64] = ACTIONS(1751),
    [anon_sym_bool] = ACTIONS(1751),
    [anon_sym_str] = ACTIONS(1751),
    [anon_sym_char] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_POUND] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1757),
    [anon_sym_default] = ACTIONS(1759),
    [anon_sym_enum] = ACTIONS(1761),
    [anon_sym_fn] = ACTIONS(1763),
    [anon_sym_impl] = ACTIONS(1765),
    [anon_sym_let] = ACTIONS(1767),
    [anon_sym_mod] = ACTIONS(1769),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_struct] = ACTIONS(1773),
    [anon_sym_trait] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_union] = ACTIONS(1779),
    [anon_sym_unsafe] = ACTIONS(1781),
    [anon_sym_use] = ACTIONS(1783),
    [anon_sym_extern] = ACTIONS(1785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1787),
    [sym_super] = ACTIONS(1787),
    [sym_crate] = ACTIONS(1789),
    [sym_metavariable] = ACTIONS(1791),
  },
  [687] = {
    [sym_line_comment] = STATE(687),
    [sym_block_comment] = STATE(687),
    [ts_builtin_sym_end] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_macro_rules_BANG] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_u8] = ACTIONS(2544),
    [anon_sym_i8] = ACTIONS(2544),
    [anon_sym_u16] = ACTIONS(2544),
    [anon_sym_i16] = ACTIONS(2544),
    [anon_sym_u32] = ACTIONS(2544),
    [anon_sym_i32] = ACTIONS(2544),
    [anon_sym_u64] = ACTIONS(2544),
    [anon_sym_i64] = ACTIONS(2544),
    [anon_sym_u128] = ACTIONS(2544),
    [anon_sym_i128] = ACTIONS(2544),
    [anon_sym_isize] = ACTIONS(2544),
    [anon_sym_usize] = ACTIONS(2544),
    [anon_sym_f32] = ACTIONS(2544),
    [anon_sym_f64] = ACTIONS(2544),
    [anon_sym_bool] = ACTIONS(2544),
    [anon_sym_str] = ACTIONS(2544),
    [anon_sym_char] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_POUND] = ACTIONS(2542),
    [anon_sym_LT] = ACTIONS(2542),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_fn] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_impl] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_loop] = ACTIONS(2544),
    [anon_sym_match] = ACTIONS(2544),
    [anon_sym_mod] = ACTIONS(2544),
    [anon_sym_pub] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_struct] = ACTIONS(2544),
    [anon_sym_trait] = ACTIONS(2544),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_union] = ACTIONS(2544),
    [anon_sym_unsafe] = ACTIONS(2544),
    [anon_sym_use] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_extern] = ACTIONS(2544),
    [anon_sym_DOT_DOT] = ACTIONS(2542),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_move] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [sym_integer_literal] = ACTIONS(2542),
    [aux_sym_string_literal_token1] = ACTIONS(2542),
    [sym_char_literal] = ACTIONS(2542),
    [anon_sym_true] = ACTIONS(2544),
    [anon_sym_false] = ACTIONS(2544),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_crate] = ACTIONS(2544),
    [sym_metavariable] = ACTIONS(2542),
    [sym_raw_string_literal] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
  },
  [688] = {
    [sym_line_comment] = STATE(688),
    [sym_block_comment] = STATE(688),
    [ts_builtin_sym_end] = ACTIONS(2546),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_macro_rules_BANG] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_u8] = ACTIONS(2548),
    [anon_sym_i8] = ACTIONS(2548),
    [anon_sym_u16] = ACTIONS(2548),
    [anon_sym_i16] = ACTIONS(2548),
    [anon_sym_u32] = ACTIONS(2548),
    [anon_sym_i32] = ACTIONS(2548),
    [anon_sym_u64] = ACTIONS(2548),
    [anon_sym_i64] = ACTIONS(2548),
    [anon_sym_u128] = ACTIONS(2548),
    [anon_sym_i128] = ACTIONS(2548),
    [anon_sym_isize] = ACTIONS(2548),
    [anon_sym_usize] = ACTIONS(2548),
    [anon_sym_f32] = ACTIONS(2548),
    [anon_sym_f64] = ACTIONS(2548),
    [anon_sym_bool] = ACTIONS(2548),
    [anon_sym_str] = ACTIONS(2548),
    [anon_sym_char] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2546),
    [anon_sym_POUND] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2546),
    [anon_sym_PIPE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_fn] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_impl] = ACTIONS(2548),
    [anon_sym_let] = ACTIONS(2548),
    [anon_sym_loop] = ACTIONS(2548),
    [anon_sym_match] = ACTIONS(2548),
    [anon_sym_mod] = ACTIONS(2548),
    [anon_sym_pub] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_trait] = ACTIONS(2548),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [anon_sym_unsafe] = ACTIONS(2548),
    [anon_sym_use] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym_DOT_DOT] = ACTIONS(2546),
    [anon_sym_yield] = ACTIONS(2548),
    [anon_sym_move] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [sym_integer_literal] = ACTIONS(2546),
    [aux_sym_string_literal_token1] = ACTIONS(2546),
    [sym_char_literal] = ACTIONS(2546),
    [anon_sym_true] = ACTIONS(2548),
    [anon_sym_false] = ACTIONS(2548),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2548),
    [sym_super] = ACTIONS(2548),
    [sym_crate] = ACTIONS(2548),
    [sym_metavariable] = ACTIONS(2546),
    [sym_raw_string_literal] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
  },
  [689] = {
    [sym_line_comment] = STATE(689),
    [sym_block_comment] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_macro_rules_BANG] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_u8] = ACTIONS(2552),
    [anon_sym_i8] = ACTIONS(2552),
    [anon_sym_u16] = ACTIONS(2552),
    [anon_sym_i16] = ACTIONS(2552),
    [anon_sym_u32] = ACTIONS(2552),
    [anon_sym_i32] = ACTIONS(2552),
    [anon_sym_u64] = ACTIONS(2552),
    [anon_sym_i64] = ACTIONS(2552),
    [anon_sym_u128] = ACTIONS(2552),
    [anon_sym_i128] = ACTIONS(2552),
    [anon_sym_isize] = ACTIONS(2552),
    [anon_sym_usize] = ACTIONS(2552),
    [anon_sym_f32] = ACTIONS(2552),
    [anon_sym_f64] = ACTIONS(2552),
    [anon_sym_bool] = ACTIONS(2552),
    [anon_sym_str] = ACTIONS(2552),
    [anon_sym_char] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_POUND] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_async] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_fn] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_impl] = ACTIONS(2552),
    [anon_sym_let] = ACTIONS(2552),
    [anon_sym_loop] = ACTIONS(2552),
    [anon_sym_match] = ACTIONS(2552),
    [anon_sym_mod] = ACTIONS(2552),
    [anon_sym_pub] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_trait] = ACTIONS(2552),
    [anon_sym_type] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_unsafe] = ACTIONS(2552),
    [anon_sym_use] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym_DOT_DOT] = ACTIONS(2550),
    [anon_sym_yield] = ACTIONS(2552),
    [anon_sym_move] = ACTIONS(2552),
    [anon_sym_try] = ACTIONS(2552),
    [sym_integer_literal] = ACTIONS(2550),
    [aux_sym_string_literal_token1] = ACTIONS(2550),
    [sym_char_literal] = ACTIONS(2550),
    [anon_sym_true] = ACTIONS(2552),
    [anon_sym_false] = ACTIONS(2552),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2552),
    [sym_super] = ACTIONS(2552),
    [sym_crate] = ACTIONS(2552),
    [sym_metavariable] = ACTIONS(2550),
    [sym_raw_string_literal] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
  },
  [690] = {
    [sym_line_comment] = STATE(690),
    [sym_block_comment] = STATE(690),
    [ts_builtin_sym_end] = ACTIONS(2554),
    [sym_identifier] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_macro_rules_BANG] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_u8] = ACTIONS(2556),
    [anon_sym_i8] = ACTIONS(2556),
    [anon_sym_u16] = ACTIONS(2556),
    [anon_sym_i16] = ACTIONS(2556),
    [anon_sym_u32] = ACTIONS(2556),
    [anon_sym_i32] = ACTIONS(2556),
    [anon_sym_u64] = ACTIONS(2556),
    [anon_sym_i64] = ACTIONS(2556),
    [anon_sym_u128] = ACTIONS(2556),
    [anon_sym_i128] = ACTIONS(2556),
    [anon_sym_isize] = ACTIONS(2556),
    [anon_sym_usize] = ACTIONS(2556),
    [anon_sym_f32] = ACTIONS(2556),
    [anon_sym_f64] = ACTIONS(2556),
    [anon_sym_bool] = ACTIONS(2556),
    [anon_sym_str] = ACTIONS(2556),
    [anon_sym_char] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_POUND] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [anon_sym_async] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_fn] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_impl] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_loop] = ACTIONS(2556),
    [anon_sym_match] = ACTIONS(2556),
    [anon_sym_mod] = ACTIONS(2556),
    [anon_sym_pub] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_trait] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_unsafe] = ACTIONS(2556),
    [anon_sym_use] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym_DOT_DOT] = ACTIONS(2554),
    [anon_sym_yield] = ACTIONS(2556),
    [anon_sym_move] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [sym_integer_literal] = ACTIONS(2554),
    [aux_sym_string_literal_token1] = ACTIONS(2554),
    [sym_char_literal] = ACTIONS(2554),
    [anon_sym_true] = ACTIONS(2556),
    [anon_sym_false] = ACTIONS(2556),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2556),
    [sym_super] = ACTIONS(2556),
    [sym_crate] = ACTIONS(2556),
    [sym_metavariable] = ACTIONS(2554),
    [sym_raw_string_literal] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
  },
  [691] = {
    [sym_line_comment] = STATE(691),
    [sym_block_comment] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(2558),
    [sym_identifier] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym_macro_rules_BANG] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_u8] = ACTIONS(2560),
    [anon_sym_i8] = ACTIONS(2560),
    [anon_sym_u16] = ACTIONS(2560),
    [anon_sym_i16] = ACTIONS(2560),
    [anon_sym_u32] = ACTIONS(2560),
    [anon_sym_i32] = ACTIONS(2560),
    [anon_sym_u64] = ACTIONS(2560),
    [anon_sym_i64] = ACTIONS(2560),
    [anon_sym_u128] = ACTIONS(2560),
    [anon_sym_i128] = ACTIONS(2560),
    [anon_sym_isize] = ACTIONS(2560),
    [anon_sym_usize] = ACTIONS(2560),
    [anon_sym_f32] = ACTIONS(2560),
    [anon_sym_f64] = ACTIONS(2560),
    [anon_sym_bool] = ACTIONS(2560),
    [anon_sym_str] = ACTIONS(2560),
    [anon_sym_char] = ACTIONS(2560),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2558),
    [anon_sym_POUND] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [anon_sym_async] = ACTIONS(2560),
    [anon_sym_break] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_continue] = ACTIONS(2560),
    [anon_sym_default] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_fn] = ACTIONS(2560),
    [anon_sym_for] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2560),
    [anon_sym_impl] = ACTIONS(2560),
    [anon_sym_let] = ACTIONS(2560),
    [anon_sym_loop] = ACTIONS(2560),
    [anon_sym_match] = ACTIONS(2560),
    [anon_sym_mod] = ACTIONS(2560),
    [anon_sym_pub] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_trait] = ACTIONS(2560),
    [anon_sym_type] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [anon_sym_unsafe] = ACTIONS(2560),
    [anon_sym_use] = ACTIONS(2560),
    [anon_sym_while] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym_DOT_DOT] = ACTIONS(2558),
    [anon_sym_yield] = ACTIONS(2560),
    [anon_sym_move] = ACTIONS(2560),
    [anon_sym_try] = ACTIONS(2560),
    [sym_integer_literal] = ACTIONS(2558),
    [aux_sym_string_literal_token1] = ACTIONS(2558),
    [sym_char_literal] = ACTIONS(2558),
    [anon_sym_true] = ACTIONS(2560),
    [anon_sym_false] = ACTIONS(2560),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2560),
    [sym_super] = ACTIONS(2560),
    [sym_crate] = ACTIONS(2560),
    [sym_metavariable] = ACTIONS(2558),
    [sym_raw_string_literal] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
  },
  [692] = {
    [sym_line_comment] = STATE(692),
    [sym_block_comment] = STATE(692),
    [ts_builtin_sym_end] = ACTIONS(2562),
    [sym_identifier] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_macro_rules_BANG] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_u8] = ACTIONS(2564),
    [anon_sym_i8] = ACTIONS(2564),
    [anon_sym_u16] = ACTIONS(2564),
    [anon_sym_i16] = ACTIONS(2564),
    [anon_sym_u32] = ACTIONS(2564),
    [anon_sym_i32] = ACTIONS(2564),
    [anon_sym_u64] = ACTIONS(2564),
    [anon_sym_i64] = ACTIONS(2564),
    [anon_sym_u128] = ACTIONS(2564),
    [anon_sym_i128] = ACTIONS(2564),
    [anon_sym_isize] = ACTIONS(2564),
    [anon_sym_usize] = ACTIONS(2564),
    [anon_sym_f32] = ACTIONS(2564),
    [anon_sym_f64] = ACTIONS(2564),
    [anon_sym_bool] = ACTIONS(2564),
    [anon_sym_str] = ACTIONS(2564),
    [anon_sym_char] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_POUND] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_fn] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_impl] = ACTIONS(2564),
    [anon_sym_let] = ACTIONS(2564),
    [anon_sym_loop] = ACTIONS(2564),
    [anon_sym_match] = ACTIONS(2564),
    [anon_sym_mod] = ACTIONS(2564),
    [anon_sym_pub] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_trait] = ACTIONS(2564),
    [anon_sym_type] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [anon_sym_unsafe] = ACTIONS(2564),
    [anon_sym_use] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2564),
    [anon_sym_move] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [sym_integer_literal] = ACTIONS(2562),
    [aux_sym_string_literal_token1] = ACTIONS(2562),
    [sym_char_literal] = ACTIONS(2562),
    [anon_sym_true] = ACTIONS(2564),
    [anon_sym_false] = ACTIONS(2564),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2564),
    [sym_super] = ACTIONS(2564),
    [sym_crate] = ACTIONS(2564),
    [sym_metavariable] = ACTIONS(2562),
    [sym_raw_string_literal] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
  },
  [693] = {
    [sym_line_comment] = STATE(693),
    [sym_block_comment] = STATE(693),
    [ts_builtin_sym_end] = ACTIONS(2566),
    [sym_identifier] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_macro_rules_BANG] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2566),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_u8] = ACTIONS(2568),
    [anon_sym_i8] = ACTIONS(2568),
    [anon_sym_u16] = ACTIONS(2568),
    [anon_sym_i16] = ACTIONS(2568),
    [anon_sym_u32] = ACTIONS(2568),
    [anon_sym_i32] = ACTIONS(2568),
    [anon_sym_u64] = ACTIONS(2568),
    [anon_sym_i64] = ACTIONS(2568),
    [anon_sym_u128] = ACTIONS(2568),
    [anon_sym_i128] = ACTIONS(2568),
    [anon_sym_isize] = ACTIONS(2568),
    [anon_sym_usize] = ACTIONS(2568),
    [anon_sym_f32] = ACTIONS(2568),
    [anon_sym_f64] = ACTIONS(2568),
    [anon_sym_bool] = ACTIONS(2568),
    [anon_sym_str] = ACTIONS(2568),
    [anon_sym_char] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_POUND] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_async] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_fn] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_impl] = ACTIONS(2568),
    [anon_sym_let] = ACTIONS(2568),
    [anon_sym_loop] = ACTIONS(2568),
    [anon_sym_match] = ACTIONS(2568),
    [anon_sym_mod] = ACTIONS(2568),
    [anon_sym_pub] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_struct] = ACTIONS(2568),
    [anon_sym_trait] = ACTIONS(2568),
    [anon_sym_type] = ACTIONS(2568),
    [anon_sym_union] = ACTIONS(2568),
    [anon_sym_unsafe] = ACTIONS(2568),
    [anon_sym_use] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_extern] = ACTIONS(2568),
    [anon_sym_DOT_DOT] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2568),
    [anon_sym_move] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [sym_integer_literal] = ACTIONS(2566),
    [aux_sym_string_literal_token1] = ACTIONS(2566),
    [sym_char_literal] = ACTIONS(2566),
    [anon_sym_true] = ACTIONS(2568),
    [anon_sym_false] = ACTIONS(2568),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2568),
    [sym_super] = ACTIONS(2568),
    [sym_crate] = ACTIONS(2568),
    [sym_metavariable] = ACTIONS(2566),
    [sym_raw_string_literal] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
  },
  [694] = {
    [sym_line_comment] = STATE(694),
    [sym_block_comment] = STATE(694),
    [ts_builtin_sym_end] = ACTIONS(2570),
    [sym_identifier] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_macro_rules_BANG] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_u8] = ACTIONS(2572),
    [anon_sym_i8] = ACTIONS(2572),
    [anon_sym_u16] = ACTIONS(2572),
    [anon_sym_i16] = ACTIONS(2572),
    [anon_sym_u32] = ACTIONS(2572),
    [anon_sym_i32] = ACTIONS(2572),
    [anon_sym_u64] = ACTIONS(2572),
    [anon_sym_i64] = ACTIONS(2572),
    [anon_sym_u128] = ACTIONS(2572),
    [anon_sym_i128] = ACTIONS(2572),
    [anon_sym_isize] = ACTIONS(2572),
    [anon_sym_usize] = ACTIONS(2572),
    [anon_sym_f32] = ACTIONS(2572),
    [anon_sym_f64] = ACTIONS(2572),
    [anon_sym_bool] = ACTIONS(2572),
    [anon_sym_str] = ACTIONS(2572),
    [anon_sym_char] = ACTIONS(2572),
    [anon_sym_DASH] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_POUND] = ACTIONS(2570),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_fn] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_impl] = ACTIONS(2572),
    [anon_sym_let] = ACTIONS(2572),
    [anon_sym_loop] = ACTIONS(2572),
    [anon_sym_match] = ACTIONS(2572),
    [anon_sym_mod] = ACTIONS(2572),
    [anon_sym_pub] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_trait] = ACTIONS(2572),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [anon_sym_unsafe] = ACTIONS(2572),
    [anon_sym_use] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_yield] = ACTIONS(2572),
    [anon_sym_move] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [sym_integer_literal] = ACTIONS(2570),
    [aux_sym_string_literal_token1] = ACTIONS(2570),
    [sym_char_literal] = ACTIONS(2570),
    [anon_sym_true] = ACTIONS(2572),
    [anon_sym_false] = ACTIONS(2572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2572),
    [sym_super] = ACTIONS(2572),
    [sym_crate] = ACTIONS(2572),
    [sym_metavariable] = ACTIONS(2570),
    [sym_raw_string_literal] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
  },
  [695] = {
    [sym_line_comment] = STATE(695),
    [sym_block_comment] = STATE(695),
    [ts_builtin_sym_end] = ACTIONS(2574),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_macro_rules_BANG] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_u8] = ACTIONS(2576),
    [anon_sym_i8] = ACTIONS(2576),
    [anon_sym_u16] = ACTIONS(2576),
    [anon_sym_i16] = ACTIONS(2576),
    [anon_sym_u32] = ACTIONS(2576),
    [anon_sym_i32] = ACTIONS(2576),
    [anon_sym_u64] = ACTIONS(2576),
    [anon_sym_i64] = ACTIONS(2576),
    [anon_sym_u128] = ACTIONS(2576),
    [anon_sym_i128] = ACTIONS(2576),
    [anon_sym_isize] = ACTIONS(2576),
    [anon_sym_usize] = ACTIONS(2576),
    [anon_sym_f32] = ACTIONS(2576),
    [anon_sym_f64] = ACTIONS(2576),
    [anon_sym_bool] = ACTIONS(2576),
    [anon_sym_str] = ACTIONS(2576),
    [anon_sym_char] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_POUND] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_fn] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_impl] = ACTIONS(2576),
    [anon_sym_let] = ACTIONS(2576),
    [anon_sym_loop] = ACTIONS(2576),
    [anon_sym_match] = ACTIONS(2576),
    [anon_sym_mod] = ACTIONS(2576),
    [anon_sym_pub] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_struct] = ACTIONS(2576),
    [anon_sym_trait] = ACTIONS(2576),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_union] = ACTIONS(2576),
    [anon_sym_unsafe] = ACTIONS(2576),
    [anon_sym_use] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_extern] = ACTIONS(2576),
    [anon_sym_DOT_DOT] = ACTIONS(2574),
    [anon_sym_yield] = ACTIONS(2576),
    [anon_sym_move] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [sym_integer_literal] = ACTIONS(2574),
    [aux_sym_string_literal_token1] = ACTIONS(2574),
    [sym_char_literal] = ACTIONS(2574),
    [anon_sym_true] = ACTIONS(2576),
    [anon_sym_false] = ACTIONS(2576),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2576),
    [sym_super] = ACTIONS(2576),
    [sym_crate] = ACTIONS(2576),
    [sym_metavariable] = ACTIONS(2574),
    [sym_raw_string_literal] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
  },
  [696] = {
    [sym_line_comment] = STATE(696),
    [sym_block_comment] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(2578),
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_macro_rules_BANG] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_RBRACE] = ACTIONS(2578),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_u8] = ACTIONS(2580),
    [anon_sym_i8] = ACTIONS(2580),
    [anon_sym_u16] = ACTIONS(2580),
    [anon_sym_i16] = ACTIONS(2580),
    [anon_sym_u32] = ACTIONS(2580),
    [anon_sym_i32] = ACTIONS(2580),
    [anon_sym_u64] = ACTIONS(2580),
    [anon_sym_i64] = ACTIONS(2580),
    [anon_sym_u128] = ACTIONS(2580),
    [anon_sym_i128] = ACTIONS(2580),
    [anon_sym_isize] = ACTIONS(2580),
    [anon_sym_usize] = ACTIONS(2580),
    [anon_sym_f32] = ACTIONS(2580),
    [anon_sym_f64] = ACTIONS(2580),
    [anon_sym_bool] = ACTIONS(2580),
    [anon_sym_str] = ACTIONS(2580),
    [anon_sym_char] = ACTIONS(2580),
    [anon_sym_DASH] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_POUND] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [anon_sym_async] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_fn] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_impl] = ACTIONS(2580),
    [anon_sym_let] = ACTIONS(2580),
    [anon_sym_loop] = ACTIONS(2580),
    [anon_sym_match] = ACTIONS(2580),
    [anon_sym_mod] = ACTIONS(2580),
    [anon_sym_pub] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_struct] = ACTIONS(2580),
    [anon_sym_trait] = ACTIONS(2580),
    [anon_sym_type] = ACTIONS(2580),
    [anon_sym_union] = ACTIONS(2580),
    [anon_sym_unsafe] = ACTIONS(2580),
    [anon_sym_use] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_extern] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2580),
    [anon_sym_move] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [sym_integer_literal] = ACTIONS(2578),
    [aux_sym_string_literal_token1] = ACTIONS(2578),
    [sym_char_literal] = ACTIONS(2578),
    [anon_sym_true] = ACTIONS(2580),
    [anon_sym_false] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2580),
    [sym_super] = ACTIONS(2580),
    [sym_crate] = ACTIONS(2580),
    [sym_metavariable] = ACTIONS(2578),
    [sym_raw_string_literal] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
  },
  [697] = {
    [sym_line_comment] = STATE(697),
    [sym_block_comment] = STATE(697),
    [ts_builtin_sym_end] = ACTIONS(2582),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_macro_rules_BANG] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_u8] = ACTIONS(2584),
    [anon_sym_i8] = ACTIONS(2584),
    [anon_sym_u16] = ACTIONS(2584),
    [anon_sym_i16] = ACTIONS(2584),
    [anon_sym_u32] = ACTIONS(2584),
    [anon_sym_i32] = ACTIONS(2584),
    [anon_sym_u64] = ACTIONS(2584),
    [anon_sym_i64] = ACTIONS(2584),
    [anon_sym_u128] = ACTIONS(2584),
    [anon_sym_i128] = ACTIONS(2584),
    [anon_sym_isize] = ACTIONS(2584),
    [anon_sym_usize] = ACTIONS(2584),
    [anon_sym_f32] = ACTIONS(2584),
    [anon_sym_f64] = ACTIONS(2584),
    [anon_sym_bool] = ACTIONS(2584),
    [anon_sym_str] = ACTIONS(2584),
    [anon_sym_char] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_POUND] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_fn] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_impl] = ACTIONS(2584),
    [anon_sym_let] = ACTIONS(2584),
    [anon_sym_loop] = ACTIONS(2584),
    [anon_sym_match] = ACTIONS(2584),
    [anon_sym_mod] = ACTIONS(2584),
    [anon_sym_pub] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_struct] = ACTIONS(2584),
    [anon_sym_trait] = ACTIONS(2584),
    [anon_sym_type] = ACTIONS(2584),
    [anon_sym_union] = ACTIONS(2584),
    [anon_sym_unsafe] = ACTIONS(2584),
    [anon_sym_use] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_extern] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2584),
    [anon_sym_move] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [sym_integer_literal] = ACTIONS(2582),
    [aux_sym_string_literal_token1] = ACTIONS(2582),
    [sym_char_literal] = ACTIONS(2582),
    [anon_sym_true] = ACTIONS(2584),
    [anon_sym_false] = ACTIONS(2584),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2584),
    [sym_super] = ACTIONS(2584),
    [sym_crate] = ACTIONS(2584),
    [sym_metavariable] = ACTIONS(2582),
    [sym_raw_string_literal] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
  },
  [698] = {
    [sym_line_comment] = STATE(698),
    [sym_block_comment] = STATE(698),
    [ts_builtin_sym_end] = ACTIONS(2586),
    [sym_identifier] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_macro_rules_BANG] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_u8] = ACTIONS(2588),
    [anon_sym_i8] = ACTIONS(2588),
    [anon_sym_u16] = ACTIONS(2588),
    [anon_sym_i16] = ACTIONS(2588),
    [anon_sym_u32] = ACTIONS(2588),
    [anon_sym_i32] = ACTIONS(2588),
    [anon_sym_u64] = ACTIONS(2588),
    [anon_sym_i64] = ACTIONS(2588),
    [anon_sym_u128] = ACTIONS(2588),
    [anon_sym_i128] = ACTIONS(2588),
    [anon_sym_isize] = ACTIONS(2588),
    [anon_sym_usize] = ACTIONS(2588),
    [anon_sym_f32] = ACTIONS(2588),
    [anon_sym_f64] = ACTIONS(2588),
    [anon_sym_bool] = ACTIONS(2588),
    [anon_sym_str] = ACTIONS(2588),
    [anon_sym_char] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_POUND] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [anon_sym_async] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_fn] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_impl] = ACTIONS(2588),
    [anon_sym_let] = ACTIONS(2588),
    [anon_sym_loop] = ACTIONS(2588),
    [anon_sym_match] = ACTIONS(2588),
    [anon_sym_mod] = ACTIONS(2588),
    [anon_sym_pub] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_struct] = ACTIONS(2588),
    [anon_sym_trait] = ACTIONS(2588),
    [anon_sym_type] = ACTIONS(2588),
    [anon_sym_union] = ACTIONS(2588),
    [anon_sym_unsafe] = ACTIONS(2588),
    [anon_sym_use] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2588),
    [anon_sym_move] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [sym_integer_literal] = ACTIONS(2586),
    [aux_sym_string_literal_token1] = ACTIONS(2586),
    [sym_char_literal] = ACTIONS(2586),
    [anon_sym_true] = ACTIONS(2588),
    [anon_sym_false] = ACTIONS(2588),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2588),
    [sym_super] = ACTIONS(2588),
    [sym_crate] = ACTIONS(2588),
    [sym_metavariable] = ACTIONS(2586),
    [sym_raw_string_literal] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
  },
  [699] = {
    [sym_line_comment] = STATE(699),
    [sym_block_comment] = STATE(699),
    [ts_builtin_sym_end] = ACTIONS(2590),
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_macro_rules_BANG] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_u8] = ACTIONS(2592),
    [anon_sym_i8] = ACTIONS(2592),
    [anon_sym_u16] = ACTIONS(2592),
    [anon_sym_i16] = ACTIONS(2592),
    [anon_sym_u32] = ACTIONS(2592),
    [anon_sym_i32] = ACTIONS(2592),
    [anon_sym_u64] = ACTIONS(2592),
    [anon_sym_i64] = ACTIONS(2592),
    [anon_sym_u128] = ACTIONS(2592),
    [anon_sym_i128] = ACTIONS(2592),
    [anon_sym_isize] = ACTIONS(2592),
    [anon_sym_usize] = ACTIONS(2592),
    [anon_sym_f32] = ACTIONS(2592),
    [anon_sym_f64] = ACTIONS(2592),
    [anon_sym_bool] = ACTIONS(2592),
    [anon_sym_str] = ACTIONS(2592),
    [anon_sym_char] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [anon_sym_fn] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_impl] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_loop] = ACTIONS(2592),
    [anon_sym_match] = ACTIONS(2592),
    [anon_sym_mod] = ACTIONS(2592),
    [anon_sym_pub] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_trait] = ACTIONS(2592),
    [anon_sym_type] = ACTIONS(2592),
    [anon_sym_union] = ACTIONS(2592),
    [anon_sym_unsafe] = ACTIONS(2592),
    [anon_sym_use] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_extern] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2592),
    [anon_sym_move] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [sym_integer_literal] = ACTIONS(2590),
    [aux_sym_string_literal_token1] = ACTIONS(2590),
    [sym_char_literal] = ACTIONS(2590),
    [anon_sym_true] = ACTIONS(2592),
    [anon_sym_false] = ACTIONS(2592),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2592),
    [sym_super] = ACTIONS(2592),
    [sym_crate] = ACTIONS(2592),
    [sym_metavariable] = ACTIONS(2590),
    [sym_raw_string_literal] = ACTIONS(2590),
    [sym_float_literal] = ACTIONS(2590),
  },
  [700] = {
    [sym_line_comment] = STATE(700),
    [sym_block_comment] = STATE(700),
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_macro_rules_BANG] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_u8] = ACTIONS(2596),
    [anon_sym_i8] = ACTIONS(2596),
    [anon_sym_u16] = ACTIONS(2596),
    [anon_sym_i16] = ACTIONS(2596),
    [anon_sym_u32] = ACTIONS(2596),
    [anon_sym_i32] = ACTIONS(2596),
    [anon_sym_u64] = ACTIONS(2596),
    [anon_sym_i64] = ACTIONS(2596),
    [anon_sym_u128] = ACTIONS(2596),
    [anon_sym_i128] = ACTIONS(2596),
    [anon_sym_isize] = ACTIONS(2596),
    [anon_sym_usize] = ACTIONS(2596),
    [anon_sym_f32] = ACTIONS(2596),
    [anon_sym_f64] = ACTIONS(2596),
    [anon_sym_bool] = ACTIONS(2596),
    [anon_sym_str] = ACTIONS(2596),
    [anon_sym_char] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2594),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2594),
    [anon_sym_POUND] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [anon_sym_async] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_fn] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_impl] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_loop] = ACTIONS(2596),
    [anon_sym_match] = ACTIONS(2596),
    [anon_sym_mod] = ACTIONS(2596),
    [anon_sym_pub] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_trait] = ACTIONS(2596),
    [anon_sym_type] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_unsafe] = ACTIONS(2596),
    [anon_sym_use] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym_DOT_DOT] = ACTIONS(2594),
    [anon_sym_yield] = ACTIONS(2596),
    [anon_sym_move] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [sym_integer_literal] = ACTIONS(2594),
    [aux_sym_string_literal_token1] = ACTIONS(2594),
    [sym_char_literal] = ACTIONS(2594),
    [anon_sym_true] = ACTIONS(2596),
    [anon_sym_false] = ACTIONS(2596),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2596),
    [sym_super] = ACTIONS(2596),
    [sym_crate] = ACTIONS(2596),
    [sym_metavariable] = ACTIONS(2594),
    [sym_raw_string_literal] = ACTIONS(2594),
    [sym_float_literal] = ACTIONS(2594),
  },
  [701] = {
    [sym_line_comment] = STATE(701),
    [sym_block_comment] = STATE(701),
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_macro_rules_BANG] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_u8] = ACTIONS(2600),
    [anon_sym_i8] = ACTIONS(2600),
    [anon_sym_u16] = ACTIONS(2600),
    [anon_sym_i16] = ACTIONS(2600),
    [anon_sym_u32] = ACTIONS(2600),
    [anon_sym_i32] = ACTIONS(2600),
    [anon_sym_u64] = ACTIONS(2600),
    [anon_sym_i64] = ACTIONS(2600),
    [anon_sym_u128] = ACTIONS(2600),
    [anon_sym_i128] = ACTIONS(2600),
    [anon_sym_isize] = ACTIONS(2600),
    [anon_sym_usize] = ACTIONS(2600),
    [anon_sym_f32] = ACTIONS(2600),
    [anon_sym_f64] = ACTIONS(2600),
    [anon_sym_bool] = ACTIONS(2600),
    [anon_sym_str] = ACTIONS(2600),
    [anon_sym_char] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2598),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2598),
    [anon_sym_POUND] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_fn] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_impl] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_loop] = ACTIONS(2600),
    [anon_sym_match] = ACTIONS(2600),
    [anon_sym_mod] = ACTIONS(2600),
    [anon_sym_pub] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_trait] = ACTIONS(2600),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_union] = ACTIONS(2600),
    [anon_sym_unsafe] = ACTIONS(2600),
    [anon_sym_use] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_extern] = ACTIONS(2600),
    [anon_sym_DOT_DOT] = ACTIONS(2598),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_move] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [sym_integer_literal] = ACTIONS(2598),
    [aux_sym_string_literal_token1] = ACTIONS(2598),
    [sym_char_literal] = ACTIONS(2598),
    [anon_sym_true] = ACTIONS(2600),
    [anon_sym_false] = ACTIONS(2600),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_crate] = ACTIONS(2600),
    [sym_metavariable] = ACTIONS(2598),
    [sym_raw_string_literal] = ACTIONS(2598),
    [sym_float_literal] = ACTIONS(2598),
  },
  [702] = {
    [sym_line_comment] = STATE(702),
    [sym_block_comment] = STATE(702),
    [ts_builtin_sym_end] = ACTIONS(2602),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_macro_rules_BANG] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_u8] = ACTIONS(2604),
    [anon_sym_i8] = ACTIONS(2604),
    [anon_sym_u16] = ACTIONS(2604),
    [anon_sym_i16] = ACTIONS(2604),
    [anon_sym_u32] = ACTIONS(2604),
    [anon_sym_i32] = ACTIONS(2604),
    [anon_sym_u64] = ACTIONS(2604),
    [anon_sym_i64] = ACTIONS(2604),
    [anon_sym_u128] = ACTIONS(2604),
    [anon_sym_i128] = ACTIONS(2604),
    [anon_sym_isize] = ACTIONS(2604),
    [anon_sym_usize] = ACTIONS(2604),
    [anon_sym_f32] = ACTIONS(2604),
    [anon_sym_f64] = ACTIONS(2604),
    [anon_sym_bool] = ACTIONS(2604),
    [anon_sym_str] = ACTIONS(2604),
    [anon_sym_char] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_POUND] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_fn] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_impl] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_loop] = ACTIONS(2604),
    [anon_sym_match] = ACTIONS(2604),
    [anon_sym_mod] = ACTIONS(2604),
    [anon_sym_pub] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_trait] = ACTIONS(2604),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_unsafe] = ACTIONS(2604),
    [anon_sym_use] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym_DOT_DOT] = ACTIONS(2602),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_move] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [sym_integer_literal] = ACTIONS(2602),
    [aux_sym_string_literal_token1] = ACTIONS(2602),
    [sym_char_literal] = ACTIONS(2602),
    [anon_sym_true] = ACTIONS(2604),
    [anon_sym_false] = ACTIONS(2604),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_crate] = ACTIONS(2604),
    [sym_metavariable] = ACTIONS(2602),
    [sym_raw_string_literal] = ACTIONS(2602),
    [sym_float_literal] = ACTIONS(2602),
  },
  [703] = {
    [sym_line_comment] = STATE(703),
    [sym_block_comment] = STATE(703),
    [ts_builtin_sym_end] = ACTIONS(2606),
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_macro_rules_BANG] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_u8] = ACTIONS(2608),
    [anon_sym_i8] = ACTIONS(2608),
    [anon_sym_u16] = ACTIONS(2608),
    [anon_sym_i16] = ACTIONS(2608),
    [anon_sym_u32] = ACTIONS(2608),
    [anon_sym_i32] = ACTIONS(2608),
    [anon_sym_u64] = ACTIONS(2608),
    [anon_sym_i64] = ACTIONS(2608),
    [anon_sym_u128] = ACTIONS(2608),
    [anon_sym_i128] = ACTIONS(2608),
    [anon_sym_isize] = ACTIONS(2608),
    [anon_sym_usize] = ACTIONS(2608),
    [anon_sym_f32] = ACTIONS(2608),
    [anon_sym_f64] = ACTIONS(2608),
    [anon_sym_bool] = ACTIONS(2608),
    [anon_sym_str] = ACTIONS(2608),
    [anon_sym_char] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_POUND] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_PIPE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_fn] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_impl] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_loop] = ACTIONS(2608),
    [anon_sym_match] = ACTIONS(2608),
    [anon_sym_mod] = ACTIONS(2608),
    [anon_sym_pub] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_struct] = ACTIONS(2608),
    [anon_sym_trait] = ACTIONS(2608),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_union] = ACTIONS(2608),
    [anon_sym_unsafe] = ACTIONS(2608),
    [anon_sym_use] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_extern] = ACTIONS(2608),
    [anon_sym_DOT_DOT] = ACTIONS(2606),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_move] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [sym_integer_literal] = ACTIONS(2606),
    [aux_sym_string_literal_token1] = ACTIONS(2606),
    [sym_char_literal] = ACTIONS(2606),
    [anon_sym_true] = ACTIONS(2608),
    [anon_sym_false] = ACTIONS(2608),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_crate] = ACTIONS(2608),
    [sym_metavariable] = ACTIONS(2606),
    [sym_raw_string_literal] = ACTIONS(2606),
    [sym_float_literal] = ACTIONS(2606),
  },
  [704] = {
    [sym_line_comment] = STATE(704),
    [sym_block_comment] = STATE(704),
    [ts_builtin_sym_end] = ACTIONS(2610),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_macro_rules_BANG] = ACTIONS(2610),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_u8] = ACTIONS(2612),
    [anon_sym_i8] = ACTIONS(2612),
    [anon_sym_u16] = ACTIONS(2612),
    [anon_sym_i16] = ACTIONS(2612),
    [anon_sym_u32] = ACTIONS(2612),
    [anon_sym_i32] = ACTIONS(2612),
    [anon_sym_u64] = ACTIONS(2612),
    [anon_sym_i64] = ACTIONS(2612),
    [anon_sym_u128] = ACTIONS(2612),
    [anon_sym_i128] = ACTIONS(2612),
    [anon_sym_isize] = ACTIONS(2612),
    [anon_sym_usize] = ACTIONS(2612),
    [anon_sym_f32] = ACTIONS(2612),
    [anon_sym_f64] = ACTIONS(2612),
    [anon_sym_bool] = ACTIONS(2612),
    [anon_sym_str] = ACTIONS(2612),
    [anon_sym_char] = ACTIONS(2612),
    [anon_sym_DASH] = ACTIONS(2610),
    [anon_sym_COLON_COLON] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_POUND] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2612),
    [anon_sym_async] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_continue] = ACTIONS(2612),
    [anon_sym_default] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_fn] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_impl] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_loop] = ACTIONS(2612),
    [anon_sym_match] = ACTIONS(2612),
    [anon_sym_mod] = ACTIONS(2612),
    [anon_sym_pub] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_trait] = ACTIONS(2612),
    [anon_sym_type] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [anon_sym_unsafe] = ACTIONS(2612),
    [anon_sym_use] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym_DOT_DOT] = ACTIONS(2610),
    [anon_sym_yield] = ACTIONS(2612),
    [anon_sym_move] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [sym_integer_literal] = ACTIONS(2610),
    [aux_sym_string_literal_token1] = ACTIONS(2610),
    [sym_char_literal] = ACTIONS(2610),
    [anon_sym_true] = ACTIONS(2612),
    [anon_sym_false] = ACTIONS(2612),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2612),
    [sym_super] = ACTIONS(2612),
    [sym_crate] = ACTIONS(2612),
    [sym_metavariable] = ACTIONS(2610),
    [sym_raw_string_literal] = ACTIONS(2610),
    [sym_float_literal] = ACTIONS(2610),
  },
  [705] = {
    [sym_line_comment] = STATE(705),
    [sym_block_comment] = STATE(705),
    [ts_builtin_sym_end] = ACTIONS(2614),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_macro_rules_BANG] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(2614),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_u8] = ACTIONS(2616),
    [anon_sym_i8] = ACTIONS(2616),
    [anon_sym_u16] = ACTIONS(2616),
    [anon_sym_i16] = ACTIONS(2616),
    [anon_sym_u32] = ACTIONS(2616),
    [anon_sym_i32] = ACTIONS(2616),
    [anon_sym_u64] = ACTIONS(2616),
    [anon_sym_i64] = ACTIONS(2616),
    [anon_sym_u128] = ACTIONS(2616),
    [anon_sym_i128] = ACTIONS(2616),
    [anon_sym_isize] = ACTIONS(2616),
    [anon_sym_usize] = ACTIONS(2616),
    [anon_sym_f32] = ACTIONS(2616),
    [anon_sym_f64] = ACTIONS(2616),
    [anon_sym_bool] = ACTIONS(2616),
    [anon_sym_str] = ACTIONS(2616),
    [anon_sym_char] = ACTIONS(2616),
    [anon_sym_DASH] = ACTIONS(2614),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_POUND] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [anon_sym_async] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_fn] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_impl] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_loop] = ACTIONS(2616),
    [anon_sym_match] = ACTIONS(2616),
    [anon_sym_mod] = ACTIONS(2616),
    [anon_sym_pub] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_trait] = ACTIONS(2616),
    [anon_sym_type] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_unsafe] = ACTIONS(2616),
    [anon_sym_use] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym_DOT_DOT] = ACTIONS(2614),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_move] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [sym_integer_literal] = ACTIONS(2614),
    [aux_sym_string_literal_token1] = ACTIONS(2614),
    [sym_char_literal] = ACTIONS(2614),
    [anon_sym_true] = ACTIONS(2616),
    [anon_sym_false] = ACTIONS(2616),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_crate] = ACTIONS(2616),
    [sym_metavariable] = ACTIONS(2614),
    [sym_raw_string_literal] = ACTIONS(2614),
    [sym_float_literal] = ACTIONS(2614),
  },
  [706] = {
    [sym_line_comment] = STATE(706),
    [sym_block_comment] = STATE(706),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_macro_rules_BANG] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_u8] = ACTIONS(2620),
    [anon_sym_i8] = ACTIONS(2620),
    [anon_sym_u16] = ACTIONS(2620),
    [anon_sym_i16] = ACTIONS(2620),
    [anon_sym_u32] = ACTIONS(2620),
    [anon_sym_i32] = ACTIONS(2620),
    [anon_sym_u64] = ACTIONS(2620),
    [anon_sym_i64] = ACTIONS(2620),
    [anon_sym_u128] = ACTIONS(2620),
    [anon_sym_i128] = ACTIONS(2620),
    [anon_sym_isize] = ACTIONS(2620),
    [anon_sym_usize] = ACTIONS(2620),
    [anon_sym_f32] = ACTIONS(2620),
    [anon_sym_f64] = ACTIONS(2620),
    [anon_sym_bool] = ACTIONS(2620),
    [anon_sym_str] = ACTIONS(2620),
    [anon_sym_char] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_POUND] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [anon_sym_async] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_fn] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_impl] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_loop] = ACTIONS(2620),
    [anon_sym_match] = ACTIONS(2620),
    [anon_sym_mod] = ACTIONS(2620),
    [anon_sym_pub] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_trait] = ACTIONS(2620),
    [anon_sym_type] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [anon_sym_unsafe] = ACTIONS(2620),
    [anon_sym_use] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym_DOT_DOT] = ACTIONS(2618),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_move] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [sym_integer_literal] = ACTIONS(2618),
    [aux_sym_string_literal_token1] = ACTIONS(2618),
    [sym_char_literal] = ACTIONS(2618),
    [anon_sym_true] = ACTIONS(2620),
    [anon_sym_false] = ACTIONS(2620),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_crate] = ACTIONS(2620),
    [sym_metavariable] = ACTIONS(2618),
    [sym_raw_string_literal] = ACTIONS(2618),
    [sym_float_literal] = ACTIONS(2618),
  },
  [707] = {
    [sym_line_comment] = STATE(707),
    [sym_block_comment] = STATE(707),
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_macro_rules_BANG] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_u8] = ACTIONS(2624),
    [anon_sym_i8] = ACTIONS(2624),
    [anon_sym_u16] = ACTIONS(2624),
    [anon_sym_i16] = ACTIONS(2624),
    [anon_sym_u32] = ACTIONS(2624),
    [anon_sym_i32] = ACTIONS(2624),
    [anon_sym_u64] = ACTIONS(2624),
    [anon_sym_i64] = ACTIONS(2624),
    [anon_sym_u128] = ACTIONS(2624),
    [anon_sym_i128] = ACTIONS(2624),
    [anon_sym_isize] = ACTIONS(2624),
    [anon_sym_usize] = ACTIONS(2624),
    [anon_sym_f32] = ACTIONS(2624),
    [anon_sym_f64] = ACTIONS(2624),
    [anon_sym_bool] = ACTIONS(2624),
    [anon_sym_str] = ACTIONS(2624),
    [anon_sym_char] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_POUND] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [anon_sym_async] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_fn] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_impl] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_loop] = ACTIONS(2624),
    [anon_sym_match] = ACTIONS(2624),
    [anon_sym_mod] = ACTIONS(2624),
    [anon_sym_pub] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_trait] = ACTIONS(2624),
    [anon_sym_type] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [anon_sym_unsafe] = ACTIONS(2624),
    [anon_sym_use] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_move] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [sym_integer_literal] = ACTIONS(2622),
    [aux_sym_string_literal_token1] = ACTIONS(2622),
    [sym_char_literal] = ACTIONS(2622),
    [anon_sym_true] = ACTIONS(2624),
    [anon_sym_false] = ACTIONS(2624),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_crate] = ACTIONS(2624),
    [sym_metavariable] = ACTIONS(2622),
    [sym_raw_string_literal] = ACTIONS(2622),
    [sym_float_literal] = ACTIONS(2622),
  },
  [708] = {
    [sym_line_comment] = STATE(708),
    [sym_block_comment] = STATE(708),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_macro_rules_BANG] = ACTIONS(2626),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_u8] = ACTIONS(2628),
    [anon_sym_i8] = ACTIONS(2628),
    [anon_sym_u16] = ACTIONS(2628),
    [anon_sym_i16] = ACTIONS(2628),
    [anon_sym_u32] = ACTIONS(2628),
    [anon_sym_i32] = ACTIONS(2628),
    [anon_sym_u64] = ACTIONS(2628),
    [anon_sym_i64] = ACTIONS(2628),
    [anon_sym_u128] = ACTIONS(2628),
    [anon_sym_i128] = ACTIONS(2628),
    [anon_sym_isize] = ACTIONS(2628),
    [anon_sym_usize] = ACTIONS(2628),
    [anon_sym_f32] = ACTIONS(2628),
    [anon_sym_f64] = ACTIONS(2628),
    [anon_sym_bool] = ACTIONS(2628),
    [anon_sym_str] = ACTIONS(2628),
    [anon_sym_char] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_POUND] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_fn] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_impl] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_loop] = ACTIONS(2628),
    [anon_sym_match] = ACTIONS(2628),
    [anon_sym_mod] = ACTIONS(2628),
    [anon_sym_pub] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_trait] = ACTIONS(2628),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [anon_sym_unsafe] = ACTIONS(2628),
    [anon_sym_use] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym_DOT_DOT] = ACTIONS(2626),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_move] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [sym_integer_literal] = ACTIONS(2626),
    [aux_sym_string_literal_token1] = ACTIONS(2626),
    [sym_char_literal] = ACTIONS(2626),
    [anon_sym_true] = ACTIONS(2628),
    [anon_sym_false] = ACTIONS(2628),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_crate] = ACTIONS(2628),
    [sym_metavariable] = ACTIONS(2626),
    [sym_raw_string_literal] = ACTIONS(2626),
    [sym_float_literal] = ACTIONS(2626),
  },
  [709] = {
    [sym_line_comment] = STATE(709),
    [sym_block_comment] = STATE(709),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_macro_rules_BANG] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_u8] = ACTIONS(2632),
    [anon_sym_i8] = ACTIONS(2632),
    [anon_sym_u16] = ACTIONS(2632),
    [anon_sym_i16] = ACTIONS(2632),
    [anon_sym_u32] = ACTIONS(2632),
    [anon_sym_i32] = ACTIONS(2632),
    [anon_sym_u64] = ACTIONS(2632),
    [anon_sym_i64] = ACTIONS(2632),
    [anon_sym_u128] = ACTIONS(2632),
    [anon_sym_i128] = ACTIONS(2632),
    [anon_sym_isize] = ACTIONS(2632),
    [anon_sym_usize] = ACTIONS(2632),
    [anon_sym_f32] = ACTIONS(2632),
    [anon_sym_f64] = ACTIONS(2632),
    [anon_sym_bool] = ACTIONS(2632),
    [anon_sym_str] = ACTIONS(2632),
    [anon_sym_char] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2630),
    [anon_sym_POUND] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [anon_sym_async] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_fn] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_impl] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_loop] = ACTIONS(2632),
    [anon_sym_match] = ACTIONS(2632),
    [anon_sym_mod] = ACTIONS(2632),
    [anon_sym_pub] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_trait] = ACTIONS(2632),
    [anon_sym_type] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [anon_sym_unsafe] = ACTIONS(2632),
    [anon_sym_use] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym_DOT_DOT] = ACTIONS(2630),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_move] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [sym_integer_literal] = ACTIONS(2630),
    [aux_sym_string_literal_token1] = ACTIONS(2630),
    [sym_char_literal] = ACTIONS(2630),
    [anon_sym_true] = ACTIONS(2632),
    [anon_sym_false] = ACTIONS(2632),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_crate] = ACTIONS(2632),
    [sym_metavariable] = ACTIONS(2630),
    [sym_raw_string_literal] = ACTIONS(2630),
    [sym_float_literal] = ACTIONS(2630),
  },
  [710] = {
    [sym_line_comment] = STATE(710),
    [sym_block_comment] = STATE(710),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_macro_rules_BANG] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_u8] = ACTIONS(2636),
    [anon_sym_i8] = ACTIONS(2636),
    [anon_sym_u16] = ACTIONS(2636),
    [anon_sym_i16] = ACTIONS(2636),
    [anon_sym_u32] = ACTIONS(2636),
    [anon_sym_i32] = ACTIONS(2636),
    [anon_sym_u64] = ACTIONS(2636),
    [anon_sym_i64] = ACTIONS(2636),
    [anon_sym_u128] = ACTIONS(2636),
    [anon_sym_i128] = ACTIONS(2636),
    [anon_sym_isize] = ACTIONS(2636),
    [anon_sym_usize] = ACTIONS(2636),
    [anon_sym_f32] = ACTIONS(2636),
    [anon_sym_f64] = ACTIONS(2636),
    [anon_sym_bool] = ACTIONS(2636),
    [anon_sym_str] = ACTIONS(2636),
    [anon_sym_char] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2634),
    [anon_sym_POUND] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_fn] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_impl] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_loop] = ACTIONS(2636),
    [anon_sym_match] = ACTIONS(2636),
    [anon_sym_mod] = ACTIONS(2636),
    [anon_sym_pub] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_trait] = ACTIONS(2636),
    [anon_sym_type] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [anon_sym_unsafe] = ACTIONS(2636),
    [anon_sym_use] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym_DOT_DOT] = ACTIONS(2634),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_move] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [sym_integer_literal] = ACTIONS(2634),
    [aux_sym_string_literal_token1] = ACTIONS(2634),
    [sym_char_literal] = ACTIONS(2634),
    [anon_sym_true] = ACTIONS(2636),
    [anon_sym_false] = ACTIONS(2636),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_crate] = ACTIONS(2636),
    [sym_metavariable] = ACTIONS(2634),
    [sym_raw_string_literal] = ACTIONS(2634),
    [sym_float_literal] = ACTIONS(2634),
  },
  [711] = {
    [sym_line_comment] = STATE(711),
    [sym_block_comment] = STATE(711),
    [ts_builtin_sym_end] = ACTIONS(2638),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_macro_rules_BANG] = ACTIONS(2638),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_u8] = ACTIONS(2640),
    [anon_sym_i8] = ACTIONS(2640),
    [anon_sym_u16] = ACTIONS(2640),
    [anon_sym_i16] = ACTIONS(2640),
    [anon_sym_u32] = ACTIONS(2640),
    [anon_sym_i32] = ACTIONS(2640),
    [anon_sym_u64] = ACTIONS(2640),
    [anon_sym_i64] = ACTIONS(2640),
    [anon_sym_u128] = ACTIONS(2640),
    [anon_sym_i128] = ACTIONS(2640),
    [anon_sym_isize] = ACTIONS(2640),
    [anon_sym_usize] = ACTIONS(2640),
    [anon_sym_f32] = ACTIONS(2640),
    [anon_sym_f64] = ACTIONS(2640),
    [anon_sym_bool] = ACTIONS(2640),
    [anon_sym_str] = ACTIONS(2640),
    [anon_sym_char] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2638),
    [anon_sym_POUND] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SQUOTE] = ACTIONS(2640),
    [anon_sym_async] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_fn] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_impl] = ACTIONS(2640),
    [anon_sym_let] = ACTIONS(2640),
    [anon_sym_loop] = ACTIONS(2640),
    [anon_sym_match] = ACTIONS(2640),
    [anon_sym_mod] = ACTIONS(2640),
    [anon_sym_pub] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_struct] = ACTIONS(2640),
    [anon_sym_trait] = ACTIONS(2640),
    [anon_sym_type] = ACTIONS(2640),
    [anon_sym_union] = ACTIONS(2640),
    [anon_sym_unsafe] = ACTIONS(2640),
    [anon_sym_use] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_extern] = ACTIONS(2640),
    [anon_sym_DOT_DOT] = ACTIONS(2638),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_move] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [sym_integer_literal] = ACTIONS(2638),
    [aux_sym_string_literal_token1] = ACTIONS(2638),
    [sym_char_literal] = ACTIONS(2638),
    [anon_sym_true] = ACTIONS(2640),
    [anon_sym_false] = ACTIONS(2640),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_crate] = ACTIONS(2640),
    [sym_metavariable] = ACTIONS(2638),
    [sym_raw_string_literal] = ACTIONS(2638),
    [sym_float_literal] = ACTIONS(2638),
  },
  [712] = {
    [sym_line_comment] = STATE(712),
    [sym_block_comment] = STATE(712),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_macro_rules_BANG] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_u8] = ACTIONS(2644),
    [anon_sym_i8] = ACTIONS(2644),
    [anon_sym_u16] = ACTIONS(2644),
    [anon_sym_i16] = ACTIONS(2644),
    [anon_sym_u32] = ACTIONS(2644),
    [anon_sym_i32] = ACTIONS(2644),
    [anon_sym_u64] = ACTIONS(2644),
    [anon_sym_i64] = ACTIONS(2644),
    [anon_sym_u128] = ACTIONS(2644),
    [anon_sym_i128] = ACTIONS(2644),
    [anon_sym_isize] = ACTIONS(2644),
    [anon_sym_usize] = ACTIONS(2644),
    [anon_sym_f32] = ACTIONS(2644),
    [anon_sym_f64] = ACTIONS(2644),
    [anon_sym_bool] = ACTIONS(2644),
    [anon_sym_str] = ACTIONS(2644),
    [anon_sym_char] = ACTIONS(2644),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2642),
    [anon_sym_POUND] = ACTIONS(2642),
    [anon_sym_LT] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2644),
    [anon_sym_async] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_fn] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_impl] = ACTIONS(2644),
    [anon_sym_let] = ACTIONS(2644),
    [anon_sym_loop] = ACTIONS(2644),
    [anon_sym_match] = ACTIONS(2644),
    [anon_sym_mod] = ACTIONS(2644),
    [anon_sym_pub] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_struct] = ACTIONS(2644),
    [anon_sym_trait] = ACTIONS(2644),
    [anon_sym_type] = ACTIONS(2644),
    [anon_sym_union] = ACTIONS(2644),
    [anon_sym_unsafe] = ACTIONS(2644),
    [anon_sym_use] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_extern] = ACTIONS(2644),
    [anon_sym_DOT_DOT] = ACTIONS(2642),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_move] = ACTIONS(2644),
    [anon_sym_try] = ACTIONS(2644),
    [sym_integer_literal] = ACTIONS(2642),
    [aux_sym_string_literal_token1] = ACTIONS(2642),
    [sym_char_literal] = ACTIONS(2642),
    [anon_sym_true] = ACTIONS(2644),
    [anon_sym_false] = ACTIONS(2644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_crate] = ACTIONS(2644),
    [sym_metavariable] = ACTIONS(2642),
    [sym_raw_string_literal] = ACTIONS(2642),
    [sym_float_literal] = ACTIONS(2642),
  },
  [713] = {
    [sym_line_comment] = STATE(713),
    [sym_block_comment] = STATE(713),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_macro_rules_BANG] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_u8] = ACTIONS(2648),
    [anon_sym_i8] = ACTIONS(2648),
    [anon_sym_u16] = ACTIONS(2648),
    [anon_sym_i16] = ACTIONS(2648),
    [anon_sym_u32] = ACTIONS(2648),
    [anon_sym_i32] = ACTIONS(2648),
    [anon_sym_u64] = ACTIONS(2648),
    [anon_sym_i64] = ACTIONS(2648),
    [anon_sym_u128] = ACTIONS(2648),
    [anon_sym_i128] = ACTIONS(2648),
    [anon_sym_isize] = ACTIONS(2648),
    [anon_sym_usize] = ACTIONS(2648),
    [anon_sym_f32] = ACTIONS(2648),
    [anon_sym_f64] = ACTIONS(2648),
    [anon_sym_bool] = ACTIONS(2648),
    [anon_sym_str] = ACTIONS(2648),
    [anon_sym_char] = ACTIONS(2648),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2646),
    [anon_sym_POUND] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_async] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [anon_sym_fn] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_impl] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_loop] = ACTIONS(2648),
    [anon_sym_match] = ACTIONS(2648),
    [anon_sym_mod] = ACTIONS(2648),
    [anon_sym_pub] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_trait] = ACTIONS(2648),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_union] = ACTIONS(2648),
    [anon_sym_unsafe] = ACTIONS(2648),
    [anon_sym_use] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_extern] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2646),
    [anon_sym_yield] = ACTIONS(2648),
    [anon_sym_move] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [sym_integer_literal] = ACTIONS(2646),
    [aux_sym_string_literal_token1] = ACTIONS(2646),
    [sym_char_literal] = ACTIONS(2646),
    [anon_sym_true] = ACTIONS(2648),
    [anon_sym_false] = ACTIONS(2648),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2648),
    [sym_super] = ACTIONS(2648),
    [sym_crate] = ACTIONS(2648),
    [sym_metavariable] = ACTIONS(2646),
    [sym_raw_string_literal] = ACTIONS(2646),
    [sym_float_literal] = ACTIONS(2646),
  },
  [714] = {
    [sym_line_comment] = STATE(714),
    [sym_block_comment] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(2650),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym_macro_rules_BANG] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_u8] = ACTIONS(2652),
    [anon_sym_i8] = ACTIONS(2652),
    [anon_sym_u16] = ACTIONS(2652),
    [anon_sym_i16] = ACTIONS(2652),
    [anon_sym_u32] = ACTIONS(2652),
    [anon_sym_i32] = ACTIONS(2652),
    [anon_sym_u64] = ACTIONS(2652),
    [anon_sym_i64] = ACTIONS(2652),
    [anon_sym_u128] = ACTIONS(2652),
    [anon_sym_i128] = ACTIONS(2652),
    [anon_sym_isize] = ACTIONS(2652),
    [anon_sym_usize] = ACTIONS(2652),
    [anon_sym_f32] = ACTIONS(2652),
    [anon_sym_f64] = ACTIONS(2652),
    [anon_sym_bool] = ACTIONS(2652),
    [anon_sym_str] = ACTIONS(2652),
    [anon_sym_char] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_COLON_COLON] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2650),
    [anon_sym_POUND] = ACTIONS(2650),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_PIPE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [anon_sym_async] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_fn] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_impl] = ACTIONS(2652),
    [anon_sym_let] = ACTIONS(2652),
    [anon_sym_loop] = ACTIONS(2652),
    [anon_sym_match] = ACTIONS(2652),
    [anon_sym_mod] = ACTIONS(2652),
    [anon_sym_pub] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_trait] = ACTIONS(2652),
    [anon_sym_type] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [anon_sym_unsafe] = ACTIONS(2652),
    [anon_sym_use] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym_DOT_DOT] = ACTIONS(2650),
    [anon_sym_yield] = ACTIONS(2652),
    [anon_sym_move] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [sym_integer_literal] = ACTIONS(2650),
    [aux_sym_string_literal_token1] = ACTIONS(2650),
    [sym_char_literal] = ACTIONS(2650),
    [anon_sym_true] = ACTIONS(2652),
    [anon_sym_false] = ACTIONS(2652),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2652),
    [sym_super] = ACTIONS(2652),
    [sym_crate] = ACTIONS(2652),
    [sym_metavariable] = ACTIONS(2650),
    [sym_raw_string_literal] = ACTIONS(2650),
    [sym_float_literal] = ACTIONS(2650),
  },
  [715] = {
    [sym_line_comment] = STATE(715),
    [sym_block_comment] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_macro_rules_BANG] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_u8] = ACTIONS(2656),
    [anon_sym_i8] = ACTIONS(2656),
    [anon_sym_u16] = ACTIONS(2656),
    [anon_sym_i16] = ACTIONS(2656),
    [anon_sym_u32] = ACTIONS(2656),
    [anon_sym_i32] = ACTIONS(2656),
    [anon_sym_u64] = ACTIONS(2656),
    [anon_sym_i64] = ACTIONS(2656),
    [anon_sym_u128] = ACTIONS(2656),
    [anon_sym_i128] = ACTIONS(2656),
    [anon_sym_isize] = ACTIONS(2656),
    [anon_sym_usize] = ACTIONS(2656),
    [anon_sym_f32] = ACTIONS(2656),
    [anon_sym_f64] = ACTIONS(2656),
    [anon_sym_bool] = ACTIONS(2656),
    [anon_sym_str] = ACTIONS(2656),
    [anon_sym_char] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [anon_sym_POUND] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_fn] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_impl] = ACTIONS(2656),
    [anon_sym_let] = ACTIONS(2656),
    [anon_sym_loop] = ACTIONS(2656),
    [anon_sym_match] = ACTIONS(2656),
    [anon_sym_mod] = ACTIONS(2656),
    [anon_sym_pub] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_trait] = ACTIONS(2656),
    [anon_sym_type] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_unsafe] = ACTIONS(2656),
    [anon_sym_use] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym_DOT_DOT] = ACTIONS(2654),
    [anon_sym_yield] = ACTIONS(2656),
    [anon_sym_move] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [sym_integer_literal] = ACTIONS(2654),
    [aux_sym_string_literal_token1] = ACTIONS(2654),
    [sym_char_literal] = ACTIONS(2654),
    [anon_sym_true] = ACTIONS(2656),
    [anon_sym_false] = ACTIONS(2656),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2656),
    [sym_super] = ACTIONS(2656),
    [sym_crate] = ACTIONS(2656),
    [sym_metavariable] = ACTIONS(2654),
    [sym_raw_string_literal] = ACTIONS(2654),
    [sym_float_literal] = ACTIONS(2654),
  },
  [716] = {
    [sym_line_comment] = STATE(716),
    [sym_block_comment] = STATE(716),
    [ts_builtin_sym_end] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_macro_rules_BANG] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2658),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_u8] = ACTIONS(2660),
    [anon_sym_i8] = ACTIONS(2660),
    [anon_sym_u16] = ACTIONS(2660),
    [anon_sym_i16] = ACTIONS(2660),
    [anon_sym_u32] = ACTIONS(2660),
    [anon_sym_i32] = ACTIONS(2660),
    [anon_sym_u64] = ACTIONS(2660),
    [anon_sym_i64] = ACTIONS(2660),
    [anon_sym_u128] = ACTIONS(2660),
    [anon_sym_i128] = ACTIONS(2660),
    [anon_sym_isize] = ACTIONS(2660),
    [anon_sym_usize] = ACTIONS(2660),
    [anon_sym_f32] = ACTIONS(2660),
    [anon_sym_f64] = ACTIONS(2660),
    [anon_sym_bool] = ACTIONS(2660),
    [anon_sym_str] = ACTIONS(2660),
    [anon_sym_char] = ACTIONS(2660),
    [anon_sym_DASH] = ACTIONS(2658),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_POUND] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2660),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_fn] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_impl] = ACTIONS(2660),
    [anon_sym_let] = ACTIONS(2660),
    [anon_sym_loop] = ACTIONS(2660),
    [anon_sym_match] = ACTIONS(2660),
    [anon_sym_mod] = ACTIONS(2660),
    [anon_sym_pub] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_trait] = ACTIONS(2660),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [anon_sym_unsafe] = ACTIONS(2660),
    [anon_sym_use] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym_DOT_DOT] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_move] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [sym_integer_literal] = ACTIONS(2658),
    [aux_sym_string_literal_token1] = ACTIONS(2658),
    [sym_char_literal] = ACTIONS(2658),
    [anon_sym_true] = ACTIONS(2660),
    [anon_sym_false] = ACTIONS(2660),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2660),
    [sym_super] = ACTIONS(2660),
    [sym_crate] = ACTIONS(2660),
    [sym_metavariable] = ACTIONS(2658),
    [sym_raw_string_literal] = ACTIONS(2658),
    [sym_float_literal] = ACTIONS(2658),
  },
  [717] = {
    [sym_line_comment] = STATE(717),
    [sym_block_comment] = STATE(717),
    [ts_builtin_sym_end] = ACTIONS(2662),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_macro_rules_BANG] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2662),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_u8] = ACTIONS(2664),
    [anon_sym_i8] = ACTIONS(2664),
    [anon_sym_u16] = ACTIONS(2664),
    [anon_sym_i16] = ACTIONS(2664),
    [anon_sym_u32] = ACTIONS(2664),
    [anon_sym_i32] = ACTIONS(2664),
    [anon_sym_u64] = ACTIONS(2664),
    [anon_sym_i64] = ACTIONS(2664),
    [anon_sym_u128] = ACTIONS(2664),
    [anon_sym_i128] = ACTIONS(2664),
    [anon_sym_isize] = ACTIONS(2664),
    [anon_sym_usize] = ACTIONS(2664),
    [anon_sym_f32] = ACTIONS(2664),
    [anon_sym_f64] = ACTIONS(2664),
    [anon_sym_bool] = ACTIONS(2664),
    [anon_sym_str] = ACTIONS(2664),
    [anon_sym_char] = ACTIONS(2664),
    [anon_sym_DASH] = ACTIONS(2662),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2662),
    [anon_sym_POUND] = ACTIONS(2662),
    [anon_sym_LT] = ACTIONS(2662),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2664),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [anon_sym_fn] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_impl] = ACTIONS(2664),
    [anon_sym_let] = ACTIONS(2664),
    [anon_sym_loop] = ACTIONS(2664),
    [anon_sym_match] = ACTIONS(2664),
    [anon_sym_mod] = ACTIONS(2664),
    [anon_sym_pub] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_struct] = ACTIONS(2664),
    [anon_sym_trait] = ACTIONS(2664),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_union] = ACTIONS(2664),
    [anon_sym_unsafe] = ACTIONS(2664),
    [anon_sym_use] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_extern] = ACTIONS(2664),
    [anon_sym_DOT_DOT] = ACTIONS(2662),
    [anon_sym_yield] = ACTIONS(2664),
    [anon_sym_move] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [sym_integer_literal] = ACTIONS(2662),
    [aux_sym_string_literal_token1] = ACTIONS(2662),
    [sym_char_literal] = ACTIONS(2662),
    [anon_sym_true] = ACTIONS(2664),
    [anon_sym_false] = ACTIONS(2664),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2664),
    [sym_super] = ACTIONS(2664),
    [sym_crate] = ACTIONS(2664),
    [sym_metavariable] = ACTIONS(2662),
    [sym_raw_string_literal] = ACTIONS(2662),
    [sym_float_literal] = ACTIONS(2662),
  },
  [718] = {
    [sym_line_comment] = STATE(718),
    [sym_block_comment] = STATE(718),
    [ts_builtin_sym_end] = ACTIONS(2666),
    [sym_identifier] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_macro_rules_BANG] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2666),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_STAR] = ACTIONS(2666),
    [anon_sym_u8] = ACTIONS(2668),
    [anon_sym_i8] = ACTIONS(2668),
    [anon_sym_u16] = ACTIONS(2668),
    [anon_sym_i16] = ACTIONS(2668),
    [anon_sym_u32] = ACTIONS(2668),
    [anon_sym_i32] = ACTIONS(2668),
    [anon_sym_u64] = ACTIONS(2668),
    [anon_sym_i64] = ACTIONS(2668),
    [anon_sym_u128] = ACTIONS(2668),
    [anon_sym_i128] = ACTIONS(2668),
    [anon_sym_isize] = ACTIONS(2668),
    [anon_sym_usize] = ACTIONS(2668),
    [anon_sym_f32] = ACTIONS(2668),
    [anon_sym_f64] = ACTIONS(2668),
    [anon_sym_bool] = ACTIONS(2668),
    [anon_sym_str] = ACTIONS(2668),
    [anon_sym_char] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2666),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_AMP] = ACTIONS(2666),
    [anon_sym_POUND] = ACTIONS(2666),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_PIPE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2668),
    [anon_sym_async] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [anon_sym_fn] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_impl] = ACTIONS(2668),
    [anon_sym_let] = ACTIONS(2668),
    [anon_sym_loop] = ACTIONS(2668),
    [anon_sym_match] = ACTIONS(2668),
    [anon_sym_mod] = ACTIONS(2668),
    [anon_sym_pub] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_struct] = ACTIONS(2668),
    [anon_sym_trait] = ACTIONS(2668),
    [anon_sym_type] = ACTIONS(2668),
    [anon_sym_union] = ACTIONS(2668),
    [anon_sym_unsafe] = ACTIONS(2668),
    [anon_sym_use] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_extern] = ACTIONS(2668),
    [anon_sym_DOT_DOT] = ACTIONS(2666),
    [anon_sym_yield] = ACTIONS(2668),
    [anon_sym_move] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [sym_integer_literal] = ACTIONS(2666),
    [aux_sym_string_literal_token1] = ACTIONS(2666),
    [sym_char_literal] = ACTIONS(2666),
    [anon_sym_true] = ACTIONS(2668),
    [anon_sym_false] = ACTIONS(2668),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2668),
    [sym_super] = ACTIONS(2668),
    [sym_crate] = ACTIONS(2668),
    [sym_metavariable] = ACTIONS(2666),
    [sym_raw_string_literal] = ACTIONS(2666),
    [sym_float_literal] = ACTIONS(2666),
  },
  [719] = {
    [sym_line_comment] = STATE(719),
    [sym_block_comment] = STATE(719),
    [ts_builtin_sym_end] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_macro_rules_BANG] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_STAR] = ACTIONS(2670),
    [anon_sym_u8] = ACTIONS(2672),
    [anon_sym_i8] = ACTIONS(2672),
    [anon_sym_u16] = ACTIONS(2672),
    [anon_sym_i16] = ACTIONS(2672),
    [anon_sym_u32] = ACTIONS(2672),
    [anon_sym_i32] = ACTIONS(2672),
    [anon_sym_u64] = ACTIONS(2672),
    [anon_sym_i64] = ACTIONS(2672),
    [anon_sym_u128] = ACTIONS(2672),
    [anon_sym_i128] = ACTIONS(2672),
    [anon_sym_isize] = ACTIONS(2672),
    [anon_sym_usize] = ACTIONS(2672),
    [anon_sym_f32] = ACTIONS(2672),
    [anon_sym_f64] = ACTIONS(2672),
    [anon_sym_bool] = ACTIONS(2672),
    [anon_sym_str] = ACTIONS(2672),
    [anon_sym_char] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2670),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2670),
    [anon_sym_POUND] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_PIPE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [anon_sym_async] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [anon_sym_fn] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_impl] = ACTIONS(2672),
    [anon_sym_let] = ACTIONS(2672),
    [anon_sym_loop] = ACTIONS(2672),
    [anon_sym_match] = ACTIONS(2672),
    [anon_sym_mod] = ACTIONS(2672),
    [anon_sym_pub] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_trait] = ACTIONS(2672),
    [anon_sym_type] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2672),
    [anon_sym_unsafe] = ACTIONS(2672),
    [anon_sym_use] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_extern] = ACTIONS(2672),
    [anon_sym_DOT_DOT] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_move] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [sym_integer_literal] = ACTIONS(2670),
    [aux_sym_string_literal_token1] = ACTIONS(2670),
    [sym_char_literal] = ACTIONS(2670),
    [anon_sym_true] = ACTIONS(2672),
    [anon_sym_false] = ACTIONS(2672),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2672),
    [sym_super] = ACTIONS(2672),
    [sym_crate] = ACTIONS(2672),
    [sym_metavariable] = ACTIONS(2670),
    [sym_raw_string_literal] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
  },
  [720] = {
    [sym_line_comment] = STATE(720),
    [sym_block_comment] = STATE(720),
    [ts_builtin_sym_end] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_macro_rules_BANG] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_STAR] = ACTIONS(2674),
    [anon_sym_u8] = ACTIONS(2676),
    [anon_sym_i8] = ACTIONS(2676),
    [anon_sym_u16] = ACTIONS(2676),
    [anon_sym_i16] = ACTIONS(2676),
    [anon_sym_u32] = ACTIONS(2676),
    [anon_sym_i32] = ACTIONS(2676),
    [anon_sym_u64] = ACTIONS(2676),
    [anon_sym_i64] = ACTIONS(2676),
    [anon_sym_u128] = ACTIONS(2676),
    [anon_sym_i128] = ACTIONS(2676),
    [anon_sym_isize] = ACTIONS(2676),
    [anon_sym_usize] = ACTIONS(2676),
    [anon_sym_f32] = ACTIONS(2676),
    [anon_sym_f64] = ACTIONS(2676),
    [anon_sym_bool] = ACTIONS(2676),
    [anon_sym_str] = ACTIONS(2676),
    [anon_sym_char] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2674),
    [anon_sym_POUND] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_PIPE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_fn] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_impl] = ACTIONS(2676),
    [anon_sym_let] = ACTIONS(2676),
    [anon_sym_loop] = ACTIONS(2676),
    [anon_sym_match] = ACTIONS(2676),
    [anon_sym_mod] = ACTIONS(2676),
    [anon_sym_pub] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_trait] = ACTIONS(2676),
    [anon_sym_type] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_unsafe] = ACTIONS(2676),
    [anon_sym_use] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym_DOT_DOT] = ACTIONS(2674),
    [anon_sym_yield] = ACTIONS(2676),
    [anon_sym_move] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [sym_integer_literal] = ACTIONS(2674),
    [aux_sym_string_literal_token1] = ACTIONS(2674),
    [sym_char_literal] = ACTIONS(2674),
    [anon_sym_true] = ACTIONS(2676),
    [anon_sym_false] = ACTIONS(2676),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2676),
    [sym_super] = ACTIONS(2676),
    [sym_crate] = ACTIONS(2676),
    [sym_metavariable] = ACTIONS(2674),
    [sym_raw_string_literal] = ACTIONS(2674),
    [sym_float_literal] = ACTIONS(2674),
  },
  [721] = {
    [sym_line_comment] = STATE(721),
    [sym_block_comment] = STATE(721),
    [ts_builtin_sym_end] = ACTIONS(2678),
    [sym_identifier] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_macro_rules_BANG] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_u8] = ACTIONS(2680),
    [anon_sym_i8] = ACTIONS(2680),
    [anon_sym_u16] = ACTIONS(2680),
    [anon_sym_i16] = ACTIONS(2680),
    [anon_sym_u32] = ACTIONS(2680),
    [anon_sym_i32] = ACTIONS(2680),
    [anon_sym_u64] = ACTIONS(2680),
    [anon_sym_i64] = ACTIONS(2680),
    [anon_sym_u128] = ACTIONS(2680),
    [anon_sym_i128] = ACTIONS(2680),
    [anon_sym_isize] = ACTIONS(2680),
    [anon_sym_usize] = ACTIONS(2680),
    [anon_sym_f32] = ACTIONS(2680),
    [anon_sym_f64] = ACTIONS(2680),
    [anon_sym_bool] = ACTIONS(2680),
    [anon_sym_str] = ACTIONS(2680),
    [anon_sym_char] = ACTIONS(2680),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2678),
    [anon_sym_POUND] = ACTIONS(2678),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_break] = ACTIONS(2680),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_continue] = ACTIONS(2680),
    [anon_sym_default] = ACTIONS(2680),
    [anon_sym_enum] = ACTIONS(2680),
    [anon_sym_fn] = ACTIONS(2680),
    [anon_sym_for] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2680),
    [anon_sym_impl] = ACTIONS(2680),
    [anon_sym_let] = ACTIONS(2680),
    [anon_sym_loop] = ACTIONS(2680),
    [anon_sym_match] = ACTIONS(2680),
    [anon_sym_mod] = ACTIONS(2680),
    [anon_sym_pub] = ACTIONS(2680),
    [anon_sym_return] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_struct] = ACTIONS(2680),
    [anon_sym_trait] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_union] = ACTIONS(2680),
    [anon_sym_unsafe] = ACTIONS(2680),
    [anon_sym_use] = ACTIONS(2680),
    [anon_sym_while] = ACTIONS(2680),
    [anon_sym_extern] = ACTIONS(2680),
    [anon_sym_DOT_DOT] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2680),
    [anon_sym_move] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(2680),
    [sym_integer_literal] = ACTIONS(2678),
    [aux_sym_string_literal_token1] = ACTIONS(2678),
    [sym_char_literal] = ACTIONS(2678),
    [anon_sym_true] = ACTIONS(2680),
    [anon_sym_false] = ACTIONS(2680),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2680),
    [sym_super] = ACTIONS(2680),
    [sym_crate] = ACTIONS(2680),
    [sym_metavariable] = ACTIONS(2678),
    [sym_raw_string_literal] = ACTIONS(2678),
    [sym_float_literal] = ACTIONS(2678),
  },
  [722] = {
    [sym_line_comment] = STATE(722),
    [sym_block_comment] = STATE(722),
    [ts_builtin_sym_end] = ACTIONS(2682),
    [sym_identifier] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_macro_rules_BANG] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2682),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_u8] = ACTIONS(2684),
    [anon_sym_i8] = ACTIONS(2684),
    [anon_sym_u16] = ACTIONS(2684),
    [anon_sym_i16] = ACTIONS(2684),
    [anon_sym_u32] = ACTIONS(2684),
    [anon_sym_i32] = ACTIONS(2684),
    [anon_sym_u64] = ACTIONS(2684),
    [anon_sym_i64] = ACTIONS(2684),
    [anon_sym_u128] = ACTIONS(2684),
    [anon_sym_i128] = ACTIONS(2684),
    [anon_sym_isize] = ACTIONS(2684),
    [anon_sym_usize] = ACTIONS(2684),
    [anon_sym_f32] = ACTIONS(2684),
    [anon_sym_f64] = ACTIONS(2684),
    [anon_sym_bool] = ACTIONS(2684),
    [anon_sym_str] = ACTIONS(2684),
    [anon_sym_char] = ACTIONS(2684),
    [anon_sym_DASH] = ACTIONS(2682),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_AMP] = ACTIONS(2682),
    [anon_sym_POUND] = ACTIONS(2682),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_fn] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_impl] = ACTIONS(2684),
    [anon_sym_let] = ACTIONS(2684),
    [anon_sym_loop] = ACTIONS(2684),
    [anon_sym_match] = ACTIONS(2684),
    [anon_sym_mod] = ACTIONS(2684),
    [anon_sym_pub] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_trait] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [anon_sym_unsafe] = ACTIONS(2684),
    [anon_sym_use] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym_DOT_DOT] = ACTIONS(2682),
    [anon_sym_yield] = ACTIONS(2684),
    [anon_sym_move] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [sym_integer_literal] = ACTIONS(2682),
    [aux_sym_string_literal_token1] = ACTIONS(2682),
    [sym_char_literal] = ACTIONS(2682),
    [anon_sym_true] = ACTIONS(2684),
    [anon_sym_false] = ACTIONS(2684),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2684),
    [sym_super] = ACTIONS(2684),
    [sym_crate] = ACTIONS(2684),
    [sym_metavariable] = ACTIONS(2682),
    [sym_raw_string_literal] = ACTIONS(2682),
    [sym_float_literal] = ACTIONS(2682),
  },
  [723] = {
    [sym_line_comment] = STATE(723),
    [sym_block_comment] = STATE(723),
    [ts_builtin_sym_end] = ACTIONS(2686),
    [sym_identifier] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_macro_rules_BANG] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_u8] = ACTIONS(2688),
    [anon_sym_i8] = ACTIONS(2688),
    [anon_sym_u16] = ACTIONS(2688),
    [anon_sym_i16] = ACTIONS(2688),
    [anon_sym_u32] = ACTIONS(2688),
    [anon_sym_i32] = ACTIONS(2688),
    [anon_sym_u64] = ACTIONS(2688),
    [anon_sym_i64] = ACTIONS(2688),
    [anon_sym_u128] = ACTIONS(2688),
    [anon_sym_i128] = ACTIONS(2688),
    [anon_sym_isize] = ACTIONS(2688),
    [anon_sym_usize] = ACTIONS(2688),
    [anon_sym_f32] = ACTIONS(2688),
    [anon_sym_f64] = ACTIONS(2688),
    [anon_sym_bool] = ACTIONS(2688),
    [anon_sym_str] = ACTIONS(2688),
    [anon_sym_char] = ACTIONS(2688),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2686),
    [anon_sym_POUND] = ACTIONS(2686),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_PIPE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [anon_sym_fn] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_impl] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(2688),
    [anon_sym_loop] = ACTIONS(2688),
    [anon_sym_match] = ACTIONS(2688),
    [anon_sym_mod] = ACTIONS(2688),
    [anon_sym_pub] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_struct] = ACTIONS(2688),
    [anon_sym_trait] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_union] = ACTIONS(2688),
    [anon_sym_unsafe] = ACTIONS(2688),
    [anon_sym_use] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_extern] = ACTIONS(2688),
    [anon_sym_DOT_DOT] = ACTIONS(2686),
    [anon_sym_yield] = ACTIONS(2688),
    [anon_sym_move] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [sym_integer_literal] = ACTIONS(2686),
    [aux_sym_string_literal_token1] = ACTIONS(2686),
    [sym_char_literal] = ACTIONS(2686),
    [anon_sym_true] = ACTIONS(2688),
    [anon_sym_false] = ACTIONS(2688),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2688),
    [sym_super] = ACTIONS(2688),
    [sym_crate] = ACTIONS(2688),
    [sym_metavariable] = ACTIONS(2686),
    [sym_raw_string_literal] = ACTIONS(2686),
    [sym_float_literal] = ACTIONS(2686),
  },
  [724] = {
    [sym_line_comment] = STATE(724),
    [sym_block_comment] = STATE(724),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_macro_rules_BANG] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_STAR] = ACTIONS(2690),
    [anon_sym_u8] = ACTIONS(2692),
    [anon_sym_i8] = ACTIONS(2692),
    [anon_sym_u16] = ACTIONS(2692),
    [anon_sym_i16] = ACTIONS(2692),
    [anon_sym_u32] = ACTIONS(2692),
    [anon_sym_i32] = ACTIONS(2692),
    [anon_sym_u64] = ACTIONS(2692),
    [anon_sym_i64] = ACTIONS(2692),
    [anon_sym_u128] = ACTIONS(2692),
    [anon_sym_i128] = ACTIONS(2692),
    [anon_sym_isize] = ACTIONS(2692),
    [anon_sym_usize] = ACTIONS(2692),
    [anon_sym_f32] = ACTIONS(2692),
    [anon_sym_f64] = ACTIONS(2692),
    [anon_sym_bool] = ACTIONS(2692),
    [anon_sym_str] = ACTIONS(2692),
    [anon_sym_char] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2690),
    [anon_sym_POUND] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_PIPE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [anon_sym_async] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_fn] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_impl] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_loop] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_mod] = ACTIONS(2692),
    [anon_sym_pub] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_trait] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [anon_sym_unsafe] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym_DOT_DOT] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_move] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [sym_integer_literal] = ACTIONS(2690),
    [aux_sym_string_literal_token1] = ACTIONS(2690),
    [sym_char_literal] = ACTIONS(2690),
    [anon_sym_true] = ACTIONS(2692),
    [anon_sym_false] = ACTIONS(2692),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2692),
    [sym_super] = ACTIONS(2692),
    [sym_crate] = ACTIONS(2692),
    [sym_metavariable] = ACTIONS(2690),
    [sym_raw_string_literal] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
  },
  [725] = {
    [sym_line_comment] = STATE(725),
    [sym_block_comment] = STATE(725),
    [ts_builtin_sym_end] = ACTIONS(2694),
    [sym_identifier] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_macro_rules_BANG] = ACTIONS(2694),
    [anon_sym_LPAREN] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_u8] = ACTIONS(2696),
    [anon_sym_i8] = ACTIONS(2696),
    [anon_sym_u16] = ACTIONS(2696),
    [anon_sym_i16] = ACTIONS(2696),
    [anon_sym_u32] = ACTIONS(2696),
    [anon_sym_i32] = ACTIONS(2696),
    [anon_sym_u64] = ACTIONS(2696),
    [anon_sym_i64] = ACTIONS(2696),
    [anon_sym_u128] = ACTIONS(2696),
    [anon_sym_i128] = ACTIONS(2696),
    [anon_sym_isize] = ACTIONS(2696),
    [anon_sym_usize] = ACTIONS(2696),
    [anon_sym_f32] = ACTIONS(2696),
    [anon_sym_f64] = ACTIONS(2696),
    [anon_sym_bool] = ACTIONS(2696),
    [anon_sym_str] = ACTIONS(2696),
    [anon_sym_char] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
    [anon_sym_POUND] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2696),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_break] = ACTIONS(2696),
    [anon_sym_const] = ACTIONS(2696),
    [anon_sym_continue] = ACTIONS(2696),
    [anon_sym_default] = ACTIONS(2696),
    [anon_sym_enum] = ACTIONS(2696),
    [anon_sym_fn] = ACTIONS(2696),
    [anon_sym_for] = ACTIONS(2696),
    [anon_sym_if] = ACTIONS(2696),
    [anon_sym_impl] = ACTIONS(2696),
    [anon_sym_let] = ACTIONS(2696),
    [anon_sym_loop] = ACTIONS(2696),
    [anon_sym_match] = ACTIONS(2696),
    [anon_sym_mod] = ACTIONS(2696),
    [anon_sym_pub] = ACTIONS(2696),
    [anon_sym_return] = ACTIONS(2696),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_struct] = ACTIONS(2696),
    [anon_sym_trait] = ACTIONS(2696),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_union] = ACTIONS(2696),
    [anon_sym_unsafe] = ACTIONS(2696),
    [anon_sym_use] = ACTIONS(2696),
    [anon_sym_while] = ACTIONS(2696),
    [anon_sym_extern] = ACTIONS(2696),
    [anon_sym_DOT_DOT] = ACTIONS(2694),
    [anon_sym_yield] = ACTIONS(2696),
    [anon_sym_move] = ACTIONS(2696),
    [anon_sym_try] = ACTIONS(2696),
    [sym_integer_literal] = ACTIONS(2694),
    [aux_sym_string_literal_token1] = ACTIONS(2694),
    [sym_char_literal] = ACTIONS(2694),
    [anon_sym_true] = ACTIONS(2696),
    [anon_sym_false] = ACTIONS(2696),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2696),
    [sym_super] = ACTIONS(2696),
    [sym_crate] = ACTIONS(2696),
    [sym_metavariable] = ACTIONS(2694),
    [sym_raw_string_literal] = ACTIONS(2694),
    [sym_float_literal] = ACTIONS(2694),
  },
  [726] = {
    [sym_line_comment] = STATE(726),
    [sym_block_comment] = STATE(726),
    [ts_builtin_sym_end] = ACTIONS(2698),
    [sym_identifier] = ACTIONS(2700),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_macro_rules_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_u8] = ACTIONS(2700),
    [anon_sym_i8] = ACTIONS(2700),
    [anon_sym_u16] = ACTIONS(2700),
    [anon_sym_i16] = ACTIONS(2700),
    [anon_sym_u32] = ACTIONS(2700),
    [anon_sym_i32] = ACTIONS(2700),
    [anon_sym_u64] = ACTIONS(2700),
    [anon_sym_i64] = ACTIONS(2700),
    [anon_sym_u128] = ACTIONS(2700),
    [anon_sym_i128] = ACTIONS(2700),
    [anon_sym_isize] = ACTIONS(2700),
    [anon_sym_usize] = ACTIONS(2700),
    [anon_sym_f32] = ACTIONS(2700),
    [anon_sym_f64] = ACTIONS(2700),
    [anon_sym_bool] = ACTIONS(2700),
    [anon_sym_str] = ACTIONS(2700),
    [anon_sym_char] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_POUND] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_break] = ACTIONS(2700),
    [anon_sym_const] = ACTIONS(2700),
    [anon_sym_continue] = ACTIONS(2700),
    [anon_sym_default] = ACTIONS(2700),
    [anon_sym_enum] = ACTIONS(2700),
    [anon_sym_fn] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2700),
    [anon_sym_if] = ACTIONS(2700),
    [anon_sym_impl] = ACTIONS(2700),
    [anon_sym_let] = ACTIONS(2700),
    [anon_sym_loop] = ACTIONS(2700),
    [anon_sym_match] = ACTIONS(2700),
    [anon_sym_mod] = ACTIONS(2700),
    [anon_sym_pub] = ACTIONS(2700),
    [anon_sym_return] = ACTIONS(2700),
    [anon_sym_static] = ACTIONS(2700),
    [anon_sym_struct] = ACTIONS(2700),
    [anon_sym_trait] = ACTIONS(2700),
    [anon_sym_type] = ACTIONS(2700),
    [anon_sym_union] = ACTIONS(2700),
    [anon_sym_unsafe] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2700),
    [anon_sym_while] = ACTIONS(2700),
    [anon_sym_extern] = ACTIONS(2700),
    [anon_sym_DOT_DOT] = ACTIONS(2698),
    [anon_sym_yield] = ACTIONS(2700),
    [anon_sym_move] = ACTIONS(2700),
    [anon_sym_try] = ACTIONS(2700),
    [sym_integer_literal] = ACTIONS(2698),
    [aux_sym_string_literal_token1] = ACTIONS(2698),
    [sym_char_literal] = ACTIONS(2698),
    [anon_sym_true] = ACTIONS(2700),
    [anon_sym_false] = ACTIONS(2700),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2700),
    [sym_super] = ACTIONS(2700),
    [sym_crate] = ACTIONS(2700),
    [sym_metavariable] = ACTIONS(2698),
    [sym_raw_string_literal] = ACTIONS(2698),
    [sym_float_literal] = ACTIONS(2698),
  },
  [727] = {
    [sym_line_comment] = STATE(727),
    [sym_block_comment] = STATE(727),
    [ts_builtin_sym_end] = ACTIONS(2702),
    [sym_identifier] = ACTIONS(2704),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_macro_rules_BANG] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2702),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2702),
    [anon_sym_u8] = ACTIONS(2704),
    [anon_sym_i8] = ACTIONS(2704),
    [anon_sym_u16] = ACTIONS(2704),
    [anon_sym_i16] = ACTIONS(2704),
    [anon_sym_u32] = ACTIONS(2704),
    [anon_sym_i32] = ACTIONS(2704),
    [anon_sym_u64] = ACTIONS(2704),
    [anon_sym_i64] = ACTIONS(2704),
    [anon_sym_u128] = ACTIONS(2704),
    [anon_sym_i128] = ACTIONS(2704),
    [anon_sym_isize] = ACTIONS(2704),
    [anon_sym_usize] = ACTIONS(2704),
    [anon_sym_f32] = ACTIONS(2704),
    [anon_sym_f64] = ACTIONS(2704),
    [anon_sym_bool] = ACTIONS(2704),
    [anon_sym_str] = ACTIONS(2704),
    [anon_sym_char] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2702),
    [anon_sym_POUND] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_PIPE] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2704),
    [anon_sym_async] = ACTIONS(2704),
    [anon_sym_break] = ACTIONS(2704),
    [anon_sym_const] = ACTIONS(2704),
    [anon_sym_continue] = ACTIONS(2704),
    [anon_sym_default] = ACTIONS(2704),
    [anon_sym_enum] = ACTIONS(2704),
    [anon_sym_fn] = ACTIONS(2704),
    [anon_sym_for] = ACTIONS(2704),
    [anon_sym_if] = ACTIONS(2704),
    [anon_sym_impl] = ACTIONS(2704),
    [anon_sym_let] = ACTIONS(2704),
    [anon_sym_loop] = ACTIONS(2704),
    [anon_sym_match] = ACTIONS(2704),
    [anon_sym_mod] = ACTIONS(2704),
    [anon_sym_pub] = ACTIONS(2704),
    [anon_sym_return] = ACTIONS(2704),
    [anon_sym_static] = ACTIONS(2704),
    [anon_sym_struct] = ACTIONS(2704),
    [anon_sym_trait] = ACTIONS(2704),
    [anon_sym_type] = ACTIONS(2704),
    [anon_sym_union] = ACTIONS(2704),
    [anon_sym_unsafe] = ACTIONS(2704),
    [anon_sym_use] = ACTIONS(2704),
    [anon_sym_while] = ACTIONS(2704),
    [anon_sym_extern] = ACTIONS(2704),
    [anon_sym_DOT_DOT] = ACTIONS(2702),
    [anon_sym_yield] = ACTIONS(2704),
    [anon_sym_move] = ACTIONS(2704),
    [anon_sym_try] = ACTIONS(2704),
    [sym_integer_literal] = ACTIONS(2702),
    [aux_sym_string_literal_token1] = ACTIONS(2702),
    [sym_char_literal] = ACTIONS(2702),
    [anon_sym_true] = ACTIONS(2704),
    [anon_sym_false] = ACTIONS(2704),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2704),
    [sym_super] = ACTIONS(2704),
    [sym_crate] = ACTIONS(2704),
    [sym_metavariable] = ACTIONS(2702),
    [sym_raw_string_literal] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
  },
  [728] = {
    [sym_line_comment] = STATE(728),
    [sym_block_comment] = STATE(728),
    [ts_builtin_sym_end] = ACTIONS(2706),
    [sym_identifier] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_macro_rules_BANG] = ACTIONS(2706),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_STAR] = ACTIONS(2706),
    [anon_sym_u8] = ACTIONS(2708),
    [anon_sym_i8] = ACTIONS(2708),
    [anon_sym_u16] = ACTIONS(2708),
    [anon_sym_i16] = ACTIONS(2708),
    [anon_sym_u32] = ACTIONS(2708),
    [anon_sym_i32] = ACTIONS(2708),
    [anon_sym_u64] = ACTIONS(2708),
    [anon_sym_i64] = ACTIONS(2708),
    [anon_sym_u128] = ACTIONS(2708),
    [anon_sym_i128] = ACTIONS(2708),
    [anon_sym_isize] = ACTIONS(2708),
    [anon_sym_usize] = ACTIONS(2708),
    [anon_sym_f32] = ACTIONS(2708),
    [anon_sym_f64] = ACTIONS(2708),
    [anon_sym_bool] = ACTIONS(2708),
    [anon_sym_str] = ACTIONS(2708),
    [anon_sym_char] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_COLON_COLON] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2706),
    [anon_sym_POUND] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_PIPE] = ACTIONS(2706),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_async] = ACTIONS(2708),
    [anon_sym_break] = ACTIONS(2708),
    [anon_sym_const] = ACTIONS(2708),
    [anon_sym_continue] = ACTIONS(2708),
    [anon_sym_default] = ACTIONS(2708),
    [anon_sym_enum] = ACTIONS(2708),
    [anon_sym_fn] = ACTIONS(2708),
    [anon_sym_for] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2708),
    [anon_sym_impl] = ACTIONS(2708),
    [anon_sym_let] = ACTIONS(2708),
    [anon_sym_loop] = ACTIONS(2708),
    [anon_sym_match] = ACTIONS(2708),
    [anon_sym_mod] = ACTIONS(2708),
    [anon_sym_pub] = ACTIONS(2708),
    [anon_sym_return] = ACTIONS(2708),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_struct] = ACTIONS(2708),
    [anon_sym_trait] = ACTIONS(2708),
    [anon_sym_type] = ACTIONS(2708),
    [anon_sym_union] = ACTIONS(2708),
    [anon_sym_unsafe] = ACTIONS(2708),
    [anon_sym_use] = ACTIONS(2708),
    [anon_sym_while] = ACTIONS(2708),
    [anon_sym_extern] = ACTIONS(2708),
    [anon_sym_DOT_DOT] = ACTIONS(2706),
    [anon_sym_yield] = ACTIONS(2708),
    [anon_sym_move] = ACTIONS(2708),
    [anon_sym_try] = ACTIONS(2708),
    [sym_integer_literal] = ACTIONS(2706),
    [aux_sym_string_literal_token1] = ACTIONS(2706),
    [sym_char_literal] = ACTIONS(2706),
    [anon_sym_true] = ACTIONS(2708),
    [anon_sym_false] = ACTIONS(2708),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2708),
    [sym_super] = ACTIONS(2708),
    [sym_crate] = ACTIONS(2708),
    [sym_metavariable] = ACTIONS(2706),
    [sym_raw_string_literal] = ACTIONS(2706),
    [sym_float_literal] = ACTIONS(2706),
  },
  [729] = {
    [sym_line_comment] = STATE(729),
    [sym_block_comment] = STATE(729),
    [ts_builtin_sym_end] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2710),
    [anon_sym_macro_rules_BANG] = ACTIONS(2710),
    [anon_sym_LPAREN] = ACTIONS(2710),
    [anon_sym_LBRACK] = ACTIONS(2710),
    [anon_sym_LBRACE] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_STAR] = ACTIONS(2710),
    [anon_sym_u8] = ACTIONS(2712),
    [anon_sym_i8] = ACTIONS(2712),
    [anon_sym_u16] = ACTIONS(2712),
    [anon_sym_i16] = ACTIONS(2712),
    [anon_sym_u32] = ACTIONS(2712),
    [anon_sym_i32] = ACTIONS(2712),
    [anon_sym_u64] = ACTIONS(2712),
    [anon_sym_i64] = ACTIONS(2712),
    [anon_sym_u128] = ACTIONS(2712),
    [anon_sym_i128] = ACTIONS(2712),
    [anon_sym_isize] = ACTIONS(2712),
    [anon_sym_usize] = ACTIONS(2712),
    [anon_sym_f32] = ACTIONS(2712),
    [anon_sym_f64] = ACTIONS(2712),
    [anon_sym_bool] = ACTIONS(2712),
    [anon_sym_str] = ACTIONS(2712),
    [anon_sym_char] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2710),
    [anon_sym_COLON_COLON] = ACTIONS(2710),
    [anon_sym_BANG] = ACTIONS(2710),
    [anon_sym_AMP] = ACTIONS(2710),
    [anon_sym_POUND] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_PIPE] = ACTIONS(2710),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [anon_sym_async] = ACTIONS(2712),
    [anon_sym_break] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_continue] = ACTIONS(2712),
    [anon_sym_default] = ACTIONS(2712),
    [anon_sym_enum] = ACTIONS(2712),
    [anon_sym_fn] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_impl] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_loop] = ACTIONS(2712),
    [anon_sym_match] = ACTIONS(2712),
    [anon_sym_mod] = ACTIONS(2712),
    [anon_sym_pub] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_static] = ACTIONS(2712),
    [anon_sym_struct] = ACTIONS(2712),
    [anon_sym_trait] = ACTIONS(2712),
    [anon_sym_type] = ACTIONS(2712),
    [anon_sym_union] = ACTIONS(2712),
    [anon_sym_unsafe] = ACTIONS(2712),
    [anon_sym_use] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [anon_sym_extern] = ACTIONS(2712),
    [anon_sym_DOT_DOT] = ACTIONS(2710),
    [anon_sym_yield] = ACTIONS(2712),
    [anon_sym_move] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [sym_integer_literal] = ACTIONS(2710),
    [aux_sym_string_literal_token1] = ACTIONS(2710),
    [sym_char_literal] = ACTIONS(2710),
    [anon_sym_true] = ACTIONS(2712),
    [anon_sym_false] = ACTIONS(2712),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2712),
    [sym_super] = ACTIONS(2712),
    [sym_crate] = ACTIONS(2712),
    [sym_metavariable] = ACTIONS(2710),
    [sym_raw_string_literal] = ACTIONS(2710),
    [sym_float_literal] = ACTIONS(2710),
  },
  [730] = {
    [sym_line_comment] = STATE(730),
    [sym_block_comment] = STATE(730),
    [ts_builtin_sym_end] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_macro_rules_BANG] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_STAR] = ACTIONS(2714),
    [anon_sym_u8] = ACTIONS(2716),
    [anon_sym_i8] = ACTIONS(2716),
    [anon_sym_u16] = ACTIONS(2716),
    [anon_sym_i16] = ACTIONS(2716),
    [anon_sym_u32] = ACTIONS(2716),
    [anon_sym_i32] = ACTIONS(2716),
    [anon_sym_u64] = ACTIONS(2716),
    [anon_sym_i64] = ACTIONS(2716),
    [anon_sym_u128] = ACTIONS(2716),
    [anon_sym_i128] = ACTIONS(2716),
    [anon_sym_isize] = ACTIONS(2716),
    [anon_sym_usize] = ACTIONS(2716),
    [anon_sym_f32] = ACTIONS(2716),
    [anon_sym_f64] = ACTIONS(2716),
    [anon_sym_bool] = ACTIONS(2716),
    [anon_sym_str] = ACTIONS(2716),
    [anon_sym_char] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_COLON_COLON] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_AMP] = ACTIONS(2714),
    [anon_sym_POUND] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(2714),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [anon_sym_fn] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_impl] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_loop] = ACTIONS(2716),
    [anon_sym_match] = ACTIONS(2716),
    [anon_sym_mod] = ACTIONS(2716),
    [anon_sym_pub] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_struct] = ACTIONS(2716),
    [anon_sym_trait] = ACTIONS(2716),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_union] = ACTIONS(2716),
    [anon_sym_unsafe] = ACTIONS(2716),
    [anon_sym_use] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_extern] = ACTIONS(2716),
    [anon_sym_DOT_DOT] = ACTIONS(2714),
    [anon_sym_yield] = ACTIONS(2716),
    [anon_sym_move] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [sym_integer_literal] = ACTIONS(2714),
    [aux_sym_string_literal_token1] = ACTIONS(2714),
    [sym_char_literal] = ACTIONS(2714),
    [anon_sym_true] = ACTIONS(2716),
    [anon_sym_false] = ACTIONS(2716),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2716),
    [sym_super] = ACTIONS(2716),
    [sym_crate] = ACTIONS(2716),
    [sym_metavariable] = ACTIONS(2714),
    [sym_raw_string_literal] = ACTIONS(2714),
    [sym_float_literal] = ACTIONS(2714),
  },
  [731] = {
    [sym_line_comment] = STATE(731),
    [sym_block_comment] = STATE(731),
    [ts_builtin_sym_end] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_macro_rules_BANG] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_LBRACE] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_u8] = ACTIONS(2720),
    [anon_sym_i8] = ACTIONS(2720),
    [anon_sym_u16] = ACTIONS(2720),
    [anon_sym_i16] = ACTIONS(2720),
    [anon_sym_u32] = ACTIONS(2720),
    [anon_sym_i32] = ACTIONS(2720),
    [anon_sym_u64] = ACTIONS(2720),
    [anon_sym_i64] = ACTIONS(2720),
    [anon_sym_u128] = ACTIONS(2720),
    [anon_sym_i128] = ACTIONS(2720),
    [anon_sym_isize] = ACTIONS(2720),
    [anon_sym_usize] = ACTIONS(2720),
    [anon_sym_f32] = ACTIONS(2720),
    [anon_sym_f64] = ACTIONS(2720),
    [anon_sym_bool] = ACTIONS(2720),
    [anon_sym_str] = ACTIONS(2720),
    [anon_sym_char] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_BANG] = ACTIONS(2718),
    [anon_sym_AMP] = ACTIONS(2718),
    [anon_sym_POUND] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_PIPE] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [anon_sym_async] = ACTIONS(2720),
    [anon_sym_break] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_continue] = ACTIONS(2720),
    [anon_sym_default] = ACTIONS(2720),
    [anon_sym_enum] = ACTIONS(2720),
    [anon_sym_fn] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_impl] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_loop] = ACTIONS(2720),
    [anon_sym_match] = ACTIONS(2720),
    [anon_sym_mod] = ACTIONS(2720),
    [anon_sym_pub] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_static] = ACTIONS(2720),
    [anon_sym_struct] = ACTIONS(2720),
    [anon_sym_trait] = ACTIONS(2720),
    [anon_sym_type] = ACTIONS(2720),
    [anon_sym_union] = ACTIONS(2720),
    [anon_sym_unsafe] = ACTIONS(2720),
    [anon_sym_use] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [anon_sym_extern] = ACTIONS(2720),
    [anon_sym_DOT_DOT] = ACTIONS(2718),
    [anon_sym_yield] = ACTIONS(2720),
    [anon_sym_move] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [sym_integer_literal] = ACTIONS(2718),
    [aux_sym_string_literal_token1] = ACTIONS(2718),
    [sym_char_literal] = ACTIONS(2718),
    [anon_sym_true] = ACTIONS(2720),
    [anon_sym_false] = ACTIONS(2720),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2720),
    [sym_super] = ACTIONS(2720),
    [sym_crate] = ACTIONS(2720),
    [sym_metavariable] = ACTIONS(2718),
    [sym_raw_string_literal] = ACTIONS(2718),
    [sym_float_literal] = ACTIONS(2718),
  },
  [732] = {
    [sym_line_comment] = STATE(732),
    [sym_block_comment] = STATE(732),
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2724),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_macro_rules_BANG] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_LBRACE] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_STAR] = ACTIONS(2722),
    [anon_sym_u8] = ACTIONS(2724),
    [anon_sym_i8] = ACTIONS(2724),
    [anon_sym_u16] = ACTIONS(2724),
    [anon_sym_i16] = ACTIONS(2724),
    [anon_sym_u32] = ACTIONS(2724),
    [anon_sym_i32] = ACTIONS(2724),
    [anon_sym_u64] = ACTIONS(2724),
    [anon_sym_i64] = ACTIONS(2724),
    [anon_sym_u128] = ACTIONS(2724),
    [anon_sym_i128] = ACTIONS(2724),
    [anon_sym_isize] = ACTIONS(2724),
    [anon_sym_usize] = ACTIONS(2724),
    [anon_sym_f32] = ACTIONS(2724),
    [anon_sym_f64] = ACTIONS(2724),
    [anon_sym_bool] = ACTIONS(2724),
    [anon_sym_str] = ACTIONS(2724),
    [anon_sym_char] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2722),
    [anon_sym_COLON_COLON] = ACTIONS(2722),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2722),
    [anon_sym_POUND] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_PIPE] = ACTIONS(2722),
    [anon_sym_SQUOTE] = ACTIONS(2724),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_break] = ACTIONS(2724),
    [anon_sym_const] = ACTIONS(2724),
    [anon_sym_continue] = ACTIONS(2724),
    [anon_sym_default] = ACTIONS(2724),
    [anon_sym_enum] = ACTIONS(2724),
    [anon_sym_fn] = ACTIONS(2724),
    [anon_sym_for] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2724),
    [anon_sym_impl] = ACTIONS(2724),
    [anon_sym_let] = ACTIONS(2724),
    [anon_sym_loop] = ACTIONS(2724),
    [anon_sym_match] = ACTIONS(2724),
    [anon_sym_mod] = ACTIONS(2724),
    [anon_sym_pub] = ACTIONS(2724),
    [anon_sym_return] = ACTIONS(2724),
    [anon_sym_static] = ACTIONS(2724),
    [anon_sym_struct] = ACTIONS(2724),
    [anon_sym_trait] = ACTIONS(2724),
    [anon_sym_type] = ACTIONS(2724),
    [anon_sym_union] = ACTIONS(2724),
    [anon_sym_unsafe] = ACTIONS(2724),
    [anon_sym_use] = ACTIONS(2724),
    [anon_sym_while] = ACTIONS(2724),
    [anon_sym_extern] = ACTIONS(2724),
    [anon_sym_DOT_DOT] = ACTIONS(2722),
    [anon_sym_yield] = ACTIONS(2724),
    [anon_sym_move] = ACTIONS(2724),
    [anon_sym_try] = ACTIONS(2724),
    [sym_integer_literal] = ACTIONS(2722),
    [aux_sym_string_literal_token1] = ACTIONS(2722),
    [sym_char_literal] = ACTIONS(2722),
    [anon_sym_true] = ACTIONS(2724),
    [anon_sym_false] = ACTIONS(2724),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2724),
    [sym_super] = ACTIONS(2724),
    [sym_crate] = ACTIONS(2724),
    [sym_metavariable] = ACTIONS(2722),
    [sym_raw_string_literal] = ACTIONS(2722),
    [sym_float_literal] = ACTIONS(2722),
  },
  [733] = {
    [sym_line_comment] = STATE(733),
    [sym_block_comment] = STATE(733),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_macro_rules_BANG] = ACTIONS(956),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(956),
    [anon_sym_u8] = ACTIONS(958),
    [anon_sym_i8] = ACTIONS(958),
    [anon_sym_u16] = ACTIONS(958),
    [anon_sym_i16] = ACTIONS(958),
    [anon_sym_u32] = ACTIONS(958),
    [anon_sym_i32] = ACTIONS(958),
    [anon_sym_u64] = ACTIONS(958),
    [anon_sym_i64] = ACTIONS(958),
    [anon_sym_u128] = ACTIONS(958),
    [anon_sym_i128] = ACTIONS(958),
    [anon_sym_isize] = ACTIONS(958),
    [anon_sym_usize] = ACTIONS(958),
    [anon_sym_f32] = ACTIONS(958),
    [anon_sym_f64] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_str] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_COLON_COLON] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_POUND] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_fn] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_impl] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_loop] = ACTIONS(958),
    [anon_sym_match] = ACTIONS(958),
    [anon_sym_mod] = ACTIONS(958),
    [anon_sym_pub] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_trait] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_unsafe] = ACTIONS(958),
    [anon_sym_use] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym_DOT_DOT] = ACTIONS(956),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_move] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [sym_integer_literal] = ACTIONS(956),
    [aux_sym_string_literal_token1] = ACTIONS(956),
    [sym_char_literal] = ACTIONS(956),
    [anon_sym_true] = ACTIONS(958),
    [anon_sym_false] = ACTIONS(958),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_crate] = ACTIONS(958),
    [sym_metavariable] = ACTIONS(956),
    [sym_raw_string_literal] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
  },
  [734] = {
    [sym_line_comment] = STATE(734),
    [sym_block_comment] = STATE(734),
    [ts_builtin_sym_end] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_macro_rules_BANG] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_STAR] = ACTIONS(2726),
    [anon_sym_u8] = ACTIONS(2728),
    [anon_sym_i8] = ACTIONS(2728),
    [anon_sym_u16] = ACTIONS(2728),
    [anon_sym_i16] = ACTIONS(2728),
    [anon_sym_u32] = ACTIONS(2728),
    [anon_sym_i32] = ACTIONS(2728),
    [anon_sym_u64] = ACTIONS(2728),
    [anon_sym_i64] = ACTIONS(2728),
    [anon_sym_u128] = ACTIONS(2728),
    [anon_sym_i128] = ACTIONS(2728),
    [anon_sym_isize] = ACTIONS(2728),
    [anon_sym_usize] = ACTIONS(2728),
    [anon_sym_f32] = ACTIONS(2728),
    [anon_sym_f64] = ACTIONS(2728),
    [anon_sym_bool] = ACTIONS(2728),
    [anon_sym_str] = ACTIONS(2728),
    [anon_sym_char] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2726),
    [anon_sym_COLON_COLON] = ACTIONS(2726),
    [anon_sym_BANG] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2726),
    [anon_sym_POUND] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_break] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_continue] = ACTIONS(2728),
    [anon_sym_default] = ACTIONS(2728),
    [anon_sym_enum] = ACTIONS(2728),
    [anon_sym_fn] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_impl] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_loop] = ACTIONS(2728),
    [anon_sym_match] = ACTIONS(2728),
    [anon_sym_mod] = ACTIONS(2728),
    [anon_sym_pub] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_struct] = ACTIONS(2728),
    [anon_sym_trait] = ACTIONS(2728),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_union] = ACTIONS(2728),
    [anon_sym_unsafe] = ACTIONS(2728),
    [anon_sym_use] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [anon_sym_extern] = ACTIONS(2728),
    [anon_sym_DOT_DOT] = ACTIONS(2726),
    [anon_sym_yield] = ACTIONS(2728),
    [anon_sym_move] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [sym_integer_literal] = ACTIONS(2726),
    [aux_sym_string_literal_token1] = ACTIONS(2726),
    [sym_char_literal] = ACTIONS(2726),
    [anon_sym_true] = ACTIONS(2728),
    [anon_sym_false] = ACTIONS(2728),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2728),
    [sym_super] = ACTIONS(2728),
    [sym_crate] = ACTIONS(2728),
    [sym_metavariable] = ACTIONS(2726),
    [sym_raw_string_literal] = ACTIONS(2726),
    [sym_float_literal] = ACTIONS(2726),
  },
  [735] = {
    [sym_line_comment] = STATE(735),
    [sym_block_comment] = STATE(735),
    [ts_builtin_sym_end] = ACTIONS(2730),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2730),
    [anon_sym_macro_rules_BANG] = ACTIONS(2730),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_STAR] = ACTIONS(2730),
    [anon_sym_u8] = ACTIONS(2732),
    [anon_sym_i8] = ACTIONS(2732),
    [anon_sym_u16] = ACTIONS(2732),
    [anon_sym_i16] = ACTIONS(2732),
    [anon_sym_u32] = ACTIONS(2732),
    [anon_sym_i32] = ACTIONS(2732),
    [anon_sym_u64] = ACTIONS(2732),
    [anon_sym_i64] = ACTIONS(2732),
    [anon_sym_u128] = ACTIONS(2732),
    [anon_sym_i128] = ACTIONS(2732),
    [anon_sym_isize] = ACTIONS(2732),
    [anon_sym_usize] = ACTIONS(2732),
    [anon_sym_f32] = ACTIONS(2732),
    [anon_sym_f64] = ACTIONS(2732),
    [anon_sym_bool] = ACTIONS(2732),
    [anon_sym_str] = ACTIONS(2732),
    [anon_sym_char] = ACTIONS(2732),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_AMP] = ACTIONS(2730),
    [anon_sym_POUND] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_PIPE] = ACTIONS(2730),
    [anon_sym_SQUOTE] = ACTIONS(2732),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_break] = ACTIONS(2732),
    [anon_sym_const] = ACTIONS(2732),
    [anon_sym_continue] = ACTIONS(2732),
    [anon_sym_default] = ACTIONS(2732),
    [anon_sym_enum] = ACTIONS(2732),
    [anon_sym_fn] = ACTIONS(2732),
    [anon_sym_for] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2732),
    [anon_sym_impl] = ACTIONS(2732),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_loop] = ACTIONS(2732),
    [anon_sym_match] = ACTIONS(2732),
    [anon_sym_mod] = ACTIONS(2732),
    [anon_sym_pub] = ACTIONS(2732),
    [anon_sym_return] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_struct] = ACTIONS(2732),
    [anon_sym_trait] = ACTIONS(2732),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_union] = ACTIONS(2732),
    [anon_sym_unsafe] = ACTIONS(2732),
    [anon_sym_use] = ACTIONS(2732),
    [anon_sym_while] = ACTIONS(2732),
    [anon_sym_extern] = ACTIONS(2732),
    [anon_sym_DOT_DOT] = ACTIONS(2730),
    [anon_sym_yield] = ACTIONS(2732),
    [anon_sym_move] = ACTIONS(2732),
    [anon_sym_try] = ACTIONS(2732),
    [sym_integer_literal] = ACTIONS(2730),
    [aux_sym_string_literal_token1] = ACTIONS(2730),
    [sym_char_literal] = ACTIONS(2730),
    [anon_sym_true] = ACTIONS(2732),
    [anon_sym_false] = ACTIONS(2732),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [sym_crate] = ACTIONS(2732),
    [sym_metavariable] = ACTIONS(2730),
    [sym_raw_string_literal] = ACTIONS(2730),
    [sym_float_literal] = ACTIONS(2730),
  },
  [736] = {
    [sym_line_comment] = STATE(736),
    [sym_block_comment] = STATE(736),
    [ts_builtin_sym_end] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_macro_rules_BANG] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_u8] = ACTIONS(2736),
    [anon_sym_i8] = ACTIONS(2736),
    [anon_sym_u16] = ACTIONS(2736),
    [anon_sym_i16] = ACTIONS(2736),
    [anon_sym_u32] = ACTIONS(2736),
    [anon_sym_i32] = ACTIONS(2736),
    [anon_sym_u64] = ACTIONS(2736),
    [anon_sym_i64] = ACTIONS(2736),
    [anon_sym_u128] = ACTIONS(2736),
    [anon_sym_i128] = ACTIONS(2736),
    [anon_sym_isize] = ACTIONS(2736),
    [anon_sym_usize] = ACTIONS(2736),
    [anon_sym_f32] = ACTIONS(2736),
    [anon_sym_f64] = ACTIONS(2736),
    [anon_sym_bool] = ACTIONS(2736),
    [anon_sym_str] = ACTIONS(2736),
    [anon_sym_char] = ACTIONS(2736),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_POUND] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [anon_sym_fn] = ACTIONS(2736),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2736),
    [anon_sym_impl] = ACTIONS(2736),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_loop] = ACTIONS(2736),
    [anon_sym_match] = ACTIONS(2736),
    [anon_sym_mod] = ACTIONS(2736),
    [anon_sym_pub] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_trait] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_union] = ACTIONS(2736),
    [anon_sym_unsafe] = ACTIONS(2736),
    [anon_sym_use] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_extern] = ACTIONS(2736),
    [anon_sym_DOT_DOT] = ACTIONS(2734),
    [anon_sym_yield] = ACTIONS(2736),
    [anon_sym_move] = ACTIONS(2736),
    [anon_sym_try] = ACTIONS(2736),
    [sym_integer_literal] = ACTIONS(2734),
    [aux_sym_string_literal_token1] = ACTIONS(2734),
    [sym_char_literal] = ACTIONS(2734),
    [anon_sym_true] = ACTIONS(2736),
    [anon_sym_false] = ACTIONS(2736),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [sym_crate] = ACTIONS(2736),
    [sym_metavariable] = ACTIONS(2734),
    [sym_raw_string_literal] = ACTIONS(2734),
    [sym_float_literal] = ACTIONS(2734),
  },
  [737] = {
    [sym_line_comment] = STATE(737),
    [sym_block_comment] = STATE(737),
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_macro_rules_BANG] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(2738),
    [anon_sym_u8] = ACTIONS(2740),
    [anon_sym_i8] = ACTIONS(2740),
    [anon_sym_u16] = ACTIONS(2740),
    [anon_sym_i16] = ACTIONS(2740),
    [anon_sym_u32] = ACTIONS(2740),
    [anon_sym_i32] = ACTIONS(2740),
    [anon_sym_u64] = ACTIONS(2740),
    [anon_sym_i64] = ACTIONS(2740),
    [anon_sym_u128] = ACTIONS(2740),
    [anon_sym_i128] = ACTIONS(2740),
    [anon_sym_isize] = ACTIONS(2740),
    [anon_sym_usize] = ACTIONS(2740),
    [anon_sym_f32] = ACTIONS(2740),
    [anon_sym_f64] = ACTIONS(2740),
    [anon_sym_bool] = ACTIONS(2740),
    [anon_sym_str] = ACTIONS(2740),
    [anon_sym_char] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2738),
    [anon_sym_COLON_COLON] = ACTIONS(2738),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_AMP] = ACTIONS(2738),
    [anon_sym_POUND] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [anon_sym_fn] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_impl] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_loop] = ACTIONS(2740),
    [anon_sym_match] = ACTIONS(2740),
    [anon_sym_mod] = ACTIONS(2740),
    [anon_sym_pub] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2740),
    [anon_sym_trait] = ACTIONS(2740),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_union] = ACTIONS(2740),
    [anon_sym_unsafe] = ACTIONS(2740),
    [anon_sym_use] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_extern] = ACTIONS(2740),
    [anon_sym_DOT_DOT] = ACTIONS(2738),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_move] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [sym_integer_literal] = ACTIONS(2738),
    [aux_sym_string_literal_token1] = ACTIONS(2738),
    [sym_char_literal] = ACTIONS(2738),
    [anon_sym_true] = ACTIONS(2740),
    [anon_sym_false] = ACTIONS(2740),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_crate] = ACTIONS(2740),
    [sym_metavariable] = ACTIONS(2738),
    [sym_raw_string_literal] = ACTIONS(2738),
    [sym_float_literal] = ACTIONS(2738),
  },
  [738] = {
    [sym_line_comment] = STATE(738),
    [sym_block_comment] = STATE(738),
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_macro_rules_BANG] = ACTIONS(2742),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_u8] = ACTIONS(2744),
    [anon_sym_i8] = ACTIONS(2744),
    [anon_sym_u16] = ACTIONS(2744),
    [anon_sym_i16] = ACTIONS(2744),
    [anon_sym_u32] = ACTIONS(2744),
    [anon_sym_i32] = ACTIONS(2744),
    [anon_sym_u64] = ACTIONS(2744),
    [anon_sym_i64] = ACTIONS(2744),
    [anon_sym_u128] = ACTIONS(2744),
    [anon_sym_i128] = ACTIONS(2744),
    [anon_sym_isize] = ACTIONS(2744),
    [anon_sym_usize] = ACTIONS(2744),
    [anon_sym_f32] = ACTIONS(2744),
    [anon_sym_f64] = ACTIONS(2744),
    [anon_sym_bool] = ACTIONS(2744),
    [anon_sym_str] = ACTIONS(2744),
    [anon_sym_char] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_COLON_COLON] = ACTIONS(2742),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2742),
    [anon_sym_POUND] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_PIPE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_fn] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_impl] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_loop] = ACTIONS(2744),
    [anon_sym_match] = ACTIONS(2744),
    [anon_sym_mod] = ACTIONS(2744),
    [anon_sym_pub] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_trait] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_unsafe] = ACTIONS(2744),
    [anon_sym_use] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_DOT_DOT] = ACTIONS(2742),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_move] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [sym_integer_literal] = ACTIONS(2742),
    [aux_sym_string_literal_token1] = ACTIONS(2742),
    [sym_char_literal] = ACTIONS(2742),
    [anon_sym_true] = ACTIONS(2744),
    [anon_sym_false] = ACTIONS(2744),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_crate] = ACTIONS(2744),
    [sym_metavariable] = ACTIONS(2742),
    [sym_raw_string_literal] = ACTIONS(2742),
    [sym_float_literal] = ACTIONS(2742),
  },
  [739] = {
    [sym_line_comment] = STATE(739),
    [sym_block_comment] = STATE(739),
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_macro_rules_BANG] = ACTIONS(2746),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_u8] = ACTIONS(2748),
    [anon_sym_i8] = ACTIONS(2748),
    [anon_sym_u16] = ACTIONS(2748),
    [anon_sym_i16] = ACTIONS(2748),
    [anon_sym_u32] = ACTIONS(2748),
    [anon_sym_i32] = ACTIONS(2748),
    [anon_sym_u64] = ACTIONS(2748),
    [anon_sym_i64] = ACTIONS(2748),
    [anon_sym_u128] = ACTIONS(2748),
    [anon_sym_i128] = ACTIONS(2748),
    [anon_sym_isize] = ACTIONS(2748),
    [anon_sym_usize] = ACTIONS(2748),
    [anon_sym_f32] = ACTIONS(2748),
    [anon_sym_f64] = ACTIONS(2748),
    [anon_sym_bool] = ACTIONS(2748),
    [anon_sym_str] = ACTIONS(2748),
    [anon_sym_char] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2746),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_POUND] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [anon_sym_fn] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_impl] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_loop] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_mod] = ACTIONS(2748),
    [anon_sym_pub] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_struct] = ACTIONS(2748),
    [anon_sym_trait] = ACTIONS(2748),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_union] = ACTIONS(2748),
    [anon_sym_unsafe] = ACTIONS(2748),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_extern] = ACTIONS(2748),
    [anon_sym_DOT_DOT] = ACTIONS(2746),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_move] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [sym_integer_literal] = ACTIONS(2746),
    [aux_sym_string_literal_token1] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [anon_sym_true] = ACTIONS(2748),
    [anon_sym_false] = ACTIONS(2748),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_crate] = ACTIONS(2748),
    [sym_metavariable] = ACTIONS(2746),
    [sym_raw_string_literal] = ACTIONS(2746),
    [sym_float_literal] = ACTIONS(2746),
  },
  [740] = {
    [sym_line_comment] = STATE(740),
    [sym_block_comment] = STATE(740),
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_macro_rules_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_STAR] = ACTIONS(2750),
    [anon_sym_u8] = ACTIONS(2752),
    [anon_sym_i8] = ACTIONS(2752),
    [anon_sym_u16] = ACTIONS(2752),
    [anon_sym_i16] = ACTIONS(2752),
    [anon_sym_u32] = ACTIONS(2752),
    [anon_sym_i32] = ACTIONS(2752),
    [anon_sym_u64] = ACTIONS(2752),
    [anon_sym_i64] = ACTIONS(2752),
    [anon_sym_u128] = ACTIONS(2752),
    [anon_sym_i128] = ACTIONS(2752),
    [anon_sym_isize] = ACTIONS(2752),
    [anon_sym_usize] = ACTIONS(2752),
    [anon_sym_f32] = ACTIONS(2752),
    [anon_sym_f64] = ACTIONS(2752),
    [anon_sym_bool] = ACTIONS(2752),
    [anon_sym_str] = ACTIONS(2752),
    [anon_sym_char] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2750),
    [anon_sym_POUND] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_PIPE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
    [anon_sym_fn] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_impl] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_loop] = ACTIONS(2752),
    [anon_sym_match] = ACTIONS(2752),
    [anon_sym_mod] = ACTIONS(2752),
    [anon_sym_pub] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_struct] = ACTIONS(2752),
    [anon_sym_trait] = ACTIONS(2752),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_union] = ACTIONS(2752),
    [anon_sym_unsafe] = ACTIONS(2752),
    [anon_sym_use] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_extern] = ACTIONS(2752),
    [anon_sym_DOT_DOT] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_move] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [sym_integer_literal] = ACTIONS(2750),
    [aux_sym_string_literal_token1] = ACTIONS(2750),
    [sym_char_literal] = ACTIONS(2750),
    [anon_sym_true] = ACTIONS(2752),
    [anon_sym_false] = ACTIONS(2752),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_crate] = ACTIONS(2752),
    [sym_metavariable] = ACTIONS(2750),
    [sym_raw_string_literal] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
  },
  [741] = {
    [sym_line_comment] = STATE(741),
    [sym_block_comment] = STATE(741),
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_macro_rules_BANG] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_STAR] = ACTIONS(2754),
    [anon_sym_u8] = ACTIONS(2756),
    [anon_sym_i8] = ACTIONS(2756),
    [anon_sym_u16] = ACTIONS(2756),
    [anon_sym_i16] = ACTIONS(2756),
    [anon_sym_u32] = ACTIONS(2756),
    [anon_sym_i32] = ACTIONS(2756),
    [anon_sym_u64] = ACTIONS(2756),
    [anon_sym_i64] = ACTIONS(2756),
    [anon_sym_u128] = ACTIONS(2756),
    [anon_sym_i128] = ACTIONS(2756),
    [anon_sym_isize] = ACTIONS(2756),
    [anon_sym_usize] = ACTIONS(2756),
    [anon_sym_f32] = ACTIONS(2756),
    [anon_sym_f64] = ACTIONS(2756),
    [anon_sym_bool] = ACTIONS(2756),
    [anon_sym_str] = ACTIONS(2756),
    [anon_sym_char] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2754),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_POUND] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
    [anon_sym_fn] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_impl] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_loop] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_mod] = ACTIONS(2756),
    [anon_sym_pub] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_struct] = ACTIONS(2756),
    [anon_sym_trait] = ACTIONS(2756),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_union] = ACTIONS(2756),
    [anon_sym_unsafe] = ACTIONS(2756),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_extern] = ACTIONS(2756),
    [anon_sym_DOT_DOT] = ACTIONS(2754),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_move] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [sym_integer_literal] = ACTIONS(2754),
    [aux_sym_string_literal_token1] = ACTIONS(2754),
    [sym_char_literal] = ACTIONS(2754),
    [anon_sym_true] = ACTIONS(2756),
    [anon_sym_false] = ACTIONS(2756),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_crate] = ACTIONS(2756),
    [sym_metavariable] = ACTIONS(2754),
    [sym_raw_string_literal] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2754),
  },
  [742] = {
    [sym_line_comment] = STATE(742),
    [sym_block_comment] = STATE(742),
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_macro_rules_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_STAR] = ACTIONS(2758),
    [anon_sym_u8] = ACTIONS(2760),
    [anon_sym_i8] = ACTIONS(2760),
    [anon_sym_u16] = ACTIONS(2760),
    [anon_sym_i16] = ACTIONS(2760),
    [anon_sym_u32] = ACTIONS(2760),
    [anon_sym_i32] = ACTIONS(2760),
    [anon_sym_u64] = ACTIONS(2760),
    [anon_sym_i64] = ACTIONS(2760),
    [anon_sym_u128] = ACTIONS(2760),
    [anon_sym_i128] = ACTIONS(2760),
    [anon_sym_isize] = ACTIONS(2760),
    [anon_sym_usize] = ACTIONS(2760),
    [anon_sym_f32] = ACTIONS(2760),
    [anon_sym_f64] = ACTIONS(2760),
    [anon_sym_bool] = ACTIONS(2760),
    [anon_sym_str] = ACTIONS(2760),
    [anon_sym_char] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2758),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_AMP] = ACTIONS(2758),
    [anon_sym_POUND] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
    [anon_sym_fn] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_impl] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_loop] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_mod] = ACTIONS(2760),
    [anon_sym_pub] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_struct] = ACTIONS(2760),
    [anon_sym_trait] = ACTIONS(2760),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_union] = ACTIONS(2760),
    [anon_sym_unsafe] = ACTIONS(2760),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_extern] = ACTIONS(2760),
    [anon_sym_DOT_DOT] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_move] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [sym_integer_literal] = ACTIONS(2758),
    [aux_sym_string_literal_token1] = ACTIONS(2758),
    [sym_char_literal] = ACTIONS(2758),
    [anon_sym_true] = ACTIONS(2760),
    [anon_sym_false] = ACTIONS(2760),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_crate] = ACTIONS(2760),
    [sym_metavariable] = ACTIONS(2758),
    [sym_raw_string_literal] = ACTIONS(2758),
    [sym_float_literal] = ACTIONS(2758),
  },
  [743] = {
    [sym_line_comment] = STATE(743),
    [sym_block_comment] = STATE(743),
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_macro_rules_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_u8] = ACTIONS(2764),
    [anon_sym_i8] = ACTIONS(2764),
    [anon_sym_u16] = ACTIONS(2764),
    [anon_sym_i16] = ACTIONS(2764),
    [anon_sym_u32] = ACTIONS(2764),
    [anon_sym_i32] = ACTIONS(2764),
    [anon_sym_u64] = ACTIONS(2764),
    [anon_sym_i64] = ACTIONS(2764),
    [anon_sym_u128] = ACTIONS(2764),
    [anon_sym_i128] = ACTIONS(2764),
    [anon_sym_isize] = ACTIONS(2764),
    [anon_sym_usize] = ACTIONS(2764),
    [anon_sym_f32] = ACTIONS(2764),
    [anon_sym_f64] = ACTIONS(2764),
    [anon_sym_bool] = ACTIONS(2764),
    [anon_sym_str] = ACTIONS(2764),
    [anon_sym_char] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_POUND] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
    [anon_sym_fn] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_impl] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_loop] = ACTIONS(2764),
    [anon_sym_match] = ACTIONS(2764),
    [anon_sym_mod] = ACTIONS(2764),
    [anon_sym_pub] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_struct] = ACTIONS(2764),
    [anon_sym_trait] = ACTIONS(2764),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_union] = ACTIONS(2764),
    [anon_sym_unsafe] = ACTIONS(2764),
    [anon_sym_use] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_extern] = ACTIONS(2764),
    [anon_sym_DOT_DOT] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_move] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [sym_integer_literal] = ACTIONS(2762),
    [aux_sym_string_literal_token1] = ACTIONS(2762),
    [sym_char_literal] = ACTIONS(2762),
    [anon_sym_true] = ACTIONS(2764),
    [anon_sym_false] = ACTIONS(2764),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_crate] = ACTIONS(2764),
    [sym_metavariable] = ACTIONS(2762),
    [sym_raw_string_literal] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
  },
  [744] = {
    [sym_line_comment] = STATE(744),
    [sym_block_comment] = STATE(744),
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_macro_rules_BANG] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(2766),
    [anon_sym_u8] = ACTIONS(2768),
    [anon_sym_i8] = ACTIONS(2768),
    [anon_sym_u16] = ACTIONS(2768),
    [anon_sym_i16] = ACTIONS(2768),
    [anon_sym_u32] = ACTIONS(2768),
    [anon_sym_i32] = ACTIONS(2768),
    [anon_sym_u64] = ACTIONS(2768),
    [anon_sym_i64] = ACTIONS(2768),
    [anon_sym_u128] = ACTIONS(2768),
    [anon_sym_i128] = ACTIONS(2768),
    [anon_sym_isize] = ACTIONS(2768),
    [anon_sym_usize] = ACTIONS(2768),
    [anon_sym_f32] = ACTIONS(2768),
    [anon_sym_f64] = ACTIONS(2768),
    [anon_sym_bool] = ACTIONS(2768),
    [anon_sym_str] = ACTIONS(2768),
    [anon_sym_char] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2766),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_POUND] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [anon_sym_fn] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_impl] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_loop] = ACTIONS(2768),
    [anon_sym_match] = ACTIONS(2768),
    [anon_sym_mod] = ACTIONS(2768),
    [anon_sym_pub] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_struct] = ACTIONS(2768),
    [anon_sym_trait] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_union] = ACTIONS(2768),
    [anon_sym_unsafe] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_extern] = ACTIONS(2768),
    [anon_sym_DOT_DOT] = ACTIONS(2766),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_move] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [sym_integer_literal] = ACTIONS(2766),
    [aux_sym_string_literal_token1] = ACTIONS(2766),
    [sym_char_literal] = ACTIONS(2766),
    [anon_sym_true] = ACTIONS(2768),
    [anon_sym_false] = ACTIONS(2768),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_crate] = ACTIONS(2768),
    [sym_metavariable] = ACTIONS(2766),
    [sym_raw_string_literal] = ACTIONS(2766),
    [sym_float_literal] = ACTIONS(2766),
  },
  [745] = {
    [sym_line_comment] = STATE(745),
    [sym_block_comment] = STATE(745),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_macro_rules_BANG] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(2770),
    [anon_sym_u8] = ACTIONS(2772),
    [anon_sym_i8] = ACTIONS(2772),
    [anon_sym_u16] = ACTIONS(2772),
    [anon_sym_i16] = ACTIONS(2772),
    [anon_sym_u32] = ACTIONS(2772),
    [anon_sym_i32] = ACTIONS(2772),
    [anon_sym_u64] = ACTIONS(2772),
    [anon_sym_i64] = ACTIONS(2772),
    [anon_sym_u128] = ACTIONS(2772),
    [anon_sym_i128] = ACTIONS(2772),
    [anon_sym_isize] = ACTIONS(2772),
    [anon_sym_usize] = ACTIONS(2772),
    [anon_sym_f32] = ACTIONS(2772),
    [anon_sym_f64] = ACTIONS(2772),
    [anon_sym_bool] = ACTIONS(2772),
    [anon_sym_str] = ACTIONS(2772),
    [anon_sym_char] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_POUND] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
    [anon_sym_fn] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_impl] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_loop] = ACTIONS(2772),
    [anon_sym_match] = ACTIONS(2772),
    [anon_sym_mod] = ACTIONS(2772),
    [anon_sym_pub] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_trait] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_union] = ACTIONS(2772),
    [anon_sym_unsafe] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_extern] = ACTIONS(2772),
    [anon_sym_DOT_DOT] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_move] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [sym_integer_literal] = ACTIONS(2770),
    [aux_sym_string_literal_token1] = ACTIONS(2770),
    [sym_char_literal] = ACTIONS(2770),
    [anon_sym_true] = ACTIONS(2772),
    [anon_sym_false] = ACTIONS(2772),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_crate] = ACTIONS(2772),
    [sym_metavariable] = ACTIONS(2770),
    [sym_raw_string_literal] = ACTIONS(2770),
    [sym_float_literal] = ACTIONS(2770),
  },
  [746] = {
    [sym_line_comment] = STATE(746),
    [sym_block_comment] = STATE(746),
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_macro_rules_BANG] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_u8] = ACTIONS(2776),
    [anon_sym_i8] = ACTIONS(2776),
    [anon_sym_u16] = ACTIONS(2776),
    [anon_sym_i16] = ACTIONS(2776),
    [anon_sym_u32] = ACTIONS(2776),
    [anon_sym_i32] = ACTIONS(2776),
    [anon_sym_u64] = ACTIONS(2776),
    [anon_sym_i64] = ACTIONS(2776),
    [anon_sym_u128] = ACTIONS(2776),
    [anon_sym_i128] = ACTIONS(2776),
    [anon_sym_isize] = ACTIONS(2776),
    [anon_sym_usize] = ACTIONS(2776),
    [anon_sym_f32] = ACTIONS(2776),
    [anon_sym_f64] = ACTIONS(2776),
    [anon_sym_bool] = ACTIONS(2776),
    [anon_sym_str] = ACTIONS(2776),
    [anon_sym_char] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_COLON_COLON] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2774),
    [anon_sym_POUND] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
    [anon_sym_fn] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_impl] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_loop] = ACTIONS(2776),
    [anon_sym_match] = ACTIONS(2776),
    [anon_sym_mod] = ACTIONS(2776),
    [anon_sym_pub] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_struct] = ACTIONS(2776),
    [anon_sym_trait] = ACTIONS(2776),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_union] = ACTIONS(2776),
    [anon_sym_unsafe] = ACTIONS(2776),
    [anon_sym_use] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_extern] = ACTIONS(2776),
    [anon_sym_DOT_DOT] = ACTIONS(2774),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_move] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [sym_integer_literal] = ACTIONS(2774),
    [aux_sym_string_literal_token1] = ACTIONS(2774),
    [sym_char_literal] = ACTIONS(2774),
    [anon_sym_true] = ACTIONS(2776),
    [anon_sym_false] = ACTIONS(2776),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_crate] = ACTIONS(2776),
    [sym_metavariable] = ACTIONS(2774),
    [sym_raw_string_literal] = ACTIONS(2774),
    [sym_float_literal] = ACTIONS(2774),
  },
  [747] = {
    [sym_line_comment] = STATE(747),
    [sym_block_comment] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_macro_rules_BANG] = ACTIONS(2778),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(2778),
    [anon_sym_u8] = ACTIONS(2780),
    [anon_sym_i8] = ACTIONS(2780),
    [anon_sym_u16] = ACTIONS(2780),
    [anon_sym_i16] = ACTIONS(2780),
    [anon_sym_u32] = ACTIONS(2780),
    [anon_sym_i32] = ACTIONS(2780),
    [anon_sym_u64] = ACTIONS(2780),
    [anon_sym_i64] = ACTIONS(2780),
    [anon_sym_u128] = ACTIONS(2780),
    [anon_sym_i128] = ACTIONS(2780),
    [anon_sym_isize] = ACTIONS(2780),
    [anon_sym_usize] = ACTIONS(2780),
    [anon_sym_f32] = ACTIONS(2780),
    [anon_sym_f64] = ACTIONS(2780),
    [anon_sym_bool] = ACTIONS(2780),
    [anon_sym_str] = ACTIONS(2780),
    [anon_sym_char] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2778),
    [anon_sym_COLON_COLON] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2778),
    [anon_sym_POUND] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [anon_sym_fn] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_impl] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_loop] = ACTIONS(2780),
    [anon_sym_match] = ACTIONS(2780),
    [anon_sym_mod] = ACTIONS(2780),
    [anon_sym_pub] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_struct] = ACTIONS(2780),
    [anon_sym_trait] = ACTIONS(2780),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_union] = ACTIONS(2780),
    [anon_sym_unsafe] = ACTIONS(2780),
    [anon_sym_use] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_extern] = ACTIONS(2780),
    [anon_sym_DOT_DOT] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_move] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [sym_integer_literal] = ACTIONS(2778),
    [aux_sym_string_literal_token1] = ACTIONS(2778),
    [sym_char_literal] = ACTIONS(2778),
    [anon_sym_true] = ACTIONS(2780),
    [anon_sym_false] = ACTIONS(2780),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_crate] = ACTIONS(2780),
    [sym_metavariable] = ACTIONS(2778),
    [sym_raw_string_literal] = ACTIONS(2778),
    [sym_float_literal] = ACTIONS(2778),
  },
  [748] = {
    [sym_line_comment] = STATE(748),
    [sym_block_comment] = STATE(748),
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_macro_rules_BANG] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2782),
    [anon_sym_u8] = ACTIONS(2784),
    [anon_sym_i8] = ACTIONS(2784),
    [anon_sym_u16] = ACTIONS(2784),
    [anon_sym_i16] = ACTIONS(2784),
    [anon_sym_u32] = ACTIONS(2784),
    [anon_sym_i32] = ACTIONS(2784),
    [anon_sym_u64] = ACTIONS(2784),
    [anon_sym_i64] = ACTIONS(2784),
    [anon_sym_u128] = ACTIONS(2784),
    [anon_sym_i128] = ACTIONS(2784),
    [anon_sym_isize] = ACTIONS(2784),
    [anon_sym_usize] = ACTIONS(2784),
    [anon_sym_f32] = ACTIONS(2784),
    [anon_sym_f64] = ACTIONS(2784),
    [anon_sym_bool] = ACTIONS(2784),
    [anon_sym_str] = ACTIONS(2784),
    [anon_sym_char] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_COLON_COLON] = ACTIONS(2782),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_POUND] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [anon_sym_fn] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_impl] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_loop] = ACTIONS(2784),
    [anon_sym_match] = ACTIONS(2784),
    [anon_sym_mod] = ACTIONS(2784),
    [anon_sym_pub] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_struct] = ACTIONS(2784),
    [anon_sym_trait] = ACTIONS(2784),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_union] = ACTIONS(2784),
    [anon_sym_unsafe] = ACTIONS(2784),
    [anon_sym_use] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_extern] = ACTIONS(2784),
    [anon_sym_DOT_DOT] = ACTIONS(2782),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_move] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [sym_integer_literal] = ACTIONS(2782),
    [aux_sym_string_literal_token1] = ACTIONS(2782),
    [sym_char_literal] = ACTIONS(2782),
    [anon_sym_true] = ACTIONS(2784),
    [anon_sym_false] = ACTIONS(2784),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_crate] = ACTIONS(2784),
    [sym_metavariable] = ACTIONS(2782),
    [sym_raw_string_literal] = ACTIONS(2782),
    [sym_float_literal] = ACTIONS(2782),
  },
  [749] = {
    [sym_line_comment] = STATE(749),
    [sym_block_comment] = STATE(749),
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_macro_rules_BANG] = ACTIONS(2786),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_u8] = ACTIONS(2788),
    [anon_sym_i8] = ACTIONS(2788),
    [anon_sym_u16] = ACTIONS(2788),
    [anon_sym_i16] = ACTIONS(2788),
    [anon_sym_u32] = ACTIONS(2788),
    [anon_sym_i32] = ACTIONS(2788),
    [anon_sym_u64] = ACTIONS(2788),
    [anon_sym_i64] = ACTIONS(2788),
    [anon_sym_u128] = ACTIONS(2788),
    [anon_sym_i128] = ACTIONS(2788),
    [anon_sym_isize] = ACTIONS(2788),
    [anon_sym_usize] = ACTIONS(2788),
    [anon_sym_f32] = ACTIONS(2788),
    [anon_sym_f64] = ACTIONS(2788),
    [anon_sym_bool] = ACTIONS(2788),
    [anon_sym_str] = ACTIONS(2788),
    [anon_sym_char] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_COLON_COLON] = ACTIONS(2786),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_POUND] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [anon_sym_fn] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_impl] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_loop] = ACTIONS(2788),
    [anon_sym_match] = ACTIONS(2788),
    [anon_sym_mod] = ACTIONS(2788),
    [anon_sym_pub] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_struct] = ACTIONS(2788),
    [anon_sym_trait] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_union] = ACTIONS(2788),
    [anon_sym_unsafe] = ACTIONS(2788),
    [anon_sym_use] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_extern] = ACTIONS(2788),
    [anon_sym_DOT_DOT] = ACTIONS(2786),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_move] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [sym_integer_literal] = ACTIONS(2786),
    [aux_sym_string_literal_token1] = ACTIONS(2786),
    [sym_char_literal] = ACTIONS(2786),
    [anon_sym_true] = ACTIONS(2788),
    [anon_sym_false] = ACTIONS(2788),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_crate] = ACTIONS(2788),
    [sym_metavariable] = ACTIONS(2786),
    [sym_raw_string_literal] = ACTIONS(2786),
    [sym_float_literal] = ACTIONS(2786),
  },
  [750] = {
    [sym_line_comment] = STATE(750),
    [sym_block_comment] = STATE(750),
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_macro_rules_BANG] = ACTIONS(2790),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2790),
    [anon_sym_u8] = ACTIONS(2792),
    [anon_sym_i8] = ACTIONS(2792),
    [anon_sym_u16] = ACTIONS(2792),
    [anon_sym_i16] = ACTIONS(2792),
    [anon_sym_u32] = ACTIONS(2792),
    [anon_sym_i32] = ACTIONS(2792),
    [anon_sym_u64] = ACTIONS(2792),
    [anon_sym_i64] = ACTIONS(2792),
    [anon_sym_u128] = ACTIONS(2792),
    [anon_sym_i128] = ACTIONS(2792),
    [anon_sym_isize] = ACTIONS(2792),
    [anon_sym_usize] = ACTIONS(2792),
    [anon_sym_f32] = ACTIONS(2792),
    [anon_sym_f64] = ACTIONS(2792),
    [anon_sym_bool] = ACTIONS(2792),
    [anon_sym_str] = ACTIONS(2792),
    [anon_sym_char] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_COLON_COLON] = ACTIONS(2790),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_POUND] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
    [anon_sym_fn] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_impl] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_loop] = ACTIONS(2792),
    [anon_sym_match] = ACTIONS(2792),
    [anon_sym_mod] = ACTIONS(2792),
    [anon_sym_pub] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_struct] = ACTIONS(2792),
    [anon_sym_trait] = ACTIONS(2792),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_union] = ACTIONS(2792),
    [anon_sym_unsafe] = ACTIONS(2792),
    [anon_sym_use] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_extern] = ACTIONS(2792),
    [anon_sym_DOT_DOT] = ACTIONS(2790),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_move] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [sym_integer_literal] = ACTIONS(2790),
    [aux_sym_string_literal_token1] = ACTIONS(2790),
    [sym_char_literal] = ACTIONS(2790),
    [anon_sym_true] = ACTIONS(2792),
    [anon_sym_false] = ACTIONS(2792),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_crate] = ACTIONS(2792),
    [sym_metavariable] = ACTIONS(2790),
    [sym_raw_string_literal] = ACTIONS(2790),
    [sym_float_literal] = ACTIONS(2790),
  },
  [751] = {
    [sym_line_comment] = STATE(751),
    [sym_block_comment] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_macro_rules_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_STAR] = ACTIONS(2794),
    [anon_sym_u8] = ACTIONS(2796),
    [anon_sym_i8] = ACTIONS(2796),
    [anon_sym_u16] = ACTIONS(2796),
    [anon_sym_i16] = ACTIONS(2796),
    [anon_sym_u32] = ACTIONS(2796),
    [anon_sym_i32] = ACTIONS(2796),
    [anon_sym_u64] = ACTIONS(2796),
    [anon_sym_i64] = ACTIONS(2796),
    [anon_sym_u128] = ACTIONS(2796),
    [anon_sym_i128] = ACTIONS(2796),
    [anon_sym_isize] = ACTIONS(2796),
    [anon_sym_usize] = ACTIONS(2796),
    [anon_sym_f32] = ACTIONS(2796),
    [anon_sym_f64] = ACTIONS(2796),
    [anon_sym_bool] = ACTIONS(2796),
    [anon_sym_str] = ACTIONS(2796),
    [anon_sym_char] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2794),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2794),
    [anon_sym_POUND] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_PIPE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [anon_sym_fn] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_impl] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_loop] = ACTIONS(2796),
    [anon_sym_match] = ACTIONS(2796),
    [anon_sym_mod] = ACTIONS(2796),
    [anon_sym_pub] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_struct] = ACTIONS(2796),
    [anon_sym_trait] = ACTIONS(2796),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_union] = ACTIONS(2796),
    [anon_sym_unsafe] = ACTIONS(2796),
    [anon_sym_use] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_extern] = ACTIONS(2796),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_move] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [sym_integer_literal] = ACTIONS(2794),
    [aux_sym_string_literal_token1] = ACTIONS(2794),
    [sym_char_literal] = ACTIONS(2794),
    [anon_sym_true] = ACTIONS(2796),
    [anon_sym_false] = ACTIONS(2796),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_crate] = ACTIONS(2796),
    [sym_metavariable] = ACTIONS(2794),
    [sym_raw_string_literal] = ACTIONS(2794),
    [sym_float_literal] = ACTIONS(2794),
  },
  [752] = {
    [sym_line_comment] = STATE(752),
    [sym_block_comment] = STATE(752),
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_macro_rules_BANG] = ACTIONS(2798),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_u8] = ACTIONS(2800),
    [anon_sym_i8] = ACTIONS(2800),
    [anon_sym_u16] = ACTIONS(2800),
    [anon_sym_i16] = ACTIONS(2800),
    [anon_sym_u32] = ACTIONS(2800),
    [anon_sym_i32] = ACTIONS(2800),
    [anon_sym_u64] = ACTIONS(2800),
    [anon_sym_i64] = ACTIONS(2800),
    [anon_sym_u128] = ACTIONS(2800),
    [anon_sym_i128] = ACTIONS(2800),
    [anon_sym_isize] = ACTIONS(2800),
    [anon_sym_usize] = ACTIONS(2800),
    [anon_sym_f32] = ACTIONS(2800),
    [anon_sym_f64] = ACTIONS(2800),
    [anon_sym_bool] = ACTIONS(2800),
    [anon_sym_str] = ACTIONS(2800),
    [anon_sym_char] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2798),
    [anon_sym_COLON_COLON] = ACTIONS(2798),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_POUND] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_PIPE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [anon_sym_fn] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_impl] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_loop] = ACTIONS(2800),
    [anon_sym_match] = ACTIONS(2800),
    [anon_sym_mod] = ACTIONS(2800),
    [anon_sym_pub] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_struct] = ACTIONS(2800),
    [anon_sym_trait] = ACTIONS(2800),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_union] = ACTIONS(2800),
    [anon_sym_unsafe] = ACTIONS(2800),
    [anon_sym_use] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_extern] = ACTIONS(2800),
    [anon_sym_DOT_DOT] = ACTIONS(2798),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_move] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [sym_integer_literal] = ACTIONS(2798),
    [aux_sym_string_literal_token1] = ACTIONS(2798),
    [sym_char_literal] = ACTIONS(2798),
    [anon_sym_true] = ACTIONS(2800),
    [anon_sym_false] = ACTIONS(2800),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_crate] = ACTIONS(2800),
    [sym_metavariable] = ACTIONS(2798),
    [sym_raw_string_literal] = ACTIONS(2798),
    [sym_float_literal] = ACTIONS(2798),
  },
  [753] = {
    [sym_line_comment] = STATE(753),
    [sym_block_comment] = STATE(753),
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_macro_rules_BANG] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_STAR] = ACTIONS(2802),
    [anon_sym_u8] = ACTIONS(2804),
    [anon_sym_i8] = ACTIONS(2804),
    [anon_sym_u16] = ACTIONS(2804),
    [anon_sym_i16] = ACTIONS(2804),
    [anon_sym_u32] = ACTIONS(2804),
    [anon_sym_i32] = ACTIONS(2804),
    [anon_sym_u64] = ACTIONS(2804),
    [anon_sym_i64] = ACTIONS(2804),
    [anon_sym_u128] = ACTIONS(2804),
    [anon_sym_i128] = ACTIONS(2804),
    [anon_sym_isize] = ACTIONS(2804),
    [anon_sym_usize] = ACTIONS(2804),
    [anon_sym_f32] = ACTIONS(2804),
    [anon_sym_f64] = ACTIONS(2804),
    [anon_sym_bool] = ACTIONS(2804),
    [anon_sym_str] = ACTIONS(2804),
    [anon_sym_char] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2802),
    [anon_sym_COLON_COLON] = ACTIONS(2802),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_AMP] = ACTIONS(2802),
    [anon_sym_POUND] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_PIPE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [anon_sym_fn] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_impl] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_loop] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_mod] = ACTIONS(2804),
    [anon_sym_pub] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_struct] = ACTIONS(2804),
    [anon_sym_trait] = ACTIONS(2804),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_union] = ACTIONS(2804),
    [anon_sym_unsafe] = ACTIONS(2804),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_extern] = ACTIONS(2804),
    [anon_sym_DOT_DOT] = ACTIONS(2802),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_move] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [sym_integer_literal] = ACTIONS(2802),
    [aux_sym_string_literal_token1] = ACTIONS(2802),
    [sym_char_literal] = ACTIONS(2802),
    [anon_sym_true] = ACTIONS(2804),
    [anon_sym_false] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_crate] = ACTIONS(2804),
    [sym_metavariable] = ACTIONS(2802),
    [sym_raw_string_literal] = ACTIONS(2802),
    [sym_float_literal] = ACTIONS(2802),
  },
  [754] = {
    [sym_line_comment] = STATE(754),
    [sym_block_comment] = STATE(754),
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_macro_rules_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_STAR] = ACTIONS(2806),
    [anon_sym_u8] = ACTIONS(2808),
    [anon_sym_i8] = ACTIONS(2808),
    [anon_sym_u16] = ACTIONS(2808),
    [anon_sym_i16] = ACTIONS(2808),
    [anon_sym_u32] = ACTIONS(2808),
    [anon_sym_i32] = ACTIONS(2808),
    [anon_sym_u64] = ACTIONS(2808),
    [anon_sym_i64] = ACTIONS(2808),
    [anon_sym_u128] = ACTIONS(2808),
    [anon_sym_i128] = ACTIONS(2808),
    [anon_sym_isize] = ACTIONS(2808),
    [anon_sym_usize] = ACTIONS(2808),
    [anon_sym_f32] = ACTIONS(2808),
    [anon_sym_f64] = ACTIONS(2808),
    [anon_sym_bool] = ACTIONS(2808),
    [anon_sym_str] = ACTIONS(2808),
    [anon_sym_char] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_BANG] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2806),
    [anon_sym_POUND] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_PIPE] = ACTIONS(2806),
    [anon_sym_SQUOTE] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_break] = ACTIONS(2808),
    [anon_sym_const] = ACTIONS(2808),
    [anon_sym_continue] = ACTIONS(2808),
    [anon_sym_default] = ACTIONS(2808),
    [anon_sym_enum] = ACTIONS(2808),
    [anon_sym_fn] = ACTIONS(2808),
    [anon_sym_for] = ACTIONS(2808),
    [anon_sym_if] = ACTIONS(2808),
    [anon_sym_impl] = ACTIONS(2808),
    [anon_sym_let] = ACTIONS(2808),
    [anon_sym_loop] = ACTIONS(2808),
    [anon_sym_match] = ACTIONS(2808),
    [anon_sym_mod] = ACTIONS(2808),
    [anon_sym_pub] = ACTIONS(2808),
    [anon_sym_return] = ACTIONS(2808),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_struct] = ACTIONS(2808),
    [anon_sym_trait] = ACTIONS(2808),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_union] = ACTIONS(2808),
    [anon_sym_unsafe] = ACTIONS(2808),
    [anon_sym_use] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2808),
    [anon_sym_extern] = ACTIONS(2808),
    [anon_sym_DOT_DOT] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2808),
    [anon_sym_move] = ACTIONS(2808),
    [anon_sym_try] = ACTIONS(2808),
    [sym_integer_literal] = ACTIONS(2806),
    [aux_sym_string_literal_token1] = ACTIONS(2806),
    [sym_char_literal] = ACTIONS(2806),
    [anon_sym_true] = ACTIONS(2808),
    [anon_sym_false] = ACTIONS(2808),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2808),
    [sym_super] = ACTIONS(2808),
    [sym_crate] = ACTIONS(2808),
    [sym_metavariable] = ACTIONS(2806),
    [sym_raw_string_literal] = ACTIONS(2806),
    [sym_float_literal] = ACTIONS(2806),
  },
  [755] = {
    [sym_line_comment] = STATE(755),
    [sym_block_comment] = STATE(755),
    [ts_builtin_sym_end] = ACTIONS(2810),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_macro_rules_BANG] = ACTIONS(2810),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_u8] = ACTIONS(2812),
    [anon_sym_i8] = ACTIONS(2812),
    [anon_sym_u16] = ACTIONS(2812),
    [anon_sym_i16] = ACTIONS(2812),
    [anon_sym_u32] = ACTIONS(2812),
    [anon_sym_i32] = ACTIONS(2812),
    [anon_sym_u64] = ACTIONS(2812),
    [anon_sym_i64] = ACTIONS(2812),
    [anon_sym_u128] = ACTIONS(2812),
    [anon_sym_i128] = ACTIONS(2812),
    [anon_sym_isize] = ACTIONS(2812),
    [anon_sym_usize] = ACTIONS(2812),
    [anon_sym_f32] = ACTIONS(2812),
    [anon_sym_f64] = ACTIONS(2812),
    [anon_sym_bool] = ACTIONS(2812),
    [anon_sym_str] = ACTIONS(2812),
    [anon_sym_char] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2810),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_AMP] = ACTIONS(2810),
    [anon_sym_POUND] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [anon_sym_fn] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_impl] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_loop] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_mod] = ACTIONS(2812),
    [anon_sym_pub] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_struct] = ACTIONS(2812),
    [anon_sym_trait] = ACTIONS(2812),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_union] = ACTIONS(2812),
    [anon_sym_unsafe] = ACTIONS(2812),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_extern] = ACTIONS(2812),
    [anon_sym_DOT_DOT] = ACTIONS(2810),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_move] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [sym_integer_literal] = ACTIONS(2810),
    [aux_sym_string_literal_token1] = ACTIONS(2810),
    [sym_char_literal] = ACTIONS(2810),
    [anon_sym_true] = ACTIONS(2812),
    [anon_sym_false] = ACTIONS(2812),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_crate] = ACTIONS(2812),
    [sym_metavariable] = ACTIONS(2810),
    [sym_raw_string_literal] = ACTIONS(2810),
    [sym_float_literal] = ACTIONS(2810),
  },
  [756] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_pattern] = STATE(3415),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(756),
    [sym_block_comment] = STATE(756),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [757] = {
    [sym_line_comment] = STATE(757),
    [sym_block_comment] = STATE(757),
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_macro_rules_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2814),
    [anon_sym_u8] = ACTIONS(2816),
    [anon_sym_i8] = ACTIONS(2816),
    [anon_sym_u16] = ACTIONS(2816),
    [anon_sym_i16] = ACTIONS(2816),
    [anon_sym_u32] = ACTIONS(2816),
    [anon_sym_i32] = ACTIONS(2816),
    [anon_sym_u64] = ACTIONS(2816),
    [anon_sym_i64] = ACTIONS(2816),
    [anon_sym_u128] = ACTIONS(2816),
    [anon_sym_i128] = ACTIONS(2816),
    [anon_sym_isize] = ACTIONS(2816),
    [anon_sym_usize] = ACTIONS(2816),
    [anon_sym_f32] = ACTIONS(2816),
    [anon_sym_f64] = ACTIONS(2816),
    [anon_sym_bool] = ACTIONS(2816),
    [anon_sym_str] = ACTIONS(2816),
    [anon_sym_char] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2814),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_POUND] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [anon_sym_fn] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_impl] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_loop] = ACTIONS(2816),
    [anon_sym_match] = ACTIONS(2816),
    [anon_sym_mod] = ACTIONS(2816),
    [anon_sym_pub] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_struct] = ACTIONS(2816),
    [anon_sym_trait] = ACTIONS(2816),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_union] = ACTIONS(2816),
    [anon_sym_unsafe] = ACTIONS(2816),
    [anon_sym_use] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_extern] = ACTIONS(2816),
    [anon_sym_DOT_DOT] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_move] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [sym_integer_literal] = ACTIONS(2814),
    [aux_sym_string_literal_token1] = ACTIONS(2814),
    [sym_char_literal] = ACTIONS(2814),
    [anon_sym_true] = ACTIONS(2816),
    [anon_sym_false] = ACTIONS(2816),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_crate] = ACTIONS(2816),
    [sym_metavariable] = ACTIONS(2814),
    [sym_raw_string_literal] = ACTIONS(2814),
    [sym_float_literal] = ACTIONS(2814),
  },
  [758] = {
    [sym_line_comment] = STATE(758),
    [sym_block_comment] = STATE(758),
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_macro_rules_BANG] = ACTIONS(2818),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_STAR] = ACTIONS(2818),
    [anon_sym_u8] = ACTIONS(2820),
    [anon_sym_i8] = ACTIONS(2820),
    [anon_sym_u16] = ACTIONS(2820),
    [anon_sym_i16] = ACTIONS(2820),
    [anon_sym_u32] = ACTIONS(2820),
    [anon_sym_i32] = ACTIONS(2820),
    [anon_sym_u64] = ACTIONS(2820),
    [anon_sym_i64] = ACTIONS(2820),
    [anon_sym_u128] = ACTIONS(2820),
    [anon_sym_i128] = ACTIONS(2820),
    [anon_sym_isize] = ACTIONS(2820),
    [anon_sym_usize] = ACTIONS(2820),
    [anon_sym_f32] = ACTIONS(2820),
    [anon_sym_f64] = ACTIONS(2820),
    [anon_sym_bool] = ACTIONS(2820),
    [anon_sym_str] = ACTIONS(2820),
    [anon_sym_char] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2818),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_POUND] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [anon_sym_fn] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_impl] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_loop] = ACTIONS(2820),
    [anon_sym_match] = ACTIONS(2820),
    [anon_sym_mod] = ACTIONS(2820),
    [anon_sym_pub] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_struct] = ACTIONS(2820),
    [anon_sym_trait] = ACTIONS(2820),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_union] = ACTIONS(2820),
    [anon_sym_unsafe] = ACTIONS(2820),
    [anon_sym_use] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_extern] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_move] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [sym_integer_literal] = ACTIONS(2818),
    [aux_sym_string_literal_token1] = ACTIONS(2818),
    [sym_char_literal] = ACTIONS(2818),
    [anon_sym_true] = ACTIONS(2820),
    [anon_sym_false] = ACTIONS(2820),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_crate] = ACTIONS(2820),
    [sym_metavariable] = ACTIONS(2818),
    [sym_raw_string_literal] = ACTIONS(2818),
    [sym_float_literal] = ACTIONS(2818),
  },
  [759] = {
    [sym_line_comment] = STATE(759),
    [sym_block_comment] = STATE(759),
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_macro_rules_BANG] = ACTIONS(2822),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_STAR] = ACTIONS(2822),
    [anon_sym_u8] = ACTIONS(2824),
    [anon_sym_i8] = ACTIONS(2824),
    [anon_sym_u16] = ACTIONS(2824),
    [anon_sym_i16] = ACTIONS(2824),
    [anon_sym_u32] = ACTIONS(2824),
    [anon_sym_i32] = ACTIONS(2824),
    [anon_sym_u64] = ACTIONS(2824),
    [anon_sym_i64] = ACTIONS(2824),
    [anon_sym_u128] = ACTIONS(2824),
    [anon_sym_i128] = ACTIONS(2824),
    [anon_sym_isize] = ACTIONS(2824),
    [anon_sym_usize] = ACTIONS(2824),
    [anon_sym_f32] = ACTIONS(2824),
    [anon_sym_f64] = ACTIONS(2824),
    [anon_sym_bool] = ACTIONS(2824),
    [anon_sym_str] = ACTIONS(2824),
    [anon_sym_char] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2822),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_POUND] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [anon_sym_fn] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_impl] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_loop] = ACTIONS(2824),
    [anon_sym_match] = ACTIONS(2824),
    [anon_sym_mod] = ACTIONS(2824),
    [anon_sym_pub] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_struct] = ACTIONS(2824),
    [anon_sym_trait] = ACTIONS(2824),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_union] = ACTIONS(2824),
    [anon_sym_unsafe] = ACTIONS(2824),
    [anon_sym_use] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_extern] = ACTIONS(2824),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_move] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [sym_integer_literal] = ACTIONS(2822),
    [aux_sym_string_literal_token1] = ACTIONS(2822),
    [sym_char_literal] = ACTIONS(2822),
    [anon_sym_true] = ACTIONS(2824),
    [anon_sym_false] = ACTIONS(2824),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_crate] = ACTIONS(2824),
    [sym_metavariable] = ACTIONS(2822),
    [sym_raw_string_literal] = ACTIONS(2822),
    [sym_float_literal] = ACTIONS(2822),
  },
  [760] = {
    [sym_line_comment] = STATE(760),
    [sym_block_comment] = STATE(760),
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_macro_rules_BANG] = ACTIONS(2826),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_u8] = ACTIONS(2828),
    [anon_sym_i8] = ACTIONS(2828),
    [anon_sym_u16] = ACTIONS(2828),
    [anon_sym_i16] = ACTIONS(2828),
    [anon_sym_u32] = ACTIONS(2828),
    [anon_sym_i32] = ACTIONS(2828),
    [anon_sym_u64] = ACTIONS(2828),
    [anon_sym_i64] = ACTIONS(2828),
    [anon_sym_u128] = ACTIONS(2828),
    [anon_sym_i128] = ACTIONS(2828),
    [anon_sym_isize] = ACTIONS(2828),
    [anon_sym_usize] = ACTIONS(2828),
    [anon_sym_f32] = ACTIONS(2828),
    [anon_sym_f64] = ACTIONS(2828),
    [anon_sym_bool] = ACTIONS(2828),
    [anon_sym_str] = ACTIONS(2828),
    [anon_sym_char] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2826),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_POUND] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
    [anon_sym_fn] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_impl] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_loop] = ACTIONS(2828),
    [anon_sym_match] = ACTIONS(2828),
    [anon_sym_mod] = ACTIONS(2828),
    [anon_sym_pub] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_struct] = ACTIONS(2828),
    [anon_sym_trait] = ACTIONS(2828),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_union] = ACTIONS(2828),
    [anon_sym_unsafe] = ACTIONS(2828),
    [anon_sym_use] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_extern] = ACTIONS(2828),
    [anon_sym_DOT_DOT] = ACTIONS(2826),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_move] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [sym_integer_literal] = ACTIONS(2826),
    [aux_sym_string_literal_token1] = ACTIONS(2826),
    [sym_char_literal] = ACTIONS(2826),
    [anon_sym_true] = ACTIONS(2828),
    [anon_sym_false] = ACTIONS(2828),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_crate] = ACTIONS(2828),
    [sym_metavariable] = ACTIONS(2826),
    [sym_raw_string_literal] = ACTIONS(2826),
    [sym_float_literal] = ACTIONS(2826),
  },
  [761] = {
    [sym_line_comment] = STATE(761),
    [sym_block_comment] = STATE(761),
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_macro_rules_BANG] = ACTIONS(2830),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2830),
    [anon_sym_u8] = ACTIONS(2832),
    [anon_sym_i8] = ACTIONS(2832),
    [anon_sym_u16] = ACTIONS(2832),
    [anon_sym_i16] = ACTIONS(2832),
    [anon_sym_u32] = ACTIONS(2832),
    [anon_sym_i32] = ACTIONS(2832),
    [anon_sym_u64] = ACTIONS(2832),
    [anon_sym_i64] = ACTIONS(2832),
    [anon_sym_u128] = ACTIONS(2832),
    [anon_sym_i128] = ACTIONS(2832),
    [anon_sym_isize] = ACTIONS(2832),
    [anon_sym_usize] = ACTIONS(2832),
    [anon_sym_f32] = ACTIONS(2832),
    [anon_sym_f64] = ACTIONS(2832),
    [anon_sym_bool] = ACTIONS(2832),
    [anon_sym_str] = ACTIONS(2832),
    [anon_sym_char] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2830),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_POUND] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
    [anon_sym_fn] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_impl] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_loop] = ACTIONS(2832),
    [anon_sym_match] = ACTIONS(2832),
    [anon_sym_mod] = ACTIONS(2832),
    [anon_sym_pub] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_struct] = ACTIONS(2832),
    [anon_sym_trait] = ACTIONS(2832),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_union] = ACTIONS(2832),
    [anon_sym_unsafe] = ACTIONS(2832),
    [anon_sym_use] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_extern] = ACTIONS(2832),
    [anon_sym_DOT_DOT] = ACTIONS(2830),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_move] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [sym_integer_literal] = ACTIONS(2830),
    [aux_sym_string_literal_token1] = ACTIONS(2830),
    [sym_char_literal] = ACTIONS(2830),
    [anon_sym_true] = ACTIONS(2832),
    [anon_sym_false] = ACTIONS(2832),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_crate] = ACTIONS(2832),
    [sym_metavariable] = ACTIONS(2830),
    [sym_raw_string_literal] = ACTIONS(2830),
    [sym_float_literal] = ACTIONS(2830),
  },
  [762] = {
    [sym_line_comment] = STATE(762),
    [sym_block_comment] = STATE(762),
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_macro_rules_BANG] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2834),
    [anon_sym_u8] = ACTIONS(2836),
    [anon_sym_i8] = ACTIONS(2836),
    [anon_sym_u16] = ACTIONS(2836),
    [anon_sym_i16] = ACTIONS(2836),
    [anon_sym_u32] = ACTIONS(2836),
    [anon_sym_i32] = ACTIONS(2836),
    [anon_sym_u64] = ACTIONS(2836),
    [anon_sym_i64] = ACTIONS(2836),
    [anon_sym_u128] = ACTIONS(2836),
    [anon_sym_i128] = ACTIONS(2836),
    [anon_sym_isize] = ACTIONS(2836),
    [anon_sym_usize] = ACTIONS(2836),
    [anon_sym_f32] = ACTIONS(2836),
    [anon_sym_f64] = ACTIONS(2836),
    [anon_sym_bool] = ACTIONS(2836),
    [anon_sym_str] = ACTIONS(2836),
    [anon_sym_char] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2834),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_POUND] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_PIPE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [anon_sym_fn] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_impl] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_loop] = ACTIONS(2836),
    [anon_sym_match] = ACTIONS(2836),
    [anon_sym_mod] = ACTIONS(2836),
    [anon_sym_pub] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_struct] = ACTIONS(2836),
    [anon_sym_trait] = ACTIONS(2836),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_union] = ACTIONS(2836),
    [anon_sym_unsafe] = ACTIONS(2836),
    [anon_sym_use] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_extern] = ACTIONS(2836),
    [anon_sym_DOT_DOT] = ACTIONS(2834),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_move] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [sym_integer_literal] = ACTIONS(2834),
    [aux_sym_string_literal_token1] = ACTIONS(2834),
    [sym_char_literal] = ACTIONS(2834),
    [anon_sym_true] = ACTIONS(2836),
    [anon_sym_false] = ACTIONS(2836),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_crate] = ACTIONS(2836),
    [sym_metavariable] = ACTIONS(2834),
    [sym_raw_string_literal] = ACTIONS(2834),
    [sym_float_literal] = ACTIONS(2834),
  },
  [763] = {
    [sym_line_comment] = STATE(763),
    [sym_block_comment] = STATE(763),
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym_macro_rules_BANG] = ACTIONS(2838),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_STAR] = ACTIONS(2838),
    [anon_sym_u8] = ACTIONS(2840),
    [anon_sym_i8] = ACTIONS(2840),
    [anon_sym_u16] = ACTIONS(2840),
    [anon_sym_i16] = ACTIONS(2840),
    [anon_sym_u32] = ACTIONS(2840),
    [anon_sym_i32] = ACTIONS(2840),
    [anon_sym_u64] = ACTIONS(2840),
    [anon_sym_i64] = ACTIONS(2840),
    [anon_sym_u128] = ACTIONS(2840),
    [anon_sym_i128] = ACTIONS(2840),
    [anon_sym_isize] = ACTIONS(2840),
    [anon_sym_usize] = ACTIONS(2840),
    [anon_sym_f32] = ACTIONS(2840),
    [anon_sym_f64] = ACTIONS(2840),
    [anon_sym_bool] = ACTIONS(2840),
    [anon_sym_str] = ACTIONS(2840),
    [anon_sym_char] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_POUND] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_PIPE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
    [anon_sym_fn] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_if] = ACTIONS(2840),
    [anon_sym_impl] = ACTIONS(2840),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_loop] = ACTIONS(2840),
    [anon_sym_match] = ACTIONS(2840),
    [anon_sym_mod] = ACTIONS(2840),
    [anon_sym_pub] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_struct] = ACTIONS(2840),
    [anon_sym_trait] = ACTIONS(2840),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_union] = ACTIONS(2840),
    [anon_sym_unsafe] = ACTIONS(2840),
    [anon_sym_use] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_extern] = ACTIONS(2840),
    [anon_sym_DOT_DOT] = ACTIONS(2838),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_move] = ACTIONS(2840),
    [anon_sym_try] = ACTIONS(2840),
    [sym_integer_literal] = ACTIONS(2838),
    [aux_sym_string_literal_token1] = ACTIONS(2838),
    [sym_char_literal] = ACTIONS(2838),
    [anon_sym_true] = ACTIONS(2840),
    [anon_sym_false] = ACTIONS(2840),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_crate] = ACTIONS(2840),
    [sym_metavariable] = ACTIONS(2838),
    [sym_raw_string_literal] = ACTIONS(2838),
    [sym_float_literal] = ACTIONS(2838),
  },
  [764] = {
    [sym_line_comment] = STATE(764),
    [sym_block_comment] = STATE(764),
    [ts_builtin_sym_end] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_macro_rules_BANG] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2842),
    [anon_sym_u8] = ACTIONS(2844),
    [anon_sym_i8] = ACTIONS(2844),
    [anon_sym_u16] = ACTIONS(2844),
    [anon_sym_i16] = ACTIONS(2844),
    [anon_sym_u32] = ACTIONS(2844),
    [anon_sym_i32] = ACTIONS(2844),
    [anon_sym_u64] = ACTIONS(2844),
    [anon_sym_i64] = ACTIONS(2844),
    [anon_sym_u128] = ACTIONS(2844),
    [anon_sym_i128] = ACTIONS(2844),
    [anon_sym_isize] = ACTIONS(2844),
    [anon_sym_usize] = ACTIONS(2844),
    [anon_sym_f32] = ACTIONS(2844),
    [anon_sym_f64] = ACTIONS(2844),
    [anon_sym_bool] = ACTIONS(2844),
    [anon_sym_str] = ACTIONS(2844),
    [anon_sym_char] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_POUND] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_PIPE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
    [anon_sym_fn] = ACTIONS(2844),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_if] = ACTIONS(2844),
    [anon_sym_impl] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_loop] = ACTIONS(2844),
    [anon_sym_match] = ACTIONS(2844),
    [anon_sym_mod] = ACTIONS(2844),
    [anon_sym_pub] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_struct] = ACTIONS(2844),
    [anon_sym_trait] = ACTIONS(2844),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_union] = ACTIONS(2844),
    [anon_sym_unsafe] = ACTIONS(2844),
    [anon_sym_use] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_extern] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2842),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_move] = ACTIONS(2844),
    [anon_sym_try] = ACTIONS(2844),
    [sym_integer_literal] = ACTIONS(2842),
    [aux_sym_string_literal_token1] = ACTIONS(2842),
    [sym_char_literal] = ACTIONS(2842),
    [anon_sym_true] = ACTIONS(2844),
    [anon_sym_false] = ACTIONS(2844),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [sym_crate] = ACTIONS(2844),
    [sym_metavariable] = ACTIONS(2842),
    [sym_raw_string_literal] = ACTIONS(2842),
    [sym_float_literal] = ACTIONS(2842),
  },
  [765] = {
    [sym_attribute_item] = STATE(846),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_match_pattern] = STATE(3479),
    [sym_const_block] = STATE(2721),
    [sym_closure_expression] = STATE(3134),
    [sym_closure_parameters] = STATE(131),
    [sym__pattern] = STATE(2855),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(765),
    [sym_block_comment] = STATE(765),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_move] = ACTIONS(1574),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [766] = {
    [sym_line_comment] = STATE(766),
    [sym_block_comment] = STATE(766),
    [ts_builtin_sym_end] = ACTIONS(2846),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_macro_rules_BANG] = ACTIONS(2846),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2846),
    [anon_sym_u8] = ACTIONS(2848),
    [anon_sym_i8] = ACTIONS(2848),
    [anon_sym_u16] = ACTIONS(2848),
    [anon_sym_i16] = ACTIONS(2848),
    [anon_sym_u32] = ACTIONS(2848),
    [anon_sym_i32] = ACTIONS(2848),
    [anon_sym_u64] = ACTIONS(2848),
    [anon_sym_i64] = ACTIONS(2848),
    [anon_sym_u128] = ACTIONS(2848),
    [anon_sym_i128] = ACTIONS(2848),
    [anon_sym_isize] = ACTIONS(2848),
    [anon_sym_usize] = ACTIONS(2848),
    [anon_sym_f32] = ACTIONS(2848),
    [anon_sym_f64] = ACTIONS(2848),
    [anon_sym_bool] = ACTIONS(2848),
    [anon_sym_str] = ACTIONS(2848),
    [anon_sym_char] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2846),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_POUND] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2846),
    [anon_sym_PIPE] = ACTIONS(2846),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
    [anon_sym_fn] = ACTIONS(2848),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_impl] = ACTIONS(2848),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_loop] = ACTIONS(2848),
    [anon_sym_match] = ACTIONS(2848),
    [anon_sym_mod] = ACTIONS(2848),
    [anon_sym_pub] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_struct] = ACTIONS(2848),
    [anon_sym_trait] = ACTIONS(2848),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_union] = ACTIONS(2848),
    [anon_sym_unsafe] = ACTIONS(2848),
    [anon_sym_use] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_extern] = ACTIONS(2848),
    [anon_sym_DOT_DOT] = ACTIONS(2846),
    [anon_sym_yield] = ACTIONS(2848),
    [anon_sym_move] = ACTIONS(2848),
    [anon_sym_try] = ACTIONS(2848),
    [sym_integer_literal] = ACTIONS(2846),
    [aux_sym_string_literal_token1] = ACTIONS(2846),
    [sym_char_literal] = ACTIONS(2846),
    [anon_sym_true] = ACTIONS(2848),
    [anon_sym_false] = ACTIONS(2848),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [sym_crate] = ACTIONS(2848),
    [sym_metavariable] = ACTIONS(2846),
    [sym_raw_string_literal] = ACTIONS(2846),
    [sym_float_literal] = ACTIONS(2846),
  },
  [767] = {
    [sym_line_comment] = STATE(767),
    [sym_block_comment] = STATE(767),
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_macro_rules_BANG] = ACTIONS(2850),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2850),
    [anon_sym_u8] = ACTIONS(2852),
    [anon_sym_i8] = ACTIONS(2852),
    [anon_sym_u16] = ACTIONS(2852),
    [anon_sym_i16] = ACTIONS(2852),
    [anon_sym_u32] = ACTIONS(2852),
    [anon_sym_i32] = ACTIONS(2852),
    [anon_sym_u64] = ACTIONS(2852),
    [anon_sym_i64] = ACTIONS(2852),
    [anon_sym_u128] = ACTIONS(2852),
    [anon_sym_i128] = ACTIONS(2852),
    [anon_sym_isize] = ACTIONS(2852),
    [anon_sym_usize] = ACTIONS(2852),
    [anon_sym_f32] = ACTIONS(2852),
    [anon_sym_f64] = ACTIONS(2852),
    [anon_sym_bool] = ACTIONS(2852),
    [anon_sym_str] = ACTIONS(2852),
    [anon_sym_char] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_POUND] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
    [anon_sym_fn] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_impl] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_loop] = ACTIONS(2852),
    [anon_sym_match] = ACTIONS(2852),
    [anon_sym_mod] = ACTIONS(2852),
    [anon_sym_pub] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_struct] = ACTIONS(2852),
    [anon_sym_trait] = ACTIONS(2852),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_union] = ACTIONS(2852),
    [anon_sym_unsafe] = ACTIONS(2852),
    [anon_sym_use] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_extern] = ACTIONS(2852),
    [anon_sym_DOT_DOT] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_move] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [sym_integer_literal] = ACTIONS(2850),
    [aux_sym_string_literal_token1] = ACTIONS(2850),
    [sym_char_literal] = ACTIONS(2850),
    [anon_sym_true] = ACTIONS(2852),
    [anon_sym_false] = ACTIONS(2852),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_crate] = ACTIONS(2852),
    [sym_metavariable] = ACTIONS(2850),
    [sym_raw_string_literal] = ACTIONS(2850),
    [sym_float_literal] = ACTIONS(2850),
  },
  [768] = {
    [sym_line_comment] = STATE(768),
    [sym_block_comment] = STATE(768),
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_macro_rules_BANG] = ACTIONS(2854),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_u8] = ACTIONS(2856),
    [anon_sym_i8] = ACTIONS(2856),
    [anon_sym_u16] = ACTIONS(2856),
    [anon_sym_i16] = ACTIONS(2856),
    [anon_sym_u32] = ACTIONS(2856),
    [anon_sym_i32] = ACTIONS(2856),
    [anon_sym_u64] = ACTIONS(2856),
    [anon_sym_i64] = ACTIONS(2856),
    [anon_sym_u128] = ACTIONS(2856),
    [anon_sym_i128] = ACTIONS(2856),
    [anon_sym_isize] = ACTIONS(2856),
    [anon_sym_usize] = ACTIONS(2856),
    [anon_sym_f32] = ACTIONS(2856),
    [anon_sym_f64] = ACTIONS(2856),
    [anon_sym_bool] = ACTIONS(2856),
    [anon_sym_str] = ACTIONS(2856),
    [anon_sym_char] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2854),
    [anon_sym_COLON_COLON] = ACTIONS(2854),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2854),
    [anon_sym_POUND] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_fn] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_impl] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_loop] = ACTIONS(2856),
    [anon_sym_match] = ACTIONS(2856),
    [anon_sym_mod] = ACTIONS(2856),
    [anon_sym_pub] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_struct] = ACTIONS(2856),
    [anon_sym_trait] = ACTIONS(2856),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_union] = ACTIONS(2856),
    [anon_sym_unsafe] = ACTIONS(2856),
    [anon_sym_use] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_extern] = ACTIONS(2856),
    [anon_sym_DOT_DOT] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_move] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [sym_integer_literal] = ACTIONS(2854),
    [aux_sym_string_literal_token1] = ACTIONS(2854),
    [sym_char_literal] = ACTIONS(2854),
    [anon_sym_true] = ACTIONS(2856),
    [anon_sym_false] = ACTIONS(2856),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_crate] = ACTIONS(2856),
    [sym_metavariable] = ACTIONS(2854),
    [sym_raw_string_literal] = ACTIONS(2854),
    [sym_float_literal] = ACTIONS(2854),
  },
  [769] = {
    [sym_line_comment] = STATE(769),
    [sym_block_comment] = STATE(769),
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_macro_rules_BANG] = ACTIONS(2858),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_u8] = ACTIONS(2860),
    [anon_sym_i8] = ACTIONS(2860),
    [anon_sym_u16] = ACTIONS(2860),
    [anon_sym_i16] = ACTIONS(2860),
    [anon_sym_u32] = ACTIONS(2860),
    [anon_sym_i32] = ACTIONS(2860),
    [anon_sym_u64] = ACTIONS(2860),
    [anon_sym_i64] = ACTIONS(2860),
    [anon_sym_u128] = ACTIONS(2860),
    [anon_sym_i128] = ACTIONS(2860),
    [anon_sym_isize] = ACTIONS(2860),
    [anon_sym_usize] = ACTIONS(2860),
    [anon_sym_f32] = ACTIONS(2860),
    [anon_sym_f64] = ACTIONS(2860),
    [anon_sym_bool] = ACTIONS(2860),
    [anon_sym_str] = ACTIONS(2860),
    [anon_sym_char] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2858),
    [anon_sym_POUND] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_PIPE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2860),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [anon_sym_fn] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_impl] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_loop] = ACTIONS(2860),
    [anon_sym_match] = ACTIONS(2860),
    [anon_sym_mod] = ACTIONS(2860),
    [anon_sym_pub] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_struct] = ACTIONS(2860),
    [anon_sym_trait] = ACTIONS(2860),
    [anon_sym_type] = ACTIONS(2860),
    [anon_sym_union] = ACTIONS(2860),
    [anon_sym_unsafe] = ACTIONS(2860),
    [anon_sym_use] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_extern] = ACTIONS(2860),
    [anon_sym_DOT_DOT] = ACTIONS(2858),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_move] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [sym_integer_literal] = ACTIONS(2858),
    [aux_sym_string_literal_token1] = ACTIONS(2858),
    [sym_char_literal] = ACTIONS(2858),
    [anon_sym_true] = ACTIONS(2860),
    [anon_sym_false] = ACTIONS(2860),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2860),
    [sym_super] = ACTIONS(2860),
    [sym_crate] = ACTIONS(2860),
    [sym_metavariable] = ACTIONS(2858),
    [sym_raw_string_literal] = ACTIONS(2858),
    [sym_float_literal] = ACTIONS(2858),
  },
  [770] = {
    [sym_line_comment] = STATE(770),
    [sym_block_comment] = STATE(770),
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_macro_rules_BANG] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_u8] = ACTIONS(2864),
    [anon_sym_i8] = ACTIONS(2864),
    [anon_sym_u16] = ACTIONS(2864),
    [anon_sym_i16] = ACTIONS(2864),
    [anon_sym_u32] = ACTIONS(2864),
    [anon_sym_i32] = ACTIONS(2864),
    [anon_sym_u64] = ACTIONS(2864),
    [anon_sym_i64] = ACTIONS(2864),
    [anon_sym_u128] = ACTIONS(2864),
    [anon_sym_i128] = ACTIONS(2864),
    [anon_sym_isize] = ACTIONS(2864),
    [anon_sym_usize] = ACTIONS(2864),
    [anon_sym_f32] = ACTIONS(2864),
    [anon_sym_f64] = ACTIONS(2864),
    [anon_sym_bool] = ACTIONS(2864),
    [anon_sym_str] = ACTIONS(2864),
    [anon_sym_char] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2862),
    [anon_sym_COLON_COLON] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_POUND] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2864),
    [anon_sym_break] = ACTIONS(2864),
    [anon_sym_const] = ACTIONS(2864),
    [anon_sym_continue] = ACTIONS(2864),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_enum] = ACTIONS(2864),
    [anon_sym_fn] = ACTIONS(2864),
    [anon_sym_for] = ACTIONS(2864),
    [anon_sym_if] = ACTIONS(2864),
    [anon_sym_impl] = ACTIONS(2864),
    [anon_sym_let] = ACTIONS(2864),
    [anon_sym_loop] = ACTIONS(2864),
    [anon_sym_match] = ACTIONS(2864),
    [anon_sym_mod] = ACTIONS(2864),
    [anon_sym_pub] = ACTIONS(2864),
    [anon_sym_return] = ACTIONS(2864),
    [anon_sym_static] = ACTIONS(2864),
    [anon_sym_struct] = ACTIONS(2864),
    [anon_sym_trait] = ACTIONS(2864),
    [anon_sym_type] = ACTIONS(2864),
    [anon_sym_union] = ACTIONS(2864),
    [anon_sym_unsafe] = ACTIONS(2864),
    [anon_sym_use] = ACTIONS(2864),
    [anon_sym_while] = ACTIONS(2864),
    [anon_sym_extern] = ACTIONS(2864),
    [anon_sym_DOT_DOT] = ACTIONS(2862),
    [anon_sym_yield] = ACTIONS(2864),
    [anon_sym_move] = ACTIONS(2864),
    [anon_sym_try] = ACTIONS(2864),
    [sym_integer_literal] = ACTIONS(2862),
    [aux_sym_string_literal_token1] = ACTIONS(2862),
    [sym_char_literal] = ACTIONS(2862),
    [anon_sym_true] = ACTIONS(2864),
    [anon_sym_false] = ACTIONS(2864),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2864),
    [sym_super] = ACTIONS(2864),
    [sym_crate] = ACTIONS(2864),
    [sym_metavariable] = ACTIONS(2862),
    [sym_raw_string_literal] = ACTIONS(2862),
    [sym_float_literal] = ACTIONS(2862),
  },
  [771] = {
    [sym_line_comment] = STATE(771),
    [sym_block_comment] = STATE(771),
    [ts_builtin_sym_end] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2868),
    [anon_sym_SEMI] = ACTIONS(2866),
    [anon_sym_macro_rules_BANG] = ACTIONS(2866),
    [anon_sym_LPAREN] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_u8] = ACTIONS(2868),
    [anon_sym_i8] = ACTIONS(2868),
    [anon_sym_u16] = ACTIONS(2868),
    [anon_sym_i16] = ACTIONS(2868),
    [anon_sym_u32] = ACTIONS(2868),
    [anon_sym_i32] = ACTIONS(2868),
    [anon_sym_u64] = ACTIONS(2868),
    [anon_sym_i64] = ACTIONS(2868),
    [anon_sym_u128] = ACTIONS(2868),
    [anon_sym_i128] = ACTIONS(2868),
    [anon_sym_isize] = ACTIONS(2868),
    [anon_sym_usize] = ACTIONS(2868),
    [anon_sym_f32] = ACTIONS(2868),
    [anon_sym_f64] = ACTIONS(2868),
    [anon_sym_bool] = ACTIONS(2868),
    [anon_sym_str] = ACTIONS(2868),
    [anon_sym_char] = ACTIONS(2868),
    [anon_sym_DASH] = ACTIONS(2866),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_AMP] = ACTIONS(2866),
    [anon_sym_POUND] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_PIPE] = ACTIONS(2866),
    [anon_sym_SQUOTE] = ACTIONS(2868),
    [anon_sym_async] = ACTIONS(2868),
    [anon_sym_break] = ACTIONS(2868),
    [anon_sym_const] = ACTIONS(2868),
    [anon_sym_continue] = ACTIONS(2868),
    [anon_sym_default] = ACTIONS(2868),
    [anon_sym_enum] = ACTIONS(2868),
    [anon_sym_fn] = ACTIONS(2868),
    [anon_sym_for] = ACTIONS(2868),
    [anon_sym_if] = ACTIONS(2868),
    [anon_sym_impl] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_loop] = ACTIONS(2868),
    [anon_sym_match] = ACTIONS(2868),
    [anon_sym_mod] = ACTIONS(2868),
    [anon_sym_pub] = ACTIONS(2868),
    [anon_sym_return] = ACTIONS(2868),
    [anon_sym_static] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2868),
    [anon_sym_trait] = ACTIONS(2868),
    [anon_sym_type] = ACTIONS(2868),
    [anon_sym_union] = ACTIONS(2868),
    [anon_sym_unsafe] = ACTIONS(2868),
    [anon_sym_use] = ACTIONS(2868),
    [anon_sym_while] = ACTIONS(2868),
    [anon_sym_extern] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2866),
    [anon_sym_yield] = ACTIONS(2868),
    [anon_sym_move] = ACTIONS(2868),
    [anon_sym_try] = ACTIONS(2868),
    [sym_integer_literal] = ACTIONS(2866),
    [aux_sym_string_literal_token1] = ACTIONS(2866),
    [sym_char_literal] = ACTIONS(2866),
    [anon_sym_true] = ACTIONS(2868),
    [anon_sym_false] = ACTIONS(2868),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2868),
    [sym_super] = ACTIONS(2868),
    [sym_crate] = ACTIONS(2868),
    [sym_metavariable] = ACTIONS(2866),
    [sym_raw_string_literal] = ACTIONS(2866),
    [sym_float_literal] = ACTIONS(2866),
  },
  [772] = {
    [sym_line_comment] = STATE(772),
    [sym_block_comment] = STATE(772),
    [ts_builtin_sym_end] = ACTIONS(2870),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_macro_rules_BANG] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2870),
    [anon_sym_u8] = ACTIONS(2872),
    [anon_sym_i8] = ACTIONS(2872),
    [anon_sym_u16] = ACTIONS(2872),
    [anon_sym_i16] = ACTIONS(2872),
    [anon_sym_u32] = ACTIONS(2872),
    [anon_sym_i32] = ACTIONS(2872),
    [anon_sym_u64] = ACTIONS(2872),
    [anon_sym_i64] = ACTIONS(2872),
    [anon_sym_u128] = ACTIONS(2872),
    [anon_sym_i128] = ACTIONS(2872),
    [anon_sym_isize] = ACTIONS(2872),
    [anon_sym_usize] = ACTIONS(2872),
    [anon_sym_f32] = ACTIONS(2872),
    [anon_sym_f64] = ACTIONS(2872),
    [anon_sym_bool] = ACTIONS(2872),
    [anon_sym_str] = ACTIONS(2872),
    [anon_sym_char] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_COLON_COLON] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_AMP] = ACTIONS(2870),
    [anon_sym_POUND] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_PIPE] = ACTIONS(2870),
    [anon_sym_SQUOTE] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_fn] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_impl] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_loop] = ACTIONS(2872),
    [anon_sym_match] = ACTIONS(2872),
    [anon_sym_mod] = ACTIONS(2872),
    [anon_sym_pub] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_struct] = ACTIONS(2872),
    [anon_sym_trait] = ACTIONS(2872),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_union] = ACTIONS(2872),
    [anon_sym_unsafe] = ACTIONS(2872),
    [anon_sym_use] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_extern] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2870),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_move] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [sym_integer_literal] = ACTIONS(2870),
    [aux_sym_string_literal_token1] = ACTIONS(2870),
    [sym_char_literal] = ACTIONS(2870),
    [anon_sym_true] = ACTIONS(2872),
    [anon_sym_false] = ACTIONS(2872),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_crate] = ACTIONS(2872),
    [sym_metavariable] = ACTIONS(2870),
    [sym_raw_string_literal] = ACTIONS(2870),
    [sym_float_literal] = ACTIONS(2870),
  },
  [773] = {
    [sym_line_comment] = STATE(773),
    [sym_block_comment] = STATE(773),
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_macro_rules_BANG] = ACTIONS(2874),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2874),
    [anon_sym_u8] = ACTIONS(2876),
    [anon_sym_i8] = ACTIONS(2876),
    [anon_sym_u16] = ACTIONS(2876),
    [anon_sym_i16] = ACTIONS(2876),
    [anon_sym_u32] = ACTIONS(2876),
    [anon_sym_i32] = ACTIONS(2876),
    [anon_sym_u64] = ACTIONS(2876),
    [anon_sym_i64] = ACTIONS(2876),
    [anon_sym_u128] = ACTIONS(2876),
    [anon_sym_i128] = ACTIONS(2876),
    [anon_sym_isize] = ACTIONS(2876),
    [anon_sym_usize] = ACTIONS(2876),
    [anon_sym_f32] = ACTIONS(2876),
    [anon_sym_f64] = ACTIONS(2876),
    [anon_sym_bool] = ACTIONS(2876),
    [anon_sym_str] = ACTIONS(2876),
    [anon_sym_char] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2874),
    [anon_sym_COLON_COLON] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_POUND] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [anon_sym_fn] = ACTIONS(2876),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_impl] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_loop] = ACTIONS(2876),
    [anon_sym_match] = ACTIONS(2876),
    [anon_sym_mod] = ACTIONS(2876),
    [anon_sym_pub] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_trait] = ACTIONS(2876),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2876),
    [anon_sym_unsafe] = ACTIONS(2876),
    [anon_sym_use] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_extern] = ACTIONS(2876),
    [anon_sym_DOT_DOT] = ACTIONS(2874),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_move] = ACTIONS(2876),
    [anon_sym_try] = ACTIONS(2876),
    [sym_integer_literal] = ACTIONS(2874),
    [aux_sym_string_literal_token1] = ACTIONS(2874),
    [sym_char_literal] = ACTIONS(2874),
    [anon_sym_true] = ACTIONS(2876),
    [anon_sym_false] = ACTIONS(2876),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [sym_crate] = ACTIONS(2876),
    [sym_metavariable] = ACTIONS(2874),
    [sym_raw_string_literal] = ACTIONS(2874),
    [sym_float_literal] = ACTIONS(2874),
  },
  [774] = {
    [sym_line_comment] = STATE(774),
    [sym_block_comment] = STATE(774),
    [ts_builtin_sym_end] = ACTIONS(2878),
    [sym_identifier] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_macro_rules_BANG] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_STAR] = ACTIONS(2878),
    [anon_sym_u8] = ACTIONS(2880),
    [anon_sym_i8] = ACTIONS(2880),
    [anon_sym_u16] = ACTIONS(2880),
    [anon_sym_i16] = ACTIONS(2880),
    [anon_sym_u32] = ACTIONS(2880),
    [anon_sym_i32] = ACTIONS(2880),
    [anon_sym_u64] = ACTIONS(2880),
    [anon_sym_i64] = ACTIONS(2880),
    [anon_sym_u128] = ACTIONS(2880),
    [anon_sym_i128] = ACTIONS(2880),
    [anon_sym_isize] = ACTIONS(2880),
    [anon_sym_usize] = ACTIONS(2880),
    [anon_sym_f32] = ACTIONS(2880),
    [anon_sym_f64] = ACTIONS(2880),
    [anon_sym_bool] = ACTIONS(2880),
    [anon_sym_str] = ACTIONS(2880),
    [anon_sym_char] = ACTIONS(2880),
    [anon_sym_DASH] = ACTIONS(2878),
    [anon_sym_COLON_COLON] = ACTIONS(2878),
    [anon_sym_BANG] = ACTIONS(2878),
    [anon_sym_AMP] = ACTIONS(2878),
    [anon_sym_POUND] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SQUOTE] = ACTIONS(2880),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_break] = ACTIONS(2880),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_continue] = ACTIONS(2880),
    [anon_sym_default] = ACTIONS(2880),
    [anon_sym_enum] = ACTIONS(2880),
    [anon_sym_fn] = ACTIONS(2880),
    [anon_sym_for] = ACTIONS(2880),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_impl] = ACTIONS(2880),
    [anon_sym_let] = ACTIONS(2880),
    [anon_sym_loop] = ACTIONS(2880),
    [anon_sym_match] = ACTIONS(2880),
    [anon_sym_mod] = ACTIONS(2880),
    [anon_sym_pub] = ACTIONS(2880),
    [anon_sym_return] = ACTIONS(2880),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_struct] = ACTIONS(2880),
    [anon_sym_trait] = ACTIONS(2880),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_union] = ACTIONS(2880),
    [anon_sym_unsafe] = ACTIONS(2880),
    [anon_sym_use] = ACTIONS(2880),
    [anon_sym_while] = ACTIONS(2880),
    [anon_sym_extern] = ACTIONS(2880),
    [anon_sym_DOT_DOT] = ACTIONS(2878),
    [anon_sym_yield] = ACTIONS(2880),
    [anon_sym_move] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2880),
    [sym_integer_literal] = ACTIONS(2878),
    [aux_sym_string_literal_token1] = ACTIONS(2878),
    [sym_char_literal] = ACTIONS(2878),
    [anon_sym_true] = ACTIONS(2880),
    [anon_sym_false] = ACTIONS(2880),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2880),
    [sym_super] = ACTIONS(2880),
    [sym_crate] = ACTIONS(2880),
    [sym_metavariable] = ACTIONS(2878),
    [sym_raw_string_literal] = ACTIONS(2878),
    [sym_float_literal] = ACTIONS(2878),
  },
  [775] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(2885),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2647),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(2892),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [776] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(2865),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2653),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [777] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(3123),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2801),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [778] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(3123),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2801),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(778),
    [sym_block_comment] = STATE(778),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [779] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(3123),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2801),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(779),
    [sym_block_comment] = STATE(779),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [780] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(3123),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2801),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [781] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym_closure_expression] = STATE(3123),
    [sym_closure_parameters] = STATE(122),
    [sym__pattern] = STATE(2801),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_move] = ACTIONS(1187),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [782] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(910),
    [sym__type] = STATE(2679),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(782),
    [sym_block_comment] = STATE(782),
    [aux_sym_enum_variant_list_repeat1] = STATE(794),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [783] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(783),
    [sym_block_comment] = STATE(783),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [784] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(784),
    [sym_block_comment] = STATE(784),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [785] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(785),
    [sym_block_comment] = STATE(785),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [786] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(786),
    [sym_block_comment] = STATE(786),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [787] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(787),
    [sym_block_comment] = STATE(787),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [788] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(788),
    [sym_block_comment] = STATE(788),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [789] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(886),
    [sym__type] = STATE(2785),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(789),
    [sym_block_comment] = STATE(789),
    [aux_sym_enum_variant_list_repeat1] = STATE(796),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [790] = {
    [sym_parameter] = STATE(2800),
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2516),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(2944),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2946),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [791] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2632),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [792] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2649),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2948),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [793] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2536),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [794] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(885),
    [sym__type] = STATE(2628),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(794),
    [sym_block_comment] = STATE(794),
    [aux_sym_enum_variant_list_repeat1] = STATE(1458),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [795] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2674),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [796] = {
    [sym_attribute_item] = STATE(1493),
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym_visibility_modifier] = STATE(954),
    [sym__type] = STATE(2720),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(796),
    [sym_block_comment] = STATE(796),
    [aux_sym_enum_variant_list_repeat1] = STATE(1458),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_pub] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(2928),
    [sym_metavariable] = ACTIONS(1626),
  },
  [797] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2960),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [798] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [799] = {
    [sym_attribute_item] = STATE(846),
    [sym_line_comment] = STATE(799),
    [sym_block_comment] = STATE(799),
    [aux_sym_enum_variant_list_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_RBRACK] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_u8] = ACTIONS(2964),
    [anon_sym_i8] = ACTIONS(2964),
    [anon_sym_u16] = ACTIONS(2964),
    [anon_sym_i16] = ACTIONS(2964),
    [anon_sym_u32] = ACTIONS(2964),
    [anon_sym_i32] = ACTIONS(2964),
    [anon_sym_u64] = ACTIONS(2964),
    [anon_sym_i64] = ACTIONS(2964),
    [anon_sym_u128] = ACTIONS(2964),
    [anon_sym_i128] = ACTIONS(2964),
    [anon_sym_isize] = ACTIONS(2964),
    [anon_sym_usize] = ACTIONS(2964),
    [anon_sym_f32] = ACTIONS(2964),
    [anon_sym_f64] = ACTIONS(2964),
    [anon_sym_bool] = ACTIONS(2964),
    [anon_sym_str] = ACTIONS(2964),
    [anon_sym_char] = ACTIONS(2964),
    [anon_sym__] = ACTIONS(2964),
    [anon_sym_DASH] = ACTIONS(542),
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_COLON_COLON] = ACTIONS(542),
    [anon_sym_BANG] = ACTIONS(542),
    [anon_sym_AMP] = ACTIONS(542),
    [anon_sym_POUND] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [anon_sym_async] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_loop] = ACTIONS(2964),
    [anon_sym_match] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_unsafe] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_ref] = ACTIONS(2964),
    [sym_mutable_specifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT] = ACTIONS(542),
    [anon_sym_yield] = ACTIONS(2964),
    [anon_sym_move] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [sym_integer_literal] = ACTIONS(542),
    [aux_sym_string_literal_token1] = ACTIONS(542),
    [sym_char_literal] = ACTIONS(542),
    [anon_sym_true] = ACTIONS(2964),
    [anon_sym_false] = ACTIONS(2964),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2964),
    [sym_super] = ACTIONS(2964),
    [sym_crate] = ACTIONS(2964),
    [sym_metavariable] = ACTIONS(542),
    [sym_raw_string_literal] = ACTIONS(542),
    [sym_float_literal] = ACTIONS(542),
  },
  [800] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_const_parameter] = STATE(2829),
    [sym_constrained_type_parameter] = STATE(2537),
    [sym_optional_type_parameter] = STATE(2829),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2777),
    [sym_bracketed_type] = STATE(3309),
    [sym_qualified_type] = STATE(3302),
    [sym_lifetime] = STATE(2302),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(800),
    [sym_block_comment] = STATE(800),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(2972),
  },
  [801] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2974),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [802] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [803] = {
    [sym_parameter] = STATE(3126),
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2792),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(2944),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2946),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [804] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [805] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2980),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [806] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [807] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2984),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [808] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2438),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [809] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2070),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [810] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2997),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [811] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_const_block] = STATE(2721),
    [sym__pattern] = STATE(2863),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [812] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3192),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [813] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2998),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [814] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3232),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [815] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_higher_ranked_trait_bound] = STATE(2152),
    [sym_removed_trait_bound] = STATE(2152),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2150),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(815),
    [sym_block_comment] = STATE(815),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_QMARK] = ACTIONS(2986),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [816] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_const_block] = STATE(2721),
    [sym__pattern] = STATE(2779),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [817] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_higher_ranked_trait_bound] = STATE(2168),
    [sym_removed_trait_bound] = STATE(2168),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2167),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2166),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(817),
    [sym_block_comment] = STATE(817),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_QMARK] = ACTIONS(2986),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [818] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_const_block] = STATE(2721),
    [sym__pattern] = STATE(2849),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [819] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2445),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(2990),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [820] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_higher_ranked_trait_bound] = STATE(2168),
    [sym_removed_trait_bound] = STATE(2168),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2163),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2162),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(820),
    [sym_block_comment] = STATE(820),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_QMARK] = ACTIONS(2986),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [821] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2704),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [822] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_higher_ranked_trait_bound] = STATE(2168),
    [sym_removed_trait_bound] = STATE(2168),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2163),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(2166),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(822),
    [sym_block_comment] = STATE(822),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_QMARK] = ACTIONS(2986),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [823] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2868),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [824] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2085),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [825] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2370),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(825),
    [sym_block_comment] = STATE(825),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [826] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2046),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(826),
    [sym_block_comment] = STATE(826),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [827] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2996),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(827),
    [sym_block_comment] = STATE(827),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [828] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2618),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(828),
    [sym_block_comment] = STATE(828),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2994),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [829] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3135),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(829),
    [sym_block_comment] = STATE(829),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [830] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_const_block] = STATE(2721),
    [sym__pattern] = STATE(2833),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(830),
    [sym_block_comment] = STATE(830),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [831] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2763),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(831),
    [sym_block_comment] = STATE(831),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [832] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3197),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(832),
    [sym_block_comment] = STATE(832),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [833] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2092),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(833),
    [sym_block_comment] = STATE(833),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [834] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_const_block] = STATE(2721),
    [sym__pattern] = STATE(2772),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(834),
    [sym_block_comment] = STATE(834),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [835] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3048),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(835),
    [sym_block_comment] = STATE(835),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [836] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3435),
    [sym_macro_invocation] = STATE(2721),
    [sym_scoped_identifier] = STATE(2103),
    [sym_scoped_type_identifier] = STATE(2795),
    [sym_const_block] = STATE(2721),
    [sym__pattern] = STATE(2774),
    [sym_tuple_pattern] = STATE(2721),
    [sym_slice_pattern] = STATE(2721),
    [sym_tuple_struct_pattern] = STATE(2721),
    [sym_struct_pattern] = STATE(2721),
    [sym_remaining_field_pattern] = STATE(2721),
    [sym_mut_pattern] = STATE(2721),
    [sym_range_pattern] = STATE(2721),
    [sym_ref_pattern] = STATE(2721),
    [sym_captured_pattern] = STATE(2721),
    [sym_reference_pattern] = STATE(2721),
    [sym_or_pattern] = STATE(2721),
    [sym__literal_pattern] = STATE(2288),
    [sym_negative_literal] = STATE(2272),
    [sym_string_literal] = STATE(2272),
    [sym_boolean_literal] = STATE(2272),
    [sym_line_comment] = STATE(836),
    [sym_block_comment] = STATE(836),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1552),
    [anon_sym_i8] = ACTIONS(1552),
    [anon_sym_u16] = ACTIONS(1552),
    [anon_sym_i16] = ACTIONS(1552),
    [anon_sym_u32] = ACTIONS(1552),
    [anon_sym_i32] = ACTIONS(1552),
    [anon_sym_u64] = ACTIONS(1552),
    [anon_sym_i64] = ACTIONS(1552),
    [anon_sym_u128] = ACTIONS(1552),
    [anon_sym_i128] = ACTIONS(1552),
    [anon_sym_isize] = ACTIONS(1552),
    [anon_sym_usize] = ACTIONS(1552),
    [anon_sym_f32] = ACTIONS(1552),
    [anon_sym_f64] = ACTIONS(1552),
    [anon_sym_bool] = ACTIONS(1552),
    [anon_sym_str] = ACTIONS(1552),
    [anon_sym_char] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_union] = ACTIONS(1564),
    [anon_sym_ref] = ACTIONS(1568),
    [sym_mutable_specifier] = ACTIONS(1570),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [sym_integer_literal] = ACTIONS(1576),
    [aux_sym_string_literal_token1] = ACTIONS(1578),
    [sym_char_literal] = ACTIONS(1576),
    [anon_sym_true] = ACTIONS(1580),
    [anon_sym_false] = ACTIONS(1580),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym_raw_string_literal] = ACTIONS(1576),
    [sym_float_literal] = ACTIONS(1576),
  },
  [837] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2645),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(837),
    [sym_block_comment] = STATE(837),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [838] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3012),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(838),
    [sym_block_comment] = STATE(838),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [839] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(839),
    [sym_block_comment] = STATE(839),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(2998),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [840] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2618),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(840),
    [sym_block_comment] = STATE(840),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3000),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [841] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2403),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(841),
    [sym_block_comment] = STATE(841),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [842] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(3000),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(842),
    [sym_block_comment] = STATE(842),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [843] = {
    [sym_bracketed_type] = STATE(3253),
    [sym_generic_type] = STATE(3246),
    [sym_generic_type_with_turbofish] = STATE(3256),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(1937),
    [sym_scoped_type_identifier] = STATE(2808),
    [sym_const_block] = STATE(2053),
    [sym__pattern] = STATE(2090),
    [sym_tuple_pattern] = STATE(2053),
    [sym_slice_pattern] = STATE(2053),
    [sym_tuple_struct_pattern] = STATE(2053),
    [sym_struct_pattern] = STATE(2053),
    [sym_remaining_field_pattern] = STATE(2053),
    [sym_mut_pattern] = STATE(2053),
    [sym_range_pattern] = STATE(2053),
    [sym_ref_pattern] = STATE(2053),
    [sym_captured_pattern] = STATE(2053),
    [sym_reference_pattern] = STATE(2053),
    [sym_or_pattern] = STATE(2053),
    [sym__literal_pattern] = STATE(2006),
    [sym_negative_literal] = STATE(2011),
    [sym_string_literal] = STATE(2011),
    [sym_boolean_literal] = STATE(2011),
    [sym_line_comment] = STATE(843),
    [sym_block_comment] = STATE(843),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_u8] = ACTIONS(2890),
    [anon_sym_i8] = ACTIONS(2890),
    [anon_sym_u16] = ACTIONS(2890),
    [anon_sym_i16] = ACTIONS(2890),
    [anon_sym_u32] = ACTIONS(2890),
    [anon_sym_i32] = ACTIONS(2890),
    [anon_sym_u64] = ACTIONS(2890),
    [anon_sym_i64] = ACTIONS(2890),
    [anon_sym_u128] = ACTIONS(2890),
    [anon_sym_i128] = ACTIONS(2890),
    [anon_sym_isize] = ACTIONS(2890),
    [anon_sym_usize] = ACTIONS(2890),
    [anon_sym_f32] = ACTIONS(2890),
    [anon_sym_f64] = ACTIONS(2890),
    [anon_sym_bool] = ACTIONS(2890),
    [anon_sym_str] = ACTIONS(2890),
    [anon_sym_char] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_union] = ACTIONS(2900),
    [anon_sym_ref] = ACTIONS(1062),
    [sym_mutable_specifier] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [sym_integer_literal] = ACTIONS(1072),
    [aux_sym_string_literal_token1] = ACTIONS(1074),
    [sym_char_literal] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1076),
    [anon_sym_false] = ACTIONS(1076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_crate] = ACTIONS(2902),
    [sym_metavariable] = ACTIONS(2904),
    [sym_raw_string_literal] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
  },
  [844] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1710),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(844),
    [sym_block_comment] = STATE(844),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [sym_mutable_specifier] = ACTIONS(3030),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [845] = {
    [sym_line_comment] = STATE(845),
    [sym_block_comment] = STATE(845),
    [sym_identifier] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_RBRACK] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_u8] = ACTIONS(2174),
    [anon_sym_i8] = ACTIONS(2174),
    [anon_sym_u16] = ACTIONS(2174),
    [anon_sym_i16] = ACTIONS(2174),
    [anon_sym_u32] = ACTIONS(2174),
    [anon_sym_i32] = ACTIONS(2174),
    [anon_sym_u64] = ACTIONS(2174),
    [anon_sym_i64] = ACTIONS(2174),
    [anon_sym_u128] = ACTIONS(2174),
    [anon_sym_i128] = ACTIONS(2174),
    [anon_sym_isize] = ACTIONS(2174),
    [anon_sym_usize] = ACTIONS(2174),
    [anon_sym_f32] = ACTIONS(2174),
    [anon_sym_f64] = ACTIONS(2174),
    [anon_sym_bool] = ACTIONS(2174),
    [anon_sym_str] = ACTIONS(2174),
    [anon_sym_char] = ACTIONS(2174),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_POUND] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_async] = ACTIONS(2174),
    [anon_sym_break] = ACTIONS(2174),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_continue] = ACTIONS(2174),
    [anon_sym_default] = ACTIONS(2174),
    [anon_sym_for] = ACTIONS(2174),
    [anon_sym_if] = ACTIONS(2174),
    [anon_sym_loop] = ACTIONS(2174),
    [anon_sym_match] = ACTIONS(2174),
    [anon_sym_return] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2174),
    [anon_sym_union] = ACTIONS(2174),
    [anon_sym_unsafe] = ACTIONS(2174),
    [anon_sym_while] = ACTIONS(2174),
    [anon_sym_ref] = ACTIONS(2174),
    [sym_mutable_specifier] = ACTIONS(2174),
    [anon_sym_DOT_DOT] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2174),
    [anon_sym_move] = ACTIONS(2174),
    [anon_sym_try] = ACTIONS(2174),
    [sym_integer_literal] = ACTIONS(2172),
    [aux_sym_string_literal_token1] = ACTIONS(2172),
    [sym_char_literal] = ACTIONS(2172),
    [anon_sym_true] = ACTIONS(2174),
    [anon_sym_false] = ACTIONS(2174),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2174),
    [sym_super] = ACTIONS(2174),
    [sym_crate] = ACTIONS(2174),
    [sym_metavariable] = ACTIONS(2172),
    [sym_raw_string_literal] = ACTIONS(2172),
    [sym_float_literal] = ACTIONS(2172),
  },
  [846] = {
    [sym_line_comment] = STATE(846),
    [sym_block_comment] = STATE(846),
    [sym_identifier] = ACTIONS(3036),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_RBRACK] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_u8] = ACTIONS(3036),
    [anon_sym_i8] = ACTIONS(3036),
    [anon_sym_u16] = ACTIONS(3036),
    [anon_sym_i16] = ACTIONS(3036),
    [anon_sym_u32] = ACTIONS(3036),
    [anon_sym_i32] = ACTIONS(3036),
    [anon_sym_u64] = ACTIONS(3036),
    [anon_sym_i64] = ACTIONS(3036),
    [anon_sym_u128] = ACTIONS(3036),
    [anon_sym_i128] = ACTIONS(3036),
    [anon_sym_isize] = ACTIONS(3036),
    [anon_sym_usize] = ACTIONS(3036),
    [anon_sym_f32] = ACTIONS(3036),
    [anon_sym_f64] = ACTIONS(3036),
    [anon_sym_bool] = ACTIONS(3036),
    [anon_sym_str] = ACTIONS(3036),
    [anon_sym_char] = ACTIONS(3036),
    [anon_sym__] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_COMMA] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_POUND] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_loop] = ACTIONS(3036),
    [anon_sym_match] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [anon_sym_unsafe] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_ref] = ACTIONS(3036),
    [sym_mutable_specifier] = ACTIONS(3036),
    [anon_sym_DOT_DOT] = ACTIONS(3038),
    [anon_sym_yield] = ACTIONS(3036),
    [anon_sym_move] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [sym_integer_literal] = ACTIONS(3038),
    [aux_sym_string_literal_token1] = ACTIONS(3038),
    [sym_char_literal] = ACTIONS(3038),
    [anon_sym_true] = ACTIONS(3036),
    [anon_sym_false] = ACTIONS(3036),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3036),
    [sym_super] = ACTIONS(3036),
    [sym_crate] = ACTIONS(3036),
    [sym_metavariable] = ACTIONS(3038),
    [sym_raw_string_literal] = ACTIONS(3038),
    [sym_float_literal] = ACTIONS(3038),
  },
  [847] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1251),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(847),
    [sym_block_comment] = STATE(847),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [sym_mutable_specifier] = ACTIONS(3068),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [848] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(848),
    [sym_block_comment] = STATE(848),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [849] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3205),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(849),
    [sym_block_comment] = STATE(849),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(3078),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [850] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(850),
    [sym_block_comment] = STATE(850),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(3080),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3082),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [851] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(851),
    [sym_block_comment] = STATE(851),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [852] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(852),
    [sym_block_comment] = STATE(852),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [853] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3142),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(849),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(853),
    [sym_block_comment] = STATE(853),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(3088),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [854] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2626),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(854),
    [sym_block_comment] = STATE(854),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [855] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_type_parameters] = STATE(935),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2320),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2351),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2137),
    [sym_line_comment] = STATE(855),
    [sym_block_comment] = STATE(855),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3092),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [856] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(856),
    [sym_block_comment] = STATE(856),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [857] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_type_parameters] = STATE(871),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2345),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2331),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2138),
    [sym_line_comment] = STATE(857),
    [sym_block_comment] = STATE(857),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [858] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2648),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(858),
    [sym_block_comment] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [859] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2597),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(859),
    [sym_block_comment] = STATE(859),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3106),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [860] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(860),
    [sym_block_comment] = STATE(860),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [861] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(861),
    [sym_block_comment] = STATE(861),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3110),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [862] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_type_parameters] = STATE(873),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2355),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2353),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2141),
    [sym_line_comment] = STATE(862),
    [sym_block_comment] = STATE(862),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3112),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [863] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(863),
    [sym_block_comment] = STATE(863),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [864] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2777),
    [sym_bracketed_type] = STATE(3309),
    [sym_qualified_type] = STATE(3302),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(864),
    [sym_block_comment] = STATE(864),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [865] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1669),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(844),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(865),
    [sym_block_comment] = STATE(865),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [sym_mutable_specifier] = ACTIONS(3118),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [866] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1384),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(847),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(866),
    [sym_block_comment] = STATE(866),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [sym_mutable_specifier] = ACTIONS(3120),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [867] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_type_parameters] = STATE(875),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2354),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2356),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2116),
    [sym_line_comment] = STATE(867),
    [sym_block_comment] = STATE(867),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3122),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [868] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1986),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(848),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(868),
    [sym_block_comment] = STATE(868),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [sym_mutable_specifier] = ACTIONS(3126),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [869] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1725),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(869),
    [sym_block_comment] = STATE(869),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [870] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2648),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(870),
    [sym_block_comment] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [871] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2328),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2339),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2145),
    [sym_line_comment] = STATE(871),
    [sym_block_comment] = STATE(871),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [872] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2968),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(872),
    [sym_block_comment] = STATE(872),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [873] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2291),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2318),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2127),
    [sym_line_comment] = STATE(873),
    [sym_block_comment] = STATE(873),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [874] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2707),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(874),
    [sym_block_comment] = STATE(874),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [875] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2298),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2295),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2136),
    [sym_line_comment] = STATE(875),
    [sym_block_comment] = STATE(875),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [876] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2193),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(876),
    [sym_block_comment] = STATE(876),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [877] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1239),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(877),
    [sym_block_comment] = STATE(877),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [878] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2970),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(878),
    [sym_block_comment] = STATE(878),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [879] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2326),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(879),
    [sym_block_comment] = STATE(879),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [880] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2325),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(880),
    [sym_block_comment] = STATE(880),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [881] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2599),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(881),
    [sym_block_comment] = STATE(881),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [882] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2412),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(882),
    [sym_block_comment] = STATE(882),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [883] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2685),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(883),
    [sym_block_comment] = STATE(883),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [884] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2715),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(884),
    [sym_block_comment] = STATE(884),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [885] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2500),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(885),
    [sym_block_comment] = STATE(885),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [886] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2720),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(886),
    [sym_block_comment] = STATE(886),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [887] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2853),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(887),
    [sym_block_comment] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [888] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2838),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(888),
    [sym_block_comment] = STATE(888),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [889] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2656),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(889),
    [sym_block_comment] = STATE(889),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [890] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2278),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(890),
    [sym_block_comment] = STATE(890),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [891] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(891),
    [sym_block_comment] = STATE(891),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [892] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(892),
    [sym_block_comment] = STATE(892),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [893] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2627),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(893),
    [sym_block_comment] = STATE(893),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [894] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2654),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(894),
    [sym_block_comment] = STATE(894),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [895] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2332),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(895),
    [sym_block_comment] = STATE(895),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [896] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2870),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(896),
    [sym_block_comment] = STATE(896),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [897] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1251),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(897),
    [sym_block_comment] = STATE(897),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [898] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2651),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(898),
    [sym_block_comment] = STATE(898),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [899] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2186),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(899),
    [sym_block_comment] = STATE(899),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [900] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2154),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(900),
    [sym_block_comment] = STATE(900),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [901] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2300),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(901),
    [sym_block_comment] = STATE(901),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [902] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1255),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(902),
    [sym_block_comment] = STATE(902),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [903] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2273),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(903),
    [sym_block_comment] = STATE(903),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [904] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2913),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(904),
    [sym_block_comment] = STATE(904),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [905] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2308),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(905),
    [sym_block_comment] = STATE(905),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [906] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2310),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(906),
    [sym_block_comment] = STATE(906),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [907] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2311),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(907),
    [sym_block_comment] = STATE(907),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [908] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2312),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(908),
    [sym_block_comment] = STATE(908),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [909] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2324),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(909),
    [sym_block_comment] = STATE(909),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [910] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2628),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(910),
    [sym_block_comment] = STATE(910),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [911] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2180),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(911),
    [sym_block_comment] = STATE(911),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [912] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2637),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(912),
    [sym_block_comment] = STATE(912),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [913] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2329),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(913),
    [sym_block_comment] = STATE(913),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [914] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2330),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(914),
    [sym_block_comment] = STATE(914),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [915] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1162),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(915),
    [sym_block_comment] = STATE(915),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [916] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2276),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(916),
    [sym_block_comment] = STATE(916),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [917] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1153),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(917),
    [sym_block_comment] = STATE(917),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [918] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1144),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(918),
    [sym_block_comment] = STATE(918),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [919] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2958),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(919),
    [sym_block_comment] = STATE(919),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [920] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2393),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(920),
    [sym_block_comment] = STATE(920),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [921] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2274),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(921),
    [sym_block_comment] = STATE(921),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [922] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2948),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(922),
    [sym_block_comment] = STATE(922),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [923] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1136),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(923),
    [sym_block_comment] = STATE(923),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [924] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2317),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(924),
    [sym_block_comment] = STATE(924),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [925] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(925),
    [sym_block_comment] = STATE(925),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [926] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1212),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(926),
    [sym_block_comment] = STATE(926),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [927] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2630),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(927),
    [sym_block_comment] = STATE(927),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [928] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2297),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(928),
    [sym_block_comment] = STATE(928),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [929] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2315),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(929),
    [sym_block_comment] = STATE(929),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [930] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2922),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(930),
    [sym_block_comment] = STATE(930),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [931] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1968),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(931),
    [sym_block_comment] = STATE(931),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [932] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2159),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(932),
    [sym_block_comment] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [933] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2789),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(933),
    [sym_block_comment] = STATE(933),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [934] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1989),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(934),
    [sym_block_comment] = STATE(934),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3140),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [935] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2287),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(2359),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(2115),
    [sym_line_comment] = STATE(935),
    [sym_block_comment] = STATE(935),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [936] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2214),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(936),
    [sym_block_comment] = STATE(936),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [937] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2760),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(937),
    [sym_block_comment] = STATE(937),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [938] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2843),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(938),
    [sym_block_comment] = STATE(938),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [939] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2425),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(939),
    [sym_block_comment] = STATE(939),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [940] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2161),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(940),
    [sym_block_comment] = STATE(940),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [941] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2768),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(941),
    [sym_block_comment] = STATE(941),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [942] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2933),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(942),
    [sym_block_comment] = STATE(942),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [943] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2946),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(943),
    [sym_block_comment] = STATE(943),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [944] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2421),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(944),
    [sym_block_comment] = STATE(944),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [945] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2670),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(945),
    [sym_block_comment] = STATE(945),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [946] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2289),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(946),
    [sym_block_comment] = STATE(946),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [947] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2290),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(947),
    [sym_block_comment] = STATE(947),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [948] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2919),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(948),
    [sym_block_comment] = STATE(948),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [949] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2740),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(949),
    [sym_block_comment] = STATE(949),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [950] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2307),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(950),
    [sym_block_comment] = STATE(950),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [951] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2306),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(951),
    [sym_block_comment] = STATE(951),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [952] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2431),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(952),
    [sym_block_comment] = STATE(952),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [953] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(953),
    [sym_block_comment] = STATE(953),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [954] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2894),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(954),
    [sym_block_comment] = STATE(954),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [955] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2783),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(955),
    [sym_block_comment] = STATE(955),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [956] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2712),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(956),
    [sym_block_comment] = STATE(956),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [957] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2185),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(957),
    [sym_block_comment] = STATE(957),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [958] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2634),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(958),
    [sym_block_comment] = STATE(958),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [959] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2333),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(959),
    [sym_block_comment] = STATE(959),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [960] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1966),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(960),
    [sym_block_comment] = STATE(960),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [961] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1978),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(961),
    [sym_block_comment] = STATE(961),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [962] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2335),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(962),
    [sym_block_comment] = STATE(962),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [963] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1979),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(963),
    [sym_block_comment] = STATE(963),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [964] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2689),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(964),
    [sym_block_comment] = STATE(964),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [965] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3219),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(965),
    [sym_block_comment] = STATE(965),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [966] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2192),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(966),
    [sym_block_comment] = STATE(966),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [967] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2494),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(967),
    [sym_block_comment] = STATE(967),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [968] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1969),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(968),
    [sym_block_comment] = STATE(968),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [969] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1105),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(969),
    [sym_block_comment] = STATE(969),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [970] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1106),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(970),
    [sym_block_comment] = STATE(970),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [971] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(971),
    [sym_block_comment] = STATE(971),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [972] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1989),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(972),
    [sym_block_comment] = STATE(972),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [973] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1974),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(1963),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(973),
    [sym_block_comment] = STATE(973),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [974] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3212),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(974),
    [sym_block_comment] = STATE(974),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [975] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1974),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(975),
    [sym_block_comment] = STATE(975),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [976] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1974),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(1963),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(976),
    [sym_block_comment] = STATE(976),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [977] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1108),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(977),
    [sym_block_comment] = STATE(977),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [978] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2562),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(978),
    [sym_block_comment] = STATE(978),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [979] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1715),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(979),
    [sym_block_comment] = STATE(979),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [980] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1642),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(980),
    [sym_block_comment] = STATE(980),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [981] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1710),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(981),
    [sym_block_comment] = STATE(981),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [982] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2935),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(982),
    [sym_block_comment] = STATE(982),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [983] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2165),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(983),
    [sym_block_comment] = STATE(983),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [984] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1696),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(984),
    [sym_block_comment] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [985] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2668),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(985),
    [sym_block_comment] = STATE(985),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [986] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2642),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(986),
    [sym_block_comment] = STATE(986),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [987] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3205),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(987),
    [sym_block_comment] = STATE(987),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [988] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3202),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(988),
    [sym_block_comment] = STATE(988),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [989] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2213),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(989),
    [sym_block_comment] = STATE(989),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [990] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1976),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(990),
    [sym_block_comment] = STATE(990),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [991] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1666),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(991),
    [sym_block_comment] = STATE(991),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [992] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1657),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(992),
    [sym_block_comment] = STATE(992),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [993] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1676),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(993),
    [sym_block_comment] = STATE(993),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [994] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1720),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(994),
    [sym_block_comment] = STATE(994),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [995] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1687),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(995),
    [sym_block_comment] = STATE(995),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [996] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2299),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(996),
    [sym_block_comment] = STATE(996),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [997] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1689),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(997),
    [sym_block_comment] = STATE(997),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [998] = {
    [sym_function_modifiers] = STATE(3254),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1244),
    [sym_bracketed_type] = STATE(3419),
    [sym_lifetime] = STATE(3347),
    [sym_array_type] = STATE(1378),
    [sym_for_lifetimes] = STATE(1609),
    [sym_function_type] = STATE(1378),
    [sym_tuple_type] = STATE(1378),
    [sym_unit_type] = STATE(1378),
    [sym_generic_type] = STATE(1058),
    [sym_generic_type_with_turbofish] = STATE(3420),
    [sym_bounded_type] = STATE(1378),
    [sym_reference_type] = STATE(1378),
    [sym_pointer_type] = STATE(1378),
    [sym_empty_type] = STATE(1378),
    [sym_abstract_type] = STATE(1378),
    [sym_dynamic_type] = STATE(1378),
    [sym_macro_invocation] = STATE(1378),
    [sym_scoped_identifier] = STATE(3229),
    [sym_scoped_type_identifier] = STATE(1028),
    [sym_line_comment] = STATE(998),
    [sym_block_comment] = STATE(998),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_u8] = ACTIONS(3050),
    [anon_sym_i8] = ACTIONS(3050),
    [anon_sym_u16] = ACTIONS(3050),
    [anon_sym_i16] = ACTIONS(3050),
    [anon_sym_u32] = ACTIONS(3050),
    [anon_sym_i32] = ACTIONS(3050),
    [anon_sym_u64] = ACTIONS(3050),
    [anon_sym_i64] = ACTIONS(3050),
    [anon_sym_u128] = ACTIONS(3050),
    [anon_sym_i128] = ACTIONS(3050),
    [anon_sym_isize] = ACTIONS(3050),
    [anon_sym_usize] = ACTIONS(3050),
    [anon_sym_f32] = ACTIONS(3050),
    [anon_sym_f64] = ACTIONS(3050),
    [anon_sym_bool] = ACTIONS(3050),
    [anon_sym_str] = ACTIONS(3050),
    [anon_sym_char] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_fn] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_crate] = ACTIONS(3070),
    [sym_metavariable] = ACTIONS(3072),
  },
  [999] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2200),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(999),
    [sym_block_comment] = STATE(999),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [1000] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(3239),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(1000),
    [sym_block_comment] = STATE(1000),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [1001] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2304),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(1001),
    [sym_block_comment] = STATE(1001),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [1002] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2305),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(1002),
    [sym_block_comment] = STATE(1002),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [1003] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(2309),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(1003),
    [sym_block_comment] = STATE(1003),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
  [1004] = {
    [sym_function_modifiers] = STATE(3392),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1732),
    [sym_bracketed_type] = STATE(3444),
    [sym_lifetime] = STATE(3491),
    [sym_array_type] = STATE(1603),
    [sym_for_lifetimes] = STATE(1692),
    [sym_function_type] = STATE(1603),
    [sym_tuple_type] = STATE(1603),
    [sym_unit_type] = STATE(1603),
    [sym_generic_type] = STATE(1557),
    [sym_generic_type_with_turbofish] = STATE(3445),
    [sym_bounded_type] = STATE(1603),
    [sym_reference_type] = STATE(1603),
    [sym_pointer_type] = STATE(1603),
    [sym_empty_type] = STATE(1603),
    [sym_abstract_type] = STATE(1603),
    [sym_dynamic_type] = STATE(1603),
    [sym_macro_invocation] = STATE(1603),
    [sym_scoped_identifier] = STATE(3074),
    [sym_scoped_type_identifier] = STATE(1494),
    [sym_line_comment] = STATE(1004),
    [sym_block_comment] = STATE(1004),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_u8] = ACTIONS(3012),
    [anon_sym_i8] = ACTIONS(3012),
    [anon_sym_u16] = ACTIONS(3012),
    [anon_sym_i16] = ACTIONS(3012),
    [anon_sym_u32] = ACTIONS(3012),
    [anon_sym_i32] = ACTIONS(3012),
    [anon_sym_u64] = ACTIONS(3012),
    [anon_sym_i64] = ACTIONS(3012),
    [anon_sym_u128] = ACTIONS(3012),
    [anon_sym_i128] = ACTIONS(3012),
    [anon_sym_isize] = ACTIONS(3012),
    [anon_sym_usize] = ACTIONS(3012),
    [anon_sym_f32] = ACTIONS(3012),
    [anon_sym_f64] = ACTIONS(3012),
    [anon_sym_bool] = ACTIONS(3012),
    [anon_sym_str] = ACTIONS(3012),
    [anon_sym_char] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_fn] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(3028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3032),
    [sym_super] = ACTIONS(3032),
    [sym_crate] = ACTIONS(3032),
    [sym_metavariable] = ACTIONS(3034),
  },
  [1005] = {
    [sym_function_modifiers] = STATE(3304),
    [sym_extern_modifier] = STATE(2277),
    [sym__type] = STATE(1967),
    [sym_bracketed_type] = STATE(3309),
    [sym_lifetime] = STATE(3299),
    [sym_array_type] = STATE(1972),
    [sym_for_lifetimes] = STATE(1694),
    [sym_function_type] = STATE(1972),
    [sym_tuple_type] = STATE(1972),
    [sym_unit_type] = STATE(1972),
    [sym_generic_type] = STATE(1936),
    [sym_generic_type_with_turbofish] = STATE(3295),
    [sym_bounded_type] = STATE(1972),
    [sym_reference_type] = STATE(1972),
    [sym_pointer_type] = STATE(1972),
    [sym_empty_type] = STATE(1972),
    [sym_abstract_type] = STATE(1972),
    [sym_dynamic_type] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(3177),
    [sym_scoped_type_identifier] = STATE(1914),
    [sym_line_comment] = STATE(1005),
    [sym_block_comment] = STATE(1005),
    [aux_sym_function_modifiers_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_u8] = ACTIONS(1608),
    [anon_sym_i8] = ACTIONS(1608),
    [anon_sym_u16] = ACTIONS(1608),
    [anon_sym_i16] = ACTIONS(1608),
    [anon_sym_u32] = ACTIONS(1608),
    [anon_sym_i32] = ACTIONS(1608),
    [anon_sym_u64] = ACTIONS(1608),
    [anon_sym_i64] = ACTIONS(1608),
    [anon_sym_u128] = ACTIONS(1608),
    [anon_sym_i128] = ACTIONS(1608),
    [anon_sym_isize] = ACTIONS(1608),
    [anon_sym_usize] = ACTIONS(1608),
    [anon_sym_f32] = ACTIONS(1608),
    [anon_sym_f64] = ACTIONS(1608),
    [anon_sym_bool] = ACTIONS(1608),
    [anon_sym_str] = ACTIONS(1608),
    [anon_sym_char] = ACTIONS(1608),
    [anon_sym_COLON_COLON] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_impl] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1620),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym_dyn] = ACTIONS(1066),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1624),
    [sym_super] = ACTIONS(1624),
    [sym_crate] = ACTIONS(1624),
    [sym_metavariable] = ACTIONS(1626),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3148), 17,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3146), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [75] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3152), 17,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3150), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1540), 17,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1538), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [225] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(770), 18,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3154), 41,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [299] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2172), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2174), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_ref,
      anon_sym_dyn,
      sym_mutable_specifier,
      anon_sym_DOT_DOT,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [367] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3158), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3156), 34,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_dyn,
      sym_mutable_specifier,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [435] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3168), 1,
      anon_sym_BANG,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    STATE(1068), 1,
      sym_parameters,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3164), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3160), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [512] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(3176), 1,
      anon_sym_COLON_COLON,
    STATE(1068), 1,
      sym_parameters,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3174), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3172), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [586] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(3176), 1,
      anon_sym_COLON_COLON,
    STATE(1068), 1,
      sym_parameters,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3180), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3178), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [660] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(3176), 1,
      anon_sym_COLON_COLON,
    STATE(1068), 1,
      sym_parameters,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3184), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3182), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [734] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(916), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(918), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [797] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    STATE(1070), 1,
      sym_parameters,
    STATE(1071), 1,
      sym_type_arguments,
    STATE(1017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3188), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3186), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [868] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3194), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3196), 1,
      anon_sym_BANG,
    STATE(1018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3192), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3190), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [935] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    STATE(1070), 1,
      sym_parameters,
    STATE(1071), 1,
      sym_type_arguments,
    STATE(1019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3200), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3198), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [1006] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    STATE(1070), 1,
      sym_parameters,
    STATE(1071), 1,
      sym_type_arguments,
    STATE(1020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3204), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3202), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [1077] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(890), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(892), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(882), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(884), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1203] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1014), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(1016), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1266] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(870), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(872), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1329] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(886), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(888), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1392] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(912), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(914), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1455] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3210), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3212), 1,
      anon_sym_BANG,
    STATE(1027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3208), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3206), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [1522] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    STATE(1070), 1,
      sym_parameters,
    STATE(1071), 1,
      sym_type_arguments,
    STATE(1028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3214), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [1593] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(998), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(1000), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1656] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3222), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    STATE(1030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3220), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3218), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [1723] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(894), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      sym_metavariable,
    ACTIONS(896), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1786] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3230), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3232), 1,
      anon_sym_BANG,
    STATE(1032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3228), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3226), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [1853] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2037), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2039), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1915] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3212), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3210), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [1977] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2742), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2744), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2039] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3238), 1,
      anon_sym_RBRACE,
    STATE(1036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3236), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3234), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_static,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2103] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2630), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2632), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2165] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    STATE(1038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3242), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3240), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_static,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2229] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3196), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3194), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2291] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3252), 1,
      anon_sym_BANG,
    STATE(1040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
    ACTIONS(3248), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2359] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1917), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1919), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2421] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2354), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2356), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3224), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3222), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3232), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3230), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2607] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3168), 1,
      anon_sym_BANG,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    ACTIONS(3258), 1,
      anon_sym_COLON_COLON,
    STATE(1276), 1,
      sym_field_initializer_list,
    STATE(1045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2677] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3260), 1,
      anon_sym_else,
    STATE(1221), 1,
      sym_else_clause,
    STATE(1046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(742), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(740), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2742] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3264), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3262), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2803] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    STATE(1048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3196), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3194), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2866] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3236), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3234), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_static,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2927] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3268), 1,
      anon_sym_LBRACE,
    STATE(1050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3224), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3222), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [2990] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3272), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3270), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3051] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3276), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3274), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3242), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3240), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_static,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [3173] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1114), 1,
      sym_label,
    STATE(1054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3278), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3238] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3284), 1,
      anon_sym_LBRACE,
    STATE(1055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3232), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3230), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3301] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3286), 1,
      anon_sym_COLON_COLON,
    STATE(1056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3364] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3288), 1,
      anon_sym_COLON_COLON,
    STATE(1057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3427] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3290), 1,
      anon_sym_COLON_COLON,
    STATE(1058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3294), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3292), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_static,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [3551] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3298), 1,
      anon_sym_LPAREN,
    STATE(1168), 1,
      sym_arguments,
    STATE(1060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3296), 29,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3616] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3302), 1,
      anon_sym_COLON_COLON,
    STATE(1061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3679] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3156), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3158), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3740] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3306), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3304), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3801] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3312), 1,
      anon_sym_DASH_GT,
    STATE(1064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3310), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3308), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3864] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3290), 1,
      anon_sym_COLON_COLON,
    STATE(1065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3204), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3202), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3927] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3316), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3314), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [3988] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3290), 1,
      anon_sym_COLON_COLON,
    STATE(1067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3188), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3186), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4051] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3322), 1,
      anon_sym_DASH_GT,
    STATE(1068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3320), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3318), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4114] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3326), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3324), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4175] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3332), 1,
      anon_sym_DASH_GT,
    STATE(1070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3330), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3328), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4238] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3334), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4299] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3338), 1,
      anon_sym_LBRACE,
    STATE(1072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3212), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3210), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4362] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3342), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3340), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4423] = 24,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1604), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3356), 1,
      anon_sym_AMP,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2515), 1,
      sym_where_predicate,
    STATE(2600), 1,
      sym_scoped_type_identifier,
    STATE(2938), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3346), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3042), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3370), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3368), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4583] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3376), 1,
      anon_sym_DASH_GT,
    STATE(1076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3372), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4646] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3380), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3378), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4707] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3386), 1,
      anon_sym_DASH_GT,
    STATE(1078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3384), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3382), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4770] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3392), 1,
      anon_sym_DASH_GT,
    STATE(1079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3390), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3388), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4833] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3192), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3190), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [4894] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3290), 1,
      anon_sym_COLON_COLON,
    STATE(1081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3200), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3198), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [4957] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1366), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1368), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5018] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3398), 1,
      anon_sym_DASH_GT,
    STATE(1083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3396), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5081] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3402), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3400), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5142] = 24,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1604), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3356), 1,
      anon_sym_AMP,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2515), 1,
      sym_where_predicate,
    STATE(2600), 1,
      sym_scoped_type_identifier,
    STATE(2938), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(3404), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(1085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3042), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5241] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3408), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3406), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5302] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3412), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3410), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5363] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2710), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2712), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [5423] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3414), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5483] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(884), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(882), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5543] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2570), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2572), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [5603] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1012), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1010), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5663] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3420), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5725] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2466), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2468), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [5785] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2730), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2732), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [5845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3424), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [5905] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2536), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2538), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [5965] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(966), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(964), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1981), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1983), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6085] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3430), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3428), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6145] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3434), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(3432), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1989), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1991), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6265] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1723), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1725), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6325] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1833), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1835), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6385] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3438), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3436), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6445] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3442), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3440), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6505] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1837), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1839), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6565] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3446), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3444), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6625] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2874), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2876), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6685] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1711), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1713), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6745] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2806), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2808), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6805] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1498), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1500), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6865] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1933), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1935), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6925] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3450), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3448), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [6985] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1953), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1955), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1957), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1959), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7105] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1969), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1971), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7165] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(992), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(990), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [7225] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(902), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(900), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [7285] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2238), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2240), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7345] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2246), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2248), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7405] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2278), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2280), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7465] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3454), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3452), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [7525] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1124), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2294), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2296), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7585] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1125), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2320), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7645] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2366), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2368), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7705] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2802), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2804), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1128), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(914), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(912), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [7825] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1129), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2782), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2784), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7885] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2766), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2768), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7945] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1131), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2758), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2760), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8005] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2750), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2752), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8065] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2418), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2420), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8125] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2734), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2736), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8185] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2726), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2728), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8245] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3458), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3456), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [8305] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2714), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2716), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8365] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2698), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2700), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8425] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2670), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2672), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8485] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2666), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2668), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2658), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2660), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8605] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2654), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2656), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8665] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1143), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2642), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2644), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8725] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3462), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3460), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [8785] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2598), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2600), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2274), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2276), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8905] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2057), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2059), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8965] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(980), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(978), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [9025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1809), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1811), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9085] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3200), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3198), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [9145] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2442), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2444), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1865), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1867), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9265] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1153), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3466), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3464), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [9325] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1925), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1927), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9385] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3470), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [9445] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1949), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1951), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9505] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1157), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2188), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2190), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9565] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2204), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2206), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9625] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2208), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2210), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9685] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2222), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2224), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9745] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1161), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2226), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2228), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9805] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3474), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3472), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [9865] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1163), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3478), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3476), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [9925] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1164), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2234), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2236), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9985] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2242), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2244), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2290), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2292), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10105] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2334), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2336), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10165] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3482), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3480), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [10225] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2870), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2872), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10285] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1170), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2718), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2720), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10345] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2586), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2588), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10405] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1172), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2346), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2348), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10465] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1173), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2350), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2352), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10525] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1174), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3486), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3484), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [10585] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(984), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(982), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [10645] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1176), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2430), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2432), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10705] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1177), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3490), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3488), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [10765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1178), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3494), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3492), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [10825] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1179), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2374), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2376), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10885] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1180), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1739), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1741), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10945] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1181), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2378), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2380), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11005] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1182), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1965), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1967), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11065] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1183), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2041), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2043), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11125] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1184), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2532), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2534), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11185] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1185), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2049), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2051), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11245] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1186), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2053), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2055), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11305] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1187), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2069), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2071), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11365] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1188), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2168), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2170), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11425] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1189), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2382), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2384), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11485] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1190), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2266), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2268), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1191), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3498), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3496), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [11605] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1192), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2386), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2388), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11665] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1193), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2406), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2408), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11725] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    STATE(1194), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3504), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 27,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [11793] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1195), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2410), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2412), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11853] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1196), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2542), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2544), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11913] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1197), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3514), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3512), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [11973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1198), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2554), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2556), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12033] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1199), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2578), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2580), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12093] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1200), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2394), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2396), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1201), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2582), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2584), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12213] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1202), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2590), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2592), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12273] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1203), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2634), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2636), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12333] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1204), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2638), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2640), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12393] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1205), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2682), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2684), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12453] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1206), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1707), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1709), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12513] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1207), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2694), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2696), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12573] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2702), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2704), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1209), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2522), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2524), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12693] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1210), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2498), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2500), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12753] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1211), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(996), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(994), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [12813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1212), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3518), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3516), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [12873] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1213), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2798), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2800), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12933] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2790), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2792), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12993] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1215), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2486), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2488), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13053] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1216), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2786), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2788), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13113] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1217), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2774), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2776), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13173] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2514), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2516), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13233] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2770), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2772), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13293] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1220), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2518), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2520), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13353] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1008), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1006), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [13413] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2526), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2528), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13473] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    STATE(1223), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3522), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3520), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [13539] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2558), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2560), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1225), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2674), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2676), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1226), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2662), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2664), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13719] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1227), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2650), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2652), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13779] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1228), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2646), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2648), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13839] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1229), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2574), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2576), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13899] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1230), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1016), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1014), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [13959] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1231), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(892), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(890), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [14019] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3524), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1232), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [14081] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1233), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2196), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2198), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14141] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1234), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2678), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2680), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14201] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1235), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2690), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2692), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14261] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1236), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2614), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2616), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14321] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1237), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2610), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2612), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14381] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1238), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3528), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3526), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [14441] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1239), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3528), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3526), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [14501] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1240), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2602), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2604), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14561] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1241), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2706), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2708), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14621] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1997), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1999), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14681] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1243), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2172), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2174), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14741] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3532), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3530), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [14801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1245), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2005), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2007), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14861] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1246), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2017), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2019), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14921] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1247), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [14981] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1248), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3536), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3534), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15041] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2822), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2824), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15101] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1250), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3540), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3538), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15161] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1251), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3544), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3542), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15221] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1252), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15281] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1253), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1494), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1496), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15341] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1254), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2878), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2880), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15401] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1255), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3548), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3546), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15461] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1256), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3552), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3550), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15521] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1257), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2866), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2868), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15581] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3556), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3554), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15641] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1259), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3560), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3558), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1260), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3564), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3562), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15761] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2862), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2864), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15821] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1262), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3568), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3566), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [15881] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1263), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2858), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2860), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15941] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2854), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2856), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16001] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1265), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(872), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(870), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [16061] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1266), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2001), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2003), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16121] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1267), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2850), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2852), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16181] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1268), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2842), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2844), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16241] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1269), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1973), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1975), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16301] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1270), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2838), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2840), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16361] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1271), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2834), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2836), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16421] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3572), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3570), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [16481] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1273), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2830), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2832), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16541] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1274), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2826), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2828), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16601] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1275), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2818), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2820), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16661] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1276), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3576), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3574), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [16721] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1277), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2494), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2496), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16781] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1278), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2502), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2504), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16841] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1279), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3580), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3578), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [16901] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1280), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1805), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1807), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16961] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1281), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2490), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2492), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17021] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1282), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1817), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1819), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17081] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1283), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1813), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1815), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17141] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1284), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1731), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1733), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17201] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2814), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2816), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17261] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1286), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(918), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(916), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [17321] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1287), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3584), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3582), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [17381] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2810), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2812), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17441] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1289), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2794), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2796), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17501] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1290), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1478), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1480), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [17561] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1291), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2778), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2780), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17621] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1292), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(954), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(952), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [17681] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    STATE(1293), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3588), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3586), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [17747] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2762), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2764), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17807] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2214), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17867] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1296), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1797), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1799), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17927] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1297), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1921), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1923), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17987] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1298), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3592), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3590), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [18047] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1299), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1941), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1943), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18107] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1945), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1947), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18167] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1301), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3596), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3594), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [18227] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1302), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1961), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1963), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18287] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2754), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2756), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18347] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1304), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1793), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1795), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18407] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1305), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2746), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2748), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18467] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    STATE(1306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3600), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3598), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [18533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1307), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3604), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3602), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [18593] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1308), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2025), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2027), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18653] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3608), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3606), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [18713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2029), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2031), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18773] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1311), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(976), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(974), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [18833] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2045), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2047), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18893] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1313), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2061), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2063), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18953] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1314), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2738), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2740), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19013] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1315), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2065), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2067), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19073] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1316), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2438), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2440), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19133] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1510), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1512), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [19193] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2073), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2075), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1319), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2686), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2688), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19313] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1320), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2626), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2628), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19373] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1321), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2176), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2178), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19433] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1322), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1000), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(998), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [19493] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1323), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2622), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2624), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19553] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1324), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2618), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2620), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19613] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1325), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2606), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2608), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1326), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1004), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1002), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [19733] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1327), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(896), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(894), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [19793] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1328), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2562), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2564), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19853] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1329), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2550), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2552), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19913] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1330), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2546), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2548), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2510), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2512), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20033] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1332), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2506), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2508), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20093] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1333), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2081), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2083), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1334), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2422), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2424), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20213] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1335), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2482), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2484), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20273] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1336), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3612), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3610), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [20333] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1337), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2474), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2476), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20393] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1338), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2478), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2480), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20453] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1825), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1827), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20513] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1340), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2338), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2340), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20573] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1341), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2470), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2472), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1342), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3616), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3614), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [20693] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1343), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2218), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2220), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20753] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1344), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2262), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2264), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3620), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3618), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [20873] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1346), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2462), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2464), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20933] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1347), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2458), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2460), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20993] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1348), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2454), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2456), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21053] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1349), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3624), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3622), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21113] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1350), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2450), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2452), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21173] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2446), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2448), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21233] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1352), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2434), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2436), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21293] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1353), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2370), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2372), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21353] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1354), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2426), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2428), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21413] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2414), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2416), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21473] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2402), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2404), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2398), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2400), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21593] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1358), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3188), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3186), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21653] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2390), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2392), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1360), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(988), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(986), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21773] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1361), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2286), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2288), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21833] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2332), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21893] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2314), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2316), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21953] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2310), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2312), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22013] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2306), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2308), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22073] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2322), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2324), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22133] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1367), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2302), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2304), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22193] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1368), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3204), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3202), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1369), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2298), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2300), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22313] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1370), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2326), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2328), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22373] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2342), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2344), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22433] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1372), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2282), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2284), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22493] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1373), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2270), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2272), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22553] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1374), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2358), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2360), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22613] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2258), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2260), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1376), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3628), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3626), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22733] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1377), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2254), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2256), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22793] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1378), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22853] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2594), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2596), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22913] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2192), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2194), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2033), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2035), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23033] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1382), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3632), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3630), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23093] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1383), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3636), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3634), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23213] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1385), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2021), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2023), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23273] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1386), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2013), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2015), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23333] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2009), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2011), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23393] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1388), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1993), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1995), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23453] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3638), 1,
      anon_sym_BANG,
    STATE(1389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23517] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1390), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1985), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1987), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23577] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1391), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1937), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1939), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23637] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1929), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1931), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23697] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1393), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3642), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3640), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23757] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3646), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3644), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23817] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3650), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3648), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23877] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1396), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3654), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3652), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23937] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1397), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1909), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1911), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23997] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1398), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3658), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3656), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24057] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(888), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(886), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24117] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1400), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3662), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3660), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24177] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1401), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3666), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3664), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24237] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1402), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1905), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1907), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24297] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1901), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1903), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24357] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1897), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1899), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24417] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1893), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1895), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24477] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1885), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1887), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24537] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1407), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1881), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1883), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24597] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24657] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3670), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3668), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24717] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1410), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1877), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1879), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24777] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2362), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2364), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24837] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1873), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1875), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24897] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1413), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1869), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1871), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24957] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1414), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3296), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25017] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1415), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1861), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1863), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25077] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2250), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2252), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25137] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1417), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25197] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1418), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2230), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2232), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25257] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1419), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2077), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2079), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25317] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2200), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2202), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25377] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1421), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2566), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2568), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25437] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1422), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(972), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(970), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25497] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1423), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3674), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3672), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25557] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1424), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(962), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(960), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1425), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1853), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1855), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25677] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1426), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1857), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1859), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25737] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1427), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25797] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1428), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1849), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1851), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25857] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1429), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1845), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1847), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1841), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1843), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25977] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1431), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1821), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1823), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26037] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1727), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1729), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26097] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1715), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1717), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26157] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2184), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2186), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26217] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1435), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2180), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(2182), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26277] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(906), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(904), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26337] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1437), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(942), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(940), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26397] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3168), 1,
      anon_sym_BANG,
    ACTIONS(3676), 1,
      anon_sym_COLON_COLON,
    STATE(1438), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26461] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1439), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1977), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1979), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26521] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1913), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1915), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26581] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1441), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1889), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1891), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26641] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1442), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1829), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1831), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1801), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1803), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26761] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1444), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1735), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1737), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26821] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1445), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(910), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(908), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26881] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1446), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1719), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(1721), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26941] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3682), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    STATE(1534), 1,
      sym_parameters,
    STATE(1549), 1,
      sym_type_arguments,
    STATE(1447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3164), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3160), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [27012] = 23,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1604), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3356), 1,
      anon_sym_AMP,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2515), 1,
      sym_where_predicate,
    STATE(2600), 1,
      sym_scoped_type_identifier,
    STATE(2938), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3042), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [27107] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3688), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3686), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27166] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3692), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3690), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27225] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3250), 1,
      anon_sym_COLON_COLON,
    STATE(1451), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [27286] = 23,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1604), 1,
      anon_sym_LBRACK,
    ACTIONS(3344), 1,
      sym_identifier,
    ACTIONS(3348), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3356), 1,
      anon_sym_AMP,
    ACTIONS(3358), 1,
      anon_sym_SQUOTE,
    ACTIONS(3362), 1,
      anon_sym_for,
    ACTIONS(3366), 1,
      sym_metavariable,
    STATE(2449), 1,
      sym_where_predicate,
    STATE(2600), 1,
      sym_scoped_type_identifier,
    STATE(2938), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3042), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3352), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [27381] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3696), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3694), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3700), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3698), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27499] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3704), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3702), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27558] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3708), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3706), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27617] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3710), 1,
      anon_sym_COLON_COLON,
    STATE(1457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [27678] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3712), 1,
      anon_sym_POUND,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(1458), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(542), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(2964), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27741] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1459), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3562), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [27833] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1460), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3668), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [27925] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(337), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(331), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28015] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3682), 1,
      anon_sym_BANG,
    ACTIONS(3743), 1,
      anon_sym_LBRACE,
    ACTIONS(3745), 1,
      anon_sym_COLON_COLON,
    STATE(1681), 1,
      sym_field_initializer_list,
    STATE(1462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28081] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 7,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28153] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 6,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28227] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(3747), 1,
      anon_sym_COLON_COLON,
    STATE(1534), 1,
      sym_parameters,
    STATE(1549), 1,
      sym_type_arguments,
    STATE(1465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3180), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3178), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [28295] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28373] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1467), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28449] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(3747), 1,
      anon_sym_COLON_COLON,
    STATE(1534), 1,
      sym_parameters,
    STATE(1549), 1,
      sym_type_arguments,
    STATE(1468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3184), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3182), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [28517] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3751), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    STATE(1469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3749), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28603] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 21,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28685] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28769] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 9,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28839] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    ACTIONS(3258), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3753), 1,
      anon_sym_BANG,
    STATE(1276), 1,
      sym_field_initializer_list,
    STATE(1473), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28905] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3757), 1,
      anon_sym_EQ,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3755), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28995] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(379), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29081] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3761), 1,
      anon_sym_EQ,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3759), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29171] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(3747), 1,
      anon_sym_COLON_COLON,
    STATE(1534), 1,
      sym_parameters,
    STATE(1549), 1,
      sym_type_arguments,
    STATE(1477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3174), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3172), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [29239] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3763), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29329] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3769), 1,
      anon_sym_EQ,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3767), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29419] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1480), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3672), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29511] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    STATE(1481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29579] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3773), 1,
      anon_sym_EQ,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3729), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1482), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3771), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29669] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    STATE(1580), 1,
      sym_type_arguments,
    STATE(1587), 1,
      sym_parameters,
    STATE(1483), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3200), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3198), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [29734] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    STATE(1580), 1,
      sym_type_arguments,
    STATE(1587), 1,
      sym_parameters,
    STATE(1484), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3188), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3186), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [29799] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3194), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3196), 1,
      anon_sym_BANG,
    STATE(1485), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3192), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3190), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [29860] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1054), 1,
      anon_sym_for,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3060), 1,
      anon_sym_fn,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3779), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3781), 1,
      anon_sym_default,
    ACTIONS(3783), 1,
      anon_sym_union,
    ACTIONS(3787), 1,
      sym_metavariable,
    STATE(1019), 1,
      sym_scoped_type_identifier,
    STATE(1081), 1,
      sym_generic_type,
    STATE(1150), 1,
      sym_function_type,
    STATE(1609), 1,
      sym_for_lifetimes,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3254), 1,
      sym_function_modifiers,
    STATE(3289), 1,
      sym_scoped_identifier,
    STATE(3437), 1,
      sym_bracketed_type,
    STATE(3438), 1,
      sym_generic_type_with_turbofish,
    STATE(1486), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3785), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3777), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29957] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3222), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    STATE(1487), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3220), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3218), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [30018] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3022), 1,
      anon_sym_fn,
    ACTIONS(3789), 1,
      sym_identifier,
    ACTIONS(3793), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3795), 1,
      anon_sym_default,
    ACTIONS(3797), 1,
      anon_sym_for,
    ACTIONS(3799), 1,
      anon_sym_union,
    ACTIONS(3803), 1,
      sym_metavariable,
    STATE(1500), 1,
      sym_scoped_type_identifier,
    STATE(1536), 1,
      sym_generic_type,
    STATE(1620), 1,
      sym_function_type,
    STATE(1692), 1,
      sym_for_lifetimes,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3392), 1,
      sym_function_modifiers,
    STATE(3403), 1,
      sym_scoped_identifier,
    STATE(3446), 1,
      sym_bracketed_type,
    STATE(3447), 1,
      sym_generic_type_with_turbofish,
    STATE(1488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3801), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3791), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30115] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1054), 1,
      anon_sym_for,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3022), 1,
      anon_sym_fn,
    ACTIONS(3793), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3795), 1,
      anon_sym_default,
    ACTIONS(3799), 1,
      anon_sym_union,
    ACTIONS(3803), 1,
      sym_metavariable,
    ACTIONS(3805), 1,
      sym_identifier,
    STATE(1484), 1,
      sym_scoped_type_identifier,
    STATE(1552), 1,
      sym_generic_type,
    STATE(1625), 1,
      sym_function_type,
    STATE(1692), 1,
      sym_for_lifetimes,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3392), 1,
      sym_function_modifiers,
    STATE(3403), 1,
      sym_scoped_identifier,
    STATE(3446), 1,
      sym_bracketed_type,
    STATE(3447), 1,
      sym_generic_type_with_turbofish,
    STATE(1489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3801), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3791), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30212] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3060), 1,
      anon_sym_fn,
    ACTIONS(3779), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3781), 1,
      anon_sym_default,
    ACTIONS(3783), 1,
      anon_sym_union,
    ACTIONS(3787), 1,
      sym_metavariable,
    ACTIONS(3807), 1,
      sym_identifier,
    ACTIONS(3809), 1,
      anon_sym_for,
    STATE(1020), 1,
      sym_scoped_type_identifier,
    STATE(1065), 1,
      sym_generic_type,
    STATE(1368), 1,
      sym_function_type,
    STATE(1609), 1,
      sym_for_lifetimes,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3254), 1,
      sym_function_modifiers,
    STATE(3289), 1,
      sym_scoped_identifier,
    STATE(3437), 1,
      sym_bracketed_type,
    STATE(3438), 1,
      sym_generic_type_with_turbofish,
    STATE(1490), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3785), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3777), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30309] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3284), 1,
      anon_sym_LBRACE,
    STATE(1491), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3232), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3230), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30368] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1054), 1,
      anon_sym_for,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3060), 1,
      anon_sym_fn,
    ACTIONS(3779), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3781), 1,
      anon_sym_default,
    ACTIONS(3783), 1,
      anon_sym_union,
    ACTIONS(3787), 1,
      sym_metavariable,
    ACTIONS(3811), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_scoped_type_identifier,
    STATE(1067), 1,
      sym_generic_type,
    STATE(1358), 1,
      sym_function_type,
    STATE(1609), 1,
      sym_for_lifetimes,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3254), 1,
      sym_function_modifiers,
    STATE(3289), 1,
      sym_scoped_identifier,
    STATE(3437), 1,
      sym_bracketed_type,
    STATE(3438), 1,
      sym_generic_type_with_turbofish,
    STATE(1492), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3785), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3777), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30465] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1493), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3038), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3036), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30522] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    STATE(1580), 1,
      sym_type_arguments,
    STATE(1587), 1,
      sym_parameters,
    STATE(1494), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3214), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [30587] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1052), 1,
      anon_sym_fn,
    ACTIONS(1054), 1,
      anon_sym_for,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3817), 1,
      anon_sym_default,
    STATE(1694), 1,
      sym_for_lifetimes,
    STATE(1915), 1,
      sym_scoped_type_identifier,
    STATE(1958), 1,
      sym_generic_type,
    STATE(1992), 1,
      sym_function_type,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3304), 1,
      sym_function_modifiers,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    STATE(1495), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30684] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3338), 1,
      anon_sym_LBRACE,
    STATE(1496), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3212), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3210), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30743] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3210), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3212), 1,
      anon_sym_BANG,
    STATE(1497), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3208), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3206), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [30804] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3168), 1,
      anon_sym_BANG,
    ACTIONS(3819), 1,
      anon_sym_COLON_COLON,
    STATE(1276), 1,
      sym_field_initializer_list,
    STATE(1498), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30867] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1054), 1,
      anon_sym_for,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3022), 1,
      anon_sym_fn,
    ACTIONS(3793), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3795), 1,
      anon_sym_default,
    ACTIONS(3799), 1,
      anon_sym_union,
    ACTIONS(3803), 1,
      sym_metavariable,
    ACTIONS(3821), 1,
      sym_identifier,
    STATE(1483), 1,
      sym_scoped_type_identifier,
    STATE(1537), 1,
      sym_generic_type,
    STATE(1692), 1,
      sym_for_lifetimes,
    STATE(1722), 1,
      sym_function_type,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3392), 1,
      sym_function_modifiers,
    STATE(3403), 1,
      sym_scoped_identifier,
    STATE(3446), 1,
      sym_bracketed_type,
    STATE(3447), 1,
      sym_generic_type_with_turbofish,
    STATE(1499), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3801), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3791), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30964] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    STATE(1580), 1,
      sym_type_arguments,
    STATE(1587), 1,
      sym_parameters,
    STATE(1500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3204), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3202), 21,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [31029] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1052), 1,
      anon_sym_fn,
    ACTIONS(1054), 1,
      anon_sym_for,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3817), 1,
      anon_sym_default,
    ACTIONS(3823), 1,
      sym_identifier,
    STATE(1694), 1,
      sym_for_lifetimes,
    STATE(1912), 1,
      sym_scoped_type_identifier,
    STATE(1939), 1,
      sym_generic_type,
    STATE(1970), 1,
      sym_function_type,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3304), 1,
      sym_function_modifiers,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    STATE(1501), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31126] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1502), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2172), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(2174), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31183] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3252), 1,
      anon_sym_BANG,
    ACTIONS(3825), 1,
      sym_identifier,
    STATE(1503), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31246] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3268), 1,
      anon_sym_LBRACE,
    STATE(1504), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3224), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3222), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31305] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3230), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3232), 1,
      anon_sym_BANG,
    STATE(1505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3228), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3226), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [31366] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    STATE(1506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3196), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3194), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31425] = 25,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1052), 1,
      anon_sym_fn,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3817), 1,
      anon_sym_default,
    ACTIONS(3827), 1,
      sym_identifier,
    ACTIONS(3829), 1,
      anon_sym_for,
    STATE(1694), 1,
      sym_for_lifetimes,
    STATE(1913), 1,
      sym_scoped_type_identifier,
    STATE(1948), 1,
      sym_generic_type,
    STATE(1964), 1,
      sym_function_type,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3304), 1,
      sym_function_modifiers,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    STATE(1507), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31522] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3833), 1,
      anon_sym_BANG,
    STATE(1508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31582] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3168), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      anon_sym_COLON_COLON,
    STATE(1509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31642] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3676), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3753), 1,
      anon_sym_BANG,
    STATE(1510), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31702] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3837), 1,
      anon_sym_SQUOTE,
    STATE(1670), 1,
      sym_label,
    STATE(1511), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3278), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31762] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1512), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3224), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3222), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31818] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3839), 1,
      anon_sym_else,
    STATE(1707), 1,
      sym_else_clause,
    STATE(1513), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(742), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(740), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31878] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1514), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3232), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3230), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31934] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3196), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3194), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31990] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1516), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3212), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3210), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32046] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3420), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1517), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32104] = 18,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1556), 1,
      anon_sym_DASH,
    ACTIONS(1578), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3841), 1,
      sym_identifier,
    ACTIONS(3845), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3849), 1,
      sym_metavariable,
    STATE(2534), 1,
      sym_scoped_identifier,
    STATE(2831), 1,
      sym__literal_pattern,
    STATE(3399), 1,
      sym_generic_type_with_turbofish,
    STATE(3417), 1,
      sym_bracketed_type,
    ACTIONS(1580), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1518), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3847), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2272), 3,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1576), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3843), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32186] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3638), 1,
      anon_sym_BANG,
    ACTIONS(3851), 1,
      anon_sym_COLON_COLON,
    STATE(1519), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1520), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3224), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3222), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32302] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1521), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3212), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3210), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32358] = 18,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1556), 1,
      anon_sym_DASH,
    ACTIONS(1578), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3845), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3853), 1,
      sym_identifier,
    ACTIONS(3859), 1,
      sym_metavariable,
    STATE(2546), 1,
      sym_scoped_identifier,
    STATE(2858), 1,
      sym__literal_pattern,
    STATE(3399), 1,
      sym_generic_type_with_turbofish,
    STATE(3417), 1,
      sym_bracketed_type,
    ACTIONS(1580), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1522), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2272), 3,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1576), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3855), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1523), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3196), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3194), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32496] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3524), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1524), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32554] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3682), 1,
      anon_sym_BANG,
    ACTIONS(3861), 1,
      anon_sym_COLON_COLON,
    STATE(1525), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32614] = 18,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1032), 1,
      anon_sym_DASH,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3863), 1,
      sym_identifier,
    ACTIONS(3869), 1,
      sym_metavariable,
    STATE(2042), 1,
      sym_scoped_identifier,
    STATE(2048), 1,
      sym__literal_pattern,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1076), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3867), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2011), 3,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1072), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3865), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32696] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3380), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3378), 26,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32752] = 18,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1032), 1,
      anon_sym_DASH,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3871), 1,
      sym_identifier,
    ACTIONS(3877), 1,
      sym_metavariable,
    STATE(2041), 1,
      sym_scoped_identifier,
    STATE(2091), 1,
      sym__literal_pattern,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1076), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1528), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3875), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2011), 3,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1072), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3873), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [32834] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1529), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3402), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3400), 26,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32890] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1530), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3408), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3406), 26,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3232), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3230), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33002] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1532), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3272), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3270), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33057] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3879), 1,
      anon_sym_DASH_GT,
    STATE(1533), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3374), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3372), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33114] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3881), 1,
      anon_sym_DASH_GT,
    STATE(1534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3320), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3318), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33171] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1535), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3412), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3410), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33226] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3883), 1,
      anon_sym_COLON_COLON,
    STATE(1536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3204), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3202), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33283] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3883), 1,
      anon_sym_COLON_COLON,
    STATE(1537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3200), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3198), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33340] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3885), 1,
      anon_sym_COLON_COLON,
    STATE(1538), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33397] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3887), 1,
      anon_sym_DASH_GT,
    STATE(1539), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3396), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3394), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33454] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3264), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3262), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33509] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(700), 1,
      anon_sym_RBRACK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3889), 1,
      anon_sym_SEMI,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    STATE(2711), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1541), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33604] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3370), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3368), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3316), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3314), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33714] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3897), 1,
      anon_sym_DASH_GT,
    STATE(1544), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3310), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3308), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33771] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1545), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3306), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3304), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1546), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3276), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3274), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33881] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3899), 1,
      anon_sym_LPAREN,
    STATE(1685), 1,
      sym_arguments,
    STATE(1547), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3296), 23,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33940] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_RBRACK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3901), 1,
      anon_sym_SEMI,
    ACTIONS(3903), 1,
      anon_sym_COMMA,
    STATE(2964), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1548), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34035] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1549), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3326), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3324), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34090] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3905), 1,
      anon_sym_DASH_GT,
    STATE(1550), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3390), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3388), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34147] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3524), 1,
      anon_sym_COLON_COLON,
    STATE(1551), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34204] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3883), 1,
      anon_sym_COLON_COLON,
    STATE(1552), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3188), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3186), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34261] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(1119), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1553), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34356] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3935), 1,
      anon_sym_DASH_GT,
    STATE(1554), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3384), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3382), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34413] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3937), 1,
      anon_sym_COLON_COLON,
    STATE(1555), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34470] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(1360), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1556), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34565] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3883), 1,
      anon_sym_COLON_COLON,
    STATE(1557), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34622] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3939), 1,
      anon_sym_COLON_COLON,
    STATE(1558), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34679] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(1621), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1559), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34774] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(472), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34869] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1561), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3192), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
    ACTIONS(3190), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [34924] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3831), 1,
      anon_sym_COLON_COLON,
    STATE(1562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34981] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1563), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3342), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3340), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35036] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_COLON_COLON,
    STATE(1564), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35093] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3943), 1,
      anon_sym_COLON_COLON,
    STATE(1565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1566), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3696), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3694), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [35205] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(652), 1,
      anon_sym_RBRACK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3945), 1,
      anon_sym_SEMI,
    ACTIONS(3947), 1,
      anon_sym_COMMA,
    STATE(2936), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1567), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35300] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(166), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1568), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35395] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(682), 1,
      anon_sym_RBRACK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3949), 1,
      anon_sym_SEMI,
    ACTIONS(3951), 1,
      anon_sym_COMMA,
    STATE(2820), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35490] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3420), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35547] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1571), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3955), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3953), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [35602] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(1733), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1572), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35697] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(246), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1573), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35792] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1114), 1,
      sym_label,
    STATE(1574), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3280), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3278), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35849] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1575), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3708), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3706), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [35904] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    STATE(1576), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3961), 8,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3957), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [35961] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1577), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(892), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(890), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36016] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1578), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(884), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(882), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36071] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    STATE(476), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1579), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36166] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1580), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3336), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3334), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36221] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3851), 1,
      anon_sym_COLON_COLON,
    STATE(1581), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3248), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3246), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36278] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1582), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(872), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(870), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36333] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1583), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(888), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(886), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36388] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    STATE(1584), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3961), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3957), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [36445] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1585), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(896), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(894), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36500] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1586), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3967), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3965), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [36555] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3969), 1,
      anon_sym_DASH_GT,
    STATE(1587), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3330), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3328), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1588), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3973), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3971), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [36667] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1589), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3562), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36755] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1590), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3478), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3476), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36809] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(694), 1,
      anon_sym_RBRACK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3979), 1,
      anon_sym_COMMA,
    STATE(2842), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1591), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36901] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1592), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(910), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(908), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36955] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(337), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1593), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(331), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37041] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3674), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3672), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37095] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1595), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3981), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37183] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1596), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3763), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37269] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3672), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37357] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1598), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(972), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(970), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37411] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1599), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1494), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1496), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37465] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1600), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(962), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(960), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37519] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1601), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(942), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(940), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37573] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1602), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(906), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(904), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37627] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1603), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3216), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3214), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37681] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1604), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37735] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1605), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(379), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37817] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1606), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3612), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3610), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37871] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1607), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1366), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1368), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37925] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3761), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1608), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3759), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38011] = 22,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3817), 1,
      anon_sym_default,
    ACTIONS(3983), 1,
      sym_identifier,
    ACTIONS(3985), 1,
      anon_sym_fn,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(2641), 1,
      sym_scoped_type_identifier,
    STATE(3246), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3290), 1,
      sym_function_modifiers,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    STATE(1609), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [38099] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1610), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3620), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3618), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1611), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3608), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3606), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38207] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1612), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3596), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3594), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38261] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1613), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3572), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3570), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38315] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1614), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3568), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3566), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38369] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1615), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3592), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3590), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38423] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1616), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3654), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3652), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38477] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1617), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3418), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38531] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1618), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3156), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3158), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38585] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3987), 1,
      anon_sym_RPAREN,
    ACTIONS(3989), 1,
      anon_sym_COMMA,
    STATE(2799), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1619), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38677] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1620), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3204), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3202), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38731] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1621), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(988), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(986), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38785] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1622), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1478), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1480), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38839] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(698), 1,
      anon_sym_RBRACK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3991), 1,
      anon_sym_COMMA,
    STATE(2815), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1623), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38931] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3757), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1624), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3755), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39017] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3188), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3186), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39071] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1626), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3584), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3582), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39125] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1627), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1004), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1002), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39179] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1628), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39233] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1629), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 9,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39299] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39379] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1631), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(918), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(916), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39433] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1632), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3300), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3296), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39487] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1633), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 17,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39565] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1634), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1498), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1500), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39619] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1635), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3666), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3664), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1636), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1510), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1512), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39727] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3751), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1637), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3749), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39809] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1638), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39863] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1639), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3632), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3630), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1640), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(976), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(974), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39971] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    STATE(1641), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3522), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3520), 22,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40031] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1642), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3518), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3516), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40085] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1643), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(954), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(952), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40139] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(696), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_COMMA,
    STATE(2882), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1644), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40231] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    STATE(1645), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3600), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3598), 22,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40291] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1646), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40363] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(656), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4001), 1,
      anon_sym_COMMA,
    STATE(2874), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1647), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40455] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1648), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40529] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 6,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40599] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1650), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 7,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40667] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1651), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3552), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3550), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40721] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1652), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4003), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40809] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1653), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3646), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3644), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40863] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1654), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1000), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(998), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1655), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3514), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3512), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40971] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1656), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3642), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3640), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3474), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3472), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41079] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3773), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1658), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3771), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41165] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1659), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3628), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3626), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41219] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    STATE(1660), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3504), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41281] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 1,
      anon_sym_RPAREN,
    ACTIONS(4009), 1,
      anon_sym_COMMA,
    STATE(2806), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1661), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41373] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    STATE(1662), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41437] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3498), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3496), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41491] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1664), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3540), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3538), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1665), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3536), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3534), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1666), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3532), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3530), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41653] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(337), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1667), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(331), 13,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41739] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1668), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(980), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(978), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41793] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1669), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3636), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3634), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41847] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1670), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3450), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3448), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41901] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3580), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3578), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41955] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3769), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3767), 13,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42041] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42095] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1674), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3763), 13,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42181] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3564), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3562), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42235] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1676), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3446), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3444), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42289] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1677), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(379), 15,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42371] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3761), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1678), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3759), 13,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42457] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1679), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3616), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3614), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42511] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4035), 1,
      anon_sym_EQ,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1680), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3672), 3,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4037), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1681), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3576), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3574), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42653] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4035), 1,
      anon_sym_EQ,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1682), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3562), 3,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4037), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42741] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4035), 1,
      anon_sym_EQ,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1683), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3668), 3,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4037), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42829] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1684), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3604), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3602), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42883] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1685), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3482), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3480), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42937] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3416), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3414), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42991] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3442), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3440), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43045] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1688), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3650), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3648), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43099] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1689), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3438), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3436), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1690), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1016), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1014), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43207] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1691), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3560), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3558), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43261] = 22,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3817), 1,
      anon_sym_default,
    ACTIONS(4039), 1,
      sym_identifier,
    ACTIONS(4041), 1,
      anon_sym_fn,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(2594), 1,
      sym_scoped_type_identifier,
    STATE(3246), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    STATE(3404), 1,
      sym_function_modifiers,
    STATE(1692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [43349] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1693), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3556), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3554), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43403] = 22,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1060), 1,
      anon_sym_extern,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3360), 1,
      anon_sym_union,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3817), 1,
      anon_sym_default,
    ACTIONS(4043), 1,
      sym_identifier,
    ACTIONS(4045), 1,
      anon_sym_fn,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(2688), 1,
      sym_scoped_type_identifier,
    STATE(3246), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    STATE(3461), 1,
      sym_function_modifiers,
    STATE(1694), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [43491] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1695), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3430), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3428), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1696), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3528), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3526), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1697), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3528), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3526), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43653] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3769), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1698), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3767), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43739] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1699), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3494), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3492), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43793] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1700), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3670), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3668), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43847] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3925), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3975), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1701), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3668), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43935] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1702), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(948), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(950), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43989] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1703), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3662), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3660), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44043] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1704), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3490), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3488), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44097] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1705), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3658), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3656), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44151] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1706), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3486), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3484), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1707), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1008), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1006), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44259] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1708), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(996), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(994), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44313] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    STATE(1709), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3588), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3586), 22,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44373] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1710), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3544), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3542), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44427] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1711), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3424), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44481] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1712), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3470), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44535] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1713), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1012), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1010), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44589] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1714), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(984), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(982), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44643] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1715), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3548), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3546), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44697] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1716), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(966), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(964), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44751] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    STATE(1717), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44815] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1718), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(992), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(990), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44869] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3773), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1719), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3771), 13,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44955] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1720), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3466), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3464), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45009] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1721), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3454), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3452), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45063] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1722), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3200), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3198), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45117] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3757), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4025), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4023), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3755), 13,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45203] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1724), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 7,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45271] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1725), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3462), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3460), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45325] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1726), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 9,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45391] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1727), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 16,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45471] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1728), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(914), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(912), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45525] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1729), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 17,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45603] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1730), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 6,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45673] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1731), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45747] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1732), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3458), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3456), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1733), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(902), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(900), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45855] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1734), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3624), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3622), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45909] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3751), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1735), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3749), 15,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45991] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1736), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46063] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4051), 1,
      anon_sym_EQ,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1737), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4073), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46150] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4075), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1738), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46237] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4077), 1,
      anon_sym_SEMI,
    ACTIONS(4079), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46326] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4081), 1,
      anon_sym_SEMI,
    ACTIONS(4083), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1740), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46415] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(135), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1741), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46504] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(147), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46593] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(153), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1743), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46682] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4087), 1,
      anon_sym_RPAREN,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1744), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46771] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3672), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1745), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46858] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1746), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4119), 3,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_AMP_AMP,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46943] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4121), 1,
      anon_sym_SEMI,
    ACTIONS(4123), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47032] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(337), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(331), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47117] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 9,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47182] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1750), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3763), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47267] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4125), 1,
      anon_sym_RPAREN,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1751), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47356] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(379), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47437] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3761), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3759), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47522] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4129), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1754), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47609] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4131), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1755), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47698] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4133), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1756), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47785] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3757), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1757), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3755), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47870] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4135), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1758), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47957] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 9,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48022] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4035), 1,
      anon_sym_EQ,
    ACTIONS(4139), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3668), 2,
      anon_sym_EQ_GT,
      anon_sym_if,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4137), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1760), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4037), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48109] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1761), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48188] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(123), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48277] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4141), 1,
      anon_sym_SEMI,
    ACTIONS(4143), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1763), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48366] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(337), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(331), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48451] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4145), 1,
      anon_sym_LBRACE,
    ACTIONS(4149), 1,
      anon_sym_DOT_DOT,
    STATE(1640), 1,
      sym_match_block,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4147), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48540] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3763), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48625] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3562), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48712] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4035), 1,
      anon_sym_EQ,
    ACTIONS(4139), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3672), 2,
      anon_sym_EQ_GT,
      anon_sym_if,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4137), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1768), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4037), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48799] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1769), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48876] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(379), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48957] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3761), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1771), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3759), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49042] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4151), 1,
      anon_sym_SEMI,
    ACTIONS(4153), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1772), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49131] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3757), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1773), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3755), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49216] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(325), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49305] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3751), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3749), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49386] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1776), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49457] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4155), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1777), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49546] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4157), 1,
      anon_sym_RBRACE,
    ACTIONS(4159), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1778), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49635] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49708] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_RBRACE,
    ACTIONS(4163), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1780), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49797] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3672), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49884] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1782), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 6,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49953] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1783), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 7,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50020] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3773), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1784), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3771), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50105] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    STATE(1785), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50168] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3769), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1786), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3767), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50253] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4165), 1,
      anon_sym_SEMI,
    ACTIONS(4167), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1787), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50342] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4015), 1,
      anon_sym_AMP,
    ACTIONS(4017), 1,
      anon_sym_CARET,
    ACTIONS(4021), 1,
      anon_sym_PIPE,
    ACTIONS(4027), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4029), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4035), 1,
      anon_sym_EQ,
    ACTIONS(4139), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3562), 2,
      anon_sym_EQ_GT,
      anon_sym_if,
    ACTIONS(4011), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4019), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4033), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4137), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1788), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4013), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4031), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4037), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50429] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(762), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1789), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50518] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1790), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50607] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(327), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1791), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50696] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(157), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1792), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50785] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3562), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1793), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50872] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4169), 1,
      anon_sym_SEMI,
    ACTIONS(4171), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1794), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50961] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3769), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3767), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51046] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4173), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1796), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51133] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    STATE(1797), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51196] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3773), 1,
      anon_sym_EQ,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3771), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51281] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(736), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51370] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 1,
      anon_sym_RPAREN,
    ACTIONS(4177), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1800), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51459] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(4179), 1,
      anon_sym_RPAREN,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1801), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51548] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4181), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1802), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51635] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1803), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 7,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51702] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(313), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51791] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4183), 1,
      anon_sym_SEMI,
    ACTIONS(4185), 1,
      anon_sym_else,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1805), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51880] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3668), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51967] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(317), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1807), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52056] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(323), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52145] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4187), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1809), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52234] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4107), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3668), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4105), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1810), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52321] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4189), 3,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_AMP_AMP,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52406] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(315), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1812), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52495] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4149), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4191), 1,
      anon_sym_LBRACE,
    STATE(468), 1,
      sym_match_block,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4147), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1813), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52584] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(311), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1814), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52673] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4051), 1,
      anon_sym_EQ,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3562), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1815), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4073), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52760] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1816), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 6,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52829] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1817), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52918] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53007] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1819), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53080] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1820), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3504), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(3500), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53151] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3751), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3749), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53232] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4149), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4193), 1,
      anon_sym_LBRACE,
    STATE(1311), 1,
      sym_match_block,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4147), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1822), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53321] = 18,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4199), 1,
      anon_sym_RBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4205), 1,
      anon_sym_COMMA,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(2757), 1,
      sym__use_clause,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1823), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [53400] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1824), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 16,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53477] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4213), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53566] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4215), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1826), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53655] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3504), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1827), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3500), 15,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53734] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(155), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1828), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53823] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1829), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53912] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(125), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1830), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54001] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(141), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54090] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4217), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1832), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54177] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(127), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1833), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54266] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(129), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1834), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54355] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3911), 1,
      anon_sym_EQ,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    ACTIONS(3915), 1,
      anon_sym_CARET,
    ACTIONS(3919), 1,
      anon_sym_PIPE,
    ACTIONS(3923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4221), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3917), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3921), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3931), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4219), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(1835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3909), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3929), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3933), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54442] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4223), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1836), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54531] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(139), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1837), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54620] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4051), 1,
      anon_sym_EQ,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4063), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4065), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3668), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4061), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1838), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4073), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54707] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(143), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54796] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(4095), 1,
      anon_sym_EQ,
    ACTIONS(4097), 1,
      anon_sym_AMP,
    ACTIONS(4099), 1,
      anon_sym_CARET,
    ACTIONS(4103), 1,
      anon_sym_PIPE,
    ACTIONS(4109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4149), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    STATE(223), 1,
      sym_match_block,
    ACTIONS(4091), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4101), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4115), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4147), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4093), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4113), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4117), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54885] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(4227), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54974] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1842), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55060] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55146] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4231), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55232] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4233), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1845), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55318] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55404] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4237), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1847), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55490] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    ACTIONS(4239), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3114), 1,
      sym__use_clause,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [55566] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4051), 1,
      anon_sym_EQ,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4119), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4241), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1849), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4073), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55650] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4245), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1850), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55736] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4247), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1851), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55822] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1852), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55908] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4251), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1853), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55994] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4253), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1854), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56080] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4255), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1855), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56166] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4257), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1856), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56252] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1857), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56338] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4261), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1858), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56424] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4051), 1,
      anon_sym_EQ,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4189), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4241), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1859), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4073), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56508] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4263), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1860), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56594] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4265), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1861), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56680] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4267), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1862), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56766] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4269), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56852] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4271), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1864), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56938] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3995), 1,
      anon_sym_QMARK,
    ACTIONS(3997), 1,
      anon_sym_DOT,
    ACTIONS(4005), 1,
      anon_sym_as,
    ACTIONS(4051), 1,
      anon_sym_EQ,
    ACTIONS(4053), 1,
      anon_sym_AMP,
    ACTIONS(4055), 1,
      anon_sym_CARET,
    ACTIONS(4059), 1,
      anon_sym_PIPE,
    ACTIONS(4067), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_EQ_GT,
    ACTIONS(4243), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4047), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4057), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4071), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4241), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1865), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4049), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(4073), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57024] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4275), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1866), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57110] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4277), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1867), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57196] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4085), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1868), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57282] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1869), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57368] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4281), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1870), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57454] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    ACTIONS(4283), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3114), 1,
      sym__use_clause,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1871), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57530] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4285), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1872), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57616] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4287), 1,
      anon_sym_RBRACK,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1873), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57702] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_COMMA,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1874), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57788] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3506), 1,
      anon_sym_QMARK,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_as,
    ACTIONS(3719), 1,
      anon_sym_EQ,
    ACTIONS(3721), 1,
      anon_sym_AMP,
    ACTIONS(3723), 1,
      anon_sym_CARET,
    ACTIONS(3727), 1,
      anon_sym_PIPE,
    ACTIONS(3733), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3735), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4291), 1,
      anon_sym_SEMI,
    ACTIONS(3715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3725), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3739), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1875), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3737), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3741), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57874] = 16,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(3464), 1,
      sym__use_clause,
    STATE(1876), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57947] = 16,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3114), 1,
      sym__use_clause,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58020] = 16,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(3471), 1,
      sym__use_clause,
    STATE(1878), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58093] = 16,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(3518), 1,
      sym__use_clause,
    STATE(1879), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58166] = 16,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4195), 1,
      sym_identifier,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4211), 1,
      sym_metavariable,
    STATE(2380), 1,
      sym_scoped_identifier,
    STATE(3331), 1,
      sym__use_clause,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1880), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2880), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4203), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58239] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4293), 1,
      sym_identifier,
    STATE(2886), 1,
      sym_scoped_type_identifier,
    STATE(2994), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1881), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58313] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4295), 1,
      sym_identifier,
    STATE(2728), 1,
      sym_scoped_type_identifier,
    STATE(3068), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1882), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58387] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4297), 1,
      sym_identifier,
    STATE(2701), 1,
      sym_scoped_type_identifier,
    STATE(3015), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1883), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58461] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4299), 1,
      sym_identifier,
    STATE(2702), 1,
      sym_scoped_type_identifier,
    STATE(3017), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1884), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58535] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4301), 1,
      sym_identifier,
    STATE(2706), 1,
      sym_scoped_type_identifier,
    STATE(3036), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1885), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58609] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4303), 1,
      sym_identifier,
    STATE(2699), 1,
      sym_scoped_type_identifier,
    STATE(3007), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1886), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58683] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4305), 1,
      sym_identifier,
    STATE(2851), 1,
      sym_scoped_type_identifier,
    STATE(3173), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1887), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58757] = 17,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3366), 1,
      sym_metavariable,
    ACTIONS(3612), 1,
      anon_sym_where,
    ACTIONS(4307), 1,
      sym_identifier,
    STATE(2971), 1,
      sym_scoped_type_identifier,
    STATE(2990), 1,
      sym_generic_type,
    STATE(3248), 1,
      sym_scoped_identifier,
    STATE(3391), 1,
      sym_bracketed_type,
    STATE(3394), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3360), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1888), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3364), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3610), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(3815), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58831] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1889), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4311), 3,
      anon_sym_COLON_COLON,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(4309), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58877] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1890), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4315), 3,
      anon_sym_COLON_COLON,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(4313), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58923] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1891), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4319), 3,
      anon_sym_COLON_COLON,
      anon_sym_LT,
      sym_metavariable,
    ACTIONS(4317), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58969] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3376), 1,
      sym_attribute,
    STATE(1892), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59030] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3334), 1,
      sym_attribute,
    STATE(1893), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59091] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3278), 1,
      sym_attribute,
    STATE(1894), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59152] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3475), 1,
      sym_attribute,
    STATE(1895), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59213] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3448), 1,
      sym_attribute,
    STATE(1896), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59274] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3357), 1,
      sym_attribute,
    STATE(1897), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59335] = 13,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4321), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      sym_metavariable,
    STATE(2264), 1,
      sym_scoped_identifier,
    STATE(3244), 1,
      sym_bracketed_type,
    STATE(3269), 1,
      sym_generic_type_with_turbofish,
    STATE(3315), 1,
      sym_attribute,
    STATE(1898), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4325), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4323), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59396] = 12,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4329), 1,
      sym_identifier,
    ACTIONS(4333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4337), 1,
      sym_metavariable,
    STATE(3138), 1,
      sym_scoped_identifier,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1899), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4335), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4331), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59454] = 12,
    ACTIONS(31), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4339), 1,
      sym_identifier,
    ACTIONS(4345), 1,
      sym_metavariable,
    STATE(3094), 1,
      sym_scoped_identifier,
    STATE(3332), 1,
      sym_generic_type_with_turbofish,
    STATE(3379), 1,
      sym_bracketed_type,
    STATE(1900), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4343), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4341), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT,
    STATE(1901), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1512), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [59548] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3164), 1,
      anon_sym_COLON,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(1902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59596] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1494), 1,
      anon_sym_DOT_DOT,
    STATE(1903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1496), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [59632] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3174), 1,
      anon_sym_COLON,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(1904), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3172), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3192), 1,
      anon_sym_COLON,
    ACTIONS(3194), 2,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
    STATE(1905), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3190), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59714] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3184), 1,
      anon_sym_COLON,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(1906), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3182), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59759] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3228), 1,
      anon_sym_COLON,
    ACTIONS(3230), 2,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
    STATE(1907), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3226), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59796] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3180), 1,
      anon_sym_COLON,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(1908), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3178), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59841] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4359), 1,
      anon_sym_LPAREN,
    ACTIONS(4361), 1,
      anon_sym_LBRACE,
    ACTIONS(4363), 1,
      anon_sym_COLON,
    ACTIONS(4365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4367), 1,
      anon_sym_AT,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    STATE(1929), 1,
      sym_type_arguments,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1909), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [59894] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3220), 1,
      anon_sym_COLON,
    ACTIONS(3222), 2,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
    STATE(1910), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3218), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59931] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3208), 1,
      anon_sym_COLON,
    ACTIONS(3210), 2,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
    STATE(1911), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3206), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59968] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1912), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3198), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60008] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1913), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3202), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60048] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1914), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60088] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(1915), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3186), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60128] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3224), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1916), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3222), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60161] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3190), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(3196), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1917), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3194), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60196] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3226), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(3232), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1918), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3230), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60231] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1919), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3190), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [60262] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3206), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(3212), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1920), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3210), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60297] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3218), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(3224), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1921), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3222), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3232), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1922), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3230), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60365] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3196), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1923), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3194), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60398] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3212), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1924), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3210), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [60431] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4377), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1925), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [60477] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4387), 1,
      anon_sym_const,
    ACTIONS(4389), 1,
      anon_sym_enum,
    ACTIONS(4391), 1,
      anon_sym_fn,
    ACTIONS(4393), 1,
      anon_sym_mod,
    ACTIONS(4395), 1,
      anon_sym_static,
    ACTIONS(4397), 1,
      anon_sym_struct,
    ACTIONS(4399), 1,
      anon_sym_trait,
    ACTIONS(4401), 1,
      anon_sym_type,
    ACTIONS(4403), 1,
      anon_sym_union,
    ACTIONS(4405), 1,
      anon_sym_unsafe,
    ACTIONS(4407), 1,
      anon_sym_use,
    ACTIONS(4409), 1,
      anon_sym_extern,
    STATE(2122), 1,
      sym_extern_modifier,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3515), 1,
      sym_function_modifiers,
    ACTIONS(4385), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1926), 2,
      sym_line_comment,
      sym_block_comment,
  [60537] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3408), 1,
      anon_sym_COLON,
    STATE(1927), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3406), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60569] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3306), 1,
      anon_sym_COLON,
    STATE(1928), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3304), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60601] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    STATE(1929), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3336), 1,
      anon_sym_COLON,
    STATE(1930), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3334), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60665] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4411), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1931), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [60709] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3402), 1,
      anon_sym_COLON,
    STATE(1932), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3400), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60741] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4413), 1,
      anon_sym_const,
    ACTIONS(4415), 1,
      anon_sym_enum,
    ACTIONS(4417), 1,
      anon_sym_fn,
    ACTIONS(4419), 1,
      anon_sym_mod,
    ACTIONS(4421), 1,
      anon_sym_static,
    ACTIONS(4423), 1,
      anon_sym_struct,
    ACTIONS(4425), 1,
      anon_sym_trait,
    ACTIONS(4427), 1,
      anon_sym_type,
    ACTIONS(4429), 1,
      anon_sym_union,
    ACTIONS(4431), 1,
      anon_sym_unsafe,
    ACTIONS(4433), 1,
      anon_sym_use,
    ACTIONS(4435), 1,
      anon_sym_extern,
    STATE(2132), 1,
      sym_extern_modifier,
    STATE(2184), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3458), 1,
      sym_function_modifiers,
    ACTIONS(4385), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1933), 2,
      sym_line_comment,
      sym_block_comment,
  [60801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3380), 1,
      anon_sym_COLON,
    STATE(1934), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3378), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60833] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4437), 1,
      anon_sym_DASH_GT,
    STATE(1935), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3382), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60864] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3216), 1,
      anon_sym_COLON,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    STATE(1936), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60897] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4359), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_COLON,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4441), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1937), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [60938] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3160), 1,
      anon_sym_PLUS,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4361), 1,
      anon_sym_LBRACE,
    ACTIONS(4363), 1,
      anon_sym_COLON,
    ACTIONS(4367), 1,
      anon_sym_AT,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4443), 1,
      anon_sym_LPAREN,
    ACTIONS(4448), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4445), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1938), 2,
      sym_line_comment,
      sym_block_comment,
  [60993] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3200), 1,
      anon_sym_COLON,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    STATE(1939), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3198), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4450), 1,
      anon_sym_DASH_GT,
    STATE(1940), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3394), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61057] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4452), 1,
      anon_sym_DASH_GT,
    STATE(1941), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3388), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61088] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1942), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(998), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61117] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4361), 1,
      anon_sym_LBRACE,
    ACTIONS(4367), 1,
      anon_sym_AT,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_RBRACK,
    ACTIONS(4454), 1,
      anon_sym_LPAREN,
    ACTIONS(4456), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    ACTIONS(3160), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1943), 2,
      sym_line_comment,
      sym_block_comment,
  [61170] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3216), 1,
      anon_sym_COLON,
    ACTIONS(4458), 1,
      anon_sym_COLON_COLON,
    STATE(1944), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61203] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1945), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3368), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61232] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1946), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3314), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61261] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4460), 1,
      anon_sym_DASH_GT,
    STATE(1947), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3328), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61292] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3204), 1,
      anon_sym_COLON,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    STATE(1948), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3202), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61325] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1949), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(912), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61354] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1950), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61383] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4462), 1,
      anon_sym_DASH_GT,
    STATE(1951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3308), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61414] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4361), 1,
      anon_sym_LBRACE,
    ACTIONS(4363), 1,
      anon_sym_COLON,
    ACTIONS(4367), 1,
      anon_sym_AT,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4464), 1,
      anon_sym_LPAREN,
    ACTIONS(4466), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1952), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [61467] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4468), 1,
      anon_sym_DASH_GT,
    STATE(1953), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3372), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61498] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1954), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3410), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61527] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1955), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [61570] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1956), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1014), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61599] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3262), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61628] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3188), 1,
      anon_sym_COLON,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    STATE(1958), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3186), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61661] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1959), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(916), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61690] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3216), 1,
      anon_sym_COLON,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    STATE(1960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61723] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4472), 1,
      anon_sym_DASH_GT,
    STATE(1961), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3318), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61754] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4474), 1,
      anon_sym_LPAREN,
    STATE(1962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3957), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61785] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3526), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61813] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3202), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61841] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1965), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3953), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61869] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1966), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3436), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61897] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3464), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61925] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3530), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61953] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3546), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61981] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3198), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62009] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3542), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62037] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62065] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3460), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62093] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1974), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3526), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62121] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4476), 1,
      anon_sym_COLON_COLON,
    STATE(1975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3961), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [62151] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3456), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62179] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1977), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3652), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62207] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3440), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62235] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3444), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62263] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1980), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3558), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62291] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3710), 1,
      anon_sym_COLON_COLON,
    STATE(1981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3961), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [62321] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1982), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3424), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62349] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3971), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [62377] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3965), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [62405] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3428), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62433] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1986), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3634), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62461] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4373), 1,
      anon_sym_PIPE,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4478), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1987), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [62505] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1988), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3610), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62533] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3472), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62561] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3554), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62589] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1991), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3476), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62617] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3186), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62645] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4480), 1,
      anon_sym_COLON,
    ACTIONS(4482), 1,
      anon_sym_EQ,
    ACTIONS(4484), 1,
      anon_sym_COMMA,
    ACTIONS(4486), 1,
      anon_sym_GT,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2956), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3160), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(1993), 2,
      sym_line_comment,
      sym_block_comment,
  [62696] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1478), 1,
      anon_sym_DOT_DOT,
    STATE(1994), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [62725] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4411), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [62760] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4490), 1,
      anon_sym_pat,
    STATE(437), 1,
      sym_fragment_specifier,
    STATE(1996), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4488), 12,
      anon_sym_block,
      anon_sym_expr,
      anon_sym_ident,
      anon_sym_item,
      anon_sym_lifetime,
      anon_sym_literal,
      anon_sym_meta,
      anon_sym_path,
      anon_sym_stmt,
      anon_sym_tt,
      anon_sym_ty,
      anon_sym_vis,
  [62791] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3196), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4492), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(1997), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3190), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3194), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62823] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3212), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4495), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(1998), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3206), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3210), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62855] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3224), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1999), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3218), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4498), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3222), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62887] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3224), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4498), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3218), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3222), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62919] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4495), 1,
      anon_sym_LPAREN,
    ACTIONS(3212), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3206), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3210), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62951] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4501), 1,
      anon_sym_LPAREN,
    ACTIONS(3232), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3226), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3230), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62983] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3212), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3206), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4495), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3210), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63015] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4506), 1,
      anon_sym_DOT_DOT,
    STATE(2004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4504), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [63043] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4492), 1,
      anon_sym_LPAREN,
    ACTIONS(3196), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3190), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3194), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63075] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63105] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3232), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3226), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4501), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3230), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63137] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4498), 1,
      anon_sym_LPAREN,
    ACTIONS(3224), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3218), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3222), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63169] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3232), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4501), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3226), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3230), 6,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63201] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3196), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3190), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4492), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3194), 5,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63233] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4510), 1,
      anon_sym_DOT_DOT,
    STATE(2011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4508), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
  [63261] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4512), 1,
      anon_sym_LPAREN,
    ACTIONS(4514), 1,
      anon_sym_LBRACE,
    ACTIONS(4516), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4518), 1,
      anon_sym_BANG,
    ACTIONS(4520), 1,
      anon_sym_AT,
    ACTIONS(4524), 1,
      anon_sym_DOT_DOT,
    STATE(1929), 1,
      sym_type_arguments,
    ACTIONS(4522), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [63305] = 10,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4425), 1,
      anon_sym_trait,
    ACTIONS(4526), 1,
      anon_sym_impl,
    STATE(207), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63342] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3224), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3218), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3222), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63370] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4530), 1,
      anon_sym_COLON,
    ACTIONS(4532), 1,
      anon_sym_COLON_COLON,
    STATE(2015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63398] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4534), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63436] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4538), 1,
      anon_sym_COLON,
    ACTIONS(4540), 1,
      anon_sym_COLON_COLON,
    STATE(2017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4536), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63464] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4542), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63502] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4544), 1,
      sym_identifier,
    STATE(172), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4546), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63536] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(886), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63560] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4548), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63598] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4550), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63636] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(894), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63660] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3212), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3206), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3210), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63688] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(890), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63712] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4554), 1,
      sym_crate,
    STATE(2196), 1,
      sym_string_literal,
    STATE(2026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4552), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63742] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3232), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3226), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3230), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63770] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4556), 1,
      sym_crate,
    STATE(2196), 1,
      sym_string_literal,
    STATE(2028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4552), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63800] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4558), 1,
      sym_crate,
    STATE(2196), 1,
      sym_string_literal,
    STATE(2029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4552), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(870), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63854] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4540), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4562), 1,
      anon_sym_COLON,
    STATE(2031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4560), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [63882] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4564), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63920] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4566), 1,
      sym_crate,
    STATE(2196), 1,
      sym_string_literal,
    STATE(2033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4552), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63950] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4568), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63988] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4572), 1,
      anon_sym_COLON,
    STATE(2035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64016] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(882), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64040] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4574), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64078] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4476), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4572), 1,
      anon_sym_COLON,
    STATE(2038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64106] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4576), 1,
      anon_sym_move,
    STATE(168), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64140] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4377), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [64178] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4572), 1,
      anon_sym_COLON,
    ACTIONS(4578), 1,
      anon_sym_COLON_COLON,
    STATE(2041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64206] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4530), 1,
      anon_sym_COLON,
    ACTIONS(4578), 1,
      anon_sym_COLON_COLON,
    STATE(2042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64234] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4476), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4530), 1,
      anon_sym_COLON,
    STATE(2043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64262] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3196), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3190), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3194), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [64290] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4580), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1961), 1,
      sym_parameters,
    STATE(2045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4582), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64351] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4584), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64374] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64397] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4588), 1,
      anon_sym_RBRACE,
    ACTIONS(4590), 1,
      anon_sym_COMMA,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2049), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2714), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64434] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4594), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64457] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4596), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64480] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(3943), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4598), 1,
      anon_sym_BANG,
    STATE(1545), 1,
      sym_type_arguments,
    STATE(2052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64511] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64534] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4600), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64557] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4602), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64580] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4359), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_COLON,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4604), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [64615] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4606), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64638] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4608), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64661] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4610), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64684] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4612), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64707] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4614), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64730] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1606), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(2075), 1,
      sym_block,
    STATE(3497), 1,
      sym_label,
    STATE(2062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64761] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4349), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4616), 1,
      anon_sym_EQ,
    STATE(1961), 1,
      sym_parameters,
    STATE(2418), 1,
      sym_type_arguments,
    STATE(2063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3160), 3,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_GT,
  [64798] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4618), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64821] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4620), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64844] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [64879] = 13,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4624), 1,
      anon_sym_RBRACE,
    ACTIONS(4626), 1,
      anon_sym_COMMA,
    ACTIONS(4628), 1,
      sym_crate,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2170), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2745), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2067), 2,
      sym_line_comment,
      sym_block_comment,
  [64920] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4630), 1,
      anon_sym_RBRACE,
    ACTIONS(4632), 1,
      anon_sym_COMMA,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2068), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2735), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64957] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4634), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [64980] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4636), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65003] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4638), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4640), 1,
      anon_sym_BANG,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4642), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [65038] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4646), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65061] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4648), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65084] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65107] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(908), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65130] = 13,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4652), 1,
      anon_sym_RBRACE,
    ACTIONS(4654), 1,
      anon_sym_COMMA,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2212), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2925), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2076), 2,
      sym_line_comment,
      sym_block_comment,
  [65171] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4656), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65194] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4658), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65217] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4660), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65240] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4662), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65263] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4664), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4666), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65309] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(3286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4668), 1,
      anon_sym_BANG,
    STATE(1063), 1,
      sym_type_arguments,
    STATE(2083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65340] = 13,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4672), 1,
      anon_sym_RBRACE,
    ACTIONS(4674), 1,
      anon_sym_COMMA,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2157), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2691), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2084), 2,
      sym_line_comment,
      sym_block_comment,
  [65381] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65404] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65427] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4680), 1,
      anon_sym_LBRACE,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [65460] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4682), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65483] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4458), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    STATE(2089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65514] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4684), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65537] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65560] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
  [65583] = 13,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4688), 1,
      anon_sym_RBRACE,
    ACTIONS(4690), 1,
      anon_sym_COMMA,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2181), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2771), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2093), 2,
      sym_line_comment,
      sym_block_comment,
  [65624] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4692), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2094), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2982), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [65658] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4373), 1,
      anon_sym_PIPE,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4478), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [65690] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4694), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    STATE(2096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65718] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4696), 1,
      anon_sym_LPAREN,
    ACTIONS(4701), 1,
      anon_sym_LBRACK,
    ACTIONS(4704), 1,
      anon_sym_LBRACE,
    STATE(3406), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    ACTIONS(4699), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2097), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_macro_definition_repeat1,
  [65750] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4707), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2098), 2,
      sym_line_comment,
      sym_block_comment,
  [65788] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4709), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2099), 2,
      sym_line_comment,
      sym_block_comment,
  [65826] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4711), 1,
      anon_sym_SEMI,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    STATE(558), 1,
      sym_field_declaration_list,
    STATE(2244), 1,
      sym_type_parameters,
    STATE(2811), 1,
      sym_ordered_field_declaration_list,
    STATE(3237), 1,
      sym_where_clause,
    STATE(2100), 2,
      sym_line_comment,
      sym_block_comment,
  [65864] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4723), 1,
      anon_sym_GT,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2101), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65900] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4729), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2102), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65936] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4512), 1,
      anon_sym_LPAREN,
    ACTIONS(4518), 1,
      anon_sym_BANG,
    ACTIONS(4524), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4731), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4522), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [65968] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4359), 1,
      anon_sym_LPAREN,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [66000] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4735), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2105), 2,
      sym_line_comment,
      sym_block_comment,
  [66038] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4737), 1,
      anon_sym_GT,
    STATE(2474), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2106), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66074] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4739), 1,
      anon_sym_SEMI,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1302), 1,
      sym_field_declaration_list,
    STATE(2239), 1,
      sym_type_parameters,
    STATE(2778), 1,
      sym_ordered_field_declaration_list,
    STATE(3165), 1,
      sym_where_clause,
    STATE(2107), 2,
      sym_line_comment,
      sym_block_comment,
  [66112] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4743), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2108), 2,
      sym_line_comment,
      sym_block_comment,
  [66150] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4745), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2109), 2,
      sym_line_comment,
      sym_block_comment,
  [66188] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3214), 1,
      anon_sym_PLUS,
    ACTIONS(4373), 1,
      anon_sym_PIPE,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4377), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4747), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2110), 2,
      sym_line_comment,
      sym_block_comment,
  [66222] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4750), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2111), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2982), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66256] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4752), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2112), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2982), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66290] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2113), 2,
      sym_line_comment,
      sym_block_comment,
  [66328] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3212), 1,
      anon_sym_DOT_DOT,
    STATE(2114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3210), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [66352] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4756), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66384] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4758), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66416] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4373), 1,
      anon_sym_PIPE,
    ACTIONS(4375), 1,
      anon_sym_COLON,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4478), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2117), 2,
      sym_line_comment,
      sym_block_comment,
  [66452] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4470), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4747), 1,
      anon_sym_RBRACK,
    ACTIONS(3214), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4373), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(4381), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2118), 2,
      sym_line_comment,
      sym_block_comment,
  [66484] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4760), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2119), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66520] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4762), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2120), 2,
      sym_line_comment,
      sym_block_comment,
  [66558] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4764), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2121), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66594] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4766), 1,
      anon_sym_SEMI,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1282), 1,
      sym_declaration_list,
    STATE(2122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66622] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4770), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2123), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66658] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4772), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2124), 2,
      sym_line_comment,
      sym_block_comment,
  [66696] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4774), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2125), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3232), 1,
      anon_sym_DOT_DOT,
    STATE(2126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3230), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [66756] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4776), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66788] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4778), 1,
      anon_sym_SEMI,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(588), 1,
      sym_declaration_list,
    STATE(2128), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66816] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4782), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2129), 2,
      sym_line_comment,
      sym_block_comment,
  [66854] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2130), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2982), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [66888] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4786), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2131), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66924] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4788), 1,
      anon_sym_SEMI,
    STATE(521), 1,
      sym_declaration_list,
    STATE(2132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66952] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    ACTIONS(4790), 1,
      anon_sym_GT,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2133), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [66988] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(4792), 1,
      anon_sym_COLON_COLON,
    STATE(1545), 1,
      sym_type_arguments,
    STATE(2134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67016] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3196), 1,
      anon_sym_DOT_DOT,
    STATE(2135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3194), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [67040] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4794), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67072] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4796), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67104] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4798), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67136] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(4800), 1,
      anon_sym_COLON_COLON,
    STATE(1063), 1,
      sym_type_arguments,
    STATE(2139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67164] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4802), 1,
      anon_sym_SEMI,
    STATE(559), 1,
      sym_field_declaration_list,
    STATE(2265), 1,
      sym_type_parameters,
    STATE(2788), 1,
      sym_ordered_field_declaration_list,
    STATE(3209), 1,
      sym_where_clause,
    STATE(2140), 2,
      sym_line_comment,
      sym_block_comment,
  [67202] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4804), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67234] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4806), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2142), 2,
      sym_line_comment,
      sym_block_comment,
  [67272] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4808), 1,
      anon_sym_SEMI,
    STATE(1419), 1,
      sym_declaration_list,
    STATE(2143), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4812), 1,
      anon_sym_PLUS,
    STATE(2144), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(4810), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67324] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4815), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1947), 1,
      sym_parameters,
    STATE(2145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67356] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3224), 1,
      anon_sym_DOT_DOT,
    STATE(2146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3222), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [67380] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4817), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2147), 2,
      sym_line_comment,
      sym_block_comment,
  [67418] = 12,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    ACTIONS(4819), 1,
      anon_sym_RBRACE,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2148), 2,
      sym_line_comment,
      sym_block_comment,
  [67456] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    ACTIONS(4821), 1,
      anon_sym_SEMI,
    STATE(1182), 1,
      sym_field_declaration_list,
    STATE(2227), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_ordered_field_declaration_list,
    STATE(3200), 1,
      sym_where_clause,
    STATE(2149), 2,
      sym_line_comment,
      sym_block_comment,
  [67494] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4825), 1,
      anon_sym_PLUS,
    STATE(2153), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4823), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67520] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4827), 1,
      anon_sym_PLUS,
    STATE(2153), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4823), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67546] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4829), 1,
      anon_sym_PLUS,
    STATE(2153), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4823), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67572] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4829), 1,
      anon_sym_PLUS,
    STATE(2144), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2153), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4831), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67598] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4833), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67619] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1074), 1,
      aux_sym_string_literal_token1,
    STATE(2196), 1,
      sym_string_literal,
    STATE(2155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4552), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67644] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4835), 1,
      anon_sym_SEMI,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1406), 1,
      sym_block,
    STATE(2387), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2156), 2,
      sym_line_comment,
      sym_block_comment,
  [67679] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2957), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2157), 2,
      sym_line_comment,
      sym_block_comment,
  [67714] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4841), 1,
      anon_sym_SEMI,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_block,
    STATE(2450), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2158), 2,
      sym_line_comment,
      sym_block_comment,
  [67749] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4845), 1,
      anon_sym_SEMI,
    STATE(1431), 1,
      sym_block,
    STATE(2361), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2159), 2,
      sym_line_comment,
      sym_block_comment,
  [67784] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(1192), 1,
      sym_declaration_list,
    STATE(2286), 1,
      sym_type_parameters,
    STATE(2667), 1,
      sym_trait_bounds,
    STATE(3189), 1,
      sym_where_clause,
    STATE(2160), 2,
      sym_line_comment,
      sym_block_comment,
  [67819] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4851), 1,
      anon_sym_SEMI,
    STATE(1443), 1,
      sym_block,
    STATE(2377), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2161), 2,
      sym_line_comment,
      sym_block_comment,
  [67854] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67875] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2163), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67896] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT_DOT,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2164), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2982), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [67927] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4853), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_block,
    STATE(2439), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2165), 2,
      sym_line_comment,
      sym_block_comment,
  [67962] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67983] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68004] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4810), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68025] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4855), 1,
      sym_identifier,
    ACTIONS(4857), 1,
      sym_metavariable,
    STATE(2427), 1,
      sym_lifetime,
    STATE(2662), 1,
      sym_constrained_type_parameter,
    STATE(2169), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2813), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [68058] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2837), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2170), 2,
      sym_line_comment,
      sym_block_comment,
  [68093] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4859), 1,
      anon_sym_SEMI,
    ACTIONS(4861), 1,
      anon_sym_DASH_GT,
    STATE(1225), 1,
      sym_block,
    STATE(2426), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2171), 2,
      sym_line_comment,
      sym_block_comment,
  [68128] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4863), 1,
      anon_sym_SEMI,
    ACTIONS(4865), 1,
      anon_sym_DASH_GT,
    STATE(623), 1,
      sym_block,
    STATE(2410), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2172), 2,
      sym_line_comment,
      sym_block_comment,
  [68163] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    ACTIONS(4871), 1,
      anon_sym_COMMA,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    STATE(2173), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2739), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68196] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(4877), 1,
      anon_sym_RBRACE,
    ACTIONS(4879), 1,
      anon_sym_COMMA,
    STATE(2174), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2737), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68229] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(3061), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2175), 2,
      sym_line_comment,
      sym_block_comment,
  [68264] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4881), 1,
      anon_sym_SEMI,
    ACTIONS(4883), 1,
      anon_sym_DASH_GT,
    STATE(720), 1,
      sym_block,
    STATE(2385), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2176), 2,
      sym_line_comment,
      sym_block_comment,
  [68299] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4885), 1,
      anon_sym_SEMI,
    ACTIONS(4887), 1,
      anon_sym_DASH_GT,
    STATE(651), 1,
      sym_block,
    STATE(2441), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2177), 2,
      sym_line_comment,
      sym_block_comment,
  [68334] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4889), 1,
      anon_sym_SEMI,
    ACTIONS(4891), 1,
      anon_sym_DASH_GT,
    STATE(1356), 1,
      sym_block,
    STATE(2388), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2178), 2,
      sym_line_comment,
      sym_block_comment,
  [68369] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4896), 1,
      anon_sym_fn,
    ACTIONS(4898), 1,
      anon_sym_extern,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(2179), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(4893), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [68396] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4901), 1,
      anon_sym_SEMI,
    STATE(1341), 1,
      sym_block,
    STATE(2390), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2180), 2,
      sym_line_comment,
      sym_block_comment,
  [68431] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2857), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2181), 2,
      sym_line_comment,
      sym_block_comment,
  [68466] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_identifier,
    ACTIONS(4905), 1,
      sym_metavariable,
    STATE(2284), 1,
      sym_lifetime,
    STATE(2537), 1,
      sym_constrained_type_parameter,
    STATE(2182), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2829), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [68499] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4907), 1,
      anon_sym_SEMI,
    ACTIONS(4909), 1,
      anon_sym_DASH_GT,
    STATE(691), 1,
      sym_block,
    STATE(2369), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2183), 2,
      sym_line_comment,
      sym_block_comment,
  [68534] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4911), 1,
      anon_sym_fn,
    ACTIONS(4913), 1,
      anon_sym_extern,
    STATE(2179), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2277), 1,
      sym_extern_modifier,
    STATE(2184), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4385), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [68563] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4915), 1,
      anon_sym_SEMI,
    STATE(748), 1,
      sym_block,
    STATE(2383), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2185), 2,
      sym_line_comment,
      sym_block_comment,
  [68598] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4917), 1,
      anon_sym_SEMI,
    STATE(1261), 1,
      sym_block,
    STATE(2424), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2186), 2,
      sym_line_comment,
      sym_block_comment,
  [68633] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_COLON,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4919), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2187), 2,
      sym_line_comment,
      sym_block_comment,
  [68666] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4903), 1,
      sym_identifier,
    ACTIONS(4905), 1,
      sym_metavariable,
    STATE(2443), 1,
      sym_lifetime,
    STATE(2537), 1,
      sym_constrained_type_parameter,
    STATE(2188), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2829), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [68699] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4921), 1,
      anon_sym_SEMI,
    ACTIONS(4923), 1,
      anon_sym_DASH_GT,
    STATE(1122), 1,
      sym_block,
    STATE(2419), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2189), 2,
      sym_line_comment,
      sym_block_comment,
  [68734] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(4925), 1,
      anon_sym_RBRACE,
    ACTIONS(4927), 1,
      anon_sym_COMMA,
    STATE(2190), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2790), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68767] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(647), 1,
      sym_declaration_list,
    STATE(2294), 1,
      sym_type_parameters,
    STATE(2672), 1,
      sym_trait_bounds,
    STATE(3082), 1,
      sym_where_clause,
    STATE(2191), 2,
      sym_line_comment,
      sym_block_comment,
  [68802] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2192), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4929), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_SQUOTE,
      anon_sym_where,
  [68823] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4931), 1,
      anon_sym_SEMI,
    STATE(538), 1,
      sym_block,
    STATE(2451), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2193), 2,
      sym_line_comment,
      sym_block_comment,
  [68858] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4933), 1,
      anon_sym_SEMI,
    ACTIONS(4935), 1,
      anon_sym_DASH_GT,
    STATE(1224), 1,
      sym_block,
    STATE(2398), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2194), 2,
      sym_line_comment,
      sym_block_comment,
  [68893] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2968), 1,
      anon_sym_SQUOTE,
    ACTIONS(4721), 1,
      sym_identifier,
    ACTIONS(4725), 1,
      anon_sym_const,
    ACTIONS(4727), 1,
      sym_metavariable,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2921), 1,
      sym_constrained_type_parameter,
    STATE(2195), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3076), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [68926] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2196), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4937), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68947] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(4939), 1,
      anon_sym_RBRACE,
    ACTIONS(4941), 1,
      anon_sym_COMMA,
    STATE(2197), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2889), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68980] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4943), 1,
      anon_sym_SEMI,
    ACTIONS(4945), 1,
      anon_sym_DASH_GT,
    STATE(620), 1,
      sym_block,
    STATE(2404), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2198), 2,
      sym_line_comment,
      sym_block_comment,
  [69015] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2210), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3208), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2199), 2,
      sym_line_comment,
      sym_block_comment,
  [69050] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4947), 1,
      anon_sym_SEMI,
    STATE(770), 1,
      sym_block,
    STATE(2422), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2200), 2,
      sym_line_comment,
      sym_block_comment,
  [69085] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4399), 1,
      anon_sym_trait,
    ACTIONS(4949), 1,
      anon_sym_impl,
    STATE(2201), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69110] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4951), 1,
      anon_sym_SEMI,
    ACTIONS(4953), 1,
      anon_sym_DASH_GT,
    STATE(673), 1,
      sym_block,
    STATE(2367), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2202), 2,
      sym_line_comment,
      sym_block_comment,
  [69145] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4955), 1,
      anon_sym_SEMI,
    ACTIONS(4957), 1,
      anon_sym_DASH_GT,
    STATE(1166), 1,
      sym_block,
    STATE(2401), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2203), 2,
      sym_line_comment,
      sym_block_comment,
  [69180] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(1300), 1,
      sym_declaration_list,
    STATE(2321), 1,
      sym_type_parameters,
    STATE(2673), 1,
      sym_trait_bounds,
    STATE(3093), 1,
      sym_where_clause,
    STATE(2204), 2,
      sym_line_comment,
      sym_block_comment,
  [69215] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4959), 1,
      anon_sym_SEMI,
    ACTIONS(4961), 1,
      anon_sym_DASH_GT,
    STATE(1281), 1,
      sym_block,
    STATE(2411), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2205), 2,
      sym_line_comment,
      sym_block_comment,
  [69250] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(1237), 1,
      sym_declaration_list,
    STATE(2285), 1,
      sym_type_parameters,
    STATE(2650), 1,
      sym_trait_bounds,
    STATE(3130), 1,
      sym_where_clause,
    STATE(2206), 2,
      sym_line_comment,
      sym_block_comment,
  [69285] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4628), 1,
      sym_crate,
    ACTIONS(4670), 1,
      sym_identifier,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2175), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3176), 1,
      sym_field_declaration,
    STATE(3360), 1,
      sym_visibility_modifier,
    STATE(2207), 2,
      sym_line_comment,
      sym_block_comment,
  [69320] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4540), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4640), 1,
      anon_sym_BANG,
    STATE(2208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69345] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(704), 1,
      sym_declaration_list,
    STATE(2341), 1,
      sym_type_parameters,
    STATE(2595), 1,
      sym_trait_bounds,
    STATE(3037), 1,
      sym_where_clause,
    STATE(2209), 2,
      sym_line_comment,
      sym_block_comment,
  [69380] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(3071), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2210), 2,
      sym_line_comment,
      sym_block_comment,
  [69415] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(554), 1,
      sym_declaration_list,
    STATE(2322), 1,
      sym_type_parameters,
    STATE(2514), 1,
      sym_trait_bounds,
    STATE(2976), 1,
      sym_where_clause,
    STATE(2211), 2,
      sym_line_comment,
      sym_block_comment,
  [69450] = 11,
    ACTIONS(65), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(4622), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      sym_crate,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2914), 1,
      sym_enum_variant,
    STATE(3449), 1,
      sym_visibility_modifier,
    STATE(2212), 2,
      sym_line_comment,
      sym_block_comment,
  [69485] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(4963), 1,
      anon_sym_SEMI,
    STATE(517), 1,
      sym_block,
    STATE(2446), 1,
      sym_where_clause,
    STATE(3501), 1,
      sym_label,
    STATE(2213), 2,
      sym_line_comment,
      sym_block_comment,
  [69520] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(4965), 1,
      anon_sym_SEMI,
    STATE(1129), 1,
      sym_block,
    STATE(2406), 1,
      sym_where_clause,
    STATE(3504), 1,
      sym_label,
    STATE(2214), 2,
      sym_line_comment,
      sym_block_comment,
  [69555] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(4967), 1,
      anon_sym_RBRACE,
    STATE(2215), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69585] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4971), 1,
      anon_sym_RPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    STATE(2261), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3149), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2216), 2,
      sym_line_comment,
      sym_block_comment,
  [69617] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_RBRACK,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3186), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2217), 2,
      sym_line_comment,
      sym_block_comment,
  [69649] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4979), 1,
      sym_identifier,
    STATE(2218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4546), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69671] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4981), 1,
      sym_identifier,
    STATE(2219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4546), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69693] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_RBRACE,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3185), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2220), 2,
      sym_line_comment,
      sym_block_comment,
  [69725] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(4985), 1,
      anon_sym_RBRACE,
    STATE(2221), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69755] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4987), 1,
      sym_identifier,
    STATE(2222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4546), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69777] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    ACTIONS(4991), 1,
      anon_sym_EQ,
    ACTIONS(4989), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2223), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2899), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [69805] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4993), 1,
      anon_sym_trait,
    STATE(2224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69827] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(4995), 1,
      anon_sym_RPAREN,
    STATE(2251), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3009), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2225), 2,
      sym_line_comment,
      sym_block_comment,
  [69859] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(4995), 1,
      anon_sym_RBRACK,
    STATE(2241), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2988), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2226), 2,
      sym_line_comment,
      sym_block_comment,
  [69891] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    ACTIONS(4997), 1,
      anon_sym_SEMI,
    STATE(1091), 1,
      sym_field_declaration_list,
    STATE(2873), 1,
      sym_ordered_field_declaration_list,
    STATE(3137), 1,
      sym_where_clause,
    STATE(2227), 2,
      sym_line_comment,
      sym_block_comment,
  [69923] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(4999), 1,
      anon_sym_RBRACE,
    STATE(2240), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2981), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2228), 2,
      sym_line_comment,
      sym_block_comment,
  [69955] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5001), 1,
      anon_sym_RBRACE,
    STATE(2246), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3031), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2229), 2,
      sym_line_comment,
      sym_block_comment,
  [69987] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_RBRACE,
    STATE(2247), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3038), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2230), 2,
      sym_line_comment,
      sym_block_comment,
  [70019] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5005), 1,
      anon_sym_RPAREN,
    STATE(2233), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3227), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2231), 2,
      sym_line_comment,
      sym_block_comment,
  [70051] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5007), 1,
      anon_sym_trait,
    STATE(2232), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70073] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_RPAREN,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3187), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2233), 2,
      sym_line_comment,
      sym_block_comment,
  [70105] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5009), 1,
      anon_sym_RPAREN,
    STATE(2252), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3160), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2234), 2,
      sym_line_comment,
      sym_block_comment,
  [70137] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5009), 1,
      anon_sym_RBRACK,
    STATE(2260), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3152), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2235), 2,
      sym_line_comment,
      sym_block_comment,
  [70169] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    ACTIONS(5015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5011), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2236), 2,
      sym_line_comment,
      sym_block_comment,
  [70197] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2237), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [70223] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(5017), 1,
      anon_sym_RBRACE,
    STATE(2238), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70253] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    ACTIONS(5019), 1,
      anon_sym_SEMI,
    STATE(1205), 1,
      sym_field_declaration_list,
    STATE(2773), 1,
      sym_ordered_field_declaration_list,
    STATE(3157), 1,
      sym_where_clause,
    STATE(2239), 2,
      sym_line_comment,
      sym_block_comment,
  [70285] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5021), 1,
      anon_sym_RBRACE,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3191), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2240), 2,
      sym_line_comment,
      sym_block_comment,
  [70317] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_RBRACK,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3193), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2241), 2,
      sym_line_comment,
      sym_block_comment,
  [70349] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5005), 1,
      anon_sym_RBRACK,
    STATE(2217), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3108), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2242), 2,
      sym_line_comment,
      sym_block_comment,
  [70381] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5025), 1,
      anon_sym_RBRACE,
    STATE(2220), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3115), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2243), 2,
      sym_line_comment,
      sym_block_comment,
  [70413] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5027), 1,
      anon_sym_SEMI,
    STATE(722), 1,
      sym_field_declaration_list,
    STATE(2697), 1,
      sym_ordered_field_declaration_list,
    STATE(2995), 1,
      sym_where_clause,
    STATE(2244), 2,
      sym_line_comment,
      sym_block_comment,
  [70445] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4971), 1,
      anon_sym_RBRACK,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    STATE(2266), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3147), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2245), 2,
      sym_line_comment,
      sym_block_comment,
  [70477] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5029), 1,
      anon_sym_RBRACE,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3238), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2246), 2,
      sym_line_comment,
      sym_block_comment,
  [70509] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5031), 1,
      anon_sym_RBRACE,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3233), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2247), 2,
      sym_line_comment,
      sym_block_comment,
  [70541] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5033), 1,
      sym_identifier,
    STATE(2248), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4546), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70563] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4638), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4644), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4642), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4373), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [70589] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    STATE(2752), 1,
      sym_use_list,
    STATE(3286), 1,
      sym_type_arguments,
    ACTIONS(5035), 2,
      sym_identifier,
      sym_super,
    STATE(2250), 2,
      sym_line_comment,
      sym_block_comment,
  [70619] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_RPAREN,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3195), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2251), 2,
      sym_line_comment,
      sym_block_comment,
  [70651] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5039), 1,
      anon_sym_RPAREN,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3102), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2252), 2,
      sym_line_comment,
      sym_block_comment,
  [70683] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    ACTIONS(5043), 1,
      anon_sym_EQ,
    ACTIONS(5041), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2253), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2810), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [70711] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(5045), 1,
      anon_sym_RBRACE,
    STATE(2254), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70741] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    STATE(2255), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70771] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4540), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_LBRACK,
    ACTIONS(5053), 1,
      anon_sym_RBRACK,
    ACTIONS(5055), 1,
      anon_sym_LBRACE,
    ACTIONS(5057), 1,
      anon_sym_EQ,
    STATE(3306), 1,
      sym_delim_token_tree,
    STATE(2256), 2,
      sym_line_comment,
      sym_block_comment,
  [70803] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    STATE(2752), 1,
      sym_use_list,
    STATE(3265), 1,
      sym_type_arguments,
    ACTIONS(5035), 2,
      sym_identifier,
      sym_super,
    STATE(2257), 2,
      sym_line_comment,
      sym_block_comment,
  [70833] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5059), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PLUS,
  [70859] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(5061), 1,
      anon_sym_RBRACE,
    STATE(2259), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70889] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5039), 1,
      anon_sym_RBRACK,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3100), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2260), 2,
      sym_line_comment,
      sym_block_comment,
  [70921] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      anon_sym_RPAREN,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3099), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2261), 2,
      sym_line_comment,
      sym_block_comment,
  [70953] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_LBRACK,
    ACTIONS(5055), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_RBRACK,
    ACTIONS(5067), 1,
      anon_sym_EQ,
    STATE(3300), 1,
      sym_delim_token_tree,
    STATE(2262), 2,
      sym_line_comment,
      sym_block_comment,
  [70985] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4476), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_LBRACK,
    ACTIONS(5055), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_RBRACK,
    ACTIONS(5067), 1,
      anon_sym_EQ,
    STATE(3300), 1,
      sym_delim_token_tree,
    STATE(2263), 2,
      sym_line_comment,
      sym_block_comment,
  [71017] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_LBRACK,
    ACTIONS(5055), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_RBRACK,
    ACTIONS(5067), 1,
      anon_sym_EQ,
    STATE(3300), 1,
      sym_delim_token_tree,
    STATE(2264), 2,
      sym_line_comment,
      sym_block_comment,
  [71049] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5069), 1,
      anon_sym_SEMI,
    STATE(694), 1,
      sym_field_declaration_list,
    STATE(2939), 1,
      sym_ordered_field_declaration_list,
    STATE(3022), 1,
      sym_where_clause,
    STATE(2265), 2,
      sym_line_comment,
      sym_block_comment,
  [71081] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    ACTIONS(4973), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      anon_sym_RBRACK,
    STATE(2097), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3098), 1,
      sym_macro_rule,
    STATE(3507), 1,
      sym_token_tree_pattern,
    STATE(2266), 2,
      sym_line_comment,
      sym_block_comment,
  [71113] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5011), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2267), 2,
      sym_line_comment,
      sym_block_comment,
  [71141] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2268), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [71167] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(5073), 1,
      anon_sym_RBRACE,
    STATE(2269), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71197] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    ACTIONS(5075), 1,
      anon_sym_RBRACE,
    STATE(2270), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71227] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_COLON,
    ACTIONS(5081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5077), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2271), 2,
      sym_line_comment,
      sym_block_comment,
  [71255] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4510), 1,
      anon_sym_DOT_DOT,
    STATE(2272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4508), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [71276] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5083), 1,
      anon_sym_SEMI,
    STATE(1285), 1,
      sym_declaration_list,
    STATE(2943), 1,
      sym_where_clause,
    STATE(2273), 2,
      sym_line_comment,
      sym_block_comment,
  [71305] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5085), 1,
      anon_sym_SEMI,
    STATE(1134), 1,
      sym_declaration_list,
    STATE(2905), 1,
      sym_where_clause,
    STATE(2274), 2,
      sym_line_comment,
      sym_block_comment,
  [71334] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5077), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2275), 2,
      sym_line_comment,
      sym_block_comment,
  [71359] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5087), 1,
      anon_sym_SEMI,
    STATE(1139), 1,
      sym_declaration_list,
    STATE(2908), 1,
      sym_where_clause,
    STATE(2276), 2,
      sym_line_comment,
      sym_block_comment,
  [71388] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2277), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3254), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71407] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5089), 1,
      anon_sym_SEMI,
    STATE(1141), 1,
      sym_declaration_list,
    STATE(2909), 1,
      sym_where_clause,
    STATE(2278), 2,
      sym_line_comment,
      sym_block_comment,
  [71436] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5077), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2279), 2,
      sym_line_comment,
      sym_block_comment,
  [71461] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5091), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2280), 2,
      sym_line_comment,
      sym_block_comment,
  [71486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4594), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2281), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3410), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
  [71507] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2282), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4699), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [71526] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4867), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      anon_sym_ref,
    ACTIONS(4875), 1,
      sym_mutable_specifier,
    STATE(2283), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3151), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71553] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5093), 1,
      anon_sym_COMMA,
    ACTIONS(5095), 1,
      anon_sym_GT,
    STATE(2879), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2960), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2962), 1,
      sym_trait_bounds,
    STATE(2284), 2,
      sym_line_comment,
      sym_block_comment,
  [71582] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(1220), 1,
      sym_declaration_list,
    STATE(2635), 1,
      sym_trait_bounds,
    STATE(3055), 1,
      sym_where_clause,
    STATE(2285), 2,
      sym_line_comment,
      sym_block_comment,
  [71611] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(1334), 1,
      sym_declaration_list,
    STATE(2652), 1,
      sym_trait_bounds,
    STATE(3158), 1,
      sym_where_clause,
    STATE(2286), 2,
      sym_line_comment,
      sym_block_comment,
  [71640] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5097), 1,
      anon_sym_SEMI,
    STATE(1370), 1,
      sym_declaration_list,
    STATE(2862), 1,
      sym_where_clause,
    STATE(2287), 2,
      sym_line_comment,
      sym_block_comment,
  [71669] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4524), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4522), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [71692] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5099), 1,
      anon_sym_SEMI,
    STATE(1104), 1,
      sym_declaration_list,
    STATE(2848), 1,
      sym_where_clause,
    STATE(2289), 2,
      sym_line_comment,
      sym_block_comment,
  [71721] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5101), 1,
      anon_sym_SEMI,
    STATE(1116), 1,
      sym_declaration_list,
    STATE(2845), 1,
      sym_where_clause,
    STATE(2290), 2,
      sym_line_comment,
      sym_block_comment,
  [71750] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5103), 1,
      anon_sym_SEMI,
    STATE(746), 1,
      sym_declaration_list,
    STATE(2941), 1,
      sym_where_clause,
    STATE(2291), 2,
      sym_line_comment,
      sym_block_comment,
  [71779] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5105), 1,
      anon_sym_if,
    STATE(3456), 1,
      sym_label,
    STATE(1118), 2,
      sym_if_expression,
      sym_block,
    STATE(2292), 2,
      sym_line_comment,
      sym_block_comment,
  [71806] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4482), 1,
      anon_sym_EQ,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5107), 1,
      anon_sym_COMMA,
    ACTIONS(5109), 1,
      anon_sym_GT,
    STATE(2754), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2293), 2,
      sym_line_comment,
      sym_block_comment,
  [71835] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(656), 1,
      sym_declaration_list,
    STATE(2624), 1,
      sym_trait_bounds,
    STATE(2978), 1,
      sym_where_clause,
    STATE(2294), 2,
      sym_line_comment,
      sym_block_comment,
  [71864] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4794), 1,
      anon_sym_for,
    STATE(2295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [71887] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4506), 1,
      anon_sym_DOT_DOT,
    STATE(2296), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4504), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [71908] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5111), 1,
      anon_sym_SEMI,
    STATE(716), 1,
      sym_declaration_list,
    STATE(2860), 1,
      sym_where_clause,
    STATE(2297), 2,
      sym_line_comment,
      sym_block_comment,
  [71937] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5113), 1,
      anon_sym_SEMI,
    STATE(632), 1,
      sym_declaration_list,
    STATE(2972), 1,
      sym_where_clause,
    STATE(2298), 2,
      sym_line_comment,
      sym_block_comment,
  [71966] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5115), 1,
      anon_sym_SEMI,
    STATE(677), 1,
      sym_declaration_list,
    STATE(2708), 1,
      sym_where_clause,
    STATE(2299), 2,
      sym_line_comment,
      sym_block_comment,
  [71995] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5117), 1,
      anon_sym_SEMI,
    STATE(1274), 1,
      sym_declaration_list,
    STATE(2942), 1,
      sym_where_clause,
    STATE(2300), 2,
      sym_line_comment,
      sym_block_comment,
  [72024] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1180), 1,
      sym_field_declaration_list,
    STATE(2664), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_where_clause,
    STATE(2301), 2,
      sym_line_comment,
      sym_block_comment,
  [72053] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    ACTIONS(5121), 1,
      anon_sym_GT,
    STATE(2960), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2962), 1,
      sym_trait_bounds,
    STATE(2302), 2,
      sym_line_comment,
      sym_block_comment,
  [72082] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3340), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4646), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5123), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2303), 2,
      sym_line_comment,
      sym_block_comment,
  [72105] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5126), 1,
      anon_sym_SEMI,
    STATE(688), 1,
      sym_declaration_list,
    STATE(2709), 1,
      sym_where_clause,
    STATE(2304), 2,
      sym_line_comment,
      sym_block_comment,
  [72134] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5128), 1,
      anon_sym_SEMI,
    STATE(692), 1,
      sym_declaration_list,
    STATE(2710), 1,
      sym_where_clause,
    STATE(2305), 2,
      sym_line_comment,
      sym_block_comment,
  [72163] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5130), 1,
      anon_sym_SEMI,
    STATE(742), 1,
      sym_declaration_list,
    STATE(2798), 1,
      sym_where_clause,
    STATE(2306), 2,
      sym_line_comment,
      sym_block_comment,
  [72192] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5132), 1,
      anon_sym_SEMI,
    STATE(736), 1,
      sym_declaration_list,
    STATE(2797), 1,
      sym_where_clause,
    STATE(2307), 2,
      sym_line_comment,
      sym_block_comment,
  [72221] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5134), 1,
      anon_sym_SEMI,
    STATE(1324), 1,
      sym_declaration_list,
    STATE(2949), 1,
      sym_where_clause,
    STATE(2308), 2,
      sym_line_comment,
      sym_block_comment,
  [72250] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5136), 1,
      anon_sym_SEMI,
    STATE(706), 1,
      sym_declaration_list,
    STATE(2713), 1,
      sym_where_clause,
    STATE(2309), 2,
      sym_line_comment,
      sym_block_comment,
  [72279] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5138), 1,
      anon_sym_SEMI,
    STATE(1328), 1,
      sym_declaration_list,
    STATE(2950), 1,
      sym_where_clause,
    STATE(2310), 2,
      sym_line_comment,
      sym_block_comment,
  [72308] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5140), 1,
      anon_sym_SEMI,
    STATE(1330), 1,
      sym_declaration_list,
    STATE(2953), 1,
      sym_where_clause,
    STATE(2311), 2,
      sym_line_comment,
      sym_block_comment,
  [72337] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5142), 1,
      anon_sym_SEMI,
    STATE(1332), 1,
      sym_declaration_list,
    STATE(2954), 1,
      sym_where_clause,
    STATE(2312), 2,
      sym_line_comment,
      sym_block_comment,
  [72366] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    ACTIONS(5121), 1,
      anon_sym_GT,
    STATE(2960), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3214), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(2313), 2,
      sym_line_comment,
      sym_block_comment,
  [72393] = 9,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5144), 1,
      sym_identifier,
    ACTIONS(5146), 1,
      anon_sym_ref,
    ACTIONS(5148), 1,
      sym_mutable_specifier,
    ACTIONS(5150), 1,
      anon_sym_move,
    STATE(130), 1,
      sym_closure_parameters,
    STATE(2314), 2,
      sym_line_comment,
      sym_block_comment,
  [72422] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5152), 1,
      anon_sym_SEMI,
    STATE(719), 1,
      sym_declaration_list,
    STATE(2793), 1,
      sym_where_clause,
    STATE(2315), 2,
      sym_line_comment,
      sym_block_comment,
  [72451] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3410), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4594), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5154), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2316), 2,
      sym_line_comment,
      sym_block_comment,
  [72474] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5157), 1,
      anon_sym_SEMI,
    STATE(1131), 1,
      sym_declaration_list,
    STATE(2904), 1,
      sym_where_clause,
    STATE(2317), 2,
      sym_line_comment,
      sym_block_comment,
  [72503] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4776), 1,
      anon_sym_for,
    STATE(2318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72526] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_enum_variant_list,
    STATE(2665), 1,
      sym_type_parameters,
    STATE(3196), 1,
      sym_where_clause,
    STATE(2319), 2,
      sym_line_comment,
      sym_block_comment,
  [72555] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5161), 1,
      anon_sym_SEMI,
    STATE(1193), 1,
      sym_declaration_list,
    STATE(2782), 1,
      sym_where_clause,
    STATE(2320), 2,
      sym_line_comment,
      sym_block_comment,
  [72584] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(1202), 1,
      sym_declaration_list,
    STATE(2669), 1,
      sym_trait_bounds,
    STATE(3164), 1,
      sym_where_clause,
    STATE(2321), 2,
      sym_line_comment,
      sym_block_comment,
  [72613] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(699), 1,
      sym_declaration_list,
    STATE(2454), 1,
      sym_trait_bounds,
    STATE(3032), 1,
      sym_where_clause,
    STATE(2322), 2,
      sym_line_comment,
      sym_block_comment,
  [72642] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    STATE(511), 1,
      sym_field_declaration_list,
    STATE(2671), 1,
      sym_type_parameters,
    STATE(3235), 1,
      sym_where_clause,
    STATE(2323), 2,
      sym_line_comment,
      sym_block_comment,
  [72671] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5163), 1,
      anon_sym_SEMI,
    STATE(760), 1,
      sym_declaration_list,
    STATE(2725), 1,
      sym_where_clause,
    STATE(2324), 2,
      sym_line_comment,
      sym_block_comment,
  [72700] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5165), 1,
      anon_sym_SEMI,
    STATE(564), 1,
      sym_declaration_list,
    STATE(2729), 1,
      sym_where_clause,
    STATE(2325), 2,
      sym_line_comment,
      sym_block_comment,
  [72729] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5167), 1,
      anon_sym_SEMI,
    STATE(549), 1,
      sym_declaration_list,
    STATE(2694), 1,
      sym_where_clause,
    STATE(2326), 2,
      sym_line_comment,
      sym_block_comment,
  [72758] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(586), 1,
      sym_enum_variant_list,
    STATE(2666), 1,
      sym_type_parameters,
    STATE(3170), 1,
      sym_where_clause,
    STATE(2327), 2,
      sym_line_comment,
      sym_block_comment,
  [72787] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5171), 1,
      anon_sym_SEMI,
    STATE(1217), 1,
      sym_declaration_list,
    STATE(2758), 1,
      sym_where_clause,
    STATE(2328), 2,
      sym_line_comment,
      sym_block_comment,
  [72816] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5173), 1,
      anon_sym_SEMI,
    STATE(1390), 1,
      sym_declaration_list,
    STATE(2965), 1,
      sym_where_clause,
    STATE(2329), 2,
      sym_line_comment,
      sym_block_comment,
  [72845] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5175), 1,
      anon_sym_SEMI,
    STATE(1392), 1,
      sym_declaration_list,
    STATE(2966), 1,
      sym_where_clause,
    STATE(2330), 2,
      sym_line_comment,
      sym_block_comment,
  [72874] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4798), 1,
      anon_sym_for,
    STATE(2331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72897] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5177), 1,
      anon_sym_SEMI,
    STATE(757), 1,
      sym_declaration_list,
    STATE(2724), 1,
      sym_where_clause,
    STATE(2332), 2,
      sym_line_comment,
      sym_block_comment,
  [72926] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5179), 1,
      anon_sym_SEMI,
    STATE(525), 1,
      sym_declaration_list,
    STATE(2937), 1,
      sym_where_clause,
    STATE(2333), 2,
      sym_line_comment,
      sym_block_comment,
  [72955] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_SEMI,
    ACTIONS(5183), 1,
      anon_sym_EQ,
    STATE(2676), 1,
      sym_type_parameters,
    STATE(3381), 1,
      sym_trait_bounds,
    STATE(2334), 2,
      sym_line_comment,
      sym_block_comment,
  [72984] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5185), 1,
      anon_sym_SEMI,
    STATE(557), 1,
      sym_declaration_list,
    STATE(2934), 1,
      sym_where_clause,
    STATE(2335), 2,
      sym_line_comment,
      sym_block_comment,
  [73013] = 8,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5187), 1,
      anon_sym_if,
    STATE(3255), 1,
      sym_label,
    STATE(248), 2,
      sym_if_expression,
      sym_block,
    STATE(2336), 2,
      sym_line_comment,
      sym_block_comment,
  [73040] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5123), 1,
      anon_sym_RBRACK,
    ACTIONS(4646), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(2337), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73063] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1297), 1,
      sym_field_declaration_list,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(3079), 1,
      sym_where_clause,
    STATE(2338), 2,
      sym_line_comment,
      sym_block_comment,
  [73092] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4815), 1,
      anon_sym_for,
    STATE(2339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73115] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(4849), 1,
      anon_sym_LT,
    ACTIONS(5189), 1,
      anon_sym_SEMI,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym_type_parameters,
    STATE(3266), 1,
      sym_trait_bounds,
    STATE(2340), 2,
      sym_line_comment,
      sym_block_comment,
  [73144] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(680), 1,
      sym_declaration_list,
    STATE(2492), 1,
      sym_trait_bounds,
    STATE(3124), 1,
      sym_where_clause,
    STATE(2341), 2,
      sym_line_comment,
      sym_block_comment,
  [73173] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5154), 1,
      anon_sym_RBRACK,
    ACTIONS(4594), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(2342), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3410), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73196] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1321), 1,
      sym_enum_variant_list,
    STATE(2658), 1,
      sym_type_parameters,
    STATE(3183), 1,
      sym_where_clause,
    STATE(2343), 2,
      sym_line_comment,
      sym_block_comment,
  [73225] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5193), 1,
      anon_sym_if,
    STATE(3505), 1,
      sym_label,
    STATE(1718), 2,
      sym_if_expression,
      sym_block,
    STATE(2344), 2,
      sym_line_comment,
      sym_block_comment,
  [73252] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5195), 1,
      anon_sym_SEMI,
    STATE(1313), 1,
      sym_declaration_list,
    STATE(2803), 1,
      sym_where_clause,
    STATE(2345), 2,
      sym_line_comment,
      sym_block_comment,
  [73281] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT,
    STATE(2346), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1512), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [73302] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5091), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2347), 2,
      sym_line_comment,
      sym_block_comment,
  [73327] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4646), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2348), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3340), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
  [73348] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5197), 1,
      anon_sym_if,
    STATE(3506), 1,
      sym_label,
    STATE(473), 2,
      sym_if_expression,
      sym_block,
    STATE(2349), 2,
      sym_line_comment,
      sym_block_comment,
  [73375] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    STATE(547), 1,
      sym_field_declaration_list,
    STATE(2499), 1,
      sym_type_parameters,
    STATE(3190), 1,
      sym_where_clause,
    STATE(2350), 2,
      sym_line_comment,
      sym_block_comment,
  [73404] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4796), 1,
      anon_sym_for,
    STATE(2351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73427] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1494), 1,
      anon_sym_DOT_DOT,
    STATE(2352), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1496), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [73448] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4804), 1,
      anon_sym_for,
    STATE(2353), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73471] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5199), 1,
      anon_sym_SEMI,
    STATE(652), 1,
      sym_declaration_list,
    STATE(2730), 1,
      sym_where_clause,
    STATE(2354), 2,
      sym_line_comment,
      sym_block_comment,
  [73500] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5201), 1,
      anon_sym_SEMI,
    STATE(584), 1,
      sym_declaration_list,
    STATE(2816), 1,
      sym_where_clause,
    STATE(2355), 2,
      sym_line_comment,
      sym_block_comment,
  [73529] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4758), 1,
      anon_sym_for,
    STATE(2356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1478), 1,
      anon_sym_DOT_DOT,
    STATE(2357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1480), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [73573] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_enum_variant_list,
    STATE(2568), 1,
      sym_type_parameters,
    STATE(3105), 1,
      sym_where_clause,
    STATE(2358), 2,
      sym_line_comment,
      sym_block_comment,
  [73602] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4756), 1,
      anon_sym_for,
    STATE(2359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [73625] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4482), 1,
      anon_sym_EQ,
    ACTIONS(4484), 1,
      anon_sym_COMMA,
    ACTIONS(4486), 1,
      anon_sym_GT,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(2951), 1,
      sym_trait_bounds,
    STATE(2956), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2360), 2,
      sym_line_comment,
      sym_block_comment,
  [73654] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5203), 1,
      anon_sym_SEMI,
    STATE(1446), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2361), 2,
      sym_line_comment,
      sym_block_comment,
  [73680] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5207), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5209), 1,
      anon_sym_as,
    STATE(2362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5205), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [73702] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5213), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5215), 1,
      anon_sym_as,
    STATE(2363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5211), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [73724] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3652), 1,
      anon_sym_PLUS,
    ACTIONS(4606), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5217), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2364), 2,
      sym_line_comment,
      sym_block_comment,
  [73746] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3696), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [73764] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3688), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [73782] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5220), 1,
      anon_sym_SEMI,
    STATE(635), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2367), 2,
      sym_line_comment,
      sym_block_comment,
  [73808] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5222), 1,
      anon_sym_RPAREN,
    ACTIONS(5224), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2368), 2,
      sym_line_comment,
      sym_block_comment,
  [73832] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5226), 1,
      anon_sym_SEMI,
    STATE(648), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2369), 2,
      sym_line_comment,
      sym_block_comment,
  [73858] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5228), 1,
      anon_sym_SEMI,
    ACTIONS(5230), 1,
      anon_sym_COLON,
    ACTIONS(5232), 1,
      anon_sym_EQ,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5236), 1,
      anon_sym_else,
    STATE(2370), 2,
      sym_line_comment,
      sym_block_comment,
  [73884] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5238), 1,
      anon_sym_RPAREN,
    ACTIONS(5240), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2371), 2,
      sym_line_comment,
      sym_block_comment,
  [73908] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5242), 1,
      anon_sym_move,
    STATE(466), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2372), 2,
      sym_line_comment,
      sym_block_comment,
  [73934] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2373), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3692), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [73952] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1203), 1,
      anon_sym_RPAREN,
    ACTIONS(5244), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2374), 2,
      sym_line_comment,
      sym_block_comment,
  [73976] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3708), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [73994] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    STATE(1554), 1,
      sym_parameters,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2376), 2,
      sym_line_comment,
      sym_block_comment,
  [74020] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5246), 1,
      anon_sym_SEMI,
    STATE(1416), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2377), 2,
      sym_line_comment,
      sym_block_comment,
  [74046] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3214), 1,
      anon_sym_PLUS,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5248), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2378), 2,
      sym_line_comment,
      sym_block_comment,
  [74068] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5253), 1,
      anon_sym_COMMA,
    ACTIONS(5251), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2379), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_where_clause_repeat1,
  [74088] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5209), 1,
      anon_sym_as,
    ACTIONS(5256), 1,
      anon_sym_COLON_COLON,
    STATE(2380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5205), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [74110] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5258), 1,
      anon_sym_RPAREN,
    ACTIONS(5261), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2381), 2,
      sym_line_comment,
      sym_block_comment,
  [74134] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5264), 1,
      anon_sym_RPAREN,
    ACTIONS(5266), 1,
      anon_sym_COLON,
    ACTIONS(5268), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2382), 2,
      sym_line_comment,
      sym_block_comment,
  [74160] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5270), 1,
      anon_sym_SEMI,
    STATE(768), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2383), 2,
      sym_line_comment,
      sym_block_comment,
  [74186] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5209), 1,
      anon_sym_as,
    ACTIONS(5272), 1,
      anon_sym_COLON_COLON,
    STATE(2384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5205), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [74208] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5274), 1,
      anon_sym_SEMI,
    STATE(610), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2385), 2,
      sym_line_comment,
      sym_block_comment,
  [74234] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    ACTIONS(5081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2386), 2,
      sym_line_comment,
      sym_block_comment,
  [74258] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5276), 1,
      anon_sym_SEMI,
    STATE(1441), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2387), 2,
      sym_line_comment,
      sym_block_comment,
  [74284] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5278), 1,
      anon_sym_SEMI,
    STATE(1429), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2388), 2,
      sym_line_comment,
      sym_block_comment,
  [74310] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3158), 5,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_as,
  [74328] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_SEMI,
    STATE(1410), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2390), 2,
      sym_line_comment,
      sym_block_comment,
  [74354] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2391), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5282), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74372] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5284), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74390] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1089), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2393), 2,
      sym_line_comment,
      sym_block_comment,
  [74416] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(5288), 1,
      anon_sym_STAR,
    STATE(2749), 1,
      sym_use_list,
    ACTIONS(5286), 2,
      sym_identifier,
      sym_super,
    STATE(2394), 2,
      sym_line_comment,
      sym_block_comment,
  [74440] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5290), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74458] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2396), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3214), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [74478] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5217), 1,
      anon_sym_RBRACK,
    ACTIONS(3652), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4606), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(2397), 2,
      sym_line_comment,
      sym_block_comment,
  [74500] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5292), 1,
      anon_sym_SEMI,
    STATE(1359), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2398), 2,
      sym_line_comment,
      sym_block_comment,
  [74526] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5294), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74544] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2400), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5296), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74562] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5298), 1,
      anon_sym_SEMI,
    STATE(1338), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2401), 2,
      sym_line_comment,
      sym_block_comment,
  [74588] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4482), 1,
      anon_sym_EQ,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(2951), 1,
      sym_trait_bounds,
    ACTIONS(5300), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2402), 2,
      sym_line_comment,
      sym_block_comment,
  [74612] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4686), 1,
      anon_sym_PIPE,
    ACTIONS(5302), 1,
      anon_sym_SEMI,
    ACTIONS(5304), 1,
      anon_sym_COLON,
    ACTIONS(5306), 1,
      anon_sym_EQ,
    ACTIONS(5308), 1,
      anon_sym_else,
    STATE(2403), 2,
      sym_line_comment,
      sym_block_comment,
  [74638] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5310), 1,
      anon_sym_SEMI,
    STATE(754), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2404), 2,
      sym_line_comment,
      sym_block_comment,
  [74664] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5312), 1,
      anon_sym_COMMA,
    STATE(2379), 1,
      aux_sym_where_clause_repeat1,
    STATE(2405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3404), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [74686] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5314), 1,
      anon_sym_SEMI,
    STATE(1264), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2406), 2,
      sym_line_comment,
      sym_block_comment,
  [74712] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5248), 1,
      anon_sym_RBRACK,
    ACTIONS(3214), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(2407), 2,
      sym_line_comment,
      sym_block_comment,
  [74734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3704), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [74752] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3700), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [74770] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_SEMI,
    STATE(670), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2410), 2,
      sym_line_comment,
      sym_block_comment,
  [74796] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5318), 1,
      anon_sym_SEMI,
    STATE(1340), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2411), 2,
      sym_line_comment,
      sym_block_comment,
  [74822] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1686), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2412), 2,
      sym_line_comment,
      sym_block_comment,
  [74848] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    STATE(2752), 1,
      sym_use_list,
    ACTIONS(5035), 2,
      sym_identifier,
      sym_super,
    STATE(2413), 2,
      sym_line_comment,
      sym_block_comment,
  [74872] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
    ACTIONS(5320), 1,
      anon_sym_COMMA,
    STATE(2878), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2414), 2,
      sym_line_comment,
      sym_block_comment,
  [74896] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2415), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5322), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74914] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4606), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3652), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [74934] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5324), 1,
      anon_sym_move,
    STATE(1436), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2417), 2,
      sym_line_comment,
      sym_block_comment,
  [74960] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5326), 1,
      anon_sym_EQ,
    STATE(2418), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3324), 4,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_GT,
  [74980] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5328), 1,
      anon_sym_SEMI,
    STATE(1111), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2419), 2,
      sym_line_comment,
      sym_block_comment,
  [75006] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1199), 1,
      anon_sym_RPAREN,
    ACTIONS(5330), 1,
      anon_sym_COMMA,
    STATE(2895), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2420), 2,
      sym_line_comment,
      sym_block_comment,
  [75030] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1298), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2421), 2,
      sym_line_comment,
      sym_block_comment,
  [75056] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5332), 1,
      anon_sym_SEMI,
    STATE(628), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2422), 2,
      sym_line_comment,
      sym_block_comment,
  [75082] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5334), 1,
      aux_sym_line_comment_token1,
    ACTIONS(5336), 1,
      aux_sym_line_comment_token3,
    ACTIONS(5338), 1,
      sym__inner_line_doc_comment,
    ACTIONS(5340), 1,
      sym__outer_line_doc_comment,
    STATE(3363), 1,
      sym__line_doc_comment,
    STATE(2423), 2,
      sym_line_comment,
      sym_block_comment,
  [75108] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5342), 1,
      anon_sym_SEMI,
    STATE(1364), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2424), 2,
      sym_line_comment,
      sym_block_comment,
  [75134] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1734), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2425), 2,
      sym_line_comment,
      sym_block_comment,
  [75160] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    ACTIONS(5344), 1,
      anon_sym_SEMI,
    STATE(1120), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2426), 2,
      sym_line_comment,
      sym_block_comment,
  [75186] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5346), 1,
      anon_sym_COMMA,
    ACTIONS(5348), 1,
      anon_sym_GT,
    STATE(2756), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2962), 1,
      sym_trait_bounds,
    STATE(2427), 2,
      sym_line_comment,
      sym_block_comment,
  [75212] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5350), 1,
      anon_sym_RPAREN,
    ACTIONS(5352), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2428), 2,
      sym_line_comment,
      sym_block_comment,
  [75236] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(1935), 1,
      sym_parameters,
    STATE(2429), 2,
      sym_line_comment,
      sym_block_comment,
  [75262] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5354), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75280] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1615), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2431), 2,
      sym_line_comment,
      sym_block_comment,
  [75306] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5356), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75324] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5358), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5360), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75360] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(5362), 1,
      anon_sym_move,
    STATE(1602), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2435), 2,
      sym_line_comment,
      sym_block_comment,
  [75386] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5364), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75404] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(1349), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2437), 2,
      sym_line_comment,
      sym_block_comment,
  [75430] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4686), 1,
      anon_sym_PIPE,
    ACTIONS(5366), 1,
      anon_sym_SEMI,
    ACTIONS(5368), 1,
      anon_sym_COLON,
    ACTIONS(5370), 1,
      anon_sym_EQ,
    ACTIONS(5372), 1,
      anon_sym_else,
    STATE(2438), 2,
      sym_line_comment,
      sym_block_comment,
  [75456] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5374), 1,
      anon_sym_SEMI,
    STATE(536), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2439), 2,
      sym_line_comment,
      sym_block_comment,
  [75482] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    STATE(1078), 1,
      sym_parameters,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2440), 2,
      sym_line_comment,
      sym_block_comment,
  [75508] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5376), 1,
      anon_sym_SEMI,
    STATE(528), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2441), 2,
      sym_line_comment,
      sym_block_comment,
  [75534] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_COLON,
    ACTIONS(5081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2442), 2,
      sym_line_comment,
      sym_block_comment,
  [75558] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    ACTIONS(5121), 1,
      anon_sym_GT,
    STATE(2960), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2962), 1,
      sym_trait_bounds,
    STATE(2443), 2,
      sym_line_comment,
      sym_block_comment,
  [75584] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2444), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5378), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75602] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5380), 1,
      anon_sym_SEMI,
    ACTIONS(5382), 1,
      anon_sym_COLON,
    ACTIONS(5384), 1,
      anon_sym_EQ,
    ACTIONS(5386), 1,
      anon_sym_else,
    STATE(2445), 2,
      sym_line_comment,
      sym_block_comment,
  [75628] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5388), 1,
      anon_sym_SEMI,
    STATE(613), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2446), 2,
      sym_line_comment,
      sym_block_comment,
  [75654] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5390), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75672] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4480), 1,
      anon_sym_COLON,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2639), 1,
      sym_trait_bounds,
    STATE(2448), 2,
      sym_line_comment,
      sym_block_comment,
  [75698] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5394), 1,
      anon_sym_COMMA,
    STATE(2405), 1,
      aux_sym_where_clause_repeat1,
    STATE(2449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5392), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [75720] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5396), 1,
      anon_sym_SEMI,
    STATE(506), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2450), 2,
      sym_line_comment,
      sym_block_comment,
  [75746] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    ACTIONS(5398), 1,
      anon_sym_SEMI,
    STATE(539), 1,
      sym_block,
    STATE(3501), 1,
      sym_label,
    STATE(2451), 2,
      sym_line_comment,
      sym_block_comment,
  [75772] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5400), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [75790] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1600), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2453), 2,
      sym_line_comment,
      sym_block_comment,
  [75813] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_declaration_list,
    STATE(2999), 1,
      sym_where_clause,
    STATE(2454), 2,
      sym_line_comment,
      sym_block_comment,
  [75836] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5402), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(5404), 1,
      sym__outer_block_doc_comment,
    ACTIONS(5406), 1,
      sym__inner_block_doc_comment,
    STATE(3359), 1,
      sym__block_doc_comment,
    STATE(2455), 2,
      sym_line_comment,
      sym_block_comment,
  [75859] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5408), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5410), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [75878] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5412), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5414), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [75897] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5416), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2458), 2,
      sym_line_comment,
      sym_block_comment,
  [75920] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3456), 1,
      sym_label,
    STATE(3512), 1,
      sym_block,
    STATE(2459), 2,
      sym_line_comment,
      sym_block_comment,
  [75943] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5418), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2460), 2,
      sym_line_comment,
      sym_block_comment,
  [75966] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(240), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2461), 2,
      sym_line_comment,
      sym_block_comment,
  [75989] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5420), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2462), 2,
      sym_line_comment,
      sym_block_comment,
  [76012] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1528), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [76029] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5422), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5424), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [76048] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4550), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2465), 2,
      sym_line_comment,
      sym_block_comment,
  [76071] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(192), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2466), 2,
      sym_line_comment,
      sym_block_comment,
  [76094] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5426), 1,
      anon_sym_SEMI,
    ACTIONS(5428), 1,
      anon_sym_EQ,
    STATE(3460), 1,
      sym_trait_bounds,
    STATE(2467), 2,
      sym_line_comment,
      sym_block_comment,
  [76117] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5430), 1,
      anon_sym_LBRACE,
    ACTIONS(5432), 1,
      anon_sym_for,
    ACTIONS(5434), 1,
      anon_sym_loop,
    ACTIONS(5436), 1,
      anon_sym_while,
    STATE(2468), 2,
      sym_line_comment,
      sym_block_comment,
  [76140] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5059), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2469), 2,
      sym_line_comment,
      sym_block_comment,
  [76161] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3456), 1,
      sym_label,
    STATE(3488), 1,
      sym_block,
    STATE(2470), 2,
      sym_line_comment,
      sym_block_comment,
  [76184] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5438), 1,
      anon_sym_LBRACE,
    ACTIONS(5440), 1,
      anon_sym_for,
    ACTIONS(5442), 1,
      anon_sym_loop,
    ACTIONS(5444), 1,
      anon_sym_while,
    STATE(2471), 2,
      sym_line_comment,
      sym_block_comment,
  [76207] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2472), 2,
      sym_line_comment,
      sym_block_comment,
  [76228] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5446), 1,
      anon_sym_DQUOTE,
    STATE(2581), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2473), 2,
      sym_line_comment,
      sym_block_comment,
  [76249] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(2962), 1,
      sym_trait_bounds,
    ACTIONS(5450), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2474), 2,
      sym_line_comment,
      sym_block_comment,
  [76270] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3371), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2475), 2,
      sym_line_comment,
      sym_block_comment,
  [76293] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(2202), 1,
      sym_parameters,
    STATE(3141), 1,
      sym_type_parameters,
    STATE(2476), 2,
      sym_line_comment,
      sym_block_comment,
  [76316] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2922), 1,
      anon_sym_POUND,
    ACTIONS(5453), 1,
      sym_identifier,
    STATE(1458), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1493), 1,
      sym_attribute_item,
    STATE(2477), 2,
      sym_line_comment,
      sym_block_comment,
  [76339] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3456), 1,
      sym_label,
    STATE(3502), 1,
      sym_block,
    STATE(2478), 2,
      sym_line_comment,
      sym_block_comment,
  [76362] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3456), 1,
      sym_label,
    STATE(3487), 1,
      sym_block,
    STATE(2479), 2,
      sym_line_comment,
      sym_block_comment,
  [76385] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3456), 1,
      sym_label,
    STATE(3484), 1,
      sym_block,
    STATE(2480), 2,
      sym_line_comment,
      sym_block_comment,
  [76408] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5455), 1,
      anon_sym_DQUOTE,
    ACTIONS(5457), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2481), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_string_literal_repeat1,
  [76427] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5460), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2482), 2,
      sym_line_comment,
      sym_block_comment,
  [76446] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3377), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2483), 2,
      sym_line_comment,
      sym_block_comment,
  [76469] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3373), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2484), 2,
      sym_line_comment,
      sym_block_comment,
  [76492] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1445), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2485), 2,
      sym_line_comment,
      sym_block_comment,
  [76515] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1424), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2486), 2,
      sym_line_comment,
      sym_block_comment,
  [76538] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(2194), 1,
      sym_parameters,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(2487), 2,
      sym_line_comment,
      sym_block_comment,
  [76561] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1472), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [76578] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5462), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5464), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [76597] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(3265), 1,
      sym_type_arguments,
    ACTIONS(5466), 2,
      sym_identifier,
      sym_super,
    STATE(2490), 2,
      sym_line_comment,
      sym_block_comment,
  [76618] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3294), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2491), 2,
      sym_line_comment,
      sym_block_comment,
  [76641] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(659), 1,
      sym_declaration_list,
    STATE(3033), 1,
      sym_where_clause,
    STATE(2492), 2,
      sym_line_comment,
      sym_block_comment,
  [76664] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5468), 1,
      anon_sym_COMMA,
    ACTIONS(3981), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2493), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_arguments_repeat1,
  [76683] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5471), 1,
      anon_sym_SEMI,
    STATE(3465), 1,
      sym_where_clause,
    STATE(2494), 2,
      sym_line_comment,
      sym_block_comment,
  [76706] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4458), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    STATE(2495), 2,
      sym_line_comment,
      sym_block_comment,
  [76729] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(2205), 1,
      sym_parameters,
    STATE(3104), 1,
      sym_type_parameters,
    STATE(2496), 2,
      sym_line_comment,
      sym_block_comment,
  [76752] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(222), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2497), 2,
      sym_line_comment,
      sym_block_comment,
  [76775] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3341), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2498), 2,
      sym_line_comment,
      sym_block_comment,
  [76798] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4719), 1,
      anon_sym_where,
    STATE(687), 1,
      sym_field_declaration_list,
    STATE(3044), 1,
      sym_where_clause,
    STATE(2499), 2,
      sym_line_comment,
      sym_block_comment,
  [76821] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5473), 1,
      anon_sym_RPAREN,
    ACTIONS(5475), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2500), 2,
      sym_line_comment,
      sym_block_comment,
  [76844] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      anon_sym_LBRACE,
    ACTIONS(5479), 1,
      anon_sym_for,
    ACTIONS(5481), 1,
      anon_sym_loop,
    ACTIONS(5483), 1,
      anon_sym_while,
    STATE(2501), 2,
      sym_line_comment,
      sym_block_comment,
  [76867] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(3286), 1,
      sym_type_arguments,
    ACTIONS(5466), 2,
      sym_identifier,
      sym_super,
    STATE(2502), 2,
      sym_line_comment,
      sym_block_comment,
  [76888] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3409), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2503), 2,
      sym_line_comment,
      sym_block_comment,
  [76911] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3408), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2504), 2,
      sym_line_comment,
      sym_block_comment,
  [76934] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5485), 1,
      anon_sym_in,
    STATE(2505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5487), 3,
      sym_self,
      sym_super,
      sym_crate,
  [76953] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(3265), 1,
      sym_type_arguments,
    ACTIONS(5035), 2,
      sym_identifier,
      sym_super,
    STATE(2506), 2,
      sym_line_comment,
      sym_block_comment,
  [76974] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    ACTIONS(5491), 1,
      anon_sym_GT,
    STATE(2847), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2507), 2,
      sym_line_comment,
      sym_block_comment,
  [76997] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    ACTIONS(5491), 1,
      anon_sym_GT,
    STATE(2847), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2508), 2,
      sym_line_comment,
      sym_block_comment,
  [77020] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(2171), 1,
      sym_parameters,
    STATE(3171), 1,
      sym_type_parameters,
    STATE(2509), 2,
      sym_line_comment,
      sym_block_comment,
  [77043] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(3286), 1,
      sym_type_arguments,
    ACTIONS(5035), 2,
      sym_identifier,
      sym_super,
    STATE(2510), 2,
      sym_line_comment,
      sym_block_comment,
  [77064] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2511), 2,
      sym_line_comment,
      sym_block_comment,
  [77085] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4369), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2512), 2,
      sym_line_comment,
      sym_block_comment,
  [77106] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5222), 1,
      anon_sym_RPAREN,
    ACTIONS(5224), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_parameters_repeat1,
    STATE(2513), 2,
      sym_line_comment,
      sym_block_comment,
  [77129] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(710), 1,
      sym_declaration_list,
    STATE(3014), 1,
      sym_where_clause,
    STATE(2514), 2,
      sym_line_comment,
      sym_block_comment,
  [77152] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5251), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [77169] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5266), 1,
      anon_sym_COLON,
    ACTIONS(5493), 1,
      anon_sym_COMMA,
    ACTIONS(5495), 1,
      anon_sym_PIPE,
    STATE(2944), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2516), 2,
      sym_line_comment,
      sym_block_comment,
  [77192] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(287), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2517), 2,
      sym_line_comment,
      sym_block_comment,
  [77215] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5497), 1,
      anon_sym_LPAREN,
    ACTIONS(5499), 1,
      anon_sym_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(282), 1,
      sym_delim_token_tree,
    STATE(2518), 2,
      sym_line_comment,
      sym_block_comment,
  [77238] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5503), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2519), 2,
      sym_line_comment,
      sym_block_comment,
  [77261] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5503), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2520), 2,
      sym_line_comment,
      sym_block_comment,
  [77284] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5503), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2521), 2,
      sym_line_comment,
      sym_block_comment,
  [77307] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5503), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2522), 2,
      sym_line_comment,
      sym_block_comment,
  [77330] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5505), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2523), 2,
      sym_line_comment,
      sym_block_comment,
  [77353] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3395), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2524), 2,
      sym_line_comment,
      sym_block_comment,
  [77376] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5505), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2525), 2,
      sym_line_comment,
      sym_block_comment,
  [77399] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5507), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2526), 2,
      sym_line_comment,
      sym_block_comment,
  [77422] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5507), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2527), 2,
      sym_line_comment,
      sym_block_comment,
  [77445] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(2176), 1,
      sym_parameters,
    STATE(3117), 1,
      sym_type_parameters,
    STATE(2528), 2,
      sym_line_comment,
      sym_block_comment,
  [77468] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5509), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2529), 2,
      sym_line_comment,
      sym_block_comment,
  [77491] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5509), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2530), 2,
      sym_line_comment,
      sym_block_comment,
  [77514] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5511), 1,
      anon_sym_COLON_COLON,
    STATE(2531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4536), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5513), 1,
      anon_sym_COLON_COLON,
    STATE(2532), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5515), 1,
      anon_sym_COLON_COLON,
    STATE(2533), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77571] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5517), 1,
      anon_sym_COLON_COLON,
    STATE(2534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77590] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(129), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2535), 2,
      sym_line_comment,
      sym_block_comment,
  [77613] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5264), 1,
      anon_sym_RPAREN,
    ACTIONS(5268), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2536), 2,
      sym_line_comment,
      sym_block_comment,
  [77636] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    ACTIONS(5121), 1,
      anon_sym_GT,
    ACTIONS(5519), 1,
      anon_sym_EQ,
    STATE(2960), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2537), 2,
      sym_line_comment,
      sym_block_comment,
  [77659] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5521), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      sym_super,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2538), 2,
      sym_line_comment,
      sym_block_comment,
  [77682] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5521), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      sym_super,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2539), 2,
      sym_line_comment,
      sym_block_comment,
  [77705] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5511), 1,
      anon_sym_COLON_COLON,
    STATE(2540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4560), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77724] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5525), 1,
      anon_sym_DQUOTE,
    STATE(2481), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2541), 2,
      sym_line_comment,
      sym_block_comment,
  [77745] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5513), 1,
      anon_sym_COLON_COLON,
    STATE(2542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77764] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5515), 1,
      anon_sym_COLON_COLON,
    STATE(2543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77783] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5527), 1,
      anon_sym_DQUOTE,
    STATE(2541), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2544), 2,
      sym_line_comment,
      sym_block_comment,
  [77804] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4580), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2545), 2,
      sym_line_comment,
      sym_block_comment,
  [77827] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5517), 1,
      anon_sym_COLON_COLON,
    STATE(2546), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77846] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1437), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2547), 2,
      sym_line_comment,
      sym_block_comment,
  [77869] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5529), 1,
      anon_sym_in,
    STATE(2548), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5531), 3,
      sym_self,
      sym_super,
      sym_crate,
  [77888] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1422), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2549), 2,
      sym_line_comment,
      sym_block_comment,
  [77911] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5533), 1,
      anon_sym_DQUOTE,
    STATE(2601), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2550), 2,
      sym_line_comment,
      sym_block_comment,
  [77932] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2551), 2,
      sym_line_comment,
      sym_block_comment,
  [77955] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2552), 2,
      sym_line_comment,
      sym_block_comment,
  [77978] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5537), 1,
      anon_sym_LPAREN,
    ACTIONS(5539), 1,
      anon_sym_LBRACK,
    ACTIONS(5541), 1,
      anon_sym_LBRACE,
    STATE(1631), 1,
      sym_delim_token_tree,
    STATE(2553), 2,
      sym_line_comment,
      sym_block_comment,
  [78001] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5543), 1,
      anon_sym_DQUOTE,
    STATE(2481), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2554), 2,
      sym_line_comment,
      sym_block_comment,
  [78022] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1606), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(2075), 1,
      sym_block,
    STATE(3497), 1,
      sym_label,
    STATE(2555), 2,
      sym_line_comment,
      sym_block_comment,
  [78045] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5537), 1,
      anon_sym_LPAREN,
    ACTIONS(5539), 1,
      anon_sym_LBRACK,
    ACTIONS(5541), 1,
      anon_sym_LBRACE,
    STATE(1654), 1,
      sym_delim_token_tree,
    STATE(2556), 2,
      sym_line_comment,
      sym_block_comment,
  [78068] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(474), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2557), 2,
      sym_line_comment,
      sym_block_comment,
  [78091] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5545), 1,
      anon_sym_DQUOTE,
    STATE(2554), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2558), 2,
      sym_line_comment,
      sym_block_comment,
  [78112] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(479), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2559), 2,
      sym_line_comment,
      sym_block_comment,
  [78135] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4197), 1,
      anon_sym_LBRACE,
    STATE(2748), 1,
      sym_use_list,
    ACTIONS(5547), 2,
      sym_identifier,
      sym_super,
    STATE(2560), 2,
      sym_line_comment,
      sym_block_comment,
  [78156] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(470), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2561), 2,
      sym_line_comment,
      sym_block_comment,
  [78179] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(2562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5549), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [78198] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5509), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2563), 2,
      sym_line_comment,
      sym_block_comment,
  [78221] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5509), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2564), 2,
      sym_line_comment,
      sym_block_comment,
  [78244] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5551), 1,
      anon_sym_LPAREN,
    ACTIONS(5553), 1,
      anon_sym_LBRACK,
    ACTIONS(5555), 1,
      anon_sym_LBRACE,
    STATE(1016), 1,
      sym_delim_token_tree,
    STATE(2565), 2,
      sym_line_comment,
      sym_block_comment,
  [78267] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5557), 1,
      anon_sym_DQUOTE,
    STATE(2481), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2566), 2,
      sym_line_comment,
      sym_block_comment,
  [78288] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(484), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2567), 2,
      sym_line_comment,
      sym_block_comment,
  [78311] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(714), 1,
      sym_enum_variant_list,
    STATE(3025), 1,
      sym_where_clause,
    STATE(2568), 2,
      sym_line_comment,
      sym_block_comment,
  [78334] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(459), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2569), 2,
      sym_line_comment,
      sym_block_comment,
  [78357] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5551), 1,
      anon_sym_LPAREN,
    ACTIONS(5553), 1,
      anon_sym_LBRACK,
    ACTIONS(5555), 1,
      anon_sym_LBRACE,
    STATE(1029), 1,
      sym_delim_token_tree,
    STATE(2570), 2,
      sym_line_comment,
      sym_block_comment,
  [78380] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(477), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2571), 2,
      sym_line_comment,
      sym_block_comment,
  [78403] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(195), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2572), 2,
      sym_line_comment,
      sym_block_comment,
  [78426] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(3286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4668), 1,
      anon_sym_BANG,
    STATE(1063), 1,
      sym_type_arguments,
    STATE(2573), 2,
      sym_line_comment,
      sym_block_comment,
  [78449] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1592), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2574), 2,
      sym_line_comment,
      sym_block_comment,
  [78472] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5559), 1,
      anon_sym_DQUOTE,
    STATE(2566), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2575), 2,
      sym_line_comment,
      sym_block_comment,
  [78493] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(481), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2576), 2,
      sym_line_comment,
      sym_block_comment,
  [78516] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(480), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2577), 2,
      sym_line_comment,
      sym_block_comment,
  [78539] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4357), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5561), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2578), 2,
      sym_line_comment,
      sym_block_comment,
  [78558] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4524), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5563), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4522), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2579), 2,
      sym_line_comment,
      sym_block_comment,
  [78579] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1326), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2580), 2,
      sym_line_comment,
      sym_block_comment,
  [78602] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5565), 1,
      anon_sym_DQUOTE,
    STATE(2481), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2581), 2,
      sym_line_comment,
      sym_block_comment,
  [78623] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_LBRACK,
    ACTIONS(5055), 1,
      anon_sym_LBRACE,
    STATE(1322), 1,
      sym_delim_token_tree,
    STATE(2582), 2,
      sym_line_comment,
      sym_block_comment,
  [78646] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1203), 1,
      anon_sym_RPAREN,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5244), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym_parameters_repeat1,
    STATE(2583), 2,
      sym_line_comment,
      sym_block_comment,
  [78669] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5567), 1,
      sym_identifier,
    STATE(1093), 1,
      sym_type_arguments,
    STATE(2584), 2,
      sym_line_comment,
      sym_block_comment,
  [78692] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5497), 1,
      anon_sym_LPAREN,
    ACTIONS(5499), 1,
      anon_sym_LBRACK,
    ACTIONS(5501), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_delim_token_tree,
    STATE(2585), 2,
      sym_line_comment,
      sym_block_comment,
  [78715] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1046), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2586), 2,
      sym_line_comment,
      sym_block_comment,
  [78738] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1713), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2587), 2,
      sym_line_comment,
      sym_block_comment,
  [78761] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5238), 1,
      anon_sym_RPAREN,
    ACTIONS(5240), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_parameters_repeat1,
    STATE(2588), 2,
      sym_line_comment,
      sym_block_comment,
  [78784] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    ACTIONS(5569), 1,
      anon_sym_COMMA,
    ACTIONS(5571), 1,
      anon_sym_GT,
    STATE(2918), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2589), 2,
      sym_line_comment,
      sym_block_comment,
  [78807] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5569), 1,
      anon_sym_COMMA,
    ACTIONS(5571), 1,
      anon_sym_GT,
    STATE(2918), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2590), 2,
      sym_line_comment,
      sym_block_comment,
  [78830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2591), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5573), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [78847] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1714), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2592), 2,
      sym_line_comment,
      sym_block_comment,
  [78870] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5575), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2593), 2,
      sym_line_comment,
      sym_block_comment,
  [78893] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1550), 1,
      sym_parameters,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2594), 2,
      sym_line_comment,
      sym_block_comment,
  [78916] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(679), 1,
      sym_declaration_list,
    STATE(3125), 1,
      sym_where_clause,
    STATE(2595), 2,
      sym_line_comment,
      sym_block_comment,
  [78939] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5575), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2596), 2,
      sym_line_comment,
      sym_block_comment,
  [78962] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5577), 1,
      anon_sym_RPAREN,
    ACTIONS(5579), 1,
      anon_sym_COMMA,
    STATE(2929), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2597), 2,
      sym_line_comment,
      sym_block_comment,
  [78985] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1292), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2598), 2,
      sym_line_comment,
      sym_block_comment,
  [79008] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5581), 1,
      anon_sym_SEMI,
    STATE(3325), 1,
      sym_where_clause,
    STATE(2599), 2,
      sym_line_comment,
      sym_block_comment,
  [79031] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2640), 1,
      sym_trait_bounds,
    STATE(2600), 2,
      sym_line_comment,
      sym_block_comment,
  [79054] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5583), 1,
      anon_sym_DQUOTE,
    STATE(2481), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2601), 2,
      sym_line_comment,
      sym_block_comment,
  [79075] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5587), 1,
      sym_super,
    STATE(1524), 1,
      sym_type_arguments,
    STATE(2602), 2,
      sym_line_comment,
      sym_block_comment,
  [79098] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5589), 1,
      sym_identifier,
    STATE(1570), 1,
      sym_type_arguments,
    STATE(2603), 2,
      sym_line_comment,
      sym_block_comment,
  [79121] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5049), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_LBRACK,
    ACTIONS(5055), 1,
      anon_sym_LBRACE,
    STATE(1286), 1,
      sym_delim_token_tree,
    STATE(2604), 2,
      sym_line_comment,
      sym_block_comment,
  [79144] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5591), 1,
      anon_sym_LPAREN,
    ACTIONS(5593), 1,
      anon_sym_LBRACK,
    ACTIONS(5595), 1,
      anon_sym_LBRACE,
    STATE(1959), 1,
      sym_delim_token_tree,
    STATE(2605), 2,
      sym_line_comment,
      sym_block_comment,
  [79167] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5587), 1,
      sym_super,
    STATE(1517), 1,
      sym_type_arguments,
    STATE(2606), 2,
      sym_line_comment,
      sym_block_comment,
  [79190] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2607), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_SQUOTE,
      anon_sym_AMP_AMP,
  [79207] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5597), 1,
      anon_sym_DQUOTE,
    STATE(2481), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2608), 2,
      sym_line_comment,
      sym_block_comment,
  [79228] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1643), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2609), 2,
      sym_line_comment,
      sym_block_comment,
  [79251] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1513), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2610), 2,
      sym_line_comment,
      sym_block_comment,
  [79274] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5591), 1,
      anon_sym_LPAREN,
    ACTIONS(5593), 1,
      anon_sym_LBRACK,
    ACTIONS(5595), 1,
      anon_sym_LBRACE,
    STATE(1942), 1,
      sym_delim_token_tree,
    STATE(2611), 2,
      sym_line_comment,
      sym_block_comment,
  [79297] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1627), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2612), 2,
      sym_line_comment,
      sym_block_comment,
  [79320] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5589), 1,
      sym_identifier,
    STATE(1551), 1,
      sym_type_arguments,
    STATE(2613), 2,
      sym_line_comment,
      sym_block_comment,
  [79343] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(3943), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4598), 1,
      anon_sym_BANG,
    STATE(1545), 1,
      sym_type_arguments,
    STATE(2614), 2,
      sym_line_comment,
      sym_block_comment,
  [79366] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5567), 1,
      sym_identifier,
    STATE(1232), 1,
      sym_type_arguments,
    STATE(2615), 2,
      sym_line_comment,
      sym_block_comment,
  [79389] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5599), 1,
      anon_sym_LBRACE,
    ACTIONS(5601), 1,
      anon_sym_for,
    ACTIONS(5603), 1,
      anon_sym_loop,
    ACTIONS(5605), 1,
      anon_sym_while,
    STATE(2616), 2,
      sym_line_comment,
      sym_block_comment,
  [79412] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(465), 1,
      sym_block,
    STATE(3506), 1,
      sym_label,
    STATE(2617), 2,
      sym_line_comment,
      sym_block_comment,
  [79435] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5607), 1,
      anon_sym_COLON,
    STATE(2618), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [79454] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    ACTIONS(4837), 1,
      anon_sym_LBRACE,
    STATE(2765), 1,
      sym_block,
    STATE(3504), 1,
      sym_label,
    STATE(2619), 2,
      sym_line_comment,
      sym_block_comment,
  [79477] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5609), 1,
      anon_sym_DQUOTE,
    STATE(2608), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2620), 2,
      sym_line_comment,
      sym_block_comment,
  [79498] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1598), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2621), 2,
      sym_line_comment,
      sym_block_comment,
  [79521] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5611), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2622), 2,
      sym_line_comment,
      sym_block_comment,
  [79544] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(395), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1601), 1,
      sym_block,
    STATE(3505), 1,
      sym_label,
    STATE(2623), 2,
      sym_line_comment,
      sym_block_comment,
  [79567] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(607), 1,
      sym_declaration_list,
    STATE(3078), 1,
      sym_where_clause,
    STATE(2624), 2,
      sym_line_comment,
      sym_block_comment,
  [79590] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5613), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2625), 2,
      sym_line_comment,
      sym_block_comment,
  [79613] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5615), 1,
      anon_sym_RPAREN,
    ACTIONS(5617), 1,
      anon_sym_COMMA,
    STATE(2718), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2626), 2,
      sym_line_comment,
      sym_block_comment,
  [79636] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5619), 1,
      anon_sym_SEMI,
    STATE(3301), 1,
      sym_where_clause,
    STATE(2627), 2,
      sym_line_comment,
      sym_block_comment,
  [79659] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5621), 1,
      anon_sym_RPAREN,
    ACTIONS(5623), 1,
      anon_sym_COMMA,
    STATE(2786), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2628), 2,
      sym_line_comment,
      sym_block_comment,
  [79682] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3277), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2629), 2,
      sym_line_comment,
      sym_block_comment,
  [79705] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5625), 1,
      anon_sym_SEMI,
    ACTIONS(5627), 1,
      anon_sym_EQ,
    ACTIONS(5629), 1,
      anon_sym_else,
    STATE(2630), 2,
      sym_line_comment,
      sym_block_comment,
  [79728] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3456), 1,
      sym_label,
    STATE(3478), 1,
      sym_block,
    STATE(2631), 2,
      sym_line_comment,
      sym_block_comment,
  [79751] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5631), 1,
      anon_sym_RBRACK,
    ACTIONS(5633), 1,
      anon_sym_COMMA,
    STATE(2826), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2632), 2,
      sym_line_comment,
      sym_block_comment,
  [79774] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(2962), 1,
      sym_trait_bounds,
    ACTIONS(5635), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2633), 2,
      sym_line_comment,
      sym_block_comment,
  [79795] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5637), 1,
      anon_sym_SEMI,
    ACTIONS(5639), 1,
      anon_sym_EQ,
    ACTIONS(5641), 1,
      anon_sym_else,
    STATE(2634), 2,
      sym_line_comment,
      sym_block_comment,
  [79818] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1352), 1,
      sym_declaration_list,
    STATE(3003), 1,
      sym_where_clause,
    STATE(2635), 2,
      sym_line_comment,
      sym_block_comment,
  [79841] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5643), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2636), 2,
      sym_line_comment,
      sym_block_comment,
  [79864] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5645), 1,
      anon_sym_SEMI,
    STATE(3493), 1,
      sym_where_clause,
    STATE(2637), 2,
      sym_line_comment,
      sym_block_comment,
  [79887] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5647), 1,
      anon_sym_LPAREN,
    ACTIONS(5649), 1,
      anon_sym_LBRACK,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2591), 1,
      sym_token_tree,
    STATE(2638), 2,
      sym_line_comment,
      sym_block_comment,
  [79910] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2639), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5653), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [79927] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2640), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5655), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [79944] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1079), 1,
      sym_parameters,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2641), 2,
      sym_line_comment,
      sym_block_comment,
  [79967] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    STATE(2642), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5657), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [79986] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5661), 1,
      anon_sym_COMMA,
    ACTIONS(5659), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2643), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_slice_pattern_repeat1,
  [80005] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5643), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2644), 2,
      sym_line_comment,
      sym_block_comment,
  [80028] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    STATE(2645), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5659), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [80047] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(3318), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2646), 2,
      sym_line_comment,
      sym_block_comment,
  [80070] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5664), 1,
      anon_sym_RPAREN,
    ACTIONS(5666), 1,
      anon_sym_COMMA,
    STATE(2731), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2647), 2,
      sym_line_comment,
      sym_block_comment,
  [80093] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5668), 1,
      anon_sym_RPAREN,
    ACTIONS(5670), 1,
      anon_sym_COMMA,
    STATE(2776), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2648), 2,
      sym_line_comment,
      sym_block_comment,
  [80116] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5672), 1,
      anon_sym_RBRACK,
    ACTIONS(5674), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2649), 2,
      sym_line_comment,
      sym_block_comment,
  [80139] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1218), 1,
      sym_declaration_list,
    STATE(3057), 1,
      sym_where_clause,
    STATE(2650), 2,
      sym_line_comment,
      sym_block_comment,
  [80162] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5676), 1,
      anon_sym_SEMI,
    STATE(3423), 1,
      sym_where_clause,
    STATE(2651), 2,
      sym_line_comment,
      sym_block_comment,
  [80185] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1161), 1,
      sym_declaration_list,
    STATE(3073), 1,
      sym_where_clause,
    STATE(2652), 2,
      sym_line_comment,
      sym_block_comment,
  [80208] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_RPAREN,
    ACTIONS(5680), 1,
      anon_sym_COMMA,
    STATE(2824), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2653), 2,
      sym_line_comment,
      sym_block_comment,
  [80231] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5682), 1,
      anon_sym_SEMI,
    STATE(3390), 1,
      sym_where_clause,
    STATE(2654), 2,
      sym_line_comment,
      sym_block_comment,
  [80254] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5320), 1,
      anon_sym_COMMA,
    STATE(2878), 1,
      aux_sym_parameters_repeat1,
    STATE(2655), 2,
      sym_line_comment,
      sym_block_comment,
  [80277] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5684), 1,
      anon_sym_SEMI,
    ACTIONS(5686), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_else,
    STATE(2656), 2,
      sym_line_comment,
      sym_block_comment,
  [80300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1368), 1,
      anon_sym_COLON,
    STATE(2657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3158), 3,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_GT,
  [80319] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1227), 1,
      sym_enum_variant_list,
    STATE(3091), 1,
      sym_where_clause,
    STATE(2658), 2,
      sym_line_comment,
      sym_block_comment,
  [80342] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1199), 1,
      anon_sym_RPAREN,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5330), 1,
      anon_sym_COMMA,
    STATE(2895), 1,
      aux_sym_parameters_repeat1,
    STATE(2659), 2,
      sym_line_comment,
      sym_block_comment,
  [80365] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(295), 1,
      sym_block,
    STATE(3255), 1,
      sym_label,
    STATE(2660), 2,
      sym_line_comment,
      sym_block_comment,
  [80388] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(2183), 1,
      sym_parameters,
    STATE(3050), 1,
      sym_type_parameters,
    STATE(2661), 2,
      sym_line_comment,
      sym_block_comment,
  [80411] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5346), 1,
      anon_sym_COMMA,
    ACTIONS(5348), 1,
      anon_sym_GT,
    ACTIONS(5519), 1,
      anon_sym_EQ,
    STATE(2756), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2662), 2,
      sym_line_comment,
      sym_block_comment,
  [80434] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1092), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2663), 2,
      sym_line_comment,
      sym_block_comment,
  [80457] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1240), 1,
      sym_field_declaration_list,
    STATE(3133), 1,
      sym_where_clause,
    STATE(2664), 2,
      sym_line_comment,
      sym_block_comment,
  [80480] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1210), 1,
      sym_enum_variant_list,
    STATE(3143), 1,
      sym_where_clause,
    STATE(2665), 2,
      sym_line_comment,
      sym_block_comment,
  [80503] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      sym_enum_variant_list,
    STATE(2986), 1,
      sym_where_clause,
    STATE(2666), 2,
      sym_line_comment,
      sym_block_comment,
  [80526] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1353), 1,
      sym_declaration_list,
    STATE(3159), 1,
      sym_where_clause,
    STATE(2667), 2,
      sym_line_comment,
      sym_block_comment,
  [80549] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5690), 1,
      anon_sym_SEMI,
    STATE(3305), 1,
      sym_where_clause,
    STATE(2668), 2,
      sym_line_comment,
      sym_block_comment,
  [80572] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1295), 1,
      sym_declaration_list,
    STATE(3166), 1,
      sym_where_clause,
    STATE(2669), 2,
      sym_line_comment,
      sym_block_comment,
  [80595] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5692), 1,
      anon_sym_SEMI,
    ACTIONS(5694), 1,
      anon_sym_EQ,
    ACTIONS(5696), 1,
      anon_sym_else,
    STATE(2670), 2,
      sym_line_comment,
      sym_block_comment,
  [80618] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    ACTIONS(4719), 1,
      anon_sym_where,
    STATE(702), 1,
      sym_field_declaration_list,
    STATE(3035), 1,
      sym_where_clause,
    STATE(2671), 2,
      sym_line_comment,
      sym_block_comment,
  [80641] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(643), 1,
      sym_declaration_list,
    STATE(2983), 1,
      sym_where_clause,
    STATE(2672), 2,
      sym_line_comment,
      sym_block_comment,
  [80664] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1203), 1,
      sym_declaration_list,
    STATE(3162), 1,
      sym_where_clause,
    STATE(2673), 2,
      sym_line_comment,
      sym_block_comment,
  [80687] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_RPAREN,
    ACTIONS(5700), 1,
      anon_sym_COMMA,
    STATE(2830), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2674), 2,
      sym_line_comment,
      sym_block_comment,
  [80710] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5575), 1,
      sym_identifier,
    STATE(3265), 1,
      sym_type_arguments,
    STATE(2675), 2,
      sym_line_comment,
      sym_block_comment,
  [80733] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    ACTIONS(5702), 1,
      anon_sym_SEMI,
    ACTIONS(5704), 1,
      anon_sym_EQ,
    STATE(3298), 1,
      sym_trait_bounds,
    STATE(2676), 2,
      sym_line_comment,
      sym_block_comment,
  [80756] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5350), 1,
      anon_sym_RPAREN,
    ACTIONS(5352), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_parameters_repeat1,
    STATE(2677), 2,
      sym_line_comment,
      sym_block_comment,
  [80779] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1196), 1,
      sym_field_declaration_list,
    STATE(3167), 1,
      sym_where_clause,
    STATE(2678), 2,
      sym_line_comment,
      sym_block_comment,
  [80802] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5706), 1,
      anon_sym_RPAREN,
    ACTIONS(5708), 1,
      anon_sym_COMMA,
    STATE(2952), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2679), 2,
      sym_line_comment,
      sym_block_comment,
  [80825] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    ACTIONS(5710), 1,
      anon_sym_COMMA,
    ACTIONS(5712), 1,
      anon_sym_GT,
    STATE(2819), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2680), 2,
      sym_line_comment,
      sym_block_comment,
  [80848] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5710), 1,
      anon_sym_COMMA,
    ACTIONS(5712), 1,
      anon_sym_GT,
    STATE(2819), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2681), 2,
      sym_line_comment,
      sym_block_comment,
  [80871] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(3286), 1,
      sym_type_arguments,
    ACTIONS(5523), 2,
      sym_identifier,
      sym_super,
    STATE(2682), 2,
      sym_line_comment,
      sym_block_comment,
  [80892] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(3265), 1,
      sym_type_arguments,
    ACTIONS(5523), 2,
      sym_identifier,
      sym_super,
    STATE(2683), 2,
      sym_line_comment,
      sym_block_comment,
  [80913] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4355), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5714), 1,
      anon_sym_for,
    STATE(1929), 1,
      sym_type_arguments,
    STATE(2684), 2,
      sym_line_comment,
      sym_block_comment,
  [80936] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5716), 1,
      anon_sym_SEMI,
    STATE(3503), 1,
      sym_where_clause,
    STATE(2685), 2,
      sym_line_comment,
      sym_block_comment,
  [80959] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(333), 1,
      anon_sym_LBRACE,
    ACTIONS(3282), 1,
      anon_sym_SQUOTE,
    STATE(1175), 1,
      sym_block,
    STATE(3456), 1,
      sym_label,
    STATE(2686), 2,
      sym_line_comment,
      sym_block_comment,
  [80982] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5575), 1,
      sym_identifier,
    STATE(3286), 1,
      sym_type_arguments,
    STATE(2687), 2,
      sym_line_comment,
      sym_block_comment,
  [81005] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(1941), 1,
      sym_parameters,
    STATE(2688), 2,
      sym_line_comment,
      sym_block_comment,
  [81028] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5718), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2689), 2,
      sym_line_comment,
      sym_block_comment,
  [81046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5561), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2690), 2,
      sym_line_comment,
      sym_block_comment,
  [81064] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5720), 1,
      anon_sym_RBRACE,
    ACTIONS(5722), 1,
      anon_sym_COMMA,
    STATE(2955), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2691), 2,
      sym_line_comment,
      sym_block_comment,
  [81084] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(5724), 1,
      anon_sym_SEMI,
    STATE(1185), 1,
      sym_declaration_list,
    STATE(2692), 2,
      sym_line_comment,
      sym_block_comment,
  [81104] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5726), 1,
      sym_identifier,
    ACTIONS(5728), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2693), 2,
      sym_line_comment,
      sym_block_comment,
  [81122] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5730), 1,
      anon_sym_SEMI,
    STATE(562), 1,
      sym_declaration_list,
    STATE(2694), 2,
      sym_line_comment,
      sym_block_comment,
  [81142] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2695), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5732), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [81158] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5734), 1,
      sym_identifier,
    ACTIONS(5736), 1,
      anon_sym_ref,
    ACTIONS(5738), 1,
      sym_mutable_specifier,
    STATE(2696), 2,
      sym_line_comment,
      sym_block_comment,
  [81178] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5740), 1,
      anon_sym_SEMI,
    STATE(3499), 1,
      sym_where_clause,
    STATE(2697), 2,
      sym_line_comment,
      sym_block_comment,
  [81198] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2698), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5742), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [81214] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5744), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2699), 2,
      sym_line_comment,
      sym_block_comment,
  [81234] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2700), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5746), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [81250] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5748), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2701), 2,
      sym_line_comment,
      sym_block_comment,
  [81270] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5750), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2702), 2,
      sym_line_comment,
      sym_block_comment,
  [81290] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(5752), 1,
      anon_sym_EQ,
    STATE(3489), 1,
      sym_type_parameters,
    STATE(2703), 2,
      sym_line_comment,
      sym_block_comment,
  [81310] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5754), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2704), 2,
      sym_line_comment,
      sym_block_comment,
  [81328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2705), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5756), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [81344] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4796), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2706), 2,
      sym_line_comment,
      sym_block_comment,
  [81364] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5758), 1,
      anon_sym_SEMI,
    ACTIONS(5760), 1,
      anon_sym_EQ,
    STATE(2707), 2,
      sym_line_comment,
      sym_block_comment,
  [81384] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5762), 1,
      anon_sym_SEMI,
    STATE(541), 1,
      sym_declaration_list,
    STATE(2708), 2,
      sym_line_comment,
      sym_block_comment,
  [81404] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5764), 1,
      anon_sym_SEMI,
    STATE(543), 1,
      sym_declaration_list,
    STATE(2709), 2,
      sym_line_comment,
      sym_block_comment,
  [81424] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5766), 1,
      anon_sym_SEMI,
    STATE(571), 1,
      sym_declaration_list,
    STATE(2710), 2,
      sym_line_comment,
      sym_block_comment,
  [81444] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(698), 1,
      anon_sym_RBRACK,
    ACTIONS(3991), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2711), 2,
      sym_line_comment,
      sym_block_comment,
  [81464] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5768), 1,
      anon_sym_SEMI,
    ACTIONS(5770), 1,
      anon_sym_EQ,
    STATE(2712), 2,
      sym_line_comment,
      sym_block_comment,
  [81484] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5772), 1,
      anon_sym_SEMI,
    STATE(574), 1,
      sym_declaration_list,
    STATE(2713), 2,
      sym_line_comment,
      sym_block_comment,
  [81504] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5774), 1,
      anon_sym_RBRACE,
    ACTIONS(5776), 1,
      anon_sym_COMMA,
    STATE(2787), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2714), 2,
      sym_line_comment,
      sym_block_comment,
  [81524] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5778), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2715), 2,
      sym_line_comment,
      sym_block_comment,
  [81542] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5780), 1,
      sym_identifier,
    ACTIONS(5782), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2716), 2,
      sym_line_comment,
      sym_block_comment,
  [81560] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5784), 1,
      anon_sym_SEMI,
    STATE(581), 1,
      sym_declaration_list,
    STATE(2717), 2,
      sym_line_comment,
      sym_block_comment,
  [81580] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3108), 1,
      anon_sym_RPAREN,
    ACTIONS(5786), 1,
      anon_sym_COMMA,
    STATE(2844), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2718), 2,
      sym_line_comment,
      sym_block_comment,
  [81600] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5788), 1,
      anon_sym_RPAREN,
    ACTIONS(5790), 1,
      anon_sym_COMMA,
    STATE(2784), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2719), 2,
      sym_line_comment,
      sym_block_comment,
  [81620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5792), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2720), 2,
      sym_line_comment,
      sym_block_comment,
  [81638] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2721), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4357), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [81654] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5710), 1,
      anon_sym_COMMA,
    ACTIONS(5712), 1,
      anon_sym_GT,
    STATE(2819), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2722), 2,
      sym_line_comment,
      sym_block_comment,
  [81674] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4682), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [81690] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5794), 1,
      anon_sym_SEMI,
    STATE(621), 1,
      sym_declaration_list,
    STATE(2724), 2,
      sym_line_comment,
      sym_block_comment,
  [81710] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5796), 1,
      anon_sym_SEMI,
    STATE(626), 1,
      sym_declaration_list,
    STATE(2725), 2,
      sym_line_comment,
      sym_block_comment,
  [81730] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5350), 1,
      anon_sym_RPAREN,
    ACTIONS(5352), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_parameters_repeat1,
    STATE(2726), 2,
      sym_line_comment,
      sym_block_comment,
  [81750] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4540), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4640), 1,
      anon_sym_BANG,
    ACTIONS(5798), 1,
      sym_identifier,
    STATE(2727), 2,
      sym_line_comment,
      sym_block_comment,
  [81770] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5800), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2728), 2,
      sym_line_comment,
      sym_block_comment,
  [81790] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5802), 1,
      anon_sym_SEMI,
    STATE(594), 1,
      sym_declaration_list,
    STATE(2729), 2,
      sym_line_comment,
      sym_block_comment,
  [81810] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5804), 1,
      anon_sym_SEMI,
    STATE(640), 1,
      sym_declaration_list,
    STATE(2730), 2,
      sym_line_comment,
      sym_block_comment,
  [81830] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2914), 1,
      anon_sym_RPAREN,
    ACTIONS(5806), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2731), 2,
      sym_line_comment,
      sym_block_comment,
  [81850] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5808), 1,
      sym_identifier,
    ACTIONS(5810), 1,
      anon_sym_ref,
    ACTIONS(5812), 1,
      sym_mutable_specifier,
    STATE(2732), 2,
      sym_line_comment,
      sym_block_comment,
  [81870] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2974), 1,
      anon_sym_RBRACK,
    ACTIONS(5814), 1,
      anon_sym_COMMA,
    STATE(2643), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2733), 2,
      sym_line_comment,
      sym_block_comment,
  [81890] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5816), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2734), 2,
      sym_line_comment,
      sym_block_comment,
  [81908] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5818), 1,
      anon_sym_RBRACE,
    ACTIONS(5820), 1,
      anon_sym_COMMA,
    STATE(2759), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2735), 2,
      sym_line_comment,
      sym_block_comment,
  [81928] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5460), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2736), 2,
      sym_line_comment,
      sym_block_comment,
  [81946] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5822), 1,
      anon_sym_RBRACE,
    ACTIONS(5824), 1,
      anon_sym_COMMA,
    STATE(2832), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2737), 2,
      sym_line_comment,
      sym_block_comment,
  [81966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5828), 1,
      anon_sym_COLON,
    ACTIONS(5826), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2738), 2,
      sym_line_comment,
      sym_block_comment,
  [81984] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5830), 1,
      anon_sym_RBRACE,
    ACTIONS(5832), 1,
      anon_sym_COMMA,
    STATE(2834), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2739), 2,
      sym_line_comment,
      sym_block_comment,
  [82004] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5834), 1,
      anon_sym_SEMI,
    ACTIONS(5836), 1,
      anon_sym_EQ,
    STATE(2740), 2,
      sym_line_comment,
      sym_block_comment,
  [82024] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    ACTIONS(5838), 1,
      anon_sym_COLON_COLON,
    STATE(1307), 1,
      sym_field_initializer_list,
    STATE(2741), 2,
      sym_line_comment,
      sym_block_comment,
  [82044] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5840), 1,
      anon_sym_LPAREN,
    ACTIONS(5842), 1,
      anon_sym_LBRACK,
    ACTIONS(5844), 1,
      anon_sym_LBRACE,
    STATE(2742), 2,
      sym_line_comment,
      sym_block_comment,
  [82064] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2743), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5846), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82080] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5848), 1,
      anon_sym_LPAREN,
    ACTIONS(5850), 1,
      anon_sym_LBRACK,
    ACTIONS(5852), 1,
      anon_sym_LBRACE,
    STATE(2744), 2,
      sym_line_comment,
      sym_block_comment,
  [82100] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5854), 1,
      anon_sym_RBRACE,
    ACTIONS(5856), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2745), 2,
      sym_line_comment,
      sym_block_comment,
  [82120] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4283), 1,
      anon_sym_RBRACE,
    ACTIONS(5858), 1,
      anon_sym_COMMA,
    STATE(2974), 1,
      aux_sym_use_list_repeat1,
    STATE(2746), 2,
      sym_line_comment,
      sym_block_comment,
  [82140] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5860), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82156] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5862), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82172] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5864), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82188] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2750), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5866), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82204] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2751), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5868), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82220] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5870), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82236] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5872), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82252] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4764), 1,
      anon_sym_GT,
    ACTIONS(5874), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2754), 2,
      sym_line_comment,
      sym_block_comment,
  [82272] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5876), 1,
      anon_sym_move,
    STATE(130), 1,
      sym_closure_parameters,
    STATE(2755), 2,
      sym_line_comment,
      sym_block_comment,
  [82292] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4760), 1,
      anon_sym_GT,
    ACTIONS(5878), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2756), 2,
      sym_line_comment,
      sym_block_comment,
  [82312] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5880), 1,
      anon_sym_RBRACE,
    ACTIONS(5882), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      aux_sym_use_list_repeat1,
    STATE(2757), 2,
      sym_line_comment,
      sym_block_comment,
  [82332] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(5884), 1,
      anon_sym_SEMI,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(2758), 2,
      sym_line_comment,
      sym_block_comment,
  [82352] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4784), 1,
      anon_sym_RBRACE,
    ACTIONS(5886), 1,
      anon_sym_COMMA,
    STATE(2973), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2759), 2,
      sym_line_comment,
      sym_block_comment,
  [82372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5888), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2760), 2,
      sym_line_comment,
      sym_block_comment,
  [82390] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5892), 1,
      anon_sym_COLON,
    ACTIONS(5890), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2761), 2,
      sym_line_comment,
      sym_block_comment,
  [82408] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5894), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82424] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5896), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2763), 2,
      sym_line_comment,
      sym_block_comment,
  [82442] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    ACTIONS(5898), 1,
      anon_sym_EQ,
    STATE(3259), 1,
      sym_type_parameters,
    STATE(2764), 2,
      sym_line_comment,
      sym_block_comment,
  [82462] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(908), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82478] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5900), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82494] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4606), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82510] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5902), 1,
      anon_sym_SEMI,
    ACTIONS(5904), 1,
      anon_sym_EQ,
    STATE(2768), 2,
      sym_line_comment,
      sym_block_comment,
  [82530] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2769), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4620), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82546] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82562] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5906), 1,
      anon_sym_RBRACE,
    ACTIONS(5908), 1,
      anon_sym_COMMA,
    STATE(2856), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2771), 2,
      sym_line_comment,
      sym_block_comment,
  [82582] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2772), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4662), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82598] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5910), 1,
      anon_sym_SEMI,
    STATE(3303), 1,
      sym_where_clause,
    STATE(2773), 2,
      sym_line_comment,
      sym_block_comment,
  [82618] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82634] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4656), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82650] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3084), 1,
      anon_sym_RPAREN,
    ACTIONS(5912), 1,
      anon_sym_COMMA,
    STATE(2844), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2776), 2,
      sym_line_comment,
      sym_block_comment,
  [82670] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5914), 1,
      anon_sym_PLUS,
    ACTIONS(5916), 1,
      anon_sym_GT,
    ACTIONS(5918), 1,
      anon_sym_as,
    STATE(2777), 2,
      sym_line_comment,
      sym_block_comment,
  [82690] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5920), 1,
      anon_sym_SEMI,
    STATE(3314), 1,
      sym_where_clause,
    STATE(2778), 2,
      sym_line_comment,
      sym_block_comment,
  [82710] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82726] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4806), 1,
      anon_sym_RBRACE,
    ACTIONS(5922), 1,
      anon_sym_COMMA,
    STATE(2781), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2780), 2,
      sym_line_comment,
      sym_block_comment,
  [82746] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5924), 1,
      anon_sym_RBRACE,
    ACTIONS(5926), 1,
      anon_sym_COMMA,
    STATE(2781), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_declaration_list_repeat1,
  [82764] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(5929), 1,
      anon_sym_SEMI,
    STATE(1374), 1,
      sym_declaration_list,
    STATE(2782), 2,
      sym_line_comment,
      sym_block_comment,
  [82784] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5931), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2783), 2,
      sym_line_comment,
      sym_block_comment,
  [82802] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5933), 1,
      anon_sym_RPAREN,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    STATE(2784), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_ordered_field_declaration_list_repeat1,
  [82820] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5938), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2785), 2,
      sym_line_comment,
      sym_block_comment,
  [82838] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5940), 1,
      anon_sym_RPAREN,
    ACTIONS(5942), 1,
      anon_sym_COMMA,
    STATE(2784), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2786), 2,
      sym_line_comment,
      sym_block_comment,
  [82858] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4750), 1,
      anon_sym_RBRACE,
    ACTIONS(5944), 1,
      anon_sym_COMMA,
    STATE(2973), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2787), 2,
      sym_line_comment,
      sym_block_comment,
  [82878] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5946), 1,
      anon_sym_SEMI,
    STATE(3480), 1,
      sym_where_clause,
    STATE(2788), 2,
      sym_line_comment,
      sym_block_comment,
  [82898] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_SEMI,
    ACTIONS(5950), 1,
      anon_sym_EQ,
    STATE(2789), 2,
      sym_line_comment,
      sym_block_comment,
  [82918] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5952), 1,
      anon_sym_RBRACE,
    ACTIONS(5954), 1,
      anon_sym_COMMA,
    STATE(2897), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2790), 2,
      sym_line_comment,
      sym_block_comment,
  [82938] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5956), 1,
      anon_sym_SEMI,
    STATE(3321), 1,
      sym_where_clause,
    STATE(2791), 2,
      sym_line_comment,
      sym_block_comment,
  [82958] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5266), 1,
      anon_sym_COLON,
    ACTIONS(5958), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(2792), 2,
      sym_line_comment,
      sym_block_comment,
  [82976] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5960), 1,
      anon_sym_SEMI,
    STATE(751), 1,
      sym_declaration_list,
    STATE(2793), 2,
      sym_line_comment,
      sym_block_comment,
  [82996] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    ACTIONS(5491), 1,
      anon_sym_GT,
    STATE(2847), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2794), 2,
      sym_line_comment,
      sym_block_comment,
  [83016] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(5962), 1,
      anon_sym_LBRACE,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2795), 2,
      sym_line_comment,
      sym_block_comment,
  [83036] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5222), 1,
      anon_sym_RPAREN,
    ACTIONS(5224), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_parameters_repeat1,
    STATE(2796), 2,
      sym_line_comment,
      sym_block_comment,
  [83056] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5964), 1,
      anon_sym_SEMI,
    STATE(762), 1,
      sym_declaration_list,
    STATE(2797), 2,
      sym_line_comment,
      sym_block_comment,
  [83076] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(5966), 1,
      anon_sym_SEMI,
    STATE(764), 1,
      sym_declaration_list,
    STATE(2798), 2,
      sym_line_comment,
      sym_block_comment,
  [83096] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(696), 1,
      anon_sym_RPAREN,
    ACTIONS(3999), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2799), 2,
      sym_line_comment,
      sym_block_comment,
  [83116] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5493), 1,
      anon_sym_COMMA,
    ACTIONS(5968), 1,
      anon_sym_PIPE,
    STATE(2944), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2800), 2,
      sym_line_comment,
      sym_block_comment,
  [83136] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5970), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2801), 2,
      sym_line_comment,
      sym_block_comment,
  [83154] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5972), 1,
      anon_sym_LPAREN,
    ACTIONS(5974), 1,
      anon_sym_LBRACK,
    ACTIONS(5976), 1,
      anon_sym_LBRACE,
    STATE(2802), 2,
      sym_line_comment,
      sym_block_comment,
  [83174] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(5978), 1,
      anon_sym_SEMI,
    STATE(1214), 1,
      sym_declaration_list,
    STATE(2803), 2,
      sym_line_comment,
      sym_block_comment,
  [83194] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5980), 1,
      anon_sym_LPAREN,
    ACTIONS(5982), 1,
      anon_sym_LBRACK,
    ACTIONS(5984), 1,
      anon_sym_LBRACE,
    STATE(2804), 2,
      sym_line_comment,
      sym_block_comment,
  [83214] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    ACTIONS(5986), 1,
      anon_sym_COLON_COLON,
    STATE(1307), 1,
      sym_field_initializer_list,
    STATE(2805), 2,
      sym_line_comment,
      sym_block_comment,
  [83234] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(656), 1,
      anon_sym_RPAREN,
    ACTIONS(4001), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2806), 2,
      sym_line_comment,
      sym_block_comment,
  [83254] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    ACTIONS(5988), 1,
      sym_mutable_specifier,
    ACTIONS(5990), 1,
      sym_self,
    STATE(2807), 2,
      sym_line_comment,
      sym_block_comment,
  [83274] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4680), 1,
      anon_sym_LBRACE,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2808), 2,
      sym_line_comment,
      sym_block_comment,
  [83294] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4735), 1,
      anon_sym_RBRACE,
    ACTIONS(5992), 1,
      anon_sym_COMMA,
    STATE(2817), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2809), 2,
      sym_line_comment,
      sym_block_comment,
  [83314] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5996), 1,
      anon_sym_EQ,
    ACTIONS(5994), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2810), 2,
      sym_line_comment,
      sym_block_comment,
  [83332] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(5998), 1,
      anon_sym_SEMI,
    STATE(3521), 1,
      sym_where_clause,
    STATE(2811), 2,
      sym_line_comment,
      sym_block_comment,
  [83352] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4694), 1,
      anon_sym_COLON_COLON,
    STATE(1928), 1,
      sym_type_arguments,
    STATE(2812), 2,
      sym_line_comment,
      sym_block_comment,
  [83372] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5346), 1,
      anon_sym_COMMA,
    ACTIONS(5348), 1,
      anon_sym_GT,
    STATE(2756), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2813), 2,
      sym_line_comment,
      sym_block_comment,
  [83392] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6000), 1,
      anon_sym_COMMA,
    ACTIONS(6002), 1,
      anon_sym_GT,
    STATE(2879), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2814), 2,
      sym_line_comment,
      sym_block_comment,
  [83412] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(692), 1,
      anon_sym_RBRACK,
    ACTIONS(6004), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2815), 2,
      sym_line_comment,
      sym_block_comment,
  [83432] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6006), 1,
      anon_sym_SEMI,
    STATE(750), 1,
      sym_declaration_list,
    STATE(2816), 2,
      sym_line_comment,
      sym_block_comment,
  [83452] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6008), 1,
      anon_sym_RBRACE,
    ACTIONS(6010), 1,
      anon_sym_COMMA,
    STATE(2817), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat2,
  [83470] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4596), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83486] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1630), 1,
      anon_sym_GT,
    ACTIONS(6013), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2819), 2,
      sym_line_comment,
      sym_block_comment,
  [83506] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(694), 1,
      anon_sym_RBRACK,
    ACTIONS(3979), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2820), 2,
      sym_line_comment,
      sym_block_comment,
  [83526] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4658), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83542] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1199), 1,
      anon_sym_RPAREN,
    ACTIONS(5330), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_parameters_repeat1,
    STATE(2822), 2,
      sym_line_comment,
      sym_block_comment,
  [83562] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6015), 1,
      anon_sym_move,
    STATE(153), 1,
      sym_closure_parameters,
    STATE(2823), 2,
      sym_line_comment,
      sym_block_comment,
  [83582] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2908), 1,
      anon_sym_RPAREN,
    ACTIONS(6017), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2824), 2,
      sym_line_comment,
      sym_block_comment,
  [83602] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1199), 1,
      anon_sym_RPAREN,
    ACTIONS(5330), 1,
      anon_sym_COMMA,
    STATE(2895), 1,
      aux_sym_parameters_repeat1,
    STATE(2825), 2,
      sym_line_comment,
      sym_block_comment,
  [83622] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2960), 1,
      anon_sym_RBRACK,
    ACTIONS(6019), 1,
      anon_sym_COMMA,
    STATE(2643), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2826), 2,
      sym_line_comment,
      sym_block_comment,
  [83642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6021), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4219), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2827), 2,
      sym_line_comment,
      sym_block_comment,
  [83660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6021), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6023), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2828), 2,
      sym_line_comment,
      sym_block_comment,
  [83678] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    ACTIONS(5121), 1,
      anon_sym_GT,
    STATE(2960), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2829), 2,
      sym_line_comment,
      sym_block_comment,
  [83698] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2982), 1,
      anon_sym_RPAREN,
    ACTIONS(6025), 1,
      anon_sym_COMMA,
    STATE(2643), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2830), 2,
      sym_line_comment,
      sym_block_comment,
  [83718] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4528), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83734] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5073), 1,
      anon_sym_RBRACE,
    ACTIONS(6027), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2832), 2,
      sym_line_comment,
      sym_block_comment,
  [83754] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2833), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4636), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83770] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5075), 1,
      anon_sym_RBRACE,
    ACTIONS(6029), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2834), 2,
      sym_line_comment,
      sym_block_comment,
  [83790] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4646), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83806] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4709), 1,
      anon_sym_RBRACE,
    ACTIONS(6031), 1,
      anon_sym_COMMA,
    STATE(2817), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2836), 2,
      sym_line_comment,
      sym_block_comment,
  [83826] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4709), 1,
      anon_sym_RBRACE,
    ACTIONS(6031), 1,
      anon_sym_COMMA,
    STATE(2901), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2837), 2,
      sym_line_comment,
      sym_block_comment,
  [83846] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6033), 1,
      anon_sym_SEMI,
    ACTIONS(6035), 1,
      anon_sym_RBRACK,
    STATE(2838), 2,
      sym_line_comment,
      sym_block_comment,
  [83866] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4602), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83882] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4608), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83898] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4614), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83914] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(660), 1,
      anon_sym_RBRACK,
    ACTIONS(6037), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2842), 2,
      sym_line_comment,
      sym_block_comment,
  [83934] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6039), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2843), 2,
      sym_line_comment,
      sym_block_comment,
  [83952] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6039), 1,
      anon_sym_RPAREN,
    ACTIONS(6041), 1,
      anon_sym_COMMA,
    STATE(2844), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_type_repeat1,
  [83970] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      sym_declaration_list,
    STATE(2845), 2,
      sym_line_comment,
      sym_block_comment,
  [83990] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84006] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1636), 1,
      anon_sym_GT,
    ACTIONS(6046), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2847), 2,
      sym_line_comment,
      sym_block_comment,
  [84026] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6048), 1,
      anon_sym_SEMI,
    STATE(1143), 1,
      sym_declaration_list,
    STATE(2848), 2,
      sym_line_comment,
      sym_block_comment,
  [84046] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2849), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4684), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84062] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
    ACTIONS(5320), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_parameters_repeat1,
    STATE(2850), 2,
      sym_line_comment,
      sym_block_comment,
  [84082] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(4758), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2851), 2,
      sym_line_comment,
      sym_block_comment,
  [84102] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6050), 1,
      anon_sym_move,
    STATE(148), 1,
      sym_closure_parameters,
    STATE(2852), 2,
      sym_line_comment,
      sym_block_comment,
  [84122] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6052), 1,
      anon_sym_SEMI,
    ACTIONS(6054), 1,
      anon_sym_EQ,
    STATE(2853), 2,
      sym_line_comment,
      sym_block_comment,
  [84142] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
    ACTIONS(5320), 1,
      anon_sym_COMMA,
    STATE(2878), 1,
      aux_sym_parameters_repeat1,
    STATE(2854), 2,
      sym_line_comment,
      sym_block_comment,
  [84162] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6056), 1,
      anon_sym_EQ_GT,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_if,
    STATE(2855), 2,
      sym_line_comment,
      sym_block_comment,
  [84182] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4745), 1,
      anon_sym_RBRACE,
    ACTIONS(6062), 1,
      anon_sym_COMMA,
    STATE(2781), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2856), 2,
      sym_line_comment,
      sym_block_comment,
  [84202] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4745), 1,
      anon_sym_RBRACE,
    ACTIONS(6062), 1,
      anon_sym_COMMA,
    STATE(2916), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2857), 2,
      sym_line_comment,
      sym_block_comment,
  [84222] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2858), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4570), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84238] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6064), 1,
      anon_sym_SEMI,
    STATE(575), 1,
      sym_declaration_list,
    STATE(2859), 2,
      sym_line_comment,
      sym_block_comment,
  [84258] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6066), 1,
      anon_sym_SEMI,
    STATE(743), 1,
      sym_declaration_list,
    STATE(2860), 2,
      sym_line_comment,
      sym_block_comment,
  [84278] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6070), 1,
      anon_sym_COLON,
    ACTIONS(6068), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2861), 2,
      sym_line_comment,
      sym_block_comment,
  [84296] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6072), 1,
      anon_sym_SEMI,
    STATE(1158), 1,
      sym_declaration_list,
    STATE(2862), 2,
      sym_line_comment,
      sym_block_comment,
  [84316] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4582), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6074), 1,
      anon_sym_RBRACE,
    ACTIONS(6076), 1,
      anon_sym_COMMA,
    STATE(2864), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_struct_pattern_repeat1,
  [84350] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5678), 1,
      anon_sym_RPAREN,
    ACTIONS(5680), 1,
      anon_sym_COMMA,
    STATE(2824), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2865), 2,
      sym_line_comment,
      sym_block_comment,
  [84370] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3743), 1,
      anon_sym_LBRACE,
    ACTIONS(6079), 1,
      anon_sym_COLON_COLON,
    STATE(1684), 1,
      sym_field_initializer_list,
    STATE(2866), 2,
      sym_line_comment,
      sym_block_comment,
  [84390] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6081), 1,
      anon_sym_move,
    STATE(136), 1,
      sym_closure_parameters,
    STATE(2867), 2,
      sym_line_comment,
      sym_block_comment,
  [84410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6083), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2868), 2,
      sym_line_comment,
      sym_block_comment,
  [84428] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2924), 1,
      anon_sym_SQUOTE,
    ACTIONS(6085), 1,
      anon_sym_GT,
    STATE(3131), 1,
      sym_lifetime,
    STATE(2869), 2,
      sym_line_comment,
      sym_block_comment,
  [84448] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6087), 1,
      anon_sym_SEMI,
    ACTIONS(6089), 1,
      anon_sym_EQ,
    STATE(2870), 2,
      sym_line_comment,
      sym_block_comment,
  [84468] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6091), 1,
      anon_sym_move,
    STATE(124), 1,
      sym_closure_parameters,
    STATE(2871), 2,
      sym_line_comment,
      sym_block_comment,
  [84488] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2872), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4664), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84504] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(6093), 1,
      anon_sym_SEMI,
    STATE(3421), 1,
      sym_where_clause,
    STATE(2873), 2,
      sym_line_comment,
      sym_block_comment,
  [84524] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(680), 1,
      anon_sym_RPAREN,
    ACTIONS(6095), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2874), 2,
      sym_line_comment,
      sym_block_comment,
  [84544] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6097), 1,
      anon_sym_COMMA,
    ACTIONS(6100), 1,
      anon_sym_GT,
    STATE(2875), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_for_lifetimes_repeat1,
  [84562] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2924), 1,
      anon_sym_SQUOTE,
    ACTIONS(6102), 1,
      anon_sym_GT,
    STATE(3131), 1,
      sym_lifetime,
    STATE(2876), 2,
      sym_line_comment,
      sym_block_comment,
  [84582] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6104), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84598] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1193), 1,
      anon_sym_RPAREN,
    ACTIONS(6106), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_parameters_repeat1,
    STATE(2878), 2,
      sym_line_comment,
      sym_block_comment,
  [84618] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6085), 1,
      anon_sym_GT,
    ACTIONS(6108), 1,
      anon_sym_COMMA,
    STATE(2875), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2879), 2,
      sym_line_comment,
      sym_block_comment,
  [84638] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2880), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5205), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84654] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5091), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2881), 2,
      sym_line_comment,
      sym_block_comment,
  [84672] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(688), 1,
      anon_sym_RPAREN,
    ACTIONS(6110), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2882), 2,
      sym_line_comment,
      sym_block_comment,
  [84692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5561), 1,
      anon_sym_RPAREN,
    ACTIONS(6112), 1,
      anon_sym_COMMA,
    STATE(2883), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_parameters_repeat1,
  [84710] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5970), 1,
      anon_sym_RPAREN,
    ACTIONS(6115), 1,
      anon_sym_COMMA,
    STATE(2884), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_pattern_repeat1,
  [84728] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      anon_sym_RPAREN,
    ACTIONS(5666), 1,
      anon_sym_COMMA,
    STATE(2731), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2885), 2,
      sym_line_comment,
      sym_block_comment,
  [84748] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(6118), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2886), 2,
      sym_line_comment,
      sym_block_comment,
  [84768] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5958), 1,
      anon_sym_PIPE,
    ACTIONS(6120), 1,
      anon_sym_COMMA,
    STATE(2887), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_closure_parameters_repeat1,
  [84786] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6123), 1,
      anon_sym_move,
    STATE(121), 1,
      sym_closure_parameters,
    STATE(2888), 2,
      sym_line_comment,
      sym_block_comment,
  [84806] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6125), 1,
      anon_sym_RBRACE,
    ACTIONS(6127), 1,
      anon_sym_COMMA,
    STATE(2898), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2889), 2,
      sym_line_comment,
      sym_block_comment,
  [84826] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6129), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_await,
    ACTIONS(6133), 1,
      sym_integer_literal,
    STATE(2890), 2,
      sym_line_comment,
      sym_block_comment,
  [84846] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2976), 1,
      anon_sym_RPAREN,
    ACTIONS(6135), 1,
      anon_sym_COMMA,
    STATE(2643), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2891), 2,
      sym_line_comment,
      sym_block_comment,
  [84866] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2892), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6137), 3,
      sym__string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [84882] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(6139), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_parameters_repeat1,
    STATE(2893), 2,
      sym_line_comment,
      sym_block_comment,
  [84902] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6141), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2894), 2,
      sym_line_comment,
      sym_block_comment,
  [84920] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1169), 1,
      anon_sym_RPAREN,
    ACTIONS(6143), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_parameters_repeat1,
    STATE(2895), 2,
      sym_line_comment,
      sym_block_comment,
  [84940] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      anon_sym_COLON,
    ACTIONS(6145), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2896), 2,
      sym_line_comment,
      sym_block_comment,
  [84958] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5061), 1,
      anon_sym_RBRACE,
    ACTIONS(6149), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2897), 2,
      sym_line_comment,
      sym_block_comment,
  [84978] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    ACTIONS(6151), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2898), 2,
      sym_line_comment,
      sym_block_comment,
  [84998] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6155), 1,
      anon_sym_EQ,
    ACTIONS(6153), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2899), 2,
      sym_line_comment,
      sym_block_comment,
  [85016] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4762), 1,
      anon_sym_RBRACE,
    ACTIONS(6157), 1,
      anon_sym_COMMA,
    STATE(2817), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2900), 2,
      sym_line_comment,
      sym_block_comment,
  [85036] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4772), 1,
      anon_sym_RBRACE,
    ACTIONS(6159), 1,
      anon_sym_COMMA,
    STATE(2817), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2901), 2,
      sym_line_comment,
      sym_block_comment,
  [85056] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4666), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85072] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4660), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85088] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6161), 1,
      anon_sym_SEMI,
    STATE(1268), 1,
      sym_declaration_list,
    STATE(2904), 2,
      sym_line_comment,
      sym_block_comment,
  [85108] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_SEMI,
    STATE(1271), 1,
      sym_declaration_list,
    STATE(2905), 2,
      sym_line_comment,
      sym_block_comment,
  [85128] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2906), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4648), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85144] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2907), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4634), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85160] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6165), 1,
      anon_sym_SEMI,
    STATE(1289), 1,
      sym_declaration_list,
    STATE(2908), 2,
      sym_line_comment,
      sym_block_comment,
  [85180] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6167), 1,
      anon_sym_SEMI,
    STATE(1294), 1,
      sym_declaration_list,
    STATE(2909), 2,
      sym_line_comment,
      sym_block_comment,
  [85200] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2910), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4612), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85216] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6169), 1,
      anon_sym_COMMA,
    ACTIONS(6172), 1,
      anon_sym_GT,
    STATE(2911), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_arguments_repeat1,
  [85234] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1203), 1,
      anon_sym_RPAREN,
    ACTIONS(5244), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym_parameters_repeat1,
    STATE(2912), 2,
      sym_line_comment,
      sym_block_comment,
  [85254] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6174), 1,
      anon_sym_SEMI,
    ACTIONS(6176), 1,
      anon_sym_EQ,
    STATE(2913), 2,
      sym_line_comment,
      sym_block_comment,
  [85274] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4762), 1,
      anon_sym_RBRACE,
    ACTIONS(6157), 1,
      anon_sym_COMMA,
    STATE(2809), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2914), 2,
      sym_line_comment,
      sym_block_comment,
  [85294] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    ACTIONS(6172), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2915), 2,
      sym_line_comment,
      sym_block_comment,
  [85312] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4782), 1,
      anon_sym_RBRACE,
    ACTIONS(6178), 1,
      anon_sym_COMMA,
    STATE(2781), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2916), 2,
      sym_line_comment,
      sym_block_comment,
  [85332] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1203), 1,
      anon_sym_RPAREN,
    ACTIONS(5244), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_parameters_repeat1,
    STATE(2917), 2,
      sym_line_comment,
      sym_block_comment,
  [85352] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1614), 1,
      anon_sym_GT,
    ACTIONS(6180), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2918), 2,
      sym_line_comment,
      sym_block_comment,
  [85372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6182), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2919), 2,
      sym_line_comment,
      sym_block_comment,
  [85390] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6172), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2920), 2,
      sym_line_comment,
      sym_block_comment,
  [85408] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5519), 1,
      anon_sym_EQ,
    ACTIONS(5635), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2921), 2,
      sym_line_comment,
      sym_block_comment,
  [85426] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6184), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2922), 2,
      sym_line_comment,
      sym_block_comment,
  [85444] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6186), 1,
      sym_identifier,
    ACTIONS(6188), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      sym_mutable_specifier,
    STATE(2923), 2,
      sym_line_comment,
      sym_block_comment,
  [85464] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5635), 1,
      anon_sym_GT,
    ACTIONS(6192), 1,
      anon_sym_COMMA,
    STATE(2924), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_parameters_repeat1,
  [85482] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    ACTIONS(6197), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2925), 2,
      sym_line_comment,
      sym_block_comment,
  [85502] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5238), 1,
      anon_sym_RPAREN,
    ACTIONS(5240), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_parameters_repeat1,
    STATE(2926), 2,
      sym_line_comment,
      sym_block_comment,
  [85522] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5569), 1,
      anon_sym_COMMA,
    ACTIONS(5571), 1,
      anon_sym_GT,
    STATE(2918), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2927), 2,
      sym_line_comment,
      sym_block_comment,
  [85542] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6199), 1,
      anon_sym_SEMI,
    STATE(1308), 1,
      sym_declaration_list,
    STATE(2928), 2,
      sym_line_comment,
      sym_block_comment,
  [85562] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3086), 1,
      anon_sym_RPAREN,
    ACTIONS(6201), 1,
      anon_sym_COMMA,
    STATE(2844), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2929), 2,
      sym_line_comment,
      sym_block_comment,
  [85582] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4480), 1,
      anon_sym_COLON,
    ACTIONS(4694), 1,
      anon_sym_COLON_COLON,
    STATE(2640), 1,
      sym_trait_bounds,
    STATE(2930), 2,
      sym_line_comment,
      sym_block_comment,
  [85602] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    ACTIONS(4792), 1,
      anon_sym_COLON_COLON,
    STATE(1545), 1,
      sym_type_arguments,
    STATE(2931), 2,
      sym_line_comment,
      sym_block_comment,
  [85622] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    ACTIONS(4800), 1,
      anon_sym_COLON_COLON,
    STATE(1063), 1,
      sym_type_arguments,
    STATE(2932), 2,
      sym_line_comment,
      sym_block_comment,
  [85642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6203), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2933), 2,
      sym_line_comment,
      sym_block_comment,
  [85660] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6205), 1,
      anon_sym_SEMI,
    STATE(730), 1,
      sym_declaration_list,
    STATE(2934), 2,
      sym_line_comment,
      sym_block_comment,
  [85680] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6207), 1,
      anon_sym_SEMI,
    ACTIONS(6209), 1,
      anon_sym_RBRACK,
    STATE(2935), 2,
      sym_line_comment,
      sym_block_comment,
  [85700] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(682), 1,
      anon_sym_RBRACK,
    ACTIONS(3951), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2936), 2,
      sym_line_comment,
      sym_block_comment,
  [85720] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6211), 1,
      anon_sym_SEMI,
    STATE(712), 1,
      sym_declaration_list,
    STATE(2937), 2,
      sym_line_comment,
      sym_block_comment,
  [85740] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4480), 1,
      anon_sym_COLON,
    STATE(2640), 1,
      sym_trait_bounds,
    STATE(2938), 2,
      sym_line_comment,
      sym_block_comment,
  [85760] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4719), 1,
      anon_sym_where,
    ACTIONS(6213), 1,
      anon_sym_SEMI,
    STATE(3323), 1,
      sym_where_clause,
    STATE(2939), 2,
      sym_line_comment,
      sym_block_comment,
  [85780] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2940), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4600), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85796] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6215), 1,
      anon_sym_SEMI,
    STATE(550), 1,
      sym_declaration_list,
    STATE(2941), 2,
      sym_line_comment,
      sym_block_comment,
  [85816] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6217), 1,
      anon_sym_SEMI,
    STATE(1367), 1,
      sym_declaration_list,
    STATE(2942), 2,
      sym_line_comment,
      sym_block_comment,
  [85836] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6219), 1,
      anon_sym_SEMI,
    STATE(1372), 1,
      sym_declaration_list,
    STATE(2943), 2,
      sym_line_comment,
      sym_block_comment,
  [85856] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5493), 1,
      anon_sym_COMMA,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    STATE(2887), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2944), 2,
      sym_line_comment,
      sym_block_comment,
  [85876] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6223), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_await,
    ACTIONS(6227), 1,
      sym_integer_literal,
    STATE(2945), 2,
      sym_line_comment,
      sym_block_comment,
  [85896] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6229), 1,
      anon_sym_SEMI,
    ACTIONS(6231), 1,
      anon_sym_EQ,
    STATE(2946), 2,
      sym_line_comment,
      sym_block_comment,
  [85916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6235), 1,
      anon_sym_COLON,
    ACTIONS(6233), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2947), 2,
      sym_line_comment,
      sym_block_comment,
  [85934] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6237), 1,
      anon_sym_SEMI,
    ACTIONS(6239), 1,
      anon_sym_EQ,
    STATE(2948), 2,
      sym_line_comment,
      sym_block_comment,
  [85954] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6241), 1,
      anon_sym_SEMI,
    STATE(1385), 1,
      sym_declaration_list,
    STATE(2949), 2,
      sym_line_comment,
      sym_block_comment,
  [85974] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6243), 1,
      anon_sym_SEMI,
    STATE(1387), 1,
      sym_declaration_list,
    STATE(2950), 2,
      sym_line_comment,
      sym_block_comment,
  [85994] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6245), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [86010] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6247), 1,
      anon_sym_RPAREN,
    ACTIONS(6249), 1,
      anon_sym_COMMA,
    STATE(2784), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2952), 2,
      sym_line_comment,
      sym_block_comment,
  [86030] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6251), 1,
      anon_sym_SEMI,
    STATE(1402), 1,
      sym_declaration_list,
    STATE(2953), 2,
      sym_line_comment,
      sym_block_comment,
  [86050] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6253), 1,
      anon_sym_SEMI,
    STATE(1404), 1,
      sym_declaration_list,
    STATE(2954), 2,
      sym_line_comment,
      sym_block_comment,
  [86070] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4819), 1,
      anon_sym_RBRACE,
    ACTIONS(6255), 1,
      anon_sym_COMMA,
    STATE(2781), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2955), 2,
      sym_line_comment,
      sym_block_comment,
  [86090] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4770), 1,
      anon_sym_GT,
    ACTIONS(6257), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2956), 2,
      sym_line_comment,
      sym_block_comment,
  [86110] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4819), 1,
      anon_sym_RBRACE,
    ACTIONS(6255), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2957), 2,
      sym_line_comment,
      sym_block_comment,
  [86130] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6259), 1,
      anon_sym_SEMI,
    ACTIONS(6261), 1,
      anon_sym_EQ,
    STATE(2958), 2,
      sym_line_comment,
      sym_block_comment,
  [86150] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2959), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4584), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86166] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4774), 1,
      anon_sym_GT,
    ACTIONS(6263), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2960), 2,
      sym_line_comment,
      sym_block_comment,
  [86186] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2961), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4594), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6265), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [86218] = 6,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6267), 1,
      anon_sym_move,
    STATE(138), 1,
      sym_closure_parameters,
    STATE(2963), 2,
      sym_line_comment,
      sym_block_comment,
  [86238] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(700), 1,
      anon_sym_RBRACK,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym_arguments_repeat1,
    STATE(2964), 2,
      sym_line_comment,
      sym_block_comment,
  [86258] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6269), 1,
      anon_sym_SEMI,
    STATE(1435), 1,
      sym_declaration_list,
    STATE(2965), 2,
      sym_line_comment,
      sym_block_comment,
  [86278] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    ACTIONS(6271), 1,
      anon_sym_SEMI,
    STATE(1439), 1,
      sym_declaration_list,
    STATE(2966), 2,
      sym_line_comment,
      sym_block_comment,
  [86298] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4610), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86314] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6273), 1,
      anon_sym_SEMI,
    ACTIONS(6275), 1,
      anon_sym_RBRACK,
    STATE(2968), 2,
      sym_line_comment,
      sym_block_comment,
  [86334] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4618), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [86350] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6277), 1,
      anon_sym_SEMI,
    ACTIONS(6279), 1,
      anon_sym_EQ,
    STATE(2970), 2,
      sym_line_comment,
      sym_block_comment,
  [86370] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4353), 1,
      anon_sym_LT2,
    ACTIONS(6281), 1,
      anon_sym_for,
    STATE(1930), 1,
      sym_type_arguments,
    STATE(2971), 2,
      sym_line_comment,
      sym_block_comment,
  [86390] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    ACTIONS(6283), 1,
      anon_sym_SEMI,
    STATE(600), 1,
      sym_declaration_list,
    STATE(2972), 2,
      sym_line_comment,
      sym_block_comment,
  [86410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6285), 1,
      anon_sym_RBRACE,
    ACTIONS(6287), 1,
      anon_sym_COMMA,
    STATE(2973), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_initializer_list_repeat1,
  [86428] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6290), 1,
      anon_sym_RBRACE,
    ACTIONS(6292), 1,
      anon_sym_COMMA,
    STATE(2974), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_use_list_repeat1,
  [86446] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6295), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [86462] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(711), 1,
      sym_declaration_list,
    STATE(2976), 2,
      sym_line_comment,
      sym_block_comment,
  [86479] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6297), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(2977), 2,
      sym_line_comment,
      sym_block_comment,
  [86494] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_declaration_list,
    STATE(2978), 2,
      sym_line_comment,
      sym_block_comment,
  [86511] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5547), 1,
      sym_super,
    ACTIONS(6299), 1,
      sym_identifier,
    STATE(2979), 2,
      sym_line_comment,
      sym_block_comment,
  [86528] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5286), 1,
      sym_super,
    ACTIONS(6301), 1,
      sym_identifier,
    STATE(2980), 2,
      sym_line_comment,
      sym_block_comment,
  [86545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5021), 1,
      anon_sym_RBRACE,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(2981), 2,
      sym_line_comment,
      sym_block_comment,
  [86562] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6285), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2982), 2,
      sym_line_comment,
      sym_block_comment,
  [86577] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_declaration_list,
    STATE(2983), 2,
      sym_line_comment,
      sym_block_comment,
  [86594] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5547), 1,
      sym_super,
    ACTIONS(6305), 1,
      sym_identifier,
    STATE(2984), 2,
      sym_line_comment,
      sym_block_comment,
  [86611] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6307), 1,
      anon_sym_LBRACK,
    ACTIONS(6309), 1,
      anon_sym_BANG,
    STATE(2985), 2,
      sym_line_comment,
      sym_block_comment,
  [86628] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_enum_variant_list,
    STATE(2986), 2,
      sym_line_comment,
      sym_block_comment,
  [86645] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6311), 1,
      sym_identifier,
    ACTIONS(6313), 1,
      sym_mutable_specifier,
    STATE(2987), 2,
      sym_line_comment,
      sym_block_comment,
  [86662] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_RBRACK,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(2988), 2,
      sym_line_comment,
      sym_block_comment,
  [86679] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6315), 1,
      sym_identifier,
    ACTIONS(6317), 1,
      sym_super,
    STATE(2989), 2,
      sym_line_comment,
      sym_block_comment,
  [86696] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6281), 1,
      anon_sym_for,
    STATE(2990), 2,
      sym_line_comment,
      sym_block_comment,
  [86713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5734), 1,
      sym_identifier,
    ACTIONS(5738), 1,
      sym_mutable_specifier,
    STATE(2991), 2,
      sym_line_comment,
      sym_block_comment,
  [86730] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6319), 2,
      sym_identifier,
      sym_super,
    STATE(2992), 2,
      sym_line_comment,
      sym_block_comment,
  [86745] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(138), 1,
      sym_closure_parameters,
    STATE(2993), 2,
      sym_line_comment,
      sym_block_comment,
  [86762] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6118), 1,
      anon_sym_for,
    STATE(2994), 2,
      sym_line_comment,
      sym_block_comment,
  [86779] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(573), 1,
      sym_field_declaration_list,
    STATE(2995), 2,
      sym_line_comment,
      sym_block_comment,
  [86796] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6321), 1,
      anon_sym_in,
    STATE(2996), 2,
      sym_line_comment,
      sym_block_comment,
  [86813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6323), 1,
      anon_sym_in,
    STATE(2997), 2,
      sym_line_comment,
      sym_block_comment,
  [86830] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6325), 1,
      anon_sym_in,
    STATE(2998), 2,
      sym_line_comment,
      sym_block_comment,
  [86847] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(533), 1,
      sym_declaration_list,
    STATE(2999), 2,
      sym_line_comment,
      sym_block_comment,
  [86864] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6327), 1,
      anon_sym_in,
    STATE(3000), 2,
      sym_line_comment,
      sym_block_comment,
  [86881] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3170), 1,
      anon_sym_LT2,
    STATE(1247), 1,
      sym_type_arguments,
    STATE(3001), 2,
      sym_line_comment,
      sym_block_comment,
  [86898] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6329), 1,
      sym_identifier,
    ACTIONS(6331), 1,
      sym_super,
    STATE(3002), 2,
      sym_line_comment,
      sym_block_comment,
  [86915] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1426), 1,
      sym_declaration_list,
    STATE(3003), 2,
      sym_line_comment,
      sym_block_comment,
  [86932] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6333), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3004), 2,
      sym_line_comment,
      sym_block_comment,
  [86947] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6335), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      sym_super,
    STATE(3005), 2,
      sym_line_comment,
      sym_block_comment,
  [86964] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6339), 1,
      anon_sym_LT,
    STATE(966), 1,
      sym_type_parameters,
    STATE(3006), 2,
      sym_line_comment,
      sym_block_comment,
  [86981] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5744), 1,
      anon_sym_for,
    STATE(3007), 2,
      sym_line_comment,
      sym_block_comment,
  [86998] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    STATE(1544), 1,
      sym_parameters,
    STATE(3008), 2,
      sym_line_comment,
      sym_block_comment,
  [87015] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_RPAREN,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3009), 2,
      sym_line_comment,
      sym_block_comment,
  [87032] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6341), 1,
      sym_identifier,
    ACTIONS(6343), 1,
      sym_super,
    STATE(3010), 2,
      sym_line_comment,
      sym_block_comment,
  [87049] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6345), 1,
      sym_identifier,
    ACTIONS(6347), 1,
      sym_super,
    STATE(3011), 2,
      sym_line_comment,
      sym_block_comment,
  [87066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_in,
    STATE(3012), 2,
      sym_line_comment,
      sym_block_comment,
  [87083] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3684), 1,
      anon_sym_LT2,
    STATE(1617), 1,
      sym_type_arguments,
    STATE(3013), 2,
      sym_line_comment,
      sym_block_comment,
  [87100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_declaration_list,
    STATE(3014), 2,
      sym_line_comment,
      sym_block_comment,
  [87117] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5748), 1,
      anon_sym_for,
    STATE(3015), 2,
      sym_line_comment,
      sym_block_comment,
  [87134] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6351), 1,
      sym_identifier,
    ACTIONS(6353), 1,
      sym_super,
    STATE(3016), 2,
      sym_line_comment,
      sym_block_comment,
  [87151] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5750), 1,
      anon_sym_for,
    STATE(3017), 2,
      sym_line_comment,
      sym_block_comment,
  [87168] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6355), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3018), 2,
      sym_line_comment,
      sym_block_comment,
  [87183] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(119), 1,
      sym_closure_parameters,
    STATE(3019), 2,
      sym_line_comment,
      sym_block_comment,
  [87200] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6357), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3020), 2,
      sym_line_comment,
      sym_block_comment,
  [87215] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1500), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3021), 2,
      sym_line_comment,
      sym_block_comment,
  [87230] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(646), 1,
      sym_field_declaration_list,
    STATE(3022), 2,
      sym_line_comment,
      sym_block_comment,
  [87247] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6347), 1,
      sym_super,
    ACTIONS(6359), 1,
      sym_identifier,
    STATE(3023), 2,
      sym_line_comment,
      sym_block_comment,
  [87264] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 2,
      sym_identifier,
      sym_super,
    STATE(3024), 2,
      sym_line_comment,
      sym_block_comment,
  [87279] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(630), 1,
      sym_enum_variant_list,
    STATE(3025), 2,
      sym_line_comment,
      sym_block_comment,
  [87296] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5585), 1,
      sym_identifier,
    ACTIONS(5587), 1,
      sym_super,
    STATE(3026), 2,
      sym_line_comment,
      sym_block_comment,
  [87313] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5587), 2,
      sym_identifier,
      sym_super,
    STATE(3027), 2,
      sym_line_comment,
      sym_block_comment,
  [87328] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6361), 1,
      sym_identifier,
    ACTIONS(6363), 1,
      sym_super,
    STATE(3028), 2,
      sym_line_comment,
      sym_block_comment,
  [87345] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5589), 1,
      sym_identifier,
    STATE(3029), 2,
      sym_line_comment,
      sym_block_comment,
  [87362] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5547), 1,
      sym_super,
    ACTIONS(6335), 1,
      sym_identifier,
    STATE(3030), 2,
      sym_line_comment,
      sym_block_comment,
  [87379] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5029), 1,
      anon_sym_RBRACE,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3031), 2,
      sym_line_comment,
      sym_block_comment,
  [87396] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(598), 1,
      sym_declaration_list,
    STATE(3032), 2,
      sym_line_comment,
      sym_block_comment,
  [87413] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(531), 1,
      sym_declaration_list,
    STATE(3033), 2,
      sym_line_comment,
      sym_block_comment,
  [87430] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6343), 1,
      sym_super,
    ACTIONS(6365), 1,
      sym_identifier,
    STATE(3034), 2,
      sym_line_comment,
      sym_block_comment,
  [87447] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(667), 1,
      sym_field_declaration_list,
    STATE(3035), 2,
      sym_line_comment,
      sym_block_comment,
  [87464] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4796), 1,
      anon_sym_for,
    STATE(3036), 2,
      sym_line_comment,
      sym_block_comment,
  [87481] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym_declaration_list,
    STATE(3037), 2,
      sym_line_comment,
      sym_block_comment,
  [87498] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5031), 1,
      anon_sym_RBRACE,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3038), 2,
      sym_line_comment,
      sym_block_comment,
  [87515] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6367), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3039), 2,
      sym_line_comment,
      sym_block_comment,
  [87530] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5575), 1,
      sym_identifier,
    STATE(3040), 2,
      sym_line_comment,
      sym_block_comment,
  [87547] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    STATE(1533), 1,
      sym_parameters,
    STATE(3041), 2,
      sym_line_comment,
      sym_block_comment,
  [87564] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4847), 1,
      anon_sym_COLON,
    STATE(2640), 1,
      sym_trait_bounds,
    STATE(3042), 2,
      sym_line_comment,
      sym_block_comment,
  [87581] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4717), 1,
      anon_sym_LT,
    STATE(1000), 1,
      sym_type_parameters,
    STATE(3043), 2,
      sym_line_comment,
      sym_block_comment,
  [87598] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(622), 1,
      sym_field_declaration_list,
    STATE(3044), 2,
      sym_line_comment,
      sym_block_comment,
  [87615] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6347), 1,
      sym_super,
    ACTIONS(6351), 1,
      sym_identifier,
    STATE(3045), 2,
      sym_line_comment,
      sym_block_comment,
  [87632] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5643), 1,
      sym_identifier,
    STATE(3046), 2,
      sym_line_comment,
      sym_block_comment,
  [87649] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 2,
      sym_identifier,
      sym_super,
    STATE(3047), 2,
      sym_line_comment,
      sym_block_comment,
  [87664] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6369), 1,
      anon_sym_in,
    STATE(3048), 2,
      sym_line_comment,
      sym_block_comment,
  [87681] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6371), 2,
      sym_identifier,
      sym_super,
    STATE(3049), 2,
      sym_line_comment,
      sym_block_comment,
  [87696] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(2177), 1,
      sym_parameters,
    STATE(3050), 2,
      sym_line_comment,
      sym_block_comment,
  [87713] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6373), 2,
      sym_identifier,
      sym_super,
    STATE(3051), 2,
      sym_line_comment,
      sym_block_comment,
  [87728] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6375), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3052), 2,
      sym_line_comment,
      sym_block_comment,
  [87743] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6377), 1,
      anon_sym_LBRACK,
    ACTIONS(6379), 1,
      anon_sym_BANG,
    STATE(3053), 2,
      sym_line_comment,
      sym_block_comment,
  [87760] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(132), 1,
      sym_closure_parameters,
    STATE(3054), 2,
      sym_line_comment,
      sym_block_comment,
  [87777] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1351), 1,
      sym_declaration_list,
    STATE(3055), 2,
      sym_line_comment,
      sym_block_comment,
  [87794] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5547), 1,
      sym_super,
    ACTIONS(6381), 1,
      sym_identifier,
    STATE(3056), 2,
      sym_line_comment,
      sym_block_comment,
  [87811] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1350), 1,
      sym_declaration_list,
    STATE(3057), 2,
      sym_line_comment,
      sym_block_comment,
  [87828] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    STATE(1076), 1,
      sym_parameters,
    STATE(3058), 2,
      sym_line_comment,
      sym_block_comment,
  [87845] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6383), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3059), 2,
      sym_line_comment,
      sym_block_comment,
  [87860] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6385), 1,
      sym_identifier,
    ACTIONS(6387), 1,
      sym_mutable_specifier,
    STATE(3060), 2,
      sym_line_comment,
      sym_block_comment,
  [87877] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6389), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3061), 2,
      sym_line_comment,
      sym_block_comment,
  [87892] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(1953), 1,
      sym_parameters,
    STATE(3062), 2,
      sym_line_comment,
      sym_block_comment,
  [87909] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6391), 1,
      anon_sym_SEMI,
    ACTIONS(6393), 1,
      anon_sym_as,
    STATE(3063), 2,
      sym_line_comment,
      sym_block_comment,
  [87926] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 2,
      sym_identifier,
      sym_super,
    STATE(3064), 2,
      sym_line_comment,
      sym_block_comment,
  [87941] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    STATE(1539), 1,
      sym_parameters,
    STATE(3065), 2,
      sym_line_comment,
      sym_block_comment,
  [87958] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5575), 1,
      sym_identifier,
    STATE(3066), 2,
      sym_line_comment,
      sym_block_comment,
  [87975] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4518), 1,
      anon_sym_BANG,
    ACTIONS(4578), 1,
      anon_sym_COLON_COLON,
    STATE(3067), 2,
      sym_line_comment,
      sym_block_comment,
  [87992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5800), 1,
      anon_sym_for,
    STATE(3068), 2,
      sym_line_comment,
      sym_block_comment,
  [88009] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(130), 1,
      sym_closure_parameters,
    STATE(3069), 2,
      sym_line_comment,
      sym_block_comment,
  [88026] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6339), 1,
      anon_sym_LT,
    STATE(1499), 1,
      sym_type_parameters,
    STATE(3070), 2,
      sym_line_comment,
      sym_block_comment,
  [88043] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6395), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3071), 2,
      sym_line_comment,
      sym_block_comment,
  [88058] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    STATE(1083), 1,
      sym_parameters,
    STATE(3072), 2,
      sym_line_comment,
      sym_block_comment,
  [88075] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1278), 1,
      sym_declaration_list,
    STATE(3073), 2,
      sym_line_comment,
      sym_block_comment,
  [88092] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6397), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6399), 1,
      anon_sym_BANG,
    STATE(3074), 2,
      sym_line_comment,
      sym_block_comment,
  [88109] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6401), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3075), 2,
      sym_line_comment,
      sym_block_comment,
  [88124] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5635), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3076), 2,
      sym_line_comment,
      sym_block_comment,
  [88139] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5567), 1,
      sym_identifier,
    STATE(3077), 2,
      sym_line_comment,
      sym_block_comment,
  [88156] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(676), 1,
      sym_declaration_list,
    STATE(3078), 2,
      sym_line_comment,
      sym_block_comment,
  [88173] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1198), 1,
      sym_field_declaration_list,
    STATE(3079), 2,
      sym_line_comment,
      sym_block_comment,
  [88190] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2924), 1,
      anon_sym_SQUOTE,
    STATE(3131), 1,
      sym_lifetime,
    STATE(3080), 2,
      sym_line_comment,
      sym_block_comment,
  [88207] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6023), 1,
      anon_sym_EQ_GT,
    ACTIONS(6403), 1,
      anon_sym_AMP_AMP,
    STATE(3081), 2,
      sym_line_comment,
      sym_block_comment,
  [88224] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(641), 1,
      sym_declaration_list,
    STATE(3082), 2,
      sym_line_comment,
      sym_block_comment,
  [88241] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(1307), 1,
      sym_field_initializer_list,
    STATE(3083), 2,
      sym_line_comment,
      sym_block_comment,
  [88258] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4219), 1,
      anon_sym_EQ_GT,
    ACTIONS(6403), 1,
      anon_sym_AMP_AMP,
    STATE(3084), 2,
      sym_line_comment,
      sym_block_comment,
  [88275] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5547), 2,
      sym_identifier,
      sym_super,
    STATE(3085), 2,
      sym_line_comment,
      sym_block_comment,
  [88290] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6172), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3086), 2,
      sym_line_comment,
      sym_block_comment,
  [88305] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6405), 1,
      anon_sym_SEMI,
    ACTIONS(6407), 1,
      anon_sym_as,
    STATE(3087), 2,
      sym_line_comment,
      sym_block_comment,
  [88322] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6347), 2,
      sym_identifier,
      sym_super,
    STATE(3088), 2,
      sym_line_comment,
      sym_block_comment,
  [88337] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(2178), 1,
      sym_parameters,
    STATE(3089), 2,
      sym_line_comment,
      sym_block_comment,
  [88354] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 2,
      sym_identifier,
      sym_super,
    STATE(3090), 2,
      sym_line_comment,
      sym_block_comment,
  [88369] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1125), 1,
      sym_enum_variant_list,
    STATE(3091), 2,
      sym_line_comment,
      sym_block_comment,
  [88386] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5286), 1,
      sym_super,
    ACTIONS(6409), 1,
      sym_identifier,
    STATE(3092), 2,
      sym_line_comment,
      sym_block_comment,
  [88403] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1204), 1,
      sym_declaration_list,
    STATE(3093), 2,
      sym_line_comment,
      sym_block_comment,
  [88420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6411), 1,
      anon_sym_RPAREN,
    ACTIONS(6413), 1,
      anon_sym_COLON_COLON,
    STATE(3094), 2,
      sym_line_comment,
      sym_block_comment,
  [88437] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6415), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3095), 2,
      sym_line_comment,
      sym_block_comment,
  [88452] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(121), 1,
      sym_closure_parameters,
    STATE(3096), 2,
      sym_line_comment,
      sym_block_comment,
  [88469] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 1,
      sym_super,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3097), 2,
      sym_line_comment,
      sym_block_comment,
  [88486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6419), 1,
      anon_sym_RBRACK,
    STATE(3098), 2,
      sym_line_comment,
      sym_block_comment,
  [88503] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6419), 1,
      anon_sym_RPAREN,
    STATE(3099), 2,
      sym_line_comment,
      sym_block_comment,
  [88520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6421), 1,
      anon_sym_RBRACK,
    STATE(3100), 2,
      sym_line_comment,
      sym_block_comment,
  [88537] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5561), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3101), 2,
      sym_line_comment,
      sym_block_comment,
  [88552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6421), 1,
      anon_sym_RPAREN,
    STATE(3102), 2,
      sym_line_comment,
      sym_block_comment,
  [88569] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 1,
      sym_super,
    ACTIONS(6423), 1,
      sym_identifier,
    STATE(3103), 2,
      sym_line_comment,
      sym_block_comment,
  [88586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(2203), 1,
      sym_parameters,
    STATE(3104), 2,
      sym_line_comment,
      sym_block_comment,
  [88603] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(713), 1,
      sym_enum_variant_list,
    STATE(3105), 2,
      sym_line_comment,
      sym_block_comment,
  [88620] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3162), 1,
      anon_sym_LPAREN,
    STATE(1064), 1,
      sym_parameters,
    STATE(3106), 2,
      sym_line_comment,
      sym_block_comment,
  [88637] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5286), 1,
      sym_super,
    ACTIONS(6425), 1,
      sym_identifier,
    STATE(3107), 2,
      sym_line_comment,
      sym_block_comment,
  [88654] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_RBRACK,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3108), 2,
      sym_line_comment,
      sym_block_comment,
  [88671] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(151), 1,
      sym_closure_parameters,
    STATE(3109), 2,
      sym_line_comment,
      sym_block_comment,
  [88688] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6427), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3110), 2,
      sym_line_comment,
      sym_block_comment,
  [88703] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 1,
      sym_super,
    ACTIONS(6429), 1,
      sym_identifier,
    STATE(3111), 2,
      sym_line_comment,
      sym_block_comment,
  [88720] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6431), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3112), 2,
      sym_line_comment,
      sym_block_comment,
  [88735] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5523), 2,
      sym_identifier,
      sym_super,
    STATE(3113), 2,
      sym_line_comment,
      sym_block_comment,
  [88750] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6290), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3114), 2,
      sym_line_comment,
      sym_block_comment,
  [88765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_RBRACE,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3115), 2,
      sym_line_comment,
      sym_block_comment,
  [88782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6343), 1,
      sym_super,
    ACTIONS(6433), 1,
      sym_identifier,
    STATE(3116), 2,
      sym_line_comment,
      sym_block_comment,
  [88799] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(2198), 1,
      sym_parameters,
    STATE(3117), 2,
      sym_line_comment,
      sym_block_comment,
  [88816] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5509), 1,
      sym_identifier,
    STATE(3118), 2,
      sym_line_comment,
      sym_block_comment,
  [88833] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 1,
      sym_super,
    ACTIONS(6435), 1,
      sym_identifier,
    STATE(3119), 2,
      sym_line_comment,
      sym_block_comment,
  [88850] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5286), 1,
      sym_super,
    ACTIONS(6437), 1,
      sym_identifier,
    STATE(3120), 2,
      sym_line_comment,
      sym_block_comment,
  [88867] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6439), 1,
      anon_sym_RPAREN,
    ACTIONS(6441), 1,
      anon_sym_COLON_COLON,
    STATE(3121), 2,
      sym_line_comment,
      sym_block_comment,
  [88884] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 1,
      sym_super,
    ACTIONS(6381), 1,
      sym_identifier,
    STATE(3122), 2,
      sym_line_comment,
      sym_block_comment,
  [88901] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5970), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3123), 2,
      sym_line_comment,
      sym_block_comment,
  [88916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(662), 1,
      sym_declaration_list,
    STATE(3124), 2,
      sym_line_comment,
      sym_block_comment,
  [88933] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4780), 1,
      anon_sym_LBRACE,
    STATE(663), 1,
      sym_declaration_list,
    STATE(3125), 2,
      sym_line_comment,
      sym_block_comment,
  [88950] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5958), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    STATE(3126), 2,
      sym_line_comment,
      sym_block_comment,
  [88965] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6443), 1,
      anon_sym_RPAREN,
    ACTIONS(6445), 1,
      anon_sym_COLON_COLON,
    STATE(3127), 2,
      sym_line_comment,
      sym_block_comment,
  [88982] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5286), 1,
      sym_super,
    ACTIONS(6365), 1,
      sym_identifier,
    STATE(3128), 2,
      sym_line_comment,
      sym_block_comment,
  [88999] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5091), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3129), 2,
      sym_line_comment,
      sym_block_comment,
  [89014] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1215), 1,
      sym_declaration_list,
    STATE(3130), 2,
      sym_line_comment,
      sym_block_comment,
  [89031] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6100), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3131), 2,
      sym_line_comment,
      sym_block_comment,
  [89046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(1951), 1,
      sym_parameters,
    STATE(3132), 2,
      sym_line_comment,
      sym_block_comment,
  [89063] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1094), 1,
      sym_field_declaration_list,
    STATE(3133), 2,
      sym_line_comment,
      sym_block_comment,
  [89080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6447), 1,
      anon_sym_EQ_GT,
    ACTIONS(6449), 1,
      anon_sym_if,
    STATE(3134), 2,
      sym_line_comment,
      sym_block_comment,
  [89097] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6451), 1,
      anon_sym_EQ,
    STATE(3135), 2,
      sym_line_comment,
      sym_block_comment,
  [89114] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6443), 1,
      anon_sym_RPAREN,
    ACTIONS(6453), 1,
      anon_sym_COLON_COLON,
    STATE(3136), 2,
      sym_line_comment,
      sym_block_comment,
  [89131] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1189), 1,
      sym_field_declaration_list,
    STATE(3137), 2,
      sym_line_comment,
      sym_block_comment,
  [89148] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6413), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6443), 1,
      anon_sym_RPAREN,
    STATE(3138), 2,
      sym_line_comment,
      sym_block_comment,
  [89165] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6343), 2,
      sym_identifier,
      sym_super,
    STATE(3139), 2,
      sym_line_comment,
      sym_block_comment,
  [89180] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(124), 1,
      sym_closure_parameters,
    STATE(3140), 2,
      sym_line_comment,
      sym_block_comment,
  [89197] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(2172), 1,
      sym_parameters,
    STATE(3141), 2,
      sym_line_comment,
      sym_block_comment,
  [89214] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3634), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_PLUS,
    STATE(3142), 2,
      sym_line_comment,
      sym_block_comment,
  [89231] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1173), 1,
      sym_enum_variant_list,
    STATE(3143), 2,
      sym_line_comment,
      sym_block_comment,
  [89248] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5077), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3144), 2,
      sym_line_comment,
      sym_block_comment,
  [89263] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3145), 2,
      sym_line_comment,
      sym_block_comment,
  [89278] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6319), 1,
      sym_super,
    ACTIONS(6457), 1,
      sym_identifier,
    STATE(3146), 2,
      sym_line_comment,
      sym_block_comment,
  [89295] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5063), 1,
      anon_sym_RBRACK,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3147), 2,
      sym_line_comment,
      sym_block_comment,
  [89312] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(137), 1,
      sym_closure_parameters,
    STATE(3148), 2,
      sym_line_comment,
      sym_block_comment,
  [89329] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5063), 1,
      anon_sym_RPAREN,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3149), 2,
      sym_line_comment,
      sym_block_comment,
  [89346] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(1940), 1,
      sym_parameters,
    STATE(3150), 2,
      sym_line_comment,
      sym_block_comment,
  [89363] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6074), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3151), 2,
      sym_line_comment,
      sym_block_comment,
  [89378] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5039), 1,
      anon_sym_RBRACK,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3152), 2,
      sym_line_comment,
      sym_block_comment,
  [89395] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6371), 1,
      sym_super,
    ACTIONS(6459), 1,
      sym_identifier,
    STATE(3153), 2,
      sym_line_comment,
      sym_block_comment,
  [89412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3743), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_field_initializer_list,
    STATE(3154), 2,
      sym_line_comment,
      sym_block_comment,
  [89429] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5535), 1,
      sym_identifier,
    STATE(3155), 2,
      sym_line_comment,
      sym_block_comment,
  [89446] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 1,
      sym_super,
    ACTIONS(6461), 1,
      sym_identifier,
    STATE(3156), 2,
      sym_line_comment,
      sym_block_comment,
  [89463] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1246), 1,
      sym_field_declaration_list,
    STATE(3157), 2,
      sym_line_comment,
      sym_block_comment,
  [89480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1160), 1,
      sym_declaration_list,
    STATE(3158), 2,
      sym_line_comment,
      sym_block_comment,
  [89497] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1159), 1,
      sym_declaration_list,
    STATE(3159), 2,
      sym_line_comment,
      sym_block_comment,
  [89514] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5039), 1,
      anon_sym_RPAREN,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3160), 2,
      sym_line_comment,
      sym_block_comment,
  [89531] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(147), 1,
      sym_closure_parameters,
    STATE(3161), 2,
      sym_line_comment,
      sym_block_comment,
  [89548] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1318), 1,
      sym_declaration_list,
    STATE(3162), 2,
      sym_line_comment,
      sym_block_comment,
  [89565] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6186), 1,
      sym_identifier,
    ACTIONS(6190), 1,
      sym_mutable_specifier,
    STATE(3163), 2,
      sym_line_comment,
      sym_block_comment,
  [89582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1233), 1,
      sym_declaration_list,
    STATE(3164), 2,
      sym_line_comment,
      sym_block_comment,
  [89599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1207), 1,
      sym_field_declaration_list,
    STATE(3165), 2,
      sym_line_comment,
      sym_block_comment,
  [89616] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1152), 1,
      sym_declaration_list,
    STATE(3166), 2,
      sym_line_comment,
      sym_block_comment,
  [89633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1361), 1,
      sym_field_declaration_list,
    STATE(3167), 2,
      sym_line_comment,
      sym_block_comment,
  [89650] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(136), 1,
      sym_closure_parameters,
    STATE(3168), 2,
      sym_line_comment,
      sym_block_comment,
  [89667] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(148), 1,
      sym_closure_parameters,
    STATE(3169), 2,
      sym_line_comment,
      sym_block_comment,
  [89684] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_LBRACE,
    STATE(674), 1,
      sym_enum_variant_list,
    STATE(3170), 2,
      sym_line_comment,
      sym_block_comment,
  [89701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4347), 1,
      anon_sym_LPAREN,
    STATE(2189), 1,
      sym_parameters,
    STATE(3171), 2,
      sym_line_comment,
      sym_block_comment,
  [89718] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5547), 1,
      sym_super,
    ACTIONS(6463), 1,
      sym_identifier,
    STATE(3172), 2,
      sym_line_comment,
      sym_block_comment,
  [89735] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4758), 1,
      anon_sym_for,
    STATE(3173), 2,
      sym_line_comment,
      sym_block_comment,
  [89752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 1,
      sym_super,
    ACTIONS(6465), 1,
      sym_identifier,
    STATE(3174), 2,
      sym_line_comment,
      sym_block_comment,
  [89769] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(149), 1,
      sym_closure_parameters,
    STATE(3175), 2,
      sym_line_comment,
      sym_block_comment,
  [89786] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5924), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3176), 2,
      sym_line_comment,
      sym_block_comment,
  [89801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4351), 1,
      anon_sym_BANG,
    ACTIONS(6467), 1,
      anon_sym_COLON_COLON,
    STATE(3177), 2,
      sym_line_comment,
      sym_block_comment,
  [89818] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6343), 1,
      sym_super,
    ACTIONS(6469), 1,
      sym_identifier,
    STATE(3178), 2,
      sym_line_comment,
      sym_block_comment,
  [89835] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6471), 1,
      sym_identifier,
    ACTIONS(6473), 1,
      sym_mutable_specifier,
    STATE(3179), 2,
      sym_line_comment,
      sym_block_comment,
  [89852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5521), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      sym_super,
    STATE(3180), 2,
      sym_line_comment,
      sym_block_comment,
  [89869] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6373), 1,
      sym_super,
    ACTIONS(6475), 1,
      sym_identifier,
    STATE(3181), 2,
      sym_line_comment,
      sym_block_comment,
  [89886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6339), 1,
      anon_sym_LT,
    STATE(1486), 1,
      sym_type_parameters,
    STATE(3182), 2,
      sym_line_comment,
      sym_block_comment,
  [89903] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1228), 1,
      sym_enum_variant_list,
    STATE(3183), 2,
      sym_line_comment,
      sym_block_comment,
  [89920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6441), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6477), 1,
      anon_sym_RPAREN,
    STATE(3184), 2,
      sym_line_comment,
      sym_block_comment,
  [89937] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6479), 1,
      anon_sym_RBRACE,
    STATE(3185), 2,
      sym_line_comment,
      sym_block_comment,
  [89954] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6481), 1,
      anon_sym_RBRACK,
    STATE(3186), 2,
      sym_line_comment,
      sym_block_comment,
  [89971] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6481), 1,
      anon_sym_RPAREN,
    STATE(3187), 2,
      sym_line_comment,
      sym_block_comment,
  [89988] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6343), 1,
      sym_super,
    ACTIONS(6409), 1,
      sym_identifier,
    STATE(3188), 2,
      sym_line_comment,
      sym_block_comment,
  [90005] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_LBRACE,
    STATE(1411), 1,
      sym_declaration_list,
    STATE(3189), 2,
      sym_line_comment,
      sym_block_comment,
  [90022] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(690), 1,
      sym_field_declaration_list,
    STATE(3190), 2,
      sym_line_comment,
      sym_block_comment,
  [90039] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6483), 1,
      anon_sym_RBRACE,
    STATE(3191), 2,
      sym_line_comment,
      sym_block_comment,
  [90056] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6485), 1,
      anon_sym_EQ,
    STATE(3192), 2,
      sym_line_comment,
      sym_block_comment,
  [90073] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6487), 1,
      anon_sym_RBRACK,
    STATE(3193), 2,
      sym_line_comment,
      sym_block_comment,
  [90090] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(153), 1,
      sym_closure_parameters,
    STATE(3194), 2,
      sym_line_comment,
      sym_block_comment,
  [90107] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6487), 1,
      anon_sym_RPAREN,
    STATE(3195), 2,
      sym_line_comment,
      sym_block_comment,
  [90124] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5159), 1,
      anon_sym_LBRACE,
    STATE(1277), 1,
      sym_enum_variant_list,
    STATE(3196), 2,
      sym_line_comment,
      sym_block_comment,
  [90141] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6489), 1,
      anon_sym_in,
    STATE(3197), 2,
      sym_line_comment,
      sym_block_comment,
  [90158] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6337), 1,
      sym_super,
    ACTIONS(6491), 1,
      sym_identifier,
    STATE(3198), 2,
      sym_line_comment,
      sym_block_comment,
  [90175] = 5,
    ACTIONS(33), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(152), 1,
      sym_closure_parameters,
    STATE(3199), 2,
      sym_line_comment,
      sym_block_comment,
  [90192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1184), 1,
      sym_field_declaration_list,
    STATE(3200), 2,
      sym_line_comment,
      sym_block_comment,
  [90209] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6343), 1,
      sym_super,
    ACTIONS(6493), 1,
      sym_identifier,
    STATE(3201), 2,
      sym_line_comment,
      sym_block_comment,
  [90226] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3546), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_PLUS,
    STATE(3202), 2,
      sym_line_comment,
      sym_block_comment,
  [90243] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5509), 1,
      sym_identifier,
    STATE(3203), 2,
      sym_line_comment,
      sym_block_comment,
  [90260] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6347), 1,
      sym_super,
    ACTIONS(6435), 1,
      sym_identifier,
    STATE(3204), 2,
      sym_line_comment,
      sym_block_comment,
  [90277] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3542), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_PLUS,
    STATE(3205), 2,
      sym_line_comment,
      sym_block_comment,
  [90294] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2924), 1,
      anon_sym_SQUOTE,
    STATE(2814), 1,
      sym_lifetime,
    STATE(3206), 2,
      sym_line_comment,
      sym_block_comment,
  [90311] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4518), 1,
      anon_sym_BANG,
    ACTIONS(4532), 1,
      anon_sym_COLON_COLON,
    STATE(3207), 2,
      sym_line_comment,
      sym_block_comment,
  [90328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6008), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3208), 2,
      sym_line_comment,
      sym_block_comment,
  [90343] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(684), 1,
      sym_field_declaration_list,
    STATE(3209), 2,
      sym_line_comment,
      sym_block_comment,
  [90360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6299), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      sym_super,
    STATE(3210), 2,
      sym_line_comment,
      sym_block_comment,
  [90377] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6301), 1,
      sym_identifier,
    ACTIONS(6343), 1,
      sym_super,
    STATE(3211), 2,
      sym_line_comment,
      sym_block_comment,
  [90394] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4839), 1,
      anon_sym_PLUS,
    ACTIONS(6495), 1,
      anon_sym_GT,
    STATE(3212), 2,
      sym_line_comment,
      sym_block_comment,
  [90411] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5507), 1,
      sym_identifier,
    STATE(3213), 2,
      sym_line_comment,
      sym_block_comment,
  [90428] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 1,
      sym_super,
    ACTIONS(6497), 1,
      sym_identifier,
    STATE(3214), 2,
      sym_line_comment,
      sym_block_comment,
  [90445] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5286), 2,
      sym_identifier,
      sym_super,
    STATE(3215), 2,
      sym_line_comment,
      sym_block_comment,
  [90460] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
    STATE(1379), 1,
      sym_field_declaration_list,
    STATE(3216), 2,
      sym_line_comment,
      sym_block_comment,
  [90477] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5505), 1,
      sym_identifier,
    STATE(3217), 2,
      sym_line_comment,
      sym_block_comment,
  [90494] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 1,
      sym_super,
    ACTIONS(6499), 1,
      sym_identifier,
    STATE(3218), 2,
      sym_line_comment,
      sym_block_comment,
  [90511] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3472), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_PLUS,
    STATE(3219), 2,
      sym_line_comment,
      sym_block_comment,
  [90528] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6339), 1,
      anon_sym_LT,
    STATE(1501), 1,
      sym_type_parameters,
    STATE(3220), 2,
      sym_line_comment,
      sym_block_comment,
  [90545] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5466), 1,
      sym_super,
    ACTIONS(5503), 1,
      sym_identifier,
    STATE(3221), 2,
      sym_line_comment,
      sym_block_comment,
  [90562] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6353), 1,
      sym_super,
    ACTIONS(6501), 1,
      sym_identifier,
    STATE(3222), 2,
      sym_line_comment,
      sym_block_comment,
  [90579] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6411), 1,
      anon_sym_RPAREN,
    ACTIONS(6453), 1,
      anon_sym_COLON_COLON,
    STATE(3223), 2,
      sym_line_comment,
      sym_block_comment,
  [90596] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6503), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3224), 2,
      sym_line_comment,
      sym_block_comment,
  [90611] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 1,
      sym_super,
    ACTIONS(5503), 1,
      sym_identifier,
    STATE(3225), 2,
      sym_line_comment,
      sym_block_comment,
  [90628] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6347), 1,
      sym_super,
    ACTIONS(6501), 1,
      sym_identifier,
    STATE(3226), 2,
      sym_line_comment,
      sym_block_comment,
  [90645] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4977), 1,
      anon_sym_RPAREN,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3227), 2,
      sym_line_comment,
      sym_block_comment,
  [90662] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(5266), 1,
      anon_sym_COLON,
    STATE(3228), 2,
      sym_line_comment,
      sym_block_comment,
  [90679] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6505), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6507), 1,
      anon_sym_BANG,
    STATE(3229), 2,
      sym_line_comment,
      sym_block_comment,
  [90696] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 1,
      anon_sym_SEMI,
    ACTIONS(6511), 1,
      anon_sym_as,
    STATE(3230), 2,
      sym_line_comment,
      sym_block_comment,
  [90713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6411), 1,
      anon_sym_RPAREN,
    ACTIONS(6445), 1,
      anon_sym_COLON_COLON,
    STATE(3231), 2,
      sym_line_comment,
      sym_block_comment,
  [90730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(6513), 1,
      anon_sym_in,
    STATE(3232), 2,
      sym_line_comment,
      sym_block_comment,
  [90747] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6515), 1,
      anon_sym_RBRACE,
    STATE(3233), 2,
      sym_line_comment,
      sym_block_comment,
  [90764] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5460), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3234), 2,
      sym_line_comment,
      sym_block_comment,
  [90779] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(700), 1,
      sym_field_declaration_list,
    STATE(3235), 2,
      sym_line_comment,
      sym_block_comment,
  [90796] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6517), 1,
      anon_sym_SEMI,
    ACTIONS(6519), 1,
      anon_sym_as,
    STATE(3236), 2,
      sym_line_comment,
      sym_block_comment,
  [90813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4715), 1,
      anon_sym_LBRACE,
    STATE(725), 1,
      sym_field_declaration_list,
    STATE(3237), 2,
      sym_line_comment,
      sym_block_comment,
  [90830] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    ACTIONS(6521), 1,
      anon_sym_RBRACE,
    STATE(3238), 2,
      sym_line_comment,
      sym_block_comment,
  [90847] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4929), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_PLUS,
    STATE(3239), 2,
      sym_line_comment,
      sym_block_comment,
  [90864] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5672), 1,
      anon_sym_RBRACK,
    STATE(3240), 2,
      sym_line_comment,
      sym_block_comment,
  [90878] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4417), 1,
      anon_sym_fn,
    STATE(3241), 2,
      sym_line_comment,
      sym_block_comment,
  [90892] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3941), 1,
      anon_sym_COLON_COLON,
    STATE(3242), 2,
      sym_line_comment,
      sym_block_comment,
  [90906] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6521), 1,
      anon_sym_SEMI,
    STATE(3243), 2,
      sym_line_comment,
      sym_block_comment,
  [90920] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4476), 1,
      anon_sym_COLON_COLON,
    STATE(3244), 2,
      sym_line_comment,
      sym_block_comment,
  [90934] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      anon_sym_SEMI,
    STATE(3245), 2,
      sym_line_comment,
      sym_block_comment,
  [90948] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4439), 1,
      anon_sym_COLON_COLON,
    STATE(3246), 2,
      sym_line_comment,
      sym_block_comment,
  [90962] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6523), 1,
      anon_sym_LPAREN,
    STATE(3247), 2,
      sym_line_comment,
      sym_block_comment,
  [90976] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6525), 1,
      anon_sym_COLON_COLON,
    STATE(3248), 2,
      sym_line_comment,
      sym_block_comment,
  [90990] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6527), 1,
      sym_identifier,
    STATE(3249), 2,
      sym_line_comment,
      sym_block_comment,
  [91004] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5854), 1,
      anon_sym_RBRACE,
    STATE(3250), 2,
      sym_line_comment,
      sym_block_comment,
  [91018] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6529), 1,
      sym_identifier,
    STATE(3251), 2,
      sym_line_comment,
      sym_block_comment,
  [91032] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6531), 1,
      sym_identifier,
    STATE(3252), 2,
      sym_line_comment,
      sym_block_comment,
  [91046] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5081), 1,
      anon_sym_COLON_COLON,
    STATE(3253), 2,
      sym_line_comment,
      sym_block_comment,
  [91060] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6533), 1,
      anon_sym_fn,
    STATE(3254), 2,
      sym_line_comment,
      sym_block_comment,
  [91074] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 1,
      anon_sym_COLON,
    STATE(3255), 2,
      sym_line_comment,
      sym_block_comment,
  [91088] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6537), 1,
      anon_sym_COLON_COLON,
    STATE(3256), 2,
      sym_line_comment,
      sym_block_comment,
  [91102] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6539), 1,
      anon_sym_COLON,
    STATE(3257), 2,
      sym_line_comment,
      sym_block_comment,
  [91116] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      sym_identifier,
    STATE(3258), 2,
      sym_line_comment,
      sym_block_comment,
  [91130] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6543), 1,
      anon_sym_EQ,
    STATE(3259), 2,
      sym_line_comment,
      sym_block_comment,
  [91144] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6545), 1,
      anon_sym_COLON,
    STATE(3260), 2,
      sym_line_comment,
      sym_block_comment,
  [91158] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6547), 1,
      sym_identifier,
    STATE(3261), 2,
      sym_line_comment,
      sym_block_comment,
  [91172] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5222), 1,
      anon_sym_RPAREN,
    STATE(3262), 2,
      sym_line_comment,
      sym_block_comment,
  [91186] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6549), 1,
      anon_sym_RPAREN,
    STATE(3263), 2,
      sym_line_comment,
      sym_block_comment,
  [91200] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1476), 1,
      anon_sym_EQ_GT,
    STATE(3264), 2,
      sym_line_comment,
      sym_block_comment,
  [91214] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3420), 1,
      anon_sym_COLON_COLON,
    STATE(3265), 2,
      sym_line_comment,
      sym_block_comment,
  [91228] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6551), 1,
      anon_sym_SEMI,
    STATE(3266), 2,
      sym_line_comment,
      sym_block_comment,
  [91242] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 1,
      anon_sym_SEMI,
    STATE(3267), 2,
      sym_line_comment,
      sym_block_comment,
  [91256] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      sym_identifier,
    STATE(3268), 2,
      sym_line_comment,
      sym_block_comment,
  [91270] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6557), 1,
      anon_sym_COLON_COLON,
    STATE(3269), 2,
      sym_line_comment,
      sym_block_comment,
  [91284] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6559), 1,
      sym_identifier,
    STATE(3270), 2,
      sym_line_comment,
      sym_block_comment,
  [91298] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6561), 1,
      sym_identifier,
    STATE(3271), 2,
      sym_line_comment,
      sym_block_comment,
  [91312] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      sym_identifier,
    STATE(3272), 2,
      sym_line_comment,
      sym_block_comment,
  [91326] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6565), 1,
      sym_identifier,
    STATE(3273), 2,
      sym_line_comment,
      sym_block_comment,
  [91340] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6567), 1,
      sym_identifier,
    STATE(3274), 2,
      sym_line_comment,
      sym_block_comment,
  [91354] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6569), 1,
      sym_identifier,
    STATE(3275), 2,
      sym_line_comment,
      sym_block_comment,
  [91368] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4694), 1,
      anon_sym_COLON_COLON,
    STATE(3276), 2,
      sym_line_comment,
      sym_block_comment,
  [91382] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6571), 1,
      anon_sym_SEMI,
    STATE(3277), 2,
      sym_line_comment,
      sym_block_comment,
  [91396] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6573), 1,
      anon_sym_RBRACK,
    STATE(3278), 2,
      sym_line_comment,
      sym_block_comment,
  [91410] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_EQ_GT,
    STATE(3279), 2,
      sym_line_comment,
      sym_block_comment,
  [91424] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6577), 1,
      anon_sym_EQ_GT,
    STATE(3280), 2,
      sym_line_comment,
      sym_block_comment,
  [91438] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6579), 1,
      anon_sym_EQ_GT,
    STATE(3281), 2,
      sym_line_comment,
      sym_block_comment,
  [91452] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6483), 1,
      anon_sym_SEMI,
    STATE(3282), 2,
      sym_line_comment,
      sym_block_comment,
  [91466] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6581), 1,
      sym_identifier,
    STATE(3283), 2,
      sym_line_comment,
      sym_block_comment,
  [91480] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6583), 1,
      anon_sym_RPAREN,
    STATE(3284), 2,
      sym_line_comment,
      sym_block_comment,
  [91494] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6585), 1,
      anon_sym_COLON,
    STATE(3285), 2,
      sym_line_comment,
      sym_block_comment,
  [91508] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3524), 1,
      anon_sym_COLON_COLON,
    STATE(3286), 2,
      sym_line_comment,
      sym_block_comment,
  [91522] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5264), 1,
      anon_sym_RPAREN,
    STATE(3287), 2,
      sym_line_comment,
      sym_block_comment,
  [91536] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6479), 1,
      anon_sym_SEMI,
    STATE(3288), 2,
      sym_line_comment,
      sym_block_comment,
  [91550] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6587), 1,
      anon_sym_COLON_COLON,
    STATE(3289), 2,
      sym_line_comment,
      sym_block_comment,
  [91564] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      anon_sym_fn,
    STATE(3290), 2,
      sym_line_comment,
      sym_block_comment,
  [91578] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5477), 1,
      anon_sym_LBRACE,
    STATE(3291), 2,
      sym_line_comment,
      sym_block_comment,
  [91592] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5952), 1,
      anon_sym_RBRACE,
    STATE(3292), 2,
      sym_line_comment,
      sym_block_comment,
  [91606] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6591), 1,
      sym_identifier,
    STATE(3293), 2,
      sym_line_comment,
      sym_block_comment,
  [91620] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6593), 1,
      anon_sym_SEMI,
    STATE(3294), 2,
      sym_line_comment,
      sym_block_comment,
  [91634] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6595), 1,
      anon_sym_COLON_COLON,
    STATE(3295), 2,
      sym_line_comment,
      sym_block_comment,
  [91648] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6597), 1,
      anon_sym_RBRACE,
    STATE(3296), 2,
      sym_line_comment,
      sym_block_comment,
  [91662] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6599), 1,
      sym_identifier,
    STATE(3297), 2,
      sym_line_comment,
      sym_block_comment,
  [91676] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6601), 1,
      anon_sym_SEMI,
    STATE(3298), 2,
      sym_line_comment,
      sym_block_comment,
  [91690] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3074), 1,
      anon_sym_PLUS,
    STATE(3299), 2,
      sym_line_comment,
      sym_block_comment,
  [91704] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6603), 1,
      anon_sym_RBRACK,
    STATE(3300), 2,
      sym_line_comment,
      sym_block_comment,
  [91718] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6605), 1,
      anon_sym_SEMI,
    STATE(3301), 2,
      sym_line_comment,
      sym_block_comment,
  [91732] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5916), 1,
      anon_sym_GT,
    STATE(3302), 2,
      sym_line_comment,
      sym_block_comment,
  [91746] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6607), 1,
      anon_sym_SEMI,
    STATE(3303), 2,
      sym_line_comment,
      sym_block_comment,
  [91760] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6609), 1,
      anon_sym_fn,
    STATE(3304), 2,
      sym_line_comment,
      sym_block_comment,
  [91774] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6611), 1,
      anon_sym_SEMI,
    STATE(3305), 2,
      sym_line_comment,
      sym_block_comment,
  [91788] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6613), 1,
      anon_sym_RBRACK,
    STATE(3306), 2,
      sym_line_comment,
      sym_block_comment,
  [91802] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6615), 1,
      sym_identifier,
    STATE(3307), 2,
      sym_line_comment,
      sym_block_comment,
  [91816] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6617), 1,
      sym_identifier,
    STATE(3308), 2,
      sym_line_comment,
      sym_block_comment,
  [91830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3963), 1,
      anon_sym_COLON_COLON,
    STATE(3309), 2,
      sym_line_comment,
      sym_block_comment,
  [91844] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5678), 1,
      anon_sym_RPAREN,
    STATE(3310), 2,
      sym_line_comment,
      sym_block_comment,
  [91858] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6619), 1,
      sym_identifier,
    STATE(3311), 2,
      sym_line_comment,
      sym_block_comment,
  [91872] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6621), 1,
      anon_sym_COLON,
    STATE(3312), 2,
      sym_line_comment,
      sym_block_comment,
  [91886] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      anon_sym_SEMI,
    STATE(3313), 2,
      sym_line_comment,
      sym_block_comment,
  [91900] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6625), 1,
      anon_sym_SEMI,
    STATE(3314), 2,
      sym_line_comment,
      sym_block_comment,
  [91914] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6627), 1,
      anon_sym_RBRACK,
    STATE(3315), 2,
      sym_line_comment,
      sym_block_comment,
  [91928] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5906), 1,
      anon_sym_RBRACE,
    STATE(3316), 2,
      sym_line_comment,
      sym_block_comment,
  [91942] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6629), 1,
      sym_self,
    STATE(3317), 2,
      sym_line_comment,
      sym_block_comment,
  [91956] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6631), 1,
      anon_sym_SEMI,
    STATE(3318), 2,
      sym_line_comment,
      sym_block_comment,
  [91970] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6633), 1,
      sym_identifier,
    STATE(3319), 2,
      sym_line_comment,
      sym_block_comment,
  [91984] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_RBRACK,
    STATE(3320), 2,
      sym_line_comment,
      sym_block_comment,
  [91998] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6635), 1,
      anon_sym_SEMI,
    STATE(3321), 2,
      sym_line_comment,
      sym_block_comment,
  [92012] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6637), 1,
      sym_identifier,
    STATE(3322), 2,
      sym_line_comment,
      sym_block_comment,
  [92026] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6639), 1,
      anon_sym_SEMI,
    STATE(3323), 2,
      sym_line_comment,
      sym_block_comment,
  [92040] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6641), 1,
      anon_sym_LT,
    STATE(3324), 2,
      sym_line_comment,
      sym_block_comment,
  [92054] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6643), 1,
      anon_sym_SEMI,
    STATE(3325), 2,
      sym_line_comment,
      sym_block_comment,
  [92068] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6645), 1,
      anon_sym_RBRACE,
    STATE(3326), 2,
      sym_line_comment,
      sym_block_comment,
  [92082] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6647), 1,
      anon_sym_RBRACE,
    STATE(3327), 2,
      sym_line_comment,
      sym_block_comment,
  [92096] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6649), 1,
      anon_sym_EQ_GT,
    STATE(3328), 2,
      sym_line_comment,
      sym_block_comment,
  [92110] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6651), 1,
      sym_identifier,
    STATE(3329), 2,
      sym_line_comment,
      sym_block_comment,
  [92124] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6653), 1,
      anon_sym_RPAREN,
    STATE(3330), 2,
      sym_line_comment,
      sym_block_comment,
  [92138] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6655), 1,
      anon_sym_SEMI,
    STATE(3331), 2,
      sym_line_comment,
      sym_block_comment,
  [92152] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(3332), 2,
      sym_line_comment,
      sym_block_comment,
  [92166] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6659), 1,
      anon_sym_RBRACE,
    STATE(3333), 2,
      sym_line_comment,
      sym_block_comment,
  [92180] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6661), 1,
      anon_sym_RBRACK,
    STATE(3334), 2,
      sym_line_comment,
      sym_block_comment,
  [92194] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6663), 1,
      anon_sym_LBRACK,
    STATE(3335), 2,
      sym_line_comment,
      sym_block_comment,
  [92208] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6665), 1,
      anon_sym_RBRACE,
    STATE(3336), 2,
      sym_line_comment,
      sym_block_comment,
  [92222] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6667), 1,
      anon_sym_RBRACE,
    STATE(3337), 2,
      sym_line_comment,
      sym_block_comment,
  [92236] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6669), 1,
      anon_sym_COLON,
    STATE(3338), 2,
      sym_line_comment,
      sym_block_comment,
  [92250] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6671), 1,
      sym_identifier,
    STATE(3339), 2,
      sym_line_comment,
      sym_block_comment,
  [92264] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      anon_sym_RPAREN,
    STATE(3340), 2,
      sym_line_comment,
      sym_block_comment,
  [92278] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6673), 1,
      anon_sym_SEMI,
    STATE(3341), 2,
      sym_line_comment,
      sym_block_comment,
  [92292] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(652), 1,
      anon_sym_RBRACK,
    STATE(3342), 2,
      sym_line_comment,
      sym_block_comment,
  [92306] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5880), 1,
      anon_sym_RBRACE,
    STATE(3343), 2,
      sym_line_comment,
      sym_block_comment,
  [92320] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6675), 1,
      sym_identifier,
    STATE(3344), 2,
      sym_line_comment,
      sym_block_comment,
  [92334] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 1,
      anon_sym_SEMI,
    STATE(3345), 2,
      sym_line_comment,
      sym_block_comment,
  [92348] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6679), 1,
      anon_sym_SEMI,
    STATE(3346), 2,
      sym_line_comment,
      sym_block_comment,
  [92362] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3046), 1,
      anon_sym_PLUS,
    STATE(3347), 2,
      sym_line_comment,
      sym_block_comment,
  [92376] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6681), 1,
      anon_sym_LPAREN,
    STATE(3348), 2,
      sym_line_comment,
      sym_block_comment,
  [92390] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6125), 1,
      anon_sym_RBRACE,
    STATE(3349), 2,
      sym_line_comment,
      sym_block_comment,
  [92404] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5599), 1,
      anon_sym_LBRACE,
    STATE(3350), 2,
      sym_line_comment,
      sym_block_comment,
  [92418] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6683), 1,
      sym_identifier,
    STATE(3351), 2,
      sym_line_comment,
      sym_block_comment,
  [92432] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6685), 1,
      sym_identifier,
    STATE(3352), 2,
      sym_line_comment,
      sym_block_comment,
  [92446] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6687), 1,
      sym_identifier,
    STATE(3353), 2,
      sym_line_comment,
      sym_block_comment,
  [92460] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6689), 1,
      anon_sym_COLON,
    STATE(3354), 2,
      sym_line_comment,
      sym_block_comment,
  [92474] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6691), 1,
      sym_identifier,
    STATE(3355), 2,
      sym_line_comment,
      sym_block_comment,
  [92488] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6693), 1,
      anon_sym_LBRACK,
    STATE(3356), 2,
      sym_line_comment,
      sym_block_comment,
  [92502] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6695), 1,
      anon_sym_RBRACK,
    STATE(3357), 2,
      sym_line_comment,
      sym_block_comment,
  [92516] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6697), 1,
      anon_sym_RPAREN,
    STATE(3358), 2,
      sym_line_comment,
      sym_block_comment,
  [92530] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6699), 1,
      anon_sym_STAR_SLASH,
    STATE(3359), 2,
      sym_line_comment,
      sym_block_comment,
  [92544] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    STATE(3360), 2,
      sym_line_comment,
      sym_block_comment,
  [92558] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6703), 1,
      anon_sym_STAR_SLASH,
    STATE(3361), 2,
      sym_line_comment,
      sym_block_comment,
  [92572] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6705), 1,
      anon_sym_STAR_SLASH,
    STATE(3362), 2,
      sym_line_comment,
      sym_block_comment,
  [92586] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6707), 1,
      aux_sym_line_comment_token2,
    STATE(3363), 2,
      sym_line_comment,
      sym_block_comment,
  [92600] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    STATE(3364), 2,
      sym_line_comment,
      sym_block_comment,
  [92614] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6711), 1,
      sym_identifier,
    STATE(3365), 2,
      sym_line_comment,
      sym_block_comment,
  [92628] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6713), 1,
      aux_sym_line_comment_token2,
    STATE(3366), 2,
      sym_line_comment,
      sym_block_comment,
  [92642] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6715), 1,
      anon_sym_RPAREN,
    STATE(3367), 2,
      sym_line_comment,
      sym_block_comment,
  [92656] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6717), 1,
      aux_sym_line_comment_token2,
    STATE(3368), 2,
      sym_line_comment,
      sym_block_comment,
  [92670] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6719), 1,
      anon_sym_RPAREN,
    STATE(3369), 2,
      sym_line_comment,
      sym_block_comment,
  [92684] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5818), 1,
      anon_sym_RBRACE,
    STATE(3370), 2,
      sym_line_comment,
      sym_block_comment,
  [92698] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6721), 1,
      anon_sym_SEMI,
    STATE(3371), 2,
      sym_line_comment,
      sym_block_comment,
  [92712] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6723), 1,
      aux_sym_line_comment_token2,
    STATE(3372), 2,
      sym_line_comment,
      sym_block_comment,
  [92726] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6725), 1,
      anon_sym_SEMI,
    STATE(3373), 2,
      sym_line_comment,
      sym_block_comment,
  [92740] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6727), 1,
      anon_sym_COLON,
    STATE(3374), 2,
      sym_line_comment,
      sym_block_comment,
  [92754] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6729), 1,
      anon_sym_RBRACE,
    STATE(3375), 2,
      sym_line_comment,
      sym_block_comment,
  [92768] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6731), 1,
      anon_sym_RBRACK,
    STATE(3376), 2,
      sym_line_comment,
      sym_block_comment,
  [92782] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6733), 1,
      anon_sym_SEMI,
    STATE(3377), 2,
      sym_line_comment,
      sym_block_comment,
  [92796] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5830), 1,
      anon_sym_RBRACE,
    STATE(3378), 2,
      sym_line_comment,
      sym_block_comment,
  [92810] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      anon_sym_COLON_COLON,
    STATE(3379), 2,
      sym_line_comment,
      sym_block_comment,
  [92824] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5822), 1,
      anon_sym_RBRACE,
    STATE(3380), 2,
      sym_line_comment,
      sym_block_comment,
  [92838] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6735), 1,
      anon_sym_SEMI,
    STATE(3381), 2,
      sym_line_comment,
      sym_block_comment,
  [92852] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5698), 1,
      anon_sym_RPAREN,
    STATE(3382), 2,
      sym_line_comment,
      sym_block_comment,
  [92866] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6737), 1,
      sym_identifier,
    STATE(3383), 2,
      sym_line_comment,
      sym_block_comment,
  [92880] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6739), 1,
      ts_builtin_sym_end,
    STATE(3384), 2,
      sym_line_comment,
      sym_block_comment,
  [92894] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6741), 1,
      sym_identifier,
    STATE(3385), 2,
      sym_line_comment,
      sym_block_comment,
  [92908] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3885), 1,
      anon_sym_COLON_COLON,
    STATE(3386), 2,
      sym_line_comment,
      sym_block_comment,
  [92922] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6743), 1,
      anon_sym_COLON_COLON,
    STATE(3387), 2,
      sym_line_comment,
      sym_block_comment,
  [92936] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3710), 1,
      anon_sym_COLON_COLON,
    STATE(3388), 2,
      sym_line_comment,
      sym_block_comment,
  [92950] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4540), 1,
      anon_sym_COLON_COLON,
    STATE(3389), 2,
      sym_line_comment,
      sym_block_comment,
  [92964] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6745), 1,
      anon_sym_SEMI,
    STATE(3390), 2,
      sym_line_comment,
      sym_block_comment,
  [92978] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6747), 1,
      anon_sym_COLON_COLON,
    STATE(3391), 2,
      sym_line_comment,
      sym_block_comment,
  [92992] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6749), 1,
      anon_sym_fn,
    STATE(3392), 2,
      sym_line_comment,
      sym_block_comment,
  [93006] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(3393), 2,
      sym_line_comment,
      sym_block_comment,
  [93020] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6751), 1,
      anon_sym_COLON_COLON,
    STATE(3394), 2,
      sym_line_comment,
      sym_block_comment,
  [93034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6753), 1,
      anon_sym_SEMI,
    STATE(3395), 2,
      sym_line_comment,
      sym_block_comment,
  [93048] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3961), 1,
      sym_identifier,
    STATE(3396), 2,
      sym_line_comment,
      sym_block_comment,
  [93062] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5720), 1,
      anon_sym_RBRACE,
    STATE(3397), 2,
      sym_line_comment,
      sym_block_comment,
  [93076] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6755), 1,
      anon_sym_SEMI,
    STATE(3398), 2,
      sym_line_comment,
      sym_block_comment,
  [93090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6757), 1,
      anon_sym_COLON_COLON,
    STATE(3399), 2,
      sym_line_comment,
      sym_block_comment,
  [93104] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4983), 1,
      anon_sym_SEMI,
    STATE(3400), 2,
      sym_line_comment,
      sym_block_comment,
  [93118] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5350), 1,
      anon_sym_RPAREN,
    STATE(3401), 2,
      sym_line_comment,
      sym_block_comment,
  [93132] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6759), 1,
      anon_sym_SEMI,
    STATE(3402), 2,
      sym_line_comment,
      sym_block_comment,
  [93146] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6761), 1,
      anon_sym_COLON_COLON,
    STATE(3403), 2,
      sym_line_comment,
      sym_block_comment,
  [93160] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6763), 1,
      anon_sym_fn,
    STATE(3404), 2,
      sym_line_comment,
      sym_block_comment,
  [93174] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6765), 1,
      anon_sym_LBRACE,
    STATE(3405), 2,
      sym_line_comment,
      sym_block_comment,
  [93188] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6303), 1,
      anon_sym_SEMI,
    STATE(3406), 2,
      sym_line_comment,
      sym_block_comment,
  [93202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6767), 1,
      sym_identifier,
    STATE(3407), 2,
      sym_line_comment,
      sym_block_comment,
  [93216] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6769), 1,
      anon_sym_SEMI,
    STATE(3408), 2,
      sym_line_comment,
      sym_block_comment,
  [93230] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6771), 1,
      anon_sym_SEMI,
    STATE(3409), 2,
      sym_line_comment,
      sym_block_comment,
  [93244] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6773), 1,
      sym_identifier,
    STATE(3410), 2,
      sym_line_comment,
      sym_block_comment,
  [93258] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5631), 1,
      anon_sym_RBRACK,
    STATE(3411), 2,
      sym_line_comment,
      sym_block_comment,
  [93272] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6775), 1,
      sym_identifier,
    STATE(3412), 2,
      sym_line_comment,
      sym_block_comment,
  [93286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    STATE(3413), 2,
      sym_line_comment,
      sym_block_comment,
  [93300] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6779), 1,
      sym_identifier,
    STATE(3414), 2,
      sym_line_comment,
      sym_block_comment,
  [93314] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6781), 1,
      anon_sym_EQ_GT,
    STATE(3415), 2,
      sym_line_comment,
      sym_block_comment,
  [93328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6783), 1,
      sym_identifier,
    STATE(3416), 2,
      sym_line_comment,
      sym_block_comment,
  [93342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5515), 1,
      anon_sym_COLON_COLON,
    STATE(3417), 2,
      sym_line_comment,
      sym_block_comment,
  [93356] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6785), 1,
      sym_identifier,
    STATE(3418), 2,
      sym_line_comment,
      sym_block_comment,
  [93370] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3288), 1,
      anon_sym_COLON_COLON,
    STATE(3419), 2,
      sym_line_comment,
      sym_block_comment,
  [93384] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6787), 1,
      anon_sym_COLON_COLON,
    STATE(3420), 2,
      sym_line_comment,
      sym_block_comment,
  [93398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6789), 1,
      anon_sym_SEMI,
    STATE(3421), 2,
      sym_line_comment,
      sym_block_comment,
  [93412] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6791), 1,
      anon_sym_COLON,
    STATE(3422), 2,
      sym_line_comment,
      sym_block_comment,
  [93426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6793), 1,
      anon_sym_SEMI,
    STATE(3423), 2,
      sym_line_comment,
      sym_block_comment,
  [93440] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6795), 1,
      anon_sym_COLON_COLON,
    STATE(3424), 2,
      sym_line_comment,
      sym_block_comment,
  [93454] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6797), 1,
      anon_sym_LBRACE,
    STATE(3425), 2,
      sym_line_comment,
      sym_block_comment,
  [93468] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6799), 1,
      sym_identifier,
    STATE(3426), 2,
      sym_line_comment,
      sym_block_comment,
  [93482] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5238), 1,
      anon_sym_RPAREN,
    STATE(3427), 2,
      sym_line_comment,
      sym_block_comment,
  [93496] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6801), 1,
      anon_sym_SEMI,
    STATE(3428), 2,
      sym_line_comment,
      sym_block_comment,
  [93510] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6803), 1,
      sym_identifier,
    STATE(3429), 2,
      sym_line_comment,
      sym_block_comment,
  [93524] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6805), 1,
      sym_identifier,
    STATE(3430), 2,
      sym_line_comment,
      sym_block_comment,
  [93538] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5015), 1,
      anon_sym_COLON_COLON,
    STATE(3431), 2,
      sym_line_comment,
      sym_block_comment,
  [93552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6807), 1,
      anon_sym_COLON_COLON,
    STATE(3432), 2,
      sym_line_comment,
      sym_block_comment,
  [93566] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6809), 1,
      anon_sym_LBRACE,
    STATE(3433), 2,
      sym_line_comment,
      sym_block_comment,
  [93580] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5563), 1,
      anon_sym_COLON_COLON,
    STATE(3434), 2,
      sym_line_comment,
      sym_block_comment,
  [93594] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6811), 1,
      anon_sym_COLON_COLON,
    STATE(3435), 2,
      sym_line_comment,
      sym_block_comment,
  [93608] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5438), 1,
      anon_sym_LBRACE,
    STATE(3436), 2,
      sym_line_comment,
      sym_block_comment,
  [93622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6813), 1,
      anon_sym_COLON_COLON,
    STATE(3437), 2,
      sym_line_comment,
      sym_block_comment,
  [93636] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6815), 1,
      anon_sym_COLON_COLON,
    STATE(3438), 2,
      sym_line_comment,
      sym_block_comment,
  [93650] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5430), 1,
      anon_sym_LBRACE,
    STATE(3439), 2,
      sym_line_comment,
      sym_block_comment,
  [93664] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5071), 1,
      anon_sym_COLON_COLON,
    STATE(3440), 2,
      sym_line_comment,
      sym_block_comment,
  [93678] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6817), 1,
      anon_sym_COLON_COLON,
    STATE(3441), 2,
      sym_line_comment,
      sym_block_comment,
  [93692] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5059), 1,
      anon_sym_COLON_COLON,
    STATE(3442), 2,
      sym_line_comment,
      sym_block_comment,
  [93706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6819), 1,
      anon_sym_COLON_COLON,
    STATE(3443), 2,
      sym_line_comment,
      sym_block_comment,
  [93720] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3939), 1,
      anon_sym_COLON_COLON,
    STATE(3444), 2,
      sym_line_comment,
      sym_block_comment,
  [93734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6821), 1,
      anon_sym_COLON_COLON,
    STATE(3445), 2,
      sym_line_comment,
      sym_block_comment,
  [93748] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6823), 1,
      anon_sym_COLON_COLON,
    STATE(3446), 2,
      sym_line_comment,
      sym_block_comment,
  [93762] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6825), 1,
      anon_sym_COLON_COLON,
    STATE(3447), 2,
      sym_line_comment,
      sym_block_comment,
  [93776] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6827), 1,
      anon_sym_RBRACK,
    STATE(3448), 2,
      sym_line_comment,
      sym_block_comment,
  [93790] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6829), 1,
      sym_identifier,
    STATE(3449), 2,
      sym_line_comment,
      sym_block_comment,
  [93804] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6831), 1,
      sym_identifier,
    STATE(3450), 2,
      sym_line_comment,
      sym_block_comment,
  [93818] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5774), 1,
      anon_sym_RBRACE,
    STATE(3451), 2,
      sym_line_comment,
      sym_block_comment,
  [93832] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6833), 1,
      anon_sym_COLON,
    STATE(3452), 2,
      sym_line_comment,
      sym_block_comment,
  [93846] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6835), 1,
      anon_sym_LBRACK,
    STATE(3453), 2,
      sym_line_comment,
      sym_block_comment,
  [93860] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1448), 1,
      anon_sym_EQ_GT,
    STATE(3454), 2,
      sym_line_comment,
      sym_block_comment,
  [93874] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6837), 1,
      anon_sym_LBRACK,
    STATE(3455), 2,
      sym_line_comment,
      sym_block_comment,
  [93888] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6839), 1,
      anon_sym_COLON,
    STATE(3456), 2,
      sym_line_comment,
      sym_block_comment,
  [93902] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6841), 1,
      anon_sym_COLON,
    STATE(3457), 2,
      sym_line_comment,
      sym_block_comment,
  [93916] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6843), 1,
      anon_sym_fn,
    STATE(3458), 2,
      sym_line_comment,
      sym_block_comment,
  [93930] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6845), 1,
      sym_identifier,
    STATE(3459), 2,
      sym_line_comment,
      sym_block_comment,
  [93944] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6847), 1,
      anon_sym_SEMI,
    STATE(3460), 2,
      sym_line_comment,
      sym_block_comment,
  [93958] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      anon_sym_fn,
    STATE(3461), 2,
      sym_line_comment,
      sym_block_comment,
  [93972] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6851), 1,
      anon_sym_COLON,
    STATE(3462), 2,
      sym_line_comment,
      sym_block_comment,
  [93986] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6853), 1,
      sym_identifier,
    STATE(3463), 2,
      sym_line_comment,
      sym_block_comment,
  [94000] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6855), 1,
      anon_sym_SEMI,
    STATE(3464), 2,
      sym_line_comment,
      sym_block_comment,
  [94014] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6857), 1,
      anon_sym_SEMI,
    STATE(3465), 2,
      sym_line_comment,
      sym_block_comment,
  [94028] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6859), 1,
      sym_identifier,
    STATE(3466), 2,
      sym_line_comment,
      sym_block_comment,
  [94042] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6861), 1,
      anon_sym_SEMI,
    STATE(3467), 2,
      sym_line_comment,
      sym_block_comment,
  [94056] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5031), 1,
      anon_sym_SEMI,
    STATE(3468), 2,
      sym_line_comment,
      sym_block_comment,
  [94070] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4792), 1,
      anon_sym_COLON_COLON,
    STATE(3469), 2,
      sym_line_comment,
      sym_block_comment,
  [94084] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(682), 1,
      anon_sym_RBRACK,
    STATE(3470), 2,
      sym_line_comment,
      sym_block_comment,
  [94098] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6863), 1,
      anon_sym_SEMI,
    STATE(3471), 2,
      sym_line_comment,
      sym_block_comment,
  [94112] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6865), 1,
      anon_sym_COLON,
    STATE(3472), 2,
      sym_line_comment,
      sym_block_comment,
  [94126] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6867), 1,
      sym_identifier,
    STATE(3473), 2,
      sym_line_comment,
      sym_block_comment,
  [94140] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4800), 1,
      anon_sym_COLON_COLON,
    STATE(3474), 2,
      sym_line_comment,
      sym_block_comment,
  [94154] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6869), 1,
      anon_sym_RBRACK,
    STATE(3475), 2,
      sym_line_comment,
      sym_block_comment,
  [94168] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6871), 1,
      anon_sym_COLON,
    STATE(3476), 2,
      sym_line_comment,
      sym_block_comment,
  [94182] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6873), 1,
      sym_identifier,
    STATE(3477), 2,
      sym_line_comment,
      sym_block_comment,
  [94196] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6875), 1,
      anon_sym_SEMI,
    STATE(3478), 2,
      sym_line_comment,
      sym_block_comment,
  [94210] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6877), 1,
      anon_sym_EQ_GT,
    STATE(3479), 2,
      sym_line_comment,
      sym_block_comment,
  [94224] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6879), 1,
      anon_sym_SEMI,
    STATE(3480), 2,
      sym_line_comment,
      sym_block_comment,
  [94238] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6881), 1,
      anon_sym_COLON,
    STATE(3481), 2,
      sym_line_comment,
      sym_block_comment,
  [94252] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6883), 1,
      anon_sym_COLON,
    STATE(3482), 2,
      sym_line_comment,
      sym_block_comment,
  [94266] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4007), 1,
      anon_sym_RPAREN,
    STATE(3483), 2,
      sym_line_comment,
      sym_block_comment,
  [94280] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6885), 1,
      anon_sym_SEMI,
    STATE(3484), 2,
      sym_line_comment,
      sym_block_comment,
  [94294] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5029), 1,
      anon_sym_SEMI,
    STATE(3485), 2,
      sym_line_comment,
      sym_block_comment,
  [94308] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5021), 1,
      anon_sym_SEMI,
    STATE(3486), 2,
      sym_line_comment,
      sym_block_comment,
  [94322] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6887), 1,
      anon_sym_SEMI,
    STATE(3487), 2,
      sym_line_comment,
      sym_block_comment,
  [94336] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6889), 1,
      anon_sym_SEMI,
    STATE(3488), 2,
      sym_line_comment,
      sym_block_comment,
  [94350] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6891), 1,
      anon_sym_EQ,
    STATE(3489), 2,
      sym_line_comment,
      sym_block_comment,
  [94364] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6893), 1,
      anon_sym_RBRACE,
    STATE(3490), 2,
      sym_line_comment,
      sym_block_comment,
  [94378] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3008), 1,
      anon_sym_PLUS,
    STATE(3491), 2,
      sym_line_comment,
      sym_block_comment,
  [94392] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6895), 1,
      anon_sym_COLON,
    STATE(3492), 2,
      sym_line_comment,
      sym_block_comment,
  [94406] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6897), 1,
      anon_sym_SEMI,
    STATE(3493), 2,
      sym_line_comment,
      sym_block_comment,
  [94420] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6899), 1,
      anon_sym_COLON,
    STATE(3494), 2,
      sym_line_comment,
      sym_block_comment,
  [94434] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6901), 1,
      anon_sym_COLON,
    STATE(3495), 2,
      sym_line_comment,
      sym_block_comment,
  [94448] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6903), 1,
      anon_sym_LBRACK,
    STATE(3496), 2,
      sym_line_comment,
      sym_block_comment,
  [94462] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6905), 1,
      anon_sym_COLON,
    STATE(3497), 2,
      sym_line_comment,
      sym_block_comment,
  [94476] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6907), 1,
      sym_identifier,
    STATE(3498), 2,
      sym_line_comment,
      sym_block_comment,
  [94490] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6909), 1,
      anon_sym_SEMI,
    STATE(3499), 2,
      sym_line_comment,
      sym_block_comment,
  [94504] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6911), 1,
      anon_sym_COLON,
    STATE(3500), 2,
      sym_line_comment,
      sym_block_comment,
  [94518] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6913), 1,
      anon_sym_COLON,
    STATE(3501), 2,
      sym_line_comment,
      sym_block_comment,
  [94532] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6915), 1,
      anon_sym_SEMI,
    STATE(3502), 2,
      sym_line_comment,
      sym_block_comment,
  [94546] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6917), 1,
      anon_sym_SEMI,
    STATE(3503), 2,
      sym_line_comment,
      sym_block_comment,
  [94560] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6919), 1,
      anon_sym_COLON,
    STATE(3504), 2,
      sym_line_comment,
      sym_block_comment,
  [94574] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6921), 1,
      anon_sym_COLON,
    STATE(3505), 2,
      sym_line_comment,
      sym_block_comment,
  [94588] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6923), 1,
      anon_sym_COLON,
    STATE(3506), 2,
      sym_line_comment,
      sym_block_comment,
  [94602] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6925), 1,
      anon_sym_EQ_GT,
    STATE(3507), 2,
      sym_line_comment,
      sym_block_comment,
  [94616] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4391), 1,
      anon_sym_fn,
    STATE(3508), 2,
      sym_line_comment,
      sym_block_comment,
  [94630] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6927), 1,
      sym_identifier,
    STATE(3509), 2,
      sym_line_comment,
      sym_block_comment,
  [94644] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(700), 1,
      anon_sym_RBRACK,
    STATE(3510), 2,
      sym_line_comment,
      sym_block_comment,
  [94658] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6929), 1,
      sym_identifier,
    STATE(3511), 2,
      sym_line_comment,
      sym_block_comment,
  [94672] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6931), 1,
      anon_sym_SEMI,
    STATE(3512), 2,
      sym_line_comment,
      sym_block_comment,
  [94686] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3987), 1,
      anon_sym_RPAREN,
    STATE(3513), 2,
      sym_line_comment,
      sym_block_comment,
  [94700] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6933), 1,
      sym_identifier,
    STATE(3514), 2,
      sym_line_comment,
      sym_block_comment,
  [94714] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6935), 1,
      anon_sym_fn,
    STATE(3515), 2,
      sym_line_comment,
      sym_block_comment,
  [94728] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6937), 1,
      sym_identifier,
    STATE(3516), 2,
      sym_line_comment,
      sym_block_comment,
  [94742] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6939), 1,
      sym_identifier,
    STATE(3517), 2,
      sym_line_comment,
      sym_block_comment,
  [94756] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6941), 1,
      anon_sym_SEMI,
    STATE(3518), 2,
      sym_line_comment,
      sym_block_comment,
  [94770] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6943), 1,
      sym_identifier,
    STATE(3519), 2,
      sym_line_comment,
      sym_block_comment,
  [94784] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6945), 1,
      sym_identifier,
    STATE(3520), 2,
      sym_line_comment,
      sym_block_comment,
  [94798] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6947), 1,
      anon_sym_SEMI,
    STATE(3521), 2,
      sym_line_comment,
      sym_block_comment,
  [94812] = 1,
    ACTIONS(6949), 1,
      ts_builtin_sym_end,
  [94816] = 1,
    ACTIONS(6951), 1,
      ts_builtin_sym_end,
  [94820] = 1,
    ACTIONS(6953), 1,
      ts_builtin_sym_end,
  [94824] = 1,
    ACTIONS(6955), 1,
      ts_builtin_sym_end,
  [94828] = 1,
    ACTIONS(6957), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1006)] = 0,
  [SMALL_STATE(1007)] = 75,
  [SMALL_STATE(1008)] = 150,
  [SMALL_STATE(1009)] = 225,
  [SMALL_STATE(1010)] = 299,
  [SMALL_STATE(1011)] = 367,
  [SMALL_STATE(1012)] = 435,
  [SMALL_STATE(1013)] = 512,
  [SMALL_STATE(1014)] = 586,
  [SMALL_STATE(1015)] = 660,
  [SMALL_STATE(1016)] = 734,
  [SMALL_STATE(1017)] = 797,
  [SMALL_STATE(1018)] = 868,
  [SMALL_STATE(1019)] = 935,
  [SMALL_STATE(1020)] = 1006,
  [SMALL_STATE(1021)] = 1077,
  [SMALL_STATE(1022)] = 1140,
  [SMALL_STATE(1023)] = 1203,
  [SMALL_STATE(1024)] = 1266,
  [SMALL_STATE(1025)] = 1329,
  [SMALL_STATE(1026)] = 1392,
  [SMALL_STATE(1027)] = 1455,
  [SMALL_STATE(1028)] = 1522,
  [SMALL_STATE(1029)] = 1593,
  [SMALL_STATE(1030)] = 1656,
  [SMALL_STATE(1031)] = 1723,
  [SMALL_STATE(1032)] = 1786,
  [SMALL_STATE(1033)] = 1853,
  [SMALL_STATE(1034)] = 1915,
  [SMALL_STATE(1035)] = 1977,
  [SMALL_STATE(1036)] = 2039,
  [SMALL_STATE(1037)] = 2103,
  [SMALL_STATE(1038)] = 2165,
  [SMALL_STATE(1039)] = 2229,
  [SMALL_STATE(1040)] = 2291,
  [SMALL_STATE(1041)] = 2359,
  [SMALL_STATE(1042)] = 2421,
  [SMALL_STATE(1043)] = 2483,
  [SMALL_STATE(1044)] = 2545,
  [SMALL_STATE(1045)] = 2607,
  [SMALL_STATE(1046)] = 2677,
  [SMALL_STATE(1047)] = 2742,
  [SMALL_STATE(1048)] = 2803,
  [SMALL_STATE(1049)] = 2866,
  [SMALL_STATE(1050)] = 2927,
  [SMALL_STATE(1051)] = 2990,
  [SMALL_STATE(1052)] = 3051,
  [SMALL_STATE(1053)] = 3112,
  [SMALL_STATE(1054)] = 3173,
  [SMALL_STATE(1055)] = 3238,
  [SMALL_STATE(1056)] = 3301,
  [SMALL_STATE(1057)] = 3364,
  [SMALL_STATE(1058)] = 3427,
  [SMALL_STATE(1059)] = 3490,
  [SMALL_STATE(1060)] = 3551,
  [SMALL_STATE(1061)] = 3616,
  [SMALL_STATE(1062)] = 3679,
  [SMALL_STATE(1063)] = 3740,
  [SMALL_STATE(1064)] = 3801,
  [SMALL_STATE(1065)] = 3864,
  [SMALL_STATE(1066)] = 3927,
  [SMALL_STATE(1067)] = 3988,
  [SMALL_STATE(1068)] = 4051,
  [SMALL_STATE(1069)] = 4114,
  [SMALL_STATE(1070)] = 4175,
  [SMALL_STATE(1071)] = 4238,
  [SMALL_STATE(1072)] = 4299,
  [SMALL_STATE(1073)] = 4362,
  [SMALL_STATE(1074)] = 4423,
  [SMALL_STATE(1075)] = 4522,
  [SMALL_STATE(1076)] = 4583,
  [SMALL_STATE(1077)] = 4646,
  [SMALL_STATE(1078)] = 4707,
  [SMALL_STATE(1079)] = 4770,
  [SMALL_STATE(1080)] = 4833,
  [SMALL_STATE(1081)] = 4894,
  [SMALL_STATE(1082)] = 4957,
  [SMALL_STATE(1083)] = 5018,
  [SMALL_STATE(1084)] = 5081,
  [SMALL_STATE(1085)] = 5142,
  [SMALL_STATE(1086)] = 5241,
  [SMALL_STATE(1087)] = 5302,
  [SMALL_STATE(1088)] = 5363,
  [SMALL_STATE(1089)] = 5423,
  [SMALL_STATE(1090)] = 5483,
  [SMALL_STATE(1091)] = 5543,
  [SMALL_STATE(1092)] = 5603,
  [SMALL_STATE(1093)] = 5663,
  [SMALL_STATE(1094)] = 5725,
  [SMALL_STATE(1095)] = 5785,
  [SMALL_STATE(1096)] = 5845,
  [SMALL_STATE(1097)] = 5905,
  [SMALL_STATE(1098)] = 5965,
  [SMALL_STATE(1099)] = 6025,
  [SMALL_STATE(1100)] = 6085,
  [SMALL_STATE(1101)] = 6145,
  [SMALL_STATE(1102)] = 6205,
  [SMALL_STATE(1103)] = 6265,
  [SMALL_STATE(1104)] = 6325,
  [SMALL_STATE(1105)] = 6385,
  [SMALL_STATE(1106)] = 6445,
  [SMALL_STATE(1107)] = 6505,
  [SMALL_STATE(1108)] = 6565,
  [SMALL_STATE(1109)] = 6625,
  [SMALL_STATE(1110)] = 6685,
  [SMALL_STATE(1111)] = 6745,
  [SMALL_STATE(1112)] = 6805,
  [SMALL_STATE(1113)] = 6865,
  [SMALL_STATE(1114)] = 6925,
  [SMALL_STATE(1115)] = 6985,
  [SMALL_STATE(1116)] = 7045,
  [SMALL_STATE(1117)] = 7105,
  [SMALL_STATE(1118)] = 7165,
  [SMALL_STATE(1119)] = 7225,
  [SMALL_STATE(1120)] = 7285,
  [SMALL_STATE(1121)] = 7345,
  [SMALL_STATE(1122)] = 7405,
  [SMALL_STATE(1123)] = 7465,
  [SMALL_STATE(1124)] = 7525,
  [SMALL_STATE(1125)] = 7585,
  [SMALL_STATE(1126)] = 7645,
  [SMALL_STATE(1127)] = 7705,
  [SMALL_STATE(1128)] = 7765,
  [SMALL_STATE(1129)] = 7825,
  [SMALL_STATE(1130)] = 7885,
  [SMALL_STATE(1131)] = 7945,
  [SMALL_STATE(1132)] = 8005,
  [SMALL_STATE(1133)] = 8065,
  [SMALL_STATE(1134)] = 8125,
  [SMALL_STATE(1135)] = 8185,
  [SMALL_STATE(1136)] = 8245,
  [SMALL_STATE(1137)] = 8305,
  [SMALL_STATE(1138)] = 8365,
  [SMALL_STATE(1139)] = 8425,
  [SMALL_STATE(1140)] = 8485,
  [SMALL_STATE(1141)] = 8545,
  [SMALL_STATE(1142)] = 8605,
  [SMALL_STATE(1143)] = 8665,
  [SMALL_STATE(1144)] = 8725,
  [SMALL_STATE(1145)] = 8785,
  [SMALL_STATE(1146)] = 8845,
  [SMALL_STATE(1147)] = 8905,
  [SMALL_STATE(1148)] = 8965,
  [SMALL_STATE(1149)] = 9025,
  [SMALL_STATE(1150)] = 9085,
  [SMALL_STATE(1151)] = 9145,
  [SMALL_STATE(1152)] = 9205,
  [SMALL_STATE(1153)] = 9265,
  [SMALL_STATE(1154)] = 9325,
  [SMALL_STATE(1155)] = 9385,
  [SMALL_STATE(1156)] = 9445,
  [SMALL_STATE(1157)] = 9505,
  [SMALL_STATE(1158)] = 9565,
  [SMALL_STATE(1159)] = 9625,
  [SMALL_STATE(1160)] = 9685,
  [SMALL_STATE(1161)] = 9745,
  [SMALL_STATE(1162)] = 9805,
  [SMALL_STATE(1163)] = 9865,
  [SMALL_STATE(1164)] = 9925,
  [SMALL_STATE(1165)] = 9985,
  [SMALL_STATE(1166)] = 10045,
  [SMALL_STATE(1167)] = 10105,
  [SMALL_STATE(1168)] = 10165,
  [SMALL_STATE(1169)] = 10225,
  [SMALL_STATE(1170)] = 10285,
  [SMALL_STATE(1171)] = 10345,
  [SMALL_STATE(1172)] = 10405,
  [SMALL_STATE(1173)] = 10465,
  [SMALL_STATE(1174)] = 10525,
  [SMALL_STATE(1175)] = 10585,
  [SMALL_STATE(1176)] = 10645,
  [SMALL_STATE(1177)] = 10705,
  [SMALL_STATE(1178)] = 10765,
  [SMALL_STATE(1179)] = 10825,
  [SMALL_STATE(1180)] = 10885,
  [SMALL_STATE(1181)] = 10945,
  [SMALL_STATE(1182)] = 11005,
  [SMALL_STATE(1183)] = 11065,
  [SMALL_STATE(1184)] = 11125,
  [SMALL_STATE(1185)] = 11185,
  [SMALL_STATE(1186)] = 11245,
  [SMALL_STATE(1187)] = 11305,
  [SMALL_STATE(1188)] = 11365,
  [SMALL_STATE(1189)] = 11425,
  [SMALL_STATE(1190)] = 11485,
  [SMALL_STATE(1191)] = 11545,
  [SMALL_STATE(1192)] = 11605,
  [SMALL_STATE(1193)] = 11665,
  [SMALL_STATE(1194)] = 11725,
  [SMALL_STATE(1195)] = 11793,
  [SMALL_STATE(1196)] = 11853,
  [SMALL_STATE(1197)] = 11913,
  [SMALL_STATE(1198)] = 11973,
  [SMALL_STATE(1199)] = 12033,
  [SMALL_STATE(1200)] = 12093,
  [SMALL_STATE(1201)] = 12153,
  [SMALL_STATE(1202)] = 12213,
  [SMALL_STATE(1203)] = 12273,
  [SMALL_STATE(1204)] = 12333,
  [SMALL_STATE(1205)] = 12393,
  [SMALL_STATE(1206)] = 12453,
  [SMALL_STATE(1207)] = 12513,
  [SMALL_STATE(1208)] = 12573,
  [SMALL_STATE(1209)] = 12633,
  [SMALL_STATE(1210)] = 12693,
  [SMALL_STATE(1211)] = 12753,
  [SMALL_STATE(1212)] = 12813,
  [SMALL_STATE(1213)] = 12873,
  [SMALL_STATE(1214)] = 12933,
  [SMALL_STATE(1215)] = 12993,
  [SMALL_STATE(1216)] = 13053,
  [SMALL_STATE(1217)] = 13113,
  [SMALL_STATE(1218)] = 13173,
  [SMALL_STATE(1219)] = 13233,
  [SMALL_STATE(1220)] = 13293,
  [SMALL_STATE(1221)] = 13353,
  [SMALL_STATE(1222)] = 13413,
  [SMALL_STATE(1223)] = 13473,
  [SMALL_STATE(1224)] = 13539,
  [SMALL_STATE(1225)] = 13599,
  [SMALL_STATE(1226)] = 13659,
  [SMALL_STATE(1227)] = 13719,
  [SMALL_STATE(1228)] = 13779,
  [SMALL_STATE(1229)] = 13839,
  [SMALL_STATE(1230)] = 13899,
  [SMALL_STATE(1231)] = 13959,
  [SMALL_STATE(1232)] = 14019,
  [SMALL_STATE(1233)] = 14081,
  [SMALL_STATE(1234)] = 14141,
  [SMALL_STATE(1235)] = 14201,
  [SMALL_STATE(1236)] = 14261,
  [SMALL_STATE(1237)] = 14321,
  [SMALL_STATE(1238)] = 14381,
  [SMALL_STATE(1239)] = 14441,
  [SMALL_STATE(1240)] = 14501,
  [SMALL_STATE(1241)] = 14561,
  [SMALL_STATE(1242)] = 14621,
  [SMALL_STATE(1243)] = 14681,
  [SMALL_STATE(1244)] = 14741,
  [SMALL_STATE(1245)] = 14801,
  [SMALL_STATE(1246)] = 14861,
  [SMALL_STATE(1247)] = 14921,
  [SMALL_STATE(1248)] = 14981,
  [SMALL_STATE(1249)] = 15041,
  [SMALL_STATE(1250)] = 15101,
  [SMALL_STATE(1251)] = 15161,
  [SMALL_STATE(1252)] = 15221,
  [SMALL_STATE(1253)] = 15281,
  [SMALL_STATE(1254)] = 15341,
  [SMALL_STATE(1255)] = 15401,
  [SMALL_STATE(1256)] = 15461,
  [SMALL_STATE(1257)] = 15521,
  [SMALL_STATE(1258)] = 15581,
  [SMALL_STATE(1259)] = 15641,
  [SMALL_STATE(1260)] = 15701,
  [SMALL_STATE(1261)] = 15761,
  [SMALL_STATE(1262)] = 15821,
  [SMALL_STATE(1263)] = 15881,
  [SMALL_STATE(1264)] = 15941,
  [SMALL_STATE(1265)] = 16001,
  [SMALL_STATE(1266)] = 16061,
  [SMALL_STATE(1267)] = 16121,
  [SMALL_STATE(1268)] = 16181,
  [SMALL_STATE(1269)] = 16241,
  [SMALL_STATE(1270)] = 16301,
  [SMALL_STATE(1271)] = 16361,
  [SMALL_STATE(1272)] = 16421,
  [SMALL_STATE(1273)] = 16481,
  [SMALL_STATE(1274)] = 16541,
  [SMALL_STATE(1275)] = 16601,
  [SMALL_STATE(1276)] = 16661,
  [SMALL_STATE(1277)] = 16721,
  [SMALL_STATE(1278)] = 16781,
  [SMALL_STATE(1279)] = 16841,
  [SMALL_STATE(1280)] = 16901,
  [SMALL_STATE(1281)] = 16961,
  [SMALL_STATE(1282)] = 17021,
  [SMALL_STATE(1283)] = 17081,
  [SMALL_STATE(1284)] = 17141,
  [SMALL_STATE(1285)] = 17201,
  [SMALL_STATE(1286)] = 17261,
  [SMALL_STATE(1287)] = 17321,
  [SMALL_STATE(1288)] = 17381,
  [SMALL_STATE(1289)] = 17441,
  [SMALL_STATE(1290)] = 17501,
  [SMALL_STATE(1291)] = 17561,
  [SMALL_STATE(1292)] = 17621,
  [SMALL_STATE(1293)] = 17681,
  [SMALL_STATE(1294)] = 17747,
  [SMALL_STATE(1295)] = 17807,
  [SMALL_STATE(1296)] = 17867,
  [SMALL_STATE(1297)] = 17927,
  [SMALL_STATE(1298)] = 17987,
  [SMALL_STATE(1299)] = 18047,
  [SMALL_STATE(1300)] = 18107,
  [SMALL_STATE(1301)] = 18167,
  [SMALL_STATE(1302)] = 18227,
  [SMALL_STATE(1303)] = 18287,
  [SMALL_STATE(1304)] = 18347,
  [SMALL_STATE(1305)] = 18407,
  [SMALL_STATE(1306)] = 18467,
  [SMALL_STATE(1307)] = 18533,
  [SMALL_STATE(1308)] = 18593,
  [SMALL_STATE(1309)] = 18653,
  [SMALL_STATE(1310)] = 18713,
  [SMALL_STATE(1311)] = 18773,
  [SMALL_STATE(1312)] = 18833,
  [SMALL_STATE(1313)] = 18893,
  [SMALL_STATE(1314)] = 18953,
  [SMALL_STATE(1315)] = 19013,
  [SMALL_STATE(1316)] = 19073,
  [SMALL_STATE(1317)] = 19133,
  [SMALL_STATE(1318)] = 19193,
  [SMALL_STATE(1319)] = 19253,
  [SMALL_STATE(1320)] = 19313,
  [SMALL_STATE(1321)] = 19373,
  [SMALL_STATE(1322)] = 19433,
  [SMALL_STATE(1323)] = 19493,
  [SMALL_STATE(1324)] = 19553,
  [SMALL_STATE(1325)] = 19613,
  [SMALL_STATE(1326)] = 19673,
  [SMALL_STATE(1327)] = 19733,
  [SMALL_STATE(1328)] = 19793,
  [SMALL_STATE(1329)] = 19853,
  [SMALL_STATE(1330)] = 19913,
  [SMALL_STATE(1331)] = 19973,
  [SMALL_STATE(1332)] = 20033,
  [SMALL_STATE(1333)] = 20093,
  [SMALL_STATE(1334)] = 20153,
  [SMALL_STATE(1335)] = 20213,
  [SMALL_STATE(1336)] = 20273,
  [SMALL_STATE(1337)] = 20333,
  [SMALL_STATE(1338)] = 20393,
  [SMALL_STATE(1339)] = 20453,
  [SMALL_STATE(1340)] = 20513,
  [SMALL_STATE(1341)] = 20573,
  [SMALL_STATE(1342)] = 20633,
  [SMALL_STATE(1343)] = 20693,
  [SMALL_STATE(1344)] = 20753,
  [SMALL_STATE(1345)] = 20813,
  [SMALL_STATE(1346)] = 20873,
  [SMALL_STATE(1347)] = 20933,
  [SMALL_STATE(1348)] = 20993,
  [SMALL_STATE(1349)] = 21053,
  [SMALL_STATE(1350)] = 21113,
  [SMALL_STATE(1351)] = 21173,
  [SMALL_STATE(1352)] = 21233,
  [SMALL_STATE(1353)] = 21293,
  [SMALL_STATE(1354)] = 21353,
  [SMALL_STATE(1355)] = 21413,
  [SMALL_STATE(1356)] = 21473,
  [SMALL_STATE(1357)] = 21533,
  [SMALL_STATE(1358)] = 21593,
  [SMALL_STATE(1359)] = 21653,
  [SMALL_STATE(1360)] = 21713,
  [SMALL_STATE(1361)] = 21773,
  [SMALL_STATE(1362)] = 21833,
  [SMALL_STATE(1363)] = 21893,
  [SMALL_STATE(1364)] = 21953,
  [SMALL_STATE(1365)] = 22013,
  [SMALL_STATE(1366)] = 22073,
  [SMALL_STATE(1367)] = 22133,
  [SMALL_STATE(1368)] = 22193,
  [SMALL_STATE(1369)] = 22253,
  [SMALL_STATE(1370)] = 22313,
  [SMALL_STATE(1371)] = 22373,
  [SMALL_STATE(1372)] = 22433,
  [SMALL_STATE(1373)] = 22493,
  [SMALL_STATE(1374)] = 22553,
  [SMALL_STATE(1375)] = 22613,
  [SMALL_STATE(1376)] = 22673,
  [SMALL_STATE(1377)] = 22733,
  [SMALL_STATE(1378)] = 22793,
  [SMALL_STATE(1379)] = 22853,
  [SMALL_STATE(1380)] = 22913,
  [SMALL_STATE(1381)] = 22973,
  [SMALL_STATE(1382)] = 23033,
  [SMALL_STATE(1383)] = 23093,
  [SMALL_STATE(1384)] = 23153,
  [SMALL_STATE(1385)] = 23213,
  [SMALL_STATE(1386)] = 23273,
  [SMALL_STATE(1387)] = 23333,
  [SMALL_STATE(1388)] = 23393,
  [SMALL_STATE(1389)] = 23453,
  [SMALL_STATE(1390)] = 23517,
  [SMALL_STATE(1391)] = 23577,
  [SMALL_STATE(1392)] = 23637,
  [SMALL_STATE(1393)] = 23697,
  [SMALL_STATE(1394)] = 23757,
  [SMALL_STATE(1395)] = 23817,
  [SMALL_STATE(1396)] = 23877,
  [SMALL_STATE(1397)] = 23937,
  [SMALL_STATE(1398)] = 23997,
  [SMALL_STATE(1399)] = 24057,
  [SMALL_STATE(1400)] = 24117,
  [SMALL_STATE(1401)] = 24177,
  [SMALL_STATE(1402)] = 24237,
  [SMALL_STATE(1403)] = 24297,
  [SMALL_STATE(1404)] = 24357,
  [SMALL_STATE(1405)] = 24417,
  [SMALL_STATE(1406)] = 24477,
  [SMALL_STATE(1407)] = 24537,
  [SMALL_STATE(1408)] = 24597,
  [SMALL_STATE(1409)] = 24657,
  [SMALL_STATE(1410)] = 24717,
  [SMALL_STATE(1411)] = 24777,
  [SMALL_STATE(1412)] = 24837,
  [SMALL_STATE(1413)] = 24897,
  [SMALL_STATE(1414)] = 24957,
  [SMALL_STATE(1415)] = 25017,
  [SMALL_STATE(1416)] = 25077,
  [SMALL_STATE(1417)] = 25137,
  [SMALL_STATE(1418)] = 25197,
  [SMALL_STATE(1419)] = 25257,
  [SMALL_STATE(1420)] = 25317,
  [SMALL_STATE(1421)] = 25377,
  [SMALL_STATE(1422)] = 25437,
  [SMALL_STATE(1423)] = 25497,
  [SMALL_STATE(1424)] = 25557,
  [SMALL_STATE(1425)] = 25617,
  [SMALL_STATE(1426)] = 25677,
  [SMALL_STATE(1427)] = 25737,
  [SMALL_STATE(1428)] = 25797,
  [SMALL_STATE(1429)] = 25857,
  [SMALL_STATE(1430)] = 25917,
  [SMALL_STATE(1431)] = 25977,
  [SMALL_STATE(1432)] = 26037,
  [SMALL_STATE(1433)] = 26097,
  [SMALL_STATE(1434)] = 26157,
  [SMALL_STATE(1435)] = 26217,
  [SMALL_STATE(1436)] = 26277,
  [SMALL_STATE(1437)] = 26337,
  [SMALL_STATE(1438)] = 26397,
  [SMALL_STATE(1439)] = 26461,
  [SMALL_STATE(1440)] = 26521,
  [SMALL_STATE(1441)] = 26581,
  [SMALL_STATE(1442)] = 26641,
  [SMALL_STATE(1443)] = 26701,
  [SMALL_STATE(1444)] = 26761,
  [SMALL_STATE(1445)] = 26821,
  [SMALL_STATE(1446)] = 26881,
  [SMALL_STATE(1447)] = 26941,
  [SMALL_STATE(1448)] = 27012,
  [SMALL_STATE(1449)] = 27107,
  [SMALL_STATE(1450)] = 27166,
  [SMALL_STATE(1451)] = 27225,
  [SMALL_STATE(1452)] = 27286,
  [SMALL_STATE(1453)] = 27381,
  [SMALL_STATE(1454)] = 27440,
  [SMALL_STATE(1455)] = 27499,
  [SMALL_STATE(1456)] = 27558,
  [SMALL_STATE(1457)] = 27617,
  [SMALL_STATE(1458)] = 27678,
  [SMALL_STATE(1459)] = 27741,
  [SMALL_STATE(1460)] = 27833,
  [SMALL_STATE(1461)] = 27925,
  [SMALL_STATE(1462)] = 28015,
  [SMALL_STATE(1463)] = 28081,
  [SMALL_STATE(1464)] = 28153,
  [SMALL_STATE(1465)] = 28227,
  [SMALL_STATE(1466)] = 28295,
  [SMALL_STATE(1467)] = 28373,
  [SMALL_STATE(1468)] = 28449,
  [SMALL_STATE(1469)] = 28517,
  [SMALL_STATE(1470)] = 28603,
  [SMALL_STATE(1471)] = 28685,
  [SMALL_STATE(1472)] = 28769,
  [SMALL_STATE(1473)] = 28839,
  [SMALL_STATE(1474)] = 28905,
  [SMALL_STATE(1475)] = 28995,
  [SMALL_STATE(1476)] = 29081,
  [SMALL_STATE(1477)] = 29171,
  [SMALL_STATE(1478)] = 29239,
  [SMALL_STATE(1479)] = 29329,
  [SMALL_STATE(1480)] = 29419,
  [SMALL_STATE(1481)] = 29511,
  [SMALL_STATE(1482)] = 29579,
  [SMALL_STATE(1483)] = 29669,
  [SMALL_STATE(1484)] = 29734,
  [SMALL_STATE(1485)] = 29799,
  [SMALL_STATE(1486)] = 29860,
  [SMALL_STATE(1487)] = 29957,
  [SMALL_STATE(1488)] = 30018,
  [SMALL_STATE(1489)] = 30115,
  [SMALL_STATE(1490)] = 30212,
  [SMALL_STATE(1491)] = 30309,
  [SMALL_STATE(1492)] = 30368,
  [SMALL_STATE(1493)] = 30465,
  [SMALL_STATE(1494)] = 30522,
  [SMALL_STATE(1495)] = 30587,
  [SMALL_STATE(1496)] = 30684,
  [SMALL_STATE(1497)] = 30743,
  [SMALL_STATE(1498)] = 30804,
  [SMALL_STATE(1499)] = 30867,
  [SMALL_STATE(1500)] = 30964,
  [SMALL_STATE(1501)] = 31029,
  [SMALL_STATE(1502)] = 31126,
  [SMALL_STATE(1503)] = 31183,
  [SMALL_STATE(1504)] = 31246,
  [SMALL_STATE(1505)] = 31305,
  [SMALL_STATE(1506)] = 31366,
  [SMALL_STATE(1507)] = 31425,
  [SMALL_STATE(1508)] = 31522,
  [SMALL_STATE(1509)] = 31582,
  [SMALL_STATE(1510)] = 31642,
  [SMALL_STATE(1511)] = 31702,
  [SMALL_STATE(1512)] = 31762,
  [SMALL_STATE(1513)] = 31818,
  [SMALL_STATE(1514)] = 31878,
  [SMALL_STATE(1515)] = 31934,
  [SMALL_STATE(1516)] = 31990,
  [SMALL_STATE(1517)] = 32046,
  [SMALL_STATE(1518)] = 32104,
  [SMALL_STATE(1519)] = 32186,
  [SMALL_STATE(1520)] = 32246,
  [SMALL_STATE(1521)] = 32302,
  [SMALL_STATE(1522)] = 32358,
  [SMALL_STATE(1523)] = 32440,
  [SMALL_STATE(1524)] = 32496,
  [SMALL_STATE(1525)] = 32554,
  [SMALL_STATE(1526)] = 32614,
  [SMALL_STATE(1527)] = 32696,
  [SMALL_STATE(1528)] = 32752,
  [SMALL_STATE(1529)] = 32834,
  [SMALL_STATE(1530)] = 32890,
  [SMALL_STATE(1531)] = 32946,
  [SMALL_STATE(1532)] = 33002,
  [SMALL_STATE(1533)] = 33057,
  [SMALL_STATE(1534)] = 33114,
  [SMALL_STATE(1535)] = 33171,
  [SMALL_STATE(1536)] = 33226,
  [SMALL_STATE(1537)] = 33283,
  [SMALL_STATE(1538)] = 33340,
  [SMALL_STATE(1539)] = 33397,
  [SMALL_STATE(1540)] = 33454,
  [SMALL_STATE(1541)] = 33509,
  [SMALL_STATE(1542)] = 33604,
  [SMALL_STATE(1543)] = 33659,
  [SMALL_STATE(1544)] = 33714,
  [SMALL_STATE(1545)] = 33771,
  [SMALL_STATE(1546)] = 33826,
  [SMALL_STATE(1547)] = 33881,
  [SMALL_STATE(1548)] = 33940,
  [SMALL_STATE(1549)] = 34035,
  [SMALL_STATE(1550)] = 34090,
  [SMALL_STATE(1551)] = 34147,
  [SMALL_STATE(1552)] = 34204,
  [SMALL_STATE(1553)] = 34261,
  [SMALL_STATE(1554)] = 34356,
  [SMALL_STATE(1555)] = 34413,
  [SMALL_STATE(1556)] = 34470,
  [SMALL_STATE(1557)] = 34565,
  [SMALL_STATE(1558)] = 34622,
  [SMALL_STATE(1559)] = 34679,
  [SMALL_STATE(1560)] = 34774,
  [SMALL_STATE(1561)] = 34869,
  [SMALL_STATE(1562)] = 34924,
  [SMALL_STATE(1563)] = 34981,
  [SMALL_STATE(1564)] = 35036,
  [SMALL_STATE(1565)] = 35093,
  [SMALL_STATE(1566)] = 35150,
  [SMALL_STATE(1567)] = 35205,
  [SMALL_STATE(1568)] = 35300,
  [SMALL_STATE(1569)] = 35395,
  [SMALL_STATE(1570)] = 35490,
  [SMALL_STATE(1571)] = 35547,
  [SMALL_STATE(1572)] = 35602,
  [SMALL_STATE(1573)] = 35697,
  [SMALL_STATE(1574)] = 35792,
  [SMALL_STATE(1575)] = 35849,
  [SMALL_STATE(1576)] = 35904,
  [SMALL_STATE(1577)] = 35961,
  [SMALL_STATE(1578)] = 36016,
  [SMALL_STATE(1579)] = 36071,
  [SMALL_STATE(1580)] = 36166,
  [SMALL_STATE(1581)] = 36221,
  [SMALL_STATE(1582)] = 36278,
  [SMALL_STATE(1583)] = 36333,
  [SMALL_STATE(1584)] = 36388,
  [SMALL_STATE(1585)] = 36445,
  [SMALL_STATE(1586)] = 36500,
  [SMALL_STATE(1587)] = 36555,
  [SMALL_STATE(1588)] = 36612,
  [SMALL_STATE(1589)] = 36667,
  [SMALL_STATE(1590)] = 36755,
  [SMALL_STATE(1591)] = 36809,
  [SMALL_STATE(1592)] = 36901,
  [SMALL_STATE(1593)] = 36955,
  [SMALL_STATE(1594)] = 37041,
  [SMALL_STATE(1595)] = 37095,
  [SMALL_STATE(1596)] = 37183,
  [SMALL_STATE(1597)] = 37269,
  [SMALL_STATE(1598)] = 37357,
  [SMALL_STATE(1599)] = 37411,
  [SMALL_STATE(1600)] = 37465,
  [SMALL_STATE(1601)] = 37519,
  [SMALL_STATE(1602)] = 37573,
  [SMALL_STATE(1603)] = 37627,
  [SMALL_STATE(1604)] = 37681,
  [SMALL_STATE(1605)] = 37735,
  [SMALL_STATE(1606)] = 37817,
  [SMALL_STATE(1607)] = 37871,
  [SMALL_STATE(1608)] = 37925,
  [SMALL_STATE(1609)] = 38011,
  [SMALL_STATE(1610)] = 38099,
  [SMALL_STATE(1611)] = 38153,
  [SMALL_STATE(1612)] = 38207,
  [SMALL_STATE(1613)] = 38261,
  [SMALL_STATE(1614)] = 38315,
  [SMALL_STATE(1615)] = 38369,
  [SMALL_STATE(1616)] = 38423,
  [SMALL_STATE(1617)] = 38477,
  [SMALL_STATE(1618)] = 38531,
  [SMALL_STATE(1619)] = 38585,
  [SMALL_STATE(1620)] = 38677,
  [SMALL_STATE(1621)] = 38731,
  [SMALL_STATE(1622)] = 38785,
  [SMALL_STATE(1623)] = 38839,
  [SMALL_STATE(1624)] = 38931,
  [SMALL_STATE(1625)] = 39017,
  [SMALL_STATE(1626)] = 39071,
  [SMALL_STATE(1627)] = 39125,
  [SMALL_STATE(1628)] = 39179,
  [SMALL_STATE(1629)] = 39233,
  [SMALL_STATE(1630)] = 39299,
  [SMALL_STATE(1631)] = 39379,
  [SMALL_STATE(1632)] = 39433,
  [SMALL_STATE(1633)] = 39487,
  [SMALL_STATE(1634)] = 39565,
  [SMALL_STATE(1635)] = 39619,
  [SMALL_STATE(1636)] = 39673,
  [SMALL_STATE(1637)] = 39727,
  [SMALL_STATE(1638)] = 39809,
  [SMALL_STATE(1639)] = 39863,
  [SMALL_STATE(1640)] = 39917,
  [SMALL_STATE(1641)] = 39971,
  [SMALL_STATE(1642)] = 40031,
  [SMALL_STATE(1643)] = 40085,
  [SMALL_STATE(1644)] = 40139,
  [SMALL_STATE(1645)] = 40231,
  [SMALL_STATE(1646)] = 40291,
  [SMALL_STATE(1647)] = 40363,
  [SMALL_STATE(1648)] = 40455,
  [SMALL_STATE(1649)] = 40529,
  [SMALL_STATE(1650)] = 40599,
  [SMALL_STATE(1651)] = 40667,
  [SMALL_STATE(1652)] = 40721,
  [SMALL_STATE(1653)] = 40809,
  [SMALL_STATE(1654)] = 40863,
  [SMALL_STATE(1655)] = 40917,
  [SMALL_STATE(1656)] = 40971,
  [SMALL_STATE(1657)] = 41025,
  [SMALL_STATE(1658)] = 41079,
  [SMALL_STATE(1659)] = 41165,
  [SMALL_STATE(1660)] = 41219,
  [SMALL_STATE(1661)] = 41281,
  [SMALL_STATE(1662)] = 41373,
  [SMALL_STATE(1663)] = 41437,
  [SMALL_STATE(1664)] = 41491,
  [SMALL_STATE(1665)] = 41545,
  [SMALL_STATE(1666)] = 41599,
  [SMALL_STATE(1667)] = 41653,
  [SMALL_STATE(1668)] = 41739,
  [SMALL_STATE(1669)] = 41793,
  [SMALL_STATE(1670)] = 41847,
  [SMALL_STATE(1671)] = 41901,
  [SMALL_STATE(1672)] = 41955,
  [SMALL_STATE(1673)] = 42041,
  [SMALL_STATE(1674)] = 42095,
  [SMALL_STATE(1675)] = 42181,
  [SMALL_STATE(1676)] = 42235,
  [SMALL_STATE(1677)] = 42289,
  [SMALL_STATE(1678)] = 42371,
  [SMALL_STATE(1679)] = 42457,
  [SMALL_STATE(1680)] = 42511,
  [SMALL_STATE(1681)] = 42599,
  [SMALL_STATE(1682)] = 42653,
  [SMALL_STATE(1683)] = 42741,
  [SMALL_STATE(1684)] = 42829,
  [SMALL_STATE(1685)] = 42883,
  [SMALL_STATE(1686)] = 42937,
  [SMALL_STATE(1687)] = 42991,
  [SMALL_STATE(1688)] = 43045,
  [SMALL_STATE(1689)] = 43099,
  [SMALL_STATE(1690)] = 43153,
  [SMALL_STATE(1691)] = 43207,
  [SMALL_STATE(1692)] = 43261,
  [SMALL_STATE(1693)] = 43349,
  [SMALL_STATE(1694)] = 43403,
  [SMALL_STATE(1695)] = 43491,
  [SMALL_STATE(1696)] = 43545,
  [SMALL_STATE(1697)] = 43599,
  [SMALL_STATE(1698)] = 43653,
  [SMALL_STATE(1699)] = 43739,
  [SMALL_STATE(1700)] = 43793,
  [SMALL_STATE(1701)] = 43847,
  [SMALL_STATE(1702)] = 43935,
  [SMALL_STATE(1703)] = 43989,
  [SMALL_STATE(1704)] = 44043,
  [SMALL_STATE(1705)] = 44097,
  [SMALL_STATE(1706)] = 44151,
  [SMALL_STATE(1707)] = 44205,
  [SMALL_STATE(1708)] = 44259,
  [SMALL_STATE(1709)] = 44313,
  [SMALL_STATE(1710)] = 44373,
  [SMALL_STATE(1711)] = 44427,
  [SMALL_STATE(1712)] = 44481,
  [SMALL_STATE(1713)] = 44535,
  [SMALL_STATE(1714)] = 44589,
  [SMALL_STATE(1715)] = 44643,
  [SMALL_STATE(1716)] = 44697,
  [SMALL_STATE(1717)] = 44751,
  [SMALL_STATE(1718)] = 44815,
  [SMALL_STATE(1719)] = 44869,
  [SMALL_STATE(1720)] = 44955,
  [SMALL_STATE(1721)] = 45009,
  [SMALL_STATE(1722)] = 45063,
  [SMALL_STATE(1723)] = 45117,
  [SMALL_STATE(1724)] = 45203,
  [SMALL_STATE(1725)] = 45271,
  [SMALL_STATE(1726)] = 45325,
  [SMALL_STATE(1727)] = 45391,
  [SMALL_STATE(1728)] = 45471,
  [SMALL_STATE(1729)] = 45525,
  [SMALL_STATE(1730)] = 45603,
  [SMALL_STATE(1731)] = 45673,
  [SMALL_STATE(1732)] = 45747,
  [SMALL_STATE(1733)] = 45801,
  [SMALL_STATE(1734)] = 45855,
  [SMALL_STATE(1735)] = 45909,
  [SMALL_STATE(1736)] = 45991,
  [SMALL_STATE(1737)] = 46063,
  [SMALL_STATE(1738)] = 46150,
  [SMALL_STATE(1739)] = 46237,
  [SMALL_STATE(1740)] = 46326,
  [SMALL_STATE(1741)] = 46415,
  [SMALL_STATE(1742)] = 46504,
  [SMALL_STATE(1743)] = 46593,
  [SMALL_STATE(1744)] = 46682,
  [SMALL_STATE(1745)] = 46771,
  [SMALL_STATE(1746)] = 46858,
  [SMALL_STATE(1747)] = 46943,
  [SMALL_STATE(1748)] = 47032,
  [SMALL_STATE(1749)] = 47117,
  [SMALL_STATE(1750)] = 47182,
  [SMALL_STATE(1751)] = 47267,
  [SMALL_STATE(1752)] = 47356,
  [SMALL_STATE(1753)] = 47437,
  [SMALL_STATE(1754)] = 47522,
  [SMALL_STATE(1755)] = 47609,
  [SMALL_STATE(1756)] = 47698,
  [SMALL_STATE(1757)] = 47785,
  [SMALL_STATE(1758)] = 47870,
  [SMALL_STATE(1759)] = 47957,
  [SMALL_STATE(1760)] = 48022,
  [SMALL_STATE(1761)] = 48109,
  [SMALL_STATE(1762)] = 48188,
  [SMALL_STATE(1763)] = 48277,
  [SMALL_STATE(1764)] = 48366,
  [SMALL_STATE(1765)] = 48451,
  [SMALL_STATE(1766)] = 48540,
  [SMALL_STATE(1767)] = 48625,
  [SMALL_STATE(1768)] = 48712,
  [SMALL_STATE(1769)] = 48799,
  [SMALL_STATE(1770)] = 48876,
  [SMALL_STATE(1771)] = 48957,
  [SMALL_STATE(1772)] = 49042,
  [SMALL_STATE(1773)] = 49131,
  [SMALL_STATE(1774)] = 49216,
  [SMALL_STATE(1775)] = 49305,
  [SMALL_STATE(1776)] = 49386,
  [SMALL_STATE(1777)] = 49457,
  [SMALL_STATE(1778)] = 49546,
  [SMALL_STATE(1779)] = 49635,
  [SMALL_STATE(1780)] = 49708,
  [SMALL_STATE(1781)] = 49797,
  [SMALL_STATE(1782)] = 49884,
  [SMALL_STATE(1783)] = 49953,
  [SMALL_STATE(1784)] = 50020,
  [SMALL_STATE(1785)] = 50105,
  [SMALL_STATE(1786)] = 50168,
  [SMALL_STATE(1787)] = 50253,
  [SMALL_STATE(1788)] = 50342,
  [SMALL_STATE(1789)] = 50429,
  [SMALL_STATE(1790)] = 50518,
  [SMALL_STATE(1791)] = 50607,
  [SMALL_STATE(1792)] = 50696,
  [SMALL_STATE(1793)] = 50785,
  [SMALL_STATE(1794)] = 50872,
  [SMALL_STATE(1795)] = 50961,
  [SMALL_STATE(1796)] = 51046,
  [SMALL_STATE(1797)] = 51133,
  [SMALL_STATE(1798)] = 51196,
  [SMALL_STATE(1799)] = 51281,
  [SMALL_STATE(1800)] = 51370,
  [SMALL_STATE(1801)] = 51459,
  [SMALL_STATE(1802)] = 51548,
  [SMALL_STATE(1803)] = 51635,
  [SMALL_STATE(1804)] = 51702,
  [SMALL_STATE(1805)] = 51791,
  [SMALL_STATE(1806)] = 51880,
  [SMALL_STATE(1807)] = 51967,
  [SMALL_STATE(1808)] = 52056,
  [SMALL_STATE(1809)] = 52145,
  [SMALL_STATE(1810)] = 52234,
  [SMALL_STATE(1811)] = 52321,
  [SMALL_STATE(1812)] = 52406,
  [SMALL_STATE(1813)] = 52495,
  [SMALL_STATE(1814)] = 52584,
  [SMALL_STATE(1815)] = 52673,
  [SMALL_STATE(1816)] = 52760,
  [SMALL_STATE(1817)] = 52829,
  [SMALL_STATE(1818)] = 52918,
  [SMALL_STATE(1819)] = 53007,
  [SMALL_STATE(1820)] = 53080,
  [SMALL_STATE(1821)] = 53151,
  [SMALL_STATE(1822)] = 53232,
  [SMALL_STATE(1823)] = 53321,
  [SMALL_STATE(1824)] = 53400,
  [SMALL_STATE(1825)] = 53477,
  [SMALL_STATE(1826)] = 53566,
  [SMALL_STATE(1827)] = 53655,
  [SMALL_STATE(1828)] = 53734,
  [SMALL_STATE(1829)] = 53823,
  [SMALL_STATE(1830)] = 53912,
  [SMALL_STATE(1831)] = 54001,
  [SMALL_STATE(1832)] = 54090,
  [SMALL_STATE(1833)] = 54177,
  [SMALL_STATE(1834)] = 54266,
  [SMALL_STATE(1835)] = 54355,
  [SMALL_STATE(1836)] = 54442,
  [SMALL_STATE(1837)] = 54531,
  [SMALL_STATE(1838)] = 54620,
  [SMALL_STATE(1839)] = 54707,
  [SMALL_STATE(1840)] = 54796,
  [SMALL_STATE(1841)] = 54885,
  [SMALL_STATE(1842)] = 54974,
  [SMALL_STATE(1843)] = 55060,
  [SMALL_STATE(1844)] = 55146,
  [SMALL_STATE(1845)] = 55232,
  [SMALL_STATE(1846)] = 55318,
  [SMALL_STATE(1847)] = 55404,
  [SMALL_STATE(1848)] = 55490,
  [SMALL_STATE(1849)] = 55566,
  [SMALL_STATE(1850)] = 55650,
  [SMALL_STATE(1851)] = 55736,
  [SMALL_STATE(1852)] = 55822,
  [SMALL_STATE(1853)] = 55908,
  [SMALL_STATE(1854)] = 55994,
  [SMALL_STATE(1855)] = 56080,
  [SMALL_STATE(1856)] = 56166,
  [SMALL_STATE(1857)] = 56252,
  [SMALL_STATE(1858)] = 56338,
  [SMALL_STATE(1859)] = 56424,
  [SMALL_STATE(1860)] = 56508,
  [SMALL_STATE(1861)] = 56594,
  [SMALL_STATE(1862)] = 56680,
  [SMALL_STATE(1863)] = 56766,
  [SMALL_STATE(1864)] = 56852,
  [SMALL_STATE(1865)] = 56938,
  [SMALL_STATE(1866)] = 57024,
  [SMALL_STATE(1867)] = 57110,
  [SMALL_STATE(1868)] = 57196,
  [SMALL_STATE(1869)] = 57282,
  [SMALL_STATE(1870)] = 57368,
  [SMALL_STATE(1871)] = 57454,
  [SMALL_STATE(1872)] = 57530,
  [SMALL_STATE(1873)] = 57616,
  [SMALL_STATE(1874)] = 57702,
  [SMALL_STATE(1875)] = 57788,
  [SMALL_STATE(1876)] = 57874,
  [SMALL_STATE(1877)] = 57947,
  [SMALL_STATE(1878)] = 58020,
  [SMALL_STATE(1879)] = 58093,
  [SMALL_STATE(1880)] = 58166,
  [SMALL_STATE(1881)] = 58239,
  [SMALL_STATE(1882)] = 58313,
  [SMALL_STATE(1883)] = 58387,
  [SMALL_STATE(1884)] = 58461,
  [SMALL_STATE(1885)] = 58535,
  [SMALL_STATE(1886)] = 58609,
  [SMALL_STATE(1887)] = 58683,
  [SMALL_STATE(1888)] = 58757,
  [SMALL_STATE(1889)] = 58831,
  [SMALL_STATE(1890)] = 58877,
  [SMALL_STATE(1891)] = 58923,
  [SMALL_STATE(1892)] = 58969,
  [SMALL_STATE(1893)] = 59030,
  [SMALL_STATE(1894)] = 59091,
  [SMALL_STATE(1895)] = 59152,
  [SMALL_STATE(1896)] = 59213,
  [SMALL_STATE(1897)] = 59274,
  [SMALL_STATE(1898)] = 59335,
  [SMALL_STATE(1899)] = 59396,
  [SMALL_STATE(1900)] = 59454,
  [SMALL_STATE(1901)] = 59512,
  [SMALL_STATE(1902)] = 59548,
  [SMALL_STATE(1903)] = 59596,
  [SMALL_STATE(1904)] = 59632,
  [SMALL_STATE(1905)] = 59677,
  [SMALL_STATE(1906)] = 59714,
  [SMALL_STATE(1907)] = 59759,
  [SMALL_STATE(1908)] = 59796,
  [SMALL_STATE(1909)] = 59841,
  [SMALL_STATE(1910)] = 59894,
  [SMALL_STATE(1911)] = 59931,
  [SMALL_STATE(1912)] = 59968,
  [SMALL_STATE(1913)] = 60008,
  [SMALL_STATE(1914)] = 60048,
  [SMALL_STATE(1915)] = 60088,
  [SMALL_STATE(1916)] = 60128,
  [SMALL_STATE(1917)] = 60161,
  [SMALL_STATE(1918)] = 60196,
  [SMALL_STATE(1919)] = 60231,
  [SMALL_STATE(1920)] = 60262,
  [SMALL_STATE(1921)] = 60297,
  [SMALL_STATE(1922)] = 60332,
  [SMALL_STATE(1923)] = 60365,
  [SMALL_STATE(1924)] = 60398,
  [SMALL_STATE(1925)] = 60431,
  [SMALL_STATE(1926)] = 60477,
  [SMALL_STATE(1927)] = 60537,
  [SMALL_STATE(1928)] = 60569,
  [SMALL_STATE(1929)] = 60601,
  [SMALL_STATE(1930)] = 60633,
  [SMALL_STATE(1931)] = 60665,
  [SMALL_STATE(1932)] = 60709,
  [SMALL_STATE(1933)] = 60741,
  [SMALL_STATE(1934)] = 60801,
  [SMALL_STATE(1935)] = 60833,
  [SMALL_STATE(1936)] = 60864,
  [SMALL_STATE(1937)] = 60897,
  [SMALL_STATE(1938)] = 60938,
  [SMALL_STATE(1939)] = 60993,
  [SMALL_STATE(1940)] = 61026,
  [SMALL_STATE(1941)] = 61057,
  [SMALL_STATE(1942)] = 61088,
  [SMALL_STATE(1943)] = 61117,
  [SMALL_STATE(1944)] = 61170,
  [SMALL_STATE(1945)] = 61203,
  [SMALL_STATE(1946)] = 61232,
  [SMALL_STATE(1947)] = 61261,
  [SMALL_STATE(1948)] = 61292,
  [SMALL_STATE(1949)] = 61325,
  [SMALL_STATE(1950)] = 61354,
  [SMALL_STATE(1951)] = 61383,
  [SMALL_STATE(1952)] = 61414,
  [SMALL_STATE(1953)] = 61467,
  [SMALL_STATE(1954)] = 61498,
  [SMALL_STATE(1955)] = 61527,
  [SMALL_STATE(1956)] = 61570,
  [SMALL_STATE(1957)] = 61599,
  [SMALL_STATE(1958)] = 61628,
  [SMALL_STATE(1959)] = 61661,
  [SMALL_STATE(1960)] = 61690,
  [SMALL_STATE(1961)] = 61723,
  [SMALL_STATE(1962)] = 61754,
  [SMALL_STATE(1963)] = 61785,
  [SMALL_STATE(1964)] = 61813,
  [SMALL_STATE(1965)] = 61841,
  [SMALL_STATE(1966)] = 61869,
  [SMALL_STATE(1967)] = 61897,
  [SMALL_STATE(1968)] = 61925,
  [SMALL_STATE(1969)] = 61953,
  [SMALL_STATE(1970)] = 61981,
  [SMALL_STATE(1971)] = 62009,
  [SMALL_STATE(1972)] = 62037,
  [SMALL_STATE(1973)] = 62065,
  [SMALL_STATE(1974)] = 62093,
  [SMALL_STATE(1975)] = 62121,
  [SMALL_STATE(1976)] = 62151,
  [SMALL_STATE(1977)] = 62179,
  [SMALL_STATE(1978)] = 62207,
  [SMALL_STATE(1979)] = 62235,
  [SMALL_STATE(1980)] = 62263,
  [SMALL_STATE(1981)] = 62291,
  [SMALL_STATE(1982)] = 62321,
  [SMALL_STATE(1983)] = 62349,
  [SMALL_STATE(1984)] = 62377,
  [SMALL_STATE(1985)] = 62405,
  [SMALL_STATE(1986)] = 62433,
  [SMALL_STATE(1987)] = 62461,
  [SMALL_STATE(1988)] = 62505,
  [SMALL_STATE(1989)] = 62533,
  [SMALL_STATE(1990)] = 62561,
  [SMALL_STATE(1991)] = 62589,
  [SMALL_STATE(1992)] = 62617,
  [SMALL_STATE(1993)] = 62645,
  [SMALL_STATE(1994)] = 62696,
  [SMALL_STATE(1995)] = 62725,
  [SMALL_STATE(1996)] = 62760,
  [SMALL_STATE(1997)] = 62791,
  [SMALL_STATE(1998)] = 62823,
  [SMALL_STATE(1999)] = 62855,
  [SMALL_STATE(2000)] = 62887,
  [SMALL_STATE(2001)] = 62919,
  [SMALL_STATE(2002)] = 62951,
  [SMALL_STATE(2003)] = 62983,
  [SMALL_STATE(2004)] = 63015,
  [SMALL_STATE(2005)] = 63043,
  [SMALL_STATE(2006)] = 63075,
  [SMALL_STATE(2007)] = 63105,
  [SMALL_STATE(2008)] = 63137,
  [SMALL_STATE(2009)] = 63169,
  [SMALL_STATE(2010)] = 63201,
  [SMALL_STATE(2011)] = 63233,
  [SMALL_STATE(2012)] = 63261,
  [SMALL_STATE(2013)] = 63305,
  [SMALL_STATE(2014)] = 63342,
  [SMALL_STATE(2015)] = 63370,
  [SMALL_STATE(2016)] = 63398,
  [SMALL_STATE(2017)] = 63436,
  [SMALL_STATE(2018)] = 63464,
  [SMALL_STATE(2019)] = 63502,
  [SMALL_STATE(2020)] = 63536,
  [SMALL_STATE(2021)] = 63560,
  [SMALL_STATE(2022)] = 63598,
  [SMALL_STATE(2023)] = 63636,
  [SMALL_STATE(2024)] = 63660,
  [SMALL_STATE(2025)] = 63688,
  [SMALL_STATE(2026)] = 63712,
  [SMALL_STATE(2027)] = 63742,
  [SMALL_STATE(2028)] = 63770,
  [SMALL_STATE(2029)] = 63800,
  [SMALL_STATE(2030)] = 63830,
  [SMALL_STATE(2031)] = 63854,
  [SMALL_STATE(2032)] = 63882,
  [SMALL_STATE(2033)] = 63920,
  [SMALL_STATE(2034)] = 63950,
  [SMALL_STATE(2035)] = 63988,
  [SMALL_STATE(2036)] = 64016,
  [SMALL_STATE(2037)] = 64040,
  [SMALL_STATE(2038)] = 64078,
  [SMALL_STATE(2039)] = 64106,
  [SMALL_STATE(2040)] = 64140,
  [SMALL_STATE(2041)] = 64178,
  [SMALL_STATE(2042)] = 64206,
  [SMALL_STATE(2043)] = 64234,
  [SMALL_STATE(2044)] = 64262,
  [SMALL_STATE(2045)] = 64290,
  [SMALL_STATE(2046)] = 64328,
  [SMALL_STATE(2047)] = 64351,
  [SMALL_STATE(2048)] = 64374,
  [SMALL_STATE(2049)] = 64397,
  [SMALL_STATE(2050)] = 64434,
  [SMALL_STATE(2051)] = 64457,
  [SMALL_STATE(2052)] = 64480,
  [SMALL_STATE(2053)] = 64511,
  [SMALL_STATE(2054)] = 64534,
  [SMALL_STATE(2055)] = 64557,
  [SMALL_STATE(2056)] = 64580,
  [SMALL_STATE(2057)] = 64615,
  [SMALL_STATE(2058)] = 64638,
  [SMALL_STATE(2059)] = 64661,
  [SMALL_STATE(2060)] = 64684,
  [SMALL_STATE(2061)] = 64707,
  [SMALL_STATE(2062)] = 64730,
  [SMALL_STATE(2063)] = 64761,
  [SMALL_STATE(2064)] = 64798,
  [SMALL_STATE(2065)] = 64821,
  [SMALL_STATE(2066)] = 64844,
  [SMALL_STATE(2067)] = 64879,
  [SMALL_STATE(2068)] = 64920,
  [SMALL_STATE(2069)] = 64957,
  [SMALL_STATE(2070)] = 64980,
  [SMALL_STATE(2071)] = 65003,
  [SMALL_STATE(2072)] = 65038,
  [SMALL_STATE(2073)] = 65061,
  [SMALL_STATE(2074)] = 65084,
  [SMALL_STATE(2075)] = 65107,
  [SMALL_STATE(2076)] = 65130,
  [SMALL_STATE(2077)] = 65171,
  [SMALL_STATE(2078)] = 65194,
  [SMALL_STATE(2079)] = 65217,
  [SMALL_STATE(2080)] = 65240,
  [SMALL_STATE(2081)] = 65263,
  [SMALL_STATE(2082)] = 65286,
  [SMALL_STATE(2083)] = 65309,
  [SMALL_STATE(2084)] = 65340,
  [SMALL_STATE(2085)] = 65381,
  [SMALL_STATE(2086)] = 65404,
  [SMALL_STATE(2087)] = 65427,
  [SMALL_STATE(2088)] = 65460,
  [SMALL_STATE(2089)] = 65483,
  [SMALL_STATE(2090)] = 65514,
  [SMALL_STATE(2091)] = 65537,
  [SMALL_STATE(2092)] = 65560,
  [SMALL_STATE(2093)] = 65583,
  [SMALL_STATE(2094)] = 65624,
  [SMALL_STATE(2095)] = 65658,
  [SMALL_STATE(2096)] = 65690,
  [SMALL_STATE(2097)] = 65718,
  [SMALL_STATE(2098)] = 65750,
  [SMALL_STATE(2099)] = 65788,
  [SMALL_STATE(2100)] = 65826,
  [SMALL_STATE(2101)] = 65864,
  [SMALL_STATE(2102)] = 65900,
  [SMALL_STATE(2103)] = 65936,
  [SMALL_STATE(2104)] = 65968,
  [SMALL_STATE(2105)] = 66000,
  [SMALL_STATE(2106)] = 66038,
  [SMALL_STATE(2107)] = 66074,
  [SMALL_STATE(2108)] = 66112,
  [SMALL_STATE(2109)] = 66150,
  [SMALL_STATE(2110)] = 66188,
  [SMALL_STATE(2111)] = 66222,
  [SMALL_STATE(2112)] = 66256,
  [SMALL_STATE(2113)] = 66290,
  [SMALL_STATE(2114)] = 66328,
  [SMALL_STATE(2115)] = 66352,
  [SMALL_STATE(2116)] = 66384,
  [SMALL_STATE(2117)] = 66416,
  [SMALL_STATE(2118)] = 66452,
  [SMALL_STATE(2119)] = 66484,
  [SMALL_STATE(2120)] = 66520,
  [SMALL_STATE(2121)] = 66558,
  [SMALL_STATE(2122)] = 66594,
  [SMALL_STATE(2123)] = 66622,
  [SMALL_STATE(2124)] = 66658,
  [SMALL_STATE(2125)] = 66696,
  [SMALL_STATE(2126)] = 66732,
  [SMALL_STATE(2127)] = 66756,
  [SMALL_STATE(2128)] = 66788,
  [SMALL_STATE(2129)] = 66816,
  [SMALL_STATE(2130)] = 66854,
  [SMALL_STATE(2131)] = 66888,
  [SMALL_STATE(2132)] = 66924,
  [SMALL_STATE(2133)] = 66952,
  [SMALL_STATE(2134)] = 66988,
  [SMALL_STATE(2135)] = 67016,
  [SMALL_STATE(2136)] = 67040,
  [SMALL_STATE(2137)] = 67072,
  [SMALL_STATE(2138)] = 67104,
  [SMALL_STATE(2139)] = 67136,
  [SMALL_STATE(2140)] = 67164,
  [SMALL_STATE(2141)] = 67202,
  [SMALL_STATE(2142)] = 67234,
  [SMALL_STATE(2143)] = 67272,
  [SMALL_STATE(2144)] = 67300,
  [SMALL_STATE(2145)] = 67324,
  [SMALL_STATE(2146)] = 67356,
  [SMALL_STATE(2147)] = 67380,
  [SMALL_STATE(2148)] = 67418,
  [SMALL_STATE(2149)] = 67456,
  [SMALL_STATE(2150)] = 67494,
  [SMALL_STATE(2151)] = 67520,
  [SMALL_STATE(2152)] = 67546,
  [SMALL_STATE(2153)] = 67572,
  [SMALL_STATE(2154)] = 67598,
  [SMALL_STATE(2155)] = 67619,
  [SMALL_STATE(2156)] = 67644,
  [SMALL_STATE(2157)] = 67679,
  [SMALL_STATE(2158)] = 67714,
  [SMALL_STATE(2159)] = 67749,
  [SMALL_STATE(2160)] = 67784,
  [SMALL_STATE(2161)] = 67819,
  [SMALL_STATE(2162)] = 67854,
  [SMALL_STATE(2163)] = 67875,
  [SMALL_STATE(2164)] = 67896,
  [SMALL_STATE(2165)] = 67927,
  [SMALL_STATE(2166)] = 67962,
  [SMALL_STATE(2167)] = 67983,
  [SMALL_STATE(2168)] = 68004,
  [SMALL_STATE(2169)] = 68025,
  [SMALL_STATE(2170)] = 68058,
  [SMALL_STATE(2171)] = 68093,
  [SMALL_STATE(2172)] = 68128,
  [SMALL_STATE(2173)] = 68163,
  [SMALL_STATE(2174)] = 68196,
  [SMALL_STATE(2175)] = 68229,
  [SMALL_STATE(2176)] = 68264,
  [SMALL_STATE(2177)] = 68299,
  [SMALL_STATE(2178)] = 68334,
  [SMALL_STATE(2179)] = 68369,
  [SMALL_STATE(2180)] = 68396,
  [SMALL_STATE(2181)] = 68431,
  [SMALL_STATE(2182)] = 68466,
  [SMALL_STATE(2183)] = 68499,
  [SMALL_STATE(2184)] = 68534,
  [SMALL_STATE(2185)] = 68563,
  [SMALL_STATE(2186)] = 68598,
  [SMALL_STATE(2187)] = 68633,
  [SMALL_STATE(2188)] = 68666,
  [SMALL_STATE(2189)] = 68699,
  [SMALL_STATE(2190)] = 68734,
  [SMALL_STATE(2191)] = 68767,
  [SMALL_STATE(2192)] = 68802,
  [SMALL_STATE(2193)] = 68823,
  [SMALL_STATE(2194)] = 68858,
  [SMALL_STATE(2195)] = 68893,
  [SMALL_STATE(2196)] = 68926,
  [SMALL_STATE(2197)] = 68947,
  [SMALL_STATE(2198)] = 68980,
  [SMALL_STATE(2199)] = 69015,
  [SMALL_STATE(2200)] = 69050,
  [SMALL_STATE(2201)] = 69085,
  [SMALL_STATE(2202)] = 69110,
  [SMALL_STATE(2203)] = 69145,
  [SMALL_STATE(2204)] = 69180,
  [SMALL_STATE(2205)] = 69215,
  [SMALL_STATE(2206)] = 69250,
  [SMALL_STATE(2207)] = 69285,
  [SMALL_STATE(2208)] = 69320,
  [SMALL_STATE(2209)] = 69345,
  [SMALL_STATE(2210)] = 69380,
  [SMALL_STATE(2211)] = 69415,
  [SMALL_STATE(2212)] = 69450,
  [SMALL_STATE(2213)] = 69485,
  [SMALL_STATE(2214)] = 69520,
  [SMALL_STATE(2215)] = 69555,
  [SMALL_STATE(2216)] = 69585,
  [SMALL_STATE(2217)] = 69617,
  [SMALL_STATE(2218)] = 69649,
  [SMALL_STATE(2219)] = 69671,
  [SMALL_STATE(2220)] = 69693,
  [SMALL_STATE(2221)] = 69725,
  [SMALL_STATE(2222)] = 69755,
  [SMALL_STATE(2223)] = 69777,
  [SMALL_STATE(2224)] = 69805,
  [SMALL_STATE(2225)] = 69827,
  [SMALL_STATE(2226)] = 69859,
  [SMALL_STATE(2227)] = 69891,
  [SMALL_STATE(2228)] = 69923,
  [SMALL_STATE(2229)] = 69955,
  [SMALL_STATE(2230)] = 69987,
  [SMALL_STATE(2231)] = 70019,
  [SMALL_STATE(2232)] = 70051,
  [SMALL_STATE(2233)] = 70073,
  [SMALL_STATE(2234)] = 70105,
  [SMALL_STATE(2235)] = 70137,
  [SMALL_STATE(2236)] = 70169,
  [SMALL_STATE(2237)] = 70197,
  [SMALL_STATE(2238)] = 70223,
  [SMALL_STATE(2239)] = 70253,
  [SMALL_STATE(2240)] = 70285,
  [SMALL_STATE(2241)] = 70317,
  [SMALL_STATE(2242)] = 70349,
  [SMALL_STATE(2243)] = 70381,
  [SMALL_STATE(2244)] = 70413,
  [SMALL_STATE(2245)] = 70445,
  [SMALL_STATE(2246)] = 70477,
  [SMALL_STATE(2247)] = 70509,
  [SMALL_STATE(2248)] = 70541,
  [SMALL_STATE(2249)] = 70563,
  [SMALL_STATE(2250)] = 70589,
  [SMALL_STATE(2251)] = 70619,
  [SMALL_STATE(2252)] = 70651,
  [SMALL_STATE(2253)] = 70683,
  [SMALL_STATE(2254)] = 70711,
  [SMALL_STATE(2255)] = 70741,
  [SMALL_STATE(2256)] = 70771,
  [SMALL_STATE(2257)] = 70803,
  [SMALL_STATE(2258)] = 70833,
  [SMALL_STATE(2259)] = 70859,
  [SMALL_STATE(2260)] = 70889,
  [SMALL_STATE(2261)] = 70921,
  [SMALL_STATE(2262)] = 70953,
  [SMALL_STATE(2263)] = 70985,
  [SMALL_STATE(2264)] = 71017,
  [SMALL_STATE(2265)] = 71049,
  [SMALL_STATE(2266)] = 71081,
  [SMALL_STATE(2267)] = 71113,
  [SMALL_STATE(2268)] = 71141,
  [SMALL_STATE(2269)] = 71167,
  [SMALL_STATE(2270)] = 71197,
  [SMALL_STATE(2271)] = 71227,
  [SMALL_STATE(2272)] = 71255,
  [SMALL_STATE(2273)] = 71276,
  [SMALL_STATE(2274)] = 71305,
  [SMALL_STATE(2275)] = 71334,
  [SMALL_STATE(2276)] = 71359,
  [SMALL_STATE(2277)] = 71388,
  [SMALL_STATE(2278)] = 71407,
  [SMALL_STATE(2279)] = 71436,
  [SMALL_STATE(2280)] = 71461,
  [SMALL_STATE(2281)] = 71486,
  [SMALL_STATE(2282)] = 71507,
  [SMALL_STATE(2283)] = 71526,
  [SMALL_STATE(2284)] = 71553,
  [SMALL_STATE(2285)] = 71582,
  [SMALL_STATE(2286)] = 71611,
  [SMALL_STATE(2287)] = 71640,
  [SMALL_STATE(2288)] = 71669,
  [SMALL_STATE(2289)] = 71692,
  [SMALL_STATE(2290)] = 71721,
  [SMALL_STATE(2291)] = 71750,
  [SMALL_STATE(2292)] = 71779,
  [SMALL_STATE(2293)] = 71806,
  [SMALL_STATE(2294)] = 71835,
  [SMALL_STATE(2295)] = 71864,
  [SMALL_STATE(2296)] = 71887,
  [SMALL_STATE(2297)] = 71908,
  [SMALL_STATE(2298)] = 71937,
  [SMALL_STATE(2299)] = 71966,
  [SMALL_STATE(2300)] = 71995,
  [SMALL_STATE(2301)] = 72024,
  [SMALL_STATE(2302)] = 72053,
  [SMALL_STATE(2303)] = 72082,
  [SMALL_STATE(2304)] = 72105,
  [SMALL_STATE(2305)] = 72134,
  [SMALL_STATE(2306)] = 72163,
  [SMALL_STATE(2307)] = 72192,
  [SMALL_STATE(2308)] = 72221,
  [SMALL_STATE(2309)] = 72250,
  [SMALL_STATE(2310)] = 72279,
  [SMALL_STATE(2311)] = 72308,
  [SMALL_STATE(2312)] = 72337,
  [SMALL_STATE(2313)] = 72366,
  [SMALL_STATE(2314)] = 72393,
  [SMALL_STATE(2315)] = 72422,
  [SMALL_STATE(2316)] = 72451,
  [SMALL_STATE(2317)] = 72474,
  [SMALL_STATE(2318)] = 72503,
  [SMALL_STATE(2319)] = 72526,
  [SMALL_STATE(2320)] = 72555,
  [SMALL_STATE(2321)] = 72584,
  [SMALL_STATE(2322)] = 72613,
  [SMALL_STATE(2323)] = 72642,
  [SMALL_STATE(2324)] = 72671,
  [SMALL_STATE(2325)] = 72700,
  [SMALL_STATE(2326)] = 72729,
  [SMALL_STATE(2327)] = 72758,
  [SMALL_STATE(2328)] = 72787,
  [SMALL_STATE(2329)] = 72816,
  [SMALL_STATE(2330)] = 72845,
  [SMALL_STATE(2331)] = 72874,
  [SMALL_STATE(2332)] = 72897,
  [SMALL_STATE(2333)] = 72926,
  [SMALL_STATE(2334)] = 72955,
  [SMALL_STATE(2335)] = 72984,
  [SMALL_STATE(2336)] = 73013,
  [SMALL_STATE(2337)] = 73040,
  [SMALL_STATE(2338)] = 73063,
  [SMALL_STATE(2339)] = 73092,
  [SMALL_STATE(2340)] = 73115,
  [SMALL_STATE(2341)] = 73144,
  [SMALL_STATE(2342)] = 73173,
  [SMALL_STATE(2343)] = 73196,
  [SMALL_STATE(2344)] = 73225,
  [SMALL_STATE(2345)] = 73252,
  [SMALL_STATE(2346)] = 73281,
  [SMALL_STATE(2347)] = 73302,
  [SMALL_STATE(2348)] = 73327,
  [SMALL_STATE(2349)] = 73348,
  [SMALL_STATE(2350)] = 73375,
  [SMALL_STATE(2351)] = 73404,
  [SMALL_STATE(2352)] = 73427,
  [SMALL_STATE(2353)] = 73448,
  [SMALL_STATE(2354)] = 73471,
  [SMALL_STATE(2355)] = 73500,
  [SMALL_STATE(2356)] = 73529,
  [SMALL_STATE(2357)] = 73552,
  [SMALL_STATE(2358)] = 73573,
  [SMALL_STATE(2359)] = 73602,
  [SMALL_STATE(2360)] = 73625,
  [SMALL_STATE(2361)] = 73654,
  [SMALL_STATE(2362)] = 73680,
  [SMALL_STATE(2363)] = 73702,
  [SMALL_STATE(2364)] = 73724,
  [SMALL_STATE(2365)] = 73746,
  [SMALL_STATE(2366)] = 73764,
  [SMALL_STATE(2367)] = 73782,
  [SMALL_STATE(2368)] = 73808,
  [SMALL_STATE(2369)] = 73832,
  [SMALL_STATE(2370)] = 73858,
  [SMALL_STATE(2371)] = 73884,
  [SMALL_STATE(2372)] = 73908,
  [SMALL_STATE(2373)] = 73934,
  [SMALL_STATE(2374)] = 73952,
  [SMALL_STATE(2375)] = 73976,
  [SMALL_STATE(2376)] = 73994,
  [SMALL_STATE(2377)] = 74020,
  [SMALL_STATE(2378)] = 74046,
  [SMALL_STATE(2379)] = 74068,
  [SMALL_STATE(2380)] = 74088,
  [SMALL_STATE(2381)] = 74110,
  [SMALL_STATE(2382)] = 74134,
  [SMALL_STATE(2383)] = 74160,
  [SMALL_STATE(2384)] = 74186,
  [SMALL_STATE(2385)] = 74208,
  [SMALL_STATE(2386)] = 74234,
  [SMALL_STATE(2387)] = 74258,
  [SMALL_STATE(2388)] = 74284,
  [SMALL_STATE(2389)] = 74310,
  [SMALL_STATE(2390)] = 74328,
  [SMALL_STATE(2391)] = 74354,
  [SMALL_STATE(2392)] = 74372,
  [SMALL_STATE(2393)] = 74390,
  [SMALL_STATE(2394)] = 74416,
  [SMALL_STATE(2395)] = 74440,
  [SMALL_STATE(2396)] = 74458,
  [SMALL_STATE(2397)] = 74478,
  [SMALL_STATE(2398)] = 74500,
  [SMALL_STATE(2399)] = 74526,
  [SMALL_STATE(2400)] = 74544,
  [SMALL_STATE(2401)] = 74562,
  [SMALL_STATE(2402)] = 74588,
  [SMALL_STATE(2403)] = 74612,
  [SMALL_STATE(2404)] = 74638,
  [SMALL_STATE(2405)] = 74664,
  [SMALL_STATE(2406)] = 74686,
  [SMALL_STATE(2407)] = 74712,
  [SMALL_STATE(2408)] = 74734,
  [SMALL_STATE(2409)] = 74752,
  [SMALL_STATE(2410)] = 74770,
  [SMALL_STATE(2411)] = 74796,
  [SMALL_STATE(2412)] = 74822,
  [SMALL_STATE(2413)] = 74848,
  [SMALL_STATE(2414)] = 74872,
  [SMALL_STATE(2415)] = 74896,
  [SMALL_STATE(2416)] = 74914,
  [SMALL_STATE(2417)] = 74934,
  [SMALL_STATE(2418)] = 74960,
  [SMALL_STATE(2419)] = 74980,
  [SMALL_STATE(2420)] = 75006,
  [SMALL_STATE(2421)] = 75030,
  [SMALL_STATE(2422)] = 75056,
  [SMALL_STATE(2423)] = 75082,
  [SMALL_STATE(2424)] = 75108,
  [SMALL_STATE(2425)] = 75134,
  [SMALL_STATE(2426)] = 75160,
  [SMALL_STATE(2427)] = 75186,
  [SMALL_STATE(2428)] = 75212,
  [SMALL_STATE(2429)] = 75236,
  [SMALL_STATE(2430)] = 75262,
  [SMALL_STATE(2431)] = 75280,
  [SMALL_STATE(2432)] = 75306,
  [SMALL_STATE(2433)] = 75324,
  [SMALL_STATE(2434)] = 75342,
  [SMALL_STATE(2435)] = 75360,
  [SMALL_STATE(2436)] = 75386,
  [SMALL_STATE(2437)] = 75404,
  [SMALL_STATE(2438)] = 75430,
  [SMALL_STATE(2439)] = 75456,
  [SMALL_STATE(2440)] = 75482,
  [SMALL_STATE(2441)] = 75508,
  [SMALL_STATE(2442)] = 75534,
  [SMALL_STATE(2443)] = 75558,
  [SMALL_STATE(2444)] = 75584,
  [SMALL_STATE(2445)] = 75602,
  [SMALL_STATE(2446)] = 75628,
  [SMALL_STATE(2447)] = 75654,
  [SMALL_STATE(2448)] = 75672,
  [SMALL_STATE(2449)] = 75698,
  [SMALL_STATE(2450)] = 75720,
  [SMALL_STATE(2451)] = 75746,
  [SMALL_STATE(2452)] = 75772,
  [SMALL_STATE(2453)] = 75790,
  [SMALL_STATE(2454)] = 75813,
  [SMALL_STATE(2455)] = 75836,
  [SMALL_STATE(2456)] = 75859,
  [SMALL_STATE(2457)] = 75878,
  [SMALL_STATE(2458)] = 75897,
  [SMALL_STATE(2459)] = 75920,
  [SMALL_STATE(2460)] = 75943,
  [SMALL_STATE(2461)] = 75966,
  [SMALL_STATE(2462)] = 75989,
  [SMALL_STATE(2463)] = 76012,
  [SMALL_STATE(2464)] = 76029,
  [SMALL_STATE(2465)] = 76048,
  [SMALL_STATE(2466)] = 76071,
  [SMALL_STATE(2467)] = 76094,
  [SMALL_STATE(2468)] = 76117,
  [SMALL_STATE(2469)] = 76140,
  [SMALL_STATE(2470)] = 76161,
  [SMALL_STATE(2471)] = 76184,
  [SMALL_STATE(2472)] = 76207,
  [SMALL_STATE(2473)] = 76228,
  [SMALL_STATE(2474)] = 76249,
  [SMALL_STATE(2475)] = 76270,
  [SMALL_STATE(2476)] = 76293,
  [SMALL_STATE(2477)] = 76316,
  [SMALL_STATE(2478)] = 76339,
  [SMALL_STATE(2479)] = 76362,
  [SMALL_STATE(2480)] = 76385,
  [SMALL_STATE(2481)] = 76408,
  [SMALL_STATE(2482)] = 76427,
  [SMALL_STATE(2483)] = 76446,
  [SMALL_STATE(2484)] = 76469,
  [SMALL_STATE(2485)] = 76492,
  [SMALL_STATE(2486)] = 76515,
  [SMALL_STATE(2487)] = 76538,
  [SMALL_STATE(2488)] = 76561,
  [SMALL_STATE(2489)] = 76578,
  [SMALL_STATE(2490)] = 76597,
  [SMALL_STATE(2491)] = 76618,
  [SMALL_STATE(2492)] = 76641,
  [SMALL_STATE(2493)] = 76664,
  [SMALL_STATE(2494)] = 76683,
  [SMALL_STATE(2495)] = 76706,
  [SMALL_STATE(2496)] = 76729,
  [SMALL_STATE(2497)] = 76752,
  [SMALL_STATE(2498)] = 76775,
  [SMALL_STATE(2499)] = 76798,
  [SMALL_STATE(2500)] = 76821,
  [SMALL_STATE(2501)] = 76844,
  [SMALL_STATE(2502)] = 76867,
  [SMALL_STATE(2503)] = 76888,
  [SMALL_STATE(2504)] = 76911,
  [SMALL_STATE(2505)] = 76934,
  [SMALL_STATE(2506)] = 76953,
  [SMALL_STATE(2507)] = 76974,
  [SMALL_STATE(2508)] = 76997,
  [SMALL_STATE(2509)] = 77020,
  [SMALL_STATE(2510)] = 77043,
  [SMALL_STATE(2511)] = 77064,
  [SMALL_STATE(2512)] = 77085,
  [SMALL_STATE(2513)] = 77106,
  [SMALL_STATE(2514)] = 77129,
  [SMALL_STATE(2515)] = 77152,
  [SMALL_STATE(2516)] = 77169,
  [SMALL_STATE(2517)] = 77192,
  [SMALL_STATE(2518)] = 77215,
  [SMALL_STATE(2519)] = 77238,
  [SMALL_STATE(2520)] = 77261,
  [SMALL_STATE(2521)] = 77284,
  [SMALL_STATE(2522)] = 77307,
  [SMALL_STATE(2523)] = 77330,
  [SMALL_STATE(2524)] = 77353,
  [SMALL_STATE(2525)] = 77376,
  [SMALL_STATE(2526)] = 77399,
  [SMALL_STATE(2527)] = 77422,
  [SMALL_STATE(2528)] = 77445,
  [SMALL_STATE(2529)] = 77468,
  [SMALL_STATE(2530)] = 77491,
  [SMALL_STATE(2531)] = 77514,
  [SMALL_STATE(2532)] = 77533,
  [SMALL_STATE(2533)] = 77552,
  [SMALL_STATE(2534)] = 77571,
  [SMALL_STATE(2535)] = 77590,
  [SMALL_STATE(2536)] = 77613,
  [SMALL_STATE(2537)] = 77636,
  [SMALL_STATE(2538)] = 77659,
  [SMALL_STATE(2539)] = 77682,
  [SMALL_STATE(2540)] = 77705,
  [SMALL_STATE(2541)] = 77724,
  [SMALL_STATE(2542)] = 77745,
  [SMALL_STATE(2543)] = 77764,
  [SMALL_STATE(2544)] = 77783,
  [SMALL_STATE(2545)] = 77804,
  [SMALL_STATE(2546)] = 77827,
  [SMALL_STATE(2547)] = 77846,
  [SMALL_STATE(2548)] = 77869,
  [SMALL_STATE(2549)] = 77888,
  [SMALL_STATE(2550)] = 77911,
  [SMALL_STATE(2551)] = 77932,
  [SMALL_STATE(2552)] = 77955,
  [SMALL_STATE(2553)] = 77978,
  [SMALL_STATE(2554)] = 78001,
  [SMALL_STATE(2555)] = 78022,
  [SMALL_STATE(2556)] = 78045,
  [SMALL_STATE(2557)] = 78068,
  [SMALL_STATE(2558)] = 78091,
  [SMALL_STATE(2559)] = 78112,
  [SMALL_STATE(2560)] = 78135,
  [SMALL_STATE(2561)] = 78156,
  [SMALL_STATE(2562)] = 78179,
  [SMALL_STATE(2563)] = 78198,
  [SMALL_STATE(2564)] = 78221,
  [SMALL_STATE(2565)] = 78244,
  [SMALL_STATE(2566)] = 78267,
  [SMALL_STATE(2567)] = 78288,
  [SMALL_STATE(2568)] = 78311,
  [SMALL_STATE(2569)] = 78334,
  [SMALL_STATE(2570)] = 78357,
  [SMALL_STATE(2571)] = 78380,
  [SMALL_STATE(2572)] = 78403,
  [SMALL_STATE(2573)] = 78426,
  [SMALL_STATE(2574)] = 78449,
  [SMALL_STATE(2575)] = 78472,
  [SMALL_STATE(2576)] = 78493,
  [SMALL_STATE(2577)] = 78516,
  [SMALL_STATE(2578)] = 78539,
  [SMALL_STATE(2579)] = 78558,
  [SMALL_STATE(2580)] = 78579,
  [SMALL_STATE(2581)] = 78602,
  [SMALL_STATE(2582)] = 78623,
  [SMALL_STATE(2583)] = 78646,
  [SMALL_STATE(2584)] = 78669,
  [SMALL_STATE(2585)] = 78692,
  [SMALL_STATE(2586)] = 78715,
  [SMALL_STATE(2587)] = 78738,
  [SMALL_STATE(2588)] = 78761,
  [SMALL_STATE(2589)] = 78784,
  [SMALL_STATE(2590)] = 78807,
  [SMALL_STATE(2591)] = 78830,
  [SMALL_STATE(2592)] = 78847,
  [SMALL_STATE(2593)] = 78870,
  [SMALL_STATE(2594)] = 78893,
  [SMALL_STATE(2595)] = 78916,
  [SMALL_STATE(2596)] = 78939,
  [SMALL_STATE(2597)] = 78962,
  [SMALL_STATE(2598)] = 78985,
  [SMALL_STATE(2599)] = 79008,
  [SMALL_STATE(2600)] = 79031,
  [SMALL_STATE(2601)] = 79054,
  [SMALL_STATE(2602)] = 79075,
  [SMALL_STATE(2603)] = 79098,
  [SMALL_STATE(2604)] = 79121,
  [SMALL_STATE(2605)] = 79144,
  [SMALL_STATE(2606)] = 79167,
  [SMALL_STATE(2607)] = 79190,
  [SMALL_STATE(2608)] = 79207,
  [SMALL_STATE(2609)] = 79228,
  [SMALL_STATE(2610)] = 79251,
  [SMALL_STATE(2611)] = 79274,
  [SMALL_STATE(2612)] = 79297,
  [SMALL_STATE(2613)] = 79320,
  [SMALL_STATE(2614)] = 79343,
  [SMALL_STATE(2615)] = 79366,
  [SMALL_STATE(2616)] = 79389,
  [SMALL_STATE(2617)] = 79412,
  [SMALL_STATE(2618)] = 79435,
  [SMALL_STATE(2619)] = 79454,
  [SMALL_STATE(2620)] = 79477,
  [SMALL_STATE(2621)] = 79498,
  [SMALL_STATE(2622)] = 79521,
  [SMALL_STATE(2623)] = 79544,
  [SMALL_STATE(2624)] = 79567,
  [SMALL_STATE(2625)] = 79590,
  [SMALL_STATE(2626)] = 79613,
  [SMALL_STATE(2627)] = 79636,
  [SMALL_STATE(2628)] = 79659,
  [SMALL_STATE(2629)] = 79682,
  [SMALL_STATE(2630)] = 79705,
  [SMALL_STATE(2631)] = 79728,
  [SMALL_STATE(2632)] = 79751,
  [SMALL_STATE(2633)] = 79774,
  [SMALL_STATE(2634)] = 79795,
  [SMALL_STATE(2635)] = 79818,
  [SMALL_STATE(2636)] = 79841,
  [SMALL_STATE(2637)] = 79864,
  [SMALL_STATE(2638)] = 79887,
  [SMALL_STATE(2639)] = 79910,
  [SMALL_STATE(2640)] = 79927,
  [SMALL_STATE(2641)] = 79944,
  [SMALL_STATE(2642)] = 79967,
  [SMALL_STATE(2643)] = 79986,
  [SMALL_STATE(2644)] = 80005,
  [SMALL_STATE(2645)] = 80028,
  [SMALL_STATE(2646)] = 80047,
  [SMALL_STATE(2647)] = 80070,
  [SMALL_STATE(2648)] = 80093,
  [SMALL_STATE(2649)] = 80116,
  [SMALL_STATE(2650)] = 80139,
  [SMALL_STATE(2651)] = 80162,
  [SMALL_STATE(2652)] = 80185,
  [SMALL_STATE(2653)] = 80208,
  [SMALL_STATE(2654)] = 80231,
  [SMALL_STATE(2655)] = 80254,
  [SMALL_STATE(2656)] = 80277,
  [SMALL_STATE(2657)] = 80300,
  [SMALL_STATE(2658)] = 80319,
  [SMALL_STATE(2659)] = 80342,
  [SMALL_STATE(2660)] = 80365,
  [SMALL_STATE(2661)] = 80388,
  [SMALL_STATE(2662)] = 80411,
  [SMALL_STATE(2663)] = 80434,
  [SMALL_STATE(2664)] = 80457,
  [SMALL_STATE(2665)] = 80480,
  [SMALL_STATE(2666)] = 80503,
  [SMALL_STATE(2667)] = 80526,
  [SMALL_STATE(2668)] = 80549,
  [SMALL_STATE(2669)] = 80572,
  [SMALL_STATE(2670)] = 80595,
  [SMALL_STATE(2671)] = 80618,
  [SMALL_STATE(2672)] = 80641,
  [SMALL_STATE(2673)] = 80664,
  [SMALL_STATE(2674)] = 80687,
  [SMALL_STATE(2675)] = 80710,
  [SMALL_STATE(2676)] = 80733,
  [SMALL_STATE(2677)] = 80756,
  [SMALL_STATE(2678)] = 80779,
  [SMALL_STATE(2679)] = 80802,
  [SMALL_STATE(2680)] = 80825,
  [SMALL_STATE(2681)] = 80848,
  [SMALL_STATE(2682)] = 80871,
  [SMALL_STATE(2683)] = 80892,
  [SMALL_STATE(2684)] = 80913,
  [SMALL_STATE(2685)] = 80936,
  [SMALL_STATE(2686)] = 80959,
  [SMALL_STATE(2687)] = 80982,
  [SMALL_STATE(2688)] = 81005,
  [SMALL_STATE(2689)] = 81028,
  [SMALL_STATE(2690)] = 81046,
  [SMALL_STATE(2691)] = 81064,
  [SMALL_STATE(2692)] = 81084,
  [SMALL_STATE(2693)] = 81104,
  [SMALL_STATE(2694)] = 81122,
  [SMALL_STATE(2695)] = 81142,
  [SMALL_STATE(2696)] = 81158,
  [SMALL_STATE(2697)] = 81178,
  [SMALL_STATE(2698)] = 81198,
  [SMALL_STATE(2699)] = 81214,
  [SMALL_STATE(2700)] = 81234,
  [SMALL_STATE(2701)] = 81250,
  [SMALL_STATE(2702)] = 81270,
  [SMALL_STATE(2703)] = 81290,
  [SMALL_STATE(2704)] = 81310,
  [SMALL_STATE(2705)] = 81328,
  [SMALL_STATE(2706)] = 81344,
  [SMALL_STATE(2707)] = 81364,
  [SMALL_STATE(2708)] = 81384,
  [SMALL_STATE(2709)] = 81404,
  [SMALL_STATE(2710)] = 81424,
  [SMALL_STATE(2711)] = 81444,
  [SMALL_STATE(2712)] = 81464,
  [SMALL_STATE(2713)] = 81484,
  [SMALL_STATE(2714)] = 81504,
  [SMALL_STATE(2715)] = 81524,
  [SMALL_STATE(2716)] = 81542,
  [SMALL_STATE(2717)] = 81560,
  [SMALL_STATE(2718)] = 81580,
  [SMALL_STATE(2719)] = 81600,
  [SMALL_STATE(2720)] = 81620,
  [SMALL_STATE(2721)] = 81638,
  [SMALL_STATE(2722)] = 81654,
  [SMALL_STATE(2723)] = 81674,
  [SMALL_STATE(2724)] = 81690,
  [SMALL_STATE(2725)] = 81710,
  [SMALL_STATE(2726)] = 81730,
  [SMALL_STATE(2727)] = 81750,
  [SMALL_STATE(2728)] = 81770,
  [SMALL_STATE(2729)] = 81790,
  [SMALL_STATE(2730)] = 81810,
  [SMALL_STATE(2731)] = 81830,
  [SMALL_STATE(2732)] = 81850,
  [SMALL_STATE(2733)] = 81870,
  [SMALL_STATE(2734)] = 81890,
  [SMALL_STATE(2735)] = 81908,
  [SMALL_STATE(2736)] = 81928,
  [SMALL_STATE(2737)] = 81946,
  [SMALL_STATE(2738)] = 81966,
  [SMALL_STATE(2739)] = 81984,
  [SMALL_STATE(2740)] = 82004,
  [SMALL_STATE(2741)] = 82024,
  [SMALL_STATE(2742)] = 82044,
  [SMALL_STATE(2743)] = 82064,
  [SMALL_STATE(2744)] = 82080,
  [SMALL_STATE(2745)] = 82100,
  [SMALL_STATE(2746)] = 82120,
  [SMALL_STATE(2747)] = 82140,
  [SMALL_STATE(2748)] = 82156,
  [SMALL_STATE(2749)] = 82172,
  [SMALL_STATE(2750)] = 82188,
  [SMALL_STATE(2751)] = 82204,
  [SMALL_STATE(2752)] = 82220,
  [SMALL_STATE(2753)] = 82236,
  [SMALL_STATE(2754)] = 82252,
  [SMALL_STATE(2755)] = 82272,
  [SMALL_STATE(2756)] = 82292,
  [SMALL_STATE(2757)] = 82312,
  [SMALL_STATE(2758)] = 82332,
  [SMALL_STATE(2759)] = 82352,
  [SMALL_STATE(2760)] = 82372,
  [SMALL_STATE(2761)] = 82390,
  [SMALL_STATE(2762)] = 82408,
  [SMALL_STATE(2763)] = 82424,
  [SMALL_STATE(2764)] = 82442,
  [SMALL_STATE(2765)] = 82462,
  [SMALL_STATE(2766)] = 82478,
  [SMALL_STATE(2767)] = 82494,
  [SMALL_STATE(2768)] = 82510,
  [SMALL_STATE(2769)] = 82530,
  [SMALL_STATE(2770)] = 82546,
  [SMALL_STATE(2771)] = 82562,
  [SMALL_STATE(2772)] = 82582,
  [SMALL_STATE(2773)] = 82598,
  [SMALL_STATE(2774)] = 82618,
  [SMALL_STATE(2775)] = 82634,
  [SMALL_STATE(2776)] = 82650,
  [SMALL_STATE(2777)] = 82670,
  [SMALL_STATE(2778)] = 82690,
  [SMALL_STATE(2779)] = 82710,
  [SMALL_STATE(2780)] = 82726,
  [SMALL_STATE(2781)] = 82746,
  [SMALL_STATE(2782)] = 82764,
  [SMALL_STATE(2783)] = 82784,
  [SMALL_STATE(2784)] = 82802,
  [SMALL_STATE(2785)] = 82820,
  [SMALL_STATE(2786)] = 82838,
  [SMALL_STATE(2787)] = 82858,
  [SMALL_STATE(2788)] = 82878,
  [SMALL_STATE(2789)] = 82898,
  [SMALL_STATE(2790)] = 82918,
  [SMALL_STATE(2791)] = 82938,
  [SMALL_STATE(2792)] = 82958,
  [SMALL_STATE(2793)] = 82976,
  [SMALL_STATE(2794)] = 82996,
  [SMALL_STATE(2795)] = 83016,
  [SMALL_STATE(2796)] = 83036,
  [SMALL_STATE(2797)] = 83056,
  [SMALL_STATE(2798)] = 83076,
  [SMALL_STATE(2799)] = 83096,
  [SMALL_STATE(2800)] = 83116,
  [SMALL_STATE(2801)] = 83136,
  [SMALL_STATE(2802)] = 83154,
  [SMALL_STATE(2803)] = 83174,
  [SMALL_STATE(2804)] = 83194,
  [SMALL_STATE(2805)] = 83214,
  [SMALL_STATE(2806)] = 83234,
  [SMALL_STATE(2807)] = 83254,
  [SMALL_STATE(2808)] = 83274,
  [SMALL_STATE(2809)] = 83294,
  [SMALL_STATE(2810)] = 83314,
  [SMALL_STATE(2811)] = 83332,
  [SMALL_STATE(2812)] = 83352,
  [SMALL_STATE(2813)] = 83372,
  [SMALL_STATE(2814)] = 83392,
  [SMALL_STATE(2815)] = 83412,
  [SMALL_STATE(2816)] = 83432,
  [SMALL_STATE(2817)] = 83452,
  [SMALL_STATE(2818)] = 83470,
  [SMALL_STATE(2819)] = 83486,
  [SMALL_STATE(2820)] = 83506,
  [SMALL_STATE(2821)] = 83526,
  [SMALL_STATE(2822)] = 83542,
  [SMALL_STATE(2823)] = 83562,
  [SMALL_STATE(2824)] = 83582,
  [SMALL_STATE(2825)] = 83602,
  [SMALL_STATE(2826)] = 83622,
  [SMALL_STATE(2827)] = 83642,
  [SMALL_STATE(2828)] = 83660,
  [SMALL_STATE(2829)] = 83678,
  [SMALL_STATE(2830)] = 83698,
  [SMALL_STATE(2831)] = 83718,
  [SMALL_STATE(2832)] = 83734,
  [SMALL_STATE(2833)] = 83754,
  [SMALL_STATE(2834)] = 83770,
  [SMALL_STATE(2835)] = 83790,
  [SMALL_STATE(2836)] = 83806,
  [SMALL_STATE(2837)] = 83826,
  [SMALL_STATE(2838)] = 83846,
  [SMALL_STATE(2839)] = 83866,
  [SMALL_STATE(2840)] = 83882,
  [SMALL_STATE(2841)] = 83898,
  [SMALL_STATE(2842)] = 83914,
  [SMALL_STATE(2843)] = 83934,
  [SMALL_STATE(2844)] = 83952,
  [SMALL_STATE(2845)] = 83970,
  [SMALL_STATE(2846)] = 83990,
  [SMALL_STATE(2847)] = 84006,
  [SMALL_STATE(2848)] = 84026,
  [SMALL_STATE(2849)] = 84046,
  [SMALL_STATE(2850)] = 84062,
  [SMALL_STATE(2851)] = 84082,
  [SMALL_STATE(2852)] = 84102,
  [SMALL_STATE(2853)] = 84122,
  [SMALL_STATE(2854)] = 84142,
  [SMALL_STATE(2855)] = 84162,
  [SMALL_STATE(2856)] = 84182,
  [SMALL_STATE(2857)] = 84202,
  [SMALL_STATE(2858)] = 84222,
  [SMALL_STATE(2859)] = 84238,
  [SMALL_STATE(2860)] = 84258,
  [SMALL_STATE(2861)] = 84278,
  [SMALL_STATE(2862)] = 84296,
  [SMALL_STATE(2863)] = 84316,
  [SMALL_STATE(2864)] = 84332,
  [SMALL_STATE(2865)] = 84350,
  [SMALL_STATE(2866)] = 84370,
  [SMALL_STATE(2867)] = 84390,
  [SMALL_STATE(2868)] = 84410,
  [SMALL_STATE(2869)] = 84428,
  [SMALL_STATE(2870)] = 84448,
  [SMALL_STATE(2871)] = 84468,
  [SMALL_STATE(2872)] = 84488,
  [SMALL_STATE(2873)] = 84504,
  [SMALL_STATE(2874)] = 84524,
  [SMALL_STATE(2875)] = 84544,
  [SMALL_STATE(2876)] = 84562,
  [SMALL_STATE(2877)] = 84582,
  [SMALL_STATE(2878)] = 84598,
  [SMALL_STATE(2879)] = 84618,
  [SMALL_STATE(2880)] = 84638,
  [SMALL_STATE(2881)] = 84654,
  [SMALL_STATE(2882)] = 84672,
  [SMALL_STATE(2883)] = 84692,
  [SMALL_STATE(2884)] = 84710,
  [SMALL_STATE(2885)] = 84728,
  [SMALL_STATE(2886)] = 84748,
  [SMALL_STATE(2887)] = 84768,
  [SMALL_STATE(2888)] = 84786,
  [SMALL_STATE(2889)] = 84806,
  [SMALL_STATE(2890)] = 84826,
  [SMALL_STATE(2891)] = 84846,
  [SMALL_STATE(2892)] = 84866,
  [SMALL_STATE(2893)] = 84882,
  [SMALL_STATE(2894)] = 84902,
  [SMALL_STATE(2895)] = 84920,
  [SMALL_STATE(2896)] = 84940,
  [SMALL_STATE(2897)] = 84958,
  [SMALL_STATE(2898)] = 84978,
  [SMALL_STATE(2899)] = 84998,
  [SMALL_STATE(2900)] = 85016,
  [SMALL_STATE(2901)] = 85036,
  [SMALL_STATE(2902)] = 85056,
  [SMALL_STATE(2903)] = 85072,
  [SMALL_STATE(2904)] = 85088,
  [SMALL_STATE(2905)] = 85108,
  [SMALL_STATE(2906)] = 85128,
  [SMALL_STATE(2907)] = 85144,
  [SMALL_STATE(2908)] = 85160,
  [SMALL_STATE(2909)] = 85180,
  [SMALL_STATE(2910)] = 85200,
  [SMALL_STATE(2911)] = 85216,
  [SMALL_STATE(2912)] = 85234,
  [SMALL_STATE(2913)] = 85254,
  [SMALL_STATE(2914)] = 85274,
  [SMALL_STATE(2915)] = 85294,
  [SMALL_STATE(2916)] = 85312,
  [SMALL_STATE(2917)] = 85332,
  [SMALL_STATE(2918)] = 85352,
  [SMALL_STATE(2919)] = 85372,
  [SMALL_STATE(2920)] = 85390,
  [SMALL_STATE(2921)] = 85408,
  [SMALL_STATE(2922)] = 85426,
  [SMALL_STATE(2923)] = 85444,
  [SMALL_STATE(2924)] = 85464,
  [SMALL_STATE(2925)] = 85482,
  [SMALL_STATE(2926)] = 85502,
  [SMALL_STATE(2927)] = 85522,
  [SMALL_STATE(2928)] = 85542,
  [SMALL_STATE(2929)] = 85562,
  [SMALL_STATE(2930)] = 85582,
  [SMALL_STATE(2931)] = 85602,
  [SMALL_STATE(2932)] = 85622,
  [SMALL_STATE(2933)] = 85642,
  [SMALL_STATE(2934)] = 85660,
  [SMALL_STATE(2935)] = 85680,
  [SMALL_STATE(2936)] = 85700,
  [SMALL_STATE(2937)] = 85720,
  [SMALL_STATE(2938)] = 85740,
  [SMALL_STATE(2939)] = 85760,
  [SMALL_STATE(2940)] = 85780,
  [SMALL_STATE(2941)] = 85796,
  [SMALL_STATE(2942)] = 85816,
  [SMALL_STATE(2943)] = 85836,
  [SMALL_STATE(2944)] = 85856,
  [SMALL_STATE(2945)] = 85876,
  [SMALL_STATE(2946)] = 85896,
  [SMALL_STATE(2947)] = 85916,
  [SMALL_STATE(2948)] = 85934,
  [SMALL_STATE(2949)] = 85954,
  [SMALL_STATE(2950)] = 85974,
  [SMALL_STATE(2951)] = 85994,
  [SMALL_STATE(2952)] = 86010,
  [SMALL_STATE(2953)] = 86030,
  [SMALL_STATE(2954)] = 86050,
  [SMALL_STATE(2955)] = 86070,
  [SMALL_STATE(2956)] = 86090,
  [SMALL_STATE(2957)] = 86110,
  [SMALL_STATE(2958)] = 86130,
  [SMALL_STATE(2959)] = 86150,
  [SMALL_STATE(2960)] = 86166,
  [SMALL_STATE(2961)] = 86186,
  [SMALL_STATE(2962)] = 86202,
  [SMALL_STATE(2963)] = 86218,
  [SMALL_STATE(2964)] = 86238,
  [SMALL_STATE(2965)] = 86258,
  [SMALL_STATE(2966)] = 86278,
  [SMALL_STATE(2967)] = 86298,
  [SMALL_STATE(2968)] = 86314,
  [SMALL_STATE(2969)] = 86334,
  [SMALL_STATE(2970)] = 86350,
  [SMALL_STATE(2971)] = 86370,
  [SMALL_STATE(2972)] = 86390,
  [SMALL_STATE(2973)] = 86410,
  [SMALL_STATE(2974)] = 86428,
  [SMALL_STATE(2975)] = 86446,
  [SMALL_STATE(2976)] = 86462,
  [SMALL_STATE(2977)] = 86479,
  [SMALL_STATE(2978)] = 86494,
  [SMALL_STATE(2979)] = 86511,
  [SMALL_STATE(2980)] = 86528,
  [SMALL_STATE(2981)] = 86545,
  [SMALL_STATE(2982)] = 86562,
  [SMALL_STATE(2983)] = 86577,
  [SMALL_STATE(2984)] = 86594,
  [SMALL_STATE(2985)] = 86611,
  [SMALL_STATE(2986)] = 86628,
  [SMALL_STATE(2987)] = 86645,
  [SMALL_STATE(2988)] = 86662,
  [SMALL_STATE(2989)] = 86679,
  [SMALL_STATE(2990)] = 86696,
  [SMALL_STATE(2991)] = 86713,
  [SMALL_STATE(2992)] = 86730,
  [SMALL_STATE(2993)] = 86745,
  [SMALL_STATE(2994)] = 86762,
  [SMALL_STATE(2995)] = 86779,
  [SMALL_STATE(2996)] = 86796,
  [SMALL_STATE(2997)] = 86813,
  [SMALL_STATE(2998)] = 86830,
  [SMALL_STATE(2999)] = 86847,
  [SMALL_STATE(3000)] = 86864,
  [SMALL_STATE(3001)] = 86881,
  [SMALL_STATE(3002)] = 86898,
  [SMALL_STATE(3003)] = 86915,
  [SMALL_STATE(3004)] = 86932,
  [SMALL_STATE(3005)] = 86947,
  [SMALL_STATE(3006)] = 86964,
  [SMALL_STATE(3007)] = 86981,
  [SMALL_STATE(3008)] = 86998,
  [SMALL_STATE(3009)] = 87015,
  [SMALL_STATE(3010)] = 87032,
  [SMALL_STATE(3011)] = 87049,
  [SMALL_STATE(3012)] = 87066,
  [SMALL_STATE(3013)] = 87083,
  [SMALL_STATE(3014)] = 87100,
  [SMALL_STATE(3015)] = 87117,
  [SMALL_STATE(3016)] = 87134,
  [SMALL_STATE(3017)] = 87151,
  [SMALL_STATE(3018)] = 87168,
  [SMALL_STATE(3019)] = 87183,
  [SMALL_STATE(3020)] = 87200,
  [SMALL_STATE(3021)] = 87215,
  [SMALL_STATE(3022)] = 87230,
  [SMALL_STATE(3023)] = 87247,
  [SMALL_STATE(3024)] = 87264,
  [SMALL_STATE(3025)] = 87279,
  [SMALL_STATE(3026)] = 87296,
  [SMALL_STATE(3027)] = 87313,
  [SMALL_STATE(3028)] = 87328,
  [SMALL_STATE(3029)] = 87345,
  [SMALL_STATE(3030)] = 87362,
  [SMALL_STATE(3031)] = 87379,
  [SMALL_STATE(3032)] = 87396,
  [SMALL_STATE(3033)] = 87413,
  [SMALL_STATE(3034)] = 87430,
  [SMALL_STATE(3035)] = 87447,
  [SMALL_STATE(3036)] = 87464,
  [SMALL_STATE(3037)] = 87481,
  [SMALL_STATE(3038)] = 87498,
  [SMALL_STATE(3039)] = 87515,
  [SMALL_STATE(3040)] = 87530,
  [SMALL_STATE(3041)] = 87547,
  [SMALL_STATE(3042)] = 87564,
  [SMALL_STATE(3043)] = 87581,
  [SMALL_STATE(3044)] = 87598,
  [SMALL_STATE(3045)] = 87615,
  [SMALL_STATE(3046)] = 87632,
  [SMALL_STATE(3047)] = 87649,
  [SMALL_STATE(3048)] = 87664,
  [SMALL_STATE(3049)] = 87681,
  [SMALL_STATE(3050)] = 87696,
  [SMALL_STATE(3051)] = 87713,
  [SMALL_STATE(3052)] = 87728,
  [SMALL_STATE(3053)] = 87743,
  [SMALL_STATE(3054)] = 87760,
  [SMALL_STATE(3055)] = 87777,
  [SMALL_STATE(3056)] = 87794,
  [SMALL_STATE(3057)] = 87811,
  [SMALL_STATE(3058)] = 87828,
  [SMALL_STATE(3059)] = 87845,
  [SMALL_STATE(3060)] = 87860,
  [SMALL_STATE(3061)] = 87877,
  [SMALL_STATE(3062)] = 87892,
  [SMALL_STATE(3063)] = 87909,
  [SMALL_STATE(3064)] = 87926,
  [SMALL_STATE(3065)] = 87941,
  [SMALL_STATE(3066)] = 87958,
  [SMALL_STATE(3067)] = 87975,
  [SMALL_STATE(3068)] = 87992,
  [SMALL_STATE(3069)] = 88009,
  [SMALL_STATE(3070)] = 88026,
  [SMALL_STATE(3071)] = 88043,
  [SMALL_STATE(3072)] = 88058,
  [SMALL_STATE(3073)] = 88075,
  [SMALL_STATE(3074)] = 88092,
  [SMALL_STATE(3075)] = 88109,
  [SMALL_STATE(3076)] = 88124,
  [SMALL_STATE(3077)] = 88139,
  [SMALL_STATE(3078)] = 88156,
  [SMALL_STATE(3079)] = 88173,
  [SMALL_STATE(3080)] = 88190,
  [SMALL_STATE(3081)] = 88207,
  [SMALL_STATE(3082)] = 88224,
  [SMALL_STATE(3083)] = 88241,
  [SMALL_STATE(3084)] = 88258,
  [SMALL_STATE(3085)] = 88275,
  [SMALL_STATE(3086)] = 88290,
  [SMALL_STATE(3087)] = 88305,
  [SMALL_STATE(3088)] = 88322,
  [SMALL_STATE(3089)] = 88337,
  [SMALL_STATE(3090)] = 88354,
  [SMALL_STATE(3091)] = 88369,
  [SMALL_STATE(3092)] = 88386,
  [SMALL_STATE(3093)] = 88403,
  [SMALL_STATE(3094)] = 88420,
  [SMALL_STATE(3095)] = 88437,
  [SMALL_STATE(3096)] = 88452,
  [SMALL_STATE(3097)] = 88469,
  [SMALL_STATE(3098)] = 88486,
  [SMALL_STATE(3099)] = 88503,
  [SMALL_STATE(3100)] = 88520,
  [SMALL_STATE(3101)] = 88537,
  [SMALL_STATE(3102)] = 88552,
  [SMALL_STATE(3103)] = 88569,
  [SMALL_STATE(3104)] = 88586,
  [SMALL_STATE(3105)] = 88603,
  [SMALL_STATE(3106)] = 88620,
  [SMALL_STATE(3107)] = 88637,
  [SMALL_STATE(3108)] = 88654,
  [SMALL_STATE(3109)] = 88671,
  [SMALL_STATE(3110)] = 88688,
  [SMALL_STATE(3111)] = 88703,
  [SMALL_STATE(3112)] = 88720,
  [SMALL_STATE(3113)] = 88735,
  [SMALL_STATE(3114)] = 88750,
  [SMALL_STATE(3115)] = 88765,
  [SMALL_STATE(3116)] = 88782,
  [SMALL_STATE(3117)] = 88799,
  [SMALL_STATE(3118)] = 88816,
  [SMALL_STATE(3119)] = 88833,
  [SMALL_STATE(3120)] = 88850,
  [SMALL_STATE(3121)] = 88867,
  [SMALL_STATE(3122)] = 88884,
  [SMALL_STATE(3123)] = 88901,
  [SMALL_STATE(3124)] = 88916,
  [SMALL_STATE(3125)] = 88933,
  [SMALL_STATE(3126)] = 88950,
  [SMALL_STATE(3127)] = 88965,
  [SMALL_STATE(3128)] = 88982,
  [SMALL_STATE(3129)] = 88999,
  [SMALL_STATE(3130)] = 89014,
  [SMALL_STATE(3131)] = 89031,
  [SMALL_STATE(3132)] = 89046,
  [SMALL_STATE(3133)] = 89063,
  [SMALL_STATE(3134)] = 89080,
  [SMALL_STATE(3135)] = 89097,
  [SMALL_STATE(3136)] = 89114,
  [SMALL_STATE(3137)] = 89131,
  [SMALL_STATE(3138)] = 89148,
  [SMALL_STATE(3139)] = 89165,
  [SMALL_STATE(3140)] = 89180,
  [SMALL_STATE(3141)] = 89197,
  [SMALL_STATE(3142)] = 89214,
  [SMALL_STATE(3143)] = 89231,
  [SMALL_STATE(3144)] = 89248,
  [SMALL_STATE(3145)] = 89263,
  [SMALL_STATE(3146)] = 89278,
  [SMALL_STATE(3147)] = 89295,
  [SMALL_STATE(3148)] = 89312,
  [SMALL_STATE(3149)] = 89329,
  [SMALL_STATE(3150)] = 89346,
  [SMALL_STATE(3151)] = 89363,
  [SMALL_STATE(3152)] = 89378,
  [SMALL_STATE(3153)] = 89395,
  [SMALL_STATE(3154)] = 89412,
  [SMALL_STATE(3155)] = 89429,
  [SMALL_STATE(3156)] = 89446,
  [SMALL_STATE(3157)] = 89463,
  [SMALL_STATE(3158)] = 89480,
  [SMALL_STATE(3159)] = 89497,
  [SMALL_STATE(3160)] = 89514,
  [SMALL_STATE(3161)] = 89531,
  [SMALL_STATE(3162)] = 89548,
  [SMALL_STATE(3163)] = 89565,
  [SMALL_STATE(3164)] = 89582,
  [SMALL_STATE(3165)] = 89599,
  [SMALL_STATE(3166)] = 89616,
  [SMALL_STATE(3167)] = 89633,
  [SMALL_STATE(3168)] = 89650,
  [SMALL_STATE(3169)] = 89667,
  [SMALL_STATE(3170)] = 89684,
  [SMALL_STATE(3171)] = 89701,
  [SMALL_STATE(3172)] = 89718,
  [SMALL_STATE(3173)] = 89735,
  [SMALL_STATE(3174)] = 89752,
  [SMALL_STATE(3175)] = 89769,
  [SMALL_STATE(3176)] = 89786,
  [SMALL_STATE(3177)] = 89801,
  [SMALL_STATE(3178)] = 89818,
  [SMALL_STATE(3179)] = 89835,
  [SMALL_STATE(3180)] = 89852,
  [SMALL_STATE(3181)] = 89869,
  [SMALL_STATE(3182)] = 89886,
  [SMALL_STATE(3183)] = 89903,
  [SMALL_STATE(3184)] = 89920,
  [SMALL_STATE(3185)] = 89937,
  [SMALL_STATE(3186)] = 89954,
  [SMALL_STATE(3187)] = 89971,
  [SMALL_STATE(3188)] = 89988,
  [SMALL_STATE(3189)] = 90005,
  [SMALL_STATE(3190)] = 90022,
  [SMALL_STATE(3191)] = 90039,
  [SMALL_STATE(3192)] = 90056,
  [SMALL_STATE(3193)] = 90073,
  [SMALL_STATE(3194)] = 90090,
  [SMALL_STATE(3195)] = 90107,
  [SMALL_STATE(3196)] = 90124,
  [SMALL_STATE(3197)] = 90141,
  [SMALL_STATE(3198)] = 90158,
  [SMALL_STATE(3199)] = 90175,
  [SMALL_STATE(3200)] = 90192,
  [SMALL_STATE(3201)] = 90209,
  [SMALL_STATE(3202)] = 90226,
  [SMALL_STATE(3203)] = 90243,
  [SMALL_STATE(3204)] = 90260,
  [SMALL_STATE(3205)] = 90277,
  [SMALL_STATE(3206)] = 90294,
  [SMALL_STATE(3207)] = 90311,
  [SMALL_STATE(3208)] = 90328,
  [SMALL_STATE(3209)] = 90343,
  [SMALL_STATE(3210)] = 90360,
  [SMALL_STATE(3211)] = 90377,
  [SMALL_STATE(3212)] = 90394,
  [SMALL_STATE(3213)] = 90411,
  [SMALL_STATE(3214)] = 90428,
  [SMALL_STATE(3215)] = 90445,
  [SMALL_STATE(3216)] = 90460,
  [SMALL_STATE(3217)] = 90477,
  [SMALL_STATE(3218)] = 90494,
  [SMALL_STATE(3219)] = 90511,
  [SMALL_STATE(3220)] = 90528,
  [SMALL_STATE(3221)] = 90545,
  [SMALL_STATE(3222)] = 90562,
  [SMALL_STATE(3223)] = 90579,
  [SMALL_STATE(3224)] = 90596,
  [SMALL_STATE(3225)] = 90611,
  [SMALL_STATE(3226)] = 90628,
  [SMALL_STATE(3227)] = 90645,
  [SMALL_STATE(3228)] = 90662,
  [SMALL_STATE(3229)] = 90679,
  [SMALL_STATE(3230)] = 90696,
  [SMALL_STATE(3231)] = 90713,
  [SMALL_STATE(3232)] = 90730,
  [SMALL_STATE(3233)] = 90747,
  [SMALL_STATE(3234)] = 90764,
  [SMALL_STATE(3235)] = 90779,
  [SMALL_STATE(3236)] = 90796,
  [SMALL_STATE(3237)] = 90813,
  [SMALL_STATE(3238)] = 90830,
  [SMALL_STATE(3239)] = 90847,
  [SMALL_STATE(3240)] = 90864,
  [SMALL_STATE(3241)] = 90878,
  [SMALL_STATE(3242)] = 90892,
  [SMALL_STATE(3243)] = 90906,
  [SMALL_STATE(3244)] = 90920,
  [SMALL_STATE(3245)] = 90934,
  [SMALL_STATE(3246)] = 90948,
  [SMALL_STATE(3247)] = 90962,
  [SMALL_STATE(3248)] = 90976,
  [SMALL_STATE(3249)] = 90990,
  [SMALL_STATE(3250)] = 91004,
  [SMALL_STATE(3251)] = 91018,
  [SMALL_STATE(3252)] = 91032,
  [SMALL_STATE(3253)] = 91046,
  [SMALL_STATE(3254)] = 91060,
  [SMALL_STATE(3255)] = 91074,
  [SMALL_STATE(3256)] = 91088,
  [SMALL_STATE(3257)] = 91102,
  [SMALL_STATE(3258)] = 91116,
  [SMALL_STATE(3259)] = 91130,
  [SMALL_STATE(3260)] = 91144,
  [SMALL_STATE(3261)] = 91158,
  [SMALL_STATE(3262)] = 91172,
  [SMALL_STATE(3263)] = 91186,
  [SMALL_STATE(3264)] = 91200,
  [SMALL_STATE(3265)] = 91214,
  [SMALL_STATE(3266)] = 91228,
  [SMALL_STATE(3267)] = 91242,
  [SMALL_STATE(3268)] = 91256,
  [SMALL_STATE(3269)] = 91270,
  [SMALL_STATE(3270)] = 91284,
  [SMALL_STATE(3271)] = 91298,
  [SMALL_STATE(3272)] = 91312,
  [SMALL_STATE(3273)] = 91326,
  [SMALL_STATE(3274)] = 91340,
  [SMALL_STATE(3275)] = 91354,
  [SMALL_STATE(3276)] = 91368,
  [SMALL_STATE(3277)] = 91382,
  [SMALL_STATE(3278)] = 91396,
  [SMALL_STATE(3279)] = 91410,
  [SMALL_STATE(3280)] = 91424,
  [SMALL_STATE(3281)] = 91438,
  [SMALL_STATE(3282)] = 91452,
  [SMALL_STATE(3283)] = 91466,
  [SMALL_STATE(3284)] = 91480,
  [SMALL_STATE(3285)] = 91494,
  [SMALL_STATE(3286)] = 91508,
  [SMALL_STATE(3287)] = 91522,
  [SMALL_STATE(3288)] = 91536,
  [SMALL_STATE(3289)] = 91550,
  [SMALL_STATE(3290)] = 91564,
  [SMALL_STATE(3291)] = 91578,
  [SMALL_STATE(3292)] = 91592,
  [SMALL_STATE(3293)] = 91606,
  [SMALL_STATE(3294)] = 91620,
  [SMALL_STATE(3295)] = 91634,
  [SMALL_STATE(3296)] = 91648,
  [SMALL_STATE(3297)] = 91662,
  [SMALL_STATE(3298)] = 91676,
  [SMALL_STATE(3299)] = 91690,
  [SMALL_STATE(3300)] = 91704,
  [SMALL_STATE(3301)] = 91718,
  [SMALL_STATE(3302)] = 91732,
  [SMALL_STATE(3303)] = 91746,
  [SMALL_STATE(3304)] = 91760,
  [SMALL_STATE(3305)] = 91774,
  [SMALL_STATE(3306)] = 91788,
  [SMALL_STATE(3307)] = 91802,
  [SMALL_STATE(3308)] = 91816,
  [SMALL_STATE(3309)] = 91830,
  [SMALL_STATE(3310)] = 91844,
  [SMALL_STATE(3311)] = 91858,
  [SMALL_STATE(3312)] = 91872,
  [SMALL_STATE(3313)] = 91886,
  [SMALL_STATE(3314)] = 91900,
  [SMALL_STATE(3315)] = 91914,
  [SMALL_STATE(3316)] = 91928,
  [SMALL_STATE(3317)] = 91942,
  [SMALL_STATE(3318)] = 91956,
  [SMALL_STATE(3319)] = 91970,
  [SMALL_STATE(3320)] = 91984,
  [SMALL_STATE(3321)] = 91998,
  [SMALL_STATE(3322)] = 92012,
  [SMALL_STATE(3323)] = 92026,
  [SMALL_STATE(3324)] = 92040,
  [SMALL_STATE(3325)] = 92054,
  [SMALL_STATE(3326)] = 92068,
  [SMALL_STATE(3327)] = 92082,
  [SMALL_STATE(3328)] = 92096,
  [SMALL_STATE(3329)] = 92110,
  [SMALL_STATE(3330)] = 92124,
  [SMALL_STATE(3331)] = 92138,
  [SMALL_STATE(3332)] = 92152,
  [SMALL_STATE(3333)] = 92166,
  [SMALL_STATE(3334)] = 92180,
  [SMALL_STATE(3335)] = 92194,
  [SMALL_STATE(3336)] = 92208,
  [SMALL_STATE(3337)] = 92222,
  [SMALL_STATE(3338)] = 92236,
  [SMALL_STATE(3339)] = 92250,
  [SMALL_STATE(3340)] = 92264,
  [SMALL_STATE(3341)] = 92278,
  [SMALL_STATE(3342)] = 92292,
  [SMALL_STATE(3343)] = 92306,
  [SMALL_STATE(3344)] = 92320,
  [SMALL_STATE(3345)] = 92334,
  [SMALL_STATE(3346)] = 92348,
  [SMALL_STATE(3347)] = 92362,
  [SMALL_STATE(3348)] = 92376,
  [SMALL_STATE(3349)] = 92390,
  [SMALL_STATE(3350)] = 92404,
  [SMALL_STATE(3351)] = 92418,
  [SMALL_STATE(3352)] = 92432,
  [SMALL_STATE(3353)] = 92446,
  [SMALL_STATE(3354)] = 92460,
  [SMALL_STATE(3355)] = 92474,
  [SMALL_STATE(3356)] = 92488,
  [SMALL_STATE(3357)] = 92502,
  [SMALL_STATE(3358)] = 92516,
  [SMALL_STATE(3359)] = 92530,
  [SMALL_STATE(3360)] = 92544,
  [SMALL_STATE(3361)] = 92558,
  [SMALL_STATE(3362)] = 92572,
  [SMALL_STATE(3363)] = 92586,
  [SMALL_STATE(3364)] = 92600,
  [SMALL_STATE(3365)] = 92614,
  [SMALL_STATE(3366)] = 92628,
  [SMALL_STATE(3367)] = 92642,
  [SMALL_STATE(3368)] = 92656,
  [SMALL_STATE(3369)] = 92670,
  [SMALL_STATE(3370)] = 92684,
  [SMALL_STATE(3371)] = 92698,
  [SMALL_STATE(3372)] = 92712,
  [SMALL_STATE(3373)] = 92726,
  [SMALL_STATE(3374)] = 92740,
  [SMALL_STATE(3375)] = 92754,
  [SMALL_STATE(3376)] = 92768,
  [SMALL_STATE(3377)] = 92782,
  [SMALL_STATE(3378)] = 92796,
  [SMALL_STATE(3379)] = 92810,
  [SMALL_STATE(3380)] = 92824,
  [SMALL_STATE(3381)] = 92838,
  [SMALL_STATE(3382)] = 92852,
  [SMALL_STATE(3383)] = 92866,
  [SMALL_STATE(3384)] = 92880,
  [SMALL_STATE(3385)] = 92894,
  [SMALL_STATE(3386)] = 92908,
  [SMALL_STATE(3387)] = 92922,
  [SMALL_STATE(3388)] = 92936,
  [SMALL_STATE(3389)] = 92950,
  [SMALL_STATE(3390)] = 92964,
  [SMALL_STATE(3391)] = 92978,
  [SMALL_STATE(3392)] = 92992,
  [SMALL_STATE(3393)] = 93006,
  [SMALL_STATE(3394)] = 93020,
  [SMALL_STATE(3395)] = 93034,
  [SMALL_STATE(3396)] = 93048,
  [SMALL_STATE(3397)] = 93062,
  [SMALL_STATE(3398)] = 93076,
  [SMALL_STATE(3399)] = 93090,
  [SMALL_STATE(3400)] = 93104,
  [SMALL_STATE(3401)] = 93118,
  [SMALL_STATE(3402)] = 93132,
  [SMALL_STATE(3403)] = 93146,
  [SMALL_STATE(3404)] = 93160,
  [SMALL_STATE(3405)] = 93174,
  [SMALL_STATE(3406)] = 93188,
  [SMALL_STATE(3407)] = 93202,
  [SMALL_STATE(3408)] = 93216,
  [SMALL_STATE(3409)] = 93230,
  [SMALL_STATE(3410)] = 93244,
  [SMALL_STATE(3411)] = 93258,
  [SMALL_STATE(3412)] = 93272,
  [SMALL_STATE(3413)] = 93286,
  [SMALL_STATE(3414)] = 93300,
  [SMALL_STATE(3415)] = 93314,
  [SMALL_STATE(3416)] = 93328,
  [SMALL_STATE(3417)] = 93342,
  [SMALL_STATE(3418)] = 93356,
  [SMALL_STATE(3419)] = 93370,
  [SMALL_STATE(3420)] = 93384,
  [SMALL_STATE(3421)] = 93398,
  [SMALL_STATE(3422)] = 93412,
  [SMALL_STATE(3423)] = 93426,
  [SMALL_STATE(3424)] = 93440,
  [SMALL_STATE(3425)] = 93454,
  [SMALL_STATE(3426)] = 93468,
  [SMALL_STATE(3427)] = 93482,
  [SMALL_STATE(3428)] = 93496,
  [SMALL_STATE(3429)] = 93510,
  [SMALL_STATE(3430)] = 93524,
  [SMALL_STATE(3431)] = 93538,
  [SMALL_STATE(3432)] = 93552,
  [SMALL_STATE(3433)] = 93566,
  [SMALL_STATE(3434)] = 93580,
  [SMALL_STATE(3435)] = 93594,
  [SMALL_STATE(3436)] = 93608,
  [SMALL_STATE(3437)] = 93622,
  [SMALL_STATE(3438)] = 93636,
  [SMALL_STATE(3439)] = 93650,
  [SMALL_STATE(3440)] = 93664,
  [SMALL_STATE(3441)] = 93678,
  [SMALL_STATE(3442)] = 93692,
  [SMALL_STATE(3443)] = 93706,
  [SMALL_STATE(3444)] = 93720,
  [SMALL_STATE(3445)] = 93734,
  [SMALL_STATE(3446)] = 93748,
  [SMALL_STATE(3447)] = 93762,
  [SMALL_STATE(3448)] = 93776,
  [SMALL_STATE(3449)] = 93790,
  [SMALL_STATE(3450)] = 93804,
  [SMALL_STATE(3451)] = 93818,
  [SMALL_STATE(3452)] = 93832,
  [SMALL_STATE(3453)] = 93846,
  [SMALL_STATE(3454)] = 93860,
  [SMALL_STATE(3455)] = 93874,
  [SMALL_STATE(3456)] = 93888,
  [SMALL_STATE(3457)] = 93902,
  [SMALL_STATE(3458)] = 93916,
  [SMALL_STATE(3459)] = 93930,
  [SMALL_STATE(3460)] = 93944,
  [SMALL_STATE(3461)] = 93958,
  [SMALL_STATE(3462)] = 93972,
  [SMALL_STATE(3463)] = 93986,
  [SMALL_STATE(3464)] = 94000,
  [SMALL_STATE(3465)] = 94014,
  [SMALL_STATE(3466)] = 94028,
  [SMALL_STATE(3467)] = 94042,
  [SMALL_STATE(3468)] = 94056,
  [SMALL_STATE(3469)] = 94070,
  [SMALL_STATE(3470)] = 94084,
  [SMALL_STATE(3471)] = 94098,
  [SMALL_STATE(3472)] = 94112,
  [SMALL_STATE(3473)] = 94126,
  [SMALL_STATE(3474)] = 94140,
  [SMALL_STATE(3475)] = 94154,
  [SMALL_STATE(3476)] = 94168,
  [SMALL_STATE(3477)] = 94182,
  [SMALL_STATE(3478)] = 94196,
  [SMALL_STATE(3479)] = 94210,
  [SMALL_STATE(3480)] = 94224,
  [SMALL_STATE(3481)] = 94238,
  [SMALL_STATE(3482)] = 94252,
  [SMALL_STATE(3483)] = 94266,
  [SMALL_STATE(3484)] = 94280,
  [SMALL_STATE(3485)] = 94294,
  [SMALL_STATE(3486)] = 94308,
  [SMALL_STATE(3487)] = 94322,
  [SMALL_STATE(3488)] = 94336,
  [SMALL_STATE(3489)] = 94350,
  [SMALL_STATE(3490)] = 94364,
  [SMALL_STATE(3491)] = 94378,
  [SMALL_STATE(3492)] = 94392,
  [SMALL_STATE(3493)] = 94406,
  [SMALL_STATE(3494)] = 94420,
  [SMALL_STATE(3495)] = 94434,
  [SMALL_STATE(3496)] = 94448,
  [SMALL_STATE(3497)] = 94462,
  [SMALL_STATE(3498)] = 94476,
  [SMALL_STATE(3499)] = 94490,
  [SMALL_STATE(3500)] = 94504,
  [SMALL_STATE(3501)] = 94518,
  [SMALL_STATE(3502)] = 94532,
  [SMALL_STATE(3503)] = 94546,
  [SMALL_STATE(3504)] = 94560,
  [SMALL_STATE(3505)] = 94574,
  [SMALL_STATE(3506)] = 94588,
  [SMALL_STATE(3507)] = 94602,
  [SMALL_STATE(3508)] = 94616,
  [SMALL_STATE(3509)] = 94630,
  [SMALL_STATE(3510)] = 94644,
  [SMALL_STATE(3511)] = 94658,
  [SMALL_STATE(3512)] = 94672,
  [SMALL_STATE(3513)] = 94686,
  [SMALL_STATE(3514)] = 94700,
  [SMALL_STATE(3515)] = 94714,
  [SMALL_STATE(3516)] = 94728,
  [SMALL_STATE(3517)] = 94742,
  [SMALL_STATE(3518)] = 94756,
  [SMALL_STATE(3519)] = 94770,
  [SMALL_STATE(3520)] = 94784,
  [SMALL_STATE(3521)] = 94798,
  [SMALL_STATE(3522)] = 94812,
  [SMALL_STATE(3523)] = 94816,
  [SMALL_STATE(3524)] = 94820,
  [SMALL_STATE(3525)] = 94824,
  [SMALL_STATE(3526)] = 94828,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1473),
  [164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(518),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2693),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(87),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(76),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(205),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1451),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2984),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(155),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2985),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(864),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(790),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3520),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2039),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(39),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2019),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1054),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1040),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3429),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3059),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(832),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(89),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(862),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(825),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2466),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(283),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3426),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1962),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(36),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2314),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3414),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3413),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3412),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1503),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2013),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1880),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(105),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2026),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(41),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(42),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3069),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2497),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1112),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2473),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1290),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1457),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3388),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1981),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1457),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 2),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 2),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 1),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 1),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 1),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 1),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3386),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1045),
  [536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(87),
  [539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(76),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2),
  [544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(3),
  [547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(205),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1451),
  [553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2984),
  [556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(155),
  [559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(3356),
  [562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(864),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(790),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(3520),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2417),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(39),
  [577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2485),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1054),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1389),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(835),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(100),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2547),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(220),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(36),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2755),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2486),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(88),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(41),
  [613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(42),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(3069),
  [619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2549),
  [622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1112),
  [625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(2473),
  [628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1290),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1457),
  [634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(3388),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT(1457),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, .production_id = 29),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, .production_id = 29),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1045),
  [767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(87),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(76),
  [775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(3),
  [778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(205),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1451),
  [784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2984),
  [787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(155),
  [790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(864),
  [793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(790),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(3520),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2417),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(39),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2485),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1054),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1389),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(835),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(100),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2547),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(220),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(36),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2755),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2486),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(88),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(41),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(42),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(3069),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2549),
  [850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1112),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2473),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1290),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1457),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(3388),
  [865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1457),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 5),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 5),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 6),
  [892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 6),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 5, .production_id = 113),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 5, .production_id = 113),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 2),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 2),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_block, 2, .production_id = 8),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_block, 2, .production_id = 8),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delim_token_tree, 3),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delim_token_tree, 3),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, .production_id = 42),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, .production_id = 42),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 2, .production_id = 8),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 2, .production_id = 8),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_except_range, 1),
  [950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_except_range, 1),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 3, .production_id = 37),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 3, .production_id = 37),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_block, 2),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_block, 2),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_block, 2),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_block, 2),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, .production_id = 32),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, .production_id = 32),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 4, .production_id = 96),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 4, .production_id = 96),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7, .production_id = 236),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7, .production_id = 236),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, .production_id = 27),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, .production_id = 27),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 3),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 3),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, .production_id = 72),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, .production_id = 72),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, .production_id = 141),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, .production_id = 141),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delim_token_tree, 2),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delim_token_tree, 2),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [1130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(436),
  [1133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(426),
  [1136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(348),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2),
  [1141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(351),
  [1144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(354),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(426),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(3247),
  [1153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(439),
  [1156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2558),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(432),
  [1162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(425),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(453),
  [1236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(452),
  [1239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(378),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2),
  [1244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(360),
  [1247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(375),
  [1250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(452),
  [1253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(453),
  [1256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(451),
  [1259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(2620),
  [1262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 2), SHIFT_REPEAT(455),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(441),
  [1272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(426),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(368),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2),
  [1280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(403),
  [1283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(405),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(426),
  [1289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(3348),
  [1292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(439),
  [1295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(2558),
  [1298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(432),
  [1301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(441),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_pattern, 1),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_pattern, 1),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 1),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 1),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2),
  [1438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2), SHIFT_REPEAT(426),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2),
  [1443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2), SHIFT_REPEAT(426),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 3),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 3),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 1),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 1),
  [1456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__non_special_token_repeat1, 2), SHIFT_REPEAT(452),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__non_special_token_repeat1, 2), SHIFT_REPEAT(452),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__non_delim_token, 1),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__non_delim_token, 1),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 5),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 5),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 2),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 2),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 2),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 2),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fragment_specifier, 1),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fragment_specifier, 1),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 6),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 6),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_binding_pattern, 3, .production_id = 192),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_binding_pattern, 3, .production_id = 192),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [1498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 5),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 5),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 4),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 4),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 6),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 6),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 1),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 1),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 4),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 4),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 3),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 3),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__delim_tokens, 1),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delim_tokens, 1),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_delim_token_tree_repeat1, 1),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_delim_token_tree_repeat1, 1),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 3),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 3),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 3, .production_id = 167),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 3, .production_id = 167),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, .production_id = 114),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, .production_id = 114),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [1638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2012),
  [1641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(775),
  [1644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(792),
  [1647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2249),
  [1650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2721),
  [1653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(3095),
  [1656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(3146),
  [1659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(834),
  [1662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(3356),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(864),
  [1668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(790),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2619),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2071),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2871),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(836),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(816),
  [1686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2723),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(3140),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2272),
  [1695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2575),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2357),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2579),
  [1704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2579),
  [1707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 82),
  [1709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 82),
  [1711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 110),
  [1713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 110),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 9, .production_id = 264),
  [1717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 9, .production_id = 264),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, .production_id = 270),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, .production_id = 270),
  [1723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, .production_id = 106),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, .production_id = 106),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 9, .production_id = 263),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 9, .production_id = 263),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, .production_id = 261),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, .production_id = 261),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, .production_id = 86),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, .production_id = 86),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3258),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3252),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, .production_id = 5),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, .production_id = 5),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3, .production_id = 36),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 3, .production_id = 36),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, .production_id = 269),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, .production_id = 269),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 6, .production_id = 170),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 6, .production_id = 170),
  [1813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3),
  [1815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3),
  [1817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3, .production_id = 43),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3, .production_id = 43),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 262),
  [1823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 262),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 5, .production_id = 108),
  [1827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 5, .production_id = 108),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, .production_id = 268),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, .production_id = 268),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 121),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 121),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 120),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 120),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 261),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 261),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 260),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 260),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 233),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 233),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 10, .production_id = 271),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 10, .production_id = 271),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 8, .production_id = 259),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 8, .production_id = 259),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 8, .production_id = 228),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 8, .production_id = 228),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 175),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 175),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, .production_id = 258),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, .production_id = 258),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 8, .production_id = 245),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 8, .production_id = 245),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 257),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 257),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 226),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 226),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 256),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 256),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, .production_id = 267),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, .production_id = 267),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 255),
  [1895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 255),
  [1897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 254),
  [1899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 254),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 222),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 222),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 253),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 253),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 220),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 220),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, .production_id = 255),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, .production_id = 255),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 3, .production_id = 28),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 3, .production_id = 28),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, .production_id = 127),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, .production_id = 127),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 252),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 252),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 119),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 119),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 251),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 251),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 3, .production_id = 5),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 3, .production_id = 5),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 3, .production_id = 28),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 3, .production_id = 28),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, .production_id = 176),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, .production_id = 176),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 76),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 76),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 118),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 118),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, .production_id = 28),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, .production_id = 28),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 86),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 86),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 117),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 117),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, .production_id = 52),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, .production_id = 52),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, .production_id = 266),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, .production_id = 266),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, .production_id = 122),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, .production_id = 122),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 250),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 250),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, .production_id = 114),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, .production_id = 114),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 249),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 249),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 28),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 28),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, .production_id = 4),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, .production_id = 4),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 69),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 69),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 248),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 248),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 218),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 218),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 109),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 109),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 247),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 247),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, .production_id = 33),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, .production_id = 33),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, .production_id = 4),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, .production_id = 4),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 216),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 216),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 6),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 6),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 93),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 93),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 3, .production_id = 31),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 3, .production_id = 31),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, .production_id = 92),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, .production_id = 92),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, .production_id = 91),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, .production_id = 91),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, .production_id = 166),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, .production_id = 166),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, .production_id = 30),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, .production_id = 30),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, .production_id = 18),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, .production_id = 18),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, .production_id = 86),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, .production_id = 86),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 125),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 125),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2, .production_id = 8),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2, .production_id = 8),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, .production_id = 251),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, .production_id = 251),
  [2085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3207),
  [2088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1280),
  [2091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2716),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [2096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3389),
  [2099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3090),
  [2102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3053),
  [2105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(864),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2277),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2219),
  [2114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2208),
  [2117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3258),
  [2120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3052),
  [2123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(857),
  [2126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(819),
  [2129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3252),
  [2132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1962),
  [2135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2732),
  [2138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3251),
  [2141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3249),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3383),
  [2147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2727),
  [2150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2201),
  [2153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1876),
  [2156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2033),
  [2159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3244),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1975),
  [2165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3244),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [2170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [2172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 4),
  [2174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 4),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 3, .production_id = 28),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 3, .production_id = 28),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, .production_id = 265),
  [2182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, .production_id = 265),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 9, .production_id = 249),
  [2186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 9, .production_id = 249),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 129),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 129),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, .production_id = 245),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, .production_id = 245),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 109),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 109),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 10, .production_id = 272),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 10, .production_id = 272),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 177),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 177),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 178),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 178),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 126),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 126),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 5, .production_id = 127),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 5, .production_id = 127),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 179),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 179),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 180),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 180),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 10, .production_id = 268),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 10, .production_id = 268),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 6, .production_id = 181),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 6, .production_id = 181),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, .production_id = 112),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, .production_id = 112),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 183),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 183),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, .production_id = 70),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, .production_id = 70),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 10, .production_id = 273),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 10, .production_id = 273),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, .production_id = 244),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, .production_id = 244),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, .production_id = 243),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, .production_id = 243),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 5, .production_id = 128),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 5, .production_id = 128),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 4, .production_id = 91),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 4, .production_id = 91),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, .production_id = 242),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, .production_id = 242),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, .production_id = 165),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, .production_id = 165),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, .production_id = 111),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, .production_id = 111),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 241),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 241),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, .production_id = 109),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, .production_id = 109),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 184),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 184),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, .production_id = 110),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, .production_id = 110),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 206),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 206),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 240),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 240),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 204),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 204),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 239),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 239),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 199),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 199),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, .production_id = 109),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, .production_id = 109),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 129),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 129),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 130),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 130),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 6),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 6),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 136),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 136),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 185),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 185),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 56),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 56),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 6, .production_id = 170),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 6, .production_id = 170),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 6, .production_id = 179),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 6, .production_id = 179),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 131),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 131),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 132),
  [2364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 132),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 3),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 3),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 133),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 133),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 86),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 86),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 134),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 134),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 179),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 179),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 86),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 86),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 235),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 235),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, .production_id = 186),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, .production_id = 186),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 190),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 190),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 234),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 234),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 85),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 85),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 56),
  [2412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 56),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 233),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 233),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 5, .production_id = 108),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 5, .production_id = 108),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 134),
  [2424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 134),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 7, .production_id = 232),
  [2428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 7, .production_id = 232),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4, .production_id = 94),
  [2432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 4, .production_id = 94),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 231),
  [2436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 231),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, .production_id = 136),
  [2440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, .production_id = 136),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 69),
  [2444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 69),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 230),
  [2448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 230),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 229),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 229),
  [2454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, .production_id = 228),
  [2456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, .production_id = 228),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, .production_id = 186),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, .production_id = 186),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 7, .production_id = 134),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 7, .production_id = 134),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 6, .production_id = 179),
  [2468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 6, .production_id = 179),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 227),
  [2472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 227),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 226),
  [2476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 226),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 225),
  [2480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 225),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 183),
  [2484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 183),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 187),
  [2488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 187),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, .production_id = 137),
  [2492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, .production_id = 137),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, .production_id = 132),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, .production_id = 132),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, .production_id = 134),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, .production_id = 134),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 224),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 224),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 223),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 223),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 222),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 222),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 188),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 188),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 189),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 189),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 86),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 86),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 190),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 190),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 132),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 132),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 138),
  [2538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 138),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, .production_id = 69),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, .production_id = 69),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 221),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 221),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 220),
  [2552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 220),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, .production_id = 68),
  [2556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, .production_id = 68),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 191),
  [2560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 191),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 219),
  [2564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 219),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2),
  [2568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 134),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 134),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 2),
  [2576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 2),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, .production_id = 82),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, .production_id = 82),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, .production_id = 84),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, .production_id = 84),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, .production_id = 52),
  [2588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, .production_id = 52),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 69),
  [2592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 69),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, .production_id = 132),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, .production_id = 132),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, .production_id = 164),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, .production_id = 164),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, .production_id = 134),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, .production_id = 134),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 218),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 218),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 139),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 139),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 5, .production_id = 140),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 5, .production_id = 140),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 217),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 217),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 216),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 216),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, .production_id = 176),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, .production_id = 176),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 83),
  [2636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 83),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 68),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 68),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 163),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 163),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, .production_id = 68),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, .production_id = 68),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, .production_id = 69),
  [2652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, .production_id = 69),
  [2654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 120),
  [2656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 120),
  [2658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 162),
  [2660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 162),
  [2662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 4, .production_id = 70),
  [2664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 4, .production_id = 70),
  [2666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 161),
  [2668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 161),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 160),
  [2672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 160),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 4, .production_id = 71),
  [2676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 4, .production_id = 71),
  [2678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, .production_id = 52),
  [2680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, .production_id = 52),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 69),
  [2684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 69),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, .production_id = 196),
  [2688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, .production_id = 196),
  [2690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, .production_id = 4),
  [2692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, .production_id = 4),
  [2694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 68),
  [2696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 68),
  [2698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 159),
  [2700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 159),
  [2702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 28),
  [2704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 28),
  [2706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, .production_id = 52),
  [2708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, .production_id = 52),
  [2710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, .production_id = 213),
  [2712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, .production_id = 213),
  [2714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 158),
  [2716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 158),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, .production_id = 4),
  [2720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, .production_id = 4),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 117),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 117),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, .production_id = 4),
  [2732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, .production_id = 4),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 157),
  [2736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 157),
  [2738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, .production_id = 212),
  [2740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, .production_id = 212),
  [2742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [2744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, .production_id = 211),
  [2748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, .production_id = 211),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 156),
  [2752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 156),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, .production_id = 210),
  [2756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, .production_id = 210),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 155),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 155),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 209),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 209),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 154),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 154),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 76),
  [2772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 76),
  [2774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 77),
  [2776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 77),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 161),
  [2780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 161),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 153),
  [2784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 153),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 18),
  [2788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 18),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 78),
  [2792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 78),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 208),
  [2796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 208),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 4, .production_id = 79),
  [2800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 4, .production_id = 79),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 152),
  [2804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 152),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 151),
  [2808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 151),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 159),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 159),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 207),
  [2816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 207),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 206),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 206),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 7, .production_id = 196),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 7, .production_id = 196),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 205),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 205),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 204),
  [2832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 204),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 203),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 203),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 156),
  [2840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 156),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 202),
  [2844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 202),
  [2846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 154),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 154),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 201),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 201),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 152),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 152),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 200),
  [2864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 200),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 199),
  [2868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 199),
  [2870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inner_attribute_item, 5),
  [2872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inner_attribute_item, 5),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 4),
  [2876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 4),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 5),
  [2880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 5),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [2970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 1),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 1),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [3060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [3100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [3128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [3146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 2),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 2),
  [3150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 4),
  [3152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 4),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lifetime, 2),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lifetime, 2),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 7),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [3164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, .production_id = 7),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 4, .production_id = 101),
  [3174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 4, .production_id = 101),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [3178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, .production_id = 21),
  [3180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, .production_id = 21),
  [3182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, .production_id = 21),
  [3184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, .production_id = 21),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, .production_id = 22),
  [3188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, .production_id = 22),
  [3190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 39),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 39),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 38),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 38),
  [3198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 4, .production_id = 102),
  [3200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 4, .production_id = 102),
  [3202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, .production_id = 22),
  [3204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, .production_id = 22),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 2, .production_id = 5),
  [3208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 2, .production_id = 5),
  [3210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, .production_id = 4),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2, .production_id = 4),
  [3214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 45),
  [3220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 45),
  [3222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 44),
  [3224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 44),
  [3226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 16),
  [3228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 16),
  [3230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 15),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 15),
  [3234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, .production_id = 167),
  [3236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, .production_id = 167),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, .production_id = 167),
  [3240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 5, .production_id = 114),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 5, .production_id = 114),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 5, .production_id = 114),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_except_range, 1, .production_id = 1),
  [3248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_except_range, 1, .production_id = 1),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [3254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [3262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .production_id = 39),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .production_id = 45),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 48),
  [3272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 48),
  [3274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 49),
  [3276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 49),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 1),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 1),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .production_id = 16),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 1),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 1),
  [3296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 19),
  [3306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 19),
  [3308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 20),
  [3310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 20),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 6),
  [3316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 6),
  [3318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 23),
  [3320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 23),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 24),
  [3326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 24),
  [3328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 25),
  [3330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 25),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 26),
  [3336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 26),
  [3338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 2, .production_id = 5),
  [3340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [3342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5),
  [3370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 57),
  [3374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 57),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 59),
  [3384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 59),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 60),
  [3390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 60),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 104),
  [3396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 104),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [3402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [3404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [3408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [3412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 6, .production_id = 171),
  [3416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 6, .production_id = 171),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_function, 3, .production_id = 40),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, .production_id = 41),
  [3422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_function, 3, .production_id = 40),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, .production_id = 143),
  [3430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 5, .production_id = 143),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, .production_id = 145),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, .production_id = 145),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, .production_id = 146),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, .production_id = 146),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, .production_id = 147),
  [3446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, .production_id = 147),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 2),
  [3450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 2),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 4),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 4),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 105),
  [3458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 105),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 103),
  [3462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 103),
  [3464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 100),
  [3466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 100),
  [3468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 4, .production_id = 99),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 4, .production_id = 99),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 12),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 12),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6),
  [3486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6, .production_id = 142),
  [3490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6, .production_id = 142),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 46),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 46),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 3),
  [3514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 3),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 3, .production_id = 50),
  [3518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 3, .production_id = 50),
  [3520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2),
  [3522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, .production_id = 51),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bounded_type, 3),
  [3528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bounded_type, 3),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, .production_id = 194),
  [3532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, .production_id = 194),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5, .production_id = 97),
  [3540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5, .production_id = 97),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 3, .production_id = 56),
  [3544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 3, .production_id = 56),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 3, .production_id = 56),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 3, .production_id = 56),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5),
  [3552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, .production_id = 55),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, .production_id = 55),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 3, .production_id = 34),
  [3564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 3, .production_id = 34),
  [3566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4),
  [3568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4),
  [3570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 4),
  [3572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 4),
  [3574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, .production_id = 10),
  [3576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, .production_id = 10),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2),
  [3580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 2),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 6),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 6),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 3, .production_id = 17),
  [3588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 3, .production_id = 17),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, .production_id = 95),
  [3592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, .production_id = 95),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4),
  [3596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4),
  [3598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 2, .production_id = 6),
  [3600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 2, .production_id = 6),
  [3602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, .production_id = 11),
  [3604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, .production_id = 11),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_type, 1),
  [3612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_type, 1),
  [3614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 5),
  [3616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 5),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3),
  [3620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 3),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 5, .production_id = 124),
  [3624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 5, .production_id = 124),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [3628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [3630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2),
  [3632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 2, .production_id = 18),
  [3636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 2, .production_id = 18),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 7),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 7),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 7),
  [3646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 7),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 2),
  [3650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 2),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_type, 2),
  [3654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_type, 2),
  [3656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3),
  [3658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3),
  [3660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [3662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [3664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_expression, 2),
  [3666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_expression, 2),
  [3668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 2, .production_id = 13),
  [3670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 2, .production_id = 13),
  [3672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, .production_id = 81),
  [3674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, .production_id = 81),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, .production_id = 73),
  [3688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, .production_id = 73),
  [3690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, .production_id = 73),
  [3692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, .production_id = 73),
  [3694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [3696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [3698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [3700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [3702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, .production_id = 73),
  [3704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, .production_id = 73),
  [3706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [3708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [3712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(3453),
  [3715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [3717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [3721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [3723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [3725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [3727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_expr, 3, .production_id = 46),
  [3757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_expr, 3, .production_id = 46),
  [3759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 2),
  [3765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 2),
  [3767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 3),
  [3769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 3),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 47),
  [3773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 47),
  [3775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [3781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [3783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [3785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3182),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2543),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 4),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 4),
  [3957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [3961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [3965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5, .production_id = 123),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5, .production_id = 123),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5),
  [3973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [4003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 3),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [4041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [4047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, .production_id = 182),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_condition, 4, .production_id = 114),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [4129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, .production_id = 135),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, .production_id = 197),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, .production_id = 198),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 3, .production_id = 167),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, .production_id = 114),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [4173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_field_initializer, 2),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [4181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 5, .production_id = 238),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_chain, 3),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, .production_id = 150),
  [4219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__condition, 1),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [4259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 98),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 17),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [4309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 5),
  [4311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 5),
  [4313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 6),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 6),
  [4317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 4),
  [4319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 4),
  [4321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [4323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [4331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3136),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [4339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [4357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, .production_id = 1),
  [4375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, .production_id = 1),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 7), REDUCE(sym__pattern, 1),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [4492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 38), REDUCE(sym_scoped_type_identifier, 3, .production_id = 39),
  [4495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, .production_id = 4), REDUCE(sym_scoped_type_identifier, 2, .production_id = 5),
  [4498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 44), REDUCE(sym_scoped_type_identifier, 3, .production_id = 45),
  [4501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 15), REDUCE(sym_scoped_type_identifier, 3, .production_id = 16),
  [4504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negative_literal, 2),
  [4506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negative_literal, 2),
  [4508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal_pattern, 1),
  [4510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal_pattern, 1),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 1),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 1),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 61),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 61),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [4546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 1),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 65),
  [4562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 65),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3),
  [4572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [4582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3),
  [4584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 4),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, .production_id = 62),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4),
  [4602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, .production_id = 62),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [4606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2),
  [4608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, .production_id = 63),
  [4610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, .production_id = 63),
  [4612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5),
  [4614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, .production_id = 62),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, .production_id = 62),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 2),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [4634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 5),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 3),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [4646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, .production_id = 62),
  [4648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, .production_id = 62),
  [4650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 2, .production_id = 1),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [4656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 2),
  [4658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 3),
  [4660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, .production_id = 63),
  [4662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 2),
  [4664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, .production_id = 62),
  [4666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, .production_id = 62),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [4676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_pattern, 2),
  [4678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, .production_id = 63),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [4682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remaining_field_pattern, 1),
  [4684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_captured_pattern, 3),
  [4686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mut_pattern, 2),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [4696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(352),
  [4699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2),
  [4701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(339),
  [4704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(350),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym__pattern, 1, .production_id = 1),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2),
  [4812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(817),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [4823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 2),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 3),
  [4833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_removed_trait_bound, 2),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(2277),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2),
  [4898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(2155),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_modifiers, 1),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [4929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higher_ranked_trait_bound, 3, .production_id = 76),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 2),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [4979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [4981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [4989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 1, .production_id = 67),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 1),
  [5013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [5035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [5041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, .production_id = 4),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [5053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 1),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [5077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 2),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 3),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [5123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 2), REDUCE(sym_tuple_struct_pattern, 3, .production_id = 62),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [5154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 3), REDUCE(sym_tuple_struct_pattern, 4, .production_id = 62),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [5205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [5211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, .production_id = 1),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [5217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_unit_type, 2), REDUCE(sym_tuple_pattern, 2),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [5248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym__pattern, 1),
  [5251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2),
  [5253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2), SHIFT_REPEAT(1448),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [5258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1), SHIFT(1954),
  [5261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1), SHIFT(330),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3, .production_id = 18),
  [5284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, .production_id = 56),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [5290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, .production_id = 18),
  [5296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, .production_id = 172),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, .production_id = 73),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, .production_id = 99),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [5354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 56),
  [5356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 214),
  [5358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 172),
  [5360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 99),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [5364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 2),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [5378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, .production_id = 214),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 7, .production_id = 246),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, .production_id = 246),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [5408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [5450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), REDUCE(aux_sym_for_lifetimes_repeat1, 2),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [5455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [5457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(2892),
  [5460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 3),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [5468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(118),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [5503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [5505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [5507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [5509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [5535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [5549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 66),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [5561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [5567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [5573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_rule, 3, .production_id = 47),
  [5575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [5589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [5635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [5643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [5653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, .production_id = 74),
  [5655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, .production_id = 75),
  [5657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 106),
  [5659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_pattern_repeat1, 2),
  [5661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_pattern_repeat1, 2), SHIFT_REPEAT(837),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [5718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_parameter, 4, .production_id = 108),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [5754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 5, .production_id = 237),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [5778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 215),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [5792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 3, .production_id = 56),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [5810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [5812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [5816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 4),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [5826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 1),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [5846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [5860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3, .production_id = 1),
  [5862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 2, .production_id = 35),
  [5864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, .production_id = 87),
  [5866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, .production_id = 88),
  [5868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3),
  [5870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, .production_id = 89),
  [5872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, .production_id = 90),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [5888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 4, .production_id = 193),
  [5890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 2),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [5894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2),
  [5896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 4, .production_id = 195),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 5),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [5924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [5926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2207),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 174),
  [5933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, .production_id = 173),
  [5935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, .production_id = 173), SHIFT_REPEAT(789),
  [5938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, .production_id = 18),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [5958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [5994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, .production_id = 33),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [6008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2),
  [6010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2), SHIFT_REPEAT(2199),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [6023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__condition, 1, .production_id = 9),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [6039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [6041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(938),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [6056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [6068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, .production_id = 64),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [6074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2),
  [6076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2), SHIFT_REPEAT(2283),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [6083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, .production_id = 149),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [6097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2), SHIFT_REPEAT(3080),
  [6100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [6104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 1),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [6112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(338),
  [6115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2), SHIFT_REPEAT(781),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [6120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2), SHIFT_REPEAT(803),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [6131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [6141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 4, .production_id = 99),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [6145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 2, .production_id = 107),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [6153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, .production_id = 11),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [6169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(502),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [6182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, .production_id = 115),
  [6184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 3, .production_id = 144),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3260),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3261),
  [6192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2195),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [6203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, .production_id = 116),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [6233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, .production_id = 148),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [6245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, .production_id = 74),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [6265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, .production_id = 75),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [6285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [6287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(2164),
  [6290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [6292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1877),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 4),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [6299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [6305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [6311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [6313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [6315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [6329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [6331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [6335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [6337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [6341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [6343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [6345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [6347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [6351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [6353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [6359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [6361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [6363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [6365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [6371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [6373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [6381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [6385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [6387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [6389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 3),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [6395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 3),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [6409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [6417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [6423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [6425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [6433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [6447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1, .production_id = 80),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [6457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [6459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [6465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3365),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [6493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, .production_id = 58),
  [6497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [6575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, .production_id = 168),
  [6577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, .production_id = 169),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 54),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [6613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 53),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [6703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_doc_comment, 1, .production_id = 2),
  [6705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_doc_comment, 1, .production_id = 3),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [6713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__line_doc_comment, 1, .production_id = 3),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [6717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__line_doc_comment, 1, .production_id = 2),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [6739] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [6795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_type, 3),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [6949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 3),
  [6951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 3, .production_id = 14),
  [6953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 2),
  [6955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2),
  [6957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, .production_id = 14),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__string_content = 0,
  ts_external_token_raw_string_literal = 1,
  ts_external_token_float_literal = 2,
  ts_external_token__outer_block_doc_comment = 3,
  ts_external_token__inner_block_doc_comment = 4,
  ts_external_token_STAR_SLASH = 5,
  ts_external_token__error_sentinel = 6,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_raw_string_literal] = sym_raw_string_literal,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token__outer_block_doc_comment] = sym__outer_block_doc_comment,
  [ts_external_token__inner_block_doc_comment] = sym__inner_block_doc_comment,
  [ts_external_token_STAR_SLASH] = anon_sym_STAR_SLASH,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_raw_string_literal] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token__outer_block_doc_comment] = true,
    [ts_external_token__inner_block_doc_comment] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token_raw_string_literal] = true,
    [ts_external_token_float_literal] = true,
  },
  [3] = {
    [ts_external_token__outer_block_doc_comment] = true,
    [ts_external_token__inner_block_doc_comment] = true,
    [ts_external_token_STAR_SLASH] = true,
  },
  [4] = {
    [ts_external_token__string_content] = true,
  },
  [5] = {
    [ts_external_token_float_literal] = true,
  },
  [6] = {
    [ts_external_token_STAR_SLASH] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rust_external_scanner_create(void);
void tree_sitter_rust_external_scanner_destroy(void *);
bool tree_sitter_rust_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rust_external_scanner_serialize(void *, char *);
void tree_sitter_rust_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_rust() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_rust_external_scanner_create,
      tree_sitter_rust_external_scanner_destroy,
      tree_sitter_rust_external_scanner_scan,
      tree_sitter_rust_external_scanner_serialize,
      tree_sitter_rust_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
